/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/keyCodes","vs/base/common/arrays","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/charCode","vs/base/browser/browser","vs/base/browser/mouseEvent","vs/base/common/scrollable","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/base","vs/base/common/path","vs/base/browser/event","vs/base/common/equals","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/browser/ui/list/list","vs/base/common/assert","vs/base/common/map","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/range","vs/base/common/buffer","vs/base/common/codiconsUtil","vs/base/common/filters","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/base/common/actions","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/browser/canIUse","vs/base/common/observable","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/hash","vs/base/common/iconLabels","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/parts/ipc/common/ipc","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/aria/aria","vs/base/browser/ui/contextview/contextview","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/lazyObservableValue","vs/base/common/observableInternal/api","vs/base/common/keybindings","vs/base/common/process","vs/base/common/mime","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/codiconsLibrary","vs/base/common/extpath","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/contextview/contextview","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],we=function(oe){for(var t=[],i=0,n=oe.length;i<n;i++)t[i]=pe[oe[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Ht,setPrototypeOf:Vt,isFrozen:ui,getPrototypeOf:hi,getOwnPropertyDescriptor:ci}=Object;let{freeze:ht,seal:$t,create:fi}=Object,{apply:Mt,construct:Pt}=typeof Reflect<"u"&&Reflect;Mt||(Mt=function(t,i,n){return t.apply(i,n)}),ht||(ht=function(t){return t}),$t||($t=function(t){return t}),Pt||(Pt=function(t,i){return new t(...i)});const di=mt(Array.prototype.forEach),xt=mt(Array.prototype.pop),St=mt(Array.prototype.push),Lt=mt(String.prototype.toLowerCase),Bt=mt(String.prototype.toString),gi=mt(String.prototype.match),pt=mt(String.prototype.replace),mi=mt(String.prototype.indexOf),bi=mt(String.prototype.trim),gt=mt(RegExp.prototype.test),Tt=$i(TypeError);function mt(oe){return function(t){for(var i=arguments.length,n=new Array(i>1?i-1:0),P=1;P<i;P++)n[P-1]=arguments[P];return Mt(oe,t,n)}}function $i(oe){return function(){for(var t=arguments.length,i=new Array(t),n=0;n<t;n++)i[n]=arguments[n];return Pt(oe,i)}}function qe(oe,t,i){var n;i=(n=i)!==null&&n!==void 0?n:Lt,Vt&&Vt(oe,null);let P=t.length;for(;P--;){let F=t[P];if(typeof F=="string"){const N=i(F);N!==F&&(ui(t)||(t[P]=N),F=N)}oe[F]=!0}return oe}function Dt(oe){const t=fi(null);for(const[i,n]of Ht(oe))t[i]=n;return t}function Ft(oe,t){for(;oe!==null;){const n=ci(oe,t);if(n){if(n.get)return mt(n.get);if(typeof n.value=="function")return mt(n.value)}oe=hi(oe)}function i(n){return console.warn("fallback value for",n),null}return i}const zt=ht(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),jt=ht(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=ht(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),pi=ht(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),_t=ht(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),wi=ht(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ht(["#text"]),Kt=ht(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ut=ht(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ht(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),It=ht(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),vi=$t(/\{\{[\w\W]*|[\w\W]*\}\}/gm),Di=$t(/<%[\w\W]*|[\w\W]*%>/gm),Ei=$t(/\${[\w\W]*}/gm),yi=$t(/^data-[\-\w.\u00B7-\uFFFF]/),Ai=$t(/^aria-[\-\w]+$/),Gt=$t(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),Si=$t(/^(?:\w+script|data):/i),Ti=$t(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Xt=$t(/^html$/i);var Yt=Object.freeze({__proto__:null,MUSTACHE_EXPR:vi,ERB_EXPR:Di,TMPLIT_EXPR:Ei,DATA_ATTR:yi,ARIA_ATTR:Ai,IS_ALLOWED_URI:Gt,IS_SCRIPT_OR_DATA:Si,ATTR_WHITESPACE:Ti,DOCTYPE_NAME:Xt});const ki=()=>typeof window>"u"?null:window,Ni=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let n=null;const P="data-tt-policy-suffix";i&&i.hasAttribute(P)&&(n=i.getAttribute(P));const F="dompurify"+(n?"#"+n:"");try{return t.createPolicy(F,{createHTML(N){return N},createScriptURL(N){return N}})}catch{return console.warn("TrustedTypes policy "+F+" could not be created."),null}};function Zt(){let oe=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ki();const t=Ue=>Zt(Ue);if(t.version="3.0.5",t.removed=[],!oe||!oe.document||oe.document.nodeType!==9)return t.isSupported=!1,t;const i=oe.document,n=i.currentScript;let{document:P}=oe;const{DocumentFragment:F,HTMLTemplateElement:N,Node:w,Element:D,NodeFilter:f,NamedNodeMap:p=oe.NamedNodeMap||oe.MozNamedAttrMap,HTMLFormElement:y,DOMParser:$,trustedTypes:m}=oe,e=D.prototype,s=Ft(e,"cloneNode"),r=Ft(e,"nextSibling"),h=Ft(e,"childNodes"),a=Ft(e,"parentNode");if(typeof N=="function"){const Ue=P.createElement("template");Ue.content&&Ue.content.ownerDocument&&(P=Ue.content.ownerDocument)}let v,T="";const{implementation:S,createNodeIterator:d,createDocumentFragment:c,getElementsByTagName:b}=P,{importNode:A}=i;let V={};t.isSupported=typeof Ht=="function"&&typeof a=="function"&&S&&S.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:U,ERB_EXPR:C,TMPLIT_EXPR:E,DATA_ATTR:O,ARIA_ATTR:x,IS_SCRIPT_OR_DATA:I,ATTR_WHITESPACE:_}=Yt;let{IS_ALLOWED_URI:q}=Yt,J=null;const G=qe({},[...zt,...jt,...Ct,..._t,...Wt]);let K=null;const Q=qe({},[...Kt,...Ut,...qt,...It]);let ae=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),me=null,ye=null,Le=!0,ne=!0,ee=!1,ce=!0,le=!1,ke=!1,te=!1,be=!1,Ae=!1,Re=!1,Ie=!1,je=!0,_e=!1;const W="user-content-";let j=!0,l=!1,o={},g=null;const M=qe({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let k=null;const u=qe({},["audio","video","img","source","image","track"]);let L=null;const R=qe({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),B="http://www.w3.org/1998/Math/MathML",H="http://www.w3.org/2000/svg",Y="http://www.w3.org/1999/xhtml";let ie=Y,re=!1,he=null;const De=qe({},[B,H,Y],Bt);let ve;const Ee=["application/xhtml+xml","text/html"],Ne="text/html";let fe,Fe=null;const Ke=P.createElement("form"),Xe=function(de){return de instanceof RegExp||de instanceof Function},tt=function(de){if(!(Fe&&Fe===de)){if((!de||typeof de!="object")&&(de={}),de=Dt(de),ve=Ee.indexOf(de.PARSER_MEDIA_TYPE)===-1?ve=Ne:ve=de.PARSER_MEDIA_TYPE,fe=ve==="application/xhtml+xml"?Bt:Lt,J="ALLOWED_TAGS"in de?qe({},de.ALLOWED_TAGS,fe):G,K="ALLOWED_ATTR"in de?qe({},de.ALLOWED_ATTR,fe):Q,he="ALLOWED_NAMESPACES"in de?qe({},de.ALLOWED_NAMESPACES,Bt):De,L="ADD_URI_SAFE_ATTR"in de?qe(Dt(R),de.ADD_URI_SAFE_ATTR,fe):R,k="ADD_DATA_URI_TAGS"in de?qe(Dt(u),de.ADD_DATA_URI_TAGS,fe):u,g="FORBID_CONTENTS"in de?qe({},de.FORBID_CONTENTS,fe):M,me="FORBID_TAGS"in de?qe({},de.FORBID_TAGS,fe):{},ye="FORBID_ATTR"in de?qe({},de.FORBID_ATTR,fe):{},o="USE_PROFILES"in de?de.USE_PROFILES:!1,Le=de.ALLOW_ARIA_ATTR!==!1,ne=de.ALLOW_DATA_ATTR!==!1,ee=de.ALLOW_UNKNOWN_PROTOCOLS||!1,ce=de.ALLOW_SELF_CLOSE_IN_ATTR!==!1,le=de.SAFE_FOR_TEMPLATES||!1,ke=de.WHOLE_DOCUMENT||!1,Ae=de.RETURN_DOM||!1,Re=de.RETURN_DOM_FRAGMENT||!1,Ie=de.RETURN_TRUSTED_TYPE||!1,be=de.FORCE_BODY||!1,je=de.SANITIZE_DOM!==!1,_e=de.SANITIZE_NAMED_PROPS||!1,j=de.KEEP_CONTENT!==!1,l=de.IN_PLACE||!1,q=de.ALLOWED_URI_REGEXP||Gt,ie=de.NAMESPACE||Y,ae=de.CUSTOM_ELEMENT_HANDLING||{},de.CUSTOM_ELEMENT_HANDLING&&Xe(de.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ae.tagNameCheck=de.CUSTOM_ELEMENT_HANDLING.tagNameCheck),de.CUSTOM_ELEMENT_HANDLING&&Xe(de.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ae.attributeNameCheck=de.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),de.CUSTOM_ELEMENT_HANDLING&&typeof de.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ae.allowCustomizedBuiltInElements=de.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),le&&(ne=!1),Re&&(Ae=!0),o&&(J=qe({},[...Wt]),K=[],o.html===!0&&(qe(J,zt),qe(K,Kt)),o.svg===!0&&(qe(J,jt),qe(K,Ut),qe(K,It)),o.svgFilters===!0&&(qe(J,Ct),qe(K,Ut),qe(K,It)),o.mathMl===!0&&(qe(J,_t),qe(K,qt),qe(K,It))),de.ADD_TAGS&&(J===G&&(J=Dt(J)),qe(J,de.ADD_TAGS,fe)),de.ADD_ATTR&&(K===Q&&(K=Dt(K)),qe(K,de.ADD_ATTR,fe)),de.ADD_URI_SAFE_ATTR&&qe(L,de.ADD_URI_SAFE_ATTR,fe),de.FORBID_CONTENTS&&(g===M&&(g=Dt(g)),qe(g,de.FORBID_CONTENTS,fe)),j&&(J["#text"]=!0),ke&&qe(J,["html","head","body"]),J.table&&(qe(J,["tbody"]),delete me.tbody),de.TRUSTED_TYPES_POLICY){if(typeof de.TRUSTED_TYPES_POLICY.createHTML!="function")throw Tt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof de.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw Tt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');v=de.TRUSTED_TYPES_POLICY,T=v.createHTML("")}else v===void 0&&(v=Ni(m,n)),v!==null&&typeof T=="string"&&(T=v.createHTML(""));ht&&ht(de),Fe=de}},lt=qe({},["mi","mo","mn","ms","mtext"]),st=qe({},["foreignobject","desc","title","annotation-xml"]),Ge=qe({},["title","style","font","a","script"]),Ze=qe({},jt);qe(Ze,Ct),qe(Ze,pi);const Z=qe({},_t);qe(Z,wi);const ue=function(de){let Oe=a(de);(!Oe||!Oe.tagName)&&(Oe={namespaceURI:ie,tagName:"template"});const Be=Lt(de.tagName),Ye=Lt(Oe.tagName);return he[de.namespaceURI]?de.namespaceURI===H?Oe.namespaceURI===Y?Be==="svg":Oe.namespaceURI===B?Be==="svg"&&(Ye==="annotation-xml"||lt[Ye]):!!Ze[Be]:de.namespaceURI===B?Oe.namespaceURI===Y?Be==="math":Oe.namespaceURI===H?Be==="math"&&st[Ye]:!!Z[Be]:de.namespaceURI===Y?Oe.namespaceURI===H&&!st[Ye]||Oe.namespaceURI===B&&!lt[Ye]?!1:!Z[Be]&&(Ge[Be]||!Ze[Be]):!!(ve==="application/xhtml+xml"&&he[de.namespaceURI]):!1},$e=function(de){St(t.removed,{element:de});try{de.parentNode.removeChild(de)}catch{de.remove()}},Se=function(de,Oe){try{St(t.removed,{attribute:Oe.getAttributeNode(de),from:Oe})}catch{St(t.removed,{attribute:null,from:Oe})}if(Oe.removeAttribute(de),de==="is"&&!K[de])if(Ae||Re)try{$e(Oe)}catch{}else try{Oe.setAttribute(de,"")}catch{}},Pe=function(de){let Oe,Be;if(be)de="<remove></remove>"+de;else{const ut=gi(de,/^[\r\n\t ]+/);Be=ut&&ut[0]}ve==="application/xhtml+xml"&&ie===Y&&(de='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+de+"</body></html>");const Ye=v?v.createHTML(de):de;if(ie===Y)try{Oe=new $().parseFromString(Ye,ve)}catch{}if(!Oe||!Oe.documentElement){Oe=S.createDocument(ie,"template",null);try{Oe.documentElement.innerHTML=re?T:Ye}catch{}}const ot=Oe.body||Oe.documentElement;return de&&Be&&ot.insertBefore(P.createTextNode(Be),ot.childNodes[0]||null),ie===Y?b.call(Oe,ke?"html":"body")[0]:ke?Oe.documentElement:ot},Ve=function(de){return d.call(de.ownerDocument||de,de,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},Je=function(de){return de instanceof y&&(typeof de.nodeName!="string"||typeof de.textContent!="string"||typeof de.removeChild!="function"||!(de.attributes instanceof p)||typeof de.removeAttribute!="function"||typeof de.setAttribute!="function"||typeof de.namespaceURI!="string"||typeof de.insertBefore!="function"||typeof de.hasChildNodes!="function")},rt=function(de){return typeof w=="object"?de instanceof w:de&&typeof de=="object"&&typeof de.nodeType=="number"&&typeof de.nodeName=="string"},it=function(de,Oe,Be){V[de]&&di(V[de],Ye=>{Ye.call(t,Oe,Be,Fe)})},ct=function(de){let Oe;if(it("beforeSanitizeElements",de,null),Je(de))return $e(de),!0;const Be=fe(de.nodeName);if(it("uponSanitizeElement",de,{tagName:Be,allowedTags:J}),de.hasChildNodes()&&!rt(de.firstElementChild)&&(!rt(de.content)||!rt(de.content.firstElementChild))&&gt(/<[/\w]/g,de.innerHTML)&&gt(/<[/\w]/g,de.textContent))return $e(de),!0;if(!J[Be]||me[Be]){if(!me[Be]&&dt(Be)&&(ae.tagNameCheck instanceof RegExp&&gt(ae.tagNameCheck,Be)||ae.tagNameCheck instanceof Function&&ae.tagNameCheck(Be)))return!1;if(j&&!g[Be]){const Ye=a(de)||de.parentNode,ot=h(de)||de.childNodes;if(ot&&Ye){const ut=ot.length;for(let Qe=ut-1;Qe>=0;--Qe)Ye.insertBefore(s(ot[Qe],!0),r(de))}}return $e(de),!0}return de instanceof D&&!ue(de)||(Be==="noscript"||Be==="noembed"||Be==="noframes")&&gt(/<\/no(script|embed|frames)/i,de.innerHTML)?($e(de),!0):(le&&de.nodeType===3&&(Oe=de.textContent,Oe=pt(Oe,U," "),Oe=pt(Oe,C," "),Oe=pt(Oe,E," "),de.textContent!==Oe&&(St(t.removed,{element:de.cloneNode()}),de.textContent=Oe)),it("afterSanitizeElements",de,null),!1)},nt=function(de,Oe,Be){if(je&&(Oe==="id"||Oe==="name")&&(Be in P||Be in Ke))return!1;if(!(ne&&!ye[Oe]&&gt(O,Oe))){if(!(Le&&gt(x,Oe))){if(!K[Oe]||ye[Oe]){if(!(dt(de)&&(ae.tagNameCheck instanceof RegExp&&gt(ae.tagNameCheck,de)||ae.tagNameCheck instanceof Function&&ae.tagNameCheck(de))&&(ae.attributeNameCheck instanceof RegExp&&gt(ae.attributeNameCheck,Oe)||ae.attributeNameCheck instanceof Function&&ae.attributeNameCheck(Oe))||Oe==="is"&&ae.allowCustomizedBuiltInElements&&(ae.tagNameCheck instanceof RegExp&&gt(ae.tagNameCheck,Be)||ae.tagNameCheck instanceof Function&&ae.tagNameCheck(Be))))return!1}else if(!L[Oe]){if(!gt(q,pt(Be,_,""))){if(!((Oe==="src"||Oe==="xlink:href"||Oe==="href")&&de!=="script"&&mi(Be,"data:")===0&&k[de])){if(!(ee&&!gt(I,pt(Be,_,"")))){if(Be)return!1}}}}}}return!0},dt=function(de){return de.indexOf("-")>0},ft=function(de){let Oe,Be,Ye,ot;it("beforeSanitizeAttributes",de,null);const{attributes:ut}=de;if(!ut)return;const Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:K};for(ot=ut.length;ot--;){Oe=ut[ot];const{name:bt,namespaceURI:Et}=Oe;if(Be=bt==="value"?Oe.value:bi(Oe.value),Ye=fe(bt),Qe.attrName=Ye,Qe.attrValue=Be,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,it("uponSanitizeAttribute",de,Qe),Be=Qe.attrValue,Qe.forceKeepAttr||(Se(bt,de),!Qe.keepAttr))continue;if(!ce&&gt(/\/>/i,Be)){Se(bt,de);continue}le&&(Be=pt(Be,U," "),Be=pt(Be,C," "),Be=pt(Be,E," "));const Rt=fe(de.nodeName);if(nt(Rt,Ye,Be)){if(_e&&(Ye==="id"||Ye==="name")&&(Se(bt,de),Be=W+Be),v&&typeof m=="object"&&typeof m.getAttributeType=="function"&&!Et)switch(m.getAttributeType(Rt,Ye)){case"TrustedHTML":{Be=v.createHTML(Be);break}case"TrustedScriptURL":{Be=v.createScriptURL(Be);break}}try{Et?de.setAttributeNS(Et,bt,Be):de.setAttribute(bt,Be),xt(t.removed)}catch{}}}it("afterSanitizeAttributes",de,null)},wt=function Ue(de){let Oe;const Be=Ve(de);for(it("beforeSanitizeShadowDOM",de,null);Oe=Be.nextNode();)it("uponSanitizeShadowNode",Oe,null),!ct(Oe)&&(Oe.content instanceof F&&Ue(Oe.content),ft(Oe));it("afterSanitizeShadowDOM",de,null)};return t.sanitize=function(Ue){let de=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Oe,Be,Ye,ot;if(re=!Ue,re&&(Ue="<!-->"),typeof Ue!="string"&&!rt(Ue))if(typeof Ue.toString=="function"){if(Ue=Ue.toString(),typeof Ue!="string")throw Tt("dirty is not a string, aborting")}else throw Tt("toString is not a function");if(!t.isSupported)return Ue;if(te||tt(de),t.removed=[],typeof Ue=="string"&&(l=!1),l){if(Ue.nodeName){const bt=fe(Ue.nodeName);if(!J[bt]||me[bt])throw Tt("root node is forbidden and cannot be sanitized in-place")}}else if(Ue instanceof w)Oe=Pe("<!---->"),Be=Oe.ownerDocument.importNode(Ue,!0),Be.nodeType===1&&Be.nodeName==="BODY"||Be.nodeName==="HTML"?Oe=Be:Oe.appendChild(Be);else{if(!Ae&&!le&&!ke&&Ue.indexOf("<")===-1)return v&&Ie?v.createHTML(Ue):Ue;if(Oe=Pe(Ue),!Oe)return Ae?null:Ie?T:""}Oe&&be&&$e(Oe.firstChild);const ut=Ve(l?Ue:Oe);for(;Ye=ut.nextNode();)ct(Ye)||(Ye.content instanceof F&&wt(Ye.content),ft(Ye));if(l)return Ue;if(Ae){if(Re)for(ot=c.call(Oe.ownerDocument);Oe.firstChild;)ot.appendChild(Oe.firstChild);else ot=Oe;return(K.shadowroot||K.shadowrootmode)&&(ot=A.call(i,ot,!0)),ot}let Qe=ke?Oe.outerHTML:Oe.innerHTML;return ke&&J["!doctype"]&&Oe.ownerDocument&&Oe.ownerDocument.doctype&&Oe.ownerDocument.doctype.name&&gt(Xt,Oe.ownerDocument.doctype.name)&&(Qe="<!DOCTYPE "+Oe.ownerDocument.doctype.name+`>
`+Qe),le&&(Qe=pt(Qe,U," "),Qe=pt(Qe,C," "),Qe=pt(Qe,E," ")),v&&Ie?v.createHTML(Qe):Qe},t.setConfig=function(Ue){tt(Ue),te=!0},t.clearConfig=function(){Fe=null,te=!1},t.isValidAttribute=function(Ue,de,Oe){Fe||tt({});const Be=fe(Ue),Ye=fe(de);return nt(Be,Ye,Oe)},t.addHook=function(Ue,de){typeof de=="function"&&(V[Ue]=V[Ue]||[],St(V[Ue],de))},t.removeHook=function(Ue){if(V[Ue])return xt(V[Ue])},t.removeHooks=function(Ue){V[Ue]&&(V[Ue]=[])},t.removeAllHooks=function(){V={}},t}var Li=Zt();define("vs/base/browser/dompurify/dompurify",function(){return Li}),define(pe[55],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sU=void 0,t.$tU=P;class i{constructor(N){this.domNode=N,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(N){const w=n(N);this.a!==w&&(this.a=w,this.domNode.style.maxWidth=this.a)}setWidth(N){const w=n(N);this.b!==w&&(this.b=w,this.domNode.style.width=this.b)}setHeight(N){const w=n(N);this.c!==w&&(this.c=w,this.domNode.style.height=this.c)}setTop(N){const w=n(N);this.d!==w&&(this.d=w,this.domNode.style.top=this.d)}setLeft(N){const w=n(N);this.e!==w&&(this.e=w,this.domNode.style.left=this.e)}setBottom(N){const w=n(N);this.f!==w&&(this.f=w,this.domNode.style.bottom=this.f)}setRight(N){const w=n(N);this.g!==w&&(this.g=w,this.domNode.style.right=this.g)}setPaddingTop(N){const w=n(N);this.h!==w&&(this.h=w,this.domNode.style.paddingTop=this.h)}setPaddingLeft(N){const w=n(N);this.i!==w&&(this.i=w,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(N){const w=n(N);this.j!==w&&(this.j=w,this.domNode.style.paddingBottom=this.j)}setPaddingRight(N){const w=n(N);this.k!==w&&(this.k=w,this.domNode.style.paddingRight=this.k)}setFontFamily(N){this.l!==N&&(this.l=N,this.domNode.style.fontFamily=this.l)}setFontWeight(N){this.m!==N&&(this.m=N,this.domNode.style.fontWeight=this.m)}setFontSize(N){const w=n(N);this.n!==w&&(this.n=w,this.domNode.style.fontSize=this.n)}setFontStyle(N){this.o!==N&&(this.o=N,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(N){this.p!==N&&(this.p=N,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(N){this.q!==N&&(this.q=N,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(N){this.r!==N&&(this.r=N,this.domNode.style.textDecoration=this.r)}setLineHeight(N){const w=n(N);this.s!==w&&(this.s=w,this.domNode.style.lineHeight=this.s)}setLetterSpacing(N){const w=n(N);this.t!==w&&(this.t=w,this.domNode.style.letterSpacing=this.t)}setClassName(N){this.u!==N&&(this.u=N,this.domNode.className=this.u)}toggleClassName(N,w){this.domNode.classList.toggle(N,w),this.u=this.domNode.className}setDisplay(N){this.v!==N&&(this.v=N,this.domNode.style.display=this.v)}setPosition(N){this.w!==N&&(this.w=N,this.domNode.style.position=this.w)}setVisibility(N){this.x!==N&&(this.x=N,this.domNode.style.visibility=this.x)}setColor(N){this.y!==N&&(this.y=N,this.domNode.style.color=this.y)}setBackgroundColor(N){this.z!==N&&(this.z=N,this.domNode.style.backgroundColor=this.z)}setLayerHinting(N){this.A!==N&&(this.A=N,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(N){this.C!==N&&(this.C=N,this.domNode.style.boxShadow=N)}setContain(N){this.B!==N&&(this.B=N,this.domNode.style.contain=this.B)}setAttribute(N,w){this.domNode.setAttribute(N,w)}removeAttribute(N){this.domNode.removeAttribute(N)}appendChild(N){this.domNode.appendChild(N.domNode)}removeChild(N){this.domNode.removeChild(N.domNode)}}t.$sU=i;function n(F){return typeof F=="number"?`${F}px`:F}function P(F){return new i(F)}}),define(pe[85],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AS=void 0,t.$BS=F;const i=new WeakMap;function n(w){if(!w.parent||w.parent===w)return null;try{const D=w.location,f=w.parent.location;if(D.origin!=="null"&&f.origin!=="null"&&D.origin!==f.origin)return null}catch{return null}return w.parent}class P{static a(D){let f=i.get(D);if(!f){f=[],i.set(D,f);let p=D,y;do y=n(p),y?f.push({window:new WeakRef(p),iframeElement:p.frameElement||null}):f.push({window:new WeakRef(p),iframeElement:null}),p=y;while(p)}return f.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(D,f){if(!f||D===f)return{top:0,left:0};let p=0,y=0;const $=this.a(D);for(const m of $){const e=m.window.deref();if(p+=e?.scrollY??0,y+=e?.scrollX??0,e===f||!m.iframeElement)break;const s=m.iframeElement.getBoundingClientRect();p+=s.top,y+=s.left}return{top:p,left:y}}}t.$AS=P;async function F(w,D){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const f=JSON.stringify({parentOrigin:w,salt:D}),y=new TextEncoder().encode(f),$=await crypto.subtle.digest("sha-256",y);return N($)}function N(w){const f=Array.from(new Uint8Array(w)).map(p=>p.toString(16).padStart(2,"0")).join("");return BigInt(`0x${f}`).toString(32).padStart(52,"0")}}),define(pe[33],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zV=n,t.$AV=P;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupManagedHover:()=>null,showManagedHover:()=>{}};function n(F){i=F}function P(){return i}}),define(pe[41],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cV=t.$bV=t.$aV=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(N){N[N.Copy=0]="Copy",N[N.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var n;(function(N){N.Over="drop-target",N.Before="drop-target-before",N.After="drop-target-after"})(n||(t.ListDragOverEffectPosition=n={})),t.$aV={reject(){return{accept:!1}},accept(){return{accept:!0}}};class P extends Error{constructor(w,D){super(`ListError [${w}] ${D}`)}}t.$bV=P;class F{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,D){D>0&&this.c.set(w,D)}}t.$cV=F}),define(pe[86],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3U=void 0;class i{constructor(P){this.a=P}splice(P,F,N){this.a.forEach(w=>w.splice(P,F,N))}}t.$3U=i}),define(pe[56],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yU=void 0;const i=20;class n{constructor(F,N,w,D,f,p){this.a=Math.round(N),this.b=Math.round(w),this.c=Math.round(F),this.d=D,this.e=f,this.f=p,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new n(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(F){const N=Math.round(F);return this.d!==N?(this.d=N,this.m(),!0):!1}setScrollSize(F){const N=Math.round(F);return this.e!==N?(this.e=N,this.m(),!0):!1}setScrollPosition(F){const N=Math.round(F);return this.f!==N?(this.f=N,this.m(),!0):!1}setScrollbarSize(F){this.a=Math.round(F)}setOppositeScrollbarSize(F){this.b=Math.round(F)}static l(F,N,w,D,f){const p=Math.max(0,w-F),y=Math.max(0,p-2*N),$=D>0&&D>w;if(!$)return{computedAvailableSize:Math.round(p),computedIsNeeded:$,computedSliderSize:Math.round(y),computedSliderRatio:0,computedSliderPosition:0};const m=Math.round(Math.max(i,Math.floor(w*y/D))),e=(y-m)/(D-w),s=f*e;return{computedAvailableSize:Math.round(p),computedIsNeeded:$,computedSliderSize:Math.round(m),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const F=n.l(this.b,this.c,this.d,this.e,this.f);this.g=F.computedAvailableSize,this.h=F.computedIsNeeded,this.i=F.computedSliderSize,this.j=F.computedSliderRatio,this.k=F.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(F){if(!this.h)return 0;const N=F-this.c-this.i/2;return Math.round(N/this.j)}getDesiredScrollPositionFromOffsetPaged(F){if(!this.h)return 0;const N=F-this.c;let w=this.f;return N<this.k?w-=this.d:w+=this.d,w}getDesiredScrollPositionFromDelta(F){if(!this.h)return 0;const N=this.k+F;return Math.round(N/this.j)}}t.$yU=n}),define(pe[34],we([1,0,41]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bX=t.$aX=t.$_W=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(f){f[f.Hidden=0]="Hidden",f[f.Visible=1]="Visible",f[f.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var P;(function(f){f[f.Expanded=0]="Expanded",f[f.Collapsed=1]="Collapsed",f[f.PreserveOrExpanded=2]="PreserveOrExpanded",f[f.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(P||(t.ObjectTreeElementCollapseState=P={}));var F;(function(f){f[f.Unknown=0]="Unknown",f[f.Twistie=1]="Twistie",f[f.Element=2]="Element",f[f.Filter=3]="Filter"})(F||(t.TreeMouseEventTarget=F={}));var N;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})(N||(t.TreeDragOverBubble=N={})),t.$_W={acceptBubbleUp(){return{accept:!0,bubble:N.Up}},acceptBubbleDown(f=!1){return{accept:!0,bubble:N.Down,autoExpand:f}},acceptCopyBubbleUp(){return{accept:!0,bubble:N.Up,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over}}},acceptCopyBubbleDown(f=!1){return{accept:!0,bubble:N.Down,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over},autoExpand:f}}};class w extends Error{constructor(p,y){super(`TreeError [${p}] ${y}`)}}t.$aX=w;class D{constructor(p){this.a=p,this.b=new WeakMap}map(p){let y=this.b.get(p);return y||(y=this.a(p),this.b.set(p,y)),y}}t.$bX=D}),define(pe[24],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dS=void 0,t.$cS=i,t.$eS=n;function i(P,F){const N=P;typeof N.vscodeWindowId!="number"&&Object.defineProperty(N,"vscodeWindowId",{get:()=>F})}t.$dS=window;function n(P){return P===t.$dS?!1:typeof P?.vscodeWindowId=="number"}}),define(pe[87],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=n,t.$hb=P,t.$ib=F,t.$jb=N,t.$kb=w,t.$lb=D,t.$nb=p,t.$ob=y,t.$pb=$,t.$qb=m,t.$rb=e;function i(s,r){const h=n(s,r);if(h!==-1)return s[h]}function n(s,r,h=s.length-1){for(let a=h;a>=0;a--){const v=s[a];if(r(v))return a}return-1}function P(s,r){const h=F(s,r);return h===-1?void 0:s[h]}function F(s,r,h=0,a=s.length){let v=h,T=a;for(;v<T;){const S=Math.floor((v+T)/2);r(s[S])?v=S+1:T=S}return v-1}function N(s,r){const h=w(s,r);return h===s.length?void 0:s[h]}function w(s,r,h=0,a=s.length){let v=h,T=a;for(;v<T;){const S=Math.floor((v+T)/2);r(s[S])?T=S:v=S+1}return v}function D(s,r,h=0,a=s.length){const v=w(s,r,h,a);return v===s.length?-1:v}class f{static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if(f.assertInvariants){if(this.d){for(const a of this.e)if(this.d(a)&&!r(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const h=F(this.e,r,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}t.$mb=f;function p(s,r){if(s.length===0)return;let h=s[0];for(let a=1;a<s.length;a++){const v=s[a];r(v,h)>0&&(h=v)}return h}function y(s,r){if(s.length===0)return;let h=s[0];for(let a=1;a<s.length;a++){const v=s[a];r(v,h)>=0&&(h=v)}return h}function $(s,r){return p(s,(h,a)=>-r(h,a))}function m(s,r){if(s.length===0)return-1;let h=0;for(let a=1;a<s.length;a++){const v=s[a];r(v,s[h])>0&&(h=a)}return h}function e(s,r){for(const h of s){const a=r(h);if(a!==void 0)return a}}}),define(pe[17],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var i;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(t.CharCode=i={}))}),define(pe[57],we([1,0]),function(oe,t){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.$g=void 0,t.$c=n,t.$d=P,t.$e=F,t.$f=N;function n(D,f){const p=Object.create(null);for(const y of D){const $=f(y);let m=p[$];m||(m=p[$]=[]),m.push(y)}return p}function P(D,f){const p=[],y=[];for(const $ of D)f.has($)||p.push($);for(const $ of f)D.has($)||y.push($);return{removed:p,added:y}}function F(D,f){const p=[],y=[];for(const[$,m]of D)f.has($)||p.push(m);for(const[$,m]of f)D.has($)||y.push(m);return{removed:p,added:y}}function N(D,f){const p=new Set;for(const y of f)D.has(y)&&p.add(y);return p}class w{static{i=Symbol.toStringTag}constructor(f,p){this.b=p,this.a=new Map,this[i]="SetWithKey";for(const y of f)this.add(y)}get size(){return this.a.size}add(f){const p=this.b(f);return this.a.set(p,f),this}delete(f){return this.a.delete(this.b(f))}has(f){return this.a.has(this.b(f))}*entries(){for(const f of this.a.values())yield[f,f]}keys(){return this.values()}*values(){for(const f of this.a.values())yield f}clear(){this.a.clear()}forEach(f,p){this.a.forEach(y=>f.call(p,y,y,this))}[Symbol.iterator](){return this.values()}}t.$g=w}),define(pe[88],we([1,0,17]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pu=t.$ou=t.$nu=t.$mu=void 0;function n(D,f){const p=Math.pow(10,f);return Math.round(D*p)/p}class P{constructor(f,p,y,$=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=n(Math.max(Math.min(1,$),0),3)}static equals(f,p){return f.r===p.r&&f.g===p.g&&f.b===p.b&&f.a===p.a}}t.$mu=P;class F{constructor(f,p,y,$){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=n(Math.max(Math.min(1,p),0),3),this.l=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,$),0),3)}static equals(f,p){return f.h===p.h&&f.s===p.s&&f.l===p.l&&f.a===p.a}static fromRGBA(f){const p=f.r/255,y=f.g/255,$=f.b/255,m=f.a,e=Math.max(p,y,$),s=Math.min(p,y,$);let r=0,h=0;const a=(s+e)/2,v=e-s;if(v>0){switch(h=Math.min(a<=.5?v/(2*a):v/(2-2*a),1),e){case p:r=(y-$)/v+(y<$?6:0);break;case y:r=($-p)/v+2;break;case $:r=(p-y)/v+4;break}r*=60,r=Math.round(r)}return new F(r,h,a,m)}static i(f,p,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?f+(p-f)*6*y:y<1/2?p:y<2/3?f+(p-f)*(2/3-y)*6:f}static toRGBA(f){const p=f.h/360,{s:y,l:$,a:m}=f;let e,s,r;if(y===0)e=s=r=$;else{const h=$<.5?$*(1+y):$+y-$*y,a=2*$-h;e=F.i(a,h,p+1/3),s=F.i(a,h,p),r=F.i(a,h,p-1/3)}return new P(Math.round(e*255),Math.round(s*255),Math.round(r*255),m)}}t.$nu=F;class N{constructor(f,p,y,$){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=n(Math.max(Math.min(1,p),0),3),this.v=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,$),0),3)}static equals(f,p){return f.h===p.h&&f.s===p.s&&f.v===p.v&&f.a===p.a}static fromRGBA(f){const p=f.r/255,y=f.g/255,$=f.b/255,m=Math.max(p,y,$),e=Math.min(p,y,$),s=m-e,r=m===0?0:s/m;let h;return s===0?h=0:m===p?h=((y-$)/s%6+6)%6:m===y?h=($-p)/s+2:h=(p-y)/s+4,new N(Math.round(h*60),r,m,f.a)}static toRGBA(f){const{h:p,s:y,v:$,a:m}=f,e=$*y,s=e*(1-Math.abs(p/60%2-1)),r=$-e;let[h,a,v]=[0,0,0];return p<60?(h=e,a=s):p<120?(h=s,a=e):p<180?(a=e,v=s):p<240?(a=s,v=e):p<300?(h=s,v=e):p<=360&&(h=e,v=s),h=Math.round((h+r)*255),a=Math.round((a+r)*255),v=Math.round((v+r)*255),new P(h,a,v,m)}}t.$ou=N;class w{static fromHex(f){return w.Format.CSS.parseHex(f)||w.red}static equals(f,p){return!f&&!p?!0:!f||!p?!1:f.equals(p)}get hsla(){return this.i?this.i:F.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:N.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof P)this.rgba=f;else if(f instanceof F)this.i=f,this.rgba=F.toRGBA(f);else if(f instanceof N)this.j=f,this.rgba=N.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&P.equals(this.rgba,f.rgba)&&F.equals(this.hsla,f.hsla)&&N.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=w.k(this.rgba.r),p=w.k(this.rgba.g),y=w.k(this.rgba.b),$=.2126*f+.7152*p+.0722*y;return n($,4)}static k(f){const p=f/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(f){const p=this.getRelativeLuminance(),y=f.getRelativeLuminance();return p>y?(p+.05)/(y+.05):(y+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const p=this.getRelativeLuminance(),y=f.getRelativeLuminance();return p>y}isDarkerThan(f){const p=this.getRelativeLuminance(),y=f.getRelativeLuminance();return p<y}lighten(f){return new w(new F(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new w(new F(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:p,g:y,b:$,a:m}=this.rgba;return new w(new P(p,y,$,m*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const p=f.rgba,y=this.rgba.a,$=p.a,m=y+$*(1-y);if(m<1e-6)return w.transparent;const e=this.rgba.r*y/m+p.r*$*(1-y)/m,s=this.rgba.g*y/m+p.g*$*(1-y)/m,r=this.rgba.b*y/m+p.b*$*(1-y)/m;return new w(new P(e,s,r,m))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:p,g:y,b:$,a:m}=this.rgba;return new w(new P(f.rgba.r-m*(f.rgba.r-p),f.rgba.g-m*(f.rgba.g-y),f.rgba.b-m*(f.rgba.b-$),1))}flatten(...f){const p=f.reduceRight((y,$)=>w.o($,y));return w.o(this,p)}static o(f,p){const y=1-f.rgba.a;return new w(new P(y*p.rgba.r+f.rgba.a*f.rgba.r,y*p.rgba.g+f.rgba.a*f.rgba.g,y*p.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(f,p,y){if(f.isLighterThan(p))return f;y=y||.5;const $=f.getRelativeLuminance(),m=p.getRelativeLuminance();return y=y*(m-$)/m,f.lighten(y)}static getDarkerColor(f,p,y){if(f.isDarkerThan(p))return f;y=y||.5;const $=f.getRelativeLuminance(),m=p.getRelativeLuminance();return y=y*($-m)/$,f.darken(y)}static{this.white=new w(new P(255,255,255,1))}static{this.black=new w(new P(0,0,0,1))}static{this.red=new w(new P(255,0,0,1))}static{this.blue=new w(new P(0,0,255,1))}static{this.green=new w(new P(0,255,0,1))}static{this.cyan=new w(new P(0,255,255,1))}static{this.lightgrey=new w(new P(211,211,211,1))}static{this.transparent=new w(new P(0,0,0,0))}}t.$pu=w,function(D){let f;(function(p){let y;(function($){function m(c){return c.rgba.a===1?`rgb(${c.rgba.r}, ${c.rgba.g}, ${c.rgba.b})`:D.Format.CSS.formatRGBA(c)}$.formatRGB=m;function e(c){return`rgba(${c.rgba.r}, ${c.rgba.g}, ${c.rgba.b}, ${+c.rgba.a.toFixed(2)})`}$.formatRGBA=e;function s(c){return c.hsla.a===1?`hsl(${c.hsla.h}, ${(c.hsla.s*100).toFixed(2)}%, ${(c.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(c)}$.formatHSL=s;function r(c){return`hsla(${c.hsla.h}, ${(c.hsla.s*100).toFixed(2)}%, ${(c.hsla.l*100).toFixed(2)}%, ${c.hsla.a.toFixed(2)})`}$.formatHSLA=r;function h(c){const b=c.toString(16);return b.length!==2?"0"+b:b}function a(c){return`#${h(c.rgba.r)}${h(c.rgba.g)}${h(c.rgba.b)}`}$.formatHex=a;function v(c,b=!1){return b&&c.rgba.a===1?D.Format.CSS.formatHex(c):`#${h(c.rgba.r)}${h(c.rgba.g)}${h(c.rgba.b)}${h(Math.round(c.rgba.a*255))}`}$.formatHexA=v;function T(c){return c.isOpaque()?D.Format.CSS.formatHex(c):D.Format.CSS.formatRGBA(c)}$.format=T;function S(c){const b=c.length;if(b===0||c.charCodeAt(0)!==i.CharCode.Hash)return null;if(b===7){const A=16*d(c.charCodeAt(1))+d(c.charCodeAt(2)),V=16*d(c.charCodeAt(3))+d(c.charCodeAt(4)),U=16*d(c.charCodeAt(5))+d(c.charCodeAt(6));return new D(new P(A,V,U,1))}if(b===9){const A=16*d(c.charCodeAt(1))+d(c.charCodeAt(2)),V=16*d(c.charCodeAt(3))+d(c.charCodeAt(4)),U=16*d(c.charCodeAt(5))+d(c.charCodeAt(6)),C=16*d(c.charCodeAt(7))+d(c.charCodeAt(8));return new D(new P(A,V,U,C/255))}if(b===4){const A=d(c.charCodeAt(1)),V=d(c.charCodeAt(2)),U=d(c.charCodeAt(3));return new D(new P(16*A+A,16*V+V,16*U+U))}if(b===5){const A=d(c.charCodeAt(1)),V=d(c.charCodeAt(2)),U=d(c.charCodeAt(3)),C=d(c.charCodeAt(4));return new D(new P(16*A+A,16*V+V,16*U+U,(16*C+C)/255))}return null}$.parseHex=S;function d(c){switch(c){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(y=p.CSS||(p.CSS={}))})(f=D.Format||(D.Format={}))}(w||(t.$pu=w={}))}),define(pe[35],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$h=n,t.$_h=P,t.$ai=F;function i(N){return(w,D,f)=>{let p=null,y=null;if(typeof f.value=="function"?(p="value",y=f.value):typeof f.get=="function"&&(p="get",y=f.get),!y)throw new Error("not supported");f[p]=N(y,D)}}function n(N,w,D){let f=null,p=null;if(typeof D.value=="function"?(f="value",p=D.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(f="get",p=D.get),!p)throw new Error("not supported");const y=`$memoize$${w}`;D[f]=function(...$){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,$)}),this[y]}}function P(N,w,D){return i((f,p)=>{const y=`$debounce$${p}`,$=`$debounce$result$${p}`;return function(...m){this[$]||(this[$]=D?D():void 0),clearTimeout(this[y]),w&&(this[$]=w(this[$],...m),m=[this[$]]),this[y]=setTimeout(()=>{f.apply(this,m),this[$]=D?D():void 0},N)}})}function F(N,w,D){return i((f,p)=>{const y=`$throttle$timer$${p}`,$=`$throttle$result$${p}`,m=`$throttle$lastRun$${p}`,e=`$throttle$pending$${p}`;return function(...s){if(this[$]||(this[$]=D?D():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),w&&(this[$]=w(this[$],...s)),this[e])return;const r=this[m]+N;r<=Date.now()?(this[m]=Date.now(),f.apply(this,[this[$]]),this[$]=D?D():void 0):(this[e]=!0,this[y]=setTimeout(()=>{this[e]=!1,this[m]=Date.now(),f.apply(this,[this[$]]),this[$]=D?D():void 0},r-Date.now()))}})}}),define(pe[89],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$St=void 0;class i{constructor(P,F,N,w){this.originalStart=P,this.originalLength=F,this.modifiedStart=N,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$St=i}),define(pe[6],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$W=t.$V=void 0,t.setUnexpectedErrorHandler=n,t.$Y=P,t.$Z=F,t.$1=N,t.$2=w,t.$3=D,t.$4=p,t.$6=$,t.$7=m,t.$8=e,t.$0=r;class i{constructor(){this.b=[],this.a=function(c){setTimeout(()=>{throw c.stack?T.isErrorNoTelemetry(c)?new T(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.b.push(c),()=>{this.d(c)}}c(c){this.b.forEach(b=>{b(c)})}d(c){this.b.splice(this.b.indexOf(c),1)}setUnexpectedErrorHandler(c){this.a=c}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(c){this.a(c),this.c(c)}onUnexpectedExternalError(c){this.a(c)}}t.$V=i,t.$W=new i;function n(d){t.$W.setUnexpectedErrorHandler(d)}function P(d){if(!d||typeof d!="object")return!1;const c=d;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}function F(d){p(d)||t.$W.onUnexpectedError(d)}function N(d){p(d)||t.$W.onUnexpectedExternalError(d)}function w(d){if(d instanceof Error){const{name:c,message:b}=d,A=d.stacktrace||d.stack;return{$isError:!0,name:c,message:b,stack:A,noTelemetry:T.isErrorNoTelemetry(d)}}return d}function D(d){let c;return d.noTelemetry?c=new T:(c=new Error,c.name=d.name),c.message=d.message,c.stack=d.stack,c}const f="Canceled";function p(d){return d instanceof y?!0:d instanceof Error&&d.name===f&&d.message===f}class y extends Error{constructor(){super(f),this.name=this.message}}t.$5=y;function $(){const d=new Error(f);return d.name=d.message,d}function m(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}function e(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}class s extends TypeError{constructor(c){super(c?`${c} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=s;function r(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}class h extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}t.$$=h;class a extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}t.$_=a;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=v;class T extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof T)return c;const b=new T;return b.message=c.message,b.stack=c.stack,b}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}t.$bb=T;class S extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype)}}t.$cb=S}),define(pe[9],we([1,0,6,87]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$9b=t.$8b=t.CompareResult=void 0,t.$sb=P,t.$tb=F,t.$ub=N,t.$vb=w,t.$wb=D,t.$xb=f,t.$yb=p,t.$zb=y,t.$Ab=$,t.$Bb=m,t.$Cb=e,t.$Db=s,t.$Eb=r,t.top=h,t.$Gb=a,t.$Hb=T,t.$Ib=S,t.$Jb=d,t.$Kb=c,t.$Lb=b,t.$Mb=A,t.$Nb=V,t.$Ob=U,t.$Pb=C,t.$Qb=E,t.$Rb=O,t.$Sb=x,t.$Tb=I,t.$Ub=_,t.$Vb=q,t.$Wb=J,t.$Xb=G,t.$Yb=K,t.$Zb=Q,t.$1b=ae,t.$2b=me,t.$3b=ye,t.$4b=Le,t.$5b=ne,t.$6b=le,t.$7b=ke,t.$0b=Ae,t.$bc=_e;function P(W,j=0){return W[W.length-(1+j)]}function F(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}function N(W,j,l=(o,g)=>o===g){if(W===j)return!0;if(!W||!j||W.length!==j.length)return!1;for(let o=0,g=W.length;o<g;o++)if(!l(W[o],j[o]))return!1;return!0}function w(W,j){const l=W.length-1;j<l&&(W[j]=W[l]),W.pop()}function D(W,j,l){return f(W.length,o=>l(W[o],j))}function f(W,j){let l=0,o=W-1;for(;l<=o;){const g=(l+o)/2|0,M=j(g);if(M<0)l=g+1;else if(M>0)o=g-1;else return g}return-(l+1)}function p(W,j,l){if(W=W|0,W>=j.length)throw new TypeError("invalid index");const o=j[Math.floor(j.length*Math.random())],g=[],M=[],k=[];for(const u of j){const L=l(u,o);L<0?g.push(u):L>0?M.push(u):k.push(u)}return W<g.length?p(W,g,l):W<g.length+k.length?k[0]:p(W-(g.length+k.length),M,l)}function y(W,j){const l=[];let o;for(const g of W.slice(0).sort(j))!o||j(o[0],g)!==0?(o=[g],l.push(o)):o.push(g);return l}function*$(W,j){let l,o;for(const g of W)o!==void 0&&j(o,g)?l.push(g):(l&&(yield l),l=[g]),o=g;l&&(yield l)}function m(W,j){for(let l=0;l<=W.length;l++)j(l===0?void 0:W[l-1],l===W.length?void 0:W[l])}function e(W,j){for(let l=0;l<W.length;l++)j(l===0?void 0:W[l-1],W[l],l+1===W.length?void 0:W[l+1])}function s(W,j,l){const o=[];function g(u,L,R){if(L===0&&R.length===0)return;const B=o[o.length-1];B&&B.start+B.deleteCount===u?(B.deleteCount+=L,B.toInsert.push(...R)):o.push({start:u,deleteCount:L,toInsert:R})}let M=0,k=0;for(;;){if(M===W.length){g(M,0,j.slice(k));break}if(k===j.length){g(M,W.length-M,[]);break}const u=W[M],L=j[k],R=l(u,L);R===0?(M+=1,k+=1):R<0?(g(M,1,[]),M+=1):R>0&&(g(M,0,[L]),k+=1)}return o}function r(W,j,l){const o=s(W,j,l),g=[],M=[];for(const k of o)g.push(...W.slice(k.start,k.start+k.deleteCount)),M.push(...k.toInsert);return{removed:g,added:M}}function h(W,j,l){if(l===0)return[];const o=W.slice(0,l).sort(j);return v(W,j,o,l,W.length),o}function a(W,j,l,o,g){return l===0?Promise.resolve([]):new Promise((M,k)=>{(async()=>{const u=W.length,L=W.slice(0,l).sort(j);for(let R=l,B=Math.min(l+o,u);R<u;R=B,B=Math.min(B+o,u)){if(R>l&&await new Promise(H=>setTimeout(H)),g&&g.isCancellationRequested)throw new i.$5;v(W,j,L,R,B)}return L})().then(M,k)})}function v(W,j,l,o,g){for(const M=l.length;o<g;o++){const k=W[o];if(j(k,l[M-1])<0){l.pop();const u=(0,n.$kb)(l,L=>j(k,L)<0);l.splice(u,0,k)}}}function T(W){return W.filter(j=>!!j)}function S(W){let j=0;for(let l=0;l<W.length;l++)W[l]&&(W[j]=W[l],j+=1);W.length=j}function d(W,j,l){W.splice(l,0,W.splice(j,1)[0])}function c(W){return!Array.isArray(W)||W.length===0}function b(W){return Array.isArray(W)&&W.length>0}function A(W,j=l=>l){const l=new Set;return W.filter(o=>{const g=j(o);return l.has(g)?!1:(l.add(g),!0)})}function V(W){const j=new Set;return l=>{const o=W(l);return j.has(o)?!1:(j.add(o),!0)}}function U(W,j){return W.length>0?W[0]:j}function C(W,j){return W.length>0?W[W.length-1]:j}function E(W,j,l=(o,g)=>o===g){let o=0;for(let g=0,M=Math.min(W.length,j.length);g<M&&l(W[g],j[g]);g++)o++;return o}function O(W,j){let l=typeof j=="number"?W:0;typeof j=="number"?l=W:(l=0,j=W);const o=[];if(l<=j)for(let g=l;g<j;g++)o.push(g);else for(let g=l;g>j;g--)o.push(g);return o}function x(W,j,l){return W.reduce((o,g)=>(o[j(g)]=l?l(g):g,o),Object.create(null))}function I(W,j){return W.push(j),()=>_(W,j)}function _(W,j){const l=W.indexOf(j);if(l>-1)return W.splice(l,1),j}function q(W,j,l){const o=W.slice(0,j),g=W.slice(j);return o.concat(l,g)}function J(W,j){let l;if(typeof j=="number"){let o=j;l=()=>{const g=Math.sin(o++)*179426549;return g-Math.floor(g)}}else l=Math.random;for(let o=W.length-1;o>0;o-=1){const g=Math.floor(l()*(o+1)),M=W[o];W[o]=W[g],W[g]=M}}function G(W,j){const l=W.indexOf(j);l>-1&&(W.splice(l,1),W.unshift(j))}function K(W,j){const l=W.indexOf(j);l>-1&&(W.splice(l,1),W.push(j))}function Q(W,j){for(const l of j)W.push(l)}function ae(W,j){return Array.isArray(W)?W.map(j):j(W)}function me(W){return Array.isArray(W)?W:[W]}function ye(W){return W[Math.floor(Math.random()*W.length)]}function Le(W,j,l){const o=ee(W,j),g=W.length,M=l.length;W.length=g+M;for(let k=g-1;k>=o;k--)W[k+M]=W[k];for(let k=0;k<M;k++)W[k+o]=l[k]}function ne(W,j,l,o){const g=ee(W,j);let M=W.splice(g,l);return M===void 0&&(M=[]),Le(W,g,o),M}function ee(W,j){return j<0?Math.max(j+W.length,0):Math.min(j,W.length)}var ce;(function(W){function j(M){return M<0}W.isLessThan=j;function l(M){return M<=0}W.isLessThanOrEqual=l;function o(M){return M>0}W.isGreaterThan=o;function g(M){return M===0}W.isNeitherLessOrGreaterThan=g,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(ce||(t.CompareResult=ce={}));function le(W,j){return(l,o)=>j(W(l),W(o))}function ke(...W){return(j,l)=>{for(const o of W){const g=o(j,l);if(!ce.isNeitherLessOrGreaterThan(g))return g}return ce.neitherLessOrGreaterThan}}const te=(W,j)=>W-j;t.$8b=te;const be=(W,j)=>(0,t.$8b)(W?1:0,j?1:0);t.$9b=be;function Ae(W){return(j,l)=>-W(j,l)}class Re{constructor(j){this.g=j,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(j){let l=this.c;for(;l<this.g.length&&j(this.g[l]);)l++;const o=l===this.c?null:this.g.slice(this.c,l);return this.c=l,o}takeFromEndWhile(j){let l=this.d;for(;l>=0&&j(this.g[l]);)l--;const o=l===this.d?null:this.g.slice(l+1,this.d+1);return this.d=l,o}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const j=this.g[this.c];return this.c++,j}removeLast(){const j=this.g[this.d];return this.d--,j}takeCount(j){const l=this.g.slice(this.c,this.c+j);return this.c+=j,l}}t.$$b=Re;class Ie{static{this.empty=new Ie(j=>{})}constructor(j){this.iterate=j}forEach(j){this.iterate(l=>(j(l),!0))}toArray(){const j=[];return this.iterate(l=>(j.push(l),!0)),j}filter(j){return new Ie(l=>this.iterate(o=>j(o)?l(o):!0))}map(j){return new Ie(l=>this.iterate(o=>l(j(o))))}some(j){let l=!1;return this.iterate(o=>(l=j(o),!l)),l}findFirst(j){let l;return this.iterate(o=>j(o)?(l=o,!1):!0),l}findLast(j){let l;return this.iterate(o=>(j(o)&&(l=o),!0)),l}findLastMaxBy(j){let l,o=!0;return this.iterate(g=>((o||ce.isGreaterThan(j(g,l)))&&(o=!1,l=g),!0)),l}}t.$_b=Ie;class je{constructor(j){this.c=j}static createSortPermutation(j,l){const o=Array.from(j.keys()).sort((g,M)=>l(j[g],j[M]));return new je(o)}apply(j){return j.map((l,o)=>j[this.c[o]])}inverse(){const j=this.c.slice();for(let l=0;l<this.c.length;l++)j[this.c[l]]=l;return new je(j)}}t.$ac=je;async function _e(W,j){return(await Promise.all(W.map(async(o,g)=>({element:o,ok:await j(o,g)})))).find(o=>o.ok)?.element}}),define(pe[42],we([1,0,6]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=n,t.$fd=P,t.$gd=F,t.$hd=N,t.$id=w,t.$jd=D;function n(f,p){if(!f)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}function P(f,p="Unreachable"){throw new Error(p)}function F(f,p="unexpected state"){if(!f)throw new i.$cb(`Assertion Failed: ${p}`)}function N(f){f||(0,i.$Z)(new i.$cb("Soft Assertion Failed"))}function w(f){if(!f()){debugger;f(),(0,i.$Z)(new i.$cb("Assertion Failed"))}}function D(f,p){let y=0;for(;y<f.length-1;){const $=f[y],m=f[y+1];if(!p($,m))return!1;y++}return!0}});var Fi=this&&this.__createBinding||(Object.create?function(oe,t,i,n){n===void 0&&(n=i);var P=Object.getOwnPropertyDescriptor(t,i);(!P||("get"in P?!t.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return t[i]}}),Object.defineProperty(oe,n,P)}:function(oe,t,i,n){n===void 0&&(n=i),oe[n]=t[i]}),Ii=this&&this.__setModuleDefault||(Object.create?function(oe,t){Object.defineProperty(oe,"default",{enumerable:!0,value:t})}:function(oe,t){oe.default=t}),He=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var t={};if(oe!=null)for(var i in oe)i!=="default"&&Object.prototype.hasOwnProperty.call(oe,i)&&Fi(t,oe,i);return Ii(t,oe),t};define(pe[30],we([1,0,9]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=void 0,t.$8c=P,t.$9c=F,t.$0c=N,t.$$c=w,t.$_c=D,t.$ad=f,i=He(i);const n=(m,e)=>m===e;t.$7c=n;function P(m=t.$7c){return(e,s)=>i.$ub(e,s,m)}function F(){return(m,e)=>JSON.stringify(m)===JSON.stringify(e)}function N(){return(m,e)=>m.equals(e)}function w(m,e,s){if(s!==void 0){const r=m;return r==null||e===void 0||e===null?e===r:s(r,e)}else{const r=m;return(h,a)=>h==null||a===void 0||a===null?a===h:r(h,a)}}function D(m,e){if(m===e)return!0;if(Array.isArray(m)&&Array.isArray(e)){if(m.length!==e.length)return!1;for(let s=0;s<m.length;s++)if(!D(m[s],e[s]))return!1;return!0}if(m&&typeof m=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(m)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=m,r=e,h=Object.keys(s),a=Object.keys(r),v=new Set(a);if(h.length!==a.length)return!1;for(const T of h)if(!v.has(T)||!D(s[T],r[T]))return!1;return!0}return!1}function f(m){return JSON.stringify($(m))}let p=0;const y=new WeakMap;function $(m){if(Array.isArray(m))return m.map($);if(m&&typeof m=="object")if(Object.getPrototypeOf(m)===Object.prototype){const e=m,s=Object.create(null);for(const r of Object.keys(e).sort())s[r]=$(e[r]);return s}else{let e=y.get(m);return e===void 0&&(e=p++,y.set(m,e)),e+"----2b76a038c20c4bcc"}return m}}),define(pe[58],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(n,P){const F=this;let N=!1,w;return function(){if(N)return w;if(N=!0,P)try{w=n.apply(F,arguments)}finally{P()}else w=n.apply(F,arguments);return w}}}),define(pe[90],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uQ=t.$tQ=void 0;class i{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}t.$tQ=i,t.$uQ=new i("id#")}),define(pe[36],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(n){function P(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=P;const F=Object.freeze([]);function N(){return F}n.empty=N;function*w(c){yield c}n.single=w;function D(c){return P(c)?c:w(c)}n.wrap=D;function f(c){return c||F}n.from=f;function*p(c){for(let b=c.length-1;b>=0;b--)yield c[b]}n.reverse=p;function y(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=y;function $(c){return c[Symbol.iterator]().next().value}n.first=$;function m(c,b){let A=0;for(const V of c)if(b(V,A++))return!0;return!1}n.some=m;function e(c,b){for(const A of c)if(b(A))return A}n.find=e;function*s(c,b){for(const A of c)b(A)&&(yield A)}n.filter=s;function*r(c,b){let A=0;for(const V of c)yield b(V,A++)}n.map=r;function*h(c,b){let A=0;for(const V of c)yield*b(V,A++)}n.flatMap=h;function*a(...c){for(const b of c)yield*b}n.concat=a;function v(c,b,A){let V=A;for(const U of c)V=b(V,U);return V}n.reduce=v;function*T(c,b,A=c.length){for(b<0&&(b+=c.length),A<0?A+=c.length:A>c.length&&(A=c.length);b<A;b++)yield c[b]}n.slice=T;function S(c,b=Number.POSITIVE_INFINITY){const A=[];if(b===0)return[A,c];const V=c[Symbol.iterator]();for(let U=0;U<b;U++){const C=V.next();if(C.done)return[A,n.empty()];A.push(C.value)}return[A,{[Symbol.iterator](){return V}}]}n.consume=S;async function d(c){const b=[];for await(const A of c)b.push(A);return Promise.resolve(b)}n.asyncToArray=d})(i||(t.Iterable=i={}))}),define(pe[91],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9j=i;function i(F){let N=!1;const w=new Map,D=new Map;if(P(F,s=>{if(F===s)return!0;const r=JSON.stringify(s);if(r.length<30)return!0;const h=w.get(r);if(!h){const a={schemas:[s]};return w.set(r,a),D.set(s,a),!0}return h.schemas.push(s),D.set(s,h),N=!0,!1}),w.clear(),!N)return JSON.stringify(F);let p="$defs";for(;F.hasOwnProperty(p);)p+="_";const y=[];function $(s){return JSON.stringify(s,(r,h)=>{if(h!==s){const a=D.get(h);if(a&&a.schemas.length>1)return a.id||(a.id=`_${y.length}`,y.push(a.schemas[0])),{$ref:`#/${p}/${a.id}`}}return h})}const m=$(F),e=[];for(let s=0;s<y.length;s++)e.push(`"_${s}":${$(y[s])}`);return e.length?`${m.substring(0,m.length-1)},"${p}":{${e.join(",")}}}`:m}function n(F){return typeof F=="object"&&F!==null}function P(F,N){if(!F||typeof F!="object")return;const w=(...m)=>{for(const e of m)n(e)&&y.push(e)},D=(...m)=>{for(const e of m)if(n(e))for(const s in e){const r=e[s];n(r)&&y.push(r)}},f=(...m)=>{for(const e of m)if(Array.isArray(e))for(const s of e)n(s)&&y.push(s)},p=m=>{if(Array.isArray(m))for(const e of m)n(e)&&y.push(e);else n(m)&&y.push(m)},y=[F];let $=y.pop();for(;$;)N($)&&(w($.additionalItems,$.additionalProperties,$.not,$.contains,$.propertyNames,$.if,$.then,$.else,$.unevaluatedItems,$.unevaluatedProperties),D($.definitions,$.$defs,$.properties,$.patternProperties,$.dependencies,$.dependentSchemas),f($.anyOf,$.allOf,$.oneOf,$.prefixItems),p($.items)),$=y.pop()}}),define(pe[8],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Yr=t.$Xr=t.$Wr=t.$Vr=t.$Ur=t.ScanCode=t.KeyCode=void 0,t.$Zr=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(t.ScanCode=n={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,r){this._keyCodeToStr[s]=r,this._strToKeyCode[r.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||i.Unknown}}const F=new P,N=new P,w=new P;t.$Ur=new Array(230),t.$Vr={};const D=[],f=Object.create(null),p=Object.create(null);t.$Wr={lowerCaseToEnum:e=>p[e]||n.None,toEnum:e=>f[e]||n.None,toString:e=>D[e]||"None"},t.$Xr=[],t.$Yr=[];for(let e=0;e<=n.MAX_VALUE;e++)t.$Xr[e]=i.DependsOnKbLayout;for(let e=0;e<=i.MAX_VALUE;e++)t.$Yr[e]=n.DependsOnKbLayout;(function(){const e="",s=[[1,n.None,"None",i.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",i.Unknown,e,0,e,e,e],[1,n.Super,"Super",i.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",i.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",i.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",i.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",i.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",i.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",i.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",i.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",i.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",i.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",i.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",i.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",i.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",i.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",i.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",i.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",i.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",i.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",i.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",i.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",i.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",i.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",i.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",i.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",i.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",i.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",i.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",i.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",i.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",i.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",i.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",i.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",i.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",i.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",i.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",i.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",i.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",i.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",i.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",i.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",i.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",i.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",i.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",i.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",i.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",i.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",i.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",i.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",i.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",i.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",i.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",i.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",i.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",i.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",i.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",i.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",i.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",i.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",i.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",i.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",i.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",i.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",i.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",i.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",i.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",i.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",i.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",i.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",i.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",i.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",i.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",i.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",i.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",i.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",i.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",i.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",i.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",i.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",i.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",i.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",i.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",i.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",i.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",i.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",i.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",i.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",i.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",i.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",i.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",i.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",i.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",i.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",i.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",i.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",i.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",i.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",i.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",i.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",i.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",i.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",i.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",i.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",i.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",i.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",i.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",i.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",i.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",i.Unknown,e,0,e,e,e],[1,n.F13,"F13",i.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",i.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",i.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",i.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",i.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",i.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",i.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",i.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",i.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",i.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",i.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",i.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",i.Unknown,e,0,e,e,e],[1,n.Help,"Help",i.Unknown,e,0,e,e,e],[1,n.Select,"Select",i.Unknown,e,0,e,e,e],[1,n.Again,"Again",i.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",i.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",i.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",i.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",i.Unknown,e,0,e,e,e],[1,n.Find,"Find",i.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",i.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",i.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",i.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",i.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",i.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",i.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",i.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",i.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",i.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",i.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",i.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",i.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",i.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",i.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",i.Unknown,e,0,e,e,e],[1,n.Props,"Props",i.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",i.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",i.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",i.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",i.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",i.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",i.Unknown,e,0,e,e,e],[1,n.None,e,i.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,i.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,i.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,i.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",i.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",i.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",i.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",i.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",i.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",i.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",i.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",i.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",i.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",i.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",i.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",i.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",i.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",i.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",i.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",i.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",i.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",i.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",i.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",i.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",i.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",i.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",i.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",i.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",i.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",i.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",i.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",i.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",i.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",i.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",i.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",i.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",i.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",i.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",i.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",i.Unknown,e,0,e,e,e],[1,n.None,e,i.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,i.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,i.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,i.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,i.Unknown,e,0,"VK_OEM_CLEAR",e,e]],r=[],h=[];for(const a of s){const[v,T,S,d,c,b,A,V,U]=a;if(h[T]||(h[T]=!0,D[T]=S,f[S]=T,p[S.toLowerCase()]=T,v&&(t.$Xr[T]=d,d!==i.Unknown&&d!==i.Enter&&d!==i.Ctrl&&d!==i.Shift&&d!==i.Alt&&d!==i.Meta&&(t.$Yr[d]=T))),!r[d]){if(r[d]=!0,!c)throw new Error(`String representation missing for key code ${d} around scan code ${S}`);F.define(d,c),N.define(d,V||c),w.define(d,U||V||c)}b&&(t.$Ur[b]=d),A&&(t.$Vr[A]=d)}t.$Yr[i.Enter]=n.Enter})();var y;(function(e){function s(S){return F.keyCodeToStr(S)}e.toString=s;function r(S){return F.strToKeyCode(S)}e.fromString=r;function h(S){return N.keyCodeToStr(S)}e.toUserSettingsUS=h;function a(S){return w.keyCodeToStr(S)}e.toUserSettingsGeneral=a;function v(S){return N.strToKeyCode(S)||w.strToKeyCode(S)}e.fromUserSettings=v;function T(S){if(S>=i.Numpad0&&S<=i.NumpadDivide)return null;switch(S){case i.UpArrow:return"Up";case i.DownArrow:return"Down";case i.LeftArrow:return"Left";case i.RightArrow:return"Right"}return F.keyCodeToStr(S)}e.toElectronAccelerator=T})(y||(t.KeyCodeUtils=y={}));var $;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})($||(t.KeyMod=$={}));function m(e,s){const r=(s&65535)<<16>>>0;return(e|r)>>>0}}),define(pe[25],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class i{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=i}),define(pe[14],we([1,0,25]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NU=w,t.$OU=D,t.$PU=f;let P=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const F=new i.$U(()=>P("mouse",!1)),N=new i.$U(()=>P("element",!1));function w(p){P=p}function D(p){return p==="element"?N.value:F.value}function f(){return P("element",!0)}}),define(pe[59],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(F){this.element=F,this.next=i.Undefined,this.prev=i.Undefined}}class n{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let F=this.a;for(;F!==i.Undefined;){const N=F.next;F.prev=i.Undefined,F.next=i.Undefined,F=N}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(F){return this.d(F,!1)}push(F){return this.d(F,!0)}d(F,N){const w=new i(F);if(this.a===i.Undefined)this.a=w,this.b=w;else if(N){const f=this.b;this.b=w,w.prev=f,f.next=w}else{const f=this.a;this.a=w,w.next=f,f.prev=w}this.c+=1;let D=!1;return()=>{D||(D=!0,this.e(w))}}shift(){if(this.a!==i.Undefined){const F=this.a.element;return this.e(this.a),F}}pop(){if(this.b!==i.Undefined){const F=this.b.element;return this.e(this.b),F}}e(F){if(F.prev!==i.Undefined&&F.next!==i.Undefined){const N=F.prev;N.next=F.next,F.next.prev=N}else F.prev===i.Undefined&&F.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):F.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):F.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let F=this.a;for(;F!==i.Undefined;)yield F.element,F=F.next}}t.$6c=n}),define(pe[43],we([1,0]),function(oe,t){"use strict";var i,n,P;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=F,t.$zc=N,t.$Ac=w,t.$Jc=T;function F(S,d,c){let b=S.get(d);return b===void 0&&(b=c,S.set(d,b)),b}function N(S){const d=[];return S.forEach((c,b)=>{d.push(`${b} => ${c}`)}),`Map(${S.size}) {${d.join(", ")}}`}function w(S){const d=[];return S.forEach(c=>{d.push(c)}),`Set(${S.size}) {${d.join(", ")}}`}class D{constructor(d,c){this.uri=d,this.value=c}}function f(S){return Array.isArray(S)}class p{static{this.c=d=>d.toString()}constructor(d,c){if(this[i]="ResourceMap",d instanceof p)this.d=new Map(d.d),this.e=c??p.c;else if(f(d)){this.d=new Map,this.e=c??p.c;for(const[b,A]of d)this.set(b,A)}else this.d=new Map,this.e=d??p.c}set(d,c){return this.d.set(this.e(d),new D(d,c)),this}get(d){return this.d.get(this.e(d))?.value}has(d){return this.d.has(this.e(d))}get size(){return this.d.size}clear(){this.d.clear()}delete(d){return this.d.delete(this.e(d))}forEach(d,c){typeof c<"u"&&(d=d.bind(c));for(const[b,A]of this.d)d(A.value,A.uri,this)}*values(){for(const d of this.d.values())yield d.value}*keys(){for(const d of this.d.values())yield d.uri}*entries(){for(const d of this.d.values())yield[d.uri,d.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.d)yield[d.uri,d.value]}}t.$Bc=p;class y{constructor(d,c){this[n]="ResourceSet",!d||typeof d=="function"?this.c=new p(d):(this.c=new p(c),d.forEach(this.add,this))}get size(){return this.c.size}add(d){return this.c.set(d,d),this}clear(){this.c.clear()}delete(d){return this.c.delete(d)}forEach(d,c){this.c.forEach((b,A)=>d.call(c,A,A,this))}has(d){return this.c.has(d)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=y;var $;(function(S){S[S.None=0]="None",S[S.AsOld=1]="AsOld",S[S.AsNew=2]="AsNew"})($||(t.Touch=$={}));class m{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(d){return this.c.has(d)}get(d,c=$.None){const b=this.c.get(d);if(b)return c!==$.None&&this.m(b,c),b.value}set(d,c,b=$.None){let A=this.c.get(d);if(A)A.value=c,b!==$.None&&this.m(A,b);else{switch(A={key:d,value:c,next:void 0,previous:void 0},b){case $.None:this.k(A);break;case $.AsOld:this.j(A);break;case $.AsNew:this.k(A);break;default:this.k(A);break}this.c.set(d,A),this.f++}return this}delete(d){return!!this.remove(d)}remove(d){const c=this.c.get(d);if(c)return this.c.delete(d),this.l(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const d=this.d;return this.c.delete(d.key),this.l(d),this.f--,d.value}forEach(d,c){const b=this.g;let A=this.d;for(;A;){if(c?d.bind(c)(A.value,A.key,this):d(A.value,A.key,this),this.g!==b)throw new Error("LinkedMap got modified during iteration.");A=A.next}}keys(){const d=this,c=this.g;let b=this.d;const A={[Symbol.iterator](){return A},next(){if(d.g!==c)throw new Error("LinkedMap got modified during iteration.");if(b){const V={value:b.key,done:!1};return b=b.next,V}else return{value:void 0,done:!0}}};return A}values(){const d=this,c=this.g;let b=this.d;const A={[Symbol.iterator](){return A},next(){if(d.g!==c)throw new Error("LinkedMap got modified during iteration.");if(b){const V={value:b.value,done:!1};return b=b.next,V}else return{value:void 0,done:!0}}};return A}entries(){const d=this,c=this.g;let b=this.d;const A={[Symbol.iterator](){return A},next(){if(d.g!==c)throw new Error("LinkedMap got modified during iteration.");if(b){const V={value:[b.key,b.value],done:!1};return b=b.next,V}else return{value:void 0,done:!0}}};return A}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(d){if(d>=this.size)return;if(d===0){this.clear();return}let c=this.d,b=this.size;for(;c&&b>d;)this.c.delete(c.key),c=c.next,b--;this.d=c,this.f=b,c&&(c.previous=void 0),this.g++}i(d){if(d>=this.size)return;if(d===0){this.clear();return}let c=this.e,b=this.size;for(;c&&b>d;)this.c.delete(c.key),c=c.previous,b--;this.e=c,this.f=b,c&&(c.next=void 0),this.g++}j(d){if(!this.d&&!this.e)this.e=d;else if(this.d)d.next=this.d,this.d.previous=d;else throw new Error("Invalid list");this.d=d,this.g++}k(d){if(!this.d&&!this.e)this.d=d;else if(this.e)d.previous=this.e,this.e.next=d;else throw new Error("Invalid list");this.e=d,this.g++}l(d){if(d===this.d&&d===this.e)this.d=void 0,this.e=void 0;else if(d===this.d){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.d=d.next}else if(d===this.e){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.e=d.previous}else{const c=d.next,b=d.previous;if(!c||!b)throw new Error("Invalid list");c.previous=b,b.next=c}d.next=void 0,d.previous=void 0,this.g++}m(d,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==$.AsOld&&c!==$.AsNew)){if(c===$.AsOld){if(d===this.d)return;const b=d.next,A=d.previous;d===this.e?(A.next=void 0,this.e=A):(b.previous=A,A.next=b),d.previous=void 0,d.next=this.d,this.d.previous=d,this.d=d,this.g++}else if(c===$.AsNew){if(d===this.e)return;const b=d.next,A=d.previous;d===this.d?(b.previous=void 0,this.d=b):(b.previous=A,A.next=b),d.next=void 0,d.previous=this.e,this.e.next=d,this.e=d,this.g++}}}toJSON(){const d=[];return this.forEach((c,b)=>{d.push([b,c])}),d}fromJSON(d){this.clear();for(const[c,b]of d)this.set(c,b)}}t.$Dc=m;class e extends m{constructor(d,c=1){super(),this.n=d,this.o=Math.min(Math.max(0,c),1)}get limit(){return this.n}set limit(d){this.n=d,this.p()}get ratio(){return this.o}set ratio(d){this.o=Math.min(Math.max(0,d),1),this.p()}get(d,c=$.AsNew){return super.get(d,c)}peek(d){return super.get(d,$.None)}set(d,c){return super.set(d,c,$.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class s extends e{constructor(d,c=1){super(d,c)}q(d){this.h(d)}set(d,c){return super.set(d,c),this.p(),this}}t.$Ec=s;class r extends e{constructor(d,c=1){super(d,c)}q(d){this.i(d)}set(d,c){return this.n<=this.size&&!this.has(d)&&this.q(Math.round(this.n*this.o)-1),super.set(d,c),this}}t.$Fc=r;class h{constructor(){this.c=new Map}add(d){return this.c.set(d,(this.c.get(d)||0)+1),this}delete(d){let c=this.c.get(d)||0;return c===0?!1:(c--,c===0?this.c.delete(d):this.c.set(d,c),!0)}has(d){return this.c.has(d)}}t.$Gc=h;class a{constructor(d){if(this.c=new Map,this.d=new Map,d)for(const[c,b]of d)this.set(c,b)}clear(){this.c.clear(),this.d.clear()}set(d,c){this.c.set(d,c),this.d.set(c,d)}get(d){return this.c.get(d)}getKey(d){return this.d.get(d)}delete(d){const c=this.c.get(d);return c===void 0?!1:(this.c.delete(d),this.d.delete(c),!0)}forEach(d,c){this.c.forEach((b,A)=>{d.call(c,b,A,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Hc=a;class v{constructor(){this.c=new Map}add(d,c){let b=this.c.get(d);b||(b=new Set,this.c.set(d,b)),b.add(c)}delete(d,c){const b=this.c.get(d);b&&(b.delete(c),b.size===0&&this.c.delete(d))}forEach(d,c){const b=this.c.get(d);b&&b.forEach(c)}get(d){const c=this.c.get(d);return c||new Set}}t.$Ic=v;function T(S,d){if(S===d)return!0;if(S.size!==d.size)return!1;for(const[c,b]of S)if(!d.has(c)||d.get(c)!==b)return!1;for(const[c]of d)if(!S.has(c))return!1;return!0}}),define(pe[2],we([1,0,9,57,43,58,36]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Kc=void 0,t.$Lc=p,t.$Mc=y,t.$Nc=$,t.$Oc=s,t.$Pc=r,t.$Qc=h,t.$Rc=a,t.$Sc=v,t.$Tc=T,t.$4c=O;const w=!1;let D=null;class f{constructor(){this.b=new Map}static{this.a=0}c(_){let q=this.b.get(_);return q||(q={parent:null,source:null,isSingleton:!1,value:_,idx:f.a++},this.b.set(_,q)),q}trackDisposable(_){const q=this.c(_);q.source||(q.source=new Error().stack)}setParent(_,q){const J=this.c(_);J.parent=q}markAsDisposed(_){this.b.delete(_)}markAsSingleton(_){this.c(_).isSingleton=!0}f(_,q){const J=q.get(_);if(J)return J;const G=_.parent?this.f(this.c(_.parent),q):_;return q.set(_,G),G}getTrackedDisposables(){const _=new Map;return[...this.b.entries()].filter(([,J])=>J.source!==null&&!this.f(J,_).isSingleton).flatMap(([J])=>J)}computeLeakingDisposables(_=10,q){let J;if(q)J=q;else{const me=new Map,ye=[...this.b.values()].filter(ne=>ne.source!==null&&!this.f(ne,me).isSingleton);if(ye.length===0)return;const Le=new Set(ye.map(ne=>ne.value));if(J=ye.filter(ne=>!(ne.parent&&Le.has(ne.parent))),J.length===0)throw new Error("There are cyclic diposable chains!")}if(!J)return;function G(me){function ye(ne,ee){for(;ne.length>0&&ee.some(ce=>typeof ce=="string"?ce===ne[0]:ne[0].match(ce));)ne.shift()}const Le=me.source.split(`
`).map(ne=>ne.trim().replace("at ","")).filter(ne=>ne!=="");return ye(Le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Le.reverse()}const K=new P.$Ic;for(const me of J){const ye=G(me);for(let Le=0;Le<=ye.length;Le++)K.add(ye.slice(0,Le).join(`
`),me)}J.sort((0,i.$6b)(me=>me.idx,i.$8b));let Q="",ae=0;for(const me of J.slice(0,_)){ae++;const ye=G(me),Le=[];for(let ne=0;ne<ye.length;ne++){let ee=ye[ne];ee=`(shared with ${K.get(ye.slice(0,ne+1).join(`
`)).size}/${J.length} leaks) at ${ee}`;const le=K.get(ye.slice(0,ne).join(`
`)),ke=(0,n.$c)([...le].map(te=>G(te)[ne]),te=>te);delete ke[ye[ne]];for(const[te,be]of Object.entries(ke))Le.unshift(`    - stacktraces of ${be.length} other leaks continue with ${te}`);Le.unshift(ee)}Q+=`


==================== Leaking disposable ${ae}/${J.length}: ${me.value.constructor.name} ====================
${Le.join(`
`)}
============================================================

`}return J.length>_&&(Q+=`


... and ${J.length-_} more leaking disposables

`),{leaks:J,details:Q}}}t.$Kc=f;function p(I){D=I}if(w){const I="__is_disposable_tracked__";p(new class{trackDisposable(_){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{_[I]||console.log(q)},3e3)}setParent(_,q){if(_&&_!==d.None)try{_[I]=!0}catch{}}markAsDisposed(_){if(_&&_!==d.None)try{_[I]=!0}catch{}}markAsSingleton(_){}})}function y(I){return D?.trackDisposable(I),I}function $(I){D?.markAsDisposed(I)}function m(I,_){D?.setParent(I,_)}function e(I,_){if(D)for(const q of I)D.setParent(q,_)}function s(I){return D?.markAsSingleton(I),I}function r(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function h(I){if(N.Iterable.is(I)){const _=[];for(const q of I)if(q)try{q.dispose()}catch(J){_.push(J)}if(_.length===1)throw _[0];if(_.length>1)throw new AggregateError(_,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function a(I){for(const _ of I)r(_)&&_.dispose();return[]}function v(...I){const _=T(()=>h(I));return e(I,_),_}function T(I){const _=y({dispose:(0,F.$db)(()=>{$(_),I()})});return _}class S{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(_){if(!_)return _;if(_===this)throw new Error("Cannot register a disposable on itself!");return m(_,this),this.g?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(_),_}delete(_){if(_){if(_===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(_),_.dispose()}}deleteAndLeak(_){_&&this.f.has(_)&&(this.f.delete(_),m(_,null))}}t.$Uc=S;class d{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new S,y(this),m(this.q,this)}dispose(){$(this),this.q.dispose()}B(_){if(_===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(_)}}t.$Vc=d;class c{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(_){this.b||_===this.a||(this.a?.dispose(),_&&m(_,this),this.a=_)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const _=this.a;return this.a=void 0,_&&m(_,null),_}}t.$Wc=c;class b{constructor(_){this.a=new c,this.b=!1,this.a.value=_}get value(){return this.a.value}set value(_){this.b||_===this.a.value||(this.a.value=_)}dispose(){this.b=!0,this.a.dispose()}}t.$Xc=b;class A{constructor(_){this.b=_,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Yc=A;class V{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(_){let q=_;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,$(this))},this}}t.$Zc=V;class U{constructor(){this.a=new Map}acquire(_,...q){let J=this.a.get(_);J||(J={counter:0,object:this.b(_,...q)},this.a.set(_,J));const{object:G}=J,K=(0,F.$db)(()=>{--J.counter===0&&(this.c(_,J.object),this.a.delete(_))});return J.counter++,{object:G,dispose:K}}}t.$1c=U;class C{constructor(_){this.a=_}async acquire(_,...q){const J=this.a.acquire(_,...q);try{return{object:await J.object,dispose:()=>J.dispose()}}catch(G){throw J.dispose(),G}}}t.$2c=C;class E{constructor(_){this.object=_}dispose(){}}t.$3c=E;function O(I){const _=new S;try{I(_)}finally{_.dispose()}}class x{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(_){return this.a.has(_)}get size(){return this.a.size}get(_){return this.a.get(_)}set(_,q,J=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),J||this.a.get(_)?.dispose(),this.a.set(_,q)}deleteAndDispose(_){this.a.get(_)?.dispose(),this.a.delete(_)}deleteAndLeak(_){const q=this.a.get(_);return this.a.delete(_),q}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$5c=x}),function(oe,t){typeof define=="function"&&define.amd?define(pe[92],we([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,t(oe.marked={}))}(this,function(oe){"use strict";function t(W,j){for(var l=0;l<j.length;l++){var o=j[l];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(W,o.key,o)}}function i(W,j,l){return j&&t(W.prototype,j),l&&t(W,l),Object.defineProperty(W,"prototype",{writable:!1}),W}function n(W,j){if(W){if(typeof W=="string")return P(W,j);var l=Object.prototype.toString.call(W).slice(8,-1);if(l==="Object"&&W.constructor&&(l=W.constructor.name),l==="Map"||l==="Set")return Array.from(W);if(l==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(l))return P(W,j)}}function P(W,j){(j==null||j>W.length)&&(j=W.length);for(var l=0,o=new Array(j);l<j;l++)o[l]=W[l];return o}function F(W,j){var l=typeof Symbol<"u"&&W[Symbol.iterator]||W["@@iterator"];if(l)return(l=l.call(W)).next.bind(l);if(Array.isArray(W)||(l=n(W))||j&&W&&typeof W.length=="number"){l&&(W=l);var o=0;return function(){return o>=W.length?{done:!0}:{done:!1,value:W[o++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function N(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=N();function w(W){oe.defaults=W}var D=/[&<>"']/,f=/[&<>"']/g,p=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(j){return $[j]};function e(W,j){if(j){if(D.test(W))return W.replace(f,m)}else if(p.test(W))return W.replace(y,m);return W}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(W){return W.replace(s,function(j,l){return l=l.toLowerCase(),l==="colon"?":":l.charAt(0)==="#"?l.charAt(1)==="x"?String.fromCharCode(parseInt(l.substring(2),16)):String.fromCharCode(+l.substring(1)):""})}var h=/(^|[^\[])\^/g;function a(W,j){W=typeof W=="string"?W:W.source,j=j||"";var l={replace:function(g,M){return M=M.source||M,M=M.replace(h,"$1"),W=W.replace(g,M),l},getRegex:function(){return new RegExp(W,j)}};return l}var v=/[^\w:]/g,T=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(W,j,l){if(W){var o;try{o=decodeURIComponent(r(l)).replace(v,"").toLowerCase()}catch{return null}if(o.indexOf("javascript:")===0||o.indexOf("vbscript:")===0||o.indexOf("data:")===0)return null}j&&!T.test(l)&&(l=V(j,l));try{l=encodeURI(l).replace(/%25/g,"%")}catch{return null}return l}var d={},c=/^[^:]+:\/*[^/]*$/,b=/^([^:]+:)[\s\S]*$/,A=/^([^:]+:\/*[^/]*)[\s\S]*$/;function V(W,j){d[" "+W]||(c.test(W)?d[" "+W]=W+"/":d[" "+W]=O(W,"/",!0)),W=d[" "+W];var l=W.indexOf(":")===-1;return j.substring(0,2)==="//"?l?j:W.replace(b,"$1")+j:j.charAt(0)==="/"?l?j:W.replace(A,"$1")+j:W+j}var U={exec:function(){}};function C(W){for(var j=1,l,o;j<arguments.length;j++){l=arguments[j];for(o in l)Object.prototype.hasOwnProperty.call(l,o)&&(W[o]=l[o])}return W}function E(W,j){var l=W.replace(/\|/g,function(M,k,u){for(var L=!1,R=k;--R>=0&&u[R]==="\\";)L=!L;return L?"|":" |"}),o=l.split(/ \|/),g=0;if(o[0].trim()||o.shift(),o.length>0&&!o[o.length-1].trim()&&o.pop(),o.length>j)o.splice(j);else for(;o.length<j;)o.push("");for(;g<o.length;g++)o[g]=o[g].trim().replace(/\\\|/g,"|");return o}function O(W,j,l){var o=W.length;if(o===0)return"";for(var g=0;g<o;){var M=W.charAt(o-g-1);if(M===j&&!l)g++;else if(M!==j&&l)g++;else break}return W.slice(0,o-g)}function x(W,j){if(W.indexOf(j[1])===-1)return-1;for(var l=W.length,o=0,g=0;g<l;g++)if(W[g]==="\\")g++;else if(W[g]===j[0])o++;else if(W[g]===j[1]&&(o--,o<0))return g;return-1}function I(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function _(W,j){if(j<1)return"";for(var l="";j>1;)j&1&&(l+=W),j>>=1,W+=W;return l+W}function q(W,j,l,o){var g=j.href,M=j.title?e(j.title):null,k=W[1].replace(/\\([\[\]])/g,"$1");if(W[0].charAt(0)!=="!"){o.state.inLink=!0;var u={type:"link",raw:l,href:g,title:M,text:k,tokens:o.inlineTokens(k)};return o.state.inLink=!1,u}return{type:"image",raw:l,href:g,title:M,text:e(k)}}function J(W,j){var l=W.match(/^(\s+)(?:```)/);if(l===null)return j;var o=l[1];return j.split(`
`).map(function(g){var M=g.match(/^\s+/);if(M===null)return g;var k=M[0];return k.length>=o.length?g.slice(o.length):g}).join(`
`)}var G=function(){function W(l){this.options=l||oe.defaults}var j=W.prototype;return j.space=function(o){var g=this.rules.block.newline.exec(o);if(g&&g[0].length>0)return{type:"space",raw:g[0]}},j.code=function(o){var g=this.rules.block.code.exec(o);if(g){var M=g[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:g[0],codeBlockStyle:"indented",text:this.options.pedantic?M:O(M,`
`)}}},j.fences=function(o){var g=this.rules.block.fences.exec(o);if(g){var M=g[0],k=J(M,g[3]||"");return{type:"code",raw:M,lang:g[2]?g[2].trim():g[2],text:k}}},j.heading=function(o){var g=this.rules.block.heading.exec(o);if(g){var M=g[2].trim();if(/#$/.test(M)){var k=O(M,"#");(this.options.pedantic||!k||/ $/.test(k))&&(M=k.trim())}return{type:"heading",raw:g[0],depth:g[1].length,text:M,tokens:this.lexer.inline(M)}}},j.hr=function(o){var g=this.rules.block.hr.exec(o);if(g)return{type:"hr",raw:g[0]}},j.blockquote=function(o){var g=this.rules.block.blockquote.exec(o);if(g){var M=g[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:g[0],tokens:this.lexer.blockTokens(M,[]),text:M}}},j.list=function(o){var g=this.rules.block.list.exec(o);if(g){var M,k,u,L,R,B,H,Y,ie,re,he,De,ve=g[1].trim(),Ee=ve.length>1,Ne={type:"list",raw:"",ordered:Ee,start:Ee?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Ee?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Ee?ve:"[*+-]");for(var fe=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");o&&(De=!1,!(!(g=fe.exec(o))||this.rules.block.hr.test(o)));){if(M=g[0],o=o.substring(M.length),Y=g[2].split(`
`,1)[0],ie=o.split(`
`,1)[0],this.options.pedantic?(L=2,he=Y.trimLeft()):(L=g[2].search(/[^ ]/),L=L>4?1:L,he=Y.slice(L),L+=g[1].length),B=!1,!Y&&/^ *$/.test(ie)&&(M+=ie+`
`,o=o.substring(ie.length+1),De=!0),!De)for(var Fe=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ke=new RegExp("^ {0,"+Math.min(3,L-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Xe=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,L-1)+"}#");o&&(re=o.split(`
`,1)[0],Y=re,this.options.pedantic&&(Y=Y.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Xe.test(Y)||tt.test(Y)||Fe.test(Y)||Ke.test(o)));){if(Y.search(/[^ ]/)>=L||!Y.trim())he+=`
`+Y.slice(L);else if(!B)he+=`
`+Y;else break;!B&&!Y.trim()&&(B=!0),M+=re+`
`,o=o.substring(re.length+1)}Ne.loose||(H?Ne.loose=!0:/\n *\n *$/.test(M)&&(H=!0)),this.options.gfm&&(k=/^\[[ xX]\] /.exec(he),k&&(u=k[0]!=="[ ] ",he=he.replace(/^\[[ xX]\] +/,""))),Ne.items.push({type:"list_item",raw:M,task:!!k,checked:u,loose:!1,text:he}),Ne.raw+=M}Ne.items[Ne.items.length-1].raw=M.trimRight(),Ne.items[Ne.items.length-1].text=he.trimRight(),Ne.raw=Ne.raw.trimRight();var lt=Ne.items.length;for(R=0;R<lt;R++){this.lexer.state.top=!1,Ne.items[R].tokens=this.lexer.blockTokens(Ne.items[R].text,[]);var st=Ne.items[R].tokens.filter(function(Ze){return Ze.type==="space"}),Ge=st.every(function(Ze){for(var Z=Ze.raw.split(""),ue=0,$e=F(Z),Se;!(Se=$e()).done;){var Pe=Se.value;if(Pe===`
`&&(ue+=1),ue>1)return!0}return!1});!Ne.loose&&st.length&&Ge&&(Ne.loose=!0,Ne.items[R].loose=!0)}return Ne}},j.html=function(o){var g=this.rules.block.html.exec(o);if(g){var M={type:"html",raw:g[0],pre:!this.options.sanitizer&&(g[1]==="pre"||g[1]==="script"||g[1]==="style"),text:g[0]};if(this.options.sanitize){var k=this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]);M.type="paragraph",M.text=k,M.tokens=this.lexer.inline(k)}return M}},j.def=function(o){var g=this.rules.block.def.exec(o);if(g){g[3]&&(g[3]=g[3].substring(1,g[3].length-1));var M=g[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:M,raw:g[0],href:g[2],title:g[3]}}},j.table=function(o){var g=this.rules.block.table.exec(o);if(g){var M={type:"table",header:E(g[1]).map(function(H){return{text:H}}),align:g[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:g[3]&&g[3].trim()?g[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(M.header.length===M.align.length){M.raw=g[0];var k=M.align.length,u,L,R,B;for(u=0;u<k;u++)/^ *-+: *$/.test(M.align[u])?M.align[u]="right":/^ *:-+: *$/.test(M.align[u])?M.align[u]="center":/^ *:-+ *$/.test(M.align[u])?M.align[u]="left":M.align[u]=null;for(k=M.rows.length,u=0;u<k;u++)M.rows[u]=E(M.rows[u],M.header.length).map(function(H){return{text:H}});for(k=M.header.length,L=0;L<k;L++)M.header[L].tokens=this.lexer.inline(M.header[L].text);for(k=M.rows.length,L=0;L<k;L++)for(B=M.rows[L],R=0;R<B.length;R++)B[R].tokens=this.lexer.inline(B[R].text);return M}}},j.lheading=function(o){var g=this.rules.block.lheading.exec(o);if(g)return{type:"heading",raw:g[0],depth:g[2].charAt(0)==="="?1:2,text:g[1],tokens:this.lexer.inline(g[1])}},j.paragraph=function(o){var g=this.rules.block.paragraph.exec(o);if(g){var M=g[1].charAt(g[1].length-1)===`
`?g[1].slice(0,-1):g[1];return{type:"paragraph",raw:g[0],text:M,tokens:this.lexer.inline(M)}}},j.text=function(o){var g=this.rules.block.text.exec(o);if(g)return{type:"text",raw:g[0],text:g[0],tokens:this.lexer.inline(g[0])}},j.escape=function(o){var g=this.rules.inline.escape.exec(o);if(g)return{type:"escape",raw:g[0],text:e(g[1])}},j.tag=function(o){var g=this.rules.inline.tag.exec(o);if(g)return!this.lexer.state.inLink&&/^<a /i.test(g[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(g[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(g[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(g[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:g[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]):g[0]}},j.link=function(o){var g=this.rules.inline.link.exec(o);if(g){var M=g[2].trim();if(!this.options.pedantic&&/^</.test(M)){if(!/>$/.test(M))return;var k=O(M.slice(0,-1),"\\");if((M.length-k.length)%2===0)return}else{var u=x(g[2],"()");if(u>-1){var L=g[0].indexOf("!")===0?5:4,R=L+g[1].length+u;g[2]=g[2].substring(0,u),g[0]=g[0].substring(0,R).trim(),g[3]=""}}var B=g[2],H="";if(this.options.pedantic){var Y=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);Y&&(B=Y[1],H=Y[3])}else H=g[3]?g[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(M)?B=B.slice(1):B=B.slice(1,-1)),q(g,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},g[0],this.lexer)}},j.reflink=function(o,g){var M;if((M=this.rules.inline.reflink.exec(o))||(M=this.rules.inline.nolink.exec(o))){var k=(M[2]||M[1]).replace(/\s+/g," ");if(k=g[k.toLowerCase()],!k||!k.href){var u=M[0].charAt(0);return{type:"text",raw:u,text:u}}return q(M,k,M[0],this.lexer)}},j.emStrong=function(o,g,M){M===void 0&&(M="");var k=this.rules.inline.emStrong.lDelim.exec(o);if(k&&!(k[3]&&M.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var u=k[1]||k[2]||"";if(!u||u&&(M===""||this.rules.inline.punctuation.exec(M))){var L=k[0].length-1,R,B,H=L,Y=0,ie=k[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,g=g.slice(-1*o.length+L);(k=ie.exec(g))!=null;)if(R=k[1]||k[2]||k[3]||k[4]||k[5]||k[6],!!R){if(B=R.length,k[3]||k[4]){H+=B;continue}else if((k[5]||k[6])&&L%3&&!((L+B)%3)){Y+=B;continue}if(H-=B,!(H>0)){if(B=Math.min(B,B+H+Y),Math.min(L,B)%2){var re=o.slice(1,L+k.index+B);return{type:"em",raw:o.slice(0,L+k.index+B+1),text:re,tokens:this.lexer.inlineTokens(re)}}var he=o.slice(2,L+k.index+B-1);return{type:"strong",raw:o.slice(0,L+k.index+B+1),text:he,tokens:this.lexer.inlineTokens(he)}}}}}},j.codespan=function(o){var g=this.rules.inline.code.exec(o);if(g){var M=g[2].replace(/\n/g," "),k=/[^ ]/.test(M),u=/^ /.test(M)&&/ $/.test(M);return k&&u&&(M=M.substring(1,M.length-1)),M=e(M,!0),{type:"codespan",raw:g[0],text:M}}},j.br=function(o){var g=this.rules.inline.br.exec(o);if(g)return{type:"br",raw:g[0]}},j.del=function(o){var g=this.rules.inline.del.exec(o);if(g)return{type:"del",raw:g[0],text:g[2],tokens:this.lexer.inlineTokens(g[2])}},j.autolink=function(o,g){var M=this.rules.inline.autolink.exec(o);if(M){var k,u;return M[2]==="@"?(k=e(this.options.mangle?g(M[1]):M[1]),u="mailto:"+k):(k=e(M[1]),u=k),{type:"link",raw:M[0],text:k,href:u,tokens:[{type:"text",raw:k,text:k}]}}},j.url=function(o,g){var M;if(M=this.rules.inline.url.exec(o)){var k,u;if(M[2]==="@")k=e(this.options.mangle?g(M[0]):M[0]),u="mailto:"+k;else{var L;do L=M[0],M[0]=this.rules.inline._backpedal.exec(M[0])[0];while(L!==M[0]);k=e(M[0]),M[1]==="www."?u="http://"+k:u=k}return{type:"link",raw:M[0],text:k,href:u,tokens:[{type:"text",raw:k,text:k}]}}},j.inlineText=function(o,g){var M=this.rules.inline.text.exec(o);if(M){var k;return this.lexer.state.inRawBlock?k=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(M[0]):e(M[0]):M[0]:k=e(this.options.smartypants?g(M[0]):M[0]),{type:"text",raw:M[0],text:k}}},W}(),K={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};K._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,K._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,K.def=a(K.def).replace("label",K._label).replace("title",K._title).getRegex(),K.bullet=/(?:[*+-]|\d{1,9}[.)])/,K.listItemStart=a(/^( *)(bull) */).replace("bull",K.bullet).getRegex(),K.list=a(K.list).replace(/bull/g,K.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+K.def.source+")").getRegex(),K._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",K._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,K.html=a(K.html,"i").replace("comment",K._comment).replace("tag",K._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),K.paragraph=a(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.blockquote=a(K.blockquote).replace("paragraph",K.paragraph).getRegex(),K.normal=C({},K),K.gfm=C({},K.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),K.gfm.table=a(K.gfm.table).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.gfm.paragraph=a(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",K.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.pedantic=C({},K.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",K._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:a(K.normal._paragraph).replace("hr",K.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",K.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=a(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=a(K._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=a(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=a(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=a(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=a(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=a(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=a(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=a(Q.reflink).replace("label",Q._label).replace("ref",K._label).getRegex(),Q.nolink=a(Q.nolink).replace("ref",K._label).getRegex(),Q.reflinkSearch=a(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=C({},Q),Q.pedantic=C({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=C({},Q.normal,{escape:a(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=a(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=C({},Q.gfm,{br:a(Q.br).replace("{2,}","*").getRegex(),text:a(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ae(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function me(W){var j="",l,o,g=W.length;for(l=0;l<g;l++)o=W.charCodeAt(l),Math.random()>.5&&(o="x"+o.toString(16)),j+="&#"+o+";";return j}var ye=function(){function W(l){this.tokens=[],this.tokens.links=Object.create(null),this.options=l||oe.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var o={block:K.normal,inline:Q.normal};this.options.pedantic?(o.block=K.pedantic,o.inline=Q.pedantic):this.options.gfm&&(o.block=K.gfm,this.options.breaks?o.inline=Q.breaks:o.inline=Q.gfm),this.tokenizer.rules=o}W.lex=function(o,g){var M=new W(g);return M.lex(o)},W.lexInline=function(o,g){var M=new W(g);return M.inlineTokens(o)};var j=W.prototype;return j.lex=function(o){o=o.replace(/\r\n|\r/g,`
`),this.blockTokens(o,this.tokens);for(var g;g=this.inlineQueue.shift();)this.inlineTokens(g.src,g.tokens);return this.tokens},j.blockTokens=function(o,g){var M=this;g===void 0&&(g=[]),this.options.pedantic?o=o.replace(/\t/g,"    ").replace(/^ +$/gm,""):o=o.replace(/^( *)(\t+)/gm,function(H,Y,ie){return Y+"    ".repeat(ie.length)});for(var k,u,L,R;o;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(k=H.call({lexer:M},o,g))?(o=o.substring(k.raw.length),g.push(k),!0):!1}))){if(k=this.tokenizer.space(o)){o=o.substring(k.raw.length),k.raw.length===1&&g.length>0?g[g.length-1].raw+=`
`:g.push(k);continue}if(k=this.tokenizer.code(o)){o=o.substring(k.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+k.raw,u.text+=`
`+k.text,this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(k);continue}if(k=this.tokenizer.fences(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.heading(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.hr(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.blockquote(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.list(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.html(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.def(o)){o=o.substring(k.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+k.raw,u.text+=`
`+k.raw,this.inlineQueue[this.inlineQueue.length-1].src=u.text):this.tokens.links[k.tag]||(this.tokens.links[k.tag]={href:k.href,title:k.title});continue}if(k=this.tokenizer.table(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.lheading(o)){o=o.substring(k.raw.length),g.push(k);continue}if(L=o,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,Y=o.slice(1),ie=void 0;M.options.extensions.startBlock.forEach(function(re){ie=re.call({lexer:this},Y),typeof ie=="number"&&ie>=0&&(H=Math.min(H,ie))}),H<1/0&&H>=0&&(L=o.substring(0,H+1))}(),this.state.top&&(k=this.tokenizer.paragraph(L))){u=g[g.length-1],R&&u.type==="paragraph"?(u.raw+=`
`+k.raw,u.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(k),R=L.length!==o.length,o=o.substring(k.raw.length);continue}if(k=this.tokenizer.text(o)){o=o.substring(k.raw.length),u=g[g.length-1],u&&u.type==="text"?(u.raw+=`
`+k.raw,u.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(k);continue}if(o){var B="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,g},j.inline=function(o,g){return g===void 0&&(g=[]),this.inlineQueue.push({src:o,tokens:g}),g},j.inlineTokens=function(o,g){var M=this;g===void 0&&(g=[]);var k,u,L,R=o,B,H,Y;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(R))!=null;)ie.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(R=R.slice(0,B.index)+"["+_("a",B[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(R))!=null;)R=R.slice(0,B.index)+"["+_("a",B[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(R))!=null;)R=R.slice(0,B.index)+"++"+R.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;o;)if(H||(Y=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(k=he.call({lexer:M},o,g))?(o=o.substring(k.raw.length),g.push(k),!0):!1}))){if(k=this.tokenizer.escape(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.tag(o)){o=o.substring(k.raw.length),u=g[g.length-1],u&&k.type==="text"&&u.type==="text"?(u.raw+=k.raw,u.text+=k.text):g.push(k);continue}if(k=this.tokenizer.link(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.reflink(o,this.tokens.links)){o=o.substring(k.raw.length),u=g[g.length-1],u&&k.type==="text"&&u.type==="text"?(u.raw+=k.raw,u.text+=k.text):g.push(k);continue}if(k=this.tokenizer.emStrong(o,R,Y)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.codespan(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.br(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.del(o)){o=o.substring(k.raw.length),g.push(k);continue}if(k=this.tokenizer.autolink(o,me)){o=o.substring(k.raw.length),g.push(k);continue}if(!this.state.inLink&&(k=this.tokenizer.url(o,me))){o=o.substring(k.raw.length),g.push(k);continue}if(L=o,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,De=o.slice(1),ve=void 0;M.options.extensions.startInline.forEach(function(Ee){ve=Ee.call({lexer:this},De),typeof ve=="number"&&ve>=0&&(he=Math.min(he,ve))}),he<1/0&&he>=0&&(L=o.substring(0,he+1))}(),k=this.tokenizer.inlineText(L,ae)){o=o.substring(k.raw.length),k.raw.slice(-1)!=="_"&&(Y=k.raw.slice(-1)),H=!0,u=g[g.length-1],u&&u.type==="text"?(u.raw+=k.raw,u.text+=k.text):g.push(k);continue}if(o){var re="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return g},i(W,null,[{key:"rules",get:function(){return{block:K,inline:Q}}}]),W}(),Le=function(){function W(l){this.options=l||oe.defaults}var j=W.prototype;return j.code=function(o,g,M){var k=(g||"").match(/\S*/)[0];if(this.options.highlight){var u=this.options.highlight(o,k);u!=null&&u!==o&&(M=!0,o=u)}return o=o.replace(/\n$/,"")+`
`,k?'<pre><code class="'+this.options.langPrefix+e(k,!0)+'">'+(M?o:e(o,!0))+`</code></pre>
`:"<pre><code>"+(M?o:e(o,!0))+`</code></pre>
`},j.blockquote=function(o){return`<blockquote>
`+o+`</blockquote>
`},j.html=function(o){return o},j.heading=function(o,g,M,k){if(this.options.headerIds){var u=this.options.headerPrefix+k.slug(M);return"<h"+g+' id="'+u+'">'+o+"</h"+g+`>
`}return"<h"+g+">"+o+"</h"+g+`>
`},j.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},j.list=function(o,g,M){var k=g?"ol":"ul",u=g&&M!==1?' start="'+M+'"':"";return"<"+k+u+`>
`+o+"</"+k+`>
`},j.listitem=function(o){return"<li>"+o+`</li>
`},j.checkbox=function(o){return"<input "+(o?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},j.paragraph=function(o){return"<p>"+o+`</p>
`},j.table=function(o,g){return g&&(g="<tbody>"+g+"</tbody>"),`<table>
<thead>
`+o+`</thead>
`+g+`</table>
`},j.tablerow=function(o){return`<tr>
`+o+`</tr>
`},j.tablecell=function(o,g){var M=g.header?"th":"td",k=g.align?"<"+M+' align="'+g.align+'">':"<"+M+">";return k+o+("</"+M+`>
`)},j.strong=function(o){return"<strong>"+o+"</strong>"},j.em=function(o){return"<em>"+o+"</em>"},j.codespan=function(o){return"<code>"+o+"</code>"},j.br=function(){return this.options.xhtml?"<br/>":"<br>"},j.del=function(o){return"<del>"+o+"</del>"},j.link=function(o,g,M){if(o=S(this.options.sanitize,this.options.baseUrl,o),o===null)return M;var k='<a href="'+e(o)+'"';return g&&(k+=' title="'+g+'"'),k+=">"+M+"</a>",k},j.image=function(o,g,M){if(o=S(this.options.sanitize,this.options.baseUrl,o),o===null)return M;var k='<img src="'+o+'" alt="'+M+'"';return g&&(k+=' title="'+g+'"'),k+=this.options.xhtml?"/>":">",k},j.text=function(o){return o},W}(),ne=function(){function W(){}var j=W.prototype;return j.strong=function(o){return o},j.em=function(o){return o},j.codespan=function(o){return o},j.del=function(o){return o},j.html=function(o){return o},j.text=function(o){return o},j.link=function(o,g,M){return""+M},j.image=function(o,g,M){return""+M},j.br=function(){return""},W}(),ee=function(){function W(){this.seen={}}var j=W.prototype;return j.serialize=function(o){return o.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},j.getNextSafeSlug=function(o,g){var M=o,k=0;if(this.seen.hasOwnProperty(M)){k=this.seen[o];do k++,M=o+"-"+k;while(this.seen.hasOwnProperty(M))}return g||(this.seen[o]=k,this.seen[M]=0),M},j.slug=function(o,g){g===void 0&&(g={});var M=this.serialize(o);return this.getNextSafeSlug(M,g.dryrun)},W}(),ce=function(){function W(l){this.options=l||oe.defaults,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ne,this.slugger=new ee}W.parse=function(o,g){var M=new W(g);return M.parse(o)},W.parseInline=function(o,g){var M=new W(g);return M.parseInline(o)};var j=W.prototype;return j.parse=function(o,g){g===void 0&&(g=!0);var M="",k,u,L,R,B,H,Y,ie,re,he,De,ve,Ee,Ne,fe,Fe,Ke,Xe,tt,lt=o.length;for(k=0;k<lt;k++){if(he=o[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(tt=this.options.extensions.renderers[he.type].call({parser:this},he),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){M+=tt||"";continue}switch(he.type){case"space":continue;case"hr":{M+=this.renderer.hr();continue}case"heading":{M+=this.renderer.heading(this.parseInline(he.tokens),he.depth,r(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{M+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(ie="",Y="",R=he.header.length,u=0;u<R;u++)Y+=this.renderer.tablecell(this.parseInline(he.header[u].tokens),{header:!0,align:he.align[u]});for(ie+=this.renderer.tablerow(Y),re="",R=he.rows.length,u=0;u<R;u++){for(H=he.rows[u],Y="",B=H.length,L=0;L<B;L++)Y+=this.renderer.tablecell(this.parseInline(H[L].tokens),{header:!1,align:he.align[L]});re+=this.renderer.tablerow(Y)}M+=this.renderer.table(ie,re);continue}case"blockquote":{re=this.parse(he.tokens),M+=this.renderer.blockquote(re);continue}case"list":{for(De=he.ordered,ve=he.start,Ee=he.loose,R=he.items.length,re="",u=0;u<R;u++)fe=he.items[u],Fe=fe.checked,Ke=fe.task,Ne="",fe.task&&(Xe=this.renderer.checkbox(Fe),Ee?fe.tokens.length>0&&fe.tokens[0].type==="paragraph"?(fe.tokens[0].text=Xe+" "+fe.tokens[0].text,fe.tokens[0].tokens&&fe.tokens[0].tokens.length>0&&fe.tokens[0].tokens[0].type==="text"&&(fe.tokens[0].tokens[0].text=Xe+" "+fe.tokens[0].tokens[0].text)):fe.tokens.unshift({type:"text",text:Xe}):Ne+=Xe),Ne+=this.parse(fe.tokens,Ee),re+=this.renderer.listitem(Ne,Ke,Fe);M+=this.renderer.list(re,De,ve);continue}case"html":{M+=this.renderer.html(he.text);continue}case"paragraph":{M+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(re=he.tokens?this.parseInline(he.tokens):he.text;k+1<lt&&o[k+1].type==="text";)he=o[++k],re+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);M+=g?this.renderer.paragraph(re):re;continue}default:{var st='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return M},j.parseInline=function(o,g){g=g||this.renderer;var M="",k,u,L,R=o.length;for(k=0;k<R;k++){if(u=o[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[u.type]&&(L=this.options.extensions.renderers[u.type].call({parser:this},u),L!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(u.type))){M+=L||"";continue}switch(u.type){case"escape":{M+=g.text(u.text);break}case"html":{M+=g.html(u.text);break}case"link":{M+=g.link(u.href,u.title,this.parseInline(u.tokens,g));break}case"image":{M+=g.image(u.href,u.title,u.text);break}case"strong":{M+=g.strong(this.parseInline(u.tokens,g));break}case"em":{M+=g.em(this.parseInline(u.tokens,g));break}case"codespan":{M+=g.codespan(u.text);break}case"br":{M+=g.br();break}case"del":{M+=g.del(this.parseInline(u.tokens,g));break}case"text":{M+=g.text(u.text);break}default:{var B='Token with "'+u.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return M},W}();function le(W,j,l){if(typeof W>"u"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof j=="function"&&(l=j,j=null),j=C({},le.defaults,j||{}),I(j),l){var o=j.highlight,g;try{g=ye.lex(W,j)}catch(R){return l(R)}var M=function(B){var H;if(!B)try{j.walkTokens&&le.walkTokens(g,j.walkTokens),H=ce.parse(g,j)}catch(Y){B=Y}return j.highlight=o,B?l(B):l(null,H)};if(!o||o.length<3||(delete j.highlight,!g.length))return M();var k=0;le.walkTokens(g,function(R){R.type==="code"&&(k++,setTimeout(function(){o(R.text,R.lang,function(B,H){if(B)return M(B);H!=null&&H!==R.text&&(R.text=H,R.escaped=!0),k--,k===0&&M()})},0))}),k===0&&M();return}function u(R){if(R.message+=`
Please report this to https://github.com/markedjs/marked.`,j.silent)return"<p>An error occurred:</p><pre>"+e(R.message+"",!0)+"</pre>";throw R}try{var L=ye.lex(W,j);if(j.walkTokens){if(j.async)return Promise.all(le.walkTokens(L,j.walkTokens)).then(function(){return ce.parse(L,j)}).catch(u);le.walkTokens(L,j.walkTokens)}return ce.parse(L,j)}catch(R){u(R)}}le.options=le.setOptions=function(W){return C(le.defaults,W),w(le.defaults),le},le.getDefaults=N,le.defaults=oe.defaults,le.use=function(){for(var W=arguments.length,j=new Array(W),l=0;l<W;l++)j[l]=arguments[l];var o=C.apply(void 0,[{}].concat(j)),g=le.defaults.extensions||{renderers:{},childTokens:{}},M;j.forEach(function(k){if(k.extensions&&(M=!0,k.extensions.forEach(function(L){if(!L.name)throw new Error("extension name required");if(L.renderer){var R=g.renderers?g.renderers[L.name]:null;R?g.renderers[L.name]=function(){for(var B=arguments.length,H=new Array(B),Y=0;Y<B;Y++)H[Y]=arguments[Y];var ie=L.renderer.apply(this,H);return ie===!1&&(ie=R.apply(this,H)),ie}:g.renderers[L.name]=L.renderer}if(L.tokenizer){if(!L.level||L.level!=="block"&&L.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");g[L.level]?g[L.level].unshift(L.tokenizer):g[L.level]=[L.tokenizer],L.start&&(L.level==="block"?g.startBlock?g.startBlock.push(L.start):g.startBlock=[L.start]:L.level==="inline"&&(g.startInline?g.startInline.push(L.start):g.startInline=[L.start]))}L.childTokens&&(g.childTokens[L.name]=L.childTokens)})),k.renderer&&function(){var L=le.defaults.renderer||new Le,R=function(Y){var ie=L[Y];L[Y]=function(){for(var re=arguments.length,he=new Array(re),De=0;De<re;De++)he[De]=arguments[De];var ve=k.renderer[Y].apply(L,he);return ve===!1&&(ve=ie.apply(L,he)),ve}};for(var B in k.renderer)R(B);o.renderer=L}(),k.tokenizer&&function(){var L=le.defaults.tokenizer||new G,R=function(Y){var ie=L[Y];L[Y]=function(){for(var re=arguments.length,he=new Array(re),De=0;De<re;De++)he[De]=arguments[De];var ve=k.tokenizer[Y].apply(L,he);return ve===!1&&(ve=ie.apply(L,he)),ve}};for(var B in k.tokenizer)R(B);o.tokenizer=L}(),k.walkTokens){var u=le.defaults.walkTokens;o.walkTokens=function(L){var R=[];return R.push(k.walkTokens.call(this,L)),u&&(R=R.concat(u.call(this,L))),R}}M&&(o.extensions=g),le.setOptions(o)})},le.walkTokens=function(W,j){for(var l=[],o=function(){var u=M.value;switch(l=l.concat(j.call(le,u)),u.type){case"table":{for(var L=F(u.header),R;!(R=L()).done;){var B=R.value;l=l.concat(le.walkTokens(B.tokens,j))}for(var H=F(u.rows),Y;!(Y=H()).done;)for(var ie=Y.value,re=F(ie),he;!(he=re()).done;){var De=he.value;l=l.concat(le.walkTokens(De.tokens,j))}break}case"list":{l=l.concat(le.walkTokens(u.items,j));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[u.type]?le.defaults.extensions.childTokens[u.type].forEach(function(ve){l=l.concat(le.walkTokens(u[ve],j))}):u.tokens&&(l=l.concat(le.walkTokens(u.tokens,j)))}},g=F(W),M;!(M=g()).done;)o();return l},le.parseInline=function(W,j){if(typeof W>"u"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");j=C({},le.defaults,j||{}),I(j);try{var l=ye.lexInline(W,j);return j.walkTokens&&le.walkTokens(l,j.walkTokens),ce.parseInline(l,j)}catch(o){if(o.message+=`
Please report this to https://github.com/markedjs/marked.`,j.silent)return"<p>An error occurred:</p><pre>"+e(o.message+"",!0)+"</pre>";throw o}},le.Parser=ce,le.parser=ce.parse,le.Renderer=Le,le.TextRenderer=ne,le.Lexer=ye,le.lexer=ye.lex,le.Tokenizer=G,le.Slugger=ee,le.parse=le;var ke=le.options,te=le.setOptions,be=le.use,Ae=le.walkTokens,Re=le.parseInline,Ie=le,je=ce.parse,_e=ye.lex;oe.Lexer=ye,oe.Parser=ce,oe.Renderer=Le,oe.Slugger=ee,oe.TextRenderer=ne,oe.Tokenizer=G,oe.getDefaults=N,oe.lexer=_e,oe.marked=le,oe.options=ke,oe.parse=Ie,oe.parseInline=Re,oe.parser=je,oe.setOptions=te,oe.use=be,oe.walkTokens=Ae,Object.defineProperty(oe,"__esModule",{value:!0})}),define(pe[60],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var i;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(t.MarshalledId=i={}))}),define(pe[93],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gk=i;function i(s){const r=F(s);if(r&&r.length>0)return new Uint32Array(r)}let n=0;const P=new Uint32Array(10);function F(s){if(n=0,N(s,y,D.InitialConsonant),n>0||(N(s,$,D.Vowel),n>0)||(N(s,m,D.FinalConsonant),n>0)||(N(s,e,D.CompatibilityJamo),n))return P.subarray(0,n);if(s>=44032&&s<=55203){const r=s-44032,h=r%588,a=Math.floor(r/588),v=Math.floor(h/28),T=h%28-1;if(a<y.length?N(a,y,0):D.InitialConsonant+a-D.CompatibilityJamo<e.length&&N(D.InitialConsonant+a,e,D.CompatibilityJamo),v<$.length?N(v,$,0):D.Vowel+v-D.CompatibilityJamo<e.length&&N(D.Vowel+v-D.CompatibilityJamo,e,D.CompatibilityJamo),T>=0&&(T<m.length?N(T,m,0):D.FinalConsonant+T-D.CompatibilityJamo<e.length&&N(D.FinalConsonant+T-D.CompatibilityJamo,e,D.CompatibilityJamo)),n>0)return P.subarray(0,n)}}function N(s,r,h){s>=h&&s<h+r.length&&w(r[s-h])}function w(s){s!==f.NUL&&(P[n++]=s&255,s>>8&&(P[n++]=s>>8&255),s>>16&&(P[n++]=s>>16&255))}var D;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(D||(D={}));var f;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(f||(f={}));var p;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(p||(p={}));const y=new Uint8Array([f.r,f.R,f.s,f.e,f.E,f.f,f.a,f.q,f.Q,f.t,f.T,f.d,f.w,f.W,f.c,f.z,f.x,f.v,f.g]),$=new Uint16Array([f.k,f.o,f.i,f.O,f.j,f.p,f.u,f.P,f.h,p.hk,p.ho,p.hl,f.y,f.n,p.nj,p.np,p.nl,f.b,f.m,p.ml,f.l]),m=new Uint16Array([f.r,f.R,p.rt,f.s,p.sw,p.sg,f.e,f.f,p.fr,p.fa,p.fq,p.ft,p.fx,p.fv,p.fg,f.a,f.q,p.qt,f.t,f.T,f.d,f.w,f.c,f.z,f.x,f.v,f.g]),e=new Uint16Array([f.r,f.R,p.rt,f.s,p.sw,p.sg,f.e,f.E,f.f,p.fr,p.fa,p.fq,p.ft,p.fx,p.fv,p.fg,f.a,f.q,f.Q,p.qt,f.t,f.T,f.d,f.w,f.W,f.c,f.z,f.x,f.v,f.g,f.k,f.o,f.i,f.O,f.j,f.p,f.u,f.P,f.h,p.hk,p.ho,p.hl,f.y,f.n,p.nj,p.np,p.nl,f.b,f.m,p.ml,f.l])}),define(pe[94],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wW=void 0;class i{constructor(P,F=0,N=P.length,w=F-1){this.a=P,this.b=F,this.c=N,this.d=w}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$wW=i}),define(pe[95],we([1,0,57,94]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yW=t.$xW=void 0;class P{constructor(w=[],D=10){this.h(w),this.b=D,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new n.$wW(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const D of w)this.a.add(D)}get j(){const w=[];return this.a.forEach(D=>w.push(D)),w}}t.$xW=P;class F{get size(){return this.f}constructor(w,D=10,f=p=>p){if(this.g=D,this.h=f,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new i.$g([w[0]],f);for(let p=1;p<w.length;p++)this.add(w[p])}add(w){const D={value:w,previous:this.c,next:void 0};for(this.c.next=D,this.c=D,this.d=this.c,this.f++,this.a.has(w)?this.j(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.h(this.c.value)===this.h(w))return w;const D=this.c.value;return this.a.delete(D),this.c.value=w,this.a.has(w)?this.j(w):this.a.add(w),D}prepend(w){if(this.f===this.g||this.a.has(w))return;const D={value:w,previous:void 0,next:this.b};this.b.previous=D,this.b=D,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}j(w){let D=this.b;const f=this.h(w);for(;D!==this.c;)this.h(D.value)===f&&(D===this.b?(this.b=this.b.next,this.b.previous=void 0):(D.previous.next=D.next,D.next.previous=D.previous),this.f--),D=D.next}}t.$yW=F}),define(pe[37],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qm=t.$Pm=t.$Om=void 0,t.$Mm=i,t.rot=n,t.$Rm=w;function i(D,f,p){return Math.min(Math.max(D,f),p)}function n(D,f){return(f+D%f)%f}class P{constructor(){this.a=0}getNext(){return this.a++}}t.$Om=P;class F{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Pm=F;class N{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const p=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Qm=N;function w(D,f,p,y,$,m,e,s){const r=e-p,h=s-y,a=$-p,v=m-y,T=D-p,S=f-y,d=r*r+h*h,c=r*a+h*v,b=r*T+h*S,A=a*a+v*v,V=a*T+v*S,U=1/(d*A-c*c),C=(A*b-c*V)*U,E=(d*V-c*b)*U;return C>=0&&E>=0&&C+E<1}}),define(pe[26],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bd=void 0,t.$cd=F,t.$dd=$;class i{constructor(e,s,r){this.owner=e,this.debugNameSource=s,this.referenceFn=r}getDebugName(e){return F(e,this)}}t.$bd=i;const n=new Map,P=new WeakMap;function F(m,e){const s=P.get(m);if(s)return s;const r=N(m,e);if(r){let h=n.get(r)??0;h++,n.set(r,h);const a=h===1?r:`${r}#${h}`;return P.set(m,a),a}}function N(m,e){const s=P.get(m);if(s)return s;const r=e.owner?p(e.owner)+".":"";let h;const a=e.debugNameSource;if(a!==void 0)if(typeof a=="function"){if(h=a(),h!==void 0)return r+h}else return r+a;const v=e.referenceFn;if(v!==void 0&&(h=$(v),h!==void 0))return r+h;if(e.owner!==void 0){const T=w(e.owner,m);if(T!==void 0)return r+T}}function w(m,e){for(const s in m)if(m[s]===e)return s}const D=new Map,f=new WeakMap;function p(m){const e=f.get(m);if(e)return e;const s=y(m);let r=D.get(s)??0;r++,D.set(s,r);const h=r===1?s:`${s}#${r}`;return f.set(m,h),h}function y(m){const e=m.constructor;return e?e.name:"Object"}function $(m){const e=m.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(r?r[1]:void 0)?.trim()}}),define(pe[31],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nd=void 0,t.$Ld=n,t.$Md=P;let i;function n(s){i=s}function P(){return i}class F{constructor(){this.a=0,this.d=new WeakMap}b(r){return N([w(m("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[w(" "),f(p(r.oldValue,70),{color:"red",strikeThrough:!0}),w(" "),f(p(r.newValue,60),{color:"green"})]:[w(" (unchanged)")]:[w(" "),f(p(r.newValue,60),{color:"green"}),w(" (initial)")]}handleObservableChanged(r,h){console.log(...this.b([D("observable value changed"),f(r.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(r){if(r.size!==0)return f(" (changed deps: "+[...r].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(a,v)=>(this.d.get(r).add(a),h.apply(r,[a,v]))}handleDerivedRecomputed(r,h){const a=this.d.get(r);console.log(...this.b([D("derived recomputed"),f(r.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(a),{data:[{fn:r._debugNameData.referenceFn??r._computeFn}]}])),a.clear()}handleFromEventObservableTriggered(r,h){console.log(...this.b([D("observable from event triggered"),f(r.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const h=r.handleChange;this.d.set(r,new Set),r.handleChange=(a,v)=>(this.d.get(r).add(a),h.apply(r,[a,v]))}handleAutorunTriggered(r){const h=this.d.get(r);console.log(...this.b([D("autorun"),f(r.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:r._debugNameData.referenceFn??r._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let h=r.getDebugName();h===void 0&&(h=""),console.log(...this.b([D("transaction"),f(h,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Nd=F;function N(s){const r=new Array,h=[];let a="";function v(S){if("length"in S)for(const d of S)d&&v(d);else"text"in S?(a+=`%c${S.text}`,r.push(S.style),S.data&&h.push(...S.data)):"data"in S&&h.push(...S.data)}v(s);const T=[a,...r];return T.push(...h),T}function w(s){return f(s,{color:"black"})}function D(s){return f(e(`${s}: `,10),{color:"black",bold:!0})}function f(s,r={color:"black"}){function h(v){return Object.entries(v).reduce((T,[S,d])=>`${T}${S}:${d};`,"")}const a={color:r.color};return r.strikeThrough&&(a["text-decoration"]="line-through"),r.bold&&(a["font-weight"]="bold"),{text:s,style:h(a)}}function p(s,r){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=r?`"${s}"`:`"${s.substr(0,r-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?y(s,r):$(s,r);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function y(s,r){let h="[ ",a=!0;for(const v of s){if(a||(h+=", "),h.length-5>r){h+="...";break}a=!1,h+=`${p(v,r-h.length)}`}return h+=" ]",h}function $(s,r){let h="{ ",a=!0;for(const[v,T]of Object.entries(s)){if(a||(h+=", "),h.length-5>r){h+="...";break}a=!1,h+=`${v}: ${p(T,r-h.length)}`}return h+=" }",h}function m(s,r){let h="";for(let a=1;a<=r;a++)h+=s;return h}function e(s,r){for(;s.length<r;)s+=" ";return s}}),define(pe[44],we([1,0,42,2,26,31]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qd=void 0,t.$kd=N,t.$ld=w,t.$md=D,t.$nd=f,t.$od=p,t.$pd=y;function N(e){return new m(new P.$bd(void 0,void 0,e),e,void 0,void 0)}function w(e,s){return new m(new P.$bd(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function D(e,s){return new m(new P.$bd(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function f(e,s){const r=new n.$Uc,h=D({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn??s,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(a,v)=>{r.clear(),s(a,v,r)});return(0,n.$Tc)(()=>{h.dispose(),r.dispose()})}function p(e){const s=new n.$Uc,r=w({owner:void 0,debugName:void 0,debugReferenceFn:e},h=>{s.clear(),e(h,s)});return(0,n.$Tc)(()=>{r.dispose(),s.dispose()})}function y(e,s){let r;return w({debugReferenceFn:s},h=>{const a=e.read(h),v=r;r=a,s({lastValue:v,newValue:a})})}var $;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})($||($={}));class m{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(s,r,h,a){this._debugNameData=s,this._runFn=r,this.h=h,this.i=a,this.a=$.stale,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.h?.(),(0,F.$Md)()?.handleAutorunCreated(this),this.j(),(0,n.$Mc)(this)}dispose(){this.c=!0;for(const s of this.e)s.removeObserver(this);this.e.clear(),(0,n.$Nc)(this)}j(){if(this.a===$.upToDate)return;const s=this.f;this.f=this.e,this.e=s,this.a=$.upToDate;const r=this.c;try{if(!r){(0,F.$Md)()?.handleAutorunTriggered(this);const h=this.g;this.g=this.h?.(),this._runFn(this,h)}}finally{r||(0,F.$Md)()?.handleAutorunFinished(this);for(const h of this.f)h.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===$.upToDate&&(this.a=$.dependenciesMightHaveChanged),this.b++}endUpdate(){if(this.b===1)do{if(this.a===$.dependenciesMightHaveChanged){this.a=$.upToDate;for(const s of this.e)if(s.reportChanges(),this.a===$.stale)break}this.j()}while(this.a!==$.upToDate);this.b--,(0,i.$id)(()=>this.b>=0)}handlePossibleChange(s){this.a===$.upToDate&&this.e.has(s)&&!this.f.has(s)&&(this.a=$.dependenciesMightHaveChanged)}handleChange(s,r){this.e.has(s)&&!this.f.has(s)&&(!this.i||this.i({changedObservable:s,change:r,didChange:a=>a===s},this.g))&&(this.a=$.stale)}readObservable(s){if(this.c)return s.get();s.addObserver(this);const r=s.get();return this.e.add(s),this.f.delete(s),r}}t.$qd=m,function(e){e.Observer=m}(N||(t.$kd=N={}))}),define(pe[27],we([1,0,30,26,31]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0d=t.$8d=t.$6d=t.$1d=t.$Zd=void 0,t.$Wd=N,t.$Xd=D,t.$Yd=p,t.$2d=m,t.$3d=s,t.$4d=r,t.$5d=h,t.$7d=v,t.$9d=S;let F;function N(c){F=c}let w;function D(c){w=c}let f;function p(c){f=c}class y{get TChange(){return null}reportChanges(){this.get()}read(b){return b?b.readObservable(this):this.get()}map(b,A){const V=A===void 0?void 0:b,U=A===void 0?b:A;return f({owner:V,debugName:()=>{const C=(0,n.$dd)(U);if(C!==void 0)return C;const O=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(U.toString());if(O)return`${this.debugName}.${O[2]}`;if(!V)return`${this.debugName} (mapped)`},debugReferenceFn:U},C=>U(this.read(C),C))}flatten(){return f({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},b=>this.read(b).read(b))}recomputeInitiallyAndOnChange(b,A){return b.add(F(this,A)),this}keepObserved(b){return b.add(w(this)),this}get a(){return this.get()}}t.$Zd=y;class $ extends y{constructor(){super(...arguments),this.b=new Set}addObserver(b){const A=this.b.size;this.b.add(b),A===0&&this.c()}removeObserver(b){this.b.delete(b)&&this.b.size===0&&this.f()}c(){}f(){}}t.$1d=$;function m(c,b){const A=new a(c,b);try{c(A)}finally{A.finish()}}let e;function s(c){if(e)c(e);else{const b=new a(c,void 0);e=b;try{c(b)}finally{b.finish(),e=void 0}}}async function r(c,b){const A=new a(c,b);try{await c(A)}finally{A.finish()}}function h(c,b,A){c?b(c):m(b,A)}class a{constructor(b,A){this._fn=b,this.b=A,this.a=[],(0,P.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,n.$dd)(this._fn)}updateObserver(b,A){this.a.push({observer:b,observable:A}),b.beginUpdate(A)}finish(){const b=this.a;for(let A=0;A<b.length;A++){const{observer:V,observable:U}=b[A];V.endUpdate(U)}this.a=null,(0,P.$Md)()?.handleEndTransaction()}}t.$6d=a;function v(c,b){let A;return typeof c=="string"?A=new n.$bd(void 0,c,void 0):A=new n.$bd(c,void 0,void 0),new T(A,b,i.$7c)}class T extends ${get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(b,A,V){super(),this.e=b,this.g=V,this.d=A}get(){return this.d}set(b,A,V){if(V===void 0&&this.g(this.d,b))return;let U;A||(A=U=new a(()=>{},()=>`Setting ${this.debugName}`));try{const C=this.d;this.h(b),(0,P.$Md)()?.handleObservableChanged(this,{oldValue:C,newValue:b,change:V,didChange:!0,hadValue:!0});for(const E of this.b)A.updateObserver(E,this),E.handleChange(this,V)}finally{U&&U.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(b){this.d=b}}t.$8d=T;function S(c,b){let A;return typeof c=="string"?A=new n.$bd(void 0,c,void 0):A=new n.$bd(c,void 0,void 0),new d(A,b,i.$7c)}class d extends T{h(b){this.d!==b&&(this.d&&this.d.dispose(),this.d=b)}dispose(){this.d?.dispose()}}t.$0d=d}),define(pe[45],we([1,0,42,30,2,27,26,31]),function(oe,t,i,n,P,F,N,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vd=t.$Ud=void 0,t.$Od=D,t.$Pd=f,t.$Qd=p,t.$Rd=y,t.$Sd=$,t.$Td=m;function D(h,a){return a!==void 0?new s(new N.$bd(h,void 0,a),a,void 0,void 0,void 0,n.$7c):new s(new N.$bd(void 0,void 0,h),h,void 0,void 0,void 0,n.$7c)}function f(h,a,v){return new r(new N.$bd(h,void 0,a),a,void 0,void 0,void 0,n.$7c,v)}function p(h,a){return new s(new N.$bd(h.owner,h.debugName,h.debugReferenceFn),a,void 0,void 0,h.onLastObserverRemoved,h.equalsFn??n.$7c)}(0,F.$Yd)(p);function y(h,a){return new s(new N.$bd(h.owner,h.debugName,void 0),a,h.createEmptyChangeSummary,h.handleChange,void 0,h.equalityComparer??n.$7c)}function $(h,a){let v,T;a===void 0?(v=h,T=void 0):(T=h,v=a);const S=new P.$Uc;return new s(new N.$bd(T,void 0,v),d=>(S.clear(),v(d,S)),void 0,void 0,()=>S.dispose(),n.$7c)}function m(h,a){let v,T;a===void 0?(v=h,T=void 0):(T=h,v=a);let S;return new s(new N.$bd(T,void 0,v),d=>{S?S.clear():S=new P.$Uc;const c=v(d);return c&&S.add(c),c},void 0,void 0,()=>{S&&(S.dispose(),S=void 0)},n.$7c)}var e;(function(h){h[h.initial=0]="initial",h[h.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",h[h.stale=2]="stale",h[h.upToDate=3]="upToDate"})(e||(e={}));class s extends F.$1d{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(a,v,T,S,d=void 0,c){super(),this._debugNameData=a,this._computeFn=v,this.m=T,this.n=S,this.p=d,this.q=c,this.e=e.initial,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.m?.(),(0,w.$Md)()?.handleDerivedCreated(this)}f(){this.e=e.initial,this.g=void 0;for(const a of this.j)a.removeObserver(this);this.j.clear(),this.p?.()}get(){if(this.b.size===0){const a=this._computeFn(this,this.m?.());return this.f(),a}else{do{if(this.e===e.dependenciesMightHaveChanged){for(const a of this.j)if(a.reportChanges(),this.e===e.stale)break}this.e===e.dependenciesMightHaveChanged&&(this.e=e.upToDate),this.t()}while(this.e!==e.upToDate);return this.g}}t(){if(this.e===e.upToDate)return;const a=this.k;this.k=this.j,this.j=a;const v=this.e!==e.initial,T=this.g;this.e=e.upToDate;const S=this.l;this.l=this.m?.();try{this.g=this._computeFn(this,S)}finally{for(const c of this.k)c.removeObserver(this);this.k.clear()}const d=v&&!this.q(T,this.g);if((0,w.$Md)()?.handleDerivedRecomputed(this,{oldValue:T,newValue:this.g,change:void 0,didChange:d,hadValue:v}),d)for(const c of this.b)c.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(a){this.h++;const v=this.h===1;if(this.e===e.upToDate&&(this.e=e.dependenciesMightHaveChanged,!v))for(const T of this.b)T.handlePossibleChange(this);if(v)for(const T of this.b)T.beginUpdate(this)}endUpdate(a){if(this.h--,this.h===0){const v=[...this.b];for(const T of v)T.endUpdate(this)}(0,i.$id)(()=>this.h>=0)}handlePossibleChange(a){if(this.e===e.upToDate&&this.j.has(a)&&!this.k.has(a)){this.e=e.dependenciesMightHaveChanged;for(const v of this.b)v.handlePossibleChange(this)}}handleChange(a,v){if(this.j.has(a)&&!this.k.has(a)){const T=this.n?this.n({changedObservable:a,change:v,didChange:d=>d===a},this.l):!0,S=this.e===e.upToDate;if(T&&(this.e===e.dependenciesMightHaveChanged||S)&&(this.e=e.stale,S))for(const d of this.b)d.handlePossibleChange(this)}}readObservable(a){a.addObserver(this);const v=a.get();return this.j.add(a),this.k.delete(a),v}addObserver(a){const v=!this.b.has(a)&&this.h>0;super.addObserver(a),v&&a.beginUpdate(this)}removeObserver(a){const v=this.b.has(a)&&this.h>0;super.removeObserver(a),v&&a.endUpdate(this)}}t.$Ud=s;class r extends s{constructor(a,v,T,S,d=void 0,c,b){super(a,v,T,S,d,c),this.set=b}}t.$Vd=r}),define(pe[96],we([1,0,27]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=void 0;class n extends i.$1d{get debugName(){return this.h.getDebugName(this)??"LazyObservableValue"}constructor(F,N,w){super(),this.h=F,this.j=w,this.e=!0,this.g=[],this.l=0,this.d=N}get(){return this.k(),this.d}k(){if(!this.e)if(this.e=!0,this.g.length>0){for(const F of this.b)for(const N of this.g)F.handleChange(this,N);this.g.length=0}else for(const F of this.b)F.handleChange(this,void 0)}m(){if(this.l++,this.l===1)for(const F of this.b)F.beginUpdate(this)}n(){if(this.l--,this.l===0){this.k();const F=[...this.b];for(const N of F)N.endUpdate(this)}}addObserver(F){const N=!this.b.has(F)&&this.l>0;super.addObserver(F),N&&F.beginUpdate(this)}removeObserver(F){const N=this.b.has(F)&&this.l>0;super.removeObserver(F),N&&F.endUpdate(this)}set(F,N,w){if(w===void 0&&this.j(this.d,F))return;let D;N||(N=D=new i.$6d(()=>{},()=>`Setting ${this.debugName}`));try{if(this.e=!1,this.o(F),w!==void 0&&this.g.push(w),N.updateObserver({beginUpdate:()=>this.m(),endUpdate:()=>this.n(),handleChange:(f,p)=>{},handlePossibleChange:f=>{}},this),this.l>1)for(const f of this.b)f.handlePossibleChange(this)}finally{D&&D.finish()}}toString(){return`${this.debugName}: ${this.d}`}o(F){this.d=F}}t.$ee=n}),define(pe[97],we([1,0,30,27,26,96]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=N;function N(w,D){return w.lazy?new F.$ee(new P.$bd(w.owner,w.debugName,void 0),D,w.equalsFn??i.$7c):new n.$8d(new P.$bd(w.owner,w.debugName,void 0),D,w.equalsFn??i.$7c)}}),define(pe[5],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.OS=t.OperatingSystem=t.$C=t.$B=t.$A=t.$z=t.$y=t.Language=t.$x=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.Platform=t.$h=void 0,t.$i=d,t.$E=C,t.$K=E,t.$h="en";let i=!1,n=!1,P=!1,F=!1,N=!1,w=!1,D=!1,f=!1,p=!1,y=!1,$,m=t.$h,e=t.$h,s,r;const h=globalThis;let a;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?a=h.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(a=process);const v=typeof a?.versions?.electron=="string",T=v&&a?.type==="renderer";if(typeof a=="object"){i=a.platform==="win32",n=a.platform==="darwin",P=a.platform==="linux",F=P&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,D=v,p=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=t.$h,m=t.$h;const O=a.env.VSCODE_NLS_CONFIG;if(O)try{const x=JSON.parse(O);$=x.userLocale,e=x.osLocale,m=x.resolvedLanguage||t.$h,s=x.languagePack?.translationsConfigFile}catch{}N=!0}else typeof navigator=="object"&&!T?(r=navigator.userAgent,i=r.indexOf("Windows")>=0,n=r.indexOf("Macintosh")>=0,f=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=r.indexOf("Linux")>=0,y=r?.indexOf("Mobi")>=0,w=!0,m=globalThis._VSCODE_NLS_LANGUAGE||t.$h,$=navigator.language.toLowerCase(),e=$):console.error("Unable to resolve platform.");var S;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(S||(t.Platform=S={}));function d(O){switch(O){case S.Web:return"Web";case S.Mac:return"Mac";case S.Linux:return"Linux";case S.Windows:return"Windows"}}let c=S.Web;n?c=S.Mac:i?c=S.Windows:P&&(c=S.Linux),t.$j=i,t.$k=n,t.$l=P,t.$m=F,t.$n=N,t.$o=D,t.$p=w,t.$q=w&&typeof h.importScripts=="function",t.$r=t.$q?h.origin:void 0,t.$s=f,t.$t=y,t.$u=p,t.$v=c,t.$w=r,t.$x=m;var b;(function(O){function x(){return t.$x}O.value=x;function I(){return t.$x.length===2?t.$x==="en":t.$x.length>=3?t.$x[0]==="e"&&t.$x[1]==="n"&&t.$x[2]==="-":!1}O.isDefaultVariant=I;function _(){return t.$x==="en"}O.isDefault=_})(b||(t.Language=b={})),t.$y=$,t.$z=e,t.$A=s,t.$B=typeof h.postMessage=="function"&&!h.importScripts,t.$C=(()=>{if(t.$B){const O=[];h.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let _=0,q=O.length;_<q;_++){const J=O[_];if(J.id===I.data.vscodeScheduleAsyncWork){O.splice(_,1),J.callback();return}}});let x=0;return I=>{const _=++x;O.push({id:_,callback:I}),h.postMessage({vscodeScheduleAsyncWork:_},"*")}}return O=>setTimeout(O)})();var A;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(A||(t.OperatingSystem=A={})),t.OS=n||f?A.Macintosh:i?A.Windows:A.Linux;let V=!0,U=!1;function C(){if(!U){U=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,V=new Uint16Array(O.buffer)[0]===513}return V}t.$F=!!(t.$w&&t.$w.indexOf("Chrome")>=0),t.$G=!!(t.$w&&t.$w.indexOf("Firefox")>=0),t.$H=!!(!t.$F&&t.$w&&t.$w.indexOf("Safari")>=0),t.$I=!!(t.$w&&t.$w.indexOf("Edg/")>=0),t.$J=!!(t.$w&&t.$w.indexOf("Android")>=0);function E(O){return parseFloat(O)>=20}}),define(pe[98],we([1,0,6,8,5]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7r=t.$6r=t.$5r=t.$4r=t.$3r=void 0,t.$1r=N,t.$2r=w;var F;(function(m){m[m.CtrlCmd=2048]="CtrlCmd",m[m.Shift=1024]="Shift",m[m.Alt=512]="Alt",m[m.WinCtrl=256]="WinCtrl",m[m.KeyCode=255]="KeyCode"})(F||(F={}));function N(m,e){if(typeof m=="number"){if(m===0)return null;const s=(m&65535)>>>0,r=(m&4294901760)>>>16;return r!==0?new p([w(s,e),w(r,e)]):new p([w(s,e)])}else{const s=[];for(let r=0;r<m.length;r++)s.push(w(m[r],e));return new p(s)}}function w(m,e){const s=!!(m&F.CtrlCmd),r=!!(m&F.WinCtrl),h=e===P.OperatingSystem.Macintosh?r:s,a=!!(m&F.Shift),v=!!(m&F.Alt),T=e===P.OperatingSystem.Macintosh?s:r,S=m&F.KeyCode;return new D(h,a,v,T,S)}class D{constructor(e,s,r,h,a){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=h,this.keyCode=a}equals(e){return e instanceof D&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",r=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${e}${s}${r}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===n.KeyCode.Unknown||this.keyCode===n.KeyCode.Ctrl||this.keyCode===n.KeyCode.Meta||this.keyCode===n.KeyCode.Alt||this.keyCode===n.KeyCode.Shift}toKeybinding(){return new p([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===n.KeyCode.Ctrl||this.shiftKey&&this.keyCode===n.KeyCode.Shift||this.altKey&&this.keyCode===n.KeyCode.Alt||this.metaKey&&this.keyCode===n.KeyCode.Meta}}t.$3r=D;class f{constructor(e,s,r,h,a){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=h,this.scanCode=a}equals(e){return e instanceof f&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",r=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${e}${s}${r}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===n.ScanCode.ControlLeft||this.scanCode===n.ScanCode.ControlRight)||this.shiftKey&&(this.scanCode===n.ScanCode.ShiftLeft||this.scanCode===n.ScanCode.ShiftRight)||this.altKey&&(this.scanCode===n.ScanCode.AltLeft||this.scanCode===n.ScanCode.AltRight)||this.metaKey&&(this.scanCode===n.ScanCode.MetaLeft||this.scanCode===n.ScanCode.MetaRight)}}t.$4r=f;class p{constructor(e){if(e.length===0)throw(0,i.$7)("chords");this.chords=e}getHashCode(){let e="";for(let s=0,r=this.chords.length;s<r;s++)s!==0&&(e+=";"),e+=this.chords[s].getHashCode();return e}equals(e){if(e===null||this.chords.length!==e.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(e.chords[s]))return!1;return!0}}t.$5r=p;class y{constructor(e,s,r,h,a,v){this.ctrlKey=e,this.shiftKey=s,this.altKey=r,this.metaKey=h,this.keyLabel=a,this.keyAriaLabel=v}}t.$6r=y;class ${}t.$7r=$}),define(pe[99],we([1,0,5]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let n;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const F=P.process;n={get platform(){return F.platform},get arch(){return F.arch},get env(){return F.env},cwd(){return F.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return i.$j?"win32":i.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.$ec=n.platform,t.$fc=n.arch}),define(pe[28],we([1,0,99]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0,i=He(i);const n=65,P=97,F=90,N=122,w=46,D=47,f=92,p=58,y=63;class $ extends Error{constructor(b,A,V){let U;typeof A=="string"&&A.indexOf("not ")===0?(U="must not be",A=A.replace(/^not /,"")):U="must be";const C=b.indexOf(".")!==-1?"property":"argument";let E=`The "${b}" ${C} ${U} of type ${A}`;E+=`. Received type ${typeof V}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function m(c,b){if(c===null||typeof c!="object")throw new $(b,"Object",c)}function e(c,b){if(typeof c!="string")throw new $(b,"string",c)}const s=i.$ec==="win32";function r(c){return c===D||c===f}function h(c){return c===D}function a(c){return c>=n&&c<=F||c>=P&&c<=N}function v(c,b,A,V){let U="",C=0,E=-1,O=0,x=0;for(let I=0;I<=c.length;++I){if(I<c.length)x=c.charCodeAt(I);else{if(V(x))break;x=D}if(V(x)){if(!(E===I-1||O===1))if(O===2){if(U.length<2||C!==2||U.charCodeAt(U.length-1)!==w||U.charCodeAt(U.length-2)!==w){if(U.length>2){const _=U.lastIndexOf(A);_===-1?(U="",C=0):(U=U.slice(0,_),C=U.length-1-U.lastIndexOf(A)),E=I,O=0;continue}else if(U.length!==0){U="",C=0,E=I,O=0;continue}}b&&(U+=U.length>0?`${A}..`:"..",C=2)}else U.length>0?U+=`${A}${c.slice(E+1,I)}`:U=c.slice(E+1,I),C=I-E-1;E=I,O=0}else x===w&&O!==-1?++O:O=-1}return U}function T(c){return c?`${c[0]==="."?"":"."}${c}`:""}function S(c,b){m(b,"pathObject");const A=b.dir||b.root,V=b.base||`${b.name||""}${T(b.ext)}`;return A?A===b.root?`${A}${V}`:`${A}${c}${V}`:V}t.$gc={resolve(...c){let b="",A="",V=!1;for(let U=c.length-1;U>=-1;U--){let C;if(U>=0){if(C=c[U],e(C,`paths[${U}]`),C.length===0)continue}else b.length===0?C=i.cwd():(C=i.env[`=${b}`]||i.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==b.toLowerCase()&&C.charCodeAt(2)===f)&&(C=`${b}\\`));const E=C.length;let O=0,x="",I=!1;const _=C.charCodeAt(0);if(E===1)r(_)&&(O=1,I=!0);else if(r(_))if(I=!0,r(C.charCodeAt(1))){let q=2,J=q;for(;q<E&&!r(C.charCodeAt(q));)q++;if(q<E&&q!==J){const G=C.slice(J,q);for(J=q;q<E&&r(C.charCodeAt(q));)q++;if(q<E&&q!==J){for(J=q;q<E&&!r(C.charCodeAt(q));)q++;(q===E||q!==J)&&(x=`\\\\${G}\\${C.slice(J,q)}`,O=q)}}}else O=1;else a(_)&&C.charCodeAt(1)===p&&(x=C.slice(0,2),O=2,E>2&&r(C.charCodeAt(2))&&(I=!0,O=3));if(x.length>0)if(b.length>0){if(x.toLowerCase()!==b.toLowerCase())continue}else b=x;if(V){if(b.length>0)break}else if(A=`${C.slice(O)}\\${A}`,V=I,I&&b.length>0)break}return A=v(A,!V,"\\",r),V?`${b}\\${A}`:`${b}${A}`||"."},normalize(c){e(c,"path");const b=c.length;if(b===0)return".";let A=0,V,U=!1;const C=c.charCodeAt(0);if(b===1)return h(C)?"\\":c;if(r(C))if(U=!0,r(c.charCodeAt(1))){let O=2,x=O;for(;O<b&&!r(c.charCodeAt(O));)O++;if(O<b&&O!==x){const I=c.slice(x,O);for(x=O;O<b&&r(c.charCodeAt(O));)O++;if(O<b&&O!==x){for(x=O;O<b&&!r(c.charCodeAt(O));)O++;if(O===b)return`\\\\${I}\\${c.slice(x)}\\`;O!==x&&(V=`\\\\${I}\\${c.slice(x,O)}`,A=O)}}}else A=1;else a(C)&&c.charCodeAt(1)===p&&(V=c.slice(0,2),A=2,b>2&&r(c.charCodeAt(2))&&(U=!0,A=3));let E=A<b?v(c.slice(A),!U,"\\",r):"";return E.length===0&&!U&&(E="."),E.length>0&&r(c.charCodeAt(b-1))&&(E+="\\"),V===void 0?U?`\\${E}`:E:U?`${V}\\${E}`:`${V}${E}`},isAbsolute(c){e(c,"path");const b=c.length;if(b===0)return!1;const A=c.charCodeAt(0);return r(A)||b>2&&a(A)&&c.charCodeAt(1)===p&&r(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let b,A;for(let C=0;C<c.length;++C){const E=c[C];e(E,"path"),E.length>0&&(b===void 0?b=A=E:b+=`\\${E}`)}if(b===void 0)return".";let V=!0,U=0;if(typeof A=="string"&&r(A.charCodeAt(0))){++U;const C=A.length;C>1&&r(A.charCodeAt(1))&&(++U,C>2&&(r(A.charCodeAt(2))?++U:V=!1))}if(V){for(;U<b.length&&r(b.charCodeAt(U));)U++;U>=2&&(b=`\\${b.slice(U)}`)}return t.$gc.normalize(b)},relative(c,b){if(e(c,"from"),e(b,"to"),c===b)return"";const A=t.$gc.resolve(c),V=t.$gc.resolve(b);if(A===V||(c=A.toLowerCase(),b=V.toLowerCase(),c===b))return"";let U=0;for(;U<c.length&&c.charCodeAt(U)===f;)U++;let C=c.length;for(;C-1>U&&c.charCodeAt(C-1)===f;)C--;const E=C-U;let O=0;for(;O<b.length&&b.charCodeAt(O)===f;)O++;let x=b.length;for(;x-1>O&&b.charCodeAt(x-1)===f;)x--;const I=x-O,_=E<I?E:I;let q=-1,J=0;for(;J<_;J++){const K=c.charCodeAt(U+J);if(K!==b.charCodeAt(O+J))break;K===f&&(q=J)}if(J!==_){if(q===-1)return V}else{if(I>_){if(b.charCodeAt(O+J)===f)return V.slice(O+J+1);if(J===2)return V.slice(O+J)}E>_&&(c.charCodeAt(U+J)===f?q=J:J===2&&(q=3)),q===-1&&(q=0)}let G="";for(J=U+q+1;J<=C;++J)(J===C||c.charCodeAt(J)===f)&&(G+=G.length===0?"..":"\\..");return O+=q,G.length>0?`${G}${V.slice(O,x)}`:(V.charCodeAt(O)===f&&++O,V.slice(O,x))},toNamespacedPath(c){if(typeof c!="string"||c.length===0)return c;const b=t.$gc.resolve(c);if(b.length<=2)return c;if(b.charCodeAt(0)===f){if(b.charCodeAt(1)===f){const A=b.charCodeAt(2);if(A!==y&&A!==w)return`\\\\?\\UNC\\${b.slice(2)}`}}else if(a(b.charCodeAt(0))&&b.charCodeAt(1)===p&&b.charCodeAt(2)===f)return`\\\\?\\${b}`;return c},dirname(c){e(c,"path");const b=c.length;if(b===0)return".";let A=-1,V=0;const U=c.charCodeAt(0);if(b===1)return r(U)?c:".";if(r(U)){if(A=V=1,r(c.charCodeAt(1))){let O=2,x=O;for(;O<b&&!r(c.charCodeAt(O));)O++;if(O<b&&O!==x){for(x=O;O<b&&r(c.charCodeAt(O));)O++;if(O<b&&O!==x){for(x=O;O<b&&!r(c.charCodeAt(O));)O++;if(O===b)return c;O!==x&&(A=V=O+1)}}}}else a(U)&&c.charCodeAt(1)===p&&(A=b>2&&r(c.charCodeAt(2))?3:2,V=A);let C=-1,E=!0;for(let O=b-1;O>=V;--O)if(r(c.charCodeAt(O))){if(!E){C=O;break}}else E=!1;if(C===-1){if(A===-1)return".";C=A}return c.slice(0,C)},basename(c,b){b!==void 0&&e(b,"suffix"),e(c,"path");let A=0,V=-1,U=!0,C;if(c.length>=2&&a(c.charCodeAt(0))&&c.charCodeAt(1)===p&&(A=2),b!==void 0&&b.length>0&&b.length<=c.length){if(b===c)return"";let E=b.length-1,O=-1;for(C=c.length-1;C>=A;--C){const x=c.charCodeAt(C);if(r(x)){if(!U){A=C+1;break}}else O===-1&&(U=!1,O=C+1),E>=0&&(x===b.charCodeAt(E)?--E===-1&&(V=C):(E=-1,V=O))}return A===V?V=O:V===-1&&(V=c.length),c.slice(A,V)}for(C=c.length-1;C>=A;--C)if(r(c.charCodeAt(C))){if(!U){A=C+1;break}}else V===-1&&(U=!1,V=C+1);return V===-1?"":c.slice(A,V)},extname(c){e(c,"path");let b=0,A=-1,V=0,U=-1,C=!0,E=0;c.length>=2&&c.charCodeAt(1)===p&&a(c.charCodeAt(0))&&(b=V=2);for(let O=c.length-1;O>=b;--O){const x=c.charCodeAt(O);if(r(x)){if(!C){V=O+1;break}continue}U===-1&&(C=!1,U=O+1),x===w?A===-1?A=O:E!==1&&(E=1):A!==-1&&(E=-1)}return A===-1||U===-1||E===0||E===1&&A===U-1&&A===V+1?"":c.slice(A,U)},format:S.bind(null,"\\"),parse(c){e(c,"path");const b={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return b;const A=c.length;let V=0,U=c.charCodeAt(0);if(A===1)return r(U)?(b.root=b.dir=c,b):(b.base=b.name=c,b);if(r(U)){if(V=1,r(c.charCodeAt(1))){let q=2,J=q;for(;q<A&&!r(c.charCodeAt(q));)q++;if(q<A&&q!==J){for(J=q;q<A&&r(c.charCodeAt(q));)q++;if(q<A&&q!==J){for(J=q;q<A&&!r(c.charCodeAt(q));)q++;q===A?V=q:q!==J&&(V=q+1)}}}}else if(a(U)&&c.charCodeAt(1)===p){if(A<=2)return b.root=b.dir=c,b;if(V=2,r(c.charCodeAt(2))){if(A===3)return b.root=b.dir=c,b;V=3}}V>0&&(b.root=c.slice(0,V));let C=-1,E=V,O=-1,x=!0,I=c.length-1,_=0;for(;I>=V;--I){if(U=c.charCodeAt(I),r(U)){if(!x){E=I+1;break}continue}O===-1&&(x=!1,O=I+1),U===w?C===-1?C=I:_!==1&&(_=1):C!==-1&&(_=-1)}return O!==-1&&(C===-1||_===0||_===1&&C===O-1&&C===E+1?b.base=b.name=c.slice(E,O):(b.name=c.slice(E,C),b.base=c.slice(E,O),b.ext=c.slice(C,O))),E>0&&E!==V?b.dir=c.slice(0,E-1):b.dir=b.root,b},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(s){const c=/\\/g;return()=>{const b=i.cwd().replace(c,"/");return b.slice(b.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...c){let b="",A=!1;for(let V=c.length-1;V>=-1&&!A;V--){const U=V>=0?c[V]:d();e(U,`paths[${V}]`),U.length!==0&&(b=`${U}/${b}`,A=U.charCodeAt(0)===D)}return b=v(b,!A,"/",h),A?`/${b}`:b.length>0?b:"."},normalize(c){if(e(c,"path"),c.length===0)return".";const b=c.charCodeAt(0)===D,A=c.charCodeAt(c.length-1)===D;return c=v(c,!b,"/",h),c.length===0?b?"/":A?"./":".":(A&&(c+="/"),b?`/${c}`:c)},isAbsolute(c){return e(c,"path"),c.length>0&&c.charCodeAt(0)===D},join(...c){if(c.length===0)return".";let b;for(let A=0;A<c.length;++A){const V=c[A];e(V,"path"),V.length>0&&(b===void 0?b=V:b+=`/${V}`)}return b===void 0?".":t.$hc.normalize(b)},relative(c,b){if(e(c,"from"),e(b,"to"),c===b||(c=t.$hc.resolve(c),b=t.$hc.resolve(b),c===b))return"";const A=1,V=c.length,U=V-A,C=1,E=b.length-C,O=U<E?U:E;let x=-1,I=0;for(;I<O;I++){const q=c.charCodeAt(A+I);if(q!==b.charCodeAt(C+I))break;q===D&&(x=I)}if(I===O)if(E>O){if(b.charCodeAt(C+I)===D)return b.slice(C+I+1);if(I===0)return b.slice(C+I)}else U>O&&(c.charCodeAt(A+I)===D?x=I:I===0&&(x=0));let _="";for(I=A+x+1;I<=V;++I)(I===V||c.charCodeAt(I)===D)&&(_+=_.length===0?"..":"/..");return`${_}${b.slice(C+x)}`},toNamespacedPath(c){return c},dirname(c){if(e(c,"path"),c.length===0)return".";const b=c.charCodeAt(0)===D;let A=-1,V=!0;for(let U=c.length-1;U>=1;--U)if(c.charCodeAt(U)===D){if(!V){A=U;break}}else V=!1;return A===-1?b?"/":".":b&&A===1?"//":c.slice(0,A)},basename(c,b){b!==void 0&&e(b,"ext"),e(c,"path");let A=0,V=-1,U=!0,C;if(b!==void 0&&b.length>0&&b.length<=c.length){if(b===c)return"";let E=b.length-1,O=-1;for(C=c.length-1;C>=0;--C){const x=c.charCodeAt(C);if(x===D){if(!U){A=C+1;break}}else O===-1&&(U=!1,O=C+1),E>=0&&(x===b.charCodeAt(E)?--E===-1&&(V=C):(E=-1,V=O))}return A===V?V=O:V===-1&&(V=c.length),c.slice(A,V)}for(C=c.length-1;C>=0;--C)if(c.charCodeAt(C)===D){if(!U){A=C+1;break}}else V===-1&&(U=!1,V=C+1);return V===-1?"":c.slice(A,V)},extname(c){e(c,"path");let b=-1,A=0,V=-1,U=!0,C=0;for(let E=c.length-1;E>=0;--E){const O=c.charCodeAt(E);if(O===D){if(!U){A=E+1;break}continue}V===-1&&(U=!1,V=E+1),O===w?b===-1?b=E:C!==1&&(C=1):b!==-1&&(C=-1)}return b===-1||V===-1||C===0||C===1&&b===V-1&&b===A+1?"":c.slice(b,V)},format:S.bind(null,"/"),parse(c){e(c,"path");const b={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return b;const A=c.charCodeAt(0)===D;let V;A?(b.root="/",V=1):V=0;let U=-1,C=0,E=-1,O=!0,x=c.length-1,I=0;for(;x>=V;--x){const _=c.charCodeAt(x);if(_===D){if(!O){C=x+1;break}continue}E===-1&&(O=!1,E=x+1),_===w?U===-1?U=x:I!==1&&(I=1):U!==-1&&(I=-1)}if(E!==-1){const _=C===0&&A?1:C;U===-1||I===0||I===1&&U===E-1&&U===C+1?b.base=b.name=c.slice(_,E):(b.name=c.slice(_,U),b.base=c.slice(_,E),b.ext=c.slice(U,E))}return C>0?b.dir=c.slice(0,C-1):A&&(b.dir="/"),b},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=s?t.$gc.normalize:t.$hc.normalize,t.$jc=s?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=s?t.$gc.join:t.$hc.join,t.$lc=s?t.$gc.resolve:t.$hc.resolve,t.$mc=s?t.$gc.relative:t.$hc.relative,t.$nc=s?t.$gc.dirname:t.$hc.dirname,t.$oc=s?t.$gc.basename:t.$hc.basename,t.$pc=s?t.$gc.extname:t.$hc.extname,t.$qc=s?t.$gc.format:t.$hc.format,t.$rc=s?t.$gc.parse:t.$hc.parse,t.$sc=s?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=s?t.$gc.sep:t.$hc.sep,t.$uc=s?t.$gc.delimiter:t.$hc.delimiter}),define(pe[100],we([1,0,28]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=void 0,t.$at=F,t.$bt=N,t.$ct=w,t.$dt=f,t.$_s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(p){const y=(0,i.$pc)(p),$=n[y.toLowerCase()];return $!==void 0?$:N(p)}function N(p){const y=(0,i.$pc)(p);return P[y.toLowerCase()]}function w(p){for(const y in P)if(P[y]===p)return y}const D=/^(.+)\/(.+?)(;.+)?$/;function f(p,y){const $=D.exec(p);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:y?void 0:p}}),define(pe[46],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(n){function P(D,f){if(D.start>=f.end||f.start>=D.end)return{start:0,end:0};const p=Math.max(D.start,f.start),y=Math.min(D.end,f.end);return y-p<=0?{start:0,end:0}:{start:p,end:y}}n.intersect=P;function F(D){return D.end-D.start<=0}n.isEmpty=F;function N(D,f){return!F(P(D,f))}n.intersects=N;function w(D,f){const p=[],y={start:D.start,end:Math.min(f.start,D.end)},$={start:Math.max(f.end,D.start),end:D.end};return F(y)||p.push(y),F($)||p.push($),p}n.relativeComplement=w})(i||(t.Range=i={}))}),define(pe[101],we([1,0,46]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7U=void 0,t.$4U=n,t.$5U=P,t.$6U=F;function n(D,f){const p=[];for(const y of f){if(D.start>=y.range.end)continue;if(D.end<y.range.start)break;const $=i.Range.intersect(D,y.range);i.Range.isEmpty($)||p.push({range:$,size:y.size})}return p}function P({start:D,end:f},p){return{start:D+p,end:f+p}}function F(D){const f=[];let p=null;for(const y of D){const $=y.range.start,m=y.range.end,e=y.size;if(p&&e===p.size){p.range.end=m;continue}p={range:{start:$,end:m},size:e},f.push(p)}return f}function N(...D){return F(D.reduce((f,p)=>f.concat(p),[]))}class w{get paddingTop(){return this.c}set paddingTop(f){this.b=this.b+f-this.c,this.c=f}constructor(f){this.a=[],this.b=0,this.c=0,this.c=f??0,this.b=this.c}splice(f,p,y=[]){const $=y.length-p,m=n({start:0,end:f},this.a),e=n({start:f+p,end:Number.POSITIVE_INFINITY},this.a).map(r=>({range:P(r.range,$),size:r.size})),s=y.map((r,h)=>({range:{start:f+h,end:f+h+1},size:r.size}));this.a=N(m,s,e),this.b=this.c+this.a.reduce((r,h)=>r+h.size*(h.range.end-h.range.start),0)}get count(){const f=this.a.length;return f?this.a[f-1].range.end:0}get size(){return this.b}indexAt(f){if(f<0)return-1;if(f<this.c)return 0;let p=0,y=this.c;for(const $ of this.a){const m=$.range.end-$.range.start,e=y+m*$.size;if(f<e)return p+Math.floor((f-y)/$.size);p+=m,y=e}return p}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let p=0,y=0;for(const $ of this.a){const m=$.range.end-$.range.start,e=y+m;if(f<e)return this.c+p+(f-y)*$.size;p+=m*$.size,y=e}return-1}}t.$7U=w}),define(pe[102],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ge=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(F){return new n(F)}constructor(F){this.c=i&&F===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ge=n}),define(pe[3],we([1,0,6,58,2,59,102]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$ie=t.Event=void 0,t.$je=m;const w=!1,D=!1,f=!1;var p;(function(G){G.None=()=>P.$Vc.None;function K(B){if(f){const{onDidAddListener:H}=B,Y=s.create();let ie=0;B.onDidAddListener=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),H?.()}}}function Q(B,H){return te(B,()=>{},0,void 0,!0,void 0,H)}G.defer=Q;function ae(B){return(H,Y=null,ie)=>{let re=!1,he;return he=B(De=>{if(!re)return he?he.dispose():re=!0,H.call(Y,De)},null,ie),re&&he.dispose(),he}}G.once=ae;function me(B,H,Y){return le((ie,re=null,he)=>B(De=>ie.call(re,H(De)),null,he),Y)}G.map=me;function ye(B,H,Y){return le((ie,re=null,he)=>B(De=>{H(De),ie.call(re,De)},null,he),Y)}G.forEach=ye;function Le(B,H,Y){return le((ie,re=null,he)=>B(De=>H(De)&&ie.call(re,De),null,he),Y)}G.filter=Le;function ne(B){return B}G.signal=ne;function ee(...B){return(H,Y=null,ie)=>{const re=(0,P.$Sc)(...B.map(he=>he(De=>H.call(Y,De))));return ke(re,ie)}}G.any=ee;function ce(B,H,Y,ie){let re=Y;return me(B,he=>(re=H(re,he),re),ie)}G.reduce=ce;function le(B,H){let Y;const ie={onWillAddFirstListener(){Y=B(re.fire,re)},onDidRemoveLastListener(){Y?.dispose()}};H||K(ie);const re=new c(ie);return H?.add(re),re.event}function ke(B,H){return H instanceof Array?H.push(B):H&&H.add(B),B}function te(B,H,Y=100,ie=!1,re=!1,he,De){let ve,Ee,Ne,fe=0,Fe;const Ke={leakWarningThreshold:he,onWillAddFirstListener(){ve=B(tt=>{fe++,Ee=H(Ee,tt),ie&&!Ne&&(Xe.fire(Ee),Ee=void 0),Fe=()=>{const lt=Ee;Ee=void 0,Ne=void 0,(!ie||fe>1)&&Xe.fire(lt),fe=0},typeof Y=="number"?(clearTimeout(Ne),Ne=setTimeout(Fe,Y)):Ne===void 0&&(Ne=0,queueMicrotask(Fe))})},onWillRemoveListener(){re&&fe>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,ve.dispose()}};De||K(Ke);const Xe=new c(Ke);return De?.add(Xe),Xe.event}G.debounce=te;function be(B,H=0,Y){return G.debounce(B,(ie,re)=>ie?(ie.push(re),ie):[re],H,void 0,!0,void 0,Y)}G.accumulate=be;function Ae(B,H=(ie,re)=>ie===re,Y){let ie=!0,re;return Le(B,he=>{const De=ie||!H(he,re);return ie=!1,re=he,De},Y)}G.latch=Ae;function Re(B,H,Y){return[G.filter(B,H,Y),G.filter(B,ie=>!H(ie),Y)]}G.split=Re;function Ie(B,H=!1,Y=[],ie){let re=Y.slice(),he=B(Ee=>{re?re.push(Ee):ve.fire(Ee)});ie&&ie.add(he);const De=()=>{re?.forEach(Ee=>ve.fire(Ee)),re=null},ve=new c({onWillAddFirstListener(){he||(he=B(Ee=>ve.fire(Ee)),ie&&ie.add(he))},onDidAddFirstListener(){re&&(H?setTimeout(De):De())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return ie&&ie.add(ve),ve.event}G.buffer=Ie;function je(B,H){return(ie,re,he)=>{const De=H(new W);return B(function(ve){const Ee=De.evaluate(ve);Ee!==_e&&ie.call(re,Ee)},void 0,he)}}G.chain=je;const _e=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(H){return this.f.push(H),this}forEach(H){return this.f.push(Y=>(H(Y),Y)),this}filter(H){return this.f.push(Y=>H(Y)?Y:_e),this}reduce(H,Y){let ie=Y;return this.f.push(re=>(ie=H(ie,re),ie)),this}latch(H=(Y,ie)=>Y===ie){let Y=!0,ie;return this.f.push(re=>{const he=Y||!H(re,ie);return Y=!1,ie=re,he?re:_e}),this}evaluate(H){for(const Y of this.f)if(H=Y(H),H===_e)break;return H}}function j(B,H,Y=ie=>ie){const ie=(...ve)=>De.fire(Y(...ve)),re=()=>B.on(H,ie),he=()=>B.removeListener(H,ie),De=new c({onWillAddFirstListener:re,onDidRemoveLastListener:he});return De.event}G.fromNodeEventEmitter=j;function l(B,H,Y=ie=>ie){const ie=(...ve)=>De.fire(Y(...ve)),re=()=>B.addEventListener(H,ie),he=()=>B.removeEventListener(H,ie),De=new c({onWillAddFirstListener:re,onDidRemoveLastListener:he});return De.event}G.fromDOMEventEmitter=l;function o(B){return new Promise(H=>ae(B)(H))}G.toPromise=o;function g(B){const H=new c;return B.then(Y=>{H.fire(Y)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}G.fromPromise=g;function M(B,H){return B(Y=>H.fire(Y))}G.forward=M;function k(B,H,Y){return H(Y),B(ie=>H(ie))}G.runAndSubscribe=k;class u{constructor(H,Y){this._observable=H,this.f=0,this.g=!1;const ie={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};Y||K(ie),this.emitter=new c(ie),Y&&Y.add(this.emitter)}beginUpdate(H){this.f++}handlePossibleChange(H){}handleChange(H,Y){this.g=!0}endUpdate(H){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function L(B,H){return new u(B,H).emitter.event}G.fromObservable=L;function R(B){return(H,Y,ie)=>{let re=0,he=!1;const De={beginUpdate(){re++},endUpdate(){re--,re===0&&(B.reportChanges(),he&&(he=!1,H.call(Y)))},handlePossibleChange(){},handleChange(){he=!0}};B.addObserver(De),B.reportChanges();const ve={dispose(){B.removeObserver(De)}};return ie instanceof P.$Uc?ie.add(ve):Array.isArray(ie)&&ie.push(ve),ve}}G.fromObservableLight=R})(p||(t.Event=p={}));class y{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${y.f++}`,y.all.add(this)}start(K){this.g=new N.$ge,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}t.$ie=y;let $=-1;function m(G){const K=$;return $=G,{dispose(){$=K}}}class e{static{this.f=1}constructor(K,Q,ae=(e.f++).toString(16).padStart(3,"0")){this.j=K,this.threshold=Q,this.name=ae,this.h=0}dispose(){this.g?.clear()}check(K,Q){const ae=this.threshold;if(ae<=0||Q<ae)return;this.g||(this.g=new Map);const me=this.g.get(K.value)||0;if(this.g.set(K.value,me+1),this.h-=1,this.h<=0){this.h=ae*.5;const[ye,Le]=this.getMostFrequentStack(),ne=`[${this.name}] potential listener LEAK detected, having ${Q} listeners already. MOST frequent listener (${Le}):`;console.warn(ne),console.warn(ye);const ee=new r(ne,ye);this.j(ee)}return()=>{const ye=this.g.get(K.value)||0;this.g.set(K.value,ye-1)}}getMostFrequentStack(){if(!this.g)return;let K,Q=0;for(const[ae,me]of this.g)(!K||Q<me)&&(K=[ae,me],Q=me);return K}}class s{static create(){const K=new Error;return new s(K.stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class r extends Error{constructor(K,Q){super(K),this.name="ListenerLeakError",this.stack=Q}}t.$ke=r;class h extends Error{constructor(K,Q){super(K),this.name="ListenerRefusalError",this.stack=Q}}t.$le=h;let a=0;class v{constructor(K){this.value=K,this.id=a++}}const T=2,S=(G,K)=>{if(G instanceof v)K(G);else for(let Q=0;Q<G.length;Q++){const ae=G[Q];ae&&K(ae)}};let d;if(w){const G=[];setInterval(()=>{G.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(G.join(`
`)),G.length=0)},3e3),d=new FinalizationRegistry(K=>{typeof K=="string"&&G.push(K)})}class c{constructor(K){this.z=0,this.f=K,this.g=$>0||this.f?.leakWarningThreshold?new e(K?.onListenerError??i.$Z,this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(D){const K=this.u;queueMicrotask(()=>{S(K,Q=>Q.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,Q,ae)=>{if(this.g&&this.z>this.g.threshold**2){const ee=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(ee);const ce=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],le=new h(`${ee}. HINT: Stack shows most frequent listener (${ce[1]}-times)`,ce[0]);return(this.f?.onListenerError||i.$Z)(le),P.$Vc.None}if(this.m)return P.$Vc.None;Q&&(K=K.bind(Q));const me=new v(K);let ye,Le;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(me.stack=s.create(),ye=this.g.check(me.stack,this.z+1)),D&&(me.stack=Le??s.create()),this.u?this.u instanceof v?(this.w??=new A,this.u=[this.u,me]):this.u.push(me):(this.f?.onWillAddFirstListener?.(this),this.u=me,this.f?.onDidAddFirstListener?.(this)),this.z++;const ne=(0,P.$Tc)(()=>{d?.unregister(ne),ye?.(),this.A(me)});if(ae instanceof P.$Uc?ae.add(ne):Array.isArray(ae)&&ae.push(ne),d){const ee=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ce=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(ee);d.register(ne,ce?.[2]??ee,ne)}return ne},this.q}A(K){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Q=this.u,ae=Q.indexOf(K);if(ae===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Q[ae]=void 0;const me=this.w.current===this;if(this.z*T<=Q.length){let ye=0;for(let Le=0;Le<Q.length;Le++)Q[Le]?Q[ye++]=Q[Le]:me&&(this.w.end--,ye<this.w.i&&this.w.i--);Q.length=ye}}B(K,Q){if(!K)return;const ae=this.f?.onListenerError||i.$Z;if(!ae){K.value(Q);return}try{K.value(Q)}catch(me){ae(me)}}C(K){const Q=K.current.u;for(;K.i<K.end;)this.B(Q[K.i++],K.value);K.reset()}fire(K){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof v)this.B(this.u,K);else{const Q=this.w;Q.enqueue(this,K,this.u.length),this.C(Q)}this.j?.stop()}hasListeners(){return this.z>0}}t.$me=c;const b=()=>new A;t.$ne=b;class A{constructor(){this.i=-1,this.end=0}enqueue(K,Q,ae){this.i=0,this.end=ae,this.current=K,this.value=Q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class V extends c{async fireAsync(K,Q,ae){if(this.u)for(this.h||(this.h=new F.$6c),S(this.u,me=>this.h.push([me.value,K]));this.h.size>0&&!Q.isCancellationRequested;){const[me,ye]=this.h.shift(),Le=[],ne={...ye,token:Q,waitUntil:ee=>{if(Object.isFrozen(Le))throw new Error("waitUntil can NOT be called asynchronous");ae&&(ee=ae(ee,me)),Le.push(ee)}};try{me(ne)}catch(ee){(0,i.$Z)(ee);continue}Object.freeze(Le),await Promise.allSettled(Le).then(ee=>{for(const ce of ee)ce.status==="rejected"&&(0,i.$Z)(ce.reason)})}}}t.$oe=V;class U extends c{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new F.$6c,this.t=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.t(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.z&&(this.h!==0?this.s.push(K):super.fire(K))}}t.$pe=U;class C extends U{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}t.$qe=C;class E extends c{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Q=>super.fire(Q)),this.h=[]}))}}t.$re=E;class O{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const Q={event:K,listener:null};this.h.push(Q),this.g&&this.m(Q);const ae=()=>{this.g&&this.o(Q);const me=this.h.indexOf(Q);this.h.splice(me,1)};return(0,P.$Tc)((0,n.$db)(ae))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(Q=>this.f.fire(Q))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}t.$se=O;class x{constructor(K,Q,ae,me){this.f=new P.$Uc;const ye=this.f.add(new O),Le=this.f.add(new P.$5c);function ne(ee){Le.set(ee,ye.add(me(ee)))}for(const ee of K)ne(ee);this.f.add(Q(ee=>{ne(ee)})),this.f.add(ae(ee=>{Le.deleteAndDispose(ee)})),this.event=ye.event}dispose(){this.f.dispose()}}t.$te=x;class I{constructor(){this.f=[]}wrapEvent(K,Q,ae){return(me,ye,Le)=>K(ne=>{const ee=this.f[this.f.length-1];if(!Q){ee?ee.buffers.push(()=>me.call(ye,ne)):me.call(ye,ne);return}const ce=ee;if(!ce){me.call(ye,Q(ae,ne));return}ce.items??=[],ce.items.push(ne),ce.buffers.length===0&&ee.buffers.push(()=>{ce.reducedResult??=ae?ce.items.reduce(Q,ae):ce.items.reduce(Q),me.call(ye,ce.reducedResult)})},void 0,Le)}bufferEvents(K){const Q={buffers:new Array};this.f.push(Q);const ae=K();return this.f.pop(),Q.buffers.forEach(me=>me()),ae}}t.$ue=I;class _{constructor(){this.f=!1,this.g=p.None,this.h=P.$Vc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ve=_;class q{static const(K){return new J(K)}constructor(K){this.g=K,this.f=new c,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}t.$we=q;class J{constructor(K){this.value=K,this.onDidChange=p.None}}}),define(pe[18],we([1,0,24,3]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vS=t.$uS=t.$tS=t.$sS=t.$rS=t.$qS=t.$pS=t.$oS=t.$jS=void 0,t.$gS=F,t.$hS=N,t.$iS=w,t.$kS=D,t.$lS=f,t.$mS=p,t.$nS=y,t.$wS=e,t.$xS=s,t.$yS=r;class P{constructor(){this.a=new Map,this.b=new n.$me,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new n.$me,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new P}getZoomLevel(a){return this.a.get(this.f(a))??0}setZoomLevel(a,v){if(this.getZoomLevel(v)===a)return;const T=this.f(v);this.a.set(T,a),this.b.fire(T)}getZoomFactor(a){return this.c.get(this.f(a))??1}setZoomFactor(a,v){this.c.set(this.f(v),a)}setFullscreen(a,v){if(this.isFullscreen(v)===a)return;const T=this.f(v);this.e.set(T,a),this.d.fire(T)}isFullscreen(a){return!!this.e.get(this.f(a))}f(a){return a.vscodeWindowId}}function F(h,a,v){typeof a=="string"&&(a=h.matchMedia(a)),a.addEventListener("change",v)}function N(h,a){P.INSTANCE.setZoomLevel(h,a)}function w(h){return P.INSTANCE.getZoomLevel(h)}t.$jS=P.INSTANCE.onDidChangeZoomLevel;function D(h){return P.INSTANCE.getZoomFactor(h)}function f(h,a){P.INSTANCE.setZoomFactor(h,a)}function p(h,a){P.INSTANCE.setFullscreen(h,a)}function y(h){return P.INSTANCE.isFullscreen(h)}t.$oS=P.INSTANCE.onDidChangeFullscreen;const $=navigator.userAgent;t.$pS=$.indexOf("Firefox")>=0,t.$qS=$.indexOf("AppleWebKit")>=0,t.$rS=$.indexOf("Chrome")>=0,t.$sS=!t.$rS&&$.indexOf("Safari")>=0,t.$tS=!t.$rS&&!t.$sS&&t.$qS,t.$uS=$.indexOf("Electron/")>=0,t.$vS=$.indexOf("Android")>=0;let m=!1;if(typeof i.$dS.matchMedia=="function"){const h=i.$dS.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),a=i.$dS.matchMedia("(display-mode: fullscreen)");m=h.matches,F(i.$dS,h,({matches:v})=>{m&&a.matches||(m=v)})}function e(){return m}function s(){return navigator?.windowControlsOverlay?.visible}function r(){return navigator?.windowControlsOverlay?.getTitlebarAreaRect()}}),define(pe[61],we([1,0,18,24,5]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zS=t.KeyboardSupport=void 0,i=He(i),P=He(P);var F;(function(N){N[N.Always=0]="Always",N[N.FullScreen=1]="FullScreen",N[N.None=2]="None"})(F||(t.KeyboardSupport=F={})),t.$zS={clipboard:{writeText:P.$n||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:P.$n||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:P.$n||i.$wS()?F.Always:navigator.keyboard||i.$sS?F.FullScreen:F.None,touch:"ontouchstart"in n.$dS||navigator.maxTouchPoints>0,pointerEvents:n.$dS.PointerEvent&&("ontouchstart"in n.$dS||navigator.maxTouchPoints>0)}}),define(pe[29],we([1,0,3]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YU=void 0;class n{get event(){return this.a.event}constructor(F,N,w){const D=f=>this.a.fire(f);this.a=new i.$me({onWillAddFirstListener:()=>F.addEventListener(N,D,w),onDidRemoveLastListener:()=>F.removeEventListener(N,D,w)})}dispose(){this.a.dispose()}}t.$YU=n}),define(pe[15],we([1,0,18,8,98,5]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HS=void 0,t.$FS=y,t.$GS=$,i=He(i),F=He(F);function N(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(r)}const s=e.keyCode;if(s===3)return n.KeyCode.PauseBreak;if(i.$pS)switch(s){case 59:return n.KeyCode.Semicolon;case 60:if(F.$l)return n.KeyCode.IntlBackslash;break;case 61:return n.KeyCode.Equal;case 107:return n.KeyCode.NumpadAdd;case 109:return n.KeyCode.NumpadSubtract;case 173:return n.KeyCode.Minus;case 224:if(F.$k)return n.KeyCode.Meta;break}else if(i.$qS){if(F.$k&&s===93)return n.KeyCode.Meta;if(!F.$k&&s===92)return n.KeyCode.Meta}return n.$Ur[s]||n.KeyCode.Unknown}const w=F.$k?n.KeyMod.WinCtrl:n.KeyMod.CtrlCmd,D=n.KeyMod.Alt,f=n.KeyMod.Shift,p=F.$k?n.KeyMod.CtrlCmd:n.KeyMod.WinCtrl;function y(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function $(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${n.KeyCodeUtils.toString(e.keyCode)}')`}class m{constructor(s){this._standardKeyboardEventBrand=!0;const r=s;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState?.("AltGraph"),this.keyCode=N(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===n.KeyCode.Ctrl,this.altKey=this.altKey||this.keyCode===n.KeyCode.Alt,this.shiftKey=this.shiftKey||this.keyCode===n.KeyCode.Shift,this.metaKey=this.metaKey||this.keyCode===n.KeyCode.Meta,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=n.KeyCode.Unknown;this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode);let r=0;return this.ctrlKey&&(r|=w),this.altKey&&(r|=D),this.shiftKey&&(r|=f),this.metaKey&&(r|=p),r|=s,r}d(){let s=n.KeyCode.Unknown;return this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode),new P.$3r(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$HS=m}),define(pe[19],we([1,0,18,85,5]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ES=t.$DS=t.$CS=void 0,i=He(i),P=He(P);class F{constructor(f,p){this.timestamp=Date.now(),this.browserEvent=p,this.leftButton=p.button===0,this.middleButton=p.button===1,this.rightButton=p.button===2,this.buttons=p.buttons,this.target=p.target,this.detail=p.detail||1,p.type==="dblclick"&&(this.detail=2),this.ctrlKey=p.ctrlKey,this.shiftKey=p.shiftKey,this.altKey=p.altKey,this.metaKey=p.metaKey,typeof p.pageX=="number"?(this.posx=p.pageX,this.posy=p.pageY):(this.posx=p.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=p.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const y=n.$AS.getPositionOfChildWindowRelativeToAncestorWindow(f,p.view);this.posx-=y.left,this.posy-=y.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$CS=F;class N extends F{constructor(f,p){super(f,p),this.dataTransfer=p.dataTransfer}}t.$DS=N;class w{constructor(f,p=0,y=0){this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=y,this.deltaX=p;let $=!1;if(i.$rS){const m=navigator.userAgent.match(/Chrome\/(\d+)/);$=(m?parseInt(m[1]):123)<=122}if(f){const m=f,e=f,s=f.view?.devicePixelRatio||1;if(typeof m.wheelDeltaY<"u")$?this.deltaY=m.wheelDeltaY/(120*s):this.deltaY=m.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(f.type==="wheel"){const r=f;r.deltaMode===r.DOM_DELTA_LINE?i.$pS&&!P.$k?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof m.wheelDeltaX<"u")i.$sS&&P.$j?this.deltaX=-(m.wheelDeltaX/120):$?this.deltaX=m.wheelDeltaX/(120*s):this.deltaX=m.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const r=f;r.deltaMode===r.DOM_DELTA_LINE?i.$pS&&!P.$k?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&($?this.deltaY=f.wheelDelta/(120*s):this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$ES=w}),define(pe[38],we([1,0,3]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xe=t.CancellationToken=void 0,t.$ye=w;const n=Object.freeze(function(D,f){const p=setTimeout(D.bind(f),0);return{dispose(){clearTimeout(p)}}});var P;(function(D){function f(p){return p===D.None||p===D.Cancelled||p instanceof F?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}D.isCancellationToken=f,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(P||(t.CancellationToken=P={}));class F{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new i.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new F),this.f}cancel(){this.f?this.f instanceof F&&this.f.cancel():this.f=P.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof F&&this.f.dispose():this.f=P.None}}t.$xe=N;function w(D){const f=new N;return D.add({dispose(){f.cancel()}}),f.token}}),define(pe[103],we([1,0,38]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$af=t.$_e=t.$0e=void 0,t.$$e=P;class n{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new i.$xe,f=this.b(D.token);return this.a={promise:f,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}t.$0e=n;function P(w){return w}class F{constructor(D,f){this.a=void 0,this.b=void 0,typeof D=="function"?(this.c=D,this.d=P):(this.c=f,this.d=D.getCacheKey)}get(D){const f=this.d(D);return this.b!==f&&(this.b=f,this.a=this.c(D)),this.a}}t.$_e=F;class N{get cachedValues(){return this.a}constructor(D,f){this.a=new Map,this.b=new Map,typeof D=="function"?(this.c=D,this.d=P):(this.c=f,this.d=D.getCacheKey)}get(D){const f=this.d(D);if(this.b.has(f))return this.b.get(f);const p=this.c(D);return this.a.set(D,p),this.b.set(f,p),p}}t.$af=N}),define(pe[104],we([1,0,44,27,45,38,26,30,6]),function(oe,t,i,n,P,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=t.$ae=t.$_d=t.$$d=void 0,t.$ce=m,t.$de=e;class f{get cachedValue(){return this.a}constructor(r){this.b=r,this.a=(0,n.$7d)(this,void 0)}getValue(){let r=this.a.get();return r||(r=this.b(),this.a.set(r,void 0)),r}}t.$$d=f;class p{static fromFn(r){return new p(r())}constructor(r){this.a=(0,n.$7d)(this,void 0),this.promiseResult=this.a,this.promise=r.then(h=>((0,n.$2d)(a=>{this.a.set(new y(h,void 0),a)}),h),h=>{throw(0,n.$2d)(a=>{this.a.set(new y(void 0,h),a)}),h})}}t.$_d=p;class y{constructor(r,h){this.data=r,this.error=h}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$ae=y;class ${constructor(r){this.b=r,this.a=new f(()=>new p(this.b())),this.cachedPromiseResult=(0,P.$Od)(this,h=>this.a.cachedValue.read(h)?.promiseResult.read(h))}getPromise(){return this.a.getValue().promise}}t.$be=$;function m(s,r,h,a){return r||(r=v=>v!=null),new Promise((v,T)=>{let S=!0,d=!1;const c=s.map(A=>({isFinished:r(A),error:h?h(A):!1,state:A})),b=(0,i.$kd)(A=>{const{isFinished:V,error:U,state:C}=c.read(A);(V||U)&&(S?d=!0:b.dispose(),U?T(U===!0?C:U):v(C))});if(a){const A=a.onCancellationRequested(()=>{b.dispose(),A.dispose(),T(new D.$5)});if(a.isCancellationRequested){b.dispose(),A.dispose(),T(new D.$5);return}}S=!1,d&&b.dispose()})}function e(s,r){let h,a;r===void 0?(h=s,a=void 0):(a=s,h=r);let v;return new P.$Ud(new N.$bd(a,void 0,h),T=>(v&&v.dispose(!0),v=new F.$xe,h(T,v.token)),void 0,void 0,()=>v?.dispose(),w.$7c)}}),define(pe[105],we([1,0,3,2,44,27,26,45,31,6,30]),function(oe,t,i,n,P,F,N,w,D,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hd=t.$Dd=t.$vd=void 0,t.$rd=y,t.$sd=m,t.$td=e,t.$ud=s,t.$wd=h,t.$xd=v,t.$yd=S,t.$zd=d,t.$Ad=c,t.$Bd=b,t.$Cd=A,t.$Ed=U,t.$Fd=C,t.$Gd=E,t.$Id=I,t.$Jd=_,t.$Kd=q;function y(J){return new $(J)}class $ extends F.$Zd{constructor(G){super(),this.b=G}get debugName(){return this.toString()}get(){return this.b}addObserver(G){}removeObserver(G){}toString(){return`Const: ${this.b}`}}function m(J){const G=(0,F.$7d)("promiseValue",{});return J.then(K=>{G.set({value:K},void 0)}),G}function e(...J){let G,K,Q;return J.length===3?[G,K,Q]=J:[K,Q]=J,new r(new N.$bd(G,void 0,Q),K,Q,()=>r.globalTransaction,p.$7c)}function s(J,G,K){return new r(new N.$bd(J.owner,J.debugName,J.debugReferenceFn??K),G,K,()=>r.globalTransaction,J.equalsFn??p.$7c)}class r extends F.$1d{constructor(G,K,Q,ae,me){super(),this.j=G,this.k=K,this._getValue=Q,this.l=ae,this.n=me,this.g=!1,this.r=ye=>{const Le=this._getValue(ye),ne=this.e,ee=!this.g||!this.n(ne,Le);let ce=!1;ee&&(this.e=Le,this.g&&(ce=!0,(0,F.$5d)(this.l(),le=>{(0,D.$Md)()?.handleFromEventObservableTriggered(this,{oldValue:ne,newValue:Le,change:void 0,didChange:ee,hadValue:this.g});for(const ke of this.b)le.updateObserver(ke,this),ke.handleChange(this,void 0)},()=>{const le=this.p();return"Event fired"+(le?`: ${le}`:"")})),this.g=!0),ce||(0,D.$Md)()?.handleFromEventObservableTriggered(this,{oldValue:ne,newValue:Le,change:void 0,didChange:ee,hadValue:this.g})}}p(){return this.j.getDebugName(this)}get debugName(){const G=this.p();return"From Event"+(G?`: ${G}`:"")}c(){this.h=this.k(this.r)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.r(void 0),this.e):this._getValue(void 0)}}t.$vd=r,function(J){J.Observer=r;function G(K,Q){let ae=!1;r.globalTransaction===void 0&&(r.globalTransaction=K,ae=!0);try{Q()}finally{ae&&(r.globalTransaction=void 0)}}J.batchEventsGlobally=G}(e||(t.$td=e={}));function h(J,G){return new a(J,G)}class a extends F.$1d{constructor(G,K){super(),this.debugName=G,this.g=K,this.j=()=>{(0,F.$2d)(Q=>{for(const ae of this.b)Q.updateObserver(ae,this),ae.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function v(J){return typeof J=="string"?new T(J):new T(void 0,J)}class T extends F.$1d{get debugName(){return new N.$bd(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}toString(){return this.debugName}constructor(G,K){super(),this.e=G,this.g=K}trigger(G,K){if(!G){(0,F.$2d)(Q=>{this.trigger(Q,K)},()=>`Trigger signal ${this.debugName}`);return}for(const Q of this.b)G.updateObserver(Q,this),Q.handleChange(this,K)}get(){}}function S(J,G,K){const Q=(0,F.$7d)("debounced",void 0);let ae;return K.add((0,P.$kd)(me=>{const ye=J.read(me);ae&&clearTimeout(ae),ae=setTimeout(()=>{(0,F.$2d)(Le=>{Q.set(ye,Le)})},G)})),Q}function d(J,G){let K=!1,Q,ae;return e(me=>{const ye=(0,P.$kd)(Le=>{const ne=J.read(Le);K?(ae&&clearTimeout(ae),ae=setTimeout(()=>{Q=ne,me()},G)):(K=!0,Q=ne)});return{dispose(){ye.dispose(),K=!1,Q=void 0}}},()=>K?Q:J.get())}function c(J,G,K){const Q=(0,F.$7d)("triggeredRecently",!1);let ae;return K.add(J(()=>{Q.set(!0,void 0),ae&&clearTimeout(ae),ae=setTimeout(()=>{Q.set(!1,void 0)},G)})),Q}function b(J){const G=new V(!1,void 0);return J.addObserver(G),(0,n.$Tc)(()=>{J.removeObserver(G)})}(0,F.$Xd)(b);function A(J,G){const K=new V(!0,G);return J.addObserver(K),G?G(J.get()):J.reportChanges(),(0,n.$Tc)(()=>{J.removeObserver(K)})}(0,F.$Wd)(A);class V{constructor(G,K){this.b=G,this.c=K,this.a=0}beginUpdate(G){this.a++}endUpdate(G){this.a--,this.a===0&&this.b&&(this.c?this.c(G.get()):G.reportChanges())}handlePossibleChange(G){}handleChange(G,K){}}t.$Dd=V;function U(J,G){let K;return(0,w.$Qd)({owner:J,debugReferenceFn:G},ae=>(K=G(ae,K),K))}function C(J,G){let K;const Q=v("derivedObservableWithWritableCache"),ae=(0,w.$Od)(J,me=>(Q.read(me),K=G(me,K),K));return Object.assign(ae,{clearCache:me=>{K=void 0,Q.trigger(me)},setCache:(me,ye)=>{K=me,Q.trigger(ye)}})}function E(J,G,K,Q){let ae=new O(K,Q);return(0,w.$Qd)({debugReferenceFn:K,owner:J,onLastObserverRemoved:()=>{ae.dispose(),ae=new O(K)}},ye=>(ae.setItems(G.read(ye)),ae.getItems()))}class O{constructor(G,K){this.c=G,this.e=K,this.a=new Map,this.b=[]}dispose(){this.a.forEach(G=>G.store.dispose()),this.a.clear()}setItems(G){const K=[],Q=new Set(this.a.keys());for(const ae of G){const me=this.e?this.e(ae):ae;let ye=this.a.get(me);if(ye)Q.delete(me);else{const Le=new n.$Uc;ye={out:this.c(ae,Le),store:Le},this.a.set(me,ye)}K.push(ye.out)}for(const ae of Q)this.a.get(ae).store.dispose(),this.a.delete(ae);this.b=K}getItems(){return this.b}}class x{constructor(G){this.observable=G}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Hd=x;function I(J,G){return G instanceof x?G.observable:e(J,G.onDidChange,()=>G.value)}function _(J,G){if(G.length===0)throw new f.$cb;let K=!1,Q;const ae=e(J,me=>{const ye=new n.$Uc;for(const Le of G)ye.add((0,P.$ld)({debugName:()=>(0,N.$cd)(ae,new N.$bd(J,void 0,void 0))+".updateLastChangedValue"},ne=>{K=!0,Q=Le.read(ne),me()}));return ye.add({dispose(){K=!1,Q=void 0}}),ye},()=>K?Q:G[G.length-1].get());return ae}function q(J,G){return U(J,(K,Q)=>Q??G(K))}}),define(pe[62],we([1,0,27,45,44,105,104,97,31]),function(oe,t,i,n,P,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$7d}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$9d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$2d}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$5d}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return n.$Od}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return n.$Qd}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return n.$Rd}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return n.$Sd}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return P.$kd}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return P.$pd}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return P.$md}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return P.$od}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return P.$ld}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return P.$nd}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return F.$rd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return F.$yd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return F.$Ed}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return F.$Fd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return F.$Bd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return F.$Cd}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return F.$td}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return F.$sd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return F.$xd}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return F.$wd}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return F.$Ad}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return N.$$d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return N.$be}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return N.$_d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return N.$ae}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return N.$ce}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return N.$de}}),Object.defineProperty(t,"observableValueOpts",{enumerable:!0,get:function(){return w.$fe}}),!1&&(0,D.$Ld)(new D.$Nd)}),define(pe[20],we([1,0,3,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ht=t.$gt=t.$ft=t.$et=t.ScrollbarVisibility=void 0;var P;(function(m){m[m.Auto=1]="Auto",m[m.Hidden=2]="Hidden",m[m.Visible=3]="Visible"})(P||(t.ScrollbarVisibility=P={}));class F{constructor(e,s,r,h,a,v,T){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,r=r|0,h=h|0,a=a|0,v=v|0,T=T|0),this.rawScrollLeft=h,this.rawScrollTop=T,s<0&&(s=0),h+s>r&&(h=r-s),h<0&&(h=0),a<0&&(a=0),T+a>v&&(T=v-a),T<0&&(T=0),this.width=s,this.scrollWidth=r,this.scrollLeft=h,this.height=a,this.scrollHeight=v,this.scrollTop=T}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new F(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new F(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const r=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,a=this.scrollLeft!==e.scrollLeft,v=this.height!==e.height,T=this.scrollHeight!==e.scrollHeight,S=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:h,scrollLeftChanged:a,heightChanged:v,scrollHeightChanged:T,scrollTopChanged:S}}}t.$et=F;class N extends n.$Vc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$me),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new F(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const r=this.g.withScrollDimensions(e,s);this.n(r,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const r=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===r.scrollLeft&&this.h.to.scrollTop===r.scrollTop)return;let h;s?h=new p(this.h.from,r,this.h.startTime,this.h.duration):h=this.h.combine(this.g,r,this.c),this.h.dispose(),this.h=h}else{const r=this.g.withScrollPosition(e);this.h=p.start(this.g,r,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const r=this.g;r.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(r,s)))}}t.$ft=N;class w{constructor(e,s,r){this.scrollLeft=e,this.scrollTop=s,this.isDone=r}}t.$gt=w;function D(m,e){const s=e-m;return function(r){return m+s*$(r)}}function f(m,e,s){return function(r){return r<s?m(r/s):e((r-s)/(1-s))}}class p{constructor(e,s,r,h){this.from=e,this.to=s,this.duration=h,this.startTime=r,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,r){if(Math.abs(e-s)>2.5*r){let a,v;return e<s?(a=e+.75*r,v=s-.75*r):(a=e-.75*r,v=s+.75*r),f(D(e,a),D(v,s),.33)}return D(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const r=this.c(s),h=this.d(s);return new w(r,h,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,r){return p.start(e,s,r)}static start(e,s,r){r=r+10;const h=Date.now()-10;return new p(e,s,h,r)}}t.$ht=p;function y(m){return Math.pow(m,3)}function $(m){return 1-y(1-m)}}),define(pe[106],we([1,0,6,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=P,t.$Ae=F,t.$Be=N,t.$Ce=w,t.$De=f,t.$Ee=p,t.$Fe=y,t.$Ge=$,t.$He=m,t.$Ie=e,t.$Je=s,t.$Ke=r,t.$Le=h,t.$Me=a,t.$Ne=v;function P(T){const S=T;return S?typeof S.read=="function":!1}function F(T){const S=T;return S?[S.on,S.pause,S.resume,S.destroy].every(d=>typeof d=="function"):!1}function N(T){const S=T;return S?F(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}function w(T,S){return new D(T,S)}class D{constructor(S,d){this.e=S,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(d=>d(S))}h(S){this.c.error.length===0?(0,i.$Z)(S):this.c.error.slice(0).forEach(d=>d(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,d){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(S,d){if(this.a.destroyed)return;let c;switch(S){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const b=c.indexOf(d);b>=0&&c.splice(b,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(T,S){const d=[];let c;for(;(c=T.read())!==null;)d.push(c);return S(d)}function p(T,S,d){const c=[];let b;for(;(b=T.read())!==null&&c.length<d;)c.push(b);return b===null&&c.length>0?S(c):{read:()=>{if(c.length>0)return c.shift();if(typeof b<"u"){const A=b;return b=void 0,A}return T.read()}}}function y(T,S){return new Promise((d,c)=>{const b=[];$(T,{onData:A=>{S&&b.push(A)},onError:A=>{S?c(A):d(void 0)},onEnd:()=>{d(S?S(b):void 0)}})})}function $(T,S,d){T.on("error",c=>{d?.isCancellationRequested||S.onError(c)}),T.on("end",()=>{d?.isCancellationRequested||S.onEnd()}),T.on("data",c=>{d?.isCancellationRequested||S.onData(c)})}function m(T,S){return new Promise((d,c)=>{const b=new n.$Uc,A=[],V=E=>{if(A.push(E),A.length>S)return b.dispose(),T.pause(),d({stream:T,buffer:A,ended:!1})},U=E=>(b.dispose(),c(E)),C=()=>(b.dispose(),d({stream:T,buffer:A,ended:!0}));b.add((0,n.$Tc)(()=>T.removeListener("error",U))),T.on("error",U),b.add((0,n.$Tc)(()=>T.removeListener("end",C))),T.on("end",C),b.add((0,n.$Tc)(()=>T.removeListener("data",V))),T.on("data",V)})}function e(T,S){const d=w(S);return d.end(T),d}function s(){const T=w(()=>{throw new Error("not supported")});return T.end(),T}function r(T){let S=!1;return{read:()=>S?null:(S=!0,T)}}function h(T,S,d){const c=w(d);return $(T,{onData:b=>c.write(S.data(b)),onError:b=>c.error(S.error?S.error(b):b),onEnd:()=>c.end()}),c}function a(T,S,d){let c=!1;return{read:()=>{const b=S.read();return c?b:(c=!0,b!==null?d([T,b]):T)}}}function v(T,S,d){let c=!1;const b=w(d);return $(S,{onData:A=>c?b.write(A):(c=!0,b.write(d([T,A]))),onError:A=>b.error(A),onEnd:()=>{c||(c=!0,b.write(T)),b.end()}}),b}}),define(pe[47],we([1,0,25,106]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oe=void 0,t.$Pe=f,t.$Qe=p,t.$Re=y,t.$Se=$,t.$Te=m,t.$Ue=e,t.$Ve=s,t.$We=r,t.$Xe=h,t.$Ye=a,t.$Ze=v,t.$1e=T,t.$2e=S,t.$3e=d,t.$4e=c,t.$5e=b,t.$6e=A,t.$7e=V,t.$8e=U,t.$9e=O,n=He(n);const P=typeof Buffer<"u",F=new i.$U(()=>new Uint8Array(256));let N,w;class D{static alloc(I){return P?new D(Buffer.allocUnsafe(I)):new D(new Uint8Array(I))}static wrap(I){return P&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new D(I)}static fromString(I,_){return!(_?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(I)):(N||(N=new TextEncoder),new D(N.encode(I)))}static fromByteArray(I){const _=D.alloc(I.length);for(let q=0,J=I.length;q<J;q++)_.buffer[q]=I[q];return _}static concat(I,_){if(typeof _>"u"){_=0;for(let G=0,K=I.length;G<K;G++)_+=I[G].byteLength}const q=D.alloc(_);let J=0;for(let G=0,K=I.length;G<K;G++){const Q=I[G];q.set(Q,J),J+=Q.byteLength}return q}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=D.alloc(this.byteLength);return I.set(this),I}toString(){return P?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(I,_){return new D(this.buffer.subarray(I,_))}set(I,_){if(I instanceof D)this.buffer.set(I.buffer,_);else if(I instanceof Uint8Array)this.buffer.set(I,_);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),_);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return $(this.buffer,I)}writeUInt32BE(I,_){m(this.buffer,I,_)}readUInt32LE(I){return e(this.buffer,I)}writeUInt32LE(I,_){s(this.buffer,I,_)}readUInt8(I){return r(this.buffer,I)}writeUInt8(I,_){h(this.buffer,I,_)}indexOf(I,_=0){return f(this.buffer,I instanceof D?I.buffer:I,_)}}t.$Oe=D;function f(x,I,_=0){const q=I.byteLength,J=x.byteLength;if(q===0)return 0;if(q===1)return x.indexOf(I[0]);if(q>J-_)return-1;const G=F.value;G.fill(I.length);for(let me=0;me<I.length;me++)G[I[me]]=I.length-me-1;let K=_+I.length-1,Q=K,ae=-1;for(;K<J;)if(x[K]===I[Q]){if(Q===0){ae=K;break}K--,Q--}else K+=Math.max(I.length-Q,G[x[K]]),Q=I.length-1;return ae}function p(x,I){return x[I+0]<<0>>>0|x[I+1]<<8>>>0}function y(x,I,_){x[_+0]=I&255,I=I>>>8,x[_+1]=I&255}function $(x,I){return x[I]*2**24+x[I+1]*2**16+x[I+2]*2**8+x[I+3]}function m(x,I,_){x[_+3]=I,I=I>>>8,x[_+2]=I,I=I>>>8,x[_+1]=I,I=I>>>8,x[_]=I}function e(x,I){return x[I+0]<<0>>>0|x[I+1]<<8>>>0|x[I+2]<<16>>>0|x[I+3]<<24>>>0}function s(x,I,_){x[_+0]=I&255,I=I>>>8,x[_+1]=I&255,I=I>>>8,x[_+2]=I&255,I=I>>>8,x[_+3]=I&255}function r(x,I){return x[I]}function h(x,I,_){x[_]=I}function a(x){return n.$De(x,I=>D.concat(I))}function v(x){return n.$Ke(x)}function T(x){return n.$Fe(x,I=>D.concat(I))}async function S(x){return x.ended?D.concat(x.buffer):D.concat([...x.buffer,await T(x.stream)])}function d(x){return n.$Ie(x,I=>D.concat(I))}function c(x){return n.$Le(x,{data:I=>typeof I=="string"?D.fromString(I):D.wrap(I)},I=>D.concat(I))}function b(x){return n.$Ce(I=>D.concat(I),x)}function A(x,I){return n.$Me(x,I,_=>D.concat(_))}function V(x,I){return n.$Ne(x,I,_=>D.concat(_))}function U(x){let I=0,_=0,q=0;const J=new Uint8Array(Math.floor(x.length/4*3)),G=Q=>{switch(_){case 3:J[q++]=I|Q,_=0;break;case 2:J[q++]=I|Q>>>2,I=Q<<6,_=3;break;case 1:J[q++]=I|Q>>>4,I=Q<<4,_=2;break;default:I=Q<<2,_=1}};for(let Q=0;Q<x.length;Q++){const ae=x.charCodeAt(Q);if(ae>=65&&ae<=90)G(ae-65);else if(ae>=97&&ae<=122)G(ae-97+26);else if(ae>=48&&ae<=57)G(ae-48+52);else if(ae===43||ae===45)G(62);else if(ae===47||ae===95)G(63);else{if(ae===61)break;throw new SyntaxError(`Unexpected base64 character ${x[Q]}`)}}const K=q;for(;_>0;)G(0);return D.wrap(J).slice(0,K)}const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:x},I=!0,_=!1){const q=_?E:C;let J="";const G=x.byteLength%3;let K=0;for(;K<x.byteLength-G;K+=3){const Q=x[K+0],ae=x[K+1],me=x[K+2];J+=q[Q>>>2],J+=q[(Q<<4|ae>>>4)&63],J+=q[(ae<<2|me>>>6)&63],J+=q[me&63]}if(G===1){const Q=x[K+0];J+=q[Q>>>2],J+=q[Q<<4&63],I&&(J+="==")}else if(G===2){const Q=x[K+0],ae=x[K+1];J+=q[Q>>>2],J+=q[(Q<<4|ae>>>4)&63],J+=q[ae<<2&63],I&&(J+="=")}return J}}),define(pe[63],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$he=void 0,t.$he=Symbol("MicrotaskDelay")}),define(pe[10],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fg=i,t.$gg=n,t.$hg=P,t.$ig=F,t.$jg=N,t.$kg=w,t.$lg=D,t.$mg=f,t.$ng=p,t.$og=y,t.$pg=$,t.$qg=m,t.$rg=e,t.$sg=r,t.$tg=h,t.$ug=a,t.$vg=v,t.$wg=T,t.$xg=S;function i(d){return typeof d=="string"}function n(d){return Array.isArray(d)&&d.every(c=>i(c))}function P(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}function F(d){const c=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof c}function N(d){return typeof d=="number"&&!isNaN(d)}function w(d){return!!d&&typeof d[Symbol.iterator]=="function"}function D(d){return d===!0||d===!1}function f(d){return typeof d>"u"}function p(d){return!y(d)}function y(d){return f(d)||d===null}function $(d,c){if(!d)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}function m(d){if(y(d))throw new Error("Assertion Failed: argument is undefined or null");return d}function e(...d){const c=[];for(let b=0;b<d.length;b++){const A=d[b];if(y(A))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);c.push(A)}return c}const s=Object.prototype.hasOwnProperty;function r(d){if(!P(d))return!1;for(const c in d)if(s.call(d,c))return!1;return!0}function h(d){return typeof d=="function"}function a(...d){return d.length>0&&d.every(h)}function v(d,c){const b=Math.min(d.length,c.length);for(let A=0;A<b;A++)T(d[A],c[A])}function T(d,c){if(i(c)){if(typeof d!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(h(c)){try{if(d instanceof c)return}catch{}if(!y(d)&&d.constructor===c||c.length===1&&c.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function S(d){return d}}),define(pe[48],we([1,0,10]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1j=P,t.$2j=F;const n=Object.create(null);function P(N,w){if((0,i.$fg)(w)){const D=n[w];if(D===void 0)throw new Error(`${N} references an unknown codicon: ${w}`);w=D}return n[N]=w,{id:N}}function F(){return n}}),define(pe[107],we([1,0,48]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3j=void 0,t.$3j={add:(0,i.$1j)("add",6e4),plus:(0,i.$1j)("plus",6e4),gistNew:(0,i.$1j)("gist-new",6e4),repoCreate:(0,i.$1j)("repo-create",6e4),lightbulb:(0,i.$1j)("lightbulb",60001),lightBulb:(0,i.$1j)("light-bulb",60001),repo:(0,i.$1j)("repo",60002),repoDelete:(0,i.$1j)("repo-delete",60002),gistFork:(0,i.$1j)("gist-fork",60003),repoForked:(0,i.$1j)("repo-forked",60003),gitPullRequest:(0,i.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,i.$1j)("record-keys",60005),keyboard:(0,i.$1j)("keyboard",60005),tag:(0,i.$1j)("tag",60006),gitPullRequestLabel:(0,i.$1j)("git-pull-request-label",60006),tagAdd:(0,i.$1j)("tag-add",60006),tagRemove:(0,i.$1j)("tag-remove",60006),person:(0,i.$1j)("person",60007),personFollow:(0,i.$1j)("person-follow",60007),personOutline:(0,i.$1j)("person-outline",60007),personFilled:(0,i.$1j)("person-filled",60007),gitBranch:(0,i.$1j)("git-branch",60008),gitBranchCreate:(0,i.$1j)("git-branch-create",60008),gitBranchDelete:(0,i.$1j)("git-branch-delete",60008),sourceControl:(0,i.$1j)("source-control",60008),mirror:(0,i.$1j)("mirror",60009),mirrorPublic:(0,i.$1j)("mirror-public",60009),star:(0,i.$1j)("star",60010),starAdd:(0,i.$1j)("star-add",60010),starDelete:(0,i.$1j)("star-delete",60010),starEmpty:(0,i.$1j)("star-empty",60010),comment:(0,i.$1j)("comment",60011),commentAdd:(0,i.$1j)("comment-add",60011),alert:(0,i.$1j)("alert",60012),warning:(0,i.$1j)("warning",60012),search:(0,i.$1j)("search",60013),searchSave:(0,i.$1j)("search-save",60013),logOut:(0,i.$1j)("log-out",60014),signOut:(0,i.$1j)("sign-out",60014),logIn:(0,i.$1j)("log-in",60015),signIn:(0,i.$1j)("sign-in",60015),eye:(0,i.$1j)("eye",60016),eyeUnwatch:(0,i.$1j)("eye-unwatch",60016),eyeWatch:(0,i.$1j)("eye-watch",60016),circleFilled:(0,i.$1j)("circle-filled",60017),primitiveDot:(0,i.$1j)("primitive-dot",60017),closeDirty:(0,i.$1j)("close-dirty",60017),debugBreakpoint:(0,i.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,i.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,i.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,i.$1j)("primitive-square",60018),edit:(0,i.$1j)("edit",60019),pencil:(0,i.$1j)("pencil",60019),info:(0,i.$1j)("info",60020),issueOpened:(0,i.$1j)("issue-opened",60020),gistPrivate:(0,i.$1j)("gist-private",60021),gitForkPrivate:(0,i.$1j)("git-fork-private",60021),lock:(0,i.$1j)("lock",60021),mirrorPrivate:(0,i.$1j)("mirror-private",60021),close:(0,i.$1j)("close",60022),removeClose:(0,i.$1j)("remove-close",60022),x:(0,i.$1j)("x",60022),repoSync:(0,i.$1j)("repo-sync",60023),sync:(0,i.$1j)("sync",60023),clone:(0,i.$1j)("clone",60024),desktopDownload:(0,i.$1j)("desktop-download",60024),beaker:(0,i.$1j)("beaker",60025),microscope:(0,i.$1j)("microscope",60025),vm:(0,i.$1j)("vm",60026),deviceDesktop:(0,i.$1j)("device-desktop",60026),file:(0,i.$1j)("file",60027),fileText:(0,i.$1j)("file-text",60027),more:(0,i.$1j)("more",60028),ellipsis:(0,i.$1j)("ellipsis",60028),kebabHorizontal:(0,i.$1j)("kebab-horizontal",60028),mailReply:(0,i.$1j)("mail-reply",60029),reply:(0,i.$1j)("reply",60029),organization:(0,i.$1j)("organization",60030),organizationFilled:(0,i.$1j)("organization-filled",60030),organizationOutline:(0,i.$1j)("organization-outline",60030),newFile:(0,i.$1j)("new-file",60031),fileAdd:(0,i.$1j)("file-add",60031),newFolder:(0,i.$1j)("new-folder",60032),fileDirectoryCreate:(0,i.$1j)("file-directory-create",60032),trash:(0,i.$1j)("trash",60033),trashcan:(0,i.$1j)("trashcan",60033),history:(0,i.$1j)("history",60034),clock:(0,i.$1j)("clock",60034),folder:(0,i.$1j)("folder",60035),fileDirectory:(0,i.$1j)("file-directory",60035),symbolFolder:(0,i.$1j)("symbol-folder",60035),logoGithub:(0,i.$1j)("logo-github",60036),markGithub:(0,i.$1j)("mark-github",60036),github:(0,i.$1j)("github",60036),terminal:(0,i.$1j)("terminal",60037),console:(0,i.$1j)("console",60037),repl:(0,i.$1j)("repl",60037),zap:(0,i.$1j)("zap",60038),symbolEvent:(0,i.$1j)("symbol-event",60038),error:(0,i.$1j)("error",60039),stop:(0,i.$1j)("stop",60039),variable:(0,i.$1j)("variable",60040),symbolVariable:(0,i.$1j)("symbol-variable",60040),array:(0,i.$1j)("array",60042),symbolArray:(0,i.$1j)("symbol-array",60042),symbolModule:(0,i.$1j)("symbol-module",60043),symbolPackage:(0,i.$1j)("symbol-package",60043),symbolNamespace:(0,i.$1j)("symbol-namespace",60043),symbolObject:(0,i.$1j)("symbol-object",60043),symbolMethod:(0,i.$1j)("symbol-method",60044),symbolFunction:(0,i.$1j)("symbol-function",60044),symbolConstructor:(0,i.$1j)("symbol-constructor",60044),symbolBoolean:(0,i.$1j)("symbol-boolean",60047),symbolNull:(0,i.$1j)("symbol-null",60047),symbolNumeric:(0,i.$1j)("symbol-numeric",60048),symbolNumber:(0,i.$1j)("symbol-number",60048),symbolStructure:(0,i.$1j)("symbol-structure",60049),symbolStruct:(0,i.$1j)("symbol-struct",60049),symbolParameter:(0,i.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,i.$1j)("symbol-type-parameter",60050),symbolKey:(0,i.$1j)("symbol-key",60051),symbolText:(0,i.$1j)("symbol-text",60051),symbolReference:(0,i.$1j)("symbol-reference",60052),goToFile:(0,i.$1j)("go-to-file",60052),symbolEnum:(0,i.$1j)("symbol-enum",60053),symbolValue:(0,i.$1j)("symbol-value",60053),symbolRuler:(0,i.$1j)("symbol-ruler",60054),symbolUnit:(0,i.$1j)("symbol-unit",60054),activateBreakpoints:(0,i.$1j)("activate-breakpoints",60055),archive:(0,i.$1j)("archive",60056),arrowBoth:(0,i.$1j)("arrow-both",60057),arrowDown:(0,i.$1j)("arrow-down",60058),arrowLeft:(0,i.$1j)("arrow-left",60059),arrowRight:(0,i.$1j)("arrow-right",60060),arrowSmallDown:(0,i.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,i.$1j)("arrow-small-left",60062),arrowSmallRight:(0,i.$1j)("arrow-small-right",60063),arrowSmallUp:(0,i.$1j)("arrow-small-up",60064),arrowUp:(0,i.$1j)("arrow-up",60065),bell:(0,i.$1j)("bell",60066),bold:(0,i.$1j)("bold",60067),book:(0,i.$1j)("book",60068),bookmark:(0,i.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$1j)("briefcase",60076),broadcast:(0,i.$1j)("broadcast",60077),browser:(0,i.$1j)("browser",60078),bug:(0,i.$1j)("bug",60079),calendar:(0,i.$1j)("calendar",60080),caseSensitive:(0,i.$1j)("case-sensitive",60081),check:(0,i.$1j)("check",60082),checklist:(0,i.$1j)("checklist",60083),chevronDown:(0,i.$1j)("chevron-down",60084),chevronLeft:(0,i.$1j)("chevron-left",60085),chevronRight:(0,i.$1j)("chevron-right",60086),chevronUp:(0,i.$1j)("chevron-up",60087),chromeClose:(0,i.$1j)("chrome-close",60088),chromeMaximize:(0,i.$1j)("chrome-maximize",60089),chromeMinimize:(0,i.$1j)("chrome-minimize",60090),chromeRestore:(0,i.$1j)("chrome-restore",60091),circleOutline:(0,i.$1j)("circle-outline",60092),circle:(0,i.$1j)("circle",60092),debugBreakpointUnverified:(0,i.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$1j)("circle-slash",60093),circuitBoard:(0,i.$1j)("circuit-board",60094),clearAll:(0,i.$1j)("clear-all",60095),clippy:(0,i.$1j)("clippy",60096),closeAll:(0,i.$1j)("close-all",60097),cloudDownload:(0,i.$1j)("cloud-download",60098),cloudUpload:(0,i.$1j)("cloud-upload",60099),code:(0,i.$1j)("code",60100),collapseAll:(0,i.$1j)("collapse-all",60101),colorMode:(0,i.$1j)("color-mode",60102),commentDiscussion:(0,i.$1j)("comment-discussion",60103),creditCard:(0,i.$1j)("credit-card",60105),dash:(0,i.$1j)("dash",60108),dashboard:(0,i.$1j)("dashboard",60109),database:(0,i.$1j)("database",60110),debugContinue:(0,i.$1j)("debug-continue",60111),debugDisconnect:(0,i.$1j)("debug-disconnect",60112),debugPause:(0,i.$1j)("debug-pause",60113),debugRestart:(0,i.$1j)("debug-restart",60114),debugStart:(0,i.$1j)("debug-start",60115),debugStepInto:(0,i.$1j)("debug-step-into",60116),debugStepOut:(0,i.$1j)("debug-step-out",60117),debugStepOver:(0,i.$1j)("debug-step-over",60118),debugStop:(0,i.$1j)("debug-stop",60119),debug:(0,i.$1j)("debug",60120),deviceCameraVideo:(0,i.$1j)("device-camera-video",60121),deviceCamera:(0,i.$1j)("device-camera",60122),deviceMobile:(0,i.$1j)("device-mobile",60123),diffAdded:(0,i.$1j)("diff-added",60124),diffIgnored:(0,i.$1j)("diff-ignored",60125),diffModified:(0,i.$1j)("diff-modified",60126),diffRemoved:(0,i.$1j)("diff-removed",60127),diffRenamed:(0,i.$1j)("diff-renamed",60128),diff:(0,i.$1j)("diff",60129),diffSidebyside:(0,i.$1j)("diff-sidebyside",60129),discard:(0,i.$1j)("discard",60130),editorLayout:(0,i.$1j)("editor-layout",60131),emptyWindow:(0,i.$1j)("empty-window",60132),exclude:(0,i.$1j)("exclude",60133),extensions:(0,i.$1j)("extensions",60134),eyeClosed:(0,i.$1j)("eye-closed",60135),fileBinary:(0,i.$1j)("file-binary",60136),fileCode:(0,i.$1j)("file-code",60137),fileMedia:(0,i.$1j)("file-media",60138),filePdf:(0,i.$1j)("file-pdf",60139),fileSubmodule:(0,i.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,i.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$1j)("file-symlink-file",60142),fileZip:(0,i.$1j)("file-zip",60143),files:(0,i.$1j)("files",60144),filter:(0,i.$1j)("filter",60145),flame:(0,i.$1j)("flame",60146),foldDown:(0,i.$1j)("fold-down",60147),foldUp:(0,i.$1j)("fold-up",60148),fold:(0,i.$1j)("fold",60149),folderActive:(0,i.$1j)("folder-active",60150),folderOpened:(0,i.$1j)("folder-opened",60151),gear:(0,i.$1j)("gear",60152),gift:(0,i.$1j)("gift",60153),gistSecret:(0,i.$1j)("gist-secret",60154),gist:(0,i.$1j)("gist",60155),gitCommit:(0,i.$1j)("git-commit",60156),gitCompare:(0,i.$1j)("git-compare",60157),compareChanges:(0,i.$1j)("compare-changes",60157),gitMerge:(0,i.$1j)("git-merge",60158),githubAction:(0,i.$1j)("github-action",60159),githubAlt:(0,i.$1j)("github-alt",60160),globe:(0,i.$1j)("globe",60161),grabber:(0,i.$1j)("grabber",60162),graph:(0,i.$1j)("graph",60163),gripper:(0,i.$1j)("gripper",60164),heart:(0,i.$1j)("heart",60165),home:(0,i.$1j)("home",60166),horizontalRule:(0,i.$1j)("horizontal-rule",60167),hubot:(0,i.$1j)("hubot",60168),inbox:(0,i.$1j)("inbox",60169),issueReopened:(0,i.$1j)("issue-reopened",60171),issues:(0,i.$1j)("issues",60172),italic:(0,i.$1j)("italic",60173),jersey:(0,i.$1j)("jersey",60174),json:(0,i.$1j)("json",60175),kebabVertical:(0,i.$1j)("kebab-vertical",60176),key:(0,i.$1j)("key",60177),law:(0,i.$1j)("law",60178),lightbulbAutofix:(0,i.$1j)("lightbulb-autofix",60179),linkExternal:(0,i.$1j)("link-external",60180),link:(0,i.$1j)("link",60181),listOrdered:(0,i.$1j)("list-ordered",60182),listUnordered:(0,i.$1j)("list-unordered",60183),liveShare:(0,i.$1j)("live-share",60184),loading:(0,i.$1j)("loading",60185),location:(0,i.$1j)("location",60186),mailRead:(0,i.$1j)("mail-read",60187),mail:(0,i.$1j)("mail",60188),markdown:(0,i.$1j)("markdown",60189),megaphone:(0,i.$1j)("megaphone",60190),mention:(0,i.$1j)("mention",60191),milestone:(0,i.$1j)("milestone",60192),gitPullRequestMilestone:(0,i.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,i.$1j)("mortar-board",60193),move:(0,i.$1j)("move",60194),multipleWindows:(0,i.$1j)("multiple-windows",60195),mute:(0,i.$1j)("mute",60196),noNewline:(0,i.$1j)("no-newline",60197),note:(0,i.$1j)("note",60198),octoface:(0,i.$1j)("octoface",60199),openPreview:(0,i.$1j)("open-preview",60200),package:(0,i.$1j)("package",60201),paintcan:(0,i.$1j)("paintcan",60202),pin:(0,i.$1j)("pin",60203),play:(0,i.$1j)("play",60204),run:(0,i.$1j)("run",60204),plug:(0,i.$1j)("plug",60205),preserveCase:(0,i.$1j)("preserve-case",60206),preview:(0,i.$1j)("preview",60207),project:(0,i.$1j)("project",60208),pulse:(0,i.$1j)("pulse",60209),question:(0,i.$1j)("question",60210),quote:(0,i.$1j)("quote",60211),radioTower:(0,i.$1j)("radio-tower",60212),reactions:(0,i.$1j)("reactions",60213),references:(0,i.$1j)("references",60214),refresh:(0,i.$1j)("refresh",60215),regex:(0,i.$1j)("regex",60216),remoteExplorer:(0,i.$1j)("remote-explorer",60217),remote:(0,i.$1j)("remote",60218),remove:(0,i.$1j)("remove",60219),replaceAll:(0,i.$1j)("replace-all",60220),replace:(0,i.$1j)("replace",60221),repoClone:(0,i.$1j)("repo-clone",60222),repoForcePush:(0,i.$1j)("repo-force-push",60223),repoPull:(0,i.$1j)("repo-pull",60224),repoPush:(0,i.$1j)("repo-push",60225),report:(0,i.$1j)("report",60226),requestChanges:(0,i.$1j)("request-changes",60227),rocket:(0,i.$1j)("rocket",60228),rootFolderOpened:(0,i.$1j)("root-folder-opened",60229),rootFolder:(0,i.$1j)("root-folder",60230),rss:(0,i.$1j)("rss",60231),ruby:(0,i.$1j)("ruby",60232),saveAll:(0,i.$1j)("save-all",60233),saveAs:(0,i.$1j)("save-as",60234),save:(0,i.$1j)("save",60235),screenFull:(0,i.$1j)("screen-full",60236),screenNormal:(0,i.$1j)("screen-normal",60237),searchStop:(0,i.$1j)("search-stop",60238),server:(0,i.$1j)("server",60240),settingsGear:(0,i.$1j)("settings-gear",60241),settings:(0,i.$1j)("settings",60242),shield:(0,i.$1j)("shield",60243),smiley:(0,i.$1j)("smiley",60244),sortPrecedence:(0,i.$1j)("sort-precedence",60245),splitHorizontal:(0,i.$1j)("split-horizontal",60246),splitVertical:(0,i.$1j)("split-vertical",60247),squirrel:(0,i.$1j)("squirrel",60248),starFull:(0,i.$1j)("star-full",60249),starHalf:(0,i.$1j)("star-half",60250),symbolClass:(0,i.$1j)("symbol-class",60251),symbolColor:(0,i.$1j)("symbol-color",60252),symbolConstant:(0,i.$1j)("symbol-constant",60253),symbolEnumMember:(0,i.$1j)("symbol-enum-member",60254),symbolField:(0,i.$1j)("symbol-field",60255),symbolFile:(0,i.$1j)("symbol-file",60256),symbolInterface:(0,i.$1j)("symbol-interface",60257),symbolKeyword:(0,i.$1j)("symbol-keyword",60258),symbolMisc:(0,i.$1j)("symbol-misc",60259),symbolOperator:(0,i.$1j)("symbol-operator",60260),symbolProperty:(0,i.$1j)("symbol-property",60261),wrench:(0,i.$1j)("wrench",60261),wrenchSubaction:(0,i.$1j)("wrench-subaction",60261),symbolSnippet:(0,i.$1j)("symbol-snippet",60262),tasklist:(0,i.$1j)("tasklist",60263),telescope:(0,i.$1j)("telescope",60264),textSize:(0,i.$1j)("text-size",60265),threeBars:(0,i.$1j)("three-bars",60266),thumbsdown:(0,i.$1j)("thumbsdown",60267),thumbsup:(0,i.$1j)("thumbsup",60268),tools:(0,i.$1j)("tools",60269),triangleDown:(0,i.$1j)("triangle-down",60270),triangleLeft:(0,i.$1j)("triangle-left",60271),triangleRight:(0,i.$1j)("triangle-right",60272),triangleUp:(0,i.$1j)("triangle-up",60273),twitter:(0,i.$1j)("twitter",60274),unfold:(0,i.$1j)("unfold",60275),unlock:(0,i.$1j)("unlock",60276),unmute:(0,i.$1j)("unmute",60277),unverified:(0,i.$1j)("unverified",60278),verified:(0,i.$1j)("verified",60279),versions:(0,i.$1j)("versions",60280),vmActive:(0,i.$1j)("vm-active",60281),vmOutline:(0,i.$1j)("vm-outline",60282),vmRunning:(0,i.$1j)("vm-running",60283),watch:(0,i.$1j)("watch",60284),whitespace:(0,i.$1j)("whitespace",60285),wholeWord:(0,i.$1j)("whole-word",60286),window:(0,i.$1j)("window",60287),wordWrap:(0,i.$1j)("word-wrap",60288),zoomIn:(0,i.$1j)("zoom-in",60289),zoomOut:(0,i.$1j)("zoom-out",60290),listFilter:(0,i.$1j)("list-filter",60291),listFlat:(0,i.$1j)("list-flat",60292),listSelection:(0,i.$1j)("list-selection",60293),selection:(0,i.$1j)("selection",60293),listTree:(0,i.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$1j)("circle-small-filled",60298),debugStackframeDot:(0,i.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,i.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,i.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$1j)("symbol-string",60301),debugReverseContinue:(0,i.$1j)("debug-reverse-continue",60302),debugStepBack:(0,i.$1j)("debug-step-back",60303),debugRestartFrame:(0,i.$1j)("debug-restart-frame",60304),debugAlt:(0,i.$1j)("debug-alt",60305),callIncoming:(0,i.$1j)("call-incoming",60306),callOutgoing:(0,i.$1j)("call-outgoing",60307),menu:(0,i.$1j)("menu",60308),expandAll:(0,i.$1j)("expand-all",60309),feedback:(0,i.$1j)("feedback",60310),gitPullRequestReviewer:(0,i.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,i.$1j)("ungroup-by-ref-type",60312),account:(0,i.$1j)("account",60313),gitPullRequestAssignee:(0,i.$1j)("git-pull-request-assignee",60313),bellDot:(0,i.$1j)("bell-dot",60314),debugConsole:(0,i.$1j)("debug-console",60315),library:(0,i.$1j)("library",60316),output:(0,i.$1j)("output",60317),runAll:(0,i.$1j)("run-all",60318),syncIgnored:(0,i.$1j)("sync-ignored",60319),pinned:(0,i.$1j)("pinned",60320),githubInverted:(0,i.$1j)("github-inverted",60321),serverProcess:(0,i.$1j)("server-process",60322),serverEnvironment:(0,i.$1j)("server-environment",60323),pass:(0,i.$1j)("pass",60324),issueClosed:(0,i.$1j)("issue-closed",60324),stopCircle:(0,i.$1j)("stop-circle",60325),playCircle:(0,i.$1j)("play-circle",60326),record:(0,i.$1j)("record",60327),debugAltSmall:(0,i.$1j)("debug-alt-small",60328),vmConnect:(0,i.$1j)("vm-connect",60329),cloud:(0,i.$1j)("cloud",60330),merge:(0,i.$1j)("merge",60331),export:(0,i.$1j)("export",60332),graphLeft:(0,i.$1j)("graph-left",60333),magnet:(0,i.$1j)("magnet",60334),notebook:(0,i.$1j)("notebook",60335),redo:(0,i.$1j)("redo",60336),checkAll:(0,i.$1j)("check-all",60337),pinnedDirty:(0,i.$1j)("pinned-dirty",60338),passFilled:(0,i.$1j)("pass-filled",60339),circleLargeFilled:(0,i.$1j)("circle-large-filled",60340),circleLarge:(0,i.$1j)("circle-large",60341),circleLargeOutline:(0,i.$1j)("circle-large-outline",60341),combine:(0,i.$1j)("combine",60342),gather:(0,i.$1j)("gather",60342),table:(0,i.$1j)("table",60343),variableGroup:(0,i.$1j)("variable-group",60344),typeHierarchy:(0,i.$1j)("type-hierarchy",60345),typeHierarchySub:(0,i.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$1j)("git-pull-request-create",60348),runAbove:(0,i.$1j)("run-above",60349),runBelow:(0,i.$1j)("run-below",60350),notebookTemplate:(0,i.$1j)("notebook-template",60351),debugRerun:(0,i.$1j)("debug-rerun",60352),workspaceTrusted:(0,i.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,i.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,i.$1j)("workspace-unknown",60355),terminalCmd:(0,i.$1j)("terminal-cmd",60356),terminalDebian:(0,i.$1j)("terminal-debian",60357),terminalLinux:(0,i.$1j)("terminal-linux",60358),terminalPowershell:(0,i.$1j)("terminal-powershell",60359),terminalTmux:(0,i.$1j)("terminal-tmux",60360),terminalUbuntu:(0,i.$1j)("terminal-ubuntu",60361),terminalBash:(0,i.$1j)("terminal-bash",60362),arrowSwap:(0,i.$1j)("arrow-swap",60363),copy:(0,i.$1j)("copy",60364),personAdd:(0,i.$1j)("person-add",60365),filterFilled:(0,i.$1j)("filter-filled",60366),wand:(0,i.$1j)("wand",60367),debugLineByLine:(0,i.$1j)("debug-line-by-line",60368),inspect:(0,i.$1j)("inspect",60369),layers:(0,i.$1j)("layers",60370),layersDot:(0,i.$1j)("layers-dot",60371),layersActive:(0,i.$1j)("layers-active",60372),compass:(0,i.$1j)("compass",60373),compassDot:(0,i.$1j)("compass-dot",60374),compassActive:(0,i.$1j)("compass-active",60375),azure:(0,i.$1j)("azure",60376),issueDraft:(0,i.$1j)("issue-draft",60377),gitPullRequestClosed:(0,i.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$1j)("git-pull-request-draft",60379),debugAll:(0,i.$1j)("debug-all",60380),debugCoverage:(0,i.$1j)("debug-coverage",60381),runErrors:(0,i.$1j)("run-errors",60382),folderLibrary:(0,i.$1j)("folder-library",60383),debugContinueSmall:(0,i.$1j)("debug-continue-small",60384),beakerStop:(0,i.$1j)("beaker-stop",60385),graphLine:(0,i.$1j)("graph-line",60386),graphScatter:(0,i.$1j)("graph-scatter",60387),pieChart:(0,i.$1j)("pie-chart",60388),bracket:(0,i.$1j)("bracket",60175),bracketDot:(0,i.$1j)("bracket-dot",60389),bracketError:(0,i.$1j)("bracket-error",60390),lockSmall:(0,i.$1j)("lock-small",60391),azureDevops:(0,i.$1j)("azure-devops",60392),verifiedFilled:(0,i.$1j)("verified-filled",60393),newline:(0,i.$1j)("newline",60394),layout:(0,i.$1j)("layout",60395),layoutActivitybarLeft:(0,i.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,i.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,i.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,i.$1j)("layout-panel-right",60401),layoutPanel:(0,i.$1j)("layout-panel",60402),layoutSidebarLeft:(0,i.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$1j)("layout-statusbar",60405),layoutMenubar:(0,i.$1j)("layout-menubar",60406),layoutCentered:(0,i.$1j)("layout-centered",60407),target:(0,i.$1j)("target",60408),indent:(0,i.$1j)("indent",60409),recordSmall:(0,i.$1j)("record-small",60410),errorSmall:(0,i.$1j)("error-small",60411),terminalDecorationError:(0,i.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,i.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,i.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$1j)("layout-sidebar-left-off",60418),blank:(0,i.$1j)("blank",60419),heartFilled:(0,i.$1j)("heart-filled",60420),map:(0,i.$1j)("map",60421),mapHorizontal:(0,i.$1j)("map-horizontal",60421),foldHorizontal:(0,i.$1j)("fold-horizontal",60421),mapFilled:(0,i.$1j)("map-filled",60422),mapHorizontalFilled:(0,i.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$1j)("fold-horizontal-filled",60422),circleSmall:(0,i.$1j)("circle-small",60423),bellSlash:(0,i.$1j)("bell-slash",60424),bellSlashDot:(0,i.$1j)("bell-slash-dot",60425),commentUnresolved:(0,i.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$1j)("search-fuzzy",60429),commentDraft:(0,i.$1j)("comment-draft",60430),send:(0,i.$1j)("send",60431),sparkle:(0,i.$1j)("sparkle",60432),insert:(0,i.$1j)("insert",60433),mic:(0,i.$1j)("mic",60434),thumbsdownFilled:(0,i.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$1j)("thumbsup-filled",60436),coffee:(0,i.$1j)("coffee",60437),snake:(0,i.$1j)("snake",60438),game:(0,i.$1j)("game",60439),vr:(0,i.$1j)("vr",60440),chip:(0,i.$1j)("chip",60441),piano:(0,i.$1j)("piano",60442),music:(0,i.$1j)("music",60443),micFilled:(0,i.$1j)("mic-filled",60444),repoFetch:(0,i.$1j)("repo-fetch",60445),copilot:(0,i.$1j)("copilot",60446),lightbulbSparkle:(0,i.$1j)("lightbulb-sparkle",60447),robot:(0,i.$1j)("robot",60448),sparkleFilled:(0,i.$1j)("sparkle-filled",60449),diffSingle:(0,i.$1j)("diff-single",60450),diffMultiple:(0,i.$1j)("diff-multiple",60451),surroundWith:(0,i.$1j)("surround-with",60452),share:(0,i.$1j)("share",60453),gitStash:(0,i.$1j)("git-stash",60454),gitStashApply:(0,i.$1j)("git-stash-apply",60455),gitStashPop:(0,i.$1j)("git-stash-pop",60456),vscode:(0,i.$1j)("vscode",60457),vscodeInsiders:(0,i.$1j)("vscode-insiders",60458),codeOss:(0,i.$1j)("code-oss",60459),runCoverage:(0,i.$1j)("run-coverage",60460),runAllCoverage:(0,i.$1j)("run-all-coverage",60461),coverage:(0,i.$1j)("coverage",60462),githubProject:(0,i.$1j)("github-project",60463),mapVertical:(0,i.$1j)("map-vertical",60464),foldVertical:(0,i.$1j)("fold-vertical",60464),mapVerticalFilled:(0,i.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$1j)("fold-vertical-filled",60465),goToSearch:(0,i.$1j)("go-to-search",60466),percentage:(0,i.$1j)("percentage",60467),sortPercentage:(0,i.$1j)("sort-percentage",60467),attach:(0,i.$1j)("attach",60468)}}),define(pe[21],we([1,0,48,107]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6j=t.$5j=void 0,t.$4j=P;function P(){return Object.values(t.$6j)}t.$5j={dialogError:(0,i.$1j)("dialog-error","error"),dialogWarning:(0,i.$1j)("dialog-warning","warning"),dialogInfo:(0,i.$1j)("dialog-info","info"),dialogClose:(0,i.$1j)("dialog-close","close"),treeItemExpanded:(0,i.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$1j)("tree-filter-clear","close"),treeItemLoading:(0,i.$1j)("tree-item-loading","loading"),menuSelection:(0,i.$1j)("menu-selection","check"),menuSubmenu:(0,i.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,i.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,i.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$1j)("toolbar-more","more"),quickInputBack:(0,i.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,i.$1j)("drop-down-button",60084),symbolCustomColor:(0,i.$1j)("symbol-customcolor",60252),exportIcon:(0,i.$1j)("export",60332),workspaceUnspecified:(0,i.$1j)("workspace-unspecified",60355),newLine:(0,i.$1j)("newline",60394),thumbsDownFilled:(0,i.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$1j)("thumbsup-filled",60436),gitFetch:(0,i.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$1j)("debug-breakpoint-pending",60377)},t.$6j={...n.$3j,...t.$5j}}),define(pe[64],we([1,0,10]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fo=n,t.$go=P,t.$ho=N,t.$io=D,t.$jo=f,t.$ko=p,t.$lo=y,t.$mo=$,t.$no=m,t.$oo=e,t.$po=s,t.$qo=r,t.$ro=h;function n(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const v=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([T,S])=>{v[T]=S&&typeof S=="object"?n(S):S}),v}function P(a){if(!a||typeof a!="object")return a;const v=[a];for(;v.length>0;){const T=v.shift();Object.freeze(T);for(const S in T)if(F.call(T,S)){const d=T[S];typeof d=="object"&&!Object.isFrozen(d)&&!(0,i.$ig)(d)&&v.push(d)}}return a}const F=Object.prototype.hasOwnProperty;function N(a,v){return w(a,v,new Set)}function w(a,v,T){if((0,i.$og)(a))return a;const S=v(a);if(typeof S<"u")return S;if(Array.isArray(a)){const d=[];for(const c of a)d.push(w(c,v,T));return d}if((0,i.$hg)(a)){if(T.has(a))throw new Error("Cannot clone recursive data-structure");T.add(a);const d={};for(const c in a)F.call(a,c)&&(d[c]=w(a[c],v,T));return T.delete(a),d}return a}function D(a,v,T=!0){return(0,i.$hg)(a)?((0,i.$hg)(v)&&Object.keys(v).forEach(S=>{S in a?T&&((0,i.$hg)(a[S])&&(0,i.$hg)(v[S])?D(a[S],v[S],T):a[S]=v[S]):a[S]=v[S]}),a):v}function f(a,v){if(a===v)return!0;if(a==null||v===null||v===void 0||typeof a!=typeof v||typeof a!="object"||Array.isArray(a)!==Array.isArray(v))return!1;let T,S;if(Array.isArray(a)){if(a.length!==v.length)return!1;for(T=0;T<a.length;T++)if(!f(a[T],v[T]))return!1}else{const d=[];for(S in a)d.push(S);d.sort();const c=[];for(S in v)c.push(S);if(c.sort(),!f(d,c))return!1;for(T=0;T<d.length;T++)if(!f(a[d[T]],v[d[T]]))return!1}return!0}function p(a){const v=new Set;return JSON.stringify(a,(T,S)=>{if((0,i.$hg)(S)||Array.isArray(S)){if(v.has(S))return"[Circular]";v.add(S)}return typeof S=="bigint"?`[BigInt ${S.toString()}]`:S})}function y(a,v){const T=Object.create(null);return!a||!v||Object.keys(v).forEach(d=>{const c=a[d],b=v[d];f(c,b)||(T[d]=b)}),T}function $(a,v){const T=v.toLowerCase(),S=Object.keys(a).find(d=>d.toLowerCase()===T);return S?a[S]:a[v]}function m(a,v){const T=Object.create(null);for(const[S,d]of Object.entries(a))v(S,d)&&(T[S]=d);return T}function e(a){let v=[];for(;Object.prototype!==a;)v=v.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return v}function s(a){const v=[];for(const T of e(a))typeof a[T]=="function"&&v.push(T);return v}function r(a,v){const T=d=>function(){const c=Array.prototype.slice.call(arguments,0);return v(d,c)},S={};for(const d of a)S[d]=T(d);return S}function h(a,v){const T={};for(const[S,d]of Object.entries(a))T[S]=v(d,S);return T}}),define(pe[22],we([1,0,21]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$7j=P;var n;(function(N){function w(D){return D&&typeof D=="object"&&typeof D.id=="string"}N.isThemeColor=w})(n||(t.ThemeColor=n={}));function P(N){return{id:N}}var F;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function D(a){const v=w.exec(a.id);if(!v)return D(i.$6j.error);const[,T,S]=v,d=["codicon","codicon-"+T];return S&&d.push("codicon-modifier-"+S.substring(1)),d}N.asClassNameArray=D;function f(a){return D(a).join(" ")}N.asClassName=f;function p(a){return"."+D(a).join(".")}N.asCSSSelector=p;function y(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||n.isThemeColor(a.color))}N.isThemeIcon=y;const $=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function m(a){const v=$.exec(a);if(!v)return;const[,T]=v;return{id:T}}N.fromString=m;function e(a){return{id:a}}N.fromId=e;function s(a,v){let T=a.id;const S=T.lastIndexOf("~");return S!==-1&&(T=T.substring(0,S)),v&&(T=`${T}~${v}`),{id:T}}N.modify=s;function r(a){const v=a.id.lastIndexOf("~");if(v!==-1)return a.id.substring(v+1)}N.getModifier=r;function h(a,v){return a.id===v.id&&a.color?.id===v.color?.id}N.isEqual=h})(F||(t.ThemeIcon=F={}))}),define(pe[65],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$bf=n,t.$cf=P;var i;(function(F){F[F.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",F[F.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",F[F.MAX_UINT_8=255]="MAX_UINT_8",F[F.MAX_UINT_16=65535]="MAX_UINT_16",F[F.MAX_UINT_32=4294967295]="MAX_UINT_32",F[F.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function n(F){return F<0?0:F>i.MAX_UINT_8?i.MAX_UINT_8:F|0}function P(F){return F<0?0:F>i.MAX_UINT_32?i.MAX_UINT_32:F|0}}),define(pe[11],we([1,0,103,17,25,65]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eg=t.$dg=t.$cg=t.GraphemeBreakType=t.$5f=t.$Wf=t.$Pf=t.$Of=void 0,t.$df=N,t.$ef=D,t.$ff=p,t.$gf=y,t.$hf=$,t.$if=m,t.$jf=e,t.$kf=s,t.$lf=r,t.$mf=h,t.$nf=a,t.$of=v,t.$pf=T,t.$qf=S,t.$rf=d,t.$sf=c,t.$tf=b,t.$uf=A,t.$vf=V,t.$wf=U,t.$xf=C,t.$yf=E,t.$zf=O,t.$Af=x,t.$Bf=I,t.$Cf=_,t.$Df=q,t.$Ef=J,t.$Ff=G,t.$Gf=K,t.$Hf=Q,t.$If=ae,t.$Jf=me,t.$Kf=ye,t.$Lf=Le,t.$Mf=ne,t.$Nf=ee,t.$Qf=te,t.$Rf=be,t.$Sf=Ae,t.$Tf=Re,t.$Uf=_e,t.$Vf=j,t.$Xf=l,t.$Yf=o,t.$Zf=g,t.$1f=M,t.$2f=u,t.$3f=L,t.$4f=B,t.$6f=H,t.$7f=Y,t.$8f=ie,t.$9f=re,t.$0f=he,t.$$f=De,t.$_f=ve,t.$ag=Ee,t.$bg=Xe;function N(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}const w=/{(\d+)}/g;function D(Z,...ue){return ue.length===0?Z:Z.replace(w,function($e,Se){const Pe=parseInt(Se,10);return isNaN(Pe)||Pe<0||Pe>=ue.length?$e:ue[Pe]})}const f=/{([^}]+)}/g;function p(Z,ue){return Object.keys(ue).length===0?Z:Z.replace(f,($e,Se)=>ue[Se]??$e)}function y(Z){return Z.replace(/[<>"'&]/g,ue=>{switch(ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ue})}function $(Z){return Z.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}function m(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(Z,ue){let $e=0,Se=Z.indexOf(ue);for(;Se!==-1;)$e++,Se=Z.indexOf(ue,Se+ue.length);return $e}function s(Z,ue,$e="\u2026"){return Z.length<=ue?Z:`${Z.substr(0,ue)}${$e}`}function r(Z,ue,$e="\u2026"){if(Z.length<=ue)return Z;const Se=Math.ceil(ue/2)-$e.length/2,Pe=Math.floor(ue/2)-$e.length/2;return`${Z.substr(0,Se)}${$e}${Z.substr(Z.length-Pe)}`}function h(Z,ue=" "){const $e=a(Z,ue);return v($e,ue)}function a(Z,ue){if(!Z||!ue)return Z;const $e=ue.length;if($e===0||Z.length===0)return Z;let Se=0;for(;Z.indexOf(ue,Se)===Se;)Se=Se+$e;return Z.substring(Se)}function v(Z,ue){if(!Z||!ue)return Z;const $e=ue.length,Se=Z.length;if($e===0||Se===0)return Z;let Pe=Se,Ve=-1;for(;Ve=Z.lastIndexOf(ue,Pe-1),!(Ve===-1||Ve+$e!==Pe);){if(Ve===0)return"";Pe=Ve}return Z.substring(0,Pe)}function T(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function S(Z){return Z.replace(/\*/g,"")}function d(Z,ue,$e={}){if(!Z)throw new Error("Cannot create regex from empty string");ue||(Z=m(Z)),$e.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let Se="";return $e.global&&(Se+="g"),$e.matchCase||(Se+="i"),$e.multiline&&(Se+="m"),$e.unicode&&(Se+="u"),new RegExp(Z,Se)}function c(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}function b(Z){return Z.split(/\r\n|\r|\n/)}function A(Z){const ue=[],$e=Z.split(/(\r\n|\r|\n)/);for(let Se=0;Se<Math.ceil($e.length/2);Se++)ue.push($e[2*Se]+($e[2*Se+1]??""));return ue}function V(Z){for(let ue=0,$e=Z.length;ue<$e;ue++){const Se=Z.charCodeAt(ue);if(Se!==n.CharCode.Space&&Se!==n.CharCode.Tab)return ue}return-1}function U(Z,ue=0,$e=Z.length){for(let Se=ue;Se<$e;Se++){const Pe=Z.charCodeAt(Se);if(Pe!==n.CharCode.Space&&Pe!==n.CharCode.Tab)return Z.substring(ue,Se)}return Z.substring(ue,$e)}function C(Z,ue=Z.length-1){for(let $e=ue;$e>=0;$e--){const Se=Z.charCodeAt($e);if(Se!==n.CharCode.Space&&Se!==n.CharCode.Tab)return $e}return-1}function E(Z,ue,$e){const Se=[];let Pe=0;for(const Ve of Z.matchAll(ue)){if(Se.push(Z.slice(Pe,Ve.index)),Ve.index===void 0)throw new Error("match.index should be defined");Pe=Ve.index+Ve[0].length,Se.push($e(Ve[0],...Ve.slice(1),Ve.index,Z,Ve.groups))}return Se.push(Z.slice(Pe)),Promise.all(Se).then(Ve=>Ve.join(""))}function O(Z,ue){return Z<ue?-1:Z>ue?1:0}function x(Z,ue,$e=0,Se=Z.length,Pe=0,Ve=ue.length){for(;$e<Se&&Pe<Ve;$e++,Pe++){const it=Z.charCodeAt($e),ct=ue.charCodeAt(Pe);if(it<ct)return-1;if(it>ct)return 1}const Je=Se-$e,rt=Ve-Pe;return Je<rt?-1:Je>rt?1:0}function I(Z,ue){return _(Z,ue,0,Z.length,0,ue.length)}function _(Z,ue,$e=0,Se=Z.length,Pe=0,Ve=ue.length){for(;$e<Se&&Pe<Ve;$e++,Pe++){let it=Z.charCodeAt($e),ct=ue.charCodeAt(Pe);if(it===ct)continue;if(it>=128||ct>=128)return x(Z.toLowerCase(),ue.toLowerCase(),$e,Se,Pe,Ve);J(it)&&(it-=32),J(ct)&&(ct-=32);const nt=it-ct;if(nt!==0)return nt}const Je=Se-$e,rt=Ve-Pe;return Je<rt?-1:Je>rt?1:0}function q(Z){return Z>=n.CharCode.Digit0&&Z<=n.CharCode.Digit9}function J(Z){return Z>=n.CharCode.a&&Z<=n.CharCode.z}function G(Z){return Z>=n.CharCode.A&&Z<=n.CharCode.Z}function K(Z,ue){return Z.length===ue.length&&_(Z,ue)===0}function Q(Z,ue){const $e=ue.length;return ue.length>Z.length?!1:_(Z,ue,0,$e)===0}function ae(Z,ue){const $e=Math.min(Z.length,ue.length);let Se;for(Se=0;Se<$e;Se++)if(Z.charCodeAt(Se)!==ue.charCodeAt(Se))return Se;return $e}function me(Z,ue){const $e=Math.min(Z.length,ue.length);let Se;const Pe=Z.length-1,Ve=ue.length-1;for(Se=0;Se<$e;Se++)if(Z.charCodeAt(Pe-Se)!==ue.charCodeAt(Ve-Se))return Se;return $e}function ye(Z){return 55296<=Z&&Z<=56319}function Le(Z){return 56320<=Z&&Z<=57343}function ne(Z,ue){return(Z-55296<<10)+(ue-56320)+65536}function ee(Z,ue,$e){const Se=Z.charCodeAt($e);if(ye(Se)&&$e+1<ue){const Pe=Z.charCodeAt($e+1);if(Le(Pe))return ne(Se,Pe)}return Se}function ce(Z,ue){const $e=Z.charCodeAt(ue-1);if(Le($e)&&ue>1){const Se=Z.charCodeAt(ue-2);if(ye(Se))return ne(Se,$e)}return $e}class le{get offset(){return this.e}constructor(ue,$e=0){this.c=ue,this.d=ue.length,this.e=$e}setOffset(ue){this.e=ue}prevCodePoint(){const ue=ce(this.c,this.e);return this.e-=ue>=F.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ue}nextCodePoint(){const ue=ee(this.c,this.d,this.e);return this.e+=ue>=F.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ue}eol(){return this.e>=this.d}}t.$Of=le;class ke{get offset(){return this.c.offset}constructor(ue,$e=0){this.c=new le(ue,$e)}nextGraphemeLength(){const ue=Fe.getInstance(),$e=this.c,Se=$e.offset;let Pe=ue.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ve=$e.offset,Je=ue.getGraphemeBreakType($e.nextCodePoint());if(Ne(Pe,Je)){$e.setOffset(Ve);break}Pe=Je}return $e.offset-Se}prevGraphemeLength(){const ue=Fe.getInstance(),$e=this.c,Se=$e.offset;let Pe=ue.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ve=$e.offset,Je=ue.getGraphemeBreakType($e.prevCodePoint());if(Ne(Je,Pe)){$e.setOffset(Ve);break}Pe=Je}return Se-$e.offset}eol(){return this.c.eol()}}t.$Pf=ke;function te(Z,ue){return new ke(Z,ue).nextGraphemeLength()}function be(Z,ue){return new ke(Z,ue).prevGraphemeLength()}function Ae(Z,ue){ue>0&&Le(Z.charCodeAt(ue))&&ue--;const $e=ue+te(Z,ue);return[$e-be(Z,$e),$e]}function Re(Z){const ue=new ke(Z);let $e=0;for(;!ue.eol();)$e++,ue.nextGraphemeLength();return $e}let Ie;function je(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _e(Z){return Ie||(Ie=je()),Ie.test(Z)}const W=/^[\t\n\r\x20-\x7E]*$/;function j(Z){return W.test(Z)}t.$Wf=/[\u2028\u2029]/;function l(Z){return t.$Wf.test(Z)}function o(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}function g(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}function M(Z,ue,$e=""){const Se=Z.trimStart();if(Se.length<ue)return Se;const Pe=/\b/g;let Ve=0;for(;Pe.test(Se)&&!(Se.length-Pe.lastIndex<ue);)Ve=Pe.lastIndex,Pe.lastIndex+=1;return Ve===0?Se:$e+Se.substring(Ve).trimStart()}const k=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*u(Z){let ue=0;for(const $e of Z.matchAll(k))ue!==$e.index&&(yield{isCode:!1,str:Z.substring(ue,$e.index)}),yield{isCode:!0,str:$e[0]},ue=$e.index+$e[0].length;ue!==Z.length&&(yield{isCode:!1,str:Z.substring(ue)})}function L(Z){return Z&&(Z=Z.replace(k,"")),Z}const R=/\\\[.*?\\\]/g;function B(Z){return L(Z).replace(R,"")}t.$5f=String.fromCharCode(n.CharCode.UTF8_BOM);function H(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===n.CharCode.UTF8_BOM)}function Y(Z){return H(Z)?Z.substr(1):Z}function ie(Z,ue){if(!Z||!ue||Z.length<ue.length)return!1;const $e=ue.length,Se=Z.toLowerCase();let Pe=0,Ve=-1;for(;Pe<$e;){const Je=Se.indexOf(ue[Pe],Ve+1);if(Je<0)return!1;Ve=Je,Pe++}return!0}function re(Z,ue=!1){return Z?(ue&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}function he(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}function De(Z,ue=1){if(ue===0)return"";let $e=-1;do $e=Z.indexOf(`
`,$e+1),ue--;while(ue>0&&$e>=0);return $e===-1?Z:(Z[$e-1]==="\r"&&$e--,Z.substr(0,$e))}function ve(Z){const ue=n.CharCode.Z-n.CharCode.A+1;return Z=Z%(2*ue),Z<ue?String.fromCharCode(n.CharCode.a+Z):String.fromCharCode(n.CharCode.A+Z-ue)}function Ee(Z){return Fe.getInstance().getGraphemeBreakType(Z)}function Ne(Z,ue){return Z===fe.Other?ue!==fe.Extend&&ue!==fe.SpacingMark:Z===fe.CR&&ue===fe.LF?!1:Z===fe.Control||Z===fe.CR||Z===fe.LF||ue===fe.Control||ue===fe.CR||ue===fe.LF?!0:!(Z===fe.L&&(ue===fe.L||ue===fe.V||ue===fe.LV||ue===fe.LVT)||(Z===fe.LV||Z===fe.V)&&(ue===fe.V||ue===fe.T)||(Z===fe.LVT||Z===fe.T)&&ue===fe.T||ue===fe.Extend||ue===fe.ZWJ||ue===fe.SpacingMark||Z===fe.Prepend||Z===fe.ZWJ&&ue===fe.Extended_Pictographic||Z===fe.Regional_Indicator&&ue===fe.Regional_Indicator)}var fe;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(fe||(t.GraphemeBreakType=fe={}));class Fe{static{this.c=null}static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=Ke()}getGraphemeBreakType(ue){if(ue<32)return ue===n.CharCode.LineFeed?fe.LF:ue===n.CharCode.CarriageReturn?fe.CR:fe.Control;if(ue<127)return fe.Other;const $e=this.d,Se=$e.length/3;let Pe=1;for(;Pe<=Se;)if(ue<$e[3*Pe])Pe=2*Pe;else if(ue>$e[3*Pe+1])Pe=2*Pe+1;else return $e[3*Pe+2];return fe.Other}}function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Xe(Z,ue){if(Z===0)return 0;const $e=tt(Z,ue);if($e!==void 0)return $e;const Se=new le(ue,Z);return Se.prevCodePoint(),Se.offset}function tt(Z,ue){const $e=new le(ue,Z);let Se=$e.prevCodePoint();for(;lt(Se)||Se===st.emojiVariantSelector||Se===st.enclosingKeyCap;){if($e.offset===0)return;Se=$e.prevCodePoint()}if(!g(Se))return;let Pe=$e.offset;return Pe>0&&$e.prevCodePoint()===st.zwj&&(Pe=$e.offset),Pe}function lt(Z){return 127995<=Z&&Z<=127999}var st;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),t.$cg="\xA0";class Ge{static{this.c=new P.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$_e({getCacheKey:JSON.stringify},ue=>{function $e(nt){const dt=new Map;for(let ft=0;ft<nt.length;ft+=2)dt.set(nt[ft],nt[ft+1]);return dt}function Se(nt,dt){const ft=new Map(nt);for(const[wt,Ue]of dt)ft.set(wt,Ue);return ft}function Pe(nt,dt){if(!nt)return dt;const ft=new Map;for(const[wt,Ue]of nt)dt.has(wt)&&ft.set(wt,Ue);return ft}const Ve=this.c.value;let Je=ue.filter(nt=>!nt.startsWith("_")&&nt in Ve);Je.length===0&&(Je=["_default"]);let rt;for(const nt of Je){const dt=$e(Ve[nt]);rt=Pe(rt,dt)}const it=$e(Ve._common),ct=Se(it,rt);return new Ge(ct)})}static getInstance(ue){return Ge.d.get(Array.from(ue))}static{this.e=new P.$U(()=>Object.keys(Ge.c.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return Ge.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}containsAmbiguousCharacter(ue){for(let $e=0;$e<ue.length;$e++){const Se=ue.codePointAt($e);if(typeof Se=="number"&&this.isAmbiguous(Se))return!0}return!1}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$dg=Ge;class Ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ze.c())),this.d}static isInvisibleCharacter(ue){return Ze.e().has(ue)}static containsInvisibleCharacter(ue){for(let $e=0;$e<ue.length;$e++){const Se=ue.codePointAt($e);if(typeof Se=="number"&&Ze.isInvisibleCharacter(Se))return!0}return!1}static get codePoints(){return Ze.e()}}t.$eg=Ze}),define(pe[108],we([1,0,17,28,5,11,10]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yg=w,t.$zg=D,t.$Ag=f,t.$Bg=p,t.$Cg=y,t.$Dg=s,t.$Eg=r,t.$Fg=h,t.$Gg=a,t.$Hg=v,t.$Ig=T,t.$Jg=S,t.$Kg=d,t.$Lg=c,t.$Mg=b,t.$Ng=A,t.$Og=C;function w(E){return E===i.CharCode.Slash||E===i.CharCode.Backslash}function D(E){return E.replace(/[\\/]/g,n.$hc.sep)}function f(E){return E.indexOf("/")===-1&&(E=D(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}function p(E,O=n.$hc.sep){if(!E)return"";const x=E.length,I=E.charCodeAt(0);if(w(I)){if(w(E.charCodeAt(1))&&!w(E.charCodeAt(2))){let q=3;const J=q;for(;q<x&&!w(E.charCodeAt(q));q++);if(J!==q&&!w(E.charCodeAt(q+1))){for(q+=1;q<x;q++)if(w(E.charCodeAt(q)))return E.slice(0,q+1).replace(/[\\/]/g,O)}}return O}else if(a(I)&&E.charCodeAt(1)===i.CharCode.Colon)return w(E.charCodeAt(2))?E.slice(0,2)+O:E.slice(0,2);let _=E.indexOf("://");if(_!==-1){for(_+=3;_<x;_++)if(w(E.charCodeAt(_)))return E.slice(0,_+1)}return""}function y(E){if(!P.$j||!E||E.length<5)return!1;let O=E.charCodeAt(0);if(O!==i.CharCode.Backslash||(O=E.charCodeAt(1),O!==i.CharCode.Backslash))return!1;let x=2;const I=x;for(;x<E.length&&(O=E.charCodeAt(x),O!==i.CharCode.Backslash);x++);return!(I===x||(O=E.charCodeAt(x+1),isNaN(O)||O===i.CharCode.Backslash))}const $=/[\\/:\*\?"<>\|]/g,m=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(E,O=P.$j){const x=O?$:m;return!(!E||E.length===0||/^\s+$/.test(E)||(x.lastIndex=0,x.test(E))||O&&e.test(E)||E==="."||E===".."||O&&E[E.length-1]==="."||O&&E.length!==E.trim().length||E.length>255)}function r(E,O,x){const I=E===O;return!x||I?I:!E||!O?!1:(0,F.$Gf)(E,O)}function h(E,O,x,I=n.sep){if(E===O)return!0;if(!E||!O||O.length>E.length)return!1;if(x){if(!(0,F.$Hf)(E,O))return!1;if(O.length===E.length)return!0;let q=O.length;return O.charAt(O.length-1)===I&&q--,E.charAt(q)===I}return O.charAt(O.length-1)!==I&&(O+=I),E.indexOf(O)===0}function a(E){return E>=i.CharCode.A&&E<=i.CharCode.Z||E>=i.CharCode.a&&E<=i.CharCode.z}function v(E,O){return P.$j&&E.endsWith(":")&&(E+=n.sep),(0,n.$jc)(E)||(E=(0,n.$kc)(O,E)),E=(0,n.$ic)(E),T(E)}function T(E){return P.$j?(E=(0,F.$of)(E,n.sep),E.endsWith(":")&&(E+=n.sep)):(E=(0,F.$of)(E,n.sep),E||(E=n.sep)),E}function S(E){const O=(0,n.$ic)(E);return P.$j?E.length>3?!1:d(O)&&(E.length===2||O.charCodeAt(2)===i.CharCode.Backslash):O===n.$hc.sep}function d(E,O=P.$j){return O?a(E.charCodeAt(0))&&E.charCodeAt(1)===i.CharCode.Colon:!1}function c(E,O=P.$j){return d(E,O)?E[0]:void 0}function b(E,O,x){return O.length>E.length?-1:E===O?0:(x&&(E=E.toLowerCase(),O=O.toLowerCase()),E.indexOf(O))}function A(E){const O=E.split(":");let x,I,_;for(const q of O){const J=Number(q);(0,N.$jg)(J)?I===void 0?I=J:_===void 0&&(_=J):x=x?[x,q].join(":"):q}if(!x)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:x,line:I!==void 0?I:void 0,column:_!==void 0?_:I!==void 0?1:void 0}}const V="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",U="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function C(E,O,x=8){let I="";for(let q=0;q<x;q++){let J;q===0&&P.$j&&!O&&(x===3||x===4)?J=U:J=V,I+=J.charAt(Math.floor(Math.random()*J.length))}let _;return O?_=`${O}-${I}`:_=I,E?(0,n.$kc)(E,_):_}}),define(pe[49],we([1,0,17,43,93,11]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uk=t.FuzzyScore=t.$Jk=t.$Ik=void 0,t.or=N,t.$Kk=D,t.$Lk=f,t.$Mk=$,t.$Nk=C,t.$Ok=E,t.$Pk=J,t.$Qk=G,t.$Rk=K,t.$Sk=Q,t.$Tk=je,t.$Vk=l,t.$Wk=M,t.$Xk=k,F=He(F);function N(...R){return function(B,H){for(let Y=0,ie=R.length;Y<ie;Y++){const re=R[Y](B,H);if(re)return re}return null}}t.$Ik=w.bind(void 0,!1),t.$Jk=w.bind(void 0,!0);function w(R,B,H){if(!H||H.length<B.length)return null;let Y;return R?Y=F.$Hf(H,B):Y=H.indexOf(B)===0,Y?B.length>0?[{start:0,end:B.length}]:[]:null}function D(R,B){const H=B.toLowerCase().indexOf(R.toLowerCase());return H===-1?null:[{start:H,end:H+R.length}]}function f(R,B){return p(R.toLowerCase(),B.toLowerCase(),0,0)}function p(R,B,H,Y){if(H===R.length)return[];if(Y===B.length)return null;if(R[H]===B[Y]){let ie=null;return(ie=p(R,B,H+1,Y+1))?S({start:Y,end:Y+1},ie):null}return p(R,B,H,Y+1)}function y(R){return i.CharCode.a<=R&&R<=i.CharCode.z}function $(R){return i.CharCode.A<=R&&R<=i.CharCode.Z}function m(R){return i.CharCode.Digit0<=R&&R<=i.CharCode.Digit9}function e(R){return R===i.CharCode.Space||R===i.CharCode.Tab||R===i.CharCode.LineFeed||R===i.CharCode.CarriageReturn}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(R=>s.add(R.charCodeAt(0)));function r(R){return e(R)||s.has(R)}function h(R,B){return R===B||r(R)&&r(B)}const a=new Map;function v(R){if(a.has(R))return a.get(R);let B;const H=(0,P.$Gk)(R);return H&&(B=H),a.set(R,B),B}function T(R){return y(R)||$(R)||m(R)}function S(R,B){return B.length===0?B=[R]:R.end===B[0].start?B[0].start=R.start:B.unshift(R),B}function d(R,B){for(let H=B;H<R.length;H++){const Y=R.charCodeAt(H);if($(Y)||m(Y)||H>0&&!T(R.charCodeAt(H-1)))return H}return R.length}function c(R,B,H,Y){if(H===R.length)return[];if(Y===B.length)return null;if(R[H]!==B[Y].toLowerCase())return null;{let ie=null,re=Y+1;for(ie=c(R,B,H+1,Y+1);!ie&&(re=d(B,re))<B.length;)ie=c(R,B,H+1,re),re++;return ie===null?null:S({start:Y,end:Y+1},ie)}}function b(R){let B=0,H=0,Y=0,ie=0,re=0;for(let Ne=0;Ne<R.length;Ne++)re=R.charCodeAt(Ne),$(re)&&B++,y(re)&&H++,T(re)&&Y++,m(re)&&ie++;const he=B/R.length,De=H/R.length,ve=Y/R.length,Ee=ie/R.length;return{upperPercent:he,lowerPercent:De,alphaPercent:ve,numericPercent:Ee}}function A(R){const{upperPercent:B,lowerPercent:H}=R;return H===0&&B>.6}function V(R){const{upperPercent:B,lowerPercent:H,alphaPercent:Y,numericPercent:ie}=R;return H>.2&&B<.8&&Y>.6&&ie<.2}function U(R){let B=0,H=0,Y=0,ie=0;for(let re=0;re<R.length;re++)Y=R.charCodeAt(re),$(Y)&&B++,y(Y)&&H++,e(Y)&&ie++;return(B===0||H===0)&&ie===0?R.length<=30:B<=5}function C(R,B){if(!B||(B=B.trim(),B.length===0)||!U(R))return null;B.length>60&&(B=B.substring(0,60));const H=b(B);if(!V(H)){if(!A(H))return null;B=B.toLowerCase()}let Y=null,ie=0;for(R=R.toLowerCase();ie<B.length&&(Y=c(R,B,0,ie))===null;)ie=d(B,ie+1);return Y}function E(R,B,H=!1){if(!B||B.length===0)return null;let Y=null,ie=0;for(R=R.toLowerCase(),B=B.toLowerCase();ie<B.length&&(Y=O(R,B,0,ie,H),Y===null);)ie=x(B,ie+1);return Y}function O(R,B,H,Y,ie){let re=0;if(H===R.length)return[];if(Y===B.length)return null;if(!h(R.charCodeAt(H),B.charCodeAt(Y))){const ve=v(R.charCodeAt(H));if(!ve)return null;for(let Ee=0;Ee<ve.length;Ee++)if(!h(ve[Ee],B.charCodeAt(Y+Ee)))return null;re+=ve.length-1}let he=null,De=Y+re+1;if(he=O(R,B,H+1,De,ie),!ie)for(;!he&&(De=x(B,De))<B.length;)he=O(R,B,H+1,De,ie),De++;if(!he)return null;if(R.charCodeAt(H)!==B.charCodeAt(Y)){const ve=v(R.charCodeAt(H));if(!ve)return he;for(let Ee=0;Ee<ve.length;Ee++)if(ve[Ee]!==B.charCodeAt(Y+Ee))return he}return S({start:Y,end:Y+re+1},he)}function x(R,B){for(let H=B;H<R.length;H++)if(r(R.charCodeAt(H))||H>0&&r(R.charCodeAt(H-1)))return H;return R.length}const I=N(t.$Jk,C,D),_=N(t.$Jk,C,f),q=new n.$Ec(1e4);function J(R,B,H=!1){if(typeof R!="string"||typeof B!="string")return null;let Y=q.get(R);Y||(Y=new RegExp(F.$pf(R),"i"),q.set(R,Y));const ie=Y.exec(B);return ie?[{start:ie.index,end:ie.index+ie[0].length}]:H?_(R,B):I(R,B)}function G(R,B){const H=l(R,R.toLowerCase(),0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?Q(H):null}function K(R,B,H,Y,ie,re){const he=Math.min(13,R.length);for(;H<he;H++){const De=l(R,B,H,Y,ie,re,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,re]}function Q(R){if(typeof R>"u")return[];const B=[],H=R[1];for(let Y=R.length-1;Y>1;Y--){const ie=R[Y]+H,re=B[B.length-1];re&&re.end===ie?re.end=ie+1:B.push({start:ie,end:ie+1})}return B}const ae=128;function me(){const R=[],B=[];for(let H=0;H<=ae;H++)B[H]=0;for(let H=0;H<=ae;H++)R.push(B.slice(0));return R}function ye(R){const B=[];for(let H=0;H<=R;H++)B[H]=0;return B}const Le=ye(2*ae),ne=ye(2*ae),ee=me(),ce=me(),le=me(),ke=!1;function te(R,B,H,Y,ie){function re(De,ve,Ee=" "){for(;De.length<ve;)De=Ee+De;return De}let he=` |   |${Y.split("").map(De=>re(De,3)).join("|")}
`;for(let De=0;De<=H;De++)De===0?he+=" |":he+=`${B[De-1]}|`,he+=R[De].slice(0,ie+1).map(ve=>re(ve.toString(),3)).join("|")+`
`;return he}function be(R,B,H,Y){R=R.substr(B),H=H.substr(Y),console.log(te(ce,R,R.length,H,H.length)),console.log(te(le,R,R.length,H,H.length)),console.log(te(ee,R,R.length,H,H.length))}function Ae(R,B){if(B<0||B>=R.length)return!1;const H=R.codePointAt(B);switch(H){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!F.$Zf(H)}}function Re(R,B){if(B<0||B>=R.length)return!1;switch(R.charCodeAt(B)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function Ie(R,B,H){return B[R]!==H[R]}function je(R,B,H,Y,ie,re,he=!1){for(;B<H&&ie<re;)R[B]===Y[ie]&&(he&&(Le[B]=ie),B+=1),ie+=1;return B===H}var _e;(function(R){R[R.Diag=1]="Diag",R[R.Left=2]="Left",R[R.LeftLeft=3]="LeftLeft"})(_e||(_e={}));var W;(function(R){R.Default=[-100,0];function B(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}R.isDefault=B})(W||(t.FuzzyScore=W={}));class j{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(B,H){this.firstMatchCanBeWeak=B,this.boostFullMatch=H}}t.$Uk=j;function l(R,B,H,Y,ie,re,he=j.default){const De=R.length>ae?ae:R.length,ve=Y.length>ae?ae:Y.length;if(H>=De||re>=ve||De-H>ve-re||!je(B,H,De,ie,re,ve,!0))return;o(De,ve,H,re,B,ie);let Ee=1,Ne=1,fe=H,Fe=re;const Ke=[!1];for(Ee=1,fe=H;fe<De;Ee++,fe++){const Ge=Le[fe],Ze=ne[fe],Z=fe+1<De?ne[fe+1]:ve;for(Ne=Ge-re+1,Fe=Ge;Fe<Z;Ne++,Fe++){let ue=Number.MIN_SAFE_INTEGER,$e=!1;Fe<=Ze&&(ue=g(R,B,fe,H,Y,ie,Fe,ve,re,ee[Ee-1][Ne-1]===0,Ke));let Se=0;ue!==Number.MAX_SAFE_INTEGER&&($e=!0,Se=ue+ce[Ee-1][Ne-1]);const Pe=Fe>Ge,Ve=Pe?ce[Ee][Ne-1]+(ee[Ee][Ne-1]>0?-5:0):0,Je=Fe>Ge+1&&ee[Ee][Ne-1]>0,rt=Je?ce[Ee][Ne-2]+(ee[Ee][Ne-2]>0?-5:0):0;if(Je&&(!Pe||rt>=Ve)&&(!$e||rt>=Se))ce[Ee][Ne]=rt,le[Ee][Ne]=_e.LeftLeft,ee[Ee][Ne]=0;else if(Pe&&(!$e||Ve>=Se))ce[Ee][Ne]=Ve,le[Ee][Ne]=_e.Left,ee[Ee][Ne]=0;else if($e)ce[Ee][Ne]=Se,le[Ee][Ne]=_e.Diag,ee[Ee][Ne]=ee[Ee-1][Ne-1]+1;else throw new Error("not possible")}}if(ke&&be(R,H,Y,re),!Ke[0]&&!he.firstMatchCanBeWeak)return;Ee--,Ne--;const Xe=[ce[Ee][Ne],re];let tt=0,lt=0;for(;Ee>=1;){let Ge=Ne;do{const Ze=le[Ee][Ge];if(Ze===_e.LeftLeft)Ge=Ge-2;else if(Ze===_e.Left)Ge=Ge-1;else break}while(Ge>=1);tt>1&&B[H+Ee-1]===ie[re+Ne-1]&&!Ie(Ge+re-1,Y,ie)&&tt+1>ee[Ee][Ge]&&(Ge=Ne),Ge===Ne?tt++:tt=1,lt||(lt=Ge),Ee--,Ne=Ge-1,Xe.push(Ne)}ve-re===De&&he.boostFullMatch&&(Xe[0]+=2);const st=lt-De;return Xe[0]-=st,Xe}function o(R,B,H,Y,ie,re){let he=R-1,De=B-1;for(;he>=H&&De>=Y;)ie[he]===re[De]&&(ne[he]=De,he--),De--}function g(R,B,H,Y,ie,re,he,De,ve,Ee,Ne){if(B[H]!==re[he])return Number.MIN_SAFE_INTEGER;let fe=1,Fe=!1;return he===H-Y?fe=R[H]===ie[he]?7:5:Ie(he,ie,re)&&(he===0||!Ie(he-1,ie,re))?(fe=R[H]===ie[he]?7:5,Fe=!0):Ae(re,he)&&(he===0||!Ae(re,he-1))?fe=5:(Ae(re,he-1)||Re(re,he-1))&&(fe=5,Fe=!0),fe>1&&H===Y&&(Ne[0]=!0),Fe||(Fe=Ie(he,ie,re)||Ae(re,he-1)||Re(re,he-1)),H===Y?he>ve&&(fe-=Fe?3:5):Ee?fe+=Fe?2:0:fe+=Fe?0:1,he+1===De&&(fe-=Fe?3:5),fe}function M(R,B,H,Y,ie,re,he){return u(R,B,H,Y,ie,re,!0,he)}function k(R,B,H,Y,ie,re,he){return u(R,B,H,Y,ie,re,!1,he)}function u(R,B,H,Y,ie,re,he,De){let ve=l(R,B,H,Y,ie,re,De);if(ve&&!he)return ve;if(R.length>=3){const Ee=Math.min(7,R.length-1);for(let Ne=H+1;Ne<Ee;Ne++){const fe=L(R,Ne);if(fe){const Fe=l(fe,fe.toLowerCase(),H,Y,ie,re,De);Fe&&(Fe[0]-=3,(!ve||Fe[0]>ve[0])&&(ve=Fe))}}}return ve}function L(R,B){if(B+1>=R.length)return;const H=R[B],Y=R[B+1];if(H!==Y)return R.slice(0,B)+Y+H+R.slice(B+2)}}),define(pe[66],we([1,0,11]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aj=t.$yj=void 0,t.$uj=n,t.$vj=P,t.$wj=F,t.$xj=w,t.$zj=s,i=He(i);function n(h){return P(h,0)}function P(h,a){switch(typeof h){case"object":return h===null?F(349,a):Array.isArray(h)?D(h,a):f(h,a);case"string":return w(h,a);case"boolean":return N(h,a);case"number":return F(h,a);case"undefined":return F(937,a);default:return F(617,a)}}function F(h,a){return(a<<5)-a+h|0}function N(h,a){return F(h?433:863,a)}function w(h,a){a=F(149417,a);for(let v=0,T=h.length;v<T;v++)a=F(h.charCodeAt(v),a);return a}function D(h,a){return a=F(104579,a),h.reduce((v,T)=>P(T,v),a)}function f(h,a){return a=F(181387,a),Object.keys(h).sort().reduce((v,T)=>(v=w(T,v),P(h[T],v)),a)}class p{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=P(a,this.g),this.g}}t.$yj=p;var y;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function $(h,a,v=32){const T=v-a,S=~((1<<T)-1);return(h<<a|(S&h)>>>T)>>>0}function m(h,a=0,v=h.byteLength,T=0){for(let S=0;S<v;S++)h[a+S]=T}function e(h,a,v="0"){for(;h.length<a;)h=v+h;return h}function s(h,a=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),a/4)}class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(y.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const v=a.length;if(v===0)return;const T=this.p;let S=this.r,d=this.u,c,b;for(d!==0?(c=d,b=-1,d=0):(c=a.charCodeAt(0),b=0);;){let A=c;if(i.$Kf(c))if(b+1<v){const V=a.charCodeAt(b+1);i.$Lf(V)?(b++,A=i.$Mf(c,V)):A=y.UNICODE_REPLACEMENT}else{d=c;break}else i.$Lf(c)&&(A=y.UNICODE_REPLACEMENT);if(S=this.w(T,S,A),b++,b<v)c=a.charCodeAt(b);else break}this.r=S,this.u=d}w(a,v,T){return T<128?a[v++]=T:T<2048?(a[v++]=192|(T&1984)>>>6,a[v++]=128|(T&63)>>>0):T<65536?(a[v++]=224|(T&61440)>>>12,a[v++]=128|(T&4032)>>>6,a[v++]=128|(T&63)>>>0):(a[v++]=240|(T&1835008)>>>18,a[v++]=128|(T&258048)>>>12,a[v++]=128|(T&4032)>>>6,a[v++]=128|(T&63)>>>0),v>=y.BLOCK_SIZE&&(this.y(),v-=y.BLOCK_SIZE,this.t+=y.BLOCK_SIZE,a[0]=a[y.BLOCK_SIZE+0],a[1]=a[y.BLOCK_SIZE+1],a[2]=a[y.BLOCK_SIZE+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,y.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=r.g,v=this.q;for(let C=0;C<64;C+=4)a.setUint32(C,v.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)a.setUint32(C,$(a.getUint32(C-12,!1)^a.getUint32(C-32,!1)^a.getUint32(C-56,!1)^a.getUint32(C-64,!1),1),!1);let T=this.h,S=this.l,d=this.m,c=this.n,b=this.o,A,V,U;for(let C=0;C<80;C++)C<20?(A=S&d|~S&c,V=1518500249):C<40?(A=S^d^c,V=1859775393):C<60?(A=S&d|S&c|d&c,V=2400959708):(A=S^d^c,V=3395469782),U=$(T,5)+A+b+V+a.getUint32(C*4,!1)&4294967295,b=c,c=d,d=$(S,30),S=T,T=U;this.h=this.h+T&4294967295,this.l=this.l+S&4294967295,this.m=this.m+d&4294967295,this.n=this.n+c&4294967295,this.o=this.o+b&4294967295}}t.$Aj=r}),define(pe[109],we([1,0,89,66,65]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vt=t.$Tt=void 0,t.$Ut=N;class F{constructor(m){this.a=m}getElements(){const m=this.a,e=new Int32Array(m.length);for(let s=0,r=m.length;s<r;s++)e[s]=m.charCodeAt(s);return e}}t.$Tt=F;function N($,m,e){return new y(new F($),new F(m)).ComputeDiff(e).changes}class w{static Assert(m,e){if(!m)throw new Error(e)}}class D{static Copy(m,e,s,r,h){for(let a=0;a<h;a++)s[r+a]=m[e+a]}static Copy2(m,e,s,r,h){for(let a=0;a<h;a++)s[r+a]=m[e+a]}}var f;(function($){$[$.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(f||(f={}));class p{constructor(){this.a=[],this.b=P.Constants.MAX_SAFE_SMALL_INTEGER,this.c=P.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$St(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=P.Constants.MAX_SAFE_SMALL_INTEGER,this.c=P.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(m,e){this.b=Math.min(this.b,m),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(m,e){this.b=Math.min(this.b,m),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class y{constructor(m,e,s=null){this.a=s,this.b=m,this.c=e;const[r,h,a]=y.o(m),[v,T,S]=y.o(e);this.d=a&&S,this.e=r,this.f=h,this.g=v,this.h=T,this.k=[],this.m=[]}static n(m){return m.length>0&&typeof m[0]=="string"}static o(m){const e=m.getElements();if(y.n(e)){const s=new Int32Array(e.length);for(let r=0,h=e.length;r<h;r++)s[r]=(0,n.$xj)(e[r],0);return[e,s,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(m,e){return this.f[m]!==this.h[e]?!1:this.d?this.e[m]===this.g[e]:!0}q(m,e){if(!this.p(m,e))return!1;const s=y.r(this.b,m),r=y.r(this.c,e);return s===r}static r(m,e){return typeof m.getStrictElement=="function"?m.getStrictElement(e):null}s(m,e){return this.f[m]!==this.f[e]?!1:this.d?this.e[m]===this.e[e]:!0}u(m,e){return this.h[m]!==this.h[e]?!1:this.d?this.g[m]===this.g[e]:!0}ComputeDiff(m){return this.v(0,this.f.length-1,0,this.h.length-1,m)}v(m,e,s,r,h){const a=[!1];let v=this.w(m,e,s,r,a);return h&&(v=this.z(v)),{quitEarly:a[0],changes:v}}w(m,e,s,r,h){for(h[0]=!1;m<=e&&s<=r&&this.p(m,s);)m++,s++;for(;e>=m&&r>=s&&this.p(e,r);)e--,r--;if(m>e||s>r){let c;return s<=r?(w.Assert(m===e+1,"originalStart should only be one more than originalEnd"),c=[new i.$St(m,0,s,r-s+1)]):m<=e?(w.Assert(s===r+1,"modifiedStart should only be one more than modifiedEnd"),c=[new i.$St(m,e-m+1,s,0)]):(w.Assert(m===e+1,"originalStart should only be one more than originalEnd"),w.Assert(s===r+1,"modifiedStart should only be one more than modifiedEnd"),c=[]),c}const a=[0],v=[0],T=this.y(m,e,s,r,a,v,h),S=a[0],d=v[0];if(T!==null)return T;if(!h[0]){const c=this.w(m,S,s,d,h);let b=[];return h[0]?b=[new i.$St(S+1,e-(S+1)+1,d+1,r-(d+1)+1)]:b=this.w(S+1,e,d+1,r,h),this.H(c,b)}return[new i.$St(m,e-m+1,s,r-s+1)]}x(m,e,s,r,h,a,v,T,S,d,c,b,A,V,U,C,E,O){let x=null,I=null,_=new p,q=e,J=s,G=A[0]-C[0]-r,K=P.Constants.MIN_SAFE_SMALL_INTEGER,Q=this.k.length-1;do{const ae=G+m;ae===q||ae<J&&S[ae-1]<S[ae+1]?(c=S[ae+1],V=c-G-r,c<K&&_.MarkNextChange(),K=c,_.AddModifiedElement(c+1,V),G=ae+1-m):(c=S[ae-1]+1,V=c-G-r,c<K&&_.MarkNextChange(),K=c-1,_.AddOriginalElement(c,V+1),G=ae-1-m),Q>=0&&(S=this.k[Q],m=S[0],q=1,J=S.length-1)}while(--Q>=-1);if(x=_.getReverseChanges(),O[0]){let ae=A[0]+1,me=C[0]+1;if(x!==null&&x.length>0){const ye=x[x.length-1];ae=Math.max(ae,ye.getOriginalEnd()),me=Math.max(me,ye.getModifiedEnd())}I=[new i.$St(ae,b-ae+1,me,U-me+1)]}else{_=new p,q=a,J=v,G=A[0]-C[0]-T,K=P.Constants.MAX_SAFE_SMALL_INTEGER,Q=E?this.m.length-1:this.m.length-2;do{const ae=G+h;ae===q||ae<J&&d[ae-1]>=d[ae+1]?(c=d[ae+1]-1,V=c-G-T,c>K&&_.MarkNextChange(),K=c+1,_.AddOriginalElement(c+1,V+1),G=ae+1-h):(c=d[ae-1],V=c-G-T,c>K&&_.MarkNextChange(),K=c,_.AddModifiedElement(c+1,V+1),G=ae-1-h),Q>=0&&(d=this.m[Q],h=d[0],q=1,J=d.length-1)}while(--Q>=-1);I=_.getChanges()}return this.H(x,I)}y(m,e,s,r,h,a,v){let T=0,S=0,d=0,c=0,b=0,A=0;m--,s--,h[0]=0,a[0]=0,this.k=[],this.m=[];const V=e-m+(r-s),U=V+1,C=new Int32Array(U),E=new Int32Array(U),O=r-s,x=e-m,I=m-s,_=e-r,J=(x-O)%2===0;C[O]=m,E[x]=e,v[0]=!1;for(let G=1;G<=V/2+1;G++){let K=0,Q=0;d=this.J(O-G,G,O,U),c=this.J(O+G,G,O,U);for(let me=d;me<=c;me+=2){me===d||me<c&&C[me-1]<C[me+1]?T=C[me+1]:T=C[me-1]+1,S=T-(me-O)-I;const ye=T;for(;T<e&&S<r&&this.p(T+1,S+1);)T++,S++;if(C[me]=T,T+S>K+Q&&(K=T,Q=S),!J&&Math.abs(me-x)<=G-1&&T>=E[me])return h[0]=T,a[0]=S,ye<=E[me]&&f.MaxDifferencesHistory>0&&G<=f.MaxDifferencesHistory+1?this.x(O,d,c,I,x,b,A,_,C,E,T,e,h,S,r,a,J,v):null}const ae=(K-m+(Q-s)-G)/2;if(this.a!==null&&!this.a(K,ae))return v[0]=!0,h[0]=K,a[0]=Q,ae>0&&f.MaxDifferencesHistory>0&&G<=f.MaxDifferencesHistory+1?this.x(O,d,c,I,x,b,A,_,C,E,T,e,h,S,r,a,J,v):(m++,s++,[new i.$St(m,e-m+1,s,r-s+1)]);b=this.J(x-G,G,x,U),A=this.J(x+G,G,x,U);for(let me=b;me<=A;me+=2){me===b||me<A&&E[me-1]>=E[me+1]?T=E[me+1]-1:T=E[me-1],S=T-(me-x)-_;const ye=T;for(;T>m&&S>s&&this.p(T,S);)T--,S--;if(E[me]=T,J&&Math.abs(me-O)<=G&&T<=C[me])return h[0]=T,a[0]=S,ye>=C[me]&&f.MaxDifferencesHistory>0&&G<=f.MaxDifferencesHistory+1?this.x(O,d,c,I,x,b,A,_,C,E,T,e,h,S,r,a,J,v):null}if(G<=f.MaxDifferencesHistory){let me=new Int32Array(c-d+2);me[0]=O-d+1,D.Copy2(C,d,me,1,c-d+1),this.k.push(me),me=new Int32Array(A-b+2),me[0]=x-b+1,D.Copy2(E,b,me,1,A-b+1),this.m.push(me)}}return this.x(O,d,c,I,x,b,A,_,C,E,T,e,h,S,r,a,J,v)}z(m){for(let e=0;e<m.length;e++){const s=m[e],r=e<m.length-1?m[e+1].originalStart:this.f.length,h=e<m.length-1?m[e+1].modifiedStart:this.h.length,a=s.originalLength>0,v=s.modifiedLength>0;for(;s.originalStart+s.originalLength<r&&s.modifiedStart+s.modifiedLength<h&&(!a||this.s(s.originalStart,s.originalStart+s.originalLength))&&(!v||this.u(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const S=this.q(s.originalStart,s.modifiedStart);if(this.q(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!S)break;s.originalStart++,s.modifiedStart++}const T=[null];if(e<m.length-1&&this.I(m[e],m[e+1],T)){m[e]=T[0],m.splice(e+1,1),e--;continue}}for(let e=m.length-1;e>=0;e--){const s=m[e];let r=0,h=0;if(e>0){const c=m[e-1];r=c.originalStart+c.originalLength,h=c.modifiedStart+c.modifiedLength}const a=s.originalLength>0,v=s.modifiedLength>0;let T=0,S=this.G(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let c=1;;c++){const b=s.originalStart-c,A=s.modifiedStart-c;if(b<r||A<h||a&&!this.s(b,b+s.originalLength)||v&&!this.u(A,A+s.modifiedLength))break;const U=(b===r&&A===h?5:0)+this.G(b,s.originalLength,A,s.modifiedLength);U>S&&(S=U,T=c)}s.originalStart-=T,s.modifiedStart-=T;const d=[null];if(e>0&&this.I(m[e-1],m[e],d)){m[e-1]=d[0],m.splice(e,1),e++;continue}}if(this.d)for(let e=1,s=m.length;e<s;e++){const r=m[e-1],h=m[e],a=h.originalStart-r.originalStart-r.originalLength,v=r.originalStart,T=h.originalStart+h.originalLength,S=T-v,d=r.modifiedStart,c=h.modifiedStart+h.modifiedLength,b=c-d;if(a<5&&S<20&&b<20){const A=this.A(v,S,d,b,a);if(A){const[V,U]=A;(V!==r.originalStart+r.originalLength||U!==r.modifiedStart+r.modifiedLength)&&(r.originalLength=V-r.originalStart,r.modifiedLength=U-r.modifiedStart,h.originalStart=V+a,h.modifiedStart=U+a,h.originalLength=T-h.originalStart,h.modifiedLength=c-h.modifiedStart)}}}return m}A(m,e,s,r,h){if(e<h||r<h)return null;const a=m+e-h+1,v=s+r-h+1;let T=0,S=0,d=0;for(let c=m;c<a;c++)for(let b=s;b<v;b++){const A=this.B(c,b,h);A>0&&A>T&&(T=A,S=c,d=b)}return T>0?[S,d]:null}B(m,e,s){let r=0;for(let h=0;h<s;h++){if(!this.p(m+h,e+h))return 0;r+=this.e[m+h].length}return r}C(m){return m<=0||m>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[m])}D(m,e){if(this.C(m)||this.C(m-1))return!0;if(e>0){const s=m+e;if(this.C(s-1)||this.C(s))return!0}return!1}E(m){return m<=0||m>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[m])}F(m,e){if(this.E(m)||this.E(m-1))return!0;if(e>0){const s=m+e;if(this.E(s-1)||this.E(s))return!0}return!1}G(m,e,s,r){const h=this.D(m,e)?1:0,a=this.F(s,r)?1:0;return h+a}H(m,e){const s=[];if(m.length===0||e.length===0)return e.length>0?e:m;if(this.I(m[m.length-1],e[0],s)){const r=new Array(m.length+e.length-1);return D.Copy(m,0,r,0,m.length-1),r[m.length-1]=s[0],D.Copy(e,1,r,m.length,e.length-1),r}else{const r=new Array(m.length+e.length);return D.Copy(m,0,r,0,m.length),D.Copy(e,0,r,m.length,e.length),r}}I(m,e,s){if(w.Assert(m.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),w.Assert(m.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=e.originalStart||m.modifiedStart+m.modifiedLength>=e.modifiedStart){const r=m.originalStart;let h=m.originalLength;const a=m.modifiedStart;let v=m.modifiedLength;return m.originalStart+m.originalLength>=e.originalStart&&(h=e.originalStart+e.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=e.modifiedStart&&(v=e.modifiedStart+e.modifiedLength-m.modifiedStart),s[0]=new i.$St(r,h,a,v),!0}else return s[0]=null,!1}J(m,e,s,r){if(m>=0&&m<r)return m;const h=s,a=r-s-1,v=e%2===0;if(m<0){const T=h%2===0;return v===T?0:1}else{const T=a%2===0;return v===T?r-1:r-2}}}t.$Vt=y}),define(pe[67],we([1,0,49,11,22]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yk=D,t.$Zk=p,t.$1k=$,t.$2k=m,t.$3k=s,t.$4k=r;const F="$(",N=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${N.source}`,"g");function D(h){return h.replace(w,(a,v)=>v?a:`\\${a}`)}const f=new RegExp(`\\\\${N.source}`,"g");function p(h){return h.replace(f,a=>`\\${a}`)}const y=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function $(h){return h.indexOf(F)===-1?h:h.replace(y,(a,v,T,S)=>T?a:v||S||"")}function m(h){return h?h.replace(/\$\((.*?)\)/g,(a,v)=>` ${v} `).trim():""}const e=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(h){e.lastIndex=0;let a="";const v=[];let T=0;for(;;){const S=e.lastIndex,d=e.exec(h),c=h.substring(S,d?.index);if(c.length>0){a+=c;for(let b=0;b<c.length;b++)v.push(T)}if(!d)break;T+=d[0].length}return{text:a,iconOffsets:v}}function r(h,a,v=!1){const{text:T,iconOffsets:S}=a;if(!S||S.length===0)return(0,i.$Pk)(h,T,v);const d=(0,n.$nf)(T," "),c=T.length-d.length,b=(0,i.$Pk)(h,d,v);if(b)for(const A of b){const V=S[A.start+c]+c;A.start+=V,A.end+=V}return b}}),define(pe[110],we([1,0,9,17,11]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mi=t.$Li=t.$Ki=t.$Ji=t.$Ii=void 0;class F{constructor(){this.b="",this.c=0}reset(e){return this.b=e,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(e){const s=e.charCodeAt(0),r=this.b.charCodeAt(this.c);return s-r}value(){return this.b[this.c]}}t.$Ii=F;class N{constructor(e=!0){this.e=e}reset(e){return this.b=e,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let e=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===n.CharCode.Period)if(e)this.c++;else break;else e=!1;return this}cmp(e){return this.e?(0,P.$Af)(e,this.b,0,e.length,this.c,this.d):(0,P.$Cf)(e,this.b,0,e.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Ji=N;class w{constructor(e=!0,s=!0){this.f=e,this.g=s}reset(e){this.d=0,this.e=0,this.b=e,this.c=e.length;for(let s=e.length-1;s>=0;s--,this.c--){const r=this.b.charCodeAt(s);if(!(r===n.CharCode.Slash||this.f&&r===n.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let e=!0;for(;this.e<this.c;this.e++){const s=this.b.charCodeAt(this.e);if(s===n.CharCode.Slash||this.f&&s===n.CharCode.Backslash)if(e)this.d++;else break;else e=!1}return this}cmp(e){return this.g?(0,P.$Af)(e,this.b,0,e.length,this.d,this.e):(0,P.$Cf)(e,this.b,0,e.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Ki=w;var D;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(D||(D={}));class f{constructor(e,s){this.f=e,this.g=s,this.d=[],this.e=0}reset(e){return this.c=e,this.d=[],this.c.scheme&&this.d.push(D.Scheme),this.c.authority&&this.d.push(D.Authority),this.c.path&&(this.b=new w(!1,!this.f(e)),this.b.reset(e.path),this.b.value()&&this.d.push(D.Path)),this.g(e)||(this.c.query&&this.d.push(D.Query),this.c.fragment&&this.d.push(D.Fragment)),this.e=0,this}next(){return this.d[this.e]===D.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===D.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(e){if(this.d[this.e]===D.Scheme)return(0,P.$Bf)(e,this.c.scheme);if(this.d[this.e]===D.Authority)return(0,P.$Bf)(e,this.c.authority);if(this.d[this.e]===D.Path)return this.b.cmp(e);if(this.d[this.e]===D.Query)return(0,P.$zf)(e,this.c.query);if(this.d[this.e]===D.Fragment)return(0,P.$zf)(e,this.c.fragment);throw new Error}value(){if(this.d[this.e]===D.Scheme)return this.c.scheme;if(this.d[this.e]===D.Authority)return this.c.authority;if(this.d[this.e]===D.Path)return this.b.value();if(this.d[this.e]===D.Query)return this.c.query;if(this.d[this.e]===D.Fragment)return this.c.fragment;throw new Error}}t.$Li=f;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(y||(y={}));class ${static forUris(e=()=>!1,s=()=>!1){return new $(new f(e,s))}static forPaths(e=!1){return new $(new w(void 0,!e))}static forStrings(){return new $(new F)}static forConfigKeys(){return new $(new N)}constructor(e){this.b=e}clear(){this.c=void 0}fill(e,s){if(s){const r=s.slice(0);(0,i.$Wb)(r);for(const h of r)this.set(h,e)}else{const r=e.slice(0);(0,i.$Wb)(r);for(const h of r)this.set(h[0],h[1])}}set(e,s){const r=this.b.reset(e);let h;this.c||(this.c=new p,this.c.segment=r.value());const a=[];for(h=this.c;;){const T=r.cmp(h.segment);if(T>0)h.left||(h.left=new p,h.left.segment=r.value()),a.push([y.Left,h]),h=h.left;else if(T<0)h.right||(h.right=new p,h.right.segment=r.value()),a.push([y.Right,h]),h=h.right;else if(r.hasNext())r.next(),h.mid||(h.mid=new p,h.mid.segment=r.value()),a.push([y.Mid,h]),h=h.mid;else break}const v=h.value;h.value=s,h.key=e;for(let T=a.length-1;T>=0;T--){const S=a[T][1];S.updateHeight();const d=S.balanceFactor();if(d<-1||d>1){const c=a[T][0],b=a[T+1][0];if(c===y.Right&&b===y.Right)a[T][1]=S.rotateLeft();else if(c===y.Left&&b===y.Left)a[T][1]=S.rotateRight();else if(c===y.Right&&b===y.Left)S.right=a[T+1][1]=a[T+1][1].rotateRight(),a[T][1]=S.rotateLeft();else if(c===y.Left&&b===y.Right)S.left=a[T+1][1]=a[T+1][1].rotateLeft(),a[T][1]=S.rotateRight();else throw new Error;if(T>0)switch(a[T-1][0]){case y.Left:a[T-1][1].left=a[T][1];break;case y.Right:a[T-1][1].right=a[T][1];break;case y.Mid:a[T-1][1].mid=a[T][1];break}else this.c=a[0][1]}}return v}get(e){return this.d(e)?.value}d(e){const s=this.b.reset(e);let r=this.c;for(;r;){const h=s.cmp(r.segment);if(h>0)r=r.left;else if(h<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(e){const s=this.d(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this.e(e,!1)}deleteSuperstr(e){return this.e(e,!0)}e(e,s){const r=this.b.reset(e),h=[];let a=this.c;for(;a;){const v=r.cmp(a.segment);if(v>0)h.push([y.Left,a]),a=a.left;else if(v<0)h.push([y.Right,a]),a=a.right;else if(r.hasNext())r.next(),h.push([y.Mid,a]),a=a.mid;else break}if(a){if(s?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const v=this.f(a.right);if(v.key){const{key:T,value:S,segment:d}=v;this.e(v.key,!1),a.key=T,a.value=S,a.segment=d}}else{const v=a.left??a.right;if(h.length>0){const[T,S]=h[h.length-1];switch(T){case y.Left:S.left=v;break;case y.Mid:S.mid=v;break;case y.Right:S.right=v;break}}else this.c=v}for(let v=h.length-1;v>=0;v--){const T=h[v][1];T.updateHeight();const S=T.balanceFactor();if(S>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),h[v][1]=T.rotateLeft()):S<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),h[v][1]=T.rotateRight()),v>0)switch(h[v-1][0]){case y.Left:h[v-1][1].left=h[v][1];break;case y.Right:h[v-1][1].right=h[v][1];break;case y.Mid:h[v-1][1].mid=h[v][1];break}else this.c=h[0][1]}}}f(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this.b.reset(e);let r=this.c,h;for(;r;){const a=s.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(s.hasNext())s.next(),h=r.value||h,r=r.mid;else break}return r&&r.value||h}findSuperstr(e){return this.g(e,!1)}g(e,s){const r=this.b.reset(e);let h=this.c;for(;h;){const a=r.cmp(h.segment);if(a>0)h=h.left;else if(a<0)h=h.right;else if(r.hasNext())r.next(),h=h.mid;else return h.mid?this.h(h.mid):s?h.value:void 0}}hasElementOrSubtree(e){return this.g(e,!0)!==void 0}forEach(e){for(const[s,r]of this)e(r,s)}*[Symbol.iterator](){yield*this.h(this.c)}h(e){const s=[];return this.j(e,s),s[Symbol.iterator]()}j(e,s){e&&(e.left&&this.j(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this.j(e.mid,s),e.right&&this.j(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const r=s.balanceFactor();return r<-1||r>1?!1:e(s.left)&&e(s.right)};return e(this.c)}}t.$Mi=$}),define(pe[16],we([1,0,17,60,28,5]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=r,t.$xc=d,P=He(P);const N=/^\w[\w\d+.-]*$/,w=/^\//,D=/^\/\//;function f(U,C){if(!U.scheme&&C)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${U.authority}", path: "${U.path}", query: "${U.query}", fragment: "${U.fragment}"}`);if(U.scheme&&!N.test(U.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(U.path){if(U.authority){if(!w.test(U.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(U.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(U,C){return!U&&!C?"file":U}function y(U,C){switch(U){case"https":case"http":case"file":C?C[0]!==m&&(C=m+C):C=m;break}return C}const $="",m="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(C){return C instanceof s?!0:C?typeof C.authority=="string"&&typeof C.fragment=="string"&&typeof C.path=="string"&&typeof C.query=="string"&&typeof C.scheme=="string"&&typeof C.fsPath=="string"&&typeof C.with=="function"&&typeof C.toString=="function":!1}constructor(C,E,O,x,I,_=!1){typeof C=="object"?(this.scheme=C.scheme||$,this.authority=C.authority||$,this.path=C.path||$,this.query=C.query||$,this.fragment=C.fragment||$):(this.scheme=p(C,_),this.authority=E||$,this.path=y(this.scheme,O||$),this.query=x||$,this.fragment=I||$,f(this,_))}get fsPath(){return d(this,!1)}with(C){if(!C)return this;let{scheme:E,authority:O,path:x,query:I,fragment:_}=C;return E===void 0?E=this.scheme:E===null&&(E=$),O===void 0?O=this.authority:O===null&&(O=$),x===void 0?x=this.path:x===null&&(x=$),I===void 0?I=this.query:I===null&&(I=$),_===void 0?_=this.fragment:_===null&&(_=$),E===this.scheme&&O===this.authority&&x===this.path&&I===this.query&&_===this.fragment?this:new a(E,O,x,I,_)}static parse(C,E=!1){const O=e.exec(C);return O?new a(O[2]||$,V(O[4]||$),V(O[5]||$),V(O[7]||$),V(O[9]||$),E):new a($,$,$,$,$)}static file(C){let E=$;if(F.$j&&(C=C.replace(/\\/g,m)),C[0]===m&&C[1]===m){const O=C.indexOf(m,2);O===-1?(E=C.substring(2),C=m):(E=C.substring(2,O),C=C.substring(O)||m)}return new a("file",E,C,$,$)}static from(C,E){return new a(C.scheme,C.authority,C.path,C.query,C.fragment,E)}static joinPath(C,...E){if(!C.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let O;return F.$j&&C.scheme==="file"?O=s.file(P.$gc.join(d(C,!0),...E)).path:O=P.$hc.join(C.path,...E),C.with({path:O})}toString(C=!1){return c(this,C)}toJSON(){return this}static revive(C){if(C){if(C instanceof s)return C;{const E=new a(C);return E._formatted=C.external??null,E._fsPath=C._sep===h?C.fsPath??null:null,E}}else return C}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}t.URI=s;function r(U){return!U||typeof U!="object"?!1:typeof U.scheme=="string"&&(typeof U.authority=="string"||typeof U.authority>"u")&&(typeof U.path=="string"||typeof U.path>"u")&&(typeof U.query=="string"||typeof U.query>"u")&&(typeof U.fragment=="string"||typeof U.fragment>"u")}const h=F.$j?1:void 0;class a extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(C=!1){return C?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const C={$mid:n.MarshalledId.Uri};return this._fsPath&&(C.fsPath=this._fsPath,C._sep=h),this._formatted&&(C.external=this._formatted),this.path&&(C.path=this.path),this.scheme&&(C.scheme=this.scheme),this.authority&&(C.authority=this.authority),this.query&&(C.query=this.query),this.fragment&&(C.fragment=this.fragment),C}}const v={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function T(U,C,E){let O,x=-1;for(let I=0;I<U.length;I++){const _=U.charCodeAt(I);if(_>=i.CharCode.a&&_<=i.CharCode.z||_>=i.CharCode.A&&_<=i.CharCode.Z||_>=i.CharCode.Digit0&&_<=i.CharCode.Digit9||_===i.CharCode.Dash||_===i.CharCode.Period||_===i.CharCode.Underline||_===i.CharCode.Tilde||C&&_===i.CharCode.Slash||E&&_===i.CharCode.OpenSquareBracket||E&&_===i.CharCode.CloseSquareBracket||E&&_===i.CharCode.Colon)x!==-1&&(O+=encodeURIComponent(U.substring(x,I)),x=-1),O!==void 0&&(O+=U.charAt(I));else{O===void 0&&(O=U.substr(0,I));const q=v[_];q!==void 0?(x!==-1&&(O+=encodeURIComponent(U.substring(x,I)),x=-1),O+=q):x===-1&&(x=I)}}return x!==-1&&(O+=encodeURIComponent(U.substring(x))),O!==void 0?O:U}function S(U){let C;for(let E=0;E<U.length;E++){const O=U.charCodeAt(E);O===i.CharCode.Hash||O===i.CharCode.QuestionMark?(C===void 0&&(C=U.substr(0,E)),C+=v[O]):C!==void 0&&(C+=U[E])}return C!==void 0?C:U}function d(U,C){let E;return U.authority&&U.path.length>1&&U.scheme==="file"?E=`//${U.authority}${U.path}`:U.path.charCodeAt(0)===i.CharCode.Slash&&(U.path.charCodeAt(1)>=i.CharCode.A&&U.path.charCodeAt(1)<=i.CharCode.Z||U.path.charCodeAt(1)>=i.CharCode.a&&U.path.charCodeAt(1)<=i.CharCode.z)&&U.path.charCodeAt(2)===i.CharCode.Colon?C?E=U.path.substr(1):E=U.path[1].toLowerCase()+U.path.substr(2):E=U.path,F.$j&&(E=E.replace(/\//g,"\\")),E}function c(U,C){const E=C?S:T;let O="",{scheme:x,authority:I,path:_,query:q,fragment:J}=U;if(x&&(O+=x,O+=":"),(I||x==="file")&&(O+=m,O+=m),I){let G=I.indexOf("@");if(G!==-1){const K=I.substr(0,G);I=I.substr(G+1),G=K.lastIndexOf(":"),G===-1?O+=E(K,!1,!1):(O+=E(K.substr(0,G),!1,!1),O+=":",O+=E(K.substr(G+1),!1,!0)),O+="@"}I=I.toLowerCase(),G=I.lastIndexOf(":"),G===-1?O+=E(I,!1,!0):(O+=E(I.substr(0,G),!1,!0),O+=I.substr(G))}if(_){if(_.length>=3&&_.charCodeAt(0)===i.CharCode.Slash&&_.charCodeAt(2)===i.CharCode.Colon){const G=_.charCodeAt(1);G>=i.CharCode.A&&G<=i.CharCode.Z&&(_=`/${String.fromCharCode(G+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===i.CharCode.Colon){const G=_.charCodeAt(0);G>=i.CharCode.A&&G<=i.CharCode.Z&&(_=`${String.fromCharCode(G+32)}:${_.substr(2)}`)}O+=E(_,!0,!1)}return q&&(O+="?",O+=E(q,!1,!1)),J&&(O+="#",O+=C?J:T(J,!1,!1)),O}function b(U){try{return decodeURIComponent(U)}catch{return U.length>3?U.substr(0,3)+b(U.substr(3)):U}}const A=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function V(U){return U.match(A)?U.replace(A,C=>b(C)):U}}),define(pe[68],we([1,0,47,16,60]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bi=F,t.$ci=N,t.$di=D;function F(f){return JSON.stringify(f,w)}function N(f){let p=JSON.parse(f);return p=D(p),p}function w(f,p){return p instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:p.source,flags:p.flags}:p}function D(f,p=0){if(!f||p>200)return f;if(typeof f=="object"){switch(f.$mid){case P.MarshalledId.Uri:return n.URI.revive(f);case P.MarshalledId.Regexp:return new RegExp(f.source,f.flags);case P.MarshalledId.Date:return new Date(f.source)}if(f instanceof i.$Oe||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let y=0;y<f.length;++y)f[y]=D(f[y],p+1);else for(const y in f)Object.hasOwnProperty.call(f,y)&&(f[y]=D(f[y],p+1))}return f}}),define(pe[39],we([1,0,6,5,11,16,28]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Tg=t.$Sg=t.$Rg=t.Schemas=void 0,t.$Pg=D,t.$Qg=f,t.$Ug=y,i=He(i),n=He(n),N=He(N);var w;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(w||(t.Schemas=w={}));function D(e,s){return F.URI.isUri(e)?(0,P.$Gf)(e.scheme,s):(0,P.$Hf)(e,s+":")}function f(e,...s){return s.some(r=>D(e,r))}t.$Rg="vscode-tkn",t.$Sg="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,r){this.f=y(s,r)}getServerRootPath(){return this.f}get g(){return N.$hc.join(this.f,w.vscodeRemoteResource)}set(s,r,h){this.a[s]=r,this.b[s]=h}setConnectionToken(s,r){this.c[s]=r}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(S){return i.$Z(S),s}const r=s.authority;let h=this.a[r];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const a=this.b[r],v=this.c[r];let T=`path=${encodeURIComponent(s.path)}`;return typeof v=="string"&&(T+=`&${t.$Sg}=${encodeURIComponent(v)}`),F.URI.from({scheme:n.$p?this.d:w.vscodeRemoteResource,authority:`${h}:${a}`,path:this.g,query:T})}}t.$Tg=new p;function y(e,s){return N.$hc.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Vg="vs/../../extensions",t.$Wg="vs/../../node_modules",t.$Xg="vs/../../node_modules.asar",t.$Yg="vs/../../node_modules.asar.unpacked",t.$Zg="vscode-app";class ${static{this.a=t.$Zg}asBrowserUri(s){const r=this.b(s,oe);return this.uriToBrowserUri(r)}uriToBrowserUri(s){return s.scheme===w.vscodeRemote?t.$Tg.rewrite(s):s.scheme===w.file&&(n.$n||n.$r===`${w.vscodeFileResource}://${$.a}`)?s.with({scheme:w.vscodeFileResource,authority:s.authority||$.a,query:null,fragment:null}):s}asFileUri(s){const r=this.b(s,oe);return this.uriToFileUri(r)}uriToFileUri(s){return s.scheme===w.vscodeFileResource?s.with({scheme:w.file,authority:s.authority!==$.a?s.authority:null,query:null,fragment:null}):s}b(s,r){return F.URI.isUri(s)?s:F.URI.parse(r.toUrl(s))}}t.$1g=new $;var m;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const r="vscode-coi";function h(v){let T;typeof v=="string"?T=new URL(v).searchParams:v instanceof URL?T=v.searchParams:F.URI.isUri(v)&&(T=new URL(v.toString(!0)).searchParams);const S=T?.get(r);if(S)return s.get(S)}e.getHeadersFromQuery=h;function a(v,T,S){if(!globalThis.crossOriginIsolated)return;const d=T&&S?"3":S?"2":"1";v instanceof URLSearchParams?v.set(r,d):v[r]=d}e.addSearchParam=a})(m||(t.COI=m={}))}),define(pe[50],we([1,0,17,108,39,28,5,11,16]),function(oe,t,i,n,P,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=void 0,t.$8g=f,t.$qh=y,t.$rh=m,n=He(n),F=He(F);function f(e){return(0,D.$xc)(e,!0)}class p{constructor(s){this.a=s}compare(s,r,h=!1){return s===r?0:(0,w.$zf)(this.getComparisonKey(s,h),this.getComparisonKey(r,h))}isEqual(s,r,h=!1){return s===r?!0:!s||!r?!1:this.getComparisonKey(s,h)===this.getComparisonKey(r,h)}getComparisonKey(s,r=!1){return s.with({path:this.a(s)?s.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(s){return this.a(s)}isEqualOrParent(s,r,h=!1){if(s.scheme===r.scheme){if(s.scheme===P.Schemas.file)return n.$Fg(f(s),f(r),this.a(s))&&s.query===r.query&&(h||s.fragment===r.fragment);if((0,t.$mh)(s.authority,r.authority))return n.$Fg(s.path,r.path,this.a(s),"/")&&s.query===r.query&&(h||s.fragment===r.fragment)}return!1}joinPath(s,...r){return D.URI.joinPath(s,...r)}basenameOrAuthority(s){return(0,t.$eh)(s)||s.authority}basename(s){return F.$hc.basename(s.path)}extname(s){return F.$hc.extname(s.path)}dirname(s){if(s.path.length===0)return s;let r;return s.scheme===P.Schemas.file?r=D.URI.file(F.$nc(f(s))).path:(r=F.$hc.dirname(s.path),s.authority&&r.length&&r.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),r="/")),s.with({path:r})}normalizePath(s){if(!s.path.length)return s;let r;return s.scheme===P.Schemas.file?r=D.URI.file(F.$ic(f(s))).path:r=F.$hc.normalize(s.path),s.with({path:r})}relativePath(s,r){if(s.scheme!==r.scheme||!(0,t.$mh)(s.authority,r.authority))return;if(s.scheme===P.Schemas.file){const v=F.$mc(f(s),f(r));return N.$j?n.$zg(v):v}let h=s.path||"/";const a=r.path||"/";if(this.a(s)){let v=0;for(const T=Math.min(h.length,a.length);v<T&&!(h.charCodeAt(v)!==a.charCodeAt(v)&&h.charAt(v).toLowerCase()!==a.charAt(v).toLowerCase());v++);h=a.substr(0,v)+h.substr(v)}return F.$hc.relative(h,a)}resolvePath(s,r){if(s.scheme===P.Schemas.file){const h=D.URI.file(F.$lc(f(s),r));return s.with({authority:h.authority,path:h.path})}return r=n.$Ag(r),s.with({path:F.$hc.resolve(s.path,r)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,r){return s===r||s!==void 0&&r!==void 0&&(0,w.$Gf)(s,r)}hasTrailingPathSeparator(s,r=F.sep){if(s.scheme===P.Schemas.file){const h=f(s);return h.length>n.$Bg(h).length&&h[h.length-1]===r}else{const h=s.path;return h.length>1&&h.charCodeAt(h.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,r=F.sep){return(0,t.$nh)(s,r)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,r=F.sep){let h=!1;if(s.scheme===P.Schemas.file){const a=f(s);h=a!==void 0&&a.length===n.$Bg(a).length&&a[a.length-1]===r}else{r="/";const a=s.path;h=a.length===1&&a.charCodeAt(a.length-1)===i.CharCode.Slash}return!h&&!(0,t.$nh)(s,r)?s.with({path:s.path+"/"}):s}}t.$9g=p,t.$0g=new p(()=>!1),t.$$g=new p(e=>e.scheme===P.Schemas.file?!N.$l:!0),t.$_g=new p(e=>!0),t.$ah=t.$0g.isEqual.bind(t.$0g),t.$bh=t.$0g.isEqualOrParent.bind(t.$0g),t.$ch=t.$0g.getComparisonKey.bind(t.$0g),t.$dh=t.$0g.basenameOrAuthority.bind(t.$0g),t.$eh=t.$0g.basename.bind(t.$0g),t.$fh=t.$0g.extname.bind(t.$0g),t.$gh=t.$0g.dirname.bind(t.$0g),t.$hh=t.$0g.joinPath.bind(t.$0g),t.$ih=t.$0g.normalizePath.bind(t.$0g),t.$jh=t.$0g.relativePath.bind(t.$0g),t.$kh=t.$0g.resolvePath.bind(t.$0g),t.$lh=t.$0g.isAbsolutePath.bind(t.$0g),t.$mh=t.$0g.isEqualAuthority.bind(t.$0g),t.$nh=t.$0g.hasTrailingPathSeparator.bind(t.$0g),t.$oh=t.$0g.removeTrailingPathSeparator.bind(t.$0g),t.$ph=t.$0g.addTrailingPathSeparator.bind(t.$0g);function y(e,s){const r=[];for(let h=0;h<e.length;h++){const a=s(e[h]);e.some((v,T)=>T===h?!1:(0,t.$bh)(a,s(v)))||r.push(e[h])}return r}var $;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function s(r){const h=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(T=>{const[S,d]=T.split(":");S&&d&&h.set(S,d)});const v=r.path.substring(0,r.path.indexOf(";"));return v&&h.set(e.META_DATA_MIME,v),h}e.parseMetaData=s})($||(t.DataUri=$={}));function m(e,s,r){if(s){let h=e.path;return h&&h[0]!==F.$hc.sep&&(h=F.$hc.sep+h),e.with({scheme:r,authority:s,path:h})}return e.with({scheme:r})}}),define(pe[12],we([1,0,38,6,3,2,50,5,63,25]),function(oe,t,i,n,P,F,N,w,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0h=t.$8h=t.$7h=t.$6h=t.$5h=t.Promises=t.$4h=t.$3h=t.$2h=t.$Zh=t.$Yh=t.$Xh=t.$Wh=t.$Vh=t.$Uh=t.$Th=t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.$Oh=t.$Nh=t.$Mh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=t.$Ah=void 0,t.$sh=p,t.$th=y,t.$uh=$,t.$vh=m,t.$wh=e,t.$xh=s,t.$yh=r,t.$zh=h,t.$Hh=U,t.$Ih=C,t.$Jh=E,t.$Kh=O,t.$Lh=x,t.$1h=ee,t.$9h=W;function p(l){return!!l&&typeof l.then=="function"}function y(l){const o=new i.$xe,g=l(o.token),M=new Promise((k,u)=>{const L=o.token.onCancellationRequested(()=>{L.dispose(),u(new n.$5)});Promise.resolve(g).then(R=>{L.dispose(),o.dispose(),k(R)},R=>{L.dispose(),o.dispose(),u(R)})});return new class{cancel(){o.cancel(),o.dispose()}then(k,u){return M.then(k,u)}catch(k){return this.then(void 0,k)}finally(k){return M.finally(k)}}}function $(l,o,g){return new Promise((M,k)=>{const u=o.onCancellationRequested(()=>{u.dispose(),M(g)});l.then(M,k).finally(()=>u.dispose())})}function m(l,o){return new Promise((g,M)=>{const k=o.onCancellationRequested(()=>{k.dispose(),M(new n.$5)});l.then(g,M).finally(()=>k.dispose())})}async function e(l){let o=-1;const g=l.map((M,k)=>M.then(u=>(o=k,u)));try{return await Promise.race(g)}finally{l.forEach((M,k)=>{k!==o&&M.cancel()})}}function s(l,o,g){let M;const k=setTimeout(()=>{M?.(void 0),g?.()},o);return Promise.race([l.finally(()=>clearTimeout(k)),new Promise(u=>M=u)])}function r(l){return new Promise((o,g)=>{const M=l();p(M)?M.then(o,g):o(M)})}function h(){let l,o;return{promise:new Promise((M,k)=>{l=M,o=k}),resolve:l,reject:o}}class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const g=()=>{if(this.b=null,this.f)return;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(g,g).then(M)})}return new Promise((g,M)=>{this.b.then(g,M)})}return this.a=o(),new Promise((g,M)=>{this.a.then(k=>{this.a=null,g(k)},k=>{this.a=null,M(k)})})}dispose(){this.f=!0}}t.$Ah=a;class v{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}t.$Bh=v;class T{constructor(){this.a=new Map}queue(o,g){const k=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.a.get(o)===k&&this.a.delete(o)});return this.a.set(o,k),k}}t.$Ch=T;const S=(l,o)=>{let g=!0;const M=setTimeout(()=>{g=!1,o()},l);return{isTriggered:()=>g,dispose:()=>{clearTimeout(M),g=!1}}},d=l=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,l())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class c{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,g=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((k,u)=>{this.d=k,this.f=u}).then(()=>{if(this.b=null,this.d=null,this.g){const k=this.g;return this.g=null,k()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=g===D.$he?d(M):S(g,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new n.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Dh=c;class b{constructor(o){this.a=new c(o),this.b=new a}trigger(o,g){return this.a.trigger(()=>this.b.queue(o),g)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Eh=b;class A{constructor(){this.a=!1,this.b=new Promise((o,g)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Fh=A;class V extends A{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}t.$Gh=V;function U(l,o){return o?new Promise((g,M)=>{const k=setTimeout(()=>{u.dispose(),g()},l),u=o.onCancellationRequested(()=>{clearTimeout(k),u.dispose(),M(new n.$5)})}):y(g=>U(l,g))}function C(l,o=0,g){const M=setTimeout(()=>{l(),g&&k.dispose()},o),k=(0,F.$Tc)(()=>{clearTimeout(M),g?.deleteAndLeak(k)});return g?.add(k),k}function E(l){const o=[];let g=0;const M=l.length;function k(){return g<M?l[g++]():null}function u(L){L!=null&&o.push(L);const R=k();return R?R.then(u):Promise.resolve(o)}return Promise.resolve(null).then(u)}function O(l,o=M=>!!M,g=null){let M=0;const k=l.length,u=()=>{if(M>=k)return Promise.resolve(g);const L=l[M++];return Promise.resolve(L()).then(B=>o(B)?Promise.resolve(B):u())};return u()}function x(l,o=M=>!!M,g=null){if(l.length===0)return Promise.resolve(g);let M=l.length;const k=()=>{M=-1;for(const u of l)u.cancel?.()};return new Promise((u,L)=>{for(const R of l)R.then(B=>{--M>=0&&o(B)?(k(),u(B)):M===0&&u(g)}).catch(B=>{--M>=0&&(k(),L(B))})})}class I{constructor(o){this.a=0,this.b=!1,this.f=o,this.g=[],this.d=0,this.h=new P.$me}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(o){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((g,M)=>{this.g.push({factory:o,c:g,e:M}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const o=this.g.shift();this.d++;const g=o.factory();g.then(o.c,o.e),g.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Mh=I;class _ extends I{constructor(){super(1)}}t.$Nh=_;class q{constructor(){this.a=new ce,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}t.$Oh=q;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new te;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueSize(o,g=N.$0g){const M=g.getComparisonKey(o);return this.a.get(M)?.size??0}queueFor(o,g,M=N.$0g){const k=M.getComparisonKey(o);let u=this.a.get(k);if(!u){u=new _;const L=this.f++,R=P.Event.once(u.onDrained)(()=>{u?.dispose(),this.a.delete(k),this.h(),this.d?.deleteAndDispose(L),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$5c),this.d.set(L,R),this.a.set(k,u)}return u.queue(g)}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Ph=J;class G{constructor(o,g){this.b=!1,this.a=-1,typeof o=="function"&&typeof g=="number"&&this.setIfNotSet(o,g)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,g){if(this.b)throw new n.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},g)}setIfNotSet(o,g){if(this.b)throw new n.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},g))}}t.$Qh=G;class K{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,g,M=globalThis){if(this.f)throw new n.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const k=M.setInterval(()=>{o()},g);this.d=(0,F.$Tc)(()=>{M.clearInterval(k),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}t.$Rh=K;class Q{constructor(o,g){this.b=-1,this.a=o,this.d=g,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Sh=Q;class ae{constructor(o,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.a=o,this.b=g,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Th=ae;class me extends Q{constructor(o,g){super(o,g),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}t.$Uh=me;class ye extends F.$Vc{constructor(o,g){super(),this.g=o,this.h=g,this.a=[],this.b=this.B(new F.$Wc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const g of o)this.a.push(g);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Vh=ye,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Xh=(l,o)=>{(0,w.$C)(()=>{if(g)return;const M=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let g=!1;return{dispose(){g||(g=!0)}}}:t.$Xh=(l,o,g)=>{const M=l.requestIdleCallback(o,typeof g=="number"?{timeout:g}:void 0);let k=!1;return{dispose(){k||(k=!0,l.cancelIdleCallback(M))}}},t.$Wh=l=>(0,t.$Xh)(globalThis,l)}();class Le{constructor(o,g){this.g=!1,this.d=()=>{try{this.j=g()}catch(M){this.l=M}finally{this.g=!0}},this.f=(0,t.$Xh)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Yh=Le;class ne extends Le{constructor(o){super(globalThis,o)}}t.$Zh=ne;async function ee(l,o,g){let M;for(let k=0;k<g;k++)try{return await l()}catch(u){M=u,await U(o)}throw M}class ce{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,g,M){return this.a={taskId:o,cancel:()=>M?.(),promise:g},g.then(()=>this.d(o),()=>this.d(o)),g}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{const{promise:g,resolve:M,reject:k}=h();this.b={run:o,promise:g,promiseResolve:M,promiseReject:k}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$2h=ce;class le{constructor(o,g=()=>Date.now()){this.d=o,this.f=g,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}t.$3h=le;var ke;(function(l){l[l.Resolved=0]="Resolved",l[l.Rejected=1]="Rejected"})(ke||(ke={}));class te{get isRejected(){return this.d?.outcome===ke.Rejected}get isResolved(){return this.d?.outcome===ke.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ke.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((o,g)=>{this.a=o,this.b=g})}complete(o){return new Promise(g=>{this.a(o),this.d={outcome:ke.Resolved,value:o},g()})}error(o){return new Promise(g=>{this.b(o),this.d={outcome:ke.Rejected,value:o},g()})}cancel(){return this.error(new n.$5)}}t.$4h=te;var be;(function(l){async function o(M){let k;const u=await Promise.all(M.map(L=>L.then(R=>R,R=>{k||(k=R)})));if(typeof k<"u")throw k;return u}l.settled=o;function g(M){return new Promise(async(k,u)=>{try{await M(k,u)}catch(L){u(L)}})}l.withAsyncBody=g})(be||(t.Promises=be={}));class Ae{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(o){this.a=void 0,this.b=void 0,this.d=!1,this.promise=o.then(g=>(this.a=g,this.d=!0,g),g=>{throw this.b=g,this.d=!0,g})}requireValue(){if(!this.d)throw new n.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$5h=Ae;class Re{constructor(o){this.b=o,this.a=new f.$U(()=>new Ae(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$6h=Re;var Ie;(function(l){l[l.Initial=0]="Initial",l[l.DoneOK=1]="DoneOK",l[l.DoneError=2]="DoneError"})(Ie||(Ie={}));class je{static fromArray(o){return new je(g=>{g.emitMany(o)})}static fromPromise(o){return new je(async g=>{g.emitMany(await o)})}static fromPromises(o){return new je(async g=>{await Promise.all(o.map(async M=>g.emitOne(await M)))})}static merge(o){return new je(async g=>{await Promise.all(o.map(async M=>{for await(const k of M)g.emitOne(k)}))})}static{this.EMPTY=je.fromArray([])}constructor(o,g){this.a=Ie.Initial,this.b=[],this.d=null,this.f=g,this.g=new P.$me,queueMicrotask(async()=>{const M={emitOne:k=>this.h(k),emitMany:k=>this.j(k),reject:k=>this.l(k)};try{await Promise.resolve(o(M)),this.k()}catch(k){this.l(k)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===Ie.DoneError)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===Ie.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(o,g){return new je(async M=>{for await(const k of o)M.emitOne(g(k))})}map(o){return je.map(this,o)}static filter(o,g){return new je(async M=>{for await(const k of o)g(k)&&M.emitOne(k)})}filter(o){return je.filter(this,o)}static coalesce(o){return je.filter(o,g=>!!g)}coalesce(){return je.coalesce(this)}static async toPromise(o){const g=[];for await(const M of o)g.push(M);return g}toPromise(){return je.toPromise(this)}h(o){this.a===Ie.Initial&&(this.b.push(o),this.g.fire())}j(o){this.a===Ie.Initial&&(this.b=this.b.concat(o),this.g.fire())}k(){this.a===Ie.Initial&&(this.a=Ie.DoneOK,this.g.fire())}l(o){this.a===Ie.Initial&&(this.a=Ie.DoneError,this.d=o,this.g.fire())}}t.$7h=je;class _e extends je{constructor(o,g){super(g),this.m=o}cancel(){this.m.cancel()}}t.$8h=_e;function W(l){const o=new i.$xe,g=l(o.token);return new _e(o,async M=>{const k=o.token.onCancellationRequested(()=>{k.dispose(),o.dispose(),M.reject(new n.$5)});try{for await(const u of g){if(o.token.isCancellationRequested)return;M.emitOne(u)}k.dispose(),o.dispose()}catch(u){k.dispose(),o.dispose(),M.reject(u)}})}class j{constructor(o){this.a=new te,this.b=new je(k=>{if(g){k.reject(g);return}return M&&k.emitMany(M),this.d=u=>k.reject(u),this.f=u=>k.emitOne(u),this.a.p},o);let g,M;this.f=k=>{M||(M=[]),M.push(k)},this.d=k=>{g||(g=k)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}t.$0h=j}),define(pe[4],we([1,0,18,61,15,19,12,6,3,111,8,2,39,5,16,66,24,37]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$,m,e,s,r,h){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.$nU=t.$iU=t.$gU=t.$dU=t.DetectedFullscreenMode=t.Namespace=t.$NT=t.$LT=t.$uT=t.$3S=t.$WS=t.$US=t.$TS=t.$SS=t.$NS=t.$MS=t.$LS=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$JS=v,t.$KS=S,t.$OS=U,t.$PS=C,t.$QS=E,t.$RS=O,t.$VS=I,t.$XS=J,t.$YS=G,t.$ZS=me,t.$1S=ye,t.$2S=Le,t.$4S=ce,t.$5S=le,t.$6S=ke,t.$7S=te,t.$8S=be,t.$9S=Ae,t.$0S=Re,t.$$S=Ie,t.$_S=je,t.$aT=_e,t.$bT=j,t.$cT=l,t.$dT=g,t.$eT=k,t.$fT=u,t.$gT=L,t.$hT=R,t.$iT=B,t.$jT=H,t.$kT=Y,t.$lT=ie,t.$mT=re,t.$nT=he,t.$oT=De,t.$pT=ve,t.$qT=Ne,t.$rT=fe,t.$sT=Ke,t.$tT=Xe,t.$vT=lt,t.$wT=st,t.$xT=$e,t.$yT=Se,t.$zT=Ve,t.$AT=Je,t.$BT=rt,t.$CT=it,t.$DT=ct,t.$ET=nt,t.$FT=dt,t.$GT=ft,t.$HT=wt,t.$IT=Ue,t.$JT=de,t.$KT=Oe,t.$MT=Be,t.$OT=Ye,t.$PT=ot,t.$QT=Qe,t.$RT=bt,t.$ST=Et,t.$TT=Rt,t.$UT=Jt,t.$=ei,t.$WT=Mi,t.$XT=Pi,t.$YT=ti,t.$ZT=ii,t.$1T=ji,t.$2T=Ci,t.$3T=_i,t.$4T=Ui,t.$5T=Hi,t.$6T=Vi,t.$7T=xi,t.$8T=zi,t.$9T=Wi,t.$0T=Ki,t.$$T=ri,t.$_T=qi,t.$aU=Gi,t.$bU=Xi,t.$cU=oi,t.$eU=Ji,t.$fU=en,t.$hU=tn,t.h=sn,t.$kU=rn,t.$lU=ai,t.$mU=ln,i=He(i),D=He(D),f=He(f),m=He(m),a=function(){const z=new Map;(0,r.$cS)(r.$dS,1);const X={window:r.$dS,disposables:new y.$Uc};z.set(r.$dS.vscodeWindowId,X);const se=new D.$me,ge=new D.$me,Te=new D.$me;function Ce(Me,We){return(typeof Me=="number"?z.get(Me):void 0)??(We?X:void 0)}return{onDidRegisterWindow:se.event,onWillUnregisterWindow:Te.event,onDidUnregisterWindow:ge.event,registerWindow(Me){if(z.has(Me.vscodeWindowId))return y.$Vc.None;const We=new y.$Uc,ze={window:Me,disposables:We.add(new y.$Uc)};return z.set(Me.vscodeWindowId,ze),We.add((0,y.$Tc)(()=>{z.delete(Me.vscodeWindowId),ge.fire(Me)})),We.add(S(Me,t.$LT.BEFORE_UNLOAD,()=>{Te.fire(Me)})),se.fire(ze),We},getWindows(){return z.values()},getWindowsCount(){return z.size},getWindowId(Me){return Me.vscodeWindowId},hasWindow(Me){return z.has(Me)},getWindowById:Ce,getWindow(Me){const We=Me;if(We?.ownerDocument?.defaultView)return We.ownerDocument.defaultView.window;const ze=Me;return ze?.view?ze.view.window:r.$dS},getDocument(Me){const We=Me;return(0,t.getWindow)(We).document}}}(),t.registerWindow=a.registerWindow,t.getWindow=a.getWindow,t.getDocument=a.getDocument,t.getWindows=a.getWindows,t.getWindowsCount=a.getWindowsCount,t.getWindowId=a.getWindowId,t.getWindowById=a.getWindowById,t.hasWindow=a.hasWindow,t.onDidRegisterWindow=a.onDidRegisterWindow,t.onWillUnregisterWindow=a.onWillUnregisterWindow,t.onDidUnregisterWindow=a.onDidUnregisterWindow;function v(z){for(;z.firstChild;)z.firstChild.remove()}class T{constructor(X,se,ge,Te){this.f=X,this.g=se,this.d=ge,this.j=Te||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function S(z,X,se,ge){return new T(z,X,se,ge)}function d(z,X){return function(se){return X(new F.$CS(z,se))}}function c(z){return function(X){return z(new P.$HS(X))}}const b=function(X,se,ge,Te){let Ce=ge;return se==="click"||se==="mousedown"||se==="contextmenu"?Ce=d((0,t.getWindow)(X),ge):(se==="keydown"||se==="keypress"||se==="keyup")&&(Ce=c(ge)),S(X,se,Ce,Te)};t.$LS=b;const A=function(X,se,ge){const Te=d((0,t.getWindow)(X),se);return U(X,Te,ge)};t.$MS=A;const V=function(X,se,ge){const Te=d((0,t.getWindow)(X),se);return E(X,Te,ge)};t.$NS=V;function U(z,X,se){return S(z,m.$s&&n.$zS.pointerEvents?t.$LT.POINTER_DOWN:t.$LT.MOUSE_DOWN,X,se)}function C(z,X,se){return S(z,m.$s&&n.$zS.pointerEvents?t.$LT.POINTER_MOVE:t.$LT.MOUSE_MOVE,X,se)}function E(z,X,se){return S(z,m.$s&&n.$zS.pointerEvents?t.$LT.POINTER_UP:t.$LT.MOUSE_UP,X,se)}function O(z,X,se){return(0,N.$Xh)(z,X,se)}class x extends N.$Yh{constructor(X,se){super(X,se)}}t.$SS=x;function I(z,X,se,ge){let Te=0;const Ce=z.setInterval(()=>{Te++,(typeof ge=="number"&&Te>=ge||X()===!0)&&Me.dispose()},se),Me=(0,y.$Tc)(()=>{z.clearInterval(Ce)});return Me}class _ extends N.$Rh{constructor(X){super(),this.g=X&&(0,t.getWindow)(X)}cancelAndSet(X,se,ge){return super.cancelAndSet(X,se,ge??this.g)}}t.$WS=_;class q{constructor(X,se=0){this.d=X,this.priority=se,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(X){(0,w.$Z)(X)}}static sort(X,se){return se.priority-X.priority}}(function(){const z=new Map,X=new Map,se=new Map,ge=new Map,Te=Ce=>{se.set(Ce,!1);const Me=z.get(Ce)??[];for(X.set(Ce,Me),z.set(Ce,[]),ge.set(Ce,!0);Me.length>0;)Me.sort(q.sort),Me.shift().execute();ge.set(Ce,!1)};t.$US=(Ce,Me,We=0)=>{const ze=(0,t.getWindowId)(Ce),xe=new q(Me,We);let at=z.get(ze);return at||(at=[],z.set(ze,at)),at.push(xe),se.get(ze)||(se.set(ze,!0),Ce.requestAnimationFrame(()=>Te(ze))),xe},t.$TS=(Ce,Me,We)=>{const ze=(0,t.getWindowId)(Ce);if(ge.get(ze)){const xe=new q(Me,We);let at=X.get(ze);return at||(at=[],X.set(ze,at)),at.push(xe),xe}else return(0,t.$US)(Ce,Me,We)}})();function J(z,X){return(0,t.$US)(z,X,1e4)}function G(z,X){return(0,t.$US)(z,X,-1e4)}const K=8,Q=function(z,X){return X};class ae extends y.$Vc{constructor(X,se,ge,Te=Q,Ce=K){super();let Me=null,We=0;const ze=this.B(new N.$Qh),xe=()=>{We=new Date().getTime(),ge(Me),Me=null};this.B(S(X,se,at=>{Me=Te(Me,at);const At=new Date().getTime()-We;At>=Ce?(ze.cancel(),xe()):ze.setIfNotSet(xe,Ce-At)}))}}function me(z,X,se,ge,Te){return new ae(z,X,se,ge,Te)}function ye(z){return(0,t.getWindow)(z).getComputedStyle(z,null)}function Le(z,X){const se=(0,t.getWindow)(z),ge=se.document;if(z!==ge.body)return new ee(z.clientWidth,z.clientHeight);if(m.$s&&se?.visualViewport)return new ee(se.visualViewport.width,se.visualViewport.height);if(se?.innerWidth&&se.innerHeight)return new ee(se.innerWidth,se.innerHeight);if(ge.body&&ge.body.clientWidth&&ge.body.clientHeight)return new ee(ge.body.clientWidth,ge.body.clientHeight);if(ge.documentElement&&ge.documentElement.clientWidth&&ge.documentElement.clientHeight)return new ee(ge.documentElement.clientWidth,ge.documentElement.clientHeight);if(X)return Le(X);throw new Error("Unable to figure out browser width and height")}class ne{static d(X,se){return parseFloat(se)||0}static f(X,se,ge){const Te=ye(X),Ce=Te?Te.getPropertyValue(se):"0";return ne.d(X,Ce)}static getBorderLeftWidth(X){return ne.f(X,"border-left-width","borderLeftWidth")}static getBorderRightWidth(X){return ne.f(X,"border-right-width","borderRightWidth")}static getBorderTopWidth(X){return ne.f(X,"border-top-width","borderTopWidth")}static getBorderBottomWidth(X){return ne.f(X,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(X){return ne.f(X,"padding-left","paddingLeft")}static getPaddingRight(X){return ne.f(X,"padding-right","paddingRight")}static getPaddingTop(X){return ne.f(X,"padding-top","paddingTop")}static getPaddingBottom(X){return ne.f(X,"padding-bottom","paddingBottom")}static getMarginLeft(X){return ne.f(X,"margin-left","marginLeft")}static getMarginTop(X){return ne.f(X,"margin-top","marginTop")}static getMarginRight(X){return ne.f(X,"margin-right","marginRight")}static getMarginBottom(X){return ne.f(X,"margin-bottom","marginBottom")}}class ee{static{this.None=new ee(0,0)}constructor(X,se){this.width=X,this.height=se}with(X=this.width,se=this.height){return X!==this.width||se!==this.height?new ee(X,se):this}static is(X){return typeof X=="object"&&typeof X.height=="number"&&typeof X.width=="number"}static lift(X){return X instanceof ee?X:new ee(X.width,X.height)}static equals(X,se){return X===se?!0:!X||!se?!1:X.width===se.width&&X.height===se.height}}t.$3S=ee;function ce(z){let X=z.offsetParent,se=z.offsetTop,ge=z.offsetLeft;for(;(z=z.parentNode)!==null&&z!==z.ownerDocument.body&&z!==z.ownerDocument.documentElement;){se-=z.scrollTop;const Te=R(z)?null:ye(z);Te&&(ge-=Te.direction!=="rtl"?z.scrollLeft:-z.scrollLeft),z===X&&(ge+=ne.getBorderLeftWidth(z),se+=ne.getBorderTopWidth(z),se+=z.offsetTop,ge+=z.offsetLeft,X=z.offsetParent)}return{left:ge,top:se}}function le(z,X,se){typeof X=="number"&&(z.style.width=`${X}px`),typeof se=="number"&&(z.style.height=`${se}px`)}function ke(z,X,se,ge,Te,Ce="absolute"){typeof X=="number"&&(z.style.top=`${X}px`),typeof se=="number"&&(z.style.right=`${se}px`),typeof ge=="number"&&(z.style.bottom=`${ge}px`),typeof Te=="number"&&(z.style.left=`${Te}px`),z.style.position=Ce}function te(z){const X=z.getBoundingClientRect(),se=(0,t.getWindow)(z);return{left:X.left+se.scrollX,top:X.top+se.scrollY,width:X.width,height:X.height}}function be(z){let X=z,se=1;do{const ge=ye(X).zoom;ge!=null&&ge!=="1"&&(se*=ge),X=X.parentElement}while(X!==null&&X!==X.ownerDocument.documentElement);return se}function Ae(z){const X=ne.getMarginLeft(z)+ne.getMarginRight(z);return z.offsetWidth+X}function Re(z){const X=ne.getBorderLeftWidth(z)+ne.getBorderRightWidth(z),se=ne.getPaddingLeft(z)+ne.getPaddingRight(z);return z.offsetWidth-X-se}function Ie(z){const X=ne.getMarginLeft(z)+ne.getMarginRight(z);return z.scrollWidth+X}function je(z){const X=ne.getBorderTopWidth(z)+ne.getBorderBottomWidth(z),se=ne.getPaddingTop(z)+ne.getPaddingBottom(z);return z.offsetHeight-X-se}function _e(z){const X=ne.getMarginTop(z)+ne.getMarginBottom(z);return z.offsetHeight+X}function W(z,X){if(z===null)return 0;const se=ce(z),ge=ce(X);return se.left-ge.left}function j(z,X){const se=X.map(Te=>Math.max(Ie(Te),Ae(Te))+W(Te,z)||0);return Math.max(...se)}function l(z,X){return!!X?.contains(z)}const o="parentFlowToElementId";function g(z,X){z.dataset[o]=X.id}function M(z){const X=z.dataset[o];return typeof X=="string"?z.ownerDocument.getElementById(X):null}function k(z,X){let se=z;for(;se;){if(se===X)return!0;if(Ve(se)){const ge=M(se);if(ge){se=ge;continue}}se=se.parentNode}return!1}function u(z,X,se){for(;z&&z.nodeType===z.ELEMENT_NODE;){if(z.classList.contains(X))return z;if(se){if(typeof se=="string"){if(z.classList.contains(se))return null}else if(z===se)return null}z=z.parentNode}return null}function L(z,X,se){return!!u(z,X,se)}function R(z){return z&&!!z.host&&!!z.mode}function B(z){return!!H(z)}function H(z){for(;z.parentNode;){if(z===z.ownerDocument?.body)return null;z=z.parentNode}return R(z)?z:null}function Y(){let z=De().activeElement;for(;z?.shadowRoot;)z=z.shadowRoot.activeElement;return z}function ie(z){return Y()===z}function re(z){return l(Y(),z)}function he(z){return z.ownerDocument===De()}function De(){return(0,t.getWindowsCount)()<=1?r.$dS.document:Array.from((0,t.getWindows)()).map(({window:X})=>X.document).find(X=>X.hasFocus())??r.$dS.document}function ve(){return De().defaultView?.window??r.$dS}const Ee=new Map;function Ne(z){return Ee.has(z)}function fe(){return new Fe}class Fe{constructor(){this.d="",this.f=void 0}setStyle(X){X!==this.d&&(this.d=X,this.f?this.f.innerText=X:this.f=Ke(r.$dS.document.head,se=>se.innerText=X))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ke(z=r.$dS.document.head,X,se){const ge=document.createElement("style");if(ge.type="text/css",ge.media="screen",X?.(ge),z.appendChild(ge),se&&se.add((0,y.$Tc)(()=>ge.remove())),z===r.$dS.document.head){const Te=new Set;Ee.set(ge,Te);for(const{window:Ce,disposables:Me}of(0,t.getWindows)()){if(Ce===r.$dS)continue;const We=Me.add(tt(ge,Te,Ce));se?.add(We)}}return ge}function Xe(z){const X=new y.$Uc;for(const[se,ge]of Ee)X.add(tt(se,ge,z));return X}function tt(z,X,se){const ge=new y.$Uc,Te=z.cloneNode(!0);se.document.head.appendChild(Te),ge.add((0,y.$Tc)(()=>Te.remove()));for(const Ce of ue(z))Te.sheet?.insertRule(Ce.cssText,Te.sheet?.cssRules.length);return ge.add(t.$uT.observe(z,ge,{childList:!0})(()=>{Te.textContent=z.textContent})),X.add(Te),ge.add((0,y.$Tc)(()=>X.delete(Te))),ge}t.$uT=new class{constructor(){this.mutationObservers=new Map}observe(z,X,se){let ge=this.mutationObservers.get(z);ge||(ge=new Map,this.mutationObservers.set(z,ge));const Te=(0,s.$uj)(se);let Ce=ge.get(Te);if(Ce)Ce.users+=1;else{const Me=new D.$me,We=new MutationObserver(xe=>Me.fire(xe));We.observe(z,se);const ze=Ce={users:1,observer:We,onDidMutate:Me.event};X.add((0,y.$Tc)(()=>{ze.users-=1,ze.users===0&&(Me.dispose(),We.disconnect(),ge?.delete(Te),ge?.size===0&&this.mutationObservers.delete(z))})),ge.set(Te,Ce)}return Ce.onDidMutate}};function lt(z=r.$dS.document.head){return Ge("meta",z)}function st(z=r.$dS.document.head){return Ge("link",z)}function Ge(z,X=r.$dS.document.head){const se=document.createElement(z);return X.appendChild(se),se}let Ze=null;function Z(){return Ze||(Ze=Ke()),Ze}function ue(z){return z?.sheet?.rules?z.sheet.rules:z?.sheet?.cssRules?z.sheet.cssRules:[]}function $e(z,X,se=Z()){if(!(!se||!X)){se.sheet?.insertRule(`${z} {${X}}`,0);for(const ge of Ee.get(se)??[])$e(z,X,ge)}}function Se(z,X=Z()){if(!X)return;const se=ue(X),ge=[];for(let Te=0;Te<se.length;Te++){const Ce=se[Te];Pe(Ce)&&Ce.selectorText.indexOf(z)!==-1&&ge.push(Te)}for(let Te=ge.length-1;Te>=0;Te--)X.sheet?.deleteRule(ge[Te]);for(const Te of Ee.get(X)??[])Se(z,Te)}function Pe(z){return typeof z.selectorText=="string"}function Ve(z){return z instanceof HTMLElement||z instanceof(0,t.getWindow)(z).HTMLElement}function Je(z){return z instanceof HTMLAnchorElement||z instanceof(0,t.getWindow)(z).HTMLAnchorElement}function rt(z){return z instanceof HTMLSpanElement||z instanceof(0,t.getWindow)(z).HTMLSpanElement}function it(z){return z instanceof HTMLTextAreaElement||z instanceof(0,t.getWindow)(z).HTMLTextAreaElement}function ct(z){return z instanceof HTMLInputElement||z instanceof(0,t.getWindow)(z).HTMLInputElement}function nt(z){return z instanceof HTMLButtonElement||z instanceof(0,t.getWindow)(z).HTMLButtonElement}function dt(z){return z instanceof HTMLDivElement||z instanceof(0,t.getWindow)(z).HTMLDivElement}function ft(z){return z instanceof SVGElement||z instanceof(0,t.getWindow)(z).SVGElement}function wt(z){return z instanceof MouseEvent||z instanceof(0,t.getWindow)(z).MouseEvent}function Ue(z){return z instanceof KeyboardEvent||z instanceof(0,t.getWindow)(z).KeyboardEvent}function de(z){return z instanceof PointerEvent||z instanceof(0,t.getWindow)(z).PointerEvent}function Oe(z){return z instanceof DragEvent||z instanceof(0,t.getWindow)(z).DragEvent}t.$LT={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$qS?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$qS?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$qS?"webkitAnimationIteration":"animationiteration"};function Be(z){const X=z;return!!(X&&typeof X.preventDefault=="function"&&typeof X.stopPropagation=="function")}t.$NT={stop:(z,X)=>(z.preventDefault(),X&&z.stopPropagation(),z)};function Ye(z){const X=[];for(let se=0;z&&z.nodeType===z.ELEMENT_NODE;se++)X[se]=z.scrollTop,z=z.parentNode;return X}function ot(z,X){for(let se=0;z&&z.nodeType===z.ELEMENT_NODE;se++)z.scrollTop!==X[se]&&(z.scrollTop=X[se]),z=z.parentNode}class ut extends y.$Vc{static m(X){if(Ve(X)){const se=H(X),ge=se?se.activeElement:X.ownerDocument.activeElement;return l(ge,X)}else{const se=X;return l(se.document.activeElement,se.document)}}constructor(X){super(),this.f=this.B(new D.$me),this.onDidFocus=this.f.event,this.g=this.B(new D.$me),this.onDidBlur=this.g.event;let se=ut.m(X),ge=!1;const Te=()=>{ge=!1,se||(se=!0,this.f.fire())},Ce=()=>{se&&(ge=!0,(Ve(X)?(0,t.getWindow)(X):X).setTimeout(()=>{ge&&(ge=!1,se=!1,this.g.fire())},0))};this.j=()=>{ut.m(X)!==se&&(se?Ce():Te())},this.B(S(X,t.$LT.FOCUS,Te,!0)),this.B(S(X,t.$LT.BLUR,Ce,!0)),Ve(X)&&(this.B(S(X,t.$LT.FOCUS_IN,()=>this.j())),this.B(S(X,t.$LT.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Qe(z){return new ut(z)}function bt(z,X){return z.after(X),X}function Et(z,...X){if(z.append(...X),X.length===1&&typeof X[0]!="string")return X[0]}function Rt(z,X){return z.insertBefore(X,z.firstChild),X}function Jt(z,...X){z.innerText="",Et(z,...X)}const Oi=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var kt;(function(z){z.HTML="http://www.w3.org/1999/xhtml",z.SVG="http://www.w3.org/2000/svg"})(kt||(t.Namespace=kt={}));function Qt(z,X,se,...ge){const Te=Oi.exec(X);if(!Te)throw new Error("Bad use of emmet");const Ce=Te[1]||"div";let Me;return z!==kt.HTML?Me=document.createElementNS(z,Ce):Me=document.createElement(Ce),Te[3]&&(Me.id=Te[3]),Te[4]&&(Me.className=Te[4].replace(/\./g," ").trim()),se&&Object.entries(se).forEach(([We,ze])=>{typeof ze>"u"||(/^on\w+$/.test(We)?Me[We]=ze:We==="selected"?ze&&Me.setAttribute(We,"true"):Me.setAttribute(We,ze))}),Me.append(...ge),Me}function ei(z,X,...se){return Qt(kt.HTML,z,X,...se)}ei.SVG=function(z,X,...se){return Qt(kt.SVG,z,X,...se)};function Mi(z,X){const se=[];return z.forEach((ge,Te)=>{Te>0&&(X instanceof Node?se.push(X.cloneNode()):se.push(document.createTextNode(X))),se.push(ge)}),se}function Pi(z,...X){z?ti(...X):ii(...X)}function ti(...z){for(const X of z)X.style.display="",X.removeAttribute("aria-hidden")}function ii(...z){for(const X of z)X.style.display="none",X.setAttribute("aria-hidden","true")}function Bi(z,X){for(;z&&z.nodeType===z.ELEMENT_NODE;){if(Ve(z)&&z.hasAttribute(X))return z;z=z.parentNode}return null}function ji(z){!z||!z.hasAttribute("tabIndex")||(z.ownerDocument.activeElement===z&&Bi(z.parentElement,"tabIndex")?.focus(),z.removeAttribute("tabindex"))}function Ci(z){return X=>{X.preventDefault(),X.stopPropagation(),z(X)}}function _i(z){return new Promise(X=>{if(z.document.readyState==="complete"||z.document&&z.document.body!==null)X(void 0);else{const ge=()=>{z.window.removeEventListener("DOMContentLoaded",ge,!1),X()};z.window.addEventListener("DOMContentLoaded",ge,!1)}})}function Ui(z,X){const se=z.devicePixelRatio*X;return Math.max(1,Math.floor(se))/z.devicePixelRatio}function Hi(z){r.$dS.open(z,"_blank","noopener")}const ni=780,si=640;function Vi(z){const X=Math.floor(r.$dS.screenLeft+r.$dS.innerWidth/2-ni/2),se=Math.floor(r.$dS.screenTop+r.$dS.innerHeight/2-si/2);r.$dS.open(z,"_blank",`width=${ni},height=${si},top=${se},left=${X}`)}function xi(z,X=!0){const se=r.$dS.open();return se?(X&&(se.opener=null),se.location.href=z,!0):!1}function zi(z,X){const se=()=>{X(),ge=(0,t.$US)(z,se)};let ge=(0,t.$US)(z,se);return(0,y.$Tc)(()=>ge.dispose())}$.$Tg.setPreferredWebSchema(/^https:/.test(r.$dS.location.href)?"https":"http");function Wi(z){return z?`url('${$.$1g.uriToBrowserUri(z).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Ki(z){return`'${z.replace(/'/g,"%27")}'`}function ri(z,X){if(z!==void 0){const se=z.match(/^\s*var\((.+)\)$/);if(se){const ge=se[1].split(",",2);return ge.length===2&&(X=ri(ge[1].trim(),X)),`var(${ge[0]}, ${X})`}return z}return X}function qi(z,X){let se;if(e.URI.isUri(z))se=z.toString(!0);else{const Ce=new Blob([z]);se=URL.createObjectURL(Ce),setTimeout(()=>URL.revokeObjectURL(se))}const ge=ve(),Te=document.createElement("a");ge.document.body.appendChild(Te),Te.download=X,Te.href=se,Te.click(),setTimeout(()=>Te.remove())}function Gi(){return new Promise(z=>{const X=ve(),se=document.createElement("input");X.document.body.appendChild(se),se.type="file",se.multiple=!0,D.Event.once(D.Event.fromDOMEventEmitter(se,"input"))(()=>{z(se.files??void 0)}),se.click(),setTimeout(()=>se.remove())})}var Nt;(function(z){z[z.DOCUMENT=1]="DOCUMENT",z[z.BROWSER=2]="BROWSER"})(Nt||(t.DetectedFullscreenMode=Nt={}));function Xi(z){return z.document.fullscreenElement||z.document.webkitFullscreenElement||z.document.webkitIsFullScreen?{mode:Nt.DOCUMENT,guess:!1}:z.innerHeight===z.screen.height?{mode:Nt.BROWSER,guess:!1}:(m.$k||m.$l)&&z.outerHeight===z.screen.height&&z.outerWidth===z.screen.width?{mode:Nt.BROWSER,guess:!0}:null}function oi(z,X=!1){const se=document.createElement("a");return f.addHook("afterSanitizeAttributes",ge=>{for(const Te of["href","src"])if(ge.hasAttribute(Te)){const Ce=ge.getAttribute(Te);if(Te==="href"&&Ce.startsWith("#"))continue;if(se.href=Ce,!z.includes(se.protocol.replace(/:$/,""))){if(X&&Te==="src"&&se.href.startsWith("data:"))continue;ge.removeAttribute(Te)}}}),(0,y.$Tc)(()=>{f.removeHook("afterSanitizeAttributes")})}const Yi=[$.Schemas.http,$.Schemas.https,$.Schemas.command];t.$dU=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Zi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Ji(z,X){const se=oi(Yi);try{const ge=f.sanitize(X,Zi);z.innerHTML=ge}finally{se.dispose()}}function Qi(z){const X=new Uint16Array(z.length);for(let Te=0;Te<X.length;Te++)X[Te]=z.charCodeAt(Te);let se="";const ge=new Uint8Array(X.buffer);for(let Te=0;Te<ge.length;Te++)se+=String.fromCharCode(ge[Te]);return se}function en(z){return btoa(Qi(z))}class yt extends D.$me{constructor(){super(),this.o=new y.$Uc,this.D={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(D.Event.runAndSubscribe(t.onDidRegisterWindow,({window:X,disposables:se})=>this.G(X,se),{window:r.$dS,disposables:this.o}))}G(X,se){se.add(S(X,"keydown",ge=>{if(ge.defaultPrevented)return;const Te=new P.$HS(ge);if(!(Te.keyCode===p.KeyCode.Alt&&ge.repeat)){if(ge.altKey&&!this.D.altKey)this.D.lastKeyPressed="alt";else if(ge.ctrlKey&&!this.D.ctrlKey)this.D.lastKeyPressed="ctrl";else if(ge.metaKey&&!this.D.metaKey)this.D.lastKeyPressed="meta";else if(ge.shiftKey&&!this.D.shiftKey)this.D.lastKeyPressed="shift";else if(Te.keyCode!==p.KeyCode.Alt)this.D.lastKeyPressed=void 0;else return;this.D.altKey=ge.altKey,this.D.ctrlKey=ge.ctrlKey,this.D.metaKey=ge.metaKey,this.D.shiftKey=ge.shiftKey,this.D.lastKeyPressed&&(this.D.event=ge,this.fire(this.D))}},!0)),se.add(S(X,"keyup",ge=>{ge.defaultPrevented||(!ge.altKey&&this.D.altKey?this.D.lastKeyReleased="alt":!ge.ctrlKey&&this.D.ctrlKey?this.D.lastKeyReleased="ctrl":!ge.metaKey&&this.D.metaKey?this.D.lastKeyReleased="meta":!ge.shiftKey&&this.D.shiftKey?this.D.lastKeyReleased="shift":this.D.lastKeyReleased=void 0,this.D.lastKeyPressed!==this.D.lastKeyReleased&&(this.D.lastKeyPressed=void 0),this.D.altKey=ge.altKey,this.D.ctrlKey=ge.ctrlKey,this.D.metaKey=ge.metaKey,this.D.shiftKey=ge.shiftKey,this.D.lastKeyReleased&&(this.D.event=ge,this.fire(this.D)))},!0)),se.add(S(X.document.body,"mousedown",()=>{this.D.lastKeyPressed=void 0},!0)),se.add(S(X.document.body,"mouseup",()=>{this.D.lastKeyPressed=void 0},!0)),se.add(S(X.document.body,"mousemove",ge=>{ge.buttons&&(this.D.lastKeyPressed=void 0)},!0)),se.add(S(X,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.D}get isModifierPressed(){return this.D.altKey||this.D.ctrlKey||this.D.metaKey||this.D.shiftKey}resetKeyStatus(){this.H(),this.fire(this.D)}H(){this.D={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return yt.F||(yt.F=new yt),yt.F}dispose(){super.dispose(),this.o.dispose()}}t.$gU=yt;function tn(z){const X=document.cookie.match("(^|[^;]+)\\s*"+z+"\\s*=\\s*([^;]+)");return X?X.pop():void 0}class nn extends y.$Vc{constructor(X,se){super(),this.j=X,this.m=se,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(S(this.j,t.$LT.DRAG_START,X=>{this.m.onDragStart?.(X)})),this.m.onDrag&&this.B(S(this.j,t.$LT.DRAG,X=>{this.m.onDrag?.(X)})),this.B(S(this.j,t.$LT.DRAG_ENTER,X=>{this.f++,this.g=X.timeStamp,this.m.onDragEnter?.(X)})),this.B(S(this.j,t.$LT.DRAG_OVER,X=>{X.preventDefault(),this.m.onDragOver?.(X,X.timeStamp-this.g)})),this.B(S(this.j,t.$LT.DRAG_LEAVE,X=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(X))})),this.B(S(this.j,t.$LT.DRAG_END,X=>{this.f=0,this.g=0,this.m.onDragEnd?.(X)})),this.B(S(this.j,t.$LT.DROP,X=>{this.f=0,this.g=0,this.m.onDrop?.(X)}))}}t.$iU=nn;const li=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function sn(z,...X){let se,ge;Array.isArray(X[0])?(se={},ge=X[0]):(se=X[0]||{},ge=X[1]);const Te=li.exec(z);if(!Te||!Te.groups)throw new Error("Bad use of h");const Ce=Te.groups.tag||"div",Me=document.createElement(Ce);Te.groups.id&&(Me.id=Te.groups.id);const We=[];if(Te.groups.class)for(const xe of Te.groups.class.split("."))xe!==""&&We.push(xe);if(se.className!==void 0)for(const xe of se.className.split("."))xe!==""&&We.push(xe);We.length>0&&(Me.className=We.join(" "));const ze={};if(Te.groups.name&&(ze[Te.groups.name]=Me),ge)for(const xe of ge)Ve(xe)?Me.appendChild(xe):typeof xe=="string"?Me.append(xe):"root"in xe&&(Object.assign(ze,xe),Me.appendChild(xe.root));for(const[xe,at]of Object.entries(se))if(xe!=="className")if(xe==="style")for(const[At,vt]of Object.entries(at))Me.style.setProperty(Ot(At),typeof vt=="number"?vt+"px":""+vt);else xe==="tabIndex"?Me.tabIndex=at:Me.setAttribute(Ot(xe),at.toString());return ze.root=Me,ze}function rn(z,...X){let se,ge;Array.isArray(X[0])?(se={},ge=X[0]):(se=X[0]||{},ge=X[1]);const Te=li.exec(z);if(!Te||!Te.groups)throw new Error("Bad use of h");const Ce=Te.groups.tag||"div",Me=document.createElementNS("http://www.w3.org/2000/svg",Ce);Te.groups.id&&(Me.id=Te.groups.id);const We=[];if(Te.groups.class)for(const xe of Te.groups.class.split("."))xe!==""&&We.push(xe);if(se.className!==void 0)for(const xe of se.className.split("."))xe!==""&&We.push(xe);We.length>0&&(Me.className=We.join(" "));const ze={};if(Te.groups.name&&(ze[Te.groups.name]=Me),ge)for(const xe of ge)Ve(xe)?Me.appendChild(xe):typeof xe=="string"?Me.append(xe):"root"in xe&&(Object.assign(ze,xe),Me.appendChild(xe.root));for(const[xe,at]of Object.entries(se))if(xe!=="className")if(xe==="style")for(const[At,vt]of Object.entries(at))Me.style.setProperty(Ot(At),typeof vt=="number"?vt+"px":""+vt);else xe==="tabIndex"?Me.tabIndex=at:Me.setAttribute(Ot(xe),at.toString());return ze.root=Me,ze}function Ot(z){return z.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ai(z,X,se){for(const{name:ge,value:Te}of z.attributes)(!se||se.includes(ge))&&X.setAttribute(ge,Te)}function on(z,X,se){const ge=z.getAttribute(se);ge?X.setAttribute(se,ge):X.removeAttribute(se)}function ln(z,X,se){ai(z,X,se);const ge=new y.$Uc;return ge.add(t.$uT.observe(z,ge,{attributes:!0,attributeFilter:se})(Te=>{for(const Ce of Te)Ce.type==="attributes"&&Ce.attributeName&&on(z,X,Ce.attributeName)})),ge}class an{constructor(X,se,ge){this.f=X,this.g=se,this.d=new Int16Array(8);const{top:Te,left:Ce,right:Me,bottom:We}=ge.getBoundingClientRect(),ze=this.d;let xe=0;ze[xe++]=Ce,ze[xe++]=Te,ze[xe++]=Me,ze[xe++]=Te,ze[xe++]=Ce,ze[xe++]=We,ze[xe++]=Me,ze[xe++]=We}contains(X,se){const{d:ge,f:Te,g:Ce}=this;for(let Me=0;Me<4;Me++){const We=2*Me,ze=2*((Me+1)%4);if((0,h.$Rm)(X,se,Te,Ce,ge[We],ge[We+1],ge[ze],ge[ze+1]))return!0}return!1}}t.$nU=an}),define(pe[69],we([1,0,4,2,100]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pU=t.$oU=void 0,t.$qU=N;class F extends n.$Vc{constructor(D,f){super(),this.B((0,i.$KS)(D,"dragover",p=>{p.preventDefault(),this.a||(this.a=setTimeout(()=>{f(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(p=>{this.B((0,i.$KS)(D,p,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$oU=F,t.$pU={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:P.$_s.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function N(w,D,f,p,y){const $=document.createElement("div");$.className=f,$.textContent=D,y&&($.style.color=y),p&&($.style.background=p),w.dataTransfer&&((0,i.getWindow)(w).document.body.appendChild($),w.dataTransfer.setDragImage($,-10,-10),setTimeout(()=>$.remove(),0))}}),define(pe[70],we([1,0,4]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VU=n,t.$WU=P,t.$XU=F,i=He(i);function n($,m={}){const e=F(m);return e.textContent=$,e}function P($,m={}){const e=F(m);return D(e,f($,!!m.renderCodeSegments),m.actionHandler,m.renderCodeSegments),e}function F($){const m=$.inline?"span":"div",e=document.createElement(m);return $.className&&(e.className=$.className),e}class N{constructor(m){this.b=m,this.c=0}eos(){return this.c>=this.b.length}next(){const m=this.peek();return this.advance(),m}peek(){return this.b[this.c]}advance(){this.c++}}var w;(function($){$[$.Invalid=0]="Invalid",$[$.Root=1]="Root",$[$.Text=2]="Text",$[$.Bold=3]="Bold",$[$.Italics=4]="Italics",$[$.Action=5]="Action",$[$.ActionClose=6]="ActionClose",$[$.Code=7]="Code",$[$.NewLine=8]="NewLine"})(w||(w={}));function D($,m,e,s){let r;if(m.type===w.Text)r=document.createTextNode(m.content||"");else if(m.type===w.Bold)r=document.createElement("b");else if(m.type===w.Italics)r=document.createElement("i");else if(m.type===w.Code&&s)r=document.createElement("code");else if(m.type===w.Action&&e){const h=document.createElement("a");e.disposables.add(i.$LS(h,"click",a=>{e.callback(String(m.index),a)})),r=h}else m.type===w.NewLine?r=document.createElement("br"):m.type===w.Root&&(r=$);r&&$!==r&&$.appendChild(r),r&&Array.isArray(m.children)&&m.children.forEach(h=>{D(r,h,e,s)})}function f($,m){const e={type:w.Root,children:[]};let s=0,r=e;const h=[],a=new N($);for(;!a.eos();){let v=a.next();const T=v==="\\"&&y(a.peek(),m)!==w.Invalid;if(T&&(v=a.next()),!T&&p(v,m)&&v===a.peek()){a.advance(),r.type===w.Text&&(r=h.pop());const S=y(v,m);if(r.type===S||r.type===w.Action&&S===w.ActionClose)r=h.pop();else{const d={type:S,children:[]};S===w.Action&&(d.index=s,s++),r.children.push(d),h.push(r),r=d}}else if(v===`
`)r.type===w.Text&&(r=h.pop()),r.children.push({type:w.NewLine});else if(r.type!==w.Text){const S={type:w.Text,content:v};r.children.push(S),h.push(r),r=S}else r.content+=v}return r.type===w.Text&&(r=h.pop()),h.length,e}function p($,m){return y($,m)!==w.Invalid}function y($,m){switch($){case"*":return w.Bold;case"_":return w.Italics;case"[":return w.Action;case"]":return w.ActionClose;case"`":return m?w.Code:w.Invalid;default:return w.Invalid}}}),define(pe[71],we([1,0,4,2]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uU=void 0,i=He(i);class P{constructor(){this.a=new n.$Uc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(N,w){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const D=this.c;this.c=null,N&&D&&D(w)}isMonitoring(){return!!this.b}startMonitoring(N,w,D,f,p){this.isMonitoring()&&this.stopMonitoring(!1),this.b=f,this.c=p;let y=N;try{N.setPointerCapture(w),this.a.add((0,n.$Tc)(()=>{try{N.releasePointerCapture(w)}catch{}}))}catch{y=i.getWindow(N)}this.a.add(i.$KS(y,i.$LT.POINTER_MOVE,$=>{if($.buttons!==D){this.stopMonitoring(!0);return}$.preventDefault(),this.b($)})),this.a.add(i.$KS(y,i.$LT.POINTER_UP,$=>this.stopMonitoring(!0)))}}t.$uU=P});var et=this&&this.__decorate||function(oe,t,i,n){var P=arguments.length,F=P<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,i):n,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(oe,t,i,n);else for(var w=oe.length-1;w>=0;w--)(N=oe[w])&&(F=(P<3?N(F):P>3?N(t,i,F):N(t,i))||F);return P>3&&F&&Object.defineProperty(t,i,F),F};define(pe[32],we([1,0,4,24,9,35,3,2,59]),function(oe,t,i,n,P,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rU=t.EventType=void 0,i=He(i),P=He(P);var f;(function(y){y.Tap="-monaco-gesturetap",y.Change="-monaco-gesturechange",y.Start="-monaco-gesturestart",y.End="-monaco-gesturesend",y.Contextmenu="-monaco-gesturecontextmenu"})(f||(t.EventType=f={}));class p extends w.$Vc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new D.$6c,this.m=new D.$6c,this.r={},this.n=null,this.s=0,this.B(N.Event.runAndSubscribe(i.onDidRegisterWindow,({window:$,disposables:m})=>{m.add(i.$KS($.document,"touchstart",e=>this.w(e),{passive:!1})),m.add(i.$KS($.document,"touchend",e=>this.z($,e))),m.add(i.$KS($.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:n.$dS,disposables:this.q}))}static addTarget($){if(!p.isTouchDevice())return w.$Vc.None;p.f||(p.f=(0,w.$Oc)(new p));const m=p.f.j.push($);return(0,w.$Tc)(m)}static ignoreTarget($){if(!p.isTouchDevice())return w.$Vc.None;p.f||(p.f=(0,w.$Oc)(new p));const m=p.f.m.push($);return(0,w.$Tc)(m)}static isTouchDevice(){return"ontouchstart"in n.$dS||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w($){const m=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,s=$.targetTouches.length;e<s;e++){const r=$.targetTouches.item(e);this.r[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:m,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[m],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const h=this.C(f.Start,r.target);h.pageX=r.pageX,h.pageY=r.pageY,this.D(h)}this.h&&($.preventDefault(),$.stopPropagation(),this.h=!1)}z($,m){const e=Date.now(),s=Object.keys(this.r).length;for(let r=0,h=m.changedTouches.length;r<h;r++){const a=m.changedTouches.item(r);if(!this.r.hasOwnProperty(String(a.identifier))){console.warn("move of an UNKNOWN touch",a);continue}const v=this.r[a.identifier],T=Date.now()-v.initialTimeStamp;if(T<p.g&&Math.abs(v.initialPageX-P.$sb(v.rollingPageX))<30&&Math.abs(v.initialPageY-P.$sb(v.rollingPageY))<30){const S=this.C(f.Tap,v.initialTarget);S.pageX=P.$sb(v.rollingPageX),S.pageY=P.$sb(v.rollingPageY),this.D(S)}else if(T>=p.g&&Math.abs(v.initialPageX-P.$sb(v.rollingPageX))<30&&Math.abs(v.initialPageY-P.$sb(v.rollingPageY))<30){const S=this.C(f.Contextmenu,v.initialTarget);S.pageX=P.$sb(v.rollingPageX),S.pageY=P.$sb(v.rollingPageY),this.D(S)}else if(s===1){const S=P.$sb(v.rollingPageX),d=P.$sb(v.rollingPageY),c=P.$sb(v.rollingTimestamps)-v.rollingTimestamps[0],b=S-v.rollingPageX[0],A=d-v.rollingPageY[0],V=[...this.j].filter(U=>v.initialTarget instanceof Node&&U.contains(v.initialTarget));this.F($,V,e,Math.abs(b)/c,b>0?1:-1,S,Math.abs(A)/c,A>0?1:-1,d)}this.D(this.C(f.End,v.initialTarget)),delete this.r[a.identifier]}this.h&&(m.preventDefault(),m.stopPropagation(),this.h=!1)}C($,m){const e=document.createEvent("CustomEvent");return e.initEvent($,!1,!0),e.initialTarget=m,e.tapCount=0,e}D($){if($.type===f.Tap){const m=new Date().getTime();let e=0;m-this.s>p.u?e=1:e=2,this.s=m,$.tapCount=e}else($.type===f.Change||$.type===f.Contextmenu)&&(this.s=0);if($.initialTarget instanceof Node){for(const e of this.m)if(e.contains($.initialTarget))return;const m=[];for(const e of this.j)if(e.contains($.initialTarget)){let s=0,r=$.initialTarget;for(;r&&r!==e;)s++,r=r.parentElement;m.push([s,e])}m.sort((e,s)=>e[0]-s[0]);for(const[e,s]of m)s.dispatchEvent($),this.h=!0}}F($,m,e,s,r,h,a,v,T){this.n=i.$US($,()=>{const S=Date.now(),d=S-e;let c=0,b=0,A=!0;s+=p.c*d,a+=p.c*d,s>0&&(A=!1,c=r*s*d),a>0&&(A=!1,b=v*a*d);const V=this.C(f.Change);V.translationX=c,V.translationY=b,m.forEach(U=>U.dispatchEvent(V)),A||this.F($,m,S,s,r,h+c,a,v,T+b)})}G($){const m=Date.now();for(let e=0,s=$.changedTouches.length;e<s;e++){const r=$.changedTouches.item(e);if(!this.r.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const h=this.r[r.identifier],a=this.C(f.Change,h.initialTarget);a.translationX=r.pageX-P.$sb(h.rollingPageX),a.translationY=r.pageY-P.$sb(h.rollingPageY),a.pageX=r.pageX,a.pageY=r.pageY,this.D(a),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(r.pageX),h.rollingPageY.push(r.pageY),h.rollingTimestamps.push(m)}this.h&&($.preventDefault(),$.stopPropagation(),this.h=!1)}}t.$rU=p,et([F.$$h],p,"isTouchDevice",null)}),define(pe[112],we([1,0,4,22]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sV=F,t.$tV=N,i=He(i);const P=new RegExp(`(\\\\)?\\$\\((${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?)\\)`,"g");function F(w){const D=new Array;let f,p=0,y=0;for(;(f=P.exec(w))!==null;){y=f.index||0,p<y&&D.push(w.substring(p,y)),p=(f.index||0)+f[0].length;const[,$,m]=f;D.push($?`$(${m})`:N({id:m}))}return p<w.length&&D.push(w.substring(p)),D}function N(w){const D=i.$("span");return D.classList.add(...n.ThemeIcon.asClassNameArray(w)),D}}),define(pe[113],we([1,0,4]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8U=void 0;class n{constructor(F){this.d=F,this.a=new Map,this.b=new Set,this.c=!1}alloc(F){let N=this.g(F).pop(),w=!1;if(N)w=this.b.has(N.domNode),w&&this.b.delete(N.domNode);else{const D=(0,i.$)(".monaco-list-row"),p=this.h(F).renderTemplate(D);N={domNode:D,templateId:F,templateData:p}}return{row:N,isReusingConnectedDomNode:w}}release(F){F&&this.e(F)}transact(F){if(this.c)throw new Error("Already in transaction");this.c=!0;try{F()}finally{for(const N of this.b)this.f(N);this.b.clear(),this.c=!1}}e(F){const{domNode:N,templateId:w}=F;N&&(this.c?this.b.add(N):this.f(N)),this.g(w).push(F)}f(F){F.classList.remove("scrolling"),F.remove()}g(F){let N=this.a.get(F);return N||(N=[],this.a.set(F,N)),N}dispose(){this.a.forEach((F,N)=>{for(const w of F)this.h(N).disposeTemplate(w.templateData),w.templateData=null}),this.a.clear(),this.b.clear()}h(F){const N=this.d.get(F);if(!N)throw new Error(`No renderer found for ${F}`);return N}}t.$8U=n}),define(pe[114],we([1,0,12,2,20]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zU=void 0;class F extends n.$Vc{constructor(w,D,f){super(),this.a=w,this.b=D,this.c=f,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Qh)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===P.ScrollbarVisibility.Hidden?!1:this.a===P.ScrollbarVisibility.Visible?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$zU=F}),define(pe[115],we([1,0,4,32,9,3,8,2,5]),function(oe,t,i,n,P,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CV=void 0,i=He(i),P=He(P);class f extends w.$Vc{constructor(y,$,m,e){super(),this.f=0,this.b=e||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new F.$me),this.h=m,this.j(),this.setOptions(y,$)}j(){this.B(n.$rU.addTarget(this.a)),[n.EventType.Tap].forEach(y=>{this.B(i.$KS(this.a,y,$=>{this.a.focus()}))}),this.B(i.$LS(this.a,"click",y=>{i.$NT.stop(y,!0)})),this.B(i.$LS(this.a,"change",y=>{this.a.title=y.target.value,this.g.fire({index:y.target.selectedIndex,selected:y.target.value})})),this.B(i.$LS(this.a,"keydown",y=>{let $=!1;D.$k?(y.keyCode===N.KeyCode.DownArrow||y.keyCode===N.KeyCode.UpArrow||y.keyCode===N.KeyCode.Space)&&($=!0):(y.keyCode===N.KeyCode.DownArrow&&y.altKey||y.keyCode===N.KeyCode.Space||y.keyCode===N.KeyCode.Enter)&&($=!0),$&&y.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(y,$){(!this.c||!P.$ub(this.c,y))&&(this.c=y,this.a.options.length=0,this.c.forEach((m,e)=>{this.a.add(this.m(m.text,e,m.isDisabled))})),$!==void 0&&this.select($)}select(y){this.c.length===0?this.f=0:y>=0&&y<this.c.length?this.f=y:y>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(y){this.b.ariaLabel=y,this.a.setAttribute("aria-label",y)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setEnabled(y){this.a.disabled=!y}setFocusable(y){this.a.tabIndex=y?0:-1}render(y){y.classList.add("select-container"),y.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(y){this.h=y,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(y,$,m){const e=document.createElement("option");return e.value=y,e.text=y,e.disabled=!!m,e}}t.$CV=f}),define(pe[72],we([1,0,34,9,12,63,109,3,36]),function(oe,t,i,n,P,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eX=void 0,t.$cX=f,t.$dX=p;function f(m){return typeof m=="object"&&"visibility"in m&&"data"in m}function p(m){switch(m){case!0:return i.TreeVisibility.Visible;case!1:return i.TreeVisibility.Hidden;default:return m}}function y(m){return typeof m.collapsible=="boolean"}class ${constructor(e,s,r,h={}){this.p=e,this.q=s,this.rootRef=[],this.d=new w.$ue,this.f=new w.$me,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new w.$me,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new w.$me,this.onDidSplice=this.m.event,this.o=new P.$Dh(F.$he),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.allowNonCollapsibleParents??!1,this.k=h.filter,this.l=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0}}splice(e,s,r=D.Iterable.empty(),h={}){if(e.length===0)throw new i.$aX(this.p,"Invalid tree location");h.diffIdentityProvider?this.s(h.diffIdentityProvider,e,s,r,h):this.t(e,s,r,h)}s(e,s,r,h=D.Iterable.empty(),a,v=a.diffDepth??0){const{parentNode:T}=this.H(s);if(!T.lastDiffIds)return this.t(s,r,h,a);const S=[...h],d=s[s.length-1],c=new N.$Vt({getElements:()=>T.lastDiffIds},{getElements:()=>[...T.children.slice(0,d),...S,...T.children.slice(d+r)].map(C=>e.getId(C.element).toString())}).ComputeDiff(!1);if(c.quitEarly)return T.lastDiffIds=void 0,this.t(s,r,S,a);const b=s.slice(0,-1),A=(C,E,O)=>{if(v>0)for(let x=0;x<O;x++)C--,E--,this.s(e,[...b,C,0],Number.MAX_SAFE_INTEGER,S[E].children,a,v-1)};let V=Math.min(T.children.length,d+r),U=S.length;for(const C of c.changes.sort((E,O)=>O.originalStart-E.originalStart))A(V,U,V-(C.originalStart+C.originalLength)),V=C.originalStart,U=C.modifiedStart-d,this.t([...b,V],C.originalLength,D.Iterable.slice(S,U,U+C.modifiedLength),a);A(V,U,V)}t(e,s,r=D.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:a,diffIdentityProvider:v}){const{parentNode:T,listIndex:S,revealed:d,visible:c}=this.H(e),b=[],A=D.Iterable.map(r,q=>this.x(q,T,T.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,d,b,h)),V=e[e.length-1];let U=0;for(let q=V;q>=0&&q<T.children.length;q--){const J=T.children[q];if(J.visible){U=J.visibleChildIndex;break}}const C=[];let E=0,O=0;for(const q of A)C.push(q),O+=q.renderNodeCount,q.visible&&(q.visibleChildIndex=U+E++);const x=(0,n.$5b)(T.children,V,s,C);v?T.lastDiffIds?(0,n.$5b)(T.lastDiffIds,V,s,C.map(q=>v.getId(q.element).toString())):T.lastDiffIds=T.children.map(q=>v.getId(q.element).toString()):T.lastDiffIds=void 0;let I=0;for(const q of x)q.visible&&I++;if(I!==0)for(let q=V+C.length;q<T.children.length;q++){const J=T.children[q];J.visible&&(J.visibleChildIndex-=I)}if(T.visibleChildrenCount+=E-I,d&&c){const q=x.reduce((J,G)=>J+(G.visible?G.renderNodeCount:0),0);this.C(T,O-q),this.q.splice(S,q,b)}if(x.length>0&&a){const q=J=>{a(J),J.children.forEach(q)};x.forEach(q)}this.m.fire({insertedNodes:C,deletedNodes:x});let _=T;for(;_;){if(_.visibility===i.TreeVisibility.Recurse){this.o.trigger(()=>this.refilter());break}_=_.parent}}rerender(e){if(e.length===0)throw new i.$aX(this.p,"Invalid tree location");const{node:s,listIndex:r,revealed:h}=this.G(e);s.visible&&h&&this.q.splice(r,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.$aX(this.p,"Invalid tree location");const{listIndex:r}=this.G(e);this.q.updateElementHeight(r,s)}has(e){return this.E(e)}getListIndex(e){const{listIndex:s,visible:r,revealed:h}=this.G(e);return r&&h?s:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,s){const r=this.F(e);typeof s>"u"&&(s=!r.collapsible);const h={collapsible:s};return this.d.bufferEvents(()=>this.u(e,h))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,s,r){const h=this.F(e);typeof s>"u"&&(s=!h.collapsed);const a={collapsed:s,recursive:r||!1};return this.d.bufferEvents(()=>this.u(e,a))}u(e,s){const{node:r,listIndex:h,revealed:a}=this.G(e),v=this.v(r,h,a,s);if(r!==this.c&&this.l&&v&&!y(s)&&r.collapsible&&!r.collapsed&&!s.recursive){let T=-1;for(let S=0;S<r.children.length;S++)if(r.children[S].visible)if(T>-1){T=-1;break}else T=S;T>-1&&this.u([...e,T],s)}return v}v(e,s,r,h){const a=this.w(e,h,!1);if(!r||!e.visible||!a)return a;const v=e.renderNodeCount,T=this.y(e),S=v-(s===-1?0:1);return this.q.splice(s+1,S,T.slice(1)),a}w(e,s,r){let h;if(e===this.c?h=!1:(y(s)?(h=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(h=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):h=!1,h&&this.f.fire({node:e,deep:r})),!y(s)&&s.recursive)for(const a of e.children)h=this.w(a,s,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let s=this.F(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.A(this.c);this.q.splice(0,e,s),this.o.cancel()}x(e,s,r,h,a,v){const T={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0},S=this.D(T,r);T.visibility=S,h&&a.push(T);const d=e.children||D.Iterable.empty(),c=h&&S!==i.TreeVisibility.Hidden&&!T.collapsed;let b=0,A=1;for(const V of d){const U=this.x(V,T,S,c,a,v);T.children.push(U),A+=U.renderNodeCount,U.visible&&(U.visibleChildIndex=b++)}return this.j||(T.collapsible=T.collapsible||T.children.length>0),T.visibleChildrenCount=b,T.visible=S===i.TreeVisibility.Recurse?b>0:S===i.TreeVisibility.Visible,T.visible?T.collapsed||(T.renderNodeCount=A):(T.renderNodeCount=0,h&&a.pop()),v?.(T),T}y(e){const s=e.renderNodeCount,r=[];return this.z(e,r),this.C(e.parent,r.length-s),r}z(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this.z(r,s);return this.g.fire(e),e.renderNodeCount}A(e){const s=e.renderNodeCount,r=[];return this.B(e,e.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,r),this.C(e.parent,r.length-s),r}B(e,s,r,h=!0){let a;if(e!==this.c){if(a=this.D(e,s),a===i.TreeVisibility.Hidden)return e.visible=!1,e.renderNodeCount=0,!1;h&&r.push(e)}const v=r.length;e.renderNodeCount=e===this.c?0:1;let T=!1;if(!e.collapsed||a!==i.TreeVisibility.Hidden){let S=0;for(const d of e.children)T=this.B(d,a,r,h&&!e.collapsed)||T,d.visible&&(d.visibleChildIndex=S++);e.visibleChildrenCount=S}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=a===i.TreeVisibility.Recurse?T:a===i.TreeVisibility.Visible,e.visibility=a),e.visible?e.collapsed||(e.renderNodeCount+=r.length-v):(e.renderNodeCount=0,h&&r.pop()),this.g.fire(e),e.visible}C(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}D(e,s){const r=this.k?this.k.filter(e.element,s):i.TreeVisibility.Visible;return typeof r=="boolean"?(e.filterData=void 0,r?i.TreeVisibility.Visible:i.TreeVisibility.Hidden):f(r)?(e.filterData=r.data,p(r.visibility)):(e.filterData=void 0,p(r))}E(e,s=this.c){if(!e||e.length===0)return!0;const[r,...h]=e;return r<0||r>s.children.length?!1:this.E(h,s.children[r])}F(e,s=this.c){if(!e||e.length===0)return s;const[r,...h]=e;if(r<0||r>s.children.length)throw new i.$aX(this.p,"Invalid tree location");return this.F(h,s.children[r])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:r,revealed:h,visible:a}=this.H(e),v=e[e.length-1];if(v<0||v>s.children.length)throw new i.$aX(this.p,"Invalid tree location");const T=s.children[v];return{node:T,listIndex:r,revealed:h,visible:a&&T.visible}}H(e,s=this.c,r=0,h=!0,a=!0){const[v,...T]=e;if(v<0||v>s.children.length)throw new i.$aX(this.p,"Invalid tree location");for(let S=0;S<v;S++)r+=s.children[S].renderNodeCount;return h=h&&!s.collapsed,a=a&&s.visible,T.length===0?{parentNode:s,listIndex:r,revealed:h,visible:a}:this.H(T,s.children[v],r+1,h,a)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const s=[];let r=e;for(;r.parent;)s.push(r.parent.children.indexOf(r)),r=r.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,n.$tb)(e)[0]}getFirstElementChild(e){const s=this.F(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.F(e);if(s.children.length!==0)return this.I(s)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$eX=$}),define(pe[116],we([1,0,72,34,36]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lX=void 0;class F{get size(){return this.d.size}constructor(w,D,f={}){this.k=w,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$eX(w,D,null,f),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,f.sorter&&(this.j={compare(p,y){return f.sorter.compare(p.element,y.element)}}),this.h=f.identityProvider}setChildren(w,D=P.Iterable.empty(),f={}){const p=this.o(w);this.l(p,this.m(D),f)}l(w,D=P.Iterable.empty(),f){const p=new Set,y=new Set,$=e=>{if(e.element===null)return;const s=e;if(p.add(s.element),this.d.set(s.element,s),this.h){const r=this.h.getId(s.element).toString();y.add(r),this.f.set(r,s)}f.onDidCreateNode?.(s)},m=e=>{if(e.element===null)return;const s=e;if(p.has(s.element)||this.d.delete(s.element),this.h){const r=this.h.getId(s.element).toString();y.has(r)||this.f.delete(r)}f.onDidDeleteNode?.(s)};this.c.splice([...w,0],Number.MAX_VALUE,D,{...f,onDidCreateNode:$,onDidDeleteNode:m})}m(w=P.Iterable.empty()){return this.j&&(w=[...w].sort(this.j.compare.bind(this.j))),P.Iterable.map(w,D=>{let f=this.d.get(D.element);if(!f&&this.h){const $=this.h.getId(D.element).toString();f=this.f.get($)}if(!f){let $;return typeof D.collapsed>"u"?$=void 0:D.collapsed===n.ObjectTreeElementCollapseState.Collapsed||D.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed?$=!0:D.collapsed===n.ObjectTreeElementCollapseState.Expanded||D.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?$=!1:$=!!D.collapsed,{...D,children:this.m(D.children),collapsed:$}}const p=typeof D.collapsible=="boolean"?D.collapsible:f.collapsible;let y;return typeof D.collapsed>"u"||D.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed||D.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?y=f.collapsed:D.collapsed===n.ObjectTreeElementCollapseState.Collapsed?y=!0:D.collapsed===n.ObjectTreeElementCollapseState.Expanded?y=!1:y=!!D.collapsed,{...D,collapsible:p,collapsed:y,children:this.m(D.children)}})}rerender(w){const D=this.o(w);this.c.rerender(D)}updateElementHeight(w,D){const f=this.o(w);this.c.updateElementHeight(f,D)}resort(w=null,D=!0){if(!this.j)return;const f=this.o(w),p=this.c.getNode(f);this.l(f,this.n(p,D),{})}n(w,D,f=!0){let p=[...w.children];return(D||f)&&(p=p.sort(this.j.compare.bind(this.j))),P.Iterable.map(p,y=>({element:y.element,collapsible:y.collapsible,collapsed:y.collapsed,children:this.n(y,D,!1)}))}getFirstElementChild(w=null){const D=this.o(w);return this.c.getFirstElementChild(D)}getLastElementAncestor(w=null){const D=this.o(w);return this.c.getLastElementAncestor(D)}has(w){return this.d.has(w)}getListIndex(w){const D=this.o(w);return this.c.getListIndex(D)}getListRenderCount(w){const D=this.o(w);return this.c.getListRenderCount(D)}isCollapsible(w){const D=this.o(w);return this.c.isCollapsible(D)}setCollapsible(w,D){const f=this.o(w);return this.c.setCollapsible(f,D)}isCollapsed(w){const D=this.o(w);return this.c.isCollapsed(D)}setCollapsed(w,D,f){const p=this.o(w);return this.c.setCollapsed(p,D,f)}expandTo(w){const D=this.o(w);this.c.expandTo(D)}refilter(){this.c.refilter()}getNode(w=null){if(w===null)return this.c.getNode(this.c.rootRef);const D=this.d.get(w);if(!D)throw new n.$aX(this.k,`Tree element not found: ${w}`);return D}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new n.$aX(this.k,"Invalid getParentNodeLocation call");const D=this.d.get(w);if(!D)throw new n.$aX(this.k,`Tree element not found: ${w}`);const f=this.c.getNodeLocation(D),p=this.c.getParentNodeLocation(f);return this.c.getNode(p).element}o(w){if(w===null)return[];const D=this.d.get(w);if(!D)throw new n.$aX(this.k,`Tree element not found: ${w}`);return this.c.getNodeLocation(D)}}t.$lX=F}),define(pe[23],we([1,0,4,15,19,32,2]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vU=void 0,i=He(i);class w extends N.$Vc{f(f,p){this.B(i.$KS(f,i.$LT.CLICK,y=>p(new P.$CS(i.getWindow(f),y))))}j(f,p){this.B(i.$KS(f,i.$LT.MOUSE_DOWN,y=>p(new P.$CS(i.getWindow(f),y))))}m(f,p){this.B(i.$KS(f,i.$LT.MOUSE_OVER,y=>p(new P.$CS(i.getWindow(f),y))))}u(f,p){this.B(i.$KS(f,i.$LT.MOUSE_LEAVE,y=>p(new P.$CS(i.getWindow(f),y))))}z(f,p){this.B(i.$KS(f,i.$LT.KEY_DOWN,y=>p(new n.$HS(y))))}C(f,p){this.B(i.$KS(f,i.$LT.KEY_UP,y=>p(new n.$HS(y))))}D(f,p){this.B(i.$KS(f,i.$LT.INPUT,p))}F(f,p){this.B(i.$KS(f,i.$LT.BLUR,p))}G(f,p){this.B(i.$KS(f,i.$LT.FOCUS,p))}H(f,p){this.B(i.$KS(f,i.$LT.CHANGE,p))}I(f){return F.$rU.ignoreTarget(f)}}t.$vU=w}),define(pe[51],we([1,0,71,23,12,22,4]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xU=t.$wU=void 0,N=He(N),t.$wU=11;class w extends n.$vU{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...F.ThemeIcon.asClassNameArray(f.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$wU+"px",this.domNode.style.height=t.$wU+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new i.$uU),this.B(N.$LS(this.bgDomNode,N.$LT.POINTER_DOWN,p=>this.h(p))),this.B(N.$LS(this.domNode,N.$LT.POINTER_DOWN,p=>this.h(p))),this.b=this.B(new N.$WS),this.c=this.B(new P.$Qh)}h(f){if(!f.target||!(f.target instanceof Element))return;const p=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,N.getWindow(f))};this.a(),this.b.cancel(),this.c.cancelAndSet(p,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,y=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.$xU=w}),define(pe[73],we([1,0,4,55,71,51,114,23,5]),function(oe,t,i,n,P,F,N,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AU=void 0,i=He(i),D=He(D);const f=140;class p extends w.$vU{constructor($){super(),this.g=$.lazyRender,this.a=$.host,this.b=$.scrollable,this.c=$.scrollByPage,this.h=$.scrollbarState,this.n=this.B(new N.$zU($.visibility,"visible scrollbar "+$.extraScrollbarClassName,"invisible scrollbar "+$.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new P.$uU),this.s=!0,this.domNode=(0,n.$tU)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$KS(this.domNode.domNode,i.$LT.POINTER_DOWN,m=>this.M(m)))}t($){const m=this.B(new F.$xU($));this.domNode.domNode.appendChild(m.bgDomNode),this.domNode.domNode.appendChild(m.domNode)}w($,m,e,s){this.slider=(0,n.$tU)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop($),this.slider.setLeft(m),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$KS(this.slider.domNode,i.$LT.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this.O(r))})),this.f(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}y($){return this.h.setVisibleSize($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J($){return this.h.setScrollSize($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L($){return this.h.setScrollPosition($)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M($){$.target===this.domNode.domNode&&this.N($)}delegatePointerDown($){const m=this.domNode.domNode.getClientRects()[0].top,e=m+this.h.getSliderPosition(),s=m+this.h.getSliderPosition()+this.h.getSliderSize(),r=this.U($);e<=r&&r<=s?$.button===0&&($.preventDefault(),this.O($)):this.N($)}N($){let m,e;if($.target===this.domNode.domNode&&typeof $.offsetX=="number"&&typeof $.offsetY=="number")m=$.offsetX,e=$.offsetY;else{const r=i.$7S(this.domNode.domNode);m=$.pageX-r.left,e=$.pageY-r.top}const s=this.S(m,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),$.button===0&&($.preventDefault(),this.O($))}O($){if(!$.target||!($.target instanceof Element))return;const m=this.U($),e=this.W($),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring($.target,$.pointerId,$.buttons,r=>{const h=this.W(r),a=Math.abs(h-e);if(D.$j&&a>f){this.P(s.getScrollPosition());return}const T=this.U(r)-m;this.P(s.getDesiredScrollPositionFromDelta(T))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P($){const m={};this.writeScrollPosition(m,$),this.b.setScrollPositionNow(m)}updateScrollbarSize($){this.X($),this.h.setScrollbarSize($),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$AU=p}),define(pe[117],we([1,0,19,73,51,56,21,20]),function(oe,t,i,n,P,F,N,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BU=void 0;class D extends n.$AU{constructor(p,y,$){const m=p.getScrollDimensions(),e=p.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:$,scrollbarState:new F.$yU(y.horizontalHasArrows?y.arrowSize:0,y.horizontal===w.ScrollbarVisibility.Hidden?0:y.horizontalScrollbarSize,y.vertical===w.ScrollbarVisibility.Hidden?0:y.verticalScrollbarSize,m.width,m.scrollWidth,e.scrollLeft),visibility:y.horizontal,extraScrollbarClassName:"horizontal",scrollable:p,scrollByPage:y.scrollByPage}),y.horizontalHasArrows){const s=(y.arrowSize-P.$wU)/2,r=(y.horizontalScrollbarSize-P.$wU)/2;this.t({className:"scra",icon:N.$6j.scrollbarButtonLeft,top:r,left:s,bottom:void 0,right:void 0,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$ES(null,1,0))}),this.t({className:"scra",icon:N.$6j.scrollbarButtonRight,top:r,left:void 0,bottom:void 0,right:s,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$ES(null,-1,0))})}this.w(Math.floor((y.horizontalScrollbarSize-y.horizontalSliderSize)/2),0,void 0,y.horizontalSliderSize)}R(p,y){this.slider.setWidth(p),this.slider.setLeft(y)}Q(p,y){this.domNode.setWidth(p),this.domNode.setHeight(y),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(p){return this.s=this.J(p.scrollWidth)||this.s,this.s=this.L(p.scrollLeft)||this.s,this.s=this.y(p.width)||this.s,this.s}S(p,y){return p}U(p){return p.pageX}W(p){return p.pageY}X(p){this.slider.setHeight(p)}writeScrollPosition(p,y){p.scrollLeft=y}updateOptions(p){this.updateScrollbarSize(p.horizontal===w.ScrollbarVisibility.Hidden?0:p.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(p.vertical===w.ScrollbarVisibility.Hidden?0:p.verticalScrollbarSize),this.n.setVisibility(p.horizontal),this.c=p.scrollByPage}}t.$BU=D}),define(pe[118],we([1,0,19,73,51,56,21,20]),function(oe,t,i,n,P,F,N,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CU=void 0;class D extends n.$AU{constructor(p,y,$){const m=p.getScrollDimensions(),e=p.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:$,scrollbarState:new F.$yU(y.verticalHasArrows?y.arrowSize:0,y.vertical===w.ScrollbarVisibility.Hidden?0:y.verticalScrollbarSize,0,m.height,m.scrollHeight,e.scrollTop),visibility:y.vertical,extraScrollbarClassName:"vertical",scrollable:p,scrollByPage:y.scrollByPage}),y.verticalHasArrows){const s=(y.arrowSize-P.$wU)/2,r=(y.verticalScrollbarSize-P.$wU)/2;this.t({className:"scra",icon:N.$6j.scrollbarButtonUp,top:s,left:r,bottom:void 0,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$ES(null,0,1))}),this.t({className:"scra",icon:N.$6j.scrollbarButtonDown,top:void 0,left:r,bottom:s,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$ES(null,0,-1))})}this.w(0,Math.floor((y.verticalScrollbarSize-y.verticalSliderSize)/2),y.verticalSliderSize,void 0)}R(p,y){this.slider.setHeight(p),this.slider.setTop(y)}Q(p,y){this.domNode.setWidth(y),this.domNode.setHeight(p),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(p){return this.s=this.J(p.scrollHeight)||this.s,this.s=this.L(p.scrollTop)||this.s,this.s=this.y(p.height)||this.s,this.s}S(p,y){return y}U(p){return p.pageY}W(p){return p.pageX}X(p){this.slider.setWidth(p)}writeScrollPosition(p,y){p.scrollTop=y}updateOptions(p){this.updateScrollbarSize(p.vertical===w.ScrollbarVisibility.Hidden?0:p.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(p.vertical),this.c=p.scrollByPage}}t.$CU=D}),define(pe[119],we([1,0,6,67,50,11,16]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5k=t.MarkdownStringTextNewlineStyle=void 0,t.$6k=f,t.$7k=p,t.$8k=y,t.$9k=$,t.$0k=m,t.$$k=e,t.$_k=s,t.$al=r;var w;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(w||(t.MarkdownStringTextNewlineStyle=w={}));class D{constructor(a="",v=!1){if(this.value=a,typeof this.value!="string")throw(0,i.$7)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(a,v=w.Paragraph){return this.value+=$(this.supportThemeIcons?(0,n.$Yk)(a):a).replace(/([ \t]+)/g,(T,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===w.Break?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,v){return this.value+=`
${m(v,a)}
`,this}appendLink(a,v,T){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(a),")"),T&&(this.value+=` "${this.c(this.c(T,'"'),")")}"`),this.value+=")",this}c(a,v){const T=new RegExp((0,F.$if)(v),"g");return a.replace(T,(S,d)=>a.charAt(d-1)!=="\\"?`\\${S}`:S)}}t.$5k=D;function f(h){return p(h)?!h.value:Array.isArray(h)?h.every(f):!0}function p(h){return h instanceof D?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function y(h,a){return h===a?!0:!h||!a?!1:h.value===a.value&&h.isTrusted===a.isTrusted&&h.supportThemeIcons===a.supportThemeIcons&&h.supportHtml===a.supportHtml&&(h.baseUri===a.baseUri||!!h.baseUri&&!!a.baseUri&&(0,P.$ah)(N.URI.from(h.baseUri),N.URI.from(a.baseUri)))}function $(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(h,a){const v=h.match(/^`+/gm)?.reduce((S,d)=>S.length>d.length?S:d).length??0,T=v>=3?v+1:3;return[`${"`".repeat(T)}${a}`,h,`${"`".repeat(T)}`].join(`
`)}function e(h){return h.replace(/"/g,"&quot;")}function s(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(h){const a=[],v=h.split("|").map(S=>S.trim());h=v[0];const T=v[1];if(T){const S=/height=(\d+)/.exec(T),d=/width=(\d+)/.exec(T),c=S?S[1]:"",b=d?d[1]:"",A=isFinite(parseInt(b)),V=isFinite(parseInt(c));A&&a.push(`width="${b}"`),V&&a.push(`height="${c}"`)}return{href:h,dimensions:a}}}),define(pe[120],we([1,0,4,111,29,70,15,19,112,6,3,119,67,90,8,25,2,92,68,39,64,50,11,16]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$,m,e,s,r,h,a,v,T,S,d,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vV=void 0,t.$uV=A,t.$wV=x,t.$xV=I,t.$yV=ne,i=He(i),n=He(n);const b=Object.freeze({image:(l,o,g)=>{let M=[],k=[];return l&&({href:l,dimensions:M}=(0,y.$al)(l),k.push(`src="${(0,y.$$k)(l)}"`)),g&&k.push(`alt="${(0,y.$$k)(g)}"`),o&&k.push(`title="${(0,y.$$k)(o)}"`),M.length&&(k=k.concat(M)),"<img "+k.join(" ")+">"},paragraph:l=>`<p>${l}</p>`,link:(l,o,g)=>typeof l!="string"?"":(l===g&&(g=(0,y.$_k)(g)),o=typeof o=="string"?(0,y.$$k)((0,y.$_k)(o)):"",l=(0,y.$_k)(l),l=l.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${l}" title="${o||l}" draggable="false">${g}</a>`)});function A(l,o={},g={}){const M=new r.$Uc;let k=!1;const u=(0,F.$XU)(o),L=function(ve){let Ee;try{Ee=(0,a.$ci)(decodeURIComponent(ve))}catch{}return Ee?(Ee=(0,T.$ho)(Ee,Ne=>{if(l.uris&&l.uris[Ne])return c.URI.revive(l.uris[Ne])}),encodeURIComponent(JSON.stringify(Ee))):ve},R=function(ve,Ee){const Ne=l.uris&&l.uris[ve];let fe=c.URI.revive(Ne);return Ee?ve.startsWith(v.Schemas.data+":")?ve:(fe||(fe=c.URI.parse(ve)),v.$1g.uriToBrowserUri(fe).toString(!0)):!fe||c.URI.parse(ve).toString()===fe.toString()?ve:(fe.query&&(fe=fe.with({query:L(fe.query)})),fe.toString())},B=new h.marked.Renderer;B.image=b.image,B.link=b.link,B.paragraph=b.paragraph;const H=[],Y=[];if(o.codeBlockRendererSync?B.code=(ve,Ee)=>{const Ne=m.$uQ.nextId(),fe=o.codeBlockRendererSync(V(Ee),ve);return Y.push([Ne,fe]),`<div class="code" data-code="${Ne}">${(0,d.$hf)(ve)}</div>`}:o.codeBlockRenderer&&(B.code=(ve,Ee)=>{const Ne=m.$uQ.nextId(),fe=o.codeBlockRenderer(V(Ee),ve);return H.push(fe.then(Fe=>[Ne,Fe])),`<div class="code" data-code="${Ne}">${(0,d.$hf)(ve)}</div>`}),o.actionHandler){const ve=function(fe){let Fe=fe.target;if(!(Fe.tagName!=="A"&&(Fe=Fe.parentElement,!Fe||Fe.tagName!=="A")))try{let Ke=Fe.dataset.href;Ke&&(l.baseUri&&(Ke=U(c.URI.from(l.baseUri),Ke)),o.actionHandler.callback(Ke,fe))}catch(Ke){(0,f.$Z)(Ke)}finally{fe.preventDefault()}},Ee=o.actionHandler.disposables.add(new P.$YU(u,"click")),Ne=o.actionHandler.disposables.add(new P.$YU(u,"auxclick"));o.actionHandler.disposables.add(p.Event.any(Ee.event,Ne.event)(fe=>{const Fe=new w.$CS(i.getWindow(u),fe);!Fe.leftButton&&!Fe.middleButton||ve(Fe)})),o.actionHandler.disposables.add(i.$KS(u,"keydown",fe=>{const Fe=new N.$HS(fe);!Fe.equals(e.KeyCode.Space)&&!Fe.equals(e.KeyCode.Enter)||ve(Fe)}))}l.supportHtml||(g.sanitizer=ve=>o.sanitizerOptions?.replaceWithPlaintext?(0,d.$hf)(ve):(l.isTrusted?ve.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?ve:"",g.sanitize=!0,g.silent=!0),g.renderer=B;let ie=l.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`),l.supportThemeIcons&&(ie=(0,$.$Zk)(ie));let re;if(o.fillInIncompleteTokens){const ve={...h.marked.defaults,...g},Ee=h.marked.lexer(ie,ve),Ne=ne(Ee);re=h.marked.parser(Ne,ve)}else re=h.marked.parse(ie,g);l.supportThemeIcons&&(re=(0,D.$sV)(re).map(Ee=>typeof Ee=="string"?Ee:Ee.outerHTML).join(""));const De=new DOMParser().parseFromString(E({isTrusted:l.isTrusted,...o.sanitizerOptions},re),"text/html");if(De.body.querySelectorAll("img, audio, video, source").forEach(ve=>{const Ee=ve.getAttribute("src");if(Ee){let Ne=Ee;try{l.baseUri&&(Ne=U(c.URI.from(l.baseUri),Ne))}catch{}if(ve.setAttribute("src",R(Ne,!0)),o.remoteImageIsAllowed){const fe=c.URI.parse(Ne);fe.scheme!==v.Schemas.file&&fe.scheme!==v.Schemas.data&&!o.remoteImageIsAllowed(fe)&&ve.replaceWith(i.$("",void 0,ve.outerHTML))}}}),De.body.querySelectorAll("a").forEach(ve=>{const Ee=ve.getAttribute("href");if(ve.setAttribute("href",""),!Ee||/^data:|javascript:/i.test(Ee)||/^command:/i.test(Ee)&&!l.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(Ee))ve.replaceWith(...ve.childNodes);else{let Ne=R(Ee,!1);l.baseUri&&(Ne=U(c.URI.from(l.baseUri),Ee)),ve.dataset.href=Ne}}),u.innerHTML=E({isTrusted:l.isTrusted,...o.sanitizerOptions},De.body.innerHTML),H.length>0)Promise.all(H).then(ve=>{if(k)return;const Ee=new Map(ve),Ne=u.querySelectorAll("div[data-code]");for(const fe of Ne){const Fe=Ee.get(fe.dataset.code??"");Fe&&i.$UT(fe,Fe)}o.asyncRenderCallback?.()});else if(Y.length>0){const ve=new Map(Y),Ee=u.querySelectorAll("div[data-code]");for(const Ne of Ee){const fe=ve.get(Ne.dataset.code??"");fe&&i.$UT(Ne,fe)}}if(o.asyncRenderCallback)for(const ve of u.getElementsByTagName("img")){const Ee=M.add(i.$KS(ve,"load",()=>{Ee.dispose(),o.asyncRenderCallback()}))}return{element:u,dispose:()=>{k=!0,M.dispose()}}}function V(l){if(!l)return"";const o=l.split(/[\s+|:|,|\{|\?]/,1);return o.length?o[0]:l}function U(l,o){return/^\w[\w\d+.-]*:/.test(o)?o:l.path.endsWith("/")?(0,S.$kh)(l,o).toString():(0,S.$kh)((0,S.$gh)(l),o).toString()}const C=["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"];function E(l,o){const{config:g,allowedSchemes:M}=O(l),k=new r.$Uc;k.add(j("uponSanitizeAttribute",(u,L)=>{if(L.attrName==="style"||L.attrName==="class"){if(u.tagName==="SPAN"){if(L.attrName==="style"){L.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(border-radius:[0-9]+px;)?$/.test(L.attrValue);return}else if(L.attrName==="class"){L.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(L.attrValue);return}}L.keepAttr=!1;return}else if(u.tagName==="INPUT"&&u.attributes.getNamedItem("type")?.value==="checkbox"){if(L.attrName==="type"&&L.attrValue==="checkbox"||L.attrName==="disabled"||L.attrName==="checked"){L.keepAttr=!0;return}L.keepAttr=!1}})),k.add(j("uponSanitizeElement",(u,L)=>{if(L.tagName==="input"&&(u.attributes.getNamedItem("type")?.value==="checkbox"?u.setAttribute("disabled",""):l.replaceWithPlaintext||u.remove()),l.replaceWithPlaintext&&!L.allowedTags[L.tagName]&&L.tagName!=="body"&&u.parentElement){let R,B;if(L.tagName==="#comment")R=`<!--${u.textContent}-->`;else{const re=C.includes(L.tagName),he=u.attributes.length?" "+Array.from(u.attributes).map(De=>`${De.name}="${De.value}"`).join(" "):"";R=`<${L.tagName}${he}>`,re||(B=`</${L.tagName}>`)}const H=document.createDocumentFragment(),Y=u.parentElement.ownerDocument.createTextNode(R);H.appendChild(Y);const ie=B?u.parentElement.ownerDocument.createTextNode(B):void 0;for(;u.firstChild;)H.appendChild(u.firstChild);ie&&H.appendChild(ie),u.parentElement.replaceChild(H,u)}})),k.add(i.$cU(M));try{return n.sanitize(o,{...g,RETURN_TRUSTED_TYPE:!0})}finally{k.dispose()}}t.$vV=["align","autoplay","alt","checked","class","colspan","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","rowspan","src","style","target","title","type","width","start"];function O(l){const o=[v.Schemas.http,v.Schemas.https,v.Schemas.mailto,v.Schemas.data,v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemote,v.Schemas.vscodeRemoteResource];return l.isTrusted&&o.push(v.Schemas.command),{config:{ALLOWED_TAGS:l.allowedTags??[...i.$dU],ALLOWED_ATTR:t.$vV,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:o}}function x(l){return typeof l=="string"?l:I(l)}function I(l,o){let g=l.value??"";g.length>1e5&&(g=`${g.substr(0,1e5)}\u2026`);const M=h.marked.parse(g,{renderer:o?G.value:J.value}).replace(/&(#\d+|[a-zA-Z]+);/g,k=>_.get(k)??k);return E({isTrusted:!1},M).toString()}const _=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]);function q(){const l=new h.marked.Renderer;return l.code=o=>o,l.blockquote=o=>o,l.html=o=>"",l.heading=(o,g,M)=>o+`
`,l.hr=()=>"",l.list=(o,g)=>o,l.listitem=o=>o+`
`,l.paragraph=o=>o+`
`,l.table=(o,g)=>o+g+`
`,l.tablerow=o=>o,l.tablecell=(o,g)=>o+" ",l.strong=o=>o,l.em=o=>o,l.codespan=o=>o,l.br=()=>`
`,l.del=o=>o,l.image=(o,g,M)=>"",l.text=o=>o,l.link=(o,g,M)=>M,l}const J=new s.$U(l=>q()),G=new s.$U(()=>{const l=q();return l.code=o=>`
\`\`\`
${o}
\`\`\`
`,l});function K(l){let o="";return l.forEach(g=>{o+=g.raw}),o}function Q(l){if(l.tokens)for(let o=l.tokens.length-1;o>=0;o--){const g=l.tokens[o];if(g.type==="text"){const M=g.raw.split(`
`),k=M[M.length-1];if(k.includes("`"))return le(l);if(k.includes("**"))return Ie(l);if(k.match(/\*\w/))return ke(l);if(k.match(/(^|\s)__\w/))return je(l);if(k.match(/(^|\s)_\w/))return te(l);if(ae(k)||me(k)&&l.tokens.slice(0,o).some(u=>u.type==="text"&&u.raw.match(/\[[^\]]*$/))){const u=l.tokens.slice(o+1);return u[0]?.type==="link"&&u[1]?.type==="text"&&u[1].raw.match(/^ *"[^"]*$/)||k.match(/^[^"]* +"[^"]*$/)?Ae(l):be(l)}else if(k.match(/(^|\s)\[\w*/))return Re(l)}}}function ae(l){return!!l.match(/(^|\s)\[.*\]\(\w*/)}function me(l){return!!l.match(/^[^\[]*\]\([^\)]*$/)}function ye(l){const o=l.items[l.items.length-1],g=o.tokens?o.tokens[o.tokens.length-1]:void 0;let M;if(g?.type==="text"&&!("inRawBlock"in o)&&(M=Q(g)),!M||M.type!=="paragraph")return;const k=K(l.items.slice(0,-1)),u=o.raw.match(/^(\s*(-|\d+\.|\*) +)/)?.[0];if(!u)return;const L=u+K(o.tokens.slice(0,-1))+M.raw,R=h.marked.lexer(k+L)[0];if(R.type==="list")return R}const Le=3;function ne(l){for(let o=0;o<Le;o++){const g=ee(l);if(g)l=g;else break}return l}function ee(l){let o,g;for(o=0;o<l.length;o++){const M=l[o];let k;if(M.type==="paragraph"&&(k=M.raw.match(/(\n|^)(````*)/))){const u=k[2];g=ce(l.slice(o),u);break}if(M.type==="paragraph"&&M.raw.match(/(\n|^)\|/)){g=W(l.slice(o));break}if(o===l.length-1&&M.type==="list"){const u=ye(M);if(u){g=[u];break}}if(o===l.length-1&&M.type==="paragraph"){const u=Q(M);if(u){g=[u];break}}}if(g){const M=[...l.slice(0,o),...g];return M.links=l.links,M}return null}function ce(l,o){const g=K(l);return h.marked.lexer(g+`
${o}`)}function le(l){return _e(l,"`")}function ke(l){return _e(l,"*")}function te(l){return _e(l,"_")}function be(l){return _e(l,")")}function Ae(l){return _e(l,'")')}function Re(l){return _e(l,"](https://microsoft.com)")}function Ie(l){return _e(l,"**")}function je(l){return _e(l,"__")}function _e(l,o){const g=K(Array.isArray(l)?l:[l]);return h.marked.lexer(g+o)[0]}function W(l){const o=K(l),g=o.split(`
`);let M,k=!1;for(let u=0;u<g.length;u++){const L=g[u].trim();if(typeof M>"u"&&L.match(/^\s*\|/)){const R=L.match(/(\|[^\|]+)(?=\||$)/g);R&&(M=R.length)}else if(typeof M=="number")if(L.match(/^\s*\|/)){if(u!==g.length-1)return;k=!0}else return}if(typeof M=="number"&&M>0){const u=k?g.slice(0,-1).join(`
`):o,L=!!u.match(/\|\s*$/),R=u+(L?"":"|")+`
|${" --- |".repeat(M)}`;return h.marked.lexer(R)}}function j(l,o){return n.addHook(l,o),(0,r.$Tc)(()=>n.removeHook(l))}}),define(pe[121],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZX=t.$YX=void 0,t.$YX="vscode:contextmenu",t.$ZX="vscode:onCloseContextMenu"}),define(pe[74],we([1,0,9,12,47,38,35,6,3,2,68,11,10]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pi=t.ProxyChannel=t.$oi=t.$li=t.$ki=t.$ji=t.RequestInitiator=t.$ii=t.$fi=t.$ei=void 0,t.$gi=U,t.$hi=C,t.$mi=q,t.$ni=J,y=He(y);var m;(function(ne){ne[ne.Promise=100]="Promise",ne[ne.PromiseCancel=101]="PromiseCancel",ne[ne.EventListen=102]="EventListen",ne[ne.EventDispose=103]="EventDispose"})(m||(m={}));function e(ne){switch(ne){case m.Promise:return"req";case m.PromiseCancel:return"cancel";case m.EventListen:return"subscribe";case m.EventDispose:return"unsubscribe"}}var s;(function(ne){ne[ne.Initialize=200]="Initialize",ne[ne.PromiseSuccess=201]="PromiseSuccess",ne[ne.PromiseError=202]="PromiseError",ne[ne.PromiseErrorObj=203]="PromiseErrorObj",ne[ne.EventFire=204]="EventFire"})(s||(s={}));function r(ne){switch(ne){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var h;(function(ne){ne[ne.Uninitialized=0]="Uninitialized",ne[ne.Idle=1]="Idle"})(h||(h={}));function a(ne){let ee=0;for(let ce=0;;ce+=7){const le=ne.read(1);if(ee|=(le.buffer[0]&127)<<ce,!(le.buffer[0]&128))return ee}}const v=b(0);function T(ne,ee){if(ee===0){ne.write(v);return}let ce=0;for(let ke=ee;ke!==0;ke=ke>>>7)ce++;const le=P.$Oe.alloc(ce);for(let ke=0;ee!==0;ke++)le.buffer[ke]=ee&127,ee=ee>>>7,ee>0&&(le.buffer[ke]|=128);ne.write(le)}class S{constructor(ee){this.b=ee,this.a=0}read(ee){const ce=this.b.slice(this.a,this.a+ee);return this.a+=ce.byteLength,ce}}t.$ei=S;class d{constructor(){this.a=[]}get buffer(){return P.$Oe.concat(this.a)}write(ee){this.a.push(ee)}}t.$fi=d;var c;(function(ne){ne[ne.Undefined=0]="Undefined",ne[ne.String=1]="String",ne[ne.Buffer=2]="Buffer",ne[ne.VSBuffer=3]="VSBuffer",ne[ne.Array=4]="Array",ne[ne.Object=5]="Object",ne[ne.Int=6]="Int"})(c||(c={}));function b(ne){const ee=P.$Oe.alloc(1);return ee.writeUInt8(ne,0),ee}const A={Undefined:b(c.Undefined),String:b(c.String),Buffer:b(c.Buffer),VSBuffer:b(c.VSBuffer),Array:b(c.Array),Object:b(c.Object),Uint:b(c.Int)},V=typeof Buffer<"u";function U(ne,ee){if(typeof ee>"u")ne.write(A.Undefined);else if(typeof ee=="string"){const ce=P.$Oe.fromString(ee);ne.write(A.String),T(ne,ce.byteLength),ne.write(ce)}else if(V&&Buffer.isBuffer(ee)){const ce=P.$Oe.wrap(ee);ne.write(A.Buffer),T(ne,ce.byteLength),ne.write(ce)}else if(ee instanceof P.$Oe)ne.write(A.VSBuffer),T(ne,ee.byteLength),ne.write(ee);else if(Array.isArray(ee)){ne.write(A.Array),T(ne,ee.length);for(const ce of ee)U(ne,ce)}else if(typeof ee=="number"&&(ee|0)===ee)ne.write(A.Uint),T(ne,ee);else{const ce=P.$Oe.fromString(JSON.stringify(ee));ne.write(A.Object),T(ne,ce.byteLength),ne.write(ce)}}function C(ne){switch(ne.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return ne.read(a(ne)).toString();case c.Buffer:return ne.read(a(ne)).buffer;case c.VSBuffer:return ne.read(a(ne));case c.Array:{const ce=a(ne),le=[];for(let ke=0;ke<ce;ke++)le.push(C(ne));return le}case c.Object:return JSON.parse(ne.read(a(ne)).toString());case c.Int:return a(ne)}}class E{constructor(ee,ce,le=null,ke=1e3){this.h=ee,this.j=ce,this.k=le,this.l=ke,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:s.Initialize})}registerChannel(ee,ce){this.b.set(ee,ce),setTimeout(()=>this.w(ee),0)}m(ee){switch(ee.type){case s.Initialize:{const ce=this.o([ee.type]);this.k?.logOutgoing(ce,0,O.OtherSide,r(ee.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const ce=this.o([ee.type,ee.id],ee.data);this.k?.logOutgoing(ce,ee.id,O.OtherSide,r(ee.type),ee.data);return}}}o(ee,ce=void 0){const le=new d;return U(le,ee),U(le,ce),this.p(le.buffer)}p(ee){try{return this.h.send(ee),ee.byteLength}catch{return 0}}q(ee){const ce=new S(ee),le=C(ce),ke=C(ce),te=le[0];switch(te){case m.Promise:return this.k?.logIncoming(ee.byteLength,le[1],O.OtherSide,`${e(te)}: ${le[2]}.${le[3]}`,ke),this.s({type:te,id:le[1],channelName:le[2],name:le[3],arg:ke});case m.EventListen:return this.k?.logIncoming(ee.byteLength,le[1],O.OtherSide,`${e(te)}: ${le[2]}.${le[3]}`,ke),this.t({type:te,id:le[1],channelName:le[2],name:le[3],arg:ke});case m.PromiseCancel:return this.k?.logIncoming(ee.byteLength,le[1],O.OtherSide,`${e(te)}`),this.u({type:te,id:le[1]});case m.EventDispose:return this.k?.logIncoming(ee.byteLength,le[1],O.OtherSide,`${e(te)}`),this.u({type:te,id:le[1]})}}s(ee){const ce=this.b.get(ee.channelName);if(!ce){this.v(ee);return}const le=new F.$xe;let ke;try{ke=ce.call(this.j,ee.name,ee.arg,le.token)}catch(Ae){ke=Promise.reject(Ae)}const te=ee.id;ke.then(Ae=>{this.m({id:te,data:Ae,type:s.PromiseSuccess})},Ae=>{Ae instanceof Error?this.m({id:te,data:{message:Ae.message,name:Ae.name,stack:Ae.stack?Ae.stack.split(`
`):void 0},type:s.PromiseError}):this.m({id:te,data:Ae,type:s.PromiseErrorObj})}).finally(()=>{be.dispose(),this.d.delete(ee.id)});const be=(0,f.$Tc)(()=>le.cancel());this.d.set(ee.id,be)}t(ee){const ce=this.b.get(ee.channelName);if(!ce){this.v(ee);return}const le=ee.id,te=ce.listen(this.j,ee.name,ee.arg)(be=>this.m({id:le,data:be,type:s.EventFire}));this.d.set(ee.id,te)}u(ee){const ce=this.d.get(ee.id);ce&&(ce.dispose(),this.d.delete(ee.id))}v(ee){let ce=this.g.get(ee.channelName);ce||(ce=[],this.g.set(ee.channelName,ce));const le=setTimeout(()=>{console.error(`Unknown channel: ${ee.channelName}`),ee.type===m.Promise&&this.m({id:ee.id,data:{name:"Unknown channel",message:`Channel name '${ee.channelName}' timed out after ${this.l}ms`,stack:void 0},type:s.PromiseError})},this.l);ce.push({request:ee,timeoutTimer:le})}w(ee){const ce=this.g.get(ee);if(ce){for(const le of ce)switch(clearTimeout(le.timeoutTimer),le.request.type){case m.Promise:this.s(le.request);break;case m.EventListen:this.t(le.request);break}this.g.delete(ee)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Qc)(this.d.values()),this.d.clear()}}t.$ii=E;var O;(function(ne){ne[ne.LocalSide=0]="LocalSide",ne[ne.OtherSide=1]="OtherSide"})(O||(t.RequestInitiator=O={}));class x{constructor(ee,ce=null){this.l=ee,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new D.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=ce}getChannel(ee){const ce=this;return{call(le,ke,te){return ce.a?Promise.reject(new w.$5):ce.m(ee,le,ke,te)},listen(le,ke){return ce.a?D.Event.None:ce.o(ee,le,ke)}}}m(ee,ce,le,ke=F.CancellationToken.None){const te=this.g++,be=m.Promise,Ae={id:te,type:be,channelName:ee,name:ce,arg:le};if(ke.isCancellationRequested)return Promise.reject(new w.$5);let Re;return new Promise((je,_e)=>{if(ke.isCancellationRequested)return _e(new w.$5);const W=()=>{const g=M=>{switch(M.type){case s.PromiseSuccess:this.f.delete(te),je(M.data);break;case s.PromiseError:{this.f.delete(te);const k=new Error(M.data.message);k.stack=Array.isArray(M.data.stack)?M.data.stack.join(`
`):M.data.stack,k.name=M.data.name,_e(k);break}case s.PromiseErrorObj:this.f.delete(te),_e(M.data);break}};this.f.set(te,g),this.p(Ae)};let j=null;this.b===h.Idle?W():(j=(0,n.$th)(g=>this.u()),j.then(()=>{j=null,W()}));const l=()=>{j?(j.cancel(),j=null):this.p({id:te,type:m.PromiseCancel}),_e(new w.$5)},o=ke.onCancellationRequested(l);Re=(0,f.$Sc)((0,f.$Tc)(l),o),this.d.add(Re)}).finally(()=>{Re.dispose(),this.d.delete(Re)})}o(ee,ce,le){const ke=this.g++,te=m.EventListen,be={id:ke,type:te,channelName:ee,name:ce,arg:le};let Ae=null;const Re=new D.$me({onWillAddFirstListener:()=>{Ae=(0,n.$th)(je=>this.u()),Ae.then(()=>{Ae=null,this.d.add(Re),this.p(be)})},onDidRemoveLastListener:()=>{Ae?(Ae.cancel(),Ae=null):(this.d.delete(Re),this.p({id:ke,type:m.EventDispose}))}}),Ie=je=>Re.fire(je.data);return this.f.set(ke,Ie),Re.event}p(ee){switch(ee.type){case m.Promise:case m.EventListen:{const ce=this.q([ee.type,ee.id,ee.channelName,ee.name],ee.arg);this.j?.logOutgoing(ce,ee.id,O.LocalSide,`${e(ee.type)}: ${ee.channelName}.${ee.name}`,ee.arg);return}case m.PromiseCancel:case m.EventDispose:{const ce=this.q([ee.type,ee.id]);this.j?.logOutgoing(ce,ee.id,O.LocalSide,e(ee.type));return}}}q(ee,ce=void 0){const le=new d;return U(le,ee),U(le,ce),this.r(le.buffer)}r(ee){try{return this.l.send(ee),ee.byteLength}catch{return 0}}s(ee){const ce=new S(ee),le=C(ce),ke=C(ce),te=le[0];switch(te){case s.Initialize:return this.j?.logIncoming(ee.byteLength,0,O.LocalSide,r(te)),this.t({type:le[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.j?.logIncoming(ee.byteLength,le[1],O.LocalSide,r(te),ke),this.t({type:le[0],id:le[1],data:ke})}}t(ee){if(ee.type===s.Initialize){this.b=h.Idle,this.k.fire();return}this.f.get(ee.id)?.(ee)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Qc)(this.d.values()),this.d.clear()}}t.$ji=x,et([N.$$h],x.prototype,"onDidInitializePromise",null);class I{get connections(){const ee=[];return this.f.forEach(ce=>ee.push(ce)),ee}constructor(ee,ce,le){this.a=new Map,this.f=new Set,this.g=new D.$me,this.onDidAddConnection=this.g.event,this.h=new D.$me,this.onDidRemoveConnection=this.h.event,this.j=new f.$Uc,this.j.add(ee(({protocol:ke,onDidClientDisconnect:te})=>{const be=D.Event.once(ke.onMessage);this.j.add(be(Ae=>{const Re=new S(Ae),Ie=C(Re),je=new E(ke,Ie,ce,le),_e=new x(ke,ce);this.a.forEach((j,l)=>je.registerChannel(l,j));const W={channelServer:je,channelClient:_e,ctx:Ie};this.f.add(W),this.g.fire(W),this.j.add(te(()=>{je.dispose(),_e.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(ee,ce){const le=this;return{call(ke,te,be){let Ae;if((0,$.$tg)(ce)){const Ie=(0,i.$3b)(le.connections.filter(ce));Ae=Ie?Promise.resolve(Ie):D.Event.toPromise(D.Event.filter(le.onDidAddConnection,ce))}else Ae=ce.routeCall(le,ke,te);const Re=Ae.then(Ie=>Ie.channelClient.getChannel(ee));return q(Re).call(ke,te,be)},listen(ke,te){if((0,$.$tg)(ce))return le.k(ee,ce,ke,te);const be=ce.routeEvent(le,ke,te).then(Ae=>Ae.channelClient.getChannel(ee));return q(be).listen(ke,te)}}}k(ee,ce,le,ke){const te=this;let be;const Ae=new D.$me({onWillAddFirstListener:()=>{be=new f.$Uc;const Re=new D.$se,Ie=new Map,je=W=>{const l=W.channelClient.getChannel(ee).listen(le,ke),o=Re.add(l);Ie.set(W,o)},_e=W=>{const j=Ie.get(W);j&&(j.dispose(),Ie.delete(W))};te.connections.filter(ce).forEach(je),D.Event.filter(te.onDidAddConnection,ce)(je,void 0,be),te.onDidRemoveConnection(_e,void 0,be),Re.event(Ae.fire,Ae,be),be.add(Re)},onDidRemoveLastListener:()=>{be?.dispose(),be=void 0}});return Ae.event}registerChannel(ee,ce){this.a.set(ee,ce);for(const le of this.f)le.channelServer.registerChannel(ee,ce)}dispose(){this.j.dispose();for(const ee of this.f)ee.channelClient.dispose(),ee.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$ki=I;class _{constructor(ee,ce,le=null){const ke=new d;U(ke,ce),ee.send(ke.buffer),this.a=new x(ee,le),this.d=new E(ee,ce,le)}getChannel(ee){return this.a.getChannel(ee)}registerChannel(ee,ce){this.d.registerChannel(ee,ce)}dispose(){this.a.dispose(),this.d.dispose()}}t.$li=_;function q(ne){return{call(ee,ce,le){return ne.then(ke=>ke.call(ee,ce,le))},listen(ee,ce){const le=new D.$ve;return ne.then(ke=>le.input=ke.listen(ee,ce)),le.event}}}function J(ne){let ee=!1;return{call(ce,le,ke){return ee?ne.call(ce,le,ke):(0,n.$Hh)(0).then(()=>ee=!0).then(()=>ne.call(ce,le,ke))},listen(ce,le){if(ee)return ne.listen(ce,le);const ke=new D.$ve;return(0,n.$Hh)(0).then(()=>ee=!0).then(()=>ke.input=ne.listen(ce,le)),ke.event}}}class G{constructor(ee){this.a=ee}routeCall(ee){return this.b(ee)}routeEvent(ee){return this.b(ee)}async b(ee){for(const ce of ee.connections)if(await Promise.resolve(this.a(ce.ctx)))return Promise.resolve(ce);return await D.Event.toPromise(ee.onDidAddConnection),await this.b(ee)}}t.$oi=G;var K;(function(ne){function ee(te,be,Ae){const Re=te,Ie=Ae&&Ae.disableMarshalling,je=new Map;for(const _e in Re)le(_e)&&je.set(_e,D.Event.buffer(Re[_e],!0,void 0,be));return new class{listen(_e,W,j){const l=je.get(W);if(l)return l;const o=Re[W];if(typeof o=="function"){if(ke(W))return o.call(Re,j);if(le(W))return je.set(W,D.Event.buffer(Re[W],!0,void 0,be)),je.get(W)}throw new w.$bb(`Event not found: ${W}`)}call(_e,W,j){const l=Re[W];if(typeof l=="function"){if(!Ie&&Array.isArray(j))for(let g=0;g<j.length;g++)j[g]=(0,p.$di)(j[g]);let o=l.apply(Re,j);return o instanceof Promise||(o=Promise.resolve(o)),o}throw new w.$bb(`Method not found: ${W}`)}}}ne.fromService=ee;function ce(te,be){const Ae=be&&be.disableMarshalling;return new Proxy({},{get(Re,Ie){if(typeof Ie=="string")return be?.properties?.has(Ie)?be.properties.get(Ie):ke(Ie)?function(je){return te.listen(Ie,je)}:le(Ie)?te.listen(Ie):async function(...je){let _e;be&&!(0,$.$og)(be.context)?_e=[be.context,...je]:_e=je;const W=await te.call(Ie,_e);return Ae?W:(0,p.$di)(W)};throw new w.$bb(`Property not found: ${String(Ie)}`)}})}ne.toService=ce;function le(te){return te[0]==="o"&&te[1]==="n"&&y.$Ff(te.charCodeAt(2))}function ke(te){return/^onDynamic/.test(te)&&y.$Ff(te.charCodeAt(9))}})(K||(t.ProxyChannel=K={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(ne){if(Array.isArray(ne))return ne;if(ne&&typeof ne=="object"&&typeof ne.toString=="function"){const ee=ne.toString();if(ee!=="[object Object]")return ee}return ne}function me(ne){return Array.isArray(ne)?ne.map(ae):ae(ne)}function ye(ne,ee,ce,le,ke,te,be){be=me(be);const Ae=Q[ke],Re=Ae[le%Ae.length];let Ie=[`%c[${ne}]%c[${String(ee).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${Re}`];/\($/.test(te)?(Ie=Ie.concat(be),Ie.push(")")):Ie.push(be),console.log.apply(console,Ie)}class Le{constructor(ee,ce){this.d=ee,this.f=ce,this.a=0,this.b=0}logOutgoing(ee,ce,le,ke,te){this.b+=ee,ye(this.d,this.b,ee,ce,le,ke,te)}logIncoming(ee,ce,le,ke,te){this.a+=ee,ye(this.f,this.a,ee,ce,le,ke,te)}}t.$pi=Le}),define(pe[122],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7X=void 0;class i{constructor(P,F){this.a=P,this.onMessage=F}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$7X=i}),define(pe[40],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Q=t.$P=t.$O=t.$N=t.$M=t.$L=void 0;const i=globalThis.vscode;t.$L=i.ipcRenderer,t.$M=i.ipcMessagePort,t.$N=i.webFrame,t.$O=i.process,t.$P=i.context,t.$Q=i.webUtils}),define(pe[123],we([1,0,121,40]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3X=F;let P=0;function F(w,D,f){const p=[],y=P++,$=`vscode:onContextMenu${y}`,m=(e,s,r)=>{p[s].click?.(r)};n.$L.once($,m),n.$L.once(i.$ZX,(e,s)=>{s===y&&(n.$L.removeListener($,m),f?.())}),n.$L.send(i.$YX,y,w.map(e=>N(e,p)),$,D)}function N(w,D){const f={id:D.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return D.push(w),Array.isArray(w.submenu)&&(f.submenu=w.submenu.map(p=>N(p,D))),f}}),define(pe[124],we([1,0,47,3,74,122,40]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$X=void 0;class w extends P.$li{static f(){const f=n.Event.fromNodeEventEmitter(N.$L,"vscode:message",(p,y)=>i.$Oe.wrap(y));return N.$L.send("vscode:hello"),new F.$7X(N.$L,f)}constructor(f){const p=w.f();super(p,f),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}t.$$X=w}),define(pe[75],we([7]),{}),define(pe[125],we([7]),{}),define(pe[76],we([1,0,4,125]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZU=f,t.$1U=p,t.$2U=y,i=He(i);const n=2e4;let P,F,N,w,D;function f(m){P=document.createElement("div"),P.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),P.appendChild(r),r};F=e(),N=e();const s=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),P.appendChild(r),r};w=s(),D=s(),m.appendChild(P)}function p(m){P&&(F.textContent!==m?(i.$JS(N),$(F,m)):(i.$JS(F),$(N,m)))}function y(m){P&&(w.textContent!==m?(i.$JS(D),$(w,m)):(i.$JS(w),$(D,m)))}function $(m,e){i.$JS(m),e.length>n&&(e=e.substr(0,n)),m.textContent=e,m.style.visibility="hidden",m.style.visibility="visible"}}),define(pe[126],we([7]),{}),define(pe[127],we([7]),{}),define(pe[128],we([1,0,126,127]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(pe[129],we([7]),{}),define(pe[77],we([1,0,61,4,2,5,46,129]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UU=t.LayoutAnchorMode=t.LayoutAnchorPosition=t.AnchorAxisAlignment=t.AnchorPosition=t.AnchorAlignment=t.ContextViewDOMPosition=void 0,t.$SU=D,t.$TU=e,n=He(n),F=He(F);var w;(function(h){h[h.ABSOLUTE=1]="ABSOLUTE",h[h.FIXED=2]="FIXED",h[h.FIXED_SHADOW=3]="FIXED_SHADOW"})(w||(t.ContextViewDOMPosition=w={}));function D(h){const a=h;return!!a&&typeof a.x=="number"&&typeof a.y=="number"}var f;(function(h){h[h.LEFT=0]="LEFT",h[h.RIGHT=1]="RIGHT"})(f||(t.AnchorAlignment=f={}));var p;(function(h){h[h.BELOW=0]="BELOW",h[h.ABOVE=1]="ABOVE"})(p||(t.AnchorPosition=p={}));var y;(function(h){h[h.VERTICAL=0]="VERTICAL",h[h.HORIZONTAL=1]="HORIZONTAL"})(y||(t.AnchorAxisAlignment=y={}));var $;(function(h){h[h.Before=0]="Before",h[h.After=1]="After"})($||(t.LayoutAnchorPosition=$={}));var m;(function(h){h[h.AVOID=0]="AVOID",h[h.ALIGN=1]="ALIGN"})(m||(t.LayoutAnchorMode=m={}));function e(h,a,v){const T=v.mode===m.ALIGN?v.offset:v.offset+v.size,S=v.mode===m.ALIGN?v.offset+v.size:v.offset;return v.position===$.Before?a<=h-T?T:a<=S?S-a:Math.max(h-a,0):a<=S?S-a:a<=h-T?T:0}class s extends P.$Vc{static{this.a=["click","keydown","focus","blur"]}static{this.b=["click"]}constructor(a,v){super(),this.c=null,this.g=!1,this.h=!1,this.j=null,this.m=P.$Vc.None,this.n=P.$Vc.None,this.r=null,this.s=null,this.f=n.$(".context-view"),n.$ZT(this.f),this.setContainer(a,v),this.B((0,P.$Tc)(()=>this.setContainer(null,w.ABSOLUTE)))}setContainer(a,v){this.g=v!==w.ABSOLUTE;const T=this.h;if(this.h=v===w.FIXED_SHADOW,!(a===this.c&&T===this.h)&&(this.c&&(this.n.dispose(),this.f.remove(),this.r&&(this.r=null,this.s?.remove(),this.s=null),this.c=null),a)){if(this.c=a,this.h){this.s=n.$(".shadow-root-host"),this.c.appendChild(this.s),this.r=this.s.attachShadow({mode:"open"});const d=document.createElement("style");d.textContent=r,this.r.appendChild(d),this.r.appendChild(this.f),this.r.appendChild(n.$("slot"))}else this.c.appendChild(this.f);const S=new P.$Uc;s.a.forEach(d=>{S.add(n.$LS(this.c,d,c=>{this.w(c,!1)}))}),s.b.forEach(d=>{S.add(n.$LS(this.c,d,c=>{this.w(c,!0)},!0))}),this.n=S}}show(a){this.u()&&this.hide(),n.$JS(this.f),this.f.className="context-view monaco-component",this.f.style.top="0px",this.f.style.left="0px",this.f.style.zIndex=`${2575+(a.layer??0)}`,this.f.style.position=this.g?"fixed":"absolute",n.$YT(this.f),this.m=a.render(this.f)||P.$Vc.None,this.j=a,this.t(),this.j.focus?.()}getViewElement(){return this.f}layout(){if(this.u()){if(this.j.canRelayout===!1&&!(F.$s&&i.$zS.pointerEvents)){this.hide();return}this.j?.layout?.(),this.t()}}t(){if(!this.u())return;const a=this.j.getAnchor();let v;if(n.$zT(a)){const E=n.$7S(a),O=n.$8S(a);v={top:E.top*O,left:E.left*O,width:E.width*O,height:E.height*O}}else D(a)?v={top:a.y,left:a.x,width:a.width||1,height:a.height||2}:v={top:a.posy,left:a.posx,width:2,height:2};const T=n.$9S(this.f),S=n.$aT(this.f),d=this.j.anchorPosition||p.BELOW,c=this.j.anchorAlignment||f.LEFT,b=this.j.anchorAxisAlignment||y.VERTICAL;let A,V;const U=n.$pT();if(b===y.VERTICAL){const E={offset:v.top-U.pageYOffset,size:v.height,position:d===p.BELOW?$.Before:$.After},O={offset:v.left,size:v.width,position:c===f.LEFT?$.Before:$.After,mode:m.ALIGN};A=e(U.innerHeight,S,E)+U.pageYOffset,N.Range.intersects({start:A,end:A+S},{start:E.offset,end:E.offset+E.size})&&(O.mode=m.AVOID),V=e(U.innerWidth,T,O)}else{const E={offset:v.left,size:v.width,position:c===f.LEFT?$.Before:$.After},O={offset:v.top,size:v.height,position:d===p.BELOW?$.Before:$.After,mode:m.ALIGN};V=e(U.innerWidth,T,E),N.Range.intersects({start:V,end:V+T},{start:E.offset,end:E.offset+E.size})&&(O.mode=m.AVOID),A=e(U.innerHeight,S,O)+U.pageYOffset}this.f.classList.remove("top","bottom","left","right"),this.f.classList.add(d===p.BELOW?"bottom":"top"),this.f.classList.add(c===f.LEFT?"left":"right"),this.f.classList.toggle("fixed",this.g);const C=n.$7S(this.c);this.f.style.top=`${A-(this.g?n.$7S(this.f).top:C.top)}px`,this.f.style.left=`${V-(this.g?n.$7S(this.f).left:C.left)}px`,this.f.style.width="initial"}hide(a){const v=this.j;this.j=null,v?.onHide&&v.onHide(a),this.m.dispose(),n.$ZT(this.f)}u(){return!!this.j}w(a,v){this.j&&(this.j.onDOMEvent?this.j.onDOMEvent(a,n.getWindow(a).document.activeElement):v&&!n.$cT(a.target,this.c)&&this.hide())}dispose(){this.hide(),super.dispose()}}t.$UU=s;const r=`
	:host {
		all: initial; /* 1st rule so subsequent properties are reset. */
	}

	.codicon[class*='codicon-'] {
		font: normal normal normal 16px/1 codicon;
		display: inline-block;
		text-decoration: none;
		text-rendering: auto;
		text-align: center;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		user-select: none;
		-webkit-user-select: none;
		-ms-user-select: none;
	}

	:host {
		font-family: -apple-system, BlinkMacSystemFont, "Segoe WPC", "Segoe UI", "HelveticaNeue-Light", system-ui, "Ubuntu", "Droid Sans", sans-serif;
	}

	:host-context(.mac) { font-family: -apple-system, BlinkMacSystemFont, sans-serif; }
	:host-context(.mac:lang(zh-Hans)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang SC", "Hiragino Sans GB", sans-serif; }
	:host-context(.mac:lang(zh-Hant)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang TC", sans-serif; }
	:host-context(.mac:lang(ja)) { font-family: -apple-system, BlinkMacSystemFont, "Hiragino Kaku Gothic Pro", sans-serif; }
	:host-context(.mac:lang(ko)) { font-family: -apple-system, BlinkMacSystemFont, "Nanum Gothic", "Apple SD Gothic Neo", "AppleGothic", sans-serif; }

	:host-context(.windows) { font-family: "Segoe WPC", "Segoe UI", sans-serif; }
	:host-context(.windows:lang(zh-Hans)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft YaHei", sans-serif; }
	:host-context(.windows:lang(zh-Hant)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft Jhenghei", sans-serif; }
	:host-context(.windows:lang(ja)) { font-family: "Segoe WPC", "Segoe UI", "Yu Gothic UI", "Meiryo UI", sans-serif; }
	:host-context(.windows:lang(ko)) { font-family: "Segoe WPC", "Segoe UI", "Malgun Gothic", "Dotom", sans-serif; }

	:host-context(.linux) { font-family: system-ui, "Ubuntu", "Droid Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hans)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans SC", "Source Han Sans CN", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hant)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans TC", "Source Han Sans TW", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ja)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans J", "Source Han Sans JP", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ko)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans K", "Source Han Sans JR", "Source Han Sans", "UnDotum", "FBaekmuk Gulim", sans-serif; }
`}),define(pe[130],we([7]),{}),define(pe[131],we([7]),{}),define(pe[132],we([7]),{}),define(pe[133],we([7]),{}),define(pe[78],we([1,0,18,4,55,19,117,118,23,12,3,2,5,20,133]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HU=t.$GU=t.$FU=t.$EU=t.$DU=void 0,n=He(n),$=He($);const e=500,s=50,r=!0;class h{constructor(A,V,U){this.timestamp=A,this.deltaX=V,this.deltaY=U,this.score=0}}class a{static{this.INSTANCE=new a}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let A=1,V=0,U=1,C=this.d;do{const E=C===this.c?A:Math.pow(2,-U);if(A-=E,V+=this.b[C].score*E,C===this.c)break;C=(this.a+C-1)%this.a,U++}while(!0);return V<=.5}acceptStandardWheelEvent(A){if(i.$rS){const V=n.getWindow(A.browserEvent),U=(0,i.$kS)(V);this.accept(Date.now(),A.deltaX*U,A.deltaY*U)}else this.accept(Date.now(),A.deltaX,A.deltaY)}accept(A,V,U){let C=null;const E=new h(A,V,U);this.c===-1&&this.d===-1?(this.b[0]=E,this.c=0,this.d=0):(C=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=E),E.score=this.f(E,C)}f(A,V){if(Math.abs(A.deltaX)>0&&Math.abs(A.deltaY)>0)return 1;let U=.5;if((!this.g(A.deltaX)||!this.g(A.deltaY))&&(U+=.25),V){const C=Math.abs(A.deltaX),E=Math.abs(A.deltaY),O=Math.abs(V.deltaX),x=Math.abs(V.deltaY),I=Math.max(Math.min(C,O),1),_=Math.max(Math.min(E,x),1),q=Math.max(C,O),J=Math.max(E,x);q%I===0&&J%_===0&&(U-=.5)}return Math.min(Math.max(U,0),1)}g(A){return Math.abs(Math.round(A)-A)<.01}}t.$DU=a;class v extends D.$vU{get options(){return this.a}constructor(A,V,U){super(),this.O=this.B(new p.$me),this.onScroll=this.O.event,this.P=this.B(new p.$me),this.onWillScroll=this.P.event,A.style.overflow="hidden",this.a=c(V),this.b=U,this.B(this.b.onScroll(E=>{this.P.fire(E),this.S(E),this.O.fire(E)}));const C={onMouseWheel:E=>this.R(E),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new w.$CU(this.b,this.a,C)),this.g=this.B(new N.$BU(this.b,this.a,C)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(A),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,P.$tU)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,P.$tU)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,P.$tU)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,E=>this.Z(E)),this.u(this.t,E=>this.Y(E)),this.L=this.B(new f.$Qh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,y.$Qc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(A){this.c.delegatePointerDown(A)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(A){this.b.setScrollDimensions(A,!1)}updateClassName(A){this.a.className=A,$.$k&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(A){typeof A.handleMouseWheel<"u"&&(this.a.handleMouseWheel=A.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof A.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=A.mouseWheelScrollSensitivity),typeof A.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=A.fastScrollSensitivity),typeof A.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=A.scrollPredominantAxis),typeof A.horizontal<"u"&&(this.a.horizontal=A.horizontal),typeof A.vertical<"u"&&(this.a.vertical=A.vertical),typeof A.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=A.horizontalScrollbarSize),typeof A.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=A.verticalScrollbarSize),typeof A.scrollByPage<"u"&&(this.a.scrollByPage=A.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(A){this.N=A}delegateScrollFromMouseWheelEvent(A){this.R(new F.$ES(A))}Q(A){if(this.w.length>0!==A&&(this.w=(0,y.$Qc)(this.w),A)){const U=C=>{this.R(new F.$ES(C))};this.w.push(n.$KS(this.t,n.$LT.MOUSE_WHEEL,U,{passive:!1}))}}R(A){if(A.browserEvent?.defaultPrevented)return;const V=a.INSTANCE;r&&V.acceptStandardWheelEvent(A);let U=!1;if(A.deltaY||A.deltaX){let E=A.deltaY*this.a.mouseWheelScrollSensitivity,O=A.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&O+E===0?O=E=0:Math.abs(E)>=Math.abs(O)?O=0:E=0),this.a.flipAxes&&([E,O]=[O,E]);const x=!$.$k&&A.browserEvent&&A.browserEvent.shiftKey;(this.a.scrollYToX||x)&&!O&&(O=E,E=0),A.browserEvent&&A.browserEvent.altKey&&(O=O*this.a.fastScrollSensitivity,E=E*this.a.fastScrollSensitivity);const I=this.b.getFutureScrollPosition();let _={};if(E){const q=s*E,J=I.scrollTop-(q<0?Math.floor(q):Math.ceil(q));this.c.writeScrollPosition(_,J)}if(O){const q=s*O,J=I.scrollLeft-(q<0?Math.floor(q):Math.ceil(q));this.g.writeScrollPosition(_,J)}_=this.b.validateScrollPosition(_),(I.scrollLeft!==_.scrollLeft||I.scrollTop!==_.scrollTop)&&(r&&this.a.mouseWheelSmoothScroll&&V.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(_):this.b.setScrollPositionNow(_),U=!0)}let C=U;!C&&this.a.alwaysConsumeMouseWheel&&(C=!0),!C&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(C=!0),C&&(A.preventDefault(),A.stopPropagation())}S(A){this.M=this.g.onDidScroll(A)||this.M,this.M=this.c.onDidScroll(A)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const A=this.b.getCurrentScrollPosition(),V=A.scrollTop>0,U=A.scrollLeft>0,C=U?" left":"",E=V?" top":"",O=U||V?" top-left-corner":"";this.n.setClassName(`shadow${C}`),this.r.setClassName(`shadow${E}`),this.s.setClassName(`shadow${O}${E}${C}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(A){this.J=!1,this.ab()}Z(A){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$EU=v;class T extends v{constructor(A,V){V=V||{},V.mouseWheelSmoothScroll=!1;const U=new m.$ft({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:C=>n.$US(n.getWindow(A),C)});super(A,V,U),this.B(U)}setScrollPosition(A){this.b.setScrollPositionNow(A)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$FU=T;class S extends v{constructor(A,V,U){super(A,V,U)}setScrollPosition(A){A.reuseAnimation?this.b.setScrollPositionSmooth(A,A.reuseAnimation):this.b.setScrollPositionNow(A)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$GU=S;class d extends v{constructor(A,V){V=V||{},V.mouseWheelSmoothScroll=!1;const U=new m.$ft({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:C=>n.$US(n.getWindow(A),C)});super(A,V,U),this.B(U),this.cb=A,this.B(this.onScroll(C=>{C.scrollTopChanged&&(this.cb.scrollTop=C.scrollTop),C.scrollLeftChanged&&(this.cb.scrollLeft=C.scrollLeft)})),this.scanDomNode()}setScrollPosition(A){this.b.setScrollPositionNow(A)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$HU=d;function c(b){const A={lazyRender:typeof b.lazyRender<"u"?b.lazyRender:!1,className:typeof b.className<"u"?b.className:"",useShadows:typeof b.useShadows<"u"?b.useShadows:!0,handleMouseWheel:typeof b.handleMouseWheel<"u"?b.handleMouseWheel:!0,flipAxes:typeof b.flipAxes<"u"?b.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof b.consumeMouseWheelIfScrollbarIsNeeded<"u"?b.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof b.alwaysConsumeMouseWheel<"u"?b.alwaysConsumeMouseWheel:!1,scrollYToX:typeof b.scrollYToX<"u"?b.scrollYToX:!1,mouseWheelScrollSensitivity:typeof b.mouseWheelScrollSensitivity<"u"?b.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof b.fastScrollSensitivity<"u"?b.fastScrollSensitivity:5,scrollPredominantAxis:typeof b.scrollPredominantAxis<"u"?b.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof b.mouseWheelSmoothScroll<"u"?b.mouseWheelSmoothScroll:!0,arrowSize:typeof b.arrowSize<"u"?b.arrowSize:11,listenOnDomNode:typeof b.listenOnDomNode<"u"?b.listenOnDomNode:null,horizontal:typeof b.horizontal<"u"?b.horizontal:m.ScrollbarVisibility.Auto,horizontalScrollbarSize:typeof b.horizontalScrollbarSize<"u"?b.horizontalScrollbarSize:10,horizontalSliderSize:typeof b.horizontalSliderSize<"u"?b.horizontalSliderSize:0,horizontalHasArrows:typeof b.horizontalHasArrows<"u"?b.horizontalHasArrows:!1,vertical:typeof b.vertical<"u"?b.vertical:m.ScrollbarVisibility.Auto,verticalScrollbarSize:typeof b.verticalScrollbarSize<"u"?b.verticalScrollbarSize:10,verticalHasArrows:typeof b.verticalHasArrows<"u"?b.verticalHasArrows:!1,verticalSliderSize:typeof b.verticalSliderSize<"u"?b.verticalSliderSize:0,scrollByPage:typeof b.scrollByPage<"u"?b.scrollByPage:!1};return A.horizontalSliderSize=typeof b.horizontalSliderSize<"u"?b.horizontalSliderSize:A.horizontalScrollbarSize,A.verticalSliderSize=typeof b.verticalSliderSize<"u"?b.verticalSliderSize:A.verticalScrollbarSize,$.$k&&(A.className+=" mac"),A}}),define(pe[79],we([1,0,69,4,29,32,78,9,12,35,3,2,46,20,41,101,113,6,37]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$,m,e,s,r,h,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_U=t.$$U=t.$0U=t.$9U=t.ListViewTargetSector=void 0;const v={CurrentDragAndDropData:void 0};var T;(function(C){C[C.TOP=0]="TOP",C[C.CENTER_TOP=1]="CENTER_TOP",C[C.CENTER_BOTTOM=2]="CENTER_BOTTOM",C[C.BOTTOM=3]="BOTTOM"})(T||(t.ListViewTargetSector=T={}));const S={useShadows:!0,verticalScrollMode:m.ScrollbarVisibility.Auto,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(C){return[C]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class d{get context(){return this.d}set context(E){this.d=E}constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.$9U=d;class c{constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.$0U=c;class b{constructor(){this.types=[],this.files=[]}update(E){if(E.types&&this.types.splice(0,this.types.length,...E.types),E.files){this.files.splice(0,this.files.length);for(let O=0;O<E.files.length;O++){const x=E.files.item(O);x&&(x.size||x.type)&&this.files.push(x)}}}getData(){return{types:this.types,files:this.files}}}t.$$U=b;function A(C,E){return Array.isArray(C)&&Array.isArray(E)?(0,w.$ub)(C,E):C===E}class V{constructor(E){E?.getSetSize?this.getSetSize=E.getSetSize.bind(E):this.getSetSize=(O,x,I)=>I,E?.getPosInSet?this.getPosInSet=E.getPosInSet.bind(E):this.getPosInSet=(O,x)=>x+1,E?.getRole?this.getRole=E.getRole.bind(E):this.getRole=O=>"listitem",E?.isChecked?this.isChecked=E.isChecked.bind(E):this.isChecked=O=>{}}}class U{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(E){if(E!==this.P){if(E&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=E,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const O of this.d)this.ab(O);this.X(),this.q.setScrollDimensions({width:(0,n.$0S)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(E,O,x,I=S){if(this.R=O,this.domId=`list_id_${++U.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new D.$Dh(50),this.v=!1,this.x=y.$Vc.None,this.y=0,this.G=!1,this.K=y.$Vc.None,this.L=y.$Vc.None,this.M=new y.$Uc,this.N=new p.$me,this.O=new p.$me,this.onDidChangeContentHeight=p.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=p.Event.latch(this.O.event,void 0,this.M),this.P=!1,I.horizontalScrolling&&I.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(I.paddingTop??0);for(const q of x)this.j.set(q.templateId,q);this.h=this.M.add(new r.$8U(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof I.mouseSupport=="boolean"?I.mouseSupport:!0),this.P=I.horizontalScrolling??S.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof I.paddingBottom>"u"?0:I.paddingBottom,this.D=new V(I.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(I.transformOptimization??S.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(F.$rU.addTarget(this.o)),this.p=this.M.add(new m.$ft({forceIntegerValues:!0,smoothScrollDuration:I.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:q=>(0,n.$US)((0,n.getWindow)(this.domNode),q)})),this.q=this.M.add(new N.$GU(this.o,{alwaysConsumeMouseWheel:I.alwaysConsumeMouseWheel??S.alwaysConsumeMouseWheel,horizontal:m.ScrollbarVisibility.Auto,vertical:I.verticalScrollMode??S.verticalScrollMode,useShadows:I.useShadows??S.useShadows,mouseWheelScrollSensitivity:I.mouseWheelScrollSensitivity,fastScrollSensitivity:I.fastScrollSensitivity,scrollByPage:I.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),E.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,n.$KS)(this.o,F.EventType.Change,q=>this.jb(q))),this.M.add((0,n.$KS)(this.q.getDomNode(),"scroll",q=>q.target.scrollTop=0)),this.M.add((0,n.$KS)(this.domNode,"dragover",q=>this.lb(this.hb(q)))),this.M.add((0,n.$KS)(this.domNode,"drop",q=>this.nb(this.hb(q)))),this.M.add((0,n.$KS)(this.domNode,"dragleave",q=>this.mb(this.hb(q)))),this.M.add((0,n.$KS)(this.domNode,"dragend",q=>this.ob(q))),this.z=I.setRowLineHeight??S.setRowLineHeight,this.A=I.setRowHeight??S.setRowHeight,this.B=I.supportDynamicHeights??S.supportDynamicHeights,this.F=I.dnd??this.M.add(S.dnd),this.layout(I.initialSize?.height,I.initialSize?.width)}updateOptions(E){E.paddingBottom!==void 0&&(this.C=E.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),E.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(E.smoothScrolling?125:0),E.horizontalScrolling!==void 0&&(this.Q=E.horizontalScrolling);let O;if(E.scrollByPage!==void 0&&(O={...O??{},scrollByPage:E.scrollByPage}),E.mouseWheelScrollSensitivity!==void 0&&(O={...O??{},mouseWheelScrollSensitivity:E.mouseWheelScrollSensitivity}),E.fastScrollSensitivity!==void 0&&(O={...O??{},fastScrollSensitivity:E.fastScrollSensitivity}),O&&this.q.updateOptions(O),E.paddingTop!==void 0&&E.paddingTop!==this.g.paddingTop){const x=this.vb(this.k,this.m),I=E.paddingTop-this.g.paddingTop;this.g.paddingTop=E.paddingTop,this.Y(x,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(E){this.q.delegateScrollFromMouseWheelEvent(E)}delegateVerticalScrollbarPointerDown(E){this.q.delegateVerticalScrollbarPointerDown(E)}updateElementHeight(E,O,x){if(E<0||E>=this.d.length)return;const I=this.d[E].size;if(typeof O>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[E].lastDynamicHeightWidth=void 0,O=I+this.xb(E)}if(I===O)return;const _=this.vb(this.k,this.m);let q=0;E<_.start||x!==null&&x>E&&x<_.end?q=O-I:q=0,this.g.splice(E,1,[{size:O}]),this.d[E].size=O,this.Y(_,Math.max(0,this.k+q),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(E){return new s.$7U(E)}splice(E,O,x=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(E,O,x)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(E,O,x=[]){const I=this.vb(this.k,this.m),_={start:E,end:E+O},q=$.Range.intersect(I,_),J=new Map;for(let be=q.end-1;be>=q.start;be--){const Ae=this.d[be];if(Ae.dragStartDisposable.dispose(),Ae.checkedDisposable.dispose(),Ae.row){let Re=J.get(Ae.templateId);Re||(Re=[],J.set(Ae.templateId,Re));const Ie=this.j.get(Ae.templateId);Ie&&Ie.disposeElement&&Ie.disposeElement(Ae.element,be,Ae.row.templateData,Ae.size),Re.unshift(Ae.row)}Ae.row=null,Ae.stale=!0}const G={start:E+O,end:this.d.length},K=$.Range.intersect(G,I),Q=$.Range.relativeComplement(G,I),ae=x.map(be=>({id:String(this.f++),element:be,templateId:this.R.getTemplateId(be),size:this.R.getHeight(be),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(be),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:y.$Vc.None,checkedDisposable:y.$Vc.None,stale:!1}));let me;E===0&&O>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ae),me=this.d,this.d=ae):(this.g.splice(E,O,ae),me=this.d.splice(E,O,...ae));const ye=x.length-O,Le=this.vb(this.k,this.m),ne=(0,s.$5U)(K,ye),ee=$.Range.intersect(Le,ne);for(let be=ee.start;be<ee.end;be++)this.bb(this.d[be],be);const ce=$.Range.relativeComplement(ne,Le);for(const be of ce)for(let Ae=be.start;Ae<be.end;Ae++)this.db(Ae);const le=Q.map(be=>(0,s.$5U)(be,ye)),te=[{start:E,end:E+x.length},...le].map(be=>$.Range.intersect(Le,be)).reverse();for(const be of te)for(let Ae=be.end-1;Ae>=be.start;Ae--){const Re=this.d[Ae],je=J.get(Re.templateId)?.pop();this.Z(Ae,je)}for(const be of J.values())for(const Ae of be)this.h.release(Ae);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),me.map(be=>be.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,n.$US)((0,n.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let E=0;for(const O of this.d)typeof O.width<"u"&&(E=Math.max(E,O.width));this.E=E,this.q.setScrollDimensions({scrollWidth:E===0?0:E+10}),this.O.fire(this.E)}updateWidth(E){if(!this.Q||typeof this.E>"u")return;const O=this.d[E];this.ab(O),typeof O.width<"u"&&O.width>this.E&&(this.E=O.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const E of this.d)E.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const E=this.firstVisibleIndex,O=this.g.positionAt(E),x=this.g.positionAt(E+1);return x!==-1&&(x-O)/2+O<this.scrollTop?E+1:E}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(E){return this.d[E].element}indexOf(E){return this.d.findIndex(O=>O.element===E)}domElement(E){const O=this.d[E].row;return O&&O.domNode}elementHeight(E){return this.d[E].size}elementTop(E){return this.g.positionAt(E)}indexAt(E){return this.g.indexAt(E)}indexAfter(E){return this.g.indexAfter(E)}layout(E,O){const x={height:typeof E=="number"?E:(0,n.$_S)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,x.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(x),typeof O<"u"&&(this.n=O,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof O=="number"?O:(0,n.$0S)(this.domNode)})}Y(E,O,x,I,_,q=!1){const J=this.vb(O,x),G=$.Range.relativeComplement(J,E).reverse(),K=$.Range.relativeComplement(E,J);if(q){const Q=$.Range.intersect(E,J);for(let ae=Q.start;ae<Q.end;ae++)this.bb(this.d[ae],ae)}this.h.transact(()=>{for(const Q of K)for(let ae=Q.start;ae<Q.end;ae++)this.db(ae);for(const Q of G)for(let ae=Q.end-1;ae>=Q.start;ae--)this.Z(ae)}),I!==void 0&&(this.o.style.left=`-${I}px`),this.o.style.top=`-${O}px`,this.Q&&_!==void 0&&(this.o.style.width=`${Math.max(_,this.n)}px`),this.k=O,this.m=x}Z(E,O){const x=this.d[E];if(!x.row)if(O)x.row=O,x.stale=!0;else{const G=this.h.alloc(x.templateId);x.row=G.row,x.stale||=G.isReusingConnectedDomNode}const I=this.D.getRole(x.element)||"listitem";x.row.domNode.setAttribute("role",I);const _=this.D.isChecked(x.element);if(typeof _=="boolean")x.row.domNode.setAttribute("aria-checked",String(!!_));else if(_){const G=K=>x.row.domNode.setAttribute("aria-checked",String(!!K));G(_.value),x.checkedDisposable=_.onDidChange(()=>G(_.value))}if(x.stale||!x.row.domNode.parentElement){const G=this.d.at(E+1)?.row?.domNode??null;(x.row.domNode.parentElement!==this.o||x.row.domNode.nextElementSibling!==G)&&this.o.insertBefore(x.row.domNode,G),x.stale=!1}this.bb(x,E);const q=this.j.get(x.templateId);if(!q)throw new Error(`No renderer found for template id ${x.templateId}`);q?.renderElement(x.element,E,x.row.templateData,x.size);const J=this.F.getDragURI(x.element);x.dragStartDisposable.dispose(),x.row.domNode.draggable=!!J,J&&(x.dragStartDisposable=(0,n.$KS)(x.row.domNode,"dragstart",G=>this.kb(x.element,J,G))),this.Q&&(this.ab(x),this.W())}ab(E){if(!E.row||!E.row.domNode)return;E.row.domNode.style.width="fit-content",E.width=(0,n.$0S)(E.row.domNode);const O=(0,n.getWindow)(E.row.domNode).getComputedStyle(E.row.domNode);O.paddingLeft&&(E.width+=parseFloat(O.paddingLeft)),O.paddingRight&&(E.width+=parseFloat(O.paddingRight)),E.row.domNode.style.width=""}bb(E,O){E.row.domNode.style.top=`${this.elementTop(O)}px`,this.A&&(E.row.domNode.style.height=`${E.size}px`),this.z&&(E.row.domNode.style.lineHeight=`${E.size}px`),E.row.domNode.setAttribute("data-index",`${O}`),E.row.domNode.setAttribute("data-last-element",O===this.length-1?"true":"false"),E.row.domNode.setAttribute("data-parity",O%2===0?"even":"odd"),E.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(E.element,O,this.length))),E.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(E.element,O))),E.row.domNode.setAttribute("id",this.getElementDomId(O)),E.row.domNode.classList.toggle("drop-target",E.dropTarget)}db(E){const O=this.d[E];if(O.dragStartDisposable.dispose(),O.checkedDisposable.dispose(),O.row){const x=this.j.get(O.templateId);x&&x.disposeElement&&x.disposeElement(O.element,E,O.row.templateData,O.size),this.h.release(O.row),O.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(E,O){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:E,reuseAnimation:O})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(E){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:E})}get scrollTop(){return this.getScrollTop()}set scrollTop(E){this.setScrollTop(E)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return p.Event.map(this.M.add(new P.$YU(this.domNode,"click")).event,E=>this.eb(E),this.M)}get onMouseDblClick(){return p.Event.map(this.M.add(new P.$YU(this.domNode,"dblclick")).event,E=>this.eb(E),this.M)}get onMouseMiddleClick(){return p.Event.filter(p.Event.map(this.M.add(new P.$YU(this.domNode,"auxclick")).event,E=>this.eb(E),this.M),E=>E.browserEvent.button===1,this.M)}get onMouseUp(){return p.Event.map(this.M.add(new P.$YU(this.domNode,"mouseup")).event,E=>this.eb(E),this.M)}get onMouseDown(){return p.Event.map(this.M.add(new P.$YU(this.domNode,"mousedown")).event,E=>this.eb(E),this.M)}get onMouseOver(){return p.Event.map(this.M.add(new P.$YU(this.domNode,"mouseover")).event,E=>this.eb(E),this.M)}get onMouseMove(){return p.Event.map(this.M.add(new P.$YU(this.domNode,"mousemove")).event,E=>this.eb(E),this.M)}get onMouseOut(){return p.Event.map(this.M.add(new P.$YU(this.domNode,"mouseout")).event,E=>this.eb(E),this.M)}get onContextMenu(){return p.Event.any(p.Event.map(this.M.add(new P.$YU(this.domNode,"contextmenu")).event,E=>this.eb(E),this.M),p.Event.map(this.M.add(new P.$YU(this.domNode,F.EventType.Contextmenu)).event,E=>this.gb(E),this.M))}get onTouchStart(){return p.Event.map(this.M.add(new P.$YU(this.domNode,"touchstart")).event,E=>this.fb(E),this.M)}get onTap(){return p.Event.map(this.M.add(new P.$YU(this.o,F.EventType.Tap)).event,E=>this.gb(E),this.M)}eb(E){const O=this.ub(E.target||null),x=typeof O>"u"?void 0:this.d[O],I=x&&x.element;return{browserEvent:E,index:O,element:I}}fb(E){const O=this.ub(E.target||null),x=typeof O>"u"?void 0:this.d[O],I=x&&x.element;return{browserEvent:E,index:O,element:I}}gb(E){const O=this.ub(E.initialTarget||null),x=typeof O>"u"?void 0:this.d[O],I=x&&x.element;return{browserEvent:E,index:O,element:I}}hb(E){const O=this.ub(E.target||null),x=typeof O>"u"?void 0:this.d[O],I=x&&x.element,_=this.tb(E,O);return{browserEvent:E,index:O,element:I,sector:_}}ib(E){try{const O=this.vb(this.k,this.m);this.Y(O,E.scrollTop,E.height,E.scrollLeft,E.scrollWidth),this.B&&this.wb(E.scrollTop,E.height,E.inSmoothScrolling)}catch(O){throw console.error("Got bad scroll event:",E),O}}jb(E){E.preventDefault(),E.stopPropagation(),this.scrollTop-=E.translationY}kb(E,O,x){if(!x.dataTransfer)return;const I=this.F.getDragElements(E);if(x.dataTransfer.effectAllowed="copyMove",x.dataTransfer.setData(i.$pU.TEXT,O),x.dataTransfer.setDragImage){let _;this.F.getDragLabel&&(_=this.F.getDragLabel(I,x)),typeof _>"u"&&(_=String(I.length));const q=(0,n.$)(".monaco-drag-image");q.textContent=_,(K=>{for(;K&&!K.classList.contains("monaco-workbench");)K=K.parentElement;return K||this.domNode.ownerDocument})(this.domNode).appendChild(q),x.dataTransfer.setDragImage(q,-10,-10),setTimeout(()=>q.remove(),0)}this.domNode.classList.add("dragging"),this.H=new d(I),v.CurrentDragAndDropData=new c(I),this.F.onDragStart?.(this.H,x)}lb(E){if(E.browserEvent.preventDefault(),this.L.dispose(),v.CurrentDragAndDropData&&v.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(E.browserEvent),!E.browserEvent.dataTransfer))return!1;if(!this.H)if(v.CurrentDragAndDropData)this.H=v.CurrentDragAndDropData;else{if(!E.browserEvent.dataTransfer.types)return!1;this.H=new b}const O=this.F.onDragOver(this.H,E.element,E.index,E.sector,E.browserEvent);if(this.G=typeof O=="boolean"?O:O.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;E.browserEvent.dataTransfer.dropEffect=typeof O!="boolean"&&O.effect?.type===e.ListDragOverEffectType.Copy?"copy":"move";let x;typeof O!="boolean"&&O.feedback?x=O.feedback:typeof E.index>"u"?x=[-1]:x=[E.index],x=(0,w.$Mb)(x).filter(_=>_>=-1&&_<this.length).sort((_,q)=>_-q),x=x[0]===-1?[-1]:x;let I=typeof O!="boolean"&&O.effect&&O.effect.position?O.effect.position:e.ListDragOverEffectPosition.Over;if(A(this.I,x)&&this.J===I)return!0;if(this.I=x,this.J=I,this.K.dispose(),x[0]===-1)this.domNode.classList.add(I),this.o.classList.add(I),this.K=(0,y.$Tc)(()=>{this.domNode.classList.remove(I),this.o.classList.remove(I)});else{if(x.length>1&&I!==e.ListDragOverEffectPosition.Over)throw new Error("Can't use multiple feedbacks with position different than 'over'");I===e.ListDragOverEffectPosition.After&&x[0]<this.length-1&&(x[0]+=1,I=e.ListDragOverEffectPosition.Before);for(const _ of x){const q=this.d[_];q.dropTarget=!0,q.row?.domNode.classList.add(I)}this.K=(0,y.$Tc)(()=>{for(const _ of x){const q=this.d[_];q.dropTarget=!1,q.row?.domNode.classList.remove(I)}})}return!0}mb(E){this.L.dispose(),this.L=(0,D.$Ih)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,E.element,E.index,E.browserEvent)}nb(E){if(!this.G)return;const O=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,v.CurrentDragAndDropData=void 0,!(!O||!E.browserEvent.dataTransfer)&&(E.browserEvent.preventDefault(),O.update(E.browserEvent.dataTransfer),this.F.drop(O,E.element,E.index,E.sector,E.browserEvent))}ob(E){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,v.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(E)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=y.$Vc.None}qb(E){if(!this.w){const O=(0,n.$4S)(this.domNode).top;this.w=(0,n.$8T)((0,n.getWindow)(this.domNode),this.rb.bind(this,O))}this.x.dispose(),this.x=(0,D.$Ih)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=E.pageY}rb(E){if(this.y===void 0)return;const O=this.y-E,x=this.renderHeight-35;O<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(O-35))):O>x&&(this.scrollTop+=Math.min(14,Math.floor(.3*(O-x))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(E,O){if(O===void 0)return;const x=E.offsetY/this.d[O].size,I=Math.floor(x/.25);return(0,a.$Mm)(I,0,3)}ub(E){const O=this.q.getDomNode();let x=E;for(;((0,n.$zT)(x)||(0,n.$GT)(x))&&x!==this.o&&O.contains(x);){const I=x.getAttribute("data-index");if(I){const _=Number(I);if(!isNaN(_))return _}x=x.parentElement}}vb(E,O){return{start:this.g.indexAt(E),end:this.g.indexAfter(E+O-1)}}wb(E,O,x){const I=this.vb(E,O);let _,q;E===this.elementTop(I.start)?(_=I.start,q=0):I.end-I.start>1&&(_=I.start+1,q=this.elementTop(_)-E);let J=0;for(;;){const G=this.vb(E,O);let K=!1;for(let Q=G.start;Q<G.end;Q++){const ae=this.xb(Q);ae!==0&&this.g.splice(Q,1,[this.d[Q]]),J+=ae,K=K||ae!==0}if(!K){J!==0&&this.V();const Q=$.Range.relativeComplement(I,G);for(const me of Q)for(let ye=me.start;ye<me.end;ye++)this.d[ye].row&&this.db(ye);const ae=$.Range.relativeComplement(G,I).reverse();for(const me of ae)for(let ye=me.end-1;ye>=me.start;ye--)this.Z(ye);for(let me=G.start;me<G.end;me++)this.d[me].row&&this.bb(this.d[me],me);if(typeof _=="number"){const me=this.p.getFutureScrollPosition().scrollTop-E,ye=this.elementTop(_)-q+me;this.setScrollTop(ye,x)}this.N.fire(this.contentHeight);return}}}xb(E){const O=this.d[E];if(this.R.getDynamicHeight){const q=this.R.getDynamicHeight(O.element);if(q!==null){const J=O.size;return O.size=q,O.lastDynamicHeightWidth=this.n,q-J}}if(!O.hasDynamicHeight||O.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(O.element))return 0;const x=O.size;if(O.row)return O.row.domNode.style.height="",O.size=O.row.domNode.offsetHeight,O.size===0&&!(0,n.$cT)(O.row.domNode,(0,n.getWindow)(O.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),O.lastDynamicHeightWidth=this.n,O.size-x;const{row:I}=this.h.alloc(O.templateId);I.domNode.style.height="",this.o.appendChild(I.domNode);const _=this.j.get(O.templateId);if(!_)throw new h.$cb("Missing renderer for templateId: "+O.templateId);return _.renderElement(O.element,E,I.templateData,void 0),O.size=I.domNode.offsetHeight,_.disposeElement?.(O.element,E,I.templateData,void 0),this.R.setDynamicHeight?.(O.element,O.size),O.lastDynamicHeightWidth=this.n,I.domNode.remove(),this.h.release(I),O.size-x}getElementDomId(E){return`${this.domId}_${E}`}dispose(){for(const E of this.d)if(E.dragStartDisposable.dispose(),E.checkedDisposable.dispose(),E.row){const O=this.j.get(E.row.templateId);O&&(O.disposeElement?.(E.element,-1,E.row.templateData,void 0),O.disposeTemplate(E.row.templateData))}this.d=[],this.domNode?.remove(),this.w?.dispose(),this.M.dispose()}}t.$_U=U,et([f.$$h],U.prototype,"onMouseClick",null),et([f.$$h],U.prototype,"onMouseDblClick",null),et([f.$$h],U.prototype,"onMouseMiddleClick",null),et([f.$$h],U.prototype,"onMouseUp",null),et([f.$$h],U.prototype,"onMouseDown",null),et([f.$$h],U.prototype,"onMouseOver",null),et([f.$$h],U.prototype,"onMouseMove",null),et([f.$$h],U.prototype,"onMouseOut",null),et([f.$$h],U.prototype,"onContextMenu",null),et([f.$$h],U.prototype,"onTouchStart",null),et([f.$$h],U.prototype,"onTap",null)}),define(pe[52],we([1,0,4,29,15,32,76,86,9,12,88,35,3,49,8,2,37,5,10,41,79,19,62,132]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$,m,e,s,r,h,a,v,T,S,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rV=t.$qV=t.$pV=t.$oV=t.$lV=t.TypeNavigationMode=void 0,t.$dV=U,t.$eV=E,t.$fV=O,t.$gV=x,t.$hV=I,t.$iV=_,t.$jV=q,t.$kV=J,t.$mV=ye,t.$nV=Le,h=He(h);class c{constructor(l){this.d=l,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(l){return l}renderElement(l,o,g){const M=this.c.findIndex(k=>k.templateData===g);if(M>=0){const k=this.c[M];this.d.unrender(g),k.index=o}else{const k={index:o,templateData:g};this.c.push(k)}this.d.renderIndex(o,g)}splice(l,o,g){const M=[];for(const k of this.c)k.index<l?M.push(k):k.index>=l+o&&M.push({index:k.index+g-o,templateData:k.templateData});this.c=M}renderIndexes(l){for(const{index:o,templateData:g}of this.c)l.indexOf(o)>-1&&this.d.renderIndex(o,g)}disposeTemplate(l){const o=this.c.findIndex(g=>g.templateData===l);o<0||this.c.splice(o,1)}}class b{get name(){return this.g}get renderer(){return new c(this)}constructor(l){this.g=l,this.c=[],this.d=[],this.f=new $.$me,this.onChange=this.f.event}splice(l,o,g){const M=g.length-o,k=l+o,u=[];let L=0;for(;L<this.d.length&&this.d[L]<l;)u.push(this.d[L++]);for(let R=0;R<g.length;R++)g[R]&&u.push(R+l);for(;L<this.d.length&&this.d[L]>=k;)u.push(this.d[L++]+M);this.renderer.splice(l,o,g.length),this.h(u,u)}renderIndex(l,o){o.classList.toggle(this.g,this.contains(l))}unrender(l){l.classList.remove(this.g)}set(l,o){return this.h(l,[...l].sort(Re),o)}h(l,o,g){const M=this.c,k=this.d;this.c=l,this.d=o;const u=be(k,l);return this.renderer.renderIndexes(u),this.f.fire({indexes:l,browserEvent:g}),M}get(){return this.c}contains(l){return(0,D.$wb)(this.d,l,Re)>=0}dispose(){(0,s.$Qc)(this.f)}}et([y.$$h],b.prototype,"renderer",null);class A extends b{constructor(l){super("selected"),this.k=l}renderIndex(l,o){super.renderIndex(l,o),this.k&&(this.contains(l)?o.setAttribute("aria-selected","true"):o.setAttribute("aria-selected","false"))}}class V{constructor(l,o,g){this.c=l,this.d=o,this.f=g}splice(l,o,g){if(!this.f)return this.c.splice(l,o,new Array(g.length).fill(!1));const M=this.c.get().map(L=>this.f.getId(this.d.element(L)).toString());if(M.length===0)return this.c.splice(l,o,new Array(g.length).fill(!1));const k=new Set(M),u=g.map(L=>k.has(this.f.getId(L).toString()));this.c.splice(l,o,u)}}function U(j){return j.tagName==="INPUT"||j.tagName==="TEXTAREA"}function C(j,l){return j.classList.contains(l)?!0:j.classList.contains("monaco-list")||!j.parentElement?!1:C(j.parentElement,l)}function E(j){return C(j,"monaco-editor")}function O(j){return C(j,"monaco-custom-toggle")}function x(j){return C(j,"action-item")}function I(j){return C(j,"monaco-tl-twistie")}function _(j){return C(j,"monaco-tree-sticky-row")}function q(j){return j.classList.contains("monaco-tree-sticky-container")}function J(j){return j.tagName==="A"&&j.classList.contains("monaco-button")||j.tagName==="DIV"&&j.classList.contains("monaco-button-dropdown")?!0:j.classList.contains("monaco-list")||!j.parentElement?!1:J(j.parentElement)}class G{get g(){return $.Event.chain(this.c.add(new n.$YU(this.k.domNode,"keydown")).event,l=>l.filter(o=>!U(o.target)).map(o=>new P.$HS(o)))}constructor(l,o,g){this.h=l,this.k=o,this.c=new s.$Uc,this.d=new s.$Uc,this.f=g.multipleSelectionSupport,this.c.add(this.g(M=>{switch(M.keyCode){case e.KeyCode.Enter:return this.l(M);case e.KeyCode.UpArrow:return this.o(M);case e.KeyCode.DownArrow:return this.p(M);case e.KeyCode.PageUp:return this.q(M);case e.KeyCode.PageDown:return this.s(M);case e.KeyCode.Escape:return this.u(M);case e.KeyCode.KeyA:this.f&&(h.$k?M.metaKey:M.ctrlKey)&&this.t(M)}}))}updateOptions(l){l.multipleSelectionSupport!==void 0&&(this.f=l.multipleSelectionSupport)}l(l){l.preventDefault(),l.stopPropagation(),this.h.setSelection(this.h.getFocus(),l.browserEvent)}o(l){l.preventDefault(),l.stopPropagation(),this.h.focusPrevious(1,!1,l.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}p(l){l.preventDefault(),l.stopPropagation(),this.h.focusNext(1,!1,l.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}q(l){l.preventDefault(),l.stopPropagation(),this.h.focusPreviousPage(l.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}s(l){l.preventDefault(),l.stopPropagation(),this.h.focusNextPage(l.browserEvent);const o=this.h.getFocus()[0];this.h.setAnchor(o),this.h.reveal(o),this.k.domNode.focus()}t(l){l.preventDefault(),l.stopPropagation(),this.h.setSelection((0,D.$Rb)(this.h.length),l.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(l){this.h.getSelection().length&&(l.preventDefault(),l.stopPropagation(),this.h.setSelection([],l.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}et([y.$$h],G.prototype,"g",null);var K;(function(j){j[j.Automatic=0]="Automatic",j[j.Trigger=1]="Trigger"})(K||(t.TypeNavigationMode=K={}));var Q;(function(j){j[j.Idle=0]="Idle",j[j.Typing=1]="Typing"})(Q||(Q={})),t.$lV=new class{mightProducePrintableCharacter(j){return j.ctrlKey||j.metaKey||j.altKey?!1:j.keyCode>=e.KeyCode.KeyA&&j.keyCode<=e.KeyCode.KeyZ||j.keyCode>=e.KeyCode.Digit0&&j.keyCode<=e.KeyCode.Digit9||j.keyCode>=e.KeyCode.Numpad0&&j.keyCode<=e.KeyCode.Numpad9||j.keyCode>=e.KeyCode.Semicolon&&j.keyCode<=e.KeyCode.Quote}};class ae{constructor(l,o,g,M,k){this.o=l,this.p=o,this.q=g,this.s=M,this.t=k,this.c=!1,this.d=Q.Idle,this.f=K.Automatic,this.g=!1,this.h=-1,this.k=new s.$Uc,this.l=new s.$Uc,this.updateOptions(l.options)}updateOptions(l){l.typeNavigationEnabled??!0?this.u():this.v(),this.f=l.typeNavigationMode??K.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let l=!1;const o=$.Event.chain(this.k.add(new n.$YU(this.p.domNode,"keydown")).event,k=>k.filter(u=>!U(u.target)).filter(()=>this.f===K.Automatic||this.g).map(u=>new P.$HS(u)).filter(u=>l||this.s(u)).filter(u=>this.t.mightProducePrintableCharacter(u)).forEach(u=>i.$NT.stop(u,!0)).map(u=>u.browserEvent.key)),g=$.Event.debounce(o,()=>null,800,void 0,void 0,void 0,this.k);$.Event.reduce($.Event.any(o,g),(k,u)=>u===null?null:(k||"")+u,void 0,this.k)(this.x,this,this.k),g(this.w,this,this.k),o(()=>l=!0,void 0,this.k),g(()=>l=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const l=this.o.getFocus();if(l.length>0&&l[0]===this.h){const o=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(l[0]));typeof o=="string"?(0,N.$1U)(o):o&&(0,N.$1U)(o.get())}this.h=-1}x(l){if(!l){this.d=Q.Idle,this.g=!1;return}const o=this.o.getFocus(),g=o.length>0?o[0]:0,M=this.d===Q.Idle?1:0;this.d=Q.Typing;for(let k=0;k<this.o.length;k++){const u=(g+k+M)%this.o.length,L=this.q.getKeyboardNavigationLabel(this.p.element(u)),R=L&&L.toString();if(this.o.options.typeNavigationEnabled){if(typeof R<"u"){if((0,m.$Jk)(l,R)){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}const B=(0,m.$Qk)(l,R);if(B&&B[0].end-B[0].start>1&&B.length===1){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}}}else if(typeof R>"u"||(0,m.$Jk)(l,R)){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class me{constructor(l,o){this.d=l,this.f=o,this.c=new s.$Uc;const g=$.Event.chain(this.c.add(new n.$YU(o.domNode,"keydown")).event,k=>k.filter(u=>!U(u.target)).map(u=>new P.$HS(u)));$.Event.chain(g,k=>k.filter(u=>u.keyCode===e.KeyCode.Tab&&!u.ctrlKey&&!u.metaKey&&!u.shiftKey&&!u.altKey))(this.g,this,this.c)}g(l){if(l.target!==this.f.domNode)return;const o=this.d.getFocus();if(o.length===0)return;const g=this.f.domElement(o[0]);if(!g)return;const M=g.querySelector("[tabIndex]");if(!M||!(0,i.$zT)(M)||M.tabIndex===-1)return;const k=(0,i.getWindow)(M).getComputedStyle(M);k.visibility==="hidden"||k.display==="none"||(l.preventDefault(),l.stopPropagation(),M.focus())}dispose(){this.c.dispose()}}function ye(j){return h.$k?j.browserEvent.metaKey:j.browserEvent.ctrlKey}function Le(j){return j.browserEvent.shiftKey}function ne(j){return(0,i.$HT)(j)&&j.button===2}const ee={isSelectionSingleChangeEvent:ye,isSelectionRangeChangeEvent:Le};class ce{constructor(l){this.k=l,this.f=new s.$Uc,this.g=new $.$me,this.onPointer=this.g.event,l.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ee),this.d=typeof l.options.mouseSupport>"u"||!!l.options.mouseSupport,this.d&&(l.onMouseDown(this.s,this,this.f),l.onContextMenu(this.t,this,this.f),l.onMouseDblClick(this.v,this,this.f),l.onTouchStart(this.s,this,this.f),this.f.add(F.$rU.addTarget(l.getHTMLElement()))),$.Event.any(l.onMouseClick,l.onMouseMiddleClick,l.onTap)(this.u,this,this.f)}updateOptions(l){l.multipleSelectionSupport!==void 0&&(this.c=void 0,l.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ee))}o(l){return this.c?this.c.isSelectionSingleChangeEvent(l):!1}p(l){return this.c?this.c.isSelectionRangeChangeEvent(l):!1}q(l){return this.o(l)||this.p(l)}s(l){E(l.browserEvent.target)||(0,i.$kT)()!==l.browserEvent.target&&this.k.domFocus()}t(l){if(U(l.browserEvent.target)||E(l.browserEvent.target))return;const o=typeof l.index>"u"?[]:[l.index];this.k.setFocus(o,l.browserEvent)}u(l){if(!this.d||U(l.browserEvent.target)||E(l.browserEvent.target)||l.browserEvent.isHandledByList)return;l.browserEvent.isHandledByList=!0;const o=l.index;if(typeof o>"u"){this.k.setFocus([],l.browserEvent),this.k.setSelection([],l.browserEvent),this.k.setAnchor(void 0);return}if(this.q(l))return this.w(l);this.k.setFocus([o],l.browserEvent),this.k.setAnchor(o),ne(l.browserEvent)||this.k.setSelection([o],l.browserEvent),this.g.fire(l)}v(l){if(U(l.browserEvent.target)||E(l.browserEvent.target)||this.q(l)||l.browserEvent.isHandledByList)return;l.browserEvent.isHandledByList=!0;const o=this.k.getFocus();this.k.setSelection(o,l.browserEvent)}w(l){const o=l.index;let g=this.k.getAnchor();if(this.p(l)){typeof g>"u"&&(g=this.k.getFocus()[0]??o,this.k.setAnchor(g));const M=Math.min(g,o),k=Math.max(g,o),u=(0,D.$Rb)(M,k+1),L=this.k.getSelection(),R=te(be(L,[g]),g);if(R.length===0)return;const B=be(u,Ae(L,R));this.k.setSelection(B,l.browserEvent),this.k.setFocus([o],l.browserEvent)}else if(this.o(l)){const M=this.k.getSelection(),k=M.filter(u=>u!==o);this.k.setFocus([o]),this.k.setAnchor(o),M.length===k.length?this.k.setSelection([...k,o],l.browserEvent):this.k.setSelection(k,l.browserEvent)}}dispose(){this.f.dispose()}}t.$oV=ce;class le{constructor(l,o){this.c=l,this.d=o}style(l){const o=this.d&&`.${this.d}`,g=[];l.listBackground&&g.push(`.monaco-list${o} .monaco-list-rows { background: ${l.listBackground}; }`),l.listFocusBackground&&(g.push(`.monaco-list${o}:focus .monaco-list-row.focused { background-color: ${l.listFocusBackground}; }`),g.push(`.monaco-list${o}:focus .monaco-list-row.focused:hover { background-color: ${l.listFocusBackground}; }`)),l.listFocusForeground&&g.push(`.monaco-list${o}:focus .monaco-list-row.focused { color: ${l.listFocusForeground}; }`),l.listActiveSelectionBackground&&(g.push(`.monaco-list${o}:focus .monaco-list-row.selected { background-color: ${l.listActiveSelectionBackground}; }`),g.push(`.monaco-list${o}:focus .monaco-list-row.selected:hover { background-color: ${l.listActiveSelectionBackground}; }`)),l.listActiveSelectionForeground&&g.push(`.monaco-list${o}:focus .monaco-list-row.selected { color: ${l.listActiveSelectionForeground}; }`),l.listActiveSelectionIconForeground&&g.push(`.monaco-list${o}:focus .monaco-list-row.selected .codicon { color: ${l.listActiveSelectionIconForeground}; }`),l.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.selected.focused { background-color: ${l.listFocusAndSelectionBackground}; }
			`),l.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.selected.focused { color: ${l.listFocusAndSelectionForeground}; }
			`),l.listInactiveFocusForeground&&(g.push(`.monaco-list${o} .monaco-list-row.focused { color:  ${l.listInactiveFocusForeground}; }`),g.push(`.monaco-list${o} .monaco-list-row.focused:hover { color:  ${l.listInactiveFocusForeground}; }`)),l.listInactiveSelectionIconForeground&&g.push(`.monaco-list${o} .monaco-list-row.focused .codicon { color:  ${l.listInactiveSelectionIconForeground}; }`),l.listInactiveFocusBackground&&(g.push(`.monaco-list${o} .monaco-list-row.focused { background-color:  ${l.listInactiveFocusBackground}; }`),g.push(`.monaco-list${o} .monaco-list-row.focused:hover { background-color:  ${l.listInactiveFocusBackground}; }`)),l.listInactiveSelectionBackground&&(g.push(`.monaco-list${o} .monaco-list-row.selected { background-color:  ${l.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${o} .monaco-list-row.selected:hover { background-color:  ${l.listInactiveSelectionBackground}; }`)),l.listInactiveSelectionForeground&&g.push(`.monaco-list${o} .monaco-list-row.selected { color: ${l.listInactiveSelectionForeground}; }`),l.listHoverBackground&&g.push(`.monaco-list${o}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${l.listHoverBackground}; }`),l.listHoverForeground&&g.push(`.monaco-list${o}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${l.listHoverForeground}; }`);const M=(0,i.$$T)(l.listFocusAndSelectionOutline,(0,i.$$T)(l.listSelectionOutline,l.listFocusOutline??""));M&&g.push(`.monaco-list${o}:focus .monaco-list-row.focused.selected { outline: 1px solid ${M}; outline-offset: -1px;}`),l.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${o}:focus .monaco-list-row.focused { outline: 1px solid ${l.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused .monaco-list-row.focused { outline: 1px solid ${l.listFocusOutline}; outline-offset: -1px; }
			`);const k=(0,i.$$T)(l.listSelectionOutline,l.listInactiveFocusOutline??"");k&&g.push(`.monaco-list${o} .monaco-list-row.focused.selected { outline: 1px dotted ${k}; outline-offset: -1px; }`),l.listSelectionOutline&&g.push(`.monaco-list${o} .monaco-list-row.selected { outline: 1px dotted ${l.listSelectionOutline}; outline-offset: -1px; }`),l.listInactiveFocusOutline&&g.push(`.monaco-list${o} .monaco-list-row.focused { outline: 1px dotted ${l.listInactiveFocusOutline}; outline-offset: -1px; }`),l.listHoverOutline&&g.push(`.monaco-list${o} .monaco-list-row:hover { outline: 1px dashed ${l.listHoverOutline}; outline-offset: -1px; }`),l.listDropOverBackground&&g.push(`
				.monaco-list${o}.drop-target,
				.monaco-list${o} .monaco-list-rows.drop-target,
				.monaco-list${o} .monaco-list-row.drop-target { background-color: ${l.listDropOverBackground} !important; color: inherit !important; }
			`),l.listDropBetweenBackground&&(g.push(`
			.monaco-list${o} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${o} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${l.listDropBetweenBackground};
			}`),g.push(`
			.monaco-list${o} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${o} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${l.listDropBetweenBackground};
			}`)),l.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${l.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),l.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${l.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=g.join(`
`)}}t.$pV=le,t.$qV={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:p.$pu.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:p.$pu.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:p.$pu.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const ke={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function te(j,l){const o=j.indexOf(l);if(o===-1)return[];const g=[];let M=o-1;for(;M>=0&&j[M]===l-(o-M);)g.push(j[M--]);for(g.reverse(),M=o;M<j.length&&j[M]===l+(M-o);)g.push(j[M++]);return g}function be(j,l){const o=[];let g=0,M=0;for(;g<j.length||M<l.length;)if(g>=j.length)o.push(l[M++]);else if(M>=l.length)o.push(j[g++]);else if(j[g]===l[M]){o.push(j[g]),g++,M++;continue}else j[g]<l[M]?o.push(j[g++]):o.push(l[M++]);return o}function Ae(j,l){const o=[];let g=0,M=0;for(;g<j.length||M<l.length;)if(g>=j.length)o.push(l[M++]);else if(M>=l.length)o.push(j[g++]);else if(j[g]===l[M]){g++,M++;continue}else j[g]<l[M]?o.push(j[g++]):M++;return o}const Re=(j,l)=>j-l;class Ie{constructor(l,o){this.c=l,this.d=o}get templateId(){return this.c}renderTemplate(l){return this.d.map(o=>o.renderTemplate(l))}renderElement(l,o,g,M){let k=0;for(const u of this.d)u.renderElement(l,o,g[k++],M)}disposeElement(l,o,g,M){let k=0;for(const u of this.d)u.disposeElement?.(l,o,g[k],M),k+=1}disposeTemplate(l){let o=0;for(const g of this.d)g.disposeTemplate(l[o++])}}class je{constructor(l){this.c=l,this.templateId="a18n"}renderTemplate(l){return{container:l,disposables:new s.$Uc}}renderElement(l,o,g){const M=this.c.getAriaLabel(l),k=M&&typeof M!="string"?M:(0,d.constObservable)(M);g.disposables.add((0,d.autorun)(L=>{this.d(L.readObservable(k),g.container)}));const u=this.c.getAriaLevel&&this.c.getAriaLevel(l);typeof u=="number"?g.container.setAttribute("aria-level",`${u}`):g.container.removeAttribute("aria-level")}d(l,o){l?o.setAttribute("aria-label",l):o.removeAttribute("aria-label")}disposeElement(l,o,g,M){g.disposables.clear()}disposeTemplate(l){l.disposables.dispose()}}class _e{constructor(l,o){this.c=l,this.d=o}getDragElements(l){const o=this.c.getSelectedElements();return o.indexOf(l)>-1?o:[l]}getDragURI(l){return this.d.getDragURI(l)}getDragLabel(l,o){if(this.d.getDragLabel)return this.d.getDragLabel(l,o)}onDragStart(l,o){this.d.onDragStart?.(l,o)}onDragOver(l,o,g,M,k){return this.d.onDragOver(l,o,g,M,k)}onDragLeave(l,o,g,M){this.d.onDragLeave?.(l,o,g,M)}onDragEnd(l){this.d.onDragEnd?.(l)}drop(l,o,g,M,k){this.d.drop(l,o,g,M,k)}dispose(){this.d.dispose()}}class W{get onDidChangeFocus(){return $.Event.map(this.g.wrapEvent(this.c.onChange),l=>this.G(l),this.y)}get onDidChangeSelection(){return $.Event.map(this.g.wrapEvent(this.d.onChange),l=>this.G(l),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let l=!1;const o=$.Event.chain(this.y.add(new n.$YU(this.k.domNode,"keydown")).event,k=>k.map(u=>new P.$HS(u)).filter(u=>l=u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$NT.stop(u,!0)).filter(()=>!1)),g=$.Event.chain(this.y.add(new n.$YU(this.k.domNode,"keyup")).event,k=>k.forEach(()=>l=!1).map(u=>new P.$HS(u)).filter(u=>u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$NT.stop(u,!0)).map(({browserEvent:u})=>{const L=this.getFocus(),R=L.length?L[0]:void 0,B=typeof R<"u"?this.k.element(R):void 0,H=typeof R<"u"?this.k.domElement(R):this.k.domNode;return{index:R,element:B,anchor:H,browserEvent:u}})),M=$.Event.chain(this.k.onContextMenu,k=>k.filter(u=>!l).map(({element:u,index:L,browserEvent:R})=>({element:u,index:L,anchor:new S.$CS((0,i.getWindow)(this.k.domNode),R),browserEvent:R})));return $.Event.any(o,g,M)}get onKeyDown(){return this.y.add(new n.$YU(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new n.$YU(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new n.$YU(this.k.domNode,"keypress")).event}get onDidFocus(){return $.Event.signal(this.y.add(new n.$YU(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return $.Event.signal(this.y.add(new n.$YU(this.k.domNode,"blur",!0)).event)}constructor(l,o,g,M,k=ke){this.A=l,this.B=k,this.c=new b("focused"),this.f=new b("anchor"),this.g=new $.$ue,this.x="",this.y=new s.$Uc,this.z=new $.$me,this.onDidDispose=this.z.event;const u=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new A(u!=="listbox");const L=[this.c.renderer,this.d.renderer];this.u=k.accessibilityProvider,this.u&&(L.push(new je(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),M=M.map(B=>new Ie(B.templateId,[...L,B]));const R={...k,dnd:k.dnd&&new _e(this,k.dnd)};if(this.k=this.C(o,g,M,R),this.k.domNode.setAttribute("role",u),k.styleController)this.q=k.styleController(this.k.domId);else{const B=(0,i.$sT)(this.k.domNode);this.q=new le(B,this.k.domId)}if(this.o=new w.$3U([new V(this.c,this.k,k.identityProvider),new V(this.d,this.k,k.identityProvider),new V(this.f,this.k,k.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new me(this,this.k)),(typeof k.keyboardSupport!="boolean"||k.keyboardSupport)&&(this.v=new G(this,this.k,k),this.y.add(this.v)),k.keyboardNavigationLabelProvider){const B=k.keyboardNavigationDelegate||t.$lV;this.t=new ae(this,this.k,k.keyboardNavigationLabelProvider,k.keyboardNavigationEventFilter??(()=>!0),B),this.y.add(this.t)}this.w=this.D(k),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(l,o,g,M){return new T.$_U(l,o,g,M)}D(l){return new ce(this)}updateOptions(l={}){this.B={...this.B,...l},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(l),this.v?.updateOptions(l),this.k.updateOptions(l)}get options(){return this.B}splice(l,o,g=[]){if(l<0||l>this.k.length)throw new v.$bV(this.A,`Invalid start index: ${l}`);if(o<0)throw new v.$bV(this.A,`Invalid delete count: ${o}`);o===0&&g.length===0||this.g.bufferEvents(()=>this.o.splice(l,o,g))}updateWidth(l){this.k.updateWidth(l)}updateElementHeight(l,o){this.k.updateElementHeight(l,o,null)}rerender(){this.k.rerender()}element(l){return this.k.element(l)}indexOf(l){return this.k.indexOf(l)}indexAt(l){return this.k.indexAt(l)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(l){this.k.setScrollTop(l)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(l){this.k.setScrollLeft(l)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(l){this.x=l,this.k.domNode.setAttribute("aria-label",l)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(l,o){this.k.layout(l,o)}triggerTypeNavigation(){this.t?.trigger()}setSelection(l,o){for(const g of l)if(g<0||g>=this.length)throw new v.$bV(this.A,`Invalid index ${g}`);this.d.set(l,o)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(l=>this.k.element(l))}setAnchor(l){if(typeof l>"u"){this.f.set([]);return}if(l<0||l>=this.length)throw new v.$bV(this.A,`Invalid index ${l}`);this.f.set([l])}getAnchor(){return(0,D.$Ob)(this.f.get(),void 0)}getAnchorElement(){const l=this.getAnchor();return typeof l>"u"?void 0:this.element(l)}setFocus(l,o){for(const g of l)if(g<0||g>=this.length)throw new v.$bV(this.A,`Invalid index ${g}`);this.c.set(l,o)}focusNext(l=1,o=!1,g,M){if(this.length===0)return;const k=this.c.get(),u=this.E(k.length>0?k[0]+l:0,o,M);u>-1&&this.setFocus([u],g)}focusPrevious(l=1,o=!1,g,M){if(this.length===0)return;const k=this.c.get(),u=this.F(k.length>0?k[0]-l:0,o,M);u>-1&&this.setFocus([u],g)}async focusNextPage(l,o){let g=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);g=g===0?0:g-1;const M=this.getFocus()[0];if(M!==g&&(M===void 0||g>M)){const k=this.F(g,!1,o);k>-1&&M!==k?this.setFocus([k],l):this.setFocus([g],l)}else{const k=this.k.getScrollTop();let u=k+this.k.renderHeight;g>M&&(u-=this.k.elementHeight(g)),this.k.setScrollTop(u),this.k.getScrollTop()!==k&&(this.setFocus([]),await(0,f.$Hh)(0),await this.focusNextPage(l,o))}}async focusPreviousPage(l,o,g=()=>0){let M;const k=g(),u=this.k.getScrollTop()+k;u===0?M=this.k.indexAt(u):M=this.k.indexAfter(u-1);const L=this.getFocus()[0];if(L!==M&&(L===void 0||L>=M)){const R=this.E(M,!1,o);R>-1&&L!==R?this.setFocus([R],l):this.setFocus([M],l)}else{const R=u;this.k.setScrollTop(u-this.k.renderHeight-k),this.k.getScrollTop()+g()!==R&&(this.setFocus([]),await(0,f.$Hh)(0),await this.focusPreviousPage(l,o,g))}}focusLast(l,o){if(this.length===0)return;const g=this.F(this.length-1,!1,o);g>-1&&this.setFocus([g],l)}focusFirst(l,o){this.focusNth(0,l,o)}focusNth(l,o,g){if(this.length===0)return;const M=this.E(l,!1,g);M>-1&&this.setFocus([M],o)}E(l,o=!1,g){for(let M=0;M<this.length;M++){if(l>=this.length&&!o)return-1;if(l=l%this.length,!g||g(this.element(l)))return l;l++}return-1}F(l,o=!1,g){for(let M=0;M<this.length;M++){if(l<0&&!o)return-1;if(l=(this.length+l%this.length)%this.length,!g||g(this.element(l)))return l;l--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(l=>this.k.element(l))}reveal(l,o,g=0){if(l<0||l>=this.length)throw new v.$bV(this.A,`Invalid index ${l}`);const M=this.k.getScrollTop(),k=this.k.elementTop(l),u=this.k.elementHeight(l);if((0,a.$jg)(o)){const L=u-this.k.renderHeight+g;this.k.setScrollTop(L*(0,r.$Mm)(o,0,1)+k-g)}else{const L=k+u,R=M+this.k.renderHeight;k<M+g&&L>=R||(k<M+g||L>=R&&u>=this.k.renderHeight?this.k.setScrollTop(k-g):L>=R&&this.k.setScrollTop(L-this.k.renderHeight))}}getRelativeTop(l,o=0){if(l<0||l>=this.length)throw new v.$bV(this.A,`Invalid index ${l}`);const g=this.k.getScrollTop(),M=this.k.elementTop(l),k=this.k.elementHeight(l);if(M<g+o||M+k>g+this.k.renderHeight)return null;const u=k-this.k.renderHeight+o;return Math.abs((g+o-M)/u)}isDOMFocused(){return(0,i.$lT)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(l){return this.k.getElementDomId(l)}getElementTop(l){return this.k.elementTop(l)}style(l){this.q.style(l)}G({indexes:l,browserEvent:o}){return{indexes:l,elements:l.map(g=>this.k.element(g)),browserEvent:o}}H(){const l=this.c.get();this.k.domNode.classList.toggle("element-focused",l.length>0),this.I()}I(){const l=this.c.get();if(l.length>0){let o;this.u?.getActiveDescendantId&&(o=this.u.getActiveDescendantId(this.k.element(l[0]))),this.k.domNode.setAttribute("aria-activedescendant",o||this.k.getElementDomId(l[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const l=this.d.get();this.k.domNode.classList.toggle("selection-none",l.length===0),this.k.domNode.classList.toggle("selection-single",l.length===1),this.k.domNode.classList.toggle("selection-multiple",l.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$rV=W,et([y.$$h],W.prototype,"onDidChangeFocus",null),et([y.$$h],W.prototype,"onDidChangeSelection",null),et([y.$$h],W.prototype,"onContextMenu",null),et([y.$$h],W.prototype,"onKeyDown",null),et([y.$$h],W.prototype,"onKeyUp",null),et([y.$$h],W.prototype,"onKeyPress",null),et([y.$$h],W.prototype,"onDidFocus",null),et([y.$$h],W.prototype,"onDidBlur",null)}),define(pe[134],we([7]),{}),define(pe[135],we([7]),{}),define(pe[136],we([7]),{}),define(pe[137],we([7]),{}),define(pe[138],we([7]),{}),define(pe[13],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=P,t.localize2=N;const i=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function n(w,D){let f;return D.length===0?f=w:f=w.replace(/\{(\d+)\}/g,(p,y)=>{const $=y[0],m=D[$];let e=p;return typeof m=="string"?e=m:(typeof m=="number"||typeof m=="boolean"||m===void 0||m===null)&&(e=String(m)),e}),i&&(f="\uFF3B"+f.replace(/[aouei]/g,"$&$&")+"\uFF3D"),f}function P(w,D,...f){return n(typeof w=="number"?F(w,D):D,f)}function F(w,D){const f=globalThis._VSCODE_NLS_MESSAGES?.[w];if(typeof f!="string"){if(typeof D=="string")return D;throw new Error(`!!! NLS MISSING: ${w} !!!`)}return f}function N(w,D,...f){let p;typeof w=="number"?p=F(w,D):p=D;const y=n(p,f);return{value:y,original:D===p?y:n(D,f)}}}),define(pe[139],we([1,0,4,29,15,120,77,33,14,52,9,3,8,2,5,20,13,135]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$,m,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BV=void 0,i=He(i),p=He(p);const h=i.$,a="selectOption.entry.template";class v{get templateId(){return a}renderTemplate(d){const c=Object.create(null);return c.root=d,c.text=i.$ST(d,h(".option-text")),c.detail=i.$ST(d,h(".option-detail")),c.decoratorRight=i.$ST(d,h(".option-decorator-right")),c}renderElement(d,c,b){const A=b,V=d.text,U=d.detail,C=d.decoratorRight,E=d.isDisabled;A.text.textContent=V,A.detail.textContent=U||"",A.decoratorRight.innerText=C||"",E?A.root.classList.add("option-disabled"):A.root.classList.remove("option-disabled")}disposeTemplate(d){}}class T extends m.$Vc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(d,c,b,A,V){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=A,this.g=V||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=T.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new y.$me,this.B(this.r),this.Q(),this.P(b),this.n=c||0,d&&this.setOptions(d,c),this.S()}O(d){!this.M&&d?this.M=this.B((0,w.$AV)().setupManagedHover((0,D.$OU)("mouse"),this.h,d)):this.M&&this.M.update(d)}getHeight(){return 22}getTemplateId(){return a}P(d){this.u=d,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$ST(this.w,h(".select-box-details-pane"));const c=i.$ST(this.w,h(".select-box-dropdown-container-width-control")),b=i.$ST(c,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$ST(b,this.D),this.G=N.AnchorPosition.BELOW,this.y=i.$sT(this.w),this.w.setAttribute("draggable","true"),this.B(i.$KS(this.w,i.$LT.DRAG_START,A=>{i.$NT.stop(A,!0)}))}Q(){this.B(i.$LS(this.h,"change",c=>{this.n=c.target.selectedIndex,this.r.fire({index:c.target.selectedIndex,selected:c.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$KS(this.h,i.$LT.CLICK,c=>{i.$NT.stop(c),this.f?this.Z(!0):this.Y()})),this.B(i.$KS(this.h,i.$LT.MOUSE_DOWN,c=>{i.$NT.stop(c)}));let d;this.B(i.$KS(this.h,"touchstart",c=>{d=this.f})),this.B(i.$KS(this.h,"touchend",c=>{i.$NT.stop(c),d?this.Z(!0):this.Y()})),this.B(i.$KS(this.h,i.$LT.KEY_DOWN,c=>{const b=new P.$HS(c);let A=!1;e.$k?(b.keyCode===$.KeyCode.DownArrow||b.keyCode===$.KeyCode.UpArrow||b.keyCode===$.KeyCode.Space||b.keyCode===$.KeyCode.Enter)&&(A=!0):(b.keyCode===$.KeyCode.DownArrow&&b.altKey||b.keyCode===$.KeyCode.UpArrow&&b.altKey||b.keyCode===$.KeyCode.Space||b.keyCode===$.KeyCode.Enter)&&(A=!0),A&&(this.Y(),i.$NT.stop(c,!0))}))}get onDidSelect(){return this.r.event}setOptions(d,c){p.$ub(this.m,d)||(this.m=d,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,A)=>{this.h.add(this.X(b.text,A,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),c!==void 0&&(this.select(c),this.F=this.n)}setEnabled(d){this.h.disabled=!d}R(){this.z?.splice(0,this.z.length,this.m)}select(d){d>=0&&d<this.m.length?this.n=d:d>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(d){this.g.ariaLabel=d,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(d){this.h.tabIndex=d?0:-1}render(d){this.j=d,d.classList.add("select-container"),d.appendChild(this.h),this.U()}S(){const d=[];this.s.listFocusBackground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(d.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),d.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&d.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),d.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),d.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=d.join(`
`)}U(){const d=this.s.selectBackground??"",c=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=d,this.h.style.color=c,this.h.style.borderColor=b}W(){const d=this.s.selectBackground??"",c=i.$$T(this.s.selectListBackground,d);this.C.style.backgroundColor=c,this.I.style.backgroundColor=c;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(d,c,b){const A=document.createElement("option");return A.value=d,A.text=d,A.disabled=!!b,A}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:d=>this.ab(d,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:d=>this.ab(d),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(d){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),d&&this.h.focus(),this.u.hideContextView())}ab(d,c){return d.appendChild(this.w),this.cb(c),{dispose:()=>{this.w.remove()}}}bb(){let d=0;return this.m.forEach((c,b)=>{this.jb(b),this.I.offsetHeight>d&&(d=this.I.offsetHeight)}),d}cb(d){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const c=i.getWindow(this.h),b=i.$7S(this.h),A=i.getWindow(this.h).getComputedStyle(this.h),V=parseFloat(A.getPropertyValue("--dropdown-padding-top"))+parseFloat(A.getPropertyValue("--dropdown-padding-bottom")),U=c.innerHeight-b.top-b.height-(this.g.minBottomMargin||0),C=b.top-T.b,E=this.h.offsetWidth,O=this.db(this.D),x=Math.max(O,Math.round(E)).toString()+"px";this.w.style.width=x,this.z.getHTMLElement().style.height="",this.z.layout();let I=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const _=this.H?this.L:0,q=I+V+_,J=Math.floor((U-V-_)/this.getHeight()),G=Math.floor((C-V-_)/this.getHeight());if(d)return b.top+b.height>c.innerHeight-22||b.top<T.b||J<1&&G<1?!1:(J<T.c&&G>J&&this.m.length>J?(this.G=N.AnchorPosition.ABOVE,this.C.remove(),this.I.remove(),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=N.AnchorPosition.BELOW,this.C.remove(),this.I.remove(),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(b.top+b.height>c.innerHeight-22||b.top<T.b||this.G===N.AnchorPosition.BELOW&&J<1||this.G===N.AnchorPosition.ABOVE&&G<1)return this.Z(!0),!1;if(this.G===N.AnchorPosition.BELOW){if(this.f&&J+G<1)return this.Z(!0),!1;q>U&&(I=J*this.getHeight())}else q>C&&(I=G*this.getHeight());return this.z.layout(I),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=I+V+"px",this.w.style.height=""):this.w.style.height=I+V+"px",this.jb(this.n),this.w.style.width=x,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(d){let c=0;if(d){let b=0,A=0;this.m.forEach((V,U)=>{const C=V.detail?V.detail.length:0,E=V.decoratorRight?V.decoratorRight.length:0,O=V.text.length+C+E;O>A&&(b=U,A=O)}),d.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),c=i.$9S(d)}return c}eb(d){if(this.z)return;this.C=i.$ST(d,h(".select-box-dropdown-list-container")),this.t=new v,this.z=this.B(new f.$rV("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:s.ScrollbarVisibility.Visible,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:A=>{let V=A.text;return A.detail&&(V+=`. ${A.detail}`),A.decoratorRight&&(V+=`. ${A.decoratorRight}`),A.description&&(V+=`. ${A.description}`),V},getWidgetAriaLabel:()=>(0,r.localize)(28,null),getRole:()=>e.$k?"":"option",getWidgetRole:()=>"listbox"}})),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const c=this.B(new n.$YU(this.C,"keydown")),b=y.Event.chain(c.event,A=>A.filter(()=>this.z.length>0).map(V=>new P.$HS(V)));this.B(y.Event.chain(b,A=>A.filter(V=>V.keyCode===$.KeyCode.Enter))(this.lb,this)),this.B(y.Event.chain(b,A=>A.filter(V=>V.keyCode===$.KeyCode.Tab))(this.lb,this)),this.B(y.Event.chain(b,A=>A.filter(V=>V.keyCode===$.KeyCode.Escape))(this.kb,this)),this.B(y.Event.chain(b,A=>A.filter(V=>V.keyCode===$.KeyCode.UpArrow))(this.nb,this)),this.B(y.Event.chain(b,A=>A.filter(V=>V.keyCode===$.KeyCode.DownArrow))(this.mb,this)),this.B(y.Event.chain(b,A=>A.filter(V=>V.keyCode===$.KeyCode.PageDown))(this.pb,this)),this.B(y.Event.chain(b,A=>A.filter(V=>V.keyCode===$.KeyCode.PageUp))(this.ob,this)),this.B(y.Event.chain(b,A=>A.filter(V=>V.keyCode===$.KeyCode.Home))(this.qb,this)),this.B(y.Event.chain(b,A=>A.filter(V=>V.keyCode===$.KeyCode.End))(this.rb,this)),this.B(y.Event.chain(b,A=>A.filter(V=>V.keyCode>=$.KeyCode.Digit0&&V.keyCode<=$.KeyCode.KeyZ||V.keyCode>=$.KeyCode.Semicolon&&V.keyCode<=$.KeyCode.NumpadDivide))(this.sb,this)),this.B(i.$KS(this.z.getHTMLElement(),i.$LT.POINTER_UP,A=>this.fb(A))),this.B(this.z.onMouseOver(A=>typeof A.index<"u"&&this.z.setFocus([A.index]))),this.B(this.z.onDidChangeFocus(A=>this.ib(A))),this.B(i.$KS(this.w,i.$LT.FOCUS_OUT,A=>{!this.f||i.$cT(A.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(d){if(!this.z.length)return;i.$NT.stop(d);const c=d.target;if(!c||c.classList.contains("slider"))return;const b=c.closest(".monaco-list-row");if(!b)return;const A=Number(b.getAttribute("data-index")),V=b.classList.contains("option-disabled");A>=0&&A<this.m.length&&!V&&(this.n=A,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(d,c){const b=V=>{for(let U=0;U<V.childNodes.length;U++){const C=V.childNodes.item(U);(C.tagName&&C.tagName.toLowerCase())==="img"?C.remove():b(C)}},A=(0,F.$uV)({value:d,supportThemeIcons:!0},{actionHandler:c});return A.element.classList.add("select-box-description-markdown"),b(A.element),A.element}ib(d){!this.f||!this.H||this.jb(d.indexes[0])}jb(d){this.I.innerText="";const c=this.m[d],b=c?.description??"",A=c?.descriptionIsMarkdown??!1;if(b){if(A){const V=c.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(b,V))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(d){i.$NT.stop(d),this.select(this.F),this.Z(!0)}lb(d){i.$NT.stop(d),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(d){if(this.n<this.m.length-1){i.$NT.stop(d,!0);const c=this.m[this.n+1].isDisabled;if(c&&this.m.length>this.n+2)this.n+=2;else{if(c)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(d){this.n>0&&(i.$NT.stop(d,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(d){i.$NT.stop(d),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(d){i.$NT.stop(d),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(d){i.$NT.stop(d),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(d){i.$NT.stop(d),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(d){const c=$.KeyCodeUtils.toString(d.keyCode);let b=-1;for(let A=0;A<this.m.length-1;A++)if(b=(A+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===c&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),i.$NT.stop(d);break}}dispose(){this.Z(!1),super.dispose()}}t.$BV=T}),define(pe[140],we([1,0,52,139,115,23,5,134]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EV=t.$DV=void 0,t.$DV={...i.$qV,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class w extends F.$vU{constructor(f,p,y,$,m){super(),N.$k&&!m?.useCustomDrawn?this.a=new P.$CV(f,p,$,m):this.a=new n.$BV(f,p,y,$,m),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,p){this.a.setOptions(f,p)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}setEnabled(f){this.a.setEnabled(f)}render(f){this.a.render(f)}}t.$EV=w}),define(pe[53],we([1,0,3,2,13]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pj=t.$oj=t.$nj=t.$mj=t.$lj=void 0,t.$qj=p,P=He(P);class F extends n.$Vc{constructor($,m="",e="",s=!0,r){super(),this.j=this.B(new i.$me),this.onDidChange=this.j.event,this.z=!0,this.m=$,this.n=m,this.w=e,this.z=s,this.D=r}get id(){return this.m}get label(){return this.n}set label($){this.F($)}F($){this.n!==$&&(this.n=$,this.j.fire({label:$}))}get tooltip(){return this.u||""}set tooltip($){this.G($)}G($){this.u!==$&&(this.u=$,this.j.fire({tooltip:$}))}get class(){return this.w}set class($){this.H($)}H($){this.w!==$&&(this.w=$,this.j.fire({class:$}))}get enabled(){return this.z}set enabled($){this.I($)}I($){this.z!==$&&(this.z=$,this.j.fire({enabled:$}))}get checked(){return this.C}set checked($){this.J($)}J($){this.C!==$&&(this.C=$,this.j.fire({checked:$}))}async run($,m){this.D&&await this.D($)}}t.$lj=F;class N extends n.$Vc{constructor(){super(...arguments),this.f=this.B(new i.$me),this.onWillRun=this.f.event,this.m=this.B(new i.$me),this.onDidRun=this.m.event}async run($,m){if(!$.enabled)return;this.f.fire({action:$});let e;try{await this.u($,m)}catch(s){e=s}this.m.fire({action:$,error:e})}async u($,m){await $.run(m)}}t.$mj=N;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let m=[];for(const e of $)e.length&&(m.length?m=[...m,new w,...e]:m=e);return m}static{this.ID="vs.actions.separator"}async run(){}}t.$nj=w;class D{get actions(){return this.a}constructor($,m,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=m,this.class=s,this.a=e}async run(){}}t.$oj=D;class f extends F{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,P.localize(39,null),void 0,!1)}}t.$pj=f;function p(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...$)=>y.run(...$)}}}),define(pe[80],we([1,0,18,69,4,32,14,140,53,2,5,10,13,33,75]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MV=t.$LV=t.$KV=void 0,p=He(p),y=He(y),$=He($);class e extends f.$Vc{get action(){return this._action}constructor(a,v,T={}){super(),this.m=T,this._context=a||this,this._action=v,v instanceof D.$lj&&this.B(v.onDidChange(S=>{this.element&&this.t(S)}))}t(a){a.enabled!==void 0&&this.u(),a.checked!==void 0&&this.H(),a.class!==void 0&&this.G(),a.label!==void 0&&(this.w(),this.D()),a.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new D.$mj)),this.j}set actionRunner(a){this.j=a}isEnabled(){return this._action.enabled}setActionContext(a){this._context=a}render(a){const v=this.element=a;this.B(F.$rU.addTarget(a));const T=this.m&&this.m.draggable;T&&(a.draggable=!0,i.$pS&&this.B((0,P.$KS)(a,P.$LT.DRAG_START,S=>S.dataTransfer?.setData(n.$pU.TEXT,this._action.label)))),this.B((0,P.$KS)(v,F.EventType.Tap,S=>this.onClick(S,!0))),this.B((0,P.$KS)(v,P.$LT.MOUSE_DOWN,S=>{T||P.$NT.stop(S,!0),this._action.enabled&&S.button===0&&v.classList.add("active")})),p.$k&&this.B((0,P.$KS)(v,P.$LT.CONTEXT_MENU,S=>{S.button===0&&S.ctrlKey===!0&&this.onClick(S)})),this.B((0,P.$KS)(v,P.$LT.CLICK,S=>{P.$NT.stop(S,!0),this.m&&this.m.isMenu||this.onClick(S)})),this.B((0,P.$KS)(v,P.$LT.DBLCLICK,S=>{P.$NT.stop(S,!0)})),[P.$LT.MOUSE_UP,P.$LT.MOUSE_OUT].forEach(S=>{this.B((0,P.$KS)(v,S,d=>{P.$NT.stop(d),v.classList.remove("active")}))})}onClick(a,v=!1){P.$NT.stop(a,!0);const T=y.$og(this._context)?this.m?.useEventAsContext?a:{preserveFocus:v}:this._context;this.actionRunner.run(this._action,T)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(a){this.element&&(this.element.tabIndex=a?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const a=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=a;else if(!this.f&&a!==""){const v=this.m.hoverDelegate??(0,N.$OU)("element");this.f=this.q.add((0,m.$AV)().setupManagedHover(v,this.element,a))}else this.f&&this.f.update(a)}F(){if(this.element){const a=this.C()??"";this.element.setAttribute("aria-label",a)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$KV=e;class s extends e{constructor(a,v,T){super(a,v,T),this.m=T,this.m.icon=T.icon!==void 0?T.icon:!1,this.m.label=T.label!==void 0?T.label:!0,this.L=""}render(a){super.render(a),y.$pg(this.element);const v=document.createElement("a");if(v.classList.add("action-label"),v.setAttribute("role",this.M()),this.I=v,this.element.appendChild(v),this.m.label&&this.m.keybinding){const T=document.createElement("span");T.classList.add("keybinding"),T.textContent=this.m.keybinding,this.element.appendChild(T)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===D.$nj.ID?"presentation":this.m.isMenu?"menuitem":this.m.isTabList?"tab":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(a){this.I&&(this.I.tabIndex=a?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let a=null;return this.action.tooltip?a=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(a=this.action.label,this.m.keybinding&&(a=$.localize(0,null,a,this.m.keybinding))),a??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const a=this.C()??"";this.I.setAttribute("aria-label",a)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.m.isTabList?this.I.setAttribute("aria-selected",this.action.checked?"true":"false"):(this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox"))):(this.I.classList.remove("checked"),this.I.removeAttribute(this.m.isTabList?"aria-selected":"aria-checked"),this.I.setAttribute("role",this.M())))}}t.$LV=s;class r extends e{constructor(a,v,T,S,d,c,b){super(a,v),this.b=new w.$EV(T,S,d,c,b),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(a,v){this.b.setOptions(a,v)}select(a){this.b.select(a)}g(){this.B(this.b.onDidSelect(a=>this.n(a.selected,a.index)))}n(a,v){this.actionRunner.run(this._action,this.r(a,v))}r(a,v){return a}setFocusable(a){this.b.setFocusable(a)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(a){this.b.render(a)}}t.$MV=r}),define(pe[81],we([1,0,4,15,80,14,53,3,8,2,10,75]),function(oe,t,i,n,P,F,N,w,D,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QU=t.ActionsOrientation=void 0,t.$RU=m,i=He(i),p=He(p);var y;(function(e){e[e.HORIZONTAL=0]="HORIZONTAL",e[e.VERTICAL=1]="VERTICAL"})(y||(t.ActionsOrientation=y={}));class $ extends f.$Vc{constructor(s,r={}){super(),this.j=this.B(new f.$Uc),this.s=this.B(new f.$5c),this.y=!1,this.z=!0,this.D=this.B(new w.$me),this.onDidBlur=this.D.event,this.F=this.B(new w.$me({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new w.$me),this.onDidRun=this.H.event,this.I=this.B(new w.$me),this.onWillRun=this.I.event,this.b=r,this.m=r.context??null,this.n=this.b.orientation??y.HORIZONTAL,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[D.KeyCode.Enter,D.KeyCode.Space]},this.f=r.hoverDelegate??this.B((0,F.$PU)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new N.$mj,this.j.add(this.g)),this.j.add(this.g.onDidRun(v=>this.H.fire(v))),this.j.add(this.g.onWillRun(v=>this.I.fire(v))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let h,a;switch(this.n){case y.HORIZONTAL:h=[D.KeyCode.LeftArrow],a=[D.KeyCode.RightArrow];break;case y.VERTICAL:h=[D.KeyCode.UpArrow],a=[D.KeyCode.DownArrow],this.domNode.className+=" vertical";break}this.B(i.$KS(this.domNode,i.$LT.KEY_DOWN,v=>{const T=new n.$HS(v);let S=!0;const d=typeof this.u=="number"?this.viewItems[this.u]:void 0;h&&(T.equals(h[0])||T.equals(h[1]))?S=this.Q():a&&(T.equals(a[0])||T.equals(a[1]))?S=this.P():T.equals(D.KeyCode.Escape)&&this.G?this.F.fire():T.equals(D.KeyCode.Home)?S=this.N():T.equals(D.KeyCode.End)?S=this.O():T.equals(D.KeyCode.Tab)&&d instanceof P.$KV&&d.trapsArrowNavigation?S=this.P(void 0,!0):this.L(T)?this.r.keyDown?this.S(T):this.y=!0:S=!1,S&&(T.preventDefault(),T.stopPropagation())})),this.B(i.$KS(this.domNode,i.$LT.KEY_UP,v=>{const T=new n.$HS(v);this.L(T)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(T)),T.preventDefault(),T.stopPropagation()):(T.equals(D.KeyCode.Tab)||T.equals(D.KeyMod.Shift|D.KeyCode.Tab)||T.equals(D.KeyCode.UpArrow)||T.equals(D.KeyCode.DownArrow)||T.equals(D.KeyCode.LeftArrow)||T.equals(D.KeyCode.RightArrow))&&this.M()})),this.w=this.B(i.$QT(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$kT()===this.domNode||!i.$cT(i.$kT(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),s.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(s){s?this.C.setAttribute("aria-label",s):this.C.removeAttribute("aria-label")}setFocusable(s){if(this.z=s,this.z){const r=this.viewItems.find(h=>h instanceof P.$KV&&h.isEnabled());r instanceof P.$KV&&r.setFocusable(!0)}else this.viewItems.forEach(r=>{r instanceof P.$KV&&r.setFocusable(!1)})}L(s){let r=!1;return this.r.keys.forEach(h=>{r=r||s.equals(h)}),r}M(){for(let s=0;s<this.C.children.length;s++){const r=this.C.children[s];if(i.$cT(i.$kT(),r)){this.u=s,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(s){this.m=s,this.viewItems.forEach(r=>r.setActionContext(s))}get actionRunner(){return this.g}set actionRunner(s){this.g=s,this.j.clear(),this.j.add(this.g.onDidRun(r=>this.H.fire(r))),this.j.add(this.g.onWillRun(r=>this.I.fire(r))),this.viewItems.forEach(r=>r.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(r=>r.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(i.$zT(s)){for(;s.parentElement!==this.C;){if(!s.parentElement)return;s=s.parentElement}for(let r=0;r<this.C.childNodes.length;r++)if(this.C.childNodes[r]===s)return this.viewItems[r].action}}push(s,r={}){const h=Array.isArray(s)?s:[s];let a=p.$jg(r.index)?r.index:null;h.forEach(v=>{const T=document.createElement("li");T.className="action-item",T.setAttribute("role","presentation");let S;const d={hoverDelegate:this.f,...r,isTabList:this.b.ariaRole==="tablist"};this.b.actionViewItemProvider&&(S=this.b.actionViewItemProvider(v,d)),S||(S=new P.$LV(this.context,v,d)),this.b.allowContextMenu||this.s.set(S,i.$KS(T,i.$LT.CONTEXT_MENU,c=>{i.$NT.stop(c,!0)})),S.actionRunner=this.g,S.setActionContext(this.context),S.render(T),this.z&&S instanceof P.$KV&&this.viewItems.length===0&&S.setFocusable(!0),a===null||a<0||a>=this.C.children.length?(this.C.appendChild(T),this.viewItems.push(S)):(this.C.insertBefore(T,this.C.children[a]),this.viewItems.splice(a,0,S),a++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(s){if(s>=0&&s<this.C.children.length){const r=this.C.children.item(s);if(r)return r.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.C.children.length){const r=this.C.children.item(s);if(r)return r.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.C.childNodes[s].remove(),this.s.deleteAndDispose(this.viewItems[s]),(0,f.$Qc)(this.viewItems.splice(s,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,f.$Qc)(this.viewItems),this.s.clearAndDisposeAll(),i.$JS(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let r=!1,h;if(s===void 0?r=!0:typeof s=="number"?h=s:typeof s=="boolean"&&(r=s),r&&typeof this.u>"u"){const a=this.viewItems.findIndex(v=>v.isEnabled());this.u=a===-1?void 0:a,this.R(void 0,void 0,!0)}else h!==void 0&&(this.u=h),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(s,r){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const h=this.u;let a;do{if(!s&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=h,!1;this.u=(this.u+1)%this.viewItems.length,a=this.viewItems[this.u]}while(this.u!==h&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===N.$nj.ID));return this.R(void 0,void 0,r),!0}Q(s){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const r=this.u;let h;do{if(this.u=this.u-1,this.u<0){if(!s&&this.b.preventLoopNavigation)return this.u=r,!1;this.u=this.viewItems.length-1}h=this.viewItems[this.u]}while(this.u!==r&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===N.$nj.ID));return this.R(!0),!0}R(s,r,h=!1){typeof this.u>"u"&&this.C.focus({preventScroll:r}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const a=this.u!==void 0?this.viewItems[this.u]:void 0;if(a){let v=!0;p.$tg(a.focus)||(v=!1),this.b.focusOnlyEnabledItems&&p.$tg(a.isEnabled)&&!a.isEnabled()&&(v=!1),a.action.id===N.$nj.ID&&(v=!1),v?(h||this.t!==this.u)&&(a.focus(s),this.t=this.u):(this.C.focus({preventScroll:r}),this.t=void 0),v&&a.showHover?.()}}S(s){if(typeof this.u>"u")return;const r=this.viewItems[this.u];if(r instanceof P.$KV){const h=r._context===null||r._context===void 0?s:r._context;this.run(r._action,h)}}async run(s,r){await this.g.run(s,r)}dispose(){this.m=void 0,this.viewItems=(0,f.$Qc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$QU=$;function m(e){if(!e.length)return e;let s=-1;for(let h=0;h<e.length;h++)if(e[h].id!==N.$nj.ID){s=h;break}if(s===-1)return[];e=e.slice(s);for(let h=e.length-1;h>=0&&e[h].id===N.$nj.ID;h--)e.splice(h,1);let r=!1;for(let h=e.length-1;h>=0;h--){const a=e[h].id===N.$nj.ID;a&&!r?e.splice(h,1):a?a&&(r=!1):r=!0}return e}}),define(pe[82],we([1,0,4,29,70,81,76,77,33,14,78,23,3,95,64,20,13,131]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$,m,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BW=t.$AW=t.$zW=t.MessageType=void 0,i=He(i),N=He(N),r=He(r);const h=i.$;var a;(function(S){S[S.INFO=1]="INFO",S[S.WARNING=2]="WARNING",S[S.ERROR=3]="ERROR"})(a||(t.MessageType=a={})),t.$zW={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class v extends y.$vU{constructor(d,c,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new $.$me),this.onDidChange=this.P.event,this.Q=this.B(new $.$me),this.onDidHeightChange=this.Q.event,this.a=c,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$ST(d,h(".monaco-inputbox.idle"));const A=this.g.flexibleHeight?"textarea":"input",V=i.$ST(this.element,h(".ibwrapper"));if(this.b=i.$ST(V,h(A+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$ST(V,h("div.mirror")),this.y.innerText="\xA0",this.N=new p.$FU(this.element,{vertical:s.ScrollbarVisibility.Auto}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$ST(d,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(E=>this.b.scrollTop=E.scrollTop));const U=this.B(new n.$YU(d.ownerDocument,"selectionchange")),C=$.Event.filter(U.event,()=>d.ownerDocument.getSelection()?.anchorNode===V);this.B(C(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new F.$QU(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(d){this.n=d,this.b.setAttribute("placeholder",d)}setTooltip(d){this.r=d,this.O?this.O.update(d):this.O=this.B((0,D.$AV)().setupManagedHover((0,f.$OU)("mouse"),this.b,d))}setAriaLabel(d){this.s=d,d?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(d){this.b.value!==d&&(this.b.value=d,this.Z())}get step(){return this.b.step}set step(d){this.b.step=d}get height(){return typeof this.J=="number"?this.J:i.$aT(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$lT(this.b)}select(d=null){this.b.select(),d&&(this.b.setSelectionRange(d.start,d.end),d.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const d=this.b.selectionStart;if(d===null)return null;const c=this.b.selectionEnd??d;return{start:d,end:c}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(d){d?this.enable():this.disable()}get width(){return i.$9S(this.b)}set width(d){if(this.g.flexibleHeight&&this.g.flexibleWidth){let c=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,A=parseFloat(this.y.style.paddingRight||"")||0;c=b+A}this.b.style.width=d-c+"px"}else this.b.style.width=d+"px";this.y&&(this.y.style.width=d+"px")}set paddingRight(d){this.b.style.width=`calc(100% - ${d}px)`,this.y&&(this.y.style.paddingRight=d+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const d=this.L,c=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:d,height:c}),this.N.setScrollPosition({scrollTop:b})}showMessage(d,c){if(this.w==="open"&&(0,e.$jo)(this.h,d))return;this.h=d,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(d.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$$T(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||c)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let d=null;return this.t&&(d=this.t(this.value),d?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(d)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),d?.type}stylesForType(d){const c=this.g.inputBoxStyles;switch(d){case a.INFO:return{border:c.inputValidationInfoBorder,background:c.inputValidationInfoBackground,foreground:c.inputValidationInfoForeground};case a.WARNING:return{border:c.inputValidationWarningBorder,background:c.inputValidationWarningBackground,foreground:c.inputValidationWarningForeground};default:return{border:c.inputValidationErrorBorder,background:c.inputValidationErrorBackground,foreground:c.inputValidationErrorForeground}}}W(d){switch(d){case a.INFO:return"info";case a.WARNING:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let d;const c=()=>d.style.width=i.$9S(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:w.AnchorAlignment.RIGHT,render:A=>{if(!this.h)return null;d=i.$ST(A,h(".monaco-inputbox-container")),c();const V={inline:!0,className:"monaco-inputbox-message"},U=this.h.formatContent?(0,P.$WU)(this.h.content,V):(0,P.$VU)(this.h.content,V);U.classList.add(this.W(this.h.type));const C=this.stylesForType(this.h.type);return U.style.backgroundColor=C.background??"",U.style.color=C.foreground??"",U.style.border=C.border?`1px solid ${C.border}`:"",i.$ST(d,U),null},onHide:()=>{this.w="closed"},layout:c});let b;this.h.type===a.ERROR?b=r.localize(19,null,this.h.content):this.h.type===a.WARNING?b=r.localize(20,null,this.h.content):b=r.localize(21,null,this.h.content),N.$1U(b),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const d=this.value,b=d.charCodeAt(d.length-1)===10?" ":"";(d+b).replace(/\u000c/g,"")?this.y.textContent=d+b:this.y.innerText="\xA0",this.layout()}bb(){const d=this.g.inputBoxStyles,c=d.inputBackground??"",b=d.inputForeground??"",A=d.inputBorder??"";this.element.style.backgroundColor=c,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${i.$$T(A,"transparent")}`}layout(){if(!this.y)return;const d=this.L;this.L=i.$aT(this.y),d!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(d){const c=this.inputElement,b=c.selectionStart,A=c.selectionEnd,V=c.value;b!==null&&A!==null&&(this.value=V.substr(0,b)+d+V.substr(A),c.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$AW=v;class T extends v{constructor(d,c,b){const A=r.localize(22,null,"\u21C5"),V=r.localize(23,null,"\u21C5");super(d,c,b),this.eb=this.B(new $.$me),this.onDidFocus=this.eb.event,this.fb=this.B(new $.$me),this.onDidBlur=this.fb.event,this.cb=new m.$xW(b.history,100);const U=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(A)&&!this.n.endsWith(V)&&this.cb.getHistory().length){const C=this.n.endsWith(")")?A:V,E=this.n+C;b.showPlaceholderOnFocus&&!i.$lT(this.b)?this.n=E:this.setPlaceHolder(E)}};this.db=new MutationObserver((C,E)=>{C.forEach(O=>{O.target.textContent||U()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>U()),this.F(this.b,()=>{const C=E=>{if(this.n.endsWith(E)){const O=this.n.slice(0,this.n.length-E.length);return b.showPlaceholderOnFocus?this.n=O:this.setPlaceHolder(O),!0}else return!1};C(V)||C(A)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(d){this.value&&(d||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(d){const c=this.getHistory();this.clearHistory(),d.forEach(b=>{this.cb.add(b)}),c.forEach(b=>{this.cb.add(b)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let d=this.kb();d&&(d=d===this.value?this.kb():d),this.value=d??"",N.$2U(this.value?this.value:r.localize(24,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let d=this.jb();d&&(d=d===this.value?this.jb():d),d&&(this.value=d,N.$2U(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(d){super.setPlaceHolder(d),this.setTooltip(d)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let d=this.cb.current();return d||(d=this.cb.last(),this.cb.next()),d}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$BW=T}),define(pe[83],we([1,0,80,23,21,22,3,8,4,14,33,136]),function(oe,t,i,n,P,F,N,w,D,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JV=t.$IV=t.$HV=t.$GV=t.$FV=void 0,t.$FV={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends i.$KV{constructor(r,h,a){super(r,h,a),this.a=this.B(new $({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:a.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:a.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:a.toggleStyles?.inputActiveOptionForeground,hoverDelegate:a.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(r){this.element=r,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(r){this.a.domNode.tabIndex=r?0:-1}}t.$GV=y;class $ extends n.$vU{constructor(r){super(),this.a=this.B(new N.$me),this.onChange=this.a.event,this.b=this.B(new N.$me),this.onKeyDown=this.b.event,this.c=r,this.s=this.c.isChecked;const h=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,h.push(...F.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&h.push(...this.c.actionClassName.split(" ")),this.s&&h.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,p.$AV)().setupManagedHover(r.hoverDelegate??(0,f.$OU)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...h),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,a=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),a.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,a=>{if(a.keyCode===w.KeyCode.Space||a.keyCode===w.KeyCode.Enter){this.checked=!this.s,this.a.fire(!0),a.preventDefault(),a.stopPropagation();return}this.b.fire(a)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(r){this.s=r,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(r){this.g&&this.domNode.classList.remove(...F.ThemeIcon.asClassNameArray(this.g)),this.g=r,this.g&&this.domNode.classList.add(...F.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(r){this.t.update(r),this.domNode.setAttribute("aria-label",r)}set visible(r){this.domNode.style.display=r?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$HV=$;class m extends n.$vU{static{this.CLASS_NAME="monaco-checkbox"}constructor(r,h,a){super(),this.g=r,this.h=h,this.a=this.B(new N.$me),this.onChange=this.a.event,this.b=this.B(new $({title:this.g,isChecked:this.h,icon:P.$6j.check,actionClassName:m.CLASS_NAME,...t.$FV})),this.domNode=this.b.domNode,this.c=a,this.n(),this.B(this.b.onChange(v=>{this.n(),this.a.fire(v)}))}get checked(){return this.b.checked}set checked(r){this.b.checked=r,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,D.$lT)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$IV=m;class e extends i.$KV{constructor(r,h,a){super(r,h,a),this.a=this.B(new m(this._action.label,!!this._action.checked,a.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(r){if(this.element=r,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const h=this.element.appendChild((0,D.$)("span.checkbox-label",void 0,this._action.label));this.B((0,D.$KS)(h,D.$LT.CLICK,a=>{this.a.checked=!this.a.checked,a.stopPropagation(),a.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(r){this.a.domNode.tabIndex=r?0:-1}}t.$JV=e}),define(pe[141],we([1,0,14,83,21,13]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HW=t.$GW=t.$FW=void 0,F=He(F);const N=F.localize(10,null),w=F.localize(11,null),D=F.localize(12,null);class f extends n.$HV{constructor(m){super({icon:P.$6j.caseSensitive,title:N+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$OU)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$FW=f;class p extends n.$HV{constructor(m){super({icon:P.$6j.wholeWord,title:w+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$OU)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$GW=p;class y extends n.$HV{constructor(m){super({icon:P.$6j.regex,title:D+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$OU)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$HW=y}),define(pe[142],we([1,0,4,141,82,23,3,8,13,2,14,130]),function(oe,t,i,n,P,F,N,w,D,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IW=void 0,i=He(i),D=He(D);const y=D.localize(9,null);class $ extends F.$vU{static{this.OPTION_CHANGE="optionChange"}constructor(e,s,r){super(),this.n=!0,this.s=!1,this.w=this.B(new f.$Wc),this.N=[],this.O=this.B(new N.$me),this.onDidOptionChange=this.O.event,this.P=this.B(new N.$me),this.onKeyDown=this.P.event,this.Q=this.B(new N.$me),this.onMouseDown=this.Q.event,this.R=this.B(new N.$me),this.onInput=this.R.event,this.S=this.B(new N.$me),this.onKeyUp=this.S.event,this.U=this.B(new N.$me),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new N.$me),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=r.placeholder||"",this.b=r.validation,this.c=r.label||y,this.h=!!r.showCommonFindToggles;const h=r.appendCaseSensitiveLabel||"",a=r.appendWholeWordsLabel||"",v=r.appendRegexLabel||"",T=r.history||[],S=!!r.flexibleHeight,d=!!r.flexibleWidth,c=r.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new P.$BW(this.domNode,s,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:T,showHistoryHint:r.showHistoryHint,flexibleHeight:S,flexibleWidth:d,flexibleMaxHeight:c,inputBoxStyles:r.inputBoxStyles}));const b=this.B((0,p.$PU)());if(this.h){this.J=this.B(new n.$HW({appendTitle:v,isChecked:!1,hoverDelegate:b,...r.toggleStyles})),this.B(this.J.onChange(V=>{this.O.fire(V),!V&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(V=>{this.W.fire(V)})),this.L=this.B(new n.$GW({appendTitle:a,isChecked:!1,hoverDelegate:b,...r.toggleStyles})),this.B(this.L.onChange(V=>{this.O.fire(V),!V&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new n.$FW({appendTitle:h,isChecked:!1,hoverDelegate:b,...r.toggleStyles})),this.B(this.M.onChange(V=>{this.O.fire(V),!V&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(V=>{this.U.fire(V)}));const A=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,V=>{if(V.equals(w.KeyCode.LeftArrow)||V.equals(w.KeyCode.RightArrow)||V.equals(w.KeyCode.Escape)){const U=A.indexOf(this.domNode.ownerDocument.activeElement);if(U>=0){let C=-1;V.equals(w.KeyCode.RightArrow)?C=(U+1)%A.length:V.equals(w.KeyCode.LeftArrow)&&(U===0?C=A.length-1:C=U-1),V.equals(w.KeyCode.Escape)?(A[U].blur(),this.inputBox.focus()):C>=0&&A[C].focus(),i.$NT.stop(V,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(r?.additionalToggles),this.y&&this.domNode.appendChild(this.y),e?.appendChild(this.domNode),this.B(i.$KS(this.inputBox.inputElement,"compositionstart",A=>{this.s=!0})),this.B(i.$KS(this.inputBox.inputElement,"compositionend",A=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,A=>this.P.fire(A)),this.C(this.inputBox.inputElement,A=>this.S.fire(A)),this.D(this.inputBox.inputElement,A=>this.R.fire()),this.j(this.inputBox.inputElement,A=>this.Q.fire(A))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(e){this.inputBox.layout(),this.X(e.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const e of this.N)e.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const e of this.N)e.disable()}setFocusInputOnOptionClick(e){this.n=e}setEnabled(e){e?this.enable():this.disable()}setAdditionalToggles(e){for(const s of this.N)s.domNode.remove();this.N=[],this.w.value=new f.$Uc;for(const s of e??[])this.w.value.add(s),this.y.appendChild(s.domNode),this.w.value.add(s.onChange(r=>{this.O.fire(r),!r&&this.n&&this.inputBox.focus()})),this.N.push(s);this.N.length>0&&(this.y.style.display=""),this.X()}X(e=!1){e?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((s,r)=>s+r.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(e){this.inputBox.value!==e&&(this.inputBox.value=e)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(e){this.M&&(this.M.checked=e)}getWholeWords(){return this.L?.checked??!1}setWholeWords(e){this.L&&(this.L.checked=e)}getRegex(){return this.J?.checked??!1}setRegex(e){this.J&&(this.J.checked=e,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(e){this.inputBox.showMessage(e)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$IW=$}),define(pe[143],we([1,0,4,29,15,81,142,82,79,52,83,72,34,53,9,12,21,22,43,3,49,8,2,37,10,13,14,62,137]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$,m,e,s,r,h,a,v,T,S,d,c,b,A,V,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kX=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$jX=t.$iX=t.$hX=t.RenderIndentGuides=t.$gX=t.$fX=void 0;class C extends D.$9U{set context(u){this.c.context=u}get context(){return this.c.context}constructor(u){super(u.elements.map(L=>L.element)),this.c=u}}function E(k){return k instanceof D.$9U?new C(k):k}class O{constructor(u,L){this.d=u,this.f=L,this.b=d.$Vc.None,this.c=new d.$Uc}getDragURI(u){return this.f.getDragURI(u.element)}getDragLabel(u,L){if(this.f.getDragLabel)return this.f.getDragLabel(u.map(R=>R.element),L)}onDragStart(u,L){this.f.onDragStart?.(E(u),L)}onDragOver(u,L,R,B,H,Y=!0){const ie=this.f.onDragOver(E(u),L&&L.element,R,B,H),re=this.a!==L;if(re&&(this.b.dispose(),this.a=L),typeof L>"u")return ie;if(re&&typeof ie!="boolean"&&ie.autoExpand&&(this.b=(0,s.$Ih)(()=>{const Ne=this.d(),fe=Ne.getNodeLocation(L);Ne.isCollapsed(fe)&&Ne.setCollapsed(fe,!1),this.a=void 0},500,this.c)),typeof ie=="boolean"||!ie.accept||typeof ie.bubble>"u"||ie.feedback){if(!Y){const Ne=typeof ie=="boolean"?ie:ie.accept,fe=typeof ie=="boolean"?void 0:ie.effect;return{accept:Ne,effect:fe,feedback:[R]}}return ie}if(ie.bubble===$.TreeDragOverBubble.Up){const Ne=this.d(),fe=Ne.getNodeLocation(L),Fe=Ne.getParentNodeLocation(fe),Ke=Ne.getNode(Fe),Xe=Fe&&Ne.getListIndex(Fe);return this.onDragOver(u,Ke,Xe,B,H,!1)}const he=this.d(),De=he.getNodeLocation(L),ve=he.getListIndex(De),Ee=he.getListRenderCount(De);return{...ie,feedback:(0,e.$Rb)(ve,ve+Ee)}}drop(u,L,R,B,H){this.b.dispose(),this.a=void 0,this.f.drop(E(u),L&&L.element,R,B,H)}onDragEnd(u){this.f.onDragEnd?.(u)}dispose(){this.c.dispose(),this.f.dispose()}}function x(k,u){return u&&{...u,identityProvider:u.identityProvider&&{getId(L){return u.identityProvider.getId(L.element)}},dnd:u.dnd&&new O(k,u.dnd),multipleSelectionController:u.multipleSelectionController&&{isSelectionSingleChangeEvent(L){return u.multipleSelectionController.isSelectionSingleChangeEvent({...L,element:L.element})},isSelectionRangeChangeEvent(L){return u.multipleSelectionController.isSelectionRangeChangeEvent({...L,element:L.element})}},accessibilityProvider:u.accessibilityProvider&&{...u.accessibilityProvider,getSetSize(L){const R=k(),B=R.getNodeLocation(L),H=R.getParentNodeLocation(B);return R.getNode(H).visibleChildrenCount},getPosInSet(L){return L.visibleChildIndex+1},isChecked:u.accessibilityProvider&&u.accessibilityProvider.isChecked?L=>u.accessibilityProvider.isChecked(L.element):void 0,getRole:u.accessibilityProvider&&u.accessibilityProvider.getRole?L=>u.accessibilityProvider.getRole(L.element):()=>"treeitem",getAriaLabel(L){return u.accessibilityProvider.getAriaLabel(L.element)},getWidgetAriaLabel(){return u.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:u.accessibilityProvider&&u.accessibilityProvider.getWidgetRole?()=>u.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:u.accessibilityProvider&&u.accessibilityProvider.getAriaLevel?L=>u.accessibilityProvider.getAriaLevel(L.element):L=>L.depth,getActiveDescendantId:u.accessibilityProvider.getActiveDescendantId&&(L=>u.accessibilityProvider.getActiveDescendantId(L.element))},keyboardNavigationLabelProvider:u.keyboardNavigationLabelProvider&&{...u.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(L){return u.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(L.element)}}}}class I{constructor(u){this.a=u}getHeight(u){return this.a.getHeight(u.element)}getTemplateId(u){return this.a.getTemplateId(u.element)}hasDynamicHeight(u){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(u.element)}setDynamicHeight(u,L){this.a.setDynamicHeight?.(u.element,L)}}t.$fX=I;class _{static lift(u){return u instanceof _?u:new _(u)}static empty(u=0){return new _({focus:[],selection:[],expanded:Object.create(null),scrollTop:u})}constructor(u){if(this.focus=new Set(u.focus),this.selection=new Set(u.selection),u.expanded instanceof Array){this.expanded=Object.create(null);for(const L of u.expanded)this.expanded[L]=1}else this.expanded=u.expanded;this.expanded=u.expanded,this.scrollTop=u.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$gX=_;var q;(function(k){k.None="none",k.OnHover="onHover",k.Always="always"})(q||(t.RenderIndentGuides=q={}));class J{get elements(){return this.b}constructor(u,L=[]){this.b=L,this.a=new d.$Uc,this.onDidChange=v.Event.forEach(u,R=>this.b=R,this.a)}dispose(){this.a.dispose()}}class G{static{this.a=8}constructor(u,L,R,B,H,Y={}){this.o=u,this.p=L,this.q=B,this.s=H,this.b=new Map,this.c=new Map,this.d=G.a,this.f=!1,this.g=!1,this.j=new Set,this.k=d.$Vc.None,this.m=new d.$Uc,this.templateId=u.templateId,this.updateOptions(Y),v.Event.map(R,ie=>ie.node)(this.u,this,this.m),u.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(u={}){if(typeof u.indent<"u"){const L=(0,c.$Mm)(u.indent,0,40);if(L!==this.d){this.d=L;for(const[R,B]of this.c)this.v(R,B)}}if(typeof u.renderIndentGuides<"u"){const L=u.renderIndentGuides!==q.None;if(L!==this.g){this.g=L;for(const[R,B]of this.c)this.w(R,B);if(this.k.dispose(),L){const R=new d.$Uc;this.q.onDidChange(this.x,this,R),this.k=R,this.x(this.q.elements)}}}typeof u.hideTwistiesOfChildlessElements<"u"&&(this.f=u.hideTwistiesOfChildlessElements)}renderTemplate(u){const L=(0,i.$ST)(u,(0,i.$)(".monaco-tl-row")),R=(0,i.$ST)(L,(0,i.$)(".monaco-tl-indent")),B=(0,i.$ST)(L,(0,i.$)(".monaco-tl-twistie")),H=(0,i.$ST)(L,(0,i.$)(".monaco-tl-contents")),Y=this.o.renderTemplate(H);return{container:u,indent:R,twistie:B,indentGuidesDisposable:d.$Vc.None,templateData:Y}}renderElement(u,L,R,B){this.c.set(u,R),this.b.set(u.element,u),this.v(u,R),this.o.renderElement(u,L,R.templateData,B)}disposeElement(u,L,R,B){R.indentGuidesDisposable.dispose(),this.o.disposeElement?.(u,L,R.templateData,B),typeof B=="number"&&(this.c.delete(u),this.b.delete(u.element))}disposeTemplate(u){this.o.disposeTemplate(u.templateData)}t(u){const L=this.b.get(u);L&&this.u(L)}u(u){const L=this.c.get(u);L&&(this.x(this.q.elements),this.v(u,L))}v(u,L){const R=G.a+(u.depth-1)*this.d;L.twistie.style.paddingLeft=`${R}px`,L.indent.style.width=`${R+this.d-16}px`,u.collapsible?L.container.setAttribute("aria-expanded",String(!u.collapsed)):L.container.removeAttribute("aria-expanded"),L.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(r.$6j.treeItemExpanded));let B=!1;this.o.renderTwistie&&(B=this.o.renderTwistie(u.element,L.twistie)),u.collapsible&&(!this.f||u.visibleChildrenCount>0)?(B||L.twistie.classList.add(...h.ThemeIcon.asClassNameArray(r.$6j.treeItemExpanded)),L.twistie.classList.add("collapsible"),L.twistie.classList.toggle("collapsed",u.collapsed)):L.twistie.classList.remove("collapsible","collapsed"),this.w(u,L)}w(u,L){if((0,i.$JS)(L.indent),L.indentGuidesDisposable.dispose(),!this.g)return;const R=new d.$Uc,B=this.p();for(;;){const H=B.getNodeLocation(u),Y=B.getParentNodeLocation(H);if(!Y)break;const ie=B.getNode(Y),re=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(ie)&&re.classList.add("active"),L.indent.childElementCount===0?L.indent.appendChild(re):L.indent.insertBefore(re,L.indent.firstElementChild),this.s.add(ie,re),R.add((0,d.$Tc)(()=>this.s.delete(ie,re))),u=ie}L.indentGuidesDisposable=R}x(u){if(!this.g)return;const L=new Set,R=this.p();u.forEach(B=>{const H=R.getNodeLocation(B);try{const Y=R.getParentNodeLocation(H);B.collapsible&&B.children.length>0&&!B.collapsed?L.add(B):Y&&L.add(R.getNode(Y))}catch{}}),this.j.forEach(B=>{L.has(B)||this.s.forEach(B,H=>H.classList.remove("active"))}),L.forEach(B=>{this.j.has(B)||this.s.forEach(B,H=>H.classList.add("active"))}),this.j=L}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,d.$Qc)(this.m)}}t.$hX=G;class K{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(u){this.c=u,this.d=u.toLowerCase()}constructor(u,L,R){this.g=u,this.j=L,this.k=R,this.a=0,this.b=0,this.c="",this.d="",this.f=new d.$Uc,u.onWillRefilter(this.m,this,this.f)}filter(u,L){let R=$.TreeVisibility.Visible;if(this.k){const Y=this.k.filter(u,L);if(typeof Y=="boolean"?R=Y?$.TreeVisibility.Visible:$.TreeVisibility.Hidden:(0,y.$cX)(Y)?R=(0,y.$dX)(Y.visibility):R=Y,R===$.TreeVisibility.Hidden)return!1}if(this.a++,!this.c)return this.b++,{data:T.FuzzyScore.Default,visibility:R};const B=this.j.getKeyboardNavigationLabel(u),H=Array.isArray(B)?B:[B];for(const Y of H){const ie=Y&&Y.toString();if(typeof ie>"u")return{data:T.FuzzyScore.Default,visibility:R};let re;if(this.g.findMatchType===Le.Contiguous){const he=ie.toLowerCase().indexOf(this.d);if(he>-1){re=[Number.MAX_SAFE_INTEGER,0];for(let De=this.d.length;De>0;De--)re.push(he+De-1)}}else re=(0,T.$Vk)(this.c,this.d,0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return this.b++,H.length===1?{data:re,visibility:R}:{data:{label:ie,score:re},visibility:R}}return this.g.findMode===ye.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(u):$.TreeVisibility.Recurse:{data:T.FuzzyScore.Default,visibility:R}}m(){this.a=0,this.b=0}dispose(){(0,d.$Qc)(this.f)}}class Q extends p.$HV{constructor(u){super({icon:r.$6j.listFilter,title:(0,A.localize)(31,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,V.$OU)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$iX=Q;class ae extends p.$HV{constructor(u){super({icon:r.$6j.searchFuzzy,title:(0,A.localize)(32,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,V.$OU)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$jX=ae;const me={inputBoxStyles:w.$zW,toggleStyles:p.$FV,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ye;(function(k){k[k.Highlight=0]="Highlight",k[k.Filter=1]="Filter"})(ye||(t.TreeFindMode=ye={}));var Le;(function(k){k[k.Fuzzy=0]="Fuzzy",k[k.Contiguous=1]="Contiguous"})(Le||(t.TreeFindMatchType=Le={}));class ne extends d.$Vc{set mode(u){this.b.checked=u===ye.Filter,this.f.inputBox.setPlaceHolder(u===ye.Filter?(0,A.localize)(33,null):(0,A.localize)(34,null))}set matchType(u){this.c.checked=u===Le.Fuzzy}get value(){return this.f.inputBox.value}set value(u){this.f.inputBox.value=u}constructor(u,L,R,B,H,Y){super(),this.t=L,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new v.$me,this.onDidDisable=this._onDidDisable.event,u.appendChild(this.a.root),this.B((0,d.$Tc)(()=>this.a.root.remove()));const ie=Y?.styles??me;ie.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=ie.listFilterWidgetBackground),ie.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${ie.listFilterWidgetShadow}`);const re=this.B((0,V.$PU)());this.b=this.B(new Q({...ie.toggleStyles,isChecked:B===ye.Filter,hoverDelegate:re})),this.c=this.B(new ae({...ie.toggleStyles,isChecked:H===Le.Fuzzy,hoverDelegate:re})),this.onDidChangeMode=v.Event.map(this.b.onChange,()=>this.b.checked?ye.Filter:ye.Highlight,this.q),this.onDidChangeMatchType=v.Event.map(this.c.onChange,()=>this.c.checked?Le.Fuzzy:Le.Contiguous,this.q),this.f=this.B(new N.$IW(this.a.findInput,R,{label:(0,A.localize)(35,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:ie.inputBoxStyles,toggleStyles:ie.toggleStyles,history:Y?.history})),this.g=this.B(new F.$QU(this.a.actionbar)),this.mode=B;const he=this.B(new n.$YU(this.f.inputBox.inputElement,"keydown")),De=v.Event.chain(he.event,fe=>fe.map(Fe=>new P.$HS(Fe)));this.B(De(fe=>{if(fe.equals(S.KeyCode.Enter)){fe.preventDefault(),fe.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(fe.equals(S.KeyCode.DownArrow)){fe.preventDefault(),fe.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(fe.equals(S.KeyCode.UpArrow)){fe.preventDefault(),fe.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const ve=this.B(new m.$lj("close",(0,A.localize)(36,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(ve,{icon:!0,label:!1});const Ee=this.B(new n.$YU(this.a.grab,"mousedown"));this.B(Ee.event(fe=>{const Fe=new d.$Uc,Ke=Fe.add(new n.$YU((0,i.getWindow)(fe),"mousemove")),Xe=Fe.add(new n.$YU((0,i.getWindow)(fe),"mouseup")),tt=this.m,lt=fe.pageX,st=this.s,Ge=fe.pageY;this.a.grab.classList.add("grabbing");const Ze=this.a.root.style.transition;this.a.root.style.transition="unset";const Z=ue=>{const $e=ue.pageX-lt;this.m=tt-$e;const Se=ue.pageY-Ge;this.s=st+Se,this.layout()};Fe.add(Ke.event(Z)),Fe.add(Xe.event(ue=>{Z(ue),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ze,Fe.dispose()}))}));const Ne=v.Event.chain(this.B(new n.$YU(this.a.grab,"keydown")).event,fe=>fe.map(Fe=>new P.$HS(Fe)));this.B(Ne(fe=>{let Fe,Ke;if(fe.keyCode===S.KeyCode.LeftArrow?Fe=Number.POSITIVE_INFINITY:fe.keyCode===S.KeyCode.RightArrow?Fe=0:fe.keyCode===S.KeyCode.Space&&(Fe=this.m===0?Number.POSITIVE_INFINITY:0),fe.keyCode===S.KeyCode.UpArrow?Ke=0:fe.keyCode===S.KeyCode.DownArrow&&(Ke=Number.POSITIVE_INFINITY),Fe!==void 0&&(fe.preventDefault(),fe.stopPropagation(),this.m=Fe,this.layout()),Ke!==void 0){fe.preventDefault(),fe.stopPropagation(),this.s=Ke;const Xe=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Xe},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(u=this.j){this.j=u,this.m=(0,c.$Mm)(this.m,0,Math.max(0,u-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,c.$Mm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(u){this.f.showMessage(u)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$Hh)(300),super.dispose()}}class ee{get pattern(){return this.b}get mode(){return this.d}set mode(u){u!==this.d&&(this.d=u,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(u))}get matchType(){return this.f}set matchType(u){u!==this.f&&(this.f=u,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(u))}constructor(u,L,R,B,H,Y={}){this.t=u,this.u=R,this.v=B,this.w=H,this.x=Y,this.b="",this.c="",this.j=0,this.k=new v.$me,this.onDidChangeMode=this.k.event,this.m=new v.$me,this.onDidChangeMatchType=this.m.event,this.o=new v.$me,this.onDidChangePattern=this.o.event,this.p=new v.$me,this.onDidChangeOpenState=this.p.event,this.q=new d.$Uc,this.s=new d.$Uc,this.d=u.options.defaultFindMode??ye.Highlight,this.f=u.options.defaultFindMatchType??Le.Fuzzy,L.onDidSplice(this.z,this,this.s)}updateOptions(u={}){u.defaultFindMode!==void 0&&(this.mode=u.defaultFindMode),u.defaultFindMatchType!==void 0&&(this.matchType=u.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new ne(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(u=>this.mode=u,void 0,this.q),this.g.onDidChangeMatchType(u=>this.matchType=u,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(u){this.b=u,this.o.fire(u),this.v.pattern=u,this.t.refilter(),u&&this.t.focusNext(0,!0,void 0,R=>!T.FuzzyScore.isDefault(R.filterData));const L=this.t.getFocus();if(L.length>0){const R=L[0];this.t.getRelativeTop(R)===null&&this.t.reveal(R,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const u=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&u?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:w.MessageType.WARNING,content:(0,A.localize)(37,null)}):this.g?.showMessage({type:w.MessageType.WARNING}):this.g?.clearMessage()}shouldAllowFocus(u){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!T.FuzzyScore.isDefault(u.filterData)}layout(u){this.j=u,this.g?.layout(u)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function ce(k,u){return k.position===u.position&&le(k,u)}function le(k,u){return k.node.element===u.node.element&&k.startIndex===u.startIndex&&k.height===u.height&&k.endIndex===u.endIndex}class ke{constructor(u=[]){this.stickyNodes=u}get count(){return this.stickyNodes.length}equal(u){return(0,e.$ub)(this.stickyNodes,u.stickyNodes,ce)}lastNodePartiallyVisible(){if(this.count===0)return!1;const u=this.stickyNodes[this.count-1];if(this.count===1)return u.position!==0;const L=this.stickyNodes[this.count-2];return L.position+L.height!==u.position}animationStateChanged(u){if(!(0,e.$ub)(this.stickyNodes,u.stickyNodes,le)||this.count===0)return!1;const L=this.stickyNodes[this.count-1],R=u.stickyNodes[u.count-1];return L.position!==R.position}}class te{constrainStickyScrollNodes(u,L,R){for(let B=0;B<u.length;B++){const H=u[B];if(H.position+H.height>R||B>=L)return u.slice(0,B)}return u}}class be extends d.$Vc{constructor(u,L,R,B,H,Y={}){super(),this.g=u,this.j=L,this.m=R,this.s=H,this.c=.4;const ie=this.validateStickySettings(Y);this.b=ie.stickyScrollMaxItemCount,this.a=Y.stickyScrollDelegate??new te,this.f=this.B(new Ae(R.getScrollableElement(),R,u,B,H,Y.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(R.onDidScroll(()=>this.u())),this.B(R.onDidChangeContentHeight(()=>this.u())),this.B(u.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(u){return this.f.getNode(u)}t(u){let L;if(u===0?L=this.m.firstVisibleIndex:L=this.m.indexAt(u+this.m.scrollTop),!(L<0||L>=this.m.length))return this.m.element(L)}u(){const u=this.t(0);if(!u||this.g.scrollTop===0){this.f.setState(void 0);return}const L=this.w(u);this.f.setState(L)}w(u){const L=[];let R=u,B=0,H=this.z(R,void 0,B);for(;H&&(L.push(H),B+=H.height,!(L.length<=this.b&&(R=this.y(H),!R)));)H=this.z(R,H.node,B);const Y=this.H(L);return Y.length?new ke(Y):void 0}y(u){return this.t(u.position+u.height)}z(u,L,R){const B=this.F(u,L);if(B&&!(B===u&&(!this.J(u)||this.C(u,R))))return this.D(B,R)}C(u,L){const R=this.L(u),B=this.m.getElementTop(R),H=L;return this.m.scrollTop===B-H}D(u,L){const R=this.s.getHeight(u),{startIndex:B,endIndex:H}=this.M(u),Y=this.G(H,L,R);return{node:u,position:Y,height:R,startIndex:B,endIndex:H}}F(u,L=void 0){let R=u,B=this.I(R);for(;B;){if(B===L)return R;R=B,B=this.I(R)}if(L===void 0)return R}G(u,L,R){let B=this.m.getRelativeTop(u);if(B===null&&this.m.firstVisibleIndex===u&&u+1<this.m.length){const he=this.s.getHeight(this.m.element(u)),De=this.m.getRelativeTop(u+1);B=De?De-he/this.m.renderHeight:null}if(B===null)return L;const H=this.m.element(u),Y=this.s.getHeight(H),re=B*this.m.renderHeight+Y;return L+R>re&&L<=re?re-R:L}H(u){if(u.length===0)return[];const L=this.m.renderHeight*this.c,R=u[u.length-1];if(u.length<=this.b&&R.position+R.height<=L)return u;const B=this.a.constrainStickyScrollNodes(u,this.b,L);if(!B.length)return[];const H=B[B.length-1];if(B.length>this.b||H.position+H.height>L)throw new Error("stickyScrollDelegate violates constraints");return B}I(u){const L=this.j.getNodeLocation(u),R=this.j.getParentNodeLocation(L);return R?this.j.getNode(R):void 0}J(u){const L=this.j.getNodeLocation(u);return this.j.getListRenderCount(L)>1}L(u){const L=this.j.getNodeLocation(u);return this.j.getListIndex(L)}M(u){const L=this.j.getNodeLocation(u),R=this.j.getListIndex(L);if(R<0)throw new Error("Node not found in tree");const B=this.j.getListRenderCount(L),H=R+B-1;return{startIndex:R,endIndex:H}}nodePositionTopBelowWidget(u){const L=[];let R=this.I(u);for(;R;)L.push(R),R=this.I(R);let B=0;for(let H=0;H<L.length&&H<this.b;H++)B+=this.s.getHeight(L[H]);return B}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(u={}){if(!u.stickyScrollMaxItemCount)return;const L=this.validateStickySettings(u);this.b!==L.stickyScrollMaxItemCount&&(this.b=L.stickyScrollMaxItemCount,this.u())}validateStickySettings(u){let L=7;return typeof u.stickyScrollMaxItemCount=="number"&&(L=Math.max(u.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:L}}}class Ae{constructor(u,L,R,B,H,Y){this.g=L,this.j=R,this.k=B,this.m=H,this.o=Y,this.c=[],this.d=new d.$Uc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),u.appendChild(this.a);const ie=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(ie),this.f=new Re(this.a,L),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const u=this.b.stickyNodes[this.b.count-1];return u.position+u.height}get count(){return this.b?.count??0}getNode(u){return this.b?.stickyNodes.find(L=>L.node===u)}setState(u){const L=!!this.b&&this.b.count>0,R=!!u&&u.count>0;if(!L&&!R||L&&R&&this.b.equal(u))return;if(L!==R&&this.s(R),!R){this.b=void 0,this.c=[],this.d.clear();return}const B=u.stickyNodes[u.count-1];if(this.b&&u.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${B.position}px`;else{this.d.clear();const H=Array(u.count);for(let Y=u.count-1;Y>=0;Y--){const ie=u.stickyNodes[Y],{element:re,disposable:he}=this.p(ie,Y,u.count);H[Y]=re,this.a.appendChild(re),this.d.add(he)}this.f.updateElements(H,u),this.c=H}this.b=u,this.a.style.height=`${B.position+B.height}px`}p(u,L,R){const B=u.startIndex,H=document.createElement("div");H.style.top=`${u.position}px`,this.j.options.setRowHeight!==!1&&(H.style.height=`${u.height}px`),this.j.options.setRowLineHeight!==!1&&(H.style.lineHeight=`${u.height}px`),H.classList.add("monaco-tree-sticky-row"),H.classList.add("monaco-list-row"),H.setAttribute("data-index",`${B}`),H.setAttribute("data-parity",B%2===0?"even":"odd"),H.setAttribute("id",this.g.getElementID(B));const Y=this.q(H,u.node.element,L,R),ie=this.m.getTemplateId(u.node),re=this.k.find(Ee=>Ee.templateId===ie);if(!re)throw new Error(`No renderer found for template id ${ie}`);let he=u.node;he===this.j.getNode(this.j.getNodeLocation(u.node))&&(he=new Proxy(u.node,{}));const De=re.renderTemplate(H);re.renderElement(he,u.startIndex,De,u.height);const ve=(0,d.$Tc)(()=>{Y.dispose(),re.disposeElement(he,u.startIndex,De,u.height),re.disposeTemplate(De),H.remove()});return{element:H,disposable:ve}}q(u,L,R,B){if(!this.o)return d.$Vc.None;this.o.getSetSize&&u.setAttribute("aria-setsize",String(this.o.getSetSize(L,R,B))),this.o.getPosInSet&&u.setAttribute("aria-posinset",String(this.o.getPosInSet(L,R))),this.o.getRole&&u.setAttribute("role",this.o.getRole(L)??"treeitem");const H=this.o.getAriaLabel(L),Y=H&&typeof H!="string"?H:(0,U.constObservable)(H),ie=(0,U.autorun)(he=>{const De=he.readObservable(Y);De?u.setAttribute("aria-label",De):u.removeAttribute("aria-label")});typeof H=="string"||H&&u.setAttribute("aria-label",H.get());const re=this.o.getAriaLevel&&this.o.getAriaLevel(L);return typeof re=="number"&&u.setAttribute("aria-level",`${re}`),u.setAttribute("aria-selected",String(!1)),ie}s(u){this.a.classList.toggle("empty",!u),u||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class Re extends d.$Vc{get m(){return this.j}set m(u){u!==this.j&&(this.f.fire(u),this.j=u)}constructor(u,L){super(),this.s=u,this.t=L,this.a=-1,this.b=[],this.f=new v.$me,this.onDidChangeHasFocus=this.f.event,this.g=new v.$me,this.onContextMenu=this.g.event,this.j=!1,this.B((0,i.$KS)(this.s,"focus",()=>this.M())),this.B((0,i.$KS)(this.s,"blur",()=>this.O())),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(R=>this.w(R))),this.B(this.t.onMouseDown(R=>this.y(R))),this.B(this.t.onContextMenu(R=>this.u(R)))}u(u){const L=u.browserEvent.target;if(!(0,f.$jV)(L)&&!(0,f.$iV)(L)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$IT)(u.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const Y=this.c.stickyNodes.findIndex(ie=>ie.node.element===u.element?.element);if(Y===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(Y);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const B=this.c.stickyNodes[this.a].node.element,H=this.b[this.a];this.g.fire({element:B,anchor:H,browserEvent:u.browserEvent,isStickyScroll:!0})}w(u){if(this.m&&this.c){if(u.key==="ArrowUp")this.z(Math.max(0,this.a-1)),u.preventDefault(),u.stopPropagation();else if(u.key==="ArrowDown"||u.key==="ArrowRight"){if(this.a>=this.c.count-1){const L=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([L]),this.C(L,this.c)}else this.z(this.a+1);u.preventDefault(),u.stopPropagation()}}}y(u){const L=u.browserEvent.target;!(0,f.$jV)(L)&&!(0,f.$iV)(L)||(u.browserEvent.preventDefault(),u.browserEvent.stopPropagation())}updateElements(u,L){if(L&&L.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(L&&L.count!==u.length)throw new Error("Sticky scroll focus received illigel state");const R=this.a;if(this.D(),this.b=u,this.c=L,L){const B=(0,c.$Mm)(R,0,L.count-1);this.F(B)}else this.m&&this.t.domFocus();this.s.tabIndex=L?0:-1}z(u){const L=this.c;if(!L)throw new Error("Cannot set focus when state is undefined");if(this.F(u),!(u<L.count-1)&&L.lastNodePartiallyVisible()){const R=L.stickyNodes[u];this.C(R.endIndex+1,L)}}C(u,L){const R=L.stickyNodes[L.count-1],B=L.count>1?L.stickyNodes[L.count-2]:void 0,H=this.t.getElementTop(u),Y=B?B.position+B.height+R.height:R.height;this.t.scrollTop=H-Y}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(u){if(0>u)throw new Error("addFocus() can not remove focus");if(!this.c&&u>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&u>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const L=this.a;L>=0&&this.G(this.b[L],!1),u>=0&&this.G(this.b[u],!0),this.a=u}G(u,L){this.I(u,L&&this.m),this.J(u,L)}H(u){this.a!==-1&&this.I(this.b[this.a],u)}I(u,L){u.classList.toggle("focused",L)}J(u,L){u.classList.toggle("passive-focused",L)}L(u){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",u)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function Ie(k){let u=$.TreeMouseEventTarget.Unknown;return(0,i.$gT)(k.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?u=$.TreeMouseEventTarget.Twistie:(0,i.$gT)(k.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?u=$.TreeMouseEventTarget.Element:(0,i.$gT)(k.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(u=$.TreeMouseEventTarget.Filter),{browserEvent:k.browserEvent,element:k.element?k.element.element:null,target:u}}function je(k){const u=(0,f.$jV)(k.browserEvent.target);return{element:k.element?k.element.element:null,browserEvent:k.browserEvent,anchor:k.anchor,isStickyScroll:u}}function _e(k,u){u(k),k.children.forEach(L=>_e(L,u))}class W{get f(){return this.d||(this.d=this.m()),this.d}constructor(u,L){this.g=u,this.j=L,this.a=[],this.c=new v.$me,this.onDidChange=this.c.event}set(u,L){!L?.__forceEvent&&(0,e.$ub)(this.a,u)||this.k(u,!1,L)}k(u,L,R){if(this.a=[...u],this.b=void 0,this.d=void 0,!L){const B=this;this.c.fire({get elements(){return B.get()},browserEvent:R})}}get(){return this.b||(this.b=this.a.map(u=>u.element)),[...this.b]}getNodes(){return this.a}has(u){return this.f.has(u)}onDidModelSplice({insertedNodes:u,deletedNodes:L}){if(!this.j){const re=this.m(),he=De=>re.delete(De);L.forEach(De=>_e(De,he)),this.set([...re.values()]);return}const R=new Set,B=re=>R.add(this.j.getId(re.element).toString());L.forEach(re=>_e(re,B));const H=new Map,Y=re=>H.set(this.j.getId(re.element).toString(),re);u.forEach(re=>_e(re,Y));const ie=[];for(const re of this.a){const he=this.j.getId(re.element).toString();if(!R.has(he))ie.push(re);else{const ve=H.get(he);ve&&ve.visible&&ie.push(ve)}}if(this.a.length>0&&ie.length===0){const re=this.g();re&&ie.push(re)}this.k(ie,!0)}m(){const u=new Set;for(const L of this.a)u.add(L);return u}}class j extends f.$oV{constructor(u,L,R){super(u),this.x=L,this.y=R}u(u){if((0,f.$kV)(u.browserEvent.target)||(0,f.$dV)(u.browserEvent.target)||(0,f.$eV)(u.browserEvent.target)||u.browserEvent.isHandledByList)return;const L=u.element;if(!L)return super.u(u);if(this.p(u)||this.o(u))return super.u(u);const R=u.browserEvent.target,B=R.classList.contains("monaco-tl-twistie")||R.classList.contains("monaco-icon-label")&&R.classList.contains("folder-icon")&&u.browserEvent.offsetX<16,H=(0,f.$iV)(u.browserEvent.target);let Y=!1;if(H?Y=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?Y=this.x.expandOnlyOnTwistieClick(L.element):Y=!!this.x.expandOnlyOnTwistieClick,H)this.A(u,L);else{if(Y&&!B&&u.browserEvent.detail!==2)return super.u(u);if(!this.x.expandOnDoubleClick&&u.browserEvent.detail===2)return super.u(u)}if(L.collapsible&&(!H||B)){const ie=this.x.getNodeLocation(L),re=u.browserEvent.altKey;if(this.x.setFocus([ie]),this.x.toggleCollapsed(ie,re),B){u.browserEvent.isHandledByList=!0;return}}H||super.u(u)}A(u,L){if((0,f.$fV)(u.browserEvent.target)||(0,f.$gV)(u.browserEvent.target))return;const R=this.y();if(!R)throw new Error("Sticky scroll controller not found");const B=this.k.indexOf(L),H=this.k.getElementTop(B),Y=R.nodePositionTopBelowWidget(L);this.x.scrollTop=H-Y,this.k.domFocus(),this.k.setFocus([B]),this.k.setSelection([B])}v(u){u.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||u.browserEvent.isHandledByList||super.v(u)}s(u){const L=u.browserEvent.target;if(!(0,f.$jV)(L)&&!(0,f.$iV)(L)){super.s(u);return}}t(u){const L=u.browserEvent.target;if(!(0,f.$jV)(L)&&!(0,f.$iV)(L)){super.t(u);return}}}class l extends f.$rV{constructor(u,L,R,B,H,Y,ie,re){super(u,L,R,B,re),this.p=H,this.s=Y,this.K=ie}D(u){return new j(this,u.tree,u.stickyScrollProvider)}splice(u,L,R=[]){if(super.splice(u,L,R),R.length===0)return;const B=[],H=[];let Y;R.forEach((ie,re)=>{this.p.has(ie)&&B.push(u+re),this.s.has(ie)&&H.push(u+re),this.K.has(ie)&&(Y=u+re)}),B.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...B])),H.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...H])),typeof Y=="number"&&super.setAnchor(Y)}setFocus(u,L,R=!1){super.setFocus(u,L),R||this.p.set(u.map(B=>this.element(B)),L)}setSelection(u,L,R=!1){super.setSelection(u,L),R||this.s.set(u.map(B=>this.element(B)),L)}setAnchor(u,L=!1){super.setAnchor(u),L||(typeof u>"u"?this.K.set([]):this.K.set([this.element(u)]))}}var o;(function(k){k[k.Tree=0]="Tree",k[k.StickyScroll=1]="StickyScroll"})(o||(t.AbstractTreePart=o={}));class g{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return v.Event.map(this.j.onMouseClick,Ie)}get onMouseDblClick(){return v.Event.filter(v.Event.map(this.j.onMouseDblClick,Ie),u=>u.target!==$.TreeMouseEventTarget.Filter)}get onMouseOver(){return v.Event.map(this.j.onMouseOver,Ie)}get onMouseOut(){return v.Event.map(this.j.onMouseOut,Ie)}get onContextMenu(){return v.Event.any(v.Event.filter(v.Event.map(this.j.onContextMenu,je),u=>!u.isStickyScroll),this.B?.onContextMenu??v.Event.None)}get onTap(){return v.Event.map(this.j.onTap,Ie)}get onPointer(){return v.Event.map(this.j.onPointer,Ie)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return v.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ye.Highlight}set findMode(u){this.z&&(this.z.mode=u)}get findMatchType(){return this.z?.matchType??Le.Fuzzy}set findMatchType(u){this.z&&(this.z.matchType=u)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:v.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(u,L,R,B,H={}){this.G=u,this.H=H,this.y=new v.$ue,this.onDidChangeFindOpenState=v.Event.None,this.onDidChangeStickyScrollFocused=v.Event.None,this.D=new d.$Uc,this.E=new v.$me,this.onWillRefilter=this.E.event,this.F=new v.$me,this.onDidUpdateOptions=this.F.event,this.p=new I(R);const Y=new v.$ve,ie=new v.$ve,re=this.D.add(new J(ie.event)),he=new a.$Ic;this.k=B.map(fe=>new G(fe,()=>this.o,Y.event,re,he,H));for(const fe of this.k)this.D.add(fe);let De;H.keyboardNavigationLabelProvider&&(De=new K(this,H.keyboardNavigationLabelProvider,H.filter),H={...H,filter:De},this.D.add(De)),this.q=new W(()=>this.j.getFocusedElements()[0],H.identityProvider),this.w=new W(()=>this.j.getSelectedElements()[0],H.identityProvider),this.x=new W(()=>this.j.getAnchorElement(),H.identityProvider),this.j=new l(u,L,this.p,this.k,this.q,this.w,this.x,{...x(()=>this.o,H),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(u,this.j,H),Y.input=this.o.onDidChangeCollapseState;const ve=v.Event.forEach(this.o.onDidSplice,fe=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(fe),this.w.onDidModelSplice(fe)})},this.D);ve(()=>null,null,this.D);const Ee=this.D.add(new v.$me),Ne=this.D.add(new s.$Dh(0));if(this.D.add(v.Event.any(ve,this.q.onDidChange,this.w.onDidChange)(()=>{Ne.trigger(()=>{const fe=new Set;for(const Fe of this.q.getNodes())fe.add(Fe);for(const Fe of this.w.getNodes())fe.add(Fe);Ee.fire([...fe.values()])})})),ie.input=Ee.event,H.keyboardSupport!==!1){const fe=v.Event.chain(this.j.onKeyDown,Fe=>Fe.filter(Ke=>!(0,f.$dV)(Ke.target)).map(Ke=>new P.$HS(Ke)));v.Event.chain(fe,Fe=>Fe.filter(Ke=>Ke.keyCode===S.KeyCode.LeftArrow))(this.J,this,this.D),v.Event.chain(fe,Fe=>Fe.filter(Ke=>Ke.keyCode===S.KeyCode.RightArrow))(this.K,this,this.D),v.Event.chain(fe,Fe=>Fe.filter(Ke=>Ke.keyCode===S.KeyCode.Space))(this.L,this,this.D)}if((H.findWidgetEnabled??!0)&&H.keyboardNavigationLabelProvider&&H.contextViewProvider){const fe=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new ee(this,this.o,this.j,De,H.contextViewProvider,fe),this.A=Fe=>this.z.shouldAllowFocus(Fe),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=v.Event.None,this.onDidChangeFindMatchType=v.Event.None;H.enableStickyScroll&&(this.B=new be(this,this.o,this.j,this.k,this.p,H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$sT)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===q.Always)}updateOptions(u={}){this.H={...this.H,...u};for(const L of this.k)L.updateOptions(u);this.j.updateOptions(this.H),this.z?.updateOptions(u),this.I(u),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===q.Always)}get options(){return this.H}I(u){!this.B&&this.H.enableStickyScroll?(this.B=new be(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=v.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(u)}updateWidth(u){const L=this.o.getListIndex(u);L!==-1&&this.j.updateWidth(L)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(u){this.j.scrollTop=u}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(u){this.j.scrollLeft=u}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let u=this.j.firstVisibleIndex;return this.B&&(u+=this.B.count),u<0||u>=this.j.length?void 0:this.j.element(u).element}get lastVisibleElement(){const u=this.j.lastVisibleIndex;return this.j.element(u).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(u){this.j.ariaLabel=u}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$lT)(this.getHTMLElement())}layout(u,L){this.j.layout(u,L),(0,b.$jg)(L)&&this.z?.layout(L)}style(u){const L=`.${this.j.domId}`,R=[];u.treeIndentGuidesStroke&&(R.push(`.monaco-list${L}:hover .monaco-tl-indent > .indent-guide, .monaco-list${L}.always .monaco-tl-indent > .indent-guide  { border-color: ${u.treeInactiveIndentGuidesStroke}; }`),R.push(`.monaco-list${L} .monaco-tl-indent > .indent-guide.active { border-color: ${u.treeIndentGuidesStroke}; }`));const B=u.treeStickyScrollBackground??u.listBackground;B&&(R.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${B}; }`),R.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${B}; }`)),u.treeStickyScrollBorder&&R.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${u.treeStickyScrollBorder}; }`),u.treeStickyScrollShadow&&R.push(`.monaco-list${L} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${u.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),u.listFocusForeground&&(R.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),R.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const H=(0,i.$$T)(u.listFocusAndSelectionOutline,(0,i.$$T)(u.listSelectionOutline,u.listFocusOutline??""));H&&(R.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${H}; outline-offset: -1px;}`),R.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),u.listFocusOutline&&(R.push(`.monaco-list${L}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),R.push(`.monaco-list${L}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),R.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),R.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),R.push(`.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=R.join(`
`),this.j.style(u)}getParentElement(u){const L=this.o.getParentNodeLocation(u);return this.o.getNode(L).element}getFirstElementChild(u){return this.o.getFirstElementChild(u)}getNode(u){return this.o.getNode(u)}getNodeLocation(u){return this.o.getNodeLocation(u)}collapse(u,L=!1){return this.o.setCollapsed(u,!0,L)}expand(u,L=!1){return this.o.setCollapsed(u,!1,L)}toggleCollapsed(u,L=!1){return this.o.setCollapsed(u,void 0,L)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(u){return this.o.isCollapsible(u)}setCollapsible(u,L){return this.o.setCollapsible(u,L)}isCollapsed(u){return this.o.isCollapsed(u)}expandTo(u){this.o.expandTo(u)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(u){if(typeof u>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const L=this.o.getNode(u);this.x.set([L]);const R=this.o.getListIndex(u);R>-1&&this.j.setAnchor(R,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(u,L){this.y.bufferEvents(()=>{const R=u.map(H=>this.o.getNode(H));this.w.set(R,L);const B=u.map(H=>this.o.getListIndex(H)).filter(H=>H>-1);this.j.setSelection(B,L,!0)})}getSelection(){return this.w.get()}setFocus(u,L){this.y.bufferEvents(()=>{const R=u.map(H=>this.o.getNode(H));this.q.set(R,L);const B=u.map(H=>this.o.getListIndex(H)).filter(H=>H>-1);this.j.setFocus(B,L,!0)})}focusNext(u=1,L=!1,R,B=(0,i.$IT)(R)&&R.altKey?void 0:this.A){this.j.focusNext(u,L,R,B)}focusPrevious(u=1,L=!1,R,B=(0,i.$IT)(R)&&R.altKey?void 0:this.A){this.j.focusPrevious(u,L,R,B)}focusNextPage(u,L=(0,i.$IT)(u)&&u.altKey?void 0:this.A){return this.j.focusNextPage(u,L)}focusPreviousPage(u,L=(0,i.$IT)(u)&&u.altKey?void 0:this.A){return this.j.focusPreviousPage(u,L,()=>this.B?.height??0)}focusLast(u,L=(0,i.$IT)(u)&&u.altKey?void 0:this.A){this.j.focusLast(u,L)}focusFirst(u,L=(0,i.$IT)(u)&&u.altKey?void 0:this.A){this.j.focusFirst(u,L)}getFocus(){return this.q.get()}getStickyScrollFocus(){const u=this.B?.getFocus();return u!==void 0?[u]:[]}getFocusedPart(){return this.B?.focusedLast()?o.StickyScroll:o.Tree}reveal(u,L){this.o.expandTo(u);const R=this.o.getListIndex(u);if(R!==-1)if(!this.B)this.j.reveal(R,L);else{const B=this.B.nodePositionTopBelowWidget(this.getNode(u));this.j.reveal(R,L,B)}}getRelativeTop(u){const L=this.o.getListIndex(u);if(L===-1)return null;const R=this.B?.getNode(this.getNode(u));return this.j.getRelativeTop(L,R?.position??this.B?.height)}getViewState(u=this.options.identityProvider){if(!u)throw new $.$aX(this.G,"Can't get tree view state without an identity provider");const L=Y=>u.getId(Y).toString(),R=_.empty(this.scrollTop);for(const Y of this.getFocus())R.focus.add(L(Y));for(const Y of this.getSelection())R.selection.add(L(Y));const B=this.o.getNode(),H=[B];for(;H.length>0;){const Y=H.shift();Y!==B&&Y.collapsible&&(R.expanded[L(Y.element)]=Y.collapsed?0:1),H.push(...Y.children)}return R}J(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const R=L[0],B=this.o.getNodeLocation(R);if(!this.o.setCollapsed(B,!0)){const Y=this.o.getParentNodeLocation(B);if(!Y)return;const ie=this.o.getListIndex(Y);this.j.reveal(ie),this.j.setFocus([ie])}}K(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const R=L[0],B=this.o.getNodeLocation(R);if(!this.o.setCollapsed(B,!1)){if(!R.children.some(re=>re.visible))return;const[Y]=this.j.getFocus(),ie=Y+1;this.j.reveal(ie),this.j.setFocus([ie])}}L(u){u.preventDefault(),u.stopPropagation();const L=this.j.getFocusedElements();if(L.length===0)return;const R=L[0],B=this.o.getNodeLocation(R),H=u.browserEvent.altKey;this.o.setCollapsed(B,void 0,H)}navigate(u){return new M(this.j,this.o,u)}dispose(){(0,d.$Qc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$kX=g;class M{constructor(u,L,R){this.b=u,this.c=L,R?this.a=this.c.getListIndex(R):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(pe[144],we([1,0,143,116,34,36]),function(oe,t,i,n,P,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vX=void 0;class N extends i.$kX{constructor(D,f,p,y,$,m={}){super(D,f,p,y,m),this.f=D,this.g=$,this.d=new Map,this.c=m.identityProvider}getInput(){return this.b}setInput(D,f){if(f&&!this.c)throw new P.$aX(this.f,"Can't restore tree view state without an identity provider");if(this.b=D,!D){this.d.clear(),this.o.setChildren(null,F.Iterable.empty());return}if(!f){this.m(D);return}const p=[],y=[],$=e=>{const s=this.c.getId(e).toString();return!f.expanded[s]},m=e=>{const s=this.c.getId(e.element).toString();f.focus.has(s)&&p.push(e.element),f.selection.has(s)&&y.push(e.element)};this.m(D,$,m),this.setFocus(p),this.setSelection(y),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(D=this.b){if(typeof this.b>"u")throw new P.$aX(this.f,"Tree input not set");let f;this.c&&(f=p=>{const y=this.c.getId(p).toString(),$=this.d.get(y);if($)return $.collapsed}),this.m(D,f)}resort(D=this.b,f=!0){this.o.resort(D===this.b?null:D,f)}refresh(D){if(D===void 0){this.j.rerender();return}this.o.rerender(D)}m(D,f,p){let y;if(this.c){const $=new Set,m=p;p=e=>{const s=this.c.getId(e.element).toString();$.add(s),this.d.set(s,e),m?.(e)},y=e=>{const s=this.c.getId(e.element).toString();$.has(s)||this.d.delete(s)}}this.o.setChildren(D===this.b?null:D,this.s(D,f).elements,{onDidCreateNode:p,onDidDeleteNode:y})}s(D,f){const p=[...this.g.getChildren(D)];return{elements:F.Iterable.map(p,$=>{const{elements:m,size:e}=this.s($,f),s=this.g.hasChildren?this.g.hasChildren($):void 0,r=e===0?void 0:f&&f($);return{element:$,children:m,collapsible:s,collapsed:r}}),size:p.length}}M(D,f,p){return new n.$lX(D,f,p)}}t.$vX=N}),define(pe[54],we([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fi=t._util=void 0,t.$Gi=P,t.$Hi=F;var i;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function w(D){return D[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=w})(i||(t._util=i={})),t.$Fi=P("instantiationService");function n(N,w,D){w[i.DI_TARGET]===w?w[i.DI_DEPENDENCIES].push({id:N,index:D}):(w[i.DI_DEPENDENCIES]=[{id:N,index:D}],w[i.DI_TARGET]=w)}function P(N){if(i.serviceIds.has(N))return i.serviceIds.get(N);const w=function(D,f,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(w,D,p)};return w.toString=()=>N,i.serviceIds.set(N,w),w}function F(N){return N}}),define(pe[145],we([1,0,54]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wm=t.$Um=t.ID=void 0,t.$Vm=n,t.ID="diagnosticsService",t.$Um=(0,i.$Gi)(t.ID);function n(F){return!!F.hostName&&!!F.errorMessage}class P{async getPerformanceInfo(N,w){return{}}async getSystemInfo(N,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,w){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}t.$Wm=P}),define(pe[146],we([1,0,110,28,11,10,16,13,54,5,39,25]),function(oe,t,i,n,P,F,N,w,D,f,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jl=t.$Gl=t.FileKind=t.$Fl=t.$El=t.$Dl=t.$Cl=t.$Bl=t.$Al=t.$zl=t.FileOperationResult=t.$yl=t.$xl=t.$wl=t.$ul=t.FileChangeType=t.$tl=t.FileOperation=t.$nl=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$bl=void 0,t.$cl=$,t.$dl=r,t.$el=a,t.$fl=v,t.$gl=T,t.$hl=S,t.$il=d,t.$jl=c,t.$kl=b,t.$ll=A,t.$ml=V,t.$ol=E,t.$pl=O,t.$ql=x,t.$rl=I,t.$sl=_,t.$vl=Q,t.$Hl=ee,t.$Il=ce,t.$Kl=ke,t.$bl=(0,D.$Gi)("fileService");function $(te){return te.create===!0}var m;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(m||(t.FileType=m={}));var e;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function r(te){const be=te;return!!be&&typeof be.onDidChange=="function"}var h;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(h||(t.FileSystemProviderCapabilities=h={}));function a(te){return!!(te.capabilities&h.FileReadWrite)}function v(te){return!!(te.capabilities&h.FileFolderCopy)}function T(te){return!!(te.capabilities&h.FileClone)}function S(te){return!!(te.capabilities&h.FileOpenReadWriteClose)}function d(te){return!!(te.capabilities&h.FileReadStream)}function c(te){return a(te)?!!(te.capabilities&h.FileAtomicRead):!1}function b(te){return a(te)?!!(te.capabilities&h.FileAtomicWrite):!1}function A(te){return!!(te.capabilities&h.FileAtomicDelete)}function V(te){return!!(te.capabilities&h.Readonly)}var U;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(U||(t.FileSystemProviderErrorCode=U={}));class C extends Error{static create(be,Ae){const Re=new C(be.toString(),Ae);return x(Re,Ae),Re}constructor(be,Ae){super(be),this.code=Ae}}t.$nl=C;function E(te,be){return C.create(te,be)}function O(te){return te||E((0,w.localize)(1856,null),U.Unknown)}function x(te,be){return te.name=be?`${be} (FileSystemError)`:"FileSystemError",te}function I(te){if(!te)return U.Unknown;if(te instanceof C)return te.code;const be=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!be)return U.Unknown;switch(be[1]){case U.FileExists:return U.FileExists;case U.FileIsADirectory:return U.FileIsADirectory;case U.FileNotADirectory:return U.FileNotADirectory;case U.FileNotFound:return U.FileNotFound;case U.FileTooLarge:return U.FileTooLarge;case U.FileWriteLocked:return U.FileWriteLocked;case U.NoPermissions:return U.NoPermissions;case U.Unavailable:return U.Unavailable}return U.Unknown}function _(te){if(te instanceof ae)return te.fileOperationResult;switch(I(te)){case U.FileNotFound:return Le.FILE_NOT_FOUND;case U.FileIsADirectory:return Le.FILE_IS_DIRECTORY;case U.FileNotADirectory:return Le.FILE_NOT_DIRECTORY;case U.FileWriteLocked:return Le.FILE_WRITE_LOCKED;case U.NoPermissions:return Le.FILE_PERMISSION_DENIED;case U.FileExists:return Le.FILE_MOVE_CONFLICT;case U.FileTooLarge:return Le.FILE_TOO_LARGE;default:return Le.FILE_OTHER_ERROR}}var q;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(q||(t.FileOperation=q={}));class J{constructor(be,Ae,Re){this.resource=be,this.operation=Ae,this.target=Re}isOperation(be){return this.operation===be}}t.$tl=J;var G;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(G||(t.FileChangeType=G={}));class K{static{this.a=null}constructor(be,Ae){this.c=Ae,this.b=void 0,this.d=new y.$U(()=>{const Re=i.$Mi.forUris(()=>this.c);return Re.fill(this.rawAdded.map(Ie=>[Ie,!0])),Re}),this.f=new y.$U(()=>{const Re=i.$Mi.forUris(()=>this.c);return Re.fill(this.rawUpdated.map(Ie=>[Ie,!0])),Re}),this.g=new y.$U(()=>{const Re=i.$Mi.forUris(()=>this.c);return Re.fill(this.rawDeleted.map(Ie=>[Ie,!0])),Re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Re of be){switch(Re.type){case G.ADDED:this.rawAdded.push(Re.resource);break;case G.UPDATED:this.rawUpdated.push(Re.resource);break;case G.DELETED:this.rawDeleted.push(Re.resource);break}this.b!==K.a&&(typeof Re.cId=="number"?this.b===void 0?this.b=Re.cId:this.b!==Re.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains(be,...Ae){return this.h(be,{includeChildren:!1},...Ae)}affects(be,...Ae){return this.h(be,{includeChildren:!0},...Ae)}h(be,Ae,...Re){if(!be)return!1;const Ie=Re.length>0;return!!((!Ie||Re.includes(G.ADDED))&&(this.d.value.get(be)||Ae.includeChildren&&this.d.value.findSuperstr(be))||(!Ie||Re.includes(G.UPDATED))&&(this.f.value.get(be)||Ae.includeChildren&&this.f.value.findSuperstr(be))||(!Ie||Re.includes(G.DELETED))&&(this.g.value.findSubstr(be)||Ae.includeChildren&&this.g.value.findSuperstr(be)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(be){return this.b===be}hasCorrelation(){return typeof this.b=="number"}}t.$ul=K;function Q(te,be,Ae){return!te||!be||te===be||be.length>te.length?!1:(be.charAt(be.length-1)!==n.sep&&(be+=n.sep),Ae?(0,P.$Hf)(te,be):te.indexOf(be)===0)}class ae extends Error{constructor(be,Ae,Re){super(be),this.fileOperationResult=Ae,this.options=Re}}t.$wl=ae;class me extends ae{constructor(be,Ae,Re,Ie){super(be,Ae,Ie),this.fileOperationResult=Ae,this.size=Re}}t.$xl=me;class ye extends ae{constructor(be,Ae,Re){super(be,Le.FILE_NOT_MODIFIED_SINCE,Re),this.stat=Ae}}t.$yl=ye;var Le;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Le||(t.FileOperationResult=Le={})),t.$zl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Bl="files.associations",t.$Cl="files.exclude",t.$Dl="files.readonlyInclude",t.$El="files.readonlyExclude",t.$Fl="files.readonlyFromPermissions";var ne;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(t.FileKind=ne={})),t.$Gl="";function ee(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function ce(te,be){if(!be.hasProvider(N.URI.from({scheme:te.scheme})))return new Promise(Ae=>{const Re=be.onDidChangeFileSystemProviderRegistrations(Ie=>{Ie.scheme===te.scheme&&Ie.added&&(Re.dispose(),Ae())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(be){return(0,F.$jg)(be)||(be=0),be<le.KB?(0,w.localize)(1857,null,be.toFixed(0)):be<le.MB?(0,w.localize)(1858,null,(be/le.KB).toFixed(2)):be<le.GB?(0,w.localize)(1859,null,(be/le.MB).toFixed(2)):be<le.TB?(0,w.localize)(1860,null,(be/le.GB).toFixed(2)):(0,w.localize)(1861,null,(be/le.TB).toFixed(2))}}t.$Jl=le;function ke(te){const be=typeof te=="string"||te?.scheme===p.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===p.Schemas.file?1024*le.MB:be?10*le.MB:f.$p?50*le.MB:1024*le.MB}}),define(pe[147],we([1,0,54]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$hc=t.$0hc=void 0,t.$0hc=(0,i.$Gi)("mainProcessService");class n{constructor(F,N){this.a=F,this.b=N}getChannel(F){return this.a.getChannel(F,this.b)}registerChannel(F,N){this.a.registerChannel(F,N)}}t.$$hc=n}),define(pe[148],we([1,0,2,124]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_hc=void 0;class P extends i.$Vc{constructor(N){super(),this.a=this.B(new n.$$X(`window:${N}`))}getChannel(N){return this.a.getChannel(N)}registerChannel(N,w){this.a.registerChannel(N,w)}}t.$_hc=P});var Ri=this&&this.__param||function(oe,t){return function(i,n){t(i,n,oe)}};define(pe[149],we([1,0,74,147]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aic=void 0;let P=class{constructor(N,w){return this.windowId=N,i.ProxyChannel.toService(w.getChannel("nativeHost"),{context:N,properties:(()=>{const D=new Map;return D.set("windowId",N),D})()})}};t.$aic=P,t.$aic=P=et([Ri(1,n.$0hc)],P)}),define(pe[84],we([1,0,42,10]),function(oe,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$so=void 0,i=He(i),n=He(n);class P{constructor(){this.a=new Map}add(N,w){i.ok(n.$fg(N)),i.ok(n.$hg(w)),i.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,w)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}t.$so=new P}),define(pe[150],we([1,0,3,91,84]),function(oe,t,i,n,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$to=void 0,P=He(P),t.$to={JSONContribution:"base.contributions.json"};function F(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class N{constructor(){this.b=new i.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,p){this.a[F(f)]=p,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(f){const p=this.a[f];return p?(0,n.$9j)(p):void 0}hasSchemaContent(f){return!!this.a[f]}}const w=new N;P.$so.add(t.$to.JSONContribution,w)}),define(pe[151],we([1,0,12,21,48,22,3,10,16,13,150,84]),function(oe,t,i,n,P,F,N,w,D,f,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kx=t.$Jx=t.$Ix=t.$Hx=t.$Gx=t.$Fx=t.IconFontDefinition=t.IconContribution=t.$Cx=void 0,t.$Dx=r,t.$Ex=h,y=He(y),t.$Cx={IconContribution:"base.contributions.icons"};var $;(function(S){function d(c,b){let A=c.defaults;for(;F.ThemeIcon.isThemeIcon(A);){const V=s.getIcon(A.id);if(!V)return;A=V.defaults}return A}S.getDefinition=d})($||(t.IconContribution=$={}));var m;(function(S){function d(b){return{weight:b.weight,style:b.style,src:b.src.map(A=>({format:A.format,location:A.location.toString()}))}}S.toJSONObject=d;function c(b){const A=V=>(0,w.$fg)(V)?V:void 0;if(b&&Array.isArray(b.src)&&b.src.every(V=>(0,w.$fg)(V.format)&&(0,w.$fg)(V.location)))return{weight:A(b.weight),style:A(b.style),src:b.src.map(V=>({format:V.format,location:D.URI.parse(V.location)}))}}S.fromJSONObject=c})(m||(t.IconFontDefinition=m={}));class e{constructor(){this.a=new N.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(2351,null)},fontCharacter:{type:"string",description:(0,f.localize)(2352,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${F.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(d,c,b,A){const V=this.b[d];if(V){if(b&&!V.description){V.description=b,this.d.properties[d].markdownDescription=`${b} $(${d})`;const E=this.e.enum.indexOf(d);E!==-1&&(this.e.enumDescriptions[E]=b),this.a.fire()}return V}const U={id:d,description:b,defaults:c,deprecationMessage:A};this.b[d]=U;const C={$ref:"#/definitions/icons"};return A&&(C.deprecationMessage=A),b&&(C.markdownDescription=`${b}: $(${d})`),this.d.properties[d]=C,this.e.enum.push(d),this.e.enumDescriptions.push(b||""),this.a.fire(),{id:d}}deregisterIcon(d){delete this.b[d],delete this.d.properties[d];const c=this.e.enum.indexOf(d);c!==-1&&(this.e.enum.splice(c,1),this.e.enumDescriptions.splice(c,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(d=>this.b[d])}getIcon(d){return this.b[d]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(d,c){const b=this.f[d];return b||(this.f[d]=c,this.a.fire(),c)}deregisterIconFont(d){delete this.f[d]}getIconFont(d){return this.f[d]}toString(){const d=(V,U)=>V.id.localeCompare(U.id),c=V=>{for(;F.ThemeIcon.isThemeIcon(V.defaults);)V=this.b[V.defaults.id];return`codicon codicon-${V?V.id:""}`},b=[];b.push("| preview     | identifier                        | default codicon ID                | description"),b.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const A=Object.keys(this.b).map(V=>this.b[V]);for(const V of A.filter(U=>!!U.description).sort(d))b.push(`|<i class="${c(V)}"></i>|${V.id}|${F.ThemeIcon.isThemeIcon(V.defaults)?V.defaults.id:V.id}|${V.description||""}|`);b.push("| preview     | identifier                        "),b.push("| ----------- | --------------------------------- |");for(const V of A.filter(U=>!F.ThemeIcon.isThemeIcon(U.defaults)).sort(d))b.push(`|<i class="${c(V)}"></i>|${V.id}|`);return b.join(`
`)}}const s=new e;y.$so.add(t.$Cx.IconContribution,s);function r(S,d,c,b){return s.registerIcon(S,d,c,b)}function h(){return s}function a(){const S=(0,P.$2j)();for(const d in S){const c="\\"+S[d].toString(16);s.registerIcon(d,{fontCharacter:c})}}a(),t.$Fx="vscode://schemas/icons";const v=y.$so.as(p.$to.JSONContribution);v.registerSchema(t.$Fx,s.getIconSchema());const T=new i.$Sh(()=>v.notifySchemaChanged(t.$Fx),200);s.onDidChange(()=>{T.isScheduled()||T.schedule()}),t.$Gx=r("widget-close",n.$6j.close,(0,f.localize)(2353,null)),t.$Hx=r("goto-previous-location",n.$6j.arrowUp,(0,f.localize)(2354,null)),t.$Ix=r("goto-next-location",n.$6j.arrowDown,(0,f.localize)(2355,null)),t.$Jx=F.ThemeIcon.modify(n.$6j.sync,"spin"),t.$Kx=F.ThemeIcon.modify(n.$6j.loading,"spin")}),define(pe[152],we([1,0,4,3,2,22,151]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DMb=void 0,t.$CMb=w;function w(f){const p=new P.$Uc,y=p.add(new n.$me),$=(0,N.$Ex)();return p.add($.onDidChange(()=>y.fire())),f&&p.add(f.onDidProductIconThemeChange(()=>y.fire())),{dispose:()=>p.dispose(),onDidChange:y.event,getCSS(){const m=f?f.getProductIconTheme():new D,e={},s=[],r=[];for(const h of $.getIcons()){const a=m.getIcon(h);if(!a)continue;const v=a.font,T=`--vscode-icon-${h.id}-font-family`,S=`--vscode-icon-${h.id}-content`;v?(e[v.id]=v.definition,r.push(`${T}: ${(0,i.$0T)(v.id)};`,`${S}: '${a.fontCharacter}';`),s.push(`.codicon-${h.id}:before { content: '${a.fontCharacter}'; font-family: ${(0,i.$0T)(v.id)}; }`)):(r.push(`${S}: '${a.fontCharacter}'; ${T}: 'codicon';`),s.push(`.codicon-${h.id}:before { content: '${a.fontCharacter}'; }`))}for(const h in e){const a=e[h],v=a.weight?`font-weight: ${a.weight};`:"",T=a.style?`font-style: ${a.style};`:"",S=a.src.map(d=>`${(0,i.$9T)(d.location)} format('${d.format}')`).join(", ");s.push(`@font-face { src: ${S}; font-family: ${(0,i.$0T)(h)};${v}${T} font-display: block; }`)}return s.push(`:root { ${r.join(" ")} }`),s.join(`
`)}}}class D{getIcon(p){const y=(0,N.$Ex)();let $=p.defaults;for(;F.ThemeIcon.isThemeIcon($);){const m=y.getIcon($.id);if(!m)return;$=m.defaults}return $}}t.$DMb=D}),define(pe[153],we([1,0,5]),function(oe,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gE=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$0D=void 0,t.$$D=n,t.$_D=P,t.$aE=F,t.$bE=N,t.$cE=w,t.$dE=y,t.$eE=$,t.$fE=m,t.$hE=e,t.$iE=s,t.$jE=r,t.$0D={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(h){return typeof h.parentId=="number"}function P(h){return!!h.workspaceUri}function F(h){return!!h.folderUri}function N(h){return!!h.fileUri}function w(h){const a=$(h),v=h.getValue("window.menuBarVisibility");return v==="default"||a&&v==="compact"||i.$k&&i.$n?"classic":v}var D;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(D||(t.TitleBarSetting=D={}));var f;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(f||(t.TitlebarStyle=f={}));var p;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})(p||(t.CustomTitleBarVisibility=p={}));function y(h,a){return!0}function $(h,a){return a||(a=m(h)),a===f.NATIVE}function m(h){if(i.$p)return f.CUSTOM;const a=h.getValue("window");if(a){if(i.$k&&a.nativeTabs===!0||i.$k&&a.nativeFullScreen===!1)return f.NATIVE;const S=a.titleBarStyle;if(S===f.NATIVE||S===f.CUSTOM)return S}return i.$l?f.NATIVE:f.CUSTOM}t.$gE=35;function e(h){return!(!i.$j||i.$p||$(h))}function s(h){const a=h.getValue("window");return!a||typeof a.nativeFullScreen!="boolean"||a.nativeTabs?!0:a.nativeFullScreen!==!1}function r(h=0){return Math.pow(1.2,h)}}),define(pe[154],we([1,0,18,4,24,40,153]),function(oe,t,i,n,P,F,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cic=t.$bic=t.ApplyZoomTarget=void 0,t.$dic=D,t.$eic=p,t.$fic=y;var w;(function($){$[$.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",$[$.ALL_WINDOWS=2]="ALL_WINDOWS"})(w||(t.ApplyZoomTarget=w={})),t.$bic=8,t.$cic=-8;function D($,m){$=Math.min(Math.max($,t.$cic),t.$bic);const e=[];m===w.ACTIVE_WINDOW?e.push((0,n.$pT)()):m===w.ALL_WINDOWS?e.push(...Array.from((0,n.getWindows)()).map(({window:s})=>s)):e.push(m);for(const s of e)f(s)?.webFrame?.setZoomLevel($),(0,i.$lS)((0,N.$jE)($),s),(0,i.$hS)($,s)}function f($){if($===P.$dS)return{ipcRenderer:F.$L,webFrame:F.$N};{const m=$;if(m?.vscode?.ipcRenderer&&m?.vscode?.webFrame)return m.vscode}}function p($){D((0,i.$iS)(typeof $=="number"?(0,n.$pT)():$)+1,$)}function y($){D((0,i.$iS)(typeof $=="number"?(0,n.$pT)():$)-1,$)}}),define(pe[155],we([1,0,13,4,144,12,123,40,145,146,148,149,152,154,15,8,24,138,128]),function(oe,t,i,n,P,F,N,w,D,f,p,y,$,m,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=O;const h=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,a=/\s--inspect-port=(?<port>\d+)/;class v{getHeight(I){return 22}getTemplateId(I){return U(I)?"process":A(I)?"machine":(0,D.$Vm)(I)?"error":V(I)?"header":""}}class T{hasChildren(I){return(0,D.$Vm)(I)?!1:U(I)?!!I.children?.length:!0}getChildren(I){return U(I)?I.children?I.children:[]:(0,D.$Vm)(I)?[]:V(I)?I.processRoots.length>1?I.processRoots:[I.processRoots[0].rootProcess]:A(I)?[I.rootProcess]:[I.processes]}}class S{constructor(){this.templateId="header"}renderTemplate(I){const _=(0,n.$ST)(I,(0,n.$)(".row")),q=(0,n.$ST)(_,(0,n.$)(".nameLabel")),J=(0,n.$ST)(_,(0,n.$)(".cpu")),G=(0,n.$ST)(_,(0,n.$)(".memory")),K=(0,n.$ST)(_,(0,n.$)(".pid"));return{name:q,CPU:J,memory:G,PID:K}}renderElement(I,_,q,J){q.name.textContent=(0,i.localize)(158,null),q.CPU.textContent=(0,i.localize)(159,null),q.PID.textContent=(0,i.localize)(160,null),q.memory.textContent=(0,i.localize)(161,null)}disposeTemplate(I){}}class d{constructor(){this.templateId="machine"}renderTemplate(I){const _=Object.create(null),q=(0,n.$ST)(I,(0,n.$)(".row"));return _.name=(0,n.$ST)(q,(0,n.$)(".nameLabel")),_}renderElement(I,_,q,J){q.name.textContent=I.element.name}disposeTemplate(I){}}class c{constructor(){this.templateId="error"}renderTemplate(I){const _=Object.create(null),q=(0,n.$ST)(I,(0,n.$)(".row"));return _.name=(0,n.$ST)(q,(0,n.$)(".nameLabel")),_}renderElement(I,_,q,J){q.name.textContent=I.element.errorMessage}disposeTemplate(I){}}class b{constructor(I,_,q){this.a=I,this.b=_,this.c=q,this.templateId="process"}renderTemplate(I){const _=(0,n.$ST)(I,(0,n.$)(".row")),q=(0,n.$ST)(_,(0,n.$)(".nameLabel")),J=(0,n.$ST)(_,(0,n.$)(".cpu")),G=(0,n.$ST)(_,(0,n.$)(".memory")),K=(0,n.$ST)(_,(0,n.$)(".pid"));return{name:q,CPU:J,PID:K,memory:G}}renderElement(I,_,q,J){const{element:G}=I,K=G.pid.toFixed(0);let Q=G.name;this.c.has(G.pid)&&(Q=this.c.get(G.pid)),q.name.textContent=Q,q.name.title=G.cmd,q.CPU.textContent=G.load.toFixed(0),q.PID.textContent=K,q.PID.parentElement.id=`pid-${K}`;const ae=this.a==="win32"?G.mem:this.b*(G.mem/100);q.memory.textContent=(ae/f.$Jl.MB).toFixed(0)}disposeTemplate(I){}}function A(x){return!!x.name&&!!x.rootProcess}function V(x){return!!x.processRoots}function U(x){return!!x.pid}class C{constructor(I,_){this.f=_,this.b=new Map;const q=new p.$_hc(I);this.c=new y.$aic(I,q),this.k(_.styles),this.g(_),w.$L.on("vscode:pidToNameResponse",(J,G)=>{this.b.clear();for(const[K,Q]of G)this.b.set(K,Q)}),w.$L.on("vscode:listProcessesResponse",async(J,G)=>{G.forEach((K,Q)=>{U(K.rootProcess)&&(K.rootProcess.name=Q===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:G}}),this.d.layout(r.$dS.innerHeight,r.$dS.innerWidth)):await this.h(G),this.m(0)}),this.a=Date.now(),w.$L.send("vscode:pidToNameRequest"),w.$L.send("vscode:listProcesses")}g(I){r.$dS.document.onkeydown=_=>{const q=I.platform==="darwin"?_.metaKey:_.ctrlKey;q&&_.keyCode===87&&(_.stopPropagation(),_.preventDefault(),w.$L.send("vscode:closeProcessExplorer")),q&&_.keyCode===187&&(0,m.$eic)(r.$dS),q&&_.keyCode===189&&(0,m.$fic)(r.$dS)}}async h(I){const _=r.$dS.document.getElementById("process-list");if(!_)return;const{totalmem:q}=await this.c.getOSStatistics(),J=[new b(this.f.platform,q,this.b),new S,new d,new c];this.d=new P.$vX("processExplorer",_,new v,J,new T,{identityProvider:{getId:G=>U(G)?G.pid.toString():(0,D.$Vm)(G)?G.hostName:V(G)?"processes":A(G)?G.name:"header"}}),this.d.setInput({processes:{processRoots:I}}),this.d.layout(r.$dS.innerHeight,r.$dS.innerWidth),this.d.onKeyDown(G=>{const K=new e.$HS(G);if(K.keyCode===s.KeyCode.KeyE&&K.altKey){const Q=this.n();Promise.all(Q.map(ae=>this.c.killProcess(ae,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(G=>{U(G.element)&&this.l(G.element,!0)}),_.style.height=`${r.$dS.innerHeight}px`,r.$dS.addEventListener("resize",()=>{_.style.height=`${r.$dS.innerHeight}px`,this.d?.layout(r.$dS.innerHeight,r.$dS.innerWidth)})}i(I){const _=h.exec(I);return _&&_.groups.port!=="0"||I.indexOf("node ")>=0||I.indexOf("node.exe")>=0}j(I){const _={type:"node",request:"attach",name:`process ${I.pid}`};let q=h.exec(I.cmd);q?_.port=Number(q.groups.port):_.processId=String(I.pid),q=a.exec(I.cmd),q&&(_.port=Number(q.groups.port)),w.$L.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[_]})}k(I){const _=(0,n.$sT)(),q=[];I.listFocusBackground&&(q.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${I.listFocusBackground}; }`),q.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${I.listFocusBackground}; }`)),I.listFocusForeground&&q.push(`.monaco-list:focus .monaco-list-row.focused { color: ${I.listFocusForeground}; }`),I.listActiveSelectionBackground&&(q.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${I.listActiveSelectionBackground}; }`),q.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${I.listActiveSelectionBackground}; }`)),I.listActiveSelectionForeground&&q.push(`.monaco-list:focus .monaco-list-row.selected { color: ${I.listActiveSelectionForeground}; }`),I.listHoverBackground&&q.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${I.listHoverBackground}; }`),I.listHoverForeground&&q.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${I.listHoverForeground}; }`),I.listFocusOutline&&q.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${I.listFocusOutline}; outline-offset: -1px; }`),I.listHoverOutline&&q.push(`.monaco-list-row:hover { outline: 1px dashed ${I.listHoverOutline}; outline-offset: -1px; }`),I.scrollbarShadowColor&&q.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${I.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${I.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${I.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),I.scrollbarSliderBackgroundColor&&q.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${I.scrollbarSliderBackgroundColor};
				}
			`),I.scrollbarSliderHoverBackgroundColor&&q.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${I.scrollbarSliderHoverBackgroundColor};
				}
			`),I.scrollbarSliderActiveBackgroundColor&&q.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${I.scrollbarSliderActiveBackgroundColor};
				}
			`),_.textContent=q.join(`
`),I.color&&(r.$dS.document.body.style.color=I.color)}l(I,_){const q=[],J=Number(I.pid);_&&(q.push({accelerator:"Alt+E",label:(0,i.localize)(162,null),click:()=>{this.c.killProcess(J,"SIGTERM")}}),q.push({label:(0,i.localize)(163,null),click:()=>{this.c.killProcess(J,"SIGKILL")}}),q.push({type:"separator"})),q.push({label:(0,i.localize)(164,null),click:()=>{const G=this.n();G?.includes(J)||(G.length=0,G.push(J));const K=G?.map(Q=>r.$dS.document.getElementById(`pid-${Q}`)).filter(Q=>!!Q);if(K){const Q=K.map(ae=>ae.innerText).filter(ae=>!!ae);this.c.writeClipboardText(Q.join(`
`))}}}),q.push({label:(0,i.localize)(165,null),click:()=>{const G=r.$dS.document.getElementById("process-list");G&&this.c.writeClipboardText(G.innerText)}}),I&&_&&this.i(I.cmd)&&(q.push({type:"separator"}),q.push({label:(0,i.localize)(166,null),click:()=>{this.j(I)}})),(0,N.$3X)(q)}m(I){setTimeout(()=>{const _=Date.now(),q=I+_-this.a;this.a=_,q>1e3?(w.$L.send("vscode:pidToNameRequest"),w.$L.send("vscode:listProcesses")):this.m(q)},200)}n(){return this.d?.getSelection()?.map(I=>{if(!(!I||!("pid"in I)))return I.pid}).filter(I=>!!I)}}function E(){const x=(0,n.$sT)();x.id="codiconStyles";const I=(0,$.$CMb)(void 0);function _(){x.textContent=I.getCSS()}const q=new F.$Sh(_,0);I.onDidChange(()=>q.schedule()),q.schedule()}function O(x){const I=x.data.platform==="win32"?"windows":x.data.platform==="linux"?"linux":"mac";r.$dS.document.body.classList.add(I),E(),(0,m.$dic)(x.data.zoomLevel,r.$dS),new C(x.windowId,x.data)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/3b27f1f74bc09fe2e2068997fcd42768be44a4e3/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
