/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/processes","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/request/common/request","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],he=function(Z){for(var e=[],S=0,P=Z.length;S<P;S++)e[S]=le[Z[S]];return e};define(le[74],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.LoaderEventType=e.$S=e.$R=void 0,e.$R=!1,e.$S=!0;var S;(function(v){v[v.LoaderAvailable=1]="LoaderAvailable",v[v.BeginLoadingScript=10]="BeginLoadingScript",v[v.EndLoadingScriptOK=11]="EndLoadingScriptOK",v[v.EndLoadingScriptError=12]="EndLoadingScriptError",v[v.BeginInvokeFactory=21]="BeginInvokeFactory",v[v.EndInvokeFactory=22]="EndInvokeFactory",v[v.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",v[v.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",v[v.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",v[v.NodeEndNativeRequire=34]="NodeEndNativeRequire",v[v.CachedDataFound=60]="CachedDataFound",v[v.CachedDataMissed=61]="CachedDataMissed",v[v.CachedDataRejected=62]="CachedDataRejected",v[v.CachedDataCreated=63]="CachedDataCreated"})(S||(e.LoaderEventType=S={}));class P{static get(){const k=new Map,L=new Map,O=new Map,w=new Map;function a(m,I){m.has(I.detail)||m.set(I.detail,-I.timestamp)}function d(m,I){const b=m.get(I.detail);b&&(b>=0||m.set(I.detail,b+I.timestamp))}let u=[];typeof Z=="function"&&typeof Z.getStats=="function"&&(u=Z.getStats().slice(0).sort((m,I)=>m.timestamp-I.timestamp));for(const m of u)switch(m.type){case S.BeginLoadingScript:a(k,m);break;case S.EndLoadingScriptOK:case S.EndLoadingScriptError:d(k,m);break;case S.BeginInvokeFactory:a(L,m);break;case S.EndInvokeFactory:d(L,m);break;case S.NodeBeginNativeRequire:a(O,m);break;case S.NodeEndNativeRequire:d(O,m);break;case S.NodeBeginEvaluatingScript:a(w,m);break;case S.NodeEndEvaluatingScript:d(w,m);break}let p=0;O.forEach(m=>p+=m);function f(m){const I=[];return m.forEach((b,h)=>I.push([h,b])),I}return{amdLoad:f(k),amdInvoke:f(L),nodeRequire:f(O),nodeEval:f(w),nodeRequireTotal:p}}static toMarkdownTable(k,L){let O="";const w=[];return k.forEach((a,d)=>{w[d]=a.length}),L.forEach(a=>{a.forEach((d,u)=>{typeof d>"u"&&(d=a[u]="-");const p=d.toString().length;w[u]=Math.max(p,w[u])})}),k.forEach((a,d)=>{O+=`| ${a+" ".repeat(w[d]-a.toString().length)} `}),O+=`|
`,k.forEach((a,d)=>{O+=`| ${"-".repeat(w[d])} `}),O+=`|
`,L.forEach(a=>{a.forEach((d,u)=>{typeof d<"u"&&(O+=`| ${d+" ".repeat(w[u]-d.toString().length)} `)}),O+=`|
`}),O}}e.$T=P}),define(le[55],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=P,e.$_h=v,e.$ai=k;function S(L){return(O,w,a)=>{let d=null,u=null;if(typeof a.value=="function"?(d="value",u=a.value):typeof a.get=="function"&&(d="get",u=a.get),!u)throw new Error("not supported");a[d]=L(u,w)}}function P(L,O,w){let a=null,d=null;if(typeof w.value=="function"?(a="value",d=w.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(a="get",d=w.get),!d)throw new Error("not supported");const u=`$memoize$${O}`;w[a]=function(...p){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,p)}),this[u]}}function v(L,O,w){return S((a,d)=>{const u=`$debounce$${d}`,p=`$debounce$result$${d}`;return function(...f){this[p]||(this[p]=w?w():void 0),clearTimeout(this[u]),O&&(this[p]=O(this[p],...f),f=[this[p]]),this[u]=setTimeout(()=>{a.apply(this,f),this[p]=w?w():void 0},L)}})}function k(L,O,w){return S((a,d)=>{const u=`$throttle$timer$${d}`,p=`$throttle$result$${d}`,f=`$throttle$lastRun$${d}`,m=`$throttle$pending$${d}`;return function(...I){if(this[p]||(this[p]=w?w():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),O&&(this[p]=O(this[p],...I)),this[m])return;const b=this[f]+L;b<=Date.now()?(this[f]=Date.now(),a.apply(this,[this[p]]),this[p]=w?w():void 0):(this[m]=!0,this[u]=setTimeout(()=>{this[m]=!1,this[f]=Date.now(),a.apply(this,[this[p]]),this[p]=w?w():void 0},b-Date.now()))}})}}),define(le[75],he([0,1,7]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=P,e.$fd=v,e.$gd=k,e.$hd=L,e.$id=O,e.$jd=w;function P(a,d){if(!a)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}function v(a,d="Unreachable"){throw new Error(d)}function k(a,d="unexpected state"){if(!a)throw new S.$cb(`Assertion Failed: ${d}`)}function L(a){a||(0,S.$Z)(new S.$cb("Soft Assertion Failed"))}function O(a){if(!a()){debugger;a(),(0,S.$Z)(new S.$cb("Assertion Failed"))}}function w(a,d){let u=0;for(;u<a.length-1;){const p=a[u],f=a[u+1];if(!d(p,f))return!1;u++}return!0}}),define(le[34],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Xn=L,e.$Yn=u,e.$Zn=p,e.$1n=f,e.$2n=m,e.$3n=I,e.$4n=b,e.$5n=h,e.$6n=$,e.$7n=R,e.$8n=y;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var P;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var v;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(v||(e.ParseErrorCode=v={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function L(i,c=!1){let n=0;const r=i.length;let t="",s=0,o=P.Unknown,l=S.None;function g(Y){let ne=0,ae=0;for(;ne<Y;){const ue=i.charCodeAt(n);if(ue>=d._0&&ue<=d._9)ae=ae*16+ue-d._0;else if(ue>=d.A&&ue<=d.F)ae=ae*16+ue-d.A+10;else if(ue>=d.a&&ue<=d.f)ae=ae*16+ue-d.a+10;else break;n++,ne++}return ne<Y&&(ae=-1),ae}function N(Y){n=Y,t="",s=0,o=P.Unknown,l=S.None}function T(){const Y=n;if(i.charCodeAt(n)===d._0)n++;else for(n++;n<i.length&&a(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===d.dot)if(n++,n<i.length&&a(i.charCodeAt(n)))for(n++;n<i.length&&a(i.charCodeAt(n));)n++;else return l=S.UnexpectedEndOfNumber,i.substring(Y,n);let ne=n;if(n<i.length&&(i.charCodeAt(n)===d.E||i.charCodeAt(n)===d.e))if(n++,(n<i.length&&i.charCodeAt(n)===d.plus||i.charCodeAt(n)===d.minus)&&n++,n<i.length&&a(i.charCodeAt(n))){for(n++;n<i.length&&a(i.charCodeAt(n));)n++;ne=n}else l=S.UnexpectedEndOfNumber;return i.substring(Y,ne)}function A(){let Y="",ne=n;for(;;){if(n>=r){Y+=i.substring(ne,n),l=S.UnexpectedEndOfString;break}const ae=i.charCodeAt(n);if(ae===d.doubleQuote){Y+=i.substring(ne,n),n++;break}if(ae===d.backslash){if(Y+=i.substring(ne,n),n++,n>=r){l=S.UnexpectedEndOfString;break}switch(i.charCodeAt(n++)){case d.doubleQuote:Y+='"';break;case d.backslash:Y+="\\";break;case d.slash:Y+="/";break;case d.b:Y+="\b";break;case d.f:Y+="\f";break;case d.n:Y+=`
`;break;case d.r:Y+="\r";break;case d.t:Y+="	";break;case d.u:{const me=g(4);me>=0?Y+=String.fromCharCode(me):l=S.InvalidUnicode;break}default:l=S.InvalidEscapeCharacter}ne=n;continue}if(ae>=0&&ae<=31)if(w(ae)){Y+=i.substring(ne,n),l=S.UnexpectedEndOfString;break}else l=S.InvalidCharacter;n++}return Y}function D(){if(t="",l=S.None,s=n,n>=r)return s=r,o=P.EOF;let Y=i.charCodeAt(n);if(O(Y)){do n++,t+=String.fromCharCode(Y),Y=i.charCodeAt(n);while(O(Y));return o=P.Trivia}if(w(Y))return n++,t+=String.fromCharCode(Y),Y===d.carriageReturn&&i.charCodeAt(n)===d.lineFeed&&(n++,t+=`
`),o=P.LineBreakTrivia;switch(Y){case d.openBrace:return n++,o=P.OpenBraceToken;case d.closeBrace:return n++,o=P.CloseBraceToken;case d.openBracket:return n++,o=P.OpenBracketToken;case d.closeBracket:return n++,o=P.CloseBracketToken;case d.colon:return n++,o=P.ColonToken;case d.comma:return n++,o=P.CommaToken;case d.doubleQuote:return n++,t=A(),o=P.StringLiteral;case d.slash:{const ne=n-1;if(i.charCodeAt(n+1)===d.slash){for(n+=2;n<r&&!w(i.charCodeAt(n));)n++;return t=i.substring(ne,n),o=P.LineCommentTrivia}if(i.charCodeAt(n+1)===d.asterisk){n+=2;const ae=r-1;let ue=!1;for(;n<ae;){if(i.charCodeAt(n)===d.asterisk&&i.charCodeAt(n+1)===d.slash){n+=2,ue=!0;break}n++}return ue||(n++,l=S.UnexpectedEndOfComment),t=i.substring(ne,n),o=P.BlockCommentTrivia}return t+=String.fromCharCode(Y),n++,o=P.Unknown}case d.minus:if(t+=String.fromCharCode(Y),n++,n===r||!a(i.charCodeAt(n)))return o=P.Unknown;case d._0:case d._1:case d._2:case d._3:case d._4:case d._5:case d._6:case d._7:case d._8:case d._9:return t+=T(),o=P.NumericLiteral;default:for(;n<r&&j(Y);)n++,Y=i.charCodeAt(n);if(s!==n){switch(t=i.substring(s,n),t){case"true":return o=P.TrueKeyword;case"false":return o=P.FalseKeyword;case"null":return o=P.NullKeyword}return o=P.Unknown}return t+=String.fromCharCode(Y),n++,o=P.Unknown}}function j(Y){if(O(Y)||w(Y))return!1;switch(Y){case d.closeBrace:case d.closeBracket:case d.openBrace:case d.openBracket:case d.doubleQuote:case d.colon:case d.comma:case d.slash:return!1}return!0}function H(){let Y;do Y=D();while(Y>=P.LineCommentTrivia&&Y<=P.Trivia);return Y}return{setPosition:N,getPosition:()=>n,scan:c?H:D,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>l}}function O(i){return i===d.space||i===d.tab||i===d.verticalTab||i===d.formFeed||i===d.nonBreakingSpace||i===d.ogham||i>=d.enQuad&&i<=d.zeroWidthSpace||i===d.narrowNoBreakSpace||i===d.mathematicalSpace||i===d.ideographicSpace||i===d.byteOrderMark}function w(i){return i===d.lineFeed||i===d.carriageReturn||i===d.lineSeparator||i===d.paragraphSeparator}function a(i){return i>=d._0&&i<=d._9}var d;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(d||(d={}));function u(i,c){const n=[],r=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(g,N,T,A){s.value=g,s.offset=N,s.length=T,s.type=A,s.colonOffset=void 0,t=s}try{R(i,{onObjectBegin:(g,N)=>{if(c<=g)throw r;t=void 0,o=c>g,n.push("")},onObjectProperty:(g,N,T)=>{if(c<N||(l(g,N,T,"property"),n[n.length-1]=g,c<=N+T))throw r},onObjectEnd:(g,N)=>{if(c<=g)throw r;t=void 0,n.pop()},onArrayBegin:(g,N)=>{if(c<=g)throw r;t=void 0,n.push(0)},onArrayEnd:(g,N)=>{if(c<=g)throw r;t=void 0,n.pop()},onLiteralValue:(g,N,T)=>{if(c<N||(l(g,N,T,y(g)),c<=N+T))throw r},onSeparator:(g,N,T)=>{if(c<=N)throw r;if(g===":"&&t&&t.type==="property")t.colonOffset=N,o=!1,t=void 0;else if(g===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(g){if(g!==r)throw g}return{path:n,previousNode:t,isAtPropertyKey:o,matches:g=>{let N=0;for(let T=0;N<g.length&&T<n.length;T++)if(g[N]===n[T]||g[N]==="*")N++;else if(g[N]!=="**")return!1;return N===g.length}}}function p(i,c=[],n=k.DEFAULT){let r=null,t=[];const s=[];function o(g){Array.isArray(t)?t.push(g):r!==null&&(t[r]=g)}return R(i,{onObjectBegin:()=>{const g={};o(g),s.push(t),t=g,r=null},onObjectProperty:g=>{r=g},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const g=[];o(g),s.push(t),t=g,r=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:o,onError:(g,N,T)=>{c.push({error:g,offset:N,length:T})}},n),t[0]}function f(i,c=[],n=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(g){r.type==="property"&&(r.length=g-r.offset,r=r.parent)}function s(g){return r.children.push(g),g}R(i,{onObjectBegin:g=>{r=s({type:"object",offset:g,length:-1,parent:r,children:[]})},onObjectProperty:(g,N,T)=>{r=s({type:"property",offset:N,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:g,offset:N,length:T,parent:r})},onObjectEnd:(g,N)=>{r.length=g+N-r.offset,r=r.parent,t(g+N)},onArrayBegin:(g,N)=>{r=s({type:"array",offset:g,length:-1,parent:r,children:[]})},onArrayEnd:(g,N)=>{r.length=g+N-r.offset,r=r.parent,t(g+N)},onLiteralValue:(g,N,T)=>{s({type:y(g),offset:N,length:T,parent:r,value:g}),t(N+T)},onSeparator:(g,N,T)=>{r.type==="property"&&(g===":"?r.colonOffset=N:g===","&&t(N))},onError:(g,N,T)=>{c.push({error:g,offset:N,length:T})}},n);const l=r.children[0];return l&&delete l.parent,l}function m(i,c){if(!i)return;let n=i;for(const r of c)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===r){n=s.children[1],t=!0;break}if(!t)return}else{const t=r;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function I(i){if(!i.parent||!i.parent.children)return[];const c=I(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;c.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&c.push(n)}return c}function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const c=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(c[n.children[0].value]=b(r))}return c}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function h(i,c,n=!1){return c>=i.offset&&c<i.offset+i.length||n&&c===i.offset+i.length}function $(i,c,n=!1){if(h(i,c,n)){const r=i.children;if(Array.isArray(r))for(let t=0;t<r.length&&r[t].offset<=c;t++){const s=$(r[t],c,n);if(s)return s}return i}}function R(i,c,n=k.DEFAULT){const r=L(i,!1);function t(K){return K?()=>K(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(K){return K?ie=>K(ie,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=t(c.onObjectBegin),l=s(c.onObjectProperty),g=t(c.onObjectEnd),N=t(c.onArrayBegin),T=t(c.onArrayEnd),A=s(c.onLiteralValue),D=s(c.onSeparator),j=t(c.onComment),H=s(c.onError),Y=n&&n.disallowComments,ne=n&&n.allowTrailingComma;function ae(){for(;;){const K=r.scan();switch(r.getTokenError()){case S.InvalidUnicode:ue(v.InvalidUnicode);break;case S.InvalidEscapeCharacter:ue(v.InvalidEscapeCharacter);break;case S.UnexpectedEndOfNumber:ue(v.UnexpectedEndOfNumber);break;case S.UnexpectedEndOfComment:Y||ue(v.UnexpectedEndOfComment);break;case S.UnexpectedEndOfString:ue(v.UnexpectedEndOfString);break;case S.InvalidCharacter:ue(v.InvalidCharacter);break}switch(K){case P.LineCommentTrivia:case P.BlockCommentTrivia:Y?ue(v.InvalidCommentToken):j();break;case P.Unknown:ue(v.InvalidSymbol);break;case P.Trivia:case P.LineBreakTrivia:break;default:return K}}}function ue(K,ie=[],se=[]){if(H(K),ie.length+se.length>0){let C=r.getToken();for(;C!==P.EOF;){if(ie.indexOf(C)!==-1){ae();break}else if(se.indexOf(C)!==-1)break;C=ae()}}}function me(K){const ie=r.getTokenValue();return K?A(ie):l(ie),ae(),!0}function W(){switch(r.getToken()){case P.NumericLiteral:{let K=0;try{K=JSON.parse(r.getTokenValue()),typeof K!="number"&&(ue(v.InvalidNumberFormat),K=0)}catch{ue(v.InvalidNumberFormat)}A(K);break}case P.NullKeyword:A(null);break;case P.TrueKeyword:A(!0);break;case P.FalseKeyword:A(!1);break;default:return!1}return ae(),!0}function _(){return r.getToken()!==P.StringLiteral?(ue(v.PropertyNameExpected,[],[P.CloseBraceToken,P.CommaToken]),!1):(me(!1),r.getToken()===P.ColonToken?(D(":"),ae(),x()||ue(v.ValueExpected,[],[P.CloseBraceToken,P.CommaToken])):ue(v.ColonExpected,[],[P.CloseBraceToken,P.CommaToken]),!0)}function z(){o(),ae();let K=!1;for(;r.getToken()!==P.CloseBraceToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(K||ue(v.ValueExpected,[],[]),D(","),ae(),r.getToken()===P.CloseBraceToken&&ne)break}else K&&ue(v.CommaExpected,[],[]);_()||ue(v.ValueExpected,[],[P.CloseBraceToken,P.CommaToken]),K=!0}return g(),r.getToken()!==P.CloseBraceToken?ue(v.CloseBraceExpected,[P.CloseBraceToken],[]):ae(),!0}function M(){N(),ae();let K=!1;for(;r.getToken()!==P.CloseBracketToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(K||ue(v.ValueExpected,[],[]),D(","),ae(),r.getToken()===P.CloseBracketToken&&ne)break}else K&&ue(v.CommaExpected,[],[]);x()||ue(v.ValueExpected,[],[P.CloseBracketToken,P.CommaToken]),K=!0}return T(),r.getToken()!==P.CloseBracketToken?ue(v.CloseBracketExpected,[P.CloseBracketToken],[]):ae(),!0}function x(){switch(r.getToken()){case P.OpenBracketToken:return M();case P.OpenBraceToken:return z();case P.StringLiteral:return me(!0);default:return W()}}return ae(),r.getToken()===P.EOF?n.allowEmptyContent?!0:(ue(v.ValueExpected,[],[]),!1):x()?(r.getToken()!==P.EOF&&ue(v.EndOfFileExpected,[],[]),!0):(ue(v.ValueExpected,[],[]),!1)}function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[76],he([0,1,34]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=P,e.$0n=v,e.$$n=O,e.$_n=w;function P(a,d,u){let p,f,m,I,b;if(d){for(I=d.offset,b=I+d.length,m=I;m>0&&!w(a,m-1);)m--;let l=b;for(;l<a.length&&!w(a,l);)l++;f=a.substring(m,l),p=L(f,u)}else f=a,p=0,m=0,I=0,b=a.length;const h=O(u,a);let $=!1,R=0,y;u.insertSpaces?y=k(" ",u.tabSize||4):y="	";const i=(0,S.$Xn)(f,!1);let c=!1;function n(){return h+k(y,p+R)}function r(){let l=i.scan();for($=!1;l===S.SyntaxKind.Trivia||l===S.SyntaxKind.LineBreakTrivia;)$=$||l===S.SyntaxKind.LineBreakTrivia,l=i.scan();return c=l===S.SyntaxKind.Unknown||i.getTokenError()!==S.ScanError.None,l}const t=[];function s(l,g,N){!c&&g<b&&N>I&&a.substring(g,N)!==l&&t.push({offset:g,length:N-g,content:l})}let o=r();if(o!==S.SyntaxKind.EOF){const l=i.getTokenOffset()+m,g=k(y,p);s(g,m,l)}for(;o!==S.SyntaxKind.EOF;){let l=i.getTokenOffset()+i.getTokenLength()+m,g=r(),N="";for(;!$&&(g===S.SyntaxKind.LineCommentTrivia||g===S.SyntaxKind.BlockCommentTrivia);){const A=i.getTokenOffset()+m;s(" ",l,A),l=i.getTokenOffset()+i.getTokenLength()+m,N=g===S.SyntaxKind.LineCommentTrivia?n():"",g=r()}if(g===S.SyntaxKind.CloseBraceToken)o!==S.SyntaxKind.OpenBraceToken&&(R--,N=n());else if(g===S.SyntaxKind.CloseBracketToken)o!==S.SyntaxKind.OpenBracketToken&&(R--,N=n());else{switch(o){case S.SyntaxKind.OpenBracketToken:case S.SyntaxKind.OpenBraceToken:R++,N=n();break;case S.SyntaxKind.CommaToken:case S.SyntaxKind.LineCommentTrivia:N=n();break;case S.SyntaxKind.BlockCommentTrivia:$?N=n():N=" ";break;case S.SyntaxKind.ColonToken:N=" ";break;case S.SyntaxKind.StringLiteral:if(g===S.SyntaxKind.ColonToken){N="";break}case S.SyntaxKind.NullKeyword:case S.SyntaxKind.TrueKeyword:case S.SyntaxKind.FalseKeyword:case S.SyntaxKind.NumericLiteral:case S.SyntaxKind.CloseBraceToken:case S.SyntaxKind.CloseBracketToken:g===S.SyntaxKind.LineCommentTrivia||g===S.SyntaxKind.BlockCommentTrivia?N=" ":g!==S.SyntaxKind.CommaToken&&g!==S.SyntaxKind.EOF&&(c=!0);break;case S.SyntaxKind.Unknown:c=!0;break}$&&(g===S.SyntaxKind.LineCommentTrivia||g===S.SyntaxKind.BlockCommentTrivia)&&(N=n())}const T=i.getTokenOffset()+m;s(N,l,T),o=g}return t}function v(a,d){const u=JSON.stringify(a,void 0,d.insertSpaces?d.tabSize||4:"	");return d.eol!==void 0?u.replace(/\r\n|\r|\n/g,d.eol):u}function k(a,d){let u="";for(let p=0;p<d;p++)u+=a;return u}function L(a,d){let u=0,p=0;const f=d.tabSize||4;for(;u<a.length;){const m=a.charAt(u);if(m===" ")p++;else if(m==="	")p+=f;else break;u++}return Math.floor(p/f)}function O(a,d){for(let u=0;u<d.length;u++){const p=d.charAt(u);if(p==="\r")return u+1<d.length&&d.charAt(u+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return a&&a.eol||`
`}function w(a,d){return`\r
`.indexOf(a.charAt(d))!==-1}}),define(le[77],he([0,1,34,76]),function(Z,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=v,e.$bo=k,e.$co=L,e.$do=O,e.$eo=w;function v(a,d,u){return k(a,d,void 0,u)}function k(a,d,u,p,f){const m=d.slice(),I=[],b=(0,S.$1n)(a,I);let h,$;for(;m.length>0&&($=m.pop(),h=(0,S.$2n)(b,m),h===void 0&&u!==void 0);)typeof $=="string"?u={[$]:u}:u=[u];if(h)if(h.type==="object"&&typeof $=="string"&&Array.isArray(h.children)){const R=(0,S.$2n)(h,[$]);if(R!==void 0)if(u===void 0){if(!R.parent)throw new Error("Malformed AST");const y=h.children.indexOf(R.parent);let i,c=R.parent.offset+R.parent.length;if(y>0){const n=h.children[y-1];i=n.offset+n.length}else i=h.offset+1,h.children.length>1&&(c=h.children[1].offset);return L(a,{offset:i,length:c-i,content:""},p)}else return L(a,{offset:R.offset,length:R.length,content:JSON.stringify(u)},p);else{if(u===void 0)return[];const y=`${JSON.stringify($)}: ${JSON.stringify(u)}`,i=f?f(h.children.map(n=>n.children[0].value)):h.children.length;let c;if(i>0){const n=h.children[i-1];c={offset:n.offset+n.length,length:0,content:","+y}}else h.children.length===0?c={offset:h.offset+1,length:0,content:y}:c={offset:h.offset+1,length:0,content:y+","};return L(a,c,p)}}else if(h.type==="array"&&typeof $=="number"&&Array.isArray(h.children))if(u!==void 0){const R=`${JSON.stringify(u)}`;let y;if(h.children.length===0||$===0)y={offset:h.offset+1,length:0,content:h.children.length===0?R:R+","};else{const i=$===-1||$>h.children.length?h.children.length:$,c=h.children[i-1];y={offset:c.offset+c.length,length:0,content:","+R}}return L(a,y,p)}else{const R=$,y=h.children[R];let i;if(h.children.length===1)i={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===R){const c=h.children[R-1],n=c.offset+c.length,r=h.offset+h.length;i={offset:n,length:r-2-n,content:""}}else i={offset:y.offset,length:h.children[R+1].offset-y.offset,content:""};return L(a,i,p)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${h.type}`);else return u===void 0?[]:L(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(u)},p)}function L(a,d,u){let p=O(a,d),f=d.offset,m=d.offset+d.content.length;if(d.length===0||d.content.length===0){for(;f>0&&!(0,P.$_n)(p,f-1);)f--;for(;m<p.length&&!(0,P.$_n)(p,m);)m++}const I=(0,P.$9n)(p,{offset:f,length:m-f},u);for(let h=I.length-1;h>=0;h--){const $=I[h];p=O(p,$),f=Math.min(f,$.offset),m=Math.max(m,$.offset+$.length),m+=$.content.length-$.length}const b=a.length-(p.length-m)-f;return[{offset:f,length:b,content:p.substring(f,m)}]}function O(a,d){return a.substring(0,d.offset)+d.content+a.substring(d.offset+d.length)}function w(a,d){const u=d.slice(0).sort((f,m)=>{const I=f.offset-m.offset;return I===0?f.length-m.length:I});let p=a.length;for(let f=u.length-1;f>=0;f--){const m=u[f];if(m.offset+m.length<=p)a=O(a,m);else throw new Error("Overlapping edit");p=m.offset}return a}}),define(le[78],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=S;function S(k){let L=!1;const O=new Map,w=new Map;if(v(k,I=>{if(k===I)return!0;const b=JSON.stringify(I);if(b.length<30)return!0;const h=O.get(b);if(!h){const $={schemas:[I]};return O.set(b,$),w.set(I,$),!0}return h.schemas.push(I),w.set(I,h),L=!0,!1}),O.clear(),!L)return JSON.stringify(k);let d="$defs";for(;k.hasOwnProperty(d);)d+="_";const u=[];function p(I){return JSON.stringify(I,(b,h)=>{if(h!==I){const $=w.get(h);if($&&$.schemas.length>1)return $.id||($.id=`_${u.length}`,u.push($.schemas[0])),{$ref:`#/${d}/${$.id}`}}return h})}const f=p(k),m=[];for(let I=0;I<u.length;I++)m.push(`"_${I}":${p(u[I])}`);return m.length?`${f.substring(0,f.length-1)},"${d}":{${m.join(",")}}}`:f}function P(k){return typeof k=="object"&&k!==null}function v(k,L){if(!k||typeof k!="object")return;const O=(...f)=>{for(const m of f)P(m)&&u.push(m)},w=(...f)=>{for(const m of f)if(P(m))for(const I in m){const b=m[I];P(b)&&u.push(b)}},a=(...f)=>{for(const m of f)if(Array.isArray(m))for(const I of m)P(I)&&u.push(I)},d=f=>{if(Array.isArray(f))for(const m of f)P(m)&&u.push(m);else P(f)&&u.push(f)},u=[k];let p=u.pop();for(;p;)L(p)&&(O(p.additionalItems,p.additionalProperties,p.not,p.contains,p.propertyNames,p.if,p.then,p.else,p.unevaluatedItems,p.unevaluatedProperties),w(p.definitions,p.$defs,p.properties,p.patternProperties,p.dependencies,p.dependentSchemas),a(p.anyOf,p.allOf,p.oneOf,p.prefixItems),d(p.items)),p=u.pop()}}),define(le[79],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=void 0,e.$Mm=S,e.rot=P,e.$Rm=O;function S(w,a,d){return Math.min(Math.max(w,a),d)}function P(w,a){return(a+w%a)%a}class v{constructor(){this.a=0}getNext(){return this.a++}}e.$Om=v;class k{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Pm=k;class L{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const d=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Qm=L;function O(w,a,d,u,p,f,m,I){const b=m-d,h=I-u,$=p-d,R=f-u,y=w-d,i=a-u,c=b*b+h*h,n=b*$+h*R,r=b*y+h*i,t=$*$+R*R,s=$*y+R*i,o=1/(c*t-n*n),l=(t*r-n*s)*o,g=(c*s-n*r)*o;return l>=0&&g>=0&&l+g<1}}),function(){function Z(v){const k=[];typeof v=="number"&&k.push("code/timeOrigin",v);function L(w){k.push(w,Date.now())}function O(){const w=[];for(let a=0;a<k.length;a+=2)w.push({name:k[a],startTime:k[a+1]});return w}return{mark:L,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(v+L.startTime)});return k}};if(typeof process=="object"){const v=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function S(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=e()),v.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=S(P))}(),define(le[56],he([0,1,12]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=k,e.$nm=L;var P;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(P||(e.Source=P={}));var v;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(v||(e.TerminateResponseCode=v={}));function k(O,...w){const a=w.reduce((p,f)=>(p[f]=!0,p),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(p=>!a[p]).forEach(p=>{for(let f=0;f<d.length;f++)if(p.search(d[f])!==-1){delete O[p];break}})}function L(O){O&&(delete O.DEBUG,S.$l&&delete O.LD_PRELOAD)}}),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var P in S)(typeof exports=="object"?exports:Z)[P]=S[P]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function S(P){if(e[P])return e[P].exports;var v=e[P]={i:P,l:!1,exports:{}};return Z[P].call(v.exports,v,v.exports,S),v.l=!0,v.exports}return S.m=Z,S.c=e,S.d=function(P,v,k){S.o(P,v)||Object.defineProperty(P,v,{enumerable:!0,get:k})},S.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},S.t=function(P,v){if(1&v&&(P=S(P)),8&v||4&v&&typeof P=="object"&&P&&P.__esModule)return P;var k=Object.create(null);if(S.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:P}),2&v&&typeof P!="string")for(var L in P)S.d(k,L,function(O){return P[O]}.bind(null,L));return k},S.n=function(P){var v=P&&P.__esModule?function(){return P.default}:function(){return P};return S.d(v,"a",v),v},S.o=function(P,v){return Object.prototype.hasOwnProperty.call(P,v)},S.p="",S(S.s=0)}([function(Z,e,S){(function(P){var v;e=Z.exports=C,v=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],w=e.src=[],a=0,d=a++;w[d]="0|[1-9]\\d*";var u=a++;w[u]="[0-9]+";var p=a++;w[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=a++;w[f]="("+w[d]+")\\.("+w[d]+")\\.("+w[d]+")";var m=a++;w[m]="("+w[u]+")\\.("+w[u]+")\\.("+w[u]+")";var I=a++;w[I]="(?:"+w[d]+"|"+w[p]+")";var b=a++;w[b]="(?:"+w[u]+"|"+w[p]+")";var h=a++;w[h]="(?:-("+w[I]+"(?:\\."+w[I]+")*))";var $=a++;w[$]="(?:-?("+w[b]+"(?:\\."+w[b]+")*))";var R=a++;w[R]="[0-9A-Za-z-]+";var y=a++;w[y]="(?:\\+("+w[R]+"(?:\\."+w[R]+")*))";var i=a++,c="v?"+w[f]+w[h]+"?"+w[y]+"?";w[i]="^"+c+"$";var n="[v=\\s]*"+w[m]+w[$]+"?"+w[y]+"?",r=a++;w[r]="^"+n+"$";var t=a++;w[t]="((?:<|>)?=?)";var s=a++;w[s]=w[u]+"|x|X|\\*";var o=a++;w[o]=w[d]+"|x|X|\\*";var l=a++;w[l]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[h]+")?"+w[y]+"?)?)?";var g=a++;w[g]="[v=\\s]*("+w[s]+")(?:\\.("+w[s]+")(?:\\.("+w[s]+")(?:"+w[$]+")?"+w[y]+"?)?)?";var N=a++;w[N]="^"+w[t]+"\\s*"+w[l]+"$";var T=a++;w[T]="^"+w[t]+"\\s*"+w[g]+"$";var A=a++;w[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=a++;w[D]="(?:~>?)";var j=a++;w[j]="(\\s*)"+w[D]+"\\s+",O[j]=new RegExp(w[j],"g");var H=a++;w[H]="^"+w[D]+w[l]+"$";var Y=a++;w[Y]="^"+w[D]+w[g]+"$";var ne=a++;w[ne]="(?:\\^)";var ae=a++;w[ae]="(\\s*)"+w[ne]+"\\s+",O[ae]=new RegExp(w[ae],"g");var ue=a++;w[ue]="^"+w[ne]+w[l]+"$";var me=a++;w[me]="^"+w[ne]+w[g]+"$";var W=a++;w[W]="^"+w[t]+"\\s*("+n+")$|^$";var _=a++;w[_]="^"+w[t]+"\\s*("+c+")$|^$";var z=a++;w[z]="(\\s*)"+w[t]+"\\s*("+n+"|"+w[l]+")",O[z]=new RegExp(w[z],"g");var M=a++;w[M]="^\\s*("+w[l]+")\\s+-\\s+("+w[l]+")\\s*$";var x=a++;w[x]="^\\s*("+w[g]+")\\s+-\\s+("+w[g]+")\\s*$";var K=a++;w[K]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)v(ie,w[ie]),O[ie]||(O[ie]=new RegExp(w[ie]));function se(B,ee){if(B instanceof C)return B;if(typeof B!="string"||B.length>k||!(ee?O[r]:O[i]).test(B))return null;try{return new C(B,ee)}catch{return null}}function C(B,ee){if(B instanceof C){if(B.loose===ee)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof C))return new C(B,ee);v("SemVer",B,ee),this.loose=ee;var te=B.trim().match(ee?O[r]:O[i]);if(!te)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var Se=+ge;if(Se>=0&&Se<L)return Se}return ge}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}e.parse=se,e.valid=function(B,ee){var te=se(B,ee);return te?te.version:null},e.clean=function(B,ee){var te=se(B.trim().replace(/^[=v]+/,""),ee);return te?te.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(B){return v("SemVer.compare",this.version,this.loose,B),B instanceof C||(B=new C(B,this.loose)),this.compareMain(B)||this.comparePre(B)},C.prototype.compareMain=function(B){return B instanceof C||(B=new C(B,this.loose)),q(this.major,B.major)||q(this.minor,B.minor)||q(this.patch,B.patch)},C.prototype.comparePre=function(B){if(B instanceof C||(B=new C(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var ee=0;do{var te=this.prerelease[ee],ge=B.prerelease[ee];if(v("prerelease compare",ee,te,ge),te===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(te===void 0)return-1;if(te!==ge)return q(te,ge)}while(++ee)},C.prototype.inc=function(B,ee){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,ee,te,ge){typeof te=="string"&&(ge=te,te=void 0);try{return new C(B,te).inc(ee,ge).version}catch{return null}},e.diff=function(B,ee){if(X(B,ee))return null;var te=se(B),ge=se(ee);if(te.prerelease.length||ge.prerelease.length){for(var Se in te)if((Se==="major"||Se==="minor"||Se==="patch")&&te[Se]!==ge[Se])return"pre"+Se;return"prerelease"}for(var Se in te)if((Se==="major"||Se==="minor"||Se==="patch")&&te[Se]!==ge[Se])return Se},e.compareIdentifiers=q;var V=/^[0-9]+$/;function q(B,ee){var te=V.test(B),ge=V.test(ee);return te&&ge&&(B=+B,ee=+ee),te&&!ge?-1:ge&&!te?1:B<ee?-1:B>ee?1:0}function E(B,ee,te){return new C(B,te).compare(new C(ee,te))}function F(B,ee,te){return E(B,ee,te)>0}function J(B,ee,te){return E(B,ee,te)<0}function X(B,ee,te){return E(B,ee,te)===0}function G(B,ee,te){return E(B,ee,te)!==0}function U(B,ee,te){return E(B,ee,te)>=0}function Q(B,ee,te){return E(B,ee,te)<=0}function re(B,ee,te,ge){var Se;switch(ee){case"===":typeof B=="object"&&(B=B.version),typeof te=="object"&&(te=te.version),Se=B===te;break;case"!==":typeof B=="object"&&(B=B.version),typeof te=="object"&&(te=te.version),Se=B!==te;break;case"":case"=":case"==":Se=X(B,te,ge);break;case"!=":Se=G(B,te,ge);break;case">":Se=F(B,te,ge);break;case">=":Se=U(B,te,ge);break;case"<":Se=J(B,te,ge);break;case"<=":Se=Q(B,te,ge);break;default:throw new TypeError("Invalid operator: "+ee)}return Se}function ce(B,ee){if(B instanceof ce){if(B.loose===ee)return B;B=B.value}if(!(this instanceof ce))return new ce(B,ee);v("comparator",B,ee),this.loose=ee,this.parse(B),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}e.rcompareIdentifiers=function(B,ee){return q(ee,B)},e.major=function(B,ee){return new C(B,ee).major},e.minor=function(B,ee){return new C(B,ee).minor},e.patch=function(B,ee){return new C(B,ee).patch},e.compare=E,e.compareLoose=function(B,ee){return E(B,ee,!0)},e.rcompare=function(B,ee,te){return E(ee,B,te)},e.sort=function(B,ee){return B.sort(function(te,ge){return e.compare(te,ge,ee)})},e.rsort=function(B,ee){return B.sort(function(te,ge){return e.rcompare(te,ge,ee)})},e.gt=F,e.lt=J,e.eq=X,e.neq=G,e.gte=U,e.lte=Q,e.cmp=re,e.Comparator=ce;var fe={};function we(B,ee){if(B instanceof we)return B.loose===ee?B:new we(B.raw,ee);if(B instanceof ce)return new we(B.value,ee);if(!(this instanceof we))return new we(B,ee);if(this.loose=ee,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function de(B){return!B||B.toLowerCase()==="x"||B==="*"}function pe(B,ee,te,ge,Se,Ae,ke,Te,Re,Le,Me,De,Ce){return((ee=de(te)?"":de(ge)?">="+te+".0.0":de(Se)?">="+te+"."+ge+".0":">="+ee)+" "+(Te=de(Re)?"":de(Le)?"<"+(+Re+1)+".0.0":de(Me)?"<"+Re+"."+(+Le+1)+".0":De?"<="+Re+"."+Le+"."+Me+"-"+De:"<="+Te)).trim()}function ye(B,ee){for(var te=0;te<B.length;te++)if(!B[te].test(ee))return!1;if(ee.prerelease.length){for(te=0;te<B.length;te++)if(v(B[te].semver),B[te].semver!==fe&&B[te].semver.prerelease.length>0){var ge=B[te].semver;if(ge.major===ee.major&&ge.minor===ee.minor&&ge.patch===ee.patch)return!0}return!1}return!0}function $e(B,ee,te){try{ee=new we(ee,te)}catch{return!1}return ee.test(B)}function ve(B,ee,te,ge){var Se,Ae,ke,Te,Re;switch(B=new C(B,ge),ee=new we(ee,ge),te){case">":Se=F,Ae=Q,ke=J,Te=">",Re=">=";break;case"<":Se=J,Ae=U,ke=F,Te="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(B,ee,ge))return!1;for(var Le=0;Le<ee.set.length;++Le){var Me=ee.set[Le],De=null,Ce=null;if(Me.forEach(function(Fe){Fe.semver===fe&&(Fe=new ce(">=0.0.0")),De=De||Fe,Ce=Ce||Fe,Se(Fe.semver,De.semver,ge)?De=Fe:ke(Fe.semver,Ce.semver,ge)&&(Ce=Fe)}),De.operator===Te||De.operator===Re||(!Ce.operator||Ce.operator===Te)&&Ae(B,Ce.semver)||Ce.operator===Re&&ke(B,Ce.semver))return!1}return!0}ce.prototype.parse=function(B){var ee=this.loose?O[W]:O[_],te=B.match(ee);if(!te)throw new TypeError("Invalid comparator: "+B);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new C(te[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(B){return v("Comparator.test",B,this.loose),this.semver===fe||(typeof B=="string"&&(B=new C(B,this.loose)),re(B,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(B,ee){if(!(B instanceof ce))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new we(B.value,ee),$e(this.value,te,ee);if(B.operator==="")return te=new we(this.value,ee),$e(B.semver,te,ee);var ge=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ae=this.semver.version===B.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Te=re(this.semver,"<",B.semver,ee)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Re=re(this.semver,">",B.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ge||Se||Ae&&ke||Te||Re},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(B){var ee=this.loose;B=B.trim(),v("range",B,ee);var te=ee?O[x]:O[M];B=B.replace(te,pe),v("hyphen replace",B),B=B.replace(O[z],"$1$2$3"),v("comparator trim",B,O[z]),B=(B=(B=B.replace(O[j],"$1~")).replace(O[ae],"$1^")).split(/\s+/).join(" ");var ge=ee?O[W]:O[_],Se=B.split(" ").map(function(Ae){return function(ke,Te){return v("comp",ke),ke=function(Re,Le){return Re.trim().split(/\s+/).map(function(Me){return function(De,Ce){v("caret",De,Ce);var Fe=Ce?O[me]:O[ue];return De.replace(Fe,function(Ue,Pe,Ie,Oe,Ne){var je;return v("caret",De,Ue,Pe,Ie,Oe,Ne),de(Pe)?je="":de(Ie)?je=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de(Oe)?je=Pe==="0"?">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+".0 <"+(+Pe+1)+".0.0":Ne?(v("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),je=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+Ne+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+Ne+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+Ne+" <"+(+Pe+1)+".0.0"):(v("no pr"),je=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+" <"+(+Pe+1)+".0.0"),v("caret return",je),je})}(Me,Le)}).join(" ")}(ke,Te),v("caret",ke),ke=function(Re,Le){return Re.trim().split(/\s+/).map(function(Me){return function(De,Ce){var Fe=Ce?O[Y]:O[H];return De.replace(Fe,function(Ue,Pe,Ie,Oe,Ne){var je;return v("tilde",De,Ue,Pe,Ie,Oe,Ne),de(Pe)?je="":de(Ie)?je=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de(Oe)?je=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":Ne?(v("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),je=">="+Pe+"."+Ie+"."+Oe+Ne+" <"+Pe+"."+(+Ie+1)+".0"):je=">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0",v("tilde return",je),je})}(Me,Le)}).join(" ")}(ke,Te),v("tildes",ke),ke=function(Re,Le){return v("replaceXRanges",Re,Le),Re.split(/\s+/).map(function(Me){return function(De,Ce){De=De.trim();var Fe=Ce?O[T]:O[N];return De.replace(Fe,function(Ue,Pe,Ie,Oe,Ne,je){v("xRange",De,Ue,Pe,Ie,Oe,Ne,je);var Ve=de(Ie),ze=Ve||de(Oe),Be=ze||de(Ne);return Pe==="="&&Be&&(Pe=""),Ve?Ue=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Be?(ze&&(Oe=0),Be&&(Ne=0),Pe===">"?(Pe=">=",ze?(Ie=+Ie+1,Oe=0,Ne=0):Be&&(Oe=+Oe+1,Ne=0)):Pe==="<="&&(Pe="<",ze?Ie=+Ie+1:Oe=+Oe+1),Ue=Pe+Ie+"."+Oe+"."+Ne):ze?Ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(Ue=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0"),v("xRange return",Ue),Ue})}(Me,Le)}).join(" ")}(ke,Te),v("xrange",ke),ke=function(Re,Le){return v("replaceStars",Re,Le),Re.trim().replace(O[K],"")}(ke,Te),v("stars",ke),ke}(Ae,ee)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Ae){return!!Ae.match(ge)})),Se=Se.map(function(Ae){return new ce(Ae,ee)})},we.prototype.intersects=function(B,ee){if(!(B instanceof we))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(ge){return B.set.some(function(Se){return Se.every(function(Ae){return ge.intersects(Ae,ee)})})})})},e.toComparators=function(B,ee){return new we(B,ee).set.map(function(te){return te.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},we.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new C(B,this.loose));for(var ee=0;ee<this.set.length;ee++)if(ye(this.set[ee],B))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(B,ee,te){var ge=null,Se=null;try{var Ae=new we(ee,te)}catch{return null}return B.forEach(function(ke){Ae.test(ke)&&(ge&&Se.compare(ke)!==-1||(Se=new C(ge=ke,te)))}),ge},e.minSatisfying=function(B,ee,te){var ge=null,Se=null;try{var Ae=new we(ee,te)}catch{return null}return B.forEach(function(ke){Ae.test(ke)&&(ge&&Se.compare(ke)!==1||(Se=new C(ge=ke,te)))}),ge},e.validRange=function(B,ee){try{return new we(B,ee).range||"*"}catch{return null}},e.ltr=function(B,ee,te){return ve(B,ee,"<",te)},e.gtr=function(B,ee,te){return ve(B,ee,">",te)},e.outside=ve,e.prerelease=function(B,ee){var te=se(B,ee);return te&&te.prerelease.length?te.prerelease:null},e.intersects=function(B,ee,te){return B=new we(B,te),ee=new we(ee,te),B.intersects(ee)},e.coerce=function(B){if(B instanceof C)return B;if(typeof B!="string")return null;var ee=B.match(O[A]);return ee==null?null:se((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,S(1))},function(Z,e){var S,P,v=Z.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function O(b){if(S===setTimeout)return setTimeout(b,0);if((S===k||!S)&&setTimeout)return S=setTimeout,setTimeout(b,0);try{return S(b,0)}catch{try{return S.call(null,b,0)}catch{return S.call(this,b,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:k}catch{S=k}try{P=typeof clearTimeout=="function"?clearTimeout:L}catch{P=L}})();var w,a=[],d=!1,u=-1;function p(){d&&w&&(d=!1,w.length?a=w.concat(a):u=-1,a.length&&f())}function f(){if(!d){var b=O(p);d=!0;for(var h=a.length;h;){for(w=a,a=[];++u<h;)w&&w[u].run();u=-1,h=a.length}w=null,d=!1,function($){if(P===clearTimeout)return clearTimeout($);if((P===L||!P)&&clearTimeout)return P=clearTimeout,clearTimeout($);try{P($)}catch{try{return P.call(null,$)}catch{return P.call(this,$)}}}(b)}}function m(b,h){this.fun=b,this.array=h}function I(){}v.nextTick=function(b){var h=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)h[$-1]=arguments[$];a.push(new m(b,h)),a.length!==1||d||O(f)},m.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=I,v.addListener=I,v.once=I,v.off=I,v.removeListener=I,v.removeAllListeners=I,v.emit=I,v.prependListener=I,v.prependOnceListener=I,v.listeners=function(b){return[]},v.binding=function(b){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(b){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(le[80],he([0,1]),function(Z,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class P{constructor(O,w,a){this.level=O,this.key=w,this.value=a,this.forward=[]}}const v=void 0;class k{constructor(O,w=2**16){this.comparator=O,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new P(this.c,v,v)}get size(){return this.f}clear(){this.e=new P(this.c,v,v),this.f=0}has(O){return!!k.g(this,O,this.comparator)}get(O){return k.g(this,O,this.comparator)?.value}set(O,w){return k.h(this,O,w,this.comparator)&&(this.f+=1),this}delete(O){const w=k.k(this,O,this.comparator);return w&&(this.f-=1),w}forEach(O,w){let a=this.e.forward[0];for(;a;)O.call(w,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",w=this.e.forward[0];for(;w;)O+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return O}static g(O,w,a){let d=O.e;for(let u=O.d-1;u>=0;u--)for(;d.forward[u]&&a(d.forward[u].key,w)<0;)d=d.forward[u];if(d=d.forward[0],d&&a(d.key,w)===0)return d}static h(O,w,a,d){const u=[];let p=O.e;for(let f=O.d-1;f>=0;f--){for(;p.forward[f]&&d(p.forward[f].key,w)<0;)p=p.forward[f];u[f]=p}if(p=p.forward[0],p&&d(p.key,w)===0)return p.value=a,!1;{const f=k.j(O);if(f>O.d){for(let m=O.d;m<f;m++)u[m]=O.e;O.d=f}p=new P(f,w,a);for(let m=0;m<f;m++)p.forward[m]=u[m].forward[m],u[m].forward[m]=p;return!0}}static j(O,w=.5){let a=1;for(;Math.random()<w&&a<O.c;)a+=1;return a}static k(O,w,a){const d=[];let u=O.e;for(let p=O.d-1;p>=0;p--){for(;u.forward[p]&&a(u.forward[p].key,w)<0;)u=u.forward[p];d[p]=u}if(u=u.forward[0],!u||a(u.key,w)!==0)return!1;for(let p=0;p<O.d&&d[p].forward[p]===u;p++)d[p].forward[p]=u.forward[p];for(;O.d>0&&O.e.forward[O.d-1]===v;)O.d-=1;return!0}}e.$Us=k}),define(le[47],he([0,1,7,2]),function(Z,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=v,e.$Ae=k,e.$Be=L,e.$Ce=O,e.$De=a,e.$Ee=d,e.$Fe=u,e.$Ge=p,e.$He=f,e.$Ie=m,e.$Je=I,e.$Ke=b,e.$Le=h,e.$Me=$,e.$Ne=R;function v(y){const i=y;return i?typeof i.read=="function":!1}function k(y){const i=y;return i?[i.on,i.pause,i.resume,i.destroy].every(c=>typeof c=="function"):!1}function L(y){const i=y;return i?k(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function O(y,i){return new w(y,i)}class w{constructor(i,c){this.e=i,this.f=c,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(c=>this.d.push(c))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(c=>c(i))}h(i){this.c.error.length===0?(0,S.$Z)(i):this.c.error.slice(0).forEach(c=>c(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,c){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(c),this.resume();break;case"end":this.c.end.push(c),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(c),this.a.flowing&&this.k();break}}removeListener(i,c){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(c);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const c=[...this.d];this.d.length=0,c.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(y,i){const c=[];let n;for(;(n=y.read())!==null;)c.push(n);return i(c)}function d(y,i,c){const n=[];let r;for(;(r=y.read())!==null&&n.length<c;)n.push(r);return r===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return y.read()}}}function u(y,i){return new Promise((c,n)=>{const r=[];p(y,{onData:t=>{i&&r.push(t)},onError:t=>{i?n(t):c(void 0)},onEnd:()=>{c(i?i(r):void 0)}})})}function p(y,i,c){y.on("error",n=>{c?.isCancellationRequested||i.onError(n)}),y.on("end",()=>{c?.isCancellationRequested||i.onEnd()}),y.on("data",n=>{c?.isCancellationRequested||i.onData(n)})}function f(y,i){return new Promise((c,n)=>{const r=new P.$Uc,t=[],s=g=>{if(t.push(g),t.length>i)return r.dispose(),y.pause(),c({stream:y,buffer:t,ended:!1})},o=g=>(r.dispose(),n(g)),l=()=>(r.dispose(),c({stream:y,buffer:t,ended:!0}));r.add((0,P.$Tc)(()=>y.removeListener("error",o))),y.on("error",o),r.add((0,P.$Tc)(()=>y.removeListener("end",l))),y.on("end",l),r.add((0,P.$Tc)(()=>y.removeListener("data",s))),y.on("data",s)})}function m(y,i){const c=O(i);return c.end(y),c}function I(){const y=O(()=>{throw new Error("not supported")});return y.end(),y}function b(y){let i=!1;return{read:()=>i?null:(i=!0,y)}}function h(y,i,c){const n=O(c);return p(y,{onData:r=>n.write(i.data(r)),onError:r=>n.error(i.error?i.error(r):r),onEnd:()=>n.end()}),n}function $(y,i,c){let n=!1;return{read:()=>{const r=i.read();return n?r:(n=!0,r!==null?c([y,r]):y)}}}function R(y,i,c){let n=!1;const r=O(c);return p(i,{onData:t=>n?r.write(t):(n=!0,r.write(c([y,t]))),onError:t=>r.error(t),onEnd:()=>{n||(n=!0,r.write(y)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(Z,e,S,P){P===void 0&&(P=S);var v=Object.getOwnPropertyDescriptor(e,S);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[S]}}),Object.defineProperty(Z,P,v)}:function(Z,e,S,P){P===void 0&&(P=S),Z[P]=e[S]}),He=this&&this.__setModuleDefault||(Object.create?function(Z,e){Object.defineProperty(Z,"default",{enumerable:!0,value:e})}:function(Z,e){Z.default=e}),be=this&&this.__importStar||function(Z){if(Z&&Z.__esModule)return Z;var e={};if(Z!=null)for(var S in Z)S!=="default"&&Object.prototype.hasOwnProperty.call(Z,S)&&We(e,Z,S);return He(e,Z),e};define(le[13],he([0,1,147,47]),function(Z,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=a,e.$Qe=d,e.$Re=u,e.$Se=p,e.$Te=f,e.$Ue=m,e.$Ve=I,e.$We=b,e.$Xe=h,e.$Ye=$,e.$Ze=R,e.$1e=y,e.$2e=i,e.$3e=c,e.$4e=n,e.$5e=r,e.$6e=t,e.$7e=s,e.$8e=o,e.$9e=N,P=be(P);const v=typeof Buffer<"u",k=new S.$U(()=>new Uint8Array(256));let L,O;class w{static alloc(A){return v?new w(Buffer.allocUnsafe(A)):new w(new Uint8Array(A))}static wrap(A){return v&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new w(A)}static fromString(A,D){return!(D?.dontUseNodeBuffer||!1)&&v?new w(Buffer.from(A)):(L||(L=new TextEncoder),new w(L.encode(A)))}static fromByteArray(A){const D=w.alloc(A.length);for(let j=0,H=A.length;j<H;j++)D.buffer[j]=A[j];return D}static concat(A,D){if(typeof D>"u"){D=0;for(let Y=0,ne=A.length;Y<ne;Y++)D+=A[Y].byteLength}const j=w.alloc(D);let H=0;for(let Y=0,ne=A.length;Y<ne;Y++){const ae=A[Y];j.set(ae,H),H+=ae.byteLength}return j}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=w.alloc(this.byteLength);return A.set(this),A}toString(){return v?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(A,D){return new w(this.buffer.subarray(A,D))}set(A,D){if(A instanceof w)this.buffer.set(A.buffer,D);else if(A instanceof Uint8Array)this.buffer.set(A,D);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),D);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return p(this.buffer,A)}writeUInt32BE(A,D){f(this.buffer,A,D)}readUInt32LE(A){return m(this.buffer,A)}writeUInt32LE(A,D){I(this.buffer,A,D)}readUInt8(A){return b(this.buffer,A)}writeUInt8(A,D){h(this.buffer,A,D)}indexOf(A,D=0){return a(this.buffer,A instanceof w?A.buffer:A,D)}}e.$Oe=w;function a(T,A,D=0){const j=A.byteLength,H=T.byteLength;if(j===0)return 0;if(j===1)return T.indexOf(A[0]);if(j>H-D)return-1;const Y=k.value;Y.fill(A.length);for(let me=0;me<A.length;me++)Y[A[me]]=A.length-me-1;let ne=D+A.length-1,ae=ne,ue=-1;for(;ne<H;)if(T[ne]===A[ae]){if(ae===0){ue=ne;break}ne--,ae--}else ne+=Math.max(A.length-ae,Y[T[ne]]),ae=A.length-1;return ue}function d(T,A){return T[A+0]<<0>>>0|T[A+1]<<8>>>0}function u(T,A,D){T[D+0]=A&255,A=A>>>8,T[D+1]=A&255}function p(T,A){return T[A]*2**24+T[A+1]*2**16+T[A+2]*2**8+T[A+3]}function f(T,A,D){T[D+3]=A,A=A>>>8,T[D+2]=A,A=A>>>8,T[D+1]=A,A=A>>>8,T[D]=A}function m(T,A){return T[A+0]<<0>>>0|T[A+1]<<8>>>0|T[A+2]<<16>>>0|T[A+3]<<24>>>0}function I(T,A,D){T[D+0]=A&255,A=A>>>8,T[D+1]=A&255,A=A>>>8,T[D+2]=A&255,A=A>>>8,T[D+3]=A&255}function b(T,A){return T[A]}function h(T,A,D){T[D]=A}function $(T){return P.$De(T,A=>w.concat(A))}function R(T){return P.$Ke(T)}function y(T){return P.$Fe(T,A=>w.concat(A))}async function i(T){return T.ended?w.concat(T.buffer):w.concat([...T.buffer,await y(T.stream)])}function c(T){return P.$Ie(T,A=>w.concat(A))}function n(T){return P.$Le(T,{data:A=>typeof A=="string"?w.fromString(A):w.wrap(A)},A=>w.concat(A))}function r(T){return P.$Ce(A=>w.concat(A),T)}function t(T,A){return P.$Me(T,A,D=>w.concat(D))}function s(T,A){return P.$Ne(T,A,D=>w.concat(D))}function o(T){let A=0,D=0,j=0;const H=new Uint8Array(Math.floor(T.length/4*3)),Y=ae=>{switch(D){case 3:H[j++]=A|ae,D=0;break;case 2:H[j++]=A|ae>>>2,A=ae<<6,D=3;break;case 1:H[j++]=A|ae>>>4,A=ae<<4,D=2;break;default:A=ae<<2,D=1}};for(let ae=0;ae<T.length;ae++){const ue=T.charCodeAt(ae);if(ue>=65&&ue<=90)Y(ue-65);else if(ue>=97&&ue<=122)Y(ue-97+26);else if(ue>=48&&ue<=57)Y(ue-48+52);else if(ue===43||ue===45)Y(62);else if(ue===47||ue===95)Y(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ae]}`)}}const ne=j;for(;D>0;)Y(0);return w.wrap(H).slice(0,ne)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function N({buffer:T},A=!0,D=!1){const j=D?g:l;let H="";const Y=T.byteLength%3;let ne=0;for(;ne<T.byteLength-Y;ne+=3){const ae=T[ne+0],ue=T[ne+1],me=T[ne+2];H+=j[ae>>>2],H+=j[(ae<<4|ue>>>4)&63],H+=j[(ue<<2|me>>>6)&63],H+=j[me&63]}if(Y===1){const ae=T[ne+0];H+=j[ae>>>2],H+=j[ae<<4&63],A&&(H+="==")}else if(Y===2){const ae=T[ne+0],ue=T[ne+1];H+=j[ae>>>2],H+=j[(ae<<4|ue>>>4)&63],H+=j[ue<<2&63],A&&(H+="=")}return H}}),define(le[27],he([0,1,3]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=P,e.$go=v,e.$ho=L,e.$io=w,e.$jo=a,e.$ko=d,e.$lo=u,e.$mo=p,e.$no=f,e.$oo=m,e.$po=I,e.$qo=b,e.$ro=h;function P($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const R=Array.isArray($)?[]:{};return Object.entries($).forEach(([y,i])=>{R[y]=i&&typeof i=="object"?P(i):i}),R}function v($){if(!$||typeof $!="object")return $;const R=[$];for(;R.length>0;){const y=R.shift();Object.freeze(y);for(const i in y)if(k.call(y,i)){const c=y[i];typeof c=="object"&&!Object.isFrozen(c)&&!(0,S.$ig)(c)&&R.push(c)}}return $}const k=Object.prototype.hasOwnProperty;function L($,R){return O($,R,new Set)}function O($,R,y){if((0,S.$og)($))return $;const i=R($);if(typeof i<"u")return i;if(Array.isArray($)){const c=[];for(const n of $)c.push(O(n,R,y));return c}if((0,S.$hg)($)){if(y.has($))throw new Error("Cannot clone recursive data-structure");y.add($);const c={};for(const n in $)k.call($,n)&&(c[n]=O($[n],R,y));return y.delete($),c}return $}function w($,R,y=!0){return(0,S.$hg)($)?((0,S.$hg)(R)&&Object.keys(R).forEach(i=>{i in $?y&&((0,S.$hg)($[i])&&(0,S.$hg)(R[i])?w($[i],R[i],y):$[i]=R[i]):$[i]=R[i]}),$):R}function a($,R){if($===R)return!0;if($==null||R===null||R===void 0||typeof $!=typeof R||typeof $!="object"||Array.isArray($)!==Array.isArray(R))return!1;let y,i;if(Array.isArray($)){if($.length!==R.length)return!1;for(y=0;y<$.length;y++)if(!a($[y],R[y]))return!1}else{const c=[];for(i in $)c.push(i);c.sort();const n=[];for(i in R)n.push(i);if(n.sort(),!a(c,n))return!1;for(y=0;y<c.length;y++)if(!a($[c[y]],R[c[y]]))return!1}return!0}function d($){const R=new Set;return JSON.stringify($,(y,i)=>{if((0,S.$hg)(i)||Array.isArray(i)){if(R.has(i))return"[Circular]";R.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function u($,R){const y=Object.create(null);return!$||!R||Object.keys(R).forEach(c=>{const n=$[c],r=R[c];a(n,r)||(y[c]=r)}),y}function p($,R){const y=R.toLowerCase(),i=Object.keys($).find(c=>c.toLowerCase()===y);return i?$[i]:$[R]}function f($,R){const y=Object.create(null);for(const[i,c]of Object.entries($))R(i,c)&&(y[i]=c);return y}function m($){let R=[];for(;Object.prototype!==$;)R=R.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return R}function I($){const R=[];for(const y of m($))typeof $[y]=="function"&&R.push(y);return R}function b($,R){const y=c=>function(){const n=Array.prototype.slice.call(arguments,0);return R(c,n)},i={};for(const c of $)i[c]=y(c);return i}function h($,R){const y={};for(const[i,c]of Object.entries($))y[i]=R(c,i);return y}}),define(le[43],he([0,1,31]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=P,e.$vj=v,e.$wj=k,e.$xj=O,e.$zj=I,S=be(S);function P(h){return v(h,0)}function v(h,$){switch(typeof h){case"object":return h===null?k(349,$):Array.isArray(h)?w(h,$):a(h,$);case"string":return O(h,$);case"boolean":return L(h,$);case"number":return k(h,$);case"undefined":return k(937,$);default:return k(617,$)}}function k(h,$){return($<<5)-$+h|0}function L(h,$){return k(h?433:863,$)}function O(h,$){$=k(149417,$);for(let R=0,y=h.length;R<y;R++)$=k(h.charCodeAt(R),$);return $}function w(h,$){return $=k(104579,$),h.reduce((R,y)=>v(y,R),$)}function a(h,$){return $=k(181387,$),Object.keys(h).sort().reduce((R,y)=>(R=O(y,R),v(h[y],R)),$)}class d{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=v($,this.g),this.g}}e.$yj=d;var u;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function p(h,$,R=32){const y=R-$,i=~((1<<y)-1);return(h<<$|(i&h)>>>y)>>>0}function f(h,$=0,R=h.byteLength,y=0){for(let i=0;i<R;i++)h[$+i]=y}function m(h,$,R="0"){for(;h.length<$;)h=R+h;return h}function I(h,$=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(R=>R.toString(16).padStart(2,"0")).join(""):m((h>>>0).toString(16),$/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(u.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const R=$.length;if(R===0)return;const y=this.p;let i=this.r,c=this.u,n,r;for(c!==0?(n=c,r=-1,c=0):(n=$.charCodeAt(0),r=0);;){let t=n;if(S.$Kf(n))if(r+1<R){const s=$.charCodeAt(r+1);S.$Lf(s)?(r++,t=S.$Mf(n,s)):t=u.UNICODE_REPLACEMENT}else{c=n;break}else S.$Lf(n)&&(t=u.UNICODE_REPLACEMENT);if(i=this.w(y,i,t),r++,r<R)n=$.charCodeAt(r);else break}this.r=i,this.u=c}w($,R,y){return y<128?$[R++]=y:y<2048?($[R++]=192|(y&1984)>>>6,$[R++]=128|(y&63)>>>0):y<65536?($[R++]=224|(y&61440)>>>12,$[R++]=128|(y&4032)>>>6,$[R++]=128|(y&63)>>>0):($[R++]=240|(y&1835008)>>>18,$[R++]=128|(y&258048)>>>12,$[R++]=128|(y&4032)>>>6,$[R++]=128|(y&63)>>>0),R>=u.BLOCK_SIZE&&(this.y(),R-=u.BLOCK_SIZE,this.t+=u.BLOCK_SIZE,$[0]=$[u.BLOCK_SIZE+0],$[1]=$[u.BLOCK_SIZE+1],$[2]=$[u.BLOCK_SIZE+2]),R}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,u.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),I(this.h)+I(this.l)+I(this.m)+I(this.n)+I(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=b.g,R=this.q;for(let l=0;l<64;l+=4)$.setUint32(l,R.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)$.setUint32(l,p($.getUint32(l-12,!1)^$.getUint32(l-32,!1)^$.getUint32(l-56,!1)^$.getUint32(l-64,!1),1),!1);let y=this.h,i=this.l,c=this.m,n=this.n,r=this.o,t,s,o;for(let l=0;l<80;l++)l<20?(t=i&c|~i&n,s=1518500249):l<40?(t=i^c^n,s=1859775393):l<60?(t=i&c|i&n|c&n,s=2400959708):(t=i^c^n,s=3395469782),o=p(y,5)+t+r+s+$.getUint32(l*4,!1)&4294967295,r=n,n=c,c=p(i,30),i=y,y=o;this.h=this.h+y&4294967295,this.l=this.l+i&4294967295,this.m=this.m+c&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.$Aj=b}),define(le[57],he([0,1,31]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),S=be(S);var P;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(P||(P={})),function(v){const k="error",L="warning",O="warn",w="info",a="ignore";function d(p){return p?S.$Gf(k,p)?v.Error:S.$Gf(L,p)||S.$Gf(O,p)?v.Warning:S.$Gf(w,p)?v.Info:v.Ignore:v.Ignore}v.fromValue=d;function u(p){switch(p){case v.Error:return k;case v.Warning:return L;case v.Info:return w;default:return a}}v.toString=u}(P||(P={})),e.default=P}),define(le[81],he([0,1,11]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=P,e.$fr=v,e.$gr=k,e.log=O;function P(a){const d=a;return d&&typeof d.type=="string"&&typeof d.severity=="string"}function v(a){const d=[];let u;try{const p=JSON.parse(a.arguments),f=p[p.length-1];f&&f.__$stack&&(p.pop(),u=f.__$stack),d.push(...p)}catch{d.push("Unable to log remote console arguments",a.arguments)}return{args:d,stack:u}}function k(a){if(typeof a!="string")return k(v(a).stack);const d=a;if(d){const u=L(d),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(p&&p.length===4)return{uri:S.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function L(a){if(!a)return a;const d=a.indexOf(`
`);return d===-1?a:a.substring(0,d)}function O(a,d){const{args:u,stack:p}=v(a),f=typeof u[0]=="string"&&u.length===1;let m=L(p);m&&(m=`(${m.trim()})`);let I=[];if(typeof u[0]=="string"?m&&f?I=[`%c[${d}] %c${u[0]} %c${m}`,w("blue"),w(""),w("grey")]:I=[`%c[${d}] %c${u[0]}`,w("blue"),w(""),...u.slice(1)]:I=[`%c[${d}]%`,w("blue"),...u],m&&!f&&I.push(m),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,I)}function w(a){return`color: ${a}`}}),define(le[48],he([0,1,13,11,148]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=k,e.$ci=L,e.$di=w;function k(a){return JSON.stringify(a,O)}function L(a){let d=JSON.parse(a);return d=w(d),d}function O(a,d){return d instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:d.source,flags:d.flags}:d}function w(a,d=0){if(!a||d>200)return a;if(typeof a=="object"){switch(a.$mid){case v.MarshalledId.Uri:return P.URI.revive(a);case v.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case v.MarshalledId.Date:return new Date(a.source)}if(a instanceof S.$Oe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let u=0;u<a.length;++u)a[u]=w(a[u],d+1);else for(const u in a)Object.hasOwnProperty.call(a,u)&&(a[u]=w(a[u],d+1))}return a}}),define(le[82],he([0,1,74,14,12,3,11]),function(Z,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EE=u,e.$FE=p,v=be(v);class O{constructor(m,I,b){this.id=m,this.dependencies=I,this.callback=b}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,I,b)=>{typeof m!="string"&&(b=I,I=m,m=null),(typeof I!="object"||!Array.isArray(I))&&(b=I,I=null),this.c.push(new O(m,I,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const I=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!I)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(I.dependencies)&&I.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${I.dependencies.join(", ")}`);return typeof I.callback=="function"?I.callback([]):I.callback}h(m){return new Promise((I,b)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const $=()=>{h.removeEventListener("load",R),h.removeEventListener("error",y)},R=i=>{$(),I(this.c.pop())},y=i=>{$(),b(i)};h.addEventListener("load",R),h.addEventListener("error",y),this.f&&(m=this.f.createScriptURL(m)),h.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(m){return new Promise((I,b)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),I(this.c.pop())}catch(h){b(h)}})}async j(m){try{const I=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,$=L.URI.parse(m).fsPath,R=I.readFileSync($).toString(),y=h.wrap(R.replace(/^#!.*/,""));return new b.Script(y).runInThisContext().apply(),this.c.pop()}catch(I){throw I}}}const a=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function u(f,m,I){if(S.$R){I===void 0&&(I=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[f]&&(f=d[f]);const b=m?`${f}/${m}`:f;if(a.has(b))return a.get(b);let h;if(/^\w[\w\d+.-]*:\/\//.test(b))h=b;else{const i=`${S.$S&&I&&!v.$p?P.$Xg:P.$Wg}/${b}`;h=P.$1g.asBrowserUri(i).toString(!0)}const $=w.INSTANCE.load(h);return a.set(b,$),$}else return await new Promise((b,h)=>{Z([f],b,h)}).then(be)}function p(f,m){(0,k.$pg)(S.$R);const b=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,h=S.$S&&b&&!v.$p,$=`${f}/${m}`,y=`${h?P.$Xg:P.$Wg}/${$}`;return P.$1g.asBrowserUri(y).toString(!0)}}),define(le[28],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=P;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(v){return S.test(v)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(O){for(let w=0;w<O.length;w++)O[w]=Math.floor(Math.random()*256);return O};const k=new Uint8Array(16),L=[];for(let O=0;O<256;O++)L.push(O.toString(16).padStart(2,"0"));return function(){v(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let w=0,a="";return a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a}}()}),define(le[83],he([0,1,35]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=k;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(L){const O=L.replace(/\-/g,":").toLowerCase();return!P.has(O)}function k(){const L=(0,S.networkInterfaces)();for(const O in L){const w=L[O];if(w){for(const{mac:a}of w)if(v(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[84],he([0,1,35,49,28,83,12]),function(Z,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0,e.$Un=w,e.$Vn=u,e.$Wn=p,v=be(v),e.$Tn=new class{c(f){return this.a||(this.a=P.$Mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(f)}value(){if(this.b===void 0){let f=0,m=0;const I=(0,S.networkInterfaces)();for(const b in I){const h=I[b];if(h)for(const{mac:$,internal:R}of h)R||(m+=1,this.c($.toUpperCase())&&(f+=1))}this.b=m>0?f/m:0}return this.b}};let O;async function w(f){return O||(O=(async()=>await a(f)||v.$3g())()),O}async function a(f){try{const m=await new Promise((b,h)=>{Z(["crypto"],b,h)}).then(be),I=(0,k.$Sn)();return m.createHash("sha256").update(I,"utf8").digest("hex")}catch(m){f(m);return}}const d="Software\\Microsoft\\SQMClient";async function u(f){if(L.$j){const m=await new Promise((I,b)=>{Z(["@vscode/windows-registry"],I,b)}).then(be);try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",d,"MachineId")||""}catch(I){return f(I),""}}return""}async function p(f){try{return await(await new Promise((b,h)=>{Z(["@vscode/deviceid"],b,h)}).then(be)).getDeviceId()}catch(m){return f(m),""}}}),define(le[85],he([0,1,35,15,29]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=$,e.$ym=R,S=be(S),P=be(P),v=be(v);const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,O=/^Microsoft.PowerShellPreview_.*/;var w;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(w||(w={}));let a;switch(process.arch){case"ia32":a=w.x86;break;case"arm":case"arm64":a=w.ARM;break;default:a=w.x64;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?w.ARM:w.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=w.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=w.x86:d=w.x64;class u{constructor(i,c,n){this.exePath=i,this.displayName=c,this.a=n}async exists(){return this.a===void 0&&(this.a=await v.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:y=!1}={}){return y?a===w.x64?process.env["ProgramFiles(x86)"]||null:d===w.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:y=!1,findPreview:i=!1}={}){const c=p({useAlternateBitness:y});if(!c)return null;const n=P.$kc(c,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(n))return null;let r=-1,t=null;for(const l of await v.Promises.readdir(n)){let g=-1;if(i){const T=l.indexOf("-");if(T<0)continue;const A=l.substring(0,T);if(!k.test(A)||l.substring(T+1)!=="preview")continue;g=parseInt(A,10)}else{if(!k.test(l))continue;g=parseInt(l,10)}if(g<=r)continue;const N=P.$kc(n,l,"pwsh.exe");await v.SymlinkSupport.existsFile(N)&&(t=N,r=g)}if(!t)return null;const s=c.includes("x86")?" (x86)":"",o=i?" Preview":"";return new u(t,`PowerShell${o}${s}`,!0)}async function m({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const i=P.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:c,pwshMsixName:n}=y?{pwshMsixDirRegex:O,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const r of await v.Promises.readdir(i))if(c.test(r)){const t=P.$kc(i,r,"pwsh.exe");return new u(t,n)}return null}function I(){const y=P.$kc(S.homedir(),".dotnet","tools","pwsh.exe");return new u(y,".NET Core PowerShell Global Tool")}function b(){const y=P.$kc(process.env.windir,a===w.x86&&d!==w.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(y,"Windows PowerShell",!0)}async function*h(){let y=await f();y&&(yield y),y=await f({useAlternateBitness:!0}),y&&(yield y),y=await m(),y&&(yield y),y=I(),y&&(yield y),y=await f({findPreview:!0}),y&&(yield y),y=await m({findPreview:!0}),y&&(yield y),y=await f({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=b(),y&&(yield y)}async function*$(){for await(const y of h())await y.exists()&&(yield y)}async function R(){for await(const y of $())return y;return null}}),define(le[58],he([0,1,32,15,12,36,56,3,29]),function(Z,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$zm=a,e.$Am=d,P=be(P),v=be(v),k=be(k),O=be(O),w=be(w),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function a(p=k.env){return p.comspec||"cmd.exe"}function d(p){let f=[],m=!1;const I=function(b){if(m){f.push(b);return}(!p.send(b,$=>{if($&&console.error($),m=!1,f.length>0){const R=f.slice(0);f=[],R.forEach(y=>I(y))}})||v.$j)&&(m=!0)};return{send:I}}var u;(function(p){async function f(m,I,b){if(P.$jc(m))return m;if(I===void 0&&(I=k.cwd()),P.$nc(m)!=="."||(b===void 0&&O.$fg(k.env.PATH)&&(b=k.env.PATH.split(P.$uc)),b===void 0||b.length===0))return P.$kc(I,m);async function $(R){if(await w.Promises.exists(R)){let y;try{y=await S.promises.stat(R)}catch(i){i.message.startsWith("EACCES")&&(y=await S.promises.lstat(R))}return y?!y.isDirectory():!1}return!1}for(const R of b){let y;if(P.$jc(R)?y=P.$kc(R,m):y=P.$kc(I,R,m),await $(y))return y;let i=y+".com";if(await $(i)||(i=y+".exe",await $(i)))return i}return P.$kc(I,m)}p.findExecutable=f})(u||(e.win32=u={}))}),define(le[86],he([0,1,35,12,85,58]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=L,P=be(P),k=be(k);async function L(u,p){return u===P.OperatingSystem.Windows?P.$j?d():k.$zm(p):w(u,p)}let O=null;function w(u,p){if(P.$l&&u===P.OperatingSystem.Macintosh||P.$k&&u===P.OperatingSystem.Linux)return"/bin/bash";if(!O){let f;if(P.$j)f="/bin/bash";else{if(f=p.SHELL,!f)try{f=(0,S.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}O=f}return O}let a=null;async function d(){return a||(a=(await(0,v.$ym)()).exePath),a}});var Ee=this&&this.__decorate||function(Z,e,S,P){var v=arguments.length,k=v<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,S):P,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Z,e,S,P);else for(var O=Z.length-1;O>=0;O--)(L=Z[O])&&(k=(v<3?L(k):v>3?L(e,S,k):L(e,S))||k);return v>3&&k&&Object.defineProperty(e,S,k),k};define(le[59],he([0,1,19,8,13,21,55,7,4,2,48,31,3]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=o,e.$hi=l,e.$mi=j,e.$ni=H,u=be(u);var f;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(f||(f={}));function m(z){switch(z){case f.Promise:return"req";case f.PromiseCancel:return"cancel";case f.EventListen:return"subscribe";case f.EventDispose:return"unsubscribe"}}var I;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(I||(I={}));function b(z){switch(z){case I.Initialize:return"init";case I.PromiseSuccess:return"reply:";case I.PromiseError:case I.PromiseErrorObj:return"replyErr:";case I.EventFire:return"event:"}}var h;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(h||(h={}));function $(z){let M=0;for(let x=0;;x+=7){const K=z.read(1);if(M|=(K.buffer[0]&127)<<x,!(K.buffer[0]&128))return M}}const R=r(0);function y(z,M){if(M===0){z.write(R);return}let x=0;for(let ie=M;ie!==0;ie=ie>>>7)x++;const K=v.$Oe.alloc(x);for(let ie=0;M!==0;ie++)K.buffer[ie]=M&127,M=M>>>7,M>0&&(K.buffer[ie]|=128);z.write(K)}class i{constructor(M){this.b=M,this.a=0}read(M){const x=this.b.slice(this.a,this.a+M);return this.a+=x.byteLength,x}}e.$ei=i;class c{constructor(){this.a=[]}get buffer(){return v.$Oe.concat(this.a)}write(M){this.a.push(M)}}e.$fi=c;var n;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(n||(n={}));function r(z){const M=v.$Oe.alloc(1);return M.writeUInt8(z,0),M}const t={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function o(z,M){if(typeof M>"u")z.write(t.Undefined);else if(typeof M=="string"){const x=v.$Oe.fromString(M);z.write(t.String),y(z,x.byteLength),z.write(x)}else if(s&&Buffer.isBuffer(M)){const x=v.$Oe.wrap(M);z.write(t.Buffer),y(z,x.byteLength),z.write(x)}else if(M instanceof v.$Oe)z.write(t.VSBuffer),y(z,M.byteLength),z.write(M);else if(Array.isArray(M)){z.write(t.Array),y(z,M.length);for(const x of M)o(z,x)}else if(typeof M=="number"&&(M|0)===M)z.write(t.Uint),y(z,M);else{const x=v.$Oe.fromString(JSON.stringify(M));z.write(t.Object),y(z,x.byteLength),z.write(x)}}function l(z){switch(z.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return z.read($(z)).toString();case n.Buffer:return z.read($(z)).buffer;case n.VSBuffer:return z.read($(z));case n.Array:{const x=$(z),K=[];for(let ie=0;ie<x;ie++)K.push(l(z));return K}case n.Object:return JSON.parse(z.read($(z)).toString());case n.Int:return $(z)}}class g{constructor(M,x,K=null,ie=1e3){this.h=M,this.j=x,this.k=K,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:I.Initialize})}registerChannel(M,x){this.b.set(M,x),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case I.Initialize:{const x=this.o([M.type]);this.k?.logOutgoing(x,0,N.OtherSide,b(M.type));return}case I.PromiseSuccess:case I.PromiseError:case I.EventFire:case I.PromiseErrorObj:{const x=this.o([M.type,M.id],M.data);this.k?.logOutgoing(x,M.id,N.OtherSide,b(M.type),M.data);return}}}o(M,x=void 0){const K=new c;return o(K,M),o(K,x),this.p(K.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const x=new i(M),K=l(x),ie=l(x),se=K[0];switch(se){case f.Promise:return this.k?.logIncoming(M.byteLength,K[1],N.OtherSide,`${m(se)}: ${K[2]}.${K[3]}`,ie),this.s({type:se,id:K[1],channelName:K[2],name:K[3],arg:ie});case f.EventListen:return this.k?.logIncoming(M.byteLength,K[1],N.OtherSide,`${m(se)}: ${K[2]}.${K[3]}`,ie),this.t({type:se,id:K[1],channelName:K[2],name:K[3],arg:ie});case f.PromiseCancel:return this.k?.logIncoming(M.byteLength,K[1],N.OtherSide,`${m(se)}`),this.u({type:se,id:K[1]});case f.EventDispose:return this.k?.logIncoming(M.byteLength,K[1],N.OtherSide,`${m(se)}`),this.u({type:se,id:K[1]})}}s(M){const x=this.b.get(M.channelName);if(!x){this.v(M);return}const K=new k.$xe;let ie;try{ie=x.call(this.j,M.name,M.arg,K.token)}catch(V){ie=Promise.reject(V)}const se=M.id;ie.then(V=>{this.m({id:se,data:V,type:I.PromiseSuccess})},V=>{V instanceof Error?this.m({id:se,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split(`
`):void 0},type:I.PromiseError}):this.m({id:se,data:V,type:I.PromiseErrorObj})}).finally(()=>{C.dispose(),this.d.delete(M.id)});const C=(0,a.$Tc)(()=>K.cancel());this.d.set(M.id,C)}t(M){const x=this.b.get(M.channelName);if(!x){this.v(M);return}const K=M.id,se=x.listen(this.j,M.name,M.arg)(C=>this.m({id:K,data:C,type:I.EventFire}));this.d.set(M.id,se)}u(M){const x=this.d.get(M.id);x&&(x.dispose(),this.d.delete(M.id))}v(M){let x=this.g.get(M.channelName);x||(x=[],this.g.set(M.channelName,x));const K=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===f.Promise&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:I.PromiseError})},this.l);x.push({request:M,timeoutTimer:K})}w(M){const x=this.g.get(M);if(x){for(const K of x)switch(clearTimeout(K.timeoutTimer),K.request.type){case f.Promise:this.s(K.request);break;case f.EventListen:this.t(K.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Qc)(this.d.values()),this.d.clear()}}e.$ii=g;var N;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(N||(e.RequestInitiator=N={}));class T{constructor(M,x=null){this.l=M,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=x}getChannel(M){const x=this;return{call(K,ie,se){return x.a?Promise.reject(new O.$5):x.m(M,K,ie,se)},listen(K,ie){return x.a?w.Event.None:x.o(M,K,ie)}}}m(M,x,K,ie=k.CancellationToken.None){const se=this.g++,C=f.Promise,V={id:se,type:C,channelName:M,name:x,arg:K};if(ie.isCancellationRequested)return Promise.reject(new O.$5);let q;return new Promise((F,J)=>{if(ie.isCancellationRequested)return J(new O.$5);const X=()=>{const re=ce=>{switch(ce.type){case I.PromiseSuccess:this.f.delete(se),F(ce.data);break;case I.PromiseError:{this.f.delete(se);const fe=new Error(ce.data.message);fe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,fe.name=ce.data.name,J(fe);break}case I.PromiseErrorObj:this.f.delete(se),J(ce.data);break}};this.f.set(se,re),this.p(V)};let G=null;this.b===h.Idle?X():(G=(0,P.$th)(re=>this.u()),G.then(()=>{G=null,X()}));const U=()=>{G?(G.cancel(),G=null):this.p({id:se,type:f.PromiseCancel}),J(new O.$5)},Q=ie.onCancellationRequested(U);q=(0,a.$Sc)((0,a.$Tc)(U),Q),this.d.add(q)}).finally(()=>{q.dispose(),this.d.delete(q)})}o(M,x,K){const ie=this.g++,se=f.EventListen,C={id:ie,type:se,channelName:M,name:x,arg:K};let V=null;const q=new w.$me({onWillAddFirstListener:()=>{V=(0,P.$th)(F=>this.u()),V.then(()=>{V=null,this.d.add(q),this.p(C)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete(q),this.p({id:ie,type:f.EventDispose}))}}),E=F=>q.fire(F.data);return this.f.set(ie,E),q.event}p(M){switch(M.type){case f.Promise:case f.EventListen:{const x=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(x,M.id,N.LocalSide,`${m(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case f.PromiseCancel:case f.EventDispose:{const x=this.q([M.type,M.id]);this.j?.logOutgoing(x,M.id,N.LocalSide,m(M.type));return}}}q(M,x=void 0){const K=new c;return o(K,M),o(K,x),this.r(K.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const x=new i(M),K=l(x),ie=l(x),se=K[0];switch(se){case I.Initialize:return this.j?.logIncoming(M.byteLength,0,N.LocalSide,b(se)),this.t({type:K[0]});case I.PromiseSuccess:case I.PromiseError:case I.EventFire:case I.PromiseErrorObj:return this.j?.logIncoming(M.byteLength,K[1],N.LocalSide,b(se),ie),this.t({type:K[0],id:K[1],data:ie})}}t(M){if(M.type===I.Initialize){this.b=h.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Qc)(this.d.values()),this.d.clear()}}e.$ji=T,Ee([L.$$h],T.prototype,"onDidInitializePromise",null);class A{get connections(){const M=[];return this.f.forEach(x=>M.push(x)),M}constructor(M,x,K){this.a=new Map,this.f=new Set,this.g=new w.$me,this.onDidAddConnection=this.g.event,this.h=new w.$me,this.onDidRemoveConnection=this.h.event,this.j=new a.$Uc,this.j.add(M(({protocol:ie,onDidClientDisconnect:se})=>{const C=w.Event.once(ie.onMessage);this.j.add(C(V=>{const q=new i(V),E=l(q),F=new g(ie,E,x,K),J=new T(ie,x);this.a.forEach((G,U)=>F.registerChannel(U,G));const X={channelServer:F,channelClient:J,ctx:E};this.f.add(X),this.g.fire(X),this.j.add(se(()=>{F.dispose(),J.dispose(),this.f.delete(X),this.h.fire(X)}))}))}))}getChannel(M,x){const K=this;return{call(ie,se,C){let V;if((0,p.$tg)(x)){const E=(0,S.$3b)(K.connections.filter(x));V=E?Promise.resolve(E):w.Event.toPromise(w.Event.filter(K.onDidAddConnection,x))}else V=x.routeCall(K,ie,se);const q=V.then(E=>E.channelClient.getChannel(M));return j(q).call(ie,se,C)},listen(ie,se){if((0,p.$tg)(x))return K.k(M,x,ie,se);const C=x.routeEvent(K,ie,se).then(V=>V.channelClient.getChannel(M));return j(C).listen(ie,se)}}}k(M,x,K,ie){const se=this;let C;const V=new w.$me({onWillAddFirstListener:()=>{C=new a.$Uc;const q=new w.$se,E=new Map,F=X=>{const U=X.channelClient.getChannel(M).listen(K,ie),Q=q.add(U);E.set(X,Q)},J=X=>{const G=E.get(X);G&&(G.dispose(),E.delete(X))};se.connections.filter(x).forEach(F),w.Event.filter(se.onDidAddConnection,x)(F,void 0,C),se.onDidRemoveConnection(J,void 0,C),q.event(V.fire,V,C),C.add(q)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return V.event}registerChannel(M,x){this.a.set(M,x);for(const K of this.f)K.channelServer.registerChannel(M,x)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=A;class D{constructor(M,x,K=null){const ie=new c;o(ie,x),M.send(ie.buffer),this.a=new T(M,K),this.d=new g(M,x,K)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,x){this.d.registerChannel(M,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=D;function j(z){return{call(M,x,K){return z.then(ie=>ie.call(M,x,K))},listen(M,x){const K=new w.$ve;return z.then(ie=>K.input=ie.listen(M,x)),K.event}}}function H(z){let M=!1;return{call(x,K,ie){return M?z.call(x,K,ie):(0,P.$Hh)(0).then(()=>M=!0).then(()=>z.call(x,K,ie))},listen(x,K){if(M)return z.listen(x,K);const ie=new w.$ve;return(0,P.$Hh)(0).then(()=>M=!0).then(()=>ie.input=z.listen(x,K)),ie.event}}}class Y{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const x of M.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await w.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$oi=Y;var ne;(function(z){function M(se,C,V){const q=se,E=V&&V.disableMarshalling,F=new Map;for(const J in q)K(J)&&F.set(J,w.Event.buffer(q[J],!0,void 0,C));return new class{listen(J,X,G){const U=F.get(X);if(U)return U;const Q=q[X];if(typeof Q=="function"){if(ie(X))return Q.call(q,G);if(K(X))return F.set(X,w.Event.buffer(q[X],!0,void 0,C)),F.get(X)}throw new O.$bb(`Event not found: ${X}`)}call(J,X,G){const U=q[X];if(typeof U=="function"){if(!E&&Array.isArray(G))for(let re=0;re<G.length;re++)G[re]=(0,d.$di)(G[re]);let Q=U.apply(q,G);return Q instanceof Promise||(Q=Promise.resolve(Q)),Q}throw new O.$bb(`Method not found: ${X}`)}}}z.fromService=M;function x(se,C){const V=C&&C.disableMarshalling;return new Proxy({},{get(q,E){if(typeof E=="string")return C?.properties?.has(E)?C.properties.get(E):ie(E)?function(F){return se.listen(E,F)}:K(E)?se.listen(E):async function(...F){let J;C&&!(0,p.$og)(C.context)?J=[C.context,...F]:J=F;const X=await se.call(E,J);return V?X:(0,d.$di)(X)};throw new O.$bb(`Property not found: ${String(E)}`)}})}z.toService=x;function K(se){return se[0]==="o"&&se[1]==="n"&&u.$Ff(se.charCodeAt(2))}function ie(se){return/^onDynamic/.test(se)&&u.$Ff(se.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const M=z.toString();if(M!=="[object Object]")return M}return z}function me(z){return Array.isArray(z)?z.map(ue):ue(z)}function W(z,M,x,K,ie,se,C){C=me(C);const V=ae[ie],q=V[K%V.length];let E=[`%c[${z}]%c[${String(M).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(se)?(E=E.concat(C),E.push(")")):E.push(C),console.log.apply(console,E)}class _{constructor(M,x){this.d=M,this.f=x,this.a=0,this.b=0}logOutgoing(M,x,K,ie,se){this.b+=M,W(this.d,this.b,M,x,K,ie,se)}logIncoming(M,x,K,ie,se){this.a+=M,W(this.f,this.a,M,x,K,ie,se)}}e.$pi=_}),define(le[87],he([0,1,60,8,13,21,81,7,4,2,27,58,56,59]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0,O=be(O);class m extends f.$ii{constructor(h){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",$=>v.$Oe.wrap(Buffer.from($,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$ir=m;class I{constructor(h,$){this.i=h,this.j=$,this.c=new Set,this.g=new Map,this.h=new w.$me,this.onDidProcessExit=this.h.event;const R=$&&$.timeout?$.timeout:6e4;this.b=new P.$Dh(R),this.d=null,this.f=null}getChannel(h){const $=this;return{call(R,y,i){return $.k(h,R,y,i)},listen(R,y){return $.l(h,R,y)}}}k(h,$,R,y=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(O.$6());this.b.cancel();const i=this.n(h),c=(0,P.$th)(t=>i.call($,R,t)),n=y.onCancellationRequested(()=>c.cancel()),r=(0,a.$Tc)(()=>c.cancel());return this.c.add(r),c.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),c}l(h,$,R){if(!this.b)return w.Event.None;this.b.cancel();let y;const i=new w.$me({onWillAddFirstListener:()=>{y=this.n(h).listen($,R)(i.fire,i),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,d.$fo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,p.$nm)($.env),this.d=(0,S.fork)(this.i,h,$);const R=new w.$me,i=w.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,L.$er)(o)){(0,L.log)(o,`IPC Library: ${this.j.serverName}`);return}R.fire(v.$Oe.wrap(Buffer.from(o,"base64")))}),c=this.j.useQueue?(0,u.$Am)(this.d):this.d,n=o=>this.d&&this.d.connected&&c.send(o.buffer.toString("base64")),r=R.event,t={send:n,onMessage:r};this.f=new f.$ji(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",s),i.dispose(),this.c.forEach(g=>(0,a.$Qc)(g)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(h){let $=this.g.get(h);return $||($=this.m.getChannel(h),this.g.set(h,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$jr=I}),define(le[88],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=void 0,e.$0o=P;const S="Offline";function P(k){return k instanceof v?!0:k instanceof Error&&k.name===S&&k.message===S}class v extends Error{constructor(){super(S),this.name=this.message}}e.$$o=v}),define(le[89],he([0,1,8,4,2,48,3]),function(Z,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.StorageState=e.StorageHint=void 0,e.$eq=w;var O;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function w(p){const f=p;return f?.changed instanceof Map||f?.deleted instanceof Set}var a;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(a||(e.StorageState=a={}));class d extends v.$Vc{static{this.a=100}constructor(f,m=Object.create(null)){super(),this.r=f,this.s=m,this.b=this.B(new P.$pe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Eh(d.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((m,I)=>this.w(I,m)),f.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(f,m){if(this.c===a.Closed)return;let I=!1;(0,L.$og)(m)?I=this.f.delete(f):this.f.get(f)!==m&&(this.f.set(f,m),I=!0),I&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,m){const I=this.f.get(f);return(0,L.$og)(I)?m:I}getBoolean(f,m){const I=this.get(f);return(0,L.$og)(I)?m:I==="true"}getNumber(f,m){const I=this.get(f);return(0,L.$og)(I)?m:parseInt(I,10)}getObject(f,m){const I=this.get(f);return(0,L.$og)(I)?m:(0,k.$ci)(I)}async set(f,m,I=!1){if(this.c===a.Closed)return;if((0,L.$og)(m))return this.delete(f,I);const b=(0,L.$hg)(m)||Array.isArray(m)?(0,k.$bi)(m):String(m);if(this.f.get(f)!==b)return this.f.set(f,b),this.j.set(f,b),this.h.delete(f),this.b.fire({key:f,external:I}),this.D()}async delete(f,m=!1){if(!(this.c===a.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:m}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(!(this.c===a.Closed||this.m))return this.D(f)}async D(f){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$fq=d;class u{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((m,I)=>this.a.set(I,m)),f.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$gq=u}),define(le[90],he([0,1,5]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=a,e.$4m=d,e.$5m=u;const P=60,v=P*60,k=v*24,L=k*7,O=k*30,w=k*365;function a(p,f,m,I){typeof p!="number"&&(p=p.getTime());const b=Math.round((new Date().getTime()-p)/1e3);if(b<-30)return(0,S.localize)(40,null,a(new Date().getTime()+b*1e3,!1));if(!I&&b<30)return(0,S.localize)(41,null);let h;return b<P?(h=b,f?h===1?m?(0,S.localize)(42,null,h):(0,S.localize)(43,null,h):m?(0,S.localize)(44,null,h):(0,S.localize)(45,null,h):h===1?m?(0,S.localize)(46,null,h):(0,S.localize)(47,null,h):m?(0,S.localize)(48,null,h):(0,S.localize)(49,null,h)):b<v?(h=Math.floor(b/P),f?h===1?m?(0,S.localize)(50,null,h):(0,S.localize)(51,null,h):m?(0,S.localize)(52,null,h):(0,S.localize)(53,null,h):h===1?m?(0,S.localize)(54,null,h):(0,S.localize)(55,null,h):m?(0,S.localize)(56,null,h):(0,S.localize)(57,null,h)):b<k?(h=Math.floor(b/v),f?h===1?m?(0,S.localize)(58,null,h):(0,S.localize)(59,null,h):m?(0,S.localize)(60,null,h):(0,S.localize)(61,null,h):h===1?m?(0,S.localize)(62,null,h):(0,S.localize)(63,null,h):m?(0,S.localize)(64,null,h):(0,S.localize)(65,null,h)):b<L?(h=Math.floor(b/k),f?h===1?(0,S.localize)(66,null,h):(0,S.localize)(67,null,h):h===1?(0,S.localize)(68,null,h):(0,S.localize)(69,null,h)):b<O?(h=Math.floor(b/L),f?h===1?m?(0,S.localize)(70,null,h):(0,S.localize)(71,null,h):m?(0,S.localize)(72,null,h):(0,S.localize)(73,null,h):h===1?m?(0,S.localize)(74,null,h):(0,S.localize)(75,null,h):m?(0,S.localize)(76,null,h):(0,S.localize)(77,null,h)):b<w?(h=Math.floor(b/O),f?h===1?m?(0,S.localize)(78,null,h):(0,S.localize)(79,null,h):m?(0,S.localize)(80,null,h):(0,S.localize)(81,null,h):h===1?m?(0,S.localize)(82,null,h):(0,S.localize)(83,null,h):m?(0,S.localize)(84,null,h):(0,S.localize)(85,null,h)):(h=Math.floor(b/w),f?h===1?m?(0,S.localize)(86,null,h):(0,S.localize)(87,null,h):m?(0,S.localize)(88,null,h):(0,S.localize)(89,null,h):h===1?m?(0,S.localize)(90,null,h):(0,S.localize)(91,null,h):m?(0,S.localize)(92,null,h):(0,S.localize)(93,null,h))}function d(p,f){const m=Math.abs(p/1e3);return m<1?f?(0,S.localize)(94,null,p):(0,S.localize)(95,null,p):m<P?f?(0,S.localize)(96,null,Math.round(p)/1e3):(0,S.localize)(97,null,Math.round(p)/1e3):m<v?f?(0,S.localize)(98,null,Math.round(p/(1e3*P))):(0,S.localize)(99,null,Math.round(p/(1e3*P))):m<k?f?(0,S.localize)(100,null,Math.round(p/(1e3*v))):(0,S.localize)(101,null,Math.round(p/(1e3*v))):(0,S.localize)(102,null,Math.round(p/(1e3*k)))}function u(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[38],he([0,1,19,3,5]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=w,e.$sj=a,e.$tj=d,S=be(S),P=be(P),v=be(v);function k(u,p){return p&&(u.stack||u.stacktrace)?v.localize(103,null,O(u),L(u.stack)||L(u.stacktrace)):O(u)}function L(u){return Array.isArray(u)?u.join(`
`):u}function O(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?v.localize(104,null,u.message):u.message||v.localize(105,null)}function w(u=null,p=!1){if(!u)return v.localize(106,null);if(Array.isArray(u)){const f=S.$Hb(u),m=w(f[0],p);return f.length>1?v.localize(107,null,m,f.length):m}if(P.$fg(u))return u;if(u.detail){const f=u.detail;if(f.error)return k(f.error,p);if(f.exception)return k(f.exception,p)}return u.stack?k(u,p):u.message?u.message:v.localize(108,null)}function a(u){const p=u;return p instanceof Error&&Array.isArray(p.actions)}function d(u,p){let f;return typeof u=="string"?f=new Error(u):f=u,f.actions=p,f}}),define(le[91],he([0,1,5,34]),function(Z,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=v;function v(k){switch(k){case P.ParseErrorCode.InvalidSymbol:return(0,S.localize)(109,null);case P.ParseErrorCode.InvalidNumberFormat:return(0,S.localize)(110,null);case P.ParseErrorCode.PropertyNameExpected:return(0,S.localize)(111,null);case P.ParseErrorCode.ValueExpected:return(0,S.localize)(112,null);case P.ParseErrorCode.ColonExpected:return(0,S.localize)(113,null);case P.ParseErrorCode.CommaExpected:return(0,S.localize)(114,null);case P.ParseErrorCode.CloseBraceExpected:return(0,S.localize)(115,null);case P.ParseErrorCode.CloseBracketExpected:return(0,S.localize)(116,null);case P.ParseErrorCode.EndOfFileExpected:return(0,S.localize)(117,null);default:return""}}}),define(le[50],he([0,1,32,8,15,3,29,5]),function(Z,e,S,P,v,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0,e.zip=b,e.$Eq=h,e.$Fq=R,v=be(v),O=be(O),e.$Bq="end of central directory record signature not found";const w=new RegExp(e.$Bq);class a extends Error{constructor(i,c){let n=c.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=c}}e.$Cq=a;function d(y){const i=y.externalFileAttributes>>16||33188;return[448,56,7].map(c=>i&c).reduce((c,n)=>c+n,i&61440)}function u(y){if(y instanceof a)return y;let i;return w.test(y.message)&&(i="CorruptZip"),new a(i,y)}function p(y,i,c,n,r,t){const s=v.$nc(i),o=v.$kc(n,s);if(!o.startsWith(n))return Promise.reject(new Error(O.localize(138,null,i)));const l=v.$kc(n,i);let g;return t.onCancellationRequested(()=>{g?.destroy()}),Promise.resolve(S.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((N,T)=>{if(!t.isCancellationRequested)try{g=(0,S.createWriteStream)(l,{mode:c}),g.once("close",()=>N()),g.once("error",T),y.once("error",T),y.pipe(g)}catch(A){T(A)}}))}function f(y,i,c,n){let r=(0,P.$th)(()=>Promise.resolve()),t=0;const s=n.onCancellationRequested(()=>{r.cancel(),y.close()});return new Promise((o,l)=>{const g=new P.$Bh,N=T=>{T.isCancellationRequested||(t++,y.readEntry())};y.once("error",l),y.once("close",()=>r.then(()=>{n.isCancellationRequested||y.entryCount===t?o():l(new a("Incomplete",new Error(O.localize(139,null,t,y.entryCount))))},l)),y.readEntry(),y.on("entry",T=>{if(n.isCancellationRequested)return;if(!c.sourcePathRegex.test(T.fileName)){N(n);return}const A=T.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(A)){const H=v.$kc(i,A);r=(0,P.$th)(Y=>S.promises.mkdir(H,{recursive:!0}).then(()=>N(Y)).then(void 0,l));return}const D=I(y,T),j=d(T);r=(0,P.$th)(H=>g.queue(()=>D.then(Y=>p(Y,A,j,i,c,H).then(()=>N(H)))).then(null,l))})}).finally(()=>s.dispose())}async function m(y,i=!1){const{open:c}=await new Promise((n,r)=>{Z(["yauzl"],n,r)}).then(be);return new Promise((n,r)=>{c(y,i?{lazyEntries:!0}:void 0,(t,s)=>{t?r(u(t)):n((0,k.$qg)(s))})})}function I(y,i){return new Promise((c,n)=>{y.openReadStream(i,(r,t)=>{r?n(u(r)):c((0,k.$qg)(t))})})}async function b(y,i){const{ZipFile:c}=await new Promise((n,r)=>{Z(["yazl"],n,r)}).then(be);return new Promise((n,r)=>{const t=new c;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,S.createWriteStream)(y);t.outputStream.pipe(s),t.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(y))})}function h(y,i,c={},n){const r=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let t=m(y,!0);return c.overwrite&&(t=t.then(s=>L.Promises.rm(i).then(()=>s))),t.then(s=>f(s,i,{sourcePathRegex:r},n))}function $(y,i){return m(y).then(c=>new Promise((n,r)=>{c.on("entry",t=>{t.fileName===i&&I(c,t).then(s=>n(s),s=>r(s))}),c.once("close",()=>r(new Error(O.localize(140,null,i))))}))}function R(y,i){return $(y,i).then(c=>new Promise((n,r)=>{const t=[];c.once("error",r),c.on("data",s=>t.push(s)),c.on("end",()=>n(Buffer.concat(t)))}))}}),define(le[92],he([0,1,93,7,5]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var k;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(k||(e.TokenType=k={}));function L(...d){switch(d.length){case 1:return(0,v.localize)(1684,null,d[0]);case 2:return(0,v.localize)(1685,null,d[0],d[1]);case 3:return(0,v.localize)(1686,null,d[0],d[1],d[2]);default:return}}const O=(0,v.localize)(1687,null),w=(0,v.localize)(1688,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return u.isTripleEq?"===":"==";case k.NotEq:return u.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return u.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return u.lexeme;case k.QuotedStr:return u.lexeme;case k.Error:return u.lexeme;case k.EOF:return"EOF";default:throw(0,P.$8)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case S.CharCode.OpenParen:this.k(k.LParen);break;case S.CharCode.CloseParen:this.k(k.RParen);break;case S.CharCode.ExclamationMark:if(this.h(S.CharCode.Equals)){const p=this.h(S.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:p})}else this.k(k.Neg);break;case S.CharCode.SingleQuote:this.o();break;case S.CharCode.Slash:this.q();break;case S.CharCode.Equals:if(this.h(S.CharCode.Equals)){const p=this.h(S.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:p})}else this.h(S.CharCode.Tilde)?this.k(k.RegexOp):this.l(L("==","=~"));break;case S.CharCode.LessThan:this.k(this.h(S.CharCode.Equals)?k.LtEq:k.Lt);break;case S.CharCode.GreaterThan:this.k(this.h(S.CharCode.Equals)?k.GtEq:k.Gt);break;case S.CharCode.Ampersand:this.h(S.CharCode.Ampersand)?this.k(k.And):this.l(L("&&"));break;case S.CharCode.Pipe:this.h(S.CharCode.Pipe)?this.k(k.Or):this.l(L("||"));break;case S.CharCode.Space:case S.CharCode.CarriageReturn:case S.CharCode.Tab:case S.CharCode.LineFeed:case S.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?S.CharCode.Null:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const p=this.d,f=this.c.substring(this.d,this.e),m={type:k.Error,offset:this.d,lexeme:f};this.g.push({offset:p,lexeme:f,additionalInfo:u}),this.f.push(m)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const p=this.c.substring(this.d,this.e),f=a.b.get(p);f?this.k(f):this.f.push({type:k.Str,lexeme:p,offset:this.d})}}o(){for(;this.j()!==S.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,p=!1,f=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(w);return}const I=this.c.charCodeAt(u);if(p)p=!1;else if(I===S.CharCode.Slash&&!f){u++;break}else I===S.CharCode.OpenSquareBracket?f=!0:I===S.CharCode.Backslash?p=!0:I===S.CharCode.CloseSquareBracket&&(f=!1);u++}for(;u<this.c.length&&a.a.has(this.c.charCodeAt(u));)u++;this.e=u;const m=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=a}),define(le[94],he([0,1,90,55,14,15,36,16,11]),function(Z,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=void 0,e.$8m=d,e.$9m=u,e.$6m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,k.$nc)(v.$1g.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,k.$kc)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,O.$hh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$hh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,S.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$kc)(this.userDataPath,"logs",f)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$hh)(w.URI.file((0,k.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$hh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$hh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$hh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=L.env.VSCODE_PORTABLE;return f?w.URI.file((0,k.$kc)(f,"argv.json")):(0,O.$hh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,k.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,k.$lc)(f):(0,k.$ic)((0,k.$kc)(v.$1g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?w.URI.file((0,k.$lc)(f)):w.URI.file((0,k.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,k.$lc)(f);const m=L.env.VSCODE_EXTENSIONS;if(m)return m;const I=L.env.VSCODE_PORTABLE;return I?(0,k.$kc)(I,"extensions"):(0,O.$hh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(m=>/^[^:/?#]+?:\/\//.test(m)?w.URI.parse(m):w.URI.file((0,k.$ic)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?w.URI.parse(f):w.URI.file((0,k.$ic)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return d(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$6m.test(f))}get extensionLogLevel(){const f=[];for(const m of this.args.log||[]){const I=e.$6m.exec(m);I&&I[1]&&I[2]&&f.push([I[1],I[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,O.$hh)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=L.env.VSCODE_PORTABLE;return f?w.URI.file((0,k.$kc)(f,"policy.json")):(0,O.$hh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,m,I){this.a=f,this.b=m,this.c=I,this.editSessionId=this.args.editSessionId}}e.$7m=a,Ee([P.$$h],a.prototype,"appRoot",null),Ee([P.$$h],a.prototype,"userHome",null),Ee([P.$$h],a.prototype,"userDataPath",null),Ee([P.$$h],a.prototype,"appSettingsHome",null),Ee([P.$$h],a.prototype,"tmpDir",null),Ee([P.$$h],a.prototype,"cacheHome",null),Ee([P.$$h],a.prototype,"stateResource",null),Ee([P.$$h],a.prototype,"userRoamingDataHome",null),Ee([P.$$h],a.prototype,"userDataSyncHome",null),Ee([P.$$h],a.prototype,"sync",null),Ee([P.$$h],a.prototype,"machineSettingsResource",null),Ee([P.$$h],a.prototype,"workspaceStorageHome",null),Ee([P.$$h],a.prototype,"localHistoryHome",null),Ee([P.$$h],a.prototype,"keyboardLayoutResource",null),Ee([P.$$h],a.prototype,"argvResource",null),Ee([P.$$h],a.prototype,"isExtensionDevelopment",null),Ee([P.$$h],a.prototype,"untitledWorkspacesHome",null),Ee([P.$$h],a.prototype,"builtinExtensionsPath",null),Ee([P.$$h],a.prototype,"extensionsPath",null),Ee([P.$$h],a.prototype,"extensionDevelopmentLocationURI",null),Ee([P.$$h],a.prototype,"extensionDevelopmentKind",null),Ee([P.$$h],a.prototype,"extensionTestsLocationURI",null),Ee([P.$$h],a.prototype,"debugExtensionHost",null),Ee([P.$$h],a.prototype,"logLevel",null),Ee([P.$$h],a.prototype,"extensionLogLevel",null),Ee([P.$$h],a.prototype,"serviceMachineIdResource",null),Ee([P.$$h],a.prototype,"disableTelemetry",null),Ee([P.$$h],a.prototype,"disableWorkspaceTrust",null),Ee([P.$$h],a.prototype,"useInMemorySecretStorage",null),Ee([P.$$h],a.prototype,"policyFile",null);function d(p,f){return u(p["inspect-extensions"],p["inspect-brk-extensions"],5870,f,p.debugId,p.extensionEnvironment)}function u(p,f,m,I,b,h){const R=Number(f||p)||(I?null:m),y=R?!!f:!1;let i;if(h)try{i=JSON.parse(h)}catch{}return{port:R,break:y,debugId:b,env:i}}}),function(){function Z(e,S,P){function v(L,O){const w=k(L,O),a=[w];return e.isAbsolute(w)||a.unshift(P),e.resolve(...a)}function k(L,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,O);const d=L["user-data-dir"];if(d)return d;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(u,"AppData","Roaming")}break;case"darwin":a=e.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,O)}return{getUserDataPath:v}}if(typeof define=="function")define(le[95],he([149,35,36]),function(e,S,P){return Z(e,S,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=Z(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[96],he([0,1,35,94,95]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0,e.$$m=L,e.$_m=O;class k extends P.$7m{constructor(a,d){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,v.getUserDataPath)(a,d.nameShort)},d)}}e.$0m=k;function L(w,a){return(0,P.$9m)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,a,w.extensionEnvironment)}function O(w,a){return(0,P.$9m)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,a,w.extensionEnvironment)}}),define(le[97],he([0,1,3,5]),function(Z,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=v;function v(L,O,w,a){try{k(L,O,w,a)}catch(d){L.error(d?.message??d)}return O}function k(L,O,w,a){const d=(u,p,f)=>{const m=u[p];if((0,S.$fg)(m)){const I=m,b=I.length;if(b>1&&I[0]==="%"&&I[b-1]==="%"){const h=I.substr(1,b-2);let $=w[h];$===void 0&&a&&($=a[h]);const R=typeof $=="string"?$:$?.message,y=a?.[h],i=typeof y=="string"?y:y?.message;if(!R){i||L.warn(`[${O.name}]: ${(0,P.localize)(1805,null,h)}`);return}if(f&&(p==="title"||p==="category")&&i&&i!==R){const c={value:R,original:i};u[p]=c}else u[p]=R}}else if((0,S.$hg)(m))for(const I in m)m.hasOwnProperty(I)&&(I==="commands"?d(m,I,!0):d(m,I,f));else if(Array.isArray(m))for(let I=0;I<m.length;I++)d(m,I,f)};for(const u in O)O.hasOwnProperty(u)&&d(O,u)}}),define(le[98],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const S={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(S)}),define(le[51],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class S{constructor(v,k=[],L=!1){this.ctor=v,this.staticArguments=k,this.supportsDelayedInstantiation=L}}e.$Di=S}),define(le[99],he([0,1,51]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ss=k,e.$Ts=L;const P=[];var v;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(v||(e.InstantiationType=v={}));function k(O,w,a){w instanceof S.$Di||(w=new S.$Di(w,[],!!a)),P.push([O,w])}function L(){return P}}),define(le[100],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;class S{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$vr=S;class P{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const L of this.a.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const O=this.lookupOrInsertNode(k),w=this.lookupOrInsertNode(L);O.outgoing.set(w.key,w),w.incoming.set(O.key,O)}removeNode(k){const L=this.b(k);this.a.delete(L);for(const O of this.a.values())O.outgoing.delete(L),O.incoming.delete(L)}lookupOrInsertNode(k){const L=this.b(k);let O=this.a.get(L);return O||(O=new S(L,k),this.a.set(L,O)),O}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[L,O]of this.a)k.push(`${L}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this.a){const O=new Set([k]),w=this.c(L,O);if(w)return w}}c(k,L){for(const[O,w]of k.outgoing){if(L.has(O))return[...L,O].join(" -> ");L.add(O);const a=this.c(w,L);if(a)return a;L.delete(O)}}}e.$wr=P}),define(le[30],he([0,1,3,11,10]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=k,e.$cj=L,e.$dj=w,e.$ej=a,e.$fj=d,e.$gj=u,e.$hj=p,e.$ij=m,e.$jj=I,e.$kj=b,S=be(S),e.$aj=(0,v.$Gi)("configurationService");function k(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof P.URI)}function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof P.URI)}var O;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function w(h){switch(h){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function a(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function d(h,$){const R=Object.create(null);for(const y in h)u(R,y,h[y],$);return R}function u(h,$,R,y){const i=$.split("."),c=i.pop();let n=h;for(let r=0;r<i.length;r++){const t=i[r];let s=n[t];switch(typeof s){case"undefined":s=n[t]=Object.create(null);break;case"object":if(s===null){y(`Ignoring ${$} as ${i.slice(0,r+1).join(".")} is null`);return}break;default:y(`Ignoring ${$} as ${i.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[c]=R}catch{y(`Ignoring ${$} as ${i.join(".")} is ${JSON.stringify(n)}`)}else y(`Ignoring ${$} as ${i.join(".")} is ${JSON.stringify(n)}`)}function p(h,$){const R=$.split(".");f(h,R)}function f(h,$){const R=$.shift();if($.length===0){delete h[R];return}if(Object.keys(h).indexOf(R)!==-1){const y=h[R];typeof y=="object"&&!Array.isArray(y)&&(f(y,$),Object.keys(y).length===0&&delete h[R])}}function m(h,$,R){function y(n,r){let t=n;for(const s of r){if(typeof t!="object"||t===null)return;t=t[s]}return t}const i=$.split("."),c=y(h,i);return typeof c>"u"?R:c}function I(h,$,R){Object.keys($).forEach(y=>{y!=="__proto__"&&(y in h?S.$hg(h[y])&&S.$hg($[y])?I(h[y],$[y],R):R&&(h[y]=$[y]):h[y]=$[y])})}function b(h){return h.replace(/[\[\]]/g,"")}}),define(le[101],he([0,1,93,12,31,92,10,5,7]),function(Z,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=d,e.$Fj=r,e.$Gj=t,e.$Zj=se;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",P.$k),a.set("isLinux",P.$l),a.set("isWindows",P.$j),a.set("isWeb",P.$p),a.set("isMacNative",P.$k&&!P.$p),a.set("isEdge",P.$I),a.set("isFirefox",P.$G),a.set("isChrome",P.$F),a.set("isSafari",P.$H);function d(q,E){if(a.get(q)!==void 0)throw(0,w.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(q,E)}const u=Object.prototype.hasOwnProperty;var p;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const f={regexParsingWithErrorRecovery:!0},m=(0,O.localize)(1664,null),I=(0,O.localize)(1665,null),b=(0,O.localize)(1666,null),h=(0,O.localize)(1667,null),$=(0,O.localize)(1668,null),R=(0,O.localize)(1669,null),y=(0,O.localize)(1670,null),i=(0,O.localize)(1671,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(E=f){this.k=E,this.d=new k.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(E){if(E===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:I});return}this.f=this.d.reset(E).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const J=this.D(),X=J.type===k.TokenType.Str?R:void 0;throw this.h.push({message:$,offset:J.offset,lexeme:k.$Bj.getLexeme(J),additionalInfo:X}),c.c}return F}catch(F){if(F!==c.c)throw F;return}}l(){return this.m()}m(){const E=[this.o()];for(;this.y(k.TokenType.Or);){const F=this.o();E.push(F)}return E.length===1?E[0]:n.or(...E)}o(){const E=[this.s()];for(;this.y(k.TokenType.And);){const F=this.s();E.push(F)}return E.length===1?E[0]:n.and(...E)}s(){if(this.y(k.TokenType.Neg)){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),o.INSTANCE;case k.TokenType.False:return this.z(),l.INSTANCE;case k.TokenType.LParen:{this.z();const F=this.l();return this.A(k.TokenType.RParen,h),F?.negate()}case k.TokenType.Str:return this.z(),j.create(E.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",E)}}return this.t()}t(){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),n.true();case k.TokenType.False:return this.z(),n.false();case k.TokenType.LParen:{this.z();const F=this.l();return this.A(k.TokenType.RParen,h),F}case k.TokenType.Str:{const F=E.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const X=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),X.type!==k.TokenType.RegexStr)throw this.B("REGEX",X);const G=X.lexeme,U=G.lastIndexOf("/"),Q=U===G.length-1?void 0:this.w(G.substring(U+1));let re;try{re=new RegExp(G.substring(1,U),Q)}catch{throw this.B("REGEX",X)}return me.create(F,re)}switch(X.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const G=[X.lexeme];this.z();let U=this.D(),Q=0;for(let de=0;de<X.lexeme.length;de++)X.lexeme.charCodeAt(de)===S.CharCode.OpenParen?Q++:X.lexeme.charCodeAt(de)===S.CharCode.CloseParen&&Q--;for(;!this.E()&&U.type!==k.TokenType.And&&U.type!==k.TokenType.Or;){switch(U.type){case k.TokenType.LParen:Q++;break;case k.TokenType.RParen:Q--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let de=0;de<U.lexeme.length;de++)U.lexeme.charCodeAt(de)===S.CharCode.OpenParen?Q++:X.lexeme.charCodeAt(de)===S.CharCode.CloseParen&&Q--}if(Q<0)break;G.push(k.$Bj.getLexeme(U)),this.z(),U=this.D()}const re=G.join(""),ce=re.lastIndexOf("/"),fe=ce===re.length-1?void 0:this.w(re.substring(ce+1));let we;try{we=new RegExp(re.substring(1,ce),fe)}catch{throw this.B("REGEX",X)}return n.regex(F,we)}case k.TokenType.QuotedStr:{const G=X.lexeme;this.z();let U=null;if(!(0,v.$df)(G)){const Q=G.indexOf("/"),re=G.lastIndexOf("/");if(Q!==re&&Q>=0){const ce=G.slice(Q+1,re),fe=G[re+1]==="i"?"i":"";try{U=new RegExp(ce,fe)}catch{throw this.B("REGEX",X)}}}if(U===null)throw this.B("REGEX",X);return me.create(F,U)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,b);const X=this.u();return n.notIn(F,X)}switch(this.D().type){case k.TokenType.Eq:{this.z();const X=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.equals(F,X);switch(X){case"true":return n.has(F);case"false":return n.not(F);default:return n.equals(F,X)}}case k.TokenType.NotEq:{this.z();const X=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.notEquals(F,X);switch(X){case"true":return n.not(F);case"false":return n.has(F);default:return n.notEquals(F,X)}}case k.TokenType.Lt:return this.z(),ae.create(F,this.u());case k.TokenType.LtEq:return this.z(),ue.create(F,this.u());case k.TokenType.Gt:return this.z(),Y.create(F,this.u());case k.TokenType.GtEq:return this.z(),ne.create(F,this.u());case k.TokenType.In:return this.z(),n.in(F,this.u());default:return n.has(F)}}case k.TokenType.EOF:throw this.h.push({message:y,offset:E.offset,lexeme:"",additionalInfo:i}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const E=this.D();switch(E.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),E.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(E){return E.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(E){return this.C(E)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(E,F){if(this.C(E))return this.z();throw this.B(F,this.D())}B(E,F,J){const X=(0,O.localize)(1672,null,E,k.$Bj.getLexeme(F)),G=F.offset,U=k.$Bj.getLexeme(F);return this.h.push({message:X,offset:G,lexeme:U,additionalInfo:J}),c.c}C(E){return this.D().type===E}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Dj=c;class n{static false(){return o.INSTANCE}static true(){return l.INSTANCE}static has(E){return g.create(E)}static equals(E,F){return N.create(E,F)}static notEquals(E,F){return D.create(E,F)}static regex(E,F){return me.create(E,F)}static in(E,F){return T.create(E,F)}static notIn(E,F){return A.create(E,F)}static not(E){return j.create(E)}static and(...E){return z.create(E,null,!0)}static or(...E){return M.create(E,null,!0)}static greater(E,F){return Y.create(E,F)}static greaterEquals(E,F){return ne.create(E,F)}static smaller(E,F){return ae.create(E,F)}static smallerEquals(E,F){return ue.create(E,F)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(E){return E==null?void 0:this.c.parse(E)}}e.$Ej=n;function r(q){const E=new c({regexParsingWithErrorRecovery:!1});return q.map(F=>(E.parse(F),E.lexingErrors.length>0?E.lexingErrors.map(J=>({errorMessage:J.additionalInfo?(0,O.localize)(1673,null,J.additionalInfo):(0,O.localize)(1674,null),offset:J.offset,length:J.lexeme.length})):E.parsingErrors.length>0?E.parsingErrors.map(J=>({errorMessage:J.additionalInfo?`${J.message}. ${J.additionalInfo}`:J.message,offset:J.offset,length:J.lexeme.length})):[]))}function t(q,E){const F=q?q.substituteConstants():void 0,J=E?E.substituteConstants():void 0;return!F&&!J?!0:!F||!J?!1:F.equals(J)}function s(q,E){return q.cmp(E)}class o{static{this.INSTANCE=new o}constructor(){this.type=p.False}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return l.INSTANCE}}e.$Hj=o;class l{static{this.INSTANCE=new l}constructor(){this.type=p.True}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return o.INSTANCE}}e.$Ij=l;class g{static create(E,F=null){const J=a.get(E);return typeof J=="boolean"?J?l.INSTANCE:o.INSTANCE:new g(E,F)}constructor(E,F){this.key=E,this.c=F,this.type=p.Defined}cmp(E){return E.type!==this.type?this.type-E.type:K(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=a.get(this.key);return typeof E=="boolean"?E?l.INSTANCE:o.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Jj=g;class N{static create(E,F,J=null){if(typeof F=="boolean")return F?g.create(E,J):j.create(E,J);const X=a.get(E);return typeof X=="boolean"?F===(X?"true":"false")?l.INSTANCE:o.INSTANCE:new N(E,F,J)}constructor(E,F,J){this.c=E,this.d=F,this.f=J,this.type=p.Equals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=a.get(this.c);if(typeof E=="boolean"){const F=E?"true":"false";return this.d===F?l.INSTANCE:o.INSTANCE}return this}evaluate(E){return E.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(E){return E.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Kj=N;class T{static create(E,F){return new T(E,F)}constructor(E,F){this.d=E,this.f=F,this.type=p.In,this.c=null}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.d,this.f,E.d,E.f)}equals(E){return E.type===this.type?this.d===E.d&&this.f===E.f:!1}substituteConstants(){return this}evaluate(E){const F=E.getValue(this.f),J=E.getValue(this.d);return Array.isArray(F)?F.includes(J):typeof J=="string"&&typeof F=="object"&&F!==null?u.call(F,J):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(E){return E.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Lj=T;class A{static create(E,F){return new A(E,F)}constructor(E,F){this.d=E,this.f=F,this.type=p.NotIn,this.c=T.create(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(E){return E.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=A;class D{static create(E,F,J=null){if(typeof F=="boolean")return F?j.create(E,J):g.create(E,J);const X=a.get(E);return typeof X=="boolean"?F===(X?"true":"false")?o.INSTANCE:l.INSTANCE:new D(E,F,J)}constructor(E,F,J){this.c=E,this.d=F,this.f=J,this.type=p.NotEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=a.get(this.c);if(typeof E=="boolean"){const F=E?"true":"false";return this.d===F?o.INSTANCE:l.INSTANCE}return this}evaluate(E){return E.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(E){return E.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Nj=D;class j{static create(E,F=null){const J=a.get(E);return typeof J=="boolean"?J?o.INSTANCE:l.INSTANCE:new j(E,F)}constructor(E,F){this.c=E,this.d=F,this.type=p.Not}cmp(E){return E.type!==this.type?this.type-E.type:K(this.c,E.c)}equals(E){return E.type===this.type?this.c===E.c:!1}substituteConstants(){const E=a.get(this.c);return typeof E=="boolean"?E?o.INSTANCE:l.INSTANCE:this}evaluate(E){return!E.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(E){return E.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$Oj=j;function H(q,E){if(typeof q=="string"){const F=parseFloat(q);isNaN(F)||(q=F)}return typeof q=="string"||typeof q=="number"?E(q):o.INSTANCE}class Y{static create(E,F,J=null){return H(F,X=>new Y(E,X,J))}constructor(E,F,J){this.c=E,this.d=F,this.f=J,this.type=p.Greater}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Pj=Y;class ne{static create(E,F,J=null){return H(F,X=>new ne(E,X,J))}constructor(E,F,J){this.c=E,this.d=F,this.f=J,this.type=p.GreaterEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Qj=ne;class ae{static create(E,F,J=null){return H(F,X=>new ae(E,X,J))}constructor(E,F,J){this.c=E,this.d=F,this.f=J,this.type=p.Smaller}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Rj=ae;class ue{static create(E,F,J=null){return H(F,X=>new ue(E,X,J))}constructor(E,F,J){this.c=E,this.d=F,this.f=J,this.type=p.SmallerEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Sj=ue;class me{static create(E,F){return new me(E,F)}constructor(E,F){this.d=E,this.f=F,this.type=p.Regex,this.c=null}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.d<E.d)return-1;if(this.d>E.d)return 1;const F=this.f?this.f.source:"",J=E.f?E.f.source:"";return F<J?-1:F>J?1:0}equals(E){if(E.type===this.type){const F=this.f?this.f.source:"",J=E.f?E.f.source:"";return this.d===E.d&&F===J}return!1}substituteConstants(){return this}evaluate(E){const F=E.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const E=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${E}`}keys(){return[this.d]}map(E){return E.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$Tj=me;class W{static create(E){return new W(E)}constructor(E){this.c=E,this.type=p.NotRegex}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(E){return new W(this.c.map(E))}negate(){return this.c}}e.$Uj=W;function _(q){let E=null;for(let F=0,J=q.length;F<J;F++){const X=q[F].substituteConstants();if(q[F]!==X&&E===null){E=[];for(let G=0;G<F;G++)E[G]=q[G]}E!==null&&(E[F]=X)}return E===null?q:E}class z{static create(E,F,J){return z.d(E,F,J)}constructor(E,F){this.expr=E,this.c=F,this.type=p.And}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,J=this.expr.length;F<J;F++){const X=s(this.expr[F],E.expr[F]);if(X!==0)return X}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,J=this.expr.length;F<J;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}substituteConstants(){const E=_(this.expr);return E===this.expr?this:z.create(E,this.c,!1)}evaluate(E){for(let F=0,J=this.expr.length;F<J;F++)if(!this.expr[F].evaluate(E))return!1;return!0}static d(E,F,J){const X=[];let G=!1;for(const U of E)if(U){if(U.type===p.True){G=!0;continue}if(U.type===p.False)return o.INSTANCE;if(U.type===p.And){X.push(...U.expr);continue}X.push(U)}if(X.length===0&&G)return l.INSTANCE;if(X.length!==0){if(X.length===1)return X[0];X.sort(s);for(let U=1;U<X.length;U++)X[U-1].equals(X[U])&&(X.splice(U,1),U--);if(X.length===1)return X[0];for(;X.length>1;){const U=X[X.length-1];if(U.type!==p.Or)break;X.pop();const Q=X.pop(),re=X.length===0,ce=M.create(U.expr.map(fe=>z.create([fe,Q],null,J)),null,re);ce&&(X.push(ce),X.sort(s))}if(X.length===1)return X[0];if(J){for(let U=0;U<X.length;U++)for(let Q=U+1;Q<X.length;Q++)if(X[U].negate().equals(X[Q]))return o.INSTANCE;if(X.length===1)return X[0]}return new z(X,F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(const F of this.expr)E.push(...F.keys());return E}map(E){return new z(this.expr.map(F=>F.map(E)),null)}negate(){if(!this.c){const E=[];for(const F of this.expr)E.push(F.negate());this.c=M.create(E,this,!0)}return this.c}}e.$Vj=z;class M{static create(E,F,J){return M.d(E,F,J)}constructor(E,F){this.expr=E,this.c=F,this.type=p.Or}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,J=this.expr.length;F<J;F++){const X=s(this.expr[F],E.expr[F]);if(X!==0)return X}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,J=this.expr.length;F<J;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}substituteConstants(){const E=_(this.expr);return E===this.expr?this:M.create(E,this.c,!1)}evaluate(E){for(let F=0,J=this.expr.length;F<J;F++)if(this.expr[F].evaluate(E))return!0;return!1}static d(E,F,J){let X=[],G=!1;if(E){for(let U=0,Q=E.length;U<Q;U++){const re=E[U];if(re){if(re.type===p.False){G=!0;continue}if(re.type===p.True)return l.INSTANCE;if(re.type===p.Or){X=X.concat(re.expr);continue}X.push(re)}}if(X.length===0&&G)return o.INSTANCE;X.sort(s)}if(X.length!==0){if(X.length===1)return X[0];for(let U=1;U<X.length;U++)X[U-1].equals(X[U])&&(X.splice(U,1),U--);if(X.length===1)return X[0];if(J){for(let U=0;U<X.length;U++)for(let Q=U+1;Q<X.length;Q++)if(X[U].negate().equals(X[Q]))return l.INSTANCE;if(X.length===1)return X[0]}return new M(X,F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(const F of this.expr)E.push(...F.keys());return E}map(E){return new M(this.expr.map(F=>F.map(E)),null)}negate(){if(!this.c){const E=[];for(const F of this.expr)E.push(F.negate());for(;E.length>1;){const F=E.shift(),J=E.shift(),X=[];for(const G of V(F))for(const U of V(J))X.push(z.create([G,U],null,!1));E.unshift(M.create(X,null,!1))}this.c=M.create(E,this,!0)}return this.c}}e.$Wj=M;class x extends g{static{this.d=[]}static all(){return x.d.values()}constructor(E,F,J){super(E,null),this.f=F,typeof J=="object"?x.d.push({...J,key:E}):J!==!0&&x.d.push({key:E,description:J,type:F!=null?typeof F:void 0})}bindTo(E){return E.createKey(this.key,this.f)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return N.create(this.key,E)}notEqualsTo(E){return D.create(this.key,E)}}e.$Xj=x,e.$Yj=(0,L.$Gi)("contextKeyService");function K(q,E){return q<E?-1:q>E?1:0}function ie(q,E,F,J){return q<F?-1:q>F?1:E<J?-1:E>J?1:0}function se(q,E){if(q.type===p.False||E.type===p.True)return!0;if(q.type===p.Or)return E.type===p.Or?C(q.expr,E.expr):!1;if(E.type===p.Or){for(const F of E.expr)if(se(q,F))return!0;return!1}if(q.type===p.And){if(E.type===p.And)return C(E.expr,q.expr);for(const F of q.expr)if(se(F,E))return!0;return!1}return q.equals(E)}function C(q,E){let F=0,J=0;for(;F<q.length&&J<E.length;){const X=q[F].cmp(E[J]);if(X<0)return!1;X===0&&F++,J++}return F===q.length}function V(q){return q.type===p.Or?q.expr:[q]}}),define(le[61],he([0,1,10]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0,e.$3o=(0,S.$Gi)("downloadService")}),define(le[17],he([0,1,10]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,S.$Gi)("environmentService"),e.$Oi=(0,S.$Hi)(e.$Ni)}),define(le[62],he([0,1,13,7,5,9]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=L;async function L(d,u,p,f,m,I){let b;try{await O(d,u,p,f,m,I)}catch(h){b=h}finally{b&&m.errorTransformer&&(b=m.errorTransformer(b)),typeof b<"u"&&p.error(b),p.end()}}async function O(d,u,p,f,m,I){w(I);const b=await d.open(u,{create:!1});try{w(I);let h=0,$=0,R=m&&typeof m.length=="number"?m.length:void 0,y=S.$Oe.alloc(Math.min(m.bufferSize,typeof R=="number"?R:m.bufferSize)),i=m&&typeof m.position=="number"?m.position:0,c=0;do $=await d.read(b,i,y.buffer,c,y.byteLength-c),i+=$,c+=$,h+=$,typeof R=="number"&&(R-=$),c===y.byteLength&&(await p.write(f(y)),y=S.$Oe.alloc(Math.min(m.bufferSize,typeof R=="number"?R:m.bufferSize)),c=0);while($>0&&(typeof R!="number"||R>0)&&w(I)&&a(h,m));if(c>0){let n=c;typeof R=="number"&&(n=Math.min(c,R)),p.write(f(y.slice(0,n)))}}catch(h){throw(0,k.$pl)(h)}finally{await d.close(b)}}function w(d){if(d.isCancellationRequested)throw(0,P.$6)();return!0}function a(d,u){if(typeof u?.limits?.size=="number"&&d>u.limits.size)throw(0,k.$ol)((0,v.localize)(1889,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[102],he([0,1,32,2,52,4,9,11,8]),function(Z,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class a extends P.$Vc{constructor(){super(),this.a=this.B(new k.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new P.$5c),this.m=new Set,this.n=this.B(new w.$Eh(this.y())),this.r=5007,this.s=new w.$4h,this.R=!1,this.B(this.f(u=>this.t(u)))}t(u){this.u(u)&&this.z(u)}u(u){return(0,v.$5q)(u)}async watch(u){this.s.isSettled||this.s.complete(),this.s=new w.$4h;try{this.h.clear(),this.g.clear();for(const p of u)this.u(p)?this.h.set(p.correlationId,p):this.g.add(p);for(const[p]of this.j)this.h.has(p)||(this.j.deleteAndDispose(p),this.m.delete(p));return await this.w(!1)}finally{this.s.complete()}}w(u){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(p=>!this.j.has(p.correlationId))]),u?this.y():0)}y(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async z(u){if(this.j.has(u.correlationId))return;const p=new P.$Uc;this.j.set(u.correlationId,p),await this.s.p,!p.isDisposed&&(this.D(u,p),this.w(!0))}C(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.w(!1)}D(u,p){this.F(u,p)?(this.P(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.G(u,p),this.m.add(u.correlationId))}F(u,p){const f=this.O?.subscribe(u.path,(m,I)=>{p.isDisposed||(m?this.D(u,p):I?.type===L.FileChangeType.ADDED&&this.H(u))});return f?(p.add(f),!0):!1}G(u,p){let f=!1;const m=(I,b)=>{if(p.isDisposed)return;const h=this.I(I),$=this.I(b),R=f;f=h,!h&&($||R)&&this.H(u)};this.P(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,S.watchFile)(u.path,{persistent:!1,interval:this.r},m)}catch(I){this.Q(`fs.watchFile() failed with error ${I} on path ${u.path} (correlationId: ${u.correlationId})`)}p.add((0,P.$Tc)(()=>{this.P(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,S.unwatchFile)(u.path,m)}catch(I){this.Q(`fs.unwatchFile() failed with error ${I} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}H(u){this.P(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const p={resource:O.URI.file(u.path),type:L.FileChangeType.ADDED,cId:u.correlationId};this.a.fire([p]),this.J(p,u),this.C(u)}I(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(u,p){if(this.R){const f=` >> normalized ${u.type===L.FileChangeType.ADDED?"[ADDED]":u.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.L(f,p)}}L(u,p){this.R&&this.P(`${u}${typeof p.correlationId=="number"?` <${p.correlationId}> `:""}`)}M(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,v.$cr)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.R=u}}e.$lr=a}),define(le[103],he([0,1,4,150,102,12,151,63]),function(Z,e,S,P,v,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class w extends v.$lr{constructor(d){super(),this.O=d,this.onDidError=S.Event.None,this.watchers=new Set}async N(d){d=this.Z(d);const u=[],p=new Set(Array.from(this.watchers));for(const f of d){const m=this.W(f);m&&(0,P.$Fk)(m.request.excludes,f.excludes)&&(0,P.$Fk)(m.request.includes,f.includes)?p.delete(m):u.push(f)}u.length&&this.P(`Request to start watching: ${u.map(f=>this.M(f)).join(",")}`),p.size&&this.P(`Request to stop watching: ${Array.from(p).map(f=>this.M(f.request)).join(",")}`);for(const f of p)this.Y(f);for(const f of u)this.X(f)}W(d){for(const u of this.watchers)if(typeof d.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===d.correlationId)return u}else if((0,O.$Eg)(u.request.path,d.path,!k.$l))return u}X(d){const u=new L.$qr(d,this.O,f=>this.a.fire(f),()=>this.c.fire(d),f=>this.b.fire(f),this.R),p={request:d,instance:u};this.watchers.add(p)}async stop(){await super.stop();for(const d of this.watchers)this.Y(d)}Y(d){this.P("stopping file watcher",d),this.watchers.delete(d),d.instance.dispose()}Z(d){const u=new Map;for(const p of d){const f=k.$l?p.path:p.path.toLowerCase();let m=u.get(p.correlationId);m||(m=new Map,u.set(p.correlationId,m)),m.has(f)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(p)}`),m.set(f,p)}return Array.from(u.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(d){super.setVerboseLogging(d);for(const u of this.watchers)u.instance.setVerboseLogging(d)}P(d,u){this.R&&this.b.fire({type:"trace",message:this.bb(d,u)})}Q(d){this.b.fire({type:"warn",message:this.bb(d)})}bb(d,u){return u?`[File Watcher (node.js)] ${d} (${this.M(u.request)})`:`[File Watcher (node.js)] ${d}`}}e.$sr=w}),define(le[104],he([0,1,52,103]),function(Z,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;class v extends S.$8q{constructor(L,O,w){super(L,O,w),this.s()}r(L){return L.add(new P.$sr(void 0))}}e.$tr=v}),define(le[105],he([0,1,14,59,87,52]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class L extends k.$9q{constructor(w,a,d){super(w,a,d),this.s()}r(w){const a=w.add(new v.$jr(S.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(a.onDidProcessExit(({code:d,signal:u})=>this.t(`terminated by itself with code ${d}, signal: ${u} (ETERM)`))),P.ProxyChannel.toService((0,P.$ni)(a.getChannel("watcher")))}}e.$kr=L}),define(le[64],he([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class S{constructor(...v){this.a=new Map;for(const[k,L]of v)this.set(k,L)}set(v,k){const L=this.a.get(v);return this.a.set(v,k),L}has(v){return this.a.has(v)}get(v){return this.a.get(v)}}e.$Ei=S}),define(le[106],he([0,1,8,7,2,51,100,10,64,152]),function(Z,e,S,P,v,k,L,O,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=void 0;const d=!1;class u extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class p{constructor(b=new w.$Ei,h=!1,$,R=d){this.i=b,this.j=h,this.k=$,this.l=R,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Fi,this),this._globalGraph=R?$?._globalGraph??new L.$wr(y=>y):void 0}dispose(){if(!this.f){this.f=!0,(0,v.$Qc)(this.h),this.h.clear();for(const b of this.g)(0,v.$Pc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,h){this.m();const $=this,R=new class extends p{dispose(){$.h.delete(R),super.dispose()}}(b,this.j,this,this.l);return this.h.add(R),h?.add(R),R}invokeFunction(b,...h){this.m();const $=m.traceInvocation(this.l,b);let R=!1;try{return b({get:i=>{if(R)throw(0,P.$8)("service accessor is only valid during the invocation of its target method");const c=this.s(i,$);if(!c)throw new Error(`[invokeFunction] unknown service '${i}'`);return c}},...h)}finally{R=!0,$.stop()}}createInstance(b,...h){this.m();let $,R;return b instanceof k.$Di?($=m.traceCreation(this.l,b.ctor),R=this.o(b.ctor,b.staticArguments.concat(h),$)):($=m.traceCreation(this.l,b),R=this.o(b,h,$)),$.stop(),R}o(b,h=[],$){const R=O._util.getServiceDependencies(b).sort((c,n)=>c.index-n.index),y=[];for(const c of R){const n=this.s(c.id,$);n||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${c.id}.`,!1),y.push(n)}const i=R.length>0?R[0].index:h.length;if(h.length!==i){console.trace(`[createInstance] First service dependency of ${b.name} at position ${i+1} conflicts with ${h.length} static arguments`);const c=i-h.length;c>0?h=h.concat(new Array(c)):h=h.slice(0,i)}return Reflect.construct(b,h.concat(y))}q(b,h){if(this.i.get(b)instanceof k.$Di)this.i.set(b,h);else if(this.k)this.k.q(b,h);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const h=this.i.get(b);return!h&&this.k?this.k.r(b):h}s(b,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const $=this.r(b);return $ instanceof k.$Di?this.u(b,$,h.branch(b,!0)):(h.branch(b,!1),$)}u(b,h,$){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,h,$)}finally{this.t.delete(b)}}v(b,h,$){const R=new L.$wr(n=>n.id.toString());let y=0;const i=[{id:b,desc:h,_trace:$}],c=new Set;for(;i.length;){const n=i.pop();if(!c.has(String(n.id))){if(c.add(String(n.id)),R.lookupOrInsertNode(n),y++>1e3)throw new u(R);for(const r of O._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof k.$Di){const s={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};R.insertEdge(n,s),i.push(s)}}}}for(;;){const n=R.roots();if(n.length===0){if(!R.isEmpty())throw new u(R);break}for(const{data:r}of n){if(this.r(r.id)instanceof k.$Di){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}R.removeNode(r)}}return this.r(b)}w(b,h,$=[],R,y){if(this.i.get(b)instanceof k.$Di)return this.x(b,h,$,R,y,this.g);if(this.k)return this.k.w(b,h,$,R,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}x(b,h,$=[],R,y,i){if(R){const c=new p(void 0,this.j,this,this.l);c.c=String(b);const n=new Map,r=new S.$Zh(()=>{const t=c.o(h,$,y);for(const[s,o]of n){const l=t[s];if(typeof l=="function")for(const g of o)g.disposable=l.apply(t,g.listener)}return n.clear(),i.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let g=n.get(s);return g||(g=new a.$6c,n.set(s,g)),(T,A,D)=>{if(r.isInitialized)return r.value[s](T,A,D);{const j={listener:[T,A,D],disposable:void 0},H=g.push(j);return(0,v.$Tc)(()=>{H(),j.disposable?.dispose()})}}}if(s in t)return t[s];const o=r.value;let l=o[s];return typeof l!="function"||(l=l.bind(o),t[s]=l),l},set(t,s,o){return r.value[s]=o,!0},getPrototypeOf(t){return h.prototype}})}else{const c=this.o(h,$,y);return i.add(c),c}}y(b,h){if(h&&console.warn(b),this.j)throw new Error(b)}}e.$xr=p;var f;(function(I){I[I.None=0]="None",I[I.Creation=1]="Creation",I[I.Invocation=2]="Invocation",I[I.Branch=3]="Branch"})(f||(f={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(f.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,h){return b?new m(f.Invocation,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(b,h){return b?new m(f.Creation,h.name):m.c}static{this.f=0}constructor(b,h){this.type=b,this.name=h,this.g=Date.now(),this.h=[]}branch(b,h){const $=new m(f.Branch,b.toString());return this.h.push([b,h,$]),$}stop(){const b=Date.now()-this.g;m.f+=b;let h=!1;function $(y,i){const c=[],n=new Array(y+1).join("	");for(const[r,t,s]of i.h)if(t&&s){h=!0,c.push(`${n}CREATES -> ${r}`);const o=$(y+1,s);o&&c.push(o)}else c.push(`${n}uses -> ${r}`);return c.join(`
`)}const R=[`${this.type===f.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(b>2||h)&&m.all.add(R.join(`
`))}}e.$yr=m}),define(le[6],he([0,1,5,38,4,43,2,25,12,16,3,11,101,10]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$ek=e.LogLevel=e.$ck=e.$bk=void 0,e.$dk=I,e.log=h,e.$pk=l,e.$qk=g,e.$rk=N,e.$sk=T,S=be(S),e.$bk=(0,f.$Gi)("logService"),e.$ck=(0,f.$Gi)("loggerService");function m(){return new Date().toISOString()}function I(A){return(0,d.$jg)(A)}var b;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$ek=b.Info;function h(A,D,j){switch(D){case b.Trace:A.trace(j);break;case b.Debug:A.debug(j);break;case b.Info:A.info(j);break;case b.Warning:A.warn(j);break;case b.Error:A.error(j);break;case b.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function $(A,D=!1){let j="";for(let H=0;H<A.length;H++){let Y=A[H];if(Y instanceof Error&&(Y=(0,P.$rj)(Y,D)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}j+=(H>0?" ":"")+Y}return j}class R extends L.$Vc{constructor(){super(...arguments),this.b=e.$ek,this.c=this.B(new v.$me),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==b.Off&&this.b<=D}}e.$gk=R;class y extends R{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...j){this.f(b.Trace)&&this.g(b.Trace,$([D,...j],!0))}debug(D,...j){this.f(b.Debug)&&this.g(b.Debug,$([D,...j]))}info(D,...j){this.f(b.Info)&&this.g(b.Info,$([D,...j]))}warn(D,...j){this.f(b.Warning)&&this.g(b.Warning,$([D,...j]))}error(D,...j){if(this.f(b.Error))if(D instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=D.stack,this.g(b.Error,$(H))}else this.g(b.Error,$([D,...j]))}flush(){}}e.$hk=y;class i extends R{constructor(D=e.$ek){super(),this.setLevel(D),this.g=!w.$j}trace(D,...j){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,D,...j):console.log(`[main ${m()}]`,D,...j))}debug(D,...j){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,D,...j):console.log(`[main ${m()}]`,D,...j))}info(D,...j){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,D,...j):console.log(`[main ${m()}]`,D,...j))}warn(D,...j){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,D,...j):console.warn(`[main ${m()}]`,D,...j))}error(D,...j){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,D,...j):console.error(`[main ${m()}]`,D,...j))}flush(){}}e.$ik=i;class c extends R{constructor(D=e.$ek,j=!0){super(),this.g=j,this.setLevel(D)}trace(D,...j){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...j):console.log(D,...j))}debug(D,...j){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...j):console.log(D,...j))}info(D,...j){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...j):console.log(D,...j))}warn(D,...j){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...j):console.log(D,...j))}error(D,...j){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...j):console.error(D,...j))}flush(){}}e.$jk=c;class n extends R{constructor(D,j=e.$ek){super(),this.g=D,this.setLevel(j)}trace(D,...j){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(D),...j])}debug(D,...j){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(D),...j])}info(D,...j){this.f(b.Info)&&this.g.log(b.Info,[this.h(D),...j])}warn(D,...j){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(D),...j])}error(D,...j){this.f(b.Error)&&this.g.log(b.Error,[this.h(D),...j])}h(D){return typeof D=="string"?D:(0,P.$rj)(D,this.f(b.Trace))}flush(){}}e.$kk=n;class r extends R{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const j of this.g)j.setLevel(D);super.setLevel(D)}trace(D,...j){for(const H of this.g)H.trace(D,...j)}debug(D,...j){for(const H of this.g)H.debug(D,...j)}info(D,...j){for(const H of this.g)H.info(D,...j)}warn(D,...j){for(const H of this.g)H.warn(D,...j)}error(D,...j){for(const H of this.g)H.error(D,...j)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose();super.dispose()}}e.$lk=r;class t extends L.$Vc{constructor(D,j,H){if(super(),this.h=D,this.j=j,this.b=new O.$Bc,this.c=this.B(new v.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new v.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new v.$me),this.onDidChangeVisibility=this.g.event,H)for(const Y of H)this.b.set(Y.resource,{logger:void 0,info:Y})}m(D){return(0,d.$fg)(D)?[...this.b.values()].find(j=>j.info.id===D):this.b.get(D)}getLogger(D){return this.m(D)?.logger}createLogger(D,j){const H=this.n(D),Y=(0,d.$fg)(D)?D:j?.id??(0,k.$uj)(H.toString()).toString(16);let ne=this.b.get(H)?.logger;const ae=j?.logLevel==="always"?b.Trace:j?.logLevel;ne||(ne=this.s(H,ae??this.getLogLevel(H)??this.h,{...j,id:Y}));const ue={logger:ne,info:{resource:H,id:Y,logLevel:ae,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(ue.info),this.b.set(H,ue),ne}n(D){return(0,d.$fg)(D)?(0,a.$hh)(this.j,`${D}.log`):D}setLogLevel(D,j){if(u.URI.isUri(D)){const H=D,Y=j,ne=this.b.get(H);ne&&Y!==ne.info.logLevel&&(ne.info.logLevel=Y===this.h?void 0:Y,ne.logger?.setLevel(Y),this.b.set(ne.info.resource,ne),this.f.fire([H,Y]))}else{this.h=D;for(const[H,Y]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&Y.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,j){const H=this.m(D);H&&j!==!H.info.hidden&&(H.info.hidden=!j,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,j]))}getLogLevel(D){let j;return D&&(j=this.b.get(D)?.info.logLevel),j??this.h}registerLogger(D){const j=this.b.get(D.resource);j?j.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const j=this.b.get(D);j&&(j.logger&&j.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.$mk=t;class s{constructor(){this.onDidChangeLogLevel=new v.$me().event}setLevel(D){}getLevel(){return b.Info}trace(D,...j){}debug(D,...j){}info(D,...j){}warn(D,...j){}error(D,...j){}critical(D,...j){}dispose(){}flush(){}}e.$nk=s;class o extends s{}e.$ok=o;function l(A){if(A.verbose)return b.Trace;if(typeof A.logLevel=="string"){const D=T(A.logLevel.toLowerCase());if(D!==void 0)return D}return e.$ek}function g(A){switch(A){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function N(A){switch(A){case b.Trace:return{original:"Trace",value:S.localize(1950,null)};case b.Debug:return{original:"Debug",value:S.localize(1951,null)};case b.Info:return{original:"Info",value:S.localize(1952,null)};case b.Warning:return{original:"Warning",value:S.localize(1953,null)};case b.Error:return{original:"Error",value:S.localize(1954,null)};case b.Off:return{original:"Off",value:S.localize(1955,null)}}}function T(A){switch(A){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$tk=new p.$Xj("logLevel",g(b.Info))}),define(le[107],he([0,1,19,8,7,4,63,2,15,52,6]),function(Z,e,S,P,v,k,L,O,w,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class u extends O.$Vc{constructor(f,m){super(),this.a=f,this.b=m,this.c=this.B(new k.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new P.$Eh(0)),this.w=[],this.y=this.B(new P.$Eh(0))}watch(f,m){return m.recursive||this.b?.watcher?.forceUniversal?this.n(f,m):this.z(f,m)}n(f,m){const I={path:this.J(f),excludes:m.excludes,includes:m.includes,recursive:m.recursive,filter:m.filter,correlationId:m.correlationId},b=(0,S.$Tb)(this.j,I);return this.r(),(0,O.$Tc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(f=>(0,v.$Z)(f))}s(){this.h||(this.h=this.B(this.t(m=>this.c.fire((0,a.$0q)(m)),m=>this.G(m),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const f=this.b?.watcher?.recursive?.usePolling;if(f===!0)for(const m of this.j)(0,a.$6q)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const m of this.j)(0,a.$6q)(m)&&f.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(f,m){const I={path:this.J(f),excludes:m.excludes,includes:m.includes,recursive:!1,filter:m.filter,correlationId:m.correlationId},b=(0,S.$Tb)(this.w,I);return this.C(),(0,O.$Tc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(f=>(0,v.$Z)(f))}D(){return this.u||(this.u=this.B(this.F(f=>this.c.fire((0,a.$0q)(f)),f=>this.G(f),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(f){f.type==="error"&&this.g.fire(f.message),this.H(f)}H(f){this.a[f.type](f.message)}I(f){return(0,w.$ic)(f.fsPath)}J(f){const m=this.I(f);return(0,L.$Ig)(m)}}e.$dr=u});var oe=this&&this.__param||function(Z,e){return function(S,P){e(S,P,Z)}};define(le[108],he([0,1,19,8,13,21,4,43,65,2,49,14,109,16,47,5,9,62,6,7]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h,$,R){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let i=class extends a.$Vc{static{y=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new L.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new L.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new L.$me),this.Y=this.B(new L.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new L.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new P.$Ph)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${n}`);const t=new a.$Uc;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(s=>{const o=new b.$ul(s,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,a.$Tc)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,a.$Qc)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(t){r.push(t)}}),!this.h.has(n)&&await P.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return w.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,f.$lh)(n))throw new b.$wl((0,I.localize)(1862,null,this.sb(n)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const t=new R.$bb;throw t.message=(0,I.localize)(1863,null,n.toString()),t}return r}async m(n){const r=await this.j(n);if((0,b.$hl)(r)||(0,b.$el)(r)||(0,b.$il)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const r=await this.j(n);if((0,b.$hl)(r)||(0,b.$el)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.s(n,r)}catch(t){throw(0,b.$rl)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.$wl((0,I.localize)(1864,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$pl)(t)}}async s(n,r){const t=await this.j(n),s=this.S(t),o=r?.resolveTo,l=r?.resolveSingleChildDescendants,g=r?.resolveMetadata,N=await t.stat(n);let T;return this.t(t,n,N,void 0,!!g,(A,D)=>(T||(T=d.$Mi.forUris(()=>!s),T.set(n,!0),o&&T.fill(!0,o)),T.get(A.resource)||T.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&l?D===1:!1))}async t(n,r,t,s,o,l){const{providerExtUri:g}=this.R(n),N={resource:r,name:g.basename(r),isFile:(t.type&b.FileType.File)!==0,isDirectory:(t.type&b.FileType.Directory)!==0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&b.FilePermission.Readonly)||!!(n.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Hl)({mtime:t.mtime,size:t.size}),children:void 0};if(N.isDirectory&&l(N,s)){try{const T=await n.readdir(r),A=await P.Promises.settled(T.map(async([D,j])=>{try{const H=g.joinPath(r,D),Y=o?await n.stat(H):{type:j};return await this.t(n,H,Y,T.length,o,l)}catch(H){return this.b.trace(H),null}}));N.children=(0,S.$Hb)(A)}catch(T){this.b.trace(T),N.children=[]}return N}return N}async resolveAll(n){return P.Promises.settled(n.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),t=await r.stat(n);return this.t(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.u(n,r)}catch(t){return t}return!0}async u(n,r){if(!r?.overwrite&&await this.exists(n))throw new b.$wl((0,I.localize)(1865,null,this.sb(n)),b.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(n,r=v.$Oe.fromString(""),t){await this.u(n,t);const s=await this.writeFile(n,r);return this.r.fire(new b.$tl(n,b.FileOperation.CREATE,s)),s}async writeFile(n,r,t){const s=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(s);let l=t;if((0,b.$kl)(s)&&!l?.atomic){const g=s.enforceAtomicWriteFile?.(n);g&&(l={...t,atomic:g})}try{await this.w(s,n,l)||await this.U(s,o.dirname(n));let N;if((0,b.$el)(s)&&!(r instanceof v.$Oe))if((0,m.$Ae)(r)){const T=await(0,m.$He)(r,3);T.ended?N=v.$Oe.concat(T.buffer):N=T}else N=(0,m.$Ee)(r,T=>v.$Oe.concat(T),3);else N=r;!(0,b.$hl)(s)||(0,b.$el)(s)&&N instanceof v.$Oe||(0,b.$el)(s)&&(0,b.$kl)(s)&&l?.atomic?await this.hb(s,n,l,N):await this.db(s,n,l,N instanceof v.$Oe?(0,v.$Ze)(N):N),this.r.fire(new b.$tl(n,b.FileOperation.WRITE))}catch(g){throw new b.$wl((0,I.localize)(1866,null,this.sb(n),(0,b.$pl)(g).toString()),(0,b.$sl)(g),l)}return this.resolve(n,{resolveMetadata:!0})}async w(n,r,t){const s=!!t?.unlock;if(s&&!(n.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,I.localize)(1867,null,this.sb(r)));if(!!t?.atomic){if(!(n.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,I.localize)(1868,null,this.sb(r)));if(!(n.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,I.localize)(1869,null,this.sb(r)));if(s)throw new Error((0,I.localize)(1870,null,this.sb(r)))}let l;try{l=await n.stat(r)}catch{return}if(l.type&b.FileType.Directory)throw new b.$wl((0,I.localize)(1871,null,this.sb(r)),b.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(r,l),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.$Gl&&typeof l.mtime=="number"&&typeof l.size=="number"&&t.mtime<l.mtime&&t.etag!==(0,b.$Hl)({mtime:t.mtime,size:l.size}))throw new b.$wl((0,I.localize)(1872,null),b.FileOperationResult.FILE_MODIFIED_SINCE,t);return l}async readFile(n,r,t){const s=await this.m(n);return r?.atomic?this.z(s,n,r,t):this.C(s,n,r,t)}async z(n,r,t,s){return new Promise((o,l)=>{this.cb.queueFor(r,async()=>{try{const g=await this.C(n,r,t,s);o(g)}catch(g){l(g)}},this.R(n).providerExtUri)})}async C(n,r,t,s){const o=await this.D(n,r,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,v.$1e)(o.value)}}async readFileStream(n,r,t){const s=await this.m(n);return this.D(s,n,r,t)}async D(n,r,t,s){const o=new k.$xe(s);let l=t;(0,b.$jl)(n)&&n.enforceAtomicReadFile?.(r)&&(l={...t,atomic:!0});const g=this.J(r,l).then(T=>T,T=>{throw o.dispose(!0),T});let N;try{return typeof l?.etag=="string"&&l.etag!==b.$Gl&&await g,l?.atomic&&(0,b.$jl)(n)||!((0,b.$hl)(n)||(0,b.$il)(n))||(0,b.$el)(n)&&l?.preferUnbuffered?N=this.I(n,r,l):(0,b.$il)(n)?N=this.G(n,r,o.token,l):N=this.H(n,r,o.token,l),N.on("end",()=>o.dispose()),N.on("error",()=>o.dispose()),{...await g,value:N}}catch(T){throw N&&await(0,m.$Fe)(N),this.F(T,r,l)}}F(n,r,t){const s=(0,I.localize)(1873,null,this.sb(r),(0,b.$pl)(n).toString());return n instanceof b.$yl?new b.$yl(s,n.stat,t):n instanceof b.$xl?new b.$xl(s,n.fileOperationResult,n.size,n.options):new b.$wl(s,(0,b.$sl)(n),t)}G(n,r,t,s=Object.create(null)){const o=n.readFileStream(r,s,t);return(0,m.$Le)(o,{data:l=>l instanceof v.$Oe?l:v.$Oe.wrap(l),error:l=>this.F(l,r,s)},l=>v.$Oe.concat(l))}H(n,r,t,s=Object.create(null)){const o=(0,v.$5e)();return(0,h.$3q)(n,r,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,r,s)},t),o}I(n,r,t){const s=(0,m.$Ce)(o=>v.$Oe.concat(o));return(async()=>{try{let o;t?.atomic&&(0,b.$jl)(n)?o=await n.readFile(r,{atomic:!0}):o=await n.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(r,o.byteLength,t),s.end(v.$Oe.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new b.$wl((0,I.localize)(1874,null,this.sb(n)),b.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==b.$Gl&&r.etag===t.etag)throw new b.$yl((0,I.localize)(1875,null),t,r);return this.L(n,t.size,r),t}L(n,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new b.$xl((0,I.localize)(1876,null,this.sb(n)),b.FileOperationResult.FILE_TOO_LARGE,r,t)}async canMove(n,r,t){return this.M(n,r,"move",t)}async canCopy(n,r,t){return this.M(n,r,"copy",t)}async M(n,r,t,s){if(n.toString()!==r.toString())try{const o=t==="move"?this.qb(await this.n(n),n):await this.m(n),l=this.qb(await this.n(r),r);await this.Q(o,n,l,r,t,s)}catch(o){return o}return!0}async move(n,r,t){const s=this.qb(await this.n(n),n),o=this.qb(await this.n(r),r),l=await this.N(s,n,o,r,"move",!!t),g=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$tl(n,l==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,g)),g}async copy(n,r,t){const s=await this.m(n),o=this.qb(await this.n(r),r),l=await this.N(s,n,o,r,"copy",!!t),g=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$tl(n,l==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,g)),g}async N(n,r,t,s,o,l){if(r.toString()===s.toString())return o;const{exists:g,isSameResourceWithDifferentPathCase:N}=await this.Q(n,r,t,s,o,l);if(g&&!N&&l&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),o==="copy"){if(n===t&&(0,b.$fl)(n))await n.copy(r,s,{overwrite:l});else{const T=await this.resolve(r);T.isDirectory?await this.P(n,T,t,s):await this.O(n,r,t,s)}return o}else return n===t?(await n.rename(r,s,{overwrite:l}),o):(await this.N(n,r,t,s,"copy",l),await this.del(r,{recursive:!0}),"copy")}async O(n,r,t,s){if((0,b.$hl)(n)&&(0,b.$hl)(t))return this.jb(n,r,t,s);if((0,b.$hl)(n)&&(0,b.$el)(t))return this.pb(n,r,t,s);if((0,b.$el)(n)&&(0,b.$hl)(t))return this.nb(n,r,t,s);if((0,b.$el)(n)&&(0,b.$el)(t))return this.lb(n,r,t,s)}async P(n,r,t,s){await t.mkdir(s),Array.isArray(r.children)&&await P.Promises.settled(r.children.map(async o=>{const l=this.R(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),t,l):this.O(n,o.resource,t,l)}))}async Q(n,r,t,s,o,l){let g=!1;if(n===t){const{providerExtUri:T,isPathCaseSensitive:A}=this.R(n);if(A||(g=T.isEqual(r,s)),g&&o==="copy")throw new Error((0,I.localize)(1877,null,this.sb(r),this.sb(s)));if(!g&&T.isEqualOrParent(s,r))throw new Error((0,I.localize)(1878,null,this.sb(r),this.sb(s)))}const N=await this.exists(s);if(N&&!g){if(!l)throw new b.$wl((0,I.localize)(1879,null,this.sb(r),this.sb(s)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(n===t){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(r,s))throw new Error((0,I.localize)(1880,null,this.sb(r),this.sb(s)))}}return{exists:N,isSameResourceWithDifferentPathCase:g}}R(n){const r=this.S(n);return{providerExtUri:r?f.$0g:f.$_g,isPathCaseSensitive:r}}S(n){return!!(n.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const r=this.qb(await this.j(n),n);await this.U(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new b.$tl(n,b.FileOperation.CREATE,t)),t}async U(n,r){const t=[],{providerExtUri:s}=this.R(n);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await n.stat(r)).type&b.FileType.Directory))throw new Error((0,I.localize)(1881,null,this.sb(r)));break}catch(o){if((0,b.$rl)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(r)),r=s.dirname(r)}for(let o=t.length-1;o>=0;o--){r=s.joinPath(r,t[o]);try{await n.mkdir(r)}catch(l){if((0,b.$rl)(l)!==b.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(n,r){try{await this.W(n,r)}catch(t){return t}return!0}async W(n,r){const t=this.qb(await this.j(n),n),s=!!r?.useTrash;if(s&&!(t.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,I.localize)(1882,null,this.sb(n)));const o=r?.atomic;if(o&&!(t.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,I.localize)(1883,null,this.sb(n)));if(s&&o)throw new Error((0,I.localize)(1884,null,this.sb(n)));let l;try{l=await t.stat(n)}catch{}if(l)this.rb(n,l);else throw new b.$wl((0,I.localize)(1885,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const N=await this.resolve(n);if(N.isDirectory&&Array.isArray(N.children)&&N.children.length>0)throw new Error((0,I.localize)(1886,null,this.sb(n)))}return t}async del(n,r){const t=await this.W(n,r);let s=r;if((0,b.$ll)(t)&&!s?.atomic){const N=t.enforceAtomicDelete?.(n);N&&(s={...r,atomic:N})}const o=!!s?.useTrash,l=!!s?.recursive,g=s?.atomic??!1;await t.delete(n,{recursive:l,useTrash:o,atomic:g}),this.r.fire(new b.$tl(n,b.FileOperation.DELETE))}async cloneFile(n,r){const t=await this.j(n),s=this.qb(await this.n(r),r);if(!(t===s&&this.R(t).providerExtUri.isEqual(n,r)))return t===s&&(0,b.$gl)(t)?t.cloneFile(n,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),t===s&&(0,b.$fl)(t)?this.cb.queueFor(n,()=>t.copy(n,r,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(n,()=>this.O(t,n,s,r),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(n,r){return this.watch(n,{...r,correlationId:y.ab++})}watch(n,r={recursive:!1,excludes:[]}){const t=new a.$Uc;let s=!1,o=()=>{s=!0};t.add((0,a.$Tc)(()=>o())),(async()=>{try{const g=await this.bb(n,r);s?(0,a.$Qc)(g):o=()=>(0,a.$Qc)(g)}catch(g){this.b.error(g)}})();const l=r.correlationId;if(typeof l=="number"){const g=t.add(new L.$me);return t.add(this.X.event(T=>{T.correlates(l)&&g.fire(T)})),{onDidChange:g.event,dispose:()=>t.dispose()}}return t}async bb(n,r){const t=await this.j(n),s=(0,O.$uj)([this.R(t).providerExtUri.getComparisonKey(n),r]);let o=this.$.get(s);return o||(o={count:0,disposable:t.watch(n,r)},this.$.set(s,o)),o.count+=1,(0,a.$Tc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Qc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,a.$Qc)(n.disposable);this.$.clear()}async db(n,r,t,s){return this.cb.queueFor(r,async()=>{const o=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,m.$Ae)(s)||(0,m.$Be)(s)?await this.eb(n,o,s):await this.fb(n,o,s)}catch(l){throw(0,b.$pl)(l)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,r,t){let s=0,o;if((0,m.$Be)(t)){if(t.buffer.length>0){const l=v.$Oe.concat(t.buffer);await this.gb(n,r,l,l.byteLength,s,0),s+=l.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((l,g)=>{(0,m.$Ge)(o,{onData:async N=>{o.pause();try{await this.gb(n,r,N,N.byteLength,s,0)}catch(T){return g(T)}s+=N.byteLength,setTimeout(()=>o.resume())},onError:N=>g(N),onEnd:()=>l()})})}async fb(n,r,t){let s=0,o;for(;(o=t.read())!==null;)await this.gb(n,r,o,o.byteLength,s,0),s+=o.byteLength}async gb(n,r,t,s,o,l){let g=0;for(;g<s;){const N=await n.write(r,o+g,t.buffer,l+g,s-g);g+=N}}async hb(n,r,t,s){return this.cb.queueFor(r,()=>this.ib(n,r,t,s),this.R(n).providerExtUri)}async ib(n,r,t,s){let o;s instanceof v.$Oe?o=s:(0,m.$Ae)(s)?o=await(0,v.$1e)(s):(0,m.$Be)(s)?o=await(0,v.$2e)(s):o=(0,v.$Ye)(s),await n.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(n,r,t,s){return this.cb.queueFor(s,()=>this.kb(n,r,t,s),this.R(t).providerExtUri)}async kb(n,r,t,s){let o,l;try{o=await n.open(r,{create:!1}),l=await t.open(s,{create:!0,unlock:!1});const g=v.$Oe.alloc(this.a);let N=0,T=0,A=0;do A=await n.read(o,N,g.buffer,T,g.byteLength-T),await this.gb(t,l,g,A,N,T),N+=A,T+=A,T===g.byteLength&&(T=0);while(A>0)}catch(g){throw(0,b.$pl)(g)}finally{await P.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof l=="number"?t.close(l):Promise.resolve()])}}async lb(n,r,t,s){return this.cb.queueFor(s,()=>this.mb(n,r,t,s),this.R(t).providerExtUri)}async mb(n,r,t,s){return t.writeFile(s,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,r,t,s){return this.cb.queueFor(s,()=>this.ob(n,r,t,s),this.R(t).providerExtUri)}async ob(n,r,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const l=await n.readFile(r);await this.gb(t,o,v.$Oe.wrap(l),l.byteLength,0,0)}catch(l){throw(0,b.$pl)(l)}finally{await t.close(o)}}async pb(n,r,t,s){const o=await(0,v.$1e)(this.H(n,r,k.CancellationToken.None));await this.hb(t,s,void 0,o)}qb(n,r){if(n.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$wl((0,I.localize)(1887,null,this.sb(r)),b.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.$wl((0,I.localize)(1888,null,this.sb(n)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}};e.$4q=i,e.$4q=i=y=Ee([oe(0,$.$bk)],i)}),define(le[110],he([0,1,32,8,25,13,4,63,2,15,12,16,47,29,5,9,62,107,105,104]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;class y extends h.$dr{static{this.L=!1}constructor(c,n){super(c,n),this.onDidChangeCapabilities=L.Event.None,this.P=new v.$Bc(r=>u.$$g.getComparisonKey(r)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=I.FileSystemProviderCapabilities.FileReadWrite|I.FileSystemProviderCapabilities.FileOpenReadWriteClose|I.FileSystemProviderCapabilities.FileReadStream|I.FileSystemProviderCapabilities.FileFolderCopy|I.FileSystemProviderCapabilities.FileWriteUnlock|I.FileSystemProviderCapabilities.FileAtomicRead|I.FileSystemProviderCapabilities.FileAtomicWrite|I.FileSystemProviderCapabilities.FileAtomicDelete|I.FileSystemProviderCapabilities.FileClone,d.$l&&(this.M|=I.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(c){try{const{stat:n,symbolicLink:r}=await f.SymlinkSupport.stat(this.I(c));return{type:this.O(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:I.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(c){try{return await this.stat(c)}catch{return}}async readdir(c){try{const n=await f.Promises.readdir(this.I(c),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,u.$hh)(c,t.name))).type:s=this.O(t),r.push([t.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.hb(n)}}O(c,n){let r;return n?.dangling?r=I.FileType.Unknown:c.isFile()?r=I.FileType.File:c.isDirectory()?r=I.FileType.Directory:r=I.FileType.Unknown,n&&(r|=I.FileType.SymbolicLink),r}async Q(c){const n=this.I(c);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.P.get(c);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const t=new P.$Fh;return this.P.set(c,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,w.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(c)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(c)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),t.open()})}async readFile(c,n){let r;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(c)})`),r=await this.Q(c));const t=this.I(c);return await S.promises.readFile(t)}catch(t){throw this.hb(t)}finally{r?.dispose()}}R(c){y.L&&this.a.trace(c)}readFileStream(c,n,r){const t=(0,p.$Ce)(s=>k.$Oe.concat(s.map(o=>k.$Oe.wrap(o))).buffer);return(0,b.$3q)(this,c,t,s=>s.buffer,{...n,bufferSize:256*1024},r),t}async writeFile(c,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.S(c)?this.U(c,(0,u.$hh)((0,u.$gh)(c),`${(0,u.$eh)(c)}${r.atomic.postfix}`),n,r):this.W(c,n,r)}async S(c){try{const n=this.I(c),{symbolicLink:r}=await f.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async U(c,n,r,t){const s=new w.$Uc;try{s.add(await this.Q(c)),s.add(await this.Q(n)),await this.W(n,r,t,!0);try{await this.rename(n,c,{overwrite:!0})}catch(o){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{s.dispose()}}async W(c,n,r,t){let s;try{const o=this.I(c);if(!r.create||!r.overwrite){if(await f.Promises.exists(o)){if(!r.overwrite)throw(0,I.$ol)((0,m.localize)(1892,null),I.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,I.$ol)((0,m.localize)(1893,null),I.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(c,{create:!0,unlock:r.unlock},t),await this.write(s,0,n,0,n.byteLength)}catch(o){throw await this.ib(c,o)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(c){y.$=c}async open(c,n,r){const t=this.I(c);let s;(0,I.$cl)(n)&&!r&&(s=await this.Q(c));let o;try{if((0,I.$cl)(n)&&n.unlock)try{const{stat:g}=await f.SymlinkSupport.stat(t);g.mode&128||await S.promises.chmod(t,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let l;if((0,I.$cl)(n)){if(d.$j)try{await S.promises.truncate(t,0),l="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}l||(l="w")}else l="r";o=await f.Promises.open(t,l)}catch(l){throw s?.dispose(),(0,I.$cl)(n)?await this.ib(c,l):this.hb(l)}if(this.X.set(o,0),(0,I.$cl)(n)&&this.Z.set(o,c),s){const l=this.Y.get(o);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.Y.set(o,s),l&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),l.dispose())}return o}async close(c){const n=this.Y.get(c);try{if(this.X.delete(c),this.Z.delete(c)&&y.$)try{await f.Promises.fdatasync(c)}catch(r){y.configureFlushOnWrite(!1),this.a.error(r)}return await f.Promises.close(c)}catch(r){throw this.hb(r)}finally{n&&(this.Y.get(c)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${c}`),this.Y.delete(c)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${c}`),n.dispose())}}async read(c,n,r,t,s){const o=this.ab(c,n);let l=null;try{l=(await f.Promises.read(c,r,t,s,o)).bytesRead}catch(g){throw this.hb(g)}finally{this.bb(c,o,l)}return l}ab(c,n){return n===this.X.get(c)?null:n}bb(c,n,r){const t=this.X.get(c);typeof t=="number"&&(typeof n=="number"||(typeof r=="number"?this.X.set(c,t+r):this.X.delete(c)))}async write(c,n,r,t,s){return(0,P.$1h)(()=>this.cb(c,n,r,t,s),100,3)}async cb(c,n,r,t,s){const o=this.ab(c,n);let l=null;try{l=(await f.Promises.write(c,r,t,s,o)).bytesWritten}catch(g){throw await this.ib(this.Z.get(c),g)}finally{this.bb(c,o,l)}return l}async mkdir(c){try{await S.promises.mkdir(this.I(c))}catch(n){throw this.hb(n)}}async delete(c,n){try{const r=this.I(c);if(n.recursive){let t;n?.atomic!==!1&&n.atomic.postfix&&(t=(0,a.$kc)((0,a.$nc)(r),`${(0,a.$oc)(r)}${n.atomic.postfix}`)),await f.Promises.rm(r,f.RimRafMode.MOVE,t)}else try{await S.promises.unlink(r)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:o,symbolicLink:l}=await f.SymlinkSupport.stat(r);s=o.isDirectory()&&!l}catch{}if(s)await S.promises.rmdir(r);else throw t}else throw t}}catch(r){throw this.hb(r)}}async rename(c,n,r){const t=this.I(c),s=this.I(n);if(t!==s)try{await this.db(c,n,"move",r.overwrite),await f.Promises.rename(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,m.localize)(1894,null,(0,a.$oc)(t),(0,a.$oc)((0,a.$nc)(s)),o.toString()))),this.hb(o)}}async copy(c,n,r){const t=this.I(c),s=this.I(n);if(t!==s)try{await this.db(c,n,"copy",r.overwrite),await f.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,m.localize)(1895,null,(0,a.$oc)(t),(0,a.$oc)((0,a.$nc)(s)),o.toString()))),this.hb(o)}}async db(c,n,r,t){const s=this.I(c),o=this.I(n);let l=!1;if(!!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive)||(l=(0,O.$Eg)(s,o,!0)),l){if(r==="copy")throw(0,I.$ol)((0,m.localize)(1896,null),I.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const N=await this.N(c);if(!N)throw(0,I.$ol)((0,m.localize)(1897,null),I.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(n);if(T){if(!t)throw(0,I.$ol)((0,m.localize)(1898,null),I.FileSystemProviderErrorCode.FileExists);N.type&I.FileType.File&&T.type&I.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(c,n){return this.eb(c,n,!1)}async eb(c,n,r){const t=this.I(c),s=this.I(n),o=!!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Eg)(t,s,!o))return;const l=new w.$Uc;try{l.add(await this.Q(c)),l.add(await this.Q(n)),r&&await S.promises.mkdir((0,a.$nc)(s),{recursive:!0}),await S.promises.copyFile(t,s)}catch(g){if(g.code==="ENOENT"&&!r)return this.eb(c,n,!0);throw this.hb(g)}finally{l.dispose()}}t(c,n,r){return new $.$kr(t=>c(t),t=>n(t),r)}F(c,n,r){return new R.$tr(t=>c(t),t=>n(t),r)}hb(c){if(c instanceof I.$nl)return c;let n=c,r;switch(c.code){case"ENOENT":r=I.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=I.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=I.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=I.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=I.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=I.FileSystemProviderErrorCode.Unknown;break;default:r=I.FileSystemProviderErrorCode.Unknown}return(0,I.$ol)(n,r)}async ib(c,n){let r=this.hb(n);if(c&&r.code===I.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await f.SymlinkSupport.stat(this.I(c));t.mode&128||(r=(0,I.$ol)(n,I.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return r}}e.$ur=y}),define(le[111],he([0,1,2,6]),function(Z,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OR=void 0;class v extends S.$Vc{constructor(L,O=[]){super(),this.a=new P.$lk([L,...O]),this.B(L.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...O){this.a.trace(L,...O)}debug(L,...O){this.a.debug(L,...O)}info(L,...O){this.a.info(L,...O)}warn(L,...O){this.a.warn(L,...O)}error(L,...O){this.a.error(L,...O)}flush(){this.a.flush()}}e.$OR=v}),define(le[112],he([0,1,9,6]),function(Z,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;var v;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(v||(v={}));async function k(a,d,u,p,f){try{const m=await new Promise((b,h)=>{Z(["@vscode/spdlog"],b,h)}).then(be);m.setFlushOn(v.Trace);const I=await m.createAsyncRotatingLogger(a,d,u,p);return f?I.clearFormatters():I.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),I}catch(m){console.error(m)}return null}function L(a,d,u){switch(d){case P.LogLevel.Trace:a.trace(u);break;case P.LogLevel.Debug:a.debug(u);break;case P.LogLevel.Info:a.info(u);break;case P.LogLevel.Warning:a.warn(u);break;case P.LogLevel.Error:a.error(u);break;case P.LogLevel.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function O(a,d){switch(d){case P.LogLevel.Trace:a.setLevel(v.Trace);break;case P.LogLevel.Debug:a.setLevel(v.Debug);break;case P.LogLevel.Info:a.setLevel(v.Info);break;case P.LogLevel.Warning:a.setLevel(v.Warning);break;case P.LogLevel.Error:a.setLevel(v.Error);break;case P.LogLevel.Off:a.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${d}`)}}class w extends P.$hk{constructor(d,u,p,f,m){super(),this.m=[],this.setLevel(m),this.n=this.s(d,u,p,f),this.B(this.onDidChangeLogLevel(I=>{this.r&&O(this.r,I)}))}async s(d,u,p,f){const m=p?6:1,I=30/m*S.$Jl.MB,b=await k(d,u,I,m,f);if(b){this.r=b,O(this.r,this.getLevel());for(const{level:h,message:$}of this.m)L(this.r,h,$);this.m=[]}}g(d,u){this.r?L(this.r,d,u):this.getLevel()<=d&&this.m.push({level:d,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$DR=w}),define(le[113],he([0,1,28,6,112]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ER=void 0;class k extends P.$mk{s(O,w,a){return new v.$DR((0,S.$3g)(),O.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,w)}}e.$ER=k}),define(le[39],he([0,1,4,65,2,10]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=void 0,e.$uo=(0,k.$Gi)("policy");class L extends v.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const d=Object.keys(this.f).length;return this.f={...a,...this.f},d!==Object.keys(this.f).length&&await this.j(a),P.Iterable.reduce(this.g.entries(),(u,[p,f])=>({...u,[p]:f}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return P.Iterable.reduce(Object.entries(this.f),(a,[d,u])=>({...a,[d]:{definition:u,value:this.g.get(d)}}),{})}}e.$vo=L;class O{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$wo=O}),define(le[114],he([0,1,8,4,65,3,9,6,39]),function(Z,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;function a(u,p){const f=[];for(const m of new Set(v.Iterable.concat(u.keys(),p.keys())))u.get(m)!==p.get(m)&&f.push(m);return f}let d=class extends w.$vo{constructor(p,f,m){super(),this.m=p,this.n=f,this.s=m,this.c=this.B(new S.$Eh(500));const I=P.Event.filter(f.onDidFilesChange,b=>b.affects(p));this.B(f.watch(p)),this.B(I(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const p=new Map;try{const f=await this.n.readFile(this.m),m=JSON.parse(f.value.toString());if(!(0,k.$hg)(m))throw new Error("Policy file isn't a JSON object");for(const I of Object.keys(m))this.f[I]&&p.set(I,m[I])}catch(f){f.fileOperationResult!==L.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",f)}return p}async w(){const p=await this.u(),f=a(this.g,p);this.g=p,f.length>0&&this.h.fire(f)}};e.$8hc=d,e.$8hc=d=Ee([oe(1,L.$bl),oe(2,O.$bk)],d)}),define(le[115],he([0,1,39,8,2,6]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;let L=class extends S.$vo{constructor(w,a){super(),this.m=w,this.n=a,this.a=new P.$Ah,this.b=this.B(new v.$Wc)}async j(w){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(w).length} policy definitions`);const{createWatcher:a}=await new Promise((d,u)=>{Z(["@vscode/policy-watcher"],d,u)}).then(be);await this.a.queue(()=>new Promise((d,u)=>{try{this.b.value=a(this.n,w,p=>{this.t(p),d()})}catch(p){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),u(p)}}))}t(w){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(w)}`);for(const a in w){const d=w[a];d===void 0?this.g.delete(a):this.g.set(a,d)}this.h.fire(Object.keys(w))}};e.$7hc=L,e.$7hc=L=Ee([oe(0,k.$bk)],L)}),define(le[33],he([0,1,10]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$uk=(0,S.$Gi)("productService"),e.$vk="vscode://schemas/vscode-product"}),define(le[37],he([0,1,75,3]),function(Z,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,S=be(S),P=be(P);class v{constructor(){this.a=new Map}add(L,O){S.ok(P.$fg(L)),S.ok(P.$hg(O)),S.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,O)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$so=new v}),define(le[116],he([0,1,4,78,37]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,v=be(v),e.$to={JSONContribution:"base.contributions.json"};function k(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class L{constructor(){this.b=new S.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(a,d){this.a[k(a)]=d,this.b.fire(a)}notifySchemaChanged(a){this.b.fire(a)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(a){const d=this.a[a];return d?(0,P.$9j)(d):void 0}hasSchemaContent(a){return!!this.a[a]}}const O=new L;v.$so.add(e.$to.JSONContribution,O)}),define(le[40],he([0,1,19,4,3,5,30,116,37]),function(Z,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ConfigurationScope=e.$xo=e.EditPresentationTypes=void 0,e.$Io=I,e.$Jo=b,e.$Ko=h,e.$Lo=R,e.$Mo=y,e.$No=i,e.$Oo=c,v=be(v),k=be(k);var a;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$xo={Configuration:"base.contributions.configuration"};var d;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d||(e.ConfigurationScope=d={})),e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo="vscode://schemas/settings/resourceLanguage",e.$Fo="vscode://schemas/settings/configurationDefaults";const u=w.$so.as(O.$to.JSONContribution);class p{constructor(){this.a=[],this.i=new Set,this.j=new P.$me,this.onDidSchemaChange=this.j.event,this.k=new P.$me,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:k.localize(1653,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},u.registerSchema(e.$Eo,this.h),this.z()}registerConfiguration(r,t=!0){this.registerConfigurations([r],t)}registerConfigurations(r,t=!0){const s=new Set;this.r(r,t,s),u.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(r){const t=new Set;this.s(r,t),u.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:r,remove:t}){const s=new Set;this.s(t,s),this.r(r,!1,s),u.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(r){const t=new Set;this.l(r,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(r,t){this.a.push(...r);const s=[];for(const{overrides:o,source:l}of r)for(const g in o){t.add(g);const N=this.b.get(g)??this.b.set(g,{configurationDefaultOverrides:[]}).get(g),T=o[g];if(N.configurationDefaultOverrides.push({value:T,source:l}),e.$Ho.test(g)){const A=this.o(g,T,l,N.configurationDefaultOverrideValue);if(!A)continue;N.configurationDefaultOverrideValue=A,this.n(g,A,l),s.push(...I(g))}else{const A=this.p(g,T,l,N.configurationDefaultOverrideValue);if(!A)continue;N.configurationDefaultOverrideValue=A;const D=this.e[g];D&&(this.A(g,D),this.w(g,D))}}this.q(s)}deregisterDefaultConfigurations(r){const t=new Set;this.m(r,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(r,t){for(const s of r){const o=this.a.indexOf(s);o!==-1&&this.a.splice(o,1)}for(const{overrides:s,source:o}of r)for(const l in s){const g=this.b.get(l);if(!g)continue;const N=g.configurationDefaultOverrides.findIndex(T=>o?T.source?.id===o.id:T.value===s[l]);if(N!==-1){if(g.configurationDefaultOverrides.splice(N,1),g.configurationDefaultOverrides.length===0&&this.b.delete(l),e.$Ho.test(l)){let T;for(const A of g.configurationDefaultOverrides)T=this.o(l,A.value,A.source,T);T&&!v.$sg(T.value)?(g.configurationDefaultOverrideValue=T,this.n(l,T,o)):(this.b.delete(l),delete this.e[l],delete this.c.properties[l])}else{let T;for(const D of g.configurationDefaultOverrides)T=this.p(l,D.value,D.source,T);g.configurationDefaultOverrideValue=T;const A=this.e[l];A&&(this.A(l,A),this.w(l,A))}t.add(l)}}this.y()}n(r,t,s){const o={type:"object",default:t.value,description:k.localize(1654,null,(0,L.$kj)(r)),$ref:e.$Eo,defaultDefaultValue:t.value,source:s,defaultValueSource:s};this.e[r]=o,this.c.properties[r]=o}o(r,t,s,o){const l=o?.value||{},g=o?.source??new Map;if(!(g instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const N of Object.keys(t)){const T=t[N];if(v.$hg(T)&&(v.$mg(l[N])||v.$hg(l[N]))){if(l[N]={...l[N]??{},...T},s)for(const D in T)g.set(`${N}.${D}`,s)}else l[N]=T,s?g.set(N,s):g.delete(N)}return{value:l,source:g}}p(r,t,s,o){const l=this.e[r],g=o?.value??l?.defaultDefaultValue;let N=s;if(v.$hg(t)&&(l!==void 0&&l.type==="object"||l===void 0&&(v.$mg(g)||v.$hg(g)))){if(N=o?.source??new Map,!(N instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in t)s&&N.set(`${r}.${A}`,s);t={...v.$hg(g)?g:{},...t}}return{value:t,source:N}}deltaConfiguration(r){let t=!1;const s=new Set;r.removedDefaults&&(this.m(r.removedDefaults,s),t=!0),r.addedDefaults&&(this.l(r.addedDefaults,s),t=!0),r.removedConfigurations&&this.s(r.removedConfigurations,s),r.addedConfigurations&&this.r(r.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...r){this.j.fire()}registerOverrideIdentifiers(r){this.q(r),this.j.fire()}q(r){for(const t of r)this.i.add(t);this.y()}r(r,t,s){r.forEach(o=>{this.u(o,t,o.extensionInfo,o.restrictedProperties,void 0,s),this.d.push(o),this.v(o)})}s(r,t){const s=o=>{if(o.properties)for(const l in o.properties){t.add(l);const g=this.e[l];g?.policy?.name&&this.f.delete(g.policy.name),delete this.e[l],this.x(l,o.properties[l])}o.allOf?.forEach(l=>s(l))};for(const o of r){s(o);const l=this.d.indexOf(o);l!==-1&&this.d.splice(l,1)}}u(r,t=!0,s,o,l=d.WINDOW,g){l=v.$og(r.scope)?l:r.scope;const N=r.properties;if(N)for(const A in N){const D=N[A];if(t&&R(A,D)){delete N[A];continue}if(D.source=s,D.defaultDefaultValue=N[A].default,this.A(A,D),e.$Ho.test(A)?D.scope=void 0:(D.scope=v.$og(D.scope)?l:D.scope,D.restricted=v.$og(D.restricted)?!!o?.includes(A):D.restricted),N[A].hasOwnProperty("included")&&!N[A].included){this.g[A]=N[A],delete N[A];continue}else this.e[A]=N[A],N[A].policy?.name&&this.f.set(N[A].policy.name,A);!N[A].deprecationMessage&&N[A].markdownDeprecationMessage&&(N[A].deprecationMessage=N[A].markdownDeprecationMessage),g.add(A)}const T=r.allOf;if(T)for(const A of T)this.u(A,t,s,o,l,g)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const r=new Map;for(const[t,s]of this.b)s.configurationDefaultOverrideValue&&r.set(t,s.configurationDefaultOverrideValue);return r}v(r){const t=s=>{const o=s.properties;if(o)for(const g in o)this.w(g,o[g]);s.allOf?.forEach(t)};t(r)}w(r,t){switch(e.$yo.properties[r]=t,t.scope){case d.APPLICATION:e.$zo.properties[r]=t;break;case d.MACHINE:e.$Ao.properties[r]=t;break;case d.MACHINE_OVERRIDABLE:e.$Bo.properties[r]=t;break;case d.WINDOW:e.$Co.properties[r]=t;break;case d.RESOURCE:e.$Do.properties[r]=t;break;case d.LANGUAGE_OVERRIDABLE:e.$Do.properties[r]=t,this.h.properties[r]=t;break}}x(r,t){switch(delete e.$yo.properties[r],t.scope){case d.APPLICATION:delete e.$zo.properties[r];break;case d.MACHINE:delete e.$Ao.properties[r];break;case d.MACHINE_OVERRIDABLE:delete e.$Bo.properties[r];break;case d.WINDOW:delete e.$Co.properties[r];break;case d.RESOURCE:case d.LANGUAGE_OVERRIDABLE:delete e.$Do.properties[r],delete this.h.properties[r];break}}y(){for(const r of this.i.values()){const t=`[${r}]`,s={type:"object",description:k.localize(1655,null),errorMessage:k.localize(1656,null),$ref:e.$Eo};this.A(t,s),e.$yo.properties[t]=s,e.$zo.properties[t]=s,e.$Ao.properties[t]=s,e.$Bo.properties[t]=s,e.$Co.properties[t]=s,e.$Do.properties[t]=s}}z(){const r={type:"object",description:k.localize(1657,null),errorMessage:k.localize(1658,null),$ref:e.$Eo};e.$yo.patternProperties[e.$Go]=r,e.$zo.patternProperties[e.$Go]=r,e.$Ao.patternProperties[e.$Go]=r,e.$Bo.patternProperties[e.$Go]=r,e.$Co.patternProperties[e.$Go]=r,e.$Do.patternProperties[e.$Go]=r,this.j.fire()}A(r,t){const s=this.b.get(r)?.configurationDefaultOverrideValue;let o,l;s&&(!t.disallowConfigurationDefault||!s.source)&&(o=s.value,l=s.source),v.$mg(o)&&(o=t.defaultDefaultValue,l=void 0),v.$mg(o)&&(o=h(t.type)),t.default=o,t.defaultValueSource=l}}const f="\\[([^\\]]+)\\]",m=new RegExp(f,"g");e.$Go=`^(${f})+$`,e.$Ho=new RegExp(e.$Go);function I(n){const r=[];if(e.$Ho.test(n)){let t=m.exec(n);for(;t?.length;){const s=t[1].trim();s&&r.push(s),t=m.exec(n)}}return(0,S.$Mb)(r)}function b(n){return n.reduce((r,t)=>`${r}[${t}]`,"")}function h(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new p;w.$so.add(e.$xo.Configuration,$);function R(n,r){return n.trim()?e.$Ho.test(n)?k.localize(1660,null,n):$.getConfigurationProperties()[n]!==void 0?k.localize(1661,null,n):r.policy?.name&&$.getPolicyConfigurations().get(r.policy?.name)!==void 0?k.localize(1662,null,n,r.policy?.name,$.getPolicyConfigurations().get(r.policy?.name)):null:k.localize(1659,null)}function y(){const n=[],r=$.getConfigurationProperties();for(const t of Object.keys(r))n.push([t,r[t].scope]);return n.push(["launch",d.RESOURCE]),n.push(["task",d.RESOURCE]),n}function i(n){const r={};for(const t of n){const s=t.properties;if(v.$hg(s))for(const o in s)r[o]=s[o];t.allOf&&Object.assign(r,i(t.allOf))}return r}function c(n){switch(n){case"application":return d.APPLICATION;case"machine":return d.MACHINE;case"resource":return d.RESOURCE;case"machine-overridable":return d.MACHINE_OVERRIDABLE;case"language-overridable":return d.LANGUAGE_OVERRIDABLE;default:return d.WINDOW}}}),define(le[66],he([0,1,19,4,34,2,25,27,3,11,30,40,9,37]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$So=e.$Ro=e.$Qo=e.$Po=void 0,e.$To=y,S=be(S),v=be(v),O=be(O),w=be(w);function m(r){return Object.isFrozen(r)?r:O.$go(r)}class I{static createEmptyModel(t){return new I({},[],[],void 0,t)}constructor(t,s,o,l,g){this.b=t,this.c=s,this.d=o,this.raw=l,this.f=g,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof I)return s;const o=new b("",this.f);return o.parseRaw(s),o.configurationModel});this.g=t.reduce((s,o)=>o===s?o:s.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,d.$ij)(this.contents,t):this.contents}inspect(t,s){const o=this;return{get value(){return m(o.rawConfiguration.getValue(t))},get override(){return s?m(o.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return m(s?o.rawConfiguration.override(s).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const l=[];for(const{contents:g,identifiers:N,keys:T}of o.rawConfiguration.overrides){const A=new I(g,T,[],void 0,o.f).getValue(t);A!==void 0&&l.push({identifiers:N,value:A})}return l.length?m(l):void 0}}}getOverrideValue(t,s){const o=this.j(s);return o?t?(0,d.$ij)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const o of this.overrides)o.identifiers.includes(t)&&s.push(...o.keys);return S.$Mb(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return S.$Mb(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=O.$fo(this.contents),o=O.$fo(this.overrides),l=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const N of t)if(g.push(...N.raw?.length?N.raw:[N]),!N.isEmpty()){this.i(s,N.contents);for(const T of N.overrides){const[A]=o.filter(D=>S.$ub(D.identifiers,T.identifiers));A?(this.i(A.contents,T.contents),A.keys.push(...T.keys),A.keys=S.$Mb(A.keys)):o.push(O.$fo(T))}for(const T of N.keys)l.indexOf(T)===-1&&l.push(T)}return new I(s,l,o,g.every(N=>N instanceof I)?void 0:g,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const l of S.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let g=this.contents[l];const N=s[l];N&&(typeof g=="object"&&typeof N=="object"?(g=O.$fo(g),this.i(g,N)):g=N),o[l]=g}return new I(o,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const o of Object.keys(s)){if(o in t&&w.$hg(t[o])&&w.$hg(s[o])){this.i(t[o],s[o]);continue}t[o]=O.$fo(s[o])}}j(t){let s=null,o=null;const l=g=>{g&&(o?this.i(o,g):o=O.$fo(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===t?s=g.contents:g.identifiers.includes(t)&&l(g.contents);return l(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,d.$hj)(this.contents,t),u.$Ho.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>S.$ub(o.identifiers,(0,u.$Io)(t))),1))}k(t,s,o){if((0,d.$gj)(this.contents,t,s,l=>this.f.error(l)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),u.$Ho.test(t)){const l=(0,u.$Io)(t),g={identifiers:l,keys:Object.keys(this.contents[t]),contents:(0,d.$fj)(this.contents[t],T=>this.f.error(T))},N=this.overrides.findIndex(T=>S.$ub(T.identifiers,l));N!==-1?this.overrides[N]=g:this.overrides.push(g)}}}e.$Po=I;class b{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||I.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!w.$og(t)){const o=this.h(t);this.parseRaw(o,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:o,keys:l,overrides:g,restricted:N,hasExcludedProperties:T}=this.i(t,s);this.b=new I(o,l,g,T?[t]:void 0,this.g),this.c=N||[]}h(t){let s={},o=null,l=[];const g=[],N=[];function T(D){Array.isArray(l)?l.push(D):o!==null&&(l[o]=D)}const A={onObjectBegin:()=>{const D={};T(D),g.push(l),l=D,o=null},onObjectProperty:D=>{o=D},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const D=[];T(D),g.push(l),l=D,o=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:T,onError:(D,j,H)=>{N.push({error:D,offset:j,length:H})}};if(t)try{v.$7n(t,A),s=l[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return s}i(t,s){const o=f.$so.as(u.$xo.Configuration).getConfigurationProperties(),l=this.j(t,o,!0,s);t=l.raw;const g=(0,d.$fj)(t,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),N=Object.keys(t),T=this.l(t,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:g,keys:N,overrides:T,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(t,s,o,l){let g=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:g};const N={},T=[];for(const A in t)if(u.$Ho.test(A)&&o){const D=this.j(t[A],s,!1,l);N[A]=D.raw,g=g||D.hasExcludedProperties,T.push(...D.restricted)}else{const D=s[A],j=D?typeof D.scope<"u"?D.scope:u.ConfigurationScope.WINDOW:void 0;D?.restricted&&T.push(A),!l.exclude?.includes(A)&&(l.include?.includes(A)||(j===void 0||l.scopes===void 0||l.scopes.includes(j))&&!(l.skipRestricted&&D?.restricted))?N[A]=t[A]:g=!0}return{raw:N,restricted:T,hasExcludedProperties:g}}l(t,s){const o=[];for(const l of Object.keys(t))if(u.$Ho.test(l)){const g={};for(const N in t[l])g[N]=t[l][N];o.push({identifiers:(0,u.$Io)(l),keys:Object.keys(g),contents:(0,d.$fj)(g,s)})}return o}}e.$Qo=b;class h extends k.$Vc{constructor(t,s,o,l,g){super(),this.c=t,this.f=s,this.g=l,this.h=g,this.b=this.B(new P.$me),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),g),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,N=>N.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,N=>(N.isOperation(p.FileOperation.CREATE)||N.isOperation(p.FileOperation.COPY)||N.isOperation(p.FileOperation.DELETE)||N.isOperation(p.FileOperation.WRITE))&&o.isEqual(N.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return I.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ro=h;class ${constructor(t,s,o,l,g,N,T,A,D,j,H,Y,ne){this.a=t,this.b=s,this.c=o,this.overrideIdentifiers=l,this.d=g,this.f=N,this.g=T,this.h=A,this.i=D,this.j=j,this.k=H,this.l=Y,this.m=ne}get value(){return m(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class R{constructor(t,s,o,l,g,N,T,A,D,j){this.j=t,this.l=s,this.m=o,this.n=l,this.p=g,this.q=N,this.r=T,this.s=A,this.t=D,this.u=j,this.h=null,this.i=new L.$Bc,this.v=null}getValue(t,s,o){return this.w(t,s,o).getValue(t)}updateValue(t,s,o={}){let l;o.resource?(l=this.t.get(o.resource),l||(l=I.createEmptyModel(this.u),this.t.set(o.resource,l))):l=this.s,s===void 0?l.removeValue(t):l.setValue(t,s),o.resource||(this.h=null)}inspect(t,s,o){const l=this.w(t,s,o),g=this.A(s.resource,o),N=s.resource?this.t.get(s.resource)||this.s:this.s,T=new Set;for(const A of l.overrides)for(const D of A.identifiers)l.getOverrideValue(t,D)!==void 0&&T.add(D);return new $(t,s,l.getValue(t),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,g||void 0,N)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=[];if(!s){const{added:l,updated:g,removed:N}=c(this.j,t);s=[...l,...g,...N]}for(const l of s)for(const g of(0,u.$Io)(l)){const N=this.j.getKeysForOverrideIdentifier(g),T=t.getKeysForOverrideIdentifier(g),A=[...T.filter(D=>N.indexOf(D)===-1),...N.filter(D=>T.indexOf(D)===-1),...N.filter(D=>!O.$jo(this.j.override(g).getValue(D),t.override(g).getValue(D)))];o.push([g,A])}return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:o,removed:l}=c(this.l,t),g=[...s,...o,...l];return g.length&&this.updatePolicyConfiguration(t),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:o,removed:l,overrides:g}=c(this.applicationConfiguration,t),N=[...s,...o,...l];return N.length&&this.updateApplicationConfiguration(t),{keys:N,overrides:g}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:l,overrides:g}=c(this.localUserConfiguration,t),N=[...s,...o,...l];return N.length&&this.updateLocalUserConfiguration(t),{keys:N,overrides:g}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:l,overrides:g}=c(this.remoteUserConfiguration,t),N=[...s,...o,...l];return N.length&&this.updateRemoteUserConfiguration(t),{keys:N,overrides:g}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:l,overrides:g}=c(this.workspaceConfiguration,t),N=[...s,...o,...l];return N.length&&this.updateWorkspaceConfiguration(t),{keys:N,overrides:g}}compareAndUpdateFolderConfiguration(t,s){const o=this.folderConfigurations.get(t),{added:l,updated:g,removed:N,overrides:T}=c(o,s),A=[...l,...g,...N];return(A.length||!o)&&this.updateFolderConfiguration(t,s),{keys:A,overrides:T}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:l,removed:g,overrides:N}=c(s,void 0);return{keys:[...o,...l,...g],overrides:N}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,o){let l=this.x(s,o);return s.overrideIdentifier&&(l=l.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(l=l.merge(this.l)),l}x({resource:t},s){let o=this.y();if(s&&t){const l=s.getFolder(t);l&&(o=this.z(l.uri)||o);const g=this.t.get(t);g&&(o=o.merge(g))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const o=this.y(),l=this.r.get(t);l?(s=o.merge(l),this.i.set(t,s)):s=o}return s}A(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:o,overrides:l,keys:g}=this.r.get(s);return t.push([s,{contents:o,overrides:l,keys:g}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(l=>s.add(l))),[...s.values()]}static parse(t,s){const o=this.E(t.defaults,s),l=this.E(t.policy,s),g=this.E(t.application,s),N=this.E(t.user,s),T=this.E(t.workspace,s),A=t.folders.reduce((D,j)=>(D.set(a.URI.revive(j[0]),this.E(j[1],s)),D),new L.$Bc);return new R(o,l,g,N,I.createEmptyModel(s),T,A,I.createEmptyModel(s),new L.$Bc,s)}static E(t,s){return new I(t.contents,t.keys,t.overrides,void 0,s)}}e.$So=R;function y(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,s=new Map;for(const l of r)l.keys.forEach(g=>t.add(g)),l.overrides.forEach(([g,N])=>{const T=(0,L.$yc)(s,g,new Set);N.forEach(A=>T.add(A))});const o=[];return s.forEach((l,g)=>o.push([g,[...l.values()]])),{keys:[...t.values()],overrides:o}}class i{constructor(t,s,o,l,g){this.change=t,this.f=s,this.g=o,this.h=l,this.i=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const N of t.keys)this.affectedKeys.add(N);for(const[,N]of t.overrides)for(const T of N)this.affectedKeys.add(T);this.d=this.a;for(const N of this.affectedKeys)this.d+=N+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=R.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const o=this.a+t,l=this.d.indexOf(o);if(l<0)return!1;const g=l+o.length;if(g>=this.d.length)return!1;const N=this.d.charCodeAt(g);if(N!==this.b&&N!==this.c)return!1;if(s){const T=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,A=this.g.getValue(t,s,this.h);return!O.$jo(T,A)}return!0}}e.$Uo=i;function c(r,t){const{added:s,removed:o,updated:l}=n(t?.rawConfiguration,r?.rawConfiguration),g=[],N=r?.getAllOverrideIdentifiers()||[],T=t?.getAllOverrideIdentifiers()||[];if(t){const A=T.filter(D=>!N.includes(D));for(const D of A)g.push([D,t.getKeysForOverrideIdentifier(D)])}if(r){const A=N.filter(D=>!T.includes(D));for(const D of A)g.push([D,r.getKeysForOverrideIdentifier(D)])}if(t&&r){for(const A of N)if(T.includes(A)){const D=n({contents:r.getOverrideValue(void 0,A)||{},keys:r.getKeysForOverrideIdentifier(A)},{contents:t.getOverrideValue(void 0,A)||{},keys:t.getKeysForOverrideIdentifier(A)});g.push([A,[...D.added,...D.removed,...D.updated]])}}return{added:s,removed:o,updated:l,overrides:g}}function n(r,t){const s=r?t?r.keys.filter(g=>t.keys.indexOf(g)===-1):[...r.keys]:[],o=t?r?t.keys.filter(g=>r.keys.indexOf(g)===-1):[...t.keys]:[],l=[];if(r&&t){for(const g of t.keys)if(r.keys.indexOf(g)!==-1){const N=(0,d.$ij)(t.contents,g),T=(0,d.$ij)(r.contents,g);O.$jo(N,T)||l.push(g)}}return{added:s,removed:o,updated:l}}}),define(le[117],he([0,1,19,4,2,27,3,66,40,6,39,37]),function(Z,e,S,P,v,k,L,O,w,a,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=void 0;class p extends v.$Vc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new P.$me),this.onDidChangeConfiguration=this.a.event,this.b=O.$Po.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(u.$so.as(w.$xo.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:h})=>this.f(Array.from(b),h))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,h){this.j(b,u.$so.as(w.$xo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=O.$Po.createEmptyModel(this.c);const b=u.$so.as(w.$xo.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,h){const $=this.g();for(const R of b){const y=$[R],i=h[R];y!==void 0?this.b.setValue(R,y):i?this.b.setValue(R,i.default):this.b.removeValue(R)}}}e.$Vo=p;class f{constructor(){this.onDidChangeConfiguration=P.Event.None,this.configurationModel=O.$Po.createEmptyModel(new a.$ok)}async initialize(){return this.configurationModel}}e.$Wo=f;let m=class extends v.$Vc{get configurationModel(){return this.b}constructor(b,h,$){super(),this.c=b,this.f=h,this.g=$,this.a=this.B(new P.$me),this.onDidChangeConfiguration=this.a.event,this.b=O.$Po.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const h={},$=[],R=u.$so.as(w.$xo.Configuration).getConfigurationProperties();for(const y of b){const i=R[y];if(!i){$.push(y);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}$.push(y),h[i.policy.name]={type:i.type}}}return(0,L.$sg)(h)||await this.f.updatePolicyDefinitions(h),$}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const h=u.$so.as(w.$xo.Configuration).getPolicyConfigurations(),$=(0,S.$Hb)(b.map(R=>h.get(R)));this.m($,!0)}m(b,h){this.g.trace("PolicyConfiguration#update",b);const $=u.$so.as(w.$xo.Configuration).getConfigurationProperties(),R=[],y=this.b.isEmpty();for(const i of b){const c=$[i]?.policy?.name;if(c){const n=this.f.getPolicyValue(c);(y?n!==void 0:!(0,k.$jo)(this.b.getValue(i),n))&&R.push([i,n])}else this.b.getValue(i)!==void 0&&R.push([i,void 0])}if(R.length){this.g.trace("PolicyConfiguration#changed",R);const i=this.b;this.b=O.$Po.createEmptyModel(this.g);for(const c of i.keys)this.b.setValue(c,i.getValue(c));for(const[c,n]of R)n===void 0?this.b.removeValue(c):this.b.setValue(c,n);h&&this.a.fire(this.b)}}};e.$Xo=m,e.$Xo=m=Ee([oe(1,d.$uo),oe(2,a.$bk)],m)}),define(le[118],he([0,1,19,8,13,4,34,77,2,25,27,12,16,30,66,40,117,9,39]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=void 0;class R extends w.$Vc{constructor(c,n,r,t){super(),this.m=c,this.n=t,this.h=this.B(new k.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$Vo(t)),this.c=r instanceof $.$wo?new b.$Wo:this.B(new b.$Xo(this.b,r,t)),this.f=this.B(new m.$Ro(this.m,{},p.$$g,n,t)),this.a=new m.$So(this.b.configurationModel,this.c.configurationModel,m.$Po.createEmptyModel(t),m.$Po.createEmptyModel(t),m.$Po.createEmptyModel(t),m.$Po.createEmptyModel(t),new a.$Bc,m.$Po.createEmptyModel(t),new a.$Bc,t),this.j=new y(c,n,this),this.g=this.B(new P.$Sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:o})=>this.s(s,o))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[c,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new m.$So(c,n,m.$Po.createEmptyModel(this.n),r,m.$Po.createEmptyModel(this.n),m.$Po.createEmptyModel(this.n),new a.$Bc,m.$Po.createEmptyModel(this.n),new a.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(c,n){const r=typeof c=="string"?c:void 0,t=(0,f.$bj)(c)?c:(0,f.$bj)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue(c,n,r,t,s){const o=(0,f.$cj)(r)?r:(0,f.$bj)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,l=o?t:r;if(l!==void 0&&l!==f.ConfigurationTarget.USER_LOCAL&&l!==f.ConfigurationTarget.USER)throw new Error(`Unable to write ${c} to target ${l}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,S.$Mb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const g=this.inspect(c,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(g.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,d.$jo)(n,g.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(D=>(0,S.$ub)([...D.identifiers].sort(),T));A&&(o.overrideIdentifiers=A.identifiers)}const N=o?.overrideIdentifiers?.length?[(0,I.$Jo)(o.overrideIdentifiers),c]:[c];await this.j.write(N,n),await this.reloadConfiguration()}inspect(c,n={}){return this.a.inspect(c,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const c=await this.f.loadConfiguration();this.r(c)}r(c){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(c);this.u(r,n,f.ConfigurationTarget.USER)}s(c,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(c,n);this.u(t,r,f.ConfigurationTarget.DEFAULT)}t(c){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(c);this.u(r,n,f.ConfigurationTarget.DEFAULT)}u(c,n,r){const t=new m.$Uo(c,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$Yo=R;class y{constructor(c,n,r){this.b=c,this.c=n,this.d=r,this.a=new P.$Nh}write(c,n){return this.a.queue(()=>this.e(c,n))}async e(c,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===h.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const t=[];if((0,L.$Zn)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,c,n);r=(0,O.$eo)(r,s),await this.c.writeFile(this.b,v.$Oe.fromString(r))}f(c,n,r){const{tabSize:t,insertSpaces:s,eol:o}=this.h;if(!n.length){const l=JSON.stringify(r,null,s?" ".repeat(t):"	");return[{content:l,length:l.length,offset:0}]}return(0,O.$bo)(c,n,r,{tabSize:t,insertSpaces:s,eol:o})}get h(){if(!this.g){let c=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(c=n),this.g={eol:c,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[67],he([0,1,14]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=P,e.$jn=v,e.$kn=k,e.$ln=L;function P(w){return w.scheme===S.Schemas.vscodeRemote?w.authority:void 0}function v(w){if(!w)return;const a=w.indexOf("+");return a<0?w:w.substr(0,a)}function k(w){const{host:a,port:d}=O(w);if(typeof d>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:d}}function L(w,a){let{host:d,port:u}=O(w);return typeof u>"u"&&(u=a),{host:d,port:u}}function O(w){const a=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const d=w.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const u=w.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:w,port:void 0}}}),define(le[22],he([0,1,31,10,67]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$un=e.$tn=e.$sn=e.TargetPlatform=e.ExtensionType=e.$rn=e.$pn=e.$on=e.$nn=e.$mn=void 0,e.$qn=k,e.$vn=u,e.$wn=p,e.$xn=f,e.$yn=m,e.$zn=I,e.$An=b,S=be(S),e.$mn="extensions.user.cache",e.$nn="extensions.builtin.cache",e.$on="undefined_publisher",e.$pn=["ui","workspace","web"];function k(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$rn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(L||(e.ExtensionType=L={}));var O;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class w{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,R){if(typeof $>"u"||$===null)return typeof R>"u"||R===null;if(typeof R>"u"||R===null)return!1;if(typeof $=="string"||typeof R=="string"){const y=typeof $=="string"?$:$.value,i=typeof R=="string"?R:R.value;return S.$Gf(y,i)}return $._lower===R._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$sn=w;class a{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const R of $)this.add(R)}add($){this.c.add(w.toKey($))}delete($){return this.c.delete(w.toKey($))}has($){return this.c.has(w.toKey($))}}e.$tn=a;class d{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(w.toKey($))}get($){return this.c.get(w.toKey($))}has($){return this.c.has(w.toKey($))}set($,R){this.c.set(w.toKey($),R)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$un=d;function u(h){return p(h)}function p(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function f(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function m(h,$){if($){const R=`onResolveRemoteAuthority:${(0,v.$jn)($)}`;return!!h.activationEvents?.includes(R)}return!1}function I(h){return h.map($=>{const[R,y]=$.split("@");return{proposalName:R,version:y?parseInt(y):void 0}})}function b(h){return h.map($=>$.split("@")[0])}e.$Bn=(0,P.$Gi)("IBuiltinExtensionsScannerService")}),define(le[20],he([0,1,12,5,22,10]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.ExtensionManagementErrorCode=e.$np=e.ExtensionGalleryErrorCode=e.$mp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=O,e.$hp=w,e.$ip=a,e.$jp=d,e.$kp=u,e.$lp=p,e.$_o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ap=new RegExp(e.$_o),e.$bp="__web_extension",e.$cp="skipWalkthrough",e.$dp="extensionInstallSource",e.$ep="dependecyOrPackExtensionInstall",e.$fp="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function O(i){switch(i){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function w(i){switch(i){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function a(i,c){switch(i){case S.Platform.Windows:return c==="x64"?v.TargetPlatform.WIN32_X64:c==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case S.Platform.Linux:return c==="x64"?v.TargetPlatform.LINUX_X64:c==="arm64"?v.TargetPlatform.LINUX_ARM64:c==="arm"?v.TargetPlatform.LINUX_ARMHF:v.TargetPlatform.UNKNOWN;case"alpine":return c==="x64"?v.TargetPlatform.ALPINE_X64:c==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case S.Platform.Mac:return c==="x64"?v.TargetPlatform.DARWIN_X64:c==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case S.Platform.Web:return v.TargetPlatform.WEB}}function d(i,c){return c===v.TargetPlatform.WEB&&!i.includes(v.TargetPlatform.WEB)}function u(i,c,n){return d(c,n)?!1:i===v.TargetPlatform.UNDEFINED||i===v.TargetPlatform.UNIVERSAL?!0:i===v.TargetPlatform.UNKNOWN?!1:i===n}function p(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var f;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(f||(e.SortBy=f={}));var m;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var I;(function(i){i.Install="install",i.Uninstall="uninstall"})(I||(e.StatisticType=I={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$mp=(0,k.$Gi)("extensionGalleryService");var h;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting",i.Offline="Offline"})(h||(e.ExtensionGalleryErrorCode=h={}));class $ extends Error{constructor(c,n){super(c),this.code=n,this.name=n}}e.$np=$;var R;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(R||(e.ExtensionManagementErrorCode=R={}));class y extends Error{constructor(c,n){super(c),this.code=n,this.name=n}}e.$op=y,e.$pp=(0,k.$Gi)("extensionManagementService"),e.$qp="extensionsIdentifiers/disabled",e.$rp="extensionsIdentifiers/enabled",e.$sp=(0,k.$Gi)("IGlobalExtensionEnablementService"),e.$tp=(0,k.$Gi)("IExtensionTipsService"),e.$up=(0,P.localize2)(1771,"Extensions"),e.$vp=(0,P.localize2)(1772,"Preferences")}),define(le[119],he([0,1,2,22,9]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;class k extends S.$Vc{constructor(O,w,a,d,u){super(),this.a=O,this.b=w,this.c=a,this.f=u,this.B(d.onDidInstallExtensions(p=>this.g(p))),this.B(d.onDidUninstallExtension(p=>this.h(p)))}g(O){for(const w of O)w.local&&this.invalidate(w.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const w of this.a.profiles)this.c.extUri.isEqual(w.extensionsResource,O)&&await this.j(w);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,P.$mn))}catch(w){(0,v.$sl)(w)!==v.FileOperationResult.FILE_NOT_FOUND&&this.f.error(w)}}}e.$Xq=k});var qe=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[44],he([0,1,16,57,5,45,22,98]),function(Z,e,S,P,v,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=d,e.$2p=u,e.$3p=p,e.$4p=f,e.$5p=m,e.$6p=I,e.$7p=b,e.$8p=h,P=qe(P),v=be(v),k=be(k);const w=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function d(y){return y=y.trim(),y==="*"||w.test(y)}function u(y){if(!d(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=y.match(w);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function p(y){if(!y)return null;const i=y.majorBase,c=y.majorMustEqual,n=y.minorBase;let r=y.minorMustEqual;const t=y.patchBase;let s=y.patchMustEqual;y.hasCaret&&(i===0||(r=!1),s=!1);let o=0;if(y.preRelease){const l=a.exec(y.preRelease);if(l){const[,g,N,T]=l;o=Date.UTC(Number(g),Number(N)-1,Number(T))}}return{majorBase:i,majorMustEqual:c,minorBase:n,minorMustEqual:r,patchBase:t,patchMustEqual:s,isMinimum:y.hasGreaterEquals,notBefore:o}}function f(y,i,c){let n;typeof y=="string"?n=p(u(y)):n=y;let r;i instanceof Date?r=i.getTime():typeof i=="string"&&(r=new Date(i).getTime());let t;if(typeof c=="string"?t=p(u(c)):t=c,!n||!t)return!1;const s=n.majorBase,o=n.minorBase,l=n.patchBase;let g=t.majorBase,N=t.minorBase,T=t.patchBase;const A=t.notBefore;let D=t.majorMustEqual,j=t.minorMustEqual,H=t.patchMustEqual;return t.isMinimum?s>g?!0:s<g?!1:o>N?!0:o<N||r&&r<A?!1:l>=T:(s===1&&g===0&&(!D||!j||!H)&&(g=1,N=0,T=0,D=!0,j=!1,H=!1),s<g?!1:s>g?!D:o<N?!1:o>N?!j:l<T?!1:l>T?!H:!(r&&r<A))}function m(y,i,c,n,r,t){const s=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return s.push([P.default.Error,v.localize(1823,null)]),s;if(typeof n.name!="string")return s.push([P.default.Error,v.localize(1824,null,"name")]),s;if(typeof n.version!="string")return s.push([P.default.Error,v.localize(1825,null,"version")]),s;if(!n.engines)return s.push([P.default.Error,v.localize(1826,null,"engines")]),s;if(typeof n.engines.vscode!="string")return s.push([P.default.Error,v.localize(1827,null,"engines.vscode")]),s;if(typeof n.extensionDependencies<"u"&&!R(n.extensionDependencies))return s.push([P.default.Error,v.localize(1828,null,"extensionDependencies")]),s;if(typeof n.activationEvents<"u"){if(!R(n.activationEvents))return s.push([P.default.Error,v.localize(1829,null,"activationEvents")]),s;if(typeof n.main>"u"&&typeof n.browser>"u")return s.push([P.default.Error,v.localize(1830,null,"activationEvents","main","browser")]),s}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&s.push([P.default.Warning,v.localize(1831,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return s.push([P.default.Error,v.localize(1832,null,"main")]),s;{const g=(0,S.$hh)(c,n.main);(0,S.$bh)(g,c)||s.push([P.default.Warning,v.localize(1833,null,g.path,c.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return s.push([P.default.Error,v.localize(1834,null,"browser")]),s;{const g=(0,S.$hh)(c,n.browser);(0,S.$bh)(g,c)||s.push([P.default.Warning,v.localize(1835,null,g.path,c.path)])}}if(!k.valid(n.version))return s.push([P.default.Error,v.localize(1836,null)]),s;const o=[];if(!I(y,i,n,r,o))for(const g of o)s.push([P.default.Error,g]);if(t&&n.enabledApiProposals?.length){const g=[];if(!h([...n.enabledApiProposals],g))for(const N of g)s.push([P.default.Error,N])}return s}function I(y,i,c,n,r){return n||typeof c.main>"u"&&typeof c.browser>"u"?!0:$(y,i,c.engines.vscode,r)}function b(y,i,c){return y==="*"||$(i,c,y)}function h(y,i){if(y.length===0)return!0;const c=Array.isArray(i)?i:void 0,n=(c?void 0:i)??O.allApiProposals,r=[],t=(0,L.$zn)(y);for(const{proposalName:s,version:o}of t){const l=n[s];l&&o&&l.version!==o&&r.push(v.localize(1837,null,s))}return c?.push(...r),r.length===0}function $(y,i,c,n=[]){const r=p(u(c));if(!r)return n.push(v.localize(1838,null,c)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return n.push(v.localize(1839,null,c)),!1}else if(!r.majorMustEqual)return n.push(v.localize(1840,null,c)),!1;return f(y,i,r)?!0:(n.push(v.localize(1841,null,y,c)),!1)}function R(y){if(!Array.isArray(y))return!1;for(let i=0,c=y.length;i<c;i++)if(typeof y[i]!="string")return!1;return!0}}),define(le[68],he([0,1,21,2,12,5,20,10]),function(Z,e,S,P,v,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=void 0,e.$_r=w;function w(d){return d.tags.find(u=>u.startsWith("lp-"))?.split("lp-")[1]}e.$as=(0,O.$Gi)("languagePackService");let a=class extends P.$Vc{constructor(u){super(),this.c=u}async getAvailableLanguages(){const u=new S.$xe;setTimeout(()=>u.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},u.token)}catch{return[]}const m=p.firstPage.filter(I=>I.properties.localizedLanguages?.length&&I.tags.some(b=>b.startsWith("lp-"))).map(I=>{const b=I.properties.localizedLanguages?.[0],h=w(I);return{...this.f(h,b,I),extensionId:I.identifier.id,galleryExtension:I}});return m.push(this.f("en","English")),m}f(u,p,f){const m=p??u;let I;if(m!==u&&(I=`(${u})`),u.toLowerCase()===v.$x.toLowerCase()&&(I??="",I+=(0,k.localize)(1919,null)),f?.installCount){I??="";const b=f.installCount;let h;b>1e6?h=`${Math.floor(b/1e5)/10}M`:b>1e3?h=`${Math.floor(b/1e3)}K`:h=String(b),I+=` $(cloud-download) ${h}`}return{id:u,label:m,description:I}}};e.$bs=a,e.$bs=a=Ee([oe(0,L.$mp)],a)}),define(le[46],he([0,1,13,7,2,5,40,10,6,37]),function(Z,e,S,P,v,k,L,O,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0,e.$$p=p,e.$_p=f,e.$aq=m,e.$bq=I,e.$cq=b,e.$dq=h,e.$9p=(0,O.$Gi)("requestService");class d{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const c in this.b)c.toLowerCase()==="authorization"||c.toLowerCase()==="proxy-authorization"?i[c]="*****":i[c]=this.b[c];this.a=i}return this.a}}class u extends v.$Vc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,k.localize)(2041,null),when:w.$tk.isEqualTo((0,w.$qk)(w.LogLevel.Trace)).serialize()})}async c(i,c,n){const r=`${i} #${++this.b}: ${c.url}`;this.a.trace(`${r} - begin`,c.type,new d(c.headers??{}));try{const t=await n();return this.a.trace(`${r} - end`,c.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,c.type,(0,P.$0)(t)),t}}}e.$0p=u;function p(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}function f(y){return y.res.statusCode===204}async function m(y){return f(y)?null:(await(0,S.$1e)(y.stream)).toString()}async function I(y){if(!p(y))throw new Error("Server returned "+y.res.statusCode);return m(y)}async function b(y){if(!p(y))throw new Error("Server returned "+y.res.statusCode);if(f(y))return null;const c=(await(0,S.$1e)(y.stream)).toString();try{return JSON.parse(c)}catch(n){throw n.message+=`:
`+c,n}}function h(y){R(y)}let $;function R(y){const i=a.$so.as(L.$xo.Configuration),c=$;$={id:"http",order:15,title:(0,k.localize)(2042,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2043,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(2044,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(2045,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(2046,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(2047,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(2048,null),(0,k.localize)(2049,null),(0,k.localize)(2050,null),(0,k.localize)(2051,null)],default:"override",description:(0,k.localize)(2052,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(2053,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(2054,null),restricted:!0}}},i.updateConfigurations({add:[$],remove:c?[c]:[]})}R(L.ConfigurationScope.APPLICATION)}),define(le[120],he([0,1,21,14,9,46]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0;let L=class{constructor(w,a){this.a=w,this.b=a}async download(w,a,d=S.CancellationToken.None){if(w.scheme===P.Schemas.file||w.scheme===P.Schemas.vscodeRemote){await this.b.copy(w,a);return}const u={type:"GET",url:w.toString(!0)},p=await this.a.request(u,d);if(p.res.statusCode===200)await this.b.writeFile(a,p.stream);else{const f=await(0,k.$bq)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${f}`)}}};e.$4R=L,e.$4R=L=Ee([oe(0,k.$9p),oe(1,v.$bl)],L)}),define(le[121],he([0,1,122,3]),function(Z,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=k;function v(L,O){return L.protocol==="http:"?O.HTTP_PROXY||O.http_proxy||null:L.protocol==="https:"&&(O.HTTPS_PROXY||O.https_proxy||O.HTTP_PROXY||O.http_proxy)||null}async function k(L,O,w={}){const a=(0,S.parse)(L),d=w.proxyUrl||v(a,O);if(!d)return null;const u=(0,S.parse)(d);if(!/^https?:$/.test(u.protocol||""))return null;const p={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,P.$lg)(w.strictSSL)?w.strictSSL:!0};if(a.protocol==="http:"){const f=await new Promise((m,I)=>{Z(["http-proxy-agent"],m,I)}).then(be);return new f.HttpProxyAgent(d,p)}else{const f=await new Promise((m,I)=>{Z(["https-proxy-agent"],m,I)}).then(be);return new f.HttpsProxyAgent(d,p)}}}),define(le[123],he([0,1,60,15,5,21,38,7,12,28,86,153,8,79]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=I;let m;async function I(h,$,R,y){return R["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.$Lm)(y)&&!R["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.$Lm)(y)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=p.Promises.withAsyncBody(async(i,c)=>{const n=new k.$xe;let r=1e4;const t=h.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,f.$Mm)(t,1,120)*1e3);const s=setTimeout(()=>{n.dispose(!0),c(new Error((0,v.localize)(2055,null)))},r);try{i(await b($,n.token))}catch(o){!(0,O.$4)(o)&&!n.token.isCancellationRequested?c(new Error((0,v.localize)(2056,null,(0,L.$rj)(o)))):i({})}finally{clearTimeout(s),n.dispose()}})),m)}async function b(h,$){const R=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",R);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",y);const i=(0,a.$3g)().replace(/-/g,"").substr(0,12),c=new RegExp(i+"({.*})"+i),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",n);const r=await(0,d.$Bm)(w.OS,n);return h.trace("getUnixShellEnvironment#shell",r),new Promise((t,s)=>{if($.isCancellationRequested)return s(new O.$5);const o=(0,P.$oc)(r);let l,g;const N="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${N} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,g=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${N} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,g=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,g=["-i","-l","-c"]):(l=`'${process.execPath}' ${N} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?g=["-ic"]:g=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),l);const T=(0,S.spawn)(r,[...g,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});$.onCancellationRequested(()=>(T.kill(),s(new O.$5))),T.on("error",j=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,L.$rj)(j)),s(j)});const A=[];T.stdout.on("data",j=>A.push(j));const D=[];T.stderr.on("data",j=>D.push(j)),T.on("close",(j,H)=>{const Y=Buffer.concat(A).toString("utf8");h.trace("getUnixShellEnvironment#raw",Y);const ne=Buffer.concat(D).toString("utf8");if(ne.trim()&&h.trace("getUnixShellEnvironment#stderr",ne),j||H)return s(new Error((0,v.localize)(2057,null,j,H)));const ae=c.exec(Y),ue=ae?ae[1]:"{}";try{const me=JSON.parse(ue);R?me.ELECTRON_RUN_AS_NODE=R:delete me.ELECTRON_RUN_AS_NODE,y?me.ELECTRON_NO_ATTACH_CONSOLE=y:delete me.ELECTRON_NO_ATTACH_CONSOLE,delete me.VSCODE_RESOLVING_ENVIRONMENT,delete me.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",me),t(me)}catch(me){h.error("getUnixShellEnvironment#errorCaught",(0,L.$rj)(me)),s(me)}})})}}),define(le[124],he([0,1,10]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GR=e.$FR=void 0,e.$FR=(0,S.$Gi)("stateReadService"),e.$GR=(0,S.$Gi)("stateService")}),define(le[69],he([0,1,8,13,2,3,17,9,6]),function(Z,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JR=e.$IR=e.$HR=e.SaveStrategy=void 0;var a;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class d extends v.$Vc{constructor(m,I,b,h){super(),this.h=m,this.j=I,this.m=b,this.n=h,this.a=Object.create(null),this.b="",this.c=this.B(new S.$Eh(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.m.error(m)}}getItem(m,I){const b=this.a[m];return(0,k.$og)(b)?I:b}setItem(m,I){this.setItems([{key:m,data:I}])}setItems(m){let I=!1;for(const{key:b,data:h}of m)this.a[b]!==h&&((0,k.$og)(h)?(0,k.$mg)(this.a[b])||(this.a[b]=void 0,I=!0):(this.a[b]=h,I=!0));I&&this.s()}removeItem(m){(0,k.$mg)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,P.$Oe.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(I){this.m.error(I)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$HR=d;let u=class extends v.$Vc{constructor(m,I,b,h){super(),this.a=this.B(new d(I.stateResource,m,b,h))}async init(){await this.a.init()}getItem(m,I){return this.a.getItem(m,I)}};e.$IR=u,e.$IR=u=Ee([oe(1,L.$Ni),oe(2,w.$bk),oe(3,O.$bl)],u);class p extends u{setItem(m,I){this.a.setItem(m,I)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$JR=p}),define(le[70],he([0,1,12,36,28]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=L,e.$xp=O;function k(w){if(S.$v===S.Platform.Linux&&/^penguin(\.|$)/i.test(w))return"chromebook"}function L(w,a,d,u,p,f,m,I,b,h){const $=Object.create(null);$["common.machineId"]=f,$["common.sqmId"]=m,$["common.devDeviceId"]=I,$.sessionID=(0,v.$3g)()+Date.now(),$.commitHash=u,$.version=p,$["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,S.$i)(S.$v),$["common.nodePlatform"]=P.$ec,$["common.nodeArch"]=d,$["common.product"]=h||"desktop",b&&($["common.msftInternal"]=b);let R=0;const y=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),S.$m&&($["common.snap"]="true");const i=k(a);return i&&($["common.platformDetail"]=i),$}function O(w){const a=P.env.USERDNSDOMAIN;if(!a)return!1;const d=a.toLowerCase();return w.some(u=>d===u)}}),define(le[18],he([0,1,10]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am=(0,S.$Gi)("telemetryService"),e.$bm=(0,S.$Gi)("customEndpointTelemetryService"),e.$cm="telemetry.currentSessionDate",e.$dm="telemetry.firstSessionDate",e.$em="telemetry.lastSessionDate",e.$fm="telemetry.machineId",e.$gm="telemetry.sqmId",e.$hm="telemetry.devDeviceId",e.$im="telemetry",e.$jm="telemetry.telemetryLevel",e.$km="telemetry.enableCrashReporter",e.$lm="telemetry.enableTelemetry";var P;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var v;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(v||(e.TelemetryConfiguration=v={}))}),define(le[71],he([0,1,7,10,6,18]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.ExtensionSignatureVerificationCode=e.$uq=void 0,e.$uq=(0,P.$Gi)("IExtensionSignatureVerificationService");var L;(function(a){a.Success="Success",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(L||(e.ExtensionSignatureVerificationCode=L={}));class O extends Error{constructor(d){super(d),this.code=d}}e.$vq=O;let w=class{constructor(d,u){this.b=d,this.c=u}d(){return this.a||(this.a=new Promise((d,u)=>Z(["@vscode/vsce-sign"],async p=>d(p),u))),this.a}async verify(d,u,p,f){let m;const I=d.identifier.id;try{m=await this.d()}catch(R){return this.b.error("Could not load vsce-sign module",(0,S.$0)(R)),this.b.info(`Extension signature verification is not done: ${I}`),!1}const b=new Date().getTime();let h;try{this.b.trace(`Verifying extension signature for ${I}...`),h=await m.verify(u,p,this.b.getLevel()===v.LogLevel.Trace)}catch(R){h={code:L.UnknownError,didExecute:!1,output:(0,S.$0)(R)}}const $=new Date().getTime()-b;if(this.b.info(`Extension signature verification result for ${I}: ${h.code}. Executed: ${h.didExecute}. Duration: ${$}ms.`),this.b.trace(`Extension signature verification output for ${I}:
${h.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:I,extensionVersion:d.version,code:h.code,internalCode:h.internalCode,duration:$,didExecute:h.didExecute,clientTargetPlatform:f}),h.code===L.Success)return!0;throw new O(h.code)}};e.$wq=w,e.$wq=w=Ee([oe(0,v.$bk),oe(1,k.$am)],w)}),define(le[41],he([0,1,27,3,67,70,18]),function(Z,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=void 0,e.$Fp=d,e.$Gp=u,e.$Hp=p,e.$Ip=f,e.$Jp=I,e.$Kp=h,e.$Lp=$,e.$Mp=i;class O{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$yp=O;class w{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$zp=w,e.$Ap=new w;class a{async publicLog(n,r,t){}async publicLogError(n,r,t){}}e.$Bp=a,e.$Cp="telemetry",e.$Dp="extensionTelemetryLog",e.$Ep={log:()=>null,flush:()=>Promise.resolve(null)};function d(c,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!c.enableTelemetry)}function u(c,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}function p(c){const n=c.getValue(L.$jm),r=c.getValue(L.$km);if(c.getValue(L.$lm)===!1||r===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function f(c){const n={},r={},t={};b(c,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const o=t[s];typeof o=="number"?r[s]=o:typeof o=="boolean"?r[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),n[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[s]=o)}return{properties:n,measurements:r}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function I(c){if(!c)return"none";const n=(0,v.$jn)(c);return m.has(n)?n:"other"}function b(c,n,r=0,t){if(c)for(const s of Object.getOwnPropertyNames(c)){const o=c[s],l=t?t+s:s;Array.isArray(o)?n[l]=(0,S.$ko)(o):o instanceof Date?n[l]=o.toISOString():(0,P.$hg)(o)?r<2?b(o,n,r+1,l+"."):n[l]=(0,S.$ko)(o):n[l]=o}}function h(c,n){const r=c.msftInternalDomains||[],t=n.getValue("telemetry.internalTesting");return(0,k.$xp)(r)||t}function $(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}function R(c,n){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let r=c;const t=[];for(const g of n)for(;;){const N=g.exec(c);if(!N)break;t.push([N.index,g.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(r="";;){const g=o.exec(c);if(!g)break;const N=t.some(([T,A])=>g.index<A&&T<o.lastIndex);!s.test(g[0])&&!N&&(r+=c.substring(l,g.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<c.length&&(r+=c.substr(l)),r}function y(c){if(!c)return c;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(c))return`<REDACTED: ${r.label}>`;return c}function i(c,n){return(0,S.$ho)(c,r=>{if(r instanceof O||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let t=r.replaceAll("%20"," ");t=R(t,n);for(const s of n)t=t.replace(s,"");return t=y(t),t}})}}),define(le[26],he([0,1,31,20,22,12,11,7,36,41]),function(Z,e,S,P,v,k,L,O,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Op=void 0,e.$Np=d,e.$Pp=m,e.$Qp=I,e.$Rp=b,e.$Sp=h,e.$Tp=$,e.$Up=R,e.$Vp=y,e.$Xp=i,e.$Yp=n;function d(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,S.$Bf)(r.id,t.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new p(t.identifier,s,o)}static parse(t){const s=u.exec(t);return s&&s[1]&&s[2]?new p({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o=v.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof p?d(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Op=p;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const t=f.exec(r);return t&&t[1]?[b(t[1]),t[2]]:[b(r),void 0]}function I(r,t){return`${r}.${t}`}function b(r){return r.toLowerCase()}function h(r,t){return b(I(r??v.$on,t))}function $(r,t){const s=[],o=l=>{for(const g of s)if(g.some(N=>d(t(N),t(l))))return g;return null};for(const l of r){const g=o(l);g?g.push(l):s.push([l])}return s}function R(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function y(r){return{id:new a.$yp(r.identifier.id),name:new a.$yp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Wp=new v.$sn("pprice.better-merge");function i(r,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(g=>!d(g.identifier,{id:l}))){const g=r.filter(N=>d(N.identifier,{id:l}));g.length===1&&(s.push(g[0]),o.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function c(r,t){if(!k.$l)return!1;let s;try{s=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,O.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,t){const s=await c(r,t),o=(0,P.$ip)(s?"alpine":k.$v,w.$fc);return t.debug("ComputeTargetPlatform:",o),o}}),define(le[125],he([0,1,21,7,14,16,45,11,5,20,26,22]),function(Z,e,S,P,v,k,L,O,w,a,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=void 0;const p=I=>(0,w.localize)(1773,null,I),f=(0,w.localize)(1774,null,"ms-dotnettools.csharp");let m=class{constructor(b,h,$){this.a=b,this.b=h,this.d=$}get f(){}async listExtensions(b,h,$){let R=await this.b.getInstalled(u.ExtensionType.User,$);const y=u.$rn.map(c=>c.toLowerCase());if(h&&h!==""){if(y.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}R=R.filter(c=>c.manifest.categories?c.manifest.categories.map(r=>r.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),y.forEach(c=>{this.a.info(c)});return}this.f&&this.a.info((0,w.localize)(1775,null,this.f)),R=R.sort((c,n)=>c.identifier.id.localeCompare(n.identifier.id));let i;for(const c of R)i!==c.identifier.id&&(i=c.identifier.id,this.a.info(b?`${i}@${c.manifest.version}`:i))}async installExtensions(b,h,$,R){const y=[];try{b.length&&this.a.info(this.f?(0,w.localize)(1776,null,this.f):(0,w.localize)(1777,null));const i=[],c=[],n=(t,s,o)=>{c.push({id:t,version:s!=="prerelease"?s:void 0,installOptions:{...$,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||$.installPreReleaseVersion}})};for(const t of b)if(t instanceof O.URI)i.push({vsix:t,installOptions:$});else{const[s,o]=(0,d.$Pp)(t);n(s,o,!1)}for(const t of h)if(t instanceof O.URI)i.push({vsix:t,installOptions:{...$,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,d.$Pp)(t);n(s,o,!0)}const r=await this.b.getInstalled(void 0,$.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:t,installOptions:s})=>{try{await this.h(t,s,R,r)}catch(o){this.a.error(o),y.push(t.toString())}})),c.length){const t=await this.g(c,r,R);y.push(...t)}}catch(i){throw this.a.error((0,w.localize)(1778,null,(0,P.$0)(i))),i}if(y.length)throw new Error((0,w.localize)(1779,null,y.join(", ")))}async updateExtensions(b){const h=await this.b.getInstalled(u.ExtensionType.User,b),$=[];for(const c of h)c.identifier.uuid&&$.push({...c.identifier,preRelease:c.preRelease});this.a.trace((0,w.localize)(1780,null,$.length));const R=await this.d.getExtensions($,{compatible:!0},S.CancellationToken.None),y=[];for(const c of R)for(const n of h)(0,d.$Np)(n.identifier,c.identifier)&&(0,L.gt)(c.version,n.manifest.version)&&y.push({extension:c,options:{operation:a.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:b,isApplicationScoped:n.isApplicationScoped}});if(!y.length){this.a.info((0,w.localize)(1781,null));return}this.a.info((0,w.localize)(1782,null,y.map(c=>c.extension.identifier.id).join(", ")));const i=await this.b.installGalleryExtensions(y);for(const c of i)c.error?this.a.error((0,w.localize)(1783,null,c.identifier.id,(0,P.$0)(c.error))):this.a.info((0,w.localize)(1784,null,c.identifier.id,c.local?.manifest.version))}async g(b,h,$){if(b=b.filter(({id:c,version:n})=>{const r=h.find(t=>(0,d.$Np)(t.identifier,{id:c}));if(r){if(!$&&(!n||n==="prerelease"&&r.preRelease))return this.a.info((0,w.localize)(1785,null,c,r.manifest.version,c)),!1;if(n&&r.manifest.version===n)return this.a.info((0,w.localize)(1786,null,`${c}@${n}`)),!1}return!0}),!b.length)return[];const R=[],y=[],i=await this.j(b);if(await Promise.all(b.map(async({id:c,version:n,installOptions:r})=>{const t=i.get(c.toLowerCase());if(!t){this.a.error(`${p(n?`${c}@${n}`:c)}
${f}`),R.push(c);return}try{const o=await this.d.getManifest(t,S.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),R.push(c);return}const s=h.find(o=>(0,d.$Np)(o.identifier,t.identifier));if(s){if(t.version===s.manifest.version){this.a.info((0,w.localize)(1787,null,n?`${c}@${n}`:c));return}this.a.info((0,w.localize)(1788,null,c,t.version))}r.isBuiltin?this.a.info(n?(0,w.localize)(1789,null,c,n):(0,w.localize)(1790,null,c)):this.a.info(n?(0,w.localize)(1791,null,c,n):(0,w.localize)(1792,null,c)),y.push({extension:t,options:{...r,installGivenVersion:!!n,isApplicationScoped:r.isApplicationScoped||s?.isApplicationScoped}})})),y.length){const c=await this.b.installGalleryExtensions(y);for(const n of c)n.error?(this.a.error((0,w.localize)(1793,null,n.identifier.id,(0,P.$0)(n.error))),R.push(n.identifier.id)):this.a.info((0,w.localize)(1794,null,n.identifier.id,n.local?.manifest.version))}return R}async h(b,h,$,R){const y=await this.b.getManifest(b);if(!y)throw new Error("Invalid vsix");if(await this.l(y,$,h.profileLocation,R))try{await this.b.install(b,{...h,installGivenVersion:!0}),this.a.info((0,w.localize)(1795,null,(0,k.$eh)(b)))}catch(c){if((0,P.$4)(c))this.a.info((0,w.localize)(1796,null,(0,k.$eh)(b)));else throw c}}async j(b){const h=new Map,$=b.some(i=>i.installOptions.installPreReleaseVersion),R=await this.b.getTargetPlatform(),y=[];for(const i of b)a.$ap.test(i.id)&&y.push({...i,preRelease:$});if(y.length){const i=await this.d.getExtensions(y,{targetPlatform:R},S.CancellationToken.None);for(const c of i)h.set(c.identifier.id.toLowerCase(),c)}return h}k(b){return!0}async l(b,h,$,R){if(!h){const y={id:(0,d.$Sp)(b.publisher,b.name)},i=R.find(c=>(0,d.$Np)(y,c.identifier)&&(0,L.gt)(c.manifest.version,b.version));if(i)return this.a.info((0,w.localize)(1797,null,i.identifier.id,i.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,h,$){const R=async i=>{if(i instanceof O.URI){const c=await this.b.getManifest(i);return(0,d.$Qp)(c.publisher,c.name)}return i},y=[];for(const i of b){const c=await R(i),r=(await this.b.getInstalled(void 0,$)).filter(t=>(0,d.$Np)(t.identifier,{id:c}));if(!r.length)throw new Error(`${this.m(c)}
${f}`);if(r.some(t=>t.type===u.ExtensionType.System)){this.a.info((0,w.localize)(1798,null,c));return}if(!h&&r.some(t=>t.isBuiltin)){this.a.info((0,w.localize)(1799,null,c));return}this.a.info((0,w.localize)(1800,null,c));for(const t of r)await this.b.uninstall(t,{profileLocation:$}),y.push(t);this.f?this.a.info((0,w.localize)(1801,null,c,this.f)):this.a.info((0,w.localize)(1802,null,c))}}async locateExtension(b){const h=await this.b.getInstalled();b.forEach($=>{h.forEach(R=>{if(R.identifier.id===$&&R.location.scheme===v.Schemas.file){this.a.info(R.location.fsPath);return}})})}m(b){return this.f?(0,w.localize)(1803,null,b,this.f):(0,w.localize)(1804,null,b)}};e.$xq=m,e.$xq=m=Ee([oe(1,a.$pp),oe(2,a.$mp)],m)}),define(le[126],he([0,1,7,4,2,25,26,22,9]),function(Z,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class a extends v.$Vc{constructor(u,p,f,m,I,b,h){super(),this.f=u,this.g=p,this.h=f,this.j=m,this.m=I,this.n=b,this.r=h,this.a=this.B(new P.$me),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new v.$5c),this.s().then(null,$=>h.error("Error while initializing Extensions Watcher",(0,S.$0)($)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(u=>this.u(u.added))),this.B(this.j.onAddExtensions(u=>this.w(u))),this.B(this.j.onDidAddExtensions(u=>this.y(u))),this.B(this.j.onRemoveExtensions(u=>this.z(u))),this.B(this.j.onDidRemoveExtensions(u=>this.C(u))),this.B(this.n.onDidFilesChange(u=>this.D(u)))}async u(u){try{u.length&&await Promise.all(u.map(p=>(this.c.set(p.id,(0,v.$Sc)(this.n.watch(this.m.extUri.dirname(p.extensionsResource)),this.n.watch(p.extensionsResource))),this.G(p.extensionsResource))))}catch(p){throw this.r.error(p),p}}async w(u){for(const p of u.extensions)this.I(this.L(p.identifier,p.version),u.profileLocation)}async y(u){for(const p of u.extensions){const f=this.L(p.identifier,p.version);u.error?this.J(f,u.profileLocation):this.I(f,u.profileLocation)}}async z(u){for(const p of u.extensions)this.J(this.L(p.identifier,p.version),u.profileLocation)}async C(u){const p=[],f=[];for(const m of u.extensions){const I=this.L(m.identifier,m.version);u.error?this.I(I,u.profileLocation):(this.J(I,u.profileLocation),this.b.has(I)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),f.push(this.f.scanInstalledExtensionAtLocation(m.location).then(b=>{b?p.push(b):this.r.info("Extension not found at the location",m.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(f),p.length&&await this.H(p)}catch(m){this.r.error(m)}}D(u){for(const p of this.h.profiles)u.contains(p.extensionsResource,w.FileChangeType.UPDATED,w.FileChangeType.ADDED)&&this.F(p.extensionsResource)}async F(u){const p=[],f=[],m=await this.j.scanProfileExtensions(u),I=new Set,b=new Set;for(const[h,$]of this.b)$.has(u)&&b.add(h);for(const h of m){const $=this.L(h.identifier,h.version);I.add($),b.has($)||(p.push(h.identifier),this.I($,u))}for(const h of b)if(!I.has(h)){const $=this.M(h);$&&(f.push($.identifier),this.J(h,u))}(p.length||f.length)&&this.a.fire({added:p.length?{extensions:p,profileLocation:u}:void 0,removed:f.length?{extensions:f,profileLocation:u}:void 0})}async G(u){const p=await this.j.scanProfileExtensions(u);for(const f of p)this.I(this.L(f.identifier,f.version),u)}async H(u){u||(u=(await this.f.scanAllUserInstalledExtensions()).filter(f=>!this.b.has(this.L(f.identifier,f.manifest.version)))),u.length&&await this.f.markAsUninstalled(...u)}I(u,p){let f=this.b.get(u);f||this.b.set(u,f=new k.$Cc(m=>this.m.extUri.getComparisonKey(m))),f.add(p)}J(u,p){const f=this.b.get(u);f&&f.delete(p),f?.size||this.b.delete(u)}L(u,p){return`${O.$sn.toKey(u.id)}@${p}`}M(u){const[p,f]=(0,L.$Pp)(u);return f?{identifier:{id:p},version:f}:void 0}}e.$Yq=a}),define(le[127],he([0,1,32,154,19,8,2,14,15,29,17,20,26,6,68,11]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0,S=be(S);let b=class extends m.$bs{constructor(y,i,c,n){super(c),this.h=y,this.j=n,this.g=this.B(new h(i,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(y,i){const n=(await this.g.getLanguagePacks())[i];if(!n){this.j.warn(`No language pack found for ${i}`);return}const r=n.translations[y];return r?I.URI.file(r):void 0}async getInstalledLanguages(){const y=await this.g.getLanguagePacks(),i=Object.keys(y).map(c=>{const n=y[c];return{...this.f(c,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return i.push(this.f("en","English")),i.sort((c,n)=>c.label.localeCompare(n.label)),i}async m(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",y.identifier.id),await this.update())}async n(y){const i=await this.g.getLanguagePacks();Object.keys(i).some(c=>i[c]&&i[c].extensions.some(n=>(0,p.$Np)(n.extensionIdentifier,y.identifier)))&&(this.j.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,i]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),c=await this.g.update(i);return!(0,v.$ub)(Object.keys(y),Object.keys(c))}};e.$cs=b,e.$cs=b=Ee([oe(0,u.$pp),oe(1,d.$Oi),oe(2,u.$mp),oe(3,f.$bk)],b);let h=class extends L.$Vc{constructor(y,i){super(),this.j=i,this.c={},this.f=(0,w.$kc)(y.userDataPath,"languagepacks.json"),this.g=new k.$Nh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(y){return this.s(i=>{Object.keys(i).forEach(c=>delete i[c]),this.m(i,...y)}).then(()=>this.c)}m(y,...i){for(const c of i)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.n(y,c);Object.keys(y).forEach(c=>this.r(y[c]))}n(y,i){const c=i.identifier,n=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const r of n)if(i.location.scheme===O.Schemas.file&&$(r)){let t=y[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},y[r.languageId]=t);const s=t.extensions.filter(o=>(0,p.$Np)(o.extensionIdentifier,c))[0];s?s.version=i.manifest.version:t.extensions.push({extensionIdentifier:c,version:i.manifest.version});for(const o of r.translations)t.translations[o.id]=(0,w.$kc)(i.location.fsPath,o.path)}}r(y){if(y){const i=(0,P.createHash)("md5");for(const c of y.extensions)i.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);y.hash=i.digest("hex")}}s(y=()=>null){return this.g.queue(()=>{let i=null;return S.promises.readFile(this.f,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch{return{}}}).then(c=>(i=y(c),c)).then(c=>{for(const r of Object.keys(c))c[r]||delete c[r];this.c=c,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),a.Promises.writeFile(this.f,n)}).then(()=>i,c=>this.j.error(c))})}};h=Ee([oe(0,d.$Oi),oe(1,f.$bk)],h);function $(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const y of R.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}}),define(le[128],he([0,1,82,7,27,41]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BR=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function w(d,u,p){const f=await(0,S.$EE)("@microsoft/1ds-core-js","dist/ms.core.js"),m=await(0,S.$EE)("@microsoft/1ds-post-js","dist/ms.post.js"),I=new f.AppInsightsCore,b=new m.PostChannel,h={instrumentationKey:d,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(p){h.extensionConfig={};const $={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:p};h.extensionConfig[b.identifier]=$}return I.initialize(h,[]),I.addTelemetryInitializer($=>{$.ext=$.ext??{},$.ext.web=$.ext.web??{},$.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',u&&($.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),I}class a{constructor(u,p,f,m,I){this.e=u,this.f=p,this.g=f,this.h=I,this.c=L,this.d=O,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(u){if(this.a){if(typeof this.a!="string"){u(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(p=>{u(p)},p=>{(0,P.$Z)(p),console.error(p)})}}log(u,p){if(!this.a)return;p=(0,v.$io)(p,this.g),p=(0,k.$Ip)(p);const f=this.f+"/"+u;try{this.i(m=>{m.pluginVersionString=p?.properties.version??"Unknown",m.track({name:f,baseData:{name:f,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(u=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,u(void 0)})})}):Promise.resolve(void 0)}}e.$BR=a});var qe=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[129],he([0,1,2,27,12,31,5,30,40,130,33,37,18,41]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0,a=qe(a);let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,$,R){this.k=$,this.l=R,this.d={},this.i=new S.$Uc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=p.TelemetryLevel.USAGE,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,k.$if)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$if)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(p.$jm)||y.affectsConfiguration(p.$lm)||y.affectsConfiguration(p.$km))&&this.m()}))}setExperimentProperty(h,$){this.d[h]=$}m(){let h=(0,f.$Hp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const R=$.usage?p.TelemetryLevel.USAGE:$.error?p.TelemetryLevel.ERROR:p.TelemetryLevel.NONE;h=Math.min(h,R)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,$,R){this.g<$||(R=(0,P.$io)(R,this.d),R=(0,f.$Mp)(R,this.j),R=(0,P.$io)(R,this.c),this.b.forEach(y=>y.log(h,R)))}publicLog(h,$){this.n(h,p.TelemetryLevel.USAGE,$)}publicLog2(h,$){this.publicLog(h,$)}publicLogError(h,$){this.h&&this.n(h,p.TelemetryLevel.ERROR,$)}publicLogError2(h,$){this.publicLogError(h,$)}};e.$is=m,e.$is=m=Ee([oe(1,O.$aj),oe(2,d.$uk)],m);function I(){const b=(0,L.localize)(2059,null,a.default.nameLong),h=a.default.privacyStatementUrl?(0,L.localize)(2061,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,L.localize)(2060,null,"https://aka.ms/vscode-telemetry"),$=v.$p?"":(0,L.localize)(2062,null),R=(0,L.localize)(2063,null),y=(0,L.localize)(2064,null),i=(0,L.localize)(2065,null),c=(0,L.localize)(2066,null),n=`
|       | ${R} | ${y} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(2067,null);return`
${b} ${h} ${$}

&nbsp;

${c}
${n}

&nbsp;

${r}
`}u.$so.as(w.$xo.Configuration).registerConfiguration({id:p.$im,order:1,type:"object",title:(0,L.localize)(2068,null),properties:{[p.$jm]:{type:"string",enum:[p.TelemetryConfiguration.ON,p.TelemetryConfiguration.ERROR,p.TelemetryConfiguration.CRASH,p.TelemetryConfiguration.OFF],enumDescriptions:[(0,L.localize)(2069,null),(0,L.localize)(2070,null),(0,L.localize)(2071,null),(0,L.localize)(2072,null)],markdownDescription:I(),default:p.TelemetryConfiguration.ON,restricted:!0,scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.$so.as(w.$xo.Configuration).registerConfiguration({id:p.$im,order:110,type:"object",title:(0,L.localize)(2073,null),properties:{[p.$lm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,L.localize)(2075,null,a.default.nameLong,a.default.privacyStatementUrl):(0,L.localize)(2074,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(2076,null,`\`#${p.$jm}#\``),scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[131],he([0,1,13,21,155,128]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=void 0,v=be(v);async function L(d,u){const p=await u.request(d,P.CancellationToken.None),f=(await(0,S.$1e)(p.stream)).toString(),m=p.res.statusCode??200;return{headers:p.res.headers,statusCode:m,responseData:f}}async function O(d){const u={method:d.type,headers:d.headers};return new Promise((f,m)=>{const I=v.request(d.url??"",u,b=>{b.on("data",function(h){f({headers:b.headers,statusCode:b.statusCode??200,responseData:h.toString()})}),b.on("error",function(h){m(h)})});I.write(d.data,b=>{b&&m(b)}),I.end()})}async function w(d,u,p){const f=typeof u.data=="string"?u.data:new TextDecoder().decode(u.data),m={type:"POST",headers:{...u.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(u.data).toString()},url:u.urlString,data:f};try{const I=d?await L(m,d):await O(m);p(I.statusCode,I.headers,I.responseData)}catch{p(0,{})}}class a extends k.$BR{constructor(u,p,f,m,I){const b={sendPOST:(h,$)=>{w(u,h,$)}};super(p,f,m,I,b)}}e.$CR=a}),define(le[132],he([0,1,32,15,29]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=k,S=be(S);async function k(L,O){const w=Object.create(null),a=(u,p)=>{const f=JSON.parse(u);w[p]=f};if(O){const u=[],p=await v.Promises.readdir(O);for(const m of p)try{(await S.promises.stat((0,P.$kc)(O,m))).isDirectory()&&u.push(m)}catch{}const f=[];for(const m of u)(await v.Promises.readdir((0,P.$kc)(O,m))).filter(b=>b==="telemetry.json").length===1&&f.push(m);for(const m of f){const I=(await S.promises.readFile((0,P.$kc)(O,m,"telemetry.json"))).toString();a(I,m)}}let d=(await S.promises.readFile((0,P.$kc)(L,"telemetry-core.json"))).toString();return a(d,"vscode-core"),d=(await S.promises.readFile((0,P.$kc)(L,"telemetry-extensions.json"))).toString(),a(d,"vscode-extensions"),JSON.stringify(w,null,4)}}),define(le[133],he([0,1,12,84,18]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=k,e.$Jhc=L,e.$Khc=O;async function k(w,a){let d=w.getItem(v.$fm);return(typeof d!="string"||S.$k&&d==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(d=await(0,P.$Un)(a.error.bind(a))),d}async function L(w,a){let d=w.getItem(v.$gm);return typeof d!="string"&&(d=await(0,P.$Vn)(a.error.bind(a))),d}async function O(w,a){let d=w.getItem(v.$hm);return typeof d!="string"&&(d=await(0,P.$Wn)(a.error.bind(a))),d}}),define(le[23],he([0,1,10]),function(Z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=void 0,e.$Ll=(0,S.$Gi)("IUriIdentityService")}),define(le[134],he([0,1,23,99,9,16,80,4,2]),function(Z,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class a{static{this._clock=0}constructor(p){this.uri=p,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let d=class{constructor(p){this.g=p,this.c=new w.$Uc,this.f=2**16;const f=new Map,m=I=>{let b=f.get(I.scheme);return b===void 0&&(b=p.hasProvider(I)&&!this.g.hasCapability(I,v.FileSystemProviderCapabilities.PathCaseSensitive),f.set(I.scheme,b)),b};this.c.add(O.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(I=>{f.delete(I.scheme)})),this.extUri=new k.$9g(m),this.d=new L.$Us((I,b)=>this.extUri.compare(I,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,k.$ih)(p));const f=this.d.get(p);return f?f.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new a(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((m,I)=>m[1].time<I[1].time?1:m[1].time>I[1].time?-1:0);a._clock=0,this.d.clear();const f=this.f*.5;for(let m=0;m<f;m++)this.d.set(p[m][0],p[m][1].touch())}};e.$Vs=d,e.$Vs=d=Ee([oe(0,v.$bl)],d),(0,P.$Ss)(S.$Ll,d,P.InstantiationType.Delayed)}),define(le[135],he([0,1,4,2,9,49,25]),function(Z,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class O extends P.$Vc{constructor(a,d,u,p,f,m){super(),this.f=a,this.g=d,this.h=u,this.j=p,this.m=f,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$me),this.onDidChangeFile=this.a.event,this.b=k.$Mi.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new L.$Cc(I=>this.m.extUri.getComparisonKey(this.t(I))),this.r(),this.B(p.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(I=>this.s(I)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,d){return this.g.open(this.t(a),d)}close(a){return this.g.close(a)}read(a,d,u,p,f){return this.g.read(a,d,u,p,f)}write(a,d,u,p,f){return this.g.write(a,d,u,p,f)}watch(a,d){this.b.set(a,a);const u=this.g.watch(this.t(a),d);return(0,P.$Tc)(()=>{this.b.delete(a),u.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,d,u){return this.g.rename(this.t(a),this.t(d),u)}readFile(a,d){return this.g.readFile(this.t(a),d)}readFileStream(a,d,u){return this.g.readFileStream(this.t(a),d,u)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,d,u){return this.g.writeFile(this.t(a),d,u)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,d){return this.g.delete(this.t(a),d)}copy(a,d,u){if((0,v.$fl)(this.g))return this.g.copy(this.t(a),this.t(d),u);throw new Error("copy not supported")}cloneFile(a,d){if((0,v.$gl)(this.g))return this.g.cloneFile(this.t(a),this.t(d));throw new Error("clone not supported")}s(a){const d=[];for(const u of a){if(u.resource.scheme!==this.f)continue;const p=this.u(u.resource);this.b.findSubstr(p)&&d.push({resource:p,type:u.type,cId:u.cId})}d.length&&(this.n.debug("User data changed"),this.a.fire(d))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$9hc=O}),define(le[136],he([0,1,5,15,49,16,11,10,14]),function(Z,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=a,e.$Ri=d,e.$Ui=u,e.$Vi=p,e.$Wi=f,e.$Xi=I,e.$Yi=b,e.$2i=R,e.$7i=y,e.$8i=i,e.$0i=c,e.$$i=n,e.$_i=r,e.$Pi=(0,O.$Gi)("contextService");function a(t){const s=t;return typeof s?.id=="string"&&L.URI.isUri(s.uri)}function d(t){return typeof t?.id=="string"&&!a(t)&&!p(t)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function u(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,P.$oc)(t)}:s?e.$Si:e.$Ti;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function p(t){const s=t;return typeof s?.id=="string"&&L.URI.isUri(s.configPath)}function f(t){const s=t;if(s?.uri)return{id:s.id,uri:L.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var m;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function I(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function b(t){const s=t;return!!(s&&typeof s=="object"&&L.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class h{constructor(s,o,l,g,N){this.h=s,this.j=l,this.k=g,this.l=N,this.c=v.$Mi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=v.$Mi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=h;class ${constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,k.$hh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=$;function R(t){return new $({uri:t,index:0,name:(0,k.$dh)(t)},{uri:t.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,S.localize)(2476,null),extensions:[e.$3i]}],e.$6i="workspace.json";function y(t,s){return k.$$g.isEqualOrParent(t,s.untitledWorkspacesHome)}function i(t){let s;return L.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===w.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function c(t){return t.id===e.$9i}function n(t,s){return!y(t,s)&&!i(t)}function r(t){return(typeof t=="string"?(0,P.$pc)(t):(0,k.$fh)(t))===e.$4i}}),define(le[24],he([0,1,43,4,2,16,11,5,17,9,10,6,136,25,23,8,28,31,3]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Nl=e.ProfileResourceType=void 0,e.$Ml=y,e.$Ol=i,e.$Pl=c;var R;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(R||(e.ProfileResourceType=R={}));function y(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&L.URI.isUri(s.location)&&L.URI.isUri(s.globalStorageHome)&&L.URI.isUri(s.settingsResource)&&L.URI.isUri(s.keybindingsResource)&&L.URI.isUri(s.tasksResource)&&L.URI.isUri(s.snippetsHome)&&L.URI.isUri(s.extensionsResource))}e.$Nl=(0,d.$Gi)("IUserDataProfilesService");function i(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:L.URI.revive(t.location).with({scheme:s}),globalStorageHome:L.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:L.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:L.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:L.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:L.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:L.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:L.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function c(t,s,o,l,g,N){return{id:t,name:s,location:o,isDefault:!1,shortName:g?.shortName,icon:g?.icon,globalStorageHome:N&&g?.useDefaultFlags?.globalState?N.globalStorageHome:(0,k.$hh)(o,"globalStorage"),settingsResource:N&&g?.useDefaultFlags?.settings?N.settingsResource:(0,k.$hh)(o,"settings.json"),keybindingsResource:N&&g?.useDefaultFlags?.keybindings?N.keybindingsResource:(0,k.$hh)(o,"keybindings.json"),tasksResource:N&&g?.useDefaultFlags?.tasks?N.tasksResource:(0,k.$hh)(o,"tasks.json"),snippetsHome:N&&g?.useDefaultFlags?.snippets?N.snippetsHome:(0,k.$hh)(o,"snippets"),extensionsResource:N&&g?.useDefaultFlags?.extensions?N.extensionsResource:(0,k.$hh)(o,"extensions.json"),cacheHome:(0,k.$hh)(l,t),useDefaultFlags:g?.useDefaultFlags,isTransient:g?.transient}}let n=class extends v.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,g){super(),this.t=s,this.u=o,this.w=l,this.y=g,this.f=!0,this.h=this.B(new P.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new P.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new P.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new P.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new f.$Bc,workspaces:new f.$Bc,emptyWindows:new Map},this.profilesHome=(0,k.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const N of this.O()){if(!N.name||!(0,$.$fg)(N.name)||!N.location){this.y.warn("Skipping the invalid stored profile",N.location||N.name);continue}o.push(c((0,k.$eh)(N.location),N.name,N.location,this.g,{shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags},s))}}catch(N){this.y.error(N)}const l=new f.$Bc,g=new Map;if(o.length)try{const N=this.Q();if(N.workspaces)for(const[T,A]of Object.entries(N.workspaces)){const D=L.URI.parse(T),j=o.find(H=>H.id===A);j&&l.set(D,j)}if(N.emptyWindows)for(const[T,A]of Object.entries(N.emptyWindows)){const D=o.find(j=>j.id===A);D&&g.set(T,D)}}catch(N){this.y.error(N)}this.z={profiles:o,workspaces:l,emptyWindows:g}}return this.z}D(){const s=c("__default__profile__",(0,O.localize)(2429,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,h.$if)(o)}\\s(\\d+)`);let g=0;for(const T of this.profiles){const A=l.exec(T.name),D=A?parseInt(A[1]):0;g=D>g?D:g}const N=`${o} ${g+1}`;return this.createProfile((0,S.$uj)((0,b.$3g)()).toString(16),N,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,S.$uj)((0,b.$3g)()).toString(16),s,o,l)}async createProfile(s,o,l,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const N=await this.F(s,o,l);return g&&await this.setProfileForWorkspace(g,N),N}async F(s,o,l){if(!(0,$.$fg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let g=this.r.get(o);return g||(g=(async()=>{try{if(this.profiles.find(D=>D.name===o||D.id===s))throw new Error(`Profile with ${o} name already exists`);const T=c(s,o,(0,k.$hh)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(T.location);const A=[];return this.j.fire({profile:T,join(D){A.push(D)}}),await I.Promises.settled(A),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,g)),g}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(g=>g.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=c(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(g=>g.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(g){l.push(g)}});try{await Promise.allSettled(l)}catch(g){this.y.error(g)}for(const g of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(g)?.id&&this.C.emptyWindows.delete(g);for(const g of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(g)?.id&&this.C.workspaces.delete(g);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(g){(0,a.$sl)(g)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(g)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(g=>g.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s),l=L.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return l||((0,p.$Qi)(s)?this.s.folders.get(s.uri):(0,p.$Vi)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,p.$Qi)(s)?s.uri:(0,p.$Vi)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const g=[...this.profiles,...s],N=[],T=this.s.profiles;this.s.profiles=[];for(let A of g){if(A.isDefault||o.some(j=>A.id===j.id))continue;A=l.find(j=>A.id===j.id)??A;const D=T.find(j=>A.id===j.id);if(A.isTransient)this.s.profiles.push(A);else{if(D){for(const[j,H]of this.s.emptyWindows.entries())if(A.id===H.id){this.L({id:j},A);break}for(const[j,H]of this.s.workspaces.entries())if(A.id===H.id){this.L({id:"",configPath:j},A);break}for(const[j,H]of this.s.folders.entries())if(A.id===H.id){this.L({id:"",uri:j},A);break}}N.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.P(N),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){if(l=o?.isTransient?!0:l,l)(0,p.$Qi)(s)?(this.s.folders.delete(s.uri),o&&this.s.folders.set(s.uri,o)):(0,p.$Vi)(s)?(this.s.workspaces.delete(s.configPath),o&&this.s.workspaces.set(s.configPath,o)):(this.s.emptyWindows.delete(s.id),o&&this.s.emptyWindows.set(s.id,o));else{this.L(s,void 0,!0);const g=this.G(s);L.URI.isUri(g)?(this.C.workspaces.delete(g),o&&this.C.workspaces.set(g,o)):(this.C.emptyWindows.delete(g),o&&this.C.emptyWindows.set(g,o)),this.M()}}M(){const s={};for(const[l,g]of this.C.workspaces.entries())s[l.toString()]=g.id;const o={};for(const[l,g]of this.C.emptyWindows.entries())o[l.toString()]=g.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[N,T]of Object.entries(s.workspaces)){const A=L.URI.parse(T);o[N]=this.w.extUri.isEqual(A,l.location)?l.id:this.w.extUri.basename(A)}const g={};if(s.emptyWindows)for(const[N,T]of Object.entries(s.emptyWindows)){const A=L.URI.parse(T);g[N]=this.w.extUri.isEqual(A,l.location)?l.id:this.w.extUri.basename(A)}return{workspaces:o,emptyWindows:g}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Ql=n,e.$Ql=n=Ee([oe(0,w.$Ni),oe(1,a.$bl),oe(2,m.$Ll),oe(3,u.$bk)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Rl=r}),define(le[53],he([0,1,19,8,21,7,4,2,25,12,3,11,5,20,26,22,44,6,33,18,23,24]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h,$,R,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Gq=void 0,e.$Hq=n,p=be(p);let c=class extends O.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(o,l,g,N,T,A){super(),this.z=o,this.C=l,this.D=g,this.F=N,this.G=T,this.H=A,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new L.$me),this.s=this.B(new L.$me),this.t=this.B(new L.$me),this.u=this.B(new L.$me),this.w=this.B(new L.$me),this.y=[],this.B((0,O.$Tc)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.m.forEach(D=>D.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(o){const l=await this.getTargetPlatform();return o.allTargetPlatforms.some(g=>(0,f.$kp)(g,o.allTargetPlatforms,l))}async installFromGallery(o,l={}){try{const N=(await this.installGalleryExtensions([{extension:o,options:l}])).find(({identifier:T})=>(0,m.$Np)(T,o.identifier));if(N?.local)return N?.local;throw N?.error?N.error:new f.$op(`Unknown error while installing extension ${o.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(g){throw n(g)}}async installGalleryExtensions(o){if(!this.z.isEnabled())throw new f.$op(p.localize(1758,null),f.ExtensionManagementErrorCode.NotAllowed);const l=[],g=[];return await Promise.allSettled(o.map(async({extension:N,options:T})=>{try{const A=await this.N(N,!!T?.installGivenVersion,!!T?.installPreReleaseVersion,T.productVersion??{version:this.G.version,date:this.G.date});g.push({...A,options:T})}catch(A){l.push({identifier:N.identifier,operation:f.InstallOperation.Install,source:N,error:A,profileLocation:T.profileLocation??this.W()})}})),g.length&&l.push(...await this.I(g)),l}async uninstall(o,l){return this.F.trace("ExtensionManagementService#uninstall",o.identifier.id),this.uninstallExtensions([{extension:o,options:l}])}async toggleAppliationScope(o,l){if((0,I.$vn)(o.manifest)||o.isBuiltin)return o;if(o.isApplicationScoped){let g=await this.updateMetadata(o,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(l,this.H.defaultProfile.extensionsResource)||(g=await this.Z(o,this.H.defaultProfile.extensionsResource,l));for(const N of this.H.profiles){const T=(await this.getInstalled(I.ExtensionType.User,N.extensionsResource)).find(A=>(0,m.$Np)(A.identifier,o.identifier));T?this.w.fire({local:T,profileLocation:N.extensionsResource}):this.u.fire({identifier:o.identifier,profileLocation:N.extensionsResource})}return g}else{const g=this.D.extUri.isEqual(l,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(o,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(o,l,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:g.identifier,operation:f.InstallOperation.Install,local:g,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),g}}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.g||o-this.h>1e3*60*5)&&(this.g=this.U(),this.h=o),this.g}registerParticipant(o){this.y.push(o)}async resetPinnedStateForAllUserExtensions(o){try{await this.L(this.H.profiles.map(async l=>{const g=await this.getInstalled(I.ExtensionType.User,l.extensionsResource);await this.L(g.map(async N=>{N.pinned!==o&&await this.updateMetadata(N,{pinned:o},l.extensionsResource)}))}))}catch(l){throw this.F.error("Error while resetting pinned state for all user extensions",(0,k.$0)(l)),l}}async I(o){const l=new Map,g=new Map,N=[],T=(D,j)=>`${m.$Op.create(D).toString()}-${j.toString()}`,A=(D,j,H,Y)=>{const ne=this.X(D,j,H),ae=`${(0,m.$Sp)(D.publisher,D.name)}-${H.profileLocation.toString()}`;g.set(ae,{task:ne,root:Y}),this.n.fire({identifier:ne.identifier,source:j,profileLocation:H.profileLocation}),this.F.info("Installing extension:",ne.identifier.id,H),u.URI.isUri(j)||this.j.set(T(j,H.profileLocation),{task:ne,waitingTasks:[]})};try{for(const{manifest:D,extension:j,options:H}of o){const Y=H.isApplicationScoped||H.isBuiltin||(0,I.$vn)(D),ne={...H,installOnlyNewlyAddedFromExtensionPack:H.installOnlyNewlyAddedFromExtensionPack??!u.URI.isUri(j),isApplicationScoped:Y,profileLocation:Y?this.H.defaultProfile.extensionsResource:H.profileLocation??this.W(),productVersion:H.productVersion??{version:this.G.version,date:this.G.date}},ae=u.URI.isUri(j)?void 0:this.j.get(T(j,ne.profileLocation));ae?(this.F.info("Extension is already requested to install",ae.task.identifier.id,ne.profileLocation.toString()),N.push(ae.task.waitUntilTaskIsFinished())):A(D,j,ne,void 0)}return await Promise.all([...g.values()].map(async({task:D})=>{if(D.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",D.identifier.id);else try{const j=await this.M(D.identifier,D.manifest,!!D.options.installOnlyNewlyAddedFromExtensionPack,!!D.options.installPreReleaseVersion,D.options.profileLocation,D.options.productVersion),H=await this.getInstalled(void 0,D.options.profileLocation,D.options.productVersion),Y={...D.options,context:{...D.options.context,[f.$ep]:!0}};for(const{gallery:ne,manifest:ae}of(0,S.$Mb)(j,({gallery:ue})=>ue.identifier.id)){if(g.has(`${ne.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`))continue;const ue=this.j.get(T(ne,Y.profileLocation));if(ue){if(this.J(D,ue.task)){const me=ue.task.identifier;this.F.info("Waiting for already requested installing extension",me.id,D.identifier.id,Y.profileLocation.toString()),ue.waitingTasks.push(D),N.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,W=>W.some(_=>(0,m.$Np)(_.identifier,me)))).then(W=>{if(this.F.info("Finished waiting for already requested installing extension",me.id,D.identifier.id,Y.profileLocation.toString()),!W.find(z=>(0,m.$Np)(z.identifier,me))?.local)throw new Error(`Extension ${me.id} is not installed`)}))}}else H.some(({identifier:me})=>(0,m.$Np)(me,ne.identifier))||A(ae,ne,Y,D)}}catch(j){if(u.URI.isUri(D.source))(0,S.$Lb)(D.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",D.identifier.id,j.message),(0,S.$Lb)(D.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",D.identifier.id,j.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",D.identifier.id),j}})),await this.L([...g.entries()].map(async([D,{task:j}])=>{const H=new Date().getTime();let Y;try{Y=await j.run(),await this.L(this.y.map(ne=>ne.postInstall(Y,j.source,j.options,v.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(ne){const ae=n(ne);throw u.URI.isUri(j.source)||r(this.C,j.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Vp)(j.source),error:ae,source:j.options.context?.[f.$dp]}),l.set(D,{error:ae,identifier:j.identifier,operation:j.operation,source:j.source,context:j.options.context,profileLocation:j.options.profileLocation,applicationScoped:j.options.isApplicationScoped}),this.F.error("Error while installing the extension",j.identifier.id,(0,k.$0)(ae),j.options.profileLocation.toString()),ae}if(!u.URI.isUri(j.source)){const ne=j.operation===f.InstallOperation.Update,ae=ne?void 0:(new Date().getTime()-j.source.lastUpdated)/1e3;if(r(this.C,ne?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Vp)(j.source),verificationStatus:j.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:ae,source:j.options.context?.[f.$dp]}),a.$p&&j.operation!==f.InstallOperation.Update)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,f.StatisticType.Install)}catch{}}l.set(D,{local:Y,identifier:j.identifier,operation:j.operation,source:j.source,context:j.options.context,profileLocation:j.options.profileLocation,applicationScoped:Y.isApplicationScoped})})),N.length&&await this.L(N),[...l.values()]}catch(D){const j=(ne,ae,ue)=>{const me=[];ne.manifest.extensionDependencies?.length&&me.push(...ne.manifest.extensionDependencies),ne.manifest.extensionPack?.length&&me.push(...ne.manifest.extensionPack);for(const W of me){if(ue.includes(W.toLowerCase()))continue;ue.push(W.toLowerCase());const _=l.get(`${W.toLowerCase()}-${ae.toString()}`);_?.local&&(ue=j(_.local,ae,ue))}return ue},H=ne=>({identifier:ne.identifier,operation:f.InstallOperation.Install,source:ne.source,context:ne.options.context,profileLocation:ne.options.profileLocation,error:D}),Y=[];for(const[ne,{task:ae,root:ue}]of g){const me=l.get(ne);me?me.local&&ue&&!l.get(`${ue.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(Y.push(this.Y(me.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),l.set(ne,H(ae))):(ae.cancel(),l.set(ne,H(ae)))}for(const[ne,{task:ae}]of g){const ue=l.get(ne);if(!ue?.local||ae.options.donotIncludePackAndDependencies)continue;j(ue.local,ae.options.profileLocation,[ue.local.identifier.id.toLowerCase()]).slice(1).some(W=>g.has(`${W.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!l.get(`${W.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(Y.push(this.Y(ue.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),l.set(ne,H(ae)))}throw Y.length&&await Promise.allSettled(Y.map(async ne=>{try{await ne.run(),this.F.info("Rollback: Uninstalled extension",ne.extension.identifier.id)}catch(ae){this.F.warn("Rollback: Error while uninstalling extension",ne.extension.identifier.id,(0,k.$0)(ae))}})),D}finally{for(const{task:D}of g.values())D.source&&!u.URI.isUri(D.source)&&this.j.delete(T(D.source,D.options.profileLocation));if(l.size){const D=[...l.values()];for(const j of D)j.local&&this.F.info("Extension installed successfully:",j.identifier.id,j.profileLocation.toString());this.s.fire(D)}}}J(o,l){for(const[,{task:g,waitingTasks:N}]of this.j.entries())if(g===o&&(N.includes(l)||N.some(T=>this.J(T,l)))||g===l&&N[0]&&!this.J(o,N[0]))return!1;return!0}async L(o,l){const g=[],N=[],T=await Promise.allSettled(o);for(const D of T)D.status==="fulfilled"?g.push(D.value):N.push(n(D.reason,l));if(!N.length)return g;if(N.length===1)throw N[0];let A=new f.$op("",f.ExtensionManagementErrorCode.Unknown);for(const D of N)A=new f.$op(A.message?`${A.message}, ${D.message}`:D.message,D.code!==f.ExtensionManagementErrorCode.Unknown&&D.code!==f.ExtensionManagementErrorCode.Internal?D.code:A.code);throw A}async M(o,l,g,N,T,A){if(!this.z.isEnabled())return[];const D=await this.getInstalled(void 0,T,A),j=[],H=[],Y=async(ne,ae)=>{j.push(ne);const ue=ae.extensionDependencies||[],me=[...ue];if(ae.extensionPack){const W=g?D.find(_=>(0,m.$Np)(_.identifier,ne)):void 0;for(const _ of ae.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(z=>(0,m.$Np)({id:z},{id:_}))||me.every(z=>!(0,m.$Np)({id:z},{id:_}))&&me.push(_)}if(me.length){const W=me.filter(_=>j.every(z=>!(0,m.$Np)(z,{id:_})));if(W.length){const _=await this.z.getExtensions(W.map(z=>({id:z,preRelease:N})),v.CancellationToken.None);for(const z of _){if(j.find(K=>(0,m.$Np)(K,z.identifier)))continue;const M=ue.some(K=>(0,m.$Np)({id:K},z.identifier));let x;try{x=await this.N(z,!1,N,A)}catch(K){if(M)throw K;this.F.info("Skipping the packed extension as it cannot be installed",z.identifier.id,(0,k.$0)(K));continue}H.push({gallery:x.extension,manifest:x.manifest}),await Y(x.extension.identifier,x.manifest)}}}};return await Y(o,l),H}async N(o,l,g,N){let T;const A=await this.getExtensionsControlManifest();if(A.malicious.some(H=>(0,m.$Np)(o.identifier,H)))throw new f.$op(p.localize(1759,null,o.identifier.id),f.ExtensionManagementErrorCode.Malicious);const D=A.deprecated[o.identifier.id.toLowerCase()];if(D?.extension?.autoMigrate){if(this.F.info(`The '${o.identifier.id}' extension is deprecated, fetching the compatible '${D.extension.id}' extension instead.`),T=(await this.z.getExtensions([{id:D.extension.id,preRelease:D.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:N},v.CancellationToken.None))[0],!T)throw new f.$op(p.localize(1760,null,o.identifier.id,D.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(o)){const H=await this.getTargetPlatform();throw new f.$op(p.localize(1761,null,o.identifier.id,this.G.nameLong,(0,f.$gp)(H)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(T=await this.O(o,l,g,N),!T){const H=[];throw(0,b.$8p)(o.properties.enabledApiProposals??[],H)?!g&&o.properties.isPreReleaseVersion&&(await this.z.getExtensions([o.identifier],v.CancellationToken.None))[0]?new f.$op(p.localize(1763,null,o.displayName??o.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.$op(p.localize(1764,null,o.identifier.id,this.G.nameLong,this.G.version),f.ExtensionManagementErrorCode.Incompatible):new f.$op(p.localize(1762,null,o.displayName??o.identifier.id,H[0]),f.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",T.identifier.id);const j=await this.z.getManifest(T,v.CancellationToken.None);if(j===null)throw new f.$op(`Missing manifest for extension ${T.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(j.version!==T.version)throw new f.$op(`Cannot install '${T.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:T,manifest:j}}async O(o,l,g,N){const T=await this.getTargetPlatform();let A=null;return!l&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==g&&(A=(await this.z.getExtensions([{...o.identifier,preRelease:g}],{targetPlatform:T,compatible:!0,productVersion:N},v.CancellationToken.None))[0]||null),!A&&await this.z.isExtensionCompatible(o,g,T,N)&&(A=o),A||(l?A=(await this.z.getExtensions([{...o.identifier,version:o.version}],{targetPlatform:T,compatible:!0,productVersion:N},v.CancellationToken.None))[0]||null:A=await this.z.getCompatibleExtension(o,g,T,N)),A}async uninstallExtensions(o){const l=(H,Y)=>`${H.identifier.id.toLowerCase()}${Y.versionOnly?`-${H.manifest.version}`:""}@${Y.profileLocation.toString()}`,g=(H,Y)=>{const ne=this.Y(H,Y);return this.m.set(l(ne.extension,Y),ne),this.F.info("Uninstalling extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,Y.profileLocation.toString()),this.t.fire({identifier:H.identifier,profileLocation:Y.profileLocation,applicationScoped:H.isApplicationScoped}),ne},N=(H,Y,ne)=>{ne?this.F.error("Failed to uninstall extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,Y.profileLocation.toString(),ne.message):this.F.info("Successfully uninstalled extension from the profile",`${H.identifier.id}@${H.manifest.version}`,Y.profileLocation.toString()),r(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$Up)(H),error:ne}),this.u.fire({identifier:H.identifier,error:ne?.code,profileLocation:Y.profileLocation,applicationScoped:H.isApplicationScoped})},T=[],A=[],D=[],j=new w.$Bc;for(const{extension:H,options:Y}of o){const ne={...Y,profileLocation:H.isApplicationScoped?this.H.defaultProfile.extensionsResource:Y?.profileLocation??this.W()},ae=this.m.get(l(H,ne));ae?(this.F.info("Extensions is already requested to uninstall",H.identifier.id),D.push(ae.waitUntilTaskIsFinished())):T.push(g(H,ne))}try{for(const H of T.slice(0)){let Y=j.get(H.options.profileLocation);if(Y||j.set(H.options.profileLocation,Y=await this.getInstalled(I.ExtensionType.User,H.options.profileLocation)),H.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${H.extension.identifier.id}@${H.extension.manifest.version}`);else{const ne=this.R(H.extension,Y);for(const ae of ne)this.m.has(l(ae,H.options))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):T.push(g(ae,H.options))}H.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${H.extension.identifier.id}@${H.extension.manifest.version}`):this.P(T.map(ne=>ne.extension),Y,H.extension)}await this.L(T.map(async H=>{try{if(await H.run(),await this.L(this.y.map(Y=>Y.postUninstall(H.extension,H.options,v.CancellationToken.None))),H.extension.identifier.uuid)try{await this.z.reportStatistic(H.extension.manifest.publisher,H.extension.manifest.name,H.extension.manifest.version,f.StatisticType.Uninstall)}catch{}}catch(Y){const ne=n(Y);throw N(H.extension,H.options,ne),ne}finally{A.push(H)}})),D.length&&await this.L(D);for(const H of T)N(H.extension,H.options)}catch(H){const Y=n(H);for(const ne of T){try{ne.cancel()}catch{}A.includes(ne)||N(ne.extension,ne.options,Y)}throw Y}finally{for(const H of T)this.m.delete(l(H.extension,H.options))||this.F.warn("Uninstallation task is not found in the cache",H.extension.identifier.id)}}P(o,l,g){for(const N of o){const T=this.S(N,l);if(T.length){const A=T.filter(D=>!o.some(j=>(0,m.$Np)(j.identifier,D.identifier)));if(A.length)throw new Error(this.Q(N,A,g))}}}Q(o,l,g){return g===o?l.length===1?p.localize(1765,null,g.manifest.displayName||g.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?p.localize(1766,null,g.manifest.displayName||g.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):p.localize(1767,null,g.manifest.displayName||g.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):l.length===1?p.localize(1768,null,g.manifest.displayName||g.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?p.localize(1769,null,g.manifest.displayName||g.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):p.localize(1770,null,g.manifest.displayName||g.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name)}R(o,l,g=[]){if(g.indexOf(o)!==-1)return[];g.push(o);const N=o.manifest.extensionPack?o.manifest.extensionPack:[];if(N.length){const T=l.filter(D=>!D.isBuiltin&&N.some(j=>(0,m.$Np)({id:j},D.identifier))),A=[];for(const D of T)A.push(...this.R(D,l,g));return[...T,...A]}return[]}S(o,l){return l.filter(g=>g.manifest.extensionDependencies&&g.manifest.extensionDependencies.some(N=>(0,m.$Np)({id:N},o.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(o){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$0)(o)),{malicious:[],deprecated:{},search:[]}}}};e.$Gq=c,e.$Gq=c=Ee([oe(0,f.$mp),oe(1,R.$am),oe(2,y.$Ll),oe(3,h.$bk),oe(4,$.$uk),oe(5,i.$Nl)],c);function n(s,o){if(s instanceof f.$op)return s;let l;return s instanceof f.$np?l=new f.$op(s.message,s.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):l=new f.$op(s.message,(0,k.$4)(s)?f.ExtensionManagementErrorCode.Cancelled:o??f.ExtensionManagementErrorCode.Internal),l.stack=s.stack,l}function r(s,o,{extensionData:l,verificationStatus:g,duration:N,error:T,source:A,durationSinceUpdate:D}){let j,H;(0,d.$ng)(g)&&(g===!0?g="Verified":(g===!1||(j=f.ExtensionManagementErrorCode.Signature,H=g),g="Unverified")),T&&(j=T.code,T.code===f.ExtensionManagementErrorCode.Signature&&(H=T.message)),s.publicLog(o,{...l,verificationStatus:g,success:!T,duration:N,errorcode:j,errorcodeDetail:H,durationSinceUpdate:D,source:A})}class t{constructor(){this.d=new P.$Fh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,P.$th)(o=>this.h(o))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,P.$th)(o=>new Promise((l,g)=>{const N=o.onCancellationRequested(()=>{N.dispose(),g(new k.$5)})})),this.d.open()),this.g.cancel()}}e.$Iq=t}),define(le[42],he([0,1,8,13,2,4,25,11,20,26,9,10,6,24,23,3,7,18]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class R extends Error{constructor(r,t){super(r),this.code=t}}e.$Jq=R,e.$Kq=(0,u.$Gi)("IExtensionsProfileScannerService");let y=class extends v.$Vc{constructor(r,t,s,o,l,g){super(),this.j=r,this.m=t,this.n=s,this.r=o,this.s=l,this.t=g,this.b=this.B(new k.$me),this.onAddExtensions=this.b.event,this.c=this.B(new k.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$me),this.onDidRemoveExtensions=this.g.event,this.h=new L.$Bc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t,s){const o=[],l=[];try{return await this.u(t,g=>{const N=[];if(s)N.push(...g);else for(const T of g)r.some(([A])=>(0,a.$Np)(A.identifier,T.identifier)&&A.manifest.version!==T.version)?o.push(T):N.push(T);for(const[T,A]of r){const D=N.findIndex(H=>(0,a.$Np)(H.identifier,T.identifier)&&H.version===T.manifest.version),j={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:A};D===-1?(l.push(j),N.push(j)):N.splice(D,1,j)}return l.length&&this.b.fire({extensions:l,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),N}),l.length&&this.c.fire({extensions:l,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),l}catch(g){throw l.length&&this.c.fire({extensions:l,error:g,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:g,profileLocation:t}),g}}async updateMetadata(r,t){const s=[];return await this.u(t,o=>{const l=[];for(const g of o){const N=r.find(([T])=>(0,a.$Np)(T.identifier,g.identifier)&&T.manifest.version===g.version);N&&(g.metadata={...g.metadata,...N[1]},s.push(g)),l.push(g)}return l}),s}async removeExtensionFromProfile(r,t){const s=[];try{await this.u(t,o=>{const l=[];for(const g of o)(0,a.$Np)(g.identifier,r.identifier)?s.push(g):l.push(g);return s.length&&this.f.fire({extensions:s,profileLocation:t}),l}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:t}),o}}async u(r,t,s){return this.F(r).queue(async()=>{let o=[],l;try{const g=await this.m.readFile(r);l=JSON.parse(g.value.toString().trim()||"[]")}catch(g){if((0,d.$sl)(g)!==d.FileOperationResult.FILE_NOT_FOUND)throw g;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new R((0,b.$0)(g),$.ERROR_PROFILE_NOT_FOUND)}if(l){Array.isArray(l)||this.w(r);let g=!1;for(const N of l){i(N)||this.w(r);let T;if((0,I.$fg)(N.relativeLocation)&&N.relativeLocation)T=this.z(N.relativeLocation);else if((0,I.$fg)(N.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${N.location}`);continue}else{T=O.URI.revive(N.location);const A=this.y(T);A&&(g=!0,N.relativeLocation=A)}(0,I.$mg)(N.metadata?.hasPreReleaseVersion)&&N.metadata?.preRelease&&(g=!0,N.metadata.hasPreReleaseVersion=!0),o.push({identifier:N.identifier,location:T,version:N.version,metadata:N.metadata})}g&&await this.m.writeFile(r,P.$Oe.fromString(JSON.stringify(l)))}if(t){o=t(o);const g=o.map(N=>({identifier:N.identifier,version:N.version,location:N.location.toJSON(),relativeLocation:this.y(N.location),metadata:N.metadata}));await this.m.writeFile(r,P.$Oe.fromString(JSON.stringify(g)))}return o})}w(r){const t=new R(`Invalid extensions content in ${r.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(l){if((0,d.$sl)(l)===d.FileOperationResult.FILE_NOT_FOUND)return;throw l}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(g=>i(g))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,P.$Oe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,d.$sl)(l)===d.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(r)}catch(l){(0,d.$sl)(l)!==d.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}try{await this.m.del(t)}catch(l){(0,d.$sl)(l)!==d.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}return o})()),this.C}F(r){let t=this.h.get(r);return t||(t=new S.$Nh,this.h.set(r,t)),t}};e.$Lq=y,e.$Lq=y=Ee([oe(1,d.$bl),oe(2,f.$Nl),oe(3,m.$Ll),oe(4,h.$am),oe(5,p.$bk)],y);function i(n){return(0,I.$hg)(n)&&(0,w.$lp)(n.identifier)&&(c(n.location)||(0,I.$fg)(n.location)&&n.location)&&((0,I.$mg)(n.relativeLocation)||(0,I.$fg)(n.relativeLocation))&&n.version&&(0,I.$fg)(n.version)}function c(n){return n?(0,I.$fg)(n.path)&&(0,I.$fg)(n.scheme):!1}});var qe=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[54],he([0,1,19,8,27,13,7,34,91,2,14,15,12,16,45,57,3,11,5,17,26,22,44,9,10,6,33,4,48,42,24,23,97]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h,$,R,y,i,c,n,r,t,s,o,l,g,N,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Qq=e.$Pq=e.$Oq=e.Translations=void 0,e.$Rq=ae,v=be(v),u=be(u),p=be(p),m=be(m),I=qe(I);var D;(function(me){function W(_,z){if(_===z)return!0;const M=Object.keys(_),x=new Set;for(const K of Object.keys(z))x.add(K);if(M.length!==x.size)return!1;for(const K of M){if(_[K]!==z[K])return!1;x.delete(K)}return x.size===0}me.equals=W})(D||(e.Translations=D={})),e.$Oq=(0,r.$Gi)("IExtensionsScannerService");let j=class extends a.$Vc{constructor(W,_,z,M,x,K,ie,se,C,V,q,E){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=_,this.r=z,this.s=M,this.t=x,this.u=K,this.w=ie,this.y=se,this.z=C,this.C=V,this.D=q,this.F=E,this.g=this.B(new o.$me),this.onDidChangeCache=this.g.event,this.h=(0,f.$hh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ne,this.s,this.h)),this.m=this.B(this.F.createInstance(ne,this.s,this.h)),this.n=this.B(this.F.createInstance(Y,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,y.$Yp)(this.w,this.y)),this.G}async scanAllExtensions(W,_,z){const[M,x]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(_)]),K=z?await this.scanExtensionsUnderDevelopment(W,[...M,...x]):[];return this.L(M,x,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const _=[];_.push(this.M(!!W.useCache,W.language)),_.push(this.N(W.language,!!W.checkControlFile));const[z,M]=await Promise.all(_);return this.J([...z,...M],i.ExtensionType.System,W,!1)}async scanUserExtensions(W){const _=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const z=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(_,!!W.profileLocation,i.ExtensionType.User,!W.includeUninstalled,W.language,!0,z,W.productVersion??this.R()),x=W.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let K;try{K=await x.scanExtensions(M)}catch(ie){if(ie instanceof g.$Jq&&ie.code===g.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),K=await x.scanExtensions(M);else throw ie}return K=await this.J(K,i.ExtensionType.User,W,!0),this.y.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(W,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const z=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===d.Schemas.file).map(async M=>{const x=await this.P(M,!1,i.ExtensionType.User,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(x)).map(ie=>(ie.type=_.find(se=>(0,y.$Np)(se.identifier,ie.identifier))?.type??ie.type,this.n.validate(ie,x)))}))).flat();return this.J(z,"development",W,!0)}return[]}async scanExistingExtension(W,_,z){const M=await this.P(W,!1,_,!0,z.language,!0,void 0,z.productVersion??this.R()),x=await this.n.scanExtension(M);return!x||!z.includeInvalid&&!x.isValid?null:x}async scanOneOrMultipleExtensions(W,_,z){const M=await this.P(W,!1,_,!0,z.language,!0,void 0,z.productVersion??this.R()),x=await this.n.scanOneOrMultipleExtensions(M);return this.J(x,_,z,!0)}async scanMultipleExtensions(W,_,z){const M=[];return await Promise.all(W.map(async x=>{const K=await this.scanOneOrMultipleExtensions(x,_,z);M.push(...K)})),this.J(M,_,z,!0)}async scanMetadata(W){const _=(0,f.$hh)(W,"package.json"),z=(await this.w.readFile(_)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(W,_){const z=(0,f.$hh)(W,"package.json"),M=(await this.w.readFile(z)).value.toString(),x=JSON.parse(M);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,x.__metadata={...x.__metadata,..._},await this.w.writeFile((0,f.$hh)(W,"package.json"),k.$Oe.fromString(JSON.stringify(x,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof g.$Jq&&W.code===g.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Oe.fromString(JSON.stringify([])))}catch(_){(0,n.$sl)(_)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$0)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,_,z,M){return z.includeAllVersions||(W=this.L(_===i.ExtensionType.System?W:void 0,_===i.ExtensionType.User?W:void 0,_==="development"?W:void 0,await this.getTargetPlatform(),M)),z.includeInvalid||(W=W.filter(x=>x.isValid)),W.sort((x,K)=>{const ie=u.$oc(x.location.fsPath),se=u.$oc(K.location.fsPath);return ie<se?-1:ie>se?1:0})}L(W,_,z,M,x){const K=(se,C,V)=>{if(se.isValid&&!C.isValid)return!1;if(se.isValid===C.isValid){if(x&&m.gt(se.manifest.version,C.manifest.version))return this.y.debug(`Skipping extension ${C.location.path} with lower version ${C.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(m.eq(se.manifest.version,C.manifest.version)){if(se.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${C.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===M)return this.y.debug(`Skipping extension ${C.location.path} from different target platform ${C.targetPlatform}`),!1}}return V?this.y.warn(`Overwriting user extension ${se.location.path} with ${C.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${C.location.path}.`),!0},ie=new i.$un;return W?.forEach(se=>{const C=ie.get(se.identifier.id);(!C||K(C,se,!1))&&ie.set(se.identifier.id,se)}),_?.forEach(se=>{const C=ie.get(se.identifier.id);if(!C&&W&&se.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!C||K(C,se,!1))&&ie.set(se.identifier.id,se)}),z?.forEach(se=>{const C=ie.get(se.identifier.id);(!C||K(C,se,!0))&&ie.set(se.identifier.id,se),ie.set(se.identifier.id,se)}),[...ie.values()]}async M(W,_){this.y.trace("Started scanning system extensions");const z=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,_,!0,void 0,this.R()),x=await(W&&!z.devMode?this.j:this.n).scanExtensions(z);return this.y.trace("Scanned system extensions:",x.length),x}async N(W,_){const z=this.z.isBuilt?[]:this.C.builtInExtensions;if(!z?.length)return[];this.y.trace("Started scanning dev system extensions");const M=_?await this.O():{},x=[],K=h.URI.file(u.$ic(u.$kc(d.$1g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of z){const C=M[se.name]||"marketplace";switch(C){case"disabled":break;case"marketplace":x.push((0,f.$hh)(K,se.name));break;default:x.push(h.URI.file(C));break}}const ie=await Promise.all(x.map(async se=>this.n.scanExtension(await this.P(se,!1,i.ExtensionType.System,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ie.length),(0,S.$Hb)(ie)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,_,z,M,x,K,ie,se){const C=await this.f(x??p.$x),V=await this.Q(W),q=_&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=q?await this.Q(q):void 0;return new H(W,V,q,E,_,ie,z,M,K,se.version,se.date,this.C.commit,!this.z.isBuilt,x,C)}async Q(W){try{const _=await this.w.stat(W);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Pq=j,e.$Pq=j=Ee([oe(4,N.$Nl),oe(5,g.$Kq),oe(6,n.$bl),oe(7,t.$bk),oe(8,R.$Ni),oe(9,s.$uk),oe(10,T.$Ll),oe(11,r.$Fi)],j);class H{constructor(W,_,z,M,x,K,ie,se,C,V,q,E,F,J,X){this.location=W,this.mtime=_,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=M,this.profile=x,this.profileScanOptions=K,this.type=ie,this.excludeObsolete=se,this.validate=C,this.productVersion=V,this.productDate=q,this.productCommit=E,this.devMode=F,this.language=J,this.translations=X}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,_){return(0,f.$ah)(W.location,_.location)&&W.mtime===_.mtime&&(0,f.$ah)(W.applicationExtensionslocation,_.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&W.profile===_.profile&&v.$jo(W.profileScanOptions,_.profileScanOptions)&&W.type===_.type&&W.excludeObsolete===_.excludeObsolete&&W.validate===_.validate&&W.productVersion===_.productVersion&&W.productDate===_.productDate&&W.productCommit===_.productCommit&&W.devMode===_.devMode&&W.language===_.language&&D.equals(W.translations,_.translations)}}e.$Qq=H;let Y=class extends a.$Vc{constructor(W,_,z,M,x,K,ie){super(),this.g=W,this.h=_,this.j=z,this.m=M,this.n=K,this.r=ie,this.f=x.extensionsEnabledWithApiProposalVersion?.map(se=>se.toLowerCase())??[]}async scanExtensions(W){const _=W.profile?await this.t(W):await this.s(W);let z={};if(W.excludeObsolete&&W.type===i.ExtensionType.User)try{const M=(await this.m.readFile(this.g)).value.toString();z=JSON.parse(M)}catch{}return(0,b.$sg)(z)?_:_.filter(M=>!z[y.$Op.create(M).toString()])}async s(W){const _=await this.m.resolve(W.location);if(!_.children?.length)return[];const z=await Promise.all(_.children.map(async M=>{if(!M.isDirectory||W.type===i.ExtensionType.User&&(0,f.$eh)(M.resource).indexOf(".")===0)return null;const x=new H(M.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(x)}));return(0,S.$Hb)(z).sort((M,x)=>M.location.path<x.location.path?-1:1)}async t(W){let _=await this.u(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.j.extUri.isEqual(W.location,W.applicationExtensionslocation)){_=_.filter(M=>!M.metadata?.isApplicationScoped);const z=await this.u(W.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,W);_.push(...z)}return _}async u(W,_,z){const M=await this.h.scanProfileExtensions(W,z.profileScanOptions);if(!M.length)return[];const x=await Promise.all(M.map(async K=>{if(_(K)){const ie=new H(K.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(ie,K.metadata)}return null}));return(0,S.$Hb)(x)}async scanOneOrMultipleExtensions(W){try{if(await this.m.exists((0,f.$hh)(W.location,"package.json"))){const _=await this.scanExtension(W);return _?[_]:[]}else return await this.scanExtensions(W)}catch(_){return this.r.error(`Error scanning extensions at ${W.location.path}:`,(0,L.$0)(_)),[]}}async scanExtension(W,_){try{let z=await this.w(W.location);if(z){z.publisher||(z.publisher=i.$on),_=_??z.__metadata,delete z.__metadata;const M=(0,y.$Sp)(z.publisher,z.name),x=_?.id?{id:M,uuid:_.id}:{id:M},K=_?.isSystem?i.ExtensionType.System:W.type,ie=K===i.ExtensionType.System||!!_?.isBuiltin;z=await this.y(W.location,z,H.createNlsConfiguration(W));let se={type:K,identifier:x,manifest:z,location:W.location,isBuiltin:ie,targetPlatform:_?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return W.validate&&(se=this.validate(se,W)),z.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(M.toLowerCase()))&&(z.originalEnabledApiProposals=z.enabledApiProposals,z.enabledApiProposals=(0,i.$An)([...z.enabledApiProposals])),se}}catch(z){W.type!==i.ExtensionType.System&&this.r.error(z)}return null}validate(W,_){let z=!0;const M=this.n.isBuilt&&this.f.includes(W.identifier.id.toLowerCase()),x=(0,c.$5p)(_.productVersion,_.productDate,_.location,W.manifest,W.isBuiltin,M);for(const[K,ie]of x)K===I.default.Error&&(z=!1,this.r.error(this.F(_.location,ie)));return W.isValid=z,W.validations=x,W}async w(W){const _=(0,f.$hh)(W,"package.json");let z;try{z=(await this.m.readFile(_)).value.toString()}catch(x){return(0,n.$sl)(x)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(W,(0,$.localize)(1806,null,_.path,x.message))),null}let M;try{M=JSON.parse(z)}catch{const K=[];(0,O.$Zn)(z,K);for(const ie of K)this.r.error(this.F(W,(0,$.localize)(1807,null,_.path,ie.offset,ie.length,(0,w.$Mq)(ie.error))));return null}return(0,O.$8n)(M)!=="object"?(this.r.error(this.F(W,(0,$.localize)(1808,null,_.path))),null):M}async y(W,_,z){const M=await this.z(W,_,z);if(M)try{const x=[],K=await this.C(M.default,x);if(x.length>0)return x.forEach(se=>{this.r.error(this.F(W,(0,$.localize)(1809,null,M.default?.path,(0,w.$Mq)(se.error))))}),_;if((0,O.$8n)(M)!=="object")return this.r.error(this.F(W,(0,$.localize)(1810,null,M.default?.path))),_;const ie=M.values||Object.create(null);return(0,A.$Nq)(this.r,_,ie,K)}catch{}return _}async z(W,_,z){const M=(0,f.$hh)(W,"package.nls.json"),x=(C,V)=>{V.forEach(q=>{this.r.error(this.F(W,(0,$.localize)(1811,null,C?.path,(0,w.$Mq)(q.error))))})},K=C=>{this.r.error(this.F(W,(0,$.localize)(1812,null,C?.path)))},ie=`${_.publisher}.${_.name}`,se=z.translations[ie];if(se)try{const C=h.URI.file(se),V=(await this.m.readFile(C)).value.toString(),q=[],E=(0,O.$Zn)(V,q);return q.length>0?(x(C,q),{values:void 0,default:M}):(0,O.$8n)(E)!=="object"?(K(C),{values:void 0,default:M}):{values:E.contents?E.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.m.exists(M))return;let V;try{V=await this.D(W,z)}catch{return}if(!V.localized)return{values:void 0,default:V.original};try{const q=(await this.m.readFile(V.localized)).value.toString(),E=[],F=(0,O.$Zn)(q,E);return E.length>0?(x(V.localized,E),{values:void 0,default:V.original}):(0,O.$8n)(F)!=="object"?(K(V.localized),{values:void 0,default:V.original}):{values:F,default:V.original}}catch{return{values:void 0,default:V.original}}}}async C(W,_){if(W)try{const z=(await this.m.readFile(W)).value.toString();return(0,O.$Zn)(z,_)}catch{}}D(W,_){return new Promise((z,M)=>{const x=K=>{const ie=(0,f.$hh)(W,`package.nls.${K}.json`);this.m.exists(ie).then(se=>{se&&z({localized:ie,original:(0,f.$hh)(W,"package.nls.json")});const C=K.lastIndexOf("-");C===-1?z({localized:(0,f.$hh)(W,"package.nls.json"),original:null}):(K=K.substring(0,C),x(K))})};if(_.devMode||_.pseudo||!_.language)return z({localized:(0,f.$hh)(W,"package.nls.json"),original:null});x(_.language)})}F(W,_){return`[${W.path}]: ${_}`}};Y=Ee([oe(1,g.$Kq),oe(2,T.$Ll),oe(3,n.$bl),oe(4,s.$uk),oe(5,R.$Ni),oe(6,t.$bk)],Y);let ne=class extends Y{constructor(W,_,z,M,x,K,ie,se,C){super(_,M,x,K,ie,se,C),this.J=W,this.L=z,this.H=this.B(new P.$Eh(3e3)),this.I=this.B(new o.$me),this.onDidChangeCache=this.I.event}async scanExtensions(W){const _=this.P(W),z=await this.M(_);if(this.G=W,z&&z.input&&H.equals(z.input,this.G))return this.r.debug("Using cached extensions scan result",W.type===i.ExtensionType.System?"system":"user",W.location.toString()),this.H.trigger(()=>this.O()),z.result.map(x=>(x.location=h.URI.revive(x.location),x));const M=await super.scanExtensions(W);return await this.N(_,{input:W,result:M}),M}async M(W){try{const _=await this.m.readFile(W),z=JSON.parse(_.value.toString());return{result:z.result,input:(0,l.$di)(z.input)}}catch(_){this.r.debug("Error while reading the extension cache file:",W.path,(0,L.$0)(_))}return null}async N(W,_){try{await this.m.writeFile(W,k.$Oe.fromString(JSON.stringify(_)))}catch(z){this.r.debug("Error while writing the extension cache file:",W.path,(0,L.$0)(z))}}async O(){if(!this.G)return;const W=this.P(this.G),_=await this.M(W);if(!_)return;const z=_.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!v.$jo(M,z))try{this.r.info("Invalidating Cache",z,M),await this.m.del(W),this.I.fire()}catch(x){this.r.error(x)}}P(W){const _=this.Q(W);return this.j.extUri.joinPath(_.cacheHome,W.type===i.ExtensionType.System?i.$nn:i.$mn)}Q(W){return W.type===i.ExtensionType.System?this.L.defaultProfile:W.profile?this.j.extUri.isEqual(W.location,this.J.extensionsResource)?this.J:this.L.profiles.find(_=>this.j.extUri.isEqual(W.location,_.extensionsResource))??this.J:this.L.defaultProfile}};ne=Ee([oe(2,N.$Nl),oe(3,g.$Kq),oe(4,T.$Ll),oe(5,n.$bl),oe(6,s.$uk),oe(7,R.$Ni),oe(8,t.$bk)],ne);function ae(me,W){const _=(0,y.$Qp)(me.manifest.publisher,me.manifest.name);return{id:_,identifier:new i.$sn(_),isBuiltin:me.type===i.ExtensionType.System,isUserBuiltin:me.type===i.ExtensionType.User&&me.isBuiltin,isUnderDevelopment:W,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,publisherDisplayName:me.publisherDisplayName,...me.manifest}}class ue extends j{constructor(W,_,z,M,x,K,ie,se,C,V,q,E){super(W,_,(0,f.$hh)(z,".vscode-oss-dev","extensions","control.json"),M,x,K,ie,se,C,V,q,E),this.S=(async()=>{if(p.$A)try{const F=await this.w.readFile(h.URI.file(p.$A));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$Sq=ue}),define(le[137],he([0,1,60,8,38,4,2,14,15,29,6,24]),function(Z,e,S,P,v,k,L,O,w,a,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;let p=class extends L.$Vc{constructor(m,I){super(),this.b=m,this.f=I,this.a=new P.$Mh(5)}async postUninstall(m){const I=this.g(m,"uninstall");I&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(I.script,"uninstall",I.args,!0,m),this.f.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.f.error(b)}}));try{await a.Promises.rm(this.m(m))}catch(b){this.f.error("Error while removing extension storage path",m.identifier.id),this.f.error(b)}}g(m,I){const b=`vscode:${I}`;if(m.location.scheme===O.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[b]=="string"){const h=m.manifest.scripts[b].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${b} should be a node script`),null):{script:(0,w.$kc)(m.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(m,I,b,h,$){return new Promise((R,y)=>{const i=this.j(m,I,b,$);let c;const n=r=>{c&&(clearTimeout(c),c=null),r?y(r):R(void 0)};i.on("error",r=>{n((0,v.$rj)(r)||"Unknown")}),i.on("exit",(r,t)=>{n(r?`post-${I} process exited with code ${r}`:void 0)}),h&&(c=setTimeout(()=>{c=null,i.kill(),y("timed out")},5e3))})}j(m,I,b,h){const $={silent:!0,execArgv:void 0},R=(0,S.fork)(m,[`--type=extension-post-${I}`,...b],$);R.stdout.setEncoding("utf8"),R.stderr.setEncoding("utf8");const y=k.Event.fromNodeEventEmitter(R.stdout,"data"),i=k.Event.fromNodeEventEmitter(R.stderr,"data");this.B(y(r=>this.f.info(h.identifier.id,h.manifest.version,`post-${I}`,r))),this.B(i(r=>this.f.error(h.identifier.id,h.manifest.version,`post-${I}`,r)));const c=k.Event.any(k.Event.map(y,r=>({data:`%c${r}`,format:[""]}),this.q),k.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return k.Event.debounce(c,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(h.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),R}m(m){return(0,w.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};e.$Wq=p,e.$Wq=p=Ee([oe(0,u.$Nl),oe(1,d.$bk)],p)}),define(le[72],he([0,1,50,5,53,20]),function(Z,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=L,e.$Uq=O;function L(w){let a=k.ExtensionManagementErrorCode.Extract;return w instanceof S.$Cq&&(w.type==="CorruptZip"?a=k.ExtensionManagementErrorCode.CorruptZip:w.type==="Incomplete"&&(a=k.ExtensionManagementErrorCode.IncompleteZip)),(0,v.$Hq)(w,a)}async function O(w){let a;try{a=await(0,S.$Fq)(w,"extension/package.json")}catch(d){throw L(d)}try{return JSON.parse(a.toString("utf8"))}catch{throw new k.$op((0,P.localize)(1822,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(le[138],he([0,1,8,7,2,14,16,45,3,28,29,50,30,17,53,20,26,72,71,9,6,18]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h,$,R,y,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0,O=be(O);let n=class extends v.$Vc{static{c=this}static{this.c=".sigzip"}constructor(t,s,o,l,g,N,T){super(),this.h=s,this.j=o,this.m=l,this.n=g,this.r=N,this.t=T,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,o,l){await this.g;const g=await this.w(t,s);let N=!1;if(o&&this.u(t)){let T;try{T=await this.y(t)}catch(A){try{await this.delete(g)}catch(D){this.t.error(D)}throw A}try{N=await this.n.verify(t,g.fsPath,T.fsPath,l)}catch(A){if(N=A.code,N===$.ExtensionSignatureVerificationCode.PackageIsInvalidZip||N===$.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(g)}catch(D){this.t.error(D)}throw new I.$op(u.$Bq,I.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(A){this.t.error(A)}}}return{location:g,verificationStatus:N}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,w.$lg)(s)?s:!0}async w(t,s){try{const o=(0,L.$hh)(this.extensionsDownloadDir,this.G(t)),l=await this.C(t,"vsix",async()=>{await this.z(t,o,g=>this.j.download(t,g,s));try{await this.D(o.fsPath,"extension/package.json")}catch(g){try{await this.h.del(o)}catch(N){this.t.warn(`Error while deleting: ${o.path}`,(0,P.$0)(N))}throw g}},2);return l>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:l}),o}catch(o){throw(0,m.$Hq)(o,I.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,L.$hh)(this.extensionsDownloadDir,`.${(0,a.$3g)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(l){try{await this.h.del(s)}catch(g){this.t.warn(`Error while deleting: ${s.path}`,(0,P.$0)(g))}throw l}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),s}catch(s){throw(0,m.$Hq)(s,I.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,o){if(await this.h.exists(s))return;if(s.scheme!==k.Schemas.file){await o(s);return}const l=(0,L.$hh)(this.extensionsDownloadDir,`.${(0,a.$3g)()}`);try{await o(l)}catch(g){try{await this.h.del(l)}catch{}throw g}try{await d.Promises.rename(l.fsPath,s.fsPath,2*60*1e3)}catch(g){try{await this.h.del(l)}catch{}let N=!1;try{N=await this.h.exists(s)}catch{}if(N)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,P.$0)(g)}. Deleted the file from downloaded location`,l.path),g}}async C(t,s,o,l){let g=1;for(;;)try{return await o(),g}catch(N){if(g++>l)throw N;this.t.warn(`Failed downloading ${s}. ${(0,P.$0)(N)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,u.$Fq)(t,s)}catch(o){throw(0,h.$Tq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],o=[],l=[];for(const T of t.children)if(T.name.endsWith(c.c))l.push(T.resource);else{const A=b.$Op.parse(T.name);A&&o.push([A,T])}const g=(0,b.$Tp)(o,([T])=>T),N=[];for(const T of g)T.sort((A,D)=>O.rcompare(A[0].version,D[0].version)),s.push(...T.slice(1).map(A=>A[1].resource)),N.push(T[0][1]);N.sort((T,A)=>T.mtime-A.mtime),s.push(...N.slice(0,Math.max(0,N.length-this.f)).map(T=>T.resource)),s.push(...l),await S.Promises.settled(s.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(t){this.t.error(t)}}G(t){return this.f?b.$Op.create(t).toString().toLowerCase():(0,a.$3g)()}};e.$Vq=n,e.$Vq=n=c=Ee([oe(0,f.$Oi),oe(1,R.$bl),oe(2,I.$mp),oe(3,p.$aj),oe(4,$.$uq),oe(5,i.$am),oe(6,y.$bk)],n)}),define(le[139],he([0,1,32,8,13,21,38,7,4,43,2,25,14,15,16,45,3,11,28,29,50,5,61,17,53,20,26,42,54,138,137,72,119,126,22,44,9,10,6,33,18,23,24]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h,$,R,y,i,c,n,r,t,s,o,l,g,N,T,A,D,j,H,Y,ne,ae,ue,me,W,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=void 0,S=be(S),f=be(f),I=be(I),R=be(R),i=be(i),e.$Zq=(0,ne.$Hi)(t.$pp);const z=".vsctmp";let M=class extends r.$Gq{constructor(C,V,q,E,F,J,X,G,U,Q,re,ce){super(C,V,re,q,Q,ce),this.db=F,this.eb=J,this.fb=X,this.gb=G,this.hb=U,this.cb=new Map,this.sb=new u.$Cc;const fe=this.B(G.createInstance(N.$Wq));this.$=this.B(G.createInstance(x,de=>fe.postUninstall(de))),this.ab=this.B(new A.$Xq(ce,U,re,this,this.F)),this.bb=this.B(G.createInstance(g.$Vq));const we=this.B(new D.$Yq(this,this.db,ce,J,re,U,q));this.B(we.onDidChangeExtensionsByAnotherSource(de=>this.rb(de))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Yp)(this.hb,this.F)),this.ib}async zip(C){this.F.trace("ExtensionManagementService#zip",C.identifier.id);const V=await this.qb(C),q=await(0,y.zip)((0,m.$hh)(this.bb.extensionsDownloadDir,(0,$.$3g)()).fsPath,V);return h.URI.file(q)}async getManifest(C){const{location:V,cleanup:q}=await this.kb(C),E=f.$lc(V.fsPath);try{return await(0,T.$Uq)(E)}finally{await q()}}getInstalled(C,V=this.H.defaultProfile.extensionsResource,q={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(C??null,V,q)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.$.scanUserExtensionAtLocation(C)}async install(C,V={}){this.F.trace("ExtensionManagementService#install",C.toString());const{location:q,cleanup:E}=await this.kb(C);try{const F=await(0,T.$Uq)(f.$lc(q.fsPath)),J=(0,s.$Sp)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,H.$7p)(F.engines.vscode,this.G.version,this.G.date))throw new Error(i.localize(1813,null,J,this.G.version));const G=(await this.I([{manifest:F,extension:q,options:V}])).find(({identifier:U})=>(0,s.$Np)(U,{id:J}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$Hq)(new Error(`Unknown error while installing extension ${J}`))}finally{await E()}}async installFromLocation(C,V){this.F.trace("ExtensionManagementService#installFromLocation",C.toString());const q=await this.$.scanUserExtensionAtLocation(C);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.vb([[q,{source:"resource"}]],V),this.F.info("Successfully installed extension",q.identifier.id,V.toString()),q}async installExtensionsFromProfile(C,V,q){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",C,V.toString(),q.toString());const E=(await this.getInstalled(j.ExtensionType.User,V)).filter(F=>C.some(J=>(0,s.$Np)(J,F.identifier)));if(E.length){const F=await Promise.all(E.map(J=>this.$.scanMetadata(J,V)));await this.vb(E.map((J,X)=>[J,F[X]]),q),this.F.info("Successfully installed extensions",E.map(J=>J.identifier.id),q.toString())}return E}async updateMetadata(C,V,q){return this.F.trace("ExtensionManagementService#updateMetadata",C.identifier.id),V.isPreReleaseVersion&&(V.preRelease=!0,V.hasPreReleaseVersion=!0),V.isMachineScoped===!1&&(V.isMachineScoped=void 0),V.isBuiltin===!1&&(V.isBuiltin=void 0),V.pinned===!1&&(V.pinned=void 0),C=await this.$.updateMetadata(C,V,q),this.ab.invalidate(q),this.w.fire({local:C,profileLocation:q}),C}async reinstallFromGallery(C){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.z.isEnabled())throw new Error(i.localize(1814,null));const V=await this.getTargetPlatform(),[q]=await this.z.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:V,compatible:!0},k.CancellationToken.None);if(!q)throw new Error(i.localize(1815,null));await this.$.setUninstalled(C);try{await this.$.removeUninstalledExtension(C)}catch(E){throw new Error(i.localize(1816,null,(0,L.$rj)(E)))}return this.installFromGallery(q)}Z(C,V,q,E){return this.$.copyExtension(C,V,q,E)}copyExtensions(C,V){return this.$.copyExtensions(C,V,{version:this.G.version,date:this.G.date})}markAsUninstalled(...C){return this.$.setUninstalled(...C)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(C){this.F.error(C)}}async download(C,V,q){const{location:E}=await this.bb.download(C,V,!q);return E}async kb(C){if(C.scheme===p.Schemas.file)return{location:C,async cleanup(){}};this.F.trace("Downloading extension from",C.toString());const V=(0,m.$hh)(this.bb.extensionsDownloadDir,(0,$.$3g)());return await this.fb.download(C,V),this.F.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.hb.del(V)}catch(E){this.F.error(E)}}}}W(){return this.H.defaultProfile.extensionsResource}X(C,V,q){const E=V instanceof h.URI?new s.$Op({id:(0,s.$Sp)(C.publisher,C.name)},C.version):s.$Op.create(V);return this.gb.createInstance(K,E,C,V,q,(F,J)=>{if(V instanceof h.URI)return this.pb(E,V,q,J);let X=this.cb.get(E.toString());return X||(this.cb.set(E.toString(),X=this.ob(E,V,F,q,J)),X.finally(()=>this.cb.delete(E.toString()))),X},this.$)}Y(C,V){return new ie(C,V,this.eb)}async ob(C,V,q,E,F){const{verificationStatus:J,location:X}=await this.bb.download(V,q,!E.donotVerifySignature,E.context?.[t.$fp]);try{if(F.isCancellationRequested)throw new O.$5;const G=await(0,T.$Uq)(X.fsPath);if(!new s.$Op(V.identifier,V.version).equals(new s.$Op({id:(0,s.$Sp)(G.publisher,G.name)},G.version)))throw new t.$op(i.localize(1817,null,V.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(C,X.fsPath,{id:V.identifier.uuid,publisherId:V.publisherId,publisherDisplayName:V.publisherDisplayName,targetPlatform:V.properties.targetPlatform,isApplicationScoped:E.isApplicationScoped,isMachineScoped:E.isMachineScoped,isBuiltin:E.isBuiltin,isPreReleaseVersion:V.properties.isPreReleaseVersion,hasPreReleaseVersion:V.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:E.installGivenVersion?!0:!!E.pinned,preRelease:(0,b.$lg)(E.preRelease)?E.preRelease:E.installPreReleaseVersion||V.properties.isPreReleaseVersion,source:"gallery"},!1,F),verificationStatus:J}}catch(G){try{await this.bb.delete(X)}catch(U){this.F.warn("Error while deleting the downloaded file",X.toString(),(0,O.$0)(U))}throw(0,r.$Hq)(G)}}async pb(C,V,q,E){return{local:await this.$.extractUserExtension(C,f.$lc(V.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},q.keepExisting??!0,E)}}async qb(C){const V=async E=>{let F=await R.Promises.readdir(E);F=F.map(G=>f.$kc(E,G));const J=await Promise.all(F.map(G=>S.promises.stat(G)));let X=Promise.resolve([]);return J.forEach((G,U)=>{const Q=F[U];G.isFile()&&(X=X.then(re=>[...re,Q])),G.isDirectory()&&(X=X.then(re=>V(Q).then(ce=>[...re,...ce])))}),X};return(await V(C.location.fsPath)).map(E=>({path:`extension/${f.$mc(C.location.fsPath,E)}`,localPath:E}))}async rb({added:C,removed:V}){if(V){const q=C&&this.D.extUri.isEqual(V.profileLocation,C.profileLocation)?V.extensions.filter(E=>C.extensions.every(F=>!(0,s.$Np)(F,E))):V.extensions;for(const E of q)this.F.info("Extensions removed from another source",E.id,V.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:V.profileLocation})}if(C){const E=(await this.getInstalled(j.ExtensionType.User,C.profileLocation)).filter(F=>C.extensions.some(J=>(0,s.$Np)(J,F.identifier)));this.s.fire(E.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,C.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:C.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(V=>this.sb.add(V)));const C=await this.hb.resolve(this.db.userExtensionsLocation);for(const V of C.children??[])V.isDirectory&&this.sb.add(V.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(V=>this.ub(V)))}async ub(C){if(!C.affects(this.db.userExtensionsLocation,Y.FileChangeType.ADDED))return;const V=[];for(const q of C.rawAdded){if(this.sb.has(q)||!this.D.extUri.isEqual(this.D.extUri.dirname(q),this.db.userExtensionsLocation)||this.D.extUri.isEqual(q,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(q).startsWith(".")||!(await this.hb.stat(q)).isDirectory)continue;const E=await this.$.scanUserExtensionAtLocation(q);E&&E.installedTimestamp===void 0&&(this.sb.add(q),V.push(E))}V.length&&(await this.vb(V.map(q=>[q,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",V.map(q=>q.identifier.id)))}async vb(C,V){const q=C.map(E=>E[0]);await this.wb(q),await this.eb.addExtensionsToProfile(C,V),this.s.fire(q.map(E=>({local:E,identifier:E.identifier,operation:t.InstallOperation.None,profileLocation:V})))}async wb(C){const V=await this.$.getUninstalledExtensions();for(const q of C){const E=s.$Op.create(q);V[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.$.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$1q=M,e.$1q=M=Ee([oe(0,t.$mp),oe(1,me.$am),oe(2,ae.$bk),oe(3,n.$Oi),oe(4,l.$Oq),oe(5,o.$Kq),oe(6,c.$3o),oe(7,ne.$Fi),oe(8,Y.$bl),oe(9,ue.$uk),oe(10,W.$Ll),oe(11,_.$Nl)],M);let x=class extends d.$Vc{constructor(C,V,q,E,F,J,X){super(),this.n=C,this.s=V,this.t=q,this.u=E,this.w=F,this.y=J,this.z=X,this.h=this.B(new w.$me),this.onExtract=this.h.event,this.j=new u.$Bc,this.m=new u.$Bc,this.c=(0,m.$hh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Nh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(C,V,q){try{const E={includeInvalid:!0,profileLocation:V,productVersion:q};let F=[];if(C===null||C===j.ExtensionType.System){let J=this.j.get(V);J||(J=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},E,!1).finally(()=>this.j.delete(V)),this.j.set(V,J)),F.push(...await J)}else if(C===j.ExtensionType.User){let J=this.m.get(V);J||(J=this.t.scanUserExtensions(E).finally(()=>this.m.delete(V)),this.m.set(V,J)),F.push(...await J)}return F=C!==null?F.filter(J=>J.type===C):F,await Promise.all(F.map(J=>this.H(J)))}catch(E){throw(0,r.$Hq)(E,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(C){try{const V=await this.t.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return await Promise.all(V.map(q=>this.H(q)))}catch(V){throw(0,r.$Hq)(V,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(C){try{const V=await this.t.scanExistingExtension(C,j.ExtensionType.User,{includeInvalid:!0});if(V)return await this.H(V)}catch(V){this.z.error(V)}return null}async extractUserExtension(C,V,q,E,F){const J=C.toString(),X=h.URI.file(f.$kc(this.t.userExtensionsLocation.fsPath,`.${(0,$.$3g)()}`)),G=h.URI.file(f.$kc(this.t.userExtensionsLocation.fsPath,J));if(await this.s.exists(G)){if(!E)try{return await this.scanLocalExtension(G,j.ExtensionType.User)}catch(U){this.z.warn(`Error while scanning the existing extension at ${G.path}. Deleting the existing extension and extracting it.`,(0,O.$0)(U))}try{await this.D(C.id,G,"removeExisting")}catch{throw new t.$op(i.localize(1818,null,G.fsPath,C.id),t.ExtensionManagementErrorCode.Delete)}}try{if(F.isCancellationRequested)throw new O.$5;try{this.z.trace(`Started extracting the extension from ${V} to ${G.fsPath}`),await(0,y.$Eq)(V,X.fsPath,{sourcePath:"extension",overwrite:!0},F),this.z.info(`Extracted extension to ${G}:`,C.id)}catch(U){throw(0,T.$Tq)(U)}try{await this.t.updateMetadata(X,q)}catch(U){throw this.y.publicLog2("extension:extract",{extensionId:C.id,code:`${(0,Y.$sl)(U)}`}),(0,r.$Hq)(U,t.ExtensionManagementErrorCode.UpdateMetadata)}if(F.isCancellationRequested)throw new O.$5;try{this.z.trace(`Started renaming the extension from ${X.fsPath} to ${G.fsPath}`),await this.G(X.fsPath,G.fsPath),this.z.info("Renamed to",G.fsPath)}catch(U){if(U.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);try{await this.s.del(X,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,O.$0)(U)}. Deleted from extracted location`,X),U}this.h.fire(G)}catch(U){try{await this.s.del(X,{recursive:!0})}catch{}throw U}return this.scanLocalExtension(G,j.ExtensionType.User)}async scanMetadata(C,V){return V?(await this.C(C,V))?.metadata:this.t.scanMetadata(C.location)}async C(C,V){return(await this.u.scanProfileExtensions(V)).find(E=>(0,s.$Np)(E.identifier,C.identifier))}async updateMetadata(C,V,q){try{q?await this.u.updateMetadata([[C,V]],q):await this.t.updateMetadata(C.location,V)}catch(E){throw this.y.publicLog2("extension:extract",{extensionId:C.identifier.id,code:`${(0,Y.$sl)(E)}`,isProfile:!!q}),(0,r.$Hq)(E,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(C.location,C.type,q)}async getUninstalledExtensions(){try{return await this.F()}catch(C){throw(0,r.$Hq)(C,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...C){const V=C.map(q=>s.$Op.create(q));await this.F(q=>V.forEach(E=>{q[E.toString()]=!0,this.z.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(C){try{await this.F(V=>delete V[C.toString()])}catch(V){throw(0,r.$Hq)(V,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(C,V){if(this.w.extUri.isEqualOrParent(C.location,this.t.userExtensionsLocation))return this.D(C.identifier.id,C.location,V)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.F(V=>delete V[s.$Op.create(C).toString()])}async copyExtension(C,V,q,E){const F=await this.C(C,V),J=await this.C(C,q);if(E={...F?.metadata,...E},J)if(this.w.extUri.isEqual(J.location,C.location))await this.u.updateMetadata([[C,{...J.metadata,...E}]],q);else{const X=await this.scanLocalExtension(J.location,C.type,q);await this.u.removeExtensionFromProfile(X,q),await this.u.addExtensionsToProfile([[C,{...J.metadata,...E}]],q)}else await this.u.addExtensionsToProfile([[C,E]],q);return this.scanLocalExtension(C.location,C.type,q)}async copyExtensions(C,V,q){const E=await this.scanExtensions(j.ExtensionType.User,C,q),F=await Promise.all(E.filter(J=>!J.isApplicationScoped).map(async J=>[J,await this.scanMetadata(J,C)]));await this.u.addExtensionsToProfile(F,V)}async D(C,V,q){this.z.trace(`Deleting ${q} extension from disk`,C,V.fsPath);const E=this.w.extUri.joinPath(this.w.extUri.dirname(V),`${this.w.extUri.basename(V)}.${(0,a.$uj)((0,$.$3g)()).toString(16)}${z}`);await this.G(V.fsPath,E.fsPath),await this.s.del(E,{recursive:!0}),this.z.info(`Deleted ${q} extension from disk`,C,V.fsPath)}F(C){return this.g.queue(async()=>{let V;try{V=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,Y.$sl)(E)!==Y.FileOperationResult.FILE_NOT_FOUND)throw E}let q={};if(V)try{q=JSON.parse(V)}catch{}return C&&(C(q),Object.keys(q).length?await this.s.writeFile(this.c,v.$Oe.fromString(JSON.stringify(q))):await this.s.del(this.c)),q})}async G(C,V){try{await R.Promises.rename(C,V,2*60*1e3)}catch(q){throw(0,r.$Hq)(q,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(C,V,q){try{if(q){const F=(await this.t.scanUserExtensions({profileLocation:q})).find(J=>this.w.extUri.isEqual(J.location,C));if(F)return await this.H(F)}else{const E=await this.t.scanExistingExtension(C,V,{includeInvalid:!0});if(E)return await this.H(E)}throw new t.$op(i.localize(1819,null,C.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(E){throw(0,r.$Hq)(E,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(C){const V=await this.s.resolve(C.location);let q,E;return V.children&&(q=V.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,E=V.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:q,changelogUrl:E,publisherDisplayName:C.metadata?.publisherDisplayName,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!C.metadata?.hasPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned,isWorkspaceScoped:!1,source:C.metadata?.source??(C.identifier.uuid?"gallery":"vsix")}}async I(){const C=await this.getUninstalledExtensions();if(Object.keys(C).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(C));const V=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const F of V)C[s.$Op.create(F).toString()]||q.add(F.identifier.id.toLowerCase());try{const F=(0,s.$Tp)(V,J=>J.identifier);await P.Promises.settled(F.map(async J=>{const X=J.sort((G,U)=>I.rcompare(G.manifest.version,U.manifest.version))[0];q.has(X.identifier.id.toLowerCase())||await this.n(await this.H(X))}))}catch(F){this.z.error(F)}const E=V.filter(F=>F.metadata&&C[s.$Op.create(F).toString()]);await Promise.allSettled(E.map(F=>this.removeUninstalledExtension(F)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let C;try{C=await this.s.resolve(this.t.userExtensionsLocation)}catch(V){(0,Y.$sl)(V)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(V);return}if(C?.children)try{await Promise.allSettled(C.children.map(async V=>{if(!(!V.isDirectory||!V.name.endsWith(z))){this.z.trace("Deleting the temporarily deleted folder",V.resource.toString());try{await this.s.del(V.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",V.resource.toString())}catch(q){(0,Y.$sl)(q)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q)}}}))}catch{}}};e.$2q=x,e.$2q=x=Ee([oe(1,Y.$bl),oe(2,l.$Oq),oe(3,o.$Kq),oe(4,W.$Ll),oe(5,me.$am),oe(6,ae.$bk)],x);let K=class extends r.$Iq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(C,V,q,E,F,J,X,G,U,Q,re,ce){super(),this.l=C,this.manifest=V,this.source=q,this.options=E,this.m=F,this.n=J,this.o=X,this.p=G,this.q=U,this.s=Q,this.t=re,this.u=ce,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(C){const q=(await this.n.scanExtensions(j.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(X=>(0,s.$Np)(X.identifier,this.identifier));q&&(this.j=t.InstallOperation.Update);const E={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===j.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof h.URI?"vsix":"gallery"};let F;if(this.source instanceof h.URI){if(q&&this.l.equals(new s.$Op(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(i.localize(1820,null,this.manifest.displayName||this.manifest.name))}const X=await this.w(this.l);if(X)try{await this.n.removeExtension(X,"existing")}catch{throw new Error(i.localize(1821,null,this.manifest.displayName||this.manifest.name))}}else{if(E.id=this.source.identifier.uuid,E.publisherId=this.source.publisherId,E.publisherDisplayName=this.source.publisherDisplayName,E.targetPlatform=this.source.properties.targetPlatform,E.updated=!!q,E.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,E.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,E.preRelease=(0,b.$lg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==j.ExtensionType.System&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,E,this.options.profileLocation);F=await this.w(this.l)}if(C.isCancellationRequested)throw(0,r.$Hq)(new O.$5);if(!F){const X=await this.m(this.operation,C);F=X.local,this.k=X.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(X){throw(0,r.$Hq)(X,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(C.isCancellationRequested)throw(0,r.$Hq)(new O.$5);try{await this.t.addExtensionsToProfile([[F,E]],this.options.profileLocation,!F.isValid)}catch(X){throw(0,r.$Hq)(X,t.ExtensionManagementErrorCode.AddToProfile)}const J=await this.n.scanLocalExtension(F.location,j.ExtensionType.User,this.options.profileLocation);if(!J)throw new t.$op("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof h.URI&&this.x(F,C),J}async w(C){return(await this.n.getUninstalledExtensions())[C.toString()]?(this.u.trace("Removing the extension from uninstalled list:",C.id),await this.n.setInstalled(C),this.u.info("Removed the extension from uninstalled list:",C.id),(await this.n.scanAllUserExtensions(!0)).find(E=>s.$Op.create(E).equals(C))):void 0}async x(C,V){try{let[q]=await this.p.getExtensions([{id:C.identifier.id,version:C.manifest.version}],V);if(q||([q]=await this.p.getExtensions([{id:C.identifier.id}],V)),q){const E={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:C.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(C,E,this.options.profileLocation)}}catch{}}};K=Ee([oe(6,W.$Ll),oe(7,t.$mp),oe(8,_.$Nl),oe(9,l.$Oq),oe(10,o.$Kq),oe(11,ae.$bk)],K);class ie extends r.$Iq{constructor(C,V,q){super(),this.extension=C,this.options=V,this.j=q}async h(C){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(le[140],he([0,1,6,24,23,18,42,9,17,11]),function(Z,e,S,P,v,k,L,O,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NR=void 0;let d=class extends L.$Lq{constructor(p,f,m,I,b,h){super(a.URI.file(p.extensionsPath),f,m,I,b,h)}};e.$NR=d,e.$NR=d=Ee([oe(0,w.$Oi),oe(1,O.$bl),oe(2,P.$Nl),oe(3,v.$Ll),oe(4,k.$am),oe(5,S.$bk)],d)}),define(le[141],he([0,1,11,17,42,54,9,10,6,33,23,24]),function(Z,e,S,P,v,k,L,O,w,a,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;let p=class extends k.$Sq{constructor(m,I,b,h,$,R,y,i){super(S.URI.file($.builtinExtensionsPath),S.URI.file($.extensionsPath),$.userHome,m.defaultProfile,m,I,b,h,$,R,y,i)}};e.$Fhc=p,e.$Fhc=p=Ee([oe(0,u.$Nl),oe(1,v.$Kq),oe(2,L.$bl),oe(3,w.$bk),oe(4,P.$Oi),oe(5,a.$uk),oe(6,d.$Ll),oe(7,O.$Fi)],p)}),define(le[73],he([0,1,8,4,2,109,3,89,10,24]),function(Z,e,S,P,v,k,L,O,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$lq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$jq=e.$iq=e.$hq=void 0,e.$kq=f,e.$mq=I,e.$oq=h,e.$hq="__$__isNewStorageMarker",e.$iq="__$__targetStorageMarker",e.$jq=(0,w.$Gi)("storageService");var d;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(d||(e.WillSaveStateReason=d={}));var u;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var p;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function f($){const R=$.get(e.$iq);if(R)try{return JSON.parse(R)}catch{}return Object.create(null)}class m extends v.$Vc{static{this.a=60*1e3}constructor(R={flushInterval:m.a}){super(),this.m=R,this.b=this.B(new P.$pe),this.c=this.B(new P.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new P.$me),this.onWillSaveState=this.f.event,this.h=this.B(new S.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new v.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(R,y,i){return P.Event.filter(this.b.event,c=>c.scope===R&&(y===void 0||c.key===y),i)}n(){this.j.value=(0,S.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,v.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(R,y){const{key:i,external:c}=y;if(i===e.$iq){switch(R){case u.APPLICATION:this.H=void 0;break;case u.PROFILE:this.F=void 0;break;case u.WORKSPACE:this.C=void 0;break}this.c.fire({scope:R})}else this.b.fire({scope:R,key:i,target:this.J(R)[i],external:c})}w(R){this.f.fire({reason:R})}get(R,y,i){return this.P(y)?.get(R,i)}getBoolean(R,y,i){return this.P(y)?.getBoolean(R,i)}getNumber(R,y,i){return this.P(y)?.getNumber(R,i)}getObject(R,y,i){return this.P(y)?.getObject(R,i)}storeAll(R,y){this.y(()=>{for(const i of R)this.store(i.key,i.value,i.scope,i.target,y)})}store(R,y,i,c,n=!1){if((0,L.$og)(y)){this.remove(R,i,n);return}this.y(()=>{this.z(R,i,c),this.P(i)?.set(R,y,n)})}remove(R,y,i=!1){this.y(()=>{this.z(R,y,void 0),this.P(y)?.delete(R,i)})}y(R){this.b.pause(),this.c.pause();try{R()}finally{this.b.resume(),this.c.resume()}}keys(R,y){const i=[],c=this.J(R);for(const n of Object.keys(c))c[n]===y&&i.push(n);return i}z(R,y,i,c=!1){const n=this.J(y);typeof i=="number"?n[R]!==i&&(n[R]=i,this.P(y)?.set(e.$iq,JSON.stringify(n),c)):typeof n[R]=="number"&&(delete n[R],this.P(y)?.set(e.$iq,JSON.stringify(n),c))}get D(){return this.C||(this.C=this.L(u.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(u.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(u.APPLICATION)),this.H}J(R){switch(R){case u.APPLICATION:return this.I;case u.PROFILE:return this.G;default:return this.D}}L(R){const y=this.P(R);return y?f(y):Object.create(null)}isNew(R){return this.getBoolean(e.$hq,R)===!0}async flush(R=d.NONE){this.f.fire({reason:R});const y=this.P(u.APPLICATION),i=this.P(u.PROFILE),c=this.P(u.WORKSPACE);switch(R){case d.NONE:await S.Promises.settled([y?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case d.SHUTDOWN:await S.Promises.settled([y?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async log(){const R=this.P(u.APPLICATION)?.items??new Map,y=this.P(u.PROFILE)?.items??new Map,i=this.P(u.WORKSPACE)?.items??new Map;return h(R,y,i,this.Q(u.APPLICATION)??"",this.Q(u.PROFILE)??"",this.Q(u.WORKSPACE)??"")}async optimize(R){return await this.flush(),this.P(R)?.optimize()}async switch(R,y){return this.w(d.NONE),(0,a.$Ml)(R)?this.R(R,y):this.S(R,y)}M(R,y){return!(R.id===y.id||I(y)&&I(R))}N(R,y,i){this.y(()=>{const c=new Set;for(const[n,r]of R)c.add(n),y.get(n)!==r&&this.u(i,{key:n,external:!0});for(const[n]of y.items)c.has(n)||this.u(i,{key:n,external:!0})})}}e.$lq=m;function I($){return $.isDefault||!!$.useDefaultFlags?.globalState}class b extends m{constructor(){super(),this.U=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(R=>this.u(u.WORKSPACE,R))),this.B(this.W.onDidChangeStorage(R=>this.u(u.PROFILE,R))),this.B(this.U.onDidChangeStorage(R=>this.u(u.APPLICATION,R)))}P(R){switch(R){case u.APPLICATION:return this.U;case u.PROFILE:return this.W;default:return this.X}}Q(R){switch(R){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(R){return!1}}e.$nq=b;async function h($,R,y,i,c,n){const r=D=>{try{return JSON.parse(D)}catch{return D}},t=new Map,s=new Map;$.forEach((D,j)=>{t.set(j,D),s.set(j,r(D))});const o=new Map,l=new Map;R.forEach((D,j)=>{o.set(j,D),l.set(j,r(D))});const g=new Map,N=new Map;y.forEach((D,j)=>{g.set(j,D),N.set(j,r(D))}),console.group(i!==c?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const T=[];if(t.forEach((D,j)=>{T.push({key:j,value:D})}),console.table(T),console.groupEnd(),console.log(s),i!==c){console.group(`Storage: Profile (path: ${c}, profile specific)`);const D=[];o.forEach((j,H)=>{D.push({key:H,value:j})}),console.table(D),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${n})`);const A=[];g.forEach((D,j)=>{A.push({key:j,value:D})}),console.table(A),console.groupEnd(),console.log(N)}}),define(le[142],he([0,1,13,28,73]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=k;async function k(L,O,w){let a=w&&w.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(a)return a;try{const u=(await O.readFile(L.serviceMachineIdResource)).value.toString();a=(0,P.$2g)(u)?u:null}catch{a=null}if(!a){a=(0,P.$3g)();try{await O.writeFile(L.serviceMachineIdResource,S.$Oe.fromString(a))}catch{}}return w?.store("storage.serviceMachineId",a,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),a}}),define(le[143],he([0,1,142,18,41]),function(Z,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=k;async function k(L,O,w,a,d,u,p){const f={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${O.nameShort})`};if((0,v.$Fp)(O,w)&&(0,v.$Hp)(a)===P.TelemetryLevel.USAGE){const m=await(0,S.$pq)(w,d,u);f["X-Market-User-Id"]=m,f["VSCode-SessionId"]=p.machineId||m}return f}}),define(le[144],he([0,1,19,21,7,12,36,3,11,88,30,17,20,26,22,44,9,6,33,46,143,73,18,156]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h,$,R,y,i,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0,e.$rq=V;const r=k.$p?m.TargetPlatform.WEB:(0,p.$ip)(k.$v,L.$fc),t="X-Market-Search-Activity-Id";var s;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished",G[G.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function o(...G){return String(G.reduce((U,Q)=>U|Q,0))}var l;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(l||(l={}));const g={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},N={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},A={pageNumber:1,pageSize:10,sortBy:p.SortBy.NoneOrRelevance,sortOrder:p.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class D{constructor(U=A){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,Q=this.d.pageSize){return new D({...this.d,pageNumber:U,pageSize:Q})}withFilter(U,...Q){const re=[...this.d.criteria,...Q.length?Q.map(ce=>({filterType:U,value:ce})):[{filterType:U}]];return new D({...this.d,criteria:re})}withSortBy(U){return new D({...this.d,sortBy:U})}withSortOrder(U){return new D({...this.d,sortOrder:U})}withFlags(...U){return new D({...this.d,flags:U.reduce((Q,re)=>Q|re,0)})}withAssetTypes(...U){return new D({...this.d,assetTypes:U})}withSource(U){return new D({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:Q,pageSize:re,sortBy:ce,sortOrder:fe,flags:we,assetTypes:de}=this.d;return{filters:[{criteria:U,pageNumber:Q,pageSize:re,sortBy:ce,sortOrder:fe}],assetTypes:de,flags:we}}get searchText(){const U=this.d.criteria.filter(Q=>Q.filterType===l.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(G,U){const Q=(G||[]).filter(re=>re.statisticName===U)[0];return Q?Q.value:0}function H(G){const U="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(re=>re.assetType.indexOf(U)===0).reduce((re,ce)=>{const fe=ae(G,ce.assetType);return fe&&re.push([ce.assetType.substring(U.length),fe]),re},[])}function Y(G){if(G.properties){const U=G.properties.filter(ce=>ce.key===g.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=U.filter(ce=>Q.test(ce.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return ae(G,g.Repository)}function ne(G){return{uri:`${G.fallbackAssetUri}/${g.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${g.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function ae(G,U){return G.files.filter(re=>re.assetType===U)[0]?{uri:`${G.assetUri}/${U}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${U}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}:null}function ue(G,U){const Q=G.properties?G.properties.filter(ce=>ce.key===U):[],re=Q.length>0&&Q[0].value;return re?re.split(",").map(ce=>(0,f.$Rp)(ce)):[]}function me(G){const U=G.properties?G.properties.filter(Q=>Q.key===N.Engine):[];return U.length>0&&U[0].value||""}function W(G){const U=G.properties?G.properties.filter(Q=>Q.key===N.PreRelease):[];return U.length>0&&U[0].value==="true"}function _(G){const U=G.properties?G.properties.filter(Q=>Q.key===N.ExecutesCode):[];return U.length>0?U[0].value==="true":void 0}function z(G){const U=G.properties?G.properties.filter(re=>re.key===N.EnabledApiProposals):[],Q=U.length>0&&U[0].value||"";return Q?Q.split(","):[]}function M(G){const U=G.properties?G.properties.filter(re=>re.key===N.LocalizedLanguages):[],Q=U.length>0&&U[0].value||"";return Q?Q.split(","):[]}function x(G){return G.properties?.find(U=>U.key===N.SponsorLink)?.value}function K(G){return G.properties?.find(U=>U.key===N.SupportLink)?.value}function ie(G){return G.indexOf("preview")!==-1}function se(G){return G.targetPlatform?(0,p.$hp)(G.targetPlatform):m.TargetPlatform.UNDEFINED}function C(G){const U=(0,S.$Mb)(G.versions.map(se)),Q=!!G.tags?.includes(p.$bp),re=U.indexOf(m.TargetPlatform.WEB);return Q?re===-1&&U.push(m.TargetPlatform.WEB):re!==-1&&U.splice(re,1),U}function V(G,U){for(let Q=0;Q<G.length;Q++){const re=G[Q];if(re.version===G[Q-1]?.version){let ce=Q;if(se(re)===U)for(;ce>0&&G[ce-1].version===re.version;)ce--;ce!==Q&&(G.splice(Q,1),G.splice(ce,0,re))}}return G}function q(G,U,Q){G.telemetryData={index:U,querySource:Q,queryActivityId:G.queryContext?.[t]}}function E(G,U,Q,re){const ce=G.versions[0],fe={manifest:ae(U,g.Manifest),readme:ae(U,g.Details),changelog:ae(U,g.Changelog),license:ae(U,g.License),repository:Y(U),download:ne(U),icon:ae(U,g.Icon),signature:ae(U,g.Signature),coreTranslations:H(U)};return{type:"gallery",identifier:{id:(0,f.$Sp)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:U.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(ce),description:G.shortDescription??"",installCount:j(G.statistics,"install"),rating:j(G.statistics,"averagerating"),ratingCount:j(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:Q,assets:fe,properties:{dependencies:ue(U,N.Dependency),extensionPack:ue(U,N.ExtensionPack),engine:me(U),enabledApiProposals:z(U),localizedLanguages:M(U),targetPlatform:se(U),isPreReleaseVersion:W(U),executesCode:_(U)},hasPreReleaseVersion:W(ce),hasReleaseVersion:!0,preview:ie(G.flags),isSigned:!!fe.signature,queryContext:re,supportLink:K(ce)}}let F=class{constructor(U,Q,re,ce,fe,we,de,pe){this.l=Q,this.n=re,this.o=ce,this.q=fe,this.u=we,this.w=de,this.x=pe;const ye=de.extensionsGallery,$e=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=$e?ye.servicePPEUrl:ye?.serviceUrl,this.g=$e?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.k=de.extensionsEnabledWithApiProposalVersion?.map(ve=>ve.toLowerCase())??[],this.j=(0,y.$qq)(de.version,de,this.o,this.x,this.u,U,this.q)}y(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,Q,re){const ce=P.CancellationToken.isCancellationToken(Q)?{}:Q,fe=P.CancellationToken.isCancellationToken(Q)?Q:re,we=[],de=[],pe=[],ye=[];let $e=!0;for(const ee of U){ee.uuid?de.push(ee.uuid):we.push(ee.id);const te=!!(ee.version||ee.preRelease);pe.push({id:ee.id,uuid:ee.uuid,includePreRelease:te}),ee.version&&ye.push({id:ee.id,uuid:ee.uuid,version:ee.version}),$e=$e&&!!ee.hasPreRelease&&!te}if(!de.length&&!we.length)return[];let ve=new D().withPage(1,U.length);de.length&&(ve=ve.withFilter(l.ExtensionId,...de)),we.length&&(ve=ve.withFilter(l.ExtensionName,...we)),(ce.queryAllVersions||$e)&&(ve=ve.withFlags(ve.flags,s.IncludeVersions)),ce.source&&(ve=ve.withSource(ce.source));const{extensions:B}=await this.B(ve,{targetPlatform:ce.targetPlatform??r,includePreRelease:pe,versions:ye,compatible:!!ce.compatible,productVersion:ce.productVersion??{version:this.w.version,date:this.w.date}},fe);return ce.source&&B.forEach((ee,te)=>q(ee,te,ce.source)),B}async getCompatibleExtension(U,Q,re,ce={version:this.w.version,date:this.w.date}){if((0,p.$jp)(U.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(U,Q,re))return U;const fe=new D().withFlags(s.IncludeVersions).withPage(1,1).withFilter(l.ExtensionId,U.identifier.uuid),{extensions:we}=await this.B(fe,{targetPlatform:re,compatible:!0,includePreRelease:Q,productVersion:ce},P.CancellationToken.None);return we[0]||null}async isExtensionCompatible(U,Q,re,ce={version:this.w.version,date:this.w.date}){if(!(0,p.$kp)(U.properties.targetPlatform,U.allTargetPlatforms,re)||!Q&&U.properties.isPreReleaseVersion)return!1;let fe=U.properties.engine;if(!fe){const we=await this.getManifest(U,P.CancellationToken.None);if(!we)throw new Error("Manifest was not found");fe=we.engines.vscode}return!(!(0,I.$7p)(fe,ce.version,ce.date)||!this.z(U.identifier,U.properties.enabledApiProposals))}z(U,Q){return!Q||!this.k.includes(U.id.toLowerCase())?!0:(0,I.$8p)(Q)}async A(U,Q,re,ce,fe,we,de={version:this.w.version,date:this.w.date}){if(!(0,p.$kp)(se(Q),fe,we)||re!=="any"&&W(Q)!==(re==="prerelease"))return!1;if(ce)try{const pe=await this.G(U,Q);if(!(0,I.$7p)(pe,de.version,de.date))return!1}catch(pe){return this.n.error(`Error while getting the engine for the version ${Q.version}.`,(0,v.$0)(pe)),!1}return!0}async query(U,Q){let re=U.text||"";const ce=U.pageSize??50;let fe=new D().withPage(1,ce);re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,ve,B)=>(fe=fe.withFilter(l.Category,B||ve),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,ve,B)=>(fe=fe.withFilter(l.Tag,B||ve),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(fe=fe.withFilter(l.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),fe=fe.withFilter(l.SearchText,re)),fe=fe.withSortBy(p.SortBy.NoneOrRelevance)):U.ids?fe=fe.withFilter(l.ExtensionId,...U.ids):U.names?fe=fe.withFilter(l.ExtensionName,...U.names):fe=fe.withSortBy(p.SortBy.InstallCount),typeof U.sortBy=="number"&&(fe=fe.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(fe=fe.withSortOrder(U.sortOrder)),U.source&&(fe=fe.withSource(U.source));const we=async($e,ve)=>{const{extensions:B,total:ee}=await this.B($e,{targetPlatform:r,compatible:!1,includePreRelease:!!U.includePreRelease,productVersion:U.productVersion??{version:this.w.version,date:this.w.date}},ve);return B.forEach((te,ge)=>q(te,($e.pageNumber-1)*$e.pageSize+ge,U.source)),{extensions:B,total:ee}},{extensions:de,total:pe}=await we(fe,Q),ye=async($e,ve)=>{if(ve.isCancellationRequested)throw new v.$5;const{extensions:B}=await we(fe.withPage($e+1),ve);return B};return{firstPage:de,total:pe,pageSize:fe.pageSize,getPage:ye}}async B(U,Q,re){const ce=U.flags;U.flags&s.IncludeLatestVersionOnly&&U.flags&s.IncludeVersions&&(U=U.withFlags(U.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(U.flags&s.IncludeLatestVersionOnly)&&!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags,s.IncludeLatestVersionOnly)),Q.versions?.length&&(U=U.withFlags(U.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),U=U.withFlags(U.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:fe,total:we,context:de}=await this.D(U,re);if(!(U.flags&s.IncludeLatestVersionOnly)){const ve=[];for(const B of fe){const ee=await this.C(B,Q,de);ee&&ve.push(ee)}return{extensions:ve,total:we}}const ye=[],$e=new Map;for(let ve=0;ve<fe.length;ve++){const B=fe[ve],ee={id:(0,f.$Sp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},te=(0,O.$lg)(Q.includePreRelease)?Q.includePreRelease:!!Q.includePreRelease.find(Se=>(0,f.$Np)(Se,ee))?.includePreRelease;if(Q.compatible&&(0,p.$jp)(C(B),Q.targetPlatform))continue;const ge=await this.C(B,Q,de);!ge||ge.properties.isPreReleaseVersion&&(!te||!ge.hasReleaseVersion)||!ge.properties.isPreReleaseVersion&&ge.properties.targetPlatform!==Q.targetPlatform&&ge.hasPreReleaseVersion?$e.set(B.extensionId,ve):ye.push([ve,ge])}if($e.size){const ve=new n.$ge,B=new D().withFlags(ce&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,$e.size).withFilter(l.ExtensionId,...$e.keys()),{extensions:ee}=await this.B(B,Q,re);this.q.publicLog2("galleryService:additionalQuery",{duration:ve.elapsed(),count:$e.size});for(const te of ee){const ge=$e.get(te.identifier.uuid);ye.push([ge,te])}}return{extensions:ye.sort((ve,B)=>ve[0]-B[0]).map(([,ve])=>ve),total:we}}async C(U,Q,re){const ce={id:(0,f.$Sp)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},fe=Q.versions?.find(ye=>(0,f.$Np)(ye,ce))?.version,we=(0,O.$lg)(Q.includePreRelease)?Q.includePreRelease:!!Q.includePreRelease.find(ye=>(0,f.$Np)(ye,ce))?.includePreRelease,de=C(U),pe=V(U.versions,Q.targetPlatform);if(Q.compatible&&(0,p.$jp)(de,Q.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const $e=pe[ye];if(!(fe&&$e.version!==fe)){if(await this.A(ce.id,$e,we?"any":"release",Q.compatible,de,Q.targetPlatform,Q.productVersion))return Q.compatible&&!this.z(ce,z($e))?null:E(U,$e,de,re);if(fe&&$e.version===fe)return null}}return fe||Q.compatible?null:E(U,U.versions[0],de)}async D(U,Q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,s.ExcludeNonValidated).withFilter(l.Target,"Microsoft.VisualStudio.Code").withFilter(l.ExcludeWithFlags,o(s.Unpublished));const re=await this.j,ce=JSON.stringify(U.raw),fe={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ce.length)},we=new n.$ge;let de,pe,ye=0;try{if(de=await this.l.request({type:"POST",url:this.g&&U.criteria.some(ve=>ve.filterType===l.SearchText)?this.g:this.y("/extensionquery"),data:ce,headers:fe},Q),de.res.statusCode&&de.res.statusCode>=400&&de.res.statusCode<500)return{galleryExtensions:[],total:ye};const $e=await(0,R.$cq)(de);if($e){const ve=$e.results[0],B=ve.extensions,ee=ve.resultMetadata&&ve.resultMetadata.filter(te=>te.metadataType==="ResultCount")[0];return ye=ee&&ee.metadataItems.filter(te=>te.name==="TotalCount")[0].count||0,{galleryExtensions:B,total:ye,context:de.res.headers.activityid?{[t]:de.res.headers.activityid}:{}}}return{galleryExtensions:[],total:ye}}catch($e){if((0,v.$4)($e))throw pe=p.ExtensionGalleryErrorCode.Cancelled,$e;{const ve=(0,v.$0)($e);throw pe=(0,a.$0o)($e)?p.ExtensionGalleryErrorCode.Offline:ve.startsWith("XHR timeout")?p.ExtensionGalleryErrorCode.Timeout:p.ExtensionGalleryErrorCode.Failed,new p.$np(ve,pe)}}finally{this.q.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(ce.length),duration:we.elapsed(),success:!!de&&(0,R.$$p)(de),responseBodySize:de?.res.headers["Content-Length"],statusCode:de?String(de.res.statusCode):void 0,errorCode:pe,count:String(ye)})}}async reportStatistic(U,Q,re,ce){if(!this.isEnabled())return;const fe=k.$p?this.y(`/itemName/${U}.${Q}/version/${re}/statType/${ce===p.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${U}/extensions/${Q}/${re}/stats?statType=${ce}`),we=k.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:we};try{await this.l.request({type:"POST",url:fe,headers:pe},P.CancellationToken.None)}catch{}}async download(U,Q,re){this.n.trace("ExtensionGalleryService#download",U.identifier.id);const ce=(0,f.$Vp)(U),fe=new Date().getTime(),we=re===p.InstallOperation.Install?"install":re===p.InstallOperation.Update?"update":"",de=we?{uri:`${U.assets.download.uri}${w.URI.parse(U.assets.download.uri).query?"&":"?"}${we}=true`,fallbackUri:`${U.assets.download.fallbackUri}${w.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${we}=true`}:U.assets.download,pe=U.queryContext?.[t]?{[t]:U.queryContext[t]}:void 0,ye=await this.F(U.identifier.id,de,g.VSIX,pe?{headers:pe}:void 0);try{await this.u.writeFile(Q,ye.stream)}catch($e){try{await this.u.del(Q)}catch(ve){this.n.warn(`Error while deleting the file ${Q.toString()}`,(0,v.$0)(ve))}throw new p.$np((0,v.$0)($e),p.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ce,duration:new Date().getTime()-fe})}async downloadSignatureArchive(U,Q){if(!U.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const re=await this.F(U.identifier.id,U.assets.signature,g.Signature);try{await this.u.writeFile(Q,re.stream)}catch(ce){try{await this.u.del(Q)}catch(fe){this.n.warn(`Error while deleting the file ${Q.toString()}`,(0,v.$0)(fe))}throw new p.$np((0,v.$0)(ce),p.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(U,Q){if(U.assets.readme){const re=await this.F(U.identifier.id,U.assets.readme,g.Details,{},Q);return await(0,R.$bq)(re)||""}return""}async getManifest(U,Q){if(U.assets.manifest){const re=await this.F(U.identifier.id,U.assets.manifest,g.Manifest,{},Q),ce=await(0,R.$bq)(re);return ce?JSON.parse(ce):null}return null}async E(U,Q,re){const ce=ae(Q,g.Manifest);if(!ce)throw new Error("Manifest was not found");const fe={"Accept-Encoding":"gzip"},we=await this.F(U,ce,g.Manifest,{headers:fe});return await(0,R.$cq)(we)}async getCoreTranslation(U,Q){const re=U.assets.coreTranslations.filter(ce=>ce[0]===Q.toUpperCase())[0];if(re){const ce=await this.F(U.identifier.id,re[1],re[0]),fe=await(0,R.$bq)(ce);return fe?JSON.parse(fe):null}return null}async getChangelog(U,Q){if(U.assets.changelog){const re=await this.F(U.identifier.id,U.assets.changelog,g.Changelog,{},Q);return await(0,R.$bq)(re)||""}return""}async getAllCompatibleVersions(U,Q,re){let ce=new D().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);U.uuid?ce=ce.withFilter(l.ExtensionId,U.uuid):ce=ce.withFilter(l.ExtensionName,U.id);const{galleryExtensions:fe}=await this.D(ce,P.CancellationToken.None);if(!fe.length)return[];const we=C(fe[0]);if((0,p.$jp)(we,re))return[];const de=[];await Promise.all(fe[0].versions.map(async $e=>{try{await this.A(U.id,$e,Q?"any":"release",!0,we,re)&&this.z(U,z($e))&&de.push($e)}catch{}}));const pe=[],ye=new Set;for(const $e of V(de,re))ye.has($e.version)||(ye.add($e.version),pe.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:W($e)}));return pe}async F(U,Q,re,ce={},fe=P.CancellationToken.None){const we=await this.j,de={type:"GET"},pe={...we,...ce.headers||{}};ce={...ce,...de,headers:pe};const ye=Q.uri,$e=Q.fallbackUri,ve={...ce,url:ye};try{const B=await this.l.request(ve,fe);if(B.res.statusCode===200)return B;const ee=await(0,R.$bq)(B);throw new Error(`Expected 200, got back ${B.res.statusCode} instead.

${ee}`)}catch(B){if((0,v.$4)(B))throw B;const ee=(0,v.$0)(B);this.q.publicLog2("galleryService:cdnFallback",{extension:U,assetType:re,message:ee});const te={...ce,url:$e};return this.l.request(te,fe)}}async G(U,Q){let re=me(Q);if(!re){this.q.publicLog2("galleryService:engineFallback",{extension:U,version:Q.version});const ce=await this.E(U,Q,P.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");re=ce.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const U=await this.l.request({type:"GET",url:this.h},P.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,R.$cq)(U),re=[],ce={},fe=[],we=[];if(Q){for(const de of Q.malicious)re.push({id:de});if(Q.migrateToPreRelease)for(const[de,pe]of Object.entries(Q.migrateToPreRelease))(!pe.engine||(0,I.$7p)(pe.engine,this.w.version,this.w.date))&&(ce[de.toLowerCase()]={disallowInstall:!0,extension:{id:pe.id,displayName:pe.displayName,autoMigrate:{storage:!!pe.migrateStorage},preRelease:!0}});if(Q.deprecated)for(const[de,pe]of Object.entries(Q.deprecated))pe&&(ce[de.toLowerCase()]=(0,O.$lg)(pe)?{}:pe);if(Q.search)for(const de of Q.search)fe.push(de);if(Array.isArray(Q.extensionsEnabledWithPreRelease))for(const de of Q.extensionsEnabledWithPreRelease)we.push(de.toLowerCase())}return{malicious:re,deprecated:ce,search:fe,extensionsEnabledWithPreRelease:we}}};F=Ee([oe(1,R.$9p),oe(2,h.$bk),oe(3,u.$Ni),oe(4,c.$am),oe(5,b.$bl),oe(6,$.$uk),oe(7,d.$aj)],F);let J=class extends F{constructor(U,Q,re,ce,fe,we,de,pe){super(U,Q,re,ce,fe,we,de,pe)}};e.$sq=J,e.$sq=J=Ee([oe(0,i.$jq),oe(1,R.$9p),oe(2,h.$bk),oe(3,u.$Ni),oe(4,c.$am),oe(5,b.$bl),oe(6,$.$uk),oe(7,d.$aj)],J);let X=class extends F{constructor(U,Q,re,ce,fe,we,de){super(void 0,U,Q,re,ce,fe,we,de)}};e.$tq=X,e.$tq=X=Ee([oe(0,R.$9p),oe(1,h.$bk),oe(2,u.$Ni),oe(3,c.$am),oe(4,b.$bl),oe(5,$.$uk),oe(6,d.$aj)],X)}),define(le[145],he([0,1,11,17,9,6,124,23,24,3,69]),function(Z,e,S,P,v,k,L,O,w,a,d){"use strict";var u,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$MR=e.$LR=e.$KR=void 0;let f=class extends w.$Ql{static{u=this}static{this.a="profileAssociationsMigration"}constructor(h,$,R,y,i){super(R,y,$,i),this.U=h,this.W=R}O(){return this.U.getItem(u.b,[]).map($=>({...$,location:(0,a.$fg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):S.URI.revive($.location)}))}Q(){const h=this.U.getItem(u.c,{});return this.U.getItem(u.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$KR=f,e.$KR=f=u=Ee([oe(0,L.$FR),oe(1,O.$Ll),oe(2,P.$Oi),oe(3,v.$bl),oe(4,k.$bk)],f);let m=p=class extends f{constructor(h,$,R,y,i){super(h,$,R,y,i),this.$=h}P(h){h.length?this.$.setItem(p.b,h.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(p.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(p.c,h):this.$.removeItem(p.c)}Q(){const h="workspaceAndProfileInfo",$=this.$.getItem(h,void 0);if($){this.$.removeItem(h);const y=$.reduce((i,{workspace:c,profile:n})=>(i[S.URI.revive(c).toString()]=S.URI.revive(n).toString(),i),{});this.$.setItem(p.c,{workspaces:y})}const R=super.Q();return this.$.getItem(p.a,!1)||(this.R(R),this.$.setItem(p.a,!0)),R}};e.$LR=m,e.$LR=m=p=Ee([oe(0,L.$GR),oe(1,O.$Ll),oe(2,P.$Oi),oe(3,v.$bl),oe(4,k.$bk)],m);let I=class extends m{constructor(h,$,R,y){super(new d.$JR(d.SaveStrategy.IMMEDIATE,$,y,R),h,$,R,y)}async init(){return await this.$.init(),super.init()}};e.$MR=I,e.$MR=I=Ee([oe(0,O.$Ll),oe(1,P.$Oi),oe(2,v.$bl),oe(3,k.$bk)],I)}),define(le[146],he([0,1,122,8,13,7,3,30,17,123,6,46,121,157]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0,e.$hs=b;let m=class extends u.$0p{constructor($,R,y,i){super(i),this.m=$,this.n=R,this.r=y,this.s(),this.B($.onDidChangeConfiguration(c=>{c.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,R){const{f:y,g:i}=this;let c;try{c=await(0,a.$Sm)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$0)(t)))}const n={...process.env,...c},r=$.agent?$.agent:await(0,p.$fs)($.url||"",n,{proxyUrl:y,strictSSL:i});return $.agent=r,$.strictSSL=i,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>b($,R))}async resolveProxy($){}async lookupAuthorization($){}async lookupKerberosAuthorization($){try{const R=await new Promise((r,t)=>{Z(["kerberos"],r,t)}).then(be),y=new URL($),i=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${y.hostname}`:`HTTP@${y.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${y}`,`spn:${i}`),"Negotiate "+await(await R.initializeClient(i)).step("")}catch(R){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",R);return}}async loadCertificates(){return(await new Promise((R,y)=>{Z(["@vscode/proxy-agent"],R,y)}).then(be)).loadSystemCertificates({log:this.r})}};e.$gs=m,e.$gs=m=Ee([oe(0,O.$aj),oe(1,w.$Oi),oe(2,d.$bk),oe(3,d.$ck)],m);async function I(h){return((0,S.parse)(h.url).protocol==="https:"?await new Promise((y,i)=>{Z(["https"],y,i)}).then(be):await new Promise((y,i)=>{Z(["http"],y,i)}).then(be)).request}async function b(h,$){return P.Promises.withAsyncBody(async(R,y)=>{const i=(0,S.parse)(h.url),c=h.getRawRequest?h.getRawRequest(h):await I(h),n={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,L.$lg)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(n.auth=h.user+":"+h.password);const r=c(n,t=>{const s=(0,L.$jg)(h.followRedirects)?h.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&s>0&&t.headers.location)b({...h,url:t.headers.location,followRedirects:s-1},$).then(R,y);else{let o=t;!h.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,f.createGunzip)())),R({res:t,stream:(0,v.$4e)(o)})}});r.on("error",y),h.timeout&&r.setTimeout(h.timeout),h.isChromiumNetwork&&r.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&r.write(h.data),r.end(),$.onCancellationRequested(()=>{r.abort(),y(new k.$5)})})}});var qe=this&&this.__importDefault||function(Z){return Z&&Z.__esModule?Z:{default:Z}};define(le[158],he([0,1,32,35,8,38,7,2,14,15,12,36,11,30,118,61,120,17,96,144,20,71,125,42,54,139,141,9,108,110,51,106,64,68,127,6,114,39,115,130,33,46,146,69,70,18,129,41,131,132,23,134,24,145,133,140,111,113,5,135,159]),function(Z,e,S,P,v,k,L,O,w,a,d,u,p,f,m,I,b,h,$,R,y,i,c,n,r,t,s,o,l,g,N,T,A,D,j,H,Y,ne,ae,ue,me,W,_,z,M,x,K,ie,se,C,V,q,E,F,J,X,G,U,Q,re,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=we,S=be(S),ue=qe(ue);class fe extends O.$Vc{constructor(pe){super(),this.b=pe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[pe,ye]=await this.f();return pe.invokeFunction(async $e=>{const ve=$e.get(H.$bk),B=$e.get(o.$bl),ee=$e.get(h.$Oi),te=$e.get(E.$Nl);ve.info("CLI main",this.b),this.h(ve),await this.j(ee,B,te,pe),await Promise.all(ye.map(ge=>{(0,v.$xh)(ge.flush(),1e3)}))})}async f(){const pe=new A.$Ei,ye={_serviceBrand:void 0,...ue.default};pe.set(me.$uk,ye);const $e=new $.$0m(this.b,ye);pe.set(h.$Oi,$e),await Promise.all([this.g($e.appSettingsHome.with({scheme:w.Schemas.file}).fsPath),this.g($e.extensionsPath)].map(Ie=>Ie?S.promises.mkdir(Ie,{recursive:!0}):void 0));const ve=new U.$ER((0,H.$pk)($e),$e.logsHome);pe.set(H.$ck,ve);const B=this.B(ve.createLogger("cli",{name:(0,Q.localize)(167,null)})),ee=[];ve.getLogLevel()===H.LogLevel.Trace&&ee.push(new H.$jk(ve.getLogLevel()));const te=this.B(new G.$OR(B,ee));pe.set(H.$bk,te);const ge=this.B(new l.$4q(te));pe.set(o.$bl,ge);const Se=this.B(new g.$ur(te));ge.registerProvider(w.Schemas.file,Se);const Ae=new q.$Vs(ge);pe.set(V.$Ll,Ae);const ke=new z.$IR(z.SaveStrategy.DELAYED,$e,te,ge),Te=new F.$KR(ke,Ae,$e,ge,te);pe.set(E.$Nl,Te),ge.registerProvider(w.Schemas.vscodeUserData,new re.$9hc(w.Schemas.file,Se,w.Schemas.vscodeUserData,Te,Ae,te));const Re=d.$j&&ye.win32RegValueName?this.B(new ae.$7hc(te,ye.win32RegValueName)):$e.policyFile?this.B(new Y.$8hc($e.policyFile,ge,te)):new ne.$wo;pe.set(ne.$uo,Re);const Le=this.B(new m.$Yo(Te.defaultProfile.settingsResource,ge,Re,te));pe.set(f.$aj,Le),await Promise.all([ke.init(),Le.initialize()]);let Me;try{Me=await(0,J.$Ihc)(ke,te)}catch(Ie){Ie.code!=="ENOENT"&&te.error(Ie)}const De=await(0,J.$Jhc)(ke,te),Ce=await(0,J.$Khc)(ke,te);Te.init(),pe.set(V.$Ll,new q.$Vs(ge));const Fe=new _.$gs(Le,$e,te,ve);pe.set(W.$9p,Fe),pe.set(I.$3o,new N.$Di(b.$4R,void 0,!0)),pe.set(n.$Kq,new N.$Di(X.$NR,void 0,!0)),pe.set(r.$Oq,new N.$Di(s.$Fhc,void 0,!0)),pe.set(i.$uq,new N.$Di(i.$wq,void 0,!0)),pe.set(t.$Zq,new N.$Di(t.$1q,void 0,!0)),pe.set(y.$mp,new N.$Di(R.$tq,void 0,!0)),pe.set(D.$as,new N.$Di(j.$cs,void 0,!1));const Ue=[],Pe=(0,ie.$Kp)(ye,Le);if((0,ie.$Fp)(ye,$e)){ye.aiConfig&&ye.aiConfig.ariaKey&&Ue.push(new se.$CR(Fe,Pe,"monacoworkbench",null,ye.aiConfig.ariaKey));const Ie={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,M.$wp)((0,P.release)(),(0,P.hostname)(),process.arch,ye.commit,ye.version,Me,De,Ce,Pe),piiPaths:(0,ie.$Lp)($e)};pe.set(x.$am,new N.$Di(K.$is,[Ie],!1))}else pe.set(x.$am,ie.$Ap);return[new T.$xr(pe),Ue]}g(pe){if(d.$j){const ye=(0,ce.getUNCHost)(pe);ye&&(0,ce.addUNCHostToAllowlist)(ye)}return pe}h(pe){(0,L.setUnexpectedErrorHandler)(ye=>{const $e=(0,k.$rj)(ye,!0);$e&&pe.error(`[uncaught exception in CLI]: ${$e}`)}),process.on("uncaughtException",ye=>{(0,L.$Y)(ye)||(0,L.$Z)(ye)}),process.on("unhandledRejection",ye=>(0,L.$Z)(ye))}async j(pe,ye,$e,ve){let B;if(pe.args.profile&&(B=$e.profiles.find(te=>te.name===pe.args.profile),!B))throw new Error(`Profile '${pe.args.profile}' not found.`);const ee=(B??$e.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ve.createInstance(c.$xq,new H.$jk(H.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return ve.createInstance(c.$xq,new H.$jk(H.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),te,!!this.b.force)}else{if(this.b["uninstall-extension"])return ve.createInstance(c.$xq,new H.$jk(H.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return ve.createInstance(c.$xq,new H.$jk(H.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return ve.createInstance(c.$xq,new H.$jk(H.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.$lic)(pe.appRoot,pe.extensionsPath))}}m(pe){return pe.map(ye=>/\.vsix$/i.test(ye)?p.URI.file((0,a.$jc)(ye)?ye:(0,a.$kc)((0,u.cwd)(),ye)):ye)}}async function we(de){const pe=new fe(de);try{await pe.run()}finally{pe.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/3b27f1f74bc09fe2e2068997fcd42768be44a4e3/core/vs/code/node/cliProcessMain.js.map
