/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/nls","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function($e){for(var e=[],r=0,h=$e.length;r<h;r++)e[r]=ke[$e[r]];return e};define(ke[131],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.LoaderEventType=e.$S=e.$R=void 0,e.$R=!1,e.$S=!0;var r;(function(A){A[A.LoaderAvailable=1]="LoaderAvailable",A[A.BeginLoadingScript=10]="BeginLoadingScript",A[A.EndLoadingScriptOK=11]="EndLoadingScriptOK",A[A.EndLoadingScriptError=12]="EndLoadingScriptError",A[A.BeginInvokeFactory=21]="BeginInvokeFactory",A[A.EndInvokeFactory=22]="EndInvokeFactory",A[A.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",A[A.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",A[A.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",A[A.NodeEndNativeRequire=34]="NodeEndNativeRequire",A[A.CachedDataFound=60]="CachedDataFound",A[A.CachedDataMissed=61]="CachedDataMissed",A[A.CachedDataRejected=62]="CachedDataRejected",A[A.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const R=new Map,T=new Map,O=new Map,b=new Map;function c(w,a){w.has(a.detail)||w.set(a.detail,-a.timestamp)}function I(w,a){const m=w.get(a.detail);m&&(m>=0||w.set(a.detail,m+a.timestamp))}let y=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(y=$e.getStats().slice(0).sort((w,a)=>w.timestamp-a.timestamp));for(const w of y)switch(w.type){case r.BeginLoadingScript:c(R,w);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(R,w);break;case r.BeginInvokeFactory:c(T,w);break;case r.EndInvokeFactory:I(T,w);break;case r.NodeBeginNativeRequire:c(O,w);break;case r.NodeEndNativeRequire:I(O,w);break;case r.NodeBeginEvaluatingScript:c(b,w);break;case r.NodeEndEvaluatingScript:I(b,w);break}let u=0;O.forEach(w=>u+=w);function C(w){const a=[];return w.forEach((m,$)=>a.push([$,m])),a}return{amdLoad:C(R),amdInvoke:C(T),nodeRequire:C(O),nodeEval:C(b),nodeRequireTotal:u}}static toMarkdownTable(R,T){let O="";const b=[];return R.forEach((c,I)=>{b[I]=c.length}),T.forEach(c=>{c.forEach((I,y)=>{typeof I>"u"&&(I=c[y]="-");const u=I.toString().length;b[y]=Math.max(u,b[y])})}),R.forEach((c,I)=>{O+=`| ${c+" ".repeat(b[I]-c.toString().length)} `}),O+=`|
`,R.forEach((c,I)=>{O+=`| ${"-".repeat(b[I])} `}),O+=`|
`,T.forEach(c=>{c.forEach((I,y)=>{typeof I<"u"&&(O+=`| ${I+" ".repeat(b[y]-I.toString().length)} `)}),O+=`|
`}),O}}e.$T=h}),define(ke[132],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=r,e.$gb=h,e.$hb=A,e.$ib=R,e.$jb=T,e.$kb=O,e.$lb=b,e.$nb=I,e.$ob=y,e.$pb=u,e.$qb=C,e.$rb=w;function r(a,m){const $=h(a,m);if($!==-1)return a[$]}function h(a,m,$=a.length-1){for(let f=$;f>=0;f--){const i=a[f];if(m(i))return f}return-1}function A(a,m){const $=R(a,m);return $===-1?void 0:a[$]}function R(a,m,$=0,f=a.length){let i=$,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?i=t+1:s=t}return i-1}function T(a,m){const $=O(a,m);return $===a.length?void 0:a[$]}function O(a,m,$=0,f=a.length){let i=$,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?s=t:i=t+1}return i}function b(a,m,$=0,f=a.length){const i=O(a,m,$,f);return i===a.length?-1:i}class c{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!m(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const $=R(this.e,m,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=c;function I(a,m){if(a.length===0)return;let $=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,$)>0&&($=i)}return $}function y(a,m){if(a.length===0)return;let $=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,$)>=0&&($=i)}return $}function u(a,m){return I(a,($,f)=>-m($,f))}function C(a,m){if(a.length===0)return-1;let $=0;for(let f=1;f<a.length;f++){const i=a[f];m(i,a[$])>0&&($=f)}return $}function w(a,m){for(const $ of a){const f=m($);if(f!==void 0)return f}}}),define(ke[26],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(ke[78],Ie([1,0]),function($e,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=h,e.$d=A,e.$e=R,e.$f=T;function h(b,c){const I=Object.create(null);for(const y of b){const u=c(y);let C=I[u];C||(C=I[u]=[]),C.push(y)}return I}function A(b,c){const I=[],y=[];for(const u of b)c.has(u)||I.push(u);for(const u of c)b.has(u)||y.push(u);return{removed:I,added:y}}function R(b,c){const I=[],y=[];for(const[u,C]of b)c.has(u)||I.push(C);for(const[u,C]of c)b.has(u)||y.push(C);return{removed:I,added:y}}function T(b,c){const I=new Set;for(const y of c)b.has(y)&&I.add(y);return I}class O{static{r=Symbol.toStringTag}constructor(c,I){this.b=I,this.a=new Map,this[r]="SetWithKey";for(const y of c)this.add(y)}get size(){return this.a.size}add(c){const I=this.b(c);return this.a.set(I,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,I){this.a.forEach(y=>c.call(I,y,y,this))}[Symbol.iterator](){return this.values()}}e.$g=O}),define(ke[59],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=h,e.$_h=A,e.$ai=R;function r(T){return(O,b,c)=>{let I=null,y=null;if(typeof c.value=="function"?(I="value",y=c.value):typeof c.get=="function"&&(I="get",y=c.get),!y)throw new Error("not supported");c[I]=T(y,b)}}function h(T,O,b){let c=null,I=null;if(typeof b.value=="function"?(c="value",I=b.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(c="get",I=b.get),!I)throw new Error("not supported");const y=`$memoize$${O}`;b[c]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[y]}}function A(T,O,b){return r((c,I)=>{const y=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...C){this[u]||(this[u]=b?b():void 0),clearTimeout(this[y]),O&&(this[u]=O(this[u],...C),C=[this[u]]),this[y]=setTimeout(()=>{c.apply(this,C),this[u]=b?b():void 0},T)}})}function R(T,O,b){return r((c,I)=>{const y=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,C=`$throttle$lastRun$${I}`,w=`$throttle$pending$${I}`;return function(...a){if(this[u]||(this[u]=b?b():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),O&&(this[u]=O(this[u],...a)),this[w])return;const m=this[C]+T;m<=Date.now()?(this[C]=Date.now(),c.apply(this,[this[u]]),this[u]=b?b():void 0):(this[w]=!0,this[y]=setTimeout(()=>{this[w]=!1,this[C]=Date.now(),c.apply(this,[this[u]]),this[u]=b?b():void 0},m-Date.now()))}})}}),define(ke[13],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$W=e.$V=void 0,e.setUnexpectedErrorHandler=h,e.$Y=A,e.$Z=R,e.$1=T,e.$2=O,e.$3=b,e.$4=I,e.$6=u,e.$7=C,e.$8=w,e.$0=m;class r{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?s.isErrorNoTelemetry(n)?new s(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(d=>{d(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$V=r,e.$W=new r;function h(o){e.$W.setUnexpectedErrorHandler(o)}function A(o){if(!o||typeof o!="object")return!1;const n=o;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function R(o){I(o)||e.$W.onUnexpectedError(o)}function T(o){I(o)||e.$W.onUnexpectedExternalError(o)}function O(o){if(o instanceof Error){const{name:n,message:d}=o,l=o.stacktrace||o.stack;return{$isError:!0,name:n,message:d,stack:l,noTelemetry:s.isErrorNoTelemetry(o)}}return o}function b(o){let n;return o.noTelemetry?n=new s:(n=new Error,n.name=o.name),n.message=o.message,n.stack=o.stack,n}const c="Canceled";function I(o){return o instanceof y?!0:o instanceof Error&&o.name===c&&o.message===c}class y extends Error{constructor(){super(c),this.name=this.message}}e.$5=y;function u(){const o=new Error(c);return o.name=o.message,o}function C(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function w(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class a extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=a;function m(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class $ extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=$;class f extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=f;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class s extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof s)return n;const d=new s;return d.message=n.message,d.stack=n.stack,d}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=s;class t extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$cb=t}),define(ke[18],Ie([1,0,13,132]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=A,e.$tb=R,e.$ub=T,e.$vb=O,e.$wb=b,e.$xb=c,e.$yb=I,e.$zb=y,e.$Ab=u,e.$Bb=C,e.$Cb=w,e.$Db=a,e.$Eb=m,e.top=$,e.$Gb=f,e.$Hb=s,e.$Ib=t,e.$Jb=o,e.$Kb=n,e.$Lb=d,e.$Mb=l,e.$Nb=g,e.$Ob=E,e.$Pb=S,e.$Qb=D,e.$Rb=k,e.$Sb=P,e.$Tb=p,e.$Ub=v,e.$Vb=F,e.$Wb=N,e.$Xb=L,e.$Yb=M,e.$Zb=z,e.$1b=j,e.$2b=q,e.$3b=B,e.$4b=ee,e.$5b=H,e.$6b=_,e.$7b=ce,e.$0b=ge,e.$bc=ve;function A(te,ae=0){return te[te.length-(1+ae)]}function R(te){if(te.length===0)throw new Error("Invalid tail call");return[te.slice(0,te.length-1),te[te.length-1]]}function T(te,ae,se=(Z,re)=>Z===re){if(te===ae)return!0;if(!te||!ae||te.length!==ae.length)return!1;for(let Z=0,re=te.length;Z<re;Z++)if(!se(te[Z],ae[Z]))return!1;return!0}function O(te,ae){const se=te.length-1;ae<se&&(te[ae]=te[se]),te.pop()}function b(te,ae,se){return c(te.length,Z=>se(te[Z],ae))}function c(te,ae){let se=0,Z=te-1;for(;se<=Z;){const re=(se+Z)/2|0,pe=ae(re);if(pe<0)se=re+1;else if(pe>0)Z=re-1;else return re}return-(se+1)}function I(te,ae,se){if(te=te|0,te>=ae.length)throw new TypeError("invalid index");const Z=ae[Math.floor(ae.length*Math.random())],re=[],pe=[],we=[];for(const Fe of ae){const ze=se(Fe,Z);ze<0?re.push(Fe):ze>0?pe.push(Fe):we.push(Fe)}return te<re.length?I(te,re,se):te<re.length+we.length?we[0]:I(te-(re.length+we.length),pe,se)}function y(te,ae){const se=[];let Z;for(const re of te.slice(0).sort(ae))!Z||ae(Z[0],re)!==0?(Z=[re],se.push(Z)):Z.push(re);return se}function*u(te,ae){let se,Z;for(const re of te)Z!==void 0&&ae(Z,re)?se.push(re):(se&&(yield se),se=[re]),Z=re;se&&(yield se)}function C(te,ae){for(let se=0;se<=te.length;se++)ae(se===0?void 0:te[se-1],se===te.length?void 0:te[se])}function w(te,ae){for(let se=0;se<te.length;se++)ae(se===0?void 0:te[se-1],te[se],se+1===te.length?void 0:te[se+1])}function a(te,ae,se){const Z=[];function re(Fe,ze,Re){if(ze===0&&Re.length===0)return;const De=Z[Z.length-1];De&&De.start+De.deleteCount===Fe?(De.deleteCount+=ze,De.toInsert.push(...Re)):Z.push({start:Fe,deleteCount:ze,toInsert:Re})}let pe=0,we=0;for(;;){if(pe===te.length){re(pe,0,ae.slice(we));break}if(we===ae.length){re(pe,te.length-pe,[]);break}const Fe=te[pe],ze=ae[we],Re=se(Fe,ze);Re===0?(pe+=1,we+=1):Re<0?(re(pe,1,[]),pe+=1):Re>0&&(re(pe,0,[ze]),we+=1)}return Z}function m(te,ae,se){const Z=a(te,ae,se),re=[],pe=[];for(const we of Z)re.push(...te.slice(we.start,we.start+we.deleteCount)),pe.push(...we.toInsert);return{removed:re,added:pe}}function $(te,ae,se){if(se===0)return[];const Z=te.slice(0,se).sort(ae);return i(te,ae,Z,se,te.length),Z}function f(te,ae,se,Z,re){return se===0?Promise.resolve([]):new Promise((pe,we)=>{(async()=>{const Fe=te.length,ze=te.slice(0,se).sort(ae);for(let Re=se,De=Math.min(se+Z,Fe);Re<Fe;Re=De,De=Math.min(De+Z,Fe)){if(Re>se&&await new Promise(Ce=>setTimeout(Ce)),re&&re.isCancellationRequested)throw new r.$5;i(te,ae,ze,Re,De)}return ze})().then(pe,we)})}function i(te,ae,se,Z,re){for(const pe=se.length;Z<re;Z++){const we=te[Z];if(ae(we,se[pe-1])<0){se.pop();const Fe=(0,h.$kb)(se,ze=>ae(we,ze)<0);se.splice(Fe,0,we)}}}function s(te){return te.filter(ae=>!!ae)}function t(te){let ae=0;for(let se=0;se<te.length;se++)te[se]&&(te[ae]=te[se],ae+=1);te.length=ae}function o(te,ae,se){te.splice(se,0,te.splice(ae,1)[0])}function n(te){return!Array.isArray(te)||te.length===0}function d(te){return Array.isArray(te)&&te.length>0}function l(te,ae=se=>se){const se=new Set;return te.filter(Z=>{const re=ae(Z);return se.has(re)?!1:(se.add(re),!0)})}function g(te){const ae=new Set;return se=>{const Z=te(se);return ae.has(Z)?!1:(ae.add(Z),!0)}}function E(te,ae){return te.length>0?te[0]:ae}function S(te,ae){return te.length>0?te[te.length-1]:ae}function D(te,ae,se=(Z,re)=>Z===re){let Z=0;for(let re=0,pe=Math.min(te.length,ae.length);re<pe&&se(te[re],ae[re]);re++)Z++;return Z}function k(te,ae){let se=typeof ae=="number"?te:0;typeof ae=="number"?se=te:(se=0,ae=te);const Z=[];if(se<=ae)for(let re=se;re<ae;re++)Z.push(re);else for(let re=se;re>ae;re--)Z.push(re);return Z}function P(te,ae,se){return te.reduce((Z,re)=>(Z[ae(re)]=se?se(re):re,Z),Object.create(null))}function p(te,ae){return te.push(ae),()=>v(te,ae)}function v(te,ae){const se=te.indexOf(ae);if(se>-1)return te.splice(se,1),ae}function F(te,ae,se){const Z=te.slice(0,ae),re=te.slice(ae);return Z.concat(se,re)}function N(te,ae){let se;if(typeof ae=="number"){let Z=ae;se=()=>{const re=Math.sin(Z++)*179426549;return re-Math.floor(re)}}else se=Math.random;for(let Z=te.length-1;Z>0;Z-=1){const re=Math.floor(se()*(Z+1)),pe=te[Z];te[Z]=te[re],te[re]=pe}}function L(te,ae){const se=te.indexOf(ae);se>-1&&(te.splice(se,1),te.unshift(ae))}function M(te,ae){const se=te.indexOf(ae);se>-1&&(te.splice(se,1),te.push(ae))}function z(te,ae){for(const se of ae)te.push(se)}function j(te,ae){return Array.isArray(te)?te.map(ae):ae(te)}function q(te){return Array.isArray(te)?te:[te]}function B(te){return te[Math.floor(Math.random()*te.length)]}function ee(te,ae,se){const Z=W(te,ae),re=te.length,pe=se.length;te.length=re+pe;for(let we=re-1;we>=Z;we--)te[we+pe]=te[we];for(let we=0;we<pe;we++)te[we+Z]=se[we]}function H(te,ae,se,Z){const re=W(te,ae);let pe=te.splice(re,se);return pe===void 0&&(pe=[]),ee(te,re,Z),pe}function W(te,ae){return ae<0?Math.max(ae+te.length,0):Math.min(ae,te.length)}var X;(function(te){function ae(pe){return pe<0}te.isLessThan=ae;function se(pe){return pe<=0}te.isLessThanOrEqual=se;function Z(pe){return pe>0}te.isGreaterThan=Z;function re(pe){return pe===0}te.isNeitherLessOrGreaterThan=re,te.greaterThan=1,te.lessThan=-1,te.neitherLessOrGreaterThan=0})(X||(e.CompareResult=X={}));function _(te,ae){return(se,Z)=>ae(te(se),te(Z))}function ce(...te){return(ae,se)=>{for(const Z of te){const re=Z(ae,se);if(!X.isNeitherLessOrGreaterThan(re))return re}return X.neitherLessOrGreaterThan}}const ne=(te,ae)=>te-ae;e.$8b=ne;const ye=(te,ae)=>(0,e.$8b)(te?1:0,ae?1:0);e.$9b=ye;function ge(te){return(ae,se)=>-te(ae,se)}class Y{constructor(ae){this.g=ae,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let se=this.c;for(;se<this.g.length&&ae(this.g[se]);)se++;const Z=se===this.c?null:this.g.slice(this.c,se);return this.c=se,Z}takeFromEndWhile(ae){let se=this.d;for(;se>=0&&ae(this.g[se]);)se--;const Z=se===this.d?null:this.g.slice(se+1,this.d+1);return this.d=se,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ae=this.g[this.c];return this.c++,ae}removeLast(){const ae=this.g[this.d];return this.d--,ae}takeCount(ae){const se=this.g.slice(this.c,this.c+ae);return this.c+=ae,se}}e.$$b=Y;class U{static{this.empty=new U(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(se=>(ae(se),!0))}toArray(){const ae=[];return this.iterate(se=>(ae.push(se),!0)),ae}filter(ae){return new U(se=>this.iterate(Z=>ae(Z)?se(Z):!0))}map(ae){return new U(se=>this.iterate(Z=>se(ae(Z))))}some(ae){let se=!1;return this.iterate(Z=>(se=ae(Z),!se)),se}findFirst(ae){let se;return this.iterate(Z=>ae(Z)?(se=Z,!1):!0),se}findLast(ae){let se;return this.iterate(Z=>(ae(Z)&&(se=Z),!0)),se}findLastMaxBy(ae){let se,Z=!0;return this.iterate(re=>((Z||X.isGreaterThan(ae(re,se)))&&(Z=!1,se=re),!0)),se}}e.$_b=U;class oe{constructor(ae){this.c=ae}static createSortPermutation(ae,se){const Z=Array.from(ae.keys()).sort((re,pe)=>se(ae[re],ae[pe]));return new oe(Z)}apply(ae){return ae.map((se,Z)=>ae[this.c[Z]])}inverse(){const ae=this.c.slice();for(let se=0;se<this.c.length;se++)ae[this.c[se]]=se;return new oe(ae)}}e.$ac=oe;async function ve(te,ae){return(await Promise.all(te.map(async(Z,re)=>({element:Z,ok:await ae(Z,re)})))).find(Z=>Z.ok)?.element}}),define(ke[65],Ie([1,0,13]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$fd=A,e.$gd=R,e.$hd=T,e.$id=O,e.$jd=b;function h(c,I){if(!c)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function A(c,I="Unreachable"){throw new Error(I)}function R(c,I="unexpected state"){if(!c)throw new r.$cb(`Assertion Failed: ${I}`)}function T(c){c||(0,r.$Z)(new r.$cb("Soft Assertion Failed"))}function O(c){if(!c()){debugger;c(),(0,r.$Z)(new r.$cb("Assertion Failed"))}}function b(c,I){let y=0;for(;y<c.length-1;){const u=c[y],C=c[y+1];if(!I(u,C))return!1;y++}return!0}});var Qn=this&&this.__createBinding||(Object.create?function($e,e,r,h){h===void 0&&(h=r);var A=Object.getOwnPropertyDescriptor(e,r);(!A||("get"in A?!e.__esModule:A.writable||A.configurable))&&(A={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty($e,h,A)}:function($e,e,r,h){h===void 0&&(h=r),$e[h]=e[r]}),Kn=this&&this.__setModuleDefault||(Object.create?function($e,e){Object.defineProperty($e,"default",{enumerable:!0,value:e})}:function($e,e){$e.default=e}),We=this&&this.__importStar||function($e){if($e&&$e.__esModule)return $e;var e={};if($e!=null)for(var r in $e)r!=="default"&&Object.prototype.hasOwnProperty.call($e,r)&&Qn(e,$e,r);return Kn(e,$e),e};define(ke[175],Ie([1,0,18]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=A,e.$9c=R,e.$0c=T,e.$$c=O,e.$_c=b,e.$ad=c,r=We(r);const h=(C,w)=>C===w;e.$7c=h;function A(C=e.$7c){return(w,a)=>r.$ub(w,a,C)}function R(){return(C,w)=>JSON.stringify(C)===JSON.stringify(w)}function T(){return(C,w)=>C.equals(w)}function O(C,w,a){if(a!==void 0){const m=C;return m==null||w===void 0||w===null?w===m:a(m,w)}else{const m=C;return($,f)=>$==null||f===void 0||f===null?f===$:m($,f)}}function b(C,w){if(C===w)return!0;if(Array.isArray(C)&&Array.isArray(w)){if(C.length!==w.length)return!1;for(let a=0;a<C.length;a++)if(!b(C[a],w[a]))return!1;return!0}if(C&&typeof C=="object"&&w&&typeof w=="object"&&Object.getPrototypeOf(C)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const a=C,m=w,$=Object.keys(a),f=Object.keys(m),i=new Set(f);if($.length!==f.length)return!1;for(const s of $)if(!i.has(s)||!b(a[s],m[s]))return!1;return!0}return!1}function c(C){return JSON.stringify(u(C))}let I=0;const y=new WeakMap;function u(C){if(Array.isArray(C))return C.map(u);if(C&&typeof C=="object")if(Object.getPrototypeOf(C)===Object.prototype){const w=C,a=Object.create(null);for(const m of Object.keys(w).sort())a[m]=u(w[m]);return a}else{let w=y.get(C);return w===void 0&&(w=I++,y.set(C,w)),w+"----2b76a038c20c4bcc"}return C}}),define(ke[79],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=r;function r(h,A){const R=this;let T=!1,O;return function(){if(T)return O;if(T=!0,A)try{O=h.apply(R,arguments)}finally{A()}else O=h.apply(R,arguments);return O}}}),define(ke[133],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=e.$tQ=void 0;class r{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$tQ=r,e.$uQ=new r("id#")}),define(ke[39],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function A(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}h.is=A;const R=Object.freeze([]);function T(){return R}h.empty=T;function*O(n){yield n}h.single=O;function b(n){return A(n)?n:O(n)}h.wrap=b;function c(n){return n||R}h.from=c;function*I(n){for(let d=n.length-1;d>=0;d--)yield n[d]}h.reverse=I;function y(n){return!n||n[Symbol.iterator]().next().done===!0}h.isEmpty=y;function u(n){return n[Symbol.iterator]().next().value}h.first=u;function C(n,d){let l=0;for(const g of n)if(d(g,l++))return!0;return!1}h.some=C;function w(n,d){for(const l of n)if(d(l))return l}h.find=w;function*a(n,d){for(const l of n)d(l)&&(yield l)}h.filter=a;function*m(n,d){let l=0;for(const g of n)yield d(g,l++)}h.map=m;function*$(n,d){let l=0;for(const g of n)yield*d(g,l++)}h.flatMap=$;function*f(...n){for(const d of n)yield*d}h.concat=f;function i(n,d,l){let g=l;for(const E of n)g=d(g,E);return g}h.reduce=i;function*s(n,d,l=n.length){for(d<0&&(d+=n.length),l<0?l+=n.length:l>n.length&&(l=n.length);d<l;d++)yield n[d]}h.slice=s;function t(n,d=Number.POSITIVE_INFINITY){const l=[];if(d===0)return[l,n];const g=n[Symbol.iterator]();for(let E=0;E<d;E++){const S=g.next();if(S.done)return[l,h.empty()];l.push(S.value)}return[l,{[Symbol.iterator](){return g}}]}h.consume=t;async function o(n){const d=[];for await(const l of n)d.push(l);return Promise.resolve(d)}h.asyncToArray=o})(r||(e.Iterable=r={}))}),define(ke[176],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Xn=T,e.$Yn=y,e.$Zn=u,e.$1n=C,e.$2n=w,e.$3n=a,e.$4n=m,e.$5n=$,e.$6n=f,e.$7n=i,e.$8n=s;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function T(t,o=!1){let n=0;const d=t.length;let l="",g=0,E=h.Unknown,S=r.None;function D(L){let M=0,z=0;for(;M<L;){const j=t.charCodeAt(n);if(j>=I._0&&j<=I._9)z=z*16+j-I._0;else if(j>=I.A&&j<=I.F)z=z*16+j-I.A+10;else if(j>=I.a&&j<=I.f)z=z*16+j-I.a+10;else break;n++,M++}return M<L&&(z=-1),z}function k(L){n=L,l="",g=0,E=h.Unknown,S=r.None}function P(){const L=n;if(t.charCodeAt(n)===I._0)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===I.dot)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return S=r.UnexpectedEndOfNumber,t.substring(L,n);let M=n;if(n<t.length&&(t.charCodeAt(n)===I.E||t.charCodeAt(n)===I.e))if(n++,(n<t.length&&t.charCodeAt(n)===I.plus||t.charCodeAt(n)===I.minus)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;M=n}else S=r.UnexpectedEndOfNumber;return t.substring(L,M)}function p(){let L="",M=n;for(;;){if(n>=d){L+=t.substring(M,n),S=r.UnexpectedEndOfString;break}const z=t.charCodeAt(n);if(z===I.doubleQuote){L+=t.substring(M,n),n++;break}if(z===I.backslash){if(L+=t.substring(M,n),n++,n>=d){S=r.UnexpectedEndOfString;break}switch(t.charCodeAt(n++)){case I.doubleQuote:L+='"';break;case I.backslash:L+="\\";break;case I.slash:L+="/";break;case I.b:L+="\b";break;case I.f:L+="\f";break;case I.n:L+=`
`;break;case I.r:L+="\r";break;case I.t:L+="	";break;case I.u:{const q=D(4);q>=0?L+=String.fromCharCode(q):S=r.InvalidUnicode;break}default:S=r.InvalidEscapeCharacter}M=n;continue}if(z>=0&&z<=31)if(b(z)){L+=t.substring(M,n),S=r.UnexpectedEndOfString;break}else S=r.InvalidCharacter;n++}return L}function v(){if(l="",S=r.None,g=n,n>=d)return g=d,E=h.EOF;let L=t.charCodeAt(n);if(O(L)){do n++,l+=String.fromCharCode(L),L=t.charCodeAt(n);while(O(L));return E=h.Trivia}if(b(L))return n++,l+=String.fromCharCode(L),L===I.carriageReturn&&t.charCodeAt(n)===I.lineFeed&&(n++,l+=`
`),E=h.LineBreakTrivia;switch(L){case I.openBrace:return n++,E=h.OpenBraceToken;case I.closeBrace:return n++,E=h.CloseBraceToken;case I.openBracket:return n++,E=h.OpenBracketToken;case I.closeBracket:return n++,E=h.CloseBracketToken;case I.colon:return n++,E=h.ColonToken;case I.comma:return n++,E=h.CommaToken;case I.doubleQuote:return n++,l=p(),E=h.StringLiteral;case I.slash:{const M=n-1;if(t.charCodeAt(n+1)===I.slash){for(n+=2;n<d&&!b(t.charCodeAt(n));)n++;return l=t.substring(M,n),E=h.LineCommentTrivia}if(t.charCodeAt(n+1)===I.asterisk){n+=2;const z=d-1;let j=!1;for(;n<z;){if(t.charCodeAt(n)===I.asterisk&&t.charCodeAt(n+1)===I.slash){n+=2,j=!0;break}n++}return j||(n++,S=r.UnexpectedEndOfComment),l=t.substring(M,n),E=h.BlockCommentTrivia}return l+=String.fromCharCode(L),n++,E=h.Unknown}case I.minus:if(l+=String.fromCharCode(L),n++,n===d||!c(t.charCodeAt(n)))return E=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return l+=P(),E=h.NumericLiteral;default:for(;n<d&&F(L);)n++,L=t.charCodeAt(n);if(g!==n){switch(l=t.substring(g,n),l){case"true":return E=h.TrueKeyword;case"false":return E=h.FalseKeyword;case"null":return E=h.NullKeyword}return E=h.Unknown}return l+=String.fromCharCode(L),n++,E=h.Unknown}}function F(L){if(O(L)||b(L))return!1;switch(L){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function N(){let L;do L=v();while(L>=h.LineCommentTrivia&&L<=h.Trivia);return L}return{setPosition:k,getPosition:()=>n,scan:o?N:v,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>S}}function O(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function b(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function c(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function y(t,o){const n=[],d=new Object;let l;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function S(D,k,P,p){g.value=D,g.offset=k,g.length=P,g.type=p,g.colonOffset=void 0,l=g}try{i(t,{onObjectBegin:(D,k)=>{if(o<=D)throw d;l=void 0,E=o>D,n.push("")},onObjectProperty:(D,k,P)=>{if(o<k||(S(D,k,P,"property"),n[n.length-1]=D,o<=k+P))throw d},onObjectEnd:(D,k)=>{if(o<=D)throw d;l=void 0,n.pop()},onArrayBegin:(D,k)=>{if(o<=D)throw d;l=void 0,n.push(0)},onArrayEnd:(D,k)=>{if(o<=D)throw d;l=void 0,n.pop()},onLiteralValue:(D,k,P)=>{if(o<k||(S(D,k,P,s(D)),o<=k+P))throw d},onSeparator:(D,k,P)=>{if(o<=k)throw d;if(D===":"&&l&&l.type==="property")l.colonOffset=k,E=!1,l=void 0;else if(D===","){const p=n[n.length-1];typeof p=="number"?n[n.length-1]=p+1:(E=!0,n[n.length-1]=""),l=void 0}}})}catch(D){if(D!==d)throw D}return{path:n,previousNode:l,isAtPropertyKey:E,matches:D=>{let k=0;for(let P=0;k<D.length&&P<n.length;P++)if(D[k]===n[P]||D[k]==="*")k++;else if(D[k]!=="**")return!1;return k===D.length}}}function u(t,o=[],n=R.DEFAULT){let d=null,l=[];const g=[];function E(D){Array.isArray(l)?l.push(D):d!==null&&(l[d]=D)}return i(t,{onObjectBegin:()=>{const D={};E(D),g.push(l),l=D,d=null},onObjectProperty:D=>{d=D},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const D=[];E(D),g.push(l),l=D,d=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:E,onError:(D,k,P)=>{o.push({error:D,offset:k,length:P})}},n),l[0]}function C(t,o=[],n=R.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(D){d.type==="property"&&(d.length=D-d.offset,d=d.parent)}function g(D){return d.children.push(D),D}i(t,{onObjectBegin:D=>{d=g({type:"object",offset:D,length:-1,parent:d,children:[]})},onObjectProperty:(D,k,P)=>{d=g({type:"property",offset:k,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:D,offset:k,length:P,parent:d})},onObjectEnd:(D,k)=>{d.length=D+k-d.offset,d=d.parent,l(D+k)},onArrayBegin:(D,k)=>{d=g({type:"array",offset:D,length:-1,parent:d,children:[]})},onArrayEnd:(D,k)=>{d.length=D+k-d.offset,d=d.parent,l(D+k)},onLiteralValue:(D,k,P)=>{g({type:s(D),offset:k,length:P,parent:d,value:D}),l(k+P)},onSeparator:(D,k,P)=>{d.type==="property"&&(D===":"?d.colonOffset=k:D===","&&l(k))},onError:(D,k,P)=>{o.push({error:D,offset:k,length:P})}},n);const S=d.children[0];return S&&delete S.parent,S}function w(t,o){if(!t)return;let n=t;for(const d of o)if(typeof d=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===d){n=g.children[1],l=!0;break}if(!l)return}else{const l=d;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}function a(t){if(!t.parent||!t.parent.children)return[];const o=a(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const o=Object.create(null);for(const n of t.children){const d=n.children[1];d&&(o[n.children[0].value]=m(d))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}function f(t,o,n=!1){if($(t,o,n)){const d=t.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=o;l++){const g=f(d[l],o,n);if(g)return g}return t}}function i(t,o,n=R.DEFAULT){const d=T(t,!1);function l(_){return _?()=>_(d.getTokenOffset(),d.getTokenLength()):()=>!0}function g(_){return _?ce=>_(ce,d.getTokenOffset(),d.getTokenLength()):()=>!0}const E=l(o.onObjectBegin),S=g(o.onObjectProperty),D=l(o.onObjectEnd),k=l(o.onArrayBegin),P=l(o.onArrayEnd),p=g(o.onLiteralValue),v=g(o.onSeparator),F=l(o.onComment),N=g(o.onError),L=n&&n.disallowComments,M=n&&n.allowTrailingComma;function z(){for(;;){const _=d.scan();switch(d.getTokenError()){case r.InvalidUnicode:j(A.InvalidUnicode);break;case r.InvalidEscapeCharacter:j(A.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:j(A.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:L||j(A.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:j(A.UnexpectedEndOfString);break;case r.InvalidCharacter:j(A.InvalidCharacter);break}switch(_){case h.LineCommentTrivia:case h.BlockCommentTrivia:L?j(A.InvalidCommentToken):F();break;case h.Unknown:j(A.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return _}}}function j(_,ce=[],ne=[]){if(N(_),ce.length+ne.length>0){let ye=d.getToken();for(;ye!==h.EOF;){if(ce.indexOf(ye)!==-1){z();break}else if(ne.indexOf(ye)!==-1)break;ye=z()}}}function q(_){const ce=d.getTokenValue();return _?p(ce):S(ce),z(),!0}function B(){switch(d.getToken()){case h.NumericLiteral:{let _=0;try{_=JSON.parse(d.getTokenValue()),typeof _!="number"&&(j(A.InvalidNumberFormat),_=0)}catch{j(A.InvalidNumberFormat)}p(_);break}case h.NullKeyword:p(null);break;case h.TrueKeyword:p(!0);break;case h.FalseKeyword:p(!1);break;default:return!1}return z(),!0}function ee(){return d.getToken()!==h.StringLiteral?(j(A.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(q(!1),d.getToken()===h.ColonToken?(v(":"),z(),X()||j(A.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):j(A.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function H(){E(),z();let _=!1;for(;d.getToken()!==h.CloseBraceToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(_||j(A.ValueExpected,[],[]),v(","),z(),d.getToken()===h.CloseBraceToken&&M)break}else _&&j(A.CommaExpected,[],[]);ee()||j(A.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),_=!0}return D(),d.getToken()!==h.CloseBraceToken?j(A.CloseBraceExpected,[h.CloseBraceToken],[]):z(),!0}function W(){k(),z();let _=!1;for(;d.getToken()!==h.CloseBracketToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(_||j(A.ValueExpected,[],[]),v(","),z(),d.getToken()===h.CloseBracketToken&&M)break}else _&&j(A.CommaExpected,[],[]);X()||j(A.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),_=!0}return P(),d.getToken()!==h.CloseBracketToken?j(A.CloseBracketExpected,[h.CloseBracketToken],[]):z(),!0}function X(){switch(d.getToken()){case h.OpenBracketToken:return W();case h.OpenBraceToken:return H();case h.StringLiteral:return q(!0);default:return B()}}return z(),d.getToken()===h.EOF?n.allowEmptyContent?!0:(j(A.ValueExpected,[],[]),!1):X()?(d.getToken()!==h.EOF&&j(A.EndOfFileExpected,[],[]),!0):(j(A.ValueExpected,[],[]),!1)}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[177],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=r;function r(R){let T=!1;const O=new Map,b=new Map;if(A(R,a=>{if(R===a)return!0;const m=JSON.stringify(a);if(m.length<30)return!0;const $=O.get(m);if(!$){const f={schemas:[a]};return O.set(m,f),b.set(a,f),!0}return $.schemas.push(a),b.set(a,$),T=!0,!1}),O.clear(),!T)return JSON.stringify(R);let I="$defs";for(;R.hasOwnProperty(I);)I+="_";const y=[];function u(a){return JSON.stringify(a,(m,$)=>{if($!==a){const f=b.get($);if(f&&f.schemas.length>1)return f.id||(f.id=`_${y.length}`,y.push(f.schemas[0])),{$ref:`#/${I}/${f.id}`}}return $})}const C=u(R),w=[];for(let a=0;a<y.length;a++)w.push(`"_${a}":${u(y[a])}`);return w.length?`${C.substring(0,C.length-1)},"${I}":{${w.join(",")}}}`:C}function h(R){return typeof R=="object"&&R!==null}function A(R,T){if(!R||typeof R!="object")return;const O=(...C)=>{for(const w of C)h(w)&&y.push(w)},b=(...C)=>{for(const w of C)if(h(w))for(const a in w){const m=w[a];h(m)&&y.push(m)}},c=(...C)=>{for(const w of C)if(Array.isArray(w))for(const a of w)h(a)&&y.push(a)},I=C=>{if(Array.isArray(C))for(const w of C)h(w)&&y.push(w);else h(C)&&y.push(C)},y=[R];let u=y.pop();for(;u;)T(u)&&(O(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),b(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),c(u.anyOf,u.allOf,u.oneOf,u.prefixItems),I(u.items)),u=y.pop()}}),define(ke[50],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class r{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=r}),define(ke[80],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const T=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=T}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,T){const O=new r(R);if(this.a===r.Undefined)this.a=O,this.b=O;else if(T){const c=this.b;this.b=O,O.prev=c,c.next=O}else{const c=this.a;this.a=O,O.next=c,c.prev=O}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(O))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const T=R.prev;T.next=R.next,R.next.prev=T}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$6c=h}),define(ke[28],Ie([1,0]),function($e,e){"use strict";var r,h,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=T,e.$Ac=O,e.$Jc=s;function R(t,o,n){let d=t.get(o);return d===void 0&&(d=n,t.set(o,d)),d}function T(t){const o=[];return t.forEach((n,d)=>{o.push(`${d} => ${n}`)}),`Map(${t.size}) {${o.join(", ")}}`}function O(t){const o=[];return t.forEach(n=>{o.push(n)}),`Set(${t.size}) {${o.join(", ")}}`}class b{constructor(o,n){this.uri=o,this.value=n}}function c(t){return Array.isArray(t)}class I{static{this.c=o=>o.toString()}constructor(o,n){if(this[r]="ResourceMap",o instanceof I)this.d=new Map(o.d),this.e=n??I.c;else if(c(o)){this.d=new Map,this.e=n??I.c;for(const[d,l]of o)this.set(d,l)}else this.d=new Map,this.e=o??I.c}set(o,n){return this.d.set(this.e(o),new b(o,n)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,n){typeof n<"u"&&(o=o.bind(n));for(const[d,l]of this.d)o(l.value,l.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}e.$Bc=I;class y{constructor(o,n){this[h]="ResourceSet",!o||typeof o=="function"?this.c=new I(o):(this.c=new I(n),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,n){this.c.forEach((d,l)=>o.call(n,l,l,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var u;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class C{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,n=u.None){const d=this.c.get(o);if(d)return n!==u.None&&this.m(d,n),d.value}set(o,n,d=u.None){let l=this.c.get(o);if(l)l.value=n,d!==u.None&&this.m(l,d);else{switch(l={key:o,value:n,next:void 0,previous:void 0},d){case u.None:this.k(l);break;case u.AsOld:this.j(l);break;case u.AsNew:this.k(l);break;default:this.k(l);break}this.c.set(o,l),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const n=this.c.get(o);if(n)return this.c.delete(o),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.l(o),this.f--,o.value}forEach(o,n){const d=this.g;let l=this.d;for(;l;){if(n?o.bind(n)(l.value,l.key,this):o(l.value,l.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.key,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}values(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.value,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}entries(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:[d.key,d.value],done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this.d,d=this.size;for(;n&&d>o;)this.c.delete(n.key),n=n.next,d--;this.d=n,this.f=d,n&&(n.previous=void 0),this.g++}i(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this.e,d=this.size;for(;n&&d>o;)this.c.delete(n.key),n=n.previous,d--;this.e=n,this.f=d,n&&(n.next=void 0),this.g++}j(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}k(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}l(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const n=o.next,d=o.previous;if(!n||!d)throw new Error("Invalid list");n.previous=d,d.next=n}o.next=void 0,o.previous=void 0,this.g++}m(o,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==u.AsOld&&n!==u.AsNew)){if(n===u.AsOld){if(o===this.d)return;const d=o.next,l=o.previous;o===this.e?(l.next=void 0,this.e=l):(d.previous=l,l.next=d),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(n===u.AsNew){if(o===this.e)return;const d=o.next,l=o.previous;o===this.d?(d.previous=void 0,this.d=d):(d.previous=l,l.next=d),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((n,d)=>{o.push([d,n])}),o}fromJSON(o){this.clear();for(const[n,d]of o)this.set(n,d)}}e.$Dc=C;class w extends C{constructor(o,n=1){super(),this.n=o,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(o){this.n=o,this.p()}get ratio(){return this.o}set ratio(o){this.o=Math.min(Math.max(0,o),1),this.p()}get(o,n=u.AsNew){return super.get(o,n)}peek(o){return super.get(o,u.None)}set(o,n){return super.set(o,n,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends w{constructor(o,n=1){super(o,n)}q(o){this.h(o)}set(o,n){return super.set(o,n),this.p(),this}}e.$Ec=a;class m extends w{constructor(o,n=1){super(o,n)}q(o){this.i(o)}set(o,n){return this.n<=this.size&&!this.has(o)&&this.q(Math.round(this.n*this.o)-1),super.set(o,n),this}}e.$Fc=m;class ${constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let n=this.c.get(o)||0;return n===0?!1:(n--,n===0?this.c.delete(o):this.c.set(o,n),!0)}has(o){return this.c.has(o)}}e.$Gc=$;class f{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[n,d]of o)this.set(n,d)}clear(){this.c.clear(),this.d.clear()}set(o,n){this.c.set(o,n),this.d.set(n,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const n=this.c.get(o);return n===void 0?!1:(this.c.delete(o),this.d.delete(n),!0)}forEach(o,n){this.c.forEach((d,l)=>{o.call(n,d,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=f;class i{constructor(){this.c=new Map}add(o,n){let d=this.c.get(o);d||(d=new Set,this.c.set(o,d)),d.add(n)}delete(o,n){const d=this.c.get(o);d&&(d.delete(n),d.size===0&&this.c.delete(o))}forEach(o,n){const d=this.c.get(o);d&&d.forEach(n)}get(o){const n=this.c.get(o);return n||new Set}}e.$Ic=i;function s(t,o){if(t===o)return!0;if(t.size!==o.size)return!1;for(const[n,d]of t)if(!o.has(n)||o.get(n)!==d)return!1;for(const[n]of o)if(!t.has(n))return!1;return!0}}),define(ke[3],Ie([1,0,18,78,28,79,39]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=I,e.$Mc=y,e.$Nc=u,e.$Oc=a,e.$Pc=m,e.$Qc=$,e.$Rc=f,e.$Sc=i,e.$Tc=s,e.$4c=k;const O=!1;let b=null;class c{constructor(){this.b=new Map}static{this.a=0}c(v){let F=this.b.get(v);return F||(F={parent:null,source:null,isSingleton:!1,value:v,idx:c.a++},this.b.set(v,F)),F}trackDisposable(v){const F=this.c(v);F.source||(F.source=new Error().stack)}setParent(v,F){const N=this.c(v);N.parent=F}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,F){const N=F.get(v);if(N)return N;const L=v.parent?this.f(this.c(v.parent),F):v;return F.set(v,L),L}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,F){let N;if(F)N=F;else{const q=new Map,B=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,q).isSingleton);if(B.length===0)return;const ee=new Set(B.map(H=>H.value));if(N=B.filter(H=>!(H.parent&&ee.has(H.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function L(q){function B(H,W){for(;H.length>0&&W.some(X=>typeof X=="string"?X===H[0]:H[0].match(X));)H.shift()}const ee=q.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return B(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const M=new A.$Ic;for(const q of N){const B=L(q);for(let ee=0;ee<=B.length;ee++)M.add(B.slice(0,ee).join(`
`),q)}N.sort((0,r.$6b)(q=>q.idx,r.$8b));let z="",j=0;for(const q of N.slice(0,v)){j++;const B=L(q),ee=[];for(let H=0;H<B.length;H++){let W=B[H];W=`(shared with ${M.get(B.slice(0,H+1).join(`
`)).size}/${N.length} leaks) at ${W}`;const _=M.get(B.slice(0,H).join(`
`)),ce=(0,h.$c)([..._].map(ne=>L(ne)[H]),ne=>ne);delete ce[B[H]];for(const[ne,ye]of Object.entries(ce))ee.unshift(`    - stacktraces of ${ye.length} other leaks continue with ${ne}`);ee.unshift(W)}z+=`


==================== Leaking disposable ${j}/${N.length}: ${q.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return N.length>v&&(z+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:z}}}e.$Kc=c;function I(p){b=p}if(O){const p="__is_disposable_tracked__";I(new class{trackDisposable(v){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[p]||console.log(F)},3e3)}setParent(v,F){if(v&&v!==o.None)try{v[p]=!0}catch{}}markAsDisposed(v){if(v&&v!==o.None)try{v[p]=!0}catch{}}markAsSingleton(v){}})}function y(p){return b?.trackDisposable(p),p}function u(p){b?.markAsDisposed(p)}function C(p,v){b?.setParent(p,v)}function w(p,v){if(b)for(const F of p)b.setParent(F,v)}function a(p){return b?.markAsSingleton(p),p}function m(p){return typeof p=="object"&&p!==null&&typeof p.dispose=="function"&&p.dispose.length===0}function $(p){if(T.Iterable.is(p)){const v=[];for(const F of p)if(F)try{F.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}function f(p){for(const v of p)m(v)&&v.dispose();return[]}function i(...p){const v=s(()=>$(p));return w(p,v),v}function s(p){const v=y({dispose:(0,R.$db)(()=>{u(v),p()})});return v}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return C(v,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),C(v,null))}}e.$Uc=t;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,y(this),C(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Vc=o;class n{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&C(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&C(v,null),v}}e.$Wc=n;class d{constructor(v){this.a=new n,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=d;class l{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=l;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(v){let F=v;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,u(this))},this}}e.$Zc=g;class E{constructor(){this.a=new Map}acquire(v,...F){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...F)},this.a.set(v,N));const{object:L}=N,M=(0,R.$db)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:L,dispose:M}}}e.$1c=E;class S{constructor(v){this.a=v}async acquire(v,...F){const N=this.a.acquire(v,...F);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(L){throw N.dispose(),L}}}e.$2c=S;class D{constructor(v){this.object=v}dispose(){}}e.$3c=D;function k(p){const v=new t;try{p(v)}finally{v.dispose()}}class P{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,F,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,F)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const F=this.a.get(v);return this.a.delete(v),F}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=P}),function($e,e){typeof define=="function"&&define.amd?define(ke[178],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(te,ae){for(var se=0;se<ae.length;se++){var Z=ae[se];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(te,Z.key,Z)}}function r(te,ae,se){return ae&&e(te.prototype,ae),se&&e(te,se),Object.defineProperty(te,"prototype",{writable:!1}),te}function h(te,ae){if(te){if(typeof te=="string")return A(te,ae);var se=Object.prototype.toString.call(te).slice(8,-1);if(se==="Object"&&te.constructor&&(se=te.constructor.name),se==="Map"||se==="Set")return Array.from(te);if(se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(se))return A(te,ae)}}function A(te,ae){(ae==null||ae>te.length)&&(ae=te.length);for(var se=0,Z=new Array(ae);se<ae;se++)Z[se]=te[se];return Z}function R(te,ae){var se=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(se)return(se=se.call(te)).next.bind(se);if(Array.isArray(te)||(se=h(te))||ae&&te&&typeof te.length=="number"){se&&(te=se);var Z=0;return function(){return Z>=te.length?{done:!0}:{done:!1,value:te[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=T();function O(te){$e.defaults=te}var b=/[&<>"']/,c=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ae){return u[ae]};function w(te,ae){if(ae){if(b.test(te))return te.replace(c,C)}else if(I.test(te))return te.replace(y,C);return te}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(te){return te.replace(a,function(ae,se){return se=se.toLowerCase(),se==="colon"?":":se.charAt(0)==="#"?se.charAt(1)==="x"?String.fromCharCode(parseInt(se.substring(2),16)):String.fromCharCode(+se.substring(1)):""})}var $=/(^|[^\[])\^/g;function f(te,ae){te=typeof te=="string"?te:te.source,ae=ae||"";var se={replace:function(re,pe){return pe=pe.source||pe,pe=pe.replace($,"$1"),te=te.replace(re,pe),se},getRegex:function(){return new RegExp(te,ae)}};return se}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(te,ae,se){if(te){var Z;try{Z=decodeURIComponent(m(se)).replace(i,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ae&&!s.test(se)&&(se=g(ae,se));try{se=encodeURI(se).replace(/%25/g,"%")}catch{return null}return se}var o={},n=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(te,ae){o[" "+te]||(n.test(te)?o[" "+te]=te+"/":o[" "+te]=k(te,"/",!0)),te=o[" "+te];var se=te.indexOf(":")===-1;return ae.substring(0,2)==="//"?se?ae:te.replace(d,"$1")+ae:ae.charAt(0)==="/"?se?ae:te.replace(l,"$1")+ae:te+ae}var E={exec:function(){}};function S(te){for(var ae=1,se,Z;ae<arguments.length;ae++){se=arguments[ae];for(Z in se)Object.prototype.hasOwnProperty.call(se,Z)&&(te[Z]=se[Z])}return te}function D(te,ae){var se=te.replace(/\|/g,function(pe,we,Fe){for(var ze=!1,Re=we;--Re>=0&&Fe[Re]==="\\";)ze=!ze;return ze?"|":" |"}),Z=se.split(/ \|/),re=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>ae)Z.splice(ae);else for(;Z.length<ae;)Z.push("");for(;re<Z.length;re++)Z[re]=Z[re].trim().replace(/\\\|/g,"|");return Z}function k(te,ae,se){var Z=te.length;if(Z===0)return"";for(var re=0;re<Z;){var pe=te.charAt(Z-re-1);if(pe===ae&&!se)re++;else if(pe!==ae&&se)re++;else break}return te.slice(0,Z-re)}function P(te,ae){if(te.indexOf(ae[1])===-1)return-1;for(var se=te.length,Z=0,re=0;re<se;re++)if(te[re]==="\\")re++;else if(te[re]===ae[0])Z++;else if(te[re]===ae[1]&&(Z--,Z<0))return re;return-1}function p(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(te,ae){if(ae<1)return"";for(var se="";ae>1;)ae&1&&(se+=te),ae>>=1,te+=te;return se+te}function F(te,ae,se,Z){var re=ae.href,pe=ae.title?w(ae.title):null,we=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){Z.state.inLink=!0;var Fe={type:"link",raw:se,href:re,title:pe,text:we,tokens:Z.inlineTokens(we)};return Z.state.inLink=!1,Fe}return{type:"image",raw:se,href:re,title:pe,text:w(we)}}function N(te,ae){var se=te.match(/^(\s+)(?:```)/);if(se===null)return ae;var Z=se[1];return ae.split(`
`).map(function(re){var pe=re.match(/^\s+/);if(pe===null)return re;var we=pe[0];return we.length>=Z.length?re.slice(Z.length):re}).join(`
`)}var L=function(){function te(se){this.options=se||$e.defaults}var ae=te.prototype;return ae.space=function(Z){var re=this.rules.block.newline.exec(Z);if(re&&re[0].length>0)return{type:"space",raw:re[0]}},ae.code=function(Z){var re=this.rules.block.code.exec(Z);if(re){var pe=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:k(pe,`
`)}}},ae.fences=function(Z){var re=this.rules.block.fences.exec(Z);if(re){var pe=re[0],we=N(pe,re[3]||"");return{type:"code",raw:pe,lang:re[2]?re[2].trim():re[2],text:we}}},ae.heading=function(Z){var re=this.rules.block.heading.exec(Z);if(re){var pe=re[2].trim();if(/#$/.test(pe)){var we=k(pe,"#");(this.options.pedantic||!we||/ $/.test(we))&&(pe=we.trim())}return{type:"heading",raw:re[0],depth:re[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ae.hr=function(Z){var re=this.rules.block.hr.exec(Z);if(re)return{type:"hr",raw:re[0]}},ae.blockquote=function(Z){var re=this.rules.block.blockquote.exec(Z);if(re){var pe=re[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:re[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ae.list=function(Z){var re=this.rules.block.list.exec(Z);if(re){var pe,we,Fe,ze,Re,De,Ce,V,G,J,x,de,Ee=re[1].trim(),Le=Ee.length>1,He={type:"list",raw:"",ordered:Le,start:Le?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Le?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Le?Ee:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(de=!1,!(!(re=Ke.exec(Z))||this.rules.block.hr.test(Z)));){if(pe=re[0],Z=Z.substring(pe.length),V=re[2].split(`
`,1)[0],G=Z.split(`
`,1)[0],this.options.pedantic?(ze=2,x=V.trimLeft()):(ze=re[2].search(/[^ ]/),ze=ze>4?1:ze,x=V.slice(ze),ze+=re[1].length),De=!1,!V&&/^ *$/.test(G)&&(pe+=G+`
`,Z=Z.substring(G.length+1),de=!0),!de)for(var et=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),st=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");Z&&(J=Z.split(`
`,1)[0],V=J,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(st.test(V)||rt.test(V)||et.test(V)||nt.test(Z)));){if(V.search(/[^ ]/)>=ze||!V.trim())x+=`
`+V.slice(ze);else if(!De)x+=`
`+V;else break;!De&&!V.trim()&&(De=!0),pe+=J+`
`,Z=Z.substring(J.length+1)}He.loose||(Ce?He.loose=!0:/\n *\n *$/.test(pe)&&(Ce=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(x),we&&(Fe=we[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:pe,task:!!we,checked:Fe,loose:!1,text:x}),He.raw+=pe}He.items[He.items.length-1].raw=pe.trimRight(),He.items[He.items.length-1].text=x.trimRight(),He.raw=He.raw.trimRight();var at=He.items.length;for(Re=0;Re<at;Re++){this.lexer.state.top=!1,He.items[Re].tokens=this.lexer.blockTokens(He.items[Re].text,[]);var gt=He.items[Re].tokens.filter(function(ct){return ct.type==="space"}),dt=gt.every(function(ct){for(var Pe=ct.raw.split(""),Be=0,Qe=R(Pe),Ne;!(Ne=Qe()).done;){var je=Ne.value;if(je===`
`&&(Be+=1),Be>1)return!0}return!1});!He.loose&&gt.length&&dt&&(He.loose=!0,He.items[Re].loose=!0)}return He}},ae.html=function(Z){var re=this.rules.block.html.exec(Z);if(re){var pe={type:"html",raw:re[0],pre:!this.options.sanitizer&&(re[1]==="pre"||re[1]==="script"||re[1]==="style"),text:re[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(re[0]):w(re[0]);pe.type="paragraph",pe.text=we,pe.tokens=this.lexer.inline(we)}return pe}},ae.def=function(Z){var re=this.rules.block.def.exec(Z);if(re){re[3]&&(re[3]=re[3].substring(1,re[3].length-1));var pe=re[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:re[0],href:re[2],title:re[3]}}},ae.table=function(Z){var re=this.rules.block.table.exec(Z);if(re){var pe={type:"table",header:D(re[1]).map(function(Ce){return{text:Ce}}),align:re[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=re[0];var we=pe.align.length,Fe,ze,Re,De;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(pe.align[Fe])?pe.align[Fe]="right":/^ *:-+: *$/.test(pe.align[Fe])?pe.align[Fe]="center":/^ *:-+ *$/.test(pe.align[Fe])?pe.align[Fe]="left":pe.align[Fe]=null;for(we=pe.rows.length,Fe=0;Fe<we;Fe++)pe.rows[Fe]=D(pe.rows[Fe],pe.header.length).map(function(Ce){return{text:Ce}});for(we=pe.header.length,ze=0;ze<we;ze++)pe.header[ze].tokens=this.lexer.inline(pe.header[ze].text);for(we=pe.rows.length,ze=0;ze<we;ze++)for(De=pe.rows[ze],Re=0;Re<De.length;Re++)De[Re].tokens=this.lexer.inline(De[Re].text);return pe}}},ae.lheading=function(Z){var re=this.rules.block.lheading.exec(Z);if(re)return{type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:this.lexer.inline(re[1])}},ae.paragraph=function(Z){var re=this.rules.block.paragraph.exec(Z);if(re){var pe=re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1];return{type:"paragraph",raw:re[0],text:pe,tokens:this.lexer.inline(pe)}}},ae.text=function(Z){var re=this.rules.block.text.exec(Z);if(re)return{type:"text",raw:re[0],text:re[0],tokens:this.lexer.inline(re[0])}},ae.escape=function(Z){var re=this.rules.inline.escape.exec(Z);if(re)return{type:"escape",raw:re[0],text:w(re[1])}},ae.tag=function(Z){var re=this.rules.inline.tag.exec(Z);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):w(re[0]):re[0]}},ae.link=function(Z){var re=this.rules.inline.link.exec(Z);if(re){var pe=re[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var we=k(pe.slice(0,-1),"\\");if((pe.length-we.length)%2===0)return}else{var Fe=P(re[2],"()");if(Fe>-1){var ze=re[0].indexOf("!")===0?5:4,Re=ze+re[1].length+Fe;re[2]=re[2].substring(0,Fe),re[0]=re[0].substring(0,Re).trim(),re[3]=""}}var De=re[2],Ce="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(De);V&&(De=V[1],Ce=V[3])}else Ce=re[3]?re[3].slice(1,-1):"";return De=De.trim(),/^</.test(De)&&(this.options.pedantic&&!/>$/.test(pe)?De=De.slice(1):De=De.slice(1,-1)),F(re,{href:De&&De.replace(this.rules.inline._escapes,"$1"),title:Ce&&Ce.replace(this.rules.inline._escapes,"$1")},re[0],this.lexer)}},ae.reflink=function(Z,re){var pe;if((pe=this.rules.inline.reflink.exec(Z))||(pe=this.rules.inline.nolink.exec(Z))){var we=(pe[2]||pe[1]).replace(/\s+/g," ");if(we=re[we.toLowerCase()],!we||!we.href){var Fe=pe[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return F(pe,we,pe[0],this.lexer)}},ae.emStrong=function(Z,re,pe){pe===void 0&&(pe="");var we=this.rules.inline.emStrong.lDelim.exec(Z);if(we&&!(we[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var ze=we[0].length-1,Re,De,Ce=ze,V=0,G=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(G.lastIndex=0,re=re.slice(-1*Z.length+ze);(we=G.exec(re))!=null;)if(Re=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Re){if(De=Re.length,we[3]||we[4]){Ce+=De;continue}else if((we[5]||we[6])&&ze%3&&!((ze+De)%3)){V+=De;continue}if(Ce-=De,!(Ce>0)){if(De=Math.min(De,De+Ce+V),Math.min(ze,De)%2){var J=Z.slice(1,ze+we.index+De);return{type:"em",raw:Z.slice(0,ze+we.index+De+1),text:J,tokens:this.lexer.inlineTokens(J)}}var x=Z.slice(2,ze+we.index+De-1);return{type:"strong",raw:Z.slice(0,ze+we.index+De+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},ae.codespan=function(Z){var re=this.rules.inline.code.exec(Z);if(re){var pe=re[2].replace(/\n/g," "),we=/[^ ]/.test(pe),Fe=/^ /.test(pe)&&/ $/.test(pe);return we&&Fe&&(pe=pe.substring(1,pe.length-1)),pe=w(pe,!0),{type:"codespan",raw:re[0],text:pe}}},ae.br=function(Z){var re=this.rules.inline.br.exec(Z);if(re)return{type:"br",raw:re[0]}},ae.del=function(Z){var re=this.rules.inline.del.exec(Z);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2])}},ae.autolink=function(Z,re){var pe=this.rules.inline.autolink.exec(Z);if(pe){var we,Fe;return pe[2]==="@"?(we=w(this.options.mangle?re(pe[1]):pe[1]),Fe="mailto:"+we):(we=w(pe[1]),Fe=we),{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ae.url=function(Z,re){var pe;if(pe=this.rules.inline.url.exec(Z)){var we,Fe;if(pe[2]==="@")we=w(this.options.mangle?re(pe[0]):pe[0]),Fe="mailto:"+we;else{var ze;do ze=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(ze!==pe[0]);we=w(pe[0]),pe[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ae.inlineText=function(Z,re){var pe=this.rules.inline.text.exec(Z);if(pe){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):w(pe[0]):pe[0]:we=w(this.options.smartypants?re(pe[0]):pe[0]),{type:"text",raw:pe[0],text:we}}},te}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=f(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=f(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=f(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=f(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=f(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=f(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=S({},M),M.gfm=S({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=f(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=f(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=S({},M.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:f(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=f(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=f(M._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=f(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=f(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=f(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=f(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=f(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=f(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=f(z.reflink).replace("label",z._label).replace("ref",M._label).getRegex(),z.nolink=f(z.nolink).replace("ref",M._label).getRegex(),z.reflinkSearch=f(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=S({},z),z.pedantic=S({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=S({},z.normal,{escape:f(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=f(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=S({},z.gfm,{br:f(z.br).replace("{2,}","*").getRegex(),text:f(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(te){var ae="",se,Z,re=te.length;for(se=0;se<re;se++)Z=te.charCodeAt(se),Math.random()>.5&&(Z="x"+Z.toString(16)),ae+="&#"+Z+";";return ae}var B=function(){function te(se){this.tokens=[],this.tokens.links=Object.create(null),this.options=se||$e.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:M.normal,inline:z.normal};this.options.pedantic?(Z.block=M.pedantic,Z.inline=z.pedantic):this.options.gfm&&(Z.block=M.gfm,this.options.breaks?Z.inline=z.breaks:Z.inline=z.gfm),this.tokenizer.rules=Z}te.lex=function(Z,re){var pe=new te(re);return pe.lex(Z)},te.lexInline=function(Z,re){var pe=new te(re);return pe.inlineTokens(Z)};var ae=te.prototype;return ae.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var re;re=this.inlineQueue.shift();)this.inlineTokens(re.src,re.tokens);return this.tokens},ae.blockTokens=function(Z,re){var pe=this;re===void 0&&(re=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(Ce,V,G){return V+"    ".repeat(G.length)});for(var we,Fe,ze,Re;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ce){return(we=Ce.call({lexer:pe},Z,re))?(Z=Z.substring(we.raw.length),re.push(we),!0):!1}))){if(we=this.tokenizer.space(Z)){Z=Z.substring(we.raw.length),we.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(we);continue}if(we=this.tokenizer.code(Z)){Z=Z.substring(we.raw.length),Fe=re[re.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):re.push(we);continue}if(we=this.tokenizer.fences(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.heading(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.hr(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.blockquote(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.list(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.html(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.def(Z)){Z=Z.substring(we.raw.length),Fe=re[re.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.lheading(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(ze=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ce=1/0,V=Z.slice(1),G=void 0;pe.options.extensions.startBlock.forEach(function(J){G=J.call({lexer:this},V),typeof G=="number"&&G>=0&&(Ce=Math.min(Ce,G))}),Ce<1/0&&Ce>=0&&(ze=Z.substring(0,Ce+1))}(),this.state.top&&(we=this.tokenizer.paragraph(ze))){Fe=re[re.length-1],Re&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):re.push(we),Re=ze.length!==Z.length,Z=Z.substring(we.raw.length);continue}if(we=this.tokenizer.text(Z)){Z=Z.substring(we.raw.length),Fe=re[re.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):re.push(we);continue}if(Z){var De="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return this.state.top=!0,re},ae.inline=function(Z,re){return re===void 0&&(re=[]),this.inlineQueue.push({src:Z,tokens:re}),re},ae.inlineTokens=function(Z,re){var pe=this;re===void 0&&(re=[]);var we,Fe,ze,Re=Z,De,Ce,V;if(this.tokens.links){var G=Object.keys(this.tokens.links);if(G.length>0)for(;(De=this.tokenizer.rules.inline.reflinkSearch.exec(Re))!=null;)G.includes(De[0].slice(De[0].lastIndexOf("[")+1,-1))&&(Re=Re.slice(0,De.index)+"["+v("a",De[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(De=this.tokenizer.rules.inline.blockSkip.exec(Re))!=null;)Re=Re.slice(0,De.index)+"["+v("a",De[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(De=this.tokenizer.rules.inline.escapedEmSt.exec(Re))!=null;)Re=Re.slice(0,De.index)+"++"+Re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Ce||(V=""),Ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(we=x.call({lexer:pe},Z,re))?(Z=Z.substring(we.raw.length),re.push(we),!0):!1}))){if(we=this.tokenizer.escape(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.tag(Z)){Z=Z.substring(we.raw.length),Fe=re[re.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):re.push(we);continue}if(we=this.tokenizer.link(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(we.raw.length),Fe=re[re.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):re.push(we);continue}if(we=this.tokenizer.emStrong(Z,Re,V)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.codespan(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.br(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.del(Z)){Z=Z.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.autolink(Z,q)){Z=Z.substring(we.raw.length),re.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(Z,q))){Z=Z.substring(we.raw.length),re.push(we);continue}if(ze=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,de=Z.slice(1),Ee=void 0;pe.options.extensions.startInline.forEach(function(Le){Ee=Le.call({lexer:this},de),typeof Ee=="number"&&Ee>=0&&(x=Math.min(x,Ee))}),x<1/0&&x>=0&&(ze=Z.substring(0,x+1))}(),we=this.tokenizer.inlineText(ze,j)){Z=Z.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(V=we.raw.slice(-1)),Ce=!0,Fe=re[re.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):re.push(we);continue}if(Z){var J="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return re},r(te,null,[{key:"rules",get:function(){return{block:M,inline:z}}}]),te}(),ee=function(){function te(se){this.options=se||$e.defaults}var ae=te.prototype;return ae.code=function(Z,re,pe){var we=(re||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(Z,we);Fe!=null&&Fe!==Z&&(pe=!0,Z=Fe)}return Z=Z.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+w(we,!0)+'">'+(pe?Z:w(Z,!0))+`</code></pre>
`:"<pre><code>"+(pe?Z:w(Z,!0))+`</code></pre>
`},ae.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ae.html=function(Z){return Z},ae.heading=function(Z,re,pe,we){if(this.options.headerIds){var Fe=this.options.headerPrefix+we.slug(pe);return"<h"+re+' id="'+Fe+'">'+Z+"</h"+re+`>
`}return"<h"+re+">"+Z+"</h"+re+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(Z,re,pe){var we=re?"ol":"ul",Fe=re&&pe!==1?' start="'+pe+'"':"";return"<"+we+Fe+`>
`+Z+"</"+we+`>
`},ae.listitem=function(Z){return"<li>"+Z+`</li>
`},ae.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(Z){return"<p>"+Z+`</p>
`},ae.table=function(Z,re){return re&&(re="<tbody>"+re+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+re+`</table>
`},ae.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ae.tablecell=function(Z,re){var pe=re.header?"th":"td",we=re.align?"<"+pe+' align="'+re.align+'">':"<"+pe+">";return we+Z+("</"+pe+`>
`)},ae.strong=function(Z){return"<strong>"+Z+"</strong>"},ae.em=function(Z){return"<em>"+Z+"</em>"},ae.codespan=function(Z){return"<code>"+Z+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(Z){return"<del>"+Z+"</del>"},ae.link=function(Z,re,pe){if(Z=t(this.options.sanitize,this.options.baseUrl,Z),Z===null)return pe;var we='<a href="'+w(Z)+'"';return re&&(we+=' title="'+re+'"'),we+=">"+pe+"</a>",we},ae.image=function(Z,re,pe){if(Z=t(this.options.sanitize,this.options.baseUrl,Z),Z===null)return pe;var we='<img src="'+Z+'" alt="'+pe+'"';return re&&(we+=' title="'+re+'"'),we+=this.options.xhtml?"/>":">",we},ae.text=function(Z){return Z},te}(),H=function(){function te(){}var ae=te.prototype;return ae.strong=function(Z){return Z},ae.em=function(Z){return Z},ae.codespan=function(Z){return Z},ae.del=function(Z){return Z},ae.html=function(Z){return Z},ae.text=function(Z){return Z},ae.link=function(Z,re,pe){return""+pe},ae.image=function(Z,re,pe){return""+pe},ae.br=function(){return""},te}(),W=function(){function te(){this.seen={}}var ae=te.prototype;return ae.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(Z,re){var pe=Z,we=0;if(this.seen.hasOwnProperty(pe)){we=this.seen[Z];do we++,pe=Z+"-"+we;while(this.seen.hasOwnProperty(pe))}return re||(this.seen[Z]=we,this.seen[pe]=0),pe},ae.slug=function(Z,re){re===void 0&&(re={});var pe=this.serialize(Z);return this.getNextSafeSlug(pe,re.dryrun)},te}(),X=function(){function te(se){this.options=se||$e.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new W}te.parse=function(Z,re){var pe=new te(re);return pe.parse(Z)},te.parseInline=function(Z,re){var pe=new te(re);return pe.parseInline(Z)};var ae=te.prototype;return ae.parse=function(Z,re){re===void 0&&(re=!0);var pe="",we,Fe,ze,Re,De,Ce,V,G,J,x,de,Ee,Le,He,Ke,et,nt,st,rt,at=Z.length;for(we=0;we<at;we++){if(x=Z[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(rt=this.options.extensions.renderers[x.type].call({parser:this},x),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){pe+=rt||"";continue}switch(x.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(x.tokens),x.depth,m(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(G="",V="",Re=x.header.length,Fe=0;Fe<Re;Fe++)V+=this.renderer.tablecell(this.parseInline(x.header[Fe].tokens),{header:!0,align:x.align[Fe]});for(G+=this.renderer.tablerow(V),J="",Re=x.rows.length,Fe=0;Fe<Re;Fe++){for(Ce=x.rows[Fe],V="",De=Ce.length,ze=0;ze<De;ze++)V+=this.renderer.tablecell(this.parseInline(Ce[ze].tokens),{header:!1,align:x.align[ze]});J+=this.renderer.tablerow(V)}pe+=this.renderer.table(G,J);continue}case"blockquote":{J=this.parse(x.tokens),pe+=this.renderer.blockquote(J);continue}case"list":{for(de=x.ordered,Ee=x.start,Le=x.loose,Re=x.items.length,J="",Fe=0;Fe<Re;Fe++)Ke=x.items[Fe],et=Ke.checked,nt=Ke.task,He="",Ke.task&&(st=this.renderer.checkbox(et),Le?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=st+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=st+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:st}):He+=st),He+=this.parse(Ke.tokens,Le),J+=this.renderer.listitem(He,nt,et);pe+=this.renderer.list(J,de,Ee);continue}case"html":{pe+=this.renderer.html(x.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(J=x.tokens?this.parseInline(x.tokens):x.text;we+1<at&&Z[we+1].type==="text";)x=Z[++we],J+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);pe+=re?this.renderer.paragraph(J):J;continue}default:{var gt='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return pe},ae.parseInline=function(Z,re){re=re||this.renderer;var pe="",we,Fe,ze,Re=Z.length;for(we=0;we<Re;we++){if(Fe=Z[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(ze=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){pe+=ze||"";continue}switch(Fe.type){case"escape":{pe+=re.text(Fe.text);break}case"html":{pe+=re.html(Fe.text);break}case"link":{pe+=re.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,re));break}case"image":{pe+=re.image(Fe.href,Fe.title,Fe.text);break}case"strong":{pe+=re.strong(this.parseInline(Fe.tokens,re));break}case"em":{pe+=re.em(this.parseInline(Fe.tokens,re));break}case"codespan":{pe+=re.codespan(Fe.text);break}case"br":{pe+=re.br();break}case"del":{pe+=re.del(this.parseInline(Fe.tokens,re));break}case"text":{pe+=re.text(Fe.text);break}default:{var De='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(De);return}else throw new Error(De)}}}return pe},te}();function _(te,ae,se){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof ae=="function"&&(se=ae,ae=null),ae=S({},_.defaults,ae||{}),p(ae),se){var Z=ae.highlight,re;try{re=B.lex(te,ae)}catch(Re){return se(Re)}var pe=function(De){var Ce;if(!De)try{ae.walkTokens&&_.walkTokens(re,ae.walkTokens),Ce=X.parse(re,ae)}catch(V){De=V}return ae.highlight=Z,De?se(De):se(null,Ce)};if(!Z||Z.length<3||(delete ae.highlight,!re.length))return pe();var we=0;_.walkTokens(re,function(Re){Re.type==="code"&&(we++,setTimeout(function(){Z(Re.text,Re.lang,function(De,Ce){if(De)return pe(De);Ce!=null&&Ce!==Re.text&&(Re.text=Ce,Re.escaped=!0),we--,we===0&&pe()})},0))}),we===0&&pe();return}function Fe(Re){if(Re.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+w(Re.message+"",!0)+"</pre>";throw Re}try{var ze=B.lex(te,ae);if(ae.walkTokens){if(ae.async)return Promise.all(_.walkTokens(ze,ae.walkTokens)).then(function(){return X.parse(ze,ae)}).catch(Fe);_.walkTokens(ze,ae.walkTokens)}return X.parse(ze,ae)}catch(Re){Fe(Re)}}_.options=_.setOptions=function(te){return S(_.defaults,te),O(_.defaults),_},_.getDefaults=T,_.defaults=$e.defaults,_.use=function(){for(var te=arguments.length,ae=new Array(te),se=0;se<te;se++)ae[se]=arguments[se];var Z=S.apply(void 0,[{}].concat(ae)),re=_.defaults.extensions||{renderers:{},childTokens:{}},pe;ae.forEach(function(we){if(we.extensions&&(pe=!0,we.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Re=re.renderers?re.renderers[ze.name]:null;Re?re.renderers[ze.name]=function(){for(var De=arguments.length,Ce=new Array(De),V=0;V<De;V++)Ce[V]=arguments[V];var G=ze.renderer.apply(this,Ce);return G===!1&&(G=Re.apply(this,Ce)),G}:re.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");re[ze.level]?re[ze.level].unshift(ze.tokenizer):re[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?re.startBlock?re.startBlock.push(ze.start):re.startBlock=[ze.start]:ze.level==="inline"&&(re.startInline?re.startInline.push(ze.start):re.startInline=[ze.start]))}ze.childTokens&&(re.childTokens[ze.name]=ze.childTokens)})),we.renderer&&function(){var ze=_.defaults.renderer||new ee,Re=function(V){var G=ze[V];ze[V]=function(){for(var J=arguments.length,x=new Array(J),de=0;de<J;de++)x[de]=arguments[de];var Ee=we.renderer[V].apply(ze,x);return Ee===!1&&(Ee=G.apply(ze,x)),Ee}};for(var De in we.renderer)Re(De);Z.renderer=ze}(),we.tokenizer&&function(){var ze=_.defaults.tokenizer||new L,Re=function(V){var G=ze[V];ze[V]=function(){for(var J=arguments.length,x=new Array(J),de=0;de<J;de++)x[de]=arguments[de];var Ee=we.tokenizer[V].apply(ze,x);return Ee===!1&&(Ee=G.apply(ze,x)),Ee}};for(var De in we.tokenizer)Re(De);Z.tokenizer=ze}(),we.walkTokens){var Fe=_.defaults.walkTokens;Z.walkTokens=function(ze){var Re=[];return Re.push(we.walkTokens.call(this,ze)),Fe&&(Re=Re.concat(Fe.call(this,ze))),Re}}pe&&(Z.extensions=re),_.setOptions(Z)})},_.walkTokens=function(te,ae){for(var se=[],Z=function(){var Fe=pe.value;switch(se=se.concat(ae.call(_,Fe)),Fe.type){case"table":{for(var ze=R(Fe.header),Re;!(Re=ze()).done;){var De=Re.value;se=se.concat(_.walkTokens(De.tokens,ae))}for(var Ce=R(Fe.rows),V;!(V=Ce()).done;)for(var G=V.value,J=R(G),x;!(x=J()).done;){var de=x.value;se=se.concat(_.walkTokens(de.tokens,ae))}break}case"list":{se=se.concat(_.walkTokens(Fe.items,ae));break}default:_.defaults.extensions&&_.defaults.extensions.childTokens&&_.defaults.extensions.childTokens[Fe.type]?_.defaults.extensions.childTokens[Fe.type].forEach(function(Ee){se=se.concat(_.walkTokens(Fe[Ee],ae))}):Fe.tokens&&(se=se.concat(_.walkTokens(Fe.tokens,ae)))}},re=R(te),pe;!(pe=re()).done;)Z();return se},_.parseInline=function(te,ae){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");ae=S({},_.defaults,ae||{}),p(ae);try{var se=B.lexInline(te,ae);return ae.walkTokens&&_.walkTokens(se,ae.walkTokens),X.parseInline(se,ae)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+w(Z.message+"",!0)+"</pre>";throw Z}},_.Parser=X,_.parser=X.parse,_.Renderer=ee,_.TextRenderer=H,_.Lexer=B,_.lexer=B.lex,_.Tokenizer=L,_.Slugger=W,_.parse=_;var ce=_.options,ne=_.setOptions,ye=_.use,ge=_.walkTokens,Y=_.parseInline,U=_,oe=X.parse,ve=B.lex;$e.Lexer=B,$e.Parser=X,$e.Renderer=ee,$e.Slugger=W,$e.TextRenderer=H,$e.Tokenizer=L,$e.getDefaults=T,$e.lexer=ve,$e.marked=_,$e.options=ce,$e.parse=U,$e.parseInline=Y,$e.parser=oe,$e.setOptions=ne,$e.use=ye,$e.walkTokens=ge,Object.defineProperty($e,"__esModule",{value:!0})}),define(ke[40],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(ke[179],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=r;function r(a){const m=R(a);if(m&&m.length>0)return new Uint32Array(m)}let h=0;const A=new Uint32Array(10);function R(a){if(h=0,T(a,y,b.InitialConsonant),h>0||(T(a,u,b.Vowel),h>0)||(T(a,C,b.FinalConsonant),h>0)||(T(a,w,b.CompatibilityJamo),h))return A.subarray(0,h);if(a>=44032&&a<=55203){const m=a-44032,$=m%588,f=Math.floor(m/588),i=Math.floor($/28),s=$%28-1;if(f<y.length?T(f,y,0):b.InitialConsonant+f-b.CompatibilityJamo<w.length&&T(b.InitialConsonant+f,w,b.CompatibilityJamo),i<u.length?T(i,u,0):b.Vowel+i-b.CompatibilityJamo<w.length&&T(b.Vowel+i-b.CompatibilityJamo,w,b.CompatibilityJamo),s>=0&&(s<C.length?T(s,C,0):b.FinalConsonant+s-b.CompatibilityJamo<w.length&&T(b.FinalConsonant+s-b.CompatibilityJamo,w,b.CompatibilityJamo)),h>0)return A.subarray(0,h)}}function T(a,m,$){a>=$&&a<$+m.length&&O(m[a-$])}function O(a){a!==c.NUL&&(A[h++]=a&255,a>>8&&(A[h++]=a>>8&255),a>>16&&(A[h++]=a>>16&255))}var b;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var c;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(c||(c={}));var I;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(I||(I={}));const y=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l]),C=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,I.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),w=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.E,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,c.Q,I.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l])}),define(ke[81],Ie([1,0,28]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=void 0,e.$om=A,e.$pm=T;const h=new r.$Ec(1e4);function A(c){return b(c,"NFC",h)}const R=new r.$Ec(1e4);function T(c){return b(c,"NFD",R)}const O=/[^\u0000-\u0080]/;function b(c,I,y){if(!c)return c;const u=y.get(c);if(u)return u;let C;return O.test(c)?C=c.normalize(I):C=c,y.set(c,C),C}e.$qm=function(){const c=/[\u0300-\u036f]/g;return function(I){return T(I).replace(c,"")}}()}),define(ke[134],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=void 0,e.$Mm=r,e.rot=h,e.$Rm=O;function r(b,c,I){return Math.min(Math.max(b,c),I)}function h(b,c){return(c+b%c)%c}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Om=A;class R{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Pm=R;class T{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const I=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Qm=T;function O(b,c,I,y,u,C,w,a){const m=w-I,$=a-y,f=u-I,i=C-y,s=b-I,t=c-y,o=m*m+$*$,n=m*f+$*i,d=m*s+$*t,l=f*f+i*i,g=f*s+i*t,E=1/(o*l-n*n),S=(l*d-n*g)*E,D=(o*g-n*d)*E;return S>=0&&D>=0&&S+D<1}}),define(ke[180],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=R,e.$dd=u;class r{constructor(w,a,m){this.owner=w,this.debugNameSource=a,this.referenceFn=m}getDebugName(w){return R(w,this)}}e.$bd=r;const h=new Map,A=new WeakMap;function R(C,w){const a=A.get(C);if(a)return a;const m=T(C,w);if(m){let $=h.get(m)??0;$++,h.set(m,$);const f=$===1?m:`${m}#${$}`;return A.set(C,f),f}}function T(C,w){const a=A.get(C);if(a)return a;const m=w.owner?I(w.owner)+".":"";let $;const f=w.debugNameSource;if(f!==void 0)if(typeof f=="function"){if($=f(),$!==void 0)return m+$}else return m+f;const i=w.referenceFn;if(i!==void 0&&($=u(i),$!==void 0))return m+$;if(w.owner!==void 0){const s=O(w.owner,C);if(s!==void 0)return m+s}}function O(C,w){for(const a in C)if(C[a]===w)return a}const b=new Map,c=new WeakMap;function I(C){const w=c.get(C);if(w)return w;const a=y(C);let m=b.get(a)??0;m++,b.set(a,m);const $=m===1?a:`${a}#${m}`;return c.set(C,$),$}function y(C){const w=C.constructor;return w?w.name:"Object"}function u(C){const w=C.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(m?m[1]:void 0)?.trim()}}),define(ke[181],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Ld=h,e.$Md=A;let r;function h(a){r=a}function A(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(m){return T([O(C("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[O(" "),c(I(m.oldValue,70),{color:"red",strikeThrough:!0}),O(" "),c(I(m.newValue,60),{color:"green"})]:[O(" (unchanged)")]:[O(" "),c(I(m.newValue,60),{color:"green"}),O(" (initial)")]}handleObservableChanged(m,$){console.log(...this.b([b("observable value changed"),c(m.debugName,{color:"BlueViolet"}),...this.c($)]))}formatChanges(m){if(m.size!==0)return c(" (changed deps: "+[...m].map($=>$.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(f,i)=>(this.d.get(m).add(f),$.apply(m,[f,i]))}handleDerivedRecomputed(m,$){const f=this.d.get(m);console.log(...this.b([b("derived recomputed"),c(m.debugName,{color:"BlueViolet"}),...this.c($),this.formatChanges(f),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),f.clear()}handleFromEventObservableTriggered(m,$){console.log(...this.b([b("observable from event triggered"),c(m.debugName,{color:"BlueViolet"}),...this.c($),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(f,i)=>(this.d.get(m).add(f),$.apply(m,[f,i]))}handleAutorunTriggered(m){const $=this.d.get(m);console.log(...this.b([b("autorun"),c(m.debugName,{color:"BlueViolet"}),this.formatChanges($),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),$.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let $=m.getDebugName();$===void 0&&($=""),console.log(...this.b([b("transaction"),c($,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Nd=R;function T(a){const m=new Array,$=[];let f="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(f+=`%c${t.text}`,m.push(t.style),t.data&&$.push(...t.data)):"data"in t&&$.push(...t.data)}i(a);const s=[f,...m];return s.push(...$),s}function O(a){return c(a,{color:"black"})}function b(a){return c(w(`${a}: `,10),{color:"black",bold:!0})}function c(a,m={color:"black"}){function $(i){return Object.entries(i).reduce((s,[t,o])=>`${s}${t}:${o};`,"")}const f={color:m.color};return m.strikeThrough&&(f["text-decoration"]="line-through"),m.bold&&(f["font-weight"]="bold"),{text:a,style:$(f)}}function I(a,m){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=m?`"${a}"`:`"${a.substr(0,m-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?y(a,m):u(a,m);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function y(a,m){let $="[ ",f=!0;for(const i of a){if(f||($+=", "),$.length-5>m){$+="...";break}f=!1,$+=`${I(i,m-$.length)}`}return $+=" ]",$}function u(a,m){let $="{ ",f=!0;for(const[i,s]of Object.entries(a)){if(f||($+=", "),$.length-5>m){$+="...";break}f=!1,$+=`${i}: ${I(s,m-$.length)}`}return $+=" }",$}function C(a,m){let $="";for(let f=1;f<=m;f++)$+=a;return $}function w(a,m){for(;a.length<m;)a+=" ";return a}}),define(ke[182],Ie([1,0,175,180,181]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=e.$8d=e.$6d=e.$1d=e.$Zd=void 0,e.$Wd=T,e.$Xd=b,e.$Yd=I,e.$2d=C,e.$3d=a,e.$4d=m,e.$5d=$,e.$7d=i,e.$9d=t;let R;function T(n){R=n}let O;function b(n){O=n}let c;function I(n){c=n}class y{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,l){const g=l===void 0?void 0:d,E=l===void 0?d:l;return c({owner:g,debugName:()=>{const S=(0,h.$dd)(E);if(S!==void 0)return S;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(k)return`${this.debugName}.${k[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:E},S=>E(this.read(S),S))}flatten(){return c({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},d=>this.read(d).read(d))}recomputeInitiallyAndOnChange(d,l){return d.add(R(this,l)),this}keepObserved(d){return d.add(O(this)),this}get a(){return this.get()}}e.$Zd=y;class u extends y{constructor(){super(...arguments),this.b=new Set}addObserver(d){const l=this.b.size;this.b.add(d),l===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$1d=u;function C(n,d){const l=new f(n,d);try{n(l)}finally{l.finish()}}let w;function a(n){if(w)n(w);else{const d=new f(n,void 0);w=d;try{n(d)}finally{d.finish(),w=void 0}}}async function m(n,d){const l=new f(n,d);try{await n(l)}finally{l.finish()}}function $(n,d,l){n?d(n):C(d,l)}class f{constructor(d,l){this._fn=d,this.b=l,this.a=[],(0,A.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$dd)(this._fn)}updateObserver(d,l){this.a.push({observer:d,observable:l}),d.beginUpdate(l)}finish(){const d=this.a;for(let l=0;l<d.length;l++){const{observer:g,observable:E}=d[l];g.endUpdate(E)}this.a=null,(0,A.$Md)()?.handleEndTransaction()}}e.$6d=f;function i(n,d){let l;return typeof n=="string"?l=new h.$bd(void 0,n,void 0):l=new h.$bd(n,void 0,void 0),new s(l,d,r.$7c)}class s extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,l,g){super(),this.e=d,this.g=g,this.d=l}get(){return this.d}set(d,l,g){if(g===void 0&&this.g(this.d,d))return;let E;l||(l=E=new f(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(d),(0,A.$Md)()?.handleObservableChanged(this,{oldValue:S,newValue:d,change:g,didChange:!0,hadValue:!0});for(const D of this.b)l.updateObserver(D,this),D.handleChange(this,g)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$8d=s;function t(n,d){let l;return typeof n=="string"?l=new h.$bd(void 0,n,void 0):l=new h.$bd(n,void 0,void 0),new o(l,d,r.$7c)}class o extends s{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$0d=o}),function(){function $e(A){const R=[];typeof A=="number"&&R.push("code/timeOrigin",A);function T(b){R.push(b,Date.now())}function O(){const b=[];for(let c=0;c<R.length;c+=2)b.push({name:R[c],startTime:R[c+1]});return b}return{mark:T,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(A+T.startTime)});return R}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function r(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(ke[10],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=o,e.$E=S,e.$K=D,e.$h="en";let r=!1,h=!1,A=!1,R=!1,T=!1,O=!1,b=!1,c=!1,I=!1,y=!1,u,C=e.$h,w=e.$h,a,m;const $=globalThis;let f;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?f=$.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const i=typeof f?.versions?.electron=="string",s=i&&f?.type==="renderer";if(typeof f=="object"){r=f.platform==="win32",h=f.platform==="darwin",A=f.platform==="linux",R=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,b=i,I=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$h,C=e.$h;const k=f.env.VSCODE_NLS_CONFIG;if(k)try{const P=JSON.parse(k);u=P.userLocale,w=P.osLocale,C=P.resolvedLanguage||e.$h,a=P.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!s?(m=navigator.userAgent,r=m.indexOf("Windows")>=0,h=m.indexOf("Macintosh")>=0,c=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=m.indexOf("Linux")>=0,y=m?.indexOf("Mobi")>=0,O=!0,C=globalThis._VSCODE_NLS_LANGUAGE||e.$h,u=navigator.language.toLowerCase(),w=u):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(k){switch(k){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let n=t.Web;h?n=t.Mac:r?n=t.Windows:A&&(n=t.Linux),e.$j=r,e.$k=h,e.$l=A,e.$m=R,e.$n=T,e.$o=b,e.$p=O,e.$q=O&&typeof $.importScripts=="function",e.$r=e.$q?$.origin:void 0,e.$s=c,e.$t=y,e.$u=I,e.$v=n,e.$w=m,e.$x=C;var d;(function(k){function P(){return e.$x}k.value=P;function p(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}k.isDefaultVariant=p;function v(){return e.$x==="en"}k.isDefault=v})(d||(e.Language=d={})),e.$y=u,e.$z=w,e.$A=a,e.$B=typeof $.postMessage=="function"&&!$.importScripts,e.$C=(()=>{if(e.$B){const k=[];$.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let v=0,F=k.length;v<F;v++){const N=k[v];if(N.id===p.data.vscodeScheduleAsyncWork){k.splice(v,1),N.callback();return}}});let P=0;return p=>{const v=++P;k.push({id:v,callback:p}),$.postMessage({vscodeScheduleAsyncWork:v},"*")}}return k=>setTimeout(k)})();var l;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=h||c?l.Macintosh:r?l.Windows:l.Linux;let g=!0,E=!1;function S(){if(!E){E=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,g=new Uint16Array(k.buffer)[0]===513}return g}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function D(k){return parseFloat(k)>=20}}),define(ke[183],Ie([1,0,39]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=void 0;const h=Symbol("unset");class A{constructor(){this.a=new T,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}get entries(){return this.a.children?.entries()||r.Iterable.empty()}insert(b,c,I){this.d(b,y=>y._value=c,I)}mutate(b,c){this.d(b,I=>I._value=c(I._value===h?void 0:I._value))}mutatePath(b,c){this.d(b,()=>{},I=>c(I))}delete(b){const c=this.c(b);if(!c)return;let I=c.length-1;const y=c[I].node._value;if(y!==h){for(this.b--,c[I].node._value=h;I>0;I--){const{node:u,part:C}=c[I];if(u.children?.size||u._value!==h)break;c[I-1].node.children.delete(C)}return y}}*deleteRecursive(b){const c=this.c(b);if(!c)return;const I=c[c.length-1].node;for(let y=c.length-1;y>0;y--){const u=c[y-1];if(u.node.children.delete(c[y].part),u.node.children.size>0||u.node._value!==h)break}for(const y of R(I))y._value!==h&&(this.b--,yield y._value)}find(b){let c=this.a;for(const I of b){const y=c.children?.get(I);if(!y)return;c=y}return c._value===h?void 0:c._value}hasKeyOrParent(b){let c=this.a;for(const I of b){const y=c.children?.get(I);if(!y)return!1;if(y._value!==h)return!0;c=y}return!1}hasKeyOrChildren(b){let c=this.a;for(const I of b){const y=c.children?.get(I);if(!y)return!1;c=y}return!0}hasKey(b){let c=this.a;for(const I of b){const y=c.children?.get(I);if(!y)return!1;c=y}return c._value!==h}c(b){const c=[{part:"",node:this.a}];let I=0;for(const y of b){const u=c[I].node.children?.get(y);if(!u)return;c.push({part:y,node:u}),I++}return c}d(b,c,I){let y=this.a;for(const w of b){if(y.children)if(y.children.has(w))y=y.children.get(w);else{const a=new T;y.children.set(w,a),y=a}else{const a=new T;y.children=new Map([[w,a]]),y=a}I?.(y)}const u=y._value===h?0:1;c(y);const C=y._value===h?0:1;this.b+=C-u}*values(){for(const{_value:b}of R(this.a))b!==h&&(yield b)}}e.$0I=A;function*R(O){const b=[O];for(;b.length>0;){const c=b.pop();if(yield c,c.children)for(const I of c.children.values())b.push(I)}}class T{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value(b){this._value=b===void 0?h:b}}}),define(ke[55],Ie([1,0,10]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let h;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const R=A.process;h={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$j?"win32":r.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$ec=h.platform,e.$fc=h.arch}),define(ke[16],Ie([1,0,55]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,r=We(r);const h=65,A=97,R=90,T=122,O=46,b=47,c=92,I=58,y=63;class u extends Error{constructor(d,l,g){let E;typeof l=="string"&&l.indexOf("not ")===0?(E="must not be",l=l.replace(/^not /,"")):E="must be";const S=d.indexOf(".")!==-1?"property":"argument";let D=`The "${d}" ${S} ${E} of type ${l}`;D+=`. Received type ${typeof g}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function C(n,d){if(n===null||typeof n!="object")throw new u(d,"Object",n)}function w(n,d){if(typeof n!="string")throw new u(d,"string",n)}const a=r.$ec==="win32";function m(n){return n===b||n===c}function $(n){return n===b}function f(n){return n>=h&&n<=R||n>=A&&n<=T}function i(n,d,l,g){let E="",S=0,D=-1,k=0,P=0;for(let p=0;p<=n.length;++p){if(p<n.length)P=n.charCodeAt(p);else{if(g(P))break;P=b}if(g(P)){if(!(D===p-1||k===1))if(k===2){if(E.length<2||S!==2||E.charCodeAt(E.length-1)!==O||E.charCodeAt(E.length-2)!==O){if(E.length>2){const v=E.lastIndexOf(l);v===-1?(E="",S=0):(E=E.slice(0,v),S=E.length-1-E.lastIndexOf(l)),D=p,k=0;continue}else if(E.length!==0){E="",S=0,D=p,k=0;continue}}d&&(E+=E.length>0?`${l}..`:"..",S=2)}else E.length>0?E+=`${l}${n.slice(D+1,p)}`:E=n.slice(D+1,p),S=p-D-1;D=p,k=0}else P===O&&k!==-1?++k:k=-1}return E}function s(n){return n?`${n[0]==="."?"":"."}${n}`:""}function t(n,d){C(d,"pathObject");const l=d.dir||d.root,g=d.base||`${d.name||""}${s(d.ext)}`;return l?l===d.root?`${l}${g}`:`${l}${n}${g}`:g}e.$gc={resolve(...n){let d="",l="",g=!1;for(let E=n.length-1;E>=-1;E--){let S;if(E>=0){if(S=n[E],w(S,`paths[${E}]`),S.length===0)continue}else d.length===0?S=r.cwd():(S=r.env[`=${d}`]||r.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==d.toLowerCase()&&S.charCodeAt(2)===c)&&(S=`${d}\\`));const D=S.length;let k=0,P="",p=!1;const v=S.charCodeAt(0);if(D===1)m(v)&&(k=1,p=!0);else if(m(v))if(p=!0,m(S.charCodeAt(1))){let F=2,N=F;for(;F<D&&!m(S.charCodeAt(F));)F++;if(F<D&&F!==N){const L=S.slice(N,F);for(N=F;F<D&&m(S.charCodeAt(F));)F++;if(F<D&&F!==N){for(N=F;F<D&&!m(S.charCodeAt(F));)F++;(F===D||F!==N)&&(P=`\\\\${L}\\${S.slice(N,F)}`,k=F)}}}else k=1;else f(v)&&S.charCodeAt(1)===I&&(P=S.slice(0,2),k=2,D>2&&m(S.charCodeAt(2))&&(p=!0,k=3));if(P.length>0)if(d.length>0){if(P.toLowerCase()!==d.toLowerCase())continue}else d=P;if(g){if(d.length>0)break}else if(l=`${S.slice(k)}\\${l}`,g=p,p&&d.length>0)break}return l=i(l,!g,"\\",m),g?`${d}\\${l}`:`${d}${l}`||"."},normalize(n){w(n,"path");const d=n.length;if(d===0)return".";let l=0,g,E=!1;const S=n.charCodeAt(0);if(d===1)return $(S)?"\\":n;if(m(S))if(E=!0,m(n.charCodeAt(1))){let k=2,P=k;for(;k<d&&!m(n.charCodeAt(k));)k++;if(k<d&&k!==P){const p=n.slice(P,k);for(P=k;k<d&&m(n.charCodeAt(k));)k++;if(k<d&&k!==P){for(P=k;k<d&&!m(n.charCodeAt(k));)k++;if(k===d)return`\\\\${p}\\${n.slice(P)}\\`;k!==P&&(g=`\\\\${p}\\${n.slice(P,k)}`,l=k)}}}else l=1;else f(S)&&n.charCodeAt(1)===I&&(g=n.slice(0,2),l=2,d>2&&m(n.charCodeAt(2))&&(E=!0,l=3));let D=l<d?i(n.slice(l),!E,"\\",m):"";return D.length===0&&!E&&(D="."),D.length>0&&m(n.charCodeAt(d-1))&&(D+="\\"),g===void 0?E?`\\${D}`:D:E?`${g}\\${D}`:`${g}${D}`},isAbsolute(n){w(n,"path");const d=n.length;if(d===0)return!1;const l=n.charCodeAt(0);return m(l)||d>2&&f(l)&&n.charCodeAt(1)===I&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let d,l;for(let S=0;S<n.length;++S){const D=n[S];w(D,"path"),D.length>0&&(d===void 0?d=l=D:d+=`\\${D}`)}if(d===void 0)return".";let g=!0,E=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++E;const S=l.length;S>1&&m(l.charCodeAt(1))&&(++E,S>2&&(m(l.charCodeAt(2))?++E:g=!1))}if(g){for(;E<d.length&&m(d.charCodeAt(E));)E++;E>=2&&(d=`\\${d.slice(E)}`)}return e.$gc.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d)return"";const l=e.$gc.resolve(n),g=e.$gc.resolve(d);if(l===g||(n=l.toLowerCase(),d=g.toLowerCase(),n===d))return"";let E=0;for(;E<n.length&&n.charCodeAt(E)===c;)E++;let S=n.length;for(;S-1>E&&n.charCodeAt(S-1)===c;)S--;const D=S-E;let k=0;for(;k<d.length&&d.charCodeAt(k)===c;)k++;let P=d.length;for(;P-1>k&&d.charCodeAt(P-1)===c;)P--;const p=P-k,v=D<p?D:p;let F=-1,N=0;for(;N<v;N++){const M=n.charCodeAt(E+N);if(M!==d.charCodeAt(k+N))break;M===c&&(F=N)}if(N!==v){if(F===-1)return g}else{if(p>v){if(d.charCodeAt(k+N)===c)return g.slice(k+N+1);if(N===2)return g.slice(k+N)}D>v&&(n.charCodeAt(E+N)===c?F=N:N===2&&(F=3)),F===-1&&(F=0)}let L="";for(N=E+F+1;N<=S;++N)(N===S||n.charCodeAt(N)===c)&&(L+=L.length===0?"..":"\\..");return k+=F,L.length>0?`${L}${g.slice(k,P)}`:(g.charCodeAt(k)===c&&++k,g.slice(k,P))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const d=e.$gc.resolve(n);if(d.length<=2)return n;if(d.charCodeAt(0)===c){if(d.charCodeAt(1)===c){const l=d.charCodeAt(2);if(l!==y&&l!==O)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(f(d.charCodeAt(0))&&d.charCodeAt(1)===I&&d.charCodeAt(2)===c)return`\\\\?\\${d}`;return n},dirname(n){w(n,"path");const d=n.length;if(d===0)return".";let l=-1,g=0;const E=n.charCodeAt(0);if(d===1)return m(E)?n:".";if(m(E)){if(l=g=1,m(n.charCodeAt(1))){let k=2,P=k;for(;k<d&&!m(n.charCodeAt(k));)k++;if(k<d&&k!==P){for(P=k;k<d&&m(n.charCodeAt(k));)k++;if(k<d&&k!==P){for(P=k;k<d&&!m(n.charCodeAt(k));)k++;if(k===d)return n;k!==P&&(l=g=k+1)}}}}else f(E)&&n.charCodeAt(1)===I&&(l=d>2&&m(n.charCodeAt(2))?3:2,g=l);let S=-1,D=!0;for(let k=d-1;k>=g;--k)if(m(n.charCodeAt(k))){if(!D){S=k;break}}else D=!1;if(S===-1){if(l===-1)return".";S=l}return n.slice(0,S)},basename(n,d){d!==void 0&&w(d,"suffix"),w(n,"path");let l=0,g=-1,E=!0,S;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===I&&(l=2),d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let D=d.length-1,k=-1;for(S=n.length-1;S>=l;--S){const P=n.charCodeAt(S);if(m(P)){if(!E){l=S+1;break}}else k===-1&&(E=!1,k=S+1),D>=0&&(P===d.charCodeAt(D)?--D===-1&&(g=S):(D=-1,g=k))}return l===g?g=k:g===-1&&(g=n.length),n.slice(l,g)}for(S=n.length-1;S>=l;--S)if(m(n.charCodeAt(S))){if(!E){l=S+1;break}}else g===-1&&(E=!1,g=S+1);return g===-1?"":n.slice(l,g)},extname(n){w(n,"path");let d=0,l=-1,g=0,E=-1,S=!0,D=0;n.length>=2&&n.charCodeAt(1)===I&&f(n.charCodeAt(0))&&(d=g=2);for(let k=n.length-1;k>=d;--k){const P=n.charCodeAt(k);if(m(P)){if(!S){g=k+1;break}continue}E===-1&&(S=!1,E=k+1),P===O?l===-1?l=k:D!==1&&(D=1):l!==-1&&(D=-1)}return l===-1||E===-1||D===0||D===1&&l===E-1&&l===g+1?"":n.slice(l,E)},format:t.bind(null,"\\"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.length;let g=0,E=n.charCodeAt(0);if(l===1)return m(E)?(d.root=d.dir=n,d):(d.base=d.name=n,d);if(m(E)){if(g=1,m(n.charCodeAt(1))){let F=2,N=F;for(;F<l&&!m(n.charCodeAt(F));)F++;if(F<l&&F!==N){for(N=F;F<l&&m(n.charCodeAt(F));)F++;if(F<l&&F!==N){for(N=F;F<l&&!m(n.charCodeAt(F));)F++;F===l?g=F:F!==N&&(g=F+1)}}}}else if(f(E)&&n.charCodeAt(1)===I){if(l<=2)return d.root=d.dir=n,d;if(g=2,m(n.charCodeAt(2))){if(l===3)return d.root=d.dir=n,d;g=3}}g>0&&(d.root=n.slice(0,g));let S=-1,D=g,k=-1,P=!0,p=n.length-1,v=0;for(;p>=g;--p){if(E=n.charCodeAt(p),m(E)){if(!P){D=p+1;break}continue}k===-1&&(P=!1,k=p+1),E===O?S===-1?S=p:v!==1&&(v=1):S!==-1&&(v=-1)}return k!==-1&&(S===-1||v===0||v===1&&S===k-1&&S===D+1?d.base=d.name=n.slice(D,k):(d.name=n.slice(D,S),d.base=n.slice(D,k),d.ext=n.slice(S,k))),D>0&&D!==g?d.dir=n.slice(0,D-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(a){const n=/\\/g;return()=>{const d=r.cwd().replace(n,"/");return d.slice(d.indexOf("/"))}}return()=>r.cwd()})();e.$hc={resolve(...n){let d="",l=!1;for(let g=n.length-1;g>=-1&&!l;g--){const E=g>=0?n[g]:o();w(E,`paths[${g}]`),E.length!==0&&(d=`${E}/${d}`,l=E.charCodeAt(0)===b)}return d=i(d,!l,"/",$),l?`/${d}`:d.length>0?d:"."},normalize(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===b,l=n.charCodeAt(n.length-1)===b;return n=i(n,!d,"/",$),n.length===0?d?"/":l?"./":".":(l&&(n+="/"),d?`/${n}`:n)},isAbsolute(n){return w(n,"path"),n.length>0&&n.charCodeAt(0)===b},join(...n){if(n.length===0)return".";let d;for(let l=0;l<n.length;++l){const g=n[l];w(g,"path"),g.length>0&&(d===void 0?d=g:d+=`/${g}`)}return d===void 0?".":e.$hc.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d||(n=e.$hc.resolve(n),d=e.$hc.resolve(d),n===d))return"";const l=1,g=n.length,E=g-l,S=1,D=d.length-S,k=E<D?E:D;let P=-1,p=0;for(;p<k;p++){const F=n.charCodeAt(l+p);if(F!==d.charCodeAt(S+p))break;F===b&&(P=p)}if(p===k)if(D>k){if(d.charCodeAt(S+p)===b)return d.slice(S+p+1);if(p===0)return d.slice(S+p)}else E>k&&(n.charCodeAt(l+p)===b?P=p:p===0&&(P=0));let v="";for(p=l+P+1;p<=g;++p)(p===g||n.charCodeAt(p)===b)&&(v+=v.length===0?"..":"/..");return`${v}${d.slice(S+P)}`},toNamespacedPath(n){return n},dirname(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===b;let l=-1,g=!0;for(let E=n.length-1;E>=1;--E)if(n.charCodeAt(E)===b){if(!g){l=E;break}}else g=!1;return l===-1?d?"/":".":d&&l===1?"//":n.slice(0,l)},basename(n,d){d!==void 0&&w(d,"ext"),w(n,"path");let l=0,g=-1,E=!0,S;if(d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let D=d.length-1,k=-1;for(S=n.length-1;S>=0;--S){const P=n.charCodeAt(S);if(P===b){if(!E){l=S+1;break}}else k===-1&&(E=!1,k=S+1),D>=0&&(P===d.charCodeAt(D)?--D===-1&&(g=S):(D=-1,g=k))}return l===g?g=k:g===-1&&(g=n.length),n.slice(l,g)}for(S=n.length-1;S>=0;--S)if(n.charCodeAt(S)===b){if(!E){l=S+1;break}}else g===-1&&(E=!1,g=S+1);return g===-1?"":n.slice(l,g)},extname(n){w(n,"path");let d=-1,l=0,g=-1,E=!0,S=0;for(let D=n.length-1;D>=0;--D){const k=n.charCodeAt(D);if(k===b){if(!E){l=D+1;break}continue}g===-1&&(E=!1,g=D+1),k===O?d===-1?d=D:S!==1&&(S=1):d!==-1&&(S=-1)}return d===-1||g===-1||S===0||S===1&&d===g-1&&d===l+1?"":n.slice(d,g)},format:t.bind(null,"/"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.charCodeAt(0)===b;let g;l?(d.root="/",g=1):g=0;let E=-1,S=0,D=-1,k=!0,P=n.length-1,p=0;for(;P>=g;--P){const v=n.charCodeAt(P);if(v===b){if(!k){S=P+1;break}continue}D===-1&&(k=!1,D=P+1),v===O?E===-1?E=P:p!==1&&(p=1):E!==-1&&(p=-1)}if(D!==-1){const v=S===0&&l?1:S;E===-1||p===0||p===1&&E===D-1&&E===S+1?d.base=d.name=n.slice(v,D):(d.name=n.slice(v,E),d.base=n.slice(v,D),d.ext=n.slice(E,D))}return S>0?d.dir=n.slice(0,S-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(ke[135],Ie([1,0,50,16]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=O,e.$Cr=b,e.$Dr=c,e.$Er=I,e.$Fr=y,e.$Gr=u,e.$Hr=C,e.$Ir=w,e.$Jr=a,e.$Kr=m,e.$Lr=g,e.$Mr=E,e.$Nr=S;const A=new r.$U(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new r.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new r.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(D,k,P=!1){const p=D||"",v=k||"",F=A.value.collator.compare(p,v);return A.value.collatorIsNumeric&&F===0&&p!==v?p<v?-1:1:F}function b(D,k){const P=R.value.collator;return D=D||"",k=k||"",s(P,D,k)}function c(D,k){const P=R.value.collator;return D=D||"",k=k||"",d(D,k)||s(P,D,k)}function I(D,k){const P=R.value.collator;return D=D||"",k=k||"",n(D,k)||s(P,D,k)}function y(D,k){return D=D||"",k=k||"",D===k?0:D<k?-1:1}function u(D,k){const[P,p]=f(D),[v,F]=f(k);let N=A.value.collator.compare(p,F);if(N===0){if(A.value.collatorIsNumeric&&p!==F)return p<F?-1:1;if(N=A.value.collator.compare(P,v),A.value.collatorIsNumeric&&N===0&&P!==v)return P<v?-1:1}return N}function C(D,k){D=D||"",k=k||"";const P=i(D),p=i(k),v=R.value.collator,F=T.value.collator;return s(F,P,p)||s(v,D,k)}function w(D,k){D=D||"",k=k||"";const P=i(D),p=i(k),v=R.value.collator,F=T.value.collator;return s(F,P,p)||d(D,k)||s(v,D,k)}function a(D,k){D=D||"",k=k||"";const P=i(D),p=i(k),v=R.value.collator,F=T.value.collator;return s(F,P,p)||n(D,k)||s(v,D,k)}function m(D,k){D=D||"",k=k||"";const P=i(D).toLowerCase(),p=i(k).toLowerCase();return P!==p?P<p?-1:1:D!==k?D<k?-1:1:0}const $=/^(.*?)(\.([^.]*))?$/;function f(D,k=!1){const P=D?$.exec(D):[];let p=[P&&P[1]||"",P&&P[3]||""];return k&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function i(D){const k=D?$.exec(D):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function s(D,k,P){const p=D.compare(k,P);return p!==0?p:k.length!==P.length?k.length<P.length?-1:1:0}function t(D){const k=D.charAt(0);return k.toLocaleUpperCase()!==k}function o(D){const k=D.charAt(0);return k.toLocaleLowerCase()!==k}function n(D,k){return t(D)&&o(k)?-1:o(D)&&t(k)?1:0}function d(D,k){return o(D)&&t(k)?-1:t(D)&&o(k)?1:0}function l(D,k,P=!1){return P||(D=D&&D.toLowerCase(),k=k&&k.toLowerCase()),D===k?0:D<k?-1:1}function g(D,k,P=!1){const p=D.split(h.sep),v=k.split(h.sep),F=p.length-1,N=v.length-1;let L,M;for(let z=0;;z++){if(L=F===z,M=N===z,L&&M)return O(p[z],v[z],P);if(L)return-1;if(M)return 1;const j=l(p[z],v[z],P);if(j!==0)return j}}function E(D,k,P){const p=D.toLowerCase(),v=k.toLowerCase(),F=S(D,k,P);if(F)return F;const N=p.endsWith(P),L=v.endsWith(P);if(N!==L)return N?-1:1;const M=O(p,v);return M!==0?M:p.localeCompare(v)}function S(D,k,P){const p=D.toLowerCase(),v=k.toLowerCase(),F=p.startsWith(P),N=v.startsWith(P);if(F!==N)return F?-1:1;if(F&&N){if(p.length<v.length)return-1;if(p.length>v.length)return 1}return 0}}),define(ke[103],Ie([1,0,16]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=void 0,e.$at=R,e.$bt=T,e.$ct=O,e.$dt=c,e.$_s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(I){const y=(0,r.$pc)(I),u=h[y.toLowerCase()];return u!==void 0?u:T(I)}function T(I){const y=(0,r.$pc)(I);return A[y.toLowerCase()]}function O(I){for(const y in A)if(A[y]===I)return y}const b=/^(.+)\/(.+?)(;.+)?$/;function c(I,y){const u=b.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:I}}),define(ke[104],Ie([1,0,10]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=R,e.$nm=T;var h;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(h||(e.Source=h={}));var A;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function R(O,...b){const c=b.reduce((u,C)=>(u[C]=!0,u),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(u=>!c[u]).forEach(u=>{for(let C=0;C<I.length;C++)if(u.search(I[C])!==-1){delete O[u];break}})}function T(O){O&&(delete O.DEBUG,r.$l&&delete O.LD_PRELOAD)}}),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:$e)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function r(h){if(e[h])return e[h].exports;var A=e[h]={i:h,l:!1,exports:{}};return $e[h].call(A.exports,A,A.exports,r),A.l=!0,A.exports}return r.m=$e,r.c=e,r.d=function(h,A,R){r.o(h,A)||Object.defineProperty(h,A,{enumerable:!0,get:R})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,A){if(1&A&&(h=r(h)),8&A||4&A&&typeof h=="object"&&h&&h.__esModule)return h;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:h}),2&A&&typeof h!="string")for(var T in h)r.d(R,T,function(O){return h[O]}.bind(null,T));return R},r.n=function(h){var A=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(A,"a",A),A},r.o=function(h,A){return Object.prototype.hasOwnProperty.call(h,A)},r.p="",r(r.s=0)}([function($e,e,r){(function(h){var A;e=$e.exports=ye,A=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var G=Array.prototype.slice.call(arguments,0);G.unshift("SEMVER"),console.log.apply(console,G)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],b=e.src=[],c=0,I=c++;b[I]="0|[1-9]\\d*";var y=c++;b[y]="[0-9]+";var u=c++;b[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=c++;b[C]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var w=c++;b[w]="("+b[y]+")\\.("+b[y]+")\\.("+b[y]+")";var a=c++;b[a]="(?:"+b[I]+"|"+b[u]+")";var m=c++;b[m]="(?:"+b[y]+"|"+b[u]+")";var $=c++;b[$]="(?:-("+b[a]+"(?:\\."+b[a]+")*))";var f=c++;b[f]="(?:-?("+b[m]+"(?:\\."+b[m]+")*))";var i=c++;b[i]="[0-9A-Za-z-]+";var s=c++;b[s]="(?:\\+("+b[i]+"(?:\\."+b[i]+")*))";var t=c++,o="v?"+b[C]+b[$]+"?"+b[s]+"?";b[t]="^"+o+"$";var n="[v=\\s]*"+b[w]+b[f]+"?"+b[s]+"?",d=c++;b[d]="^"+n+"$";var l=c++;b[l]="((?:<|>)?=?)";var g=c++;b[g]=b[y]+"|x|X|\\*";var E=c++;b[E]=b[I]+"|x|X|\\*";var S=c++;b[S]="[v=\\s]*("+b[E]+")(?:\\.("+b[E]+")(?:\\.("+b[E]+")(?:"+b[$]+")?"+b[s]+"?)?)?";var D=c++;b[D]="[v=\\s]*("+b[g]+")(?:\\.("+b[g]+")(?:\\.("+b[g]+")(?:"+b[f]+")?"+b[s]+"?)?)?";var k=c++;b[k]="^"+b[l]+"\\s*"+b[S]+"$";var P=c++;b[P]="^"+b[l]+"\\s*"+b[D]+"$";var p=c++;b[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=c++;b[v]="(?:~>?)";var F=c++;b[F]="(\\s*)"+b[v]+"\\s+",O[F]=new RegExp(b[F],"g");var N=c++;b[N]="^"+b[v]+b[S]+"$";var L=c++;b[L]="^"+b[v]+b[D]+"$";var M=c++;b[M]="(?:\\^)";var z=c++;b[z]="(\\s*)"+b[M]+"\\s+",O[z]=new RegExp(b[z],"g");var j=c++;b[j]="^"+b[M]+b[S]+"$";var q=c++;b[q]="^"+b[M]+b[D]+"$";var B=c++;b[B]="^"+b[l]+"\\s*("+n+")$|^$";var ee=c++;b[ee]="^"+b[l]+"\\s*("+o+")$|^$";var H=c++;b[H]="(\\s*)"+b[l]+"\\s*("+n+"|"+b[S]+")",O[H]=new RegExp(b[H],"g");var W=c++;b[W]="^\\s*("+b[S]+")\\s+-\\s+("+b[S]+")\\s*$";var X=c++;b[X]="^\\s*("+b[D]+")\\s+-\\s+("+b[D]+")\\s*$";var _=c++;b[_]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)A(ce,b[ce]),O[ce]||(O[ce]=new RegExp(b[ce]));function ne(G,J){if(G instanceof ye)return G;if(typeof G!="string"||G.length>R||!(J?O[d]:O[t]).test(G))return null;try{return new ye(G,J)}catch{return null}}function ye(G,J){if(G instanceof ye){if(G.loose===J)return G;G=G.version}else if(typeof G!="string")throw new TypeError("Invalid Version: "+G);if(G.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ye))return new ye(G,J);A("SemVer",G,J),this.loose=J;var x=G.trim().match(J?O[d]:O[t]);if(!x)throw new TypeError("Invalid Version: "+G);if(this.raw=G,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var Ee=+de;if(Ee>=0&&Ee<T)return Ee}return de}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=ne,e.valid=function(G,J){var x=ne(G,J);return x?x.version:null},e.clean=function(G,J){var x=ne(G.trim().replace(/^[=v]+/,""),J);return x?x.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(G){return A("SemVer.compare",this.version,this.loose,G),G instanceof ye||(G=new ye(G,this.loose)),this.compareMain(G)||this.comparePre(G)},ye.prototype.compareMain=function(G){return G instanceof ye||(G=new ye(G,this.loose)),Y(this.major,G.major)||Y(this.minor,G.minor)||Y(this.patch,G.patch)},ye.prototype.comparePre=function(G){if(G instanceof ye||(G=new ye(G,this.loose)),this.prerelease.length&&!G.prerelease.length)return-1;if(!this.prerelease.length&&G.prerelease.length)return 1;if(!this.prerelease.length&&!G.prerelease.length)return 0;var J=0;do{var x=this.prerelease[J],de=G.prerelease[J];if(A("prerelease compare",J,x,de),x===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(x===void 0)return-1;if(x!==de)return Y(x,de)}while(++J)},ye.prototype.inc=function(G,J){switch(G){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+G)}return this.format(),this.raw=this.version,this},e.inc=function(G,J,x,de){typeof x=="string"&&(de=x,x=void 0);try{return new ye(G,x).inc(J,de).version}catch{return null}},e.diff=function(G,J){if(te(G,J))return null;var x=ne(G),de=ne(J);if(x.prerelease.length||de.prerelease.length){for(var Ee in x)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&x[Ee]!==de[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in x)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&x[Ee]!==de[Ee])return Ee},e.compareIdentifiers=Y;var ge=/^[0-9]+$/;function Y(G,J){var x=ge.test(G),de=ge.test(J);return x&&de&&(G=+G,J=+J),x&&!de?-1:de&&!x?1:G<J?-1:G>J?1:0}function U(G,J,x){return new ye(G,x).compare(new ye(J,x))}function oe(G,J,x){return U(G,J,x)>0}function ve(G,J,x){return U(G,J,x)<0}function te(G,J,x){return U(G,J,x)===0}function ae(G,J,x){return U(G,J,x)!==0}function se(G,J,x){return U(G,J,x)>=0}function Z(G,J,x){return U(G,J,x)<=0}function re(G,J,x,de){var Ee;switch(J){case"===":typeof G=="object"&&(G=G.version),typeof x=="object"&&(x=x.version),Ee=G===x;break;case"!==":typeof G=="object"&&(G=G.version),typeof x=="object"&&(x=x.version),Ee=G!==x;break;case"":case"=":case"==":Ee=te(G,x,de);break;case"!=":Ee=ae(G,x,de);break;case">":Ee=oe(G,x,de);break;case">=":Ee=se(G,x,de);break;case"<":Ee=ve(G,x,de);break;case"<=":Ee=Z(G,x,de);break;default:throw new TypeError("Invalid operator: "+J)}return Ee}function pe(G,J){if(G instanceof pe){if(G.loose===J)return G;G=G.value}if(!(this instanceof pe))return new pe(G,J);A("comparator",G,J),this.loose=J,this.parse(G),this.semver===we?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(G,J){return Y(J,G)},e.major=function(G,J){return new ye(G,J).major},e.minor=function(G,J){return new ye(G,J).minor},e.patch=function(G,J){return new ye(G,J).patch},e.compare=U,e.compareLoose=function(G,J){return U(G,J,!0)},e.rcompare=function(G,J,x){return U(J,G,x)},e.sort=function(G,J){return G.sort(function(x,de){return e.compare(x,de,J)})},e.rsort=function(G,J){return G.sort(function(x,de){return e.rcompare(x,de,J)})},e.gt=oe,e.lt=ve,e.eq=te,e.neq=ae,e.gte=se,e.lte=Z,e.cmp=re,e.Comparator=pe;var we={};function Fe(G,J){if(G instanceof Fe)return G.loose===J?G:new Fe(G.raw,J);if(G instanceof pe)return new Fe(G.value,J);if(!(this instanceof Fe))return new Fe(G,J);if(this.loose=J,this.raw=G,this.set=G.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+G);this.format()}function ze(G){return!G||G.toLowerCase()==="x"||G==="*"}function Re(G,J,x,de,Ee,Le,He,Ke,et,nt,st,rt,at){return((J=ze(x)?"":ze(de)?">="+x+".0.0":ze(Ee)?">="+x+"."+de+".0":">="+J)+" "+(Ke=ze(et)?"":ze(nt)?"<"+(+et+1)+".0.0":ze(st)?"<"+et+"."+(+nt+1)+".0":rt?"<="+et+"."+nt+"."+st+"-"+rt:"<="+Ke)).trim()}function De(G,J){for(var x=0;x<G.length;x++)if(!G[x].test(J))return!1;if(J.prerelease.length){for(x=0;x<G.length;x++)if(A(G[x].semver),G[x].semver!==we&&G[x].semver.prerelease.length>0){var de=G[x].semver;if(de.major===J.major&&de.minor===J.minor&&de.patch===J.patch)return!0}return!1}return!0}function Ce(G,J,x){try{J=new Fe(J,x)}catch{return!1}return J.test(G)}function V(G,J,x,de){var Ee,Le,He,Ke,et;switch(G=new ye(G,de),J=new Fe(J,de),x){case">":Ee=oe,Le=Z,He=ve,Ke=">",et=">=";break;case"<":Ee=ve,Le=se,He=oe,Ke="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(G,J,de))return!1;for(var nt=0;nt<J.set.length;++nt){var st=J.set[nt],rt=null,at=null;if(st.forEach(function(gt){gt.semver===we&&(gt=new pe(">=0.0.0")),rt=rt||gt,at=at||gt,Ee(gt.semver,rt.semver,de)?rt=gt:He(gt.semver,at.semver,de)&&(at=gt)}),rt.operator===Ke||rt.operator===et||(!at.operator||at.operator===Ke)&&Le(G,at.semver)||at.operator===et&&He(G,at.semver))return!1}return!0}pe.prototype.parse=function(G){var J=this.loose?O[B]:O[ee],x=G.match(J);if(!x)throw new TypeError("Invalid comparator: "+G);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new ye(x[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(G){return A("Comparator.test",G,this.loose),this.semver===we||(typeof G=="string"&&(G=new ye(G,this.loose)),re(G,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(G,J){if(!(G instanceof pe))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Fe(G.value,J),Ce(this.value,x,J);if(G.operator==="")return x=new Fe(this.value,J),Ce(G.semver,x,J);var de=!(this.operator!==">="&&this.operator!==">"||G.operator!==">="&&G.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||G.operator!=="<="&&G.operator!=="<"),Le=this.semver.version===G.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||G.operator!==">="&&G.operator!=="<="),Ke=re(this.semver,"<",G.semver,J)&&(this.operator===">="||this.operator===">")&&(G.operator==="<="||G.operator==="<"),et=re(this.semver,">",G.semver,J)&&(this.operator==="<="||this.operator==="<")&&(G.operator===">="||G.operator===">");return de||Ee||Le&&He||Ke||et},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(G){return G.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(G){var J=this.loose;G=G.trim(),A("range",G,J);var x=J?O[X]:O[W];G=G.replace(x,Re),A("hyphen replace",G),G=G.replace(O[H],"$1$2$3"),A("comparator trim",G,O[H]),G=(G=(G=G.replace(O[F],"$1~")).replace(O[z],"$1^")).split(/\s+/).join(" ");var de=J?O[B]:O[ee],Ee=G.split(" ").map(function(Le){return function(He,Ke){return A("comp",He),He=function(et,nt){return et.trim().split(/\s+/).map(function(st){return function(rt,at){A("caret",rt,at);var gt=at?O[q]:O[j];return rt.replace(gt,function(dt,ct,Pe,Be,Qe){var Ne;return A("caret",rt,dt,ct,Pe,Be,Qe),ze(ct)?Ne="":ze(Pe)?Ne=">="+ct+".0.0 <"+(+ct+1)+".0.0":ze(Be)?Ne=ct==="0"?">="+ct+"."+Pe+".0 <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+".0 <"+(+ct+1)+".0.0":Qe?(A("replaceCaret pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),Ne=ct==="0"?Pe==="0"?">="+ct+"."+Pe+"."+Be+Qe+" <"+ct+"."+Pe+"."+(+Be+1):">="+ct+"."+Pe+"."+Be+Qe+" <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+"."+Be+Qe+" <"+(+ct+1)+".0.0"):(A("no pr"),Ne=ct==="0"?Pe==="0"?">="+ct+"."+Pe+"."+Be+" <"+ct+"."+Pe+"."+(+Be+1):">="+ct+"."+Pe+"."+Be+" <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+"."+Be+" <"+(+ct+1)+".0.0"),A("caret return",Ne),Ne})}(st,nt)}).join(" ")}(He,Ke),A("caret",He),He=function(et,nt){return et.trim().split(/\s+/).map(function(st){return function(rt,at){var gt=at?O[L]:O[N];return rt.replace(gt,function(dt,ct,Pe,Be,Qe){var Ne;return A("tilde",rt,dt,ct,Pe,Be,Qe),ze(ct)?Ne="":ze(Pe)?Ne=">="+ct+".0.0 <"+(+ct+1)+".0.0":ze(Be)?Ne=">="+ct+"."+Pe+".0 <"+ct+"."+(+Pe+1)+".0":Qe?(A("replaceTilde pr",Qe),Qe.charAt(0)!=="-"&&(Qe="-"+Qe),Ne=">="+ct+"."+Pe+"."+Be+Qe+" <"+ct+"."+(+Pe+1)+".0"):Ne=">="+ct+"."+Pe+"."+Be+" <"+ct+"."+(+Pe+1)+".0",A("tilde return",Ne),Ne})}(st,nt)}).join(" ")}(He,Ke),A("tildes",He),He=function(et,nt){return A("replaceXRanges",et,nt),et.split(/\s+/).map(function(st){return function(rt,at){rt=rt.trim();var gt=at?O[P]:O[k];return rt.replace(gt,function(dt,ct,Pe,Be,Qe,Ne){A("xRange",rt,dt,ct,Pe,Be,Qe,Ne);var je=ze(Pe),ue=je||ze(Be),he=ue||ze(Qe);return ct==="="&&he&&(ct=""),je?dt=ct===">"||ct==="<"?"<0.0.0":"*":ct&&he?(ue&&(Be=0),he&&(Qe=0),ct===">"?(ct=">=",ue?(Pe=+Pe+1,Be=0,Qe=0):he&&(Be=+Be+1,Qe=0)):ct==="<="&&(ct="<",ue?Pe=+Pe+1:Be=+Be+1),dt=ct+Pe+"."+Be+"."+Qe):ue?dt=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":he&&(dt=">="+Pe+"."+Be+".0 <"+Pe+"."+(+Be+1)+".0"),A("xRange return",dt),dt})}(st,nt)}).join(" ")}(He,Ke),A("xrange",He),He=function(et,nt){return A("replaceStars",et,nt),et.trim().replace(O[_],"")}(He,Ke),A("stars",He),He}(Le,J)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Le){return!!Le.match(de)})),Ee=Ee.map(function(Le){return new pe(Le,J)})},Fe.prototype.intersects=function(G,J){if(!(G instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(de){return G.set.some(function(Ee){return Ee.every(function(Le){return de.intersects(Le,J)})})})})},e.toComparators=function(G,J){return new Fe(G,J).set.map(function(x){return x.map(function(de){return de.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(G){if(!G)return!1;typeof G=="string"&&(G=new ye(G,this.loose));for(var J=0;J<this.set.length;J++)if(De(this.set[J],G))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(G,J,x){var de=null,Ee=null;try{var Le=new Fe(J,x)}catch{return null}return G.forEach(function(He){Le.test(He)&&(de&&Ee.compare(He)!==-1||(Ee=new ye(de=He,x)))}),de},e.minSatisfying=function(G,J,x){var de=null,Ee=null;try{var Le=new Fe(J,x)}catch{return null}return G.forEach(function(He){Le.test(He)&&(de&&Ee.compare(He)!==1||(Ee=new ye(de=He,x)))}),de},e.validRange=function(G,J){try{return new Fe(G,J).range||"*"}catch{return null}},e.ltr=function(G,J,x){return V(G,J,"<",x)},e.gtr=function(G,J,x){return V(G,J,">",x)},e.outside=V,e.prerelease=function(G,J){var x=ne(G,J);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(G,J,x){return G=new Fe(G,x),J=new Fe(J,x),G.intersects(J)},e.coerce=function(G){if(G instanceof ye)return G;if(typeof G!="string")return null;var J=G.match(O[p]);return J==null?null:ne((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,r(1))},function($e,e){var r,h,A=$e.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function O(m){if(r===setTimeout)return setTimeout(m,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(m,0);try{return r(m,0)}catch{try{return r.call(null,m,0)}catch{return r.call(this,m,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{h=typeof clearTimeout=="function"?clearTimeout:T}catch{h=T}})();var b,c=[],I=!1,y=-1;function u(){I&&b&&(I=!1,b.length?c=b.concat(c):y=-1,c.length&&C())}function C(){if(!I){var m=O(u);I=!0;for(var $=c.length;$;){for(b=c,c=[];++y<$;)b&&b[y].run();y=-1,$=c.length}b=null,I=!1,function(f){if(h===clearTimeout)return clearTimeout(f);if((h===T||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(f);try{h(f)}catch{try{return h.call(null,f)}catch{return h.call(this,f)}}}(m)}}function w(m,$){this.fun=m,this.array=$}function a(){}A.nextTick=function(m){var $=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)$[f-1]=arguments[f];c.push(new w(m,$)),c.length!==1||I||O(C)},w.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=a,A.addListener=a,A.once=a,A.off=a,A.removeListener=a,A.removeAllListeners=a,A.emit=a,A.prependListener=a,A.prependOnceListener=a,A.listeners=function(m){return[]},A.binding=function(m){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(m){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(ke[42],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(R){return new h(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=h}),define(ke[4],Ie([1,0,13,79,3,80,42]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=C;const O=!1,b=!1,c=!1;var I;(function(L){L.None=()=>A.$Vc.None;function M(De){if(c){const{onDidAddListener:Ce}=De,V=a.create();let G=0;De.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),Ce?.()}}}function z(De,Ce){return ne(De,()=>{},0,void 0,!0,void 0,Ce)}L.defer=z;function j(De){return(Ce,V=null,G)=>{let J=!1,x;return x=De(de=>{if(!J)return x?x.dispose():J=!0,Ce.call(V,de)},null,G),J&&x.dispose(),x}}L.once=j;function q(De,Ce,V){return _((G,J=null,x)=>De(de=>G.call(J,Ce(de)),null,x),V)}L.map=q;function B(De,Ce,V){return _((G,J=null,x)=>De(de=>{Ce(de),G.call(J,de)},null,x),V)}L.forEach=B;function ee(De,Ce,V){return _((G,J=null,x)=>De(de=>Ce(de)&&G.call(J,de),null,x),V)}L.filter=ee;function H(De){return De}L.signal=H;function W(...De){return(Ce,V=null,G)=>{const J=(0,A.$Sc)(...De.map(x=>x(de=>Ce.call(V,de))));return ce(J,G)}}L.any=W;function X(De,Ce,V,G){let J=V;return q(De,x=>(J=Ce(J,x),J),G)}L.reduce=X;function _(De,Ce){let V;const G={onWillAddFirstListener(){V=De(J.fire,J)},onDidRemoveLastListener(){V?.dispose()}};Ce||M(G);const J=new n(G);return Ce?.add(J),J.event}function ce(De,Ce){return Ce instanceof Array?Ce.push(De):Ce&&Ce.add(De),De}function ne(De,Ce,V=100,G=!1,J=!1,x,de){let Ee,Le,He,Ke=0,et;const nt={leakWarningThreshold:x,onWillAddFirstListener(){Ee=De(rt=>{Ke++,Le=Ce(Le,rt),G&&!He&&(st.fire(Le),Le=void 0),et=()=>{const at=Le;Le=void 0,He=void 0,(!G||Ke>1)&&st.fire(at),Ke=0},typeof V=="number"?(clearTimeout(He),He=setTimeout(et,V)):He===void 0&&(He=0,queueMicrotask(et))})},onWillRemoveListener(){J&&Ke>0&&et?.()},onDidRemoveLastListener(){et=void 0,Ee.dispose()}};de||M(nt);const st=new n(nt);return de?.add(st),st.event}L.debounce=ne;function ye(De,Ce=0,V){return L.debounce(De,(G,J)=>G?(G.push(J),G):[J],Ce,void 0,!0,void 0,V)}L.accumulate=ye;function ge(De,Ce=(G,J)=>G===J,V){let G=!0,J;return ee(De,x=>{const de=G||!Ce(x,J);return G=!1,J=x,de},V)}L.latch=ge;function Y(De,Ce,V){return[L.filter(De,Ce,V),L.filter(De,G=>!Ce(G),V)]}L.split=Y;function U(De,Ce=!1,V=[],G){let J=V.slice(),x=De(Le=>{J?J.push(Le):Ee.fire(Le)});G&&G.add(x);const de=()=>{J?.forEach(Le=>Ee.fire(Le)),J=null},Ee=new n({onWillAddFirstListener(){x||(x=De(Le=>Ee.fire(Le)),G&&G.add(x))},onDidAddFirstListener(){J&&(Ce?setTimeout(de):de())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return G&&G.add(Ee),Ee.event}L.buffer=U;function oe(De,Ce){return(G,J,x)=>{const de=Ce(new te);return De(function(Ee){const Le=de.evaluate(Ee);Le!==ve&&G.call(J,Le)},void 0,x)}}L.chain=oe;const ve=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(Ce){return this.f.push(Ce),this}forEach(Ce){return this.f.push(V=>(Ce(V),V)),this}filter(Ce){return this.f.push(V=>Ce(V)?V:ve),this}reduce(Ce,V){let G=V;return this.f.push(J=>(G=Ce(G,J),G)),this}latch(Ce=(V,G)=>V===G){let V=!0,G;return this.f.push(J=>{const x=V||!Ce(J,G);return V=!1,G=J,x?J:ve}),this}evaluate(Ce){for(const V of this.f)if(Ce=V(Ce),Ce===ve)break;return Ce}}function ae(De,Ce,V=G=>G){const G=(...Ee)=>de.fire(V(...Ee)),J=()=>De.on(Ce,G),x=()=>De.removeListener(Ce,G),de=new n({onWillAddFirstListener:J,onDidRemoveLastListener:x});return de.event}L.fromNodeEventEmitter=ae;function se(De,Ce,V=G=>G){const G=(...Ee)=>de.fire(V(...Ee)),J=()=>De.addEventListener(Ce,G),x=()=>De.removeEventListener(Ce,G),de=new n({onWillAddFirstListener:J,onDidRemoveLastListener:x});return de.event}L.fromDOMEventEmitter=se;function Z(De){return new Promise(Ce=>j(De)(Ce))}L.toPromise=Z;function re(De){const Ce=new n;return De.then(V=>{Ce.fire(V)},()=>{Ce.fire(void 0)}).finally(()=>{Ce.dispose()}),Ce.event}L.fromPromise=re;function pe(De,Ce){return De(V=>Ce.fire(V))}L.forward=pe;function we(De,Ce,V){return Ce(V),De(G=>Ce(G))}L.runAndSubscribe=we;class Fe{constructor(Ce,V){this._observable=Ce,this.f=0,this.g=!1;const G={onWillAddFirstListener:()=>{Ce.addObserver(this)},onDidRemoveLastListener:()=>{Ce.removeObserver(this)}};V||M(G),this.emitter=new n(G),V&&V.add(this.emitter)}beginUpdate(Ce){this.f++}handlePossibleChange(Ce){}handleChange(Ce,V){this.g=!0}endUpdate(Ce){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ze(De,Ce){return new Fe(De,Ce).emitter.event}L.fromObservable=ze;function Re(De){return(Ce,V,G)=>{let J=0,x=!1;const de={beginUpdate(){J++},endUpdate(){J--,J===0&&(De.reportChanges(),x&&(x=!1,Ce.call(V)))},handlePossibleChange(){},handleChange(){x=!0}};De.addObserver(de),De.reportChanges();const Ee={dispose(){De.removeObserver(de)}};return G instanceof A.$Uc?G.add(Ee):Array.isArray(G)&&G.push(Ee),Ee}}L.fromObservableLight=Re})(I||(e.Event=I={}));class y{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${y.f++}`,y.all.add(this)}start(M){this.g=new T.$ge,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$ie=y;let u=-1;function C(L){const M=u;return u=L,{dispose(){u=M}}}class w{static{this.f=1}constructor(M,z,j=(w.f++).toString(16).padStart(3,"0")){this.j=M,this.threshold=z,this.name=j,this.h=0}dispose(){this.g?.clear()}check(M,z){const j=this.threshold;if(j<=0||z<j)return;this.g||(this.g=new Map);const q=this.g.get(M.value)||0;if(this.g.set(M.value,q+1),this.h-=1,this.h<=0){this.h=j*.5;const[B,ee]=this.getMostFrequentStack(),H=`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${ee}):`;console.warn(H),console.warn(B);const W=new m(H,B);this.j(W)}return()=>{const B=this.g.get(M.value)||0;this.g.set(M.value,B-1)}}getMostFrequentStack(){if(!this.g)return;let M,z=0;for(const[j,q]of this.g)(!M||z<q)&&(M=[j,q],z=q);return M}}class a{static create(){const M=new Error;return new a(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(M,z){super(M),this.name="ListenerLeakError",this.stack=z}}e.$ke=m;class $ extends Error{constructor(M,z){super(M),this.name="ListenerRefusalError",this.stack=z}}e.$le=$;let f=0;class i{constructor(M){this.value=M,this.id=f++}}const s=2,t=(L,M)=>{if(L instanceof i)M(L);else for(let z=0;z<L.length;z++){const j=L[z];j&&M(j)}};let o;if(O){const L=[];setInterval(()=>{L.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(L.join(`
`)),L.length=0)},3e3),o=new FinalizationRegistry(M=>{typeof M=="string"&&L.push(M)})}class n{constructor(M){this.z=0,this.f=M,this.g=u>0||this.f?.leakWarningThreshold?new w(M?.onListenerError??r.$Z,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(b){const M=this.u;queueMicrotask(()=>{t(M,z=>z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,z,j)=>{if(this.g&&this.z>this.g.threshold**2){const W=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(W);const X=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],_=new $(`${W}. HINT: Stack shows most frequent listener (${X[1]}-times)`,X[0]);return(this.f?.onListenerError||r.$Z)(_),A.$Vc.None}if(this.m)return A.$Vc.None;z&&(M=M.bind(z));const q=new i(M);let B,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(q.stack=a.create(),B=this.g.check(q.stack,this.z+1)),b&&(q.stack=ee??a.create()),this.u?this.u instanceof i?(this.w??=new l,this.u=[this.u,q]):this.u.push(q):(this.f?.onWillAddFirstListener?.(this),this.u=q,this.f?.onDidAddFirstListener?.(this)),this.z++;const H=(0,A.$Tc)(()=>{o?.unregister(H),B?.(),this.A(q)});if(j instanceof A.$Uc?j.add(H):Array.isArray(j)&&j.push(H),o){const W=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),X=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(W);o.register(H,X?.[2]??W,H)}return H},this.q}A(M){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const z=this.u,j=z.indexOf(M);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,z[j]=void 0;const q=this.w.current===this;if(this.z*s<=z.length){let B=0;for(let ee=0;ee<z.length;ee++)z[ee]?z[B++]=z[ee]:q&&(this.w.end--,B<this.w.i&&this.w.i--);z.length=B}}B(M,z){if(!M)return;const j=this.f?.onListenerError||r.$Z;if(!j){M.value(z);return}try{M.value(z)}catch(q){j(q)}}C(M){const z=M.current.u;for(;M.i<M.end;)this.B(z[M.i++],M.value);M.reset()}fire(M){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof i)this.B(this.u,M);else{const z=this.w;z.enqueue(this,M,this.u.length),this.C(z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=n;const d=()=>new l;e.$ne=d;class l{constructor(){this.i=-1,this.end=0}enqueue(M,z,j){this.i=0,this.end=j,this.current=M,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class g extends n{async fireAsync(M,z,j){if(this.u)for(this.h||(this.h=new R.$6c),t(this.u,q=>this.h.push([q.value,M]));this.h.size>0&&!z.isCancellationRequested;){const[q,B]=this.h.shift(),ee=[],H={...B,token:z,waitUntil:W=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");j&&(W=j(W,q)),ee.push(W)}};try{q(H)}catch(W){(0,r.$Z)(W);continue}Object.freeze(ee),await Promise.allSettled(ee).then(W=>{for(const X of W)X.status==="rejected"&&(0,r.$Z)(X.reason)})}}}e.$oe=g;class E extends n{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new R.$6c,this.t=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.t(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.z&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$pe=E;class S extends E{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$qe=S;class D extends n{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$re=D;class k{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const z={event:M,listener:null};this.h.push(z),this.g&&this.m(z);const j=()=>{this.g&&this.o(z);const q=this.h.indexOf(z);this.h.splice(q,1)};return(0,A.$Tc)((0,h.$db)(j))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(z=>this.f.fire(z))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$se=k;class P{constructor(M,z,j,q){this.f=new A.$Uc;const B=this.f.add(new k),ee=this.f.add(new A.$5c);function H(W){ee.set(W,B.add(q(W)))}for(const W of M)H(W);this.f.add(z(W=>{H(W)})),this.f.add(j(W=>{ee.deleteAndDispose(W)})),this.event=B.event}dispose(){this.f.dispose()}}e.$te=P;class p{constructor(){this.f=[]}wrapEvent(M,z,j){return(q,B,ee)=>M(H=>{const W=this.f[this.f.length-1];if(!z){W?W.buffers.push(()=>q.call(B,H)):q.call(B,H);return}const X=W;if(!X){q.call(B,z(j,H));return}X.items??=[],X.items.push(H),X.buffers.length===0&&W.buffers.push(()=>{X.reducedResult??=j?X.items.reduce(z,j):X.items.reduce(z),q.call(B,X.reducedResult)})},void 0,ee)}bufferEvents(M){const z={buffers:new Array};this.f.push(z);const j=M();return this.f.pop(),z.buffers.forEach(q=>q()),j}}e.$ue=p;class v{constructor(){this.f=!1,this.g=I.None,this.h=A.$Vc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=v;class F{static const(M){return new N(M)}constructor(M){this.g=M,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$we=F;class N{constructor(M){this.value=M,this.onDidChange=I.None}}}),define(ke[20],Ie([1,0,4]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=O;const h=Object.freeze(function(b,c){const I=setTimeout(b.bind(c),0);return{dispose(){clearTimeout(I)}}});var A;(function(b){function c(I){return I===b.None||I===b.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}b.isCancellationToken=c,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(A||(e.CancellationToken=A={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=A.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=A.None}}e.$xe=T;function O(b){const c=new T;return b.add({dispose(){c.cancel()}}),c.token}}),define(ke[184],Ie([1,0,20]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=A;class h{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new r.$xe,c=this.b(b.token);return this.a={promise:c,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$0e=h;function A(O){return O}class R{constructor(b,c){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=A):(this.c=c,this.d=b.getCacheKey)}get(b){const c=this.d(b);return this.b!==c&&(this.b=c,this.a=this.c(b)),this.a}}e.$_e=R;class T{get cachedValues(){return this.a}constructor(b,c){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=A):(this.c=c,this.d=b.getCacheKey)}get(b){const c=this.d(b);if(this.b.has(c))return this.b.get(c);const I=this.c(b);return this.a.set(b,I),this.b.set(c,I),I}}e.$af=T}),define(ke[185],Ie([1,0,4,3]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=e.$ft=e.$et=e.ScrollbarVisibility=void 0;var A;(function(C){C[C.Auto=1]="Auto",C[C.Hidden=2]="Hidden",C[C.Visible=3]="Visible"})(A||(e.ScrollbarVisibility=A={}));class R{constructor(w,a,m,$,f,i,s){this.c=w,this._scrollStateBrand=void 0,this.c&&(a=a|0,m=m|0,$=$|0,f=f|0,i=i|0,s=s|0),this.rawScrollLeft=$,this.rawScrollTop=s,a<0&&(a=0),$+a>m&&($=m-a),$<0&&($=0),f<0&&(f=0),s+f>i&&(s=i-f),s<0&&(s=0),this.width=a,this.scrollWidth=m,this.scrollLeft=$,this.height=f,this.scrollHeight=i,this.scrollTop=s}equals(w){return this.rawScrollLeft===w.rawScrollLeft&&this.rawScrollTop===w.rawScrollTop&&this.width===w.width&&this.scrollWidth===w.scrollWidth&&this.scrollLeft===w.scrollLeft&&this.height===w.height&&this.scrollHeight===w.scrollHeight&&this.scrollTop===w.scrollTop}withScrollDimensions(w,a){return new R(this.c,typeof w.width<"u"?w.width:this.width,typeof w.scrollWidth<"u"?w.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof w.height<"u"?w.height:this.height,typeof w.scrollHeight<"u"?w.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(w){return new R(this.c,this.width,this.scrollWidth,typeof w.scrollLeft<"u"?w.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof w.scrollTop<"u"?w.scrollTop:this.rawScrollTop)}createScrollEvent(w,a){const m=this.width!==w.width,$=this.scrollWidth!==w.scrollWidth,f=this.scrollLeft!==w.scrollLeft,i=this.height!==w.height,s=this.scrollHeight!==w.scrollHeight,t=this.scrollTop!==w.scrollTop;return{inSmoothScrolling:a,oldWidth:w.width,oldScrollWidth:w.scrollWidth,oldScrollLeft:w.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:w.height,oldScrollHeight:w.scrollHeight,oldScrollTop:w.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:$,scrollLeftChanged:f,heightChanged:i,scrollHeightChanged:s,scrollTopChanged:t}}}e.$et=R;class T extends h.$Vc{constructor(w){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$me),this.onScroll=this.j.event,this.c=w.smoothScrollDuration,this.f=w.scheduleAtNextAnimationFrame,this.g=new R(w.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(w){this.c=w}validateScrollPosition(w){return this.g.withScrollPosition(w)}getScrollDimensions(){return this.g}setScrollDimensions(w,a){const m=this.g.withScrollDimensions(w,a);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(w){const a=this.g.withScrollPosition(w);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(w,a){if(this.c===0)return this.setScrollPositionNow(w);if(this.h){w={scrollLeft:typeof w.scrollLeft>"u"?this.h.to.scrollLeft:w.scrollLeft,scrollTop:typeof w.scrollTop>"u"?this.h.to.scrollTop:w.scrollTop};const m=this.g.withScrollPosition(w);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let $;a?$=new I(this.h.from,m,this.h.startTime,this.h.duration):$=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=$}else{const m=this.g.withScrollPosition(w);this.h=I.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const w=this.h.tick(),a=this.g.withScrollPosition(w);if(this.n(a,!0),!!this.h){if(w.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(w,a){const m=this.g;m.equals(w)||(this.g=w,this.j.fire(this.g.createScrollEvent(m,a)))}}e.$ft=T;class O{constructor(w,a,m){this.scrollLeft=w,this.scrollTop=a,this.isDone=m}}e.$gt=O;function b(C,w){const a=w-C;return function(m){return C+a*u(m)}}function c(C,w,a){return function(m){return m<a?C(m/a):w((m-a)/(1-a))}}class I{constructor(w,a,m,$){this.from=w,this.to=a,this.duration=$,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(w,a,m){if(Math.abs(w-a)>2.5*m){let f,i;return w<a?(f=w+.75*m,i=a-.75*m):(f=w-.75*m,i=a+.75*m),c(b(w,f),b(i,a),.33)}return b(w,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(w){this.to=w.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(w){const a=(w-this.startTime)/this.duration;if(a<1){const m=this.c(a),$=this.d(a);return new O(m,$,!1)}return new O(this.to.scrollLeft,this.to.scrollTop,!0)}combine(w,a,m){return I.start(w,a,m)}static start(w,a,m){m=m+10;const $=Date.now()-10;return new I(w,a,$,m)}}e.$ht=I;function y(C){return Math.pow(C,3)}function u(C){return 1-y(1-C)}}),define(ke[105],Ie([1,0,13,3]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=A,e.$Ae=R,e.$Be=T,e.$Ce=O,e.$De=c,e.$Ee=I,e.$Fe=y,e.$Ge=u,e.$He=C,e.$Ie=w,e.$Je=a,e.$Ke=m,e.$Le=$,e.$Me=f,e.$Ne=i;function A(s){const t=s;return t?typeof t.read=="function":!1}function R(s){const t=s;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function T(s){const t=s;return t?R(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function O(s,t){return new b(s,t)}class b{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,r.$Z)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let n;switch(t){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const d=n.indexOf(o);d>=0&&n.splice(d,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,t){const o=[];let n;for(;(n=s.read())!==null;)o.push(n);return t(o)}function I(s,t,o){const n=[];let d;for(;(d=s.read())!==null&&n.length<o;)n.push(d);return d===null&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return s.read()}}}function y(s,t){return new Promise((o,n)=>{const d=[];u(s,{onData:l=>{t&&d.push(l)},onError:l=>{t?n(l):o(void 0)},onEnd:()=>{o(t?t(d):void 0)}})})}function u(s,t,o){s.on("error",n=>{o?.isCancellationRequested||t.onError(n)}),s.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),s.on("data",n=>{o?.isCancellationRequested||t.onData(n)})}function C(s,t){return new Promise((o,n)=>{const d=new h.$Uc,l=[],g=D=>{if(l.push(D),l.length>t)return d.dispose(),s.pause(),o({stream:s,buffer:l,ended:!1})},E=D=>(d.dispose(),n(D)),S=()=>(d.dispose(),o({stream:s,buffer:l,ended:!0}));d.add((0,h.$Tc)(()=>s.removeListener("error",E))),s.on("error",E),d.add((0,h.$Tc)(()=>s.removeListener("end",S))),s.on("end",S),d.add((0,h.$Tc)(()=>s.removeListener("data",g))),s.on("data",g)})}function w(s,t){const o=O(t);return o.end(s),o}function a(){const s=O(()=>{throw new Error("not supported")});return s.end(),s}function m(s){let t=!1;return{read:()=>t?null:(t=!0,s)}}function $(s,t,o){const n=O(o);return u(s,{onData:d=>n.write(t.data(d)),onError:d=>n.error(t.error?t.error(d):d),onEnd:()=>n.end()}),n}function f(s,t,o){let n=!1;return{read:()=>{const d=t.read();return n?d:(n=!0,d!==null?o([s,d]):s)}}}function i(s,t,o){let n=!1;const d=O(o);return u(t,{onData:l=>n?d.write(l):(n=!0,d.write(o([s,l]))),onError:l=>d.error(l),onEnd:()=>{n||(n=!0,d.write(s)),d.end()}}),d}}),define(ke[21],Ie([1,0,50,105]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=c,e.$Qe=I,e.$Re=y,e.$Se=u,e.$Te=C,e.$Ue=w,e.$Ve=a,e.$We=m,e.$Xe=$,e.$Ye=f,e.$Ze=i,e.$1e=s,e.$2e=t,e.$3e=o,e.$4e=n,e.$5e=d,e.$6e=l,e.$7e=g,e.$8e=E,e.$9e=k,h=We(h);const A=typeof Buffer<"u",R=new r.$U(()=>new Uint8Array(256));let T,O;class b{static alloc(p){return A?new b(Buffer.allocUnsafe(p)):new b(new Uint8Array(p))}static wrap(p){return A&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new b(p)}static fromString(p,v){return!(v?.dontUseNodeBuffer||!1)&&A?new b(Buffer.from(p)):(T||(T=new TextEncoder),new b(T.encode(p)))}static fromByteArray(p){const v=b.alloc(p.length);for(let F=0,N=p.length;F<N;F++)v.buffer[F]=p[F];return v}static concat(p,v){if(typeof v>"u"){v=0;for(let L=0,M=p.length;L<M;L++)v+=p[L].byteLength}const F=b.alloc(v);let N=0;for(let L=0,M=p.length;L<M;L++){const z=p[L];F.set(z,N),N+=z.byteLength}return F}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=b.alloc(this.byteLength);return p.set(this),p}toString(){return A?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(p,v){return new b(this.buffer.subarray(p,v))}set(p,v){if(p instanceof b)this.buffer.set(p.buffer,v);else if(p instanceof Uint8Array)this.buffer.set(p,v);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),v);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return u(this.buffer,p)}writeUInt32BE(p,v){C(this.buffer,p,v)}readUInt32LE(p){return w(this.buffer,p)}writeUInt32LE(p,v){a(this.buffer,p,v)}readUInt8(p){return m(this.buffer,p)}writeUInt8(p,v){$(this.buffer,p,v)}indexOf(p,v=0){return c(this.buffer,p instanceof b?p.buffer:p,v)}}e.$Oe=b;function c(P,p,v=0){const F=p.byteLength,N=P.byteLength;if(F===0)return 0;if(F===1)return P.indexOf(p[0]);if(F>N-v)return-1;const L=R.value;L.fill(p.length);for(let q=0;q<p.length;q++)L[p[q]]=p.length-q-1;let M=v+p.length-1,z=M,j=-1;for(;M<N;)if(P[M]===p[z]){if(z===0){j=M;break}M--,z--}else M+=Math.max(p.length-z,L[P[M]]),z=p.length-1;return j}function I(P,p){return P[p+0]<<0>>>0|P[p+1]<<8>>>0}function y(P,p,v){P[v+0]=p&255,p=p>>>8,P[v+1]=p&255}function u(P,p){return P[p]*2**24+P[p+1]*2**16+P[p+2]*2**8+P[p+3]}function C(P,p,v){P[v+3]=p,p=p>>>8,P[v+2]=p,p=p>>>8,P[v+1]=p,p=p>>>8,P[v]=p}function w(P,p){return P[p+0]<<0>>>0|P[p+1]<<8>>>0|P[p+2]<<16>>>0|P[p+3]<<24>>>0}function a(P,p,v){P[v+0]=p&255,p=p>>>8,P[v+1]=p&255,p=p>>>8,P[v+2]=p&255,p=p>>>8,P[v+3]=p&255}function m(P,p){return P[p]}function $(P,p,v){P[v]=p}function f(P){return h.$De(P,p=>b.concat(p))}function i(P){return h.$Ke(P)}function s(P){return h.$Fe(P,p=>b.concat(p))}async function t(P){return P.ended?b.concat(P.buffer):b.concat([...P.buffer,await s(P.stream)])}function o(P){return h.$Ie(P,p=>b.concat(p))}function n(P){return h.$Le(P,{data:p=>typeof p=="string"?b.fromString(p):b.wrap(p)},p=>b.concat(p))}function d(P){return h.$Ce(p=>b.concat(p),P)}function l(P,p){return h.$Me(P,p,v=>b.concat(v))}function g(P,p){return h.$Ne(P,p,v=>b.concat(v))}function E(P){let p=0,v=0,F=0;const N=new Uint8Array(Math.floor(P.length/4*3)),L=z=>{switch(v){case 3:N[F++]=p|z,v=0;break;case 2:N[F++]=p|z>>>2,p=z<<6,v=3;break;case 1:N[F++]=p|z>>>4,p=z<<4,v=2;break;default:p=z<<2,v=1}};for(let z=0;z<P.length;z++){const j=P.charCodeAt(z);if(j>=65&&j<=90)L(j-65);else if(j>=97&&j<=122)L(j-97+26);else if(j>=48&&j<=57)L(j-48+52);else if(j===43||j===45)L(62);else if(j===47||j===95)L(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${P[z]}`)}}const M=F;for(;v>0;)L(0);return b.wrap(N).slice(0,M)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:P},p=!0,v=!1){const F=v?D:S;let N="";const L=P.byteLength%3;let M=0;for(;M<P.byteLength-L;M+=3){const z=P[M+0],j=P[M+1],q=P[M+2];N+=F[z>>>2],N+=F[(z<<4|j>>>4)&63],N+=F[(j<<2|q>>>6)&63],N+=F[q&63]}if(L===1){const z=P[M+0];N+=F[z>>>2],N+=F[z<<4&63],p&&(N+="==")}else if(L===2){const z=P[M+0],j=P[M+1];N+=F[z>>>2],N+=F[(z<<4|j>>>4)&63],N+=F[j<<2&63],p&&(N+="=")}return N}}),define(ke[186],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(ke[17],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=r,e.$gg=h,e.$hg=A,e.$ig=R,e.$jg=T,e.$kg=O,e.$lg=b,e.$mg=c,e.$ng=I,e.$og=y,e.$pg=u,e.$qg=C,e.$rg=w,e.$sg=m,e.$tg=$,e.$ug=f,e.$vg=i,e.$wg=s,e.$xg=t;function r(o){return typeof o=="string"}function h(o){return Array.isArray(o)&&o.every(n=>r(n))}function A(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function R(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}function T(o){return typeof o=="number"&&!isNaN(o)}function O(o){return!!o&&typeof o[Symbol.iterator]=="function"}function b(o){return o===!0||o===!1}function c(o){return typeof o>"u"}function I(o){return!y(o)}function y(o){return c(o)||o===null}function u(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function C(o){if(y(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function w(...o){const n=[];for(let d=0;d<o.length;d++){const l=o[d];if(y(l))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);n.push(l)}return n}const a=Object.prototype.hasOwnProperty;function m(o){if(!A(o))return!1;for(const n in o)if(a.call(o,n))return!1;return!0}function $(o){return typeof o=="function"}function f(...o){return o.length>0&&o.every($)}function i(o,n){const d=Math.min(o.length,n.length);for(let l=0;l<d;l++)s(o[l],n[l])}function s(o,n){if(r(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if($(n)){try{if(o instanceof n)return}catch{}if(!y(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function t(o){return o}}),define(ke[106],Ie([1,0,17]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=A,e.$2j=R;const h=Object.create(null);function A(T,O){if((0,r.$fg)(O)){const b=h[O];if(b===void 0)throw new Error(`${T} references an unknown codicon: ${O}`);O=b}return h[T]=O,{id:T}}function R(){return h}}),define(ke[187],Ie([1,0,106]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0,e.$3j={add:(0,r.$1j)("add",6e4),plus:(0,r.$1j)("plus",6e4),gistNew:(0,r.$1j)("gist-new",6e4),repoCreate:(0,r.$1j)("repo-create",6e4),lightbulb:(0,r.$1j)("lightbulb",60001),lightBulb:(0,r.$1j)("light-bulb",60001),repo:(0,r.$1j)("repo",60002),repoDelete:(0,r.$1j)("repo-delete",60002),gistFork:(0,r.$1j)("gist-fork",60003),repoForked:(0,r.$1j)("repo-forked",60003),gitPullRequest:(0,r.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,r.$1j)("record-keys",60005),keyboard:(0,r.$1j)("keyboard",60005),tag:(0,r.$1j)("tag",60006),gitPullRequestLabel:(0,r.$1j)("git-pull-request-label",60006),tagAdd:(0,r.$1j)("tag-add",60006),tagRemove:(0,r.$1j)("tag-remove",60006),person:(0,r.$1j)("person",60007),personFollow:(0,r.$1j)("person-follow",60007),personOutline:(0,r.$1j)("person-outline",60007),personFilled:(0,r.$1j)("person-filled",60007),gitBranch:(0,r.$1j)("git-branch",60008),gitBranchCreate:(0,r.$1j)("git-branch-create",60008),gitBranchDelete:(0,r.$1j)("git-branch-delete",60008),sourceControl:(0,r.$1j)("source-control",60008),mirror:(0,r.$1j)("mirror",60009),mirrorPublic:(0,r.$1j)("mirror-public",60009),star:(0,r.$1j)("star",60010),starAdd:(0,r.$1j)("star-add",60010),starDelete:(0,r.$1j)("star-delete",60010),starEmpty:(0,r.$1j)("star-empty",60010),comment:(0,r.$1j)("comment",60011),commentAdd:(0,r.$1j)("comment-add",60011),alert:(0,r.$1j)("alert",60012),warning:(0,r.$1j)("warning",60012),search:(0,r.$1j)("search",60013),searchSave:(0,r.$1j)("search-save",60013),logOut:(0,r.$1j)("log-out",60014),signOut:(0,r.$1j)("sign-out",60014),logIn:(0,r.$1j)("log-in",60015),signIn:(0,r.$1j)("sign-in",60015),eye:(0,r.$1j)("eye",60016),eyeUnwatch:(0,r.$1j)("eye-unwatch",60016),eyeWatch:(0,r.$1j)("eye-watch",60016),circleFilled:(0,r.$1j)("circle-filled",60017),primitiveDot:(0,r.$1j)("primitive-dot",60017),closeDirty:(0,r.$1j)("close-dirty",60017),debugBreakpoint:(0,r.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,r.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,r.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,r.$1j)("primitive-square",60018),edit:(0,r.$1j)("edit",60019),pencil:(0,r.$1j)("pencil",60019),info:(0,r.$1j)("info",60020),issueOpened:(0,r.$1j)("issue-opened",60020),gistPrivate:(0,r.$1j)("gist-private",60021),gitForkPrivate:(0,r.$1j)("git-fork-private",60021),lock:(0,r.$1j)("lock",60021),mirrorPrivate:(0,r.$1j)("mirror-private",60021),close:(0,r.$1j)("close",60022),removeClose:(0,r.$1j)("remove-close",60022),x:(0,r.$1j)("x",60022),repoSync:(0,r.$1j)("repo-sync",60023),sync:(0,r.$1j)("sync",60023),clone:(0,r.$1j)("clone",60024),desktopDownload:(0,r.$1j)("desktop-download",60024),beaker:(0,r.$1j)("beaker",60025),microscope:(0,r.$1j)("microscope",60025),vm:(0,r.$1j)("vm",60026),deviceDesktop:(0,r.$1j)("device-desktop",60026),file:(0,r.$1j)("file",60027),fileText:(0,r.$1j)("file-text",60027),more:(0,r.$1j)("more",60028),ellipsis:(0,r.$1j)("ellipsis",60028),kebabHorizontal:(0,r.$1j)("kebab-horizontal",60028),mailReply:(0,r.$1j)("mail-reply",60029),reply:(0,r.$1j)("reply",60029),organization:(0,r.$1j)("organization",60030),organizationFilled:(0,r.$1j)("organization-filled",60030),organizationOutline:(0,r.$1j)("organization-outline",60030),newFile:(0,r.$1j)("new-file",60031),fileAdd:(0,r.$1j)("file-add",60031),newFolder:(0,r.$1j)("new-folder",60032),fileDirectoryCreate:(0,r.$1j)("file-directory-create",60032),trash:(0,r.$1j)("trash",60033),trashcan:(0,r.$1j)("trashcan",60033),history:(0,r.$1j)("history",60034),clock:(0,r.$1j)("clock",60034),folder:(0,r.$1j)("folder",60035),fileDirectory:(0,r.$1j)("file-directory",60035),symbolFolder:(0,r.$1j)("symbol-folder",60035),logoGithub:(0,r.$1j)("logo-github",60036),markGithub:(0,r.$1j)("mark-github",60036),github:(0,r.$1j)("github",60036),terminal:(0,r.$1j)("terminal",60037),console:(0,r.$1j)("console",60037),repl:(0,r.$1j)("repl",60037),zap:(0,r.$1j)("zap",60038),symbolEvent:(0,r.$1j)("symbol-event",60038),error:(0,r.$1j)("error",60039),stop:(0,r.$1j)("stop",60039),variable:(0,r.$1j)("variable",60040),symbolVariable:(0,r.$1j)("symbol-variable",60040),array:(0,r.$1j)("array",60042),symbolArray:(0,r.$1j)("symbol-array",60042),symbolModule:(0,r.$1j)("symbol-module",60043),symbolPackage:(0,r.$1j)("symbol-package",60043),symbolNamespace:(0,r.$1j)("symbol-namespace",60043),symbolObject:(0,r.$1j)("symbol-object",60043),symbolMethod:(0,r.$1j)("symbol-method",60044),symbolFunction:(0,r.$1j)("symbol-function",60044),symbolConstructor:(0,r.$1j)("symbol-constructor",60044),symbolBoolean:(0,r.$1j)("symbol-boolean",60047),symbolNull:(0,r.$1j)("symbol-null",60047),symbolNumeric:(0,r.$1j)("symbol-numeric",60048),symbolNumber:(0,r.$1j)("symbol-number",60048),symbolStructure:(0,r.$1j)("symbol-structure",60049),symbolStruct:(0,r.$1j)("symbol-struct",60049),symbolParameter:(0,r.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,r.$1j)("symbol-type-parameter",60050),symbolKey:(0,r.$1j)("symbol-key",60051),symbolText:(0,r.$1j)("symbol-text",60051),symbolReference:(0,r.$1j)("symbol-reference",60052),goToFile:(0,r.$1j)("go-to-file",60052),symbolEnum:(0,r.$1j)("symbol-enum",60053),symbolValue:(0,r.$1j)("symbol-value",60053),symbolRuler:(0,r.$1j)("symbol-ruler",60054),symbolUnit:(0,r.$1j)("symbol-unit",60054),activateBreakpoints:(0,r.$1j)("activate-breakpoints",60055),archive:(0,r.$1j)("archive",60056),arrowBoth:(0,r.$1j)("arrow-both",60057),arrowDown:(0,r.$1j)("arrow-down",60058),arrowLeft:(0,r.$1j)("arrow-left",60059),arrowRight:(0,r.$1j)("arrow-right",60060),arrowSmallDown:(0,r.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,r.$1j)("arrow-small-left",60062),arrowSmallRight:(0,r.$1j)("arrow-small-right",60063),arrowSmallUp:(0,r.$1j)("arrow-small-up",60064),arrowUp:(0,r.$1j)("arrow-up",60065),bell:(0,r.$1j)("bell",60066),bold:(0,r.$1j)("bold",60067),book:(0,r.$1j)("book",60068),bookmark:(0,r.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$1j)("briefcase",60076),broadcast:(0,r.$1j)("broadcast",60077),browser:(0,r.$1j)("browser",60078),bug:(0,r.$1j)("bug",60079),calendar:(0,r.$1j)("calendar",60080),caseSensitive:(0,r.$1j)("case-sensitive",60081),check:(0,r.$1j)("check",60082),checklist:(0,r.$1j)("checklist",60083),chevronDown:(0,r.$1j)("chevron-down",60084),chevronLeft:(0,r.$1j)("chevron-left",60085),chevronRight:(0,r.$1j)("chevron-right",60086),chevronUp:(0,r.$1j)("chevron-up",60087),chromeClose:(0,r.$1j)("chrome-close",60088),chromeMaximize:(0,r.$1j)("chrome-maximize",60089),chromeMinimize:(0,r.$1j)("chrome-minimize",60090),chromeRestore:(0,r.$1j)("chrome-restore",60091),circleOutline:(0,r.$1j)("circle-outline",60092),circle:(0,r.$1j)("circle",60092),debugBreakpointUnverified:(0,r.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$1j)("circle-slash",60093),circuitBoard:(0,r.$1j)("circuit-board",60094),clearAll:(0,r.$1j)("clear-all",60095),clippy:(0,r.$1j)("clippy",60096),closeAll:(0,r.$1j)("close-all",60097),cloudDownload:(0,r.$1j)("cloud-download",60098),cloudUpload:(0,r.$1j)("cloud-upload",60099),code:(0,r.$1j)("code",60100),collapseAll:(0,r.$1j)("collapse-all",60101),colorMode:(0,r.$1j)("color-mode",60102),commentDiscussion:(0,r.$1j)("comment-discussion",60103),creditCard:(0,r.$1j)("credit-card",60105),dash:(0,r.$1j)("dash",60108),dashboard:(0,r.$1j)("dashboard",60109),database:(0,r.$1j)("database",60110),debugContinue:(0,r.$1j)("debug-continue",60111),debugDisconnect:(0,r.$1j)("debug-disconnect",60112),debugPause:(0,r.$1j)("debug-pause",60113),debugRestart:(0,r.$1j)("debug-restart",60114),debugStart:(0,r.$1j)("debug-start",60115),debugStepInto:(0,r.$1j)("debug-step-into",60116),debugStepOut:(0,r.$1j)("debug-step-out",60117),debugStepOver:(0,r.$1j)("debug-step-over",60118),debugStop:(0,r.$1j)("debug-stop",60119),debug:(0,r.$1j)("debug",60120),deviceCameraVideo:(0,r.$1j)("device-camera-video",60121),deviceCamera:(0,r.$1j)("device-camera",60122),deviceMobile:(0,r.$1j)("device-mobile",60123),diffAdded:(0,r.$1j)("diff-added",60124),diffIgnored:(0,r.$1j)("diff-ignored",60125),diffModified:(0,r.$1j)("diff-modified",60126),diffRemoved:(0,r.$1j)("diff-removed",60127),diffRenamed:(0,r.$1j)("diff-renamed",60128),diff:(0,r.$1j)("diff",60129),diffSidebyside:(0,r.$1j)("diff-sidebyside",60129),discard:(0,r.$1j)("discard",60130),editorLayout:(0,r.$1j)("editor-layout",60131),emptyWindow:(0,r.$1j)("empty-window",60132),exclude:(0,r.$1j)("exclude",60133),extensions:(0,r.$1j)("extensions",60134),eyeClosed:(0,r.$1j)("eye-closed",60135),fileBinary:(0,r.$1j)("file-binary",60136),fileCode:(0,r.$1j)("file-code",60137),fileMedia:(0,r.$1j)("file-media",60138),filePdf:(0,r.$1j)("file-pdf",60139),fileSubmodule:(0,r.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,r.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$1j)("file-symlink-file",60142),fileZip:(0,r.$1j)("file-zip",60143),files:(0,r.$1j)("files",60144),filter:(0,r.$1j)("filter",60145),flame:(0,r.$1j)("flame",60146),foldDown:(0,r.$1j)("fold-down",60147),foldUp:(0,r.$1j)("fold-up",60148),fold:(0,r.$1j)("fold",60149),folderActive:(0,r.$1j)("folder-active",60150),folderOpened:(0,r.$1j)("folder-opened",60151),gear:(0,r.$1j)("gear",60152),gift:(0,r.$1j)("gift",60153),gistSecret:(0,r.$1j)("gist-secret",60154),gist:(0,r.$1j)("gist",60155),gitCommit:(0,r.$1j)("git-commit",60156),gitCompare:(0,r.$1j)("git-compare",60157),compareChanges:(0,r.$1j)("compare-changes",60157),gitMerge:(0,r.$1j)("git-merge",60158),githubAction:(0,r.$1j)("github-action",60159),githubAlt:(0,r.$1j)("github-alt",60160),globe:(0,r.$1j)("globe",60161),grabber:(0,r.$1j)("grabber",60162),graph:(0,r.$1j)("graph",60163),gripper:(0,r.$1j)("gripper",60164),heart:(0,r.$1j)("heart",60165),home:(0,r.$1j)("home",60166),horizontalRule:(0,r.$1j)("horizontal-rule",60167),hubot:(0,r.$1j)("hubot",60168),inbox:(0,r.$1j)("inbox",60169),issueReopened:(0,r.$1j)("issue-reopened",60171),issues:(0,r.$1j)("issues",60172),italic:(0,r.$1j)("italic",60173),jersey:(0,r.$1j)("jersey",60174),json:(0,r.$1j)("json",60175),kebabVertical:(0,r.$1j)("kebab-vertical",60176),key:(0,r.$1j)("key",60177),law:(0,r.$1j)("law",60178),lightbulbAutofix:(0,r.$1j)("lightbulb-autofix",60179),linkExternal:(0,r.$1j)("link-external",60180),link:(0,r.$1j)("link",60181),listOrdered:(0,r.$1j)("list-ordered",60182),listUnordered:(0,r.$1j)("list-unordered",60183),liveShare:(0,r.$1j)("live-share",60184),loading:(0,r.$1j)("loading",60185),location:(0,r.$1j)("location",60186),mailRead:(0,r.$1j)("mail-read",60187),mail:(0,r.$1j)("mail",60188),markdown:(0,r.$1j)("markdown",60189),megaphone:(0,r.$1j)("megaphone",60190),mention:(0,r.$1j)("mention",60191),milestone:(0,r.$1j)("milestone",60192),gitPullRequestMilestone:(0,r.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,r.$1j)("mortar-board",60193),move:(0,r.$1j)("move",60194),multipleWindows:(0,r.$1j)("multiple-windows",60195),mute:(0,r.$1j)("mute",60196),noNewline:(0,r.$1j)("no-newline",60197),note:(0,r.$1j)("note",60198),octoface:(0,r.$1j)("octoface",60199),openPreview:(0,r.$1j)("open-preview",60200),package:(0,r.$1j)("package",60201),paintcan:(0,r.$1j)("paintcan",60202),pin:(0,r.$1j)("pin",60203),play:(0,r.$1j)("play",60204),run:(0,r.$1j)("run",60204),plug:(0,r.$1j)("plug",60205),preserveCase:(0,r.$1j)("preserve-case",60206),preview:(0,r.$1j)("preview",60207),project:(0,r.$1j)("project",60208),pulse:(0,r.$1j)("pulse",60209),question:(0,r.$1j)("question",60210),quote:(0,r.$1j)("quote",60211),radioTower:(0,r.$1j)("radio-tower",60212),reactions:(0,r.$1j)("reactions",60213),references:(0,r.$1j)("references",60214),refresh:(0,r.$1j)("refresh",60215),regex:(0,r.$1j)("regex",60216),remoteExplorer:(0,r.$1j)("remote-explorer",60217),remote:(0,r.$1j)("remote",60218),remove:(0,r.$1j)("remove",60219),replaceAll:(0,r.$1j)("replace-all",60220),replace:(0,r.$1j)("replace",60221),repoClone:(0,r.$1j)("repo-clone",60222),repoForcePush:(0,r.$1j)("repo-force-push",60223),repoPull:(0,r.$1j)("repo-pull",60224),repoPush:(0,r.$1j)("repo-push",60225),report:(0,r.$1j)("report",60226),requestChanges:(0,r.$1j)("request-changes",60227),rocket:(0,r.$1j)("rocket",60228),rootFolderOpened:(0,r.$1j)("root-folder-opened",60229),rootFolder:(0,r.$1j)("root-folder",60230),rss:(0,r.$1j)("rss",60231),ruby:(0,r.$1j)("ruby",60232),saveAll:(0,r.$1j)("save-all",60233),saveAs:(0,r.$1j)("save-as",60234),save:(0,r.$1j)("save",60235),screenFull:(0,r.$1j)("screen-full",60236),screenNormal:(0,r.$1j)("screen-normal",60237),searchStop:(0,r.$1j)("search-stop",60238),server:(0,r.$1j)("server",60240),settingsGear:(0,r.$1j)("settings-gear",60241),settings:(0,r.$1j)("settings",60242),shield:(0,r.$1j)("shield",60243),smiley:(0,r.$1j)("smiley",60244),sortPrecedence:(0,r.$1j)("sort-precedence",60245),splitHorizontal:(0,r.$1j)("split-horizontal",60246),splitVertical:(0,r.$1j)("split-vertical",60247),squirrel:(0,r.$1j)("squirrel",60248),starFull:(0,r.$1j)("star-full",60249),starHalf:(0,r.$1j)("star-half",60250),symbolClass:(0,r.$1j)("symbol-class",60251),symbolColor:(0,r.$1j)("symbol-color",60252),symbolConstant:(0,r.$1j)("symbol-constant",60253),symbolEnumMember:(0,r.$1j)("symbol-enum-member",60254),symbolField:(0,r.$1j)("symbol-field",60255),symbolFile:(0,r.$1j)("symbol-file",60256),symbolInterface:(0,r.$1j)("symbol-interface",60257),symbolKeyword:(0,r.$1j)("symbol-keyword",60258),symbolMisc:(0,r.$1j)("symbol-misc",60259),symbolOperator:(0,r.$1j)("symbol-operator",60260),symbolProperty:(0,r.$1j)("symbol-property",60261),wrench:(0,r.$1j)("wrench",60261),wrenchSubaction:(0,r.$1j)("wrench-subaction",60261),symbolSnippet:(0,r.$1j)("symbol-snippet",60262),tasklist:(0,r.$1j)("tasklist",60263),telescope:(0,r.$1j)("telescope",60264),textSize:(0,r.$1j)("text-size",60265),threeBars:(0,r.$1j)("three-bars",60266),thumbsdown:(0,r.$1j)("thumbsdown",60267),thumbsup:(0,r.$1j)("thumbsup",60268),tools:(0,r.$1j)("tools",60269),triangleDown:(0,r.$1j)("triangle-down",60270),triangleLeft:(0,r.$1j)("triangle-left",60271),triangleRight:(0,r.$1j)("triangle-right",60272),triangleUp:(0,r.$1j)("triangle-up",60273),twitter:(0,r.$1j)("twitter",60274),unfold:(0,r.$1j)("unfold",60275),unlock:(0,r.$1j)("unlock",60276),unmute:(0,r.$1j)("unmute",60277),unverified:(0,r.$1j)("unverified",60278),verified:(0,r.$1j)("verified",60279),versions:(0,r.$1j)("versions",60280),vmActive:(0,r.$1j)("vm-active",60281),vmOutline:(0,r.$1j)("vm-outline",60282),vmRunning:(0,r.$1j)("vm-running",60283),watch:(0,r.$1j)("watch",60284),whitespace:(0,r.$1j)("whitespace",60285),wholeWord:(0,r.$1j)("whole-word",60286),window:(0,r.$1j)("window",60287),wordWrap:(0,r.$1j)("word-wrap",60288),zoomIn:(0,r.$1j)("zoom-in",60289),zoomOut:(0,r.$1j)("zoom-out",60290),listFilter:(0,r.$1j)("list-filter",60291),listFlat:(0,r.$1j)("list-flat",60292),listSelection:(0,r.$1j)("list-selection",60293),selection:(0,r.$1j)("selection",60293),listTree:(0,r.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$1j)("circle-small-filled",60298),debugStackframeDot:(0,r.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,r.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,r.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$1j)("symbol-string",60301),debugReverseContinue:(0,r.$1j)("debug-reverse-continue",60302),debugStepBack:(0,r.$1j)("debug-step-back",60303),debugRestartFrame:(0,r.$1j)("debug-restart-frame",60304),debugAlt:(0,r.$1j)("debug-alt",60305),callIncoming:(0,r.$1j)("call-incoming",60306),callOutgoing:(0,r.$1j)("call-outgoing",60307),menu:(0,r.$1j)("menu",60308),expandAll:(0,r.$1j)("expand-all",60309),feedback:(0,r.$1j)("feedback",60310),gitPullRequestReviewer:(0,r.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,r.$1j)("ungroup-by-ref-type",60312),account:(0,r.$1j)("account",60313),gitPullRequestAssignee:(0,r.$1j)("git-pull-request-assignee",60313),bellDot:(0,r.$1j)("bell-dot",60314),debugConsole:(0,r.$1j)("debug-console",60315),library:(0,r.$1j)("library",60316),output:(0,r.$1j)("output",60317),runAll:(0,r.$1j)("run-all",60318),syncIgnored:(0,r.$1j)("sync-ignored",60319),pinned:(0,r.$1j)("pinned",60320),githubInverted:(0,r.$1j)("github-inverted",60321),serverProcess:(0,r.$1j)("server-process",60322),serverEnvironment:(0,r.$1j)("server-environment",60323),pass:(0,r.$1j)("pass",60324),issueClosed:(0,r.$1j)("issue-closed",60324),stopCircle:(0,r.$1j)("stop-circle",60325),playCircle:(0,r.$1j)("play-circle",60326),record:(0,r.$1j)("record",60327),debugAltSmall:(0,r.$1j)("debug-alt-small",60328),vmConnect:(0,r.$1j)("vm-connect",60329),cloud:(0,r.$1j)("cloud",60330),merge:(0,r.$1j)("merge",60331),export:(0,r.$1j)("export",60332),graphLeft:(0,r.$1j)("graph-left",60333),magnet:(0,r.$1j)("magnet",60334),notebook:(0,r.$1j)("notebook",60335),redo:(0,r.$1j)("redo",60336),checkAll:(0,r.$1j)("check-all",60337),pinnedDirty:(0,r.$1j)("pinned-dirty",60338),passFilled:(0,r.$1j)("pass-filled",60339),circleLargeFilled:(0,r.$1j)("circle-large-filled",60340),circleLarge:(0,r.$1j)("circle-large",60341),circleLargeOutline:(0,r.$1j)("circle-large-outline",60341),combine:(0,r.$1j)("combine",60342),gather:(0,r.$1j)("gather",60342),table:(0,r.$1j)("table",60343),variableGroup:(0,r.$1j)("variable-group",60344),typeHierarchy:(0,r.$1j)("type-hierarchy",60345),typeHierarchySub:(0,r.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$1j)("git-pull-request-create",60348),runAbove:(0,r.$1j)("run-above",60349),runBelow:(0,r.$1j)("run-below",60350),notebookTemplate:(0,r.$1j)("notebook-template",60351),debugRerun:(0,r.$1j)("debug-rerun",60352),workspaceTrusted:(0,r.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,r.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,r.$1j)("workspace-unknown",60355),terminalCmd:(0,r.$1j)("terminal-cmd",60356),terminalDebian:(0,r.$1j)("terminal-debian",60357),terminalLinux:(0,r.$1j)("terminal-linux",60358),terminalPowershell:(0,r.$1j)("terminal-powershell",60359),terminalTmux:(0,r.$1j)("terminal-tmux",60360),terminalUbuntu:(0,r.$1j)("terminal-ubuntu",60361),terminalBash:(0,r.$1j)("terminal-bash",60362),arrowSwap:(0,r.$1j)("arrow-swap",60363),copy:(0,r.$1j)("copy",60364),personAdd:(0,r.$1j)("person-add",60365),filterFilled:(0,r.$1j)("filter-filled",60366),wand:(0,r.$1j)("wand",60367),debugLineByLine:(0,r.$1j)("debug-line-by-line",60368),inspect:(0,r.$1j)("inspect",60369),layers:(0,r.$1j)("layers",60370),layersDot:(0,r.$1j)("layers-dot",60371),layersActive:(0,r.$1j)("layers-active",60372),compass:(0,r.$1j)("compass",60373),compassDot:(0,r.$1j)("compass-dot",60374),compassActive:(0,r.$1j)("compass-active",60375),azure:(0,r.$1j)("azure",60376),issueDraft:(0,r.$1j)("issue-draft",60377),gitPullRequestClosed:(0,r.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$1j)("git-pull-request-draft",60379),debugAll:(0,r.$1j)("debug-all",60380),debugCoverage:(0,r.$1j)("debug-coverage",60381),runErrors:(0,r.$1j)("run-errors",60382),folderLibrary:(0,r.$1j)("folder-library",60383),debugContinueSmall:(0,r.$1j)("debug-continue-small",60384),beakerStop:(0,r.$1j)("beaker-stop",60385),graphLine:(0,r.$1j)("graph-line",60386),graphScatter:(0,r.$1j)("graph-scatter",60387),pieChart:(0,r.$1j)("pie-chart",60388),bracket:(0,r.$1j)("bracket",60175),bracketDot:(0,r.$1j)("bracket-dot",60389),bracketError:(0,r.$1j)("bracket-error",60390),lockSmall:(0,r.$1j)("lock-small",60391),azureDevops:(0,r.$1j)("azure-devops",60392),verifiedFilled:(0,r.$1j)("verified-filled",60393),newline:(0,r.$1j)("newline",60394),layout:(0,r.$1j)("layout",60395),layoutActivitybarLeft:(0,r.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,r.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,r.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,r.$1j)("layout-panel-right",60401),layoutPanel:(0,r.$1j)("layout-panel",60402),layoutSidebarLeft:(0,r.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$1j)("layout-statusbar",60405),layoutMenubar:(0,r.$1j)("layout-menubar",60406),layoutCentered:(0,r.$1j)("layout-centered",60407),target:(0,r.$1j)("target",60408),indent:(0,r.$1j)("indent",60409),recordSmall:(0,r.$1j)("record-small",60410),errorSmall:(0,r.$1j)("error-small",60411),terminalDecorationError:(0,r.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,r.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,r.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$1j)("layout-sidebar-left-off",60418),blank:(0,r.$1j)("blank",60419),heartFilled:(0,r.$1j)("heart-filled",60420),map:(0,r.$1j)("map",60421),mapHorizontal:(0,r.$1j)("map-horizontal",60421),foldHorizontal:(0,r.$1j)("fold-horizontal",60421),mapFilled:(0,r.$1j)("map-filled",60422),mapHorizontalFilled:(0,r.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$1j)("fold-horizontal-filled",60422),circleSmall:(0,r.$1j)("circle-small",60423),bellSlash:(0,r.$1j)("bell-slash",60424),bellSlashDot:(0,r.$1j)("bell-slash-dot",60425),commentUnresolved:(0,r.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$1j)("search-fuzzy",60429),commentDraft:(0,r.$1j)("comment-draft",60430),send:(0,r.$1j)("send",60431),sparkle:(0,r.$1j)("sparkle",60432),insert:(0,r.$1j)("insert",60433),mic:(0,r.$1j)("mic",60434),thumbsdownFilled:(0,r.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$1j)("thumbsup-filled",60436),coffee:(0,r.$1j)("coffee",60437),snake:(0,r.$1j)("snake",60438),game:(0,r.$1j)("game",60439),vr:(0,r.$1j)("vr",60440),chip:(0,r.$1j)("chip",60441),piano:(0,r.$1j)("piano",60442),music:(0,r.$1j)("music",60443),micFilled:(0,r.$1j)("mic-filled",60444),repoFetch:(0,r.$1j)("repo-fetch",60445),copilot:(0,r.$1j)("copilot",60446),lightbulbSparkle:(0,r.$1j)("lightbulb-sparkle",60447),robot:(0,r.$1j)("robot",60448),sparkleFilled:(0,r.$1j)("sparkle-filled",60449),diffSingle:(0,r.$1j)("diff-single",60450),diffMultiple:(0,r.$1j)("diff-multiple",60451),surroundWith:(0,r.$1j)("surround-with",60452),share:(0,r.$1j)("share",60453),gitStash:(0,r.$1j)("git-stash",60454),gitStashApply:(0,r.$1j)("git-stash-apply",60455),gitStashPop:(0,r.$1j)("git-stash-pop",60456),vscode:(0,r.$1j)("vscode",60457),vscodeInsiders:(0,r.$1j)("vscode-insiders",60458),codeOss:(0,r.$1j)("code-oss",60459),runCoverage:(0,r.$1j)("run-coverage",60460),runAllCoverage:(0,r.$1j)("run-all-coverage",60461),coverage:(0,r.$1j)("coverage",60462),githubProject:(0,r.$1j)("github-project",60463),mapVertical:(0,r.$1j)("map-vertical",60464),foldVertical:(0,r.$1j)("fold-vertical",60464),mapVerticalFilled:(0,r.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$1j)("fold-vertical-filled",60465),goToSearch:(0,r.$1j)("go-to-search",60466),percentage:(0,r.$1j)("percentage",60467),sortPercentage:(0,r.$1j)("sort-percentage",60467),attach:(0,r.$1j)("attach",60468)}}),define(ke[82],Ie([1,0,106,187]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=void 0,e.$4j=A;function A(){return Object.values(e.$6j)}e.$5j={dialogError:(0,r.$1j)("dialog-error","error"),dialogWarning:(0,r.$1j)("dialog-warning","warning"),dialogInfo:(0,r.$1j)("dialog-info","info"),dialogClose:(0,r.$1j)("dialog-close","close"),treeItemExpanded:(0,r.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$1j)("tree-filter-clear","close"),treeItemLoading:(0,r.$1j)("tree-item-loading","loading"),menuSelection:(0,r.$1j)("menu-selection","check"),menuSubmenu:(0,r.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,r.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,r.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$1j)("toolbar-more","more"),quickInputBack:(0,r.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,r.$1j)("drop-down-button",60084),symbolCustomColor:(0,r.$1j)("symbol-customcolor",60252),exportIcon:(0,r.$1j)("export",60332),workspaceUnspecified:(0,r.$1j)("workspace-unspecified",60355),newLine:(0,r.$1j)("newline",60394),thumbsDownFilled:(0,r.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$1j)("thumbsup-filled",60436),gitFetch:(0,r.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$1j)("debug-breakpoint-pending",60377)},e.$6j={...h.$3j,...e.$5j}}),define(ke[24],Ie([1,0,17]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=h,e.$go=A,e.$ho=T,e.$io=b,e.$jo=c,e.$ko=I,e.$lo=y,e.$mo=u,e.$no=C,e.$oo=w,e.$po=a,e.$qo=m,e.$ro=$;function h(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const i=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([s,t])=>{i[s]=t&&typeof t=="object"?h(t):t}),i}function A(f){if(!f||typeof f!="object")return f;const i=[f];for(;i.length>0;){const s=i.shift();Object.freeze(s);for(const t in s)if(R.call(s,t)){const o=s[t];typeof o=="object"&&!Object.isFrozen(o)&&!(0,r.$ig)(o)&&i.push(o)}}return f}const R=Object.prototype.hasOwnProperty;function T(f,i){return O(f,i,new Set)}function O(f,i,s){if((0,r.$og)(f))return f;const t=i(f);if(typeof t<"u")return t;if(Array.isArray(f)){const o=[];for(const n of f)o.push(O(n,i,s));return o}if((0,r.$hg)(f)){if(s.has(f))throw new Error("Cannot clone recursive data-structure");s.add(f);const o={};for(const n in f)R.call(f,n)&&(o[n]=O(f[n],i,s));return s.delete(f),o}return f}function b(f,i,s=!0){return(0,r.$hg)(f)?((0,r.$hg)(i)&&Object.keys(i).forEach(t=>{t in f?s&&((0,r.$hg)(f[t])&&(0,r.$hg)(i[t])?b(f[t],i[t],s):f[t]=i[t]):f[t]=i[t]}),f):i}function c(f,i){if(f===i)return!0;if(f==null||i===null||i===void 0||typeof f!=typeof i||typeof f!="object"||Array.isArray(f)!==Array.isArray(i))return!1;let s,t;if(Array.isArray(f)){if(f.length!==i.length)return!1;for(s=0;s<f.length;s++)if(!c(f[s],i[s]))return!1}else{const o=[];for(t in f)o.push(t);o.sort();const n=[];for(t in i)n.push(t);if(n.sort(),!c(o,n))return!1;for(s=0;s<o.length;s++)if(!c(f[o[s]],i[o[s]]))return!1}return!0}function I(f){const i=new Set;return JSON.stringify(f,(s,t)=>{if((0,r.$hg)(t)||Array.isArray(t)){if(i.has(t))return"[Circular]";i.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function y(f,i){const s=Object.create(null);return!f||!i||Object.keys(i).forEach(o=>{const n=f[o],d=i[o];c(n,d)||(s[o]=d)}),s}function u(f,i){const s=i.toLowerCase(),t=Object.keys(f).find(o=>o.toLowerCase()===s);return t?f[t]:f[i]}function C(f,i){const s=Object.create(null);for(const[t,o]of Object.entries(f))i(t,o)&&(s[t]=o);return s}function w(f){let i=[];for(;Object.prototype!==f;)i=i.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return i}function a(f){const i=[];for(const s of w(f))typeof f[s]=="function"&&i.push(s);return i}function m(f,i){const s=o=>function(){const n=Array.prototype.slice.call(arguments,0);return i(o,n)},t={};for(const o of f)t[o]=s(o);return t}function $(f,i){const s={};for(const[t,o]of Object.entries(f))s[t]=i(o,t);return s}}),define(ke[51],Ie([1,0,82]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=A;var h;(function(T){function O(b){return b&&typeof b=="object"&&typeof b.id=="string"}T.isThemeColor=O})(h||(e.ThemeColor=h={}));function A(T){return{id:T}}var R;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function b(f){const i=O.exec(f.id);if(!i)return b(r.$6j.error);const[,s,t]=i,o=["codicon","codicon-"+s];return t&&o.push("codicon-modifier-"+t.substring(1)),o}T.asClassNameArray=b;function c(f){return b(f).join(" ")}T.asClassName=c;function I(f){return"."+b(f).join(".")}T.asCSSSelector=I;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||h.isThemeColor(f.color))}T.isThemeIcon=y;const u=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function C(f){const i=u.exec(f);if(!i)return;const[,s]=i;return{id:s}}T.fromString=C;function w(f){return{id:f}}T.fromId=w;function a(f,i){let s=f.id;const t=s.lastIndexOf("~");return t!==-1&&(s=s.substring(0,t)),i&&(s=`${s}~${i}`),{id:s}}T.modify=a;function m(f){const i=f.id.lastIndexOf("~");if(i!==-1)return f.id.substring(i+1)}T.getModifier=m;function $(f,i){return f.id===i.id&&f.color?.id===i.color?.id}T.isEqual=$})(R||(e.ThemeIcon=R={}))}),define(ke[83],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=h,e.$cf=A;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function A(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(ke[12],Ie([1,0,184,26,50,83]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=T,e.$ef=b,e.$ff=I,e.$gf=y,e.$hf=u,e.$if=C,e.$jf=w,e.$kf=a,e.$lf=m,e.$mf=$,e.$nf=f,e.$of=i,e.$pf=s,e.$qf=t,e.$rf=o,e.$sf=n,e.$tf=d,e.$uf=l,e.$vf=g,e.$wf=E,e.$xf=S,e.$yf=D,e.$zf=k,e.$Af=P,e.$Bf=p,e.$Cf=v,e.$Df=F,e.$Ef=N,e.$Ff=L,e.$Gf=M,e.$Hf=z,e.$If=j,e.$Jf=q,e.$Kf=B,e.$Lf=ee,e.$Mf=H,e.$Nf=W,e.$Qf=ne,e.$Rf=ye,e.$Sf=ge,e.$Tf=Y,e.$Uf=ve,e.$Vf=ae,e.$Xf=se,e.$Yf=Z,e.$Zf=re,e.$1f=pe,e.$2f=Fe,e.$3f=ze,e.$4f=De,e.$6f=Ce,e.$7f=V,e.$8f=G,e.$9f=J,e.$0f=x,e.$$f=de,e.$_f=Ee,e.$ag=Le,e.$bg=st;function T(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const O=/{(\d+)}/g;function b(Pe,...Be){return Be.length===0?Pe:Pe.replace(O,function(Qe,Ne){const je=parseInt(Ne,10);return isNaN(je)||je<0||je>=Be.length?Qe:Be[je]})}const c=/{([^}]+)}/g;function I(Pe,Be){return Object.keys(Be).length===0?Pe:Pe.replace(c,(Qe,Ne)=>Be[Ne]??Qe)}function y(Pe){return Pe.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function u(Pe){return Pe.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function C(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(Pe,Be){let Qe=0,Ne=Pe.indexOf(Be);for(;Ne!==-1;)Qe++,Ne=Pe.indexOf(Be,Ne+Be.length);return Qe}function a(Pe,Be,Qe="\u2026"){return Pe.length<=Be?Pe:`${Pe.substr(0,Be)}${Qe}`}function m(Pe,Be,Qe="\u2026"){if(Pe.length<=Be)return Pe;const Ne=Math.ceil(Be/2)-Qe.length/2,je=Math.floor(Be/2)-Qe.length/2;return`${Pe.substr(0,Ne)}${Qe}${Pe.substr(Pe.length-je)}`}function $(Pe,Be=" "){const Qe=f(Pe,Be);return i(Qe,Be)}function f(Pe,Be){if(!Pe||!Be)return Pe;const Qe=Be.length;if(Qe===0||Pe.length===0)return Pe;let Ne=0;for(;Pe.indexOf(Be,Ne)===Ne;)Ne=Ne+Qe;return Pe.substring(Ne)}function i(Pe,Be){if(!Pe||!Be)return Pe;const Qe=Be.length,Ne=Pe.length;if(Qe===0||Ne===0)return Pe;let je=Ne,ue=-1;for(;ue=Pe.lastIndexOf(Be,je-1),!(ue===-1||ue+Qe!==je);){if(ue===0)return"";je=ue}return Pe.substring(0,je)}function s(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Pe){return Pe.replace(/\*/g,"")}function o(Pe,Be,Qe={}){if(!Pe)throw new Error("Cannot create regex from empty string");Be||(Pe=C(Pe)),Qe.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Ne="";return Qe.global&&(Ne+="g"),Qe.matchCase||(Ne+="i"),Qe.multiline&&(Ne+="m"),Qe.unicode&&(Ne+="u"),new RegExp(Pe,Ne)}function n(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function d(Pe){return Pe.split(/\r\n|\r|\n/)}function l(Pe){const Be=[],Qe=Pe.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(Qe.length/2);Ne++)Be.push(Qe[2*Ne]+(Qe[2*Ne+1]??""));return Be}function g(Pe){for(let Be=0,Qe=Pe.length;Be<Qe;Be++){const Ne=Pe.charCodeAt(Be);if(Ne!==h.CharCode.Space&&Ne!==h.CharCode.Tab)return Be}return-1}function E(Pe,Be=0,Qe=Pe.length){for(let Ne=Be;Ne<Qe;Ne++){const je=Pe.charCodeAt(Ne);if(je!==h.CharCode.Space&&je!==h.CharCode.Tab)return Pe.substring(Be,Ne)}return Pe.substring(Be,Qe)}function S(Pe,Be=Pe.length-1){for(let Qe=Be;Qe>=0;Qe--){const Ne=Pe.charCodeAt(Qe);if(Ne!==h.CharCode.Space&&Ne!==h.CharCode.Tab)return Qe}return-1}function D(Pe,Be,Qe){const Ne=[];let je=0;for(const ue of Pe.matchAll(Be)){if(Ne.push(Pe.slice(je,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");je=ue.index+ue[0].length,Ne.push(Qe(ue[0],...ue.slice(1),ue.index,Pe,ue.groups))}return Ne.push(Pe.slice(je)),Promise.all(Ne).then(ue=>ue.join(""))}function k(Pe,Be){return Pe<Be?-1:Pe>Be?1:0}function P(Pe,Be,Qe=0,Ne=Pe.length,je=0,ue=Be.length){for(;Qe<Ne&&je<ue;Qe++,je++){const Ze=Pe.charCodeAt(Qe),tt=Be.charCodeAt(je);if(Ze<tt)return-1;if(Ze>tt)return 1}const he=Ne-Qe,le=ue-je;return he<le?-1:he>le?1:0}function p(Pe,Be){return v(Pe,Be,0,Pe.length,0,Be.length)}function v(Pe,Be,Qe=0,Ne=Pe.length,je=0,ue=Be.length){for(;Qe<Ne&&je<ue;Qe++,je++){let Ze=Pe.charCodeAt(Qe),tt=Be.charCodeAt(je);if(Ze===tt)continue;if(Ze>=128||tt>=128)return P(Pe.toLowerCase(),Be.toLowerCase(),Qe,Ne,je,ue);N(Ze)&&(Ze-=32),N(tt)&&(tt-=32);const ut=Ze-tt;if(ut!==0)return ut}const he=Ne-Qe,le=ue-je;return he<le?-1:he>le?1:0}function F(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function N(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function L(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function M(Pe,Be){return Pe.length===Be.length&&v(Pe,Be)===0}function z(Pe,Be){const Qe=Be.length;return Be.length>Pe.length?!1:v(Pe,Be,0,Qe)===0}function j(Pe,Be){const Qe=Math.min(Pe.length,Be.length);let Ne;for(Ne=0;Ne<Qe;Ne++)if(Pe.charCodeAt(Ne)!==Be.charCodeAt(Ne))return Ne;return Qe}function q(Pe,Be){const Qe=Math.min(Pe.length,Be.length);let Ne;const je=Pe.length-1,ue=Be.length-1;for(Ne=0;Ne<Qe;Ne++)if(Pe.charCodeAt(je-Ne)!==Be.charCodeAt(ue-Ne))return Ne;return Qe}function B(Pe){return 55296<=Pe&&Pe<=56319}function ee(Pe){return 56320<=Pe&&Pe<=57343}function H(Pe,Be){return(Pe-55296<<10)+(Be-56320)+65536}function W(Pe,Be,Qe){const Ne=Pe.charCodeAt(Qe);if(B(Ne)&&Qe+1<Be){const je=Pe.charCodeAt(Qe+1);if(ee(je))return H(Ne,je)}return Ne}function X(Pe,Be){const Qe=Pe.charCodeAt(Be-1);if(ee(Qe)&&Be>1){const Ne=Pe.charCodeAt(Be-2);if(B(Ne))return H(Ne,Qe)}return Qe}class _{get offset(){return this.e}constructor(Be,Qe=0){this.c=Be,this.d=Be.length,this.e=Qe}setOffset(Be){this.e=Be}prevCodePoint(){const Be=X(this.c,this.e);return this.e-=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}nextCodePoint(){const Be=W(this.c,this.d,this.e);return this.e+=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}eol(){return this.e>=this.d}}e.$Of=_;class ce{get offset(){return this.c.offset}constructor(Be,Qe=0){this.c=new _(Be,Qe)}nextGraphemeLength(){const Be=et.getInstance(),Qe=this.c,Ne=Qe.offset;let je=Be.getGraphemeBreakType(Qe.nextCodePoint());for(;!Qe.eol();){const ue=Qe.offset,he=Be.getGraphemeBreakType(Qe.nextCodePoint());if(He(je,he)){Qe.setOffset(ue);break}je=he}return Qe.offset-Ne}prevGraphemeLength(){const Be=et.getInstance(),Qe=this.c,Ne=Qe.offset;let je=Be.getGraphemeBreakType(Qe.prevCodePoint());for(;Qe.offset>0;){const ue=Qe.offset,he=Be.getGraphemeBreakType(Qe.prevCodePoint());if(He(he,je)){Qe.setOffset(ue);break}je=he}return Ne-Qe.offset}eol(){return this.c.eol()}}e.$Pf=ce;function ne(Pe,Be){return new ce(Pe,Be).nextGraphemeLength()}function ye(Pe,Be){return new ce(Pe,Be).prevGraphemeLength()}function ge(Pe,Be){Be>0&&ee(Pe.charCodeAt(Be))&&Be--;const Qe=Be+ne(Pe,Be);return[Qe-ye(Pe,Qe),Qe]}function Y(Pe){const Be=new ce(Pe);let Qe=0;for(;!Be.eol();)Qe++,Be.nextGraphemeLength();return Qe}let U;function oe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(Pe){return U||(U=oe()),U.test(Pe)}const te=/^[\t\n\r\x20-\x7E]*$/;function ae(Pe){return te.test(Pe)}e.$Wf=/[\u2028\u2029]/;function se(Pe){return e.$Wf.test(Pe)}function Z(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function re(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function pe(Pe,Be,Qe=""){const Ne=Pe.trimStart();if(Ne.length<Be)return Ne;const je=/\b/g;let ue=0;for(;je.test(Ne)&&!(Ne.length-je.lastIndex<Be);)ue=je.lastIndex,je.lastIndex+=1;return ue===0?Ne:Qe+Ne.substring(ue).trimStart()}const we=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(Pe){let Be=0;for(const Qe of Pe.matchAll(we))Be!==Qe.index&&(yield{isCode:!1,str:Pe.substring(Be,Qe.index)}),yield{isCode:!0,str:Qe[0]},Be=Qe.index+Qe[0].length;Be!==Pe.length&&(yield{isCode:!1,str:Pe.substring(Be)})}function ze(Pe){return Pe&&(Pe=Pe.replace(we,"")),Pe}const Re=/\\\[.*?\\\]/g;function De(Pe){return ze(Pe).replace(Re,"")}e.$5f=String.fromCharCode(h.CharCode.UTF8_BOM);function Ce(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function V(Pe){return Ce(Pe)?Pe.substr(1):Pe}function G(Pe,Be){if(!Pe||!Be||Pe.length<Be.length)return!1;const Qe=Be.length,Ne=Pe.toLowerCase();let je=0,ue=-1;for(;je<Qe;){const he=Ne.indexOf(Be[je],ue+1);if(he<0)return!1;ue=he,je++}return!0}function J(Pe,Be=!1){return Pe?(Be&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function x(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function de(Pe,Be=1){if(Be===0)return"";let Qe=-1;do Qe=Pe.indexOf(`
`,Qe+1),Be--;while(Be>0&&Qe>=0);return Qe===-1?Pe:(Pe[Qe-1]==="\r"&&Qe--,Pe.substr(0,Qe))}function Ee(Pe){const Be=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*Be),Pe<Be?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-Be)}function Le(Pe){return et.getInstance().getGraphemeBreakType(Pe)}function He(Pe,Be){return Pe===Ke.Other?Be!==Ke.Extend&&Be!==Ke.SpacingMark:Pe===Ke.CR&&Be===Ke.LF?!1:Pe===Ke.Control||Pe===Ke.CR||Pe===Ke.LF||Be===Ke.Control||Be===Ke.CR||Be===Ke.LF?!0:!(Pe===Ke.L&&(Be===Ke.L||Be===Ke.V||Be===Ke.LV||Be===Ke.LVT)||(Pe===Ke.LV||Pe===Ke.V)&&(Be===Ke.V||Be===Ke.T)||(Pe===Ke.LVT||Pe===Ke.T)&&Be===Ke.T||Be===Ke.Extend||Be===Ke.ZWJ||Be===Ke.SpacingMark||Pe===Ke.Prepend||Pe===Ke.ZWJ&&Be===Ke.Extended_Pictographic||Pe===Ke.Regional_Indicator&&Be===Ke.Regional_Indicator)}var Ke;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class et{static{this.c=null}static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=nt()}getGraphemeBreakType(Be){if(Be<32)return Be===h.CharCode.LineFeed?Ke.LF:Be===h.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(Be<127)return Ke.Other;const Qe=this.d,Ne=Qe.length/3;let je=1;for(;je<=Ne;)if(Be<Qe[3*je])je=2*je;else if(Be>Qe[3*je+1])je=2*je+1;else return Qe[3*je+2];return Ke.Other}}function nt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(Pe,Be){if(Pe===0)return 0;const Qe=rt(Pe,Be);if(Qe!==void 0)return Qe;const Ne=new _(Be,Pe);return Ne.prevCodePoint(),Ne.offset}function rt(Pe,Be){const Qe=new _(Be,Pe);let Ne=Qe.prevCodePoint();for(;at(Ne)||Ne===gt.emojiVariantSelector||Ne===gt.enclosingKeyCap;){if(Qe.offset===0)return;Ne=Qe.prevCodePoint()}if(!re(Ne))return;let je=Qe.offset;return je>0&&Qe.prevCodePoint()===gt.zwj&&(je=Qe.offset),je}function at(Pe){return 127995<=Pe&&Pe<=127999}var gt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(gt||(gt={})),e.$cg="\xA0";class dt{static{this.c=new A.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$_e({getCacheKey:JSON.stringify},Be=>{function Qe(ut){const mt=new Map;for(let Dt=0;Dt<ut.length;Dt+=2)mt.set(ut[Dt],ut[Dt+1]);return mt}function Ne(ut,mt){const Dt=new Map(ut);for(const[Mt,Ht]of mt)Dt.set(Mt,Ht);return Dt}function je(ut,mt){if(!ut)return mt;const Dt=new Map;for(const[Mt,Ht]of ut)mt.has(Mt)&&Dt.set(Mt,Ht);return Dt}const ue=this.c.value;let he=Be.filter(ut=>!ut.startsWith("_")&&ut in ue);he.length===0&&(he=["_default"]);let le;for(const ut of he){const mt=Qe(ue[ut]);le=je(le,mt)}const Ze=Qe(ue._common),tt=Ne(Ze,le);return new dt(tt)})}static getInstance(Be){return dt.d.get(Array.from(Be))}static{this.e=new A.$U(()=>Object.keys(dt.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return dt.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}containsAmbiguousCharacter(Be){for(let Qe=0;Qe<Be.length;Qe++){const Ne=Be.codePointAt(Qe);if(typeof Ne=="number"&&this.isAmbiguous(Ne))return!0}return!1}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=dt;class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(Be){return ct.e().has(Be)}static containsInvisibleCharacter(Be){for(let Qe=0;Qe<Be.length;Qe++){const Ne=Be.codePointAt(Qe);if(typeof Ne=="number"&&ct.isInvisibleCharacter(Ne))return!0}return!1}static get codePoints(){return ct.e()}}e.$eg=ct}),define(ke[31],Ie([1,0,26,16,10,12,17]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=O,e.$zg=b,e.$Ag=c,e.$Bg=I,e.$Cg=y,e.$Dg=a,e.$Eg=m,e.$Fg=$,e.$Gg=f,e.$Hg=i,e.$Ig=s,e.$Jg=t,e.$Kg=o,e.$Lg=n,e.$Mg=d,e.$Ng=l,e.$Og=S;function O(D){return D===r.CharCode.Slash||D===r.CharCode.Backslash}function b(D){return D.replace(/[\\/]/g,h.$hc.sep)}function c(D){return D.indexOf("/")===-1&&(D=b(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}function I(D,k=h.$hc.sep){if(!D)return"";const P=D.length,p=D.charCodeAt(0);if(O(p)){if(O(D.charCodeAt(1))&&!O(D.charCodeAt(2))){let F=3;const N=F;for(;F<P&&!O(D.charCodeAt(F));F++);if(N!==F&&!O(D.charCodeAt(F+1))){for(F+=1;F<P;F++)if(O(D.charCodeAt(F)))return D.slice(0,F+1).replace(/[\\/]/g,k)}}return k}else if(f(p)&&D.charCodeAt(1)===r.CharCode.Colon)return O(D.charCodeAt(2))?D.slice(0,2)+k:D.slice(0,2);let v=D.indexOf("://");if(v!==-1){for(v+=3;v<P;v++)if(O(D.charCodeAt(v)))return D.slice(0,v+1)}return""}function y(D){if(!A.$j||!D||D.length<5)return!1;let k=D.charCodeAt(0);if(k!==r.CharCode.Backslash||(k=D.charCodeAt(1),k!==r.CharCode.Backslash))return!1;let P=2;const p=P;for(;P<D.length&&(k=D.charCodeAt(P),k!==r.CharCode.Backslash);P++);return!(p===P||(k=D.charCodeAt(P+1),isNaN(k)||k===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,C=/[/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(D,k=A.$j){const P=k?u:C;return!(!D||D.length===0||/^\s+$/.test(D)||(P.lastIndex=0,P.test(D))||k&&w.test(D)||D==="."||D===".."||k&&D[D.length-1]==="."||k&&D.length!==D.trim().length||D.length>255)}function m(D,k,P){const p=D===k;return!P||p?p:!D||!k?!1:(0,R.$Gf)(D,k)}function $(D,k,P,p=h.sep){if(D===k)return!0;if(!D||!k||k.length>D.length)return!1;if(P){if(!(0,R.$Hf)(D,k))return!1;if(k.length===D.length)return!0;let F=k.length;return k.charAt(k.length-1)===p&&F--,D.charAt(F)===p}return k.charAt(k.length-1)!==p&&(k+=p),D.indexOf(k)===0}function f(D){return D>=r.CharCode.A&&D<=r.CharCode.Z||D>=r.CharCode.a&&D<=r.CharCode.z}function i(D,k){return A.$j&&D.endsWith(":")&&(D+=h.sep),(0,h.$jc)(D)||(D=(0,h.$kc)(k,D)),D=(0,h.$ic)(D),s(D)}function s(D){return A.$j?(D=(0,R.$of)(D,h.sep),D.endsWith(":")&&(D+=h.sep)):(D=(0,R.$of)(D,h.sep),D||(D=h.sep)),D}function t(D){const k=(0,h.$ic)(D);return A.$j?D.length>3?!1:o(k)&&(D.length===2||k.charCodeAt(2)===r.CharCode.Backslash):k===h.$hc.sep}function o(D,k=A.$j){return k?f(D.charCodeAt(0))&&D.charCodeAt(1)===r.CharCode.Colon:!1}function n(D,k=A.$j){return o(D,k)?D[0]:void 0}function d(D,k,P){return k.length>D.length?-1:D===k?0:(P&&(D=D.toLowerCase(),k=k.toLowerCase()),D.indexOf(k))}function l(D){const k=D.split(":");let P,p,v;for(const F of k){const N=Number(F);(0,T.$jg)(N)?p===void 0?p=N:v===void 0&&(v=N):P=P?[P,F].join(":"):F}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:p!==void 0?p:void 0,column:v!==void 0?v:p!==void 0?1:void 0}}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(D,k,P=8){let p="";for(let F=0;F<P;F++){let N;F===0&&A.$j&&!k&&(P===3||P===4)?N=E:N=g,p+=N.charAt(Math.floor(Math.random()*N.length))}let v;return k?v=`${k}-${p}`:v=p,D?(0,h.$kc)(D,v):v}}),define(ke[136],Ie([1,0,26,28,179,12]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.FuzzyScore=e.$Jk=e.$Ik=void 0,e.or=T,e.$Kk=b,e.$Lk=c,e.$Mk=u,e.$Nk=S,e.$Ok=D,e.$Pk=N,e.$Qk=L,e.$Rk=M,e.$Sk=z,e.$Tk=oe,e.$Vk=se,e.$Wk=pe,e.$Xk=we,R=We(R);function T(...Re){return function(De,Ce){for(let V=0,G=Re.length;V<G;V++){const J=Re[V](De,Ce);if(J)return J}return null}}e.$Ik=O.bind(void 0,!1),e.$Jk=O.bind(void 0,!0);function O(Re,De,Ce){if(!Ce||Ce.length<De.length)return null;let V;return Re?V=R.$Hf(Ce,De):V=Ce.indexOf(De)===0,V?De.length>0?[{start:0,end:De.length}]:[]:null}function b(Re,De){const Ce=De.toLowerCase().indexOf(Re.toLowerCase());return Ce===-1?null:[{start:Ce,end:Ce+Re.length}]}function c(Re,De){return I(Re.toLowerCase(),De.toLowerCase(),0,0)}function I(Re,De,Ce,V){if(Ce===Re.length)return[];if(V===De.length)return null;if(Re[Ce]===De[V]){let G=null;return(G=I(Re,De,Ce+1,V+1))?t({start:V,end:V+1},G):null}return I(Re,De,Ce,V+1)}function y(Re){return r.CharCode.a<=Re&&Re<=r.CharCode.z}function u(Re){return r.CharCode.A<=Re&&Re<=r.CharCode.Z}function C(Re){return r.CharCode.Digit0<=Re&&Re<=r.CharCode.Digit9}function w(Re){return Re===r.CharCode.Space||Re===r.CharCode.Tab||Re===r.CharCode.LineFeed||Re===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Re=>a.add(Re.charCodeAt(0)));function m(Re){return w(Re)||a.has(Re)}function $(Re,De){return Re===De||m(Re)&&m(De)}const f=new Map;function i(Re){if(f.has(Re))return f.get(Re);let De;const Ce=(0,A.$Gk)(Re);return Ce&&(De=Ce),f.set(Re,De),De}function s(Re){return y(Re)||u(Re)||C(Re)}function t(Re,De){return De.length===0?De=[Re]:Re.end===De[0].start?De[0].start=Re.start:De.unshift(Re),De}function o(Re,De){for(let Ce=De;Ce<Re.length;Ce++){const V=Re.charCodeAt(Ce);if(u(V)||C(V)||Ce>0&&!s(Re.charCodeAt(Ce-1)))return Ce}return Re.length}function n(Re,De,Ce,V){if(Ce===Re.length)return[];if(V===De.length)return null;if(Re[Ce]!==De[V].toLowerCase())return null;{let G=null,J=V+1;for(G=n(Re,De,Ce+1,V+1);!G&&(J=o(De,J))<De.length;)G=n(Re,De,Ce+1,J),J++;return G===null?null:t({start:V,end:V+1},G)}}function d(Re){let De=0,Ce=0,V=0,G=0,J=0;for(let He=0;He<Re.length;He++)J=Re.charCodeAt(He),u(J)&&De++,y(J)&&Ce++,s(J)&&V++,C(J)&&G++;const x=De/Re.length,de=Ce/Re.length,Ee=V/Re.length,Le=G/Re.length;return{upperPercent:x,lowerPercent:de,alphaPercent:Ee,numericPercent:Le}}function l(Re){const{upperPercent:De,lowerPercent:Ce}=Re;return Ce===0&&De>.6}function g(Re){const{upperPercent:De,lowerPercent:Ce,alphaPercent:V,numericPercent:G}=Re;return Ce>.2&&De<.8&&V>.6&&G<.2}function E(Re){let De=0,Ce=0,V=0,G=0;for(let J=0;J<Re.length;J++)V=Re.charCodeAt(J),u(V)&&De++,y(V)&&Ce++,w(V)&&G++;return(De===0||Ce===0)&&G===0?Re.length<=30:De<=5}function S(Re,De){if(!De||(De=De.trim(),De.length===0)||!E(Re))return null;De.length>60&&(De=De.substring(0,60));const Ce=d(De);if(!g(Ce)){if(!l(Ce))return null;De=De.toLowerCase()}let V=null,G=0;for(Re=Re.toLowerCase();G<De.length&&(V=n(Re,De,0,G))===null;)G=o(De,G+1);return V}function D(Re,De,Ce=!1){if(!De||De.length===0)return null;let V=null,G=0;for(Re=Re.toLowerCase(),De=De.toLowerCase();G<De.length&&(V=k(Re,De,0,G,Ce),V===null);)G=P(De,G+1);return V}function k(Re,De,Ce,V,G){let J=0;if(Ce===Re.length)return[];if(V===De.length)return null;if(!$(Re.charCodeAt(Ce),De.charCodeAt(V))){const Ee=i(Re.charCodeAt(Ce));if(!Ee)return null;for(let Le=0;Le<Ee.length;Le++)if(!$(Ee[Le],De.charCodeAt(V+Le)))return null;J+=Ee.length-1}let x=null,de=V+J+1;if(x=k(Re,De,Ce+1,de,G),!G)for(;!x&&(de=P(De,de))<De.length;)x=k(Re,De,Ce+1,de,G),de++;if(!x)return null;if(Re.charCodeAt(Ce)!==De.charCodeAt(V)){const Ee=i(Re.charCodeAt(Ce));if(!Ee)return x;for(let Le=0;Le<Ee.length;Le++)if(Ee[Le]!==De.charCodeAt(V+Le))return x}return t({start:V,end:V+J+1},x)}function P(Re,De){for(let Ce=De;Ce<Re.length;Ce++)if(m(Re.charCodeAt(Ce))||Ce>0&&m(Re.charCodeAt(Ce-1)))return Ce;return Re.length}const p=T(e.$Jk,S,b),v=T(e.$Jk,S,c),F=new h.$Ec(1e4);function N(Re,De,Ce=!1){if(typeof Re!="string"||typeof De!="string")return null;let V=F.get(Re);V||(V=new RegExp(R.$pf(Re),"i"),F.set(Re,V));const G=V.exec(De);return G?[{start:G.index,end:G.index+G[0].length}]:Ce?v(Re,De):p(Re,De)}function L(Re,De){const Ce=se(Re,Re.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ce?z(Ce):null}function M(Re,De,Ce,V,G,J){const x=Math.min(13,Re.length);for(;Ce<x;Ce++){const de=se(Re,De,Ce,V,G,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,J]}function z(Re){if(typeof Re>"u")return[];const De=[],Ce=Re[1];for(let V=Re.length-1;V>1;V--){const G=Re[V]+Ce,J=De[De.length-1];J&&J.end===G?J.end=G+1:De.push({start:G,end:G+1})}return De}const j=128;function q(){const Re=[],De=[];for(let Ce=0;Ce<=j;Ce++)De[Ce]=0;for(let Ce=0;Ce<=j;Ce++)Re.push(De.slice(0));return Re}function B(Re){const De=[];for(let Ce=0;Ce<=Re;Ce++)De[Ce]=0;return De}const ee=B(2*j),H=B(2*j),W=q(),X=q(),_=q(),ce=!1;function ne(Re,De,Ce,V,G){function J(de,Ee,Le=" "){for(;de.length<Ee;)de=Le+de;return de}let x=` |   |${V.split("").map(de=>J(de,3)).join("|")}
`;for(let de=0;de<=Ce;de++)de===0?x+=" |":x+=`${De[de-1]}|`,x+=Re[de].slice(0,G+1).map(Ee=>J(Ee.toString(),3)).join("|")+`
`;return x}function ye(Re,De,Ce,V){Re=Re.substr(De),Ce=Ce.substr(V),console.log(ne(X,Re,Re.length,Ce,Ce.length)),console.log(ne(_,Re,Re.length,Ce,Ce.length)),console.log(ne(W,Re,Re.length,Ce,Ce.length))}function ge(Re,De){if(De<0||De>=Re.length)return!1;const Ce=Re.codePointAt(De);switch(Ce){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Zf(Ce)}}function Y(Re,De){if(De<0||De>=Re.length)return!1;switch(Re.charCodeAt(De)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function U(Re,De,Ce){return De[Re]!==Ce[Re]}function oe(Re,De,Ce,V,G,J,x=!1){for(;De<Ce&&G<J;)Re[De]===V[G]&&(x&&(ee[De]=G),De+=1),G+=1;return De===Ce}var ve;(function(Re){Re[Re.Diag=1]="Diag",Re[Re.Left=2]="Left",Re[Re.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var te;(function(Re){Re.Default=[-100,0];function De(Ce){return!Ce||Ce.length===2&&Ce[0]===-100&&Ce[1]===0}Re.isDefault=De})(te||(e.FuzzyScore=te={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Ce){this.firstMatchCanBeWeak=De,this.boostFullMatch=Ce}}e.$Uk=ae;function se(Re,De,Ce,V,G,J,x=ae.default){const de=Re.length>j?j:Re.length,Ee=V.length>j?j:V.length;if(Ce>=de||J>=Ee||de-Ce>Ee-J||!oe(De,Ce,de,G,J,Ee,!0))return;Z(de,Ee,Ce,J,De,G);let Le=1,He=1,Ke=Ce,et=J;const nt=[!1];for(Le=1,Ke=Ce;Ke<de;Le++,Ke++){const dt=ee[Ke],ct=H[Ke],Pe=Ke+1<de?H[Ke+1]:Ee;for(He=dt-J+1,et=dt;et<Pe;He++,et++){let Be=Number.MIN_SAFE_INTEGER,Qe=!1;et<=ct&&(Be=re(Re,De,Ke,Ce,V,G,et,Ee,J,W[Le-1][He-1]===0,nt));let Ne=0;Be!==Number.MAX_SAFE_INTEGER&&(Qe=!0,Ne=Be+X[Le-1][He-1]);const je=et>dt,ue=je?X[Le][He-1]+(W[Le][He-1]>0?-5:0):0,he=et>dt+1&&W[Le][He-1]>0,le=he?X[Le][He-2]+(W[Le][He-2]>0?-5:0):0;if(he&&(!je||le>=ue)&&(!Qe||le>=Ne))X[Le][He]=le,_[Le][He]=ve.LeftLeft,W[Le][He]=0;else if(je&&(!Qe||ue>=Ne))X[Le][He]=ue,_[Le][He]=ve.Left,W[Le][He]=0;else if(Qe)X[Le][He]=Ne,_[Le][He]=ve.Diag,W[Le][He]=W[Le-1][He-1]+1;else throw new Error("not possible")}}if(ce&&ye(Re,Ce,V,J),!nt[0]&&!x.firstMatchCanBeWeak)return;Le--,He--;const st=[X[Le][He],J];let rt=0,at=0;for(;Le>=1;){let dt=He;do{const ct=_[Le][dt];if(ct===ve.LeftLeft)dt=dt-2;else if(ct===ve.Left)dt=dt-1;else break}while(dt>=1);rt>1&&De[Ce+Le-1]===G[J+He-1]&&!U(dt+J-1,V,G)&&rt+1>W[Le][dt]&&(dt=He),dt===He?rt++:rt=1,at||(at=dt),Le--,He=dt-1,st.push(He)}Ee-J===de&&x.boostFullMatch&&(st[0]+=2);const gt=at-de;return st[0]-=gt,st}function Z(Re,De,Ce,V,G,J){let x=Re-1,de=De-1;for(;x>=Ce&&de>=V;)G[x]===J[de]&&(H[x]=de,x--),de--}function re(Re,De,Ce,V,G,J,x,de,Ee,Le,He){if(De[Ce]!==J[x])return Number.MIN_SAFE_INTEGER;let Ke=1,et=!1;return x===Ce-V?Ke=Re[Ce]===G[x]?7:5:U(x,G,J)&&(x===0||!U(x-1,G,J))?(Ke=Re[Ce]===G[x]?7:5,et=!0):ge(J,x)&&(x===0||!ge(J,x-1))?Ke=5:(ge(J,x-1)||Y(J,x-1))&&(Ke=5,et=!0),Ke>1&&Ce===V&&(He[0]=!0),et||(et=U(x,G,J)||ge(J,x-1)||Y(J,x-1)),Ce===V?x>Ee&&(Ke-=et?3:5):Le?Ke+=et?2:0:Ke+=et?0:1,x+1===de&&(Ke-=et?3:5),Ke}function pe(Re,De,Ce,V,G,J,x){return Fe(Re,De,Ce,V,G,J,!0,x)}function we(Re,De,Ce,V,G,J,x){return Fe(Re,De,Ce,V,G,J,!1,x)}function Fe(Re,De,Ce,V,G,J,x,de){let Ee=se(Re,De,Ce,V,G,J,de);if(Ee&&!x)return Ee;if(Re.length>=3){const Le=Math.min(7,Re.length-1);for(let He=Ce+1;He<Le;He++){const Ke=ze(Re,He);if(Ke){const et=se(Ke,Ke.toLowerCase(),Ce,V,G,J,de);et&&(et[0]-=3,(!Ee||et[0]>Ee[0])&&(Ee=et))}}}return Ee}function ze(Re,De){if(De+1>=Re.length)return;const Ce=Re[De],V=Re[De+1];if(Ce!==V)return Re.slice(0,De)+V+Ce+Re.slice(De+2)}}),define(ke[60],Ie([1,0,12]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=h,e.$vj=A,e.$wj=R,e.$xj=O,e.$zj=a,r=We(r);function h($){return A($,0)}function A($,f){switch(typeof $){case"object":return $===null?R(349,f):Array.isArray($)?b($,f):c($,f);case"string":return O($,f);case"boolean":return T($,f);case"number":return R($,f);case"undefined":return R(937,f);default:return R(617,f)}}function R($,f){return(f<<5)-f+$|0}function T($,f){return R($?433:863,f)}function O($,f){f=R(149417,f);for(let i=0,s=$.length;i<s;i++)f=R($.charCodeAt(i),f);return f}function b($,f){return f=R(104579,f),$.reduce((i,s)=>A(s,i),f)}function c($,f){return f=R(181387,f),Object.keys($).sort().reduce((i,s)=>(i=O(s,i),A($[s],i)),f)}class I{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=A(f,this.g),this.g}}e.$yj=I;var y;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function u($,f,i=32){const s=i-f,t=~((1<<s)-1);return($<<f|(t&$)>>>s)>>>0}function C($,f=0,i=$.byteLength,s=0){for(let t=0;t<i;t++)$[f+t]=s}function w($,f,i="0"){for(;$.length<f;)$=i+$;return $}function a($,f=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(i=>i.toString(16).padStart(2,"0")).join(""):w(($>>>0).toString(16),f/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(y.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const i=f.length;if(i===0)return;const s=this.p;let t=this.r,o=this.u,n,d;for(o!==0?(n=o,d=-1,o=0):(n=f.charCodeAt(0),d=0);;){let l=n;if(r.$Kf(n))if(d+1<i){const g=f.charCodeAt(d+1);r.$Lf(g)?(d++,l=r.$Mf(n,g)):l=y.UNICODE_REPLACEMENT}else{o=n;break}else r.$Lf(n)&&(l=y.UNICODE_REPLACEMENT);if(t=this.w(s,t,l),d++,d<i)n=f.charCodeAt(d);else break}this.r=t,this.u=o}w(f,i,s){return s<128?f[i++]=s:s<2048?(f[i++]=192|(s&1984)>>>6,f[i++]=128|(s&63)>>>0):s<65536?(f[i++]=224|(s&61440)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0):(f[i++]=240|(s&1835008)>>>18,f[i++]=128|(s&258048)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0),i>=y.BLOCK_SIZE&&(this.y(),i-=y.BLOCK_SIZE,this.t+=y.BLOCK_SIZE,f[0]=f[y.BLOCK_SIZE+0],f[1]=f[y.BLOCK_SIZE+1],f[2]=f[y.BLOCK_SIZE+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,y.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,C(this.p,this.r),this.r>56&&(this.y(),C(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=m.g,i=this.q;for(let S=0;S<64;S+=4)f.setUint32(S,i.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)f.setUint32(S,u(f.getUint32(S-12,!1)^f.getUint32(S-32,!1)^f.getUint32(S-56,!1)^f.getUint32(S-64,!1),1),!1);let s=this.h,t=this.l,o=this.m,n=this.n,d=this.o,l,g,E;for(let S=0;S<80;S++)S<20?(l=t&o|~t&n,g=1518500249):S<40?(l=t^o^n,g=1859775393):S<60?(l=t&o|t&n|o&n,g=2400959708):(l=t^o^n,g=3395469782),E=u(s,5)+l+d+g+f.getUint32(S*4,!1)&4294967295,d=n,n=o,o=u(t,30),t=s,s=E;this.h=this.h+s&4294967295,this.l=this.l+t&4294967295,this.m=this.m+o&4294967295,this.n=this.n+n&4294967295,this.o=this.o+d&4294967295}}e.$Aj=m}),define(ke[137],Ie([1,0,26,135,136,60,16,10,12]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=y,e.$Pr=$,e.$Qr=l,e.$Rr=p,e.$Sr=z,e.$Tr=q;const c=0,I=[c,[]];function y(B,ee,H,W){if(!B||!ee)return I;const X=B.length,_=ee.length;if(X<_)return I;const ce=B.toLowerCase();return u(ee,H,_,B,ce,X,W)}function u(B,ee,H,W,X,_,ce){const ne=[],ye=[];for(let oe=0;oe<H;oe++){const ve=oe*_,te=ve-_,ae=oe>0,se=B[oe],Z=ee[oe];for(let re=0;re<_;re++){const pe=re>0,we=ve+re,Fe=we-1,ze=te+re-1,Re=pe?ne[Fe]:0,De=ae&&pe?ne[ze]:0,Ce=ae&&pe?ye[ze]:0;let V;!De&&ae?V=0:V=C(se,Z,W,X,re,Ce),V&&De+V>=Re&&(ce||ae||X.startsWith(ee,re))?(ye[we]=Ce+1,ne[we]=De+V):(ye[we]=c,ne[we]=Re)}}const ge=[];let Y=H-1,U=_-1;for(;Y>=0&&U>=0;){const oe=Y*_+U;ye[oe]===c||(ge.push(U),Y--),U--}return[ne[H*_-1],ge.reverse()]}function C(B,ee,H,W,X,_){let ce=0;if(!w(ee,W[X]))return ce;if(ce+=1,_>0&&(ce+=_*5),B===H[X]&&(ce+=1),X===0)ce+=8;else{const ne=a(H.charCodeAt(X-1));ne?ce+=ne:(0,A.$Mk)(H.charCodeAt(X))&&_===0&&(ce+=2)}return ce}function w(B,ee){return B===ee?!0:B==="/"||B==="\\"?ee==="/"||ee==="\\":!1}function a(B){switch(B){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function $(B,ee,H=0,W=0){const X=ee;return X.values&&X.values.length>1?f(B,X.values,H,W):i(B,ee,H,W)}function f(B,ee,H,W){let X=0;const _=[];for(const ce of ee){const[ne,ye]=i(B,ce,H,W);if(typeof ne!="number")return m;X+=ne,_.push(...ye)}return[X,k(_)]}function i(B,ee,H,W){const X=(0,A.$Vk)(ee.original,ee.originalLowercase,H,B,B.toLowerCase(),W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,A.$Sk)(X)]:m}const s=Object.freeze({score:0}),t=1<<18,o=1<<17,n=65536;function d(B,ee,H,W){const X=W.values?W.values:[W];return(0,R.$uj)({[W.normalized]:{values:X.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:B,description:ee,allowNonContiguousMatches:H}})}function l(B,ee,H,W,X){if(!B||!ee.normalized)return s;const _=W.getItemLabel(B);if(!_)return s;const ce=W.getItemDescription(B),ne=d(_,ce,H,ee),ye=X[ne];if(ye)return ye;const ge=g(_,ce,W.getItemPath(B),ee,H);return X[ne]=ge,ge}function g(B,ee,H,W,X){const _=!H||!W.containsPathSeparator;return H&&(O.$l?W.pathNormalized===H:(0,b.$Gf)(W.pathNormalized,H))?{score:t,labelMatch:[{start:0,end:B.length}],descriptionMatch:ee?[{start:0,end:ee.length}]:void 0}:W.values&&W.values.length>1?E(B,ee,H,W.values,_,X):S(B,ee,H,W,_,X)}function E(B,ee,H,W,X,_){let ce=0;const ne=[],ye=[];for(const ge of W){const{score:Y,labelMatch:U,descriptionMatch:oe}=S(B,ee,H,ge,X,_);if(Y===c)return s;ce+=Y,U&&ne.push(...U),oe&&ye.push(...oe)}return{score:ce,labelMatch:k(ne),descriptionMatch:k(ye)}}function S(B,ee,H,W,X,_){if(X||!ee){const[ce,ne]=y(B,W.normalized,W.normalizedLowercase,_&&!W.expectContiguousMatch);if(ce){const ye=(0,A.$Jk)(W.normalized,B);let ge;if(ye){ge=o;const Y=Math.round(W.normalized.length/B.length*100);ge+=Y}else ge=n;return{score:ge+ce,labelMatch:ye||D(ne)}}}if(ee){let ce=ee;H&&(ce=`${ee}${T.sep}`);const ne=ce.length,ye=`${ce}${B}`,[ge,Y]=y(ye,W.normalized,W.normalizedLowercase,_&&!W.expectContiguousMatch);if(ge){const U=D(Y),oe=[],ve=[];return U.forEach(te=>{te.start<ne&&te.end>ne?(oe.push({start:0,end:te.end-ne}),ve.push({start:te.start,end:ne})):te.start>=ne?oe.push({start:te.start-ne,end:te.end-ne}):ve.push(te)}),{score:ge,labelMatch:oe,descriptionMatch:ve}}}return s}function D(B){const ee=[];if(!B)return ee;let H;for(const W of B)H&&H.end===W?H.end+=1:(H={start:W,end:W+1},ee.push(H));return ee}function k(B){const ee=B.sort((X,_)=>X.start-_.start),H=[];let W;for(const X of ee)!W||!P(W,X)?(W=X,H.push(X)):(W.start=Math.min(W.start,X.start),W.end=Math.max(W.end,X.end));return H}function P(B,ee){return!(B.end<ee.start||ee.end<B.start)}function p(B,ee,H,W,X,_){const ce=l(B,H,W,X,_),ne=l(ee,H,W,X,_),ye=ce.score,ge=ne.score;if((ye===t||ge===t)&&ye!==ge)return ye===t?-1:1;if(ye>n||ge>n){if(ye!==ge)return ye>ge?-1:1;if(ye<o&&ge<o){const se=F(ce.labelMatch,ne.labelMatch);if(se!==0)return se}const te=X.getItemLabel(B)||"",ae=X.getItemLabel(ee)||"";if(te.length!==ae.length)return te.length-ae.length}if(ye!==ge)return ye>ge?-1:1;const Y=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,U=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(Y&&!U)return-1;if(U&&!Y)return 1;const oe=v(B,ce,X),ve=v(ee,ne,X);return oe&&ve&&oe!==ve?ve>oe?-1:1:N(B,ee,H,X)}function v(B,ee,H){let W=-1,X=-1;if(ee.descriptionMatch&&ee.descriptionMatch.length?W=ee.descriptionMatch[0].start:ee.labelMatch&&ee.labelMatch.length&&(W=ee.labelMatch[0].start),ee.labelMatch&&ee.labelMatch.length){if(X=ee.labelMatch[ee.labelMatch.length-1].end,ee.descriptionMatch&&ee.descriptionMatch.length){const _=H.getItemDescription(B);_&&(X+=_.length)}}else ee.descriptionMatch&&ee.descriptionMatch.length&&(X=ee.descriptionMatch[ee.descriptionMatch.length-1].end);return X-W}function F(B,ee){if(!B&&!ee||(!B||!B.length)&&(!ee||!ee.length))return 0;if(!ee||!ee.length)return-1;if(!B||!B.length)return 1;const H=B[0].start,X=B[B.length-1].end-H,_=ee[0].start,ne=ee[ee.length-1].end-_;return X===ne?0:ne<X?1:-1}function N(B,ee,H,W){const X=W.getItemLabel(B)||"",_=W.getItemLabel(ee)||"",ce=W.getItemDescription(B),ne=W.getItemDescription(ee),ye=X.length+(ce?ce.length:0),ge=_.length+(ne?ne.length:0);if(ye!==ge)return ye-ge;const Y=W.getItemPath(B),U=W.getItemPath(ee);return Y&&U&&Y.length!==U.length?Y.length-U.length:X!==_?(0,h.$Mr)(X,_,H.normalized):ce&&ne&&ce!==ne?(0,h.$Mr)(ce,ne,H.normalized):Y&&U&&Y!==U?(0,h.$Mr)(Y,U,H.normalized):0}function L(B){return B.startsWith('"')&&B.endsWith('"')}const M=" ";function z(B){typeof B!="string"&&(B="");const ee=B.toLowerCase(),{pathNormalized:H,normalized:W,normalizedLowercase:X}=j(B),_=H.indexOf(T.sep)>=0,ce=L(B);let ne;const ye=B.split(M);if(ye.length>1)for(const ge of ye){const Y=L(ge),{pathNormalized:U,normalized:oe,normalizedLowercase:ve}=j(ge);oe&&(ne||(ne=[]),ne.push({original:ge,originalLowercase:ge.toLowerCase(),pathNormalized:U,normalized:oe,normalizedLowercase:ve,expectContiguousMatch:Y}))}return{original:B,originalLowercase:ee,pathNormalized:H,normalized:W,normalizedLowercase:X,values:ne,containsPathSeparator:_,expectContiguousMatch:ce}}function j(B){let ee;O.$j?ee=B.replace(/\//g,T.sep):ee=B.replace(/\\/g,T.sep);const H=(0,b.$qf)(ee).replace(/\s|"/g,"");return{pathNormalized:ee,normalized:H,normalizedLowercase:H.toLowerCase()}}function q(B){return Array.isArray(B)?z(B.map(ee=>ee.original).join(M)):z(B.original)}}),define(ke[138],Ie([1,0,136,12,51]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=b,e.$Zk=I,e.$1k=u,e.$2k=C,e.$3k=a,e.$4k=m;const R="$(",T=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${T.source}`,"g");function b($){return $.replace(O,(f,i)=>i?f:`\\${f}`)}const c=new RegExp(`\\\\${T.source}`,"g");function I($){return $.replace(c,f=>`\\${f}`)}const y=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function u($){return $.indexOf(R)===-1?$:$.replace(y,(f,i,s,t)=>s?f:i||t||"")}function C($){return $?$.replace(/\$\((.*?)\)/g,(f,i)=>` ${i} `).trim():""}const w=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function a($){w.lastIndex=0;let f="";const i=[];let s=0;for(;;){const t=w.lastIndex,o=w.exec($),n=$.substring(t,o?.index);if(n.length>0){f+=n;for(let d=0;d<n.length;d++)i.push(s)}if(!o)break;s+=o[0].length}return{text:f,iconOffsets:i}}function m($,f,i=!1){const{text:s,iconOffsets:t}=f;if(!t||t.length===0)return(0,r.$Pk)($,s,i);const o=(0,h.$nf)(s," "),n=s.length-o.length,d=(0,r.$Pk)($,o,i);if(d)for(const l of d){const g=t[l.start+n]+n;l.start+=g,l.end+=g}return d}}),define(ke[43],Ie([1,0,12]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=We(r);var h;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(h||(h={})),function(A){const R="error",T="warning",O="warn",b="info",c="ignore";function I(u){return u?r.$Gf(R,u)?A.Error:r.$Gf(T,u)||r.$Gf(O,u)?A.Warning:r.$Gf(b,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=I;function y(u){switch(u){case A.Error:return R;case A.Warning:return T;case A.Info:return b;default:return c}}A.toString=y}(h||(h={})),e.default=h}),define(ke[84],Ie([1,0,18,26,12]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const a=w.charCodeAt(0),m=this.b.charCodeAt(this.c);return a-m}value(){return this.b[this.c]}}e.$Ii=R;class T{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,A.$Af)(w,this.b,0,w.length,this.c,this.d):(0,A.$Cf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=T;class O{constructor(w=!0,a=!0){this.f=w,this.g=a}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let a=w.length-1;a>=0;a--,this.c--){const m=this.b.charCodeAt(a);if(!(m===h.CharCode.Slash||this.f&&m===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===h.CharCode.Slash||this.f&&a===h.CharCode.Backslash)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,A.$Af)(w,this.b,0,w.length,this.d,this.e):(0,A.$Cf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=O;var b;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(b||(b={}));class c{constructor(w,a){this.f=w,this.g=a,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(b.Scheme),this.c.authority&&this.d.push(b.Authority),this.c.path&&(this.b=new O(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(b.Path)),this.g(w)||(this.c.query&&this.d.push(b.Query),this.c.fragment&&this.d.push(b.Fragment)),this.e=0,this}next(){return this.d[this.e]===b.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===b.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===b.Scheme)return(0,A.$Bf)(w,this.c.scheme);if(this.d[this.e]===b.Authority)return(0,A.$Bf)(w,this.c.authority);if(this.d[this.e]===b.Path)return this.b.cmp(w);if(this.d[this.e]===b.Query)return(0,A.$zf)(w,this.c.query);if(this.d[this.e]===b.Fragment)return(0,A.$zf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===b.Scheme)return this.c.scheme;if(this.d[this.e]===b.Authority)return this.c.authority;if(this.d[this.e]===b.Path)return this.b.value();if(this.d[this.e]===b.Query)return this.c.query;if(this.d[this.e]===b.Fragment)return this.c.fragment;throw new Error}}e.$Li=c;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(y||(y={}));class u{static forUris(w=()=>!1,a=()=>!1){return new u(new c(w,a))}static forPaths(w=!1){return new u(new O(void 0,!w))}static forStrings(){return new u(new R)}static forConfigKeys(){return new u(new T)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,a){if(a){const m=a.slice(0);(0,r.$Wb)(m);for(const $ of m)this.set($,w)}else{const m=w.slice(0);(0,r.$Wb)(m);for(const $ of m)this.set($[0],$[1])}}set(w,a){const m=this.b.reset(w);let $;this.c||(this.c=new I,this.c.segment=m.value());const f=[];for($=this.c;;){const s=m.cmp($.segment);if(s>0)$.left||($.left=new I,$.left.segment=m.value()),f.push([y.Left,$]),$=$.left;else if(s<0)$.right||($.right=new I,$.right.segment=m.value()),f.push([y.Right,$]),$=$.right;else if(m.hasNext())m.next(),$.mid||($.mid=new I,$.mid.segment=m.value()),f.push([y.Mid,$]),$=$.mid;else break}const i=$.value;$.value=a,$.key=w;for(let s=f.length-1;s>=0;s--){const t=f[s][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const n=f[s][0],d=f[s+1][0];if(n===y.Right&&d===y.Right)f[s][1]=t.rotateLeft();else if(n===y.Left&&d===y.Left)f[s][1]=t.rotateRight();else if(n===y.Right&&d===y.Left)t.right=f[s+1][1]=f[s+1][1].rotateRight(),f[s][1]=t.rotateLeft();else if(n===y.Left&&d===y.Right)t.left=f[s+1][1]=f[s+1][1].rotateLeft(),f[s][1]=t.rotateRight();else throw new Error;if(s>0)switch(f[s-1][0]){case y.Left:f[s-1][1].left=f[s][1];break;case y.Right:f[s-1][1].right=f[s][1];break;case y.Mid:f[s-1][1].mid=f[s][1];break}else this.c=f[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const a=this.b.reset(w);let m=this.c;for(;m;){const $=a.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else break}return m}has(w){const a=this.d(w);return!(a?.value===void 0&&a?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,a){const m=this.b.reset(w),$=[];let f=this.c;for(;f;){const i=m.cmp(f.segment);if(i>0)$.push([y.Left,f]),f=f.left;else if(i<0)$.push([y.Right,f]),f=f.right;else if(m.hasNext())m.next(),$.push([y.Mid,f]),f=f.mid;else break}if(f){if(a?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const i=this.f(f.right);if(i.key){const{key:s,value:t,segment:o}=i;this.e(i.key,!1),f.key=s,f.value=t,f.segment=o}}else{const i=f.left??f.right;if($.length>0){const[s,t]=$[$.length-1];switch(s){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=$.length-1;i>=0;i--){const s=$[i][1];s.updateHeight();const t=s.balanceFactor();if(t>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),$[i][1]=s.rotateLeft()):t<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),$[i][1]=s.rotateRight()),i>0)switch($[i-1][0]){case y.Left:$[i-1][1].left=$[i][1];break;case y.Right:$[i-1][1].right=$[i][1];break;case y.Mid:$[i-1][1].mid=$[i][1];break}else this.c=$[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const a=this.b.reset(w);let m=this.c,$;for(;m;){const f=a.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(a.hasNext())a.next(),$=m.value||$,m=m.mid;else break}return m&&m.value||$}findSuperstr(w){return this.g(w,!1)}g(w,a){const m=this.b.reset(w);let $=this.c;for(;$;){const f=m.cmp($.segment);if(f>0)$=$.left;else if(f<0)$=$.right;else if(m.hasNext())m.next(),$=$.mid;else return $.mid?this.h($.mid):a?$.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[a,m]of this)w(m,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const a=[];return this.j(w,a),a[Symbol.iterator]()}j(w,a){w&&(w.left&&this.j(w.left,a),w.value&&a.push([w.key,w.value]),w.mid&&this.j(w.mid,a),w.right&&this.j(w.right,a))}_isBalanced(){const w=a=>{if(!a)return!0;const m=a.balanceFactor();return m<-1||m>1?!1:w(a.left)&&w(a.right)};return w(this.c)}}e.$Mi=u}),define(ke[2],Ie([1,0,26,40,16,10]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=m,e.$xc=o,A=We(A);const T=/^\w[\w\d+.-]*$/,O=/^\//,b=/^\/\//;function c(E,S){if(!E.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${E.authority}", path: "${E.path}", query: "${E.query}", fragment: "${E.fragment}"}`);if(E.scheme&&!T.test(E.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(E.path){if(E.authority){if(!O.test(E.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(E.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(E,S){return!E&&!S?"file":E}function y(E,S){switch(E){case"https":case"http":case"file":S?S[0]!==C&&(S=C+S):S=C;break}return S}const u="",C="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(S){return S instanceof a?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,D,k,P,p,v=!1){typeof S=="object"?(this.scheme=S.scheme||u,this.authority=S.authority||u,this.path=S.path||u,this.query=S.query||u,this.fragment=S.fragment||u):(this.scheme=I(S,v),this.authority=D||u,this.path=y(this.scheme,k||u),this.query=P||u,this.fragment=p||u,c(this,v))}get fsPath(){return o(this,!1)}with(S){if(!S)return this;let{scheme:D,authority:k,path:P,query:p,fragment:v}=S;return D===void 0?D=this.scheme:D===null&&(D=u),k===void 0?k=this.authority:k===null&&(k=u),P===void 0?P=this.path:P===null&&(P=u),p===void 0?p=this.query:p===null&&(p=u),v===void 0?v=this.fragment:v===null&&(v=u),D===this.scheme&&k===this.authority&&P===this.path&&p===this.query&&v===this.fragment?this:new f(D,k,P,p,v)}static parse(S,D=!1){const k=w.exec(S);return k?new f(k[2]||u,g(k[4]||u),g(k[5]||u),g(k[7]||u),g(k[9]||u),D):new f(u,u,u,u,u)}static file(S){let D=u;if(R.$j&&(S=S.replace(/\\/g,C)),S[0]===C&&S[1]===C){const k=S.indexOf(C,2);k===-1?(D=S.substring(2),S=C):(D=S.substring(2,k),S=S.substring(k)||C)}return new f("file",D,S,u,u)}static from(S,D){return new f(S.scheme,S.authority,S.path,S.query,S.fragment,D)}static joinPath(S,...D){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return R.$j&&S.scheme==="file"?k=a.file(A.$gc.join(o(S,!0),...D)).path:k=A.$hc.join(S.path,...D),S.with({path:k})}toString(S=!1){return n(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof a)return S;{const D=new f(S);return D._formatted=S.external??null,D._fsPath=S._sep===$?S.fsPath??null:null,D}}else return S}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=a;function m(E){return!E||typeof E!="object"?!1:typeof E.scheme=="string"&&(typeof E.authority=="string"||typeof E.authority>"u")&&(typeof E.path=="string"||typeof E.path>"u")&&(typeof E.query=="string"||typeof E.query>"u")&&(typeof E.fragment=="string"||typeof E.fragment>"u")}const $=R.$j?1:void 0;class f extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(S=!1){return S?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const S={$mid:h.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=$),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const i={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function s(E,S,D){let k,P=-1;for(let p=0;p<E.length;p++){const v=E.charCodeAt(p);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||S&&v===r.CharCode.Slash||D&&v===r.CharCode.OpenSquareBracket||D&&v===r.CharCode.CloseSquareBracket||D&&v===r.CharCode.Colon)P!==-1&&(k+=encodeURIComponent(E.substring(P,p)),P=-1),k!==void 0&&(k+=E.charAt(p));else{k===void 0&&(k=E.substr(0,p));const F=i[v];F!==void 0?(P!==-1&&(k+=encodeURIComponent(E.substring(P,p)),P=-1),k+=F):P===-1&&(P=p)}}return P!==-1&&(k+=encodeURIComponent(E.substring(P))),k!==void 0?k:E}function t(E){let S;for(let D=0;D<E.length;D++){const k=E.charCodeAt(D);k===r.CharCode.Hash||k===r.CharCode.QuestionMark?(S===void 0&&(S=E.substr(0,D)),S+=i[k]):S!==void 0&&(S+=E[D])}return S!==void 0?S:E}function o(E,S){let D;return E.authority&&E.path.length>1&&E.scheme==="file"?D=`//${E.authority}${E.path}`:E.path.charCodeAt(0)===r.CharCode.Slash&&(E.path.charCodeAt(1)>=r.CharCode.A&&E.path.charCodeAt(1)<=r.CharCode.Z||E.path.charCodeAt(1)>=r.CharCode.a&&E.path.charCodeAt(1)<=r.CharCode.z)&&E.path.charCodeAt(2)===r.CharCode.Colon?S?D=E.path.substr(1):D=E.path[1].toLowerCase()+E.path.substr(2):D=E.path,R.$j&&(D=D.replace(/\//g,"\\")),D}function n(E,S){const D=S?t:s;let k="",{scheme:P,authority:p,path:v,query:F,fragment:N}=E;if(P&&(k+=P,k+=":"),(p||P==="file")&&(k+=C,k+=C),p){let L=p.indexOf("@");if(L!==-1){const M=p.substr(0,L);p=p.substr(L+1),L=M.lastIndexOf(":"),L===-1?k+=D(M,!1,!1):(k+=D(M.substr(0,L),!1,!1),k+=":",k+=D(M.substr(L+1),!1,!0)),k+="@"}p=p.toLowerCase(),L=p.lastIndexOf(":"),L===-1?k+=D(p,!1,!0):(k+=D(p.substr(0,L),!1,!0),k+=p.substr(L))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const L=v.charCodeAt(1);L>=r.CharCode.A&&L<=r.CharCode.Z&&(v=`/${String.fromCharCode(L+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const L=v.charCodeAt(0);L>=r.CharCode.A&&L<=r.CharCode.Z&&(v=`${String.fromCharCode(L+32)}:${v.substr(2)}`)}k+=D(v,!0,!1)}return F&&(k+="?",k+=D(F,!1,!1)),N&&(k+="#",k+=S?N:s(N,!1,!1)),k}function d(E){try{return decodeURIComponent(E)}catch{return E.length>3?E.substr(0,3)+d(E.substr(3)):E}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(E){return E.match(l)?E.replace(l,S=>d(S)):E}}),define(ke[188],Ie([1,0,2]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=h,e.$fr=A,e.$gr=R,e.log=O;function h(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function A(c){const I=[];let y;try{const u=JSON.parse(c.arguments),C=u[u.length-1];C&&C.__$stack&&(u.pop(),y=C.__$stack),I.push(...u)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:y}}function R(c){if(typeof c!="string")return R(A(c).stack);const I=c;if(I){const y=T(I),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function T(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function O(c,I){const{args:y,stack:u}=A(c),C=typeof y[0]=="string"&&y.length===1;let w=T(u);w&&(w=`(${w.trim()})`);let a=[];if(typeof y[0]=="string"?w&&C?a=[`%c[${I}] %c${y[0]} %c${w}`,b("blue"),b(""),b("grey")]:a=[`%c[${I}] %c${y[0]}`,b("blue"),b(""),...y.slice(1)]:a=[`%c[${I}]%`,b("blue"),...y],w&&!C&&a.push(w),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,a)}function b(c){return`color: ${c}`}}),define(ke[44],Ie([1,0,21,2,40]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=R,e.$ci=T,e.$di=b;function R(c){return JSON.stringify(c,O)}function T(c){let I=JSON.parse(c);return I=b(I),I}function O(c,I){return I instanceof RegExp?{$mid:A.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function b(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case A.MarshalledId.Uri:return h.URI.revive(c);case A.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case A.MarshalledId.Date:return new Date(c.source)}if(c instanceof r.$Oe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let y=0;y<c.length;++y)c[y]=b(c[y],I+1);else for(const y in c)Object.hasOwnProperty.call(c,y)&&(c[y]=b(c[y],I+1))}return c}}),define(ke[14],Ie([1,0,13,10,12,2,16]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=b,e.$Qg=c,e.$Ug=y,r=We(r),h=We(h),T=We(T);var O;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",w.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(O||(e.Schemas=O={}));function b(w,a){return R.URI.isUri(w)?(0,A.$Gf)(w.scheme,a):(0,A.$Hf)(w,a+":")}function c(w,...a){return a.some(m=>b(w,m))}e.$Rg="vscode-tkn",e.$Sg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=y(a,m)}getServerRootPath(){return this.f}get g(){return T.$hc.join(this.f,O.vscodeRemoteResource)}set(a,m,$){this.a[a]=m,this.b[a]=$}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(t){return r.$Z(t),a}const m=a.authority;let $=this.a[m];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const f=this.b[m],i=this.c[m];let s=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(s+=`&${e.$Sg}=${encodeURIComponent(i)}`),R.URI.from({scheme:h.$p?this.d:O.vscodeRemoteResource,authority:`${$}:${f}`,path:this.g,query:s})}}e.$Tg=new I;function y(w,a){return T.$hc.join(a??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class u{static{this.a=e.$Zg}asBrowserUri(a){const m=this.b(a,$e);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===O.vscodeRemote?e.$Tg.rewrite(a):a.scheme===O.file&&(h.$n||h.$r===`${O.vscodeFileResource}://${u.a}`)?a.with({scheme:O.vscodeFileResource,authority:a.authority||u.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,$e);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===O.vscodeFileResource?a.with({scheme:O.file,authority:a.authority!==u.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return R.URI.isUri(a)?a:R.URI.parse(m.toUrl(a))}}e.$1g=new u;var C;(function(w){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function $(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:R.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const t=s?.get(m);if(t)return a.get(t)}w.getHeadersFromQuery=$;function f(i,s,t){if(!globalThis.crossOriginIsolated)return;const o=s&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(m,o):i[m]=o}w.addSearchParam=f})(C||(e.COI=C={}))}),define(ke[189],Ie([1,0,131,14,10,17,2]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EE=y,e.$FE=u,A=We(A);class O{constructor(w,a,m){this.id=w,this.dependencies=a,this.callback=m}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,a,m)=>{typeof w!="string"&&(m=a,a=w,w=null),(typeof a!="object"||!Array.isArray(a))&&(m=a,a=null),this.c.push(new O(w,a,m))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const a=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!a)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(w){return new Promise((a,m)=>{const $=document.createElement("script");$.setAttribute("async","async"),$.setAttribute("type","text/javascript");const f=()=>{$.removeEventListener("load",i),$.removeEventListener("error",s)},i=t=>{f(),a(this.c.pop())},s=t=>{f(),m(t)};$.addEventListener("load",i),$.addEventListener("error",s),this.f&&(w=this.f.createScriptURL(w)),$.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild($)})}i(w){return new Promise((a,m)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),a(this.c.pop())}catch($){m($)}})}async j(w){try{const a=globalThis._VSCODE_NODE_MODULES.fs,m=globalThis._VSCODE_NODE_MODULES.vm,$=globalThis._VSCODE_NODE_MODULES.module,f=T.URI.parse(w).fsPath,i=a.readFileSync(f).toString(),s=$.wrap(i.replace(/^#!.*/,""));return new m.Script(s).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const c=new Map;let I={};typeof globalThis.require=="object"&&(I=globalThis.require.paths??{});async function y(C,w,a){if(r.$R){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),I[C]&&(C=I[C]);const m=w?`${C}/${w}`:C;if(c.has(m))return c.get(m);let $;if(/^\w[\w\d+.-]*:\/\//.test(m))$=m;else{const t=`${r.$S&&a&&!A.$p?h.$Xg:h.$Wg}/${m}`;$=h.$1g.asBrowserUri(t).toString(!0)}const f=b.INSTANCE.load($);return c.set(m,f),f}else return await new Promise((m,$)=>{$e([C],m,$)}).then(We)}function u(C,w){(0,R.$pg)(r.$R);const m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,$=r.$S&&m&&!A.$p,f=`${C}/${w}`,s=`${$?h.$Xg:h.$Wg}/${f}`;return h.$1g.asBrowserUri(s).toString(!0)}}),define(ke[22],Ie([1,0,26,31,14,16,10,12,2]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=c,e.$qh=y,e.$rh=C,h=We(h),R=We(R);function c(w){return(0,b.$xc)(w,!0)}class I{constructor(a){this.a=a}compare(a,m,$=!1){return a===m?0:(0,O.$zf)(this.getComparisonKey(a,$),this.getComparisonKey(m,$))}isEqual(a,m,$=!1){return a===m?!0:!a||!m?!1:this.getComparisonKey(a,$)===this.getComparisonKey(m,$)}getComparisonKey(a,m=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,m,$=!1){if(a.scheme===m.scheme){if(a.scheme===A.Schemas.file)return h.$Fg(c(a),c(m),this.a(a))&&a.query===m.query&&($||a.fragment===m.fragment);if((0,e.$mh)(a.authority,m.authority))return h.$Fg(a.path,m.path,this.a(a),"/")&&a.query===m.query&&($||a.fragment===m.fragment)}return!1}joinPath(a,...m){return b.URI.joinPath(a,...m)}basenameOrAuthority(a){return(0,e.$eh)(a)||a.authority}basename(a){return R.$hc.basename(a.path)}extname(a){return R.$hc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let m;return a.scheme===A.Schemas.file?m=b.URI.file(R.$nc(c(a))).path:(m=R.$hc.dirname(a.path),a.authority&&m.length&&m.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),m="/")),a.with({path:m})}normalizePath(a){if(!a.path.length)return a;let m;return a.scheme===A.Schemas.file?m=b.URI.file(R.$ic(c(a))).path:m=R.$hc.normalize(a.path),a.with({path:m})}relativePath(a,m){if(a.scheme!==m.scheme||!(0,e.$mh)(a.authority,m.authority))return;if(a.scheme===A.Schemas.file){const i=R.$mc(c(a),c(m));return T.$j?h.$zg(i):i}let $=a.path||"/";const f=m.path||"/";if(this.a(a)){let i=0;for(const s=Math.min($.length,f.length);i<s&&!($.charCodeAt(i)!==f.charCodeAt(i)&&$.charAt(i).toLowerCase()!==f.charAt(i).toLowerCase());i++);$=f.substr(0,i)+$.substr(i)}return R.$hc.relative($,f)}resolvePath(a,m){if(a.scheme===A.Schemas.file){const $=b.URI.file(R.$lc(c(a),m));return a.with({authority:$.authority,path:$.path})}return m=h.$Ag(m),a.with({path:R.$hc.resolve(a.path,m)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,m){return a===m||a!==void 0&&m!==void 0&&(0,O.$Gf)(a,m)}hasTrailingPathSeparator(a,m=R.sep){if(a.scheme===A.Schemas.file){const $=c(a);return $.length>h.$Bg($).length&&$[$.length-1]===m}else{const $=a.path;return $.length>1&&$.charCodeAt($.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,m=R.sep){return(0,e.$nh)(a,m)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,m=R.sep){let $=!1;if(a.scheme===A.Schemas.file){const f=c(a);$=f!==void 0&&f.length===h.$Bg(f).length&&f[f.length-1]===m}else{m="/";const f=a.path;$=f.length===1&&f.charCodeAt(f.length-1)===r.CharCode.Slash}return!$&&!(0,e.$nh)(a,m)?a.with({path:a.path+"/"}):a}}e.$9g=I,e.$0g=new I(()=>!1),e.$$g=new I(w=>w.scheme===A.Schemas.file?!T.$l:!0),e.$_g=new I(w=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function y(w,a){const m=[];for(let $=0;$<w.length;$++){const f=a(w[$]);w.some((i,s)=>s===$?!1:(0,e.$bh)(f,a(i)))||m.push(w[$])}return m}var u;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function a(m){const $=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(s=>{const[t,o]=s.split(":");t&&o&&$.set(t,o)});const i=m.path.substring(0,m.path.indexOf(";"));return i&&$.set(w.META_DATA_MIME,i),$}w.parseMetaData=a})(u||(e.DataUri=u={}));function C(w,a,m){if(a){let $=w.path;return $&&$[0]!==R.$hc.sep&&($=R.$hc.sep+$),w.with({scheme:m,authority:a,path:$})}return w.with({scheme:m})}}),define(ke[7],Ie([1,0,20,13,4,3,22,10,186,50]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=I,e.$th=y,e.$uh=u,e.$vh=C,e.$wh=w,e.$xh=a,e.$yh=m,e.$zh=$,e.$Hh=E,e.$Ih=S,e.$Jh=D,e.$Kh=k,e.$Lh=P,e.$1h=W,e.$9h=te;function I(se){return!!se&&typeof se.then=="function"}function y(se){const Z=new r.$xe,re=se(Z.token),pe=new Promise((we,Fe)=>{const ze=Z.token.onCancellationRequested(()=>{ze.dispose(),Fe(new h.$5)});Promise.resolve(re).then(Re=>{ze.dispose(),Z.dispose(),we(Re)},Re=>{ze.dispose(),Z.dispose(),Fe(Re)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(we,Fe){return pe.then(we,Fe)}catch(we){return this.then(void 0,we)}finally(we){return pe.finally(we)}}}function u(se,Z,re){return new Promise((pe,we)=>{const Fe=Z.onCancellationRequested(()=>{Fe.dispose(),pe(re)});se.then(pe,we).finally(()=>Fe.dispose())})}function C(se,Z){return new Promise((re,pe)=>{const we=Z.onCancellationRequested(()=>{we.dispose(),pe(new h.$5)});se.then(re,pe).finally(()=>we.dispose())})}async function w(se){let Z=-1;const re=se.map((pe,we)=>pe.then(Fe=>(Z=we,Fe)));try{return await Promise.race(re)}finally{se.forEach((pe,we)=>{we!==Z&&pe.cancel()})}}function a(se,Z,re){let pe;const we=setTimeout(()=>{pe?.(void 0),re?.()},Z);return Promise.race([se.finally(()=>clearTimeout(we)),new Promise(Fe=>pe=Fe)])}function m(se){return new Promise((Z,re)=>{const pe=se();I(pe)?pe.then(Z,re):Z(pe)})}function $(){let se,Z;return{promise:new Promise((pe,we)=>{se=pe,Z=we}),resolve:se,reject:Z}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const re=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(re,re).then(pe)})}return new Promise((re,pe)=>{this.b.then(re,pe)})}return this.a=Z(),new Promise((re,pe)=>{this.a.then(we=>{this.a=null,re(we)},we=>{this.a=null,pe(we)})})}dispose(){this.f=!0}}e.$Ah=f;class i{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$Bh=i;class s{constructor(){this.a=new Map}queue(Z,re){const we=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(Z)===we&&this.a.delete(Z)});return this.a.set(Z,we),we}}e.$Ch=s;const t=(se,Z)=>{let re=!0;const pe=setTimeout(()=>{re=!1,Z()},se);return{isTriggered:()=>re,dispose:()=>{clearTimeout(pe),re=!1}}},o=se=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,se())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class n{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,re=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((we,Fe)=>{this.d=we,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=re===b.$he?o(pe):t(re,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=n;class d{constructor(Z){this.a=new n(Z),this.b=new f}trigger(Z,re){return this.a.trigger(()=>this.b.queue(Z),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=d;class l{constructor(){this.a=!1,this.b=new Promise((Z,re)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=l;class g extends l{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Gh=g;function E(se,Z){return Z?new Promise((re,pe)=>{const we=setTimeout(()=>{Fe.dispose(),re()},se),Fe=Z.onCancellationRequested(()=>{clearTimeout(we),Fe.dispose(),pe(new h.$5)})}):y(re=>E(se,re))}function S(se,Z=0,re){const pe=setTimeout(()=>{se(),re&&we.dispose()},Z),we=(0,R.$Tc)(()=>{clearTimeout(pe),re?.deleteAndLeak(we)});return re?.add(we),we}function D(se){const Z=[];let re=0;const pe=se.length;function we(){return re<pe?se[re++]():null}function Fe(ze){ze!=null&&Z.push(ze);const Re=we();return Re?Re.then(Fe):Promise.resolve(Z)}return Promise.resolve(null).then(Fe)}function k(se,Z=pe=>!!pe,re=null){let pe=0;const we=se.length,Fe=()=>{if(pe>=we)return Promise.resolve(re);const ze=se[pe++];return Promise.resolve(ze()).then(De=>Z(De)?Promise.resolve(De):Fe())};return Fe()}function P(se,Z=pe=>!!pe,re=null){if(se.length===0)return Promise.resolve(re);let pe=se.length;const we=()=>{pe=-1;for(const Fe of se)Fe.cancel?.()};return new Promise((Fe,ze)=>{for(const Re of se)Re.then(De=>{--pe>=0&&Z(De)?(we(),Fe(De)):pe===0&&Fe(re)}).catch(De=>{--pe>=0&&(we(),ze(De))})})}class p{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new A.$me}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,pe)=>{this.g.push({factory:Z,c:re,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const re=Z.factory();re.then(Z.c,Z.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=p;class v extends p{constructor(){super(1)}}e.$Nh=v;class F{constructor(){this.a=new X,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Oh=F;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new ne;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,re=T.$0g){const pe=re.getComparisonKey(Z);return this.a.get(pe)?.size??0}queueFor(Z,re,pe=T.$0g){const we=pe.getComparisonKey(Z);let Fe=this.a.get(we);if(!Fe){Fe=new v;const ze=this.f++,Re=A.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$5c),this.d.set(ze,Re),this.a.set(we,Fe)}return Fe.queue(re)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=N;class L{constructor(Z,re){this.b=!1,this.a=-1,typeof Z=="function"&&typeof re=="number"&&this.setIfNotSet(Z,re)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,re){if(this.b)throw new h.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},re)}setIfNotSet(Z,re){if(this.b)throw new h.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},re))}}e.$Qh=L;class M{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,re,pe=globalThis){if(this.f)throw new h.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const we=pe.setInterval(()=>{Z()},re);this.d=(0,R.$Tc)(()=>{pe.clearInterval(we),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=M;class z{constructor(Z,re){this.b=-1,this.a=Z,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=z;class j{constructor(Z,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=Z,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=j;class q extends z{constructor(Z,re){super(Z,re),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Uh=q;class B extends R.$Vc{constructor(Z,re){super(),this.g=Z,this.h=re,this.a=[],this.b=this.B(new R.$Wc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of Z)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=B,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(se,Z)=>{(0,O.$C)(()=>{if(re)return;const pe=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$Xh=(se,Z,re)=>{const pe=se.requestIdleCallback(Z,typeof re=="number"?{timeout:re}:void 0);let we=!1;return{dispose(){we||(we=!0,se.cancelIdleCallback(pe))}}},e.$Wh=se=>(0,e.$Xh)(globalThis,se)}();class ee{constructor(Z,re){this.g=!1,this.d=()=>{try{this.j=re()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Xh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=ee;class H extends ee{constructor(Z){super(globalThis,Z)}}e.$Zh=H;async function W(se,Z,re){let pe;for(let we=0;we<re;we++)try{return await se()}catch(Fe){pe=Fe,await E(Z)}throw pe}class X{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,re,pe){return this.a={taskId:Z,cancel:()=>pe?.(),promise:re},re.then(()=>this.d(Z),()=>this.d(Z)),re}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:re,resolve:pe,reject:we}=$();this.b={run:Z,promise:re,promiseResolve:pe,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=X;class _{constructor(Z,re=()=>Date.now()){this.d=Z,this.f=re,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$3h=_;var ce;(function(se){se[se.Resolved=0]="Resolved",se[se.Rejected=1]="Rejected"})(ce||(ce={}));class ne{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,re)=>{this.a=Z,this.b=re})}complete(Z){return new Promise(re=>{this.a(Z),this.d={outcome:ce.Resolved,value:Z},re()})}error(Z){return new Promise(re=>{this.b(Z),this.d={outcome:ce.Rejected,value:Z},re()})}cancel(){return this.error(new h.$5)}}e.$4h=ne;var ye;(function(se){async function Z(pe){let we;const Fe=await Promise.all(pe.map(ze=>ze.then(Re=>Re,Re=>{we||(we=Re)})));if(typeof we<"u")throw we;return Fe}se.settled=Z;function re(pe){return new Promise(async(we,Fe)=>{try{await pe(we,Fe)}catch(ze){Fe(ze)}})}se.withAsyncBody=re})(ye||(e.Promises=ye={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new h.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=ge;class Y{constructor(Z){this.b=Z,this.a=new c.$U(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=Y;var U;(function(se){se[se.Initial=0]="Initial",se[se.DoneOK=1]="DoneOK",se[se.DoneError=2]="DoneError"})(U||(U={}));class oe{static fromArray(Z){return new oe(re=>{re.emitMany(Z)})}static fromPromise(Z){return new oe(async re=>{re.emitMany(await Z)})}static fromPromises(Z){return new oe(async re=>{await Promise.all(Z.map(async pe=>re.emitOne(await pe)))})}static merge(Z){return new oe(async re=>{await Promise.all(Z.map(async pe=>{for await(const we of pe)re.emitOne(we)}))})}static{this.EMPTY=oe.fromArray([])}constructor(Z,re){this.a=U.Initial,this.b=[],this.d=null,this.f=re,this.g=new A.$me,queueMicrotask(async()=>{const pe={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(Z(pe)),this.k()}catch(we){this.l(we)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===U.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===U.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,re){return new oe(async pe=>{for await(const we of Z)pe.emitOne(re(we))})}map(Z){return oe.map(this,Z)}static filter(Z,re){return new oe(async pe=>{for await(const we of Z)re(we)&&pe.emitOne(we)})}filter(Z){return oe.filter(this,Z)}static coalesce(Z){return oe.filter(Z,re=>!!re)}coalesce(){return oe.coalesce(this)}static async toPromise(Z){const re=[];for await(const pe of Z)re.push(pe);return re}toPromise(){return oe.toPromise(this)}h(Z){this.a===U.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===U.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===U.Initial&&(this.a=U.DoneOK,this.g.fire())}l(Z){this.a===U.Initial&&(this.a=U.DoneError,this.d=Z,this.g.fire())}}e.$7h=oe;class ve extends oe{constructor(Z,re){super(re),this.m=Z}cancel(){this.m.cancel()}}e.$8h=ve;function te(se){const Z=new r.$xe,re=se(Z.token);return new ve(Z,async pe=>{const we=Z.token.onCancellationRequested(()=>{we.dispose(),Z.dispose(),pe.reject(new h.$5)});try{for await(const Fe of re){if(Z.token.isCancellationRequested)return;pe.emitOne(Fe)}we.dispose(),Z.dispose()}catch(Fe){we.dispose(),Z.dispose(),pe.reject(Fe)}})}class ae{constructor(Z){this.a=new ne,this.b=new oe(we=>{if(re){we.reject(re);return}return pe&&we.emitMany(pe),this.d=Fe=>we.reject(Fe),this.f=Fe=>we.emitOne(Fe),this.a.p},Z);let re,pe;this.f=we=>{pe||(pe=[]),pe.push(we)},this.d=we=>{re||(re=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$0h=ae}),define(ke[38],Ie([1,0,18,7,26,31,28,16,10,12]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=void 0,e.$wk=I,e.$zk=a,e.$Ak=F,e.$Bk=N,e.$Ck=L,e.$Dk=M,e.$Ek=z,e.$Fk=ee;function I(){return Object.create(null)}e.$xk="**",e.$yk="/";const y="[/\\\\]",u="[^/\\\\]",C=/\//g;function w(H,W){switch(H){case 0:return"";case 1:return`${u}*?`;default:return`(?:${y}|${u}+${y}${W?`|${y}${u}+`:""})*?`}}function a(H,W){if(!H)return[];const X=[];let _=!1,ce=!1,ne="";for(const ye of H){switch(ye){case W:if(!_&&!ce){X.push(ne),ne="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ne+=ye}return ne&&X.push(ne),X}function m(H){if(!H)return"";let W="";const X=a(H,e.$yk);if(X.every(_=>_===e.$xk))W=".*";else{let _=!1;X.forEach((ce,ne)=>{if(ce===e.$xk){if(_)return;W+=w(2,ne===X.length-1)}else{let ye=!1,ge="",Y=!1,U="";for(const oe of ce){if(oe!=="}"&&ye){ge+=oe;continue}if(Y&&(oe!=="]"||!U)){let ve;oe==="-"?ve=oe:(oe==="^"||oe==="!")&&!U?ve="^":oe===e.$yk?ve="":ve=(0,c.$if)(oe),U+=ve;continue}switch(oe){case"{":ye=!0;continue;case"[":Y=!0;continue;case"}":{const te=`(?:${a(ge,",").map(ae=>m(ae)).join("|")})`;W+=te,ye=!1,ge="";break}case"]":{W+="["+U+"]",Y=!1,U="";break}case"?":W+=u;continue;case"*":W+=w(1);continue;default:W+=(0,c.$if)(oe)}}ne<X.length-1&&(X[ne+1]!==e.$xk||ne+2<X.length)&&(W+=y)}_=ce===e.$xk})}return W}const $=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new T.$Ec(1e4),d=function(){return!1},l=function(){return null};function g(H,W){if(!H)return l;let X;typeof H!="string"?X=H.pattern:X=H,X=X.trim();const _=`${X}_${!!W.trimForExclusions}`;let ce=n.get(_);if(ce)return E(ce,H);let ne;return $.test(X)?ce=D(X.substr(4),X):(ne=f.exec(S(X,W)))?ce=k(ne[1],X):(W.trimForExclusions?s:i).test(X)?ce=P(X,W):(ne=t.exec(S(X,W)))?ce=p(ne[1].substr(1),X,!0):(ne=o.exec(S(X,W)))?ce=p(ne[1],X,!1):ce=v(X),n.set(_,ce),E(ce,H)}function E(H,W){if(typeof W=="string")return H;const X=function(_,ce){return(0,R.$Fg)(_,W.base,!b.$l)?H((0,c.$nf)(_.substr(W.base.length),O.sep),ce):null};return X.allBasenames=H.allBasenames,X.allPaths=H.allPaths,X.basenames=H.basenames,X.patterns=H.patterns,X}function S(H,W){return W.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function D(H,W){return function(X,_){return typeof X=="string"&&X.endsWith(H)?W:null}}function k(H,W){const X=`/${H}`,_=`\\${H}`,ce=function(ye,ge){return typeof ye!="string"?null:ge?ge===H?W:null:ye===H||ye.endsWith(X)||ye.endsWith(_)?W:null},ne=[H];return ce.basenames=ne,ce.patterns=[W],ce.allBasenames=ne,ce}function P(H,W){const X=B(H.slice(1,-1).split(",").map(ge=>g(ge,W)).filter(ge=>ge!==l),H),_=X.length;if(!_)return l;if(_===1)return X[0];const ce=function(ge,Y){for(let U=0,oe=X.length;U<oe;U++)if(X[U](ge,Y))return H;return null},ne=X.find(ge=>!!ge.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const ye=X.reduce((ge,Y)=>Y.allPaths?ge.concat(Y.allPaths):ge,[]);return ye.length&&(ce.allPaths=ye),ce}function p(H,W,X){const _=O.sep===O.$hc.sep,ce=_?H:H.replace(C,O.sep),ne=O.sep+ce,ye=O.$hc.sep+H;let ge;return X?ge=function(Y,U){return typeof Y=="string"&&(Y===ce||Y.endsWith(ne)||!_&&(Y===H||Y.endsWith(ye)))?W:null}:ge=function(Y,U){return typeof Y=="string"&&(Y===ce||!_&&Y===H)?W:null},ge.allPaths=[(X?"*/":"./")+H],ge}function v(H){try{const W=new RegExp(`^${m(H)}$`);return function(X){return W.lastIndex=0,typeof X=="string"&&W.test(X)?H:null}}catch{return l}}function F(H,W,X){return!H||typeof W!="string"?!1:N(H)(W,void 0,X)}function N(H,W={}){if(!H)return d;if(typeof H=="string"||L(H)){const X=g(H,W);if(X===l)return d;const _=function(ce,ne){return!!X(ce,ne)};return X.allBasenames&&(_.allBasenames=X.allBasenames),X.allPaths&&(_.allPaths=X.allPaths),_}return j(H,W)}function L(H){const W=H;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function M(H){return H.allBasenames||[]}function z(H){return H.allPaths||[]}function j(H,W){const X=B(Object.getOwnPropertyNames(H).map(ge=>q(ge,H[ge],W)).filter(ge=>ge!==l)),_=X.length;if(!_)return l;if(!X.some(ge=>!!ge.requiresSiblings)){if(_===1)return X[0];const ge=function(oe,ve){let te;for(let ae=0,se=X.length;ae<se;ae++){const Z=X[ae](oe,ve);if(typeof Z=="string")return Z;(0,h.$sh)(Z)&&(te||(te=[]),te.push(Z))}return te?(async()=>{for(const ae of te){const se=await ae;if(typeof se=="string")return se}return null})():null},Y=X.find(oe=>!!oe.allBasenames);Y&&(ge.allBasenames=Y.allBasenames);const U=X.reduce((oe,ve)=>ve.allPaths?oe.concat(ve.allPaths):oe,[]);return U.length&&(ge.allPaths=U),ge}const ce=function(ge,Y,U){let oe,ve;for(let te=0,ae=X.length;te<ae;te++){const se=X[te];se.requiresSiblings&&U&&(Y||(Y=(0,O.$oc)(ge)),oe||(oe=Y.substr(0,Y.length-(0,O.$pc)(ge).length)));const Z=se(ge,Y,oe,U);if(typeof Z=="string")return Z;(0,h.$sh)(Z)&&(ve||(ve=[]),ve.push(Z))}return ve?(async()=>{for(const te of ve){const ae=await te;if(typeof ae=="string")return ae}return null})():null},ne=X.find(ge=>!!ge.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const ye=X.reduce((ge,Y)=>Y.allPaths?ge.concat(Y.allPaths):ge,[]);return ye.length&&(ce.allPaths=ye),ce}function q(H,W,X){if(W===!1)return l;const _=g(H,X);if(_===l)return l;if(typeof W=="boolean")return _;if(W){const ce=W.when;if(typeof ce=="string"){const ne=(ye,ge,Y,U)=>{if(!U||!_(ye,ge))return null;const oe=ce.replace("$(basename)",()=>Y),ve=U(oe);return(0,h.$sh)(ve)?ve.then(te=>te?H:null):ve?H:null};return ne.requiresSiblings=!0,ne}}return _}function B(H,W){const X=H.filter(ge=>!!ge.basenames);if(X.length<2)return H;const _=X.reduce((ge,Y)=>{const U=Y.basenames;return U?ge.concat(U):ge},[]);let ce;if(W){ce=[];for(let ge=0,Y=_.length;ge<Y;ge++)ce.push(W)}else ce=X.reduce((ge,Y)=>{const U=Y.patterns;return U?ge.concat(U):ge},[]);const ne=function(ge,Y){if(typeof ge!="string")return null;if(!Y){let oe;for(oe=ge.length;oe>0;oe--){const ve=ge.charCodeAt(oe-1);if(ve===A.CharCode.Slash||ve===A.CharCode.Backslash)break}Y=ge.substr(oe)}const U=_.indexOf(Y);return U!==-1?ce[U]:null};ne.basenames=_,ne.patterns=ce,ne.allBasenames=_;const ye=H.filter(ge=>!ge.basenames);return ye.push(ne),ye}function ee(H,W){return(0,r.$ub)(H,W,(X,_)=>typeof X=="string"&&typeof _=="string"?X===_:typeof X!="string"&&typeof _!="string"?X.base===_.base&&X.pattern===_.pattern:!1)}}),define(ke[85],Ie([1,0,13,138,22,12,2]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.MarkdownStringTextNewlineStyle=void 0,e.$6k=c,e.$7k=I,e.$8k=y,e.$9k=u,e.$0k=C,e.$$k=w,e.$_k=a,e.$al=m;var O;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(O||(e.MarkdownStringTextNewlineStyle=O={}));class b{constructor(f="",i=!1){if(this.value=f,typeof this.value!="string")throw(0,r.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(f,i=O.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Yk)(f):f).replace(/([ \t]+)/g,(s,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===O.Break?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,i){return this.value+=`
${C(i,f)}
`,this}appendLink(f,i,s){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(f),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(f,i){const s=new RegExp((0,R.$if)(i),"g");return f.replace(s,(t,o)=>f.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$5k=b;function c($){return I($)?!$.value:Array.isArray($)?$.every(c):!0}function I($){return $ instanceof b?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}function y($,f){return $===f?!0:!$||!f?!1:$.value===f.value&&$.isTrusted===f.isTrusted&&$.supportThemeIcons===f.supportThemeIcons&&$.supportHtml===f.supportHtml&&($.baseUri===f.baseUri||!!$.baseUri&&!!f.baseUri&&(0,A.$ah)(T.URI.from($.baseUri),T.URI.from(f.baseUri)))}function u($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function C($,f){const i=$.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,s=i>=3?i+1:3;return[`${"`".repeat(s)}${f}`,$,`${"`".repeat(s)}`].join(`
`)}function w($){return $.replace(/"/g,"&quot;")}function a($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m($){const f=[],i=$.split("|").map(t=>t.trim());$=i[0];const s=i[1];if(s){const t=/height=(\d+)/.exec(s),o=/width=(\d+)/.exec(s),n=t?t[1]:"",d=o?o[1]:"",l=isFinite(parseInt(d)),g=isFinite(parseInt(n));l&&f.push(`width="${d}"`),g&&f.push(`height="${n}"`)}return{href:$,dimensions:f}}}),define(ke[107],Ie([1,0,18,31,16,10,22,12]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2w=b,e.$3w=I,e.$4w=u,e.$5w=C,e.$6w=$,e.$7w=i,e.$8w=s,e.$9w=t,e.$0w=o,e.$$w=n;function b(l,g){const{os:E,tildify:S,relative:D}=g;if(D){const p=c(l,D,E);if(typeof p=="string")return p}let k=l.fsPath;if(E===R.OperatingSystem.Windows&&!R.$j?k=k.replace(/\//g,"\\"):E!==R.OperatingSystem.Windows&&R.$j&&(k=k.replace(/\\/g,"/")),E!==R.OperatingSystem.Windows&&S?.userHome){const p=S.userHome.fsPath;let v;l.scheme!==S.userHome.scheme&&l.path[0]===A.$hc.sep&&l.path[1]!==A.$hc.sep?v=S.userHome.with({path:l.path}).fsPath:v=k,k=u(v,p,E)}return(E===R.OperatingSystem.Windows?A.$gc:A.$hc).normalize(I(k,E===R.OperatingSystem.Windows))}function c(l,g,E){const S=E===R.OperatingSystem.Windows?A.$gc:A.$hc,D=E===R.OperatingSystem.Linux?T.$0g:T.$_g,k=g.getWorkspace(),P=(0,r.$Ob)(k.folders);if(!P)return;l.scheme!==P.uri.scheme&&l.path[0]===A.$hc.sep&&l.path[1]!==A.$hc.sep&&(l=P.uri.with({path:l.path}));const p=g.getWorkspaceFolder(l);if(!p)return;let v;if(D.isEqual(p.uri,l)?v="":v=D.relativePath(p.uri,l)??"",v&&(v=S.normalize(v)),k.folders.length>1&&!g.noPrefix){const F=p.name?p.name:D.basenameOrAuthority(p.uri);v=v?`${F} \u2022 ${v}`:F}return v}function I(l,g=R.$j){return(0,h.$Kg)(l,g)?l.charAt(0).toUpperCase()+l.slice(1):l}let y=Object.create(null);function u(l,g,E=R.OS){if(E===R.OperatingSystem.Windows||!l||!g)return l;let S=y.original===g?y.normalized:void 0;S||(S=g,R.$j&&(S=(0,h.$zg)(S)),S=`${(0,O.$of)(S,A.$hc.sep)}${A.$hc.sep}`,y={original:g,normalized:S});let D=l;return R.$j&&(D=(0,h.$zg)(D)),(E===R.OperatingSystem.Linux?D.startsWith(S):(0,O.$Hf)(D,S))?`~/${D.substr(S.length)}`:l}function C(l,g){return l.replace(/^~($|\/|\\)/,`${g}$1`)}const w="\u2026",a="\\\\",m="~";function $(l,g=A.sep){const E=new Array(l.length);let S=!1;for(let D=0;D<l.length;D++){const k=l[D];if(k===""){E[D]=`.${g}`;continue}if(!k){E[D]=k;continue}S=!0;let P="",p=k;p.indexOf(a)===0?(P=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(g)===0?(P=p.substr(0,p.indexOf(g)+g.length),p=p.substr(p.indexOf(g)+g.length)):p.indexOf(m)===0&&(P=p.substr(0,p.indexOf(m)+m.length),p=p.substr(p.indexOf(m)+m.length));const v=p.split(g);for(let F=1;S&&F<=v.length;F++)for(let N=v.length-F;S&&N>=0;N--){S=!1;let L=v.slice(N,N+F).join(g);for(let M=0;!S&&M<l.length;M++)if(M!==D&&l[M]&&l[M].indexOf(L)>-1){const z=N+F===v.length,j=N>0&&l[M].indexOf(g)>-1?g+L:L,q=l[M].endsWith(j);S=!z||q}if(!S){let M="";(v[0].endsWith(":")||P!=="")&&(N===1&&(N=0,F++,L=v[0]+g+L),N>0&&(M=v[0]+g),M=P+M),N>0&&(M=M+w+g),M=M+L,N+F<v.length&&(M=M+g+w),E[D]=M}}S&&(E[D]=k)}return E}var f;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function i(l,g=Object.create(null)){const E=[];let S=!1,D="";for(const k of l)if(k==="$"||S&&k==="{")D&&E.push({value:D,type:f.TEXT}),D="",S=!0;else if(k==="}"&&S){const P=g[D];if(typeof P=="string")P.length&&E.push({value:P,type:f.VARIABLE});else if(P){const p=E[E.length-1];(!p||p.type!==f.SEPARATOR)&&E.push({value:P.label,type:f.SEPARATOR})}D="",S=!1}else D+=k;return D&&!S&&E.push({value:D,type:f.TEXT}),E.filter((k,P)=>{if(k.type===f.SEPARATOR){const p=E[P-1],v=E[P+1];return[p,v].every(F=>F&&(F.type===f.VARIABLE||F.type===f.TEXT)&&F.value.length>0)}return!0}).map(k=>k.value).join("")}function s(l,g){return R.$k||g?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):l.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(l,g){return R.$k||g?l.replace(/\(&&\w\)|&&/g,""):R.$j?l.replace(/&&|&/g,E=>E==="&"?"&&":"&"):l.replace(/&&/g,"_")}function o(l){return l.replace(/&/g,"&&")}function n(l){if(l.endsWith("]")){const g=l.lastIndexOf(" [",l.length-2);if(g!==-1){const E=d(l.substring(0,g)),S=l.substring(g);return{name:E.name+S,parentPath:E.parentPath}}}return d(l)}function d(l){const g=l.indexOf("/")!==-1?A.$hc:A.$gc,E=g.basename(l),S=g.dirname(l);return E.length?{name:E,parentPath:S}:{name:S,parentPath:""}}}),define(ke[139],Ie([1,0,21,40,2]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=void 0,e.$Pn=b,e.$Qn=I,e.$Rn=y;function R(u){return u.toJSON()}class T{constructor(C){this.a=C}transformIncoming(C){const w=this.a.transformIncoming(C);return w===C?C:R(A.URI.from(w))}transformOutgoing(C){const w=this.a.transformOutgoing(C);return w===C?C:R(A.URI.from(w))}transformOutgoingURI(C){const w=this.a.transformOutgoing(C);return w===C?C:A.URI.from(w)}transformOutgoingScheme(C){return this.a.transformOutgoingScheme(C)}}e.$Nn=T,e.$On=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function O(u,C,w){if(!u||w>200)return null;if(typeof u=="object"){if(u instanceof A.URI)return C.transformOutgoing(u);for(const a in u)if(Object.hasOwnProperty.call(u,a)){const m=O(u[a],C,w+1);m!==null&&(u[a]=m)}}return null}function b(u,C){const w=O(u,C,0);return w===null?u:w}function c(u,C,w,a){if(!u||a>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return w?A.URI.revive(C.transformIncoming(u)):C.transformIncoming(u);if(u instanceof r.$Oe)return null;for(const m in u)if(Object.hasOwnProperty.call(u,m)){const $=c(u[m],C,w,a+1);$!==null&&(u[m]=$)}}return null}function I(u,C){const w=c(u,C,!1,0);return w===null?u:w}function y(u,C){const w=c(u,C,!0,0);return w===null?u:w}}),define(ke[32],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(A){return r.test(A)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(O){for(let b=0;b<O.length;b++)O[b]=Math.floor(Math.random()*256);return O};const R=new Uint8Array(16),T=[];for(let O=0;O<256;O++)T.push(O.toString(16).padStart(2,"0"));return function(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let b=0,c="";return c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c+="-",c+=T[R[b++]],c+=T[R[b++]],c+="-",c+=T[R[b++]],c+=T[R[b++]],c+="-",c+=T[R[b++]],c+=T[R[b++]],c+="-",c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c+=T[R[b++]],c}}()}),define(ke[190],Ie([1,0,18,39,32]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uu=e.$su=void 0,e.$qu=R,e.$ru=T,e.$tu=c;function R(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function T(y,u,C){const w={id:(0,A.$3g)(),name:y,uri:u,data:C};return{asString:async()=>"",asFile:()=>w,value:void 0}}class O{constructor(){this.a=new Map}get size(){let u=0;for(const C of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const C=[...this.a.keys()];return h.Iterable.some(this,([w,a])=>a.asFile())&&C.push("files"),I(b(u),C)}get(u){return this.a.get(this.b(u))?.[0]}append(u,C){const w=this.a.get(u);w?w.push(C):this.a.set(this.b(u),[C])}replace(u,C){this.a.set(this.b(u),[C])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,C]of this.a)for(const w of C)yield[u,w]}b(u){return b(u)}}e.$su=O;function b(y){return y.toLowerCase()}function c(y,u){return I(b(y),u.map(b))}function I(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const C=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!C)return!1;const[w,a,m]=C;return m==="*"?u.some($=>$.startsWith(a+"/")):!1}e.$uu=Object.freeze({create:y=>(0,r.$Mb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$uu.split(y).filter(u=>!u.startsWith("#"))})}),define(ke[33],Ie([1,0,45,66,360,7,31,81,16,10,22,2]),function($e,e,r,h,A,R,T,O,b,c,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=o,e.configureFlushOnWrite=E,e.writeFileSync=D,r=We(r);var u;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function C(j,q=u.UNLINK,B){if((0,T.$Jg)(j))throw new Error("rimraf - will refuse to recursively delete root");return q===u.UNLINK?a(j):w(j,B)}async function w(j,q=(0,T.$Og)((0,h.tmpdir)())){try{try{await r.promises.rename(j,q)}catch(B){return B.code==="ENOENT"?void 0:a(j)}a(q).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function a(j){return r.promises.rm(j,{recursive:!0,force:!0,maxRetries:3})}function m(j){if((0,T.$Jg)(j))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}async function $(j,q){return s(await(q?f(j):r.promises.readdir(j)))}async function f(j){try{return await r.promises.readdir(j,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const q=[],B=await $(j);for(const ee of B){let H=!1,W=!1,X=!1;try{const _=await r.promises.lstat((0,b.$kc)(j,ee));H=_.isFile(),W=_.isDirectory(),X=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}q.push({name:ee,isFile:()=>H,isDirectory:()=>W,isSymbolicLink:()=>X})}return q}function i(j){return s(r.readdirSync(j))}function s(j){return j.map(q=>typeof q=="string"?c.$k?(0,O.$om)(q):q:(q.name=c.$k?(0,O.$om)(q.name):q.name,q))}async function t(j){const q=await $(j),B=[];for(const ee of q)await n.existsDirectory((0,b.$kc)(j,ee))&&B.push(ee);return B}function o(j,q=1e3){return new Promise(B=>{let ee=!1;const H=setInterval(()=>{ee||(ee=!0,r.access(j,W=>{ee=!1,W&&(clearInterval(H),B(void 0))}))},q)})}var n;(function(j){async function q(H){let W;try{if(W=await r.promises.lstat(H),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await r.promises.stat(H),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(c.$j&&X.code==="EACCES")try{return{stat:await r.promises.stat(await r.promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw _}throw X}}j.stat=q;async function B(H){try{const{stat:W,symbolicLink:X}=await j.stat(H);return W.isFile()&&X?.dangling!==!0}catch{}return!1}j.existsFile=B;async function ee(H){try{const{stat:W,symbolicLink:X}=await j.stat(H);return W.isDirectory()&&X?.dangling!==!0}catch{}return!1}j.existsDirectory=ee})(n||(e.SymlinkSupport=n={}));const d=new R.$Ph;function l(j,q,B){return d.queueFor(y.URI.file(j),()=>{const ee=k(B);return new Promise((H,W)=>S(j,q,ee,X=>X?W(X):H()))},I.$$g)}let g=!0;function E(j){g=j}function S(j,q,B,ee){if(!g)return r.writeFile(j,q,{mode:B.mode,flag:B.flag},ee);r.open(j,B.flag,B.mode,(H,W)=>{if(H)return ee(H);r.writeFile(W,q,X=>{if(X)return r.close(W,()=>ee(X));r.fdatasync(W,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),E(!1)),r.close(W,ce=>ee(ce))))})})}function D(j,q,B){const ee=k(B);if(!g)return r.writeFileSync(j,q,{mode:ee.mode,flag:ee.flag});const H=r.openSync(j,ee.flag,ee.mode);try{r.writeFileSync(H,q);try{r.fdatasyncSync(H)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),E(!1)}}finally{r.closeSync(H)}}function k(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function P(j,q,B=6e4){if(j!==q)try{c.$j&&typeof B=="number"?await p(j,q,Date.now(),B):await r.promises.rename(j,q)}catch(ee){if(j.toLowerCase()!==q.toLowerCase()&&ee.code==="EXDEV"||j.endsWith("."))await v(j,q,{preserveSymlinks:!1}),await C(j,u.MOVE);else throw ee}}async function p(j,q,B,ee,H=0){try{return await r.promises.rename(j,q)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-B>=ee)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${W}`),W;if(H===0){let X=!1;try{const{stat:_}=await n.stat(q);_.isFile()||(X=!0)}catch{}if(X)throw W}return await(0,R.$Hh)(Math.min(100,H*10)),p(j,q,B,ee,H+1)}}async function v(j,q,B){return N(j,q,{root:{source:j,target:q},options:B,handledSourcePaths:new Set})}const F=511;async function N(j,q,B){if(B.handledSourcePaths.has(j))return;B.handledSourcePaths.add(j);const{stat:ee,symbolicLink:H}=await n.stat(j);if(H){if(B.options.preserveSymlinks)try{return await z(j,q,B)}catch{}if(H.dangling)return}return ee.isDirectory()?L(j,q,ee.mode&F,B):M(j,q,ee.mode&F)}async function L(j,q,B,ee){await r.promises.mkdir(q,{recursive:!0,mode:B});const H=await $(j);for(const W of H)await N((0,b.$kc)(j,W),(0,b.$kc)(q,W),ee)}async function M(j,q,B){await r.promises.copyFile(j,q),await r.promises.chmod(q,B)}async function z(j,q,B){let ee=await r.promises.readlink(j);(0,T.$Fg)(ee,B.root.source,!c.$l)&&(ee=(0,b.$kc)(B.root.target,ee.substr(B.root.source.length+1))),await r.promises.symlink(ee,q)}e.Promises=new class{get read(){return(j,q,B,ee,H)=>new Promise((W,X)=>{r.read(j,q,B,ee,H,(_,ce,ne)=>_?X(_):W({bytesRead:ce,buffer:ne}))})}get write(){return(j,q,B,ee,H)=>new Promise((W,X)=>{r.write(j,q,B,ee,H,(_,ce,ne)=>_?X(_):W({bytesWritten:ce,buffer:ne}))})}get fdatasync(){return(0,A.promisify)(r.fdatasync)}get open(){return(0,A.promisify)(r.open)}get close(){return(0,A.promisify)(r.close)}get realpath(){return(0,A.promisify)(r.realpath)}async exists(j){try{return await r.promises.access(j),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return C}get rename(){return P}get copy(){return v}}}),define(ke[108],Ie([1,0,45,16,10,12,33]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=O,e.$nr=b,e.$or=c,e.$pr=I,r=We(r);function O(u){if(A.$l)return u;const C=(0,h.$nc)(u);if(u===C)return u;const w=((0,h.$oc)(u)||u).toLowerCase();try{const m=(0,T.readdirSync)(C).filter($=>$.toLowerCase()===w);if(m.length===1){const $=O(C);if($)return(0,h.$kc)($,m[0])}else if(m.length>1){const $=m.indexOf(w);if($>=0){const f=O(C);if(f)return(0,h.$kc)(f,m[$])}}}catch{}return null}async function b(u,C){if(A.$l)return u;const w=(0,h.$nc)(u);if(u===w)return u;const a=((0,h.$oc)(u)||u).toLowerCase();try{if(C?.isCancellationRequested)return null;const $=(await T.Promises.readdir(w)).filter(f=>f.toLowerCase()===a);if($.length===1){const f=await b(w,C);if(f)return(0,h.$kc)(f,$[0])}else if($.length>1){const f=$.indexOf(a);if(f>=0){const i=await b(w,C);if(i)return(0,h.$kc)(i,$[f])}}}catch{}return null}async function c(u){try{return await T.Promises.realpath(u)}catch{const w=y(u);return await r.promises.access(w,r.constants.R_OK),w}}function I(u){try{return r.realpathSync(u)}catch{const w=y(u);return r.accessSync(w,r.constants.R_OK),w}}function y(u){return(0,R.$of)((0,h.$ic)(u),h.sep)}}),define(ke[191],Ie([1,0,67]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=void 0,e.$5g=h,e.$7g=R,r=We(r);function h(O,b,c,I=1){let y=!1;return new Promise(u=>{const C=setTimeout(()=>{if(!y)return y=!0,u(0)},c);A(O,b,I,w=>{if(!y)return y=!0,clearTimeout(C),u(w)})})}function A(O,b,c,I){if(b===0)return I(0);const y=new r.Socket;y.once("connect",()=>(T(y),A(O+c,b-1,c,I))),y.once("data",()=>{}),y.once("error",u=>(T(y),u.code!=="ECONNREFUSED"?A(O+c,b-1,c,I):I(O))),y.connect(O,"127.0.0.1")}e.$6g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(O,b,c,I="127.0.0.1"){let y=!1,u,C=1;const w=r.createServer({pauseOnConnect:!0});function a(m,$){y||(y=!0,w.removeAllListeners(),w.close(),u&&clearTimeout(u),$(m))}return new Promise(m=>{u=setTimeout(()=>{a(0,m)},c),w.on("listening",()=>{a(O,m)}),w.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&C<b?(O++,C++,w.listen(O,I)):a(0,m)}),w.on("close",()=>{a(0,m)}),w.listen(O,I)})}function T(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch(b){console.error(b)}}}),define(ke[109],Ie([1,0,45,16,10,55,104,17,33]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$zm=c,e.$Am=I,h=We(h),A=We(A),R=We(R),O=We(O),b=We(b),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function c(u=R.env){return u.comspec||"cmd.exe"}function I(u){let C=[],w=!1;const a=function(m){if(w){C.push(m);return}(!u.send(m,f=>{if(f&&console.error(f),w=!1,C.length>0){const i=C.slice(0);C=[],i.forEach(s=>a(s))}})||A.$j)&&(w=!0)};return{send:a}}var y;(function(u){async function C(w,a,m){if(h.$jc(w))return w;if(a===void 0&&(a=R.cwd()),h.$nc(w)!=="."||(m===void 0&&O.$fg(R.env.PATH)&&(m=R.env.PATH.split(h.$uc)),m===void 0||m.length===0))return h.$kc(a,w);async function f(i){if(await b.Promises.exists(i)){let s;try{s=await r.promises.stat(i)}catch(t){t.message.startsWith("EACCES")&&(s=await r.promises.lstat(i))}return s?!s.isDirectory():!1}return!1}for(const i of m){let s;if(h.$jc(i)?s=h.$kc(i,w):s=h.$kc(a,i,w),await f(s))return s;let t=s+".com";if(await f(t)||(t=s+".exe",await f(t)))return t}return h.$kc(a,w)}u.findExecutable=C})(y||(e.win32=y={}))});var Je=this&&this.__decorate||function($e,e,r,h){var A=arguments.length,R=A<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($e,e,r,h);else for(var O=$e.length-1;O>=0;O--)(T=$e[O])&&(R=(A<3?T(R):A>3?T(e,r,R):T(e,r))||R);return A>3&&R&&Object.defineProperty(e,r,R),R};define(ke[86],Ie([1,0,18,7,21,20,59,13,4,3,44,12,17]),function($e,e,r,h,A,R,T,O,b,c,I,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=E,e.$hi=S,e.$mi=F,e.$ni=N,y=We(y);var C;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(C||(C={}));function w(H){switch(H){case C.Promise:return"req";case C.PromiseCancel:return"cancel";case C.EventListen:return"subscribe";case C.EventDispose:return"unsubscribe"}}var a;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(a||(a={}));function m(H){switch(H){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var $;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})($||($={}));function f(H){let W=0;for(let X=0;;X+=7){const _=H.read(1);if(W|=(_.buffer[0]&127)<<X,!(_.buffer[0]&128))return W}}const i=d(0);function s(H,W){if(W===0){H.write(i);return}let X=0;for(let ce=W;ce!==0;ce=ce>>>7)X++;const _=A.$Oe.alloc(X);for(let ce=0;W!==0;ce++)_.buffer[ce]=W&127,W=W>>>7,W>0&&(_.buffer[ce]|=128);H.write(_)}class t{constructor(W){this.b=W,this.a=0}read(W){const X=this.b.slice(this.a,this.a+W);return this.a+=X.byteLength,X}}e.$ei=t;class o{constructor(){this.a=[]}get buffer(){return A.$Oe.concat(this.a)}write(W){this.a.push(W)}}e.$fi=o;var n;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(n||(n={}));function d(H){const W=A.$Oe.alloc(1);return W.writeUInt8(H,0),W}const l={Undefined:d(n.Undefined),String:d(n.String),Buffer:d(n.Buffer),VSBuffer:d(n.VSBuffer),Array:d(n.Array),Object:d(n.Object),Uint:d(n.Int)},g=typeof Buffer<"u";function E(H,W){if(typeof W>"u")H.write(l.Undefined);else if(typeof W=="string"){const X=A.$Oe.fromString(W);H.write(l.String),s(H,X.byteLength),H.write(X)}else if(g&&Buffer.isBuffer(W)){const X=A.$Oe.wrap(W);H.write(l.Buffer),s(H,X.byteLength),H.write(X)}else if(W instanceof A.$Oe)H.write(l.VSBuffer),s(H,W.byteLength),H.write(W);else if(Array.isArray(W)){H.write(l.Array),s(H,W.length);for(const X of W)E(H,X)}else if(typeof W=="number"&&(W|0)===W)H.write(l.Uint),s(H,W);else{const X=A.$Oe.fromString(JSON.stringify(W));H.write(l.Object),s(H,X.byteLength),H.write(X)}}function S(H){switch(H.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return H.read(f(H)).toString();case n.Buffer:return H.read(f(H)).buffer;case n.VSBuffer:return H.read(f(H));case n.Array:{const X=f(H),_=[];for(let ce=0;ce<X;ce++)_.push(S(H));return _}case n.Object:return JSON.parse(H.read(f(H)).toString());case n.Int:return f(H)}}class D{constructor(W,X,_=null,ce=1e3){this.h=W,this.j=X,this.k=_,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:a.Initialize})}registerChannel(W,X){this.b.set(W,X),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case a.Initialize:{const X=this.o([W.type]);this.k?.logOutgoing(X,0,k.OtherSide,m(W.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const X=this.o([W.type,W.id],W.data);this.k?.logOutgoing(X,W.id,k.OtherSide,m(W.type),W.data);return}}}o(W,X=void 0){const _=new o;return E(_,W),E(_,X),this.p(_.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const X=new t(W),_=S(X),ce=S(X),ne=_[0];switch(ne){case C.Promise:return this.k?.logIncoming(W.byteLength,_[1],k.OtherSide,`${w(ne)}: ${_[2]}.${_[3]}`,ce),this.s({type:ne,id:_[1],channelName:_[2],name:_[3],arg:ce});case C.EventListen:return this.k?.logIncoming(W.byteLength,_[1],k.OtherSide,`${w(ne)}: ${_[2]}.${_[3]}`,ce),this.t({type:ne,id:_[1],channelName:_[2],name:_[3],arg:ce});case C.PromiseCancel:return this.k?.logIncoming(W.byteLength,_[1],k.OtherSide,`${w(ne)}`),this.u({type:ne,id:_[1]});case C.EventDispose:return this.k?.logIncoming(W.byteLength,_[1],k.OtherSide,`${w(ne)}`),this.u({type:ne,id:_[1]})}}s(W){const X=this.b.get(W.channelName);if(!X){this.v(W);return}const _=new R.$xe;let ce;try{ce=X.call(this.j,W.name,W.arg,_.token)}catch(ge){ce=Promise.reject(ge)}const ne=W.id;ce.then(ge=>{this.m({id:ne,data:ge,type:a.PromiseSuccess})},ge=>{ge instanceof Error?this.m({id:ne,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split(`
`):void 0},type:a.PromiseError}):this.m({id:ne,data:ge,type:a.PromiseErrorObj})}).finally(()=>{ye.dispose(),this.d.delete(W.id)});const ye=(0,c.$Tc)(()=>_.cancel());this.d.set(W.id,ye)}t(W){const X=this.b.get(W.channelName);if(!X){this.v(W);return}const _=W.id,ne=X.listen(this.j,W.name,W.arg)(ye=>this.m({id:_,data:ye,type:a.EventFire}));this.d.set(W.id,ne)}u(W){const X=this.d.get(W.id);X&&(X.dispose(),this.d.delete(W.id))}v(W){let X=this.g.get(W.channelName);X||(X=[],this.g.set(W.channelName,X));const _=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===C.Promise&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);X.push({request:W,timeoutTimer:_})}w(W){const X=this.g.get(W);if(X){for(const _ of X)switch(clearTimeout(_.timeoutTimer),_.request.type){case C.Promise:this.s(_.request);break;case C.EventListen:this.t(_.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Qc)(this.d.values()),this.d.clear()}}e.$ii=D;var k;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class P{constructor(W,X=null){this.l=W,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=X}getChannel(W){const X=this;return{call(_,ce,ne){return X.a?Promise.reject(new O.$5):X.m(W,_,ce,ne)},listen(_,ce){return X.a?b.Event.None:X.o(W,_,ce)}}}m(W,X,_,ce=R.CancellationToken.None){const ne=this.g++,ye=C.Promise,ge={id:ne,type:ye,channelName:W,name:X,arg:_};if(ce.isCancellationRequested)return Promise.reject(new O.$5);let Y;return new Promise((oe,ve)=>{if(ce.isCancellationRequested)return ve(new O.$5);const te=()=>{const re=pe=>{switch(pe.type){case a.PromiseSuccess:this.f.delete(ne),oe(pe.data);break;case a.PromiseError:{this.f.delete(ne);const we=new Error(pe.data.message);we.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,we.name=pe.data.name,ve(we);break}case a.PromiseErrorObj:this.f.delete(ne),ve(pe.data);break}};this.f.set(ne,re),this.p(ge)};let ae=null;this.b===$.Idle?te():(ae=(0,h.$th)(re=>this.u()),ae.then(()=>{ae=null,te()}));const se=()=>{ae?(ae.cancel(),ae=null):this.p({id:ne,type:C.PromiseCancel}),ve(new O.$5)},Z=ce.onCancellationRequested(se);Y=(0,c.$Sc)((0,c.$Tc)(se),Z),this.d.add(Y)}).finally(()=>{Y.dispose(),this.d.delete(Y)})}o(W,X,_){const ce=this.g++,ne=C.EventListen,ye={id:ce,type:ne,channelName:W,name:X,arg:_};let ge=null;const Y=new b.$me({onWillAddFirstListener:()=>{ge=(0,h.$th)(oe=>this.u()),ge.then(()=>{ge=null,this.d.add(Y),this.p(ye)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(Y),this.p({id:ce,type:C.EventDispose}))}}),U=oe=>Y.fire(oe.data);return this.f.set(ce,U),Y.event}p(W){switch(W.type){case C.Promise:case C.EventListen:{const X=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(X,W.id,k.LocalSide,`${w(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case C.PromiseCancel:case C.EventDispose:{const X=this.q([W.type,W.id]);this.j?.logOutgoing(X,W.id,k.LocalSide,w(W.type));return}}}q(W,X=void 0){const _=new o;return E(_,W),E(_,X),this.r(_.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const X=new t(W),_=S(X),ce=S(X),ne=_[0];switch(ne){case a.Initialize:return this.j?.logIncoming(W.byteLength,0,k.LocalSide,m(ne)),this.t({type:_[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(W.byteLength,_[1],k.LocalSide,m(ne),ce),this.t({type:_[0],id:_[1],data:ce})}}t(W){if(W.type===a.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Qc)(this.d.values()),this.d.clear()}}e.$ji=P,Je([T.$$h],P.prototype,"onDidInitializePromise",null);class p{get connections(){const W=[];return this.f.forEach(X=>W.push(X)),W}constructor(W,X,_){this.a=new Map,this.f=new Set,this.g=new b.$me,this.onDidAddConnection=this.g.event,this.h=new b.$me,this.onDidRemoveConnection=this.h.event,this.j=new c.$Uc,this.j.add(W(({protocol:ce,onDidClientDisconnect:ne})=>{const ye=b.Event.once(ce.onMessage);this.j.add(ye(ge=>{const Y=new t(ge),U=S(Y),oe=new D(ce,U,X,_),ve=new P(ce,X);this.a.forEach((ae,se)=>oe.registerChannel(se,ae));const te={channelServer:oe,channelClient:ve,ctx:U};this.f.add(te),this.g.fire(te),this.j.add(ne(()=>{oe.dispose(),ve.dispose(),this.f.delete(te),this.h.fire(te)}))}))}))}getChannel(W,X){const _=this;return{call(ce,ne,ye){let ge;if((0,u.$tg)(X)){const U=(0,r.$3b)(_.connections.filter(X));ge=U?Promise.resolve(U):b.Event.toPromise(b.Event.filter(_.onDidAddConnection,X))}else ge=X.routeCall(_,ce,ne);const Y=ge.then(U=>U.channelClient.getChannel(W));return F(Y).call(ce,ne,ye)},listen(ce,ne){if((0,u.$tg)(X))return _.k(W,X,ce,ne);const ye=X.routeEvent(_,ce,ne).then(ge=>ge.channelClient.getChannel(W));return F(ye).listen(ce,ne)}}}k(W,X,_,ce){const ne=this;let ye;const ge=new b.$me({onWillAddFirstListener:()=>{ye=new c.$Uc;const Y=new b.$se,U=new Map,oe=te=>{const se=te.channelClient.getChannel(W).listen(_,ce),Z=Y.add(se);U.set(te,Z)},ve=te=>{const ae=U.get(te);ae&&(ae.dispose(),U.delete(te))};ne.connections.filter(X).forEach(oe),b.Event.filter(ne.onDidAddConnection,X)(oe,void 0,ye),ne.onDidRemoveConnection(ve,void 0,ye),Y.event(ge.fire,ge,ye),ye.add(Y)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return ge.event}registerChannel(W,X){this.a.set(W,X);for(const _ of this.f)_.channelServer.registerChannel(W,X)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=p;class v{constructor(W,X,_=null){const ce=new o;E(ce,X),W.send(ce.buffer),this.a=new P(W,_),this.d=new D(W,X,_)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,X){this.d.registerChannel(W,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=v;function F(H){return{call(W,X,_){return H.then(ce=>ce.call(W,X,_))},listen(W,X){const _=new b.$ve;return H.then(ce=>_.input=ce.listen(W,X)),_.event}}}function N(H){let W=!1;return{call(X,_,ce){return W?H.call(X,_,ce):(0,h.$Hh)(0).then(()=>W=!0).then(()=>H.call(X,_,ce))},listen(X,_){if(W)return H.listen(X,_);const ce=new b.$ve;return(0,h.$Hh)(0).then(()=>W=!0).then(()=>ce.input=H.listen(X,_)),ce.event}}}class L{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const X of W.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await b.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$oi=L;var M;(function(H){function W(ne,ye,ge){const Y=ne,U=ge&&ge.disableMarshalling,oe=new Map;for(const ve in Y)_(ve)&&oe.set(ve,b.Event.buffer(Y[ve],!0,void 0,ye));return new class{listen(ve,te,ae){const se=oe.get(te);if(se)return se;const Z=Y[te];if(typeof Z=="function"){if(ce(te))return Z.call(Y,ae);if(_(te))return oe.set(te,b.Event.buffer(Y[te],!0,void 0,ye)),oe.get(te)}throw new O.$bb(`Event not found: ${te}`)}call(ve,te,ae){const se=Y[te];if(typeof se=="function"){if(!U&&Array.isArray(ae))for(let re=0;re<ae.length;re++)ae[re]=(0,I.$di)(ae[re]);let Z=se.apply(Y,ae);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new O.$bb(`Method not found: ${te}`)}}}H.fromService=W;function X(ne,ye){const ge=ye&&ye.disableMarshalling;return new Proxy({},{get(Y,U){if(typeof U=="string")return ye?.properties?.has(U)?ye.properties.get(U):ce(U)?function(oe){return ne.listen(U,oe)}:_(U)?ne.listen(U):async function(...oe){let ve;ye&&!(0,u.$og)(ye.context)?ve=[ye.context,...oe]:ve=oe;const te=await ne.call(U,ve);return ge?te:(0,I.$di)(te)};throw new O.$bb(`Property not found: ${String(U)}`)}})}H.toService=X;function _(ne){return ne[0]==="o"&&ne[1]==="n"&&y.$Ff(ne.charCodeAt(2))}function ce(ne){return/^onDynamic/.test(ne)&&y.$Ff(ne.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const W=H.toString();if(W!=="[object Object]")return W}return H}function q(H){return Array.isArray(H)?H.map(j):j(H)}function B(H,W,X,_,ce,ne,ye){ye=q(ye);const ge=z[ce],Y=ge[_%ge.length];let U=[`%c[${H}]%c[${String(W).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(ne)?(U=U.concat(ye),U.push(")")):U.push(ye),console.log.apply(console,U)}class ee{constructor(W,X){this.d=W,this.f=X,this.a=0,this.b=0}logOutgoing(W,X,_,ce,ne){this.b+=W,B(this.d,this.b,W,X,_,ce,ne)}logIncoming(W,X,_,ce,ne){this.a+=W,B(this.f,this.a,W,X,_,ce,ne)}}e.$pi=ee}),define(ke[68],Ie([1,0,21,4,3,86]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.ProtocolConstants=e.$qi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var O;(function(l){l.enableDiagnostics=!1,l.records=[];const g=new WeakMap;let E=0;function S(k,P){if(!g.has(k)){const p=String(++E);g.set(k,p)}return g.get(k)}function D(k,P,p,v){if(!l.enableDiagnostics)return;const F=S(k,P);if(v instanceof r.$Oe||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const N=r.$Oe.alloc(v.byteLength);N.set(v),l.records.push({timestamp:Date.now(),id:F,label:P,type:p,buff:N})}else l.records.push({timestamp:Date.now(),id:F,label:P,type:p,data:v})}l.traceSocketEvent=D})(O||(e.SocketDiagnostics=O={}));var b;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let c=null;function I(){return c||(c=r.$Oe.alloc(0)),c}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(g){this.a.push(g),this.b+=g.byteLength}read(g){return this.c(g,!0)}peek(g){return this.c(g,!1)}c(g,E){if(g===0)return I();if(g>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===g){const P=this.a[0];return E&&(this.a.shift(),this.b-=g),P}if(this.a[0].byteLength>g){const P=this.a[0].slice(0,g);return E&&(this.a[0]=this.a[0].slice(g),this.b-=g),P}const S=r.$Oe.alloc(g);let D=0,k=0;for(;g>0;){const P=this.a[k];if(P.byteLength>g){const p=P.slice(0,g);S.set(p,D),D+=g,E&&(this.a[k]=P.slice(g),this.b-=g),g-=g}else S.set(P,D),D+=P.byteLength,E?(this.a.shift(),this.b-=P.byteLength):k++,g-=P.byteLength}return S}}e.$qi=y;var u;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(u||(u={}));function C(l){switch(l){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var w;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class a{constructor(g,E,S,D){this.type=g,this.id=E,this.ack=S,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends A.$Vc{constructor(g){super(),this.f=this.B(new h.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:w.HeaderLength,messageType:u.None,id:0,ack:0},this.a=g,this.b=!1,this.c=new y,this.B(this.a.onData(E=>this.acceptChunk(E))),this.lastReadTime=Date.now()}acceptChunk(g){if(!(!g||g.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(g);this.c.byteLength>=this.g.readLen;){const E=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=E.readUInt32BE(9),this.g.messageType=E.readUInt8(0),this.g.id=E.readUInt32BE(1),this.g.ack=E.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:C(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,D=this.g.id,k=this.g.ack;if(this.g.readHead=!0,this.g.readLen=w.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,E),this.f.fire(new a(S,D,k,E)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(g){this.k=null,this.a=!1,this.b=!1,this.c=g,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(g){if(this.a)return;g.writtenTime=Date.now(),this.lastWriteTime=Date.now();const E=r.$Oe.alloc(w.HeaderLength);E.writeUInt8(g.type,0),E.writeUInt32BE(g.id,1),E.writeUInt32BE(g.ack,5),E.writeUInt32BE(g.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:C(g.type),id:g.id,ack:g.ack,messageSize:g.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,g.data),this.j(E,g.data)}g(g,E){const S=this.f===0;return this.d.push(g,E),this.f+=g.byteLength+E.byteLength,S}h(){const g=r.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,g}j(g,E){this.g(g,E)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const g=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:g.byteLength}),this.c.write(g)}}class f extends A.$Vc{constructor(g){super(),this.f=new h.$me,this.onMessage=this.f.event,this.g=new h.$me,this.onDidDispose=this.g.event,this.a=g,this.b=this.B(new $(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(E=>{E.type===u.Regular&&this.f.fire(E.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(g){this.b.write(new a(u.Regular,0,0,g))}}e.$ri=f;class i extends R.$li{static fromSocket(g,E){return new i(new f(g),E)}get onDidDispose(){return this.b.onDidDispose}constructor(g,E,S=null){super(g,E,S),this.b=g}dispose(){super.dispose();const g=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),g.end()}}e.$si=i;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(g){this.b?this.d.length>0?this.d.push(g):this.a.fire(g):this.d.push(g)}flushBuffer(){this.d=[]}}e.$ti=s;class t{constructor(g){this.data=g,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let g=0,E=this.a;for(;E;)E=E.next,g++;return g}peek(){return this.a?this.a.data:null}toArray(){const g=[];let E=0,S=this.a;for(;S;)g[E++]=S.data,S=S.next;return g}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(g){const E=new t(g);if(!this.a){this.a=E,this.b=E;return}this.b.next=E,this.b=E}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const g=Date.now();for(let E=0;E<n.a;E++)this.c[E]=g-1e3*E;setInterval(()=>{for(let E=n.a;E>=1;E--)this.c[E]=this.c[E-1];this.c[0]=Date.now()},1e3)}d(){const g=Date.now(),E=(1+n.a)*1e3;let S=0;for(let D=0;D<n.a;D++)g-this.c[D]<=E&&S++;return 1-S/n.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.d-this.f}constructor(g){this.v=new s,this.onControlMessage=this.v.event,this.w=new s,this.onMessage=this.w.event,this.x=new s,this.onDidDispose=this.x.event,this.y=new s,this.onSocketClose=this.y.event,this.z=new s,this.onSocketTimeout=this.z.event,this.t=g.loadEstimator??n.getInstance(),this.u=g.sendKeepAlive??!0,this.a=!1,this.c=new o,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new A.$Uc,this.p=g.socket,this.q=this.s.add(new $(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(E=>this.A(E))),this.s.add(this.p.onClose(E=>this.y.fire(E))),g.initialChunk&&this.r.acceptChunk(g.initialChunk),this.u?this.m=setInterval(()=>{this.E()},w.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const g=new a(u.Disconnect,0,0,I());this.q.write(g),this.q.flush()}}sendPause(){const g=new a(u.Pause,0,0,I());this.q.write(g)}sendResume(){const g=new a(u.Resume,0,0,I());this.q.write(g)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(g,E){this.a=!0,this.s.dispose(),this.s=new A.$Uc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=g,this.q=this.s.add(new $(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(S=>this.A(S))),this.s.add(this.p.onClose(S=>this.y.fire(S))),this.r.acceptChunk(E)}endAcceptReconnection(){this.a=!1,this.j=this.h;const g=new a(u.Ack,0,this.j,I());this.q.write(g);const E=this.c.toArray();for(let S=0,D=E.length;S<D;S++)this.q.write(E[S]);this.C()}acceptDisconnect(){this.x.fire()}A(g){if(g.ack>this.f){this.f=g.ack;do{const E=this.c.peek();if(E&&E.id<=g.ack)this.c.pop();else break}while(!0)}switch(g.type){case u.None:break;case u.Regular:{if(g.id>this.h)if(g.id!==this.h+1){const E=Date.now();E-this.n>1e4&&(this.n=E,this.q.write(new a(u.ReplayRequest,0,0,I())))}else this.h=g.id,this.k=Date.now(),this.B(),this.w.fire(g.data);break}case u.Control:{this.v.fire(g.data);break}case u.Ack:break;case u.Disconnect:{this.x.fire();break}case u.ReplayRequest:{const E=this.c.toArray();for(let S=0,D=E.length;S<D;S++)this.q.write(E[S]);this.C();break}case u.Pause:{this.q.pause();break}case u.Resume:{this.q.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(g){const E=++this.d;this.j=this.h;const S=new a(u.Regular,E,this.j,g);this.c.push(S),this.a||(this.q.write(S),this.C())}sendControl(g){const E=new a(u.Control,0,0,g);this.q.write(E)}B(){if(this.h<=this.j||this.l)return;const g=Date.now()-this.k;if(g>=w.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},w.AcknowledgeTime-g+5)}C(){if(this.d<=this.f||this.g||this.a)return;const g=this.c.peek(),E=Date.now()-g.writtenTime,S=Date.now()-this.r.lastReadTime,D=Date.now()-this.o;if(E>=w.TimeoutTime&&S>=w.TimeoutTime&&D>=w.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:E,timeSinceLastReceivedSomeData:S});return}const k=Math.max(w.TimeoutTime-E,w.TimeoutTime-S,w.TimeoutTime-D,500);this.g=setTimeout(()=>{this.g=null,this.C()},k)}D(){if(this.h<=this.j)return;this.j=this.h;const g=new a(u.Ack,0,this.j,I());this.q.write(g)}E(){this.j=this.h;const g=new a(u.KeepAlive,0,this.j,I());this.q.write(g)}}e.$ui=d}),define(ke[192],Ie([1,0,56,7,21,20,188,13,4,3,24,109,104,86]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0,O=We(O);class w extends C.$ii{constructor($){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",f=>A.$Oe.wrap(Buffer.from(f,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$ir=w;class a{constructor($,f){this.i=$,this.j=f,this.c=new Set,this.g=new Map,this.h=new b.$me,this.onDidProcessExit=this.h.event;const i=f&&f.timeout?f.timeout:6e4;this.b=new h.$Dh(i),this.d=null,this.f=null}getChannel($){const f=this;return{call(i,s,t){return f.k($,i,s,t)},listen(i,s){return f.l($,i,s)}}}k($,f,i,s=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(O.$6());this.b.cancel();const t=this.n($),o=(0,h.$th)(l=>t.call(f,i,l)),n=s.onCancellationRequested(()=>o.cancel()),d=(0,c.$Tc)(()=>o.cancel());return this.c.add(d),o.finally(()=>{n.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),o}l($,f,i){if(!this.b)return b.Event.None;this.b.cancel();let s;const t=new b.$me({onWillAddFirstListener:()=>{s=this.n($).listen(f,i)(t.fire,t),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,I.$fo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,u.$nm)(f.env),this.d=(0,r.fork)(this.i,$,f);const i=new b.$me,t=b.Event.fromNodeEventEmitter(this.d,"message",E=>E)(E=>{if((0,T.$er)(E)){(0,T.log)(E,`IPC Library: ${this.j.serverName}`);return}i.fire(A.$Oe.wrap(Buffer.from(E,"base64")))}),o=this.j.useQueue?(0,y.$Am)(this.d):this.d,n=E=>this.d&&this.d.connected&&o.send(E.buffer.toString("base64")),d=i.event,l={send:n,onMessage:d};this.f=new C.$ji(l);const g=()=>this.o();process.once("exit",g),this.d.on("error",E=>console.warn('IPC "'+this.j.serverName+'" errored with '+E)),this.d.on("exit",(E,S)=>{process.removeListener("exit",g),t.dispose(),this.c.forEach(D=>(0,c.$Qc)(D)),this.c.clear(),E!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+E+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:E,signal:S})})}return this.f}n($){let f=this.g.get($);return f||(f=this.m.getChannel($),this.g.set($,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$jr=a}),define(ke[193],Ie([1,0,7,4,3,44,17]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.StorageState=e.StorageHint=void 0,e.$eq=b;var O;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function b(u){const C=u;return C?.changed instanceof Map||C?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class I extends A.$Vc{static{this.a=100}constructor(C,w=Object.create(null)){super(),this.r=C,this.s=w,this.b=this.B(new h.$pe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new r.$Eh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(C=>this.u(C)))}u(C){this.b.pause();try{C.changed?.forEach((w,a)=>this.w(a,w)),C.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(C,w){if(this.c===c.Closed)return;let a=!1;(0,T.$og)(w)?a=this.f.delete(C):this.f.get(C)!==w&&(this.f.set(C,w),a=!0),a&&this.b.fire({key:C,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(C,w){const a=this.f.get(C);return(0,T.$og)(a)?w:a}getBoolean(C,w){const a=this.get(C);return(0,T.$og)(a)?w:a==="true"}getNumber(C,w){const a=this.get(C);return(0,T.$og)(a)?w:parseInt(a,10)}getObject(C,w){const a=this.get(C);return(0,T.$og)(a)?w:(0,R.$ci)(a)}async set(C,w,a=!1){if(this.c===c.Closed)return;if((0,T.$og)(w))return this.delete(C,a);const m=(0,T.$hg)(w)||Array.isArray(w)?(0,R.$bi)(w):String(w);if(this.f.get(C)!==m)return this.f.set(C,m),this.j.set(C,m),this.h.delete(C),this.b.fire({key:C,external:a}),this.D()}async delete(C,w=!1){if(!(this.c===c.Closed||!this.f.delete(C)))return this.h.has(C)||this.h.add(C),this.j.delete(C),this.b.fire({key:C,external:w}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const C={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(C).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(C){if(!(this.c===c.Closed||this.m))return this.D(C)}async D(C){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),C)}async whenFlushed(){if(this.z)return new Promise(C=>this.n.push(C))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$fq=I;class y{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(C){C.insert?.forEach((w,a)=>this.a.set(a,w)),C.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$gq=y}),define(ke[140],Ie([1,0,83]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=e.$iu=void 0;class h{constructor(O){const b=(0,r.$bf)(O);this.c=b,this.a=h.d(b),this.b=new Map}static d(O){const b=new Uint8Array(256);return b.fill(O),b}set(O,b){const c=(0,r.$bf)(b);O>=0&&O<256?this.a[O]=c:this.b.set(O,c)}get(O){return O>=0&&O<256?this.a[O]:this.b.get(O)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$iu=h;var A;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(A||(A={}));class R{constructor(){this.a=new h(A.False)}add(O){this.a.set(O,A.True)}has(O){return this.a.get(O)===A.True}clear(){return this.a.clear()}}e.$ju=R}),define(ke[194],Ie([1,0,26]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Au=A;var h;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function A(R){let T=0,O=0,b=0,c=h.Unknown;for(let I=0,y=R.length;I<y;I++){const u=R.charCodeAt(I);u===r.CharCode.CarriageReturn?(T===0&&(O=I),T++,I+1<y&&R.charCodeAt(I+1)===r.CharCode.LineFeed?(c|=h.CRLF,I++):c|=h.Invalid,b=I+1):u===r.CharCode.LineFeed&&(c|=h.LF,T===0&&(O=I),T++,b=I+1)}return T===0&&(O=R.length),[T,O,R.length-b,c]}}),define(ke[57],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class r{constructor(A,R){this.lineNumber=A,this.column=R}with(A=this.lineNumber,R=this.column){return A===this.lineNumber&&R===this.column?this:new r(A,R)}delta(A=0,R=0){return this.with(this.lineNumber+A,this.column+R)}equals(A){return r.equals(this,A)}static equals(A,R){return!A&&!R?!0:!!A&&!!R&&A.lineNumber===R.lineNumber&&A.column===R.column}isBefore(A){return r.isBefore(this,A)}static isBefore(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<R.column}isBeforeOrEqual(A){return r.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<=R.column}static compare(A,R){const T=A.lineNumber|0,O=R.lineNumber|0;if(T===O){const b=A.column|0,c=R.column|0;return b-c}return T-O}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new r(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Ot=r}),define(ke[30],Ie([1,0,57]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=void 0;class h{constructor(R,T,O,b){R>O||R===O&&T>b?(this.startLineNumber=O,this.startColumn=b,this.endLineNumber=R,this.endColumn=T):(this.startLineNumber=R,this.startColumn=T,this.endLineNumber=O,this.endColumn=b)}isEmpty(){return h.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return h.containsPosition(this,R)}static containsPosition(R,T){return!(T.lineNumber<R.startLineNumber||T.lineNumber>R.endLineNumber||T.lineNumber===R.startLineNumber&&T.column<R.startColumn||T.lineNumber===R.endLineNumber&&T.column>R.endColumn)}static strictContainsPosition(R,T){return!(T.lineNumber<R.startLineNumber||T.lineNumber>R.endLineNumber||T.lineNumber===R.startLineNumber&&T.column<=R.startColumn||T.lineNumber===R.endLineNumber&&T.column>=R.endColumn)}containsRange(R){return h.containsRange(this,R)}static containsRange(R,T){return!(T.startLineNumber<R.startLineNumber||T.endLineNumber<R.startLineNumber||T.startLineNumber>R.endLineNumber||T.endLineNumber>R.endLineNumber||T.startLineNumber===R.startLineNumber&&T.startColumn<R.startColumn||T.endLineNumber===R.endLineNumber&&T.endColumn>R.endColumn)}strictContainsRange(R){return h.strictContainsRange(this,R)}static strictContainsRange(R,T){return!(T.startLineNumber<R.startLineNumber||T.endLineNumber<R.startLineNumber||T.startLineNumber>R.endLineNumber||T.endLineNumber>R.endLineNumber||T.startLineNumber===R.startLineNumber&&T.startColumn<=R.startColumn||T.endLineNumber===R.endLineNumber&&T.endColumn>=R.endColumn)}plusRange(R){return h.plusRange(this,R)}static plusRange(R,T){let O,b,c,I;return T.startLineNumber<R.startLineNumber?(O=T.startLineNumber,b=T.startColumn):T.startLineNumber===R.startLineNumber?(O=T.startLineNumber,b=Math.min(T.startColumn,R.startColumn)):(O=R.startLineNumber,b=R.startColumn),T.endLineNumber>R.endLineNumber?(c=T.endLineNumber,I=T.endColumn):T.endLineNumber===R.endLineNumber?(c=T.endLineNumber,I=Math.max(T.endColumn,R.endColumn)):(c=R.endLineNumber,I=R.endColumn),new h(O,b,c,I)}intersectRanges(R){return h.intersectRanges(this,R)}static intersectRanges(R,T){let O=R.startLineNumber,b=R.startColumn,c=R.endLineNumber,I=R.endColumn;const y=T.startLineNumber,u=T.startColumn,C=T.endLineNumber,w=T.endColumn;return O<y?(O=y,b=u):O===y&&(b=Math.max(b,u)),c>C?(c=C,I=w):c===C&&(I=Math.min(I,w)),O>c||O===c&&b>I?null:new h(O,b,c,I)}equalsRange(R){return h.equalsRange(this,R)}static equalsRange(R,T){return!R&&!T?!0:!!R&&!!T&&R.startLineNumber===T.startLineNumber&&R.startColumn===T.startColumn&&R.endLineNumber===T.endLineNumber&&R.endColumn===T.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(R){return new r.$Ot(R.endLineNumber,R.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(R){return new r.$Ot(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,T){return new h(this.startLineNumber,this.startColumn,R,T)}setStartPosition(R,T){return new h(R,T,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(R){return new h(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(R){return new h(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new h(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,T=R){return new h(R.lineNumber,R.column,T.lineNumber,T.column)}static lift(R){return R?new h(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,T){return!(R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<T.startColumn||T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<R.startColumn)}static areIntersecting(R,T){return!(R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<=T.startColumn||T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,T){if(R&&T){const c=R.startLineNumber|0,I=T.startLineNumber|0;if(c===I){const y=R.startColumn|0,u=T.startColumn|0;if(y===u){const C=R.endLineNumber|0,w=T.endLineNumber|0;if(C===w){const a=R.endColumn|0,m=T.endColumn|0;return a-m}return C-w}return y-u}return c-I}return(R?1:0)-(T?1:0)}static compareRangesUsingEnds(R,T){return R.endLineNumber===T.endLineNumber?R.endColumn===T.endColumn?R.startLineNumber===T.startLineNumber?R.startColumn-T.startColumn:R.startLineNumber-T.startLineNumber:R.endColumn-T.endColumn:R.endLineNumber-T.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$Pt=h}),define(ke[195],Ie([1,0,30]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=void 0;class h{static insert(R,T){return{range:new r.$Pt(R.lineNumber,R.column,R.lineNumber,R.column),text:T,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,T){return{range:R,text:T}}static replaceMove(R,T){return{range:R,text:T,forceMoveMarkers:!0}}}e.$Qt=h}),define(ke[196],Ie([1,0,57,30]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=e.SelectionDirection=void 0;var A;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(A||(e.SelectionDirection=A={}));class R extends h.$Pt{constructor(O,b,c,I){super(O,b,c,I),this.selectionStartLineNumber=O,this.selectionStartColumn=b,this.positionLineNumber=c,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(O){return R.selectionsEqual(this,O)}static selectionsEqual(O,b){return O.selectionStartLineNumber===b.selectionStartLineNumber&&O.selectionStartColumn===b.selectionStartColumn&&O.positionLineNumber===b.positionLineNumber&&O.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?A.LTR:A.RTL}setEndPosition(O,b){return this.getDirection()===A.LTR?new R(this.startLineNumber,this.startColumn,O,b):new R(O,b,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Ot(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Ot(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(O,b){return this.getDirection()===A.LTR?new R(O,b,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,O,b)}static fromPositions(O,b=O){return new R(O.lineNumber,O.column,b.lineNumber,b.column)}static fromRange(O,b){return b===A.LTR?new R(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn):new R(O.endLineNumber,O.endColumn,O.startLineNumber,O.startColumn)}static liftSelection(O){return new R(O.selectionStartLineNumber,O.selectionStartColumn,O.positionLineNumber,O.positionColumn)}static selectionsArrEqual(O,b){if(O&&!b||!O&&b)return!1;if(!O&&!b)return!0;if(O.length!==b.length)return!1;for(let c=0,I=O.length;c<I;c++)if(!this.selectionsEqual(O[c],b[c]))return!1;return!0}static isISelection(O){return O&&typeof O.selectionStartLineNumber=="number"&&typeof O.selectionStartColumn=="number"&&typeof O.positionLineNumber=="number"&&typeof O.positionColumn=="number"}static createWithDirection(O,b,c,I,y){return y===A.LTR?new R(O,b,c,I):new R(c,I,O,b)}}e.$Rt=R}),define(ke[197],Ie([1,0,12,10,21]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fu=void 0,e.$du=I,e.$eu=y,r=We(r),h=We(h),A=We(A);let R;function T(){return R||(R=new TextDecoder("UTF-16LE")),R}let O;function b(){return O||(O=new TextDecoder("UTF-16BE")),O}let c;function I(){return c||(c=h.$E()?T():b()),c}function y(w,a,m){const $=new Uint16Array(w.buffer,a,m);return m>0&&($[0]===65279||$[0]===65534)?u(w,a,m):T().decode($)}function u(w,a,m){const $=[];let f=0;for(let i=0;i<m;i++){const s=A.$Qe(w,a);a+=2,$[f++]=String.fromCharCode(s)}return $.join("")}class C{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return I().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||r.$Kf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let $=0;$<m;$++)this.b[this.d++]=a.charCodeAt($)}}e.$fu=C}),define(ke[198],Ie([1,0,21,197]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gu=void 0,e.$hu=T,r=We(r);function A(b){return b.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,I,y,u){this.oldPosition=c,this.oldText=I,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,I,y){const u=I.length;r.$Te(c,u,y),y+=4;for(let C=0;C<u;C++)r.$Re(c,I.charCodeAt(C),y),y+=2;return y}static d(c,I){const y=r.$Se(c,I);return I+=4,(0,h.$eu)(c,I,y)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(c,I){return r.$Te(c,this.oldPosition,I),I+=4,r.$Te(c,this.newPosition,I),I+=4,I=R.c(c,this.oldText,I),I=R.c(c,this.newText,I),I}static read(c,I,y){const u=r.$Se(c,I);I+=4;const C=r.$Se(c,I);I+=4;const w=R.d(c,I);I+=R.a(w);const a=R.d(c,I);return I+=R.a(a),y.push(new R(u,w,C,a)),I}}e.$gu=R;function T(b,c){return b===null||b.length===0?c:new O(b,c).compress()}class O{constructor(c,I){this.a=c,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,I=0,y=this.n(c),u=this.l(I);for(;c<this.f||I<this.h;){if(y===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(y),y=this.n(++c);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++I);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++c);continue}if(u.oldPosition<y.newPosition){const[$,f]=O.r(u,y.newPosition-u.oldPosition);this.k($),u=f;continue}if(y.newPosition<u.oldPosition){const[$,f]=O.q(y,u.oldPosition-y.newPosition);this.m($),y=f;continue}let a,m;if(u.oldEnd===y.newEnd)a=y,m=u,y=this.n(++c),u=this.l(++I);else if(u.oldEnd<y.newEnd){const[$,f]=O.q(y,u.oldLength);a=$,m=u,y=f,u=this.l(++I)}else{const[$,f]=O.r(u,y.newLength);a=y,m=$,y=this.n(++c),u=f}this.d[this.e++]=new R(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const C=O.s(this.d);return O.t(C)}k(c){this.d[this.e++]=O.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=O.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,I){return new R(I.oldPosition-c,I.oldText,I.newPosition,I.newText)}static p(c,I){return new R(I.oldPosition,I.oldText,I.newPosition+c,I.newText)}static q(c,I){const y=c.newText.substr(0,I),u=c.newText.substr(I);return[new R(c.oldPosition,c.oldText,c.newPosition,y),new R(c.oldEnd,"",c.newPosition+I,u)]}static r(c,I){const y=c.oldText.substr(0,I),u=c.oldText.substr(I);return[new R(c.oldPosition,y,c.newPosition,c.newText),new R(c.oldPosition+I,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const I=[];let y=0,u=c[0];for(let C=1;C<c.length;C++){const w=c[C];u.oldEnd===w.oldPosition?u=new R(u.oldPosition,u.oldText+w.oldText,u.newPosition,u.newText+w.newText):(I[y++]=u,u=w)}return I[y++]=u,I}static t(c){if(c.length===0)return c;const I=[];let y=0;for(let u=0;u<c.length;u++){const C=c[u];C.oldText!==C.newText&&(I[y++]=C)}return I}}}),define(ke[199],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=void 0,e.$mt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[200],Ie([1,0,26,28,140]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ku=e.WordCharacterClass=void 0,e.$lu=b;var R;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class T extends A.$iu{constructor(I,y){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=y,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,C=I.length;u<C;u++)this.set(I.charCodeAt(u),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,y){let u=null;for(const C of this.h(I)){if(C.index>y)break;u=C}return u}findNextIntlWordAtOrAfterOffset(I,y){for(const u of this.h(I))if(!(u.index<y))return u;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const y=[];for(const u of I)this.k(u)&&y.push(u);return y}k(I){return!!I.isWordLike}}e.$ku=T;const O=new h.$Ec(10);function b(c,I){const y=`${c}/${I.join(",")}`;let u=O.get(y);return u||(u=new T(c,I),O.set(y,u)),u}}),define(ke[141],Ie([1,0,39,3,80]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$nt=void 0,e.$pt=T,e.$qt=b,e.$rt=c,e.$nt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(y=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.$nt)y.indexOf(C)>=0||(u+="\\"+C);return u+="\\s]+)",new RegExp(u,"g")}e.$ot=R();function T(y){let u=e.$ot;if(y&&y instanceof RegExp)if(y.global)u=y;else{let C="g";y.ignoreCase&&(C+="i"),y.multiline&&(C+="m"),y.unicode&&(C+="u"),u=new RegExp(y.source,C)}return u.lastIndex=0,u}const O=new A.$6c;O.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(y){const u=O.unshift(y);return(0,h.$Tc)(u)}function c(y,u,C,w,a){if(u=T(u),a||(a=r.Iterable.first(O)),C.length>a.maxLen){let s=y-a.maxLen/2;return s<0?s=0:w+=s,C=C.substring(s,y+a.maxLen/2),c(y,u,C,w,a)}const m=Date.now(),$=y-1-w;let f=-1,i=null;for(let s=1;!(Date.now()-m>=a.timeBudget);s++){const t=$-a.windowSize*s;u.lastIndex=Math.max(0,t);const o=I(u,C,$,f);if(!o&&i||(i=o,t<=0))break;f=t}if(i){const s={word:i[0],startColumn:w+1+i.index,endColumn:w+1+i.index+i[0].length};return u.lastIndex=0,s}return null}function I(y,u,C,w){let a;for(;a=y.exec(u);){const m=a.index||0;if(m<=C&&y.lastIndex>=C)return a;if(w>0&&m>w)return null}return null}}),define(ke[110],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(b){b[b.Null=0]="Null",b[b.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function(b){b[b.NotSet=-1]="NotSet",b[b.None=0]="None",b[b.Italic=1]="Italic",b[b.Bold=2]="Bold",b[b.Underline=4]="Underline",b[b.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var A;(function(b){b[b.None=0]="None",b[b.DefaultForeground=1]="DefaultForeground",b[b.DefaultBackground=2]="DefaultBackground"})(A||(e.ColorId=A={}));var R;(function(b){b[b.Other=0]="Other",b[b.Comment=1]="Comment",b[b.String=2]="String",b[b.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var T;(function(b){b[b.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",b[b.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",b[b.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",b[b.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",b[b.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",b[b.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",b[b.ITALIC_MASK=2048]="ITALIC_MASK",b[b.BOLD_MASK=4096]="BOLD_MASK",b[b.UNDERLINE_MASK=8192]="UNDERLINE_MASK",b[b.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",b[b.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",b[b.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",b[b.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",b[b.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",b[b.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",b[b.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",b[b.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",b[b.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",b[b.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",b[b.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",b[b.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",b[b.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(T||(e.MetadataConsts=T={}));class O{static getLanguageId(c){return(c&T.LANGUAGEID_MASK)>>>T.LANGUAGEID_OFFSET}static getTokenType(c){return(c&T.TOKEN_TYPE_MASK)>>>T.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&T.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&T.FONT_STYLE_MASK)>>>T.FONT_STYLE_OFFSET}static getForeground(c){return(c&T.FOREGROUND_MASK)>>>T.FOREGROUND_OFFSET}static getBackground(c){return(c&T.BACKGROUND_MASK)>>>T.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let y="mtk"+this.getForeground(c);const u=this.getFontStyle(c);return u&h.Italic&&(y+=" mtki"),u&h.Bold&&(y+=" mtkb"),u&h.Underline&&(y+=" mtku"),u&h.Strikethrough&&(y+=" mtks"),y}static getInlineStyleFromMetadata(c,I){const y=this.getForeground(c),u=this.getFontStyle(c);let C=`color: ${I[y]};`;u&h.Italic&&(C+="font-style: italic;"),u&h.Bold&&(C+="font-weight: bold;");let w="";return u&h.Underline&&(w+=" underline"),u&h.Strikethrough&&(w+=" line-through"),w&&(C+=`text-decoration:${w};`),C}static getPresentationFromMetadata(c){const I=this.getForeground(c),y=this.getFontStyle(c);return{foreground:I,italic:!!(y&h.Italic),bold:!!(y&h.Bold),underline:!!(y&h.Underline),strikethrough:!!(y&h.Strikethrough)}}}e.$wu=O}),define(ke[201],Ie([1,0,38,16]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xu=A,e.$yu=R;function A(T,O,b,c,I,y){if(Array.isArray(T)){let u=0;for(const C of T){const w=A(C,O,b,c,I,y);if(w===10)return w;w>u&&(u=w)}return u}else{if(typeof T=="string")return c?T==="*"?5:T===b?10:0:0;if(T){const{language:u,pattern:C,scheme:w,hasAccessToAllModels:a,notebookType:m}=T;if(!c&&!a)return 0;m&&I&&(O=I);let $=0;if(w)if(w===O.scheme)$=10;else if(w==="*")$=5;else return 0;if(u)if(u===b)$=10;else if(u==="*")$=Math.max($,5);else return 0;if(m)if(m===y)$=10;else if(m==="*"&&y!==void 0)$=Math.max($,5);else return 0;if(C){let f;if(typeof C=="string"?f=C:f={...C,base:(0,h.$ic)(C.base)},f===O.fsPath||(0,r.$Ak)(f,O.fsPath))$=10;else return 0}return $}else return 0}}function R(T){return typeof T=="string"?!1:Array.isArray(T)?T.some(R):!!T.notebookType}}),define(ke[202],Ie([1,0,26,110]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zu=e.$Yu=e.IndentAction=void 0;var A;(function(b){b[b.None=0]="None",b[b.Indent=1]="Indent",b[b.IndentOutdent=2]="IndentOutdent",b[b.Outdent=3]="Outdent"})(A||(e.IndentAction=A={}));class R{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let I=0,y=c.notIn.length;I<y;I++)switch(c.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,I){if(c.getTokenCount()===0)return!0;const y=c.findTokenIndexAtOffset(I-2),u=c.getStandardTokenType(y);return this.isOK(u)}g(c,I){for(let y=c;y<=I;y++){const u=String.fromCharCode(y);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Yu=R;class T{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of c)O(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),O(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),O(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),O(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&O(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Zu=T;function O(b,c,I){b.has(c)?b.get(c).push(I):b.set(c,[I])}}),define(ke[203],Ie([1,0,26,140]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K4=e.$J4=e.State=void 0,e.$L4=C;var A;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(A||(e.State=A={}));class R{constructor(a,m,$){const f=new Uint8Array(a*m);for(let i=0,s=a*m;i<s;i++)f[i]=$;this.a=f,this.rows=a,this.cols=m}get(a,m){return this.a[a*this.cols+m]}set(a,m,$){this.a[a*this.cols+m]=$}}class T{constructor(a){let m=0,$=A.Invalid;for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];o>m&&(m=o),t>$&&($=t),n>$&&($=n)}m++,$++;const f=new R($,m,A.Invalid);for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];f.set(t,o,n)}this.a=f,this.b=m}nextState(a,m){return m<0||m>=this.b?A.Invalid:this.a.get(a,m)}}e.$J4=T;let O=null;function b(){return O===null&&(O=new T([[A.Start,r.CharCode.h,A.H],[A.Start,r.CharCode.H,A.H],[A.Start,r.CharCode.f,A.F],[A.Start,r.CharCode.F,A.F],[A.H,r.CharCode.t,A.HT],[A.H,r.CharCode.T,A.HT],[A.HT,r.CharCode.t,A.HTT],[A.HT,r.CharCode.T,A.HTT],[A.HTT,r.CharCode.p,A.HTTP],[A.HTT,r.CharCode.P,A.HTTP],[A.HTTP,r.CharCode.s,A.BeforeColon],[A.HTTP,r.CharCode.S,A.BeforeColon],[A.HTTP,r.CharCode.Colon,A.AfterColon],[A.F,r.CharCode.i,A.FI],[A.F,r.CharCode.I,A.FI],[A.FI,r.CharCode.l,A.FIL],[A.FI,r.CharCode.L,A.FIL],[A.FIL,r.CharCode.e,A.BeforeColon],[A.FIL,r.CharCode.E,A.BeforeColon],[A.BeforeColon,r.CharCode.Colon,A.AfterColon],[A.AfterColon,r.CharCode.Slash,A.AlmostThere],[A.AlmostThere,r.CharCode.Slash,A.End]])),O}var c;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let I=null;function y(){if(I===null){I=new h.$iu(c.None);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<w.length;m++)I.set(w.charCodeAt(m),c.ForceTermination);const a=".,;:";for(let m=0;m<a.length;m++)I.set(a.charCodeAt(m),c.CannotEndIn)}return I}class u{static a(a,m,$,f,i){let s=i-1;do{const t=m.charCodeAt(s);if(a.get(t)!==c.CannotEndIn)break;s--}while(s>f);if(f>0){const t=m.charCodeAt(f-1),o=m.charCodeAt(s);(t===r.CharCode.OpenParen&&o===r.CharCode.CloseParen||t===r.CharCode.OpenSquareBracket&&o===r.CharCode.CloseSquareBracket||t===r.CharCode.OpenCurlyBrace&&o===r.CharCode.CloseCurlyBrace)&&s--}return{range:{startLineNumber:$,startColumn:f+1,endLineNumber:$,endColumn:s+2},url:m.substring(f,s+1)}}static computeLinks(a,m=b()){const $=y(),f=[];for(let i=1,s=a.getLineCount();i<=s;i++){const t=a.getLineContent(i),o=t.length;let n=0,d=0,l=0,g=A.Start,E=!1,S=!1,D=!1,k=!1;for(;n<o;){let P=!1;const p=t.charCodeAt(n);if(g===A.Accept){let v;switch(p){case r.CharCode.OpenParen:E=!0,v=c.None;break;case r.CharCode.CloseParen:v=E?c.None:c.ForceTermination;break;case r.CharCode.OpenSquareBracket:D=!0,S=!0,v=c.None;break;case r.CharCode.CloseSquareBracket:D=!1,v=S?c.None:c.ForceTermination;break;case r.CharCode.OpenCurlyBrace:k=!0,v=c.None;break;case r.CharCode.CloseCurlyBrace:v=k?c.None:c.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:l===p?v=c.ForceTermination:l===r.CharCode.SingleQuote||l===r.CharCode.DoubleQuote||l===r.CharCode.BackTick?v=c.None:v=c.ForceTermination;break;case r.CharCode.Asterisk:v=l===r.CharCode.Asterisk?c.ForceTermination:c.None;break;case r.CharCode.Pipe:v=l===r.CharCode.Pipe?c.ForceTermination:c.None;break;case r.CharCode.Space:v=D?c.None:c.ForceTermination;break;default:v=$.get(p)}v===c.ForceTermination&&(f.push(u.a($,t,i,d,n)),P=!0)}else if(g===A.End){let v;p===r.CharCode.OpenSquareBracket?(S=!0,v=c.None):v=$.get(p),v===c.ForceTermination?P=!0:g=A.Accept}else g=m.nextState(g,p),g===A.Invalid&&(P=!0);P&&(g=A.Start,E=!1,S=!1,k=!1,d=n+1,l=p),n++}g===A.Accept&&f.push(u.a($,t,i,d,o))}return f}}e.$K4=u;function C(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:u.computeLinks(w)}}),define(ke[58],Ie([1,0,24]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=e.$jw=e.$iw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$gw=e.$fw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$hw=w,e.$lw=s;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var A;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(A||(e.GlyphMarginLane=A={}));var R;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var T;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(T||(e.MinimapSectionHeaderStyle=T={}));var O;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(O||(e.InjectedTextCursorStops=O={}));var b;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,r.$jo)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.$fw=y;class u{constructor(o,n){this._findMatchBrand=void 0,this.range=o,this.matches=n}}e.$gw=u;var C;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C||(e.TrackedRangeStickiness=C={}));function w(t){return t&&typeof t.read=="function"}var a;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class ${constructor(o,n,d,l,g,E){this.identifier=o,this.range=n,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=g,this._isTracked=E}}e.$iw=$;class f{constructor(o,n,d){this.regex=o,this.wordSeparators=n,this.simpleSearch=d}}e.$jw=f;class i{constructor(o,n,d){this.reverseEdits=o,this.changes=n,this.trimAutoWhitespaceLineNumbers=d}}e.$kw=i;function s(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(ke[204],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.NodeColor=e.$cD=void 0,e.$eD=A,e.$fD=R,e.$gD=c,e.$hD=I,e.$iD=y,e.$jD=u,e.$kD=C,e.$lD=w;class r{constructor(m,$){this.piece=m,this.color=$,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$dD)return A(this.right);let m=this;for(;m.parent!==e.$dD&&m.parent.left!==m;)m=m.parent;return m.parent===e.$dD?e.$dD:m.parent}prev(){if(this.left!==e.$dD)return R(this.left);let m=this;for(;m.parent!==e.$dD&&m.parent.right!==m;)m=m.parent;return m.parent===e.$dD?e.$dD:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$cD=r;var h;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$dD=new r(null,h.Black),e.$dD.parent=e.$dD,e.$dD.left=e.$dD,e.$dD.right=e.$dD,e.$dD.color=h.Black;function A(a){for(;a.left!==e.$dD;)a=a.left;return a}function R(a){for(;a.right!==e.$dD;)a=a.right;return a}function T(a){return a===e.$dD?0:a.size_left+a.piece.length+T(a.right)}function O(a){return a===e.$dD?0:a.lf_left+a.piece.lineFeedCnt+O(a.right)}function b(){e.$dD.parent=e.$dD}function c(a,m){const $=m.right;$.size_left+=m.size_left+(m.piece?m.piece.length:0),$.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=$.left,$.left!==e.$dD&&($.left.parent=m),$.parent=m.parent,m.parent===e.$dD?a.root=$:m.parent.left===m?m.parent.left=$:m.parent.right=$,$.left=m,m.parent=$}function I(a,m){const $=m.left;m.left=$.right,$.right!==e.$dD&&($.right.parent=m),$.parent=m.parent,m.size_left-=$.size_left+($.piece?$.piece.length:0),m.lf_left-=$.lf_left+($.piece?$.piece.lineFeedCnt:0),m.parent===e.$dD?a.root=$:m===m.parent.right?m.parent.right=$:m.parent.left=$,$.right=m,m.parent=$}function y(a,m){let $,f;if(m.left===e.$dD?(f=m,$=f.right):m.right===e.$dD?(f=m,$=f.left):(f=A(m.right),$=f.right),f===a.root){a.root=$,$.color=h.Black,m.detach(),b(),a.root.parent=e.$dD;return}const i=f.color===h.Red;if(f===f.parent.left?f.parent.left=$:f.parent.right=$,f===m?($.parent=f.parent,w(a,$)):(f.parent===m?$.parent=f:$.parent=f.parent,w(a,$),f.left=m.left,f.right=m.right,f.parent=m.parent,f.color=m.color,m===a.root?a.root=f:m===m.parent.left?m.parent.left=f:m.parent.right=f,f.left!==e.$dD&&(f.left.parent=f),f.right!==e.$dD&&(f.right.parent=f),f.size_left=m.size_left,f.lf_left=m.lf_left,w(a,f)),m.detach(),$.parent.left===$){const t=T($),o=O($);if(t!==$.parent.size_left||o!==$.parent.lf_left){const n=t-$.parent.size_left,d=o-$.parent.lf_left;$.parent.size_left=t,$.parent.lf_left=o,C(a,$.parent,n,d)}}if(w(a,$.parent),i){b();return}let s;for(;$!==a.root&&$.color===h.Black;)$===$.parent.left?(s=$.parent.right,s.color===h.Red&&(s.color=h.Black,$.parent.color=h.Red,c(a,$.parent),s=$.parent.right),s.left.color===h.Black&&s.right.color===h.Black?(s.color=h.Red,$=$.parent):(s.right.color===h.Black&&(s.left.color=h.Black,s.color=h.Red,I(a,s),s=$.parent.right),s.color=$.parent.color,$.parent.color=h.Black,s.right.color=h.Black,c(a,$.parent),$=a.root)):(s=$.parent.left,s.color===h.Red&&(s.color=h.Black,$.parent.color=h.Red,I(a,$.parent),s=$.parent.left),s.left.color===h.Black&&s.right.color===h.Black?(s.color=h.Red,$=$.parent):(s.left.color===h.Black&&(s.right.color=h.Black,s.color=h.Red,c(a,s),s=$.parent.left),s.color=$.parent.color,$.parent.color=h.Black,s.left.color=h.Black,I(a,$.parent),$=a.root));$.color=h.Black,b()}function u(a,m){for(w(a,m);m!==a.root&&m.parent.color===h.Red;)if(m.parent===m.parent.parent.left){const $=m.parent.parent.right;$.color===h.Red?(m.parent.color=h.Black,$.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,c(a,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,I(a,m.parent.parent))}else{const $=m.parent.parent.left;$.color===h.Red?(m.parent.color=h.Black,$.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,I(a,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,c(a,m.parent.parent))}a.root.color=h.Black}function C(a,m,$,f){for(;m!==a.root&&m!==e.$dD;)m.parent.left===m&&(m.parent.size_left+=$,m.parent.lf_left+=f),m=m.parent}function w(a,m){let $=0,f=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,$=T(m.left)-m.size_left,f=O(m.left)-m.lf_left,m.size_left+=$,m.lf_left+=f;m!==a.root&&($!==0||f!==0);)m.parent.left===m&&(m.parent.size_left+=$,m.parent.lf_left+=f),m=m.parent}}}),define(ke[205],Ie([1,0,18,83]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$pw=e.$ow=void 0;class A{constructor(b){this.a=b,this.b=new Uint32Array(b.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(b,c){b=(0,h.$cf)(b);const I=this.a,y=this.b,u=c.length;return u===0?!1:(this.a=new Uint32Array(I.length+u),this.a.set(I.subarray(0,b),0),this.a.set(I.subarray(b),b+u),this.a.set(c,b),b-1<this.c[0]&&(this.c[0]=b-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(y.subarray(0,this.c[0]+1)),!0)}setValue(b,c){return b=(0,h.$cf)(b),c=(0,h.$cf)(c),this.a[b]===c?!1:(this.a[b]=c,b-1<this.c[0]&&(this.c[0]=b-1),!0)}removeValues(b,c){b=(0,h.$cf)(b),c=(0,h.$cf)(c);const I=this.a,y=this.b;if(b>=I.length)return!1;const u=I.length-b;return c>=u&&(c=u),c===0?!1:(this.a=new Uint32Array(I.length-c),this.a.set(I.subarray(0,b),0),this.a.set(I.subarray(b+c),b),this.b=new Uint32Array(this.a.length),b-1<this.c[0]&&(this.c[0]=b-1),this.c[0]>=0&&this.b.set(y.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(b){return b<0?0:(b=(0,h.$cf)(b),this.d(b))}d(b){if(b<=this.c[0])return this.b[b];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),b>=this.a.length&&(b=this.a.length-1);for(let I=c;I<=b;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],b),this.b[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let c=0,I=this.a.length-1,y=0,u=0,C=0;for(;c<=I;)if(y=c+(I-c)/2|0,u=this.b[y],C=u-this.a[y],b<C)I=y-1;else if(b>=u)c=y+1;else break;return new T(y,b-C)}}e.$ow=A;class R{constructor(b){this.a=b,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(b){return this.g(),b===0?0:this.d[b-1]}getIndexOf(b){this.g();const c=this.e[b],I=c>0?this.d[c-1]:0;return new T(c,b-I)}removeValues(b,c){this.a.splice(b,c),this.f(b)}insertValues(b,c){this.a=(0,r.$Vb)(this.a,b,c),this.f(b)}f(b){this.b=!1,this.c=Math.min(this.c,b-1)}g(){if(!this.b){for(let b=this.c+1,c=this.a.length;b<c;b++){const I=this.a[b],y=b>0?this.d[b-1]:0;this.d[b]=y+I;for(let u=0;u<I;u++)this.e[y+u]=b}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(b,c){this.a[b]!==c&&(this.a[b]=c,this.f(b))}}e.$pw=R;class T{constructor(b,c){this.index=b,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=c}}e.$qw=T}),define(ke[206],Ie([1,0,12,57,205]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rw=void 0;class R{constructor(O,b,c,I){this.d=O,this.f=b,this.g=c,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(O){O.eol&&O.eol!==this.g&&(this.g=O.eol,this.j=null);const b=O.changes;for(const c of b)this.o(c.range),this.p(new h.$Ot(c.range.startLineNumber,c.range.startColumn),c.text);this.h=O.versionId,this.k=null}l(){if(!this.j){const O=this.g.length,b=this.f.length,c=new Uint32Array(b);for(let I=0;I<b;I++)c[I]=this.f[I].length+O;this.j=new A.$ow(c)}}n(O,b){this.f[O]=b,this.j&&this.j.setValue(O,this.f[O].length+this.g.length)}o(O){if(O.startLineNumber===O.endLineNumber){if(O.startColumn===O.endColumn)return;this.n(O.startLineNumber-1,this.f[O.startLineNumber-1].substring(0,O.startColumn-1)+this.f[O.startLineNumber-1].substring(O.endColumn-1));return}this.n(O.startLineNumber-1,this.f[O.startLineNumber-1].substring(0,O.startColumn-1)+this.f[O.endLineNumber-1].substring(O.endColumn-1)),this.f.splice(O.startLineNumber,O.endLineNumber-O.startLineNumber),this.j&&this.j.removeValues(O.startLineNumber,O.endLineNumber-O.startLineNumber)}p(O,b){if(b.length===0)return;const c=(0,r.$tf)(b);if(c.length===1){this.n(O.lineNumber-1,this.f[O.lineNumber-1].substring(0,O.column-1)+c[0]+this.f[O.lineNumber-1].substring(O.column-1));return}c[c.length-1]+=this.f[O.lineNumber-1].substring(O.column-1),this.n(O.lineNumber-1,this.f[O.lineNumber-1].substring(0,O.column-1)+c[0]);const I=new Uint32Array(c.length-1);for(let y=1;y<c.length;y++)this.f.splice(O.lineNumber+y-1,0,c[y]),I[y-1]=c[y].length+this.g.length;this.j&&this.j.insertValues(O.lineNumber,I)}}e.$rw=R}),define(ke[111],Ie([1,0,26,12,200,57,30,58]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rD=e.$pD=e.$mD=void 0,e.$nD=I,e.$oD=y,e.$qD=m,h=We(h);const b=999;class c{constructor(i,s,t,o){this.searchString=i,this.isRegex=s,this.matchCase=t,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=I(this.searchString):i=this.searchString.indexOf(`
`)>=0;let s=null;try{s=h.$rf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!s)return null;let t=!this.isRegex&&!i;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new O.$jw(s,this.wordSeparators?(0,A.$lu)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$mD=c;function I(f){if(!f||f.length===0)return!1;for(let i=0,s=f.length;i<s;i++){const t=f.charCodeAt(i);if(t===r.CharCode.LineFeed)return!0;if(t===r.CharCode.Backslash){if(i++,i>=s)break;const o=f.charCodeAt(i);if(o===r.CharCode.n||o===r.CharCode.r||o===r.CharCode.W)return!0}}return!1}function y(f,i,s){if(!s)return new O.$gw(f,null);const t=[];for(let o=0,n=i.length;o<n;o++)t[o]=i[o];return new O.$gw(f,t)}class u{constructor(i){const s=[];let t=0;for(let o=0,n=i.length;o<n;o++)i.charCodeAt(o)===r.CharCode.LineFeed&&(s[t++]=o);this.a=s}findLineFeedCountBeforeOffset(i){const s=this.a;let t=0,o=s.length-1;if(o===-1||i<=s[0])return 0;for(;t<o;){const n=t+((o-t)/2>>0);s[n]>=i?o=n-1:s[n+1]>=i?(t=n,o=n):t=n+1}return t+1}}class C{static findMatches(i,s,t,o,n){const d=s.parseSearchRequest();return d?d.regex.multiline?this.b(i,t,new $(d.wordSeparators,d.regex),o,n):this.c(i,t,d,o,n):[]}static a(i,s,t,o,n,d){let l,g=0;o?(g=o.findLineFeedCountBeforeOffset(n),l=s+n+g):l=s+n;let E;if(o){const P=o.findLineFeedCountBeforeOffset(n+d.length)-g;E=l+d.length+P}else E=l+d.length;const S=i.getPositionAt(l),D=i.getPositionAt(E);return new T.$Pt(S.lineNumber,S.column,D.lineNumber,D.column)}static b(i,s,t,o,n){const d=i.getOffsetAt(s.getStartPosition()),l=i.getValueInRange(s,O.EndOfLinePreference.LF),g=i.getEOL()===`\r
`?new u(l):null,E=[];let S=0,D;for(t.reset(0);D=t.next(l);)if(E[S++]=y(this.a(i,d,l,g,D.index,D[0]),D,o),S>=n)return E;return E}static c(i,s,t,o,n){const d=[];let l=0;if(s.startLineNumber===s.endLineNumber){const E=i.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return l=this.d(t,E,s.startLineNumber,s.startColumn-1,l,d,o,n),d}const g=i.getLineContent(s.startLineNumber).substring(s.startColumn-1);l=this.d(t,g,s.startLineNumber,s.startColumn-1,l,d,o,n);for(let E=s.startLineNumber+1;E<s.endLineNumber&&l<n;E++)l=this.d(t,i.getLineContent(E),E,0,l,d,o,n);if(l<n){const E=i.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);l=this.d(t,E,s.endLineNumber,0,l,d,o,n)}return d}static d(i,s,t,o,n,d,l,g){const E=i.wordSeparators;if(!l&&i.simpleSearch){const k=i.simpleSearch,P=k.length,p=s.length;let v=-P;for(;(v=s.indexOf(k,v+P))!==-1;)if((!E||m(E,s,p,v,P))&&(d[n++]=new O.$gw(new T.$Pt(t,v+1+o,t,v+1+P+o),null),n>=g))return n;return n}const S=new $(i.wordSeparators,i.regex);let D;S.reset(0);do if(D=S.next(s),D&&(d[n++]=y(new T.$Pt(t,D.index+1+o,t,D.index+1+D[0].length+o),D,l),n>=g))return n;while(D);return n}static findNextMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const d=new $(n.wordSeparators,n.regex);return n.regex.multiline?this.e(i,t,d,o):this.f(i,t,d,o)}static e(i,s,t,o){const n=new R.$Ot(s.lineNumber,1),d=i.getOffsetAt(n),l=i.getLineCount(),g=i.getValueInRange(new T.$Pt(n.lineNumber,n.column,l,i.getLineMaxColumn(l)),O.EndOfLinePreference.LF),E=i.getEOL()===`\r
`?new u(g):null;t.reset(s.column-1);const S=t.next(g);return S?y(this.a(i,d,g,E,S.index,S[0]),S,o):s.lineNumber!==1||s.column!==1?this.e(i,new R.$Ot(1,1),t,o):null}static f(i,s,t,o){const n=i.getLineCount(),d=s.lineNumber,l=i.getLineContent(d),g=this.g(t,l,d,s.column,o);if(g)return g;for(let E=1;E<=n;E++){const S=(d+E-1)%n,D=i.getLineContent(S+1),k=this.g(t,D,S+1,1,o);if(k)return k}return null}static g(i,s,t,o,n){i.reset(o-1);const d=i.next(s);return d?y(new T.$Pt(t,d.index+1,t,d.index+1+d[0].length),d,n):null}static findPreviousMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const d=new $(n.wordSeparators,n.regex);return n.regex.multiline?this.h(i,t,d,o):this.j(i,t,d,o)}static h(i,s,t,o){const n=this.b(i,new T.$Pt(1,1,s.lineNumber,s.column),t,o,10*b);if(n.length>0)return n[n.length-1];const d=i.getLineCount();return s.lineNumber!==d||s.column!==i.getLineMaxColumn(d)?this.h(i,new R.$Ot(d,i.getLineMaxColumn(d)),t,o):null}static j(i,s,t,o){const n=i.getLineCount(),d=s.lineNumber,l=i.getLineContent(d).substring(0,s.column-1),g=this.k(t,l,d,o);if(g)return g;for(let E=1;E<=n;E++){const S=(n+d-E-1)%n,D=i.getLineContent(S+1),k=this.k(t,D,S+1,o);if(k)return k}return null}static k(i,s,t,o){let n=null,d;for(i.reset(0);d=i.next(s);)n=y(new T.$Pt(t,d.index+1,t,d.index+1+d[0].length),d,o);return n}}e.$pD=C;function w(f,i,s,t,o){if(t===0)return!0;const n=i.charCodeAt(t-1);if(f.get(n)!==A.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const d=i.charCodeAt(t);if(f.get(d)!==A.WordCharacterClass.Regular)return!0}return!1}function a(f,i,s,t,o){if(t+o===s)return!0;const n=i.charCodeAt(t+o);if(f.get(n)!==A.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const d=i.charCodeAt(t+o-1);if(f.get(d)!==A.WordCharacterClass.Regular)return!0}return!1}function m(f,i,s,t,o){return w(f,i,s,t,o)&&a(f,i,s,t,o)}class ${constructor(i,s){this._wordSeparators=i,this.a=s,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const s=i.length;let t;do{if(this.b+this.c===s||(t=this.a.exec(i),!t))return null;const o=t.index,n=t[0].length;if(o===this.b&&n===this.c){if(n===0){h.$Nf(i,s,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=n,!this._wordSeparators||m(this._wordSeparators,i,s,o,n))return t}while(t);return null}}e.$rD=$}),define(ke[142],Ie([1,0,26,57,30,58,204,111]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=e.$vD=e.$uD=void 0,e.$sD=y,e.$tD=u;const b=65535;function c(f){let i;return f[f.length-1]<65536?i=new Uint16Array(f.length):i=new Uint32Array(f.length),i.set(f,0),i}class I{constructor(i,s,t,o,n){this.lineStarts=i,this.cr=s,this.lf=t,this.crlf=o,this.isBasicASCII=n}}function y(f,i=!0){const s=[0];let t=1;for(let o=0,n=f.length;o<n;o++){const d=f.charCodeAt(o);d===r.CharCode.CarriageReturn?o+1<n&&f.charCodeAt(o+1)===r.CharCode.LineFeed?(s[t++]=o+2,o++):s[t++]=o+1:d===r.CharCode.LineFeed&&(s[t++]=o+1)}return i?c(s):s}function u(f,i){f.length=0,f[0]=0;let s=1,t=0,o=0,n=0,d=!0;for(let g=0,E=i.length;g<E;g++){const S=i.charCodeAt(g);S===r.CharCode.CarriageReturn?g+1<E&&i.charCodeAt(g+1)===r.CharCode.LineFeed?(n++,f[s++]=g+2,g++):(t++,f[s++]=g+1):S===r.CharCode.LineFeed?(o++,f[s++]=g+1):d&&S!==r.CharCode.Tab&&(S<32||S>126)&&(d=!1)}const l=new I(c(f),t,o,n,d);return f.length=0,l}class C{constructor(i,s,t,o,n){this.bufferIndex=i,this.start=s,this.end=t,this.lineFeedCnt=o,this.length=n}}e.$uD=C;class w{constructor(i,s){this.buffer=i,this.lineStarts=s}}e.$vD=w;class a{constructor(i,s){this.a=[],this.c=i,this.d=s,this.b=0,i.root!==T.$dD&&i.iterate(i.root,t=>(t!==T.$dD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class m{constructor(i){this.a=i,this.b=[]}get(i){for(let s=this.b.length-1;s>=0;s--){const t=this.b[s];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let s=this.b.length-1;s>=0;s--){const t=this.b[s];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let s=!1;const t=this.b;for(let o=0;o<t.length;o++){const n=t[o];if(n.node.parent===null||n.nodeStartOffset>=i){t[o]=null,s=!0;continue}}if(s){const o=[];for(const n of t)n!==null&&o.push(n);this.b=o}}}class ${constructor(i,s,t){this.create(i,s,t)}create(i,s,t){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=T.$dD,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=t;let o=null;for(let n=0,d=i.length;n<d;n++)if(i[n].buffer.length>0){i[n].lineStarts||(i[n].lineStarts=y(i[n].buffer));const l=new C(n+1,{line:0,column:0},{line:i[n].lineStarts.length-1,column:i[n].buffer.length-i[n].lineStarts[i[n].lineStarts.length-1]},i[n].lineStarts.length-1,i[n].buffer.length);this.a.push(i[n]),o=this.S(o,l)}this.h=new m(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const s=b,t=s-Math.floor(s/3),o=t*2;let n="",d=0;const l=[];if(this.iterate(this.root,g=>{const E=this.R(g),S=E.length;if(d<=t||d+S<o)return n+=E,d+=S,!0;const D=n.replace(/\r\n|\r|\n/g,i);return l.push(new w(D,y(D))),n=E,d=S,!0}),d>0){const g=n.replace(/\r\n|\r|\n/g,i);l.push(new w(g,y(g)))}this.create(l,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new a(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let s=0;return this.iterate(this.root,o=>{if(o===T.$dD)return!0;const n=this.R(o),d=n.length,l=i.G(s),g=i.G(s+d),E=i.getValueInRange2(l,g);return s+=d,n===E})}getOffsetAt(i,s){let t=0,o=this.root;for(;o!==T.$dD;)if(o.left!==T.$dD&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const n=this.B(o,i-o.lf_left-2);return t+=n+s-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let s=this.root,t=0;const o=i;for(;s!==T.$dD;)if(s.size_left!==0&&s.size_left>=i)s=s.left;else if(s.size_left+s.piece.length>=i){const n=this.A(s,i-s.size_left);if(t+=s.lf_left+n.index,n.index===0){const d=this.getOffsetAt(t+1,1),l=o-d;return new h.$Ot(t+1,l+1)}return new h.$Ot(t+1,n.remainder+1)}else if(i-=s.size_left+s.piece.length,t+=s.lf_left+s.piece.lineFeedCnt,s.right===T.$dD){const n=this.getOffsetAt(t+1,1),d=o-i-n;return new h.$Ot(t+1,d+1)}else s=s.right;return new h.$Ot(1,1)}getValueInRange(i,s){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),n=this.getValueInRange2(t,o);return s?s!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,s):n}getValueInRange2(i,s){if(i.node===s.node){const l=i.node,g=this.a[l.piece.bufferIndex].buffer,E=this.u(l.piece.bufferIndex,l.piece.start);return g.substring(E+i.remainder,E+s.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,n=this.u(t.piece.bufferIndex,t.piece.start);let d=o.substring(n+i.remainder,n+t.piece.length);for(t=t.next();t!==T.$dD;){const l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(t===s.node){d+=l.substring(g,g+s.remainder);break}else d+=l.substr(g,t.piece.length);t=t.next()}return d}getLinesContent(){const i=[];let s=0,t="",o=!1;return this.iterate(this.root,n=>{if(n===T.$dD)return!0;const d=n.piece;let l=d.length;if(l===0)return!0;const g=this.a[d.bufferIndex].buffer,E=this.a[d.bufferIndex].lineStarts,S=d.start.line,D=d.end.line;let k=E[S]+d.start.column;if(o&&(g.charCodeAt(k)===r.CharCode.LineFeed&&(k++,l--),i[s++]=t,t="",o=!1,l===0))return!0;if(S===D)return!this.f&&g.charCodeAt(k+l-1)===r.CharCode.CarriageReturn?(o=!0,t+=g.substr(k,l-1)):t+=g.substr(k,l),!0;t+=this.f?g.substring(k,Math.max(k,E[S+1]-this.e)):g.substring(k,E[S+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;for(let P=S+1;P<D;P++)t=this.f?g.substring(E[P],E[P+1]-this.e):g.substring(E[P],E[P+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;return!this.f&&g.charCodeAt(E[D]+d.end.column-1)===r.CharCode.CarriageReturn?(o=!0,d.end.column===0?s--:t=g.substr(E[D],d.end.column-1)):t=g.substr(E[D],d.end.column),!0}),o&&(i[s++]=t,t=""),i[s++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const s=i.node.next();if(!s)return 0;const t=this.a[s.piece.bufferIndex],o=this.u(s.piece.bufferIndex,s.piece.start);return t.buffer.charCodeAt(o)}else{const s=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return s.buffer.charCodeAt(o)}}getLineCharCode(i,s){const t=this.H(i,s+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const s=this.getOffsetAt(i,1);return this.getLength()-s}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const s=this.G(i);return this.l(s)}getNearestChunk(i){const s=this.G(i);if(s.remainder===s.node.piece.length){const t=s.node.next();if(!t||t===T.$dD)return"";const o=this.a[t.piece.bufferIndex],n=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(n,n+t.piece.length)}else{const t=this.a[s.node.piece.bufferIndex],o=this.u(s.node.piece.bufferIndex,s.node.piece.start),n=o+s.remainder,d=o+s.node.piece.length;return t.buffer.substring(n,d)}}findMatchesInNode(i,s,t,o,n,d,l,g,E,S,D){const k=this.a[i.piece.bufferIndex],P=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,n),v=this.u(i.piece.bufferIndex,d);let F;const N={line:0,column:0};let L,M;s._wordSeparators?(L=k.buffer.substring(p,v),M=z=>z+p,s.reset(0)):(L=k.buffer,M=z=>z,s.reset(p));do if(F=s.next(L),F){if(M(F.index)>=v)return S;this.s(i,M(F.index)-P,N);const z=this.t(i.piece.bufferIndex,n,N),j=N.line===n.line?N.column-n.column+o:N.column+1,q=j+F[0].length;if(D[S++]=(0,O.$oD)(new A.$Pt(t+z,j,t+z,q),F,g),M(F.index)+F[0].length>=v||S>=E)return S}while(F);return S}findMatchesLineByLine(i,s,t,o){const n=[];let d=0;const l=new O.$rD(s.wordSeparators,s.regex);let g=this.H(i.startLineNumber,i.startColumn);if(g===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let S=this.s(g.node,g.remainder);const D=this.s(E.node,E.remainder);if(g.node===E.node)return this.findMatchesInNode(g.node,l,i.startLineNumber,i.startColumn,S,D,s,t,o,d,n),n;let k=i.startLineNumber,P=g.node;for(;P!==E.node;){const v=this.t(P.piece.bufferIndex,S,P.piece.end);if(v>=1){const N=this.a[P.piece.bufferIndex].lineStarts,L=this.u(P.piece.bufferIndex,P.piece.start),M=N[S.line+v],z=k===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(P,l,k,z,S,this.s(P,M-L),s,t,o,d,n),d>=o)return n;k+=v}const F=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const N=this.getLineContent(k).substring(F,i.endColumn-1);return d=this.n(s,l,N,i.endLineNumber,F,d,n,t,o),n}if(d=this.n(s,l,this.getLineContent(k).substr(F),k,F,d,n,t,o),d>=o)return n;k++,g=this.H(k,1),P=g.node,S=this.s(g.node,g.remainder)}if(k===i.endLineNumber){const v=k===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(k).substring(v,i.endColumn-1);return d=this.n(s,l,F,i.endLineNumber,v,d,n,t,o),n}const p=k===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(E.node,l,k,p,S,D,s,t,o,d,n),n}n(i,s,t,o,n,d,l,g,E){const S=i.wordSeparators;if(!g&&i.simpleSearch){const k=i.simpleSearch,P=k.length,p=t.length;let v=-P;for(;(v=t.indexOf(k,v+P))!==-1;)if((!S||(0,O.$qD)(S,t,p,v,P))&&(l[d++]=new R.$gw(new A.$Pt(o,v+1+n,o,v+1+P+n),null),d>=E))return d;return d}let D;s.reset(0);do if(D=s.next(t),D&&(l[d++]=(0,O.$oD)(new A.$Pt(o,D.index+1+n,o,D.index+1+D[0].length+n),D,g),d>=E))return d;while(D);return d}insert(i,s,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==T.$dD){const{node:o,remainder:n,nodeStartOffset:d}=this.G(i),l=o.piece,g=l.bufferIndex,E=this.s(o,n);if(o.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&d+l.length===i&&s.length<b){this.F(o,s),this.y();return}if(d===i)this.o(s,o),this.h.validate(i);else if(d+o.piece.length>i){const S=[];let D=new C(l.bufferIndex,E,l.end,this.t(l.bufferIndex,E,l.end),this.u(g,l.end)-this.u(g,E));if(this.K()&&this.M(s)&&this.I(o,n)===10){const v={line:D.start.line+1,column:0};D=new C(D.bufferIndex,v,D.end,this.t(D.bufferIndex,v,D.end),D.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(o,n-1)===13){const v=this.s(o,n-1);this.C(o,v),s="\r"+s,o.piece.length===0&&S.push(o)}else this.C(o,E);else this.C(o,E);const k=this.w(s);D.length>0&&this.S(o,D);let P=o;for(let p=0;p<k.length;p++)P=this.S(P,k[p]);this.v(S)}else this.q(s,o)}else{const o=this.w(s);let n=this.T(null,o[0]);for(let d=1;d<o.length;d++)n=this.S(n,o[d])}this.y()}delete(i,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===T.$dD)return;const t=this.G(i),o=this.G(i+s),n=t.node,d=o.node;if(n===d){const k=this.s(n,t.remainder),P=this.s(n,o.remainder);if(t.nodeStartOffset===i){if(s===n.piece.length){const p=n.next();(0,T.$iD)(this,n),this.N(p),this.y();return}this.D(n,P),this.h.validate(i),this.N(n),this.y();return}if(t.nodeStartOffset+n.piece.length===i+s){this.C(n,k),this.O(n),this.y();return}this.E(n,k,P),this.y();return}const l=[],g=this.s(n,t.remainder);this.C(n,g),this.h.validate(i),n.piece.length===0&&l.push(n);const E=this.s(d,o.remainder);this.D(d,E),d.piece.length===0&&l.push(d);const S=n.next();for(let k=S;k!==T.$dD&&k!==d;k=k.next())l.push(k);const D=n.piece.length===0?n.prev():n;this.v(l),this.O(D),this.y()}o(i,s){const t=[];if(this.K()&&this.M(i)&&this.L(s)){const d=s.piece,l={line:d.start.line+1,column:0},g=new C(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),d.length-1);s.piece=g,i+=`
`,(0,T.$kD)(this,s,-1,-1),s.piece.length===0&&t.push(s)}const o=this.w(i);let n=this.T(s,o[o.length-1]);for(let d=o.length-2;d>=0;d--)n=this.T(n,o[d]);this.N(n),this.v(t)}q(i,s){this.Q(i,s)&&(i+=`
`);const t=this.w(i),o=this.S(s,t[0]);let n=o;for(let d=1;d<t.length;d++)n=this.S(n,t[d]);this.N(o)}s(i,s,t){const o=i.piece,n=i.piece.bufferIndex,d=this.a[n].lineStarts,g=d[o.start.line]+o.start.column+s;let E=o.start.line,S=o.end.line,D=0,k=0,P=0;for(;E<=S&&(D=E+(S-E)/2|0,P=d[D],D!==S);)if(k=d[D+1],g<P)S=D-1;else if(g>=k)E=D+1;else break;return t?(t.line=D,t.column=g-P,null):{line:D,column:g-P}}t(i,s,t){if(t.column===0)return t.line-s.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-s.line;const n=o[t.line+1],d=o[t.line]+t.column;if(n>d+1)return t.line-s.line;const l=d-1;return this.a[i].buffer.charCodeAt(l)===13?t.line-s.line+1:t.line-s.line}u(i,s){return this.a[i].lineStarts[s.line]+s.column}v(i){for(let s=0;s<i.length;s++)(0,T.$iD)(this,i[s])}w(i){if(i.length>b){const S=[];for(;i.length>b;){const k=i.charCodeAt(b-1);let P;k===r.CharCode.CarriageReturn||k>=55296&&k<=56319?(P=i.substring(0,b-1),i=i.substring(b-1)):(P=i.substring(0,b),i=i.substring(b));const p=y(P);S.push(new C(this.a.length,{line:0,column:0},{line:p.length-1,column:P.length-p[p.length-1]},p.length-1,P.length)),this.a.push(new w(P,p))}const D=y(i);return S.push(new C(this.a.length,{line:0,column:0},{line:D.length-1,column:i.length-D[D.length-1]},D.length-1,i.length)),this.a.push(new w(i,D)),S}let s=this.a[0].buffer.length;const t=y(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let S=0;S<t.length;S++)t[S]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,s+=1}else{if(s!==0)for(let S=0;S<t.length;S++)t[S]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const n=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,l=n-this.a[0].lineStarts[d],g={line:d,column:l},E=new C(0,o,g,this.t(0,o,g),n-s);return this.g=g,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,s=0){let t=this.root,o="";const n=this.h.get2(i);if(n){t=n.node;const d=this.B(t,i-n.nodeStartLineNumber-1),l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(n.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=l.substring(g+d,g+t.piece.length);else{const E=this.B(t,i-n.nodeStartLineNumber);return l.substring(g+d,g+E-s)}}else{let d=0;const l=i;for(;t!==T.$dD;)if(t.left!==T.$dD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const g=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),S=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);return d+=t.size_left,this.h.set({node:t,nodeStartOffset:d,nodeStartLineNumber:l-(i-1-t.lf_left)}),S.substring(D+g,D+E-s)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const g=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,S=this.u(t.piece.bufferIndex,t.piece.start);o=E.substring(S+g,S+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,d+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==T.$dD;){const d=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.u(t.piece.bufferIndex,t.piece.start);return o+=d.substring(g,g+l-s),o}else{const l=this.u(t.piece.bufferIndex,t.piece.start);o+=d.substr(l,t.piece.length)}t=t.next()}return o}y(){let i=this.root,s=1,t=0;for(;i!==T.$dD;)s+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=s,this.c=t,this.h.validate(this.c)}A(i,s){const t=i.piece,o=this.s(i,s),n=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===s){const d=this.t(i.piece.bufferIndex,t.start,o);if(d!==n)return{index:d,remainder:0}}return{index:n,remainder:o.column}}B(i,s){if(s<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,n=t.start.line+s+1;return n>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[n]-o[t.start.line]-t.start.column}C(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.u(t.bufferIndex,t.end),d=s,l=this.u(t.bufferIndex,d),g=this.t(t.bufferIndex,t.start,d),E=g-o,S=l-n,D=t.length+S;i.piece=new C(t.bufferIndex,t.start,d,g,D),(0,T.$kD)(this,i,S,E)}D(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.u(t.bufferIndex,t.start),d=s,l=this.t(t.bufferIndex,d,t.end),g=this.u(t.bufferIndex,d),E=l-o,S=n-g,D=t.length+S;i.piece=new C(t.bufferIndex,d,t.end,l,D),(0,T.$kD)(this,i,S,E)}E(i,s,t){const o=i.piece,n=o.start,d=o.end,l=o.length,g=o.lineFeedCnt,E=s,S=this.t(o.bufferIndex,o.start,E),D=this.u(o.bufferIndex,s)-this.u(o.bufferIndex,n);i.piece=new C(o.bufferIndex,o.start,E,S,D),(0,T.$kD)(this,i,D-l,S-g);const k=new C(o.bufferIndex,t,d,this.t(o.bufferIndex,t,d),this.u(o.bufferIndex,d)-this.u(o.bufferIndex,t)),P=this.S(i,k);this.N(P)}F(i,s){this.Q(s,i)&&(s+=`
`);const t=this.K()&&this.L(s)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=s;const n=y(s,!1);for(let P=0;P<n.length;P++)n[P]+=o;if(t){const P=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-P}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const d=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[d],g={line:d,column:l},E=i.piece.length+s.length,S=i.piece.lineFeedCnt,D=this.t(0,i.piece.start,g),k=D-S;i.piece=new C(i.piece.bufferIndex,i.piece.start,g,D,E),this.g=g,(0,T.$kD)(this,i,s.length,k)}G(i){let s=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;s!==T.$dD;)if(s.size_left>i)s=s.left;else if(s.size_left+s.piece.length>=i){o+=s.size_left;const n={node:s,remainder:i-s.size_left,nodeStartOffset:o};return this.h.set(n),n}else i-=s.size_left+s.piece.length,o+=s.size_left+s.piece.length,s=s.right;return null}H(i,s){let t=this.root,o=0;for(;t!==T.$dD;)if(t.left!==T.$dD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const n=this.B(t,i-t.lf_left-2),d=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(n+s-1,d),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const n=this.B(t,i-t.lf_left-2);if(n+s-1<=t.piece.length)return{node:t,remainder:n+s-1,nodeStartOffset:o};s-=t.piece.length-n;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==T.$dD;){if(t.piece.lineFeedCnt>0){const n=this.B(t,0),d=this.J(t);return{node:t,remainder:Math.min(s-1,n),nodeStartOffset:d}}else if(t.piece.length>=s-1){const n=this.J(t);return{node:t,remainder:s-1,nodeStartOffset:n}}else s-=t.piece.length;t=t.next()}return null}I(i,s){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+s;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let s=i.size_left;for(;i!==this.root;)i.parent.right===i&&(s+=i.parent.size_left+i.parent.piece.length),i=i.parent;return s}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===T.$dD||i.piece.lineFeedCnt===0)return!1;const s=i.piece,t=this.a[s.bufferIndex].lineStarts,o=s.start.line,n=t[o]+s.start.column;return o===t.length-1||t[o+1]>n+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(n)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===T.$dD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const s=i.prev();this.M(s)&&this.P(s,i)}}O(i){if(this.K()&&this.M(i)){const s=i.next();this.L(s)&&this.P(i,s)}}P(i,s){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let n;i.piece.end.column===0?n={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:n={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,l=i.piece.lineFeedCnt-1;i.piece=new C(i.piece.bufferIndex,i.piece.start,n,l,d),(0,T.$kD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const g={line:s.piece.start.line+1,column:0},E=s.piece.length-1,S=this.t(s.piece.bufferIndex,g,s.piece.end);s.piece=new C(s.piece.bufferIndex,g,s.piece.end,S,E),(0,T.$kD)(this,s,-1,-1),s.piece.length===0&&t.push(s);const D=this.w(`\r
`);this.S(i,D[0]);for(let k=0;k<t.length;k++)(0,T.$iD)(this,t[k])}Q(i,s){if(this.K()&&this.M(i)){const t=s.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,T.$iD)(this,t);else{const o=t.piece,n={line:o.start.line+1,column:0},d=o.length-1,l=this.t(o.bufferIndex,n,o.end);t.piece=new C(o.bufferIndex,n,o.end,l,d),(0,T.$kD)(this,t,-1,-1)}return!0}}return!1}iterate(i,s){if(i===T.$dD)return s(T.$dD);const t=this.iterate(i.left,s);return t&&s(i)&&this.iterate(i.right,s)}R(i){if(i===T.$dD)return"";const s=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),n=this.u(t.bufferIndex,t.end);return s.buffer.substring(o,n)}getPieceContent(i){const s=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return s.buffer.substring(t,o)}S(i,s){const t=new T.$cD(s,T.NodeColor.Red);if(t.left=T.$dD,t.right=T.$dD,t.parent=T.$dD,t.size_left=0,t.lf_left=0,this.root===T.$dD)this.root=t,t.color=T.NodeColor.Black;else if(i.right===T.$dD)i.right=t,t.parent=i;else{const n=(0,T.$eD)(i.right);n.left=t,t.parent=n}return(0,T.$jD)(this,t),t}T(i,s){const t=new T.$cD(s,T.NodeColor.Red);if(t.left=T.$dD,t.right=T.$dD,t.parent=T.$dD,t.size_left=0,t.lf_left=0,this.root===T.$dD)this.root=t,t.color=T.NodeColor.Black;else if(i.left===T.$dD)i.left=t,t.parent=i;else{const o=(0,T.$fD)(i.left);o.right=t,t.parent=o}return(0,T.$jD)(this,t),t}U(i){let s="";return this.iterate(i,t=>(s+=this.R(t),!0)),s}}e.$wD=$}),define(ke[207],Ie([1,0,4,12,30,58,142,194,198,3]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xD=void 0,h=We(h);class I extends c.$Vc{constructor(u,C,w,a,m,$,f){super(),this.m=this.B(new r.$me),this.onDidChangeContent=this.m.event,this.f=C,this.j=!$,this.g=a,this.h=m,this.c=new T.$wD(u,w,f)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,C){return this.c.getOffsetAt(u,C)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,C){const w=u+C,a=this.getPositionAt(u),m=this.getPositionAt(w);return new A.$Pt(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange(u,C=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const w=this.n(C);return this.c.getValueInRange(u,w)}getValueLengthInRange(u,C=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const w=this.getOffsetAt(u.startLineNumber,u.startColumn),a=this.getOffsetAt(u.endLineNumber,u.endColumn);let m=0;const $=this.n(C),f=this.getEOL();if($.length!==f.length){const i=$.length-f.length,s=u.endLineNumber-u.startLineNumber;m=i*s}return a-w+m}getCharacterCountInRange(u,C=R.EndOfLinePreference.TextDefined){if(this.j){let w=0;const a=u.startLineNumber,m=u.endLineNumber;for(let $=a;$<=m;$++){const f=this.getLineContent($),i=$===a?u.startColumn-1:0,s=$===m?u.endColumn-1:f.length;for(let t=i;t<s;t++)h.$Kf(f.charCodeAt(t))?(w=w+1,t=t+1):w=w+1}return w+=this.n(C).length*(m-a),w}return this.getValueLengthInRange(u,C)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,C){return this.c.getLineCharCode(u,C)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const C=h.$vf(this.getLineContent(u));return C===-1?0:C+1}getLineLastNonWhitespaceColumn(u){const C=h.$xf(this.getLineContent(u));return C===-1?0:C+2}n(u){switch(u){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,C,w){let a=this.g,m=this.h,$=this.j,f=!0,i=[];for(let g=0;g<u.length;g++){const E=u[g];f&&E._isTracked&&(f=!1);const S=E.range;if(E.text){let v=!0;$||(v=!h.$Vf(E.text),$=v),!a&&v&&(a=h.$Uf(E.text)),!m&&v&&(m=h.$Xf(E.text))}let D="",k=0,P=0,p=0;if(E.text){let v;[k,P,p,v]=(0,O.$Au)(E.text);const F=this.getEOL(),N=F===`\r
`?O.StringEOL.CRLF:O.StringEOL.LF;v===O.StringEOL.Unknown||v===N?D=E.text:D=E.text.replace(/\r\n|\r|\n/g,F)}i[g]={sortIndex:g,identifier:E.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:D,eolCount:k,firstLineLength:P,lastLineLength:p,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(I.u);let s=!1;for(let g=0,E=i.length-1;g<E;g++){const S=i[g].range.getEndPosition(),D=i[g+1].range.getStartPosition();if(D.isBeforeOrEqual(S)){if(D.isBefore(S))throw new Error("Overlapping ranges are not allowed!");s=!0}}f&&(i=this.s(i));const t=w||C?I._getInverseEditRanges(i):[],o=[];if(C)for(let g=0;g<i.length;g++){const E=i[g],S=t[g];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let D=S.startLineNumber;D<=S.endLineNumber;D++){let k="";D===S.startLineNumber&&(k=this.getLineContent(E.range.startLineNumber),h.$vf(k)!==-1)||o.push({lineNumber:D,oldContent:k})}}let n=null;if(w){let g=0;n=[];for(let E=0;E<i.length;E++){const S=i[E],D=t[E],k=this.getValueInRange(S.range),P=S.rangeOffset+g;g+=S.text.length-k.length,n[E]={sortIndex:S.sortIndex,identifier:S.identifier,range:D,text:k,textChange:new b.$gu(S.rangeOffset,k,P,S.text)}}s||n.sort((E,S)=>E.sortIndex-S.sortIndex)}this.g=a,this.h=m,this.j=$;const d=this.t(i);let l=null;if(C&&o.length>0){o.sort((g,E)=>E.lineNumber-g.lineNumber),l=[];for(let g=0,E=o.length;g<E;g++){const S=o[g].lineNumber;if(g>0&&o[g-1].lineNumber===S)continue;const D=o[g].oldContent,k=this.getLineContent(S);k.length===0||k===D||h.$vf(k)!==-1||l.push(S)}}return this.m.fire(),new R.$kw(n,d,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let C=!1;const w=u[0].range,a=u[u.length-1].range,m=new A.$Pt(w.startLineNumber,w.startColumn,a.endLineNumber,a.endColumn);let $=w.startLineNumber,f=w.startColumn;const i=[];for(let d=0,l=u.length;d<l;d++){const g=u[d],E=g.range;C=C||g.forceMoveMarkers,i.push(this.getValueInRange(new A.$Pt($,f,E.startLineNumber,E.startColumn))),g.text.length>0&&i.push(g.text),$=E.endLineNumber,f=E.endColumn}const s=i.join(""),[t,o,n]=(0,O.$Au)(s);return{sortIndex:0,identifier:u[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,R.EndOfLinePreference.TextDefined),text:s,eolCount:t,firstLineLength:o,lastLineLength:n,forceMoveMarkers:C,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const C=[];for(let w=0;w<u.length;w++){const a=u[w],m=a.range.startLineNumber,$=a.range.startColumn,f=a.range.endLineNumber,i=a.range.endColumn;if(m===f&&$===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const s=new A.$Pt(m,$,f,i);C.push({range:s,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return C}findMatchesLineByLine(u,C,w,a){return this.c.findMatchesLineByLine(u,C,w,a)}getPieceTree(){return this.c}static _getInverseEditRange(u,C){const w=u.startLineNumber,a=u.startColumn,[m,$,f]=(0,O.$Au)(C);let i;if(C.length>0){const s=m+1;s===1?i=new A.$Pt(w,a,w,a+$):i=new A.$Pt(w,a,w+s-1,f+1)}else i=new A.$Pt(w,a,w,a);return i}static _getInverseEditRanges(u){const C=[];let w=0,a=0,m=null;for(let $=0,f=u.length;$<f;$++){const i=u[$];let s,t;m?m.range.endLineNumber===i.range.startLineNumber?(s=w,t=a+(i.range.startColumn-m.range.endColumn)):(s=w+(i.range.startLineNumber-m.range.endLineNumber),t=i.range.startColumn):(s=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const n=i.eolCount+1;n===1?o=new A.$Pt(s,t,s,t+i.firstLineLength):o=new A.$Pt(s,t,s+n-1,i.lastLineLength+1)}else o=new A.$Pt(s,t,s,t);w=o.endLineNumber,a=o.endColumn,C.push(o),m=i}return C}static u(u,C){const w=A.$Pt.compareRangesUsingEnds(u.range,C.range);return w===0?u.sortIndex-C.sortIndex:w}static w(u,C){const w=A.$Pt.compareRangesUsingEnds(u.range,C.range);return w===0?C.sortIndex-u.sortIndex:-w}}e.$xD=I}),define(ke[208],Ie([1,0,26,12,58,142,207]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yD=void 0,h=We(h);class O{constructor(I,y,u,C,w,a,m,$,f){this.a=I,this.b=y,this.c=u,this.d=C,this.e=w,this.f=a,this.g=m,this.h=$,this.j=f}k(I){const y=this.c+this.d+this.e,u=this.c+this.e;return y===0?I===A.DefaultEndOfLine.LF?`
`:`\r
`:u>y/2?`\r
`:`
`}create(I){const y=this.k(I),u=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let w=0,a=u.length;w<a;w++){const m=u[w].buffer.replace(/\r\n|\r|\n/g,y),$=(0,R.$sD)(m);u[w]=new R.$vD(m,$)}const C=new T.$xD(u,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class b{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$6f(I)&&(this.b=h.$5f,I=I.substr(1));const y=I.charCodeAt(I.length-1);y===r.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=y):(this.m(I,!1),this.c=!1,this.d=y)}m(I,y){!y&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const y=(0,R.$tD)(this.e,I);this.a.push(new R.$vD(I,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Uf(I)),this.k||(this.k=h.$Xf(I)))}finish(I=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const y=(0,R.$sD)(I.buffer);I.lineStarts=y,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$yD=b}),define(ke[143],Ie([1,0,21,10]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2db=b,e.$3db=I,h=We(h);var A;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(A||(A={}));function R(y){for(let u=0,C=y.length;u<C;u+=4){const w=y[u+0],a=y[u+1],m=y[u+2],$=y[u+3];y[u+0]=$,y[u+1]=m,y[u+2]=a,y[u+3]=w}}function T(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return h.$E()||R(u),r.$Oe.wrap(u)}function O(y){const u=y.buffer;if(h.$E()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const C=new Uint8Array(u.byteLength);return C.set(u),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function b(y){const u=new Uint32Array(c(y));let C=0;if(u[C++]=y.id,y.type==="full")u[C++]=A.Full,u[C++]=y.data.length,u.set(y.data,C),C+=y.data.length;else{u[C++]=A.Delta,u[C++]=y.deltas.length;for(const w of y.deltas)u[C++]=w.start,u[C++]=w.deleteCount,w.data?(u[C++]=w.data.length,u.set(w.data,C),C+=w.data.length):u[C++]=0}return T(u)}function c(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const C of y.deltas)C.data&&(u+=C.data.length)}return u}function I(y){const u=O(y);let C=0;const w=u[C++];if(u[C++]===A.Full){const f=u[C++],i=u.subarray(C,C+f);return C+=f,{id:w,type:"full",data:i}}const m=u[C++],$=[];for(let f=0;f<m;f++){const i=u[C++],s=u[C++],t=u[C++];let o;t>0&&(o=u.subarray(C,C+t),C+=t),$[f]={start:i,deleteCount:s,data:o}}return{id:w,type:"delta",deltas:$}}}),define(ke[209],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T_=e.$S_=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const T=this.a.get(R);return this.a.delete(R),T}}addDragOperationTransfer(R,T){this.a.set(R,T)}}e.$S_=r;class h{constructor(R){this.identifier=R}}e.$T_=h}),define(ke[210],Ie([1,0,4,3,110]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zu=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$me,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,c){return this.a.set(b,c),this.handleChange([b]),(0,h.$Tc)(()=>{this.a.get(b)===c&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,c){this.b.get(b)?.dispose();const I=new T(this,b,c);return this.b.set(b,I),(0,h.$Tc)(()=>{const y=this.b.get(b);!y||y!==I||(this.b.delete(b),y.dispose())})}async getOrCreate(b){const c=this.get(b);if(c)return c;const I=this.b.get(b);return!I||I.isResolved?null:(await I.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const I=this.b.get(b);return!!(!I||I.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>A.ColorId.DefaultBackground?this.d[A.ColorId.DefaultBackground]:null}}e.$zu=R;class T extends h.$Vc{get isResolved(){return this.c}constructor(b,c,I){super(),this.f=b,this.g=c,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[8],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=A,e.localize2=T;const r=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function h(O,b){let c;return b.length===0?c=O:c=O.replace(/\{(\d+)\}/g,(I,y)=>{const u=y[0],C=b[u];let w=I;return typeof C=="string"?w=C:(typeof C=="number"||typeof C=="boolean"||C===void 0||C===null)&&(w=String(C)),w}),r&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function A(O,b,...c){return h(typeof O=="number"?R(O,b):b,c)}function R(O,b){const c=globalThis._VSCODE_NLS_MESSAGES?.[O];if(typeof c!="string"){if(typeof b=="string")return b;throw new Error(`!!! NLS MISSING: ${O} !!!`)}return c}function T(O,b,...c){let I;typeof O=="number"?I=R(O,b):I=b;const y=h(I,c);return{value:y,original:b===I?y:h(b,c)}}}),define(ke[211],Ie([1,0,4,3,8]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0,e.$qj=I,A=We(A);class R extends h.$Vc{constructor(u,C="",w="",a=!0,m){super(),this.j=this.B(new r.$me),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=C,this.w=w,this.z=a,this.D=m}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,C){this.D&&await this.D(u)}}e.$lj=R;class T extends h.$Vc{constructor(){super(...arguments),this.f=this.B(new r.$me),this.onWillRun=this.f.event,this.m=this.B(new r.$me),this.onDidRun=this.m.event}async run(u,C){if(!u.enabled)return;this.f.fire({action:u});let w;try{await this.u(u,C)}catch(a){w=a}this.m.fire({action:u,error:w})}async u(u,C){await u.run(C)}}e.$mj=T;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let C=[];for(const w of u)w.length&&(C.length?C=[...C,new O,...w]:C=w);return C}static{this.ID="vs.actions.separator"}async run(){}}e.$nj=O;class b{get actions(){return this.a}constructor(u,C,w,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=C,this.class=a,this.a=w}async run(){}}e.$oj=b;class c extends R{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,A.localize(39,null),void 0,!1)}}e.$pj=c;function I(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u)}}}),define(ke[212],Ie([1,0,8]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=c,e.$4m=I,e.$5m=y;const h=60,A=h*60,R=A*24,T=R*7,O=R*30,b=R*365;function c(u,C,w,a){typeof u!="number"&&(u=u.getTime());const m=Math.round((new Date().getTime()-u)/1e3);if(m<-30)return(0,r.localize)(40,null,c(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,r.localize)(41,null);let $;return m<h?($=m,C?$===1?w?(0,r.localize)(42,null,$):(0,r.localize)(43,null,$):w?(0,r.localize)(44,null,$):(0,r.localize)(45,null,$):$===1?w?(0,r.localize)(46,null,$):(0,r.localize)(47,null,$):w?(0,r.localize)(48,null,$):(0,r.localize)(49,null,$)):m<A?($=Math.floor(m/h),C?$===1?w?(0,r.localize)(50,null,$):(0,r.localize)(51,null,$):w?(0,r.localize)(52,null,$):(0,r.localize)(53,null,$):$===1?w?(0,r.localize)(54,null,$):(0,r.localize)(55,null,$):w?(0,r.localize)(56,null,$):(0,r.localize)(57,null,$)):m<R?($=Math.floor(m/A),C?$===1?w?(0,r.localize)(58,null,$):(0,r.localize)(59,null,$):w?(0,r.localize)(60,null,$):(0,r.localize)(61,null,$):$===1?w?(0,r.localize)(62,null,$):(0,r.localize)(63,null,$):w?(0,r.localize)(64,null,$):(0,r.localize)(65,null,$)):m<T?($=Math.floor(m/R),C?$===1?(0,r.localize)(66,null,$):(0,r.localize)(67,null,$):$===1?(0,r.localize)(68,null,$):(0,r.localize)(69,null,$)):m<O?($=Math.floor(m/T),C?$===1?w?(0,r.localize)(70,null,$):(0,r.localize)(71,null,$):w?(0,r.localize)(72,null,$):(0,r.localize)(73,null,$):$===1?w?(0,r.localize)(74,null,$):(0,r.localize)(75,null,$):w?(0,r.localize)(76,null,$):(0,r.localize)(77,null,$)):m<b?($=Math.floor(m/O),C?$===1?w?(0,r.localize)(78,null,$):(0,r.localize)(79,null,$):w?(0,r.localize)(80,null,$):(0,r.localize)(81,null,$):$===1?w?(0,r.localize)(82,null,$):(0,r.localize)(83,null,$):w?(0,r.localize)(84,null,$):(0,r.localize)(85,null,$)):($=Math.floor(m/b),C?$===1?w?(0,r.localize)(86,null,$):(0,r.localize)(87,null,$):w?(0,r.localize)(88,null,$):(0,r.localize)(89,null,$):$===1?w?(0,r.localize)(90,null,$):(0,r.localize)(91,null,$):w?(0,r.localize)(92,null,$):(0,r.localize)(93,null,$))}function I(u,C){const w=Math.abs(u/1e3);return w<1?C?(0,r.localize)(94,null,u):(0,r.localize)(95,null,u):w<h?C?(0,r.localize)(96,null,Math.round(u)/1e3):(0,r.localize)(97,null,Math.round(u)/1e3):w<A?C?(0,r.localize)(98,null,Math.round(u/(1e3*h))):(0,r.localize)(99,null,Math.round(u/(1e3*h))):w<R?C?(0,r.localize)(100,null,Math.round(u/(1e3*A))):(0,r.localize)(101,null,Math.round(u/(1e3*A))):(0,r.localize)(102,null,Math.round(u/(1e3*R)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[52],Ie([1,0,18,17,8]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=b,e.$sj=c,e.$tj=I,r=We(r),h=We(h),A=We(A);function R(y,u){return u&&(y.stack||y.stacktrace)?A.localize(103,null,O(y),T(y.stack)||T(y.stacktrace)):O(y)}function T(y){return Array.isArray(y)?y.join(`
`):y}function O(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?A.localize(104,null,y.message):y.message||A.localize(105,null)}function b(y=null,u=!1){if(!y)return A.localize(106,null);if(Array.isArray(y)){const C=r.$Hb(y),w=b(C[0],u);return C.length>1?A.localize(107,null,w,C.length):w}if(h.$fg(y))return y;if(y.detail){const C=y.detail;if(C.error)return R(C.error,u);if(C.exception)return R(C.exception,u)}return y.stack?R(y,u):y.message?y.message:A.localize(108,null)}function c(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function I(y,u){let C;return typeof y=="string"?C=new Error(y):C=y,C.actions=u,C}}),define(ke[87],Ie([1,0,82,2,195,30,210,8]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Tu=e.$Su=e.$Ru=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Qu=e.$Pu=e.SymbolKinds=e.SymbolTag=e.$Nu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Lu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Ku=e.$Ju=e.$Iu=void 0,e.$Mu=d,e.$Ou=g;class b{constructor(W,X,_){this.offset=W,this.type=X,this.language=_,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Iu=b;class c{constructor(W,X){this.tokens=W,this.endState=X,this._tokenizationResultBrand=void 0}}e.$Ju=c;class I{constructor(W,X){this.tokens=W,this.endState=X,this._encodedTokenizationResultBrand=void 0}}e.$Ku=I;var y;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(y||(e.HoverVerbosityAction=y={}));var u;(function(H){H[H.Method=0]="Method",H[H.Function=1]="Function",H[H.Constructor=2]="Constructor",H[H.Field=3]="Field",H[H.Variable=4]="Variable",H[H.Class=5]="Class",H[H.Struct=6]="Struct",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Event=10]="Event",H[H.Operator=11]="Operator",H[H.Unit=12]="Unit",H[H.Value=13]="Value",H[H.Constant=14]="Constant",H[H.Enum=15]="Enum",H[H.EnumMember=16]="EnumMember",H[H.Keyword=17]="Keyword",H[H.Text=18]="Text",H[H.Color=19]="Color",H[H.File=20]="File",H[H.Reference=21]="Reference",H[H.Customcolor=22]="Customcolor",H[H.Folder=23]="Folder",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue",H[H.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var C;(function(H){const W=new Map;W.set(u.Method,r.$6j.symbolMethod),W.set(u.Function,r.$6j.symbolFunction),W.set(u.Constructor,r.$6j.symbolConstructor),W.set(u.Field,r.$6j.symbolField),W.set(u.Variable,r.$6j.symbolVariable),W.set(u.Class,r.$6j.symbolClass),W.set(u.Struct,r.$6j.symbolStruct),W.set(u.Interface,r.$6j.symbolInterface),W.set(u.Module,r.$6j.symbolModule),W.set(u.Property,r.$6j.symbolProperty),W.set(u.Event,r.$6j.symbolEvent),W.set(u.Operator,r.$6j.symbolOperator),W.set(u.Unit,r.$6j.symbolUnit),W.set(u.Value,r.$6j.symbolValue),W.set(u.Enum,r.$6j.symbolEnum),W.set(u.Constant,r.$6j.symbolConstant),W.set(u.Enum,r.$6j.symbolEnum),W.set(u.EnumMember,r.$6j.symbolEnumMember),W.set(u.Keyword,r.$6j.symbolKeyword),W.set(u.Snippet,r.$6j.symbolSnippet),W.set(u.Text,r.$6j.symbolText),W.set(u.Color,r.$6j.symbolColor),W.set(u.File,r.$6j.symbolFile),W.set(u.Reference,r.$6j.symbolReference),W.set(u.Customcolor,r.$6j.symbolCustomColor),W.set(u.Folder,r.$6j.symbolFolder),W.set(u.TypeParameter,r.$6j.symbolTypeParameter),W.set(u.User,r.$6j.account),W.set(u.Issue,r.$6j.issues);function X(ne){let ye=W.get(ne);return ye||(console.info("No codicon found for CompletionItemKind "+ne),ye=r.$6j.symbolProperty),ye}H.toIcon=X;const _=new Map;_.set("method",u.Method),_.set("function",u.Function),_.set("constructor",u.Constructor),_.set("field",u.Field),_.set("variable",u.Variable),_.set("class",u.Class),_.set("struct",u.Struct),_.set("interface",u.Interface),_.set("module",u.Module),_.set("property",u.Property),_.set("event",u.Event),_.set("operator",u.Operator),_.set("unit",u.Unit),_.set("value",u.Value),_.set("constant",u.Constant),_.set("enum",u.Enum),_.set("enum-member",u.EnumMember),_.set("enumMember",u.EnumMember),_.set("keyword",u.Keyword),_.set("snippet",u.Snippet),_.set("text",u.Text),_.set("color",u.Color),_.set("file",u.File),_.set("reference",u.Reference),_.set("customcolor",u.Customcolor),_.set("folder",u.Folder),_.set("type-parameter",u.TypeParameter),_.set("typeParameter",u.TypeParameter),_.set("account",u.User),_.set("issue",u.Issue);function ce(ne,ye){let ge=_.get(ne);return typeof ge>"u"&&!ye&&(ge=u.Property),ge}H.fromString=ce})(C||(e.CompletionItemKinds=C={}));var w;(function(H){H[H.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var a;(function(H){H[H.None=0]="None",H[H.KeepWhitespace=1]="KeepWhitespace",H[H.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var m;(function(H){H[H.Word=0]="Word",H[H.Line=1]="Line",H[H.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var $;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($||(e.CompletionTriggerKind=$={}));var f;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class i{constructor(W,X,_,ce){this.range=W,this.text=X,this.completionKind=_,this.isSnippetText=ce}equals(W){return R.$Pt.lift(this.range).equalsRange(W.range)&&this.text===W.text&&this.completionKind===W.completionKind&&this.isSnippetText===W.isSnippetText}}e.$Lu=i;var s;(function(H){H[H.Invoke=1]="Invoke",H[H.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var t;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var o;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var n;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function d(H){return H&&h.URI.isUri(H.uri)&&R.$Pt.isIRange(H.range)&&(R.$Pt.isIRange(H.originSelectionRange)||R.$Pt.isIRange(H.targetSelectionRange))}var l;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(l||(e.SymbolKind=l={})),e.$Nu={[l.Array]:(0,O.localize)(783,null),[l.Boolean]:(0,O.localize)(784,null),[l.Class]:(0,O.localize)(785,null),[l.Constant]:(0,O.localize)(786,null),[l.Constructor]:(0,O.localize)(787,null),[l.Enum]:(0,O.localize)(788,null),[l.EnumMember]:(0,O.localize)(789,null),[l.Event]:(0,O.localize)(790,null),[l.Field]:(0,O.localize)(791,null),[l.File]:(0,O.localize)(792,null),[l.Function]:(0,O.localize)(793,null),[l.Interface]:(0,O.localize)(794,null),[l.Key]:(0,O.localize)(795,null),[l.Method]:(0,O.localize)(796,null),[l.Module]:(0,O.localize)(797,null),[l.Namespace]:(0,O.localize)(798,null),[l.Null]:(0,O.localize)(799,null),[l.Number]:(0,O.localize)(800,null),[l.Object]:(0,O.localize)(801,null),[l.Operator]:(0,O.localize)(802,null),[l.Package]:(0,O.localize)(803,null),[l.Property]:(0,O.localize)(804,null),[l.String]:(0,O.localize)(805,null),[l.Struct]:(0,O.localize)(806,null),[l.TypeParameter]:(0,O.localize)(807,null),[l.Variable]:(0,O.localize)(808,null)};function g(H,W){return(0,O.localize)(809,null,H,e.$Nu[W])}var E;(function(H){H[H.Deprecated=1]="Deprecated"})(E||(e.SymbolTag=E={}));var S;(function(H){const W=new Map;W.set(l.File,r.$6j.symbolFile),W.set(l.Module,r.$6j.symbolModule),W.set(l.Namespace,r.$6j.symbolNamespace),W.set(l.Package,r.$6j.symbolPackage),W.set(l.Class,r.$6j.symbolClass),W.set(l.Method,r.$6j.symbolMethod),W.set(l.Property,r.$6j.symbolProperty),W.set(l.Field,r.$6j.symbolField),W.set(l.Constructor,r.$6j.symbolConstructor),W.set(l.Enum,r.$6j.symbolEnum),W.set(l.Interface,r.$6j.symbolInterface),W.set(l.Function,r.$6j.symbolFunction),W.set(l.Variable,r.$6j.symbolVariable),W.set(l.Constant,r.$6j.symbolConstant),W.set(l.String,r.$6j.symbolString),W.set(l.Number,r.$6j.symbolNumber),W.set(l.Boolean,r.$6j.symbolBoolean),W.set(l.Array,r.$6j.symbolArray),W.set(l.Object,r.$6j.symbolObject),W.set(l.Key,r.$6j.symbolKey),W.set(l.Null,r.$6j.symbolNull),W.set(l.EnumMember,r.$6j.symbolEnumMember),W.set(l.Struct,r.$6j.symbolStruct),W.set(l.Event,r.$6j.symbolEvent),W.set(l.Operator,r.$6j.symbolOperator),W.set(l.TypeParameter,r.$6j.symbolTypeParameter);function X(_){let ce=W.get(_);return ce||(console.info("No codicon found for SymbolKind "+_),ce=r.$6j.symbolProperty),ce}H.toIcon=X})(S||(e.SymbolKinds=S={}));class D{static asEditOperation(W){return A.$Qt.replace(R.$Pt.lift(W.range),W.text)}}e.$Pu=D;class k{static{this.Comment=new k("comment")}static{this.Imports=new k("imports")}static{this.Region=new k("region")}static fromValue(W){switch(W){case"comment":return k.Comment;case"imports":return k.Imports;case"region":return k.Region}return new k(W)}constructor(W){this.value=W}}e.$Qu=k;var P;(function(H){H[H.AIGenerated=1]="AIGenerated"})(P||(e.NewSymbolNameTag=P={}));var p;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(p||(e.NewSymbolNameTriggerKind=p={}));var v;(function(H){function W(X){return!X||typeof X!="object"?!1:typeof X.id=="string"&&typeof X.title=="string"}H.is=W})(v||(e.Command=v={}));var F;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(F||(e.CommentThreadCollapsibleState=F={}));var N;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var L;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(L||(e.CommentThreadApplicability=L={}));var M;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(M||(e.CommentMode=M={}));var z;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(z||(e.CommentState=z={}));var j;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class q{constructor(W){this.b=W,this.a=null}dispose(){this.a&&this.a.then(W=>{W&&W.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Ru=q,e.$Su=new T.$zu,e.$Tu=new T.$zu;var B;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(B||(e.ExternalUriOpenerPriority=B={}));var ee;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(ee||(e.InlineEditTriggerKind=ee={}))}),define(ke[213],Ie([1,0,26,13,8]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var R;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(R||(e.TokenType=R={}));function T(...I){switch(I.length){case 1:return(0,A.localize)(1684,null,I[0]);case 2:return(0,A.localize)(1685,null,I[0],I[1]);case 3:return(0,A.localize)(1686,null,I[0],I[1],I[2]);default:return}}const O=(0,A.localize)(1687,null),b=(0,A.localize)(1688,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return y.isTripleEq?"===":"==";case R.NotEq:return y.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return y.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return y.lexeme;case R.QuotedStr:return y.lexeme;case R.Error:return y.lexeme;case R.EOF:return"EOF";default:throw(0,h.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:u})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(T("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(T("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(T("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,C=this.c.substring(this.d,this.e),w={type:R.Error,offset:this.d,lexeme:C};this.g.push({offset:u,lexeme:C,additionalInfo:y}),this.f.push(w)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),C=c.b.get(u);C?this.k(C):this.f.push({type:R.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,C=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(b);return}const a=this.c.charCodeAt(y);if(u)u=!1;else if(a===r.CharCode.Slash&&!C){y++;break}else a===r.CharCode.OpenSquareBracket?C=!0:a===r.CharCode.Backslash?u=!0:a===r.CharCode.CloseSquareBracket&&(C=!1);y++}for(;y<this.c.length&&c.a.has(this.c.charCodeAt(y));)y++;this.e=y;const w=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=c}),define(ke[144],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const r={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(r)}),define(ke[112],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class r{constructor(A,R=[],T=!1){this.ctor=A,this.staticArguments=R,this.supportsDelayedInstantiation=T}}e.$Di=r}),define(ke[88],Ie([1,0,112]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ss=R,e.$Ts=T;const h=[];var A;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function R(O,b,c){b instanceof r.$Di||(b=new r.$Di(b,[],!!c)),h.push([O,b])}function T(){return h}}),define(ke[214],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;class r{constructor(R,T){this.key=R,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$vr=r;class h{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const T of this.a.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const O=this.lookupOrInsertNode(R),b=this.lookupOrInsertNode(T);O.outgoing.set(b.key,b),b.incoming.set(O.key,O)}removeNode(R){const T=this.b(R);this.a.delete(T);for(const O of this.a.values())O.outgoing.delete(T),O.incoming.delete(T)}lookupOrInsertNode(R){const T=this.b(R);let O=this.a.get(T);return O||(O=new r(T,R),this.a.set(T,O)),O}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[T,O]of this.a)R.push(`${T}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,T]of this.a){const O=new Set([R]),b=this.c(T,O);if(b)return b}}c(R,T){for(const[O,b]of R.outgoing){if(T.has(O))return[...T,O].join(" -> ");T.add(O);const c=this.c(b,T);if(c)return c;T.delete(O)}}}e.$wr=h}),define(ke[5],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=A,e.$Hi=R;var r;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function O(b){return b[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=O})(r||(e._util=r={})),e.$Fi=A("instantiationService");function h(T,O,b){O[r.DI_TARGET]===O?O[r.DI_DEPENDENCIES].push({id:T,index:b}):(O[r.DI_DEPENDENCIES]=[{id:T,index:b}],O[r.DI_TARGET]=O)}function A(T){if(r.serviceIds.has(T))return r.serviceIds.get(T);const O=function(b,c,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(O,b,I)};return O.toString=()=>T,r.serviceIds.set(T,O),O}function R(T){return T}}),define(ke[46],Ie([1,0,17,2,5]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=R,e.$cj=T,e.$dj=b,e.$ej=c,e.$fj=I,e.$gj=y,e.$hj=u,e.$ij=w,e.$jj=a,e.$kj=m,r=We(r),e.$aj=(0,A.$Gi)("configurationService");function R($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof h.URI)}function T($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof h.URI)}var O;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function b($){switch($){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function I($,f){const i=Object.create(null);for(const s in $)y(i,s,$[s],f);return i}function y($,f,i,s){const t=f.split("."),o=t.pop();let n=$;for(let d=0;d<t.length;d++){const l=t[d];let g=n[l];switch(typeof g){case"undefined":g=n[l]=Object.create(null);break;case"object":if(g===null){s(`Ignoring ${f} as ${t.slice(0,d+1).join(".")} is null`);return}break;default:s(`Ignoring ${f} as ${t.slice(0,d+1).join(".")} is ${JSON.stringify(g)}`);return}n=g}if(typeof n=="object"&&n!==null)try{n[o]=i}catch{s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}else s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}function u($,f){const i=f.split(".");C($,i)}function C($,f){const i=f.shift();if(f.length===0){delete $[i];return}if(Object.keys($).indexOf(i)!==-1){const s=$[i];typeof s=="object"&&!Array.isArray(s)&&(C(s,f),Object.keys(s).length===0&&delete $[i])}}function w($,f,i){function s(n,d){let l=n;for(const g of d){if(typeof l!="object"||l===null)return;l=l[g]}return l}const t=f.split("."),o=s($,t);return typeof o>"u"?i:o}function a($,f,i){Object.keys(f).forEach(s=>{s!=="__proto__"&&(s in $?r.$hg($[s])&&r.$hg(f[s])?a($[s],f[s],i):i&&($[s]=f[s]):$[s]=f[s])})}function m($){return $.replace(/[\[\]]/g,"")}}),define(ke[35],Ie([1,0,26,10,12,213,5,8,13]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=I,e.$Fj=d,e.$Gj=l,e.$Zj=ne;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",h.$k),c.set("isLinux",h.$l),c.set("isWindows",h.$j),c.set("isWeb",h.$p),c.set("isMacNative",h.$k&&!h.$p),c.set("isEdge",h.$I),c.set("isFirefox",h.$G),c.set("isChrome",h.$F),c.set("isSafari",h.$H);function I(Y,U){if(c.get(Y)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Y,U)}const y=Object.prototype.hasOwnProperty;var u;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const C={regexParsingWithErrorRecovery:!0},w=(0,O.localize)(1664,null),a=(0,O.localize)(1665,null),m=(0,O.localize)(1666,null),$=(0,O.localize)(1667,null),f=(0,O.localize)(1668,null),i=(0,O.localize)(1669,null),s=(0,O.localize)(1670,null),t=(0,O.localize)(1671,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=C){this.k=U,this.d=new R.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const oe=this.l();if(!this.E()){const ve=this.D(),te=ve.type===R.TokenType.Str?i:void 0;throw this.h.push({message:f,offset:ve.offset,lexeme:R.$Bj.getLexeme(ve),additionalInfo:te}),o.c}return oe}catch(oe){if(oe!==o.c)throw oe;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(R.TokenType.Or);){const oe=this.o();U.push(oe)}return U.length===1?U[0]:n.or(...U)}o(){const U=[this.s()];for(;this.y(R.TokenType.And);){const oe=this.s();U.push(oe)}return U.length===1?U[0]:n.and(...U)}s(){if(this.y(R.TokenType.Neg)){const U=this.D();switch(U.type){case R.TokenType.True:return this.z(),E.INSTANCE;case R.TokenType.False:return this.z(),S.INSTANCE;case R.TokenType.LParen:{this.z();const oe=this.l();return this.A(R.TokenType.RParen,$),oe?.negate()}case R.TokenType.Str:return this.z(),F.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case R.TokenType.True:return this.z(),n.true();case R.TokenType.False:return this.z(),n.false();case R.TokenType.LParen:{this.z();const oe=this.l();return this.A(R.TokenType.RParen,$),oe}case R.TokenType.Str:{const oe=U.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==R.TokenType.RegexStr)throw this.B("REGEX",te);const ae=te.lexeme,se=ae.lastIndexOf("/"),Z=se===ae.length-1?void 0:this.w(ae.substring(se+1));let re;try{re=new RegExp(ae.substring(1,se),Z)}catch{throw this.B("REGEX",te)}return q.create(oe,re)}switch(te.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const ae=[te.lexeme];this.z();let se=this.D(),Z=0;for(let ze=0;ze<te.lexeme.length;ze++)te.lexeme.charCodeAt(ze)===r.CharCode.OpenParen?Z++:te.lexeme.charCodeAt(ze)===r.CharCode.CloseParen&&Z--;for(;!this.E()&&se.type!==R.TokenType.And&&se.type!==R.TokenType.Or;){switch(se.type){case R.TokenType.LParen:Z++;break;case R.TokenType.RParen:Z--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let ze=0;ze<se.lexeme.length;ze++)se.lexeme.charCodeAt(ze)===r.CharCode.OpenParen?Z++:te.lexeme.charCodeAt(ze)===r.CharCode.CloseParen&&Z--}if(Z<0)break;ae.push(R.$Bj.getLexeme(se)),this.z(),se=this.D()}const re=ae.join(""),pe=re.lastIndexOf("/"),we=pe===re.length-1?void 0:this.w(re.substring(pe+1));let Fe;try{Fe=new RegExp(re.substring(1,pe),we)}catch{throw this.B("REGEX",te)}return n.regex(oe,Fe)}case R.TokenType.QuotedStr:{const ae=te.lexeme;this.z();let se=null;if(!(0,A.$df)(ae)){const Z=ae.indexOf("/"),re=ae.lastIndexOf("/");if(Z!==re&&Z>=0){const pe=ae.slice(Z+1,re),we=ae[re+1]==="i"?"i":"";try{se=new RegExp(pe,we)}catch{throw this.B("REGEX",te)}}}if(se===null)throw this.B("REGEX",te);return q.create(oe,se)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,m);const te=this.u();return n.notIn(oe,te)}switch(this.D().type){case R.TokenType.Eq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return n.equals(oe,te);switch(te){case"true":return n.has(oe);case"false":return n.not(oe);default:return n.equals(oe,te)}}case R.TokenType.NotEq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return n.notEquals(oe,te);switch(te){case"true":return n.not(oe);case"false":return n.has(oe);default:return n.notEquals(oe,te)}}case R.TokenType.Lt:return this.z(),z.create(oe,this.u());case R.TokenType.LtEq:return this.z(),j.create(oe,this.u());case R.TokenType.Gt:return this.z(),L.create(oe,this.u());case R.TokenType.GtEq:return this.z(),M.create(oe,this.u());case R.TokenType.In:return this.z(),n.in(oe,this.u());default:return n.has(oe)}}case R.TokenType.EOF:throw this.h.push({message:s,offset:U.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),U.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,oe){if(this.C(U))return this.z();throw this.B(oe,this.D())}B(U,oe,ve){const te=(0,O.localize)(1672,null,U,R.$Bj.getLexeme(oe)),ae=oe.offset,se=R.$Bj.getLexeme(oe);return this.h.push({message:te,offset:ae,lexeme:se,additionalInfo:ve}),o.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$Dj=o;class n{static false(){return E.INSTANCE}static true(){return S.INSTANCE}static has(U){return D.create(U)}static equals(U,oe){return k.create(U,oe)}static notEquals(U,oe){return v.create(U,oe)}static regex(U,oe){return q.create(U,oe)}static in(U,oe){return P.create(U,oe)}static notIn(U,oe){return p.create(U,oe)}static not(U){return F.create(U)}static and(...U){return H.create(U,null,!0)}static or(...U){return W.create(U,null,!0)}static greater(U,oe){return L.create(U,oe)}static greaterEquals(U,oe){return M.create(U,oe)}static smaller(U,oe){return z.create(U,oe)}static smallerEquals(U,oe){return j.create(U,oe)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Ej=n;function d(Y){const U=new o({regexParsingWithErrorRecovery:!1});return Y.map(oe=>(U.parse(oe),U.lexingErrors.length>0?U.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,O.localize)(1673,null,ve.additionalInfo):(0,O.localize)(1674,null),offset:ve.offset,length:ve.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function l(Y,U){const oe=Y?Y.substituteConstants():void 0,ve=U?U.substituteConstants():void 0;return!oe&&!ve?!0:!oe||!ve?!1:oe.equals(ve)}function g(Y,U){return Y.cmp(U)}class E{static{this.INSTANCE=new E}constructor(){this.type=u.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return S.INSTANCE}}e.$Hj=E;class S{static{this.INSTANCE=new S}constructor(){this.type=u.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return E.INSTANCE}}e.$Ij=S;class D{static create(U,oe=null){const ve=c.get(U);return typeof ve=="boolean"?ve?S.INSTANCE:E.INSTANCE:new D(U,oe)}constructor(U,oe){this.key=U,this.c=oe,this.type=u.Defined}cmp(U){return U.type!==this.type?this.type-U.type:_(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=c.get(this.key);return typeof U=="boolean"?U?S.INSTANCE:E.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Jj=D;class k{static create(U,oe,ve=null){if(typeof oe=="boolean")return oe?D.create(U,ve):F.create(U,ve);const te=c.get(U);return typeof te=="boolean"?oe===(te?"true":"false")?S.INSTANCE:E.INSTANCE:new k(U,oe,ve)}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.Equals}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=c.get(this.c);if(typeof U=="boolean"){const oe=U?"true":"false";return this.d===oe?S.INSTANCE:E.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Kj=k;class P{static create(U,oe){return new P(U,oe)}constructor(U,oe){this.d=U,this.f=oe,this.type=u.In,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const oe=U.getValue(this.f),ve=U.getValue(this.d);return Array.isArray(oe)?oe.includes(ve):typeof ve=="string"&&typeof oe=="object"&&oe!==null?y.call(oe,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Lj=P;class p{static create(U,oe){return new p(U,oe)}constructor(U,oe){this.d=U,this.f=oe,this.type=u.NotIn,this.c=P.create(U,oe)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=p;class v{static create(U,oe,ve=null){if(typeof oe=="boolean")return oe?F.create(U,ve):D.create(U,ve);const te=c.get(U);return typeof te=="boolean"?oe===(te?"true":"false")?E.INSTANCE:S.INSTANCE:new v(U,oe,ve)}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=c.get(this.c);if(typeof U=="boolean"){const oe=U?"true":"false";return this.d===oe?E.INSTANCE:S.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Nj=v;class F{static create(U,oe=null){const ve=c.get(U);return typeof ve=="boolean"?ve?E.INSTANCE:S.INSTANCE:new F(U,oe)}constructor(U,oe){this.c=U,this.d=oe,this.type=u.Not}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=c.get(this.c);return typeof U=="boolean"?U?E.INSTANCE:S.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$Oj=F;function N(Y,U){if(typeof Y=="string"){const oe=parseFloat(Y);isNaN(oe)||(Y=oe)}return typeof Y=="string"||typeof Y=="number"?U(Y):E.INSTANCE}class L{static create(U,oe,ve=null){return N(oe,te=>new L(U,te,ve))}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.Greater}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Pj=L;class M{static create(U,oe,ve=null){return N(oe,te=>new M(U,te,ve))}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Qj=M;class z{static create(U,oe,ve=null){return N(oe,te=>new z(U,te,ve))}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Rj=z;class j{static create(U,oe,ve=null){return N(oe,te=>new j(U,te,ve))}constructor(U,oe,ve){this.c=U,this.d=oe,this.f=ve,this.type=u.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Sj=j;class q{static create(U,oe){return new q(U,oe)}constructor(U,oe){this.d=U,this.f=oe,this.type=u.Regex,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const oe=this.f?this.f.source:"",ve=U.f?U.f.source:"";return oe<ve?-1:oe>ve?1:0}equals(U){if(U.type===this.type){const oe=this.f?this.f.source:"",ve=U.f?U.f.source:"";return this.d===U.d&&oe===ve}return!1}substituteConstants(){return this}evaluate(U){const oe=U.getValue(this.d);return this.f?this.f.test(oe):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Tj=q;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=u.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Uj=B;function ee(Y){let U=null;for(let oe=0,ve=Y.length;oe<ve;oe++){const te=Y[oe].substituteConstants();if(Y[oe]!==te&&U===null){U=[];for(let ae=0;ae<oe;ae++)U[ae]=Y[ae]}U!==null&&(U[oe]=te)}return U===null?Y:U}class H{static create(U,oe,ve){return H.d(U,oe,ve)}constructor(U,oe){this.expr=U,this.c=oe,this.type=u.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let oe=0,ve=this.expr.length;oe<ve;oe++){const te=g(this.expr[oe],U.expr[oe]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(!this.expr[oe].equals(U.expr[oe]))return!1;return!0}return!1}substituteConstants(){const U=ee(this.expr);return U===this.expr?this:H.create(U,this.c,!1)}evaluate(U){for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(!this.expr[oe].evaluate(U))return!1;return!0}static d(U,oe,ve){const te=[];let ae=!1;for(const se of U)if(se){if(se.type===u.True){ae=!0;continue}if(se.type===u.False)return E.INSTANCE;if(se.type===u.And){te.push(...se.expr);continue}te.push(se)}if(te.length===0&&ae)return S.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(g);for(let se=1;se<te.length;se++)te[se-1].equals(te[se])&&(te.splice(se,1),se--);if(te.length===1)return te[0];for(;te.length>1;){const se=te[te.length-1];if(se.type!==u.Or)break;te.pop();const Z=te.pop(),re=te.length===0,pe=W.create(se.expr.map(we=>H.create([we,Z],null,ve)),null,re);pe&&(te.push(pe),te.sort(g))}if(te.length===1)return te[0];if(ve){for(let se=0;se<te.length;se++)for(let Z=se+1;Z<te.length;Z++)if(te[se].negate().equals(te[Z]))return E.INSTANCE;if(te.length===1)return te[0]}return new H(te,oe)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const oe of this.expr)U.push(...oe.keys());return U}map(U){return new H(this.expr.map(oe=>oe.map(U)),null)}negate(){if(!this.c){const U=[];for(const oe of this.expr)U.push(oe.negate());this.c=W.create(U,this,!0)}return this.c}}e.$Vj=H;class W{static create(U,oe,ve){return W.d(U,oe,ve)}constructor(U,oe){this.expr=U,this.c=oe,this.type=u.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let oe=0,ve=this.expr.length;oe<ve;oe++){const te=g(this.expr[oe],U.expr[oe]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(!this.expr[oe].equals(U.expr[oe]))return!1;return!0}return!1}substituteConstants(){const U=ee(this.expr);return U===this.expr?this:W.create(U,this.c,!1)}evaluate(U){for(let oe=0,ve=this.expr.length;oe<ve;oe++)if(this.expr[oe].evaluate(U))return!0;return!1}static d(U,oe,ve){let te=[],ae=!1;if(U){for(let se=0,Z=U.length;se<Z;se++){const re=U[se];if(re){if(re.type===u.False){ae=!0;continue}if(re.type===u.True)return S.INSTANCE;if(re.type===u.Or){te=te.concat(re.expr);continue}te.push(re)}}if(te.length===0&&ae)return E.INSTANCE;te.sort(g)}if(te.length!==0){if(te.length===1)return te[0];for(let se=1;se<te.length;se++)te[se-1].equals(te[se])&&(te.splice(se,1),se--);if(te.length===1)return te[0];if(ve){for(let se=0;se<te.length;se++)for(let Z=se+1;Z<te.length;Z++)if(te[se].negate().equals(te[Z]))return S.INSTANCE;if(te.length===1)return te[0]}return new W(te,oe)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const oe of this.expr)U.push(...oe.keys());return U}map(U){return new W(this.expr.map(oe=>oe.map(U)),null)}negate(){if(!this.c){const U=[];for(const oe of this.expr)U.push(oe.negate());for(;U.length>1;){const oe=U.shift(),ve=U.shift(),te=[];for(const ae of ge(oe))for(const se of ge(ve))te.push(H.create([ae,se],null,!1));U.unshift(W.create(te,null,!1))}this.c=W.create(U,this,!0)}return this.c}}e.$Wj=W;class X extends D{static{this.d=[]}static all(){return X.d.values()}constructor(U,oe,ve){super(U,null),this.f=oe,typeof ve=="object"?X.d.push({...ve,key:U}):ve!==!0&&X.d.push({key:U,description:ve,type:oe!=null?typeof oe:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return k.create(this.key,U)}notEqualsTo(U){return v.create(this.key,U)}}e.$Xj=X,e.$Yj=(0,T.$Gi)("contextKeyService");function _(Y,U){return Y<U?-1:Y>U?1:0}function ce(Y,U,oe,ve){return Y<oe?-1:Y>oe?1:U<ve?-1:U>ve?1:0}function ne(Y,U){if(Y.type===u.False||U.type===u.True)return!0;if(Y.type===u.Or)return U.type===u.Or?ye(Y.expr,U.expr):!1;if(U.type===u.Or){for(const oe of U.expr)if(ne(Y,oe))return!0;return!1}if(Y.type===u.And){if(U.type===u.And)return ye(U.expr,Y.expr);for(const oe of Y.expr)if(ne(oe,U))return!0;return!1}return Y.equals(U)}function ye(Y,U){let oe=0,ve=0;for(;oe<Y.length&&ve<U.length;){const te=Y[oe].cmp(U[ve]);if(te<0)return!1;te===0&&oe++,ve++}return oe===Y.length}function ge(Y){return Y.type===u.Or?Y.expr:[Y]}}),define(ke[215],Ie([1,0,35,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=e.$tt=e.AccessibilitySupport=e.$st=void 0,e.$ut=R,e.$st=(0,h.$Gi)("accessibilityService");var A;(function(T){T[T.Unknown=0]="Unknown",T[T.Disabled=1]="Disabled",T[T.Enabled=2]="Enabled"})(A||(e.AccessibilitySupport=A={})),e.$tt=new r.$Xj("accessibilityModeEnabled",!1);function R(T){return T&&typeof T=="object"&&typeof T.label=="string"&&(typeof T.role>"u"||typeof T.role=="string")}e.$vt="ACCESSIBLE_VIEW_SHOWN_"}),define(ke[113],Ie([1,0,18,24,10,185,83,199,141,8,215]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=n,e.stringSet=g,e.cursorStyleToString=N,e.filterValidationDecorations=De,r=We(r),h=We(h),A=We(A),c=We(c);var y;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(he){this.c=he}hasChanged(he){return this.c[he]}}e.ConfigurationChangedEvent=u;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class w{constructor(he,le,Ze,tt){this.id=he,this.name=le,this.defaultValue=Ze,this.schema=tt}applyUpdate(he,le){return m(he,le)}compute(he,le,Ze){return Ze}}class a{constructor(he,le){this.newValue=he,this.didChange=le}}e.ApplyUpdateResult=a;function m(ue,he){if(typeof ue!="object"||typeof he!="object"||!ue||!he)return new a(he,ue!==he);if(Array.isArray(ue)||Array.isArray(he)){const Ze=Array.isArray(ue)&&Array.isArray(he)&&r.$ub(ue,he);return new a(he,!Ze)}let le=!1;for(const Ze in he)if(he.hasOwnProperty(Ze)){const tt=m(ue[Ze],he[Ze]);tt.didChange&&(ue[Ze]=tt.newValue,le=!0)}return new a(ue,le)}class ${constructor(he){this.schema=void 0,this.id=he,this.name="_never_",this.defaultValue=void 0}applyUpdate(he,le){return m(he,le)}validate(he){return this.defaultValue}}class f{constructor(he,le,Ze,tt){this.id=he,this.name=le,this.defaultValue=Ze,this.schema=tt}applyUpdate(he,le){return m(he,le)}validate(he){return typeof he>"u"?this.defaultValue:he}compute(he,le,Ze){return Ze}}function i(ue,he){return typeof ue>"u"?he:ue==="false"?!1:!!ue}class s extends f{constructor(he,le,Ze,tt=void 0){typeof tt<"u"&&(tt.type="boolean",tt.default=Ze),super(he,le,Ze,tt)}validate(he){return i(he,this.defaultValue)}}function t(ue,he,le,Ze){if(typeof ue>"u")return he;let tt=parseInt(ue,10);return isNaN(tt)?he:(tt=Math.max(le,tt),tt=Math.min(Ze,tt),tt|0)}class o extends f{static clampedInt(he,le,Ze,tt){return t(he,le,Ze,tt)}constructor(he,le,Ze,tt,ut,mt=void 0){typeof mt<"u"&&(mt.type="integer",mt.default=Ze,mt.minimum=tt,mt.maximum=ut),super(he,le,Ze,mt),this.minimum=tt,this.maximum=ut}validate(he){return o.clampedInt(he,this.defaultValue,this.minimum,this.maximum)}}function n(ue,he,le,Ze){if(typeof ue>"u")return he;const tt=d.float(ue,he);return d.clamp(tt,le,Ze)}class d extends f{static clamp(he,le,Ze){return he<le?le:he>Ze?Ze:he}static float(he,le){if(typeof he=="number")return he;if(typeof he>"u")return le;const Ze=parseFloat(he);return isNaN(Ze)?le:Ze}constructor(he,le,Ze,tt,ut){typeof ut<"u"&&(ut.type="number",ut.default=Ze),super(he,le,Ze,ut),this.validationFn=tt}validate(he){return this.validationFn(d.float(he,this.defaultValue))}}class l extends f{static string(he,le){return typeof he!="string"?le:he}constructor(he,le,Ze,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.default=Ze),super(he,le,Ze,tt)}validate(he){return l.string(he,this.defaultValue)}}function g(ue,he,le,Ze){return typeof ue!="string"?he:Ze&&ue in Ze?Ze[ue]:le.indexOf(ue)===-1?he:ue}class E extends f{constructor(he,le,Ze,tt,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=tt,ut.default=Ze),super(he,le,Ze,ut),this.c=tt}validate(he){return g(he,this.defaultValue,this.c)}}class S extends w{constructor(he,le,Ze,tt,ut,mt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=tt),super(he,le,Ze,Dt),this.c=ut,this.d=mt}validate(he){return typeof he!="string"?this.defaultValue:this.c.indexOf(he)===-1?this.defaultValue:this.d(he)}}function D(ue){switch(ue){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class k extends w{constructor(){super(je.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(297,null),c.localize(298,null),c.localize(299,null)],default:"auto",tags:["accessibility"],description:c.localize(300,null)})}validate(he){switch(he){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(he,le,Ze){return Ze===I.AccessibilitySupport.Unknown?he.accessibilitySupport:Ze}}class P extends w{constructor(){const he={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",he,{"editor.comments.insertSpace":{type:"boolean",default:he.insertSpace,description:c.localize(301,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:he.ignoreEmptyLines,description:c.localize(302,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{insertSpace:i(le.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(le.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function v(ue){switch(ue){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var F;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function N(ue){switch(ue){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function L(ue){switch(ue){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class M extends ${constructor(){super(je.editorClassName)}compute(he,le,Ze){const tt=["monaco-editor"];return le.get(je.extraEditorClassName)&&tt.push(le.get(je.extraEditorClassName)),he.extraEditorClassName&&tt.push(he.extraEditorClassName),le.get(je.mouseStyle)==="default"?tt.push("mouse-default"):le.get(je.mouseStyle)==="copy"&&tt.push("mouse-copy"),le.get(je.showUnused)&&tt.push("showUnused"),le.get(je.showDeprecated)&&tt.push("showDeprecated"),tt.join(" ")}}class z extends s{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(303,null)})}compute(he,le,Ze){return Ze&&he.emptySelectionClipboard}}class j extends w{constructor(){const he={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",he,{"editor.find.cursorMoveOnType":{type:"boolean",default:he.cursorMoveOnType,description:c.localize(304,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:he.seedSearchStringFromSelection,enumDescriptions:[c.localize(305,null),c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:he.autoFindInSelection,enumDescriptions:[c.localize(309,null),c.localize(310,null),c.localize(311,null)],description:c.localize(312,null)},"editor.find.globalFindClipboard":{type:"boolean",default:he.globalFindClipboard,description:c.localize(313,null),included:A.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:he.addExtraSpaceOnTop,description:c.localize(314,null)},"editor.find.loop":{type:"boolean",default:he.loop,description:c.localize(315,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{cursorMoveOnType:i(le.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof he.seedSearchStringFromSelection=="boolean"?he.seedSearchStringFromSelection?"always":"never":g(le.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof he.autoFindInSelection=="boolean"?he.autoFindInSelection?"always":"never":g(le.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(le.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(le.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(le.loop,this.defaultValue.loop)}}}class q extends w{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:c.localize(316,null)},{type:"string",description:c.localize(317,null)}],description:c.localize(318,null),default:!1})}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he==="false"||he.length===0?q.OFF:he==="true"?q.ON:he:he?q.ON:q.OFF}}e.EditorFontLigatures=q;class B extends w{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:c.localize(319,null)},{type:"string",description:c.localize(320,null)}],description:c.localize(321,null),default:!1})}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he==="false"?B.OFF:he==="true"?B.TRANSLATE:he:he?B.TRANSLATE:B.OFF}compute(he,le,Ze){return he.fontInfo.fontVariationSettings}}e.EditorFontVariations=B;class ee extends ${constructor(){super(je.fontInfo)}compute(he,le,Ze){return he.fontInfo}}class H extends f{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(322,null)})}validate(he){const le=d.float(he,this.defaultValue);return le===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(le,6,100)}compute(he,le,Ze){return he.fontInfo.fontSize}}class W extends w{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:c.localize(323,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(324,null)})}validate(he){return he==="normal"||he==="bold"?he:String(o.clampedInt(he,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}class X extends w{constructor(){const he={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},le={type:"string",enum:["peek","gotoAndPeek","goto"],default:he.multiple,enumDescriptions:[c.localize(325,null),c.localize(326,null),c.localize(327,null)]},Ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",he,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(328,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(329,null),...le},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(330,null),...le},"editor.gotoLocation.multipleDeclarations":{description:c.localize(331,null),...le},"editor.gotoLocation.multipleImplementations":{description:c.localize(332,null),...le},"editor.gotoLocation.multipleReferences":{description:c.localize(333,null),...le},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:he.alternativeDefinitionCommand,enum:Ze,description:c.localize(334,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:he.alternativeTypeDefinitionCommand,enum:Ze,description:c.localize(335,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:he.alternativeDeclarationCommand,enum:Ze,description:c.localize(336,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:he.alternativeImplementationCommand,enum:Ze,description:c.localize(337,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:he.alternativeReferenceCommand,enum:Ze,description:c.localize(338,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{multiple:g(le.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:le.multipleDefinitions??g(le.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:le.multipleTypeDefinitions??g(le.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:le.multipleDeclarations??g(le.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:le.multipleImplementations??g(le.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:le.multipleReferences??g(le.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:le.multipleTests??g(le.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(le.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(le.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(le.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(le.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(le.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:l.string(le.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class _ extends w{constructor(){const he={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",he,{"editor.hover.enabled":{type:"boolean",default:he.enabled,description:c.localize(339,null)},"editor.hover.delay":{type:"number",default:he.delay,minimum:0,maximum:1e4,description:c.localize(340,null)},"editor.hover.sticky":{type:"boolean",default:he.sticky,description:c.localize(341,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:he.hidingDelay,description:c.localize(342,null)},"editor.hover.above":{type:"boolean",default:he.above,description:c.localize(343,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),delay:o.clampedInt(le.delay,this.defaultValue.delay,0,1e4),sticky:i(le.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(le.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(le.above,this.defaultValue.above)}}}var ce;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(ce||(e.RenderMinimap=ce={}));class ne extends ${constructor(){super(je.layoutInfo)}compute(he,le,Ze){return ne.computeLayout(le,{memory:he.memory,outerWidth:he.outerWidth,outerHeight:he.outerHeight,isDominatedByLongLines:he.isDominatedByLongLines,lineHeight:he.fontInfo.lineHeight,viewLineCount:he.viewLineCount,lineNumbersDigitCount:he.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:he.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:he.fontInfo.maxDigitWidth,pixelRatio:he.pixelRatio,glyphMarginDecorationLaneCount:he.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(he){const le=he.height/he.lineHeight,Ze=Math.floor(he.paddingTop/he.lineHeight);let tt=Math.floor(he.paddingBottom/he.lineHeight);he.scrollBeyondLastLine&&(tt=Math.max(tt,le-1));const ut=(Ze+he.viewLineCount+tt)/(he.pixelRatio*he.height),mt=Math.floor(he.viewLineCount/ut);return{typicalViewportLineCount:le,extraLinesBeforeFirstLine:Ze,extraLinesBeyondLastLine:tt,desiredRatio:ut,minimapLineCount:mt}}static c(he,le){const Ze=he.outerWidth,tt=he.outerHeight,ut=he.pixelRatio;if(!he.minimap.enabled)return{renderMinimap:ce.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const mt=le.stableMinimapLayoutInput,Dt=mt&&he.outerHeight===mt.outerHeight&&he.lineHeight===mt.lineHeight&&he.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&he.pixelRatio===mt.pixelRatio&&he.scrollBeyondLastLine===mt.scrollBeyondLastLine&&he.paddingTop===mt.paddingTop&&he.paddingBottom===mt.paddingBottom&&he.minimap.enabled===mt.minimap.enabled&&he.minimap.side===mt.minimap.side&&he.minimap.size===mt.minimap.size&&he.minimap.showSlider===mt.minimap.showSlider&&he.minimap.renderCharacters===mt.minimap.renderCharacters&&he.minimap.maxColumn===mt.minimap.maxColumn&&he.minimap.scale===mt.minimap.scale&&he.verticalScrollbarWidth===mt.verticalScrollbarWidth&&he.isViewportWrapping===mt.isViewportWrapping,Mt=he.lineHeight,Ht=he.typicalHalfwidthCharacterWidth,ei=he.scrollBeyondLastLine,oi=he.minimap.renderCharacters;let Ot=ut>=2?Math.round(he.minimap.scale*2):he.minimap.scale;const it=he.minimap.maxColumn,Ct=he.minimap.size,hi=he.minimap.side,bt=he.verticalScrollbarWidth,St=he.viewLineCount,ti=he.remainingWidth,ii=he.isViewportWrapping,qt=oi?2:3;let pt=Math.floor(ut*tt);const zt=pt/ut;let ni=!1,ai=!1,xe=qt*Ot,ci=Ot/ut,di=1;if(Ct==="fill"||Ct==="fit"){const{typicalViewportLineCount:Xt,extraLinesBeforeFirstLine:li,extraLinesBeyondLastLine:Wt,desiredRatio:Kt,minimapLineCount:Jt}=ne.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:ei,paddingTop:he.paddingTop,paddingBottom:he.paddingBottom,height:tt,lineHeight:Mt,pixelRatio:ut});if(St/Jt>1)ni=!0,ai=!0,Ot=1,xe=1,ci=Ot/ut;else{let wt=!1,It=Ot+1;if(Ct==="fit"){const Qt=Math.ceil((li+St+Wt)*xe);ii&&Dt&&ti<=le.stableFitRemainingWidth?(wt=!0,It=le.stableFitMaxMinimapScale):wt=Qt>pt}if(Ct==="fill"||wt){ni=!0;const Qt=Ot;xe=Math.min(Mt*ut,Math.max(1,Math.floor(1/Kt))),ii&&Dt&&ti<=le.stableFitRemainingWidth&&(It=le.stableFitMaxMinimapScale),Ot=Math.min(It,Math.max(1,Math.floor(xe/qt))),Ot>Qt&&(di=Math.min(2,Ot/Qt)),ci=Ot/ut/di,pt=Math.ceil(Math.max(Xt,li+St+Wt)*xe),ii?(le.stableMinimapLayoutInput=he,le.stableFitRemainingWidth=ti,le.stableFitMaxMinimapScale=Ot):(le.stableMinimapLayoutInput=null,le.stableFitRemainingWidth=0)}}}const fi=Math.floor(it*ci),vt=Math.min(fi,Math.max(0,Math.floor((ti-bt-2)*ci/(Ht+ci)))+e.MINIMAP_GUTTER_WIDTH);let jt=Math.floor(ut*vt);const Nt=jt/ut;jt=Math.floor(jt*di);const Gt=oi?ce.Text:ce.Blocks,ri=hi==="left"?0:Ze-vt-bt;return{renderMinimap:Gt,minimapLeft:ri,minimapWidth:vt,minimapHeightIsEditorHeight:ni,minimapIsSampling:ai,minimapScale:Ot,minimapLineHeight:xe,minimapCanvasInnerWidth:jt,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:zt}}static computeLayout(he,le){const Ze=le.outerWidth|0,tt=le.outerHeight|0,ut=le.lineHeight|0,mt=le.lineNumbersDigitCount|0,Dt=le.typicalHalfwidthCharacterWidth,Mt=le.maxDigitWidth,Ht=le.pixelRatio,ei=le.viewLineCount,oi=he.get(je.wordWrapOverride2),Ot=oi==="inherit"?he.get(je.wordWrapOverride1):oi,it=Ot==="inherit"?he.get(je.wordWrap):Ot,Ct=he.get(je.wordWrapColumn),hi=le.isDominatedByLongLines,bt=he.get(je.glyphMargin),St=he.get(je.lineNumbers).renderType!==ze.Off,ti=he.get(je.lineNumbersMinChars),ii=he.get(je.scrollBeyondLastLine),qt=he.get(je.padding),pt=he.get(je.minimap),zt=he.get(je.scrollbar),ni=zt.verticalScrollbarSize,ai=zt.verticalHasArrows,xe=zt.arrowSize,ci=zt.horizontalScrollbarSize,di=he.get(je.folding),fi=he.get(je.showFoldingControls)!=="never";let vt=he.get(je.lineDecorationsWidth);di&&fi&&(vt+=16);let jt=0;if(St){const mi=Math.max(mt,ti);jt=Math.round(mi*Mt)}let Nt=0;bt&&(Nt=ut*le.glyphMarginDecorationLaneCount);let Gt=0,ri=Gt+Nt,Xt=ri+jt,li=Xt+vt;const Wt=Ze-Nt-jt-vt;let Kt=!1,Jt=!1,Ft=-1;Ot==="inherit"&&hi?(Kt=!0,Jt=!0):it==="on"||it==="bounded"?Jt=!0:it==="wordWrapColumn"&&(Ft=Ct);const wt=ne.c({outerWidth:Ze,outerHeight:tt,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Ht,scrollBeyondLastLine:ii,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:pt,verticalScrollbarWidth:ni,viewLineCount:ei,remainingWidth:Wt,isViewportWrapping:Jt},le.memory||new C);wt.renderMinimap!==ce.None&&wt.minimapLeft===0&&(Gt+=wt.minimapWidth,ri+=wt.minimapWidth,Xt+=wt.minimapWidth,li+=wt.minimapWidth);const It=Wt-wt.minimapWidth,Qt=Math.max(1,Math.floor((It-ni-2)/Dt)),Pt=ai?xe:0;return Jt&&(Ft=Math.max(1,Qt),it==="bounded"&&(Ft=Math.min(Ft,Ct))),{width:Ze,height:tt,glyphMarginLeft:Gt,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:le.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:jt,decorationsLeft:Xt,decorationsWidth:vt,contentLeft:li,contentWidth:It,minimap:wt,viewportColumn:Qt,isWordWrapMinified:Kt,isViewportWrapping:Jt,wrappingColumn:Ft,verticalScrollbarWidth:ni,horizontalScrollbarHeight:ci,overviewRuler:{top:Pt,width:ni,height:tt-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=ne;class ye extends w{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(344,null),c.localize(345,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(346,null)}})}validate(he){return g(he,"simple",["simple","advanced"])}compute(he,le,Ze){return le.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Ze}}var ge;(function(ue){ue.Off="off",ue.OnCode="onCode",ue.On="on"})(ge||(e.ShowLightbulbIconMode=ge={}));class Y extends w{constructor(){const he={enabled:ge.On};super(je.lightbulb,"lightbulb",he,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ge.Off,ge.OnCode,ge.On],default:he.enabled,enumDescriptions:[c.localize(347,null),c.localize(348,null),c.localize(349,null)],description:c.localize(350,null)}})}validate(he){return!he||typeof he!="object"?this.defaultValue:{enabled:g(he.enabled,this.defaultValue.enabled,[ge.Off,ge.OnCode,ge.On])}}}class U extends w{constructor(){const he={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",he,{"editor.stickyScroll.enabled":{type:"boolean",default:he.enabled,description:c.localize(351,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:he.maxLineCount,minimum:1,maximum:20,description:c.localize(352,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:he.defaultModel,description:c.localize(353,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:he.scrollWithEditor,description:c.localize(354,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(le.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(le.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(le.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class oe extends w{constructor(){const he={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",he,{"editor.inlayHints.enabled":{type:"string",default:he.enabled,description:c.localize(355,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(356,null),c.localize(357,null,A.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(358,null,A.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(359,null)]},"editor.inlayHints.fontSize":{type:"number",default:he.fontSize,markdownDescription:c.localize(360,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:he.fontFamily,markdownDescription:c.localize(361,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:he.padding,description:c.localize(362,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return typeof le.enabled=="boolean"&&(le.enabled=le.enabled?"on":"off"),{enabled:g(le.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(le.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(le.fontFamily,this.defaultValue.fontFamily),padding:i(le.padding,this.defaultValue.padding)}}}class ve extends w{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(he){return typeof he=="string"&&/^\d+(\.\d+)?ch$/.test(he)?-parseFloat(he.substring(0,he.length-2)):o.clampedInt(he,this.defaultValue,0,1e3)}compute(he,le,Ze){return Ze<0?o.clampedInt(-Ze*he.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ze}}class te extends d{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,he=>d.clamp(he,0,150),{markdownDescription:c.localize(363,null)})}compute(he,le,Ze){return he.fontInfo.lineHeight}}class ae extends w{constructor(){const he={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",he,{"editor.minimap.enabled":{type:"boolean",default:he.enabled,description:c.localize(364,null)},"editor.minimap.autohide":{type:"boolean",default:he.autohide,description:c.localize(365,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(366,null),c.localize(367,null),c.localize(368,null)],default:he.size,description:c.localize(369,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:he.side,description:c.localize(370,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:he.showSlider,description:c.localize(371,null)},"editor.minimap.scale":{type:"number",default:he.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(372,null)},"editor.minimap.renderCharacters":{type:"boolean",default:he.renderCharacters,description:c.localize(373,null)},"editor.minimap.maxColumn":{type:"number",default:he.maxColumn,description:c.localize(374,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:he.showRegionSectionHeaders,description:c.localize(375,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:he.showMarkSectionHeaders,description:c.localize(376,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:he.sectionHeaderFontSize,description:c.localize(377,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:he.sectionHeaderLetterSpacing,description:c.localize(378,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),autohide:i(le.autohide,this.defaultValue.autohide),size:g(le.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(le.side,this.defaultValue.side,["right","left"]),showSlider:g(le.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(le.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(le.scale,1,1,3),maxColumn:o.clampedInt(le.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(le.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(le.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(le.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(le.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function se(ue){return ue==="ctrlCmd"?A.$k?"metaKey":"ctrlKey":"altKey"}class Z extends w{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(379,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(380,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{top:o.clampedInt(le.top,0,0,1e3),bottom:o.clampedInt(le.bottom,0,0,1e3)}}}class re extends w{constructor(){const he={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",he,{"editor.parameterHints.enabled":{type:"boolean",default:he.enabled,description:c.localize(381,null)},"editor.parameterHints.cycle":{type:"boolean",default:he.cycle,description:c.localize(382,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),cycle:i(le.cycle,this.defaultValue.cycle)}}}class pe extends ${constructor(){super(je.pixelRatio)}compute(he,le,Ze){return he.pixelRatio}}class we extends w{constructor(){super(je.placeholder,"placeholder",void 0)}validate(he){return typeof he>"u"?this.defaultValue:typeof he=="string"?he:this.defaultValue}}class Fe extends w{constructor(){const he={other:"on",comments:"off",strings:"off"},le=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(383,null),c.localize(384,null),c.localize(385,null)]}];super(je.quickSuggestions,"quickSuggestions",he,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:le,default:he.strings,description:c.localize(386,null)},comments:{anyOf:le,default:he.comments,description:c.localize(387,null)},other:{anyOf:le,default:he.other,description:c.localize(388,null)}},default:he,markdownDescription:c.localize(389,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=he}validate(he){if(typeof he=="boolean"){const Ht=he?"on":"off";return{comments:Ht,strings:Ht,other:Ht}}if(!he||typeof he!="object")return this.defaultValue;const{other:le,comments:Ze,strings:tt}=he,ut=["on","inline","off"];let mt,Dt,Mt;return typeof le=="boolean"?mt=le?"on":"off":mt=g(le,this.defaultValue.other,ut),typeof Ze=="boolean"?Dt=Ze?"on":"off":Dt=g(Ze,this.defaultValue.comments,ut),typeof tt=="boolean"?Mt=tt?"on":"off":Mt=g(tt,this.defaultValue.strings,ut),{other:mt,comments:Dt,strings:Mt}}}var ze;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class Re extends w{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(390,null),c.localize(391,null),c.localize(392,null),c.localize(393,null)],default:"on",description:c.localize(394,null)})}validate(he){let le=this.defaultValue.renderType,Ze=this.defaultValue.renderFn;return typeof he<"u"&&(typeof he=="function"?(le=ze.Custom,Ze=he):he==="interval"?le=ze.Interval:he==="relative"?le=ze.Relative:he==="on"?le=ze.On:le=ze.Off),{renderType:le,renderFn:Ze}}}function De(ue){const he=ue.get(je.renderValidationDecorations);return he==="editable"?ue.get(je.readOnly):he!=="on"}class Ce extends w{constructor(){const he=[],le={type:"number",description:c.localize(395,null)};super(je.rulers,"rulers",he,{type:"array",items:{anyOf:[le,{type:["object"],properties:{column:le,color:{type:"string",description:c.localize(396,null),format:"color-hex"}}}]},default:he,description:c.localize(397,null)})}validate(he){if(Array.isArray(he)){const le=[];for(const Ze of he)if(typeof Ze=="number")le.push({column:o.clampedInt(Ze,0,0,1e4),color:null});else if(Ze&&typeof Ze=="object"){const tt=Ze;le.push({column:o.clampedInt(tt.column,0,0,1e4),color:tt.color})}return le.sort((Ze,tt)=>Ze.column-tt.column),le}return this.defaultValue}}class V extends w{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(he){return!he||typeof he!="object"?this.defaultValue:he}}function G(ue,he){if(typeof ue!="string")return he;switch(ue){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class J extends w{constructor(){const he={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",he,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(398,null),c.localize(399,null),c.localize(400,null)],default:"auto",description:c.localize(401,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(402,null),c.localize(403,null),c.localize(404,null)],default:"auto",description:c.localize(405,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:he.verticalScrollbarSize,description:c.localize(406,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:he.horizontalScrollbarSize,description:c.localize(407,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:he.scrollByPage,description:c.localize(408,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:he.ignoreHorizontalScrollbarInContentHeight,description:c.localize(409,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he,Ze=o.clampedInt(le.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=o.clampedInt(le.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(le.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:G(le.vertical,this.defaultValue.vertical),horizontal:G(le.horizontal,this.defaultValue.horizontal),useShadows:i(le.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(le.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(le.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(le.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(le.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ze,horizontalSliderSize:o.clampedInt(le.horizontalSliderSize,Ze,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:o.clampedInt(le.verticalSliderSize,tt,0,1e3),scrollByPage:i(le.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(le.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends w{constructor(){const he={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",he,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.nonBasicASCII,description:c.localize(410,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:he.invisibleCharacters,description:c.localize(411,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:he.ambiguousCharacters,description:c.localize(412,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.includeComments,description:c.localize(413,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:he.includeStrings,description:c.localize(414,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:he.allowedCharacters,description:c.localize(415,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:he.allowedLocales,description:c.localize(416,null)}})}applyUpdate(he,le){let Ze=!1;le.allowedCharacters&&he&&(h.$jo(he.allowedCharacters,le.allowedCharacters)||(he={...he,allowedCharacters:le.allowedCharacters},Ze=!0)),le.allowedLocales&&he&&(h.$jo(he.allowedLocales,le.allowedLocales)||(he={...he,allowedLocales:le.allowedLocales},Ze=!0));const tt=super.applyUpdate(he,le);return Ze?new a(tt.newValue,!0):tt}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{nonBasicASCII:Ke(le.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(le.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(le.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(le.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(le.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(he.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(he.allowedLocales,this.defaultValue.allowedLocales)}}c(he,le){if(typeof he!="object"||!he)return le;const Ze={};for(const[tt,ut]of Object.entries(he))ut===!0&&(Ze[tt]=!0);return Ze}}class de extends w{constructor(){const he={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",he,{"editor.inlineSuggest.enabled":{type:"boolean",default:he.enabled,description:c.localize(417,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:he.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(418,null),c.localize(419,null),c.localize(420,null)],description:c.localize(421,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:he.suppressSuggestions,description:c.localize(422,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:he.fontFamily,description:c.localize(423,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),mode:g(le.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(le.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(le.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(le.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(le.fontFamily,this.defaultValue.fontFamily)}}}class Ee extends w{constructor(){const he={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",he,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:he.enabled,description:c.localize(424,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:he.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(425,null),c.localize(426,null),c.localize(427,null)],description:c.localize(428,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:he.fontFamily,description:c.localize(429,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),showToolbar:g(le.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(le.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(le.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Le extends w{constructor(){const he={enabled:O.$mt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$mt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",he,{"editor.bracketPairColorization.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(430,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:he.independentColorPoolPerBracketType,description:c.localize(431,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(le.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class He extends w{constructor(){const he={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",he,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(432,null),c.localize(433,null),c.localize(434,null)],default:he.bracketPairs,description:c.localize(435,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(436,null),c.localize(437,null),c.localize(438,null)],default:he.bracketPairsHorizontal,description:c.localize(439,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:he.highlightActiveBracketPair,description:c.localize(440,null)},"editor.guides.indentation":{type:"boolean",default:he.indentation,description:c.localize(441,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(442,null),c.localize(443,null),c.localize(444,null)],default:he.highlightActiveIndentation,description:c.localize(445,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{bracketPairs:Ke(le.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(le.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(le.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(le.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(le.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(ue,he,le){const Ze=le.indexOf(ue);return Ze===-1?he:le[Ze]}class et extends w{constructor(){const he={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",he,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(446,null),c.localize(447,null)],default:he.insertMode,description:c.localize(448,null)},"editor.suggest.filterGraceful":{type:"boolean",default:he.filterGraceful,description:c.localize(449,null)},"editor.suggest.localityBonus":{type:"boolean",default:he.localityBonus,description:c.localize(450,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:he.shareSuggestSelections,markdownDescription:c.localize(451,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(452,null),c.localize(453,null),c.localize(454,null),c.localize(455,null)],default:he.selectionMode,markdownDescription:c.localize(456,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:he.snippetsPreventQuickSuggestions,description:c.localize(457,null)},"editor.suggest.showIcons":{type:"boolean",default:he.showIcons,description:c.localize(458,null)},"editor.suggest.showStatusBar":{type:"boolean",default:he.showStatusBar,description:c.localize(459,null)},"editor.suggest.preview":{type:"boolean",default:he.preview,description:c.localize(460,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:he.showInlineDetails,description:c.localize(461,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(462,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(463,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(464,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(465,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(466,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(467,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(468,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(469,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(470,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(471,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(472,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(473,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(474,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(475,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(476,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(477,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(478,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(479,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(480,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(481,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(482,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(483,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(484,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(485,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(486,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(487,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(488,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(489,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(490,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(491,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(492,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(493,null)}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{insertMode:g(le.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(le.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(le.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(le.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(le.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(le.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(le.showIcons,this.defaultValue.showIcons),showStatusBar:i(le.showStatusBar,this.defaultValue.showStatusBar),preview:i(le.preview,this.defaultValue.preview),previewMode:g(le.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(le.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(le.showMethods,this.defaultValue.showMethods),showFunctions:i(le.showFunctions,this.defaultValue.showFunctions),showConstructors:i(le.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(le.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(le.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(le.showFields,this.defaultValue.showFields),showVariables:i(le.showVariables,this.defaultValue.showVariables),showClasses:i(le.showClasses,this.defaultValue.showClasses),showStructs:i(le.showStructs,this.defaultValue.showStructs),showInterfaces:i(le.showInterfaces,this.defaultValue.showInterfaces),showModules:i(le.showModules,this.defaultValue.showModules),showProperties:i(le.showProperties,this.defaultValue.showProperties),showEvents:i(le.showEvents,this.defaultValue.showEvents),showOperators:i(le.showOperators,this.defaultValue.showOperators),showUnits:i(le.showUnits,this.defaultValue.showUnits),showValues:i(le.showValues,this.defaultValue.showValues),showConstants:i(le.showConstants,this.defaultValue.showConstants),showEnums:i(le.showEnums,this.defaultValue.showEnums),showEnumMembers:i(le.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(le.showKeywords,this.defaultValue.showKeywords),showWords:i(le.showWords,this.defaultValue.showWords),showColors:i(le.showColors,this.defaultValue.showColors),showFiles:i(le.showFiles,this.defaultValue.showFiles),showReferences:i(le.showReferences,this.defaultValue.showReferences),showFolders:i(le.showFolders,this.defaultValue.showFolders),showTypeParameters:i(le.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(le.showSnippets,this.defaultValue.showSnippets),showUsers:i(le.showUsers,this.defaultValue.showUsers),showIssues:i(le.showIssues,this.defaultValue.showIssues)}}}class nt extends w{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(494,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(495,null),default:!0,type:"boolean"}})}validate(he){return!he||typeof he!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(he.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(he.selectSubwords,this.defaultValue.selectSubwords)}}}class st extends w{constructor(){const he=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",he,{anyOf:[{description:c.localize(496,null),type:"string"},{description:c.localize(497,null),type:"array",items:{type:"string"}}]})}validate(he){if(typeof he=="string"&&(he=[he]),Array.isArray(he)){const le=[];for(const Ze of he)if(typeof Ze=="string")try{Intl.Segmenter.supportedLocalesOf(Ze).length>0&&le.push(Ze)}catch{}return le}return this.defaultValue}}var rt;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class at extends w{constructor(){super(je.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(498,null),c.localize(499,null),c.localize(500,null),c.localize(501,null)],description:c.localize(502,null),default:"same"}})}validate(he){switch(he){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(he,le,Ze){return le.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?rt.None:Ze}}class gt extends ${constructor(){super(je.wrappingInfo)}compute(he,le,Ze){const tt=le.get(je.layoutInfo);return{isDominatedByLongLines:he.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}class dt extends w{constructor(){const he={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",he,{"editor.dropIntoEditor.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(503,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(504,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(505,null),c.localize(506,null)],default:"afterDrop"}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),showDropSelector:g(le.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ct extends w{constructor(){const he={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",he,{"editor.pasteAs.enabled":{type:"boolean",default:he.enabled,markdownDescription:c.localize(507,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(508,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(509,null),c.localize(510,null)],default:"afterPaste"}})}validate(he){if(!he||typeof he!="object")return this.defaultValue;const le=he;return{enabled:i(le.enabled,this.defaultValue.enabled),showPasteSelector:g(le.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$k?Be:A.$l?Qe:Pe,fontWeight:"normal",fontSize:A.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var je;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.inlineEdit=63]="inlineEdit",ue[ue.letterSpacing=64]="letterSpacing",ue[ue.lightbulb=65]="lightbulb",ue[ue.lineDecorationsWidth=66]="lineDecorationsWidth",ue[ue.lineHeight=67]="lineHeight",ue[ue.lineNumbers=68]="lineNumbers",ue[ue.lineNumbersMinChars=69]="lineNumbersMinChars",ue[ue.linkedEditing=70]="linkedEditing",ue[ue.links=71]="links",ue[ue.matchBrackets=72]="matchBrackets",ue[ue.minimap=73]="minimap",ue[ue.mouseStyle=74]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=76]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=78]="multiCursorModifier",ue[ue.multiCursorPaste=79]="multiCursorPaste",ue[ue.multiCursorLimit=80]="multiCursorLimit",ue[ue.occurrencesHighlight=81]="occurrencesHighlight",ue[ue.overviewRulerBorder=82]="overviewRulerBorder",ue[ue.overviewRulerLanes=83]="overviewRulerLanes",ue[ue.padding=84]="padding",ue[ue.pasteAs=85]="pasteAs",ue[ue.parameterHints=86]="parameterHints",ue[ue.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ue[ue.placeholder=88]="placeholder",ue[ue.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=90]="quickSuggestions",ue[ue.quickSuggestionsDelay=91]="quickSuggestionsDelay",ue[ue.readOnly=92]="readOnly",ue[ue.readOnlyMessage=93]="readOnlyMessage",ue[ue.renameOnType=94]="renameOnType",ue[ue.renderControlCharacters=95]="renderControlCharacters",ue[ue.renderFinalNewline=96]="renderFinalNewline",ue[ue.renderLineHighlight=97]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=99]="renderValidationDecorations",ue[ue.renderWhitespace=100]="renderWhitespace",ue[ue.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ue[ue.roundedSelection=102]="roundedSelection",ue[ue.rulers=103]="rulers",ue[ue.scrollbar=104]="scrollbar",ue[ue.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=106]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=107]="scrollPredominantAxis",ue[ue.selectionClipboard=108]="selectionClipboard",ue[ue.selectionHighlight=109]="selectionHighlight",ue[ue.selectOnLineNumbers=110]="selectOnLineNumbers",ue[ue.showFoldingControls=111]="showFoldingControls",ue[ue.showUnused=112]="showUnused",ue[ue.snippetSuggestions=113]="snippetSuggestions",ue[ue.smartSelect=114]="smartSelect",ue[ue.smoothScrolling=115]="smoothScrolling",ue[ue.stickyScroll=116]="stickyScroll",ue[ue.stickyTabStops=117]="stickyTabStops",ue[ue.stopRenderingLineAfter=118]="stopRenderingLineAfter",ue[ue.suggest=119]="suggest",ue[ue.suggestFontSize=120]="suggestFontSize",ue[ue.suggestLineHeight=121]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ue[ue.suggestSelection=123]="suggestSelection",ue[ue.tabCompletion=124]="tabCompletion",ue[ue.tabIndex=125]="tabIndex",ue[ue.unicodeHighlighting=126]="unicodeHighlighting",ue[ue.unusualLineTerminators=127]="unusualLineTerminators",ue[ue.useShadowDOM=128]="useShadowDOM",ue[ue.useTabStops=129]="useTabStops",ue[ue.wordBreak=130]="wordBreak",ue[ue.wordSegmenterLocales=131]="wordSegmenterLocales",ue[ue.wordSeparators=132]="wordSeparators",ue[ue.wordWrap=133]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=136]="wordWrapColumn",ue[ue.wordWrapOverride1=137]="wordWrapOverride1",ue[ue.wordWrapOverride2=138]="wordWrapOverride2",ue[ue.wrappingIndent=139]="wrappingIndent",ue[ue.wrappingStrategy=140]="wrappingStrategy",ue[ue.showDeprecated=141]="showDeprecated",ue[ue.inlayHints=142]="inlayHints",ue[ue.editorClassName=143]="editorClassName",ue[ue.pixelRatio=144]="pixelRatio",ue[ue.tabFocusMode=145]="tabFocusMode",ue[ue.layoutInfo=146]="layoutInfo",ue[ue.wrappingInfo=147]="wrappingInfo",ue[ue.defaultColorDecorators=148]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new s(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(511,null)})),acceptSuggestionOnEnter:Ne(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(512,null),""],markdownDescription:c.localize(513,null)})),accessibilitySupport:Ne(new k),accessibilityPageSize:Ne(new o(je.accessibilityPageSize,"accessibilityPageSize",10,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(514,null),tags:["accessibility"]})),ariaLabel:Ne(new l(je.ariaLabel,"ariaLabel",c.localize(515,null))),ariaRequired:Ne(new s(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new s(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(516,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(517,null),c.localize(518,null),""],description:c.localize(519,null)})),autoClosingComments:Ne(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(520,null),c.localize(521,null),""],description:c.localize(522,null)})),autoClosingDelete:Ne(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(523,null),""],description:c.localize(524,null)})),autoClosingOvertype:Ne(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(525,null),""],description:c.localize(526,null)})),autoClosingQuotes:Ne(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(527,null),c.localize(528,null),""],description:c.localize(529,null)})),autoIndent:Ne(new S(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],D,{enumDescriptions:[c.localize(530,null),c.localize(531,null),c.localize(532,null),c.localize(533,null),c.localize(534,null)],description:c.localize(535,null)})),automaticLayout:Ne(new s(je.automaticLayout,"automaticLayout",!1)),autoSurround:Ne(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(536,null),c.localize(537,null),c.localize(538,null),""],description:c.localize(539,null)})),bracketPairColorization:Ne(new Le),bracketPairGuides:Ne(new He),stickyTabStops:Ne(new s(je.stickyTabStops,"stickyTabStops",!1,{description:c.localize(540,null)})),codeLens:Ne(new s(je.codeLens,"codeLens",!0,{description:c.localize(541,null)})),codeLensFontFamily:Ne(new l(je.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(542,null)})),codeLensFontSize:Ne(new o(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(543,null)})),colorDecorators:Ne(new s(je.colorDecorators,"colorDecorators",!0,{description:c.localize(544,null)})),colorDecoratorActivatedOn:Ne(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(545,null),c.localize(546,null),c.localize(547,null)],description:c.localize(548,null)})),colorDecoratorsLimit:Ne(new o(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(549,null)})),columnSelection:Ne(new s(je.columnSelection,"columnSelection",!1,{description:c.localize(550,null)})),comments:Ne(new P),contextmenu:Ne(new s(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new s(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(551,null)})),cursorBlinking:Ne(new S(je.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:c.localize(552,null)})),cursorSmoothCaretAnimation:Ne(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(553,null),c.localize(554,null),c.localize(555,null)],description:c.localize(556,null)})),cursorStyle:Ne(new S(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:c.localize(557,null)})),cursorSurroundingLines:Ne(new o(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(558,null)})),cursorSurroundingLinesStyle:Ne(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(559,null),c.localize(560,null)],markdownDescription:c.localize(561,null)})),cursorWidth:Ne(new o(je.cursorWidth,"cursorWidth",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(562,null)})),disableLayerHinting:Ne(new s(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new s(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new s(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Ne(new s(je.dragAndDrop,"dragAndDrop",!0,{description:c.localize(563,null)})),emptySelectionClipboard:Ne(new z),dropIntoEditor:Ne(new dt),stickyScroll:Ne(new U),experimentalWhitespaceRendering:Ne(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(564,null),c.localize(565,null),c.localize(566,null)],description:c.localize(567,null)})),extraEditorClassName:Ne(new l(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Ne(new d(je.fastScrollSensitivity,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:c.localize(568,null)})),find:Ne(new j),fixedOverflowWidgets:Ne(new s(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Ne(new s(je.folding,"folding",!0,{description:c.localize(569,null)})),foldingStrategy:Ne(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(570,null),c.localize(571,null)],description:c.localize(572,null)})),foldingHighlight:Ne(new s(je.foldingHighlight,"foldingHighlight",!0,{description:c.localize(573,null)})),foldingImportsByDefault:Ne(new s(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(574,null)})),foldingMaximumRegions:Ne(new o(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(575,null)})),unfoldOnClickAfterEndOfLine:Ne(new s(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(576,null)})),fontFamily:Ne(new l(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(577,null)})),fontInfo:Ne(new ee),fontLigatures2:Ne(new q),fontSize:Ne(new H),fontWeight:Ne(new W),fontVariations:Ne(new B),formatOnPaste:Ne(new s(je.formatOnPaste,"formatOnPaste",!1,{description:c.localize(578,null)})),formatOnType:Ne(new s(je.formatOnType,"formatOnType",!1,{description:c.localize(579,null)})),glyphMargin:Ne(new s(je.glyphMargin,"glyphMargin",!0,{description:c.localize(580,null)})),gotoLocation:Ne(new X),hideCursorInOverviewRuler:Ne(new s(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(581,null)})),hover:Ne(new _),inDiffEditor:Ne(new s(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Ne(new d(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>d.clamp(ue,-5,20),{description:c.localize(582,null)})),lightbulb:Ne(new Y),lineDecorationsWidth:Ne(new ve),lineHeight:Ne(new te),lineNumbers:Ne(new Re),lineNumbersMinChars:Ne(new o(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new s(je.linkedEditing,"linkedEditing",!1,{description:c.localize(583,null)})),links:Ne(new s(je.links,"links",!0,{description:c.localize(584,null)})),matchBrackets:Ne(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(585,null)})),minimap:Ne(new ae),mouseStyle:Ne(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new d(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:c.localize(586,null)})),mouseWheelZoom:Ne(new s(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:A.$k?c.localize(587,null):c.localize(588,null)})),multiCursorMergeOverlapping:Ne(new s(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(589,null)})),multiCursorModifier:Ne(new S(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],se,{markdownEnumDescriptions:[c.localize(590,null),c.localize(591,null)],markdownDescription:c.localize(592,null)})),multiCursorPaste:Ne(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(593,null),c.localize(594,null)],markdownDescription:c.localize(595,null)})),multiCursorLimit:Ne(new o(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(596,null)})),occurrencesHighlight:Ne(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(597,null),c.localize(598,null),c.localize(599,null)],markdownDescription:c.localize(600,null)})),overviewRulerBorder:Ne(new s(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(601,null)})),overviewRulerLanes:Ne(new o(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Ne(new Z),pasteAs:Ne(new ct),parameterHints:Ne(new re),peekWidgetDefaultFocus:Ne(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(602,null),c.localize(603,null)],description:c.localize(604,null)})),placeholder:Ne(new we),definitionLinkOpensInPeek:Ne(new s(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(605,null)})),quickSuggestions:Ne(new Fe),quickSuggestionsDelay:Ne(new o(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(606,null)})),readOnly:Ne(new s(je.readOnly,"readOnly",!1)),readOnlyMessage:Ne(new V),renameOnType:Ne(new s(je.renameOnType,"renameOnType",!1,{description:c.localize(607,null),markdownDeprecationMessage:c.localize(608,null)})),renderControlCharacters:Ne(new s(je.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(609,null),restricted:!0})),renderFinalNewline:Ne(new E(je.renderFinalNewline,"renderFinalNewline",A.$l?"dimmed":"on",["off","on","dimmed"],{description:c.localize(610,null)})),renderLineHighlight:Ne(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(611,null)],description:c.localize(612,null)})),renderLineHighlightOnlyWhenFocus:Ne(new s(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(613,null)})),renderValidationDecorations:Ne(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(614,null),c.localize(615,null),c.localize(616,null),""],description:c.localize(617,null)})),revealHorizontalRightPadding:Ne(new o(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new s(je.roundedSelection,"roundedSelection",!0,{description:c.localize(618,null)})),rulers:Ne(new Ce),scrollbar:Ne(new J),scrollBeyondLastColumn:Ne(new o(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(619,null)})),scrollBeyondLastLine:Ne(new s(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(620,null)})),scrollPredominantAxis:Ne(new s(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(621,null)})),selectionClipboard:Ne(new s(je.selectionClipboard,"selectionClipboard",!0,{description:c.localize(622,null),included:A.$l})),selectionHighlight:Ne(new s(je.selectionHighlight,"selectionHighlight",!0,{description:c.localize(623,null)})),selectOnLineNumbers:Ne(new s(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(624,null),c.localize(625,null),c.localize(626,null)],description:c.localize(627,null)})),showUnused:Ne(new s(je.showUnused,"showUnused",!0,{description:c.localize(628,null)})),showDeprecated:Ne(new s(je.showDeprecated,"showDeprecated",!0,{description:c.localize(629,null)})),inlayHints:Ne(new oe),snippetSuggestions:Ne(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(630,null),c.localize(631,null),c.localize(632,null),c.localize(633,null)],description:c.localize(634,null)})),smartSelect:Ne(new nt),smoothScrolling:Ne(new s(je.smoothScrolling,"smoothScrolling",!1,{description:c.localize(635,null)})),stopRenderingLineAfter:Ne(new o(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Ne(new et),inlineSuggest:Ne(new de),inlineEdit:Ne(new Ee),inlineCompletionsAccessibilityVerbose:Ne(new s(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(636,null)})),suggestFontSize:Ne(new o(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(637,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new o(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(638,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new s(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(639,null)})),suggestSelection:Ne(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(640,null),c.localize(641,null),c.localize(642,null)],description:c.localize(643,null)})),tabCompletion:Ne(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(644,null),c.localize(645,null),c.localize(646,null)],description:c.localize(647,null)})),tabIndex:Ne(new o(je.tabIndex,"tabIndex",0,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Ne(new x),unusualLineTerminators:Ne(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(648,null),c.localize(649,null),c.localize(650,null)],description:c.localize(651,null)})),useShadowDOM:Ne(new s(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Ne(new s(je.useTabStops,"useTabStops",!0,{description:c.localize(652,null)})),wordBreak:Ne(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(653,null),c.localize(654,null)],description:c.localize(655,null)})),wordSegmenterLocales:Ne(new st),wordSeparators:Ne(new l(je.wordSeparators,"wordSeparators",b.$nt,{description:c.localize(656,null)})),wordWrap:Ne(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(657,null),c.localize(658,null),c.localize(659,null),c.localize(660,null)],description:c.localize(661,null)})),wordWrapBreakAfterCharacters:Ne(new l(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new l(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new o(je.wordWrapColumn,"wordWrapColumn",80,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(662,null)})),wordWrapOverride1:Ne(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new M),defaultColorDecorators:Ne(new s(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(663,null)})),pixelRatio:Ne(new pe),tabFocusMode:Ne(new s(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(664,null)})),layoutInfo:Ne(new ne),wrappingInfo:Ne(new gt),wrappingIndent:Ne(new at),wrappingStrategy:Ne(new ye)}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[216],Ie([1,0,22,43,8,5,107,10,24]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$bx=e.$ax=e.$_w=void 0,e.$cx=C,e.$dx=w,h=Ut(h),e.$_w=(0,R.$Gi)("dialogService");var c;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(c||(c={}));class I{a(m){return this.d(m,c.Confirmation)}b(m){return this.d(m,c.Prompt)}c(m){return this.d(m,c.Input)}d(m,$){const f=[];switch($){case c.Confirmation:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,A.localize)(1689,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,A.localize)(1690,null));break}case c.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&f.push(...i.buttons.map(s=>s.label)),i.cancelButton&&(i.cancelButton===!0?f.push((0,A.localize)(1691,null)):typeof i.cancelButton=="string"?f.push(i.cancelButton):i.cancelButton.label?f.push(i.cancelButton.label):f.push((0,A.localize)(1692,null))),f.length===0&&f.push((0,A.localize)(1693,null));break}case c.Input:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,A.localize)(1694,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,A.localize)(1695,null));break}}return f}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===h.default.Info?"info":m===h.default.Error?"error":m===h.default.Warning?"warning":"none"}f(m,$,f){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let s=i[$]?.run({checkboxChecked:f});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:f}}}e.$ax=I,e.$bx=(0,R.$Gi)("fileDialogService");var y;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const u=10;function C(a){const m=[];return m.push(...a.slice(0,u).map($=>typeof $=="string"?$:(0,r.$eh)($))),a.length>u&&(a.length-u===1?m.push((0,A.localize)(1696,null)):m.push((0,A.localize)(1697,null,a.length-u))),m.push(""),m.join(`
`)}function w(a,m){const $=(0,b.$fo)(a);let f=($.buttons??[]).map(o=>(0,T.$9w)(o)),i=(a.buttons||[]).map((o,n)=>n),s=0,t=$.cancelId??f.length-1;if(f.length>1){const o=typeof t=="number"?f[t]:void 0;if(O.$l||O.$k){if(typeof o=="string"&&f.length>1&&t!==1){f.splice(t,1),f.splice(1,0,o);const n=i[t];i.splice(t,1),i.splice(1,0,n),t=1}O.$l&&f.length>1&&(f=f.reverse(),i=i.reverse(),s=f.length-1,typeof o=="string"&&(t=s-1))}else if(O.$j&&typeof o=="string"&&f.length>1&&t!==f.length-1){f.splice(t,1),f.push(o);const n=i[t];i.splice(t,1),i.push(n),t=f.length-1}}return $.buttons=f,$.defaultId=s,$.cancelId=t,$.noLink=!0,$.title=$.title||m.nameLong,{options:$,buttonIndeces:i}}}),define(ke[145],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,r.$Gi)("environmentService"),e.$Oi=(0,r.$Hi)(e.$Ni)}),define(ke[217],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=e.$W0b=void 0,e.$W0b=(0,r.$Gi)("externalTerminal"),e.$X0b="Terminal.app"}),define(ke[218],Ie([1,0,56,59,14,16,10,104,33,109,8,217]),function($e,e,r,h,A,R,T,O,b,c,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=e.$Ngc=void 0,r=We(r),R=We(R),T=We(T),b=We(b),c=We(c),I=We(I);const u=I.localize(1842,null);class C{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends C{static{this.b="cmd.exe"}openTerminal(t,o){return this.spawnTerminal(r,t,c.$zm(),o)}spawnTerminal(t,o,n,d){const l=o.windowsExec||w.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const g=R.$oc(l,".exe").toLowerCase();if(g==="cmder")return t.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return l.indexOf(" ")>=0&&E.push(l),E.push(l),g==="wt"&&E.push("-d ."),new Promise((S,D)=>{const k=$(process),P=t.spawn(n,E,{cwd:d,env:k,detached:!0});P.on("error",D),P.on("exit",()=>S())})}async runInTerminal(t,o,n,d,l){const g="windowsExec"in l&&l.windowsExec?l.windowsExec:w.getDefaultTerminalWindows(),E=await w.f();return new Promise((S,D)=>{const k=`"${o} - ${u}"`,P=`"${n.join('" "')}" & pause`,p=Object.assign({},$(process),d);Object.keys(p).filter(M=>p[M]===null).forEach(M=>delete p[M]);const v={cwd:o,env:p,windowsVerbatimArguments:!0};let F,N;R.$oc(g,".exe")==="wt"?(F=g,N=["-d",".",w.b,"/c",P]):E?(F=E,N=["-d",".",g,"/c",P]):(F=w.b,N=["/c","start",k,"/wait",g,"/c",`"${P}"`]),r.spawn(F,N,v).on("error",M=>{D(f(M))}),S(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await b.Promises.exists(t)?t:void 0}catch{return}}}e.$Ngc=w,Je([h.$$h],w,"f",null);class a extends C{static{this.b="/usr/bin/osascript"}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,d,l){const g=l.osxExec||y.$X0b;return new Promise((E,S)=>{if(g===y.$X0b||g==="iTerm.app"){const D=g===y.$X0b?"TerminalHelper":"iTermHelper",P=[A.$1g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",t||u,"-w",o];for(const F of n)P.push("-a"),P.push(F);if(d){const F=Object.assign({},$(process),d);for(const N in F){const L=F[N];L===null?(P.push("-u"),P.push(N)):(P.push("-e"),P.push(`${N}=${L}`))}}let p="";const v=r.spawn(a.b,P);v.on("error",F=>{S(f(F))}),v.stderr.on("data",F=>{p+=F.toString()}),v.on("exit",F=>{if(F===0)E(void 0);else if(p){const N=p.split(`
`,1);S(new Error(N[0]))}else S(new Error(I.localize(1843,null,D,F)))})}else S(new Error(I.localize(1844,null,g)))})}spawnTerminal(t,o,n){const d=o.osxExec||y.$X0b;return new Promise((l,g)=>{const E=["-a",d];n&&E.push(n);const S=$(process),D=t.spawn("/usr/bin/open",E,{cwd:n,env:S});D.on("error",g),D.on("exit",()=>l())})}}e.$Ogc=a;class m extends C{static{this.b=I.localize(1845,null)}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,d,l){const g=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((E,S)=>{const D=[];g.then(k=>{k.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const P=`${i(n)}; echo; read -p "${m.b}" -n1;`;D.push(`''${P}''`);const p=Object.assign({},$(process),d);Object.keys(p).filter(L=>p[L]===null).forEach(L=>delete p[L]);const v={cwd:o,env:p};let F="";const N=r.spawn(k,D,v);N.on("error",L=>{S(f(L))}),N.stderr.on("data",L=>{F+=L.toString()}),N.on("exit",L=>{if(L===0)E(void 0);else if(F){const M=F.split(`
`,1);S(new Error(M[0]))}else S(new Error(I.localize(1846,null,k,L)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!T.$l)m.d=Promise.resolve("xterm");else{const t=await b.Promises.exists("/etc/debian_version");m.d=new Promise(o=>{t?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm")})}return m.d}spawnTerminal(t,o,n){const d=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,g)=>{d.then(E=>{const S=$(process),D=t.spawn(E,[],{cwd:n,env:S});D.on("error",g),D.on("exit",()=>l())})})}}e.$Pgc=m;function $(s){const t={...s.env};return(0,O.$mm)(t),t}function f(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(I.localize(1847,null,s.path)):s}function i(s){let t="";for(const o of s)o.indexOf(" ")>=0?t+='"'+o+'"':t+=o,t+=" ";return t}}),define(ke[27],Ie([1,0,84,16,12,17,2,8,5,10,14,50]),function($e,e,r,h,A,R,T,O,b,c,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Gl=e.FileKind=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.FileOperationResult=e.$yl=e.$xl=e.$wl=e.$ul=e.FileChangeType=e.$tl=e.FileOperation=e.$nl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$bl=void 0,e.$cl=u,e.$dl=m,e.$el=f,e.$fl=i,e.$gl=s,e.$hl=t,e.$il=o,e.$jl=n,e.$kl=d,e.$ll=l,e.$ml=g,e.$ol=D,e.$pl=k,e.$ql=P,e.$rl=p,e.$sl=v,e.$vl=z,e.$Hl=W,e.$Il=X,e.$Kl=ce,e.$bl=(0,b.$Gi)("fileService");function u(ne){return ne.create===!0}var C;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var w;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var a;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function m(ne){const ye=ne;return!!ye&&typeof ye.onDidChange=="function"}var $;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function f(ne){return!!(ne.capabilities&$.FileReadWrite)}function i(ne){return!!(ne.capabilities&$.FileFolderCopy)}function s(ne){return!!(ne.capabilities&$.FileClone)}function t(ne){return!!(ne.capabilities&$.FileOpenReadWriteClose)}function o(ne){return!!(ne.capabilities&$.FileReadStream)}function n(ne){return f(ne)?!!(ne.capabilities&$.FileAtomicRead):!1}function d(ne){return f(ne)?!!(ne.capabilities&$.FileAtomicWrite):!1}function l(ne){return!!(ne.capabilities&$.FileAtomicDelete)}function g(ne){return!!(ne.capabilities&$.Readonly)}var E;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class S extends Error{static create(ye,ge){const Y=new S(ye.toString(),ge);return P(Y,ge),Y}constructor(ye,ge){super(ye),this.code=ge}}e.$nl=S;function D(ne,ye){return S.create(ne,ye)}function k(ne){return ne||D((0,O.localize)(1856,null),E.Unknown)}function P(ne,ye){return ne.name=ye?`${ye} (FileSystemError)`:"FileSystemError",ne}function p(ne){if(!ne)return E.Unknown;if(ne instanceof S)return ne.code;const ye=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!ye)return E.Unknown;switch(ye[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function v(ne){if(ne instanceof j)return ne.fileOperationResult;switch(p(ne)){case E.FileNotFound:return ee.FILE_NOT_FOUND;case E.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case E.NoPermissions:return ee.FILE_PERMISSION_DENIED;case E.FileExists:return ee.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var F;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class N{constructor(ye,ge,Y){this.resource=ye,this.operation=ge,this.target=Y}isOperation(ye){return this.operation===ye}}e.$tl=N;var L;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class M{static{this.a=null}constructor(ye,ge){this.c=ge,this.b=void 0,this.d=new y.$U(()=>{const Y=r.$Mi.forUris(()=>this.c);return Y.fill(this.rawAdded.map(U=>[U,!0])),Y}),this.f=new y.$U(()=>{const Y=r.$Mi.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(U=>[U,!0])),Y}),this.g=new y.$U(()=>{const Y=r.$Mi.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(U=>[U,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of ye){switch(Y.type){case L.ADDED:this.rawAdded.push(Y.resource);break;case L.UPDATED:this.rawUpdated.push(Y.resource);break;case L.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==M.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ye,...ge){return this.h(ye,{includeChildren:!1},...ge)}affects(ye,...ge){return this.h(ye,{includeChildren:!0},...ge)}h(ye,ge,...Y){if(!ye)return!1;const U=Y.length>0;return!!((!U||Y.includes(L.ADDED))&&(this.d.value.get(ye)||ge.includeChildren&&this.d.value.findSuperstr(ye))||(!U||Y.includes(L.UPDATED))&&(this.f.value.get(ye)||ge.includeChildren&&this.f.value.findSuperstr(ye))||(!U||Y.includes(L.DELETED))&&(this.g.value.findSubstr(ye)||ge.includeChildren&&this.g.value.findSuperstr(ye)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ye){return this.b===ye}hasCorrelation(){return typeof this.b=="number"}}e.$ul=M;function z(ne,ye,ge){return!ne||!ye||ne===ye||ye.length>ne.length?!1:(ye.charAt(ye.length-1)!==h.sep&&(ye+=h.sep),ge?(0,A.$Hf)(ne,ye):ne.indexOf(ye)===0)}class j extends Error{constructor(ye,ge,Y){super(ye),this.fileOperationResult=ge,this.options=Y}}e.$wl=j;class q extends j{constructor(ye,ge,Y,U){super(ye,ge,U),this.fileOperationResult=ge,this.size=Y}}e.$xl=q;class B extends j{constructor(ye,ge,Y){super(ye,ee.FILE_NOT_MODIFIED_SINCE,Y),this.stat=ge}}e.$yl=B;var ee;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$zl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Bl="files.associations",e.$Cl="files.exclude",e.$Dl="files.readonlyInclude",e.$El="files.readonlyExclude",e.$Fl="files.readonlyFromPermissions";var H;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$Gl="";function W(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function X(ne,ye){if(!ye.hasProvider(T.URI.from({scheme:ne.scheme})))return new Promise(ge=>{const Y=ye.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ne.scheme&&U.added&&(Y.dispose(),ge())})})}class _{static{this.KB=1024}static{this.MB=_.KB*_.KB}static{this.GB=_.MB*_.KB}static{this.TB=_.GB*_.KB}static formatSize(ye){return(0,R.$jg)(ye)||(ye=0),ye<_.KB?(0,O.localize)(1857,null,ye.toFixed(0)):ye<_.MB?(0,O.localize)(1858,null,(ye/_.KB).toFixed(2)):ye<_.GB?(0,O.localize)(1859,null,(ye/_.MB).toFixed(2)):ye<_.TB?(0,O.localize)(1860,null,(ye/_.GB).toFixed(2)):(0,O.localize)(1861,null,(ye/_.TB).toFixed(2))}}e.$Jl=_;function ce(ne){const ye=typeof ne=="string"||ne?.scheme===I.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===I.Schemas.file?1024*_.MB:ye?10*_.MB:c.$p?50*_.MB:1024*_.MB}}),define(ke[219],Ie([1,0,21,13,8,27]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=T;async function T(I,y,u,C,w,a){let m;try{await O(I,y,u,C,w,a)}catch($){m=$}finally{m&&w.errorTransformer&&(m=w.errorTransformer(m)),typeof m<"u"&&u.error(m),u.end()}}async function O(I,y,u,C,w,a){b(a);const m=await I.open(y,{create:!1});try{b(a);let $=0,f=0,i=w&&typeof w.length=="number"?w.length:void 0,s=r.$Oe.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,o=0;do f=await I.read(m,t,s.buffer,o,s.byteLength-o),t+=f,o+=f,$+=f,typeof i=="number"&&(i-=f),o===s.byteLength&&(await u.write(C(s)),s=r.$Oe.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),o=0);while(f>0&&(typeof i!="number"||i>0)&&b(a)&&c($,w));if(o>0){let n=o;typeof i=="number"&&(n=Math.min(o,i)),u.write(C(s.slice(0,n)))}}catch($){throw(0,R.$pl)($)}finally{await I.close(m)}}function b(I){if(I.isCancellationRequested)throw(0,h.$6)();return!0}function c(I,y){if(typeof y?.limits?.size=="number"&&I>y.limits.size)throw(0,R.$ol)((0,A.localize)(1889,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[69],Ie([1,0,38,3,16,10,2,27]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=void 0,e.$5q=b,e.$6q=c,e.$0q=C,e.$$q=w,e.$_q=a,e.$ar=m,e.$br=f,e.$cr=i;function b(s){return typeof s.correlationId=="number"}function c(s){return s.recursive===!0}class I extends h.$Vc{static{this.a=5}constructor(t,o,n,d){super(),this.h=t,this.j=o,this.m=n,this.n=d,this.c=this.B(new h.$Wc),this.f=void 0,this.g=0}s(){const t=new h.$Uc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(o=>this.h(o))),t.add(this.b.onDidLogMessage(o=>this.j(o))),t.add(this.b.onDidError(o=>this.t(o.error,o.request)))}t(t,o){this.u(t,o)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,o){return!(!this.n.restartOnError||o||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$7q=I;class y extends I{constructor(t,o,n){super(t,o,n,{type:"node.js",restartOnError:!1})}}e.$8q=y;class u extends I{constructor(t,o,n){super(t,o,n,{type:"universal",restartOnError:!0})}}e.$9q=u;function C(s){return s.map(t=>({type:t.type,resource:T.URI.revive(t.resource),cId:t.cId}))}function w(s){const t=new $;for(const o of s)t.processEvent(o);return t.coalesce()}function a(s,t){return typeof t=="string"&&!t.startsWith(r.$xk)&&!(0,A.$jc)(t)?{base:s,pattern:t}:t}function m(s,t){const o=[];for(const n of t)o.push((0,r.$Bk)(a(s,n)));return o}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return R.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const o=this.b.get(this.c(t));let n=!1;if(o){const d=o.type,l=t.type;o.resource.fsPath!==t.resource.fsPath&&(t.type===O.FileChangeType.DELETED||t.type===O.FileChangeType.ADDED)?n=!0:d===O.FileChangeType.ADDED&&l===O.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(o)):d===O.FileChangeType.DELETED&&l===O.FileChangeType.ADDED?o.type=O.FileChangeType.UPDATED:d===O.FileChangeType.ADDED&&l===O.FileChangeType.UPDATED||(o.type=l)}else n=!0;n&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],o=[];return Array.from(this.a).filter(n=>n.type!==O.FileChangeType.DELETED?(t.push(n),!1):!0).sort((n,d)=>n.resource.fsPath.length-d.resource.fsPath.length).filter(n=>o.some(d=>(0,O.$vl)(n.resource.fsPath,d,!R.$l))?!1:(o.push(n.resource.fsPath),!0)).concat(t)}}function f(s,t){if(typeof t=="number")switch(s.type){case O.FileChangeType.ADDED:return(t&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(t&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(t&O.FileChangeFilter.UPDATED)===0}return!1}function i(s){if(typeof s=="number"){const t=[];return s&O.FileChangeFilter.ADDED&&t.push("Added"),s&O.FileChangeFilter.DELETED&&t.push("Deleted"),s&O.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(ke[220],Ie([1,0,45,3,69,4,27,2,7]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class c extends h.$Vc{constructor(){super(),this.a=this.B(new R.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$5c),this.m=new Set,this.n=this.B(new b.$Eh(this.y())),this.r=5007,this.s=new b.$4h,this.R=!1,this.B(this.f(y=>this.t(y)))}t(y){this.u(y)&&this.z(y)}u(y){return(0,A.$5q)(y)}async watch(y){this.s.isSettled||this.s.complete(),this.s=new b.$4h;try{this.h.clear(),this.g.clear();for(const u of y)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(y){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),y?this.y():0)}y(){return 800}isSuspended(y){return typeof y.correlationId!="number"?!1:this.m.has(y.correlationId)?"polling":this.j.has(y.correlationId)}async z(y){if(this.j.has(y.correlationId))return;const u=new h.$Uc;this.j.set(y.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(y,u),this.w(!0))}C(y){this.j.deleteAndDispose(y.correlationId),this.m.delete(y.correlationId),this.w(!1)}D(y,u){this.F(y,u)?(this.P(`reusing an existing recursive watcher to monitor ${y.path}`),this.m.delete(y.correlationId)):(this.G(y,u),this.m.add(y.correlationId))}F(y,u){const C=this.O?.subscribe(y.path,(w,a)=>{u.isDisposed||(w?this.D(y,u):a?.type===T.FileChangeType.ADDED&&this.H(y))});return C?(u.add(C),!0):!1}G(y,u){let C=!1;const w=(a,m)=>{if(u.isDisposed)return;const $=this.I(a),f=this.I(m),i=C;C=$,!$&&(f||i)&&this.H(y)};this.P(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,r.watchFile)(y.path,{persistent:!1,interval:this.r},w)}catch(a){this.Q(`fs.watchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}u.add((0,h.$Tc)(()=>{this.P(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,r.unwatchFile)(y.path,w)}catch(a){this.Q(`fs.unwatchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}H(y){this.P(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const u={resource:O.URI.file(y.path),type:T.FileChangeType.ADDED,cId:y.correlationId};this.a.fire([u]),this.J(u,y),this.C(y)}I(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(y,u){if(this.R){const C=` >> normalized ${y.type===T.FileChangeType.ADDED?"[ADDED]":y.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.L(C,u)}}L(y,u){this.R&&this.P(`${y}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,A.$cr)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.R=y}}e.$lr=c}),define(ke[221],Ie([1,0,45,7,20,31,3,81,16,10,22,2,108,33,27,69]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0,e.$rr=$;class m extends T.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,s,t,o,n,d){super(),this.s=i,this.t=s,this.u=t,this.w=o,this.y=n,this.z=d,this.c=this.B(new h.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.u(l))),this.f=this.B(new h.$Uh(l=>this.M(l),m.b)),this.g=(0,a.$ar)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$ar)(this.s.path,this.s.includes):void 0,this.j=(0,a.$5q)(this.s)?this.s.filter:void 0,this.m=new A.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const s=await r.promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,s.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let s=i.path;try{s=await C.Promises.realpath(i.path),i.path===s&&(s=await(0,u.$nr)(i.path,this.m.token)??i.path),i.path!==s&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${s})`)}catch{}return s}async G(i,s){const t=new T.$Uc;return this.H(i,s,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,s,t)),t}H(i,s,t){if(s)return!1;const o=y.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(d,l)=>{if(!t.isDisposed)if(d){const g=await this.G(i,s);t.isDisposed?g.dispose():t.add(g)}else l&&(typeof l.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:l.type,cId:this.s.correlationId},!0)});return n?(t.add(n),!0):!1}async I(i,s,t){if(c.$k&&(0,R.$Fg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new A.$xe(this.m.token);t.add((0,T.$Tc)(()=>o.dispose(!0)));const n=new T.$Uc;t.add(n);try{const d=y.URI.file(this.s.path),l=(0,b.$oc)(i),g=(0,r.watch)(i);n.add((0,T.$Tc)(()=>{g.removeAllListeners(),g.close()})),this.Q(`Started watching: '${i}'`);const E=new Set;if(s)try{for(const D of await C.Promises.readdir(i))E.add(D)}catch(D){this.O(D)}if(o.token.isCancellationRequested)return;const S=new Map;n.add((0,T.$Tc)(()=>{for(const[,D]of S)D.dispose();S.clear()})),g.on("error",(D,k)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${D}, ${k})`),this.D())}),g.on("change",(D,k)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${D}"] ${k}`);let P="";if(k&&(P=k.toString(),c.$k&&(P=(0,O.$om)(P))),!(!P||D!=="change"&&D!=="rename"))if(s)if(D==="rename"){S.get(P)?.dispose();const p=setTimeout(async()=>{if(S.delete(P),P===l&&!await C.Promises.exists(i)){this.J(d);return}if(o.token.isCancellationRequested)return;const v=await this.N((0,b.$kc)(i,P));if(o.token.isCancellationRequested)return;let F;v?E.has(P)?F=w.FileChangeType.UPDATED:(F=w.FileChangeType.ADDED,E.add(P)):(E.delete(P),F=w.FileChangeType.DELETED),this.L({resource:(0,I.$hh)(d,P),type:F,cId:this.s.correlationId})},m.a);S.set(P,(0,T.$Tc)(()=>clearTimeout(p)))}else{let p;E.has(P)?p=w.FileChangeType.UPDATED:(p=w.FileChangeType.ADDED,E.add(P)),this.L({resource:(0,I.$hh)(d,P),type:p,cId:this.s.correlationId})}else if(D==="rename"||P!==l){const p=setTimeout(async()=>{const v=await C.Promises.exists(i);o.token.isCancellationRequested||(v?(this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(i,!1))):this.J(d))},m.a);n.clear(),n.add((0,T.$Tc)(()=>clearTimeout(p)))}else this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){o.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${d.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:w.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,s=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===w.FileChangeType.ADDED?"[ADDED]":i.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!s&&this.g.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!s&&this.h&&this.h.length>0&&!this.h.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const s=(0,a.$$q)(i),t=[];for(const n of s){if((0,a.$br)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}t.push(n)}if(t.length===0)return;if(this.z)for(const n of t)this.R(` >> normalized ${n.type===w.FileChangeType.ADDED?"[ADDED]":n.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(c.$l)return C.Promises.exists(i);try{const s=(0,b.$oc)(i);return(await C.Promises.readdir((0,b.$nc)(i))).some(o=>o===s)}catch(s){return this.Q(s),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$qr=m;async function $(f,i,s,t,o=512){const n=await C.Promises.open(f,"r"),d=Buffer.allocUnsafe(o),l=new A.$xe(t);let g,E=!1;const S={path:f,excludes:[],recursive:!1},D=new m(S,void 0,k=>{(async()=>{for(const{type:P}of k)if(P===w.FileChangeType.UPDATED){if(E)return;E=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:p}=await C.Promises.read(n,d,0,o,null);if(!p||l.token.isCancellationRequested)break;i(d.slice(0,p))}}catch(p){g=new Error(p),l.dispose(!0)}finally{E=!1}}})()});return await D.ready,s(),new Promise((k,P)=>{l.token.onCancellationRequested(async()=>{D.dispose();try{await C.Promises.close(n)}catch(p){g=new Error(p)}g?P(g):k()})})}}),define(ke[222],Ie([1,0,4,38,220,10,221,31]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class b extends A.$lr{constructor(I){super(),this.O=I,this.onDidError=r.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const y=[],u=new Set(Array.from(this.watchers));for(const C of I){const w=this.W(C);w&&(0,h.$Fk)(w.request.excludes,C.excludes)&&(0,h.$Fk)(w.request.includes,C.includes)?u.delete(w):y.push(C)}y.length&&this.P(`Request to start watching: ${y.map(C=>this.M(C)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map(C=>this.M(C.request)).join(",")}`);for(const C of u)this.Y(C);for(const C of y)this.X(C)}W(I){for(const y of this.watchers)if(typeof I.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===I.correlationId)return y}else if((0,O.$Eg)(y.request.path,I.path,!R.$l))return y}X(I){const y=new T.$qr(I,this.O,C=>this.a.fire(C),()=>this.c.fire(I),C=>this.b.fire(C),this.R),u={request:I,instance:y};this.watchers.add(u)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const y=new Map;for(const u of I){const C=R.$l?u.path:u.path.toLowerCase();let w=y.get(u.correlationId);w||(w=new Map,y.set(u.correlationId,w)),w.has(C)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),w.set(C,u)}return Array.from(y.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const y of this.watchers)y.instance.setVerboseLogging(I)}P(I,y){this.R&&this.b.fire({type:"trace",message:this.bb(I,y)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,y){return y?`[File Watcher (node.js)] ${I} (${this.M(y.request)})`:`[File Watcher (node.js)] ${I}`}}e.$sr=b}),define(ke[223],Ie([1,0,69,222]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;class A extends r.$8q{constructor(T,O,b){super(T,O,b),this.s()}r(T){return T.add(new h.$sr(void 0))}}e.$tr=A}),define(ke[224],Ie([1,0,14,86,192,69]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class T extends R.$9q{constructor(b,c,I){super(b,c,I),this.s()}r(b){const c=b.add(new A.$jr(r.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(c.onDidProcessExit(({code:I,signal:y})=>this.t(`terminated by itself with code ${I}, signal: ${y} (ETERM)`))),h.ProxyChannel.toService((0,h.$ni)(c.getChannel("watcher")))}}e.$kr=T}),define(ke[114],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class r{constructor(...A){this.a=new Map;for(const[R,T]of A)this.set(R,T)}set(A,R){const T=this.a.get(A);return this.a.set(A,R),T}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Ei=r}),define(ke[225],Ie([1,0,7,13,3,112,214,5,114,80]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=void 0;const I=!1;class y extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class u{constructor(m=new b.$Ei,$=!1,f,i=I){this.i=m,this.j=$,this.k=f,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Fi,this),this._globalGraph=i?f?._globalGraph??new T.$wr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Qc)(this.h),this.h.clear();for(const m of this.g)(0,A.$Pc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,$){this.m();const f=this,i=new class extends u{dispose(){f.h.delete(i),super.dispose()}}(m,this.j,this,this.l);return this.h.add(i),$?.add(i),i}invokeFunction(m,...$){this.m();const f=w.traceInvocation(this.l,m);let i=!1;try{return m({get:t=>{if(i)throw(0,h.$8)("service accessor is only valid during the invocation of its target method");const o=this.s(t,f);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...$)}finally{i=!0,f.stop()}}createInstance(m,...$){this.m();let f,i;return m instanceof R.$Di?(f=w.traceCreation(this.l,m.ctor),i=this.o(m.ctor,m.staticArguments.concat($),f)):(f=w.traceCreation(this.l,m),i=this.o(m,$,f)),f.stop(),i}o(m,$=[],f){const i=O._util.getServiceDependencies(m).sort((o,n)=>o.index-n.index),s=[];for(const o of i){const n=this.s(o.id,f);n||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${o.id}.`,!1),s.push(n)}const t=i.length>0?i[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${$.length} static arguments`);const o=t-$.length;o>0?$=$.concat(new Array(o)):$=$.slice(0,t)}return Reflect.construct(m,$.concat(s))}q(m,$){if(this.i.get(m)instanceof R.$Di)this.i.set(m,$);else if(this.k)this.k.q(m,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const $=this.i.get(m);return!$&&this.k?this.k.r(m):$}s(m,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const f=this.r(m);return f instanceof R.$Di?this.u(m,f,$.branch(m,!0)):($.branch(m,!1),f)}u(m,$,f){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,$,f)}finally{this.t.delete(m)}}v(m,$,f){const i=new T.$wr(n=>n.id.toString());let s=0;const t=[{id:m,desc:$,_trace:f}],o=new Set;for(;t.length;){const n=t.pop();if(!o.has(String(n.id))){if(o.add(String(n.id)),i.lookupOrInsertNode(n),s++>1e3)throw new y(i);for(const d of O._util.getServiceDependencies(n.desc.ctor)){const l=this.r(d.id);if(l||this.y(`[createInstance] ${m} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(d.id)),l instanceof R.$Di){const g={id:d.id,desc:l,_trace:n._trace.branch(d.id,!0)};i.insertEdge(n,g),t.push(g)}}}}for(;;){const n=i.roots();if(n.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:d}of n){if(this.r(d.id)instanceof R.$Di){const g=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,g)}i.removeNode(d)}}return this.r(m)}w(m,$,f=[],i,s){if(this.i.get(m)instanceof R.$Di)return this.x(m,$,f,i,s,this.g);if(this.k)return this.k.w(m,$,f,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(m,$,f=[],i,s,t){if(i){const o=new u(void 0,this.j,this,this.l);o.c=String(m);const n=new Map,d=new r.$Zh(()=>{const l=o.o($,f,s);for(const[g,E]of n){const S=l[g];if(typeof S=="function")for(const D of E)D.disposable=S.apply(l,D.listener)}return n.clear(),t.add(l),l});return new Proxy(Object.create(null),{get(l,g){if(!d.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let D=n.get(g);return D||(D=new c.$6c,n.set(g,D)),(P,p,v)=>{if(d.isInitialized)return d.value[g](P,p,v);{const F={listener:[P,p,v],disposable:void 0},N=D.push(F);return(0,A.$Tc)(()=>{N(),F.disposable?.dispose()})}}}if(g in l)return l[g];const E=d.value;let S=E[g];return typeof S!="function"||(S=S.bind(E),l[g]=S),S},set(l,g,E){return d.value[g]=E,!0},getPrototypeOf(l){return $.prototype}})}else{const o=this.o($,f,s);return t.add(o),o}}y(m,$){if($&&console.warn(m),this.j)throw new Error(m)}}e.$xr=u;var C;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(C||(C={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(C.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,$){return m?new w(C.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(m,$){return m?new w(C.Creation,$.name):w.c}static{this.f=0}constructor(m,$){this.type=m,this.name=$,this.g=Date.now(),this.h=[]}branch(m,$){const f=new w(C.Branch,m.toString());return this.h.push([m,$,f]),f}stop(){const m=Date.now()-this.g;w.f+=m;let $=!1;function f(s,t){const o=[],n=new Array(s+1).join("	");for(const[d,l,g]of t.h)if(l&&g){$=!0,o.push(`${n}CREATES -> ${d}`);const E=f(s+1,g);E&&o.push(E)}else o.push(`${n}uses -> ${d}`);return o.join(`
`)}const i=[`${this.type===C.Creation?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(m>2||$)&&w.all.add(i.join(`
`))}}e.$yr=w}),define(ke[11],Ie([1,0,8,52,4,60,3,28,10,22,17,2,35,5]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$ek=e.LogLevel=e.$ck=e.$bk=void 0,e.$dk=a,e.log=$,e.$pk=S,e.$qk=D,e.$rk=k,e.$sk=P,r=We(r),e.$bk=(0,C.$Gi)("logService"),e.$ck=(0,C.$Gi)("loggerService");function w(){return new Date().toISOString()}function a(p){return(0,I.$jg)(p)}var m;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$ek=m.Info;function $(p,v,F){switch(v){case m.Trace:p.trace(F);break;case m.Debug:p.debug(F);break;case m.Info:p.info(F);break;case m.Warning:p.warn(F);break;case m.Error:p.error(F);break;case m.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function f(p,v=!1){let F="";for(let N=0;N<p.length;N++){let L=p[N];if(L instanceof Error&&(L=(0,h.$rj)(L,v)),typeof L=="object")try{L=JSON.stringify(L)}catch{}F+=(N>0?" ":"")+L}return F}class i extends T.$Vc{constructor(){super(...arguments),this.b=e.$ek,this.c=this.B(new A.$me),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==m.Off&&this.b<=v}}e.$gk=i;class s extends i{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...F){this.f(m.Trace)&&this.g(m.Trace,f([v,...F],!0))}debug(v,...F){this.f(m.Debug)&&this.g(m.Debug,f([v,...F]))}info(v,...F){this.f(m.Info)&&this.g(m.Info,f([v,...F]))}warn(v,...F){this.f(m.Warning)&&this.g(m.Warning,f([v,...F]))}error(v,...F){if(this.f(m.Error))if(v instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=v.stack,this.g(m.Error,f(N))}else this.g(m.Error,f([v,...F]))}flush(){}}e.$hk=s;class t extends i{constructor(v=e.$ek){super(),this.setLevel(v),this.g=!b.$j}trace(v,...F){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}debug(v,...F){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}info(v,...F){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}warn(v,...F){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,v,...F):console.warn(`[main ${w()}]`,v,...F))}error(v,...F){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,v,...F):console.error(`[main ${w()}]`,v,...F))}flush(){}}e.$ik=t;class o extends i{constructor(v=e.$ek,F=!0){super(),this.g=F,this.setLevel(v)}trace(v,...F){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...F):console.log(v,...F))}debug(v,...F){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...F):console.log(v,...F))}info(v,...F){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...F):console.log(v,...F))}warn(v,...F){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...F):console.log(v,...F))}error(v,...F){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...F):console.error(v,...F))}flush(){}}e.$jk=o;class n extends i{constructor(v,F=e.$ek){super(),this.g=v,this.setLevel(F)}trace(v,...F){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(v),...F])}debug(v,...F){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(v),...F])}info(v,...F){this.f(m.Info)&&this.g.log(m.Info,[this.h(v),...F])}warn(v,...F){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(v),...F])}error(v,...F){this.f(m.Error)&&this.g.log(m.Error,[this.h(v),...F])}h(v){return typeof v=="string"?v:(0,h.$rj)(v,this.f(m.Trace))}flush(){}}e.$kk=n;class d extends i{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const F of this.g)F.setLevel(v);super.setLevel(v)}trace(v,...F){for(const N of this.g)N.trace(v,...F)}debug(v,...F){for(const N of this.g)N.debug(v,...F)}info(v,...F){for(const N of this.g)N.info(v,...F)}warn(v,...F){for(const N of this.g)N.warn(v,...F)}error(v,...F){for(const N of this.g)N.error(v,...F)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$lk=d;class l extends T.$Vc{constructor(v,F,N){if(super(),this.h=v,this.j=F,this.b=new O.$Bc,this.c=this.B(new A.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$me),this.onDidChangeVisibility=this.g.event,N)for(const L of N)this.b.set(L.resource,{logger:void 0,info:L})}m(v){return(0,I.$fg)(v)?[...this.b.values()].find(F=>F.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,F){const N=this.n(v),L=(0,I.$fg)(v)?v:F?.id??(0,R.$uj)(N.toString()).toString(16);let M=this.b.get(N)?.logger;const z=F?.logLevel==="always"?m.Trace:F?.logLevel;M||(M=this.s(N,z??this.getLogLevel(N)??this.h,{...F,id:L}));const j={logger:M,info:{resource:N,id:L,logLevel:z,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(j.info),this.b.set(N,j),M}n(v){return(0,I.$fg)(v)?(0,c.$hh)(this.j,`${v}.log`):v}setLogLevel(v,F){if(y.URI.isUri(v)){const N=v,L=F,M=this.b.get(N);M&&L!==M.info.logLevel&&(M.info.logLevel=L===this.h?void 0:L,M.logger?.setLevel(L),this.b.set(M.info.resource,M),this.f.fire([N,L]))}else{this.h=v;for(const[N,L]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,F){const N=this.m(v);N&&F!==!N.info.hidden&&(N.info.hidden=!F,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,F]))}getLogLevel(v){let F;return v&&(F=this.b.get(v)?.info.logLevel),F??this.h}registerLogger(v){const F=this.b.get(v.resource);F?F.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const F=this.b.get(v);F&&(F.logger&&F.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$mk=l;class g{constructor(){this.onDidChangeLogLevel=new A.$me().event}setLevel(v){}getLevel(){return m.Info}trace(v,...F){}debug(v,...F){}info(v,...F){}warn(v,...F){}error(v,...F){}critical(v,...F){}dispose(){}flush(){}}e.$nk=g;class E extends g{}e.$ok=E;function S(p){if(p.verbose)return m.Trace;if(typeof p.logLevel=="string"){const v=P(p.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ek}function D(p){switch(p){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function k(p){switch(p){case m.Trace:return{original:"Trace",value:r.localize(1950,null)};case m.Debug:return{original:"Debug",value:r.localize(1951,null)};case m.Info:return{original:"Info",value:r.localize(1952,null)};case m.Warning:return{original:"Warning",value:r.localize(1953,null)};case m.Error:return{original:"Error",value:r.localize(1954,null)};case m.Off:return{original:"Off",value:r.localize(1955,null)}}}function P(p){switch(p){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$tk=new u.$Xj("logLevel",D(m.Info))}),define(ke[226],Ie([1,0,18,7,13,4,31,3,16,69,11]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class y extends O.$Vc{constructor(C,w){super(),this.a=C,this.b=w,this.c=this.B(new R.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Eh(0)),this.w=[],this.y=this.B(new h.$Eh(0))}watch(C,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(C,w):this.z(C,w)}n(C,w){const a={path:this.J(C),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Tb)(this.j,a);return this.r(),(0,O.$Tc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(C=>(0,A.$Z)(C))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,c.$0q)(w)),w=>this.G(w),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const C=this.b?.watcher?.recursive?.usePolling;if(C===!0)for(const w of this.j)(0,c.$6q)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(C))for(const w of this.j)(0,c.$6q)(w)&&C.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(C,w){const a={path:this.J(C),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Tb)(this.w,a);return this.C(),(0,O.$Tc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(C=>(0,A.$Z)(C))}D(){return this.u||(this.u=this.B(this.F(C=>this.c.fire((0,c.$0q)(C)),C=>this.G(C),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(C){C.type==="error"&&this.g.fire(C.message),this.H(C)}H(C){this.a[C.type](C.message)}I(C){return(0,b.$ic)(C.fsPath)}J(C){const w=this.I(C);return(0,T.$Ig)(w)}}e.$dr=y}),define(ke[227],Ie([1,0,45,7,28,21,4,31,3,16,10,22,105,33,8,27,219,226,224,223]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;class s extends $.$dr{static{this.L=!1}constructor(o,n){super(o,n),this.onDidChangeCapabilities=T.Event.None,this.P=new A.$Bc(d=>y.$$g.getComparisonKey(d)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,I.$l&&(this.M|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(o){try{const{stat:n,symbolicLink:d}=await C.SymlinkSupport.stat(this.I(o));return{type:this.O(n,d),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:a.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const n=await C.Promises.readdir(this.I(o),{withFileTypes:!0}),d=[];return await Promise.all(n.map(async l=>{try{let g;l.isSymbolicLink()?g=(await this.stat((0,y.$hh)(o,l.name))).type:g=this.O(l),d.push([l.name,g])}catch(g){this.a.trace(g)}})),d}catch(n){throw this.hb(n)}}O(o,n){let d;return n?.dangling?d=a.FileType.Unknown:o.isFile()?d=a.FileType.File:o.isDirectory()?d=a.FileType.Directory:d=a.FileType.Unknown,n&&(d|=a.FileType.SymbolicLink),d}async Q(o){const n=this.I(o);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let d;for(;d=this.P.get(o);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await d.wait();const l=new h.$Fh;return this.P.set(o,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(o)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(o)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(o,n){let d;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(o)})`),d=await this.Q(o));const l=this.I(o);return await r.promises.readFile(l)}catch(l){throw this.hb(l)}finally{d?.dispose()}}R(o){s.L&&this.a.trace(o)}readFileStream(o,n,d){const l=(0,u.$Ce)(g=>R.$Oe.concat(g.map(E=>R.$Oe.wrap(E))).buffer);return(0,m.$3q)(this,o,l,g=>g.buffer,{...n,bufferSize:256*1024},d),l}async writeFile(o,n,d){return d?.atomic!==!1&&d?.atomic?.postfix&&await this.S(o)?this.U(o,(0,y.$hh)((0,y.$gh)(o),`${(0,y.$eh)(o)}${d.atomic.postfix}`),n,d):this.W(o,n,d)}async S(o){try{const n=this.I(o),{symbolicLink:d}=await C.SymlinkSupport.stat(n);if(d)return!1}catch{}return!0}async U(o,n,d,l){const g=new b.$Uc;try{g.add(await this.Q(o)),g.add(await this.Q(n)),await this.W(n,d,l,!0);try{await this.rename(n,o,{overwrite:!0})}catch(E){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{g.dispose()}}async W(o,n,d,l){let g;try{const E=this.I(o);if(!d.create||!d.overwrite){if(await C.Promises.exists(E)){if(!d.overwrite)throw(0,a.$ol)((0,w.localize)(1892,null),a.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,a.$ol)((0,w.localize)(1893,null),a.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(o,{create:!0,unlock:d.unlock},l),await this.write(g,0,n,0,n.byteLength)}catch(E){throw await this.ib(o,E)}finally{typeof g=="number"&&await this.close(g)}}static{this.$=!0}static configureFlushOnWrite(o){s.$=o}async open(o,n,d){const l=this.I(o);let g;(0,a.$cl)(n)&&!d&&(g=await this.Q(o));let E;try{if((0,a.$cl)(n)&&n.unlock)try{const{stat:D}=await C.SymlinkSupport.stat(l);D.mode&128||await r.promises.chmod(l,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let S;if((0,a.$cl)(n)){if(I.$j)try{await r.promises.truncate(l,0),S="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}S||(S="w")}else S="r";E=await C.Promises.open(l,S)}catch(S){throw g?.dispose(),(0,a.$cl)(n)?await this.ib(o,S):this.hb(S)}if(this.X.set(E,0),(0,a.$cl)(n)&&this.Z.set(E,o),g){const S=this.Y.get(E);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${l})`),this.Y.set(E,g),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${l})`),S.dispose())}return E}async close(o){const n=this.Y.get(o);try{if(this.X.delete(o),this.Z.delete(o)&&s.$)try{await C.Promises.fdatasync(o)}catch(d){s.configureFlushOnWrite(!1),this.a.error(d)}return await C.Promises.close(o)}catch(d){throw this.hb(d)}finally{n&&(this.Y.get(o)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.Y.delete(o)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),n.dispose())}}async read(o,n,d,l,g){const E=this.ab(o,n);let S=null;try{S=(await C.Promises.read(o,d,l,g,E)).bytesRead}catch(D){throw this.hb(D)}finally{this.bb(o,E,S)}return S}ab(o,n){return n===this.X.get(o)?null:n}bb(o,n,d){const l=this.X.get(o);typeof l=="number"&&(typeof n=="number"||(typeof d=="number"?this.X.set(o,l+d):this.X.delete(o)))}async write(o,n,d,l,g){return(0,h.$1h)(()=>this.cb(o,n,d,l,g),100,3)}async cb(o,n,d,l,g){const E=this.ab(o,n);let S=null;try{S=(await C.Promises.write(o,d,l,g,E)).bytesWritten}catch(D){throw await this.ib(this.Z.get(o),D)}finally{this.bb(o,E,S)}return S}async mkdir(o){try{await r.promises.mkdir(this.I(o))}catch(n){throw this.hb(n)}}async delete(o,n){try{const d=this.I(o);if(n.recursive){let l;n?.atomic!==!1&&n.atomic.postfix&&(l=(0,c.$kc)((0,c.$nc)(d),`${(0,c.$oc)(d)}${n.atomic.postfix}`)),await C.Promises.rm(d,C.RimRafMode.MOVE,l)}else try{await r.promises.unlink(d)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let g=!1;try{const{stat:E,symbolicLink:S}=await C.SymlinkSupport.stat(d);g=E.isDirectory()&&!S}catch{}if(g)await r.promises.rmdir(d);else throw l}else throw l}}catch(d){throw this.hb(d)}}async rename(o,n,d){const l=this.I(o),g=this.I(n);if(l!==g)try{await this.db(o,n,"move",d.overwrite),await C.Promises.rename(l,g)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(1894,null,(0,c.$oc)(l),(0,c.$oc)((0,c.$nc)(g)),E.toString()))),this.hb(E)}}async copy(o,n,d){const l=this.I(o),g=this.I(n);if(l!==g)try{await this.db(o,n,"copy",d.overwrite),await C.Promises.copy(l,g,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(1895,null,(0,c.$oc)(l),(0,c.$oc)((0,c.$nc)(g)),E.toString()))),this.hb(E)}}async db(o,n,d,l){const g=this.I(o),E=this.I(n);let S=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(S=(0,O.$Eg)(g,E,!0)),S){if(d==="copy")throw(0,a.$ol)((0,w.localize)(1896,null),a.FileSystemProviderErrorCode.FileExists);if(d==="move")return}const k=await this.N(o);if(!k)throw(0,a.$ol)((0,w.localize)(1897,null),a.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(n);if(P){if(!l)throw(0,a.$ol)((0,w.localize)(1898,null),a.FileSystemProviderErrorCode.FileExists);k.type&a.FileType.File&&P.type&a.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,n){return this.eb(o,n,!1)}async eb(o,n,d){const l=this.I(o),g=this.I(n),E=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Eg)(l,g,!E))return;const S=new b.$Uc;try{S.add(await this.Q(o)),S.add(await this.Q(n)),d&&await r.promises.mkdir((0,c.$nc)(g),{recursive:!0}),await r.promises.copyFile(l,g)}catch(D){if(D.code==="ENOENT"&&!d)return this.eb(o,n,!0);throw this.hb(D)}finally{S.dispose()}}t(o,n,d){return new f.$kr(l=>o(l),l=>n(l),d)}F(o,n,d){return new i.$tr(l=>o(l),l=>n(l),d)}hb(o){if(o instanceof a.$nl)return o;let n=o,d;switch(o.code){case"ENOENT":d=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,d=a.FileSystemProviderErrorCode.Unknown;break;default:d=a.FileSystemProviderErrorCode.Unknown}return(0,a.$ol)(n,d)}async ib(o,n){let d=this.hb(n);if(o&&d.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await C.SymlinkSupport.stat(this.I(o));l.mode&128||(d=(0,a.$ol)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return d}}e.$ur=s}),define(ke[228],Ie([1,0,3,11]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OR=void 0;class A extends r.$Vc{constructor(T,O=[]){super(),this.a=new h.$lk([T,...O]),this.B(T.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...O){this.a.trace(T,...O)}debug(T,...O){this.a.debug(T,...O)}info(T,...O){this.a.info(T,...O)}warn(T,...O){this.a.warn(T,...O)}error(T,...O){this.a.error(T,...O)}flush(){this.a.flush()}}e.$OR=A}),define(ke[229],Ie([1,0,27,11]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;var A;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(A||(A={}));async function R(c,I,y,u,C){try{const w=await new Promise((m,$)=>{$e(["@vscode/spdlog"],m,$)}).then(We);w.setFlushOn(A.Trace);const a=await w.createAsyncRotatingLogger(c,I,y,u);return C?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(w){console.error(w)}return null}function T(c,I,y){switch(I){case h.LogLevel.Trace:c.trace(y);break;case h.LogLevel.Debug:c.debug(y);break;case h.LogLevel.Info:c.info(y);break;case h.LogLevel.Warning:c.warn(y);break;case h.LogLevel.Error:c.error(y);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function O(c,I){switch(I){case h.LogLevel.Trace:c.setLevel(A.Trace);break;case h.LogLevel.Debug:c.setLevel(A.Debug);break;case h.LogLevel.Info:c.setLevel(A.Info);break;case h.LogLevel.Warning:c.setLevel(A.Warning);break;case h.LogLevel.Error:c.setLevel(A.Error);break;case h.LogLevel.Off:c.setLevel(A.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class b extends h.$hk{constructor(I,y,u,C,w){super(),this.m=[],this.setLevel(w),this.n=this.s(I,y,u,C),this.B(this.onDidChangeLogLevel(a=>{this.r&&O(this.r,a)}))}async s(I,y,u,C){const w=u?6:1,a=30/w*r.$Jl.MB,m=await R(I,y,a,w,C);if(m){this.r=m,O(this.r,this.getLevel());for(const{level:$,message:f}of this.m)T(this.r,$,f);this.m=[]}}g(I,y){this.r?T(this.r,I,y):this.getLevel()<=I&&this.m.push({level:I,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$DR=b});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[146],Ie([1,0,43,8,5]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=Ut(r);var R;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var T;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(b){function c(w,a){return a-w}b.compare=c;const I=Object.create(null);I[b.Error]=(0,h.localize)(1956,null),I[b.Warning]=(0,h.localize)(1957,null),I[b.Info]=(0,h.localize)(1958,null);function y(w){return I[w]||""}b.toString=y;function u(w){switch(w){case r.default.Error:return b.Error;case r.default.Warning:return b.Warning;case r.default.Info:return b.Info;case r.default.Ignore:return b.Hint}}b.fromSeverity=u;function C(w){switch(w){case b.Error:return r.default.Error;case b.Warning:return r.default.Warning;case b.Info:return r.default.Info;case b.Hint:return r.default.Ignore}}b.toSeverity=C}(T||(e.MarkerSeverity=T={}));var O;(function(b){const c="";function I(u){return y(u,!0)}b.makeKey=I;function y(u,C){const w=[c];return u.source?w.push(u.source.replace("\xA6","\\\xA6")):w.push(c),u.code?typeof u.code=="string"?w.push(u.code.replace("\xA6","\\\xA6")):w.push(u.code.value.replace("\xA6","\\\xA6")):w.push(c),u.severity!==void 0&&u.severity!==null?w.push(T.toString(u.severity)):w.push(c),u.message&&C?w.push(u.message.replace("\xA6","\\\xA6")):w.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?w.push(u.startLineNumber.toString()):w.push(c),u.startColumn!==void 0&&u.startColumn!==null?w.push(u.startColumn.toString()):w.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?w.push(u.endLineNumber.toString()):w.push(c),u.endColumn!==void 0&&u.endColumn!==null?w.push(u.endColumn.toString()):w.push(c),w.push(c),w.join("\xA6")}b.makeKeyOptionalMessage=y})(O||(e.IMarkerData=O={})),e.$Hu=(0,A.$Gi)("markerService")});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[230],Ie([1,0,4,43,5]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yw=e.$xw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$vw=e.Severity=void 0,e.$ww=O,h=Ut(h),e.Severity=h.default,e.$vw=(0,A.$Gi)("notificationService");var R;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var T;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));function O(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var b;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(b||(e.NotificationsFilter=b={}));class c{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$xw=c;class I{infinite(){}done(){}total(u){}worked(u){}}e.$yw=I}),define(ke[231],Ie([1,0,55]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const R=A.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(ke[115],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$uk=(0,r.$Gi)("productService"),e.$vk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function($e,e){return function(r,h){e(r,h,$e)}};define(ke[89],Ie([1,0,7,20,3,5]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.ProgressLocation=e.$zw=void 0,e.$zw=(0,R.$Gi)("progressService");var T;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.$Aw=Object.freeze({total(){},worked(){},done(){}});class O{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Bw=O;class b{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const C=this.d;this.d=()=>{C?.(),u()}}):Promise.resolve()}}e.$Cw=b;let c=class extends A.$Vc{constructor(u,C){super(),this.a=new r.$4h,C.withProgress(u,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,A.$Tc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Dw=c,e.$Dw=c=Je([Ve(1,e.$zw)],c);class I extends A.$Vc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new A.$Uc)}start(u){this.stop();const C=++this.a,w=new h.$xe;return this.f=setTimeout(()=>{C===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,A.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Tc)(()=>w.cancel())),this.b.add((0,A.$Tc)(()=>this.c?this.c.done():void 0)),{id:C,token:w.token,stop:()=>this.h(C),isCurrent:()=>this.a===C}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Ew=I,e.$Fw=(0,R.$Gi)("editorProgressService")}),define(ke[36],Ie([1,0,65,17]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,r=We(r),h=We(h);class A{constructor(){this.a=new Map}add(T,O){r.ok(h.$fg(T)),r.ok(h.$hg(O)),r.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,O)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$so=new A}),define(ke[116],Ie([1,0,4,177,36]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,A=We(A),e.$to={JSONContribution:"base.contributions.json"};function R(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class T{constructor(){this.b=new r.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,I){this.a[R(c)]=I,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const I=this.a[c];return I?(0,h.$9j)(I):void 0}hasSchemaContent(c){return!!this.a[c]}}const O=new T;A.$so.add(e.$to.JSONContribution,O)}),define(ke[70],Ie([1,0,18,4,17,8,46,116,36]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ConfigurationScope=e.$xo=e.EditPresentationTypes=void 0,e.$Io=a,e.$Jo=m,e.$Ko=$,e.$Lo=i,e.$Mo=s,e.$No=t,e.$Oo=o,A=We(A),R=We(R);var c;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$xo={Configuration:"base.contributions.configuration"};var I;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo="vscode://schemas/settings/resourceLanguage",e.$Fo="vscode://schemas/settings/configurationDefaults";const y=b.$so.as(O.$to.JSONContribution);class u{constructor(){this.a=[],this.i=new Set,this.j=new h.$me,this.onDidSchemaChange=this.j.event,this.k=new h.$me,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:R.localize(1653,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Eo,this.h),this.z()}registerConfiguration(d,l=!0){this.registerConfigurations([d],l)}registerConfigurations(d,l=!0){const g=new Set;this.r(d,l,g),y.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:g})}deregisterConfigurations(d){const l=new Set;this.s(d,l),y.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:l})}updateConfigurations({add:d,remove:l}){const g=new Set;this.s(l,g),this.r(d,!1,g),y.registerSchema(e.$Eo,this.h),this.j.fire(),this.k.fire({properties:g})}registerDefaultConfigurations(d){const l=new Set;this.l(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}l(d,l){this.a.push(...d);const g=[];for(const{overrides:E,source:S}of d)for(const D in E){l.add(D);const k=this.b.get(D)??this.b.set(D,{configurationDefaultOverrides:[]}).get(D),P=E[D];if(k.configurationDefaultOverrides.push({value:P,source:S}),e.$Ho.test(D)){const p=this.o(D,P,S,k.configurationDefaultOverrideValue);if(!p)continue;k.configurationDefaultOverrideValue=p,this.n(D,p,S),g.push(...a(D))}else{const p=this.p(D,P,S,k.configurationDefaultOverrideValue);if(!p)continue;k.configurationDefaultOverrideValue=p;const v=this.e[D];v&&(this.A(D,v),this.w(D,v))}}this.q(g)}deregisterDefaultConfigurations(d){const l=new Set;this.m(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}m(d,l){for(const g of d){const E=this.a.indexOf(g);E!==-1&&this.a.splice(E,1)}for(const{overrides:g,source:E}of d)for(const S in g){const D=this.b.get(S);if(!D)continue;const k=D.configurationDefaultOverrides.findIndex(P=>E?P.source?.id===E.id:P.value===g[S]);if(k!==-1){if(D.configurationDefaultOverrides.splice(k,1),D.configurationDefaultOverrides.length===0&&this.b.delete(S),e.$Ho.test(S)){let P;for(const p of D.configurationDefaultOverrides)P=this.o(S,p.value,p.source,P);P&&!A.$sg(P.value)?(D.configurationDefaultOverrideValue=P,this.n(S,P,E)):(this.b.delete(S),delete this.e[S],delete this.c.properties[S])}else{let P;for(const v of D.configurationDefaultOverrides)P=this.p(S,v.value,v.source,P);D.configurationDefaultOverrideValue=P;const p=this.e[S];p&&(this.A(S,p),this.w(S,p))}l.add(S)}}this.y()}n(d,l,g){const E={type:"object",default:l.value,description:R.localize(1654,null,(0,T.$kj)(d)),$ref:e.$Eo,defaultDefaultValue:l.value,source:g,defaultValueSource:g};this.e[d]=E,this.c.properties[d]=E}o(d,l,g,E){const S=E?.value||{},D=E?.source??new Map;if(!(D instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const k of Object.keys(l)){const P=l[k];if(A.$hg(P)&&(A.$mg(S[k])||A.$hg(S[k]))){if(S[k]={...S[k]??{},...P},g)for(const v in P)D.set(`${k}.${v}`,g)}else S[k]=P,g?D.set(k,g):D.delete(k)}return{value:S,source:D}}p(d,l,g,E){const S=this.e[d],D=E?.value??S?.defaultDefaultValue;let k=g;if(A.$hg(l)&&(S!==void 0&&S.type==="object"||S===void 0&&(A.$mg(D)||A.$hg(D)))){if(k=E?.source??new Map,!(k instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const p in l)g&&k.set(`${d}.${p}`,g);l={...A.$hg(D)?D:{},...l}}return{value:l,source:k}}deltaConfiguration(d){let l=!1;const g=new Set;d.removedDefaults&&(this.m(d.removedDefaults,g),l=!0),d.addedDefaults&&(this.l(d.addedDefaults,g),l=!0),d.removedConfigurations&&this.s(d.removedConfigurations,g),d.addedConfigurations&&this.r(d.addedConfigurations,!1,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...d){this.j.fire()}registerOverrideIdentifiers(d){this.q(d),this.j.fire()}q(d){for(const l of d)this.i.add(l);this.y()}r(d,l,g){d.forEach(E=>{this.u(E,l,E.extensionInfo,E.restrictedProperties,void 0,g),this.d.push(E),this.v(E)})}s(d,l){const g=E=>{if(E.properties)for(const S in E.properties){l.add(S);const D=this.e[S];D?.policy?.name&&this.f.delete(D.policy.name),delete this.e[S],this.x(S,E.properties[S])}E.allOf?.forEach(S=>g(S))};for(const E of d){g(E);const S=this.d.indexOf(E);S!==-1&&this.d.splice(S,1)}}u(d,l=!0,g,E,S=I.WINDOW,D){S=A.$og(d.scope)?S:d.scope;const k=d.properties;if(k)for(const p in k){const v=k[p];if(l&&i(p,v)){delete k[p];continue}if(v.source=g,v.defaultDefaultValue=k[p].default,this.A(p,v),e.$Ho.test(p)?v.scope=void 0:(v.scope=A.$og(v.scope)?S:v.scope,v.restricted=A.$og(v.restricted)?!!E?.includes(p):v.restricted),k[p].hasOwnProperty("included")&&!k[p].included){this.g[p]=k[p],delete k[p];continue}else this.e[p]=k[p],k[p].policy?.name&&this.f.set(k[p].policy.name,p);!k[p].deprecationMessage&&k[p].markdownDeprecationMessage&&(k[p].deprecationMessage=k[p].markdownDeprecationMessage),D.add(p)}const P=d.allOf;if(P)for(const p of P)this.u(p,l,g,E,S,D)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const d=new Map;for(const[l,g]of this.b)g.configurationDefaultOverrideValue&&d.set(l,g.configurationDefaultOverrideValue);return d}v(d){const l=g=>{const E=g.properties;if(E)for(const D in E)this.w(D,E[D]);g.allOf?.forEach(l)};l(d)}w(d,l){switch(e.$yo.properties[d]=l,l.scope){case I.APPLICATION:e.$zo.properties[d]=l;break;case I.MACHINE:e.$Ao.properties[d]=l;break;case I.MACHINE_OVERRIDABLE:e.$Bo.properties[d]=l;break;case I.WINDOW:e.$Co.properties[d]=l;break;case I.RESOURCE:e.$Do.properties[d]=l;break;case I.LANGUAGE_OVERRIDABLE:e.$Do.properties[d]=l,this.h.properties[d]=l;break}}x(d,l){switch(delete e.$yo.properties[d],l.scope){case I.APPLICATION:delete e.$zo.properties[d];break;case I.MACHINE:delete e.$Ao.properties[d];break;case I.MACHINE_OVERRIDABLE:delete e.$Bo.properties[d];break;case I.WINDOW:delete e.$Co.properties[d];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Do.properties[d],delete this.h.properties[d];break}}y(){for(const d of this.i.values()){const l=`[${d}]`,g={type:"object",description:R.localize(1655,null),errorMessage:R.localize(1656,null),$ref:e.$Eo};this.A(l,g),e.$yo.properties[l]=g,e.$zo.properties[l]=g,e.$Ao.properties[l]=g,e.$Bo.properties[l]=g,e.$Co.properties[l]=g,e.$Do.properties[l]=g}}z(){const d={type:"object",description:R.localize(1657,null),errorMessage:R.localize(1658,null),$ref:e.$Eo};e.$yo.patternProperties[e.$Go]=d,e.$zo.patternProperties[e.$Go]=d,e.$Ao.patternProperties[e.$Go]=d,e.$Bo.patternProperties[e.$Go]=d,e.$Co.patternProperties[e.$Go]=d,e.$Do.patternProperties[e.$Go]=d,this.j.fire()}A(d,l){const g=this.b.get(d)?.configurationDefaultOverrideValue;let E,S;g&&(!l.disallowConfigurationDefault||!g.source)&&(E=g.value,S=g.source),A.$mg(E)&&(E=l.defaultDefaultValue,S=void 0),A.$mg(E)&&(E=$(l.type)),l.default=E,l.defaultValueSource=S}}const C="\\[([^\\]]+)\\]",w=new RegExp(C,"g");e.$Go=`^(${C})+$`,e.$Ho=new RegExp(e.$Go);function a(n){const d=[];if(e.$Ho.test(n)){let l=w.exec(n);for(;l?.length;){const g=l[1].trim();g&&d.push(g),l=w.exec(n)}}return(0,r.$Mb)(d)}function m(n){return n.reduce((d,l)=>`${d}[${l}]`,"")}function $(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new u;b.$so.add(e.$xo.Configuration,f);function i(n,d){return n.trim()?e.$Ho.test(n)?R.localize(1660,null,n):f.getConfigurationProperties()[n]!==void 0?R.localize(1661,null,n):d.policy?.name&&f.getPolicyConfigurations().get(d.policy?.name)!==void 0?R.localize(1662,null,n,d.policy?.name,f.getPolicyConfigurations().get(d.policy?.name)):null:R.localize(1659,null)}function s(){const n=[],d=f.getConfigurationProperties();for(const l of Object.keys(d))n.push([l,d[l].scope]);return n.push(["launch",I.RESOURCE]),n.push(["task",I.RESOURCE]),n}function t(n){const d={};for(const l of n){const g=l.properties;if(A.$hg(g))for(const E in g)d[E]=g[E];l.allOf&&Object.assign(d,t(l.allOf))}return d}function o(n){switch(n){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(ke[232],Ie([1,0,18,4,176,3,28,24,17,2,46,70,27,36]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$So=e.$Ro=e.$Qo=e.$Po=void 0,e.$To=s,r=We(r),A=We(A),O=We(O),b=We(b);function w(d){return Object.isFrozen(d)?d:O.$go(d)}class a{static createEmptyModel(l){return new a({},[],[],void 0,l)}constructor(l,g,E,S,D){this.b=l,this.c=g,this.d=E,this.raw=S,this.f=D,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(g=>{if(g instanceof a)return g;const E=new m("",this.f);return E.parseRaw(g),E.configurationModel});this.g=l.reduce((g,E)=>E===g?E:g.merge(E),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,I.$ij)(this.contents,l):this.contents}inspect(l,g){const E=this;return{get value(){return w(E.rawConfiguration.getValue(l))},get override(){return g?w(E.rawConfiguration.getOverrideValue(l,g)):void 0},get merged(){return w(g?E.rawConfiguration.override(g).getValue(l):E.rawConfiguration.getValue(l))},get overrides(){const S=[];for(const{contents:D,identifiers:k,keys:P}of E.rawConfiguration.overrides){const p=new a(D,P,[],void 0,E.f).getValue(l);p!==void 0&&S.push({identifiers:k,value:p})}return S.length?w(S):void 0}}}getOverrideValue(l,g){const E=this.j(g);return E?l?(0,I.$ij)(E,l):E:void 0}getKeysForOverrideIdentifier(l){const g=[];for(const E of this.overrides)E.identifiers.includes(l)&&g.push(...E.keys);return r.$Mb(g)}getAllOverrideIdentifiers(){const l=[];for(const g of this.overrides)l.push(...g.identifiers);return r.$Mb(l)}override(l){let g=this.a.get(l);return g||(g=this.h(l),this.a.set(l,g)),g}merge(...l){const g=O.$fo(this.contents),E=O.$fo(this.overrides),S=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const k of l)if(D.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(g,k.contents);for(const P of k.overrides){const[p]=E.filter(v=>r.$ub(v.identifiers,P.identifiers));p?(this.i(p.contents,P.contents),p.keys.push(...P.keys),p.keys=r.$Mb(p.keys)):E.push(O.$fo(P))}for(const P of k.keys)S.indexOf(P)===-1&&S.push(P)}return new a(g,S,E,D.every(k=>k instanceof a)?void 0:D,this.f)}h(l){const g=this.j(l);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const E={};for(const S of r.$Mb([...Object.keys(this.contents),...Object.keys(g)])){let D=this.contents[S];const k=g[S];k&&(typeof D=="object"&&typeof k=="object"?(D=O.$fo(D),this.i(D,k)):D=k),E[S]=D}return new a(E,this.keys,this.overrides,void 0,this.f)}i(l,g){for(const E of Object.keys(g)){if(E in l&&b.$hg(l[E])&&b.$hg(g[E])){this.i(l[E],g[E]);continue}l[E]=O.$fo(g[E])}}j(l){let g=null,E=null;const S=D=>{D&&(E?this.i(E,D):E=O.$fo(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===l?g=D.contents:D.identifiers.includes(l)&&S(D.contents);return S(g),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,g){this.k(l,g,!0)}setValue(l,g){this.k(l,g,!1)}removeValue(l){const g=this.keys.indexOf(l);g!==-1&&(this.keys.splice(g,1),(0,I.$hj)(this.contents,l),y.$Ho.test(l)&&this.overrides.splice(this.overrides.findIndex(E=>r.$ub(E.identifiers,(0,y.$Io)(l))),1))}k(l,g,E){if((0,I.$gj)(this.contents,l,g,S=>this.f.error(S)),E=E||this.keys.indexOf(l)===-1,E&&this.keys.push(l),y.$Ho.test(l)){const S=(0,y.$Io)(l),D={identifiers:S,keys:Object.keys(this.contents[l]),contents:(0,I.$fj)(this.contents[l],P=>this.f.error(P))},k=this.overrides.findIndex(P=>r.$ub(P.identifiers,S));k!==-1?this.overrides[k]=D:this.overrides.push(D)}}}e.$Po=a;class m{constructor(l,g){this.f=l,this.g=g,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,g){if(!b.$og(l)){const E=this.h(l);this.parseRaw(E,g)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,g){this.a=l;const{contents:E,keys:S,overrides:D,restricted:k,hasExcludedProperties:P}=this.i(l,g);this.b=new a(E,S,D,P?[l]:void 0,this.g),this.c=k||[]}h(l){let g={},E=null,S=[];const D=[],k=[];function P(v){Array.isArray(S)?S.push(v):E!==null&&(S[E]=v)}const p={onObjectBegin:()=>{const v={};P(v),D.push(S),S=v,E=null},onObjectProperty:v=>{E=v},onObjectEnd:()=>{S=D.pop()},onArrayBegin:()=>{const v=[];P(v),D.push(S),S=v,E=null},onArrayEnd:()=>{S=D.pop()},onLiteralValue:P,onError:(v,F,N)=>{k.push({error:v,offset:F,length:N})}};if(l)try{A.$7n(l,p),g=S[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return g}i(l,g){const E=C.$so.as(y.$xo.Configuration).getConfigurationProperties(),S=this.j(l,E,!0,g);l=S.raw;const D=(0,I.$fj)(l,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`)),k=Object.keys(l),P=this.l(l,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:D,keys:k,overrides:P,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(l,g,E,S){let D=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:D};const k={},P=[];for(const p in l)if(y.$Ho.test(p)&&E){const v=this.j(l[p],g,!1,S);k[p]=v.raw,D=D||v.hasExcludedProperties,P.push(...v.restricted)}else{const v=g[p],F=v?typeof v.scope<"u"?v.scope:y.ConfigurationScope.WINDOW:void 0;v?.restricted&&P.push(p),!S.exclude?.includes(p)&&(S.include?.includes(p)||(F===void 0||S.scopes===void 0||S.scopes.includes(F))&&!(S.skipRestricted&&v?.restricted))?k[p]=l[p]:D=!0}return{raw:k,restricted:P,hasExcludedProperties:D}}l(l,g){const E=[];for(const S of Object.keys(l))if(y.$Ho.test(S)){const D={};for(const k in l[S])D[k]=l[S][k];E.push({identifiers:(0,y.$Io)(S),keys:Object.keys(D),contents:(0,I.$fj)(D,g)})}return E}}e.$Qo=m;class $ extends R.$Vc{constructor(l,g,E,S,D){super(),this.c=l,this.f=g,this.g=S,this.h=D,this.b=this.B(new h.$me),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),D),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(u.FileOperation.CREATE)||k.isOperation(u.FileOperation.COPY)||k.isOperation(u.FileOperation.DELETE)||k.isOperation(u.FileOperation.WRITE))&&E.isEqual(k.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ro=$;class f{constructor(l,g,E,S,D,k,P,p,v,F,N,L,M){this.a=l,this.b=g,this.c=E,this.overrideIdentifiers=S,this.d=D,this.f=k,this.g=P,this.h=p,this.i=v,this.j=F,this.k=N,this.l=L,this.m=M}get value(){return w(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(l,g,E,S,D,k,P,p,v,F){this.j=l,this.l=g,this.m=E,this.n=S,this.p=D,this.q=k,this.r=P,this.s=p,this.t=v,this.u=F,this.h=null,this.i=new T.$Bc,this.v=null}getValue(l,g,E){return this.w(l,g,E).getValue(l)}updateValue(l,g,E={}){let S;E.resource?(S=this.t.get(E.resource),S||(S=a.createEmptyModel(this.u),this.t.set(E.resource,S))):S=this.s,g===void 0?S.removeValue(l):S.setValue(l,g),E.resource||(this.h=null)}inspect(l,g,E){const S=this.w(l,g,E),D=this.A(g.resource,E),k=g.resource?this.t.get(g.resource)||this.s:this.s,P=new Set;for(const p of S.overrides)for(const v of p.identifiers)S.getOverrideValue(l,v)!==void 0&&P.add(v);return new f(l,g,S.getValue(l),P.size?[...P]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,D||void 0,k)}keys(l){const g=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,g){this.r.set(l,g),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,g){const E=[];if(!g){const{added:S,updated:D,removed:k}=o(this.j,l);g=[...S,...D,...k]}for(const S of g)for(const D of(0,y.$Io)(S)){const k=this.j.getKeysForOverrideIdentifier(D),P=l.getKeysForOverrideIdentifier(D),p=[...P.filter(v=>k.indexOf(v)===-1),...k.filter(v=>P.indexOf(v)===-1),...k.filter(v=>!O.$jo(this.j.override(D).getValue(v),l.override(D).getValue(v)))];E.push([D,p])}return this.updateDefaultConfiguration(l),{keys:g,overrides:E}}compareAndUpdatePolicyConfiguration(l){const{added:g,updated:E,removed:S}=o(this.l,l),D=[...g,...E,...S];return D.length&&this.updatePolicyConfiguration(l),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:g,updated:E,removed:S,overrides:D}=o(this.applicationConfiguration,l),k=[...g,...E,...S];return k.length&&this.updateApplicationConfiguration(l),{keys:k,overrides:D}}compareAndUpdateLocalUserConfiguration(l){const{added:g,updated:E,removed:S,overrides:D}=o(this.localUserConfiguration,l),k=[...g,...E,...S];return k.length&&this.updateLocalUserConfiguration(l),{keys:k,overrides:D}}compareAndUpdateRemoteUserConfiguration(l){const{added:g,updated:E,removed:S,overrides:D}=o(this.remoteUserConfiguration,l),k=[...g,...E,...S];return k.length&&this.updateRemoteUserConfiguration(l),{keys:k,overrides:D}}compareAndUpdateWorkspaceConfiguration(l){const{added:g,updated:E,removed:S,overrides:D}=o(this.workspaceConfiguration,l),k=[...g,...E,...S];return k.length&&this.updateWorkspaceConfiguration(l),{keys:k,overrides:D}}compareAndUpdateFolderConfiguration(l,g){const E=this.folderConfigurations.get(l),{added:S,updated:D,removed:k,overrides:P}=o(E,g),p=[...S,...D,...k];return(p.length||!E)&&this.updateFolderConfiguration(l,g),{keys:p,overrides:P}}compareAndDeleteFolderConfiguration(l){const g=this.folderConfigurations.get(l);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:E,updated:S,removed:D,overrides:k}=o(g,void 0);return{keys:[...E,...S,...D],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,g,E){let S=this.x(g,E);return g.overrideIdentifier&&(S=S.override(g.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(S=S.merge(this.l)),S}x({resource:l},g){let E=this.y();if(g&&l){const S=g.getFolder(l);S&&(E=this.z(S.uri)||E);const D=this.t.get(l);D&&(E=E.merge(D))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let g=this.i.get(l);if(!g){const E=this.y(),S=this.r.get(l);S?(g=E.merge(S),this.i.set(l,g)):g=E}return g}A(l,g){if(g&&l){const E=g.getFolder(l);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,g)=>{const{contents:E,overrides:S,keys:D}=this.r.get(g);return l.push([g,{contents:E,overrides:S,keys:D}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(g=>l.add(g)),this.userConfiguration.keys.forEach(g=>l.add(g)),this.q.keys.forEach(g=>l.add(g)),this.r.forEach(g=>g.keys.forEach(E=>l.add(E))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.q.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.r.forEach(g=>g.getAllOverrideIdentifiers().forEach(E=>l.add(E))),[...l.values()]}D(l){const g=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.q.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(l).forEach(S=>g.add(S))),[...g.values()]}static parse(l,g){const E=this.E(l.defaults,g),S=this.E(l.policy,g),D=this.E(l.application,g),k=this.E(l.user,g),P=this.E(l.workspace,g),p=l.folders.reduce((v,F)=>(v.set(c.URI.revive(F[0]),this.E(F[1],g)),v),new T.$Bc);return new i(E,S,D,k,a.createEmptyModel(g),P,p,a.createEmptyModel(g),new T.$Bc,g)}static E(l,g){return new a(l.contents,l.keys,l.overrides,void 0,g)}}e.$So=i;function s(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const l=new Set,g=new Map;for(const S of d)S.keys.forEach(D=>l.add(D)),S.overrides.forEach(([D,k])=>{const P=(0,T.$yc)(g,D,new Set);k.forEach(p=>P.add(p))});const E=[];return g.forEach((S,D)=>E.push([D,[...S.values()]])),{keys:[...l.values()],overrides:E}}class t{constructor(l,g,E,S,D){this.change=l,this.f=g,this.g=E,this.h=S,this.i=D,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of l.keys)this.affectedKeys.add(k);for(const[,k]of l.overrides)for(const P of k)this.affectedKeys.add(P);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,g){const E=this.a+l,S=this.d.indexOf(E);if(S<0)return!1;const D=S+E.length;if(D>=this.d.length)return!1;const k=this.d.charCodeAt(D);if(k!==this.b&&k!==this.c)return!1;if(g){const P=this.previousConfiguration?this.previousConfiguration.getValue(l,g,this.f?.workspace):void 0,p=this.g.getValue(l,g,this.h);return!O.$jo(P,p)}return!0}}e.$Uo=t;function o(d,l){const{added:g,removed:E,updated:S}=n(l?.rawConfiguration,d?.rawConfiguration),D=[],k=d?.getAllOverrideIdentifiers()||[],P=l?.getAllOverrideIdentifiers()||[];if(l){const p=P.filter(v=>!k.includes(v));for(const v of p)D.push([v,l.getKeysForOverrideIdentifier(v)])}if(d){const p=k.filter(v=>!P.includes(v));for(const v of p)D.push([v,d.getKeysForOverrideIdentifier(v)])}if(l&&d){for(const p of k)if(P.includes(p)){const v=n({contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)},{contents:l.getOverrideValue(void 0,p)||{},keys:l.getKeysForOverrideIdentifier(p)});D.push([p,[...v.added,...v.removed,...v.updated]])}}return{added:g,removed:E,updated:S,overrides:D}}function n(d,l){const g=d?l?d.keys.filter(D=>l.keys.indexOf(D)===-1):[...d.keys]:[],E=l?d?l.keys.filter(D=>d.keys.indexOf(D)===-1):[...l.keys]:[],S=[];if(d&&l){for(const D of l.keys)if(d.keys.indexOf(D)!==-1){const k=(0,I.$ij)(l.contents,D),P=(0,I.$ij)(d.contents,D);O.$jo(k,P)||S.push(D)}}return{added:g,removed:E,updated:S}}}),define(ke[233],Ie([1,0,21,4,3,68]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kxb=e.$Ixb=e.$Hxb=void 0,e.$Jxb=O;const T=(c,I,y)=>{const u=new Uint8Array(16);for(let a=0;a<16;a++)u[a]=Math.round(Math.random()*256);const C=(0,r.$9e)(r.$Oe.wrap(u));return[`GET ws://localhost${c}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`].join(`\r
`)+`\r
\r
`};e.$Hxb=T,e.$Ixb=r.$Oe.fromString(`\r
\r
`);async function O(c,I,y,u,C){c.write(r.$Oe.fromString((0,e.$Hxb)(I,y,u)));const w=new A.$Uc;try{return await new Promise((a,m)=>{let $;w.add(c.onData(f=>{$?$=r.$Oe.concat([$,f],$.byteLength+f.byteLength):$=f;const i=$.indexOf(e.$Ixb);if(i===-1)return;a(c),c.pauseData();const s=$.slice(i+e.$Ixb.byteLength);s.byteLength&&C.onData.fire(s)})),w.add(c.onClose(f=>m(f??new Error("socket closed")))),w.add(c.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw c.dispose(),a}finally{w.dispose()}}class b extends A.$Vc{constructor(I,y){super(),this.g=I,this.a=this.B(new h.$pe),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$me),this.onDidDispose=this.b.event,this.f=!1,this.B(y.onData),this.B(y.onData.event(u=>this.a.fire(u))),this.onClose=this.B(y.onClose).event,this.onEnd=this.B(y.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,y){R.SocketDiagnostics.traceSocketEvent(this,this.g,I,y)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Kxb=b}),define(ke[71],Ie([1,0,13,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.RemoteAuthorityResolverErrorCode=e.$Ul=e.$Tl=e.RemoteConnectionType=e.$Sl=void 0,e.$Wl=c,e.$Sl=(0,h.$Gi)("remoteAuthorityResolverService");var A;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class R{constructor(y){this.id=y,this.type=A.Managed}toString(){return`Managed(${this.id})`}}e.$Tl=R;class T{constructor(y,u){this.host=y,this.port=u,this.type=A.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ul=T;var O;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class b extends r.$bb{static isNotAvailable(y){return y instanceof b&&y._code===O.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof b&&y._code===O.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof b&&y._code===O.NoResolverFound}static isInvalidAuthority(y){return y instanceof b&&y._code===O.InvalidAuthority}static isHandled(y){return y instanceof b&&y.isHandled}constructor(y,u=O.Unknown,C){super(y),this._message=y,this._code=u,this._detail=C,this.isHandled=u===O.NotAvailable&&C===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Vl=b;function c(I){const y=I.indexOf("+");return y===-1?I:I.substring(0,y)}}),define(ke[234],Ie([1,0,7,21,20,13,4,3,14,61,42,32,68,71]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$2l=D,e.$3l=k,e.$4l=p,c=We(c);const w=30*1e3;var a;(function(ge){ge[ge.Management=1]="Management",ge[ge.ExtensionHost=2]="ExtensionHost",ge[ge.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(ge){switch(ge){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function $(ge){const Y=new A.$xe;return setTimeout(()=>Y.cancel(),ge),Y.token}function f(ge,Y){if(ge.isCancellationRequested||Y.isCancellationRequested)return A.CancellationToken.Cancelled;const U=new A.$xe;return ge.onCancellationRequested(()=>U.cancel()),Y.onCancellationRequested(()=>U.cancel()),U.token}class i{get didTimeout(){return this.c==="timedout"}constructor(Y){this.c="pending",this.d=new O.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$zh)(),Y.isCancellationRequested?this.h():this.d.add(Y.onCancellationRequested(()=>this.h()))}registerDisposable(Y){this.c==="pending"?this.d.add(Y):Y.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Y=new Error("Time limit reached");return Y.code="ETIMEDOUT",Y.syscall="connect",Y}resolve(Y){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Y))}reject(Y){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Y))}}function s(ge,Y){const U=new i(Y);return U.registerDisposable(ge.onControlMessage(oe=>{const ve=JSON.parse(oe.toString()),te=W(ve);te?U.reject(te):U.resolve(ve)})),U.promise}function t(ge,Y,U,oe,ve,te,ae,se){const Z=new i(se),re=I.$ge.create(!1);return ge.info(`Creating a socket (${ae})...`),c.mark(`code/willCreateSocket/${te}`),Y.connect(U,oe,ve,ae).then(pe=>{Z.didTimeout?(c.mark(`code/didCreateSocketError/${te}`),ge.info(`Creating a socket (${ae}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(c.mark(`code/didCreateSocketOK/${te}`),ge.info(`Creating a socket (${ae}) was successful after ${re.elapsed()} ms.`),Z.resolve(pe))},pe=>{c.mark(`code/didCreateSocketError/${te}`),ge.info(`Creating a socket (${ae}) returned an error after ${re.elapsed()} ms.`),ge.error(pe),Z.reject(pe)}),Z.promise}function o(ge,Y){const U=new i(Y);return ge.then(oe=>{U.didTimeout||U.resolve(oe)},oe=>{U.didTimeout||U.reject(oe)}),U.promise}async function n(ge,Y,U,oe){const ve=ne(ge,Y);ge.logService.trace(`${ve} 1/6. invoking socketFactory.connect().`);let te;try{te=await t(ge.logService,ge.remoteSocketFactoryService,ge.connectTo,b.$Tg.getServerRootPath(),`reconnectionToken=${ge.reconnectionToken}&reconnection=${ge.reconnectionProtocol?"true":"false"}`,m(Y),`renderer-${m(Y)}-${ge.reconnectionToken}`,oe)}catch(pe){throw ge.logService.error(`${ve} socketFactory.connect() failed or timed out. Error:`),ge.logService.error(pe),pe}ge.logService.trace(`${ve} 2/6. socketFactory.connect() was successful.`);let ae,se;ge.reconnectionProtocol?(ge.reconnectionProtocol.beginAcceptReconnection(te,null),ae=ge.reconnectionProtocol,se=!1):(ae=new u.$ui({socket:te}),se=!0),ge.logService.trace(`${ve} 3/6. sending AuthRequest control message.`);const Z=await o(ge.signService.createNewMessage((0,y.$3g)()),oe),re={type:"auth",auth:ge.connectionToken||"00000000000000000000",data:Z.data};ae.sendControl(h.$Oe.fromString(JSON.stringify(re)));try{const pe=await s(ae,f(oe,$(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if(ge.logService.trace(`${ve} 4/6. received SignRequest control message.`),!await o(ge.signService.validate(Z,pe.signedData),oe)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const Fe=await o(ge.signService.sign(pe.data),oe),ze={type:"connectionType",commit:ge.commit,signedData:Fe,desiredConnectionType:Y};return U&&(ze.args=U),ge.logService.trace(`${ve} 5/6. sending ConnectionTypeRequest control message.`),ae.sendControl(h.$Oe.fromString(JSON.stringify(ze))),{protocol:ae,ownsProtocol:se}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(ge.logService.error(`${ve} the handshake timed out. Error:`),ge.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(ge.logService.error(`${ve} received error control message when negotiating connection. Error:`),ge.logService.error(pe)),se&&H(ae),pe}}async function d(ge,Y,U,oe){const ve=Date.now(),te=ne(ge,Y),{protocol:ae,ownsProtocol:se}=await n(ge,Y,U,oe),Z=new i(oe);return Z.registerDisposable(ae.onControlMessage(re=>{const pe=JSON.parse(re.toString()),we=W(pe);we?(ge.logService.error(`${te} received error control message when negotiating connection. Error:`),ge.logService.error(we),se&&H(ae),Z.reject(we)):(ge.reconnectionProtocol?.endAcceptReconnection(),ge.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${ye(ve)}!`),Z.resolve({protocol:ae,firstMessage:pe}))})),Z.promise}async function l(ge,Y){const{protocol:U}=await d(ge,a.Management,void 0,Y);return{protocol:U}}async function g(ge,Y,U){const{protocol:oe,firstMessage:ve}=await d(ge,a.ExtensionHost,Y,U),te=ve&&ve.debugPort;return{protocol:oe,debugPort:te}}async function E(ge,Y,U){const oe=Date.now(),ve=ne(ge,a.Tunnel),{protocol:te}=await n(ge,a.Tunnel,Y,U);return ge.logService.trace(`${ve} 6/6. handshake finished, connection is up and running after ${ye(oe)}!`),te}async function S(ge,Y,U){const{connectTo:oe,connectionToken:ve}=await ge.addressProvider.getAddress();return{commit:ge.commit,quality:ge.quality,connectTo:oe,connectionToken:ve,reconnectionToken:Y,reconnectionProtocol:U,remoteSocketFactoryService:ge.remoteSocketFactoryService,signService:ge.signService,logService:ge.logService}}async function D(ge,Y,U){return P(ge,async oe=>{const{protocol:ve}=await l(oe,A.CancellationToken.None);return new B(ge,Y,U,oe.reconnectionToken,ve)})}async function k(ge,Y){return P(ge,async U=>{const{protocol:oe,debugPort:ve}=await g(U,Y,A.CancellationToken.None);return new ee(ge,Y,U.reconnectionToken,oe,ve)})}async function P(ge,Y){for(let oe=1;;oe++)try{const ve=(0,y.$3g)(),te=await S(ge,ve,null);return await Y(te)}catch(ve){if(oe<5)ge.logService.error(`[remote-connection][attempt ${oe}] An error occurred in initial connection! Will retry... Error:`),ge.logService.error(ve);else throw ge.logService.error(`[remote-connection][attempt ${oe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ge.logService.error(ve),q.triggerPermanentFailure(0,0,C.$Vl.isHandled(ve)),ve}}async function p(ge,Y,U){const oe=await S(ge,(0,y.$3g)(),null);return await E(oe,{host:Y,port:U},A.CancellationToken.None)}function v(ge){return(0,r.$th)(Y=>new Promise((U,oe)=>{const ve=setTimeout(U,ge*1e3);Y.onCancellationRequested(()=>{clearTimeout(ve),U()})}))}var F;(function(ge){ge[ge.ConnectionLost=0]="ConnectionLost",ge[ge.ReconnectionWait=1]="ReconnectionWait",ge[ge.ReconnectionRunning=2]="ReconnectionRunning",ge[ge.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ge[ge.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class N{constructor(Y,U){this.reconnectionToken=Y,this.millisSinceLastIncomingData=U,this.type=F.ConnectionLost}}e.$5l=N;class L{constructor(Y,U,oe,ve){this.reconnectionToken=Y,this.millisSinceLastIncomingData=U,this.durationSeconds=oe,this.c=ve,this.type=F.ReconnectionWait}skipWait(){this.c.cancel()}}e.$6l=L;class M{constructor(Y,U,oe){this.reconnectionToken=Y,this.millisSinceLastIncomingData=U,this.attempt=oe,this.type=F.ReconnectionRunning}}e.$7l=M;class z{constructor(Y,U,oe){this.reconnectionToken=Y,this.millisSinceLastIncomingData=U,this.attempt=oe,this.type=F.ConnectionGain}}e.$8l=z;class j{constructor(Y,U,oe,ve){this.reconnectionToken=Y,this.millisSinceLastIncomingData=U,this.attempt=oe,this.handled=ve,this.type=F.ReconnectionPermanentFailure}}e.$9l=j;class q extends O.$Vc{static triggerPermanentFailure(Y,U,oe){this._permanentFailure=!0,this.f=Y,this.g=U,this.h=oe,this.j.forEach(ve=>ve.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Y=>Y.y())}static debugPauseSocketWriting(){this.j.forEach(Y=>Y.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||q._permanentFailure}constructor(Y,U,oe,ve,te){super(),this.t=Y,this.u=U,this.reconnectionToken=oe,this.protocol=ve,this.w=te,this.m=this.B(new T.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(ve.onSocketClose(ae=>{const se=ce(this.t,this.reconnectionToken,!0);ae?ae.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${se} received socket close event (hadError: ${ae.hadError}).`),ae.error&&this.u.logService.error(ae.error)):(this.u.logService.info(`${se} received socket close event (wasClean: ${ae.wasClean}, code: ${ae.code}, reason: ${ae.reason}).`),ae.event&&this.u.logService.error(ae.event)):this.u.logService.info(`${se} received socket close event.`),this.y()})),this.B(ve.onSocketTimeout(ae=>{const se=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${ae.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ae.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ae.timeSinceLastReceivedSomeData}).`),this.y()})),q.j.push(this),this.B((0,O.$Tc)(()=>{const ae=q.j.indexOf(this);ae>=0&&q.j.splice(ae,1)})),this.n&&this.D(q.f,q.g,q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Y=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Y} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let oe=-1;do{oe++;const ve=oe<U.length?U[oe]:U[U.length-1];try{if(ve>0){const ae=v(ve);this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ve,ae)),this.u.logService.info(`${Y} waiting for ${ve} seconds before reconnecting...`);try{await ae}catch{}}if(this.n){this.u.logService.error(`${Y} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe+1)),this.u.logService.info(`${Y} resolving connection...`);const te=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Y} connecting to ${te.connectTo}...`),await this.G(te,$(w)),this.u.logService.info(`${Y} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Y} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}if(oe>360){this.u.logService.error(`${Y} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}if(C.$Vl.isTemporarilyNotAvailable(te)){this.u.logService.info(`${Y} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this.u.logService.info(`${Y} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((0,R.$4)(te)){this.u.logService.info(`${Y} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if(te instanceof C.$Vl){this.u.logService.error(`${Y} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,C.$Vl.isHandled(te));break}this.u.logService.error(`${Y} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),oe+1,!1);break}}while(!this.n&&!this.s)}C(Y,U,oe){this.w?q.triggerPermanentFailure(Y,U,oe):this.D(Y,U,oe)}D(Y,U,oe){this.m.fire(new j(this.reconnectionToken,Y,U,oe)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$0l=q;class B extends q{constructor(Y,U,oe,ve,te){super(a.Management,Y,ve,te,!0),this.client=this.B(new u.$si(te,{remoteAuthority:U,clientId:oe},Y.ipcLogger))}async G(Y,U){await l(Y,U)}}e.$$l=B;class ee extends q{constructor(Y,U,oe,ve,te){super(a.ExtensionHost,Y,oe,ve,!1),this.H=U,this.debugPort=te}async G(Y,U){await g(Y,this.H,U)}}e.$_l=ee;function H(ge){try{ge.acceptDisconnect();const Y=ge.getSocket();ge.dispose(),Y.dispose()}catch(Y){(0,R.$Z)(Y)}}function W(ge){if(ge&&ge.type==="error"){const Y=new Error(`Connection error: ${ge.reason}`);return Y.code="VSCODE_CONNECTION_ERROR",Y}return null}function X(ge,Y){for(;ge.length<Y;)ge+=" ";return ge}function _(ge,Y){return`[remote-connection][${X(m(ge),13)}][${Y.substr(0,5)}\u2026]`}function ce(ge,Y,U){return`${_(ge,Y)}[${U?"reconnect":"initial"}]`}function ne(ge,Y){return`${ce(Y,ge.reconnectionToken,!!ge.reconnectionProtocol)}[${ge.connectTo}]`}function ye(ge){return`${Date.now()-ge} ms`}}),define(ke[90],Ie([1,0,14]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=h,e.$jn=A,e.$kn=R,e.$ln=T;function h(b){return b.scheme===r.Schemas.vscodeRemote?b.authority:void 0}function A(b){if(!b)return;const c=b.indexOf("+");return c<0?b:b.substr(0,c)}function R(b){const{host:c,port:I}=O(b);if(typeof I>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:I}}function T(b,c){let{host:I,port:y}=O(b);return typeof y>"u"&&(y=c),{host:I,port:y}}function O(b){const c=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const I=b.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const y=b.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:b,port:void 0}}}),define(ke[23],Ie([1,0,12,5,90]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$un=e.$tn=e.$sn=e.TargetPlatform=e.ExtensionType=e.$rn=e.$pn=e.$on=e.$nn=e.$mn=void 0,e.$qn=R,e.$vn=y,e.$wn=u,e.$xn=C,e.$yn=w,e.$zn=a,e.$An=m,r=We(r),e.$mn="extensions.user.cache",e.$nn="extensions.builtin.cache",e.$on="undefined_publisher",e.$pn=["ui","workspace","web"];function R($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$rn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function($){$[$.System=0]="System",$[$.User=1]="User"})(T||(e.ExtensionType=T={}));var O;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class b{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,i){if(typeof f>"u"||f===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof f=="string"||typeof i=="string"){const s=typeof f=="string"?f:f.value,t=typeof i=="string"?i:i.value;return r.$Gf(s,t)}return f._lower===i._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$sn=b;class c{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const i of f)this.add(i)}add(f){this.c.add(b.toKey(f))}delete(f){return this.c.delete(b.toKey(f))}has(f){return this.c.has(b.toKey(f))}}e.$tn=c;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(b.toKey(f))}get(f){return this.c.get(b.toKey(f))}has(f){return this.c.has(b.toKey(f))}set(f,i){this.c.set(b.toKey(f),i)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$un=I;function y($){return u($)}function u($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}function C($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}function w($,f){if(f){const i=`onResolveRemoteAuthority:${(0,A.$jn)(f)}`;return!!$.activationEvents?.includes(i)}return!1}function a($){return $.map(f=>{const[i,s]=f.split("@");return{proposalName:i,version:s?parseInt(s):void 0}})}function m($){return $.map(f=>f.split("@")[0])}e.$Bn=(0,h.$Gi)("IBuiltinExtensionsScannerService")}),define(ke[147],Ie([1,0,10,8,23,5]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.ExtensionManagementErrorCode=e.$np=e.ExtensionGalleryErrorCode=e.$mp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=O,e.$hp=b,e.$ip=c,e.$jp=I,e.$kp=y,e.$lp=u,e.$_o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ap=new RegExp(e.$_o),e.$bp="__web_extension",e.$cp="skipWalkthrough",e.$dp="extensionInstallSource",e.$ep="dependecyOrPackExtensionInstall",e.$fp="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function O(t){switch(t){case A.TargetPlatform.WIN32_X64:return"Windows 64 bit";case A.TargetPlatform.WIN32_ARM64:return"Windows ARM";case A.TargetPlatform.LINUX_X64:return"Linux 64 bit";case A.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case A.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case A.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case A.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case A.TargetPlatform.DARWIN_X64:return"Mac";case A.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case A.TargetPlatform.WEB:return"Web";case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;case A.TargetPlatform.UNKNOWN:return A.TargetPlatform.UNKNOWN;case A.TargetPlatform.UNDEFINED:return A.TargetPlatform.UNDEFINED}}function b(t){switch(t){case A.TargetPlatform.WIN32_X64:return A.TargetPlatform.WIN32_X64;case A.TargetPlatform.WIN32_ARM64:return A.TargetPlatform.WIN32_ARM64;case A.TargetPlatform.LINUX_X64:return A.TargetPlatform.LINUX_X64;case A.TargetPlatform.LINUX_ARM64:return A.TargetPlatform.LINUX_ARM64;case A.TargetPlatform.LINUX_ARMHF:return A.TargetPlatform.LINUX_ARMHF;case A.TargetPlatform.ALPINE_X64:return A.TargetPlatform.ALPINE_X64;case A.TargetPlatform.ALPINE_ARM64:return A.TargetPlatform.ALPINE_ARM64;case A.TargetPlatform.DARWIN_X64:return A.TargetPlatform.DARWIN_X64;case A.TargetPlatform.DARWIN_ARM64:return A.TargetPlatform.DARWIN_ARM64;case A.TargetPlatform.WEB:return A.TargetPlatform.WEB;case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;default:return A.TargetPlatform.UNKNOWN}}function c(t,o){switch(t){case r.Platform.Windows:return o==="x64"?A.TargetPlatform.WIN32_X64:o==="arm64"?A.TargetPlatform.WIN32_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Linux:return o==="x64"?A.TargetPlatform.LINUX_X64:o==="arm64"?A.TargetPlatform.LINUX_ARM64:o==="arm"?A.TargetPlatform.LINUX_ARMHF:A.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?A.TargetPlatform.ALPINE_X64:o==="arm64"?A.TargetPlatform.ALPINE_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Mac:return o==="x64"?A.TargetPlatform.DARWIN_X64:o==="arm64"?A.TargetPlatform.DARWIN_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Web:return A.TargetPlatform.WEB}}function I(t,o){return o===A.TargetPlatform.WEB&&!t.includes(A.TargetPlatform.WEB)}function y(t,o,n){return I(o,n)?!1:t===A.TargetPlatform.UNDEFINED||t===A.TargetPlatform.UNIVERSAL?!0:t===A.TargetPlatform.UNKNOWN?!1:t===n}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var C;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var w;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var a;(function(t){t.Install="install",t.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$mp=(0,R.$Gi)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})($||(e.ExtensionGalleryErrorCode=$={}));class f extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.$np=f;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class s extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.$op=s,e.$pp=(0,R.$Gi)("extensionManagementService"),e.$qp="extensionsIdentifiers/disabled",e.$rp="extensionsIdentifiers/enabled",e.$sp=(0,R.$Gi)("IGlobalExtensionEnablementService"),e.$tp=(0,R.$Gi)("IExtensionTipsService"),e.$up=(0,h.localize2)(1771,"Extensions"),e.$vp=(0,h.localize2)(1772,"Preferences")}),define(ke[148],Ie([1,0,13,23]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2G=e.$1G=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(T,O){this.a.set(T,O)}readActivationEvents(T){return this.b.has(T)||this.b.set(T,this.c(T)),this.b.get(T)}createActivationEventsMap(T){const O=Object.create(null);for(const b of T){const c=this.readActivationEvents(b);c.length>0&&(O[h.$sn.toKey(b.identifier)]=c)}return O}c(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const O=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let b=0;b<O.length;b++)O[b]==="onUri"&&(O[b]=`onUri:${h.$sn.toKey(T.identifier)}`);if(!T.contributes)return O;for(const b in T.contributes){const c=this.a.get(b);if(!c)continue;const I=T.contributes[b],y=Array.isArray(I)?I:[I];try{c(y,O)}catch(u){(0,r.$Z)(u)}}return O}}e.$1G=A,e.$2G=new A});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[235],Ie([1,0,22,43,8,361,23,144]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=I,e.$2p=y,e.$3p=u,e.$4p=C,e.$5p=w,e.$6p=a,e.$7p=m,e.$8p=$,h=Ut(h),A=We(A),R=We(R);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function I(s){return s=s.trim(),s==="*"||b.test(s)}function y(s){if(!I(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=s.match(b);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(s){if(!s)return null;const t=s.majorBase,o=s.majorMustEqual,n=s.minorBase;let d=s.minorMustEqual;const l=s.patchBase;let g=s.patchMustEqual;s.hasCaret&&(t===0||(d=!1),g=!1);let E=0;if(s.preRelease){const S=c.exec(s.preRelease);if(S){const[,D,k,P]=S;E=Date.UTC(Number(D),Number(k)-1,Number(P))}}return{majorBase:t,majorMustEqual:o,minorBase:n,minorMustEqual:d,patchBase:l,patchMustEqual:g,isMinimum:s.hasGreaterEquals,notBefore:E}}function C(s,t,o){let n;typeof s=="string"?n=u(y(s)):n=s;let d;t instanceof Date?d=t.getTime():typeof t=="string"&&(d=new Date(t).getTime());let l;if(typeof o=="string"?l=u(y(o)):l=o,!n||!l)return!1;const g=n.majorBase,E=n.minorBase,S=n.patchBase;let D=l.majorBase,k=l.minorBase,P=l.patchBase;const p=l.notBefore;let v=l.majorMustEqual,F=l.minorMustEqual,N=l.patchMustEqual;return l.isMinimum?g>D?!0:g<D?!1:E>k?!0:E<k||d&&d<p?!1:S>=P:(g===1&&D===0&&(!v||!F||!N)&&(D=1,k=0,P=0,v=!0,F=!1,N=!1),g<D?!1:g>D?!v:E<k?!1:E>k?!F:S<P?!1:S>P?!N:!(d&&d<p))}function w(s,t,o,n,d,l){const g=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return g.push([h.default.Error,A.localize(1823,null)]),g;if(typeof n.name!="string")return g.push([h.default.Error,A.localize(1824,null,"name")]),g;if(typeof n.version!="string")return g.push([h.default.Error,A.localize(1825,null,"version")]),g;if(!n.engines)return g.push([h.default.Error,A.localize(1826,null,"engines")]),g;if(typeof n.engines.vscode!="string")return g.push([h.default.Error,A.localize(1827,null,"engines.vscode")]),g;if(typeof n.extensionDependencies<"u"&&!i(n.extensionDependencies))return g.push([h.default.Error,A.localize(1828,null,"extensionDependencies")]),g;if(typeof n.activationEvents<"u"){if(!i(n.activationEvents))return g.push([h.default.Error,A.localize(1829,null,"activationEvents")]),g;if(typeof n.main>"u"&&typeof n.browser>"u")return g.push([h.default.Error,A.localize(1830,null,"activationEvents","main","browser")]),g}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&g.push([h.default.Warning,A.localize(1831,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return g.push([h.default.Error,A.localize(1832,null,"main")]),g;{const D=(0,r.$hh)(o,n.main);(0,r.$bh)(D,o)||g.push([h.default.Warning,A.localize(1833,null,D.path,o.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return g.push([h.default.Error,A.localize(1834,null,"browser")]),g;{const D=(0,r.$hh)(o,n.browser);(0,r.$bh)(D,o)||g.push([h.default.Warning,A.localize(1835,null,D.path,o.path)])}}if(!R.valid(n.version))return g.push([h.default.Error,A.localize(1836,null)]),g;const E=[];if(!a(s,t,n,d,E))for(const D of E)g.push([h.default.Error,D]);if(l&&n.enabledApiProposals?.length){const D=[];if(!$([...n.enabledApiProposals],D))for(const k of D)g.push([h.default.Error,k])}return g}function a(s,t,o,n,d){return n||typeof o.main>"u"&&typeof o.browser>"u"?!0:f(s,t,o.engines.vscode,d)}function m(s,t,o){return s==="*"||f(t,o,s)}function $(s,t){if(s.length===0)return!0;const o=Array.isArray(t)?t:void 0,n=(o?void 0:t)??O.allApiProposals,d=[],l=(0,T.$zn)(s);for(const{proposalName:g,version:E}of l){const S=n[g];S&&E&&S.version!==E&&d.push(A.localize(1837,null,g))}return o?.push(...d),d.length===0}function f(s,t,o,n=[]){const d=u(y(o));if(!d)return n.push(A.localize(1838,null,o)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return n.push(A.localize(1839,null,o)),!1}else if(!d.majorMustEqual)return n.push(A.localize(1840,null,o)),!1;return C(s,t,d)?!0:(n.push(A.localize(1841,null,s,o)),!1)}function i(s){if(!Array.isArray(s))return!1;for(let t=0,o=s.length;t<o;t++)if(typeof s[t]!="string")return!1;return!0}}),define(ke[236],Ie([1,0,3,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl=(0,h.$Gi)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(T,O){return this.a[T]??=[],this.a[T].push(O),(0,r.$Tc)(()=>{const b=this.a[T]?.indexOf(O);typeof b=="number"&&b>=0&&this.a[T]?.splice(b,1)})}b(T){return(this.a[T.type]||[]).find(b=>b.supports(T))}connect(T,O,b,c){const I=this.b(T);if(!I)throw new Error(`No socket factory found for ${T}`);return I.connect(T,O,b,c)}}e.$Yl=A}),define(ke[237],Ie([1,0,21,13,3,8,70,5,11,36]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0,e.$$p=u,e.$_p=C,e.$aq=w,e.$bq=a,e.$cq=m,e.$dq=$,e.$9p=(0,O.$Gi)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class y extends A.$Vc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,R.localize)(2041,null),when:b.$tk.isEqualTo((0,b.$qk)(b.LogLevel.Trace)).serialize()})}async c(t,o,n){const d=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${d} - begin`,o.type,new I(o.headers??{}));try{const l=await n();return this.a.trace(`${d} - end`,o.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${d} - error`,o.type,(0,h.$0)(l)),l}}}e.$0p=y;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function C(s){return s.res.statusCode===204}async function w(s){return C(s)?null:(await(0,r.$1e)(s.stream)).toString()}async function a(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return w(s)}async function m(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(C(s))return null;const o=(await(0,r.$1e)(s.stream)).toString();try{return JSON.parse(o)}catch(n){throw n.message+=`:
`+o,n}}function $(s){i(s)}let f;function i(s){const t=c.$so.as(T.$xo.Configuration),o=f;f={id:"http",order:15,title:(0,R.localize)(2042,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2043,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2044,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(2045,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(2046,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(2047,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(2048,null),(0,R.localize)(2049,null),(0,R.localize)(2050,null),(0,R.localize)(2051,null)],default:"override",description:(0,R.localize)(2052,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(2053,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(2054,null),restricted:!0}}},t.updateConfigurations({add:[f],remove:o?[o]:[]})}i(T.ConfigurationScope.APPLICATION)}),define(ke[238],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const R=await this.c();if(R){const T=String(r.a++);return this.b.set(T,R),{id:T,data:R.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,R){if(!A.id)return!0;const T=this.b.get(A.id);if(!T)return!1;this.b.delete(A.id);try{return T.validate(R)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$Xcc=r}),define(ke[117],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=void 0,e.$Zl="signService",e.$1l=(0,r.$Gi)(e.$Zl)}),define(ke[149],Ie([1,0,238]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class h extends r.$Xcc{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(T=>new T.signer().sign(R))}h(){return new Promise((R,T)=>$e(["vsda"],R,T))}}e.$6hc=h}),define(ke[239],Ie([1,0,10,55,32]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=T,e.$xp=O;function R(b){if(r.$v===r.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function T(b,c,I,y,u,C,w,a,m,$){const f=Object.create(null);f["common.machineId"]=C,f["common.sqmId"]=w,f["common.devDeviceId"]=a,f.sessionID=(0,A.$3g)()+Date.now(),f.commitHash=y,f.version=u,f["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,r.$i)(r.$v),f["common.nodePlatform"]=h.$ec,f["common.nodeArch"]=I,f["common.product"]=$||"desktop",m&&(f["common.msftInternal"]=m);let i=0;const s=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),r.$m&&(f["common.snap"]="true");const t=R(c);return t&&(f["common.platformDetail"]=t),f}function O(b){const c=h.env.USERDNSDOMAIN;if(!c)return!1;const I=c.toLowerCase();return b.some(y=>I===y)}}),define(ke[150],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am=(0,r.$Gi)("telemetryService"),e.$bm=(0,r.$Gi)("customEndpointTelemetryService"),e.$cm="telemetry.currentSessionDate",e.$dm="telemetry.firstSessionDate",e.$em="telemetry.lastSessionDate",e.$fm="telemetry.machineId",e.$gm="telemetry.sqmId",e.$hm="telemetry.devDeviceId",e.$im="telemetry",e.$jm="telemetry.telemetryLevel",e.$km="telemetry.enableCrashReporter",e.$lm="telemetry.enableTelemetry";var h;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var A;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(ke[91],Ie([1,0,24,17,90,239,150]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=void 0,e.$Fp=I,e.$Gp=y,e.$Hp=u,e.$Ip=C,e.$Jp=a,e.$Kp=$,e.$Lp=f,e.$Mp=t;class O{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$yp=O;class b{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$zp=b,e.$Ap=new b;class c{async publicLog(n,d,l){}async publicLogError(n,d,l){}}e.$Bp=c,e.$Cp="telemetry",e.$Dp="extensionTelemetryLog",e.$Ep={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!o.enableTelemetry)}function y(o,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const n=o.getValue(T.$jm),d=o.getValue(T.$km);if(o.getValue(T.$lm)===!1||d===!1)return T.TelemetryLevel.NONE;switch(n??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function C(o){const n={},d={},l={};m(o,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const E=l[g];typeof E=="number"?d[g]=E:typeof E=="boolean"?d[g]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${E.length}`),n[g]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(n[g]=E)}return{properties:n,measurements:d}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(o){if(!o)return"none";const n=(0,A.$jn)(o);return w.has(n)?n:"other"}function m(o,n,d=0,l){if(o)for(const g of Object.getOwnPropertyNames(o)){const E=o[g],S=l?l+g:g;Array.isArray(E)?n[S]=(0,r.$ko)(E):E instanceof Date?n[S]=E.toISOString():(0,h.$hg)(E)?d<2?m(E,n,d+1,S+"."):n[S]=(0,r.$ko)(E):n[S]=E}}function $(o,n){const d=o.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,R.$xp)(d)||l}function f(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,n){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const l=[];for(const D of n)for(;;){const k=D.exec(o);if(!k)break;l.push([k.index,D.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(d="";;){const D=E.exec(o);if(!D)break;const k=l.some(([P,p])=>D.index<p&&P<E.lastIndex);!g.test(D[0])&&!k&&(d+=o.substring(S,D.index)+"<REDACTED: user-file-path>",S=E.lastIndex)}return S<o.length&&(d+=o.substr(S)),d}function s(o){if(!o)return o;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of n)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function t(o,n){return(0,r.$ho)(o,d=>{if(d instanceof O||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,n);for(const g of n)l=l.replace(g,"");return l=s(l),l}})}}),define(ke[240],Ie([1,0,12,147,23,10,2,13,55,91]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Op=void 0,e.$Np=I,e.$Pp=w,e.$Qp=a,e.$Rp=m,e.$Sp=$,e.$Tp=f,e.$Up=i,e.$Vp=s,e.$Xp=t,e.$Yp=n;function I(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,r.$Bf)(d.id,l.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const g=l.manifest?l.manifest.version:l.version,E=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,g,E)}static parse(l){const g=y.exec(l);return g&&g[1]&&g[2]?new u({id:g[1]},g[2],g[4]||void 0):null}constructor(l,g,E=A.TargetPlatform.UNDEFINED){this.identifier=l,this.version=g,this.targetPlatform=E,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==A.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?I(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Op=u;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(d){const l=C.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function a(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function $(d,l){return m(a(d??A.$on,l))}function f(d,l){const g=[],E=S=>{for(const D of g)if(D.some(k=>I(l(k),l(S))))return D;return null};for(const S of d){const D=E(S);D?D.push(S):g.push([S])}return g}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function s(d){return{id:new c.$yp(d.identifier.id),name:new c.$yp(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Wp=new A.$sn("pprice.better-merge");function t(d,l){const g=[],E=l.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const S=E.shift();if(S&&g.every(D=>!I(D.identifier,{id:S}))){const D=d.filter(k=>I(k.identifier,{id:S}));D.length===1&&(g.push(D[0]),E.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}async function o(d,l){if(!R.$l)return!1;let g;try{g=(await d.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await d.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){l.debug("Error while getting the os-release file.",(0,O.$0)(S))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(d,l){const g=await o(d,l),E=(0,h.$ip)(g?"alpine":R.$v,b.$fc);return l.debug("ComputeTargetPlatform:",E),E}}),define(ke[241],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=r,e.$Hs=h,e.$Is=A,e.$Js=R,e.$Ks=T,e.$Ls=O;function r(b){return[...b.entries()]}function h(b){return b?[...b.entries()]:[]}function A(b){return new Map(b)}function R(b){return new Map(b??[])}function T(b){return Array.from(b.entries()).map(c=>[c[0],r(c[1].map),h(c[1].descriptionMap)])}function O(b){return new Map(b.map(c=>[c[0],{map:A(c[1]),descriptionMap:R(c[2])}]))}}),define(ke[242],Ie([1,0,5,35,36]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=e.$ss=e.$rs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$qs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ps=void 0,e.$ps=new h.$Xj("terminalTabFocusMode",!1,!0);var R;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var T;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var O;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(O||(e.PosixShellType=O={}));var b;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(b||(e.WindowsShellType=b={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$qs=(0,r.$Gi)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var C;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(C||(e.TerminalLocation=C={}));var w;(function(t){t.TerminalView="view",t.Editor="editor"})(w||(e.TerminalLocationString=w={}));var a;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var $;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var f;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$rs={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(o){const n=this.b(o.remoteAuthority);if(this.a.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this.a.set(n,o)}getTerminalBackend(o){return this.a.get(this.b(o))}b(o){return o?.toLowerCase()??""}}A.$so.add(e.$rs.Backend,new s),e.$ss=(0,r.$Gi)("localPtyService"),e.$ts=(0,r.$Gi)("terminalLogService")}),define(ke[243],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3xb=void 0;class r{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,R,T=5){const O=R(b=>{const c=typeof b=="string"?b:b.data;let I=this.a.get(A);if(I){I.data.push(c);return}const y=setTimeout(()=>this.flushBuffer(A),T);I={data:[c],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(A),O.dispose()}},this.a.set(A,I)});return O}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const R=this.a.get(A);R&&(this.a.delete(A),this.b(A,R.data.join("")))}}e.$3xb=r}),define(ke[244],Ie([1,0,7,82,106,51,4,17,2,8,116,36]),function($e,e,r,h,A,R,T,O,b,c,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kx=e.$Jx=e.$Ix=e.$Hx=e.$Gx=e.$Fx=e.IconFontDefinition=e.IconContribution=e.$Cx=void 0,e.$Dx=m,e.$Ex=$,y=We(y),e.$Cx={IconContribution:"base.contributions.icons"};var u;(function(t){function o(n,d){let l=n.defaults;for(;R.ThemeIcon.isThemeIcon(l);){const g=a.getIcon(l.id);if(!g)return;l=g.defaults}return l}t.getDefinition=o})(u||(e.IconContribution=u={}));var C;(function(t){function o(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}t.toJSONObject=o;function n(d){const l=g=>(0,O.$fg)(g)?g:void 0;if(d&&Array.isArray(d.src)&&d.src.every(g=>(0,O.$fg)(g.format)&&(0,O.$fg)(g.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(g=>({format:g.format,location:b.URI.parse(g.location)}))}}t.fromJSONObject=n})(C||(e.IconFontDefinition=C={}));class w{constructor(){this.a=new T.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(2351,null)},fontCharacter:{type:"string",description:(0,c.localize)(2352,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,n,d,l){const g=this.b[o];if(g){if(d&&!g.description){g.description=d,this.d.properties[o].markdownDescription=`${d} $(${o})`;const D=this.e.enum.indexOf(o);D!==-1&&(this.e.enumDescriptions[D]=d),this.a.fire()}return g}const E={id:o,description:d,defaults:n,deprecationMessage:l};this.b[o]=E;const S={$ref:"#/definitions/icons"};return l&&(S.deprecationMessage=l),d&&(S.markdownDescription=`${d}: $(${o})`),this.d.properties[o]=S,this.e.enum.push(o),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const n=this.e.enum.indexOf(o);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,n){const d=this.f[o];return d||(this.f[o]=n,this.a.fire(),n)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(g,E)=>g.id.localeCompare(E.id),n=g=>{for(;R.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(g=>this.b[g]);for(const g of l.filter(E=>!!E.description).sort(o))d.push(`|<i class="${n(g)}"></i>|${g.id}|${R.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const g of l.filter(E=>!R.ThemeIcon.isThemeIcon(E.defaults)).sort(o))d.push(`|<i class="${n(g)}"></i>|${g.id}|`);return d.join(`
`)}}const a=new w;y.$so.add(e.$Cx.IconContribution,a);function m(t,o,n,d){return a.registerIcon(t,o,n,d)}function $(){return a}function f(){const t=(0,A.$2j)();for(const o in t){const n="\\"+t[o].toString(16);a.registerIcon(o,{fontCharacter:n})}}f(),e.$Fx="vscode://schemas/icons";const i=y.$so.as(I.$to.JSONContribution);i.registerSchema(e.$Fx,a.getIconSchema());const s=new r.$Sh(()=>i.notifySchemaChanged(e.$Fx),200);a.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$Gx=m("widget-close",h.$6j.close,(0,c.localize)(2353,null)),e.$Hx=m("goto-previous-location",h.$6j.arrowUp,(0,c.localize)(2354,null)),e.$Ix=m("goto-next-location",h.$6j.arrowDown,(0,c.localize)(2355,null)),e.$Jx=R.ThemeIcon.modify(h.$6j.sync,"spin"),e.$Kx=R.ThemeIcon.modify(h.$6j.loading,"spin")}),define(ke[92],Ie([1,0,4,3,10,2,46,5,11]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rw=e.$Qw=e.$Nw=e.$Lw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Hw=e.$Gw=void 0,e.$Iw=y,e.$Jw=C,e.$Kw=w,e.$Mw=a,e.$Ow=m,e.$Pw=$,e.$Gw=(0,O.$Gi)("tunnelService"),e.$Hw=(0,O.$Gi)("sharedTunnelsService");var c;(function(s){s.Http="http",s.Https="https"})(c||(e.TunnelProtocol=c={}));var I;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(I||(e.TunnelPrivacyId=I={}));function y(s){return!!s.forwardPort}var u;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function C(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(t)return{address:t[1],port:+t[2]}}function w(s){if(s.scheme!=="http"&&s.scheme!=="https"||!s.query)return;const t=s.query.split("&");for(const o of t){const n=o.split("=")[1];if(/^https?:/.exec(n)){const d=C(R.URI.parse(n));if(d)return d}}}e.$Lw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function a(s){return e.$Lw.indexOf(s)>=0}e.$Nw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(s){return e.$Nw.indexOf(s)>=0}function $(s,t,o,n){if(o===A.OperatingSystem.Windows)return!1;if(o===A.OperatingSystem.Macintosh&&m(t)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(d?.length===4&&parseInt(d[1])>=18)return!1}return s<1024}class f{constructor(t,o,n){this.remoteAddress=t,this.localAddress=o,this.b=n,this.a=new r.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Qw=f;let i=class extends h.$Vc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new r.$me,this.onTunnelOpened=this.a.event,this.b=new r.$me,this.onTunnelClosed=this.b.event,this.c=new r.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const n of o){const d=Array.from(n.values());for(const l of d){const g=await l.value;g&&typeof g!="string"&&t.push(g)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(n=>typeof n!="string"?n?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,n,d,l){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:n,privacy:d,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(m(t)||a(t))&&(t=e.$Lw[0]);const n=this.D(t,o);if(n)return++n.refcount,n.value}openTunnel(t,o,n,d,l,g=!1,E,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${n} on local port ${l}.`);const D=this.g??t;if(!D)return;if(o||(o="localhost"),d||(d=this.t),this.g&&this.n.has(n)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.F(D,o,n,d,l,g,E,S);return k?k.then(P=>{if(P){if(typeof P=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,n),P}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,n);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.w(P);return(P.tunnelRemoteHost!==o||P.tunnelRemotePort!==n)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&P.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const n=o.get(t.tunnelRemotePort);n&&(n.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,n))}}}}async y(t,o,n){if(n.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const d=n.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),d}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const n=this.f.get(t);if(n&&n.has(o)){const d=n.get(o);d.refcount=0,await this.y(t,o,d)}}z(t,o,n){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:n})}async C(t,o){const n=this.f.get(t);if(n){const d=n.get(o),l=d?await d.value:void 0;(!l||typeof l=="string")&&n.delete(o),n.size===0&&this.f.delete(t)}}D(t,o){const n=[t];a(t)?(n.push(...e.$Lw),n.push(...e.$Nw)):m(t)&&n.push(...e.$Nw);const d=n.map(l=>this.f.get(l));for(const l of d){const g=l?.get(o);if(g)return g}}canTunnel(t){return!!C(t)}G(t,o,n,d,l,g,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${n} on local port ${d}.`);const S=n;this.n.add(S);const D=d===void 0?n:d,k={elevationRequired:l?this.isPortPrivileged(D):!1},P={remoteAddress:{host:o,port:n},localAddressPort:d,privacy:g,public:g?g!==I.Private:void 0,protocol:E},p=t.forwardPort(P,k);return p?(this.z(o,n,p),p.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),p}};e.$Rw=i,e.$Rw=i=Je([Ve(0,b.$bk),Ve(1,T.$aj)],i)}),define(ke[245],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=void 0,e.$Ll=(0,r.$Gi)("IUriIdentityService")}),define(ke[246],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Sw=void 0,e.$Sw=(0,r.$Gi)("editSessionIdentityService");var h;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(ke[247],Ie([1,0,14]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=h,e.$mN=A,e.$nN=R,e.$oN=T,e.$pN=O;function h(b){return b.scheme!==r.Schemas.file&&b.scheme!==r.Schemas.vscodeRemote}function A(b){if(b.folders.length)return b.folders.every(c=>h(c.uri))?b.folders[0].uri:void 0;if(b.configuration&&h(b.configuration))return b.configuration}function R(b){return A(b)?.scheme}function T(b){return A(b)?.authority}function O(b){return A(b)!==void 0}}),define(ke[47],Ie([1,0,8,16,84,22,2,5,14]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=c,e.$Ri=I,e.$Ui=y,e.$Vi=u,e.$Wi=C,e.$Xi=a,e.$Yi=m,e.$2i=i,e.$7i=s,e.$8i=t,e.$0i=o,e.$$i=n,e.$_i=d,e.$Pi=(0,O.$Gi)("contextService");function c(l){const g=l;return typeof g?.id=="string"&&T.URI.isUri(g.uri)}function I(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function y(l,g){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,h.$oc)(l)}:g?e.$Si:e.$Ti;const E=l;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function u(l){const g=l;return typeof g?.id=="string"&&T.URI.isUri(g.configPath)}function C(l){const g=l;if(g?.uri)return{id:g.id,uri:T.URI.revive(g.uri)};const E=l;if(E?.configPath)return{id:E.id,configPath:T.URI.revive(E.configPath)};if(l?.id)return{id:l.id}}var w;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function a(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}function m(l){const g=l;return!!(g&&typeof g=="object"&&T.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}class ${constructor(g,E,S,D,k){this.h=g,this.j=S,this.k=D,this.l=k,this.c=A.$Mi.forUris(this.l,()=>!0),this.folders=E}update(g){this.h=g.id,this.k=g.configuration,this.j=g.transient,this.l=g.l,this.folders=g.folders}get folders(){return this.g}set folders(g){this.g=g,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(g){this.k=g}getFolder(g){return g&&this.c.findSubstr(g)||null}n(){this.c=A.$Mi.forUris(this.l,()=>!0);for(const g of this.folders)this.c.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=$;class f{constructor(g,E){this.raw=E,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,R.$hh)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=f;function i(l){return new f({uri:l,index:0,name:(0,R.$dh)(l)},{uri:l.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,r.localize)(2476,null),extensions:[e.$3i]}],e.$6i="workspace.json";function s(l,g){return R.$$g.isEqualOrParent(l,g.untitledWorkspacesHome)}function t(l){let g;return T.URI.isUri(l)?g=l:g=l.configuration,g?.scheme===b.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(l){return l.id===e.$9i}function n(l,g){return!s(l,g)&&!t(l)}function d(l){return(typeof l=="string"?(0,h.$pc)(l):(0,R.$fh)(l))===e.$4i}}),define(ke[151],Ie([1,0,60,4,3,22,2,8,145,27,5,11,47,28,245,7,32,12,17]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Nl=e.ProfileResourceType=void 0,e.$Ml=s,e.$Ol=t,e.$Pl=o;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&T.URI.isUri(g.location)&&T.URI.isUri(g.globalStorageHome)&&T.URI.isUri(g.settingsResource)&&T.URI.isUri(g.keybindingsResource)&&T.URI.isUri(g.tasksResource)&&T.URI.isUri(g.snippetsHome)&&T.URI.isUri(g.extensionsResource))}e.$Nl=(0,I.$Gi)("IUserDataProfilesService");function t(l,g){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:T.URI.revive(l.location).with({scheme:g}),globalStorageHome:T.URI.revive(l.globalStorageHome).with({scheme:g}),settingsResource:T.URI.revive(l.settingsResource).with({scheme:g}),keybindingsResource:T.URI.revive(l.keybindingsResource).with({scheme:g}),tasksResource:T.URI.revive(l.tasksResource).with({scheme:g}),snippetsHome:T.URI.revive(l.snippetsHome).with({scheme:g}),extensionsResource:T.URI.revive(l.extensionsResource).with({scheme:g}),cacheHome:T.URI.revive(l.cacheHome).with({scheme:g}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function o(l,g,E,S,D,k){return{id:l,name:g,location:E,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:k&&D?.useDefaultFlags?.globalState?k.globalStorageHome:(0,R.$hh)(E,"globalStorage"),settingsResource:k&&D?.useDefaultFlags?.settings?k.settingsResource:(0,R.$hh)(E,"settings.json"),keybindingsResource:k&&D?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,R.$hh)(E,"keybindings.json"),tasksResource:k&&D?.useDefaultFlags?.tasks?k.tasksResource:(0,R.$hh)(E,"tasks.json"),snippetsHome:k&&D?.useDefaultFlags?.snippets?k.snippetsHome:(0,R.$hh)(E,"snippets"),extensionsResource:k&&D?.useDefaultFlags?.extensions?k.extensionsResource:(0,R.$hh)(E,"extensions.json"),cacheHome:(0,R.$hh)(S,l),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let n=class extends A.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(g,E,S,D){super(),this.t=g,this.u=E,this.w=S,this.y=D,this.f=!0,this.h=this.B(new h.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new C.$Bc,workspaces:new C.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(g){this.f!==g&&(this.z=void 0,this.f=g)}isEnabled(){return this.f}get C(){if(!this.z){const g=this.D(),E=[g];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,f.$fg)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}E.push(o((0,R.$eh)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},g))}}catch(k){this.y.error(k)}const S=new C.$Bc,D=new Map;if(E.length)try{const k=this.Q();if(k.workspaces)for(const[P,p]of Object.entries(k.workspaces)){const v=T.URI.parse(P),F=E.find(N=>N.id===p);F&&S.set(v,F)}if(k.emptyWindows)for(const[P,p]of Object.entries(k.emptyWindows)){const v=E.find(F=>F.id===p);v&&D.set(P,v)}}catch(k){this.y.error(k)}this.z={profiles:E,workspaces:S,emptyWindows:D}}return this.z}D(){const g=o("__default__profile__",(0,O.localize)(2429,null),this.t.userRoamingDataHome,this.g);return{...g,extensionsResource:this.S()??g.extensionsResource,isDefault:!0}}async createTransientProfile(g){const E="Temp",S=new RegExp(`${(0,$.$if)(E)}\\s(\\d+)`);let D=0;for(const P of this.profiles){const p=S.exec(P.name),v=p?parseInt(p[1]):0;D=v>D?v:D}const k=`${E} ${D+1}`;return this.createProfile((0,r.$uj)((0,m.$3g)()).toString(16),k,{transient:!0},g)}async createNamedProfile(g,E,S){return this.createProfile((0,r.$uj)((0,m.$3g)()).toString(16),g,E,S)}async createProfile(g,E,S,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(g,E,S);return D&&await this.setProfileForWorkspace(D,k),k}async F(g,E,S){if(!(0,f.$fg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(E);return D||(D=(async()=>{try{if(this.profiles.find(v=>v.name===E||v.id===g))throw new Error(`Profile with ${E} name already exists`);const P=o(g,E,(0,R.$hh)(this.profilesHome,g),this.g,S,this.defaultProfile);await this.u.createFolder(P.location);const p=[];return this.j.fire({profile:P,join(v){p.push(v)}}),await a.Promises.settled(p),this.I([P],[],[]),P}finally{this.r.delete(E)}})(),this.r.set(E,D)),D}async updateProfile(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(D=>D.id===g.id);if(!S)throw new Error(`Profile '${g.name}' does not exist`);return S=o(S.id,E.name??S.name,S.location,this.g,{shortName:E.shortName??S.shortName,icon:E.icon===null?void 0:E.icon??S.icon,transient:E.transient??S.isTransient,useDefaultFlags:E.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(g.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(D=>D.id===g.id);if(!E)throw new Error(`Profile '${g.name}' does not exist`);const S=[];this.m.fire({profile:E,join(D){S.push(D)}});try{await Promise.allSettled(S)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(D){(0,c.$sl)(D)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(D)}}async setProfileForWorkspace(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(D=>D.id===E.id);if(!S)throw new Error(`Profile '${E.name}' does not exist`);this.L(g,S)}unsetWorkspace(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(g,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const g=await this.u.resolve(this.profilesHome);await Promise.all((g.children||[]).filter(E=>E.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const g=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(g.map(E=>this.removeProfile(E)))}getProfileForWorkspace(g){const E=this.G(g),S=T.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return S||((0,u.$Qi)(g)?this.s.folders.get(g.uri):(0,u.$Vi)(g)?this.s.workspaces.get(g.configPath):this.s.emptyWindows.get(g.id))}G(g){return(0,u.$Qi)(g)?g.uri:(0,u.$Vi)(g)?g.configPath:g.id}H(g){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,g.location)))}I(g,E,S){const D=[...this.profiles,...g],k=[],P=this.s.profiles;this.s.profiles=[];for(let p of D){if(p.isDefault||E.some(F=>p.id===F.id))continue;p=S.find(F=>p.id===F.id)??p;const v=P.find(F=>p.id===F.id);if(p.isTransient)this.s.profiles.push(p);else{if(v){for(const[F,N]of this.s.emptyWindows.entries())if(p.id===N.id){this.L({id:F},p);break}for(const[F,N]of this.s.workspaces.entries())if(p.id===N.id){this.L({id:"",configPath:F},p);break}for(const[F,N]of this.s.folders.entries())if(p.id===N.id){this.L({id:"",uri:F},p);break}}k.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.P(k),this.z=void 0,this.J(g,E,S)}J(g,E,S){this.h.fire({added:g,removed:E,updated:S,all:this.profiles})}L(g,E,S){if(S=E?.isTransient?!0:S,S)(0,u.$Qi)(g)?(this.s.folders.delete(g.uri),E&&this.s.folders.set(g.uri,E)):(0,u.$Vi)(g)?(this.s.workspaces.delete(g.configPath),E&&this.s.workspaces.set(g.configPath,E)):(this.s.emptyWindows.delete(g.id),E&&this.s.emptyWindows.set(g.id,E));else{this.L(g,void 0,!0);const D=this.G(g);T.URI.isUri(D)?(this.C.workspaces.delete(D),E&&this.C.workspaces.set(D,E)):(this.C.emptyWindows.delete(D),E&&this.C.emptyWindows.set(D,E)),this.M()}}M(){const g={};for(const[S,D]of this.C.workspaces.entries())g[S.toString()]=D.id;const E={};for(const[S,D]of this.C.emptyWindows.entries())E[S.toString()]=D.id;this.R({workspaces:g,emptyWindows:E}),this.z=void 0}N(g){const E={},S=this.D();if(g.workspaces)for(const[k,P]of Object.entries(g.workspaces)){const p=T.URI.parse(P);E[k]=this.w.extUri.isEqual(p,S.location)?S.id:this.w.extUri.basename(p)}const D={};if(g.emptyWindows)for(const[k,P]of Object.entries(g.emptyWindows)){const p=T.URI.parse(P);D[k]=this.w.extUri.isEqual(p,S.location)?S.id:this.w.extUri.basename(p)}return{workspaces:E,emptyWindows:D}}O(){return[]}P(g){throw new Error("not implemented")}Q(){return{}}R(g){throw new Error("not implemented")}S(){}};e.$Ql=n,e.$Ql=n=Je([Ve(0,b.$Ni),Ve(1,c.$bl),Ve(2,w.$Ll),Ve(3,y.$bk)],n);class d extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(g){this.a=g}Q(){return this.X}R(g){this.X=g}}e.$Rl=d}),define(ke[152],Ie([1,0,7,4,3,61,17,193,5,151]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$lq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$jq=e.$iq=e.$hq=void 0,e.$kq=C,e.$mq=a,e.$oq=$,e.$hq="__$__isNewStorageMarker",e.$iq="__$__targetStorageMarker",e.$jq=(0,b.$Gi)("storageService");var I;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var u;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function C(f){const i=f.get(e.$iq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class w extends A.$Vc{static{this.a=60*1e3}constructor(i={flushInterval:w.a}){super(),this.m=i,this.b=this.B(new h.$pe),this.c=this.B(new h.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$me),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,s,t){return h.Event.filter(this.b.event,o=>o.scope===i&&(s===void 0||o.key===s),t)}n(){this.j.value=(0,r.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,s){const{key:t,external:o}=s;if(t===e.$iq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,s,t){return this.P(s)?.get(i,t)}getBoolean(i,s,t){return this.P(s)?.getBoolean(i,t)}getNumber(i,s,t){return this.P(s)?.getNumber(i,t)}getObject(i,s,t){return this.P(s)?.getObject(i,t)}storeAll(i,s){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,s)})}store(i,s,t,o,n=!1){if((0,T.$og)(s)){this.remove(i,t,n);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,s,n)})}remove(i,s,t=!1){this.y(()=>{this.z(i,s,void 0),this.P(s)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,s){const t=[],o=this.J(i);for(const n of Object.keys(o))o[n]===s&&t.push(n);return t}z(i,s,t,o=!1){const n=this.J(s);typeof t=="number"?n[i]!==t&&(n[i]=t,this.P(s)?.set(e.$iq,JSON.stringify(n),o)):typeof n[i]=="number"&&(delete n[i],this.P(s)?.set(e.$iq,JSON.stringify(n),o))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const s=this.P(i);return s?C(s):Object.create(null)}isNew(i){return this.getBoolean(e.$hq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const s=this.P(y.APPLICATION),t=this.P(y.PROFILE),o=this.P(y.WORKSPACE);switch(i){case I.NONE:await r.Promises.settled([s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,s=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return $(i,s,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,s){return this.w(I.NONE),(0,c.$Ml)(i)?this.R(i,s):this.S(i,s)}M(i,s){return!(i.id===s.id||a(s)&&a(i))}N(i,s,t){this.y(()=>{const o=new Set;for(const[n,d]of i)o.add(n),s.get(n)!==d&&this.u(t,{key:n,external:!0});for(const[n]of s.items)o.has(n)||this.u(t,{key:n,external:!0})})}}e.$lq=w;function a(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class m extends w{constructor(){super(),this.U=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$fq(new O.$gq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$nq=m;async function $(f,i,s,t,o,n){const d=v=>{try{return JSON.parse(v)}catch{return v}},l=new Map,g=new Map;f.forEach((v,F)=>{l.set(F,v),g.set(F,d(v))});const E=new Map,S=new Map;i.forEach((v,F)=>{E.set(F,v),S.set(F,d(v))});const D=new Map,k=new Map;s.forEach((v,F)=>{D.set(F,v),k.set(F,d(v))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const P=[];if(l.forEach((v,F)=>{P.push({key:F,value:v})}),console.table(P),console.groupEnd(),console.log(g),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const v=[];E.forEach((F,N)=>{v.push({key:N,value:F})}),console.table(v),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${n})`);const p=[];D.forEach((v,F)=>{p.push({key:F,value:v})}),console.table(p),console.groupEnd(),console.log(k)}}),define(ke[118],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=void 0;class r{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const R=this.c++;return this.b.set(R,A),this.e(),R}get(A,R){return this.b.has(A)?this.b.get(A)[R]:void 0}delete(A){this.b.delete(A),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Cpc=r}),define(ke[62],Ie([1,0,14,22,27,5]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=e.$Hpc=void 0;class T{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$9g(b=>{const c=this.b.get(b.scheme);return!(c===void 0||c&A.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(b,c){c===null?this.b.delete(b.scheme):this.b.set(b.scheme,c)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Hpc=T,e.$Ipc=(0,R.$Gi)("IExtHostFileSystemInfo")}),define(ke[29],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=void 0,e.$EQ=(0,r.$Gi)("IExtHostInitDataService")}),define(ke[248],Ie([1,0,8,11,228,29]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qrc=void 0;let T=class extends A.$OR{constructor(b,c,I){const y=I.remote.isRemote?"remoteexthost":b?"workerexthost":"exthost",u=I.remote.isRemote?(0,r.localize)(2689,null):b?(0,r.localize)(2690,null):(0,r.localize)(2691,null);super(c.createLogger(y,{name:u}))}};e.$Qrc=T,e.$Qrc=T=Je([Ve(1,h.$ck),Ve(2,R.$EQ)],T)}),define(ke[249],Ie([1,0,7]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=e.$nqc=void 0;class h{constructor(T,O,b){this.h=new Map,this.a=T,this.b=O,this.c=b,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new r.$Sh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of c.values())I.complete()}catch(I){for(const y of c.values())y.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this.d}get(T,O){let b=this.f[T];return typeof b>"u"&&(b=O),b}update(T,O){this.f[T]=O;const b=this.h.get(T);if(b!==void 0)return b.p;const c=new r.$4h;return this.h.set(T,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$nqc=h;class A extends h{setKeysForSync(T){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},T)}constructor(T,O){super(T.identifier.value,!0,O),this.j=T}}e.$oqc=A}),define(ke[250],Ie([1,0,4,2]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=void 0;class A{constructor(T){this.c=T,this.a=new r.$me,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$me,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(T,O,b,c){const y=this.c.getNotebookDocument(h.URI.revive(T)).acceptModelChanged(O.value,b,c);this.b.fire(y)}$acceptDirtyStateChanged(T,O){this.c.getNotebookDocument(h.URI.revive(T)).acceptDirty(O)}$acceptModelSaved(T){const O=this.c.getNotebookDocument(h.URI.revive(T));this.a.fire(O.apiNotebook)}}e.$irc=A}),define(ke[19],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=e.$oQ=void 0,e.$oQ=(0,r.$Gi)("IExtHostRpcService");class h{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$pQ=h}),define(ke[251],Ie([1,0,23,4,3]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;class R{#e;constructor(O,b){this.disposables=new A.$Uc,this.a=r.$sn.toKey(O.identifier),this.#e=b,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,c=>c.extensionId===this.a),c=>({key:c.key}),this.disposables)}dispose(){this.disposables.dispose()}get(O){return this.#e.get(this.a,O)}store(O,b){return this.#e.store(this.a,O,b)}delete(O){return this.#e.delete(this.a,O)}}e.$xqc=R}),define(ke[72],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=e.$Xpc=void 0,e.$Xpc=(0,r.$Gi)("IURITransformerService");class h{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.$Ypc=h}),define(ke[252],Ie([1,0,253,362,363,67,2,11,364]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$msc=I,r=We(r),h=We(h),A=We(A),R=We(R);const c=!1;function I(i,s,t,o,n,d){const l=d.environment.useHostProxy,g=typeof l=="boolean"?l:!d.remote.isRemote,E={resolveProxy:k=>i.resolveProxy(k),lookupProxyAuthorization:m.bind(void 0,i,o,n,s,{},{},d.remote.isRemote,g),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>s.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>u(s),addCertificatesV2:()=>C(s),log:o,getLogLevel:()=>{const k=o.getLevel();switch(k){case O.LogLevel.Trace:return b.LogLevel.Trace;case O.LogLevel.Debug:return b.LogLevel.Debug;case O.LogLevel.Info:return b.LogLevel.Info;case O.LogLevel.Warning:return b.LogLevel.Warning;case O.LogLevel.Error:return b.LogLevel.Error;case O.LogLevel.Off:return b.LogLevel.Off;default:return P(k)}function P(p){return o.error("Unknown log level",p),b.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:g,loadAdditionalCertificates:async()=>{const k=[];if(d.remote.isRemote&&k.push((0,b.loadSystemCertificates)({log:o})),g){o.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const P=i.loadCertificates();P.then(p=>o.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",p.length)),k.push(P)}return d.environment.extensionTestsLocationURI&&h.globalAgent.testCertificates?.length&&(o.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),k.push(Promise.resolve(h.globalAgent.testCertificates))),(await Promise.all(k)).flat()},env:process.env},S=(0,b.createProxyResolver)(E),D=y(E,S);return a(t,D)}function y(i,s){function t(o,n){return Object.assign(o.default||o,n)}return{http:t(r,(0,b.createHttpPatch)(i,r,s)),https:t(h,(0,b.createHttpPatch)(i,h,s)),net:t(R,(0,b.createNetPatch)(i,R)),tls:t(A,(0,b.createTlsPatch)(i,A))}}function u(i){const s=i.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}function C(i){const s=i.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}const w=new Map;function a(i,s){return i.getExtensionPathIndex().then(t=>{const o=globalThis._VSCODE_NODE_MODULES.module,n=o._load;o._load=function(l,g,E){if(l==="net")return s.net;if(l==="tls")return s.tls;if(l!=="http"&&l!=="https")return n.apply(this,arguments);const S=t.findSubstr(T.URI.file(g.filename));let D=w.get(S);if(D||w.set(S,D={}),!D[l]){const k=s[l];D[l]={...k}}return D[l]}})}async function m(i,s,t,o,n,d,l,g,E,S,D){const k=n[E];S&&(n[E]=S),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${E}`,`proxyAuthenticate:${S}`,`proxyAuthenticateCache:${k}`);const P=S||k,p=Array.isArray(P)?P:typeof P=="string"?[P]:[];if(f(t,p,l),p.some(F=>/^(Negotiate|Kerberos)( |$)/i.test(F))&&!D.kerberosRequested){D.kerberosRequested=!0;try{const F=await new Promise((j,q)=>{$e(["kerberos"],j,q)}).then(We),N=new URL(E),L=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${N.hostname}`:`HTTP@${N.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${E}`,`spn:${L}`),"Negotiate "+await(await F.initializeClient(L)).step("")}catch(F){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",F)}if(l&&g){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup on host",`proxyURL:${E}`);const F=await i.lookupKerberosAuthorization(E);if(F)return"Negotiate "+F}}const v=p.find(F=>/^Basic( |$)/i.test(F));if(v)try{const F=d[E];if(F)if(D.basicAuthCacheUsed)s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication deleting cached credentials",`proxyURL:${E}`),delete d[E];else return s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication using cached credentials",`proxyURL:${E}`),D.basicAuthCacheUsed=!0,F;D.basicAuthAttempt=(D.basicAuthAttempt||0)+1;const N=/ realm="([^"]+)"/i.exec(v)?.[1];s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication lookup",`proxyURL:${E}`,`realm:${N}`);const L=new URL(E),M={scheme:"basic",host:L.hostname,port:Number(L.port),realm:N||"",isProxy:!0,attempt:D.basicAuthAttempt},z=await i.lookupAuthorization(M);if(z){s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received credentials",`proxyURL:${E}`,`realm:${N}`);const j="Basic "+Buffer.from(`${z.username}:${z.password}`).toString("base64");return d[E]=j,j}else s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received no credentials",`proxyURL:${E}`,`realm:${N}`)}catch(F){s.error("ProxyResolver#lookupProxyAuthorization Basic authentication failed",F)}}let $=!1;function f(i,s,t){$||!s.length||($=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(o=>o.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(ke[254],Ie([1,0,139]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=A;function h(R){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:R,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function A(R){return new r.$Nn(h(R))}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[153],Ie([1,0,8,17,2,3,5,36,27,14,52,211,43]),function($e,e,r,h,A,R,T,O,b,c,I,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$sG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$iG=e.EditorInputCapabilities=e.$hG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=void 0,e.$$F=a,e.$_F=m,e.$aG=$,e.$bG=f,e.$cG=i,e.$dG=s,e.$eG=t,e.$fG=o,e.$gG=n,e.$jG=D,e.$kG=P,e.$lG=p,e.$mG=v,e.$nG=F,e.$oG=N,e.$pG=L,e.$qG=M,e.$rG=H,e.$tG=_,e.$uG=ne,e.$vG=ye,e.$wG=ge,u=Ut(u),e.$6F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$7F={id:"default",displayName:(0,r.localize)(4038,null),providerDisplayName:(0,r.localize)(4039,null)},e.$8F="workbench.editor.sidebysideEditor",e.$9F="workbench.editors.textDiffEditor",e.$0F="workbench.editors.binaryResourceDiffEditor";var C;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(C||(e.EditorPaneSelectionChangeReason=C={}));var w;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function a(Y){const U=Y;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(Y){const U=Y;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function $(Y,U,oe){for(const ve of oe.visibleEditorPanes)if(ve.group.id===U&&Y.matches(ve.input))return ve.getViewState()}function f(Y){if(D(Y))return!1;const U=Y;return A.URI.isUri(U?.resource)}function i(Y){if(D(Y))return!1;const U=Y;return U?.original!==void 0&&U.modified!==void 0}function s(Y){if(D(Y))return!1;const U=Y;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function t(Y){if(D(Y)||i(Y))return!1;const U=Y;return U?.primary!==void 0&&U.secondary!==void 0}function o(Y){if(D(Y))return!1;const U=Y;return U?U.resource===void 0||U.resource.scheme===c.Schemas.untitled||U.forceUntitled===!0:!1}function n(Y){if(D(Y))return!1;const U=Y;return A.URI.isUri(U?.base?.resource)&&A.URI.isUri(U?.input1?.resource)&&A.URI.isUri(U?.input2?.resource)&&A.URI.isUri(U?.result?.resource)}var d;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class g{constructor(){this.a=new Map}registerSource(U,oe){let ve=this.a.get(U);return ve||(ve={source:U,label:oe},this.a.set(U,ve)),ve.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$hG=new g;var E;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class S extends R.$Vc{}e.$iG=S;function D(Y){return Y instanceof S}function k(Y){const U=Y;return A.URI.isUri(U?.preferredResource)}function P(Y){const U=Y;return D(U?.primary)&&D(U?.secondary)}function p(Y){const U=Y;return D(U?.modified)&&D(U?.original)}function v(Y,U,oe,ve,te){return ge(ve,[(0,y.$qj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(4040,null),run:()=>{const ae={...oe,limits:{size:Number.MAX_VALUE}};Y.openEditor(U,ae)}}),(0,y.$qj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(4041,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function F(Y){return D(Y?.editor)}function N(Y){const U=Y;return F(Y)&&U?.group!==void 0}function L(Y){const U=Y;return typeof U?.groupId=="number"&&D(U.editor)}function M(Y){return typeof Y?.groupId=="number"}var z;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var j;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var q;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(q||(e.SideBySideEditor=q={}));class B{getOriginalUri(U,oe){if(!U)return;if(n(U))return e.$sG.getOriginalUri(U.result,oe);if(oe?.supportSideBySide){const{primary:te,secondary:ae}=this.a(U);if(te&&ae){if(oe?.supportSideBySide===q.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===q.ANY)return this.getOriginalUri(te,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme});U=oe.supportSideBySide===q.PRIMARY?te:ae}}if(i(U)||s(U)||t(U)||n(U))return;const ve=k(U)?U.preferredResource:U.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}a(U){return P(U)||t(U)?{primary:U.primary,secondary:U.secondary}:p(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,oe){if(!U)return;if(n(U))return e.$sG.getCanonicalUri(U.result,oe);if(oe?.supportSideBySide){const{primary:te,secondary:ae}=this.a(U);if(te&&ae){if(oe?.supportSideBySide===q.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===q.ANY)return this.getCanonicalUri(te,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme});U=oe.supportSideBySide===q.PRIMARY?te:ae}}if(i(U)||s(U)||t(U)||n(U))return;const ve=U.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}b(U,oe){if(Array.isArray(oe)){if(oe.some(ve=>U.scheme===ve))return U}else if(oe===U.scheme)return U}}var ee;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ee||(e.EditorCloseMethod=ee={}));function H(Y,U,oe,ve){if(!Y.isSticky(U))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return oe===ee.MOUSE||oe===ee.KEYBOARD;case"mouse":return oe===ee.MOUSE;case"keyboard":return oe===ee.KEYBOARD}return!1}e.$sG=new B;var W;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(W||(e.CloseDirection=W={}));class X{constructor(){this.c=new Map,this.d=new Map}start(U){const oe=this.a=U.get(T.$Fi);for(const[ve,te]of this.c)this.e(ve,te,oe);this.c.clear()}e(U,oe,ve){const te=ve.createInstance(oe);this.d.set(U,te)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,h.$qg)(this.b)}registerEditorSerializer(U,oe){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,oe,this.a):this.c.set(U,oe),(0,R.$Tc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}O.$so.add(e.$6F.EditorFactory,new X);async function _(Y,U,oe){return!Y||!Y.length?[]:await Promise.all(Y.map(async ve=>{const te=A.URI.revive(ve.fileUri);if(!te){oe.info("Cannot resolve the path because it is not valid.",ve);return}if(!await U.canHandleResource(te)){oe.info("Cannot resolve the path because it cannot be handled",ve);return}let se=ve.exists,Z=ve.type;if(typeof se!="boolean"||typeof Z!="number")try{Z=(await U.stat(te)).isDirectory?b.FileType.Directory:b.FileType.Unknown,se=!0}catch(pe){oe.error(pe),se=!1}if(!se&&ve.openOnlyIfExists){oe.info("Cannot resolve the path because it does not exist",ve);return}if(Z===b.FileType.Directory){oe.info("Cannot resolve the path because it is a directory",ve);return}const re={...ve.options,pinned:!0};return se?{resource:te,options:re}:{resource:te,options:re,forceUntitled:!0}}))}var ce;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function ne(Y){const U=Y;if(!U)return!1;const oe=U;if(oe.modified)return ne(oe.modified);const ve=U;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function ye(Y){return(0,I.$sj)(Y)}function ge(Y,U,oe){const ve=(0,I.$tj)(Y,U);return ve.forceMessage=oe?.forceMessage,ve.forceSeverity=oe?.forceSeverity,ve.allowDialog=oe?.allowDialog,ve}}),define(ke[255],Ie([1,0,4,8,5,3,28,36,24,82,244]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$CG=e.ViewContentGroups=e.$AG=e.ViewContainerLocation=e.Extensions=e.$zG=e.$yG=e.$xG=void 0,e.$BG=C,e.$xG="views",e.$yG=(0,h.localize)(4201,null),e.$zG=(0,I.$Dx)("default-view-icon",c.$6j.window,(0,h.localize)(4202,null));var y;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$AG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function C(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class w extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new r.$me),this.onDidRegister=this.c.event,this.f=this.B(new r.$me),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(n,d,l){const g=this.get(n.id);if(g)return g;const E=n;return E.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,T.$yc)(this.g,d,[]).push(E),l?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:d}),E}deregisterViewContainer(n){for(const d of this.g.keys()){const l=this.g.get(d),g=l?.indexOf(n);if(g!==-1){l?.splice(g,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:n,viewContainerLocation:d});return}}}get(n){return this.all.filter(d=>d.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(d=>this.getViewContainerLocation(d)===n)}}O.$so.add(y.ViewContainersRegistry,new w);var a;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(a||(e.ViewContentGroups=a={}));function m(o,n){const d=o.group??a.More,l=n.group??a.More;return d!==l?d.localeCompare(l):(o.order??5)-(n.order??5)}class $ extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new r.$me),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$me),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$me),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$me),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new T.$Ic}registerViews(n,d){this.registerViews2([{views:n,viewContainer:d}])}registerViews2(n){n.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(n)}deregisterViews(n,d){const l=this.s(n,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(n,d){for(const l of this.m.keys())if(l!==d){const g=this.s(n,l);g.length&&(this.r(g,d),this.g.fire({views:g,from:l,to:d}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const d of this.j){const l=(this.m.get(d)||[]).filter(g=>g.id===n)[0];if(l)return l}return null}getViewContainer(n){for(const d of this.j)if((this.m.get(d)||[]).filter(g=>g.id===n)[0])return d;return null}registerViewWelcomeContent(n,d){return this.n.add(n,d),this.h.fire(n),(0,R.$Tc)(()=>{this.n.delete(n,d),this.h.fire(n)})}registerViewWelcomeContent2(n,d){const l=new Map;for(const[g,E]of d)this.n.add(n,E),l.set(g,(0,R.$Tc)(()=>{this.n.delete(n,E),this.h.fire(n)}));return this.h.fire(n),l}getViewWelcomeContent(n){const d=[];return this.n.forEach(n,l=>d.push(l)),d.sort(m)}r(n,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const g of n){if(this.getView(g.id)!==null)throw new Error((0,h.localize)(4203,null,g.id));l.push(g)}}s(n,d){const l=this.m.get(d);if(!l)return[];const g=[],E=[];for(const S of l)n.includes(S)?g.push(S):E.push(S);return g.length&&(E.length?this.m.set(d,E):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),g}}O.$so.add(y.ViewsRegistry,new $),e.$CG=(0,A.$Gi)("viewDescriptorService");var f;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(f||(e.ViewVisibilityState=f={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class s{constructor(n,d){this.c=!1,this.d=!1,(0,b.$io)(this,n),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const g=await d(l);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$DG=s;class t extends Error{constructor(n){super((0,h.localize)(4204,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$EG=t}),define(ke[256],Ie([1,0,8,35]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG=new h.$Xj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(4673,null)}),e.$JG=new h.$Xj("chatVoteUpEnabled",!1,{type:"boolean",description:(0,r.localize)(4674,null)}),e.$KG=new h.$Xj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(4675,null)}),e.$LG=new h.$Xj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(4676,null)}),e.$MG=new h.$Xj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(4677,null)}),e.$NG=new h.$Xj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4678,null)}),e.$OG=new h.$Xj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(4679,null)}),e.$PG=new h.$Xj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(4680,null)}),e.$QG=new h.$Xj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(4681,null)}),e.$RG=new h.$Xj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(4682,null)}),e.$SG=new h.$Xj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(4683,null)}),e.$TG=new h.$Xj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(4684,null)}),e.$UG=new h.$Xj("inChat",!1,{type:"boolean",description:(0,r.localize)(4685,null)}),e.$VG=new h.$Xj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(4686,null)}),e.$WG=new h.$Xj("chatCursorAtTop",!1),e.$XG=new h.$Xj("chatInputHasAgent",!1),e.$YG=new h.$Xj("chatLocation",void 0),e.$ZG=new h.$Xj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(4687,null)})}),define(ke[154],Ie([1,0,132,7,20,4,39,3,44,182,12,35,23,5,11,115,237,152,256]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.ChatAgentLocation=void 0,e.$6H=d,e.$7H=l;var s;(function(g){g.Panel="panel",g.Terminal="terminal",g.Notebook="notebook",g.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(g){function E(S){switch(S){case"panel":return g.Panel;case"terminal":return g.Terminal;case"notebook":return g.Notebook;case"editor":return g.Editor}return g.Panel}g.fromRaw=E}(s||(e.ChatAgentLocation=s={})),e.$1H=(0,C.$Gi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new R.$me,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=f.$VG.bindTo(this.f)}registerAgent(E,S){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const k=this,P=S.slashCommands;S={...S,get slashCommands(){return P.filter(v=>!v.when||k.f.contextMatchesRules(y.$Ej.deserialize(v.when)))}};const p={data:S};return this.b.set(E,p),(0,O.$Tc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,S){const D=this.b.get(E);if(!D)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(D.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return D.data.isDefault&&this.e.set(!0),D.impl=S,this.d.fire(new o(D.data,S)),(0,O.$Tc)(()=>{D.impl=void 0,this.d.fire(void 0),D.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,S){E.isDynamic=!0;const D={data:E,impl:S};return this.b.set(E.id,D),this.d.fire(new o(E,S)),(0,O.$Tc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,S){return this.g.set(E,S),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,S,D){return await this.g.get(E)?.(S,D)??[]}updateAgent(E,S){const D=this.b.get(E);if(!D?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);D.data.metadata={...D.data.metadata,...S},this.d.fire(new o(D.data,D.impl))}getDefaultAgent(E){return(0,r.$fb)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(E))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const S=this.b.get(E);return!S?.data.when||this.f.contextMatchesRules(y.$Ej.deserialize(S.data.when))}getAgentByFullyQualifiedId(E){const S=T.Iterable.find(this.b.values(),D=>d(D.data)===E)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new o(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(S=>S.name===E)}agentHasDupeName(E){const S=this.getAgent(E);return S?this.getAgentsByName(S.name).filter(D=>D.extensionId.value!==S.extensionId.value).length>0:!1}async invokeAgent(E,S,D,k,P){const p=this.b.get(E);if(!p?.impl)throw new Error(`No activated agent with id "${E}"`);return await p.impl.invoke(S,D,k,P)}async getFollowups(E,S,D,k,P){const p=this.b.get(E);if(!p?.impl)throw new Error(`No activated agent with id "${E}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(S,D,k,P):[]}};e.$2H=t,e.$2H=t=Je([Ve(0,y.$Yj)],t);class o{constructor(E,S){this.b=E,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,S,D,k){return this.d.invoke(E,S,D,k)}async provideFollowups(E,S,D,k){return this.d.provideFollowups?this.d.provideFollowups(E,S,D,k):[]}provideWelcomeMessage(E,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,S)}provideSampleQuestions(E,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,S)}}e.$3H=o,e.$4H=(0,C.$Gi)("chatAgentNameService");let n=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,S,D,k){if(this.g=S,this.h=D,this.i=k,this.e=(0,c.$7d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const P=k.get(i.b,$.StorageScope.APPLICATION);try{this.e.set(JSON.parse(P??"{}"),void 0)}catch{k.remove(i.b,$.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,h.$Hh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},A.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,m.$cq)(E);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const D=S.restrictedChatParticipants;this.e.set(D,void 0),this.i.store(i.b,JSON.stringify(D),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}getAgentNameRestriction(E){const S=this.l(E.name,E).get(),D=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return S&&D}l(E,S){return this.e.map(k=>k[E.toLowerCase()]).map(k=>k?k.some(P=>(0,I.$Gf)(P,P.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$5H=n,e.$5H=n=i=Je([Ve(0,a.$uk),Ve(1,m.$9p),Ve(2,w.$bk),Ve(3,$.$jq)],n);function d(g){return`${g.extensionId.value}.${g.id}`}function l(g){const E="name"in g?g:{...g,name:g.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new u.$sn("")),(0,b.$di)(E)}}),define(ke[257],Ie([1,0,2,30,5]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xH=e.$wH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$uH=R,e.$vH=T;function R(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof r.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(h.$Pt.isIRange)}function T(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(R)}var O;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(O||(e.ChatResponseReferencePartStatusKind=O={}));var b;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(b||(e.ChatAgentVoteDirection=b={}));var c;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(c||(e.ChatCopyKind=c={})),e.$wH=(0,A.$Gi)("IChatService"),e.$xH="accessibility.voice.keywordActivation"}),define(ke[155],Ie([1,0,4,7,8]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cub=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$me,this.o=new r.$me,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(O){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=O}onEvent(O){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=O}onRequest(O){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.u("response",O)}sendRequest(O,b,c,I){const y={command:O};if(b&&Object.keys(b).length>0&&(y.arguments=b),this.u("request",y),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const C=this.f.get(y.seq);if(C){this.f.delete(y.seq);const w={type:"response",seq:0,request_seq:y.seq,success:!1,command:O,message:(0,A.localize)(5679,null,I,O)};C(w)}},I)}return c&&this.f.set(y.seq,c),y.seq}acceptMessage(O){this.k?this.k(O):(this.m.push(O),this.m.length===1&&this.s())}q(O,b){return O.type!=="event"||b.type!=="event"}async s(){let O;for(;this.m.length;){if((!O||this.q(this.m[0],O))&&await(0,h.$Hh)(0),O=this.m.shift(),!O)return;switch(O.type){case"event":this.j?.(O);break;case"request":this.g?.(O);break;case"response":{const b=O,c=this.f.get(b.request_seq);c&&(this.f.delete(b.request_seq),c(b));break}}}}u(O,b){b.type=O,b.seq=this.d++,this.sendMessage(b)}async w(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((b,c)=>O.set(c,b)),await(0,h.$Hh)(500),O.forEach((b,c)=>{b({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$cub=R}),define(ke[119],Ie([1,0,2,8,35,5]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$TK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$RK=e.MemoryRangeType=e.State=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=void 0,e.$QK=b,e.$SK=I,h=We(h),e.$EJ="workbench.view.debug",e.$FJ="workbench.debug.variablesView",e.$GJ="workbench.debug.watchExpressionsView",e.$HJ="workbench.debug.callStackView",e.$IJ="workbench.debug.loadedScriptsView",e.$JJ="workbench.debug.breakPointsView",e.$KJ="workbench.debug.disassemblyView",e.$LJ="workbench.panel.repl",e.$MJ="workbench.panel.repl.view",e.$NJ=new A.$Xj("debugType",void 0,{type:"string",description:h.localize(5680,null)}),e.$OJ=new A.$Xj("debugConfigurationType",void 0,{type:"string",description:h.localize(5681,null)}),e.$PJ=new A.$Xj("debugState","inactive",{type:"string",description:h.localize(5682,null)}),e.$QJ="debugUx",e.$RJ=new A.$Xj(e.$QJ,"default",{type:"string",description:h.localize(5683,null)}),e.$SJ=new A.$Xj("hasDebugged",!1,{type:"boolean",description:h.localize(5684,null)}),e.$TJ=new A.$Xj("inDebugMode",!1,{type:"boolean",description:h.localize(5685,null)}),e.$UJ=new A.$Xj("inDebugRepl",!1,{type:"boolean",description:h.localize(5686,null)}),e.$VJ=new A.$Xj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(5687,null)}),e.$WJ=new A.$Xj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(5688,null)}),e.$XJ=new A.$Xj("breakpointsFocused",!0,{type:"boolean",description:h.localize(5689,null)}),e.$YJ=new A.$Xj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(5690,null)}),e.$ZJ=new A.$Xj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(5691,null)}),e.$1J=new A.$Xj("variablesFocused",!0,{type:"boolean",description:h.localize(5692,null)}),e.$2J=new A.$Xj("expressionSelected",!1,{type:"boolean",description:h.localize(5693,null)}),e.$3J=new A.$Xj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(5694,null)}),e.$4J=new A.$Xj("callStackItemType",void 0,{type:"string",description:h.localize(5695,null)}),e.$5J=new A.$Xj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(5696,null)}),e.$6J=new A.$Xj("callStackItemStopped",!1,{type:"boolean",description:h.localize(5697,null)}),e.$7J=new A.$Xj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(5698,null)}),e.$8J=new A.$Xj("watchItemType",void 0,{type:"string",description:h.localize(5699,null)}),e.$9J=new A.$Xj("canViewMemory",void 0,{type:"boolean",description:h.localize(5700,null)}),e.$0J=new A.$Xj("breakpointItemType",void 0,{type:"string",description:h.localize(5701,null)}),e.$$J=new A.$Xj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(5702,null)}),e.$_J=new A.$Xj("breakpointHasModes",!1,{type:"boolean",description:h.localize(5703,null)}),e.$aK=new A.$Xj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(5704,null)}),e.$bK=new A.$Xj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(5705,null)}),e.$cK=new A.$Xj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(5706,null)}),e.$dK=new A.$Xj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(5707,null)}),e.$eK=new A.$Xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(5708,null)}),e.$fK=new A.$Xj("stepBackSupported",!1,{type:"boolean",description:h.localize(5709,null)}),e.$gK=new A.$Xj("restartFrameSupported",!1,{type:"boolean",description:h.localize(5710,null)}),e.$hK=new A.$Xj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(5711,null)}),e.$iK=new A.$Xj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(5712,null)}),e.$jK=new A.$Xj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(5713,null)}),e.$kK=new A.$Xj("breakpointsExist",!1,{type:"boolean",description:h.localize(5714,null)}),e.$lK=new A.$Xj("debuggersAvailable",!1,{type:"boolean",description:h.localize(5715,null)}),e.$mK=new A.$Xj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(5716,null)}),e.$nK=new A.$Xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(5717,null)}),e.$oK=new A.$Xj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(5718,null)}),e.$pK=new A.$Xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(5719,null)}),e.$qK=new A.$Xj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(5720,null)}),e.$rK=new A.$Xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(5721,null)}),e.$sK=new A.$Xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(5722,null)}),e.$tK=new A.$Xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(5723,null)}),e.$uK=new A.$Xj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(5724,null)}),e.$vK=new A.$Xj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(5725,null)}),e.$wK=new A.$Xj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(5726,null)}),e.$xK=new A.$Xj("variableIsReadonly",!1,{type:"boolean",description:h.localize(5727,null)}),e.$yK=new A.$Xj("variableValue",!1,{type:"string",description:h.localize(5728,null)}),e.$zK=new A.$Xj("variableType",!1,{type:"string",description:h.localize(5729,null)}),e.$AK=new A.$Xj("variableInterfaces",!1,{type:"array",description:h.localize(5730,null)}),e.$BK=new A.$Xj("variableName",!1,{type:"string",description:h.localize(5731,null)}),e.$CK=new A.$Xj("variableLanguage",!1,{type:"string",description:h.localize(5732,null)}),e.$DK=new A.$Xj("variableExtensionId",!1,{type:"string",description:h.localize(5733,null)}),e.$EK=new A.$Xj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(5734,null)}),e.$FK=new A.$Xj("multiSessionRepl",!1,{type:"boolean",description:h.localize(5735,null)}),e.$GK=new A.$Xj("multiSessionDebug",!1,{type:"boolean",description:h.localize(5736,null)}),e.$HK=new A.$Xj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(5737,null)}),e.$IK=new A.$Xj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(5738,null)}),e.$JK=new A.$Xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(5739,null)}),e.$KK=new A.$Xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(5740,null)});const T=i=>h.localize(5741,null,i);e.$LK=T,e.$MK="editor.contrib.debug",e.$NK="editor.contrib.breakpoint",e.$OK="debug",e.$PK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(5742,null)};var O;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(O||(e.State=O={}));function b(i){switch(i){case O.Initializing:return"initializing";case O.Stopped:return"stopped";case O.Running:return"running";default:return"inactive"}}var c;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$RK="vscode-debug-memory";function I(i){const s=i.presentationHint??i.source.presentationHint;return s==="deemphasize"||s==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var C;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$TK=(0,R.$Gi)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var $;(function(i){i.deserialize=s=>s,i.serialize=s=>s})($||(e.IDebugVisualizationTreeItem=$={}));var f;(function(i){i.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:r.URI.revive(s.iconPath.light),dark:r.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),i.serialize=s=>s})(f||(e.IDebugVisualization=f={}))}),define(ke[258],Ie([1,0,12,2,16,24,14,30,20,18]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lI=void 0,e.$_H=y,e.$aI=u,e.$bI=C,e.$cI=w,e.$dI=a,e.$eI=m,e.$fI=$,e.$gI=i,e.$hI=o,e.$iI=n,e.$jI=l,e.$kI=E;const I=/{([^}]+)}/g;function y(D,k,P){return D.replace(I,function(p,v){return k&&v.length>0&&v[0]!=="_"?p:P&&P.hasOwnProperty(v)?P[v]:p})}function u(D){const k={};for(const P of Object.keys(D))P.startsWith("!")||(k[P]=D[P]);return k}function C(D){return D.configuration.request==="attach"&&!w(D)&&(!D.parentSession||C(D.parentSession))}function w(D){let k=D.configuration.type;if(k)return k==="vslsShare"&&(k=D.configuration.adapterProxy.configuration.type),(0,r.$Gf)(k,"extensionhost")||(0,r.$Gf)(k,"pwa-extensionhost")?D:D.parentSession?w(D.parentSession):void 0}function a(D){return D.type&&(D.label||D.program||D.runtime)}function m(D,k,P){let p,v=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(D);){const L=N.index+1,M=L+N[0].length;if(L<=k&&M>=P){p=N[0],v=L;break}}if(p){const L=/(\w|\p{L})+/gu;let M=null;for(;(M=L.exec(p))&&!(M.index+1+v+M[0].length>=P););M&&(p=p.substring(0,L.lastIndex))}return p?{start:v,end:v+p.length-1}:{start:0,end:0}}async function $(D,k,P,p){if(D.evaluatableExpressionProvider.has(k)){const v=D.evaluatableExpressionProvider.ordered(k),F=(0,c.$Hb)(await Promise.all(v.map(async N=>{try{return await N.provideEvaluatableExpression(k,P,p??b.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const L=F[0].range;return N||(N=k.getLineContent(P.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const v=k.getLineContent(P.lineNumber),{start:F,end:N}=m(v,P.column,P.column),L=v.substring(F-1,N);return{matchingExpression:L,range:new O.$Pt(P.lineNumber,F,P.lineNumber,F+L.length)}}return null}const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(f))}function s(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return h.URI.parse(D.path);if((0,A.$jc)(D.path))return h.URI.file(D.path)}return D.path}function t(D){if(typeof D.path=="object"){const k=h.URI.revive(D.path);if(k)return k.scheme===T.Schemas.file?k.fsPath:k.toString()}return D.path}function o(D,k){const P=k?s:t,p=(0,R.$fo)(D);return d(p,(v,F)=>{v&&F&&(F.path=P(F))}),p}function n(D,k){const P=k?s:t,p=(0,R.$fo)(D);return d(p,(v,F)=>{!v&&F&&(F.path=P(F))}),p}function d(D,k){switch(D.type){case"event":{const P=D;switch(P.event){case"output":k(!1,P.body.source);break;case"loadedSource":k(!1,P.body.source);break;case"breakpoint":k(!1,P.body.breakpoint.source);break;default:break}break}case"request":{const P=D;switch(P.command){case"setBreakpoints":k(!0,P.arguments.source);break;case"breakpointLocations":k(!0,P.arguments.source);break;case"source":k(!0,P.arguments.source);break;case"gotoTargets":k(!0,P.arguments.source);break;case"launchVSCode":P.arguments.args.forEach(p=>k(!1,p));break;default:break}break}case"response":{const P=D;if(P.success&&P.body)switch(P.command){case"stackTrace":P.body.stackFrames.forEach(p=>k(!1,p.source));break;case"loadedSources":P.body.sources.forEach(p=>k(!1,p));break;case"scopes":P.body.scopes.forEach(p=>k(!1,p.source));break;case"setFunctionBreakpoints":P.body.breakpoints.forEach(p=>k(!1,p.source));break;case"setBreakpoints":P.body.breakpoints.forEach(p=>k(!1,p.source));break;case"disassemble":P.body?.instructions.forEach(v=>k(!1,v.location));break;default:break}break}}}function l(D){return D.filter(k=>!k.presentation?.hidden).sort((k,P)=>k.presentation?P.presentation?k.presentation.group?P.presentation.group?k.presentation.group!==P.presentation.group?k.presentation.group.localeCompare(P.presentation.group):g(k.presentation.order,P.presentation.order):-1:P.presentation.group?1:g(k.presentation.order,P.presentation.order):-1:P.presentation?1:0)}function g(D,k){return typeof D!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:D-k}async function E(D,k){const P=D.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(P!=="none"&&(await k.saveAll(),P==="allEditorsInActiveGroup")){const p=k.activeEditorPane;p&&p.input.resource?.scheme===T.Schemas.untitled&&await k.save({editor:p.input,groupId:p.group.id})}await D.reloadConfiguration()}const S=(D,k)=>!D||!k?D===k:D.name===k.name&&D.path===k.path&&D.sourceReference===k.sourceReference;e.$lI=S}),define(ke[259],Ie([1,0,56,67,24,16,10,12,33,8,155]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1rc=e.$Zrc=e.$Yrc=e.$Xrc=e.$Wrc=void 0,r=We(r),h=We(h),A=We(A),R=We(R),T=We(T),O=We(O),c=We(c);class y extends I.$cub{static{this.b=`\r
\r
`}static{this.i=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v($,f){this.p=f,this.r=Buffer.allocUnsafe(0),this.t=-1,$.on("data",i=>this.x(i))}sendMessage($){if(this.p){const f=JSON.stringify($);this.p.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${y.b}${f}`,"utf8")}}x($){for(this.r=Buffer.concat([this.r,$]);;){if(this.t>=0){if(this.r.length>=this.t){const f=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(i){this.n.fire(new Error((i.message||i)+`
`+f))}continue}}else{const f=this.r.indexOf(y.b);if(f!==-1){const s=this.r.toString("utf8",0,f).split(y.i);for(const t of s){const o=t.split(y.l);o[0]==="Content-Length"&&(this.t=Number(o[1]))}this.r=this.r.slice(f+y.b.length);continue}}break}}}e.$Wrc=y;class u extends y{startSession(){return new Promise(($,f)=>{let i=!1;this.y=this.z(()=>{this.v(this.y,this.y),$(),i=!0}),this.y.on("close",()=>{i?this.n.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.y.on("error",s=>{i?this.n.fire(s):f(s)})})}async stopSession(){await this.w(),this.y&&(this.y.end(),this.y=void 0)}}e.$Xrc=u;class C extends u{constructor($){super(),this.A=$}z($){return h.createConnection(this.A.port,this.A.host||"127.0.0.1",$)}}e.$Yrc=C;class w extends u{constructor($){super(),this.A=$}z($){return h.createConnection(this.A.path,$)}}e.$Zrc=w;class a extends y{constructor($,f){super(),this.z=$,this.A=f}async startSession(){const $=this.z.command,f=this.z.args,i=this.z.options||{};try{if($)if(R.$jc($)){if(!await b.Promises.exists($))throw new Error(c.localize(5816,null,$))}else $.indexOf("/")<0&&$.indexOf("\\")<0;else throw new Error(c.localize(5817,null,this.A));let s=process.env;if(i.env&&Object.keys(i.env).length>0&&(s=A.$io(A.$fo(process.env),i.env)),$==="node")if(Array.isArray(f)&&f.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:s,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(o.cwd=i.cwd);const n=r.fork(f[0],f.slice(1),o);if(!n.pid)throw new Error(c.localize(5818,null,f[0]));this.y=n}else throw new Error(c.localize(5819,null));else{let t=$,o=f;const n={env:s};i.cwd&&(n.cwd=i.cwd),T.$j&&($.endsWith(".bat")||$.endsWith(".cmd"))&&(n.shell=!0,t=`"${$}"`,o=f.map(d=>(d=d.replace(/"/g,'\\"'),`"${d}"`))),this.y=r.spawn(t,o,n)}this.y.on("error",t=>{this.n.fire(t)}),this.y.on("exit",(t,o)=>{this.o.fire(t)}),this.y.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.y.stdout.on("error",t=>{this.n.fire(t)}),this.y.stdin.on("error",t=>{this.n.fire(t)}),this.y.stderr.resume(),this.v(this.y.stdout,this.y.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.y?(await this.w(),T.$j?new Promise(($,f)=>{const i=r.exec(`taskkill /F /T /PID ${this.y.pid}`,function(s,t,o){if(s)return f(s)});i.on("exit",$),i.on("error",f)}):(this.y.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static B($,f){if(!$)return;const i=Object.create(null);$.runtime&&($.runtime.indexOf("./")===0?i.runtime=R.$kc(f,$.runtime):i.runtime=$.runtime),$.runtimeArgs&&(i.runtimeArgs=$.runtimeArgs),$.program&&(R.$jc($.program)?i.program=$.program:i.program=R.$kc(f,$.program)),$.args&&(i.args=$.args);const s=$;return s.win&&(i.win=a.B(s.win,f)),s.winx86&&(i.winx86=a.B(s.winx86,f)),s.windows&&(i.windows=a.B(s.windows,f)),s.osx&&(i.osx=a.B(s.osx,f)),s.linux&&(i.linux=a.B(s.linux,f)),i}static platformAdapterExecutable($,f){let i=Object.create(null);f=f.toLowerCase();for(const l of $)if(l.contributes){const g=l.contributes.debuggers;g&&g.length>0&&g.filter(E=>typeof E.type=="string"&&O.$Gf(E.type,f)).forEach(E=>{const S=a.B(E,l.extensionLocation.fsPath);i=A.$io(i,S,l.isBuiltin)})}let s;T.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=i.winx86||i.win||i.windows:T.$j?s=i.win||i.windows:T.$k?s=i.osx:T.$l&&(s=i.linux),s=s||i;const t=s.program||i.program,o=s.args||i.args,n=s.runtime||i.runtime,d=s.runtimeArgs||i.runtimeArgs;if(n)return{type:"executable",command:n,args:(d||[]).concat(typeof t=="string"?[t]:[]).concat(o||[])};if(t)return{type:"executable",command:t,args:o||[]}}}e.$1rc=a}),define(ke[260],Ie([1,0,56,31,10]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2rc=T,e.$3rc=b,r=We(r),A=We(A);function R(c,I){return new Promise((y,u)=>{let C="";const w=r.spawn(c,I);w.pid&&w.stdout.on("data",a=>{C+=a.toString()}),w.on("error",a=>{u(a)}),w.on("close",a=>{y(C)})})}async function T(c){if(c)if(A.$j){const I=await new Promise((y,u)=>{$e(["@vscode/windows-process-tree"],y,u)}).then(We);return new Promise(y=>{I.getProcessTree(c,u=>{y(!!u&&u.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(c)]).then(I=>{const y=I.trim();return!(y.length===0||y.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var O;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(O||(O={}));function b(c,I,y,u,C){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=O.powershell:c.indexOf("cmd.exe")>=0?w=O.cmd:c.indexOf("bash")>=0?w=O.bash:A.$j?w=O.cmd:w=O.bash;let a,m=" ";switch(w){case O.powershell:if(a=$=>($=$.replace(/\'/g,"''"),$.length>0&&$.charAt($.length-1)==="\\"?`'${$}\\'`:`'${$}'`),u){const $=(0,h.$Lg)(u);$&&(m+=`${$}:; `),m+=`cd ${a(u)}; `}if(C)for(const $ in C){const f=C[$];f===null?m+=`Remove-Item env:${$}; `:m+=`\${env:${$}}='${f}'; `}if(I.length>0){const $=I.shift(),f=y?$:a($);m+=f[0]==="'"?`& ${f} `:`${f} `;for(const i of I)m+=i==="<"||i===">"||y?i:a(i),m+=" "}break;case O.cmd:if(a=$=>($=$.replace(/\"/g,'""'),$=$.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>$.includes(f))||$.length===0?`"${$}"`:$),u){const $=(0,h.$Lg)(u);$&&(m+=`${$}: && `),m+=`cd ${a(u)} && `}if(C){m+='cmd /C "';for(const $ in C){let f=C[$];f===null?m+=`set "${$}=" && `:(f=f.replace(/[&^|<>]/g,i=>`^${i}`),m+=`set "${$}=${f}" && `)}}for(const $ of I)m+=$==="<"||$===">"||y?$:a($),m+=" ";C&&(m+='"');break;case O.bash:{a=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),f.length===0?'""':f);const $=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(u&&(m+=`cd ${a(u)} ; `),C){m+="/usr/bin/env";for(const f in C){const i=C[f];i===null?m+=` -u ${$(f)}`:m+=` ${$(`${f}=${i}`)}`}m+=" "}for(const f of I)m+=f==="<"||f===">"||y?f:a(f),m+=" ";break}}return m}}),define(ke[261],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.CellExecutionUpdateType=void 0;var h;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$2K=(0,r.$Gi)("INotebookExecutionService")}),define(ke[262],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6K=e.$5K=e.ProxyKernelState=e.$4K=void 0,e.$4K=100;var h;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$5K=(0,r.$Gi)("INotebookKernelService"),e.$6K=(0,r.$Gi)("INotebookKernelHistoryService")}),define(ke[263],Ie([1,0,3,30,58,208,111]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u1b=void 0;class O extends r.$Vc{constructor(c,I,y){super(),this._source=c,this.b=I,this.c=y,this.a=void 0}f(c){const I=c.getLineCount();return new h.$Pt(1,1,I,this.g(c,I))}g(c,I){if(I<1||I>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const c=new R.$yD;c.acceptChunk(this._source);const I=c.finish(!0),{textBuffer:y,disposable:u}=I.create(A.DefaultEndOfLine.LF);this.b=y,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const I=new R.$yD;I.acceptChunk(c);const y=I.finish(!0),{textBuffer:u,disposable:C}=y.create(A.DefaultEndOfLine.LF);return this.B(C),u})),this.a}findInInputs(c){const y=new T.$mD(c,!1,!1,null).parseSearchRequest();if(!y)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,y,!0,5e3)}findInOutputs(c){const y=new T.$mD(c,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(u=>{const C=u.findMatchesLineByLine(this.f(u),y,!0,5e3);if(C.length!==0)return{textBuffer:u,matches:C}}).filter(u=>!!u):[]}}e.$u1b=O}),define(ke[73],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class A{static fromExtHostTestItem(T,O,b=T.parent){if(T._isRoot)return new A([O]);const c=[T.id];for(let I=b;I&&I.id!==O;I=I.parent)c.push(I.id);return c.push(O),new A(c.reverse())}static isRoot(T){return!T.includes(r.Delimiter)}static root(T){const O=T.indexOf(r.Delimiter);return O===-1?T:T.slice(0,O)}static fromString(T){return new A(T.split(r.Delimiter))}static join(T,O){return new A([...T.path,O])}static joinToString(T,O){return T.toString()+r.Delimiter+O}static parentId(T){const O=T.lastIndexOf(r.Delimiter);return O===-1?void 0:T.slice(0,O)}static localId(T){const O=T.lastIndexOf(r.Delimiter);return O===-1?T:T.slice(O+r.Delimiter.length)}static isChild(T,O){return O[T.length]===r.Delimiter&&O.startsWith(T)}static compare(T,O){return T===O?h.IsSame:A.isChild(T,O)?h.IsChild:A.isChild(O,T)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(T,O){if(T===0)return 0;let b=0;for(;b<T-1;){for(let c=1;c<T;c++){const I=O(c-1),y=O(c);if(I.path[b]!==y.path[b])return b}b++}return b}constructor(T,O=T.length){if(this.path=T,this.d=O,T.length===0||O<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let T=1;T<=this.d;T++)yield new A(this.path,T)}*idsToRoot(){for(let T=this.d;T>0;T--)yield new A(this.path,T)}compare(T){if(typeof T=="string")return A.compare(this.toString(),T);for(let O=0;O<T.d&&O<this.d;O++)if(T.path[O]!==this.path[O])return h.Disconnected;return T.d>this.d?h.IsChild:T.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let T=1;T<this.d;T++)this.c+=r.Delimiter,this.c+=this.path[T]}return this.c}}e.$$I=A}),define(ke[74],Ie([1,0,2,57,30,73]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$gJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$fJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$eJ=e.$dJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$cJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$bJ=e.$aJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$_I=e.TestResultState=void 0;var T;(function(q){q[q.Unset=0]="Unset",q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(T||(e.TestResultState=T={})),e.$_I={[T.Unset]:"unset",[T.Queued]:"queued",[T.Running]:"running",[T.Passed]:"passed",[T.Failed]:"failed",[T.Skipped]:"skipped",[T.Errored]:"errored"};var O;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(O||(e.ExtTestRunProfileKind=O={}));var b;(function(q){q[q.Refresh=2]="Refresh",q[q.CodeRelatedToTest=4]="CodeRelatedToTest",q[q.TestRelatedToCode=8]="TestRelatedToCode"})(b||(e.TestControllerCapability=b={}));var c;(function(q){q[q.Run=2]="Run",q[q.Debug=4]="Debug",q[q.Coverage=8]="Coverage",q[q.HasNonDefaultProfile=16]="HasNonDefaultProfile",q[q.HasConfigurable=32]="HasConfigurable",q[q.SupportsContinuousRun=64]="SupportsContinuousRun"})(c||(e.TestRunProfileBitset=c={})),e.$aJ=[c.Run,c.Debug,c.Coverage,c.HasNonDefaultProfile,c.HasConfigurable,c.SupportsContinuousRun];const I=q=>"runId"in q;e.$bJ=I;var y;(function(q){q.serialize=B=>({range:B.range.toJSON(),uri:B.uri.toJSON()}),q.deserialize=(B,ee)=>({range:A.$Pt.lift(ee.range),uri:B.asCanonicalUri(r.URI.revive(ee.uri))})})(y||(e.IRichLocation=y={}));var u;(function(q){q[q.Error=0]="Error",q[q.Output=1]="Output"})(u||(e.TestMessageType=u={}));var C;(function(q){q.serialize=B=>({label:B.label,uri:B.uri?.toJSON(),position:B.position?.toJSON()}),q.deserialize=(B,ee)=>({label:ee.label,uri:ee.uri?B.asCanonicalUri(r.URI.revive(ee.uri)):void 0,position:ee.position?h.$Ot.lift(ee.position):void 0})})(C||(e.ITestMessageStackFrame=C={}));var w;(function(q){q.serialize=B=>({message:B.message,type:u.Error,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&y.serialize(B.location),stackTrace:B.stackTrace?.map(C.serialize)}),q.deserialize=(B,ee)=>({message:ee.message,type:u.Error,expected:ee.expected,actual:ee.actual,contextValue:ee.contextValue,location:ee.location&&y.deserialize(B,ee.location),stackTrace:ee.stackTrace&&ee.stackTrace.map(H=>C.deserialize(B,H))})})(w||(e.ITestErrorMessage=w={}));const a=(q,B)=>`${B?"s":"e"}${q}`;e.$cJ=a;var m;(function(q){q.serialize=B=>({message:B.message,type:u.Output,offset:B.offset,length:B.length,location:B.location&&y.serialize(B.location)}),q.deserialize=(B,ee)=>({message:ee.message,type:u.Output,offset:ee.offset,length:ee.length,location:ee.location&&y.deserialize(B,ee.location)})})(m||(e.ITestOutputMessage=m={}));var $;(function(q){q.serialize=B=>B.type===u.Error?w.serialize(B):m.serialize(B),q.deserialize=(B,ee)=>ee.type===u.Error?w.deserialize(B,ee):m.deserialize(B,ee),q.isDiffable=B=>B.type===u.Error&&B.actual!==void 0&&B.expected!==void 0})($||(e.ITestMessage=$={}));var f;(function(q){q.serializeWithoutMessages=B=>({state:B.state,duration:B.duration,messages:[]}),q.serialize=B=>({state:B.state,duration:B.duration,messages:B.messages.map($.serialize)}),q.deserialize=(B,ee)=>({state:ee.state,duration:ee.duration,messages:ee.messages.map(H=>$.deserialize(B,H))})})(f||(e.ITestTaskState=f={}));const i="\0",s=(q,B)=>q+i+B;e.$dJ=s;const t=q=>{const B=q.indexOf(i);return{ctrlId:q.slice(0,B),tagId:q.slice(B+1)}};e.$eJ=t;var o;(function(q){q.serialize=B=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?.toJSON(),range:B.range?.toJSON()||null,description:B.description,error:B.error,sortText:B.sortText}),q.deserialize=(B,ee)=>({extId:ee.extId,label:ee.label,tags:ee.tags,busy:ee.busy,children:void 0,uri:ee.uri?B.asCanonicalUri(r.URI.revive(ee.uri)):void 0,range:ee.range?A.$Pt.lift(ee.range):null,description:ee.description,error:ee.error,sortText:ee.sortText})})(o||(e.ITestItem=o={}));var n;(function(q){q[q.NotExpandable=0]="NotExpandable",q[q.Expandable=1]="Expandable",q[q.BusyExpanding=2]="BusyExpanding",q[q.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var d;(function(q){q.serialize=B=>({expand:B.expand,item:o.serialize(B.item)}),q.deserialize=(B,ee)=>({controllerId:R.$$I.root(ee.item.extId),expand:ee.expand,item:o.deserialize(B,ee.item)})})(d||(e.InternalTestItem=d={}));var l;(function(q){q.serialize=B=>{let ee;return B.item&&(ee={},B.item.label!==void 0&&(ee.label=B.item.label),B.item.tags!==void 0&&(ee.tags=B.item.tags),B.item.busy!==void 0&&(ee.busy=B.item.busy),B.item.uri!==void 0&&(ee.uri=B.item.uri?.toJSON()),B.item.range!==void 0&&(ee.range=B.item.range?.toJSON()),B.item.description!==void 0&&(ee.description=B.item.description),B.item.error!==void 0&&(ee.error=B.item.error),B.item.sortText!==void 0&&(ee.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:ee}},q.deserialize=B=>{let ee;return B.item&&(ee={},B.item.label!==void 0&&(ee.label=B.item.label),B.item.tags!==void 0&&(ee.tags=B.item.tags),B.item.busy!==void 0&&(ee.busy=B.item.busy),B.item.range!==void 0&&(ee.range=B.item.range?A.$Pt.lift(B.item.range):null),B.item.description!==void 0&&(ee.description=B.item.description),B.item.error!==void 0&&(ee.error=B.item.error),B.item.sortText!==void 0&&(ee.sortText=B.item.sortText)),{extId:B.extId,expand:B.expand,item:ee}}})(l||(e.ITestItemUpdate=l={}));const g=(q,B)=>{B.expand!==void 0&&(q.expand=B.expand),B.item!==void 0&&(q.item=q.item?Object.assign(q.item,B.item):B.item)};e.$fJ=g;var E;(function(q){q.serializeWithoutMessages=B=>({...d.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(f.serializeWithoutMessages)}),q.serialize=B=>({...d.serialize(B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(f.serialize)}),q.deserialize=(B,ee)=>({...d.deserialize(B,ee),ownComputedState:ee.ownComputedState,computedState:ee.computedState,tasks:ee.tasks.map(H=>f.deserialize(B,H)),retired:!0})})(E||(e.TestResultItem=E={}));var S;(function(q){q.empty=()=>({covered:0,total:0}),q.sum=(B,ee)=>{B.covered+=ee.covered,B.total+=ee.total}})(S||(e.ICoverageCount=S={}));var D;(function(q){q.serialize=B=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testIds:B.testIds,uri:B.uri.toJSON()}),q.deserialize=(B,ee)=>({id:ee.id,statement:ee.statement,branch:ee.branch,declaration:ee.declaration,testIds:ee.testIds,uri:B.asCanonicalUri(r.URI.revive(ee.uri))}),q.empty=(B,ee)=>({id:B,uri:ee,statement:S.empty()})})(D||(e.IFileCoverage=D={}));function k(q){return{...q,location:q.location?.toJSON()}}function P(q){return q.location=q.location?h.$Ot.isIPosition(q.location)?h.$Ot.lift(q.location):A.$Pt.lift(q.location):void 0,q}e.$gJ=3;var p;(function(q){q[q.Declaration=0]="Declaration",q[q.Statement=1]="Statement",q[q.Branch=2]="Branch"})(p||(e.DetailType=p={}));var v;(function(q){q.serialize=B=>B.type===p.Declaration?N.serialize(B):L.serialize(B),q.deserialize=B=>B.type===p.Declaration?N.deserialize(B):L.deserialize(B)})(v||(e.CoverageDetails=v={}));var F;(function(q){q.serialize=k,q.deserialize=P})(F||(e.IBranchCoverage=F={}));var N;(function(q){q.serialize=k,q.deserialize=P})(N||(e.IDeclarationCoverage=N={}));var L;(function(q){q.serialize=B=>({...k(B),branches:B.branches?.map(F.serialize)}),q.deserialize=B=>({...P(B),branches:B.branches?.map(F.deserialize)})})(L||(e.IStatementCoverage=L={}));var M;(function(q){q[q.Add=0]="Add",q[q.Update=1]="Update",q[q.DocumentSynced=2]="DocumentSynced",q[q.Remove=3]="Remove",q[q.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",q[q.Retire=5]="Retire",q[q.AddTag=6]="AddTag",q[q.RemoveTag=7]="RemoveTag"})(M||(e.TestDiffOpType=M={}));var z;(function(q){q.deserialize=(B,ee)=>ee.op===M.Add?{op:ee.op,item:d.deserialize(B,ee.item)}:ee.op===M.Update?{op:ee.op,item:l.deserialize(ee.item)}:ee.op===M.DocumentSynced?{op:ee.op,uri:B.asCanonicalUri(r.URI.revive(ee.uri)),docv:ee.docv}:ee,q.serialize=B=>B.op===M.Add?{op:B.op,item:d.serialize(B.item)}:B.op===M.Update?{op:B.op,item:l.serialize(B.item)}:B})(z||(e.TestsDiffOp=z={}));class j{constructor(B){this.l=B,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(B){const ee=this.x();for(const H of B)switch(H.op){case M.Add:this.p(d.deserialize(this.l,H.item),ee);break;case M.Update:this.q(l.deserialize(H.item),ee);break;case M.Remove:this.v(H.itemId,ee);break;case M.Retire:this.w(H.itemId);break;case M.IncrementPendingExtHosts:this.updatePendingRoots(H.amount);break;case M.AddTag:this.f.set(H.tag.id,H.tag);break;case M.RemoveTag:this.f.delete(H.id);break}ee.complete?.()}p(B,ee){const H=R.$$I.parentId(B.item.extId)?.toString();let W;if(!H)W=this.y(B),this.h.add(W),this.g.set(B.item.extId,W);else if(this.g.has(H)){const X=this.g.get(H);X.children.add(B.item.extId),W=this.y(B,X),this.g.set(B.item.extId,W)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(B)}`);return}return ee.add?.(W),B.expand===n.BusyExpanding&&this.j++,W}q(B,ee){const H=this.g.get(B.extId);if(H)return B.expand!==void 0&&(H.expand===n.BusyExpanding&&this.j--,B.expand===n.BusyExpanding&&this.j++),(0,e.$fJ)(H,B),ee.update?.(H),H}v(B,ee){const H=this.g.get(B);if(!H)return;const W=R.$$I.parentId(H.item.extId)?.toString();W?this.g.get(W).children.delete(H.item.extId):this.h.delete(H);const X=[[B]];for(;X.length;)for(const _ of X.pop()){const ce=this.g.get(_);ce&&(X.push(ce.children),this.g.delete(_),ee.remove?.(ce,ce!==H),ce.expand===n.BusyExpanding&&this.j--)}}w(B){}updatePendingRoots(B){this.k+=B}x(){return{}}}e.$hJ=j}),define(ke[264],Ie([1,0,138,8,74]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$TGb=e.$SGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var T;(function(y){y.List="list",y.Tree="true"})(T||(e.TestExplorerViewMode=T={}));var O;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(O||(e.TestExplorerViewSorting=O={}));const b={[A.TestResultState.Errored]:(0,h.localize)(10776,null),[A.TestResultState.Failed]:(0,h.localize)(10777,null),[A.TestResultState.Passed]:(0,h.localize)(10778,null),[A.TestResultState.Queued]:(0,h.localize)(10779,null),[A.TestResultState.Running]:(0,h.localize)(10780,null),[A.TestResultState.Skipped]:(0,h.localize)(10781,null),[A.TestResultState.Unset]:(0,h.localize)(10782,null)},c=(y,u)=>(0,h.localize)(10783,null,(0,r.$1k)(y),b[u]);e.$SGb=c,e.$TGb={[A.TestRunProfileBitset.Debug]:(0,h.localize)(10784,null),[A.TestRunProfileBitset.Run]:(0,h.localize)(10785,null),[A.TestRunProfileBitset.Coverage]:(0,h.localize)(10786,null)};var I;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.GoToRelatedTest="testing.goToRelatedTest",y.PeekRelatedTest="testing.peekRelatedTest",y.GoToRelatedCode="testing.goToRelatedCode",y.PeekRelatedCode="testing.peekRelatedCode",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(ke[120],Ie([1,0,7,4,3,65,74,73]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.TestItemEventOp=void 0;var b;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const c=(f,i)=>f===i,y=Object.entries({range:(f,i)=>f===i?!0:!f||!i?!1:f.equalsRange(i),busy:c,label:c,description:c,error:c,sortText:c,tags:(f,i)=>!(f.length!==i.length||f.some(s=>!i.includes(s)))}),u=(f,i)=>{let s;for(const[t,o]of y)o(f[t],i[t])||(s?s[t]=i[t]:s={[t]:i[t]});return s};class C extends A.$Vc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new r.$Sh(()=>this.flushDiff(),200)),this.g=this.B(new h.$me),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case T.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===T.TestDiffOpType.DocumentSynced&&s.uri===i.uri){s.docv=i.docv;return}break}case T.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===T.TestDiffOpType.Update&&s.item.extId===i.item.extId){(0,T.$fJ)(s.item,i.item);return}if(s.op===T.TestDiffOpType.Add&&s.item.item.extId===i.item.extId){(0,T.$fJ)(s.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,s){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||s>t.expandLevels)&&(t.expandLevels=s),t.expand===T.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,s-1):o.wait().then(()=>this.L(t,s-1))}else if(t.expand===T.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,s-1)):this.L(t,s-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,s){switch(s.op){case b.RemoveChild:this.O(O.$$I.joinToString(i.fullId,s.id));break;case b.Upsert:this.z(s.item,i);break;case b.Bulk:for(const t of s.ops)this.w(i,t);break;case b.SetTags:this.C(s.new,s.old,i.fullId.toString());break;case b.UpdateCanResolveChildren:this.J(i);break;case b.SetProp:this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:s.update}});break;case b.DocumentSynced:this.y(i.actual.uri);break;default:(0,R.$fd)(s)}}y(i){i&&this.pushDiff({op:T.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,s){const t=O.$$I.fromExtHostTestItem(i,this.root.id,s?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==s?.actual&&this.s.getChildren(o.parent).delete(i.id);let n=this.tree.get(t.toString());if(!n){n={fullId:t,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:T.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(n.fullId.toString(),n),this.G(i,s),this.pushDiff({op:T.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(i)}}),this.I(i,n,s);return}if(n.actual===i){this.H(i,n,s);return}if(n.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,s);const d=this.s.getChildren(n.actual),l=n.actual,g=u(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,n.actual=i,n.resolveBarrier=void 0,n.expand=T.TestItemExpandState.NotExpandable,g&&(g.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,t.toString()),delete g.tags),this.w(n,{op:b.SetProp,update:g})),this.I(i,n,s);for(const[S,D]of d)this.s.getChildren(i).get(D.id)||this.O(O.$$I.joinToString(t,D.id));const E=n.expandLevels;E!==void 0&&queueMicrotask(()=>{n.expand===T.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(n.actual.uri)}C(i,s,t){const o=new Set(s.map(n=>n.id));for(const n of i)o.delete(n.id)||this.D(n);this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(n=>(0,T.$dJ)(this.s.controllerId,n.id))}}}),o.forEach(this.F,this)}D(i){const s=this.j.get(i.id);s?s.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:T.TestDiffOpType.AddTag,tag:{id:(0,T.$dJ)(this.s.controllerId,i.id)}}))}F(i){const s=this.j.get(i);s&&!--s.refCount&&(this.j.delete(i),this.pushDiff({op:T.TestDiffOpType.RemoveTag,id:(0,T.$dJ)(this.s.controllerId,i)}))}G(i,s){this.s.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}H(i,s,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=n=>this.w(s,n),this.J(s)}I(i,s,t){this.H(i,s,t);for(const[o,n]of this.s.getChildren(i))this.z(n,s)}J(i){let s;this.h?i.resolveBarrier?s=i.resolveBarrier.isOpen()?T.TestItemExpandState.Expanded:T.TestItemExpandState.BusyExpanding:s=i.actual.canResolveChildren?T.TestItemExpandState.Expandable:T.TestItemExpandState.NotExpandable:s=T.TestItemExpandState.NotExpandable,s!==i.expand&&(i.expand=s,this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:s}}),s===T.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,s){if(s<0)return;const t=[];for(const[o,n]of this.s.getChildren(i.actual)){const d=this.expand(O.$$I.joinToString(i.fullId,n.id),s);(0,r.$sh)(d)&&t.push(d)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const n=new r.$Fh;return n.open(),n}i.expand=T.TestItemExpandState.BusyExpanding,this.N(i);const s=i.resolveBarrier=new r.$Fh,t=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(n){t(n)}return(0,r.$sh)(o)?o.catch(t).then(()=>{s.open(),this.J(i)}):(s.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:T.TestDiffOpType.Remove,itemId:i});const t=[s];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const n of o.actual.tags)this.F(n.id);this.tree.delete(o.fullId.toString());for(const[n,d]of this.s.getChildren(o.actual))t.push(this.tree.get(O.$$I.joinToString(o.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$eQ=C;class w extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$fQ=w;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$gQ=a;class m extends Error{constructor(i,s,t){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${t}".`)}}e.$hQ=m;const $=(f,i,s)=>{let t=new Map;return{get size(){return t.size},forEach(o,n){for(const d of t.values())o.call(n,d,this)},[Symbol.iterator](){return t.entries()},replace(o){const n=new Map,d=new Set(t.keys()),l={op:b.Bulk,ops:[]};for(const g of o){if(!(g instanceof s))throw new a(g.id);const E=i(g).controllerId;if(E!==f.controllerId)throw new m(g.id,E,f.controllerId);if(n.has(g.id))throw new w(g.id);n.set(g.id,g),d.delete(g.id),l.ops.push({op:b.Upsert,item:g})}for(const g of d.keys())l.ops.push({op:b.RemoveChild,id:g});f.listener?.(l),t=n},add(o){if(!(o instanceof s))throw new a(o.id);t.set(o.id,o),f.listener?.({op:b.Upsert,item:o})},delete(o){t.delete(o)&&f.listener?.({op:b.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$iQ=$}),define(ke[156],Ie([1,0,120]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.$jQ=void 0;const h=new WeakMap,A=(T,O)=>{const b={controllerId:O};return h.set(T,b),b};e.$jQ=A;const R=T=>{const O=h.get(T);if(!O)throw new r.$gQ(T?.id||"<unknown>");return O};e.$kQ=R}),define(ke[121],Ie([1,0,26,14,2]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MDb=e.$LDb=e.$KDb=void 0,e.$NDb=R,e.$ODb=O,e.$KDb="vscode-cdn.net",e.$LDb=`vscode-resource.${e.$KDb}`,e.$MDb=`'self' https://*.${e.$KDb}`;function R(b,c){return b.scheme===h.Schemas.http||b.scheme===h.Schemas.https?b:(c&&c.authority&&c.isRemote&&b.scheme===h.Schemas.file&&(b=A.URI.from({scheme:h.Schemas.vscodeRemote,authority:c.authority,path:b.path})),A.URI.from({scheme:h.Schemas.https,authority:`${b.scheme}+${T(b.authority)}.${e.$LDb}`,path:b.path,fragment:b.fragment,query:b.query}))}function T(b){return b.replace(/./g,c=>{const I=c.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?c:"-"+I.toString(16).padStart(4,"0")})}function O(b){return b.replace(/-([0-9a-f]{4})/g,(c,I)=>String.fromCharCode(parseInt(I,16)))}}),define(ke[265],Ie([1,0,4,3,121]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=void 0;class R{constructor(O,b,c){this.d=O,this.e=b,this.f=c,this.a=0,this.b=new h.$Uc,this.c=new Map,this.b.add(b.onDidChangeVisibleTextEditors(()=>{const I=b.getVisibleTextEditors();for(const y of this.c.values())I.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,b,c,I,y){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===O){u=i;break}if(!u)throw new Error("not a visible editor");const C=this,w=this.a++,a=new r.$me,m=new r.$me,$=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,A.$NDb)(i,C.f)}get cspSource(){return A.$MDb}set options(i){this.b=i,C.d.$setOptions(w,i)}get options(){return this.b}set html(i){this.a=i,C.d.$setHtml(w,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return C.d.$postMessage(w,i)}},f=new class{constructor(){this.editor=O,this.line=b,this.height=c,this.webview=$,this.onDidDispose=m.event}dispose(){C.c.has(w)&&(C.c.delete(w),C.d.$disposeEditorInset(w),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(w,u.id,u.value.document.uri,b+1,c,I||{},y.identifier,y.extensionLocation),this.c.set(w,{editor:O,inset:f,onDidReceiveMessage:a}),f}$onDidDispose(O){const b=this.c.get(O);b&&b.inset.dispose()}$onDidReceiveMessage(O,b){this.c.get(O)?.onDidReceiveMessage.fire(b)}}e.$Vpc=R}),define(ke[157],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=e.$QM=void 0,e.$QM="__",e.$RM=(0,r.$Gi)("IAuthenticationService"),e.$SM=(0,r.$Gi)("IAuthenticationExtensionsService")}),define(ke[266],Ie([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=e.VariableKind=e.$cR=void 0,e.$cR=(0,r.$Gi)("configurationResolverService");var h;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class A extends Error{constructor(T,O){super(O),this.variable=T}}e.$dR=A}),define(ke[267],Ie([1,0,16,55,17,24,10,107,8,266,12]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=void 0,r=We(r),h=We(h),A=We(A),R=We(R);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(C,w,a,m){this.h=new Map,this.a=C,this.b=w,this.g=a,m&&(this.c=m.then($=>this.i($)))}i(C){if(T.$j){const w=Object.create(null);return Object.keys(C).forEach(a=>{w[a.toLowerCase()]=C[a]}),w}return C}resolveWithEnvironment(C,w,a){return this.l({env:this.i(C),userHome:void 0},w?w.uri:void 0,a)}async resolveAsync(C,w){const a={env:await this.c,userHome:await this.g};return this.l(a,C?C.uri:void 0,w)}async j(C,w,a,m){const $=R.$fo(w);T.$j&&$.windows?Object.keys($.windows).forEach(i=>$[i]=$.windows[i]):T.$k&&$.osx?Object.keys($.osx).forEach(i=>$[i]=$.osx[i]):T.$l&&$.linux&&Object.keys($.linux).forEach(i=>$[i]=$.linux[i]),delete $.windows,delete $.osx,delete $.linux;const f={env:await this.c,userHome:await this.g};return this.l(f,C?C.uri:void 0,$,a,m)}async resolveAnyAsync(C,w,a){return this.j(C,w,a)}async resolveAnyMap(C,w,a){const m=new Map;return{newConfig:await this.j(C,w,a,m),resolvedVariables:m}}resolveWithInteractionReplace(C,w,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,w,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,w){if(this.h.has(C))throw new Error("Variable "+C+" is contributed twice.");this.h.set(C,w)}async l(C,w,a,m,$){if(A.$fg(a))return this.m(C,w,a,m,$);if(Array.isArray(a))return Promise.all(a.map(f=>this.l(C,w,f,m,$)));if(A.$hg(a)){const f=Object.create(null),i=await Promise.all(Object.keys(a).map(async s=>[await this.m(C,w,s,m,$),await this.l(C,w,a[s],m,$)]));for(const[s,t]of i)f[s]=t;return f}return a}m(C,w,a,m,$){return(0,I.$yf)(a,y.VARIABLE_REGEXP,async(f,i)=>{if(i.includes(y.VARIABLE_LHS))return f;let s=await this.o(C,f,i,w,m);return $?.set(i,s),s!==f&&A.$fg(s)&&s.match(y.VARIABLE_REGEXP)&&(s=await this.m(C,w,s,m,$)),s})}n(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async o(C,w,a,m,$){let f;const i=a.split(":");i.length>1&&(a=i[0],f=i[1]);const s=n=>{const d=this.a.getFilePath();if(d)return(0,O.$3w)(d);throw new c.$dR(n,(0,b.localize)(12027,null,w))},t=n=>{const d=s(n);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,O.$3w)(l)}throw new c.$dR(n,(0,b.localize)(12028,null,w,r.$oc(d)))},o=n=>{if(f){const d=this.a.getFolderUri(f);if(d)return d;throw new c.$dR(n,(0,b.localize)(12029,null,w,f))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new c.$dR(n,(0,b.localize)(12030,null,w)):new c.$dR(n,(0,b.localize)(12031,null,w))};switch(a){case"env":if(f){if(C.env){const n=C.env[T.$j?f.toLowerCase():f];if(A.$fg(n))return n}return""}throw new c.$dR(c.VariableKind.Env,(0,b.localize)(12032,null,w));case"config":if(f){const n=this.a.getConfigurationValue(m,f);if(A.$og(n))throw new c.$dR(c.VariableKind.Config,(0,b.localize)(12033,null,w,f));if(A.$hg(n))throw new c.$dR(c.VariableKind.Config,(0,b.localize)(12034,null,w,f));return n}throw new c.$dR(c.VariableKind.Config,(0,b.localize)(12035,null,w));case"command":return this.p(c.VariableKind.Command,w,f,$,"command");case"input":return this.p(c.VariableKind.Input,w,f,$,"input");case"extensionInstallFolder":if(f){const n=await this.a.getExtension(f);if(!n)throw new c.$dR(c.VariableKind.ExtensionInstallFolder,(0,b.localize)(12036,null,w,f));return this.n(n.extensionLocation)}throw new c.$dR(c.VariableKind.ExtensionInstallFolder,(0,b.localize)(12037,null,w));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,O.$3w)(this.n(o(c.VariableKind.WorkspaceFolder)));case"cwd":return m||f?(0,O.$3w)(this.n(o(c.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.$3w)(r.$oc(this.n(o(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new c.$dR(c.VariableKind.UserHome,(0,b.localize)(12038,null,w))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new c.$dR(c.VariableKind.LineNumber,(0,b.localize)(12039,null,w))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new c.$dR(c.VariableKind.SelectedText,(0,b.localize)(12040,null,w))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return t(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$oc(t(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||f?r.$mc(this.n(o(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const n=r.$nc(s(c.VariableKind.RelativeFileDirname));if(m||f){const d=r.$mc(this.n(o(c.VariableKind.RelativeFileDirname)),n);return d.length===0?".":d}return n}case"fileDirname":return r.$nc(s(c.VariableKind.FileDirname));case"fileExtname":return r.$pc(s(c.VariableKind.FileExtname));case"fileBasename":return r.$oc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=r.$oc(s(c.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-r.$pc(n).length)}case"fileDirnameBasename":return r.$oc(r.$nc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||w}case"execInstallFolder":{const n=this.a.getAppRoot();return n||w}case"pathSeparator":case"/":return r.sep;default:try{const n=f?`${a}:${f}`:a;return this.p(c.VariableKind.Unknown,w,n,$,void 0)}catch{return w}}}}p(C,w,a,m,$){if(a&&m){const f=$===void 0?m[a]:m[$+":"+a];if(typeof f=="string")return f;throw new c.$dR(C,(0,b.localize)(12041,null,w))}return w}}e.$sR=y}),define(ke[158],Ie([1,0,5,153]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$vE=void 0,e.$wE=c,e.$xE=u,e.$yE=C,e.$vE=(0,r.$Gi)("editorGroupsService");var A;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var R;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var T;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var O;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(O||(e.GroupsArrangement=O={}));var b;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function c(w){const a=w;return(0,h.$jG)(a?.editor)&&(0,h.$jG)(a?.replacement)}var I;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var y;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(w){const a=w;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function C(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?A.DOWN:A.RIGHT}}),define(ke[268],Ie([1,0,5,158]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CE=e.$BE=e.$AE=e.$zE=void 0,e.$DE=A,e.$zE=(0,r.$Gi)("editorService"),e.$AE=-1,e.$BE=-2,e.$CE=-3;function A(R){const T=R;return typeof R=="number"||(0,h.$xE)(T)}}),define(ke[159],Ie([1,0,5,145]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0,e.$_M=(0,r.$Hi)(h.$Ni)}),define(ke[160],Ie([1,0,23,4,16,3,7]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=e.$Ydc=e.$Xdc=e.$Wdc=void 0,A=We(A);class O{constructor(f,i){this.versionId=f,this.removedDueToLooping=i}}e.$Wdc=O;class b{static isHostExtension(f,i,s){if(i.getExtensionDescription(f))return!1;const t=s.getExtensionDescription(f);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(f,i){this.j=f,this.c=new h.$me,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new r.$un,this.g=[],this.h=new Map;for(const f of this.e){if(this.f.has(f.identifier)){console.error("Extension `"+f.identifier.value+"` is already registered");continue}this.f.set(f.identifier,f),this.g.push(f);const i=this.j.readActivationEvents(f);for(const s of i)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(f)}}set(f){return this.e=f,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(f,i){this.e=m(this.e,i),this.e=this.e.concat(f);const s=b.l(this.e);return this.e=m(this.e,s.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new O(this.d,s)}static l(f){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const g=i.getArcs(d);for(let E=0;E<g.length;E++)if(!l.has(g[E]))return!1;return!0}getNodes(){return this.e}},s=new r.$un;for(const d of f)if(s.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(r.$sn.toKey(d.identifier),r.$sn.toKey(l));const t=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>t.add(d));const o=i.getNodes().filter(d=>!t.has(d));let n;do{n=!1;for(let d=0;d<o.length;d++){const l=o[d];i.hasOnlyGoodArcs(l,t)&&(o.splice(d,1),d--,t.add(l),n=!0)}}while(n);return o.map(d=>s.get(d))}containsActivationEvent(f){return this.h.has(f)}containsExtension(f){return this.f.has(f)}getExtensionDescriptionsForActivationEvent(f){const i=this.h.get(f);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(f){const i=this.f.get(f);return i||void 0}getExtensionDescriptionByUUID(f){for(const i of this.g)if(i.uuid===f)return i}getExtensionDescriptionByIdOrUUID(f,i){return this.getExtensionDescription(f)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Xdc=b;class c{constructor(f,i){this.versionId=f,this.extensions=i}}e.$Ydc=c;class I{constructor(f){this.d=new C,this.c=new b(f,[])}async acquireLock(f){const i=await this.d.acquire(f);return new y(this,i)}deltaExtensions(f,i,s){if(!f.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(f){return this.c.containsActivationEvent(f)}containsExtension(f){return this.c.containsExtension(f)}getExtensionDescriptionsForActivationEvent(f){return this.c.getExtensionDescriptionsForActivationEvent(f)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(f){return this.c.getExtensionDescription(f)}getExtensionDescriptionByUUID(f){return this.c.getExtensionDescriptionByUUID(f)}getExtensionDescriptionByIdOrUUID(f,i){return this.c.getExtensionDescriptionByIdOrUUID(f,i)}}e.$Zdc=I;class y extends R.$Vc{constructor(f,i){super(),this.f=f,this.c=!1,this.B(i)}isAcquiredFor(f){return!this.c&&this.f===f}}e.$1dc=y;class u{constructor(f){this.name=f;const i=(0,T.$zh)();this.promise=i.promise,this.c=i.resolve}resolve(f){this.c(f)}}class C{constructor(){this.c=[],this.d=!1}async acquire(f){const i=new u(f);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const f=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${f.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};f.resolve((0,R.$Tc)(t))}}var w;(function($){$[$.Builtin=0]="Builtin",$[$.User=1]="User",$[$.Dev=2]="Dev"})(w||(w={}));function a($,f){const i=$.isBuiltin?w.Builtin:$.isUnderDevelopment?w.Dev:w.User,s=f.isBuiltin?w.Builtin:f.isUnderDevelopment?w.Dev:w.User;if(i!==s)return i-s;const t=A.$hc.basename($.extensionLocation.path),o=A.$hc.basename(f.extensionLocation.path);return t<o?-1:t>o?1:0}function m($,f){const i=new r.$tn(f);return $.filter(s=>!i.has(s.identifier))}}),define(ke[269],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.ExtHostConnectionType=void 0,e.$gn=O,e.$hn=b;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(y){this.pipeName=y,this.type=r.IPC}serialize(y){y[h.ENV_KEY]=this.pipeName}}e.$dn=h;class A{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(y){y[A.ENV_KEY]="1"}}e.$en=A;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(y){y[R.ENV_KEY]="1"}}e.$fn=R;function T(I){delete I[h.ENV_KEY],delete I[A.ENV_KEY],delete I[R.ENV_KEY]}function O(I,y){T(y),I.serialize(y)}function b(I){if(I[h.ENV_KEY])return c(I,new h(I[h.ENV_KEY]));if(I[A.ENV_KEY])return c(I,new A);if(I[R.ENV_KEY])return c(I,new R);throw new Error("No connection information defined in environment!")}function c(I,y){return T(I),y}}),define(ke[93],Ie([1,0,21]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Cn=T,e.$Dn=O;var h;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(h||(e.UIKind=h={}));var A;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var R;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function T(c){const I=r.$Oe.alloc(1);switch(c){case R.Initialized:I.writeUInt8(1,0);break;case R.Ready:I.writeUInt8(2,0);break;case R.Terminate:I.writeUInt8(3,0);break}return I}function O(c,I){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return I===R.Initialized;case 2:return I===R.Ready;case 3:return I===R.Terminate;default:return!1}}var b;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ke[94],Ie([1,0,5,4,150,11,29,93,90,91,24,2,3,8]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=e.$GQ=e.$FQ=void 0,e.$HQ=m;let w=class extends u.$Vc{constructor(f,i){super(),this.s=f,this.t=i,this.a=this.B(new h.$me),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$me),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=A.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:c.$Dp,name:(0,C.localize)(2696,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(s=>{(0,R.$dk)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===A.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=A.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=A.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=A.TelemetryLevel.USAGE:!1}}instantiateLogger(f,i,s){const t=this.getTelemetryDetails(),o=new a(i,s,f,this.n,this.j,this.getBuiltInCommonProperties(f),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),n=this.r.get(f.identifier.value)??[];return this.r.set(f.identifier.value,[...n,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(f,i,s){this.f=f,this.g=i,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(f){const i=Object.create(null);switch(i["common.extname"]=`${f.publisher}.${f.name}`,i["common.extversion"]=f.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case O.UIKind.Web:i["common.uikind"]="web";break;case O.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$jn)((0,c.$Jp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const i=this.getTelemetryDetails();this.r.forEach((s,t)=>{const o=s.filter(n=>!n.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(s=>{for(const t of s)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(f,i){const t=this.r.get(f.value)?.filter(n=>!n.isDisposed);if(!t)return this.r.delete(f.value),!1;let o=!1;for(const n of t)n.ignoreUnhandledExtHostErrors||(n.logError(i),o=!0);return o}};e.$FQ=w,e.$FQ=w=Je([Ve(0,T.$EQ),Ve(1,R.$ck)],w);class a{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,i,s,t,o,n,d){this.g=s,this.h=t,this.i=o,this.j=n,this.a=new h.$me,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(f,i){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let i="properties"in f?f.properties??{}:f;return i=(0,c.$Mp)(i,[]),this.c&&(i=(0,I.$io)(i,this.c)),this.b||(i=(0,I.$io)(i,this.j)),"properties"in f?f.properties=i:f=i,f}k(f,i){this.f&&(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(f,i),this.h.trace(f,i))}logUsage(f,i){this.d.isUsageEnabled&&this.k(f,i)}logError(f,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof f=="string")this.k(f,i);else{const s={name:f.name,message:f.message,stack:f.stack,cause:f.cause},t=(0,c.$Mp)(s,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const f=this,i={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.$GQ=a;function m($){const f=Date.now()-new Date($).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.$IQ=(0,r.$Gi)("IExtHostTelemetry")}),define(ke[25],Ie([1,0,4,2,240,148,23,5]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oH=e.ActivationKind=e.$lH=e.$kH=e.$hH=e.ExtensionHostStartup=e.$gH=e.$fH=e.$eH=e.$dH=void 0,e.$iH=u,e.$jH=C,e.$mH=$,e.$nH=f,e.$dH=Object.freeze({identifier:new T.$sn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:T.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$eH="extensions.webWorker",e.$fH=(0,O.$Gi)("extensionService");class b{constructor(t){this.dependency=t}}e.$gH=b;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,n){this.c=t,this.d=o.slice(0),this.e=n.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$2G.createActivationEventsMap(this.d)}}set(t,o,n){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const d=[],l=[],g=[],E=[],S=y(this.d),D=y(o),k=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=D.get(N.identifier);if(!L){d.push(N.identifier),S.delete(N.identifier);continue}if(!k(N,L)){d.push(N.identifier),S.delete(N.identifier);continue}}for(const N of o){const L=S.get(N.identifier);if(!L){l.push(N);continue}if(!k(L,N)){d.push(L.identifier),S.delete(L.identifier);continue}}const P=new T.$tn(this.e),p=new T.$tn(n);for(const N of this.e)p.has(N)||g.push(N);for(const N of n)P.has(N)||E.push(N);const v=R.$2G.createActivationEventsMap(l),F={versionId:t,toRemove:d,toAdd:l,addActivationEvents:v,myToRemove:g,myToAdd:E};return this.delta(F),F}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:n,myToRemove:d,myToAdd:l}=t,g=new T.$tn(o),E=new T.$tn(d);for(let S=0;S<this.d.length;S++)g.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)E.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of n)this.d.push(S);for(const S of l)this.e.push(S);return this.f=null,t}containsExtension(t){for(const o of this.e)if(T.$sn.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const n=R.$2G.readActivationEvents(o);for(const d of n)t.add(d)}return t}}e.$hH=I;function y(s){const t=new T.$un;for(const o of s)t.set(o.identifier,o);return t}function u(s,t){return s.enabledApiProposals?s.enabledApiProposals.includes(t):!1}function C(s,t){if(!u(s,t))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class w{constructor(t,o,n,d){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=n,this.activationReason=d}}e.$kH=w;class a{constructor(t,o){this.description=t,this.value=o}}e.$lH=a;var m;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function $(s){return{type:s.isBuiltin?T.ExtensionType.System:T.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,A.$Sp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function f(s,t){const o=(0,A.$Qp)(s.manifest.publisher,s.manifest.name);return{id:o,identifier:new T.$sn(o),isBuiltin:s.type===T.ExtensionType.System,isUserBuiltin:s.type===T.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!t,extensionLocation:s.location,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName,...s.manifest}}class i{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$oH=i}),define(ke[270],Ie([1,0,13,3,160,23,25,11,7]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=e.$iqc=e.$hqc=e.$gqc=e.$fqc=void 0,r=We(r);class c{static{this.NONE=new c(!1,-1,-1,-1)}constructor(f,i,s,t){this.startup=f,this.codeLoadingTime=i,this.activateCallTime=s,this.activateResolvedTime=t}}e.$fqc=c;class I{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,i){return f===-1||i===-1?-1:i-f}build(){return new c(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$gqc=I;class y{constructor(f,i,s,t,o,n){this.activationFailed=f,this.activationFailedError=i,this.activationTimes=s,this.module=t,this.exports=o,this.disposable=n}}e.$hqc=y;class u extends y{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,h.$Vc.None)}}e.$iqc=u;class C extends y{constructor(){super(!1,null,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Vc.None)}}e.$jqc=C;class w extends y{constructor(f){super(!0,f,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Vc.None)}}let a=class{constructor(f,i,s,t){this.g=t,this.a=f,this.b=i,this.c=s,this.d=new R.$un,this.f=Object.create(null)}dispose(){for(const[f,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const f=[];for(const[i,s]of this.d)f.push(s.wait());await Promise.all(f)}isActivated(f){const i=this.d.get(f);return!!(i&&i.value)}getActivatedExtension(f){const i=this.d.get(f);if(!i||!i.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return i.value}async activateByEvent(f,i){if(this.f[f])return;const s=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(s.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,i){const s=this.a.getExtensionDescription(f);if(!s)throw new Error(`Extension '${f.value}' is not known`);return this.h([{id:s.identifier,reason:i}])}async h(f){const i=f.filter(s=>!this.isActivated(s.id)).map(s=>this.j(s));await Promise.all(i.map(s=>s.wait()))}j(f){if(this.d.has(f.id))return this.d.get(f.id);if(this.l(f.id))return this.k(f,null,[],null);const i=this.a.getExtensionDescription(f.id);if(!i){const o=new Error(`Cannot activate unknown extension '${f.id.value}'`),n=this.k(f,null,[],new w(o));return this.c.onExtensionActivationError(f.id,o,new T.$gH(f.id.value)),n}const s=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const n=this.d.get(o);if(n){s.push(n);continue}if(this.l(o)){s.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:f.reason}));continue}const d=this.a.getExtensionDescription(o);if(d){if(!d.main&&!d.browser)continue;s.push(this.j({id:d.identifier,reason:f.reason}));continue}const l=i.displayName||i.identifier.value,g=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${o}'`),E=this.k(f,i.displayName,[],new w(g));return this.c.onExtensionActivationError(i.identifier,g,new T.$gH(o)),E}return this.k(f,i.displayName,s,null)}k(f,i,s,t){const o=new m(f.id,i,f.reason,s,t,this.c,this.g);return this.d.set(f.id,o),o}l(f){return A.$Xdc.isHostExtension(f,this.a,this.b)}m(f){const i=this.b.getExtensionDescription(f);return i?!i.main&&!i.browser:!1}};e.$kqc=a,e.$kqc=a=Je([Ve(3,O.$bk)],a);let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,i,s,t,o,n,d){this.c=f,this.d=i,this.f=s,this.g=t,this.h=o,this.j=n,this.k=d,this.a=new b.$Fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const i=this.g[f];if(i.value&&!i.value.activationFailed){this.g.splice(f,1),f--;continue}if(i.value&&i.value.activationFailed){const s=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);s.detail=i.value.activationFailedError,this.h=new w(s),this.j.onExtensionActivationError(this.c,s,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const i=new Error;if(f&&f.name&&(i.name=f.name),f&&f.message?i.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(i.stack=f.stack),this.h=new w(i),this.b&&r.$4(f))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};m=Je([Ve(6,O.$bk)],m)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[161],Ie([1,0,8,13,43,147,116,36,23,115,148,144]),function($e,e,r,h,A,R,T,O,b,c,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=void 0,r=We(r),A=Ut(A);const u=O.$so.as(T.$to.JSONContribution);class C{constructor(t,o,n){this.a=t,this.b=o,this.c=n}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(A.default.Error,t)}warn(t){this.d(A.default.Warning,t)}info(t){this.d(A.default.Info,t)}}e.$0G=C;class w{static a(t){const o=new b.$tn;for(let n=0,d=t.length;n<d;n++)o.add(t[n].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new w(o,[]);if(!o||!o.length)return new w([],t);const n=this.a(t),d=this.a(o),l=o.filter(E=>!n.has(E.description.identifier)),g=t.filter(E=>!d.has(E.description.identifier));return new w(l,g)}constructor(t,o){this.added=t,this.removed=o}}e.$$G=w;class a{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=w.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$Z)(t)}}}e.$_G=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(12196,null),r.localize(12197,null)]},$="vscode://schemas/vscode-extensions";e.$aH={properties:{engines:{type:"object",description:r.localize(12198,null),properties:{vscode:{type:"string",description:r.localize(12199,null),default:"^1.22.0"}}},publisher:{description:r.localize(12200,null),type:"string"},displayName:{description:r.localize(12201,null),type:"string"},categories:{description:r.localize(12202,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.$rn},{type:"string",const:"Languages",deprecationMessage:r.localize(12203,null)}]}},galleryBanner:{type:"object",description:r.localize(12204,null),properties:{color:{description:r.localize(12205,null),type:"string"},theme:{description:r.localize(12206,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(12207,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12208,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(12209,null)},enabledApiProposals:{markdownDescription:r.localize(12210,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(s=>s),markdownEnumDescriptions:Object.values(y.allApiProposals).map(s=>s.proposal)}},api:{markdownDescription:r.localize(12211,null),type:"string",enum:["none"],enumDescriptions:[r.localize(12212,null)]},activationEvents:{description:r.localize(12213,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(12214,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(12215,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(12216,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(12217,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(12218,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(12219,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(12220,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(12221,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(12222,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(12223,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(12224,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(12225,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(12226,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(12227,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(12228,null)},{label:"onUri",body:"onUri",description:r.localize(12229,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(12230,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(12231,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(12232,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(12233,null)},{label:"onRenderer",description:r.localize(12234,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(12235,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(12236,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(12237,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(12238,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:r.localize(12239,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:r.localize(12240,null)},{label:"*",description:r.localize(12241,null),body:"*"}]}},badges:{type:"array",description:r.localize(12242,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(12243,null)},href:{type:"string",description:r.localize(12244,null)},description:{type:"string",description:r.localize(12245,null)}}}},markdown:{type:"string",description:r.localize(12246,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(12247,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(12248,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$_o}},extensionPack:{description:r.localize(12249,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$_o}},extensionKind:{description:r.localize(12250,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(12251,null)},{body:["workspace"],description:r.localize(12252,null)},{body:["ui","workspace"],description:r.localize(12253,null)},{body:["workspace","ui"],description:r.localize(12254,null)},{body:[],description:r.localize(12255,null)}]},capabilities:{description:r.localize(12256,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(12257,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(12258,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(12259,null),r.localize(12260,null),r.localize(12261,null)]},description:{type:"string",markdownDescription:r.localize(12262,null)}}},untrustedWorkspaces:{description:r.localize(12263,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(12264,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(12265,null),r.localize(12266,null),r.localize(12267,null)]},restrictedConfigurations:{description:r.localize(12268,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(12269,null)}}}}},sponsor:{description:r.localize(12270,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(12271,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(12272,null),type:"string"},"vscode:uninstall":{description:r.localize(12273,null),type:"string"}}},icon:{type:"string",description:r.localize(12274,null)},l10n:{type:"string",description:r.localize(12275,null)},pricing:{type:"string",markdownDescription:r.localize(12276,null),enum:["Free","Trial"],default:"Free"}}};class f{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new a(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&I.$2G.register(t.extensionPoint,t.activationEventsGenerator),e.$aH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema($,e.$aH),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$bH=f;const i={ExtensionsRegistry:"ExtensionsRegistry"};O.$so.add(i.ExtensionsRegistry,new f),e.$cH=O.$so.as(i.ExtensionsRegistry),u.registerSchema($,e.$aH),u.registerSchema(c.$vk,{properties:{extensionEnabledApiProposals:{description:r.localize(12277,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(s=>s.proposal)}}]}}}})}),define(ke[271],Ie([1,0,4,39,3,12,8,23,5,11,25,161]),function($e,e,r,h,A,R,T,O,b,c,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rH=e.$qH=e.$pH=e.ChatMessageRole=void 0;var u;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$pH=(0,b.$Gi)("ILanguageModelsService");const C={type:"object",properties:{vendor:{type:"string",description:(0,T.localize)(4692,null)}}};e.$qH=y.$cH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,T.localize)(4693,null),oneOf:[C,{type:"array",items:C}]},activationEventsGenerator:(a,m)=>{for(const $ of a)m.push(`onLanguageModelChat:${$.vendor}`)}});let w=class{constructor(m,$){this.e=m,this.f=$,this.a=new A.$Uc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$me),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$qH.setHandler(f=>{this.c.clear();for(const s of f){if(!(0,I.$iH)(s.description,"chatProvider")){s.collector.error((0,T.localize)(4694,null));continue}for(const t of h.Iterable.wrap(s.value)){if(this.c.has(t.vendor)){s.collector.error((0,T.localize)(4695,null,t.vendor));continue}if((0,R.$df)(t.vendor)){s.collector.error((0,T.localize)(4696,null));continue}if(t.vendor.trim()!==t.vendor){s.collector.error((0,T.localize)(4697,null));continue}this.c.add(t.vendor)}}const i=[];for(const[s,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(s),i.push(s));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const f=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(f)}const $=[];for(const[f,i]of this.b)(m.vendor===void 0||i.metadata.vendor===m.vendor)&&(m.family===void 0||i.metadata.family===m.family)&&(m.version===void 0||i.metadata.version===m.version)&&(m.identifier===void 0||i.metadata.id===m.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(s=>O.$sn.equals(s,m.extension)))&&$.push(f);return this.f.trace("[LM] selected language models",m,$),$}registerLanguageModelChat(m,$){if(this.f.trace("[LM] registering language model chat",m,$.metadata),!this.c.has($.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${$.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,$),this.d.fire({added:[{identifier:m,metadata:$.metadata}]}),(0,A.$Tc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,$.metadata))})}async sendChatRequest(m,$,f,i,s){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(f,$,i,s)}computeTokenLength(m,$,f){const i=this.b.get(m);if(!i)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return i.provideTokenCount($,f)}};e.$rH=w,e.$rH=w=Je([Ve(0,I.$fH),Ve(1,c.$bk)],w)}),define(ke[272],Ie([1,0,8,17,24,161,35,4]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YI=void 0,r=We(r),h=We(h),A=We(A);const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(9818,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(9819,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(9820,null),default:""}}};var c;(function(u){function C(w,a,m){if(!w)return;const $=h.$fg(w.type)?w.type:void 0;if(!$||$.length===0){m.error(r.localize(9821,null));return}const f=[];if(Array.isArray(w.required))for(const i of w.required)h.$fg(i)&&f.push(i);return{extensionId:a.value,taskType:$,required:f,properties:w.properties?A.$fo(w.properties):{},when:w.when?T.$Ej.deserialize(w.when):void 0}}u.from=C})(c||(c={}));const I=R.$cH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,C)=>{for(const w of u)w.type&&C.push(`onTaskType:${w.type}`)},jsonSchema:{description:r.localize(9822,null),type:"array",items:b}});class y{constructor(){this.d=new O.$me,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,w)=>{I.setHandler((a,m)=>{this.c=void 0;try{for(const $ of m.removed){const f=$.value;for(const i of f)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const $ of m.added){const f=$.value;for(const i of f){const s=c.from(i,$.description.identifier,$.collector);s&&(this.a[s.taskType]=s)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const w of this.all()){const a={type:"object",additionalProperties:!1};w.required.length>0&&(a.required=w.required.slice(0)),w.properties!==void 0?a.properties=A.$fo(w.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[w.taskType]},C.push(a)}this.c={oneOf:C}}return this.c}}e.$YI=new y}),define(ke[273],Ie([1,0,8,17,22,24,35,272,46]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$9I=e.JsonSchemaVersion=e.ExecutionEngine=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$3I=e.ShellQuoting=e.$2I=e.$1I=e.$ZI=void 0,r=We(r),h=We(h),A=We(A),R=We(R),e.$ZI="settings",e.$1I=new T.$Xj("taskRunning",!1,r.localize(9823,null)),e.$2I=r.localize2(9825,"Tasks");var c;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$3I="$customized",function(j){function q(B){if(!B)return j.Strong;switch(B.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=q}(c||(e.ShellQuoting=c={}));var I;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var y;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(y||(e.RevealKind=y={})),function(j){function q(B){switch(B.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=q}(y||(e.RevealKind=y={}));var u;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(j){function q(B){switch(B.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=q}(u||(e.RevealProblemKind=u={}));var C;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(C||(e.PanelKind=C={})),function(j){function q(B){switch(B.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=q}(C||(e.PanelKind=C={}));var w;(function(j){j.defaults={echo:!0,reveal:y.Always,revealProblems:u.Never,focus:!1,panel:C.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var a;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(j){function q(ee){switch(ee.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=q;function B(ee){switch(ee){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=B}(a||(e.RuntimeType=a={}));var m;(function(j){function q(B){return h.$fg(B)?B:B.value}j.value=q})(m||(e.CommandString=m={}));var $;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function q(ee){return ee===j.Clean._id||ee===j.Build._id||ee===j.Rebuild._id||ee===j.Test._id}j.is=q;function B(ee){if(ee!==void 0)return h.$fg(ee)?q(ee)?{_id:ee,isDefault:!1}:void 0:ee}j.from=B})($||(e.TaskGroup=$={}));var f;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(f||(e.TaskScope=f={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function q(B){switch(B){case j.User:return b.ConfigurationTarget.USER;case j.WorkspaceFile:return b.ConfigurationTarget.WORKSPACE;default:return b.ConfigurationTarget.WORKSPACE_FOLDER}}j.toConfigurationTarget=q})(i||(e.TaskSourceKind=i={}));var s;(function(j){j.parallel="parallel",j.sequence="sequence"})(s||(e.DependsOrder=s={}));var t;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class n{constructor(q,B,ee,H,W,X){this._label="",this._id=q,B&&(this._label=B),ee&&(this.type=ee),this.runOptions=H,this.configurationProperties=W,this._source=X}getDefinition(q){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const q={folder:this.d(),id:this._id};return JSON.stringify(q)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(q,B=!1){if(q===void 0)return!1;if(h.$fg(q))return q===this._label||q===this.configurationProperties.identifier||B&&q===this._id;const ee=this.getDefinition(!0);return ee!==void 0&&ee._key===q._key}getQualifiedLabel(){const q=this.getWorkspaceFolder();return q?`${this._label} (${q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(q){this.c===void 0&&(this.c=[]),q&&(this.c=this.c.concat(q))}get taskLoadMessages(){return this.c}}e.$4I=n;class d extends n{constructor(q,B,ee,H,W,X,_,ce){super(q,ee,void 0,_,ce,B),this.command={},this._source=B,this.hasDefinedMatchers=X,W&&(this.command=W)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(q=!1){if(q&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case a.Shell:B="shell";break;case a.Process:B="process";break;case a.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(q){return q instanceof d}getMapKey(){const q=this._source.config.workspaceFolder;return q?`${q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$ZI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const q=this.d();if(!q)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const ee={type:e.$3I,folder:q,id:B};return JSON.stringify(ee)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$eh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(q){return new d(q._id,q._source,q._label,q.type,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.$5I=d;class l extends n{constructor(q,B,ee,H,W,X,_){super(q,ee,H,X,_,B),this._source=B,this.configures=W}static is(q){return q instanceof l}f(q){return q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$eh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$ZI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const q=this.d();if(!q)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const ee={type:e.$3I,folder:q,id:B};return JSON.stringify(ee)}}e.$6I=l;class g extends n{constructor(q,B,ee,H,W,X,_,ce,ne){super(q,ee,H,ce,ne,B),this.defines=W,this.hasDefinedMatchers=_,this.command=X,this.icon=ne.icon,this.hide=ne.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(q){return q instanceof g}getMapKey(){const q=this._source.workspaceFolder;return q?`${this._source.scope.toString()}|${q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===f.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const q={type:"contributed",scope:this._source.scope,id:this._id};return q.folder=this.d(),JSON.stringify(q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(q){return new g(q._id,q._source,q._label,q.type,q.defines,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.$7I=g;class E extends n{constructor(q,B,ee,H,W,X){super(q,ee,H,W,X,B),this._source=B}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(q){return q instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(q){return new E(q._id,q._source,q._label,q.type,q.runOptions,q.configurationProperties)}}e.$8I=E;var S;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(j){j._default=j.Terminal}(S||(e.ExecutionEngine=S={}));var D;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class k{constructor(q){this.c=new Map;for(let B=0;B<q.length;B++)this.c.set(q[B].uri.toString(),B)}compare(q,B){const ee=q.getWorkspaceFolder(),H=B.getWorkspaceFolder();if(ee&&H){let W=this.c.get(ee.uri.toString());W=W===void 0?0:W+1;let X=this.c.get(H.uri.toString());return X=X===void 0?0:X+1,W===X?q._label.localeCompare(B._label):W-X}else return!ee&&H?-1:ee&&!H?1:0}}e.$9I=k;var P;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(P||(e.TaskEventKind=P={}));var p;(function(j){j.SingleRun="singleRun",j.Background="background"})(p||(e.TaskRunType=p={}));var v;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var F;(function(j){function q(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?p.Background:p.SingleRun,group:ce.configurationProperties.group,__task:ce}}function B(ce,ne,ye){return{...q(ce),kind:P.Start,terminalId:ne,resolvedVariables:ye}}j.start=B;function ee(ce,ne,ye){return{...q(ce),kind:P.ProcessStarted,terminalId:ne,processId:ye}}j.processStarted=ee;function H(ce,ne,ye){return{...q(ce),kind:P.ProcessEnded,terminalId:ne,exitCode:ye}}j.processEnded=H;function W(ce,ne,ye){return{...q(ce),kind:P.Terminated,exitReason:ye,terminalId:ne}}j.terminated=W;function X(ce,ne,ye){return{...q(ne),kind:ce,terminalId:ye}}j.general=X;function _(){return{kind:P.Changed}}j.changed=_})(F||(e.TaskEvent=F={}));var N;(function(j){function q(ee){const H=Object.keys(ee).sort();let W="";for(const X of H){let _=ee[X];_ instanceof Object?_=q(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),W+=X+","+_+","}return W}function B(ee){const W={_key:q(ee),type:ee.taskType};return Object.assign(W,ee),W}j.create=B})(N||(e.KeyedTaskIdentifier=N={}));var L;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var M;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var z;(function(j){function q(B,ee){const H=O.$YI.get(B.type);if(H===void 0){const ce=R.$fo(B);return delete ce._key,N.create(ce)}const W=Object.create(null);W.type=H.taskType;const X=new Set;H.required.forEach(ce=>X.add(ce));const _=H.properties;for(const ce of Object.keys(_)){const ne=B[ce];if(ne!=null)W[ce]=ne;else if(X.has(ce)){const ye=_[ce];if(ye.default!==void 0)W[ce]=R.$fo(ye.default);else switch(ye.type){case"boolean":W[ce]=!1;break;case"number":case"integer":W[ce]=0;break;case"string":W[ce]="";break;default:ee.error(r.localize(9824,null,JSON.stringify(B,void 0,0),ce));return}}}return N.create(W)}j.createTaskIdentifier=q})(z||(e.TaskDefinition=z={}))}),define(ke[274],Ie([1,0,13]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((T,O)=>{this.b=T,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(T){this.f||this.h||(this.f=!0,this.g=T,this.a&&this.b(T))}resolveErr(T){this.f||this.h||(this.h=!0,this.i=T,this.a?this.d(T):(0,r.$Z)(T))}then(T,O){return this.j().then(T,O)}catch(T){return this.j().then(void 0,T)}finally(T){return this.j().finally(T)}}e.$2dc=h;class A extends h{constructor(){super(),this.h=!0,this.i=new r.$5}}e.$3dc=A}),define(ke[53],Ie([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zw=e.$Ww=void 0,e.$Xw=A,e.$Yw=R;class r{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++r.count}}e.$Ww=r;const h=[];function A(O){const b=new r(O);return h[b.nid]=b,b}function R(O){return h[O].sid}class T{constructor(b){this.value=b}}e.$Zw=T}),define(ke[6],Ie([1,0,53]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=e.$ON=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$NN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var A;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var T;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var O;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(O||(e.WebviewMessageArrayBufferViewType=O={}));var b;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var c;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class y{static{this.a=0}static mixin(m){return m._id=y.a++,m}}e.$NN=y;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var C;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(C||(e.ISuggestResultDtoField=C={}));var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$ON={MainThreadAuthentication:(0,r.$Xw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Xw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Xw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Xw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Xw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Xw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,r.$Xw)("MainThreadChatSkills"),MainThreadClipboard:(0,r.$Xw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Xw)("MainThreadCommands"),MainThreadComments:(0,r.$Xw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Xw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Xw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Xw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Xw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Xw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Xw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Xw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Xw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Xw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Xw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Xw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Xw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Xw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Xw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Xw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Xw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Xw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Xw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Xw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Xw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Xw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Xw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Xw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Xw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Xw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Xw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Xw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Xw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Xw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Xw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Xw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Xw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Xw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Xw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Xw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Xw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Xw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Xw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Xw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Xw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Xw)("MainThreadSCM"),MainThreadSearch:(0,r.$Xw)("MainThreadSearch"),MainThreadShare:(0,r.$Xw)("MainThreadShare"),MainThreadTask:(0,r.$Xw)("MainThreadTask"),MainThreadWindow:(0,r.$Xw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Xw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Xw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Xw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Xw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Xw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Xw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Xw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Xw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Xw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Xw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Xw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Xw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Xw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Xw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Xw)("MainThreadAiEmbeddingVector")},e.$PN={ExtHostCommands:(0,r.$Xw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Xw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Xw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Xw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Xw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Xw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Xw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Xw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Xw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Xw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Xw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Xw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Xw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Xw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Xw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Xw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Xw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Xw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Xw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Xw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Xw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Xw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Xw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Xw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Xw)("ExtHostSCM"),ExtHostSearch:(0,r.$Xw)("ExtHostSearch"),ExtHostTask:(0,r.$Xw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Xw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Xw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Xw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Xw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Xw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Xw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Xw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Xw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Xw)("ExtHostProgress"),ExtHostComments:(0,r.$Xw)("ExtHostComments"),ExtHostSecretState:(0,r.$Xw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Xw)("ExtHostStorage"),ExtHostUrls:(0,r.$Xw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Xw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Xw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Xw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Xw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Xw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Xw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Xw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Xw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Xw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Xw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Xw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Xw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Xw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,r.$Xw)("ExtHostChatSkills"),ExtHostChatProvider:(0,r.$Xw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Xw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Xw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Xw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Xw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Xw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Xw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Xw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Xw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Xw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Xw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Xw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Xw)("ExtHostLocalization")}}),define(ke[95],Ie([1,0,5,11,6,19]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=e.$Fpc=e.$Epc=void 0,A=We(A),e.$Epc=(0,r.$Gi)("IExtHostApiDeprecationService");let T=class{constructor(b,c){this.c=c,this.a=new Set,this.b=b.getProxy(A.$ON.MainThreadTelemetry)}report(b,c,I){const y=this.d(b,c);this.a.has(y)||(this.a.add(y),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${b}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:b}))}d(b,c){return`${b}-${c.identifier.value}`}};e.$Fpc=T,e.$Fpc=T=Je([Ve(0,R.$oQ),Ve(1,h.$bk)],T),e.$Gpc=Object.freeze(new class{report(O,b,c){}})}),define(ke[275],Ie([1,0,6]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=void 0;class h{constructor(R){const T=R.getProxy(r.$ON.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(O){return T.$writeText(O)}})}}e.$Tpc=h}),define(ke[276],Ie([1,0,24,6,29,19]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=void 0;let T=class{constructor(I,y){this.a=I.getProxy(h.$ON.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,y){const u=this,C=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,y,C,arguments)}})}e(I,y,u,C){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:b(C,this.b)}),this.c&&this.f(I,u,C)}};e.$Prc=T,e.$Prc=T=Je([Ve(0,R.$oQ),Ve(1,A.$EQ)],T);const O=1e5;function b(c,I){const y=[];if(c.length)for(let u=0;u<c.length;u++){let C=c[u];if(typeof C>"u")C="undefined";else if(C instanceof Error){const w=C;w.stack?C=w.stack:C=w.toString()}y.push(C)}if(I){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$ko)(y);return u.length>O?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(ke[277],Ie([1,0,2,6,25]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vqc=void 0;class R{constructor(O){this.a=O.getProxy(h.$ON.MainThreadDialogs)}showOpenDialog(O,b){return b?.allowUIResources&&(0,A.$jH)(O,"showLocal"),this.a.$showOpenDialog(b).then(c=>c?c.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(O){return this.a.$showSaveDialog(O).then(b=>b?r.URI.revive(b):void 0)}}e.$Vqc=R}),define(ke[278],Ie([1,0,20,4,3,6]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=void 0;class T{constructor(b){this.b=new Map,this.c=new h.$me,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=b.getProxy(R.$ON.MainThreadEmbeddings)}registerEmbeddingsProvider(b,c,I){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,c),this.b.set(y,{id:c,provider:I}),(0,A.$Tc)(()=>{this.d.delete(c),this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings(b,c,I){I??=r.CancellationToken.None;let y=!1;typeof c=="string"&&(c=[c],y=!0);const u=await this.a.$computeEmbeddings(b,c,I);if(u.length!==c.length)throw new Error;if(y){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(b,c,I){const y=this.b.get(b);if(!y)return[];const u=await y.provider.provideEmbeddings(c,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(b){this.d=new Set(b),this.c.fire()}}e.$Yqc=T}),define(ke[279],Ie([1,0,3,6]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=void 0;class A{constructor(T){this.b=0,this.a=T.getProxy(h.$ON.MainThreadLabelService)}$registerResourceLabelFormatter(T){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,T),(0,r.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.$drc=A}),define(ke[122],Ie([1,0,10,12,2,5,11,6,29,19]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=e.$yqc=void 0;let I=class{constructor(u,C,w){this.f=w,this.d=new Map,this.a=C.getProxy(O.$ON.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$h}getMessage(u,C){const{message:w,args:a,comment:m}=C;if(this.c)return(0,h.$ff)(w,a??{});let $=w;m&&m.length>0&&($+=`/${Array.isArray(m)?m.join(""):m}`);const f=this.d.get(u)?.contents[$];return f||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${$}`),(0,h.$ff)(f??w,a??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let C;const w=await this.g(u);if(!w){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(w),m=JSON.parse(a);C=u.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${u.identifier.value} from ${w}: ${a.message}`);return}C&&this.d.set(u.identifier.value,{contents:C,uri:w})}async g(u){if(u.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return A.URI.revive(C)}return u.l10n?A.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$yqc=I,e.$yqc=I=Je([Ve(0,b.$EQ),Ve(1,c.$oQ),Ve(2,T.$bk)],I),e.$zqc=(0,R.$Gi)("IExtHostLocalizationService")}),define(ke[162],Ie([1,0,11,6,29,19,2,44]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Orc=void 0;let b=class extends r.$mk{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(C=>(0,O.$di)(C))),this.r=y.getProxy(h.$ON.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(T.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,C){return new c(this.r,y,u,C)}};e.$Orc=b,e.$Orc=b=Je([Ve(0,R.$oQ),Ve(1,A.$EQ)],b);class c extends r.$hk{constructor(y,u,C,w){super(w?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(C),this.r.$createLogger(u,w).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const C=[[y,u]];this.m?this.u(C):this.n.push(...C)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(ke[123],Ie([1,0,6,5,3,19,21]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=e.$Aqc=void 0,e.$Aqc=(0,h.$Gi)("IExtHostManagedSockets");let O=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(r.$ON.MainThreadManagedSockets)}setFactory(y,u){for(const C of this.d.values())C.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new b(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,C=await this.c.makeConnection(),w=new A.$Uc;return this.d.set(u,new c(u,C,w)),w.add((0,A.$Tc)(()=>this.d.delete(u))),w.add(C.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),w.dispose()})),w.add(C.onDidClose(a=>{this.a.$onDidManagedSocketClose(u,a?.stack??a?.message),w.dispose()})),w.add(C.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(u,T.$Oe.wrap(a)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$Bqc=O,e.$Bqc=O=Je([Ve(0,R.$oQ)],O);class b{constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class c extends A.$Vc{constructor(y,u,C){super(),this.socketId=y,this.actual=u,this.B(C)}}}),define(ke[280],Ie([1,0,6,11,25]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=void 0;function R(O){return O&&O.title}let T=class{constructor(b,c){this.b=c,this.a=b.getProxy(r.$ON.MainThreadMessageService)}showMessage(b,c,I,y,u){const C={source:{identifier:b.identifier,label:b.displayName||b.name}};let w;typeof y=="string"||R(y)?w=[y,...u]:(C.modal=y?.modal,C.useCustom=y?.useCustom,C.detail=y?.detail,w=u),C.useCustom&&(0,A.$jH)(b,"resolvers");const a=[];let m=!1;for(let $=0;$<w.length;$++){const f=w[$];if(typeof f=="string")a.push({title:f,handle:$,isCloseAffordance:!1});else if(typeof f=="object"){const{title:i,isCloseAffordance:s}=f;a.push({title:i,isCloseAffordance:!!s,handle:$}),s&&(m?this.b.warn(`[${b.identifier}] Only one message item can have 'isCloseAffordance':`,f):m=!0)}else this.b.warn(`[${b.identifier}] Invalid message item:`,f)}return this.a.$showMessage(c,I,C,a).then($=>{if(typeof $=="number")return w[$]})}};e.$grc=T,e.$grc=T=Je([Ve(1,h.$bk)],T)}),define(ke[281],Ie([1,0,3,17,2,25,6]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=void 0;class O{constructor(c){this.b=new Map,this.a=c.getProxy(T.$ON.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,I,y){if((0,R.$jH)(c,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,y),this.a.$registerProfileContentHandler(I,y.name,y.description,c.identifier.value),(0,r.$Tc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(c,I,y,u){const C=this.b.get(c);if(!C)throw new Error(`Unknown handler with id: ${c}`);return C.saveProfile(I,y,u)}async $readProfile(c,I,y){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,h.$fg)(I)?I:A.URI.revive(I),y)}}e.$prc=O}),define(ke[124],Ie([1,0,6,4,5]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=e.$vqc=void 0;class R{constructor(O){this.b=new h.$me,this.onDidChangePassword=this.b.event,this.a=O.getProxy(r.$ON.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,b){return this.a.$getPassword(O,b)}store(O,b,c){return this.a.$setPassword(O,b,c)}delete(O,b){return this.a.$deletePassword(O,b)}}e.$vqc=R,e.$wqc=(0,A.$Gi)("IExtHostSecretState")}),define(ke[282],Ie([1,0,20,3,6]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=void 0;class R{static{this.a=1}constructor(O){this.c=new Map,this.d=new Map,this.f=new Map,this.b=O.getProxy(A.$ON.MainThreadSpeech)}async $createSpeechToTextSession(O,b,c){const I=this.c.get(O);if(!I)return;const y=new h.$Uc,u=new r.$xe;this.d.set(b,u);const C=await I.provideSpeechToTextSession(u.token,c?{language:c}:void 0);C&&(y.add(C.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(b,w)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}async $createTextToSpeechSession(O,b,c){const I=this.c.get(O);if(!I)return;const y=new h.$Uc,u=new r.$xe;this.d.set(b,u);const C=await I.provideTextToSpeechSession(u.token,c?{language:c}:void 0);C&&(this.f.set(b,C),y.add(C.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(b,w)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(O,b){this.f.get(O)?.synthesize(b)}async $cancelTextToSpeechSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O),this.f.delete(O)}async $createKeywordRecognitionSession(O,b){const c=this.c.get(O);if(!c)return;const I=new h.$Uc,y=new r.$xe;this.d.set(b,y);const u=await c.provideKeywordRecognitionSession(y.token);u&&(I.add(u.onDidChange(C=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(b,C)})),I.add(y.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}registerProvider(O,b,c){const I=R.a++;return this.c.set(I,c),this.b.$registerProvider(I,b,{extension:O,displayName:O.value}),(0,h.$Tc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$wrc=R}),define(ke[125],Ie([1,0,6,4,5]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=e.$lqc=void 0;class R{constructor(O,b){this.c=b,this.b=new h.$me,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(r.$ON.MainThreadStorage)}registerExtensionStorageKeysToSync(O,b){this.a.$registerExtensionStorageKeysToSync(O,b)}async initializeExtensionStorage(O,b,c){const I=await this.a.$initializeExtensionStorage(O,b);let y;return I&&(y=this.d(O,b,I)),y||c}setValue(O,b,c){return this.a.$setValue(O,b,c)}$acceptValue(O,b,c){const I=this.d(O,b,c);I&&this.b.fire({shared:O,key:b,value:I})}d(O,b,c){try{return JSON.parse(c)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${b}, global: ${O}): ${I}`)}}}e.$lqc=R,e.$mqc=(0,A.$Gi)("IExtHostStorage")}),define(ke[283],Ie([1,0,3,14,2,6]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=void 0;class T{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor(b){this.c=new Map,this.b=b.getProxy(R.$ON.MainThreadUriOpeners)}registerExternalUriOpener(b,c,I,y){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=y.schemes.find(C=>!T.a.has(C));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,I),this.b.$registerUriOpener(c,y.schemes,b,y.label),(0,r.$Tc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(b,c,I){const y=this.c.get(b);if(!y)throw new Error(`Unknown opener with id: ${b}`);const u=A.URI.revive(c);return y.canOpenExternalUri(u,I)}async $openUri(b,c,I){const y=this.c.get(b);if(!y)throw new Error(`Unknown opener id: '${b}'`);return y.openExternalUri(A.URI.revive(c.resolvedUri),{sourceUri:A.URI.revive(c.sourceUri)},I)}}e.$Irc=T}),define(ke[284],Ie([1,0,6,2,3,13,23]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jrc=void 0;class O{static{this.a=0}constructor(c){this.c=new T.$tn,this.d=new Map,this.b=c.getProxy(r.$ON.MainThreadUrls)}registerUriHandler(c,I){const y=c.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=O.a++;return this.c.add(y),this.d.set(u,I),this.b.$registerUriHandler(u,y,c.displayName||c.name),(0,A.$Tc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,I){const y=this.d.get(c);if(!y)return Promise.resolve(void 0);try{y.handleUri(h.URI.revive(I))}catch(u){(0,R.$Z)(u)}return Promise.resolve(void 0)}async createAppUri(c){return h.URI.revive(await this.b.$createAppUri(c))}}e.$Jrc=O}),define(ke[285],Ie([1,0,21,6]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2tb=R,e.$3tb=O,h=We(h);class A{constructor(){this.buffers=[]}add(c){let I=this.buffers.indexOf(c);return I<0&&(I=this.buffers.length,this.buffers.push(c)),I}}function R(b,c){if(c.serializeBuffersForPostMessage){const I=new A,u=JSON.stringify(b,(w,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a)};if(ArrayBuffer.isView(a)){const m=T(a);if(m)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a.buffer),view:{type:m,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),C=I.buffers.map(w=>{const a=new Uint8Array(w);return r.$Oe.wrap(a)});return{message:u,buffers:C}}else return{message:JSON.stringify(b),buffers:[]}}function T(b){switch(b.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function O(b,c){const I=c.map(C=>{const w=new ArrayBuffer(C.byteLength);return new Uint8Array(w).set(C.buffer),w}),y=c.length?(C,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const a=w,{index:m}=a,$=I[m];if(a.view)switch(a.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array($,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array($,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray($,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array($,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array($,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array($,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array($,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array($,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array($,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array($,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array($,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return $}return w}:void 0;return{message:JSON.parse(b,y),arrayBuffers:I}}}),define(ke[96],Ie([1,0,4,3,14,24,2,235,285,121,6]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=e.$9pc=void 0,e.$0pc=u,e.$_pc=a,e.$aqc=m,R=We(R),I=We(I);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(s,t,o,n,d,l,g){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$me,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$me,this._onDidDispose=this.#h.event,this.#e=s,this.#t=t,this.#o=o,this.#n=n,this.#s=d,this.#r=l,this.#u=u(l),this.#d=C(l),this.#i=g}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#l=!0,(0,c.$NDb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===A.Schemas.https||s.scheme===A.Schemas.http){let t=s.toString();return t.endsWith("/")||(t+="/"),t+" "+c.$MDb}return c.$MDb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),R.$jo(this.#o,s)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const t=(0,b.$2tb)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const t=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,g,E,S)=>{const D=T.URI.from({scheme:g||"file",path:decodeURIComponent(E)}),k=(0,c.$NDb)(D,{isRemote:t,authority:o}).toString();return`${d}${k}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,g,E,S)=>{const D=T.URI.from({scheme:g||"file",path:decodeURIComponent(E)}),k=(0,c.$NDb)(D,{isRemote:t,authority:o}).toString();return`${d}${k}${S}`})}}e.$9pc=y;function u(i){try{const s=(0,O.$3p)((0,O.$2p)(i.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function C(i){try{const s=(0,O.$3p)((0,O.$2p)(i.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class w extends h.$Vc{constructor(s,t,o,n,d){super(),this.c=t,this.f=o,this.g=n,this.h=d,this.b=new Map,this.a=s.getProxy(I.$ON.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,t,o){const n=this.j(s);if(n){const{message:d}=(0,b.$3tb)(t,o.value);n._onMessageEmitter.fire(d)}}$onMissingCsp(s,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,t,o){const n=new y(s,this.a,$(t),this.c,this.f,o,this.h);this.b.set(s,n);const d=n._onDidDispose(()=>{d.dispose(),this.deleteWebview(s)});return n}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$$pc=w;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,s,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||f(i,s)}}function $(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(s=>T.URI.from(s))}}function f(i,s){return[...(s?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(ke[163],Ie([1,0,4,14,12,2,5,19,6]),function($e,e,r,h,A,R,T,O,b){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mrc=e.$Lrc=void 0;let I=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$me,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy(b.$ON.MainThreadWindow),this.b.$getInitialState().then(({isFocused:C,isActive:w})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,C){C!==this.d[u]&&(this.d={...this.d,[u]:C},this.c.fire(this.d))}openUri(u,C){let w;if(typeof u=="string"){w=u;try{u=R.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,A.$df)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,w,C)}async asExternalUri(u,C){if((0,A.$df)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(u,C);return R.URI.from(w)}};e.$Lrc=I,e.$Lrc=I=c=Je([Ve(0,O.$oQ)],I),e.$Mrc=(0,T.$Gi)("IExtHostWindow")}),define(ke[286],Ie([1,0,276,29,19,93]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osc=void 0;const T=1024*1024;let O=class extends r.$Prc{constructor(c,I){super(c,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,I,y){const u=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${R.NativeLogMarkers.Start}
`),I.apply(console,y),u.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(c,I){const y=process[c],u=y.write;let C="";Object.defineProperty(y,"write",{set:()=>{},get:()=>(w,a,m)=>{if(!this.g){C+=w.toString(a);const $=C.length>T?C.length:C.lastIndexOf(`
`);$!==-1&&(console[I](C.slice(0,$)),C=C.slice($+1))}u.call(y,w,a,m)}})}};e.$osc=O,e.$osc=O=Je([Ve(0,A.$oQ),Ve(1,h.$EQ)],O)}),define(ke[287],Ie([1,0,162,14,229,32]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Asc=void 0;class T extends r.$Orc{s(b,c,I){return b.scheme===h.Schemas.file?new A.$DR(I?.name||(0,R.$3g)(),b.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,c):super.s(b,c,I)}registerLogger(b){super.registerLogger(b),this.r.$registerLogger(b)}deregisterLogger(b){super.deregisterLogger(b),this.r.$deregisterLogger(b)}}e.$Asc=T}),define(ke[288],Ie([1,0,7,21,20,26,13,4,3,40,139,274,53]),function($e,e,r,h,A,R,T,O,b,c,I,y,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=e.ResponsiveState=e.RequestInitiator=void 0,e.$4dc=f,e.$5dc=i,T=We(T);function w(F,N){try{return JSON.stringify(F,N)}catch{return"null"}}const a="$$ref$$",m={[a]:-1};class ${constructor(N,L){this.jsonString=N,this.referencedBuffers=L}}function f(F,N=null,L=!1){const M=[];return{jsonString:(L?w:JSON.stringify)(F,(j,q)=>{if(typeof q>"u")return m;if(typeof q=="object"){if(q instanceof h.$Oe){const B=M.push(q)-1;return{[a]:B}}if(N)return N(j,q)}return q}),referencedBuffers:M}}function i(F,N,L){return JSON.parse(F,(M,z)=>{if(z){const j=z[a];if(typeof j=="number")return N[j];if(L&&z.$mid===c.MarshalledId.Uri)return L.transformIncoming(z)}return z})}function s(F,N){return JSON.stringify(F,N)}function t(F){return F?(N,L)=>L&&L.$mid===c.MarshalledId.Uri?F.transformOutgoing(L):L:null}var o;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var n;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(n||(e.ResponsiveState=n={}));const d=()=>{},l=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class E extends b.$Vc{static{C=l}static{this.a=3*1e3}constructor(N,L=null,M=null){super(),this[C]=!0,this.b=this.B(new O.$me),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=L,this.g=M,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,j=u.$Ww.count;z<j;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=n.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Sh(()=>this.H(),1e3)),this.B(this.c.onMessage(z=>this.L(z)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const L=this.w[N];delete this.w[N],L.resolveErr(T.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(n.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(n.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,I.$Qn)(N,this.g):N}getProxy(N){const{nid:L,sid:M}=N;return this.s[L]||(this.s[L]=this.J(L,M)),this.s[L]}J(N,L){const M={get:(z,j)=>(typeof j=="string"&&!z[j]&&j.charCodeAt(0)===R.CharCode.DollarSign&&(z[j]=(...q)=>this.U(N,j,q)),j===g?L:z[j])};return new Proxy(Object.create(null),M)}set(N,L){return this.m[N.nid]=L,L}assertRegistered(N){for(let L=0,M=N.length;L<M;L++){const z=N[L];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(N){if(this.j)return;const L=N.byteLength,M=D.read(N,0),z=M.readUInt8(),j=M.readUInt32();switch(z){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:q,method:B,args:ee}=P.deserializeRequestJSONArgs(M);this.g&&(ee=(0,I.$Qn)(ee,this.g)),this.M(L,j,q,B,ee,z===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:q,method:B,args:ee}=P.deserializeRequestMixedArgs(M);this.g&&(ee=(0,I.$Qn)(ee,this.g)),this.M(L,j,q,B,ee,z===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this.f?.logIncoming(L,j,o.LocalSide,"ack"),this.G(j);break}case p.Cancel:{this.N(L,j);break}case p.ReplyOKEmpty:{this.O(L,j,void 0);break}case p.ReplyOKJSON:{let q=P.deserializeReplyOKJSON(M);this.g&&(q=(0,I.$Qn)(q,this.g)),this.O(L,j,q);break}case p.ReplyOKJSONWithBuffers:{const q=P.deserializeReplyOKJSONWithBuffers(M,this.g);this.O(L,j,q);break}case p.ReplyOKVSBuffer:{const q=P.deserializeReplyOKVSBuffer(M);this.O(L,j,q);break}case p.ReplyErrError:{let q=P.deserializeReplyErrError(M);this.g&&(q=(0,I.$Qn)(q,this.g)),this.P(L,j,q);break}case p.ReplyErrEmpty:{this.P(L,j,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,L,M,z,j,q){this.f?.logIncoming(N,L,o.OtherSide,`receiveRequest ${(0,u.$Yw)(M)}.${z}(`,j);const B=String(L);let ee,H;if(q){const X=new A.$xe;j.push(X.token),ee=this.Q(M,z,j),H=()=>X.cancel()}else ee=this.Q(M,z,j),H=d;this.u[B]=H;const W=P.serializeAcknowledged(L);this.f?.logOutgoing(W.byteLength,L,o.OtherSide,"ack"),this.c.send(W),ee.then(X=>{delete this.u[B];const _=P.serializeReplyOK(L,X,this.h);this.f?.logOutgoing(_.byteLength,L,o.OtherSide,"reply:",X),this.c.send(_)},X=>{delete this.u[B];const _=P.serializeReplyErr(L,X);this.f?.logOutgoing(_.byteLength,L,o.OtherSide,"replyErr:",X),this.c.send(_)})}N(N,L){this.f?.logIncoming(N,L,o.OtherSide,"receiveCancel");const M=String(L);this.u[M]?.()}O(N,L,M){this.f?.logIncoming(N,L,o.LocalSide,"receiveReply:",M);const z=String(L);if(!this.w.hasOwnProperty(z))return;const j=this.w[z];delete this.w[z],j.resolveOk(M)}P(N,L,M){this.f?.logIncoming(N,L,o.LocalSide,"receiveReplyErr:",M);const z=String(L);if(!this.w.hasOwnProperty(z))return;const j=this.w[z];delete this.w[z];let q;M&&(M.$isError?(q=new Error,q.name=M.name,q.message=M.message,q.stack=M.stack):q=M),j.resolveErr(q)}Q(N,L,M){try{return Promise.resolve(this.S(N,L,M))}catch(z){return Promise.reject(z)}}S(N,L,M){const z=this.m[N];if(!z)throw new Error("Unknown actor "+(0,u.$Yw)(N));const j=z[L];if(typeof j!="function")throw new Error("Unknown method "+L+" on actor "+(0,u.$Yw)(N));return j.apply(z,M)}U(N,L,M){if(this.j)return new y.$3dc;let z=null;if(M.length>0&&A.CancellationToken.isCancellationToken(M[M.length-1])&&(z=M.pop()),z&&z.isCancellationRequested)return Promise.reject(T.$6());const j=P.serializeRequestArguments(M,this.h),q=++this.t,B=String(q),ee=new y.$2dc,H=new b.$Uc;z&&H.add(z.onCancellationRequested(()=>{const X=P.serializeCancel(q);this.f?.logOutgoing(X.byteLength,q,o.LocalSide,"cancel"),this.c.send(P.serializeCancel(q))})),this.w[B]=new S(ee,H),this.F(q);const W=P.serializeRequest(q,N,L,j,!!z);return this.f?.logOutgoing(W.byteLength,q,o.LocalSide,`request: ${(0,u.$Yw)(N)}.${L}(`,M),this.c.send(W),ee}}e.$6dc=E;class S{constructor(N,L){this.a=N,this.b=L}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class D{static alloc(N,L,M){const z=new D(h.$Oe.alloc(M+1+4),0);return z.writeUInt8(N),z.writeUInt32(L),z}static read(N,L){return new D(N,L)}get buffer(){return this.a}constructor(N,L){this.a=N,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const M=this.a.slice(this.b,this.b+N).toString();return this.b+=N,M}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+N).toString();return this.b+=N,M}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+N);return this.b+=N,L}static sizeMixedArray(N){let L=0;L+=1;for(let M=0,z=N.length;M<z;M++){const j=N[M];switch(L+=1,j.type){case v.String:L+=this.sizeLongString(j.value);break;case v.VSBuffer:L+=this.sizeVSBuffer(j.value);break;case v.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(j.value);for(let q=0;q<j.buffers.length;++q)L+=this.sizeVSBuffer(j.buffers[q]);break;case v.Undefined:break}}return L}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let L=0,M=N.length;L<M;L++){const z=N[L];switch(z.type){case v.String:this.writeUInt8(v.String),this.writeLongString(z.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(z.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let j=0;j<z.buffers.length;++j)this.writeBuffer(z.buffers[j]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const L=new Array(N);for(let M=0;M<N;M++)switch(this.readUInt8()){case v.String:L[M]=this.readLongString();break;case v.VSBuffer:L[M]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const j=this.readUInt32(),q=this.readLongString(),B=[];for(let ee=0;ee<j;++ee)B.push(this.readVSBuffer());L[M]=new u.$Zw(i(q,B,null));break}case v.Undefined:L[M]=void 0;break}return L}}var k;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(k||(k={}));class P{static a(N){for(let L=0,M=N.length;L<M;L++)if(N[L]instanceof h.$Oe||N[L]instanceof u.$Zw||typeof N[L]>"u")return!0;return!1}static serializeRequestArguments(N,L){if(this.a(N)){const M=[];for(let z=0,j=N.length;z<j;z++){const q=N[z];if(q instanceof h.$Oe)M[z]={type:v.VSBuffer,value:q};else if(typeof q>"u")M[z]={type:v.Undefined};else if(q instanceof u.$Zw){const{jsonString:B,referencedBuffers:ee}=f(q.value,L);M[z]={type:v.SerializedObjectWithBuffers,value:h.$Oe.fromString(B),buffers:ee}}else M[z]={type:v.String,value:h.$Oe.fromString(s(q,L))}}return{type:k.Mixed,args:M}}return{type:k.Simple,args:s(N,L)}}static serializeRequest(N,L,M,z,j){switch(z.type){case k.Simple:return this.b(N,L,M,z.args,j);case k.Mixed:return this.c(N,L,M,z.args,j)}}static b(N,L,M,z,j){const q=h.$Oe.fromString(M),B=h.$Oe.fromString(z);let ee=0;ee+=D.sizeUInt8(),ee+=D.sizeShortString(q),ee+=D.sizeLongString(B);const H=D.alloc(j?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,N,ee);return H.writeUInt8(L),H.writeShortString(q),H.writeLongString(B),H.buffer}static deserializeRequestJSONArgs(N){const L=N.readUInt8(),M=N.readShortString(),z=N.readLongString();return{rpcId:L,method:M,args:JSON.parse(z)}}static c(N,L,M,z,j){const q=h.$Oe.fromString(M);let B=0;B+=D.sizeUInt8(),B+=D.sizeShortString(q),B+=D.sizeMixedArray(z);const ee=D.alloc(j?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,N,B);return ee.writeUInt8(L),ee.writeShortString(q),ee.writeMixedArray(z),ee.buffer}static deserializeRequestMixedArgs(N){const L=N.readUInt8(),M=N.readShortString(),z=N.readMixedArray(),j=new Array(z.length);for(let q=0,B=z.length;q<B;q++){const ee=z[q];typeof ee=="string"?j[q]=JSON.parse(ee):j[q]=ee}return{rpcId:L,method:M,args:j}}static serializeAcknowledged(N){return D.alloc(p.Acknowledged,N,0).buffer}static serializeCancel(N){return D.alloc(p.Cancel,N,0).buffer}static serializeReplyOK(N,L,M){if(typeof L>"u")return this.d(N);if(L instanceof h.$Oe)return this.e(N,L);if(L instanceof u.$Zw){const{jsonString:z,referencedBuffers:j}=f(L.value,M,!0);return this.g(N,z,j)}else return this.f(N,w(L,M))}static d(N){return D.alloc(p.ReplyOKEmpty,N,0).buffer}static e(N,L){let M=0;M+=D.sizeVSBuffer(L);const z=D.alloc(p.ReplyOKVSBuffer,N,M);return z.writeVSBuffer(L),z.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,L){const M=h.$Oe.fromString(L);let z=0;z+=D.sizeLongString(M);const j=D.alloc(p.ReplyOKJSON,N,z);return j.writeLongString(M),j.buffer}static g(N,L,M){const z=h.$Oe.fromString(L);let j=0;j+=D.sizeUInt32,j+=D.sizeLongString(z);for(const B of M)j+=D.sizeVSBuffer(B);const q=D.alloc(p.ReplyOKJSONWithBuffers,N,j);q.writeUInt32(M.length),q.writeLongString(z);for(const B of M)q.writeBuffer(B);return q.buffer}static deserializeReplyOKJSON(N){const L=N.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(N,L){const M=N.readUInt32(),z=N.readLongString(),j=[];for(let q=0;q<M;++q)j.push(N.readVSBuffer());return new u.$Zw(i(z,j,L))}static serializeReplyErr(N,L){const M=L?w(T.$2(L),null):void 0;if(typeof M!="string")return this.h(N);const z=h.$Oe.fromString(M);let j=0;j+=D.sizeLongString(z);const q=D.alloc(p.ReplyErrError,N,j);return q.writeLongString(z),q.buffer}static deserializeReplyErrError(N){const L=N.readLongString();return JSON.parse(L)}static h(N){return D.alloc(p.ReplyErrEmpty,N,0).buffer}}var p;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var v;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(v||(v={}))}),define(ke[289],Ie([1,0,21,28,14,88,5]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.$vL=void 0,e.$wL=I,e.$xL=y,e.$vL=(0,T.$Gi)("notebookDocumentService");const O=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${O.join("")}]+`),c=7;function I(C){if(C.scheme!==A.Schemas.vscodeNotebookCell)return;const w=C.fragment.indexOf("s");if(w<0)return;const a=parseInt(C.fragment.substring(0,w).replace(b,""),c),m=(0,r.$8e)(C.fragment.substring(w+1)).toString();if(!isNaN(a))return{handle:a,notebook:C.with({scheme:m,fragment:null})}}function y(C,w){const a=w.toString(c),$=`${a.length<O.length?O[a.length-1]:"z"}${a}s${(0,r.$9e)(r.$Oe.fromString(C.scheme),!0,!0)}`;return C.with({scheme:A.Schemas.vscodeNotebookCell,fragment:$})}class u{constructor(){this.a=new h.$Bc}getNotebook(w){if(w.scheme===A.Schemas.vscodeNotebookCell){const a=I(w);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$yL=u,(0,R.$Ss)(e.$vL,u,R.InstantiationType.Delayed)}),define(ke[126],Ie([1,0,21,38,39,103,14,16,10,35,289]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=e.$PL=e.CellStatusbarAlignment=e.$OL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$LL=e.$KL=e.$IL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$HL=e.$GL=e.$FL=e.$EL=e.CellKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=void 0,e.$JL=n,e.$ML=g,e.$NL=E,e.$QL=k,e.$RL=p,h=We(h),e.$zL="workbench.editor.notebook",e.$AL="workbench.editor.notebookTextDiffEditor",e.$BL="workbench.editor.interactive",e.$CL="workbench.editor.repl",e.$DL="replNotebook.input.execute";var y;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(y||(e.CellKind=y={})),e.$EL=["application/json","application/javascript","text/html","image/svg+xml",R.$_s.latex,R.$_s.markdown,"image/png","image/jpeg",R.$_s.text],e.$FL=[R.$_s.latex,R.$_s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$_s.text],e.$GL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$HL="_notAvailable";var u;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var C;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(C||(e.NotebookCellExecutionState=C={}));var w;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var a;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var $;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})($||(e.NotebookCellsChangeType=$={}));var f;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(B){B.scheme=T.Schemas.vscodeNotebookCell;function ee(ne,ye){return(0,I.$xL)(ne,ye)}B.generate=ee;function H(ne){return(0,I.$wL)(ne)}B.parse=H;function W(ne,ye){return ne.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${ye??""},${ne.scheme!==T.Schemas.file?ne.scheme:""}`})}B.generateCellOutputUri=W;function X(ne){if(ne.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const ye=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!ye)return;const ge=ye[1]&&ye[1]!==""?ye[1]:void 0,Y=ye[2];return{outputId:ge,notebook:ne.with({scheme:Y||T.Schemas.file,fragment:null})}}B.parseCellOutputUri=X;function _(ne,ye,ge){return B.generate(ne,ye).with({scheme:ge})}B.generateCellPropertyUri=_;function ce(ne,ye){if(ne.scheme===ye)return B.parse(ne.with({scheme:B.scheme}))}B.parseCellPropertyUri=ce})(s||(e.CellUri=s={}));const t=B=>b.$j?B.replace(/\//g,"\\"):B;class o{constructor(ee=[],H=e.$EL){this.e=H,this.d=[...new Set(ee)].map(W=>({pattern:W,matches:h.$Bk(t(W))}))}sort(ee){const H=new Map(A.Iterable.map(ee,X=>[X,t(X)]));let W=[];for(const{matches:X}of this.d)for(const[_,ce]of H)if(X(ce)){W.push(_),H.delete(_);break}return H.size&&(W=W.concat([...H.keys()].sort((X,_)=>this.e.indexOf(X)-this.e.indexOf(_)))),W}prioritize(ee,H){const W=this.f(ee);if(W===-1){this.d.unshift({pattern:ee,matches:h.$Bk(t(ee))});return}const X=new Set(H.map(ce=>this.f(ce,W)));X.delete(-1);const _=Array.from(X).sort();this.d.splice(W+1,0,..._.map(ce=>this.d[ce]));for(let ce=_.length-1;ce>=0;ce--)this.d.splice(_[ce],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,H=this.d.length){const W=t(ee);for(let X=0;X<H;X++)if(this.d[X].matches(W))return X;return-1}}e.$IL=o;function n(B,ee,H,W=(X,_)=>X===_){const X=[];function _(ye,ge,Y){if(ge===0&&Y.length===0)return;const U=X[X.length-1];U&&U.start+U.deleteCount===ye?(U.deleteCount+=ge,U.toInsert.push(...Y)):X.push({start:ye,deleteCount:ge,toInsert:Y})}let ce=0,ne=0;for(;;){if(ce===B.length){_(ce,0,ee.slice(ne));break}if(ne===ee.length){_(ce,B.length-ce,[]);break}const ye=B[ce],ge=ee[ne];if(W(ye,ge)){ce+=1,ne+=1;continue}H(ge)?(_(ce,1,[]),ce+=1):(_(ce,0,[ge]),ne+=1)}return X}e.$KL=new c.$Xj("notebookEditorCursorAtBoundary","none"),e.$LL=new c.$Xj("notebookEditorCursorAtLineBoundary","none");var d;(function(B){B.default="default",B.option="option"})(d||(e.NotebookEditorPriority=d={}));var l;(function(B){B.Cells="cells",B.Text="text",B.None="none"})(l||(e.NotebookFindScopeType=l={}));function g(B){const ee=B;return!!((typeof ee.include=="string"||h.$Ck(ee.include))&&(typeof ee.exclude=="string"||h.$Ck(ee.exclude)))}function E(B,ee,H){if(Array.isArray(B.viewType)&&B.viewType.indexOf(ee)>=0||B.viewType===ee)return!0;if(B.filenamePattern){const W=g(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,X=g(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(h.$Ak(W,(0,O.$oc)(H.fsPath).toLowerCase()))return!(X&&h.$Ak(X,(0,O.$oc)(H.fsPath).toLowerCase()))}return!1}e.$OL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class D{static{this.d="notebook/"}static create(ee){return`${D.d}${ee}`}static parse(ee){if(ee.startsWith(D.d))return ee.substring(D.d.length)}}e.$PL=D;function k(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const P=new TextDecoder;function p(B){const ee=[];let H=!1;for(const ce of B)(ee.length===0||H)&&(ee.push(ce),H=!0);let W=N(ee);const X=r.$Oe.concat(ee.map(ce=>r.$Oe.wrap(ce))),_=q(X);return W=W||_.byteLength!==X.byteLength,{data:_,didCompression:W}}e.$SL="\x1B[A";const v=e.$SL.split("").map(B=>B.charCodeAt(0)),F=10;function N(B){let ee=!1;return B.forEach((H,W)=>{if(W===0||H.length<e.$SL.length)return;const X=B[W-1],_=H.subarray(0,e.$SL.length);if(_[0]===v[0]&&_[1]===v[1]&&_[2]===v[2]){const ce=X.lastIndexOf(F);if(ce===-1)return;ee=!0,B[W-1]=X.subarray(0,ce),B[W]=H.subarray(e.$SL.length)}}),ee}function L(B){let ee=B;do B=ee,ee=B.replace(/[^\n]\x08/gm,"");while(ee.length<B.length);return B}function M(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const ee=B.match(/^(.*)\r+/m)[1];let H=B.match(/\r+(.*)$/m)[1];H=H+ee.slice(H.length,ee.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return B}const z=8,j=13;function q(B){return!B.buffer.includes(z)&&!B.buffer.includes(j)?B:r.$Oe.fromString(M(L(P.decode(B.buffer))))}}),define(ke[9],Ie([1,0,18,13,85,28,103,12,17,2,32,23,27,71,126]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w){"use strict";var a,m,$,f,i,s,t,o,n,d,l,g,E,S,D,k,P;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$dQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$cQ=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.LanguageModelChatMessageRole=e.$7P=e.$6P=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$5P=e.$4P=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$PP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$CP=e.$BP=e.$AP=e.$zP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.TestRunProfileKind=e.TestResultState=e.$sP=e.$rP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$qP=e.NotebookVariablesRequestKind=e.$pP=e.$oP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$nP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.ColorThemeKind=e.$hP=e.$gP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$fP=e.QuickInputButtonLocation=e.$eP=e.DebugConsoleMode=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$$O=e.$0O=e.FileChangeType=e.$9O=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$8O=e.$7O=e.$6O=e.$5O=e.InlineCompletionTriggerKind=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$RO=e.ConfigurationTarget=e.$QO=e.$PO=e.$OO=e.$NO=e.DocumentPasteTriggerKind=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$GO=e.ViewBadge=e.ProgressLocation=e.$FO=e.$EO=e.TaskScope=e.ShellQuoting=e.$DO=e.$CO=e.$BO=e.TaskPanelKind=e.TaskRevealKind=e.$AO=e.TerminalLocation=e.$zO=e.$yO=e.$xO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$wO=e.$vO=e.$uO=e.$tO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$rO=e.$qO=e.$pO=e.$oO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$nO=e.$mO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.LanguageStatusSeverity=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.CodeActionTriggerKind=e.$aO=e.$_N=e.SymbolTag=e.SymbolKind=e.$$N=e.$0N=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.DiagnosticSeverity=e.DiagnosticTag=e.$4N=e.$3N=e.FileEditType=e.$2N=e.$1N=e.$ZN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$YN=e.$XN=e.$WN=e.$TN=e.$SN=e.$RN=e.$QN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$UN=j,e.$VN=q,e.$sO=mt,e.$SO=Ni,e.$yP=An;function p(K){return Object.assign(K,{apply:function(...me){if(me.length===0)return Reflect.construct(K,[]);{const Te=me.length===1?[]:me[1];return Reflect.construct(K,Te,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(K,[]);{const[Te,...Ye]=me;return Reflect.construct(K,Ye,Te.constructor)}}})}var v;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var F;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let N=a=class{static from(...Q){let me=Q;return new a(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}#e;constructor(Q){this.#e=Q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$QN=N,e.$QN=N=a=Je([p],N);let L=m=class{static Min(...Q){if(Q.length===0)throw new TypeError;let me=Q[0];for(let Te=1;Te<Q.length;Te++){const Ye=Q[Te];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...Q){if(Q.length===0)throw new TypeError;let me=Q[0];for(let Te=1;Te<Q.length;Te++){const Ye=Q[Te];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(Q){if(!Q)return!1;if(Q instanceof m)return!0;const{line:me,character:Te}=Q;return typeof me=="number"&&typeof Te=="number"}static of(Q){if(Q instanceof m)return Q;if(this.isPosition(Q))return new m(Q.line,Q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(Q,me){if(Q<0)throw(0,h.$7)("line must be non-negative");if(me<0)throw(0,h.$7)("character must be non-negative");this.c=Q,this.e=me}isBefore(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<Q.e}isBeforeOrEqual(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<=Q.e}isAfter(Q){return!this.isBeforeOrEqual(Q)}isAfterOrEqual(Q){return!this.isBefore(Q)}isEqual(Q){return this.c===Q.c&&this.e===Q.e}compareTo(Q){return this.c<Q.c?-1:this.c>Q.line?1:this.e<Q.e?-1:this.e>Q.e?1:0}translate(Q,me=0){if(Q===null||me===null)throw(0,h.$7)();let Te;return typeof Q>"u"?Te=0:typeof Q=="number"?Te=Q:(Te=typeof Q.lineDelta=="number"?Q.lineDelta:0,me=typeof Q.characterDelta=="number"?Q.characterDelta:0),Te===0&&me===0?this:new m(this.line+Te,this.character+me)}with(Q,me=this.character){if(Q===null||me===null)throw(0,h.$7)();let Te;return typeof Q>"u"?Te=this.line:typeof Q=="number"?Te=Q:(Te=typeof Q.line=="number"?Q.line:this.line,me=typeof Q.character=="number"?Q.character:this.character),Te===this.line&&me===this.character?this:new m(Te,me)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$RN=L,e.$RN=L=m=Je([p],L);let M=$=class{static isRange(Q){return Q instanceof $?!0:Q?L.isPosition(Q.start)&&L.isPosition(Q.end):!1}static of(Q){if(Q instanceof $)return Q;if(this.isRange(Q))return new $(Q.start,Q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(Q,me,Te,Ye){let ot,$t;if(typeof Q=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"?(ot=new L(Q,me),$t=new L(Te,Ye)):L.isPosition(Q)&&L.isPosition(me)&&(ot=L.of(Q),$t=L.of(me)),!ot||!$t)throw new Error("Invalid arguments");ot.isBefore($t)?(this.c=ot,this.e=$t):(this.c=$t,this.e=ot)}contains(Q){return $.isRange(Q)?this.contains(Q.start)&&this.contains(Q.end):L.isPosition(Q)?!(L.of(Q).isBefore(this.c)||this.e.isBefore(Q)):!1}isEqual(Q){return this.c.isEqual(Q.c)&&this.e.isEqual(Q.e)}intersection(Q){const me=L.Max(Q.start,this.c),Te=L.Min(Q.end,this.e);if(!me.isAfter(Te))return new $(me,Te)}union(Q){if(this.contains(Q))return this;if(Q.contains(this))return Q;const me=L.Min(Q.start,this.c),Te=L.Max(Q.end,this.end);return new $(me,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(Q,me=this.end){if(Q===null||me===null)throw(0,h.$7)();let Te;return Q?L.isPosition(Q)?Te=Q:(Te=Q.start||this.start,me=Q.end||this.end):Te=this.start,Te.isEqual(this.c)&&me.isEqual(this.end)?this:new $(Te,me)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return j(this)}};e.$SN=M,e.$SN=M=$=Je([p],M);let z=f=class extends M{static isSelection(Q){return Q instanceof f?!0:Q?M.isRange(Q)&&L.isPosition(Q.anchor)&&L.isPosition(Q.active)&&typeof Q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(Q,me,Te,Ye){let ot,$t;if(typeof Q=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"?(ot=new L(Q,me),$t=new L(Te,Ye)):L.isPosition(Q)&&L.isPosition(me)&&(ot=L.of(Q),$t=L.of(me)),!ot||!$t)throw new Error("Invalid arguments");super(ot,$t),this.f=ot,this.g=$t}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return q(this)}};e.$TN=z,e.$TN=z=f=Je([p],z);function j(K){return K.isEmpty?`[${K.start.line}:${K.start.character})`:`[${K.start.line}:${K.start.character} -> ${K.end.line}:${K.end.character})`}function q(K){let Q=j(K);return K.isEmpty||(K.active.isEqual(K.start)?Q=`|${Q}`:Q=`${Q}|`),Q}const B=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,h.$7)("connectionToken")};class ee{static isResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.host=="string"&&typeof Q.port=="number"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,me,Te){if(typeof Q!="string"||Q.length===0)throw(0,h.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,h.$7)("port");typeof Te<"u"&&B(Te),this.host=Q,this.port=Math.round(me),this.connectionToken=Te}}e.$WN=ee;class H{static isManagedResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.makeConnection=="function"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,me){this.makeConnection=Q,this.connectionToken=me,typeof me<"u"&&B(me)}}e.$XN=H;class W extends Error{static NotAvailable(Q,me){return new W(Q,C.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(Q){return new W(Q,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(Q,me=C.RemoteAuthorityResolverErrorCode.Unknown,Te){super(Q),this._message=Q,this._code=me,this._detail=Te,Object.setPrototypeOf(this,W.prototype)}}e.$YN=W;var X;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(X||(e.EndOfLine=X={}));var _;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(_||(e.EnvironmentVariableMutatorType=_={}));let ce=i=class{static isTextEdit(Q){return Q instanceof i?!0:Q?M.isRange(Q)&&typeof Q.newText=="string":!1}static replace(Q,me){return new i(Q,me)}static insert(Q,me){return i.replace(new M(Q,Q),me)}static delete(Q){return i.replace(Q,"")}static setEndOfLine(Q){const me=new i(new M(new L(0,0),new L(0,0)),"");return me.newEol=Q,me}get range(){return this.c}set range(Q){if(Q&&!M.isRange(Q))throw(0,h.$7)("range");this.c=Q}get newText(){return this.e||""}set newText(Q){if(Q&&typeof Q!="string")throw(0,h.$7)("newText");this.e=Q}get newEol(){return this.f}set newEol(Q){if(Q&&typeof Q!="number")throw(0,h.$7)("newEol");this.f=Q}constructor(Q,me){this.c=Q,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$ZN=ce,e.$ZN=ce=i=Je([p],ce);let ne=s=class{static isNotebookCellEdit(Q){return Q instanceof s?!0:Q?Ei.isNotebookRange(Q)&&Array.isArray(Q.newCells):!1}static replaceCells(Q,me){return new s(Q,me)}static insertCells(Q,me){return new s(new Ei(Q,Q),me)}static deleteCells(Q){return new s(Q,[])}static updateCellMetadata(Q,me){const Te=new s(new Ei(Q,Q),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(Q){const me=new s(new Ei(0,0),[]);return me.newNotebookMetadata=Q,me}constructor(Q,me){this.range=Q,this.newCells=me}};e.$1N=ne,e.$1N=ne=s=Je([p],ne);class ye{static isSnippetTextEdit(Q){return Q instanceof ye?!0:Q?M.isRange(Q.range)&&U.isSnippetString(Q.snippet):!1}static replace(Q,me){return new ye(Q,me)}static insert(Q,me){return ye.replace(new M(Q,Q),me)}constructor(Q,me){this.range=Q,this.snippet=me}}e.$2N=ye;var ge;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(Q,me,Te,Ye){this.c.push({_type:ge.File,from:Q,to:me,options:Te,metadata:Ye})}createFile(Q,me,Te){this.c.push({_type:ge.File,from:void 0,to:Q,options:me,metadata:Te})}deleteFile(Q,me,Te){this.c.push({_type:ge.File,from:Q,to:void 0,options:me,metadata:Te})}e(Q,me,Te){this.c.push({_type:ge.Cell,metadata:Te,uri:Q,edit:{editType:w.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(Q,me,Te,Ye){const ot=me.start,$t=me.end;(ot!==$t||Te.length>0)&&this.c.push({_type:ge.CellReplace,uri:Q,index:ot,count:$t-ot,cells:Te,metadata:Ye})}g(Q,me,Te,Ye){this.c.push({_type:ge.Cell,metadata:Ye,uri:Q,edit:{editType:w.CellEditType.Metadata,index:me,metadata:Te}})}replace(Q,me,Te,Ye){this.c.push({_type:ge.Text,uri:Q,edit:new ce(me,Te),metadata:Ye})}insert(Q,me,Te,Ye){this.replace(Q,new M(me,me),Te,Ye)}delete(Q,me,Te){this.replace(Q,me,"",Te)}has(Q){return this.c.some(me=>me._type===ge.Text&&me.uri.toString()===Q.toString())}set(Q,me){if(me)for(const Te of me){if(!Te)continue;let Ye,ot;Array.isArray(Te)?(Ye=Te[0],ot=Te[1]):Ye=Te,ne.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(Q,Ye.range.start,Ye.newCellMetadata,ot):Ye.newNotebookMetadata?this.e(Q,Ye.newNotebookMetadata,ot):this.f(Q,Ye.range,Ye.newCells,ot):ye.isSnippetTextEdit(Ye)?this.c.push({_type:ge.Snippet,uri:Q,range:Ye.range,edit:Ye.snippet,metadata:ot}):this.c.push({_type:ge.Text,uri:Q,edit:Ye,metadata:ot})}else{for(let Te=0;Te<this.c.length;Te++){const Ye=this.c[Te];switch(Ye._type){case ge.Text:case ge.Snippet:case ge.Cell:case ge.CellReplace:Ye.uri.toString()===Q.toString()&&(this.c[Te]=void 0);break}}(0,r.$Ib)(this.c)}}get(Q){const me=[];for(const Te of this.c)Te._type===ge.Text&&Te.uri.toString()===Q.toString()&&me.push(Te.edit);return me}entries(){const Q=new R.$Bc;for(const me of this.c)if(me._type===ge.Text){let Te=Q.get(me.uri);Te||(Te=[me.uri,[]],Q.set(me.uri,Te)),Te[1].push(me.edit)}return[...Q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$3N=Y,e.$3N=Y=Je([p],Y);let U=t=class{static isSnippetString(Q){return Q instanceof t?!0:Q?typeof Q.value=="string":!1}static c(Q){return Q.replace(/\$|}|\\/g,"\\$&")}constructor(Q){this.e=1,this.value=Q||""}appendText(Q){return this.value+=t.c(Q),this}appendTabstop(Q=this.e++){return this.value+="$",this.value+=Q,this}appendPlaceholder(Q,me=this.e++){if(typeof Q=="function"){const Te=new t;Te.e=this.e,Q(Te),this.e=Te.e,Q=Te.value}else Q=t.c(Q);return this.value+="${",this.value+=me,this.value+=":",this.value+=Q,this.value+="}",this}appendChoice(Q,me=this.e++){const Te=Q.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(Q,me){if(typeof me=="function"){const Te=new t;Te.e=this.e,me(Te),this.e=Te.e,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=Q,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$4N=U,e.$4N=U=t=Je([p],U);var oe;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(oe||(e.DiagnosticTag=oe={}));var ve;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(ve||(e.DiagnosticSeverity=ve={}));let te=o=class{static isLocation(Q){return Q instanceof o?!0:Q?M.isRange(Q.range)&&c.URI.isUri(Q.uri):!1}constructor(Q,me){if(this.uri=Q,me)if(M.isRange(me))this.range=M.of(me);else if(L.isPosition(me))this.range=new M(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$5N=te,e.$5N=te=o=Je([p],te);let ae=class{static is(Q){return Q?typeof Q.message=="string"&&Q.location&&M.isRange(Q.location.range)&&c.URI.isUri(Q.location.uri):!1}constructor(Q,me){this.location=Q,this.message=me}static isEqual(Q,me){return Q===me?!0:!Q||!me?!1:Q.message===me.message&&Q.location.range.isEqual(me.location.range)&&Q.location.uri.toString()===me.location.uri.toString()}};e.$6N=ae,e.$6N=ae=Je([p],ae);let se=class{constructor(Q,me,Te=ve.Error){if(!M.isRange(Q))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=Q,this.message=me,this.severity=Te}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(Q,me){return Q===me?!0:!Q||!me?!1:Q.message===me.message&&Q.severity===me.severity&&Q.code===me.code&&Q.severity===me.severity&&Q.source===me.source&&Q.range.isEqual(me.range)&&(0,r.$ub)(Q.tags,me.tags)&&(0,r.$ub)(Q.relatedInformation,me.relatedInformation,ae.isEqual)}};e.$7N=se,e.$7N=se=Je([p],se);let Z=class{constructor(Q,me){if(!Q)throw new Error("Illegal argument, contents must be defined");Array.isArray(Q)?this.contents=Q:this.contents=[Q],this.range=me}};e.$8N=Z,e.$8N=Z=Je([p],Z);let re=class extends Z{constructor(Q,me,Te,Ye){super(Q,me),this.canIncreaseVerbosity=Te,this.canDecreaseVerbosity=Ye}};e.$9N=re,e.$9N=re=Je([p],re);var pe;(function(K){K[K.Increase=0]="Increase",K[K.Decrease=1]="Decrease"})(pe||(e.HoverVerbosityAction=pe={}));var we;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(we||(e.DocumentHighlightKind=we={}));let Fe=class{constructor(Q,me=we.Text){this.range=Q,this.kind=me}toJSON(){return{range:this.range,kind:we[this.kind]}}};e.$0N=Fe,e.$0N=Fe=Je([p],Fe);let ze=class{constructor(Q,me){this.uri=Q,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(Q=>Q.toJSON())}}};e.$$N=ze,e.$$N=ze=Je([p],ze);var Re;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(Re||(e.SymbolKind=Re={}));var De;(function(K){K[K.Deprecated=1]="Deprecated"})(De||(e.SymbolTag=De={}));let Ce=n=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy")}constructor(Q,me,Te,Ye,ot){this.name=Q,this.kind=me,this.containerName=ot,typeof Te=="string"&&(this.containerName=Te),Ye instanceof te?this.location=Ye:Te instanceof M&&(this.location=new te(Ye,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};e.$_N=Ce,e.$_N=Ce=n=Je([p],Ce);let V=d=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy");if(!Q.range.contains(Q.selectionRange))throw new Error("selectionRange must be contained in fullRange");Q.children?.forEach(d.validate)}constructor(Q,me,Te,Ye,ot){this.name=Q,this.detail=me,this.kind=Te,this.range=Ye,this.selectionRange=ot,this.children=[],d.validate(this)}};e.$aO=V,e.$aO=V=d=Je([p],V);var G;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(G||(e.CodeActionTriggerKind=G={}));let J=class{constructor(Q,me){this.title=Q,this.kind=me}};e.$bO=J,e.$bO=J=Je([p],J);let x=class{static{l=this}static{this.c="."}constructor(Q){this.value=Q}append(Q){return new l(this.value?this.value+l.c+Q:Q)}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+l.c)}};e.$cO=x,e.$cO=x=l=Je([p],x),x.Empty=new x(""),x.QuickFix=x.Empty.append("quickfix"),x.Refactor=x.Empty.append("refactor"),x.RefactorExtract=x.Refactor.append("extract"),x.RefactorInline=x.Refactor.append("inline"),x.RefactorMove=x.Refactor.append("move"),x.RefactorRewrite=x.Refactor.append("rewrite"),x.Source=x.Empty.append("source"),x.SourceOrganizeImports=x.Source.append("organizeImports"),x.SourceFixAll=x.Source.append("fixAll"),x.Notebook=x.Empty.append("notebook");let de=class{constructor(Q,me){if(this.range=Q,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$dO=de,e.$dO=de=Je([p],de);class Ee{constructor(Q,me,Te,Ye,ot,$t){this.kind=Q,this.name=me,this.detail=Te,this.uri=Ye,this.range=ot,this.selectionRange=$t}}e.$eO=Ee;class Le{constructor(Q,me){this.fromRanges=me,this.from=Q}}e.$fO=Le;class He{constructor(Q,me){this.fromRanges=me,this.to=Q}}e.$gO=He;var Ke;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Ke||(e.LanguageStatusSeverity=Ke={}));let et=class{constructor(Q,me){this.range=Q,this.command=me}get isResolved(){return!!this.command}};e.$hO=et,e.$hO=et=Je([p],et);let nt=g=class{#e;static isMarkdownString(Q){return Q instanceof g?!0:Q&&Q.appendCodeblock&&Q.appendMarkdown&&Q.appendText&&Q.value!==void 0}constructor(Q,me=!1){this.#e=new A.$5k(Q,{supportThemeIcons:me})}get value(){return this.#e.value}set value(Q){this.#e.value=Q}get isTrusted(){return this.#e.isTrusted}set isTrusted(Q){this.#e.isTrusted=Q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(Q){this.#e.supportThemeIcons=Q}get supportHtml(){return this.#e.supportHtml}set supportHtml(Q){this.#e.supportHtml=Q}get baseUri(){return this.#e.baseUri}set baseUri(Q){this.#e.baseUri=Q}appendText(Q){return this.#e.appendText(Q),this}appendMarkdown(Q){return this.#e.appendMarkdown(Q),this}appendCodeblock(Q,me){return this.#e.appendCodeblock(me??"",Q),this}};e.$iO=nt,e.$iO=nt=g=Je([p],nt);let st=class{constructor(Q,me){this.label=Q,this.documentation=me}};e.$jO=st,e.$jO=st=Je([p],st);let rt=class{constructor(Q,me){this.label=Q,this.documentation=me,this.parameters=[]}};e.$kO=rt,e.$kO=rt=Je([p],rt);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$lO=at,e.$lO=at=Je([p],at);var gt;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(gt||(e.SignatureHelpTriggerKind=gt={}));var dt;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(dt||(e.InlayHintKind=dt={}));let ct=class{constructor(Q){this.value=Q}};e.$mO=ct,e.$mO=ct=Je([p],ct);let Pe=class{constructor(Q,me,Te){this.position=Q,this.label=me,this.kind=Te}};e.$nO=Pe,e.$nO=Pe=Je([p],Pe);var Be;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Qe;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Qe||(e.CompletionItemKind=Qe={}));var Ne;(function(K){K[K.Deprecated=1]="Deprecated"})(Ne||(e.CompletionItemTag=Ne={}));let je=class{constructor(Q,me){this.label=Q,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$oO=je,e.$oO=je=Je([p],je);let ue=class{constructor(Q=[],me=!1){this.items=Q,this.isIncomplete=me}};e.$pO=ue,e.$pO=ue=Je([p],ue);let he=class{constructor(Q,me,Te){this.insertText=Q,this.range=me,this.command=Te}};e.$qO=he,e.$qO=he=Je([p],he);let le=class{constructor(Q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=Q}};e.$rO=le,e.$rO=le=Je([p],le);var Ze;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(Ze||(e.PartialAcceptTriggerKind=Ze={}));var tt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var ut;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ut||(e.StatusBarAlignment=ut={}));function mt(K,Q){return`${y.$sn.toKey(K)}.${Q}`}var Dt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(Dt||(e.TextEditorLineNumbersStyle=Dt={}));var Mt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Mt||(e.TextDocumentSaveReason=Mt={}));var Ht;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var ei;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(ei||(e.TextEditorSelectionChangeKind=ei={}));var oi;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(oi||(e.TextDocumentChangeReason=oi={}));var Ot;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(K){function Q(me){switch(me){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=Q}(ei||(e.TextEditorSelectionChangeKind=ei={}));var it;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(K){function Q(me){switch(me){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=Q}(it||(e.SyntaxTokenType=it={}));let Ct=class{constructor(Q,me){if(me&&!c.URI.isUri(me))throw(0,h.$7)("target");if(!M.isRange(Q)||Q.isEmpty)throw(0,h.$7)("range");this.range=Q,this.target=me}};e.$tO=Ct,e.$tO=Ct=Je([p],Ct);let hi=class{constructor(Q,me,Te,Ye){this.red=Q,this.green=me,this.blue=Te,this.alpha=Ye}};e.$uO=hi,e.$uO=hi=Je([p],hi);let bt=class{constructor(Q,me){if(me&&!(me instanceof hi))throw(0,h.$7)("color");if(!M.isRange(Q)||Q.isEmpty)throw(0,h.$7)("range");this.range=Q,this.color=me}};e.$vO=bt,e.$vO=bt=Je([p],bt);let St=class{constructor(Q){if(!Q||typeof Q!="string")throw(0,h.$7)("label");this.label=Q}};e.$wO=St,e.$wO=St=Je([p],St);var ti;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ii;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var qt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));var pt;(function(K){K[K.Low=0]="Low",K[K.Medium=1]="Medium",K[K.High=2]="High"})(pt||(e.TerminalShellExecutionCommandLineConfidence=pt={}));class zt{constructor(Q,me,Te){if(this.startIndex=Q,this.length=me,this.tooltip=Te,typeof Q!="number"||Q<0)throw(0,h.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,h.$7)("length");if(Te!==void 0&&typeof Te!="string")throw(0,h.$7)("tooltip")}}e.$xO=zt;class ni{constructor(Q){this.uri=Q}}e.$yO=ni;class ai{constructor(Q){this.terminalCommand=Q}}e.$zO=ai;var xe;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(xe||(e.TerminalLocation=xe={}));class ci{constructor(Q){if(this.options=Q,typeof Q!="object")throw(0,h.$7)("options")}}e.$AO=ci;var di;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var fi;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(fi||(e.TaskPanelKind=fi={}));let vt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(Q){switch(Q){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(Q,me){if(this.label=me,typeof Q!="string"||typeof me!="string")throw(0,h.$7)("name");this.c=Q}get id(){return this.c}};e.$BO=vt,e.$BO=vt=E=Je([p],vt);function jt(K){let Q="";for(let me=0;me<K.length;me++)Q+=K[me].replace(/,/g,",,")+",";return Q}let Nt=class{constructor(Q,me,Te){if(typeof Q!="string")throw(0,h.$7)("process");this.e=[],this.c=Q,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Te):this.f=me)}get process(){return this.c}set process(Q){if(typeof Q!="string")throw(0,h.$7)("process");this.c=Q}get args(){return this.e}set args(Q){Array.isArray(Q)||(Q=[]),this.e=Q}get options(){return this.f}set options(Q){this.f=Q}computeId(){const Q=[];if(Q.push("process"),this.c!==void 0&&Q.push(this.c),this.e&&this.e.length>0)for(const me of this.e)Q.push(me);return jt(Q)}};e.$CO=Nt,e.$CO=Nt=Je([p],Nt);let Gt=class{constructor(Q,me,Te){if(this.f=[],Array.isArray(me)){if(!Q)throw(0,h.$7)("command can't be undefined or null");if(typeof Q!="string"&&typeof Q.value!="string")throw(0,h.$7)("command");this.e=Q,this.f=me,this.g=Te}else{if(typeof Q!="string")throw(0,h.$7)("commandLine");this.c=Q,this.g=me}}get commandLine(){return this.c}set commandLine(Q){if(typeof Q!="string")throw(0,h.$7)("commandLine");this.c=Q}get command(){return this.e?this.e:""}set command(Q){if(typeof Q!="string"&&typeof Q.value!="string")throw(0,h.$7)("command");this.e=Q}get args(){return this.f}set args(Q){this.f=Q||[]}get options(){return this.g}set options(Q){this.g=Q}computeId(){const Q=[];if(Q.push("shell"),this.c!==void 0&&Q.push(this.c),this.e!==void 0&&Q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)Q.push(typeof me=="string"?me:me.value);return jt(Q)}};e.$DO=Gt,e.$DO=Gt=Je([p],Gt);var ri;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var Xt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Xt||(e.TaskScope=Xt={}));class li{constructor(Q){this.c=Q}computeId(){return"customExecution"+(0,I.$3g)()}set callback(Q){this.c=Q}get callback(){return this.c}}e.$EO=li;let Wt=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(Q,me,Te,Ye,ot,$t){this.k=!1,this.l=this.definition=Q;let yt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Te,this.execution=Ye,yt=ot,this.k=!0):me===Xt.Global||me===Xt.Workspace?(this.target=me,this.o=this.name=Te,this.w=this.source=Ye,this.execution=ot,yt=$t):(this.target=me,this.o=this.name=Te,this.w=this.source=Ye,this.execution=ot,yt=$t),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(Q){this.j=Q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:S.e,id:this.q.computeId()}:this.q instanceof Gt?this.l={type:S.f,id:this.q.computeId()}:this.q instanceof li?this.l={type:S.c,id:this.q.computeId()}:this.l={type:S.g,id:(0,I.$3g)()}}get definition(){return this.l}set definition(Q){if(Q==null)throw(0,h.$7)("Kind can't be undefined or null");this.B(),this.l=Q}get scope(){return this.m}set target(Q){this.B(),this.m=Q}get name(){return this.o}set name(Q){if(typeof Q!="string")throw(0,h.$7)("name");this.B(),this.o=Q}get execution(){return this.q}set execution(Q){Q===null&&(Q=void 0),this.B(),this.q=Q;const me=this.l.type;(S.g===me||S.e===me||S.f===me||S.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(Q){if(Array.isArray(Q))this.B(),this.r=Q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(Q){Q!==!0&&Q!==!1&&(Q=!1),this.B(),this.u=Q}get source(){return this.w}set source(Q){if(typeof Q!="string"||Q.length===0)throw(0,h.$7)("source must be a string of length > 0");this.B(),this.w=Q}get group(){return this.x}set group(Q){Q===null&&(Q=void 0),this.B(),this.x=Q}get detail(){return this.A}set detail(Q){Q===null&&(Q=void 0),this.A=Q}get presentationOptions(){return this.y}set presentationOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.y=Q}get runOptions(){return this.z}set runOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.z=Q}};e.$FO=Wt,e.$FO=Wt=S=Je([p],Wt);var Kt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Kt||(e.ProgressLocation=Kt={}));var Jt;(function(K){function Q(me){const Te=me;return(0,b.$jg)(Te.value)?Te.tooltip&&!(0,b.$fg)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}K.isViewBadge=Q})(Jt||(e.ViewBadge=Jt={}));let Ft=D=class{static isTreeItem(Q,me){const Te=Q;if(Te.checkboxState!==void 0){const Ye=(0,b.$jg)(Te.checkboxState)?Te.checkboxState:(0,b.$hg)(Te.checkboxState)&&(0,b.$jg)(Te.checkboxState.state)?Te.checkboxState.state:void 0,ot=!(0,b.$jg)(Te.checkboxState)&&(0,b.$hg)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==It.Checked&&Ye!==It.Unchecked||ot!==void 0&&!(0,b.$fg)(ot))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(Q instanceof D)return!0;if(Te.label!==void 0&&!(0,b.$fg)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,b.$fg)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,b.$fg)(Te.iconPath)&&!c.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,b.$fg)(Te.iconPath.id))){const Ye=Te.iconPath;if(!Ye||!(0,b.$fg)(Ye.light)&&!c.URI.isUri(Ye.light)&&!(0,b.$fg)(Ye.dark)&&!c.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,b.$fg)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!c.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,b.$fg)(Te.tooltip)&&!(Te.tooltip instanceof nt)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<wt.None&&Te.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,b.$fg)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(Q,me=wt.None){this.collapsibleState=me,c.URI.isUri(Q)?this.resourceUri=Q:this.label=Q}};e.$GO=Ft,e.$GO=Ft=D=Je([p],Ft);var wt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var It;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(It||(e.TreeItemCheckboxState=It={}));let Qt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(Q){this.value=Q}};e.$HO=Qt,e.$HO=Qt=Je([p],Qt);class Pt extends Qt{}e.$IO=Pt;class mi extends Pt{#e;constructor(Q){super(""),this.#e=Q}asFile(){return this.#e}}e.$JO=mi;class xt{constructor(Q,me,Te,Ye){this.name=Q,this.uri=me,this._itemId=Te,this.c=Ye}data(){return this.c()}}e.$KO=xt;let ki=class{#e=new Map;constructor(Q){for(const[me,Te]of Q??[]){const Ye=this.#e.get(this.#t(me));Ye?Ye.push(Te):this.#e.set(this.#t(me),[Te])}}get(Q){return this.#e.get(this.#t(Q))?.[0]}set(Q,me){this.#e.set(this.#t(Q),[me])}forEach(Q,me){for(const[Te,Ye]of this.#e)for(const ot of Ye)Q.call(me,ot,Te,this)}*[Symbol.iterator](){for(const[Q,me]of this.#e)for(const Te of me)yield[Q,Te]}#t(Q){return Q.toLowerCase()}};e.$LO=ki,e.$LO=ki=Je([p],ki);let bi=class{constructor(Q,me,Te){this.insertText=Q,this.title=me,this.kind=Te}};e.$MO=bi,e.$MO=bi=Je([p],bi);var Ri;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(Ri||(e.DocumentPasteTriggerKind=Ri={}));class Tt{static{this.c="."}constructor(Q){this.value=Q}append(...Q){return new Tt((this.value?[this.value,...Q]:Q).join(Tt.c))}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+Tt.c)}}e.$NO=Tt,Tt.Empty=new Tt("");class Li{constructor(Q,me,Te){this.title=me,this.insertText=Q,this.kind=Te}}e.$OO=Li;let ui=class{constructor(Q,me){this.id=Q,this.color=me}static isThemeIcon(Q){return typeof Q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",Q.id),!1):!0}};e.$PO=ui,e.$PO=ui=Je([p],ui),ui.File=new ui("file"),ui.Folder=new ui("folder");let At=class{constructor(Q){this.id=Q}};e.$QO=At,e.$QO=At=Je([p],At);var Oi;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Oi||(e.ConfigurationTarget=Oi={}));let Ii=class{get base(){return this.c}set base(Q){this.c=Q,this.e=c.URI.file(Q)}get baseUri(){return this.e}set baseUri(Q){this.e=Q,this.c=Q.fsPath}constructor(Q,me){if(typeof Q!="string"&&(!Q||!c.URI.isUri(Q)&&!c.URI.isUri(Q.uri)))throw(0,h.$7)("base");if(typeof me!="string")throw(0,h.$7)("pattern");typeof Q=="string"?this.baseUri=c.URI.file(Q):c.URI.isUri(Q)?this.baseUri=Q:this.baseUri=Q.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$RO=Ii,e.$RO=Ii=Je([p],Ii);const Si=new WeakMap;function Ni(K,Q){Si.set(K,Q)}let wi=class{constructor(Q,me,Te,Ye,ot){this.enabled=typeof Q=="boolean"?Q:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof Ye=="string"&&(this.logMessage=Ye),typeof ot=="string"&&(this.mode=ot)}get id(){return this.c||(this.c=Si.get(this)??(0,I.$3g)()),this.c}};e.$TO=wi,e.$TO=wi=Je([p],wi);let Vt=class extends wi{constructor(Q,me,Te,Ye,ot,$t){if(super(me,Te,Ye,ot,$t),Q===null)throw(0,h.$7)("location");this.location=Q}};e.$UO=Vt,e.$UO=Vt=Je([p],Vt);let Oe=class extends wi{constructor(Q,me,Te,Ye,ot,$t){super(me,Te,Ye,ot,$t),this.functionName=Q}};e.$VO=Oe,e.$VO=Oe=Je([p],Oe);let Me=class extends wi{constructor(Q,me,Te,Ye,ot,$t,yt,Yt){if(super(Ye,ot,$t,yt,Yt),!me)throw(0,h.$7)("dataId");this.label=Q,this.dataId=me,this.canPersist=Te}};e.$WO=Me,e.$WO=Me=Je([p],Me);let Se=class{constructor(Q,me,Te){this.command=Q,this.args=me||[],this.options=Te}};e.$XO=Se,e.$XO=Se=Je([p],Se);let ie=class{constructor(Q,me){this.port=Q,this.host=me}};e.$YO=ie,e.$YO=ie=Je([p],ie);let Ae=class{constructor(Q){this.path=Q}};e.$ZO=Ae,e.$ZO=Ae=Je([p],Ae);let Ge=class{constructor(Q){this.implementation=Q}};e.$1O=Ge,e.$1O=Ge=Je([p],Ge);class _e{constructor(Q,me,Te){this.session=Q,this.threadId=me,this.frameId=Te}}e.$2O=_e;class Xe{constructor(Q,me){this.session=Q,this.threadId=me}}e.$3O=Xe;let ft=class{constructor(Q,me){this.range=Q,this.expression=me}};e.$4O=ft,e.$4O=ft=Je([p],ft);var Rt;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Rt||(e.InlineCompletionTriggerKind=Rt={}));let Zt=class{constructor(Q,me){this.range=Q,this.text=me}};e.$5O=Zt,e.$5O=Zt=Je([p],Zt);let si=class{constructor(Q,me,Te=!0){this.range=Q,this.variableName=me,this.caseSensitiveLookup=Te}};e.$6O=si,e.$6O=si=Je([p],si);let Bt=class{constructor(Q,me){this.range=Q,this.expression=me}};e.$7O=Bt,e.$7O=Bt=Je([p],Bt);let _t=class{constructor(Q,me){this.frameId=Q,this.stoppedLocation=me}};e.$8O=_t,e.$8O=_t=Je([p],_t);var Wi;(function(K){K[K.AIGenerated=1]="AIGenerated"})(Wi||(e.NewSymbolNameTag=Wi={}));var rn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(rn||(e.NewSymbolNameTriggerKind=rn={}));class Vi{constructor(Q,me){this.newSymbolName=Q,this.tags=me}}e.$9O=Vi;var Mi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Mi||(e.FileChangeType=Mi={}));let Hi=k=class extends Error{static FileExists(Q){return new k(Q,u.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(Q){return new k(Q,u.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(Q){return new k(Q,u.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(Q){return new k(Q,u.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(Q){return new k(Q,u.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(Q){return new k(Q,u.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(Q,me=u.FileSystemProviderErrorCode.Unknown,Te){super(c.URI.isUri(Q)?Q.toString(!0):Q),this.code=Te?.name??"Unknown",(0,u.$ql)(this,me),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};e.$0O=Hi,e.$0O=Hi=k=Je([p],Hi);let Gi=class{constructor(Q,me,Te){this.start=Q,this.end=me,this.kind=Te}};e.$$O=Gi,e.$$O=Gi=Je([p],Gi);var Pi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Pi||(e.FoldingRangeKind=Pi={}));var sn;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(sn||(e.CommentThreadCollapsibleState=sn={}));var on;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(on||(e.CommentMode=on={}));var ji;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(ji||(e.CommentState=ji={}));var an;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(an||(e.CommentThreadState=an={}));var Bi;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(Bi||(e.CommentThreadApplicability=Bi={}));var Qi;(function(K){K[K.Reply=1]="Reply",K[K.Comment=2]="Comment"})(Qi||(e.CommentThreadFocus=Qi={}));class yn{constructor(Q,me=[]){this.tokenTypes=Q,this.tokenModifiers=me}}e.$_O=yn;function cn(K){return typeof K>"u"||(0,b.$gg)(K)}class Ki{constructor(Q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,Q){this.m=!0;for(let me=0,Te=Q.tokenTypes.length;me<Te;me++)this.k.set(Q.tokenTypes[me],me);for(let me=0,Te=Q.tokenModifiers.length;me<Te;me++)this.l.set(Q.tokenModifiers[me],me)}}push(Q,me,Te,Ye,ot){if(typeof Q=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"&&(typeof ot=="number"||typeof ot>"u"))return typeof ot>"u"&&(ot=0),this.q(Q,me,Te,Ye,ot);if(M.isRange(Q)&&typeof me=="string"&&cn(Te))return this.o(Q,me,Te);throw(0,h.$7)()}o(Q,me,Te){if(!this.m)throw new Error("Legend must be provided in constructor");if(Q.start.line!==Q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=Q.start.line,ot=Q.start.character,$t=Q.end.character-Q.start.character,yt=this.k.get(me);let Yt=0;if(Te)for(const pi of Te){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const yi=this.l.get(pi);Yt|=1<<yi>>>0}this.q(Ye,ot,$t,yt,Yt)}q(Q,me,Te,Ye,ot){if(this.f&&(Q<this.c||Q===this.c&&me<this.e)){this.f=!1;const Yt=this.g.length/5|0;let pi=0,yi=0;for(let Di=0;Di<Yt;Di++){let Ai=this.g[5*Di],tn=this.g[5*Di+1];Ai===0?(Ai=pi,tn+=yi):Ai+=pi,this.g[5*Di]=Ai,this.g[5*Di+1]=tn,pi=Ai,yi=tn}}let $t=Q,yt=me;this.f&&this.j>0&&($t-=this.c,$t===0&&(yt-=this.e)),this.g[this.j++]=$t,this.g[this.j++]=yt,this.g[this.j++]=Te,this.g[this.j++]=Ye,this.g[this.j++]=ot,this.c=Q,this.e=me}static r(Q){const me=[],Te=Q.length/5|0;for(let yt=0;yt<Te;yt++)me[yt]=yt;me.sort((yt,Yt)=>{const pi=Q[5*yt],yi=Q[5*Yt];if(pi===yi){const Di=Q[5*yt+1],Ai=Q[5*Yt+1];return Di-Ai}return pi-yi});const Ye=new Uint32Array(Q.length);let ot=0,$t=0;for(let yt=0;yt<Te;yt++){const Yt=5*me[yt],pi=Q[Yt+0],yi=Q[Yt+1],Di=Q[Yt+2],Ai=Q[Yt+3],tn=Q[Yt+4],Gn=pi-ot,Nr=Gn===0?yi-$t:yi,nn=5*yt;Ye[nn+0]=Gn,Ye[nn+1]=Nr,Ye[nn+2]=Di,Ye[nn+3]=Ai,Ye[nn+4]=tn,ot=pi,$t=yi}return Ye}build(Q){return this.f?new Ci(new Uint32Array(this.g),Q):new Ci(Ki.r(this.g),Q)}}e.$aP=Ki;class Ci{constructor(Q,me){this.resultId=me,this.data=Q}}e.$bP=Ci;class Sn{constructor(Q,me,Te){this.start=Q,this.deleteCount=me,this.data=Te}}e.$cP=Sn;class Dn{constructor(Q,me){this.resultId=me,this.edits=Q}}e.$dP=Dn;var ln;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(ln||(e.DebugConsoleMode=ln={}));class Xi{constructor(Q){this.name=Q}}e.$eP=Xi;var Ji;(function(K){K[K.Title=1]="Title",K[K.Inline=2]="Inline"})(Ji||(e.QuickInputButtonLocation=Ji={}));let qe=class{static{this.Back={iconPath:new ui("arrow-left")}}constructor(){}};e.$fP=qe,e.$fP=qe=Je([p],qe);var vi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var Zi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var lt;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(lt||(e.ExtensionKind=lt={}));class kt{static validate(Q){if(typeof Q.badge=="string"){let me=(0,O.$Qf)(Q.badge,0);if(me<Q.badge.length&&(me+=(0,O.$Qf)(Q.badge,me)),Q.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(Q.badge&&!ui.isThemeIcon(Q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!Q.color&&!Q.badge&&!Q.tooltip)throw new Error("The decoration is empty");return!0}constructor(Q,me,Te){this.badge=Q,this.tooltip=me,this.color=Te}}e.$gP=kt;let Yi=class{constructor(Q){this.kind=Q}};e.$hP=Yi,e.$hP=Yi=Je([p],Yi);var un;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(un||(e.ColorThemeKind=un={}));class Ei{static isNotebookRange(Q){return Q instanceof Ei?!0:Q?typeof Q.start=="number"&&typeof Q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(Q,me){if(Q<0)throw(0,h.$7)("start must be positive");if(me<0)throw(0,h.$7)("end must be positive");Q<=me?(this.c=Q,this.e=me):(this.c=me,this.e=Q)}with(Q){let me=this.c,Te=this.e;return Q.start!==void 0&&(me=Q.start),Q.end!==void 0&&(Te=Q.end),me===this.c&&Te===this.e?this:new Ei(me,Te)}}e.$iP=Ei;class zi{static validate(Q){if(typeof Q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof Q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof Q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(Q){return Array.isArray(Q)&&Q.every(me=>zi.isNotebookCellData(me))}static isNotebookCellData(Q){return!0}constructor(Q,me,Te,Ye,ot,$t,yt){this.kind=Q,this.value=me,this.languageId=Te,this.mime=Ye,this.outputs=ot??[],this.metadata=$t,this.executionSummary=yt,zi.validate(this)}}e.$jP=zi;class Ui{constructor(Q){this.cells=Q}}e.$kP=Ui;class $i{static isNotebookCellOutputItem(Q){return Q instanceof $i?!0:Q?typeof Q.mime=="string"&&Q.data instanceof Uint8Array:!1}static error(Q){const me={name:Q.name,message:Q.message,stack:Q.stack};return $i.json(me,"application/vnd.code.notebook.error")}static stdout(Q){return $i.text(Q,"application/vnd.code.notebook.stdout")}static stderr(Q){return $i.text(Q,"application/vnd.code.notebook.stderr")}static bytes(Q,me="application/octet-stream"){return new $i(Q,me)}static#e=new TextEncoder;static text(Q,me=T.$_s.text){const Te=$i.#e.encode(String(Q));return new $i(Te,me)}static json(Q,me="text/x-json"){const Te=JSON.stringify(Q,void 0,"	");return $i.text(Te,me)}constructor(Q,me){this.data=Q,this.mime=me;const Te=(0,T.$dt)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.$lP=$i;class qi{static isNotebookCellOutput(Q){return Q instanceof qi?!0:!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&Array.isArray(Q.items)}static ensureUniqueMimeTypes(Q,me=!1){const Te=new Set,Ye=new Set;for(let ot=0;ot<Q.length;ot++){const $t=Q[ot],yt=(0,T.$dt)($t.mime);if(!Te.has(yt)||(0,w.$QL)(yt)){Te.add(yt);continue}Ye.add(ot),me&&console.warn(`DUPLICATED mime type '${$t.mime}' will be dropped`)}return Ye.size===0?Q:Q.filter((ot,$t)=>!Ye.has($t))}constructor(Q,me,Te){this.items=qi.ensureUniqueMimeTypes(Q,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,I.$3g)(),this.metadata=me??Te)}}e.$mP=qi;var hn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(hn||(e.NotebookCellKind=hn={}));var xi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var dn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(dn||(e.NotebookCellStatusBarAlignment=dn={}));var fn;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(fn||(e.NotebookEditorRevealType=fn={}));class kn{constructor(Q,me){this.text=Q,this.alignment=me}}e.$nP=kn;var gn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(gn||(e.NotebookControllerAffinity=gn={}));var mn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(mn||(e.NotebookControllerAffinity2=mn={}));class In{constructor(Q,me=[]){this.uri=Q,this.provides=(0,r.$2b)(me)}}e.$oP=In;class Pn{constructor(Q){this.label=Q}}e.$pP=Pn;var $n;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})($n||(e.NotebookVariablesRequestKind=$n={}));let _i=class{constructor(Q,me){this.label=Q,this.timestamp=me}};e.$qP=_i,e.$qP=_i=Je([p],_i);var pn;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(pn||(e.ExtensionMode=pn={}));var bn;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(bn||(e.ExtensionRuntime=bn={}));var fe;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(fe||(e.StandardTokenType=fe={}));class be{constructor(Q,me){this.ranges=Q,this.wordPattern=me}}e.$rP=be;class Ue{constructor(Q){this.c=Q}get autoForwardAction(){return this.c}}e.$sP=Ue;var ht;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(ht||(e.TestResultState=ht={}));var Et;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(Et||(e.TestRunProfileKind=Et={}));let Lt=class{constructor(Q=void 0,me=void 0,Te=void 0,Ye=!1,ot=!0){this.include=Q,this.exclude=me,this.profile=Te,this.continuous=Ye,this.preserveFocus=ot}};e.$tP=Lt,e.$tP=Lt=Je([p],Lt);let gi=P=class{static diff(Q,me,Te){const Ye=new P(Q);return Ye.expectedOutput=me,Ye.actualOutput=Te,Ye}constructor(Q){this.message=Q}};e.$uP=gi,e.$uP=gi=P=Je([p],gi);let Fi=class{constructor(Q){this.id=Q}};e.$vP=Fi,e.$vP=Fi=Je([p],Fi);class en{constructor(Q,me,Te){this.label=Q,this.uri=me,this.position=Te}}e.$wP=en;class wn{constructor(Q,me){this.covered=Q,this.total=me,An(this)}}e.$xP=wn;function An(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class Cn{static fromDetails(Q,me){const Te=new wn(0,0),Ye=new wn(0,0),ot=new wn(0,0);for(const yt of me)if("branches"in yt){Te.total+=1,Te.covered+=yt.executed?1:0;for(const Yt of yt.branches)Ye.total+=1,Ye.covered+=Yt.executed?1:0}else ot.total+=1,ot.covered+=yt.executed?1:0;const $t=new Cn(Q,Te,Ye.total>0?Ye:void 0,ot.total>0?ot:void 0);return $t.detailedCoverage=me,$t}constructor(Q,me,Te,Ye,ot=[]){this.uri=Q,this.statementCoverage=me,this.branchCoverage=Te,this.declarationCoverage=Ye,this.fromTests=ot}}e.$zP=Cn;class Xn{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Te=[]){this.executed=Q,this.location=me,this.branches=Te}}e.$AP=Xn;class Jn{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Te){this.executed=Q,this.location=me,this.label=Te}}e.$BP=Jn;class Zn{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,me,Te){this.name=Q,this.executed=me,this.location=Te}}e.$CP=Zn;var Rn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var On;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(On||(e.WorkspaceTrustState=On={}));var Tn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Yn{constructor(Q,me,Te,Ye,ot,$t){this.kind=Q,this.name=me,this.detail=Te,this.uri=Ye,this.range=ot,this.selectionRange=$t}}e.$DP=Yn;class xn{constructor(Q){this.uri=Q}}e.$EP=xn;class _n{constructor(Q,me){this.original=Q,this.modified=me}}e.$FP=_n;class er{constructor(Q,me,Te,Ye){this.base=Q,this.input1=me,this.input2=Te,this.result=Ye}}e.$GP=er;class tr{constructor(Q,me){this.uri=Q,this.viewType=me}}e.$HP=tr;class ir{constructor(Q){this.viewType=Q}}e.$IP=ir;class nr{constructor(Q,me){this.uri=Q,this.notebookType=me}}e.$JP=nr;class rr{constructor(Q,me,Te){this.original=Q,this.modified=me,this.notebookType=Te}}e.$KP=rr;class sr{constructor(){}}e.$LP=sr;class or{constructor(Q,me){this.uri=Q,this.inputBoxUri=me}}e.$MP=or;class ar{constructor(){}}e.$NP=ar;class cr{constructor(Q){this.textDiffs=Q}}e.$OP=cr;var Ln;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(Ln||(e.InteractiveSessionVoteDirection=Ln={}));var Nn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Fn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Fn||(e.ChatVariableLevel=Fn={}));class lr{constructor(Q,me,Te){this.id=Q,this.label=me,this.values=Te}}e.$PP=lr;var Mn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var jn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(jn||(e.ChatResultFeedbackKind=jn={}));class ur{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new nt(Q):Q}}e.$QP=ur;class hr{constructor(Q,me){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new nt(Q):Q,this.vulnerabilities=me}}e.$RP=hr;class dr{constructor(Q,me){this.participant=Q,this.command=me}}e.$SP=dr;class fr{constructor(Q,me,Te,Ye){this.title=Q,this.message=me,this.data=Te,this.buttons=Ye}}e.$TP=fr;class gr{constructor(Q,me){this.value=Q,this.baseUri=me}}e.$UP=gr;class mr{constructor(Q,me){this.value=Q,this.title=me}}e.$VP=mr;class $r{constructor(Q){this.value=Q}}e.$WP=$r;class pr{constructor(Q,me){this.value=Q,this.task=me}}e.$XP=pr;class br{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new nt(Q):Q}}e.$YP=br;class wr{constructor(Q){this.value=Q}}e.$ZP=wr;class vr{constructor(Q,me,Te){this.value=Q,this.iconPath=me,this.options=Te}}e.$1P=vr;class Er{constructor(Q,me,Te){this.value=Q,this.license=me,this.snippet=Te}}e.$2P=Er;class yr{constructor(Q,me){this.uri=Q,this.edits=Array.isArray(me)?me:[me]}}e.$3P=yr;class Sr{constructor(Q,me,Te,Ye){this.prompt=Q,this.command=me,this.references=Te,this.participant=Ye}}e.$4P=Sr;class Dr{constructor(Q,me,Te,Ye){this.response=Q,this.result=me,this.participant=Te,this.command=Ye}}e.$5P=Dr;var Bn;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(Bn||(e.ChatLocation=Bn={}));var zn;(function(K){K[K.Complete=1]="Complete",K[K.Partial=2]="Partial",K[K.Omitted=3]="Omitted"})(zn||(e.ChatResponseReferencePartStatusKind=zn={}));class kr{constructor(Q,me,Te){this.document=Q,this.selection=me,this.wholeRange=Te}}e.$6P=kr;class Ir{constructor(Q){this.cell=Q}}e.$7P=Ir;var vn;(function(K){K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.System=3]="System"})(vn||(e.LanguageModelChatMessageRole=vn={}));class Pr{constructor(Q,me,Te){this.name=Q,this.content=me,this.isError=Te??!1}}e.$8P=Pr;class En{static User(Q,me){const Te=new En(vn.User,typeof Q=="string"?Q:"",me);return Te.content2=Q,Te}static Assistant(Q,me){return new En(vn.Assistant,Q,me)}constructor(Q,me,Te){this.role=Q,this.content=me,this.content2=me,this.name=Te}}e.$9P=En;class Cr{constructor(Q,me){this.name=Q,this.parameters=me}}e.$0P=Cr;class Ar{constructor(Q){this.value=Q}}e.$$P=Ar;class Rr{constructor(Q){this.content=Q}}e.$_P=Rr;class Or{constructor(Q,me){this.content=Q,this.name=me}}e.$aQ=Or;class Tr{constructor(Q,me){this.content=Q,this.name=me}}e.$bQ=Tr;class Ti extends Error{static NotFound(Q){return new Ti(Q,Ti.NotFound.name)}static NoPermissions(Q){return new Ti(Q,Ti.NoPermissions.name)}static Blocked(Q){return new Ti(Q,Ti.Blocked.name)}constructor(Q,me,Te){super(Q,{cause:Te}),this.name="LanguageModelError",this.code=me??""}}e.$cQ=Ti;var Un;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Un||(e.RelatedInformationType=Un={}));var qn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped",K[K.Error=5]="Error"})(qn||(e.SpeechToTextStatus=qn={}));var Wn;(function(K){K[K.Started=1]="Started",K[K.Stopped=2]="Stopped",K[K.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var Vn;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(Vn||(e.KeywordRecognitionStatus=Vn={}));class Lr{constructor(Q,me){this.text=Q,this.range=me}}e.$dQ=Lr;var Hn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Hn||(e.InlineEditTriggerKind=Hn={}))}),define(ke[290],Ie([1,0,6,9]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=void 0;class A{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(r.$ON.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,O,b){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(T);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(O,b)??[]}getRelatedInformation(T,O,b){return this.c.$getAiRelatedInformation(O,b)}registerRelatedInformationProvider(T,O,b){const c=this.b;return this.b++,this.a.set(c,b),this.c.$registerAiRelatedInformationProvider(c,O),new h.$QN(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$Dpc=A}),define(ke[127],Ie([1,0,4,6,9,23,157,5,19]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=e.$Opc=void 0,e.$Opc=(0,O.$Gi)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new r.$me,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=u.getProxy(h.$ON.MainThreadAuthentication)}async getSession(u,C,w,a={}){const m=R.$sn.toKey(u.identifier),$=[...w].sort().join(" ");return await this.d.getOrCreate(`${m} ${C} ${$}`,async()=>{await this.a.$ensureProvider(C);const f=u.displayName||u.name;return this.a.$getSession(C,w,m,f,a)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,C){const w=this.b.get(u);return w?w.provider.removeSession(C):this.a.$removeSession(u,C)}registerAuthenticationProvider(u,C,w,a){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:C,provider:w,options:a??{supportsMultipleAccounts:!1}});const m=w.onDidChangeSessions($=>this.a.$sendDidChangeSessions(u,$));return this.a.$registerAuthenticationProvider(u,C,a?.supportsMultipleAccounts??!1),new A.$QN(()=>{m.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,C,w){const a=this.b.get(u);if(a)return await a.provider.createSession(C,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,C){const w=this.b.get(u);if(w)return await w.provider.removeSession(C);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,C,w){const a=this.b.get(u);if(a)return await a.provider.getSessions(C,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,C){return u.startsWith(T.$QM)||this.c.fire({provider:{id:u,label:C}}),Promise.resolve()}};e.$Ppc=c,e.$Ppc=c=Je([Ve(0,b.$oQ)],c);class I{constructor(){this.a=new Map}getOrCreate(u,C){const w=this.a.get(u);if(w)return w;const a=C().finally(()=>this.a.delete(u));return this.a.set(u,a),a}}}),define(ke[164],Ie([1,0,2,6,9,5,19,11,18,12,16,25]),function($e,e,r,h,A,R,T,O,b,c,I,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=e.$Tqc=void 0;let C=class{static{u=this}static{this.c=0}static{this.d=250}constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(h.$ON.MainThreadDecorations)}registerFileDecorationProvider(a,m){const $=u.c++;this.f.set($,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider($,m.identifier.value);const f=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange($,null);return}const s=(0,b.$2b)(i);if(s.length<=u.d){this.g.$onDidChange($,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,s.length);const t=s.map(d=>({uri:d,rank:(0,c.$jf)(d.path,"/")})),o=(0,b.$zb)(t,(d,l)=>d.rank-l.rank||(0,c.$zf)(d.uri.path,l.uri.path)),n=[];e:for(const d of o){let l;for(const g of d){const E=(0,I.$nc)(g.uri.path);if(l!==E&&(l=E,n.push(g.uri)>=u.d))break e}}this.g.$onDidChange($,n)});return new A.$QN(()=>{f?.dispose(),this.g.$unregisterDecorationProvider($),this.f.delete($)})}async $provideDecorations(a,m,$){if(!this.f.has(a))return Object.create(null);const f=Object.create(null),{provider:i,extensionDescription:s}=this.f.get(a);return await Promise.all(m.map(async t=>{try{const{uri:o,id:n}=t,d=await Promise.resolve(i.provideFileDecoration(r.URI.revive(o),$));if(!d)return;try{A.$gP.validate(d),d.badge&&typeof d.badge!="string"&&(0,y.$jH)(s,"codiconDecoration"),f[n]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(o){this.h.error(o)}})),f}};e.$Tqc=C,e.$Tqc=C=u=Je([Ve(0,T.$oQ),Ve(1,O.$bk)],C),e.$Uqc=(0,R.$Gi)("IExtHostDecorations")}),define(ke[291],Ie([1,0,13,2,9,6,14,20,12]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=void 0;class c{static{this.a=0}constructor(y,u,C){this.d=u,this.e=C,this.b=new Map,this.c=y.getProxy(R.$ON.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(T.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const C=c.a++;this.b.set(C,u),this.c.$registerTextContentProvider(C,y);let w;if(typeof u.onDidChange=="function"){let a;w=u.onDidChange(async m=>{if(m.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const $=this.$provideTextDocumentContent(C,m).then(async f=>{if(!f&&typeof f!="string")return;const i=this.d.getDocument(m);if(!i)return;const s=(0,b.$tf)(f);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(m,f)}).catch(r.$Z).finally(()=>{a===$&&(a=void 0)});a=$})}return new A.$QN(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(y,u){const C=this.b.get(y);return C?Promise.resolve(C.provideTextDocumentContent(h.URI.revive(u),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Wqc=c}),define(ke[165],Ie([1,0,65,14,12,206,141,9,18]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.$rQ=void 0,e.$qQ=I;const c=new Map;function I(w,a){a?c.set(w,a):c.delete(w)}function y(w){return c.get(w)}class u extends R.$rw{constructor(a,m,$,f,i,s,t){super(m,$,f,i),this.c=a,this.m=s,this.q=t,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,b.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===h.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,$){return a.y(m,$)},[Symbol.for("debug.description")](){return`TextDocument(${a.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,r.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,r.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const $=this.g,f=m.start.line,i=m.end.line,s=[];s.push(this.f[f].substring(m.start.character));for(let t=f+1;t<i;t++)s.push(this.f[t]);return s.push(this.f[i].substring(0,m.end.character)),s.join($)}t(a){let m;if(a instanceof O.$RN?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new C(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),$=this.f[m.index].length;return new O.$RN(m.index,Math.min(m.remainder,$))}w(a){if(!(a instanceof O.$SN))throw new Error("Invalid argument");const m=this.x(a.start),$=this.x(a.end);return m===a.start&&$===a.end?a:new O.$SN(m.line,m.character,$.line,$.character)}x(a){if(!(a instanceof O.$RN))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:$}=a,f=!1;if(m<0)m=0,$=0,f=!0;else if(m>=this.f.length)m=this.f.length-1,$=this.f[m].length,f=!0;else{const i=this.f[m].length;$<0?($=0,f=!0):$>i&&($=i,f=!0)}return f?new O.$RN(m,$):a}y(a,m){const $=this.x(a);if(!m)m=y(this.m);else if((0,A.$sf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const f=(0,T.$rt)($.character+1,(0,T.$pt)(m),this.f[$.line],0);if(f)return new O.$SN($.line,f.startColumn-1,$.line,f.endColumn-1)}}e.$rQ=u;class C{constructor(a,m,$){this.a=a,this.b=m,this.c=$}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.$SN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.$SN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$sQ=C}),define(ke[292],Ie([1,0,6,9]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=void 0;class A{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(r.$ON.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,O,b){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(T);if(!c)throw new Error("Embedding vector provider not found");const I=await c.provideEmbeddingVector(O,b);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(T,O,b){const c=this.b;return this.b++,this.a.set(c,b),this.c.$registerAiEmbeddingVectorProvider(O,c),new h.$QN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$Zqc=A}),define(ke[75],Ie([1,0,6,27,9,21,5,19,62,3,7,22,14]),function($e,e,r,h,A,R,T,O,b,c,I,y,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=e.$5pc=void 0,h=We(h);let w=C=class{constructor(m,$){this.b=new Map,this.c=new I.$Ph,this.a=m.getProxy(r.$ON.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(i){try{let s;const t=f.b.get(i.scheme);return t?(await f.a.$ensureActivation(i.scheme),s=await t.impl.stat(i)):s=await f.a.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===h.FilePermission.Readonly?1:void 0}}catch(s){C.e(s)}},async readDirectory(i){try{const s=f.b.get(i.scheme);return s?(await f.a.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await f.a.$readdir(i)}catch(s){return C.e(s)}},async createDirectory(i){try{const s=f.b.get(i.scheme);return s&&!s.isReadonly?(await f.a.$ensureActivation(i.scheme),await f.d(s.impl,s.extUri,i)):await f.a.$mkdir(i)}catch(s){return C.e(s)}},async readFile(i){try{const s=f.b.get(i.scheme);return s?(await f.a.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await f.a.$readFile(i)).buffer}catch(s){return C.e(s)}},async writeFile(i,s){try{const t=f.b.get(i.scheme);return t&&!t.isReadonly?(await f.a.$ensureActivation(i.scheme),await f.d(t.impl,t.extUri,t.extUri.dirname(i)),await f.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await f.a.$writeFile(i,R.$Oe.wrap(s))}catch(t){return C.e(t)}},async delete(i,s){try{const t=f.b.get(i.scheme);return t&&!t.isReadonly&&!s?.useTrash?(await f.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...s})):await f.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(t){return C.e(t)}},async rename(i,s,t){try{return await f.a.$rename(i,s,{overwrite:!1,...t})}catch(o){return C.e(o)}},async copy(i,s,t){try{return await f.a.$copy(i,s,{overwrite:!1,...t})}catch(o){return C.e(o)}},isWritableFileSystem(i){const s=$.getCapabilities(i);if(typeof s=="number")return!(s&h.FileSystemProviderCapabilities.Readonly)}})}async d(m,$,f){const i=[];for(;!$.isEqual(f,$.dirname(f));)try{if(!((await m.stat(f)).type&h.FileType.Directory))throw A.$0O.FileExists(`Unable to create folder '${f.scheme===u.Schemas.file?f.fsPath:f.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(h.$rl(s)!==h.FileSystemProviderErrorCode.FileNotFound)throw s;i.push($.basename(f)),f=$.dirname(f)}for(let s=i.length-1;s>=0;s--){f=$.joinPath(f,i[s]);try{await m.createDirectory(f)}catch(t){if(h.$rl(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e(m){if(m instanceof A.$0O)throw m;if(m instanceof h.$nl)switch(m.code){case h.FileSystemProviderErrorCode.FileExists:throw A.$0O.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw A.$0O.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw A.$0O.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw A.$0O.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw A.$0O.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw A.$0O.Unavailable(m.message);default:throw new A.$0O(m.message,m.name)}if(!(m instanceof Error))throw new A.$0O(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw A.$0O.Unavailable(m.message);switch(m.name){case h.FileSystemProviderErrorCode.FileExists:throw A.$0O.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw A.$0O.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw A.$0O.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw A.$0O.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw A.$0O.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw A.$0O.Unavailable(m.message);default:throw new A.$0O(m.message,m.name)}}addFileSystemProvider(m,$,f){return this.b.set(m,{impl:$,extUri:f?.isCaseSensitive?y.$0g:y.$_g,isReadonly:!!f?.isReadonly}),(0,c.$Tc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??y.$0g}};e.$5pc=w,e.$5pc=w=C=Je([Ve(0,O.$oQ),Ve(1,b.$Ipc)],w),e.$6pc=(0,T.$Gi)("IExtHostConsumerFileSystem")}),define(ke[97],Ie([1,0,5,29,11,75,2]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=e.$7pc=void 0,e.$7pc=(0,r.$Gi)("IExtensionStoragePaths");let O=class{constructor(c,I,y){this.d=I,this.f=y,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return T.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,I=await this.g(c);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(T.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:T.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(c){if(this.c)return T.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return T.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$8pc=O,e.$8pc=O=Je([Ve(0,h.$EQ),Ve(1,A.$bk),Ve(2,R.$6pc)],O)}),define(ke[293],Ie([1,0,9,19,4]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erc=void 0;let R=class{constructor(O){this.a=new r.$hP(r.ColorThemeKind.Dark),this.b=new A.$me}get activeColorTheme(){return this.a}$onColorThemeChange(O){let b;switch(O){case"light":b=r.ColorThemeKind.Light;break;case"hcDark":b=r.ColorThemeKind.HighContrast;break;case"hcLight":b=r.ColorThemeKind.HighContrastLight;break;default:b=r.ColorThemeKind.Dark}this.a=new r.$hP(b),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Erc=R,e.$Erc=R=Je([Ve(0,h.$oQ)],R)}),define(ke[76],Ie([1,0,20,4,3,8,5,11,92,6,29,19,9]),function($e,e,r,h,A,R,T,O,b,c,I,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qGb=e.$pGb=e.TunnelDtoConverter=void 0,R=We(R),u=We(u);class C extends b.$Qw{}var w;(function(m){function $(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?b.TunnelPrivacyId.Public:b.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=$;function f(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==b.TunnelPrivacyId.ConstantPrivate&&i.privacy!==b.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=f})(w||(e.TunnelDtoConverter=w={})),e.$pGb=(0,T.$Gi)("IExtHostTunnelService");let a=class extends A.$Vc{constructor($,f,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$me,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=$.getProxy(c.$ON.MainThreadTunnelService)}async openTunnel($,f){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${$.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const i=await this.a.$openTunnel(f,$.displayName);if(i){const s=new C(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider($,f){$.portRange===void 0&&$.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:$,provider:f}),this.a.$registerPortsAttributesProvider($,i),new u.$QN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes($,f,i,s,t){const o=[];for(const d of $){const l=this.r.get(d);if(!l)return[];o.push(...await Promise.all(f.map(async g=>{let E;try{E=await l.provider.providePortAttributes({port:g,pid:i,commandLine:s},t)}catch{E=await l.provider.providePortAttributes(g,i,s,t)}return{providedAttributes:E,port:g}})))}const n=o.filter(d=>!!d.providedAttributes);return n.length>0?n.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder($){}registerTunnelProvider($,f){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,t)=>await $.provideTunnel(s,t,r.CancellationToken.None)??void 0;const i=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,privacyOptions:f.tunnelFeatures?.privacyOptions,protocol:f.tunnelFeatures.protocol===void 0?!0:f.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,A.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory($,f){if($){$.candidatePortSource!==void 0&&this.a.$setCandidatePortSource($.candidatePortSource),$.showCandidatePort&&(this.f=$.showCandidatePort,this.a.$setCandidateFilter());const i=$.tunnelFactory??(f?this.w(f):void 0);if(i){this.b=i;let s=$.tunnelFeatures?.privacyOptions??[];$.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:R.localize(2699,null),themeIcon:"lock"},{id:"public",label:R.localize(2700,null),themeIcon:"eye"}]);const t=$.tunnelFeatures?{elevation:!!$.tunnelFeatures?.elevation,public:!!$.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,A.$Tc)(()=>{this.b=void 0})}w($){}async $closeTunnel($,f){if(this.g.has($.host)){const i=this.g.get($.host);i.has($.port)&&(f&&i.get($.port).disposeListener.dispose(),await i.get($.port).tunnel.dispose(),i.delete($.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort($,f){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b($,f);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has($.remoteAddress.host)||this.g.set($.remoteAddress.host,new Map);const t=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get($.remoteAddress.host).set($.remoteAddress.port,{tunnel:s,disposeListener:t}),w.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter($){const f=await Promise.all($.map(s=>this.f(s.host,s.port,s.detail??""))),i=$.filter((s,t)=>f[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${$.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.$qGb=a,e.$qGb=a=Je([Ve(0,y.$oQ),Ve(1,I.$EQ),Ve(2,O.$bk)],a)}),define(ke[15],Ie([1,0,18,21,190,79,85,28,178,44,103,24,183,22,51,17,2,113,30,110,87,58,146,89,156,153,154,271,119,126,73,74,268,9]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n,d,l,g,E,S,D,k,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$lQ=_,e.$mQ=ne,e.$nQ=ye,T=We(T),f=We(f),i=We(i),s=We(s),E=We(E),D=We(D),v=We(v);var F;(function(Oe){function Me(ie){const{selectionStartLineNumber:Ae,selectionStartColumn:Ge,positionLineNumber:_e,positionColumn:Xe}=ie,ft=new v.$RN(Ae-1,Ge-1),Rt=new v.$RN(_e-1,Xe-1);return new v.$TN(ft,Rt)}Oe.to=Me;function Se(ie){const{anchor:Ae,active:Ge}=ie;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Ge.line+1,positionColumn:Ge.character+1}}Oe.from=Se})(F||(e.Selection=F={}));var N;(function(Oe){function Me(ie){if(!ie)return;const{start:Ae,end:Ge}=ie;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Ge.line+1,endColumn:Ge.character+1}}Oe.from=Me;function Se(ie){if(!ie)return;const{startLineNumber:Ae,startColumn:Ge,endLineNumber:_e,endColumn:Xe}=ie;return new v.$SN(Ae-1,Ge-1,_e-1,Xe-1)}Oe.to=Se})(N||(e.Range=N={}));var L;(function(Oe){function Me(ie){return{uri:ie.uri,range:N.from(ie.range)}}Oe.from=Me;function Se(ie){return new v.$5N(m.URI.revive(ie.uri),N.to(ie.range))}Oe.to=Se})(L||(e.Location=L={}));var M;(function(Oe){function Me(Se){switch(Se){case i.StandardTokenType.Comment:return v.StandardTokenType.Comment;case i.StandardTokenType.Other:return v.StandardTokenType.Other;case i.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case i.StandardTokenType.String:return v.StandardTokenType.String}}Oe.to=Me})(M||(e.TokenType=M={}));var z;(function(Oe){function Me(ie){return new v.$RN(ie.lineNumber-1,ie.column-1)}Oe.to=Me;function Se(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Oe.from=Se})(z||(e.Position=z={}));var j;(function(Oe){function Me(Ae,Ge,_e){return(0,r.$Hb)((0,r.$2b)(Ae).map(Xe=>Se(Xe,Ge,_e)))}Oe.from=Me;function Se(Ae,Ge,_e){if(typeof Ae=="string")return{$serialized:!0,language:Ae,isBuiltin:_e?.isBuiltin};if(Ae)return{$serialized:!0,language:Ae.language,scheme:ie(Ae.scheme,Ge),pattern:tt.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType,isBuiltin:_e?.isBuiltin}}function ie(Ae,Ge){return Ge&&typeof Ae=="string"?Ge.transformOutgoingScheme(Ae):Ae}})(j||(e.DocumentSelector=j={}));var q;(function(Oe){function Me(ie){switch(ie){case v.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}Oe.from=Me;function Se(ie){switch(ie){case o.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Oe.to=Se})(q||(e.DiagnosticTag=q={}));var B;(function(Oe){function Me(ie){let Ae;return ie.code&&((0,a.$fg)(ie.code)||(0,a.$jg)(ie.code)?Ae=String(ie.code):Ae={value:String(ie.code.value),target:ie.code.target}),{...N.from(ie.range),message:ie.message,source:ie.source,code:Ae,severity:H.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(ee.from),tags:Array.isArray(ie.tags)?(0,r.$Hb)(ie.tags.map(q.from)):void 0}}Oe.from=Me;function Se(ie){const Ae=new v.$7N(N.to(ie),ie.message,H.to(ie.severity));return Ae.source=ie.source,Ae.code=(0,a.$fg)(ie.code)?ie.code:ie.code?.value,Ae.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(ee.to),Ae.tags=ie.tags&&(0,r.$Hb)(ie.tags.map(q.to)),Ae}Oe.to=Se})(B||(e.Diagnostic=B={}));var ee;(function(Oe){function Me(ie){return{...N.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Oe.from=Me;function Se(ie){return new v.$6N(new v.$5N(ie.resource,N.to(ie)),ie.message)}Oe.to=Se})(ee||(e.DiagnosticRelatedInformation=ee={}));var H;(function(Oe){function Me(ie){switch(ie){case v.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Oe.from=Me;function Se(ie){switch(ie){case o.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Oe.to=Se})(H||(e.DiagnosticSeverity=H={}));var W;(function(Oe){function Me(ie){return typeof ie=="number"&&ie>=v.ViewColumn.One?ie-1:ie===v.ViewColumn.Beside?p.$BE:p.$AE}Oe.from=Me;function Se(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=Se})(W||(e.ViewColumn=W={}));function X(Oe){return typeof Oe.range<"u"}function _(Oe){return Oe.length===0?!0:!!X(Oe[0])}var ce;(function(Oe){function Me(Xe){return Xe.map(Oe.from)}Oe.fromMany=Me;function Se(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function ie(Xe){let ft;if(Se(Xe)){const{language:Bt,value:_t}=Xe;ft={value:"```"+Bt+`
`+_t+"\n```\n"}}else v.$iO.isMarkdownString(Xe)?ft={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?ft={value:Xe}:ft={value:""};const Rt=Object.create(null);ft.uris=Rt;const Zt=Bt=>{try{let _t=m.URI.parse(Bt,!0);_t=_t.with({query:Ae(_t.query,Rt)}),Rt[Bt]=_t}catch{}return""},si=new b.marked.Renderer;return si.link=Zt,si.image=Bt=>typeof Bt=="string"?Zt(T.$al(Bt).href):"",(0,b.marked)(ft.value,{renderer:si}),ft}Oe.from=ie;function Ae(Xe,ft){if(!Xe)return Xe;let Rt;try{Rt=(0,c.$ci)(Xe)}catch{}if(!Rt)return Xe;let Zt=!1;return Rt=(0,y.$ho)(Rt,si=>{if(m.URI.isUri(si)){const Bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[Bt]=si,Zt=!0,Bt}else return}),Zt?JSON.stringify(Rt):Xe}function Ge(Xe){const ft=new v.$iO(Xe.value,Xe.supportThemeIcons);return ft.isTrusted=Xe.isTrusted,ft.supportHtml=Xe.supportHtml,ft.baseUri=Xe.baseUri?m.URI.from(Xe.baseUri):void 0,ft}Oe.to=Ge;function _e(Xe){if(Xe)return typeof Xe=="string"?Xe:Oe.from(Xe)}Oe.fromStrict=_e})(ce||(e.MarkdownString=ce={}));function ne(Oe){return _(Oe)?Oe.map(Me=>({range:N.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?ce.fromMany(Me.hoverMessage):Me.hoverMessage?ce.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Oe.map(Me=>({range:N.from(Me)}))}function ye(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?m.URI.file(Oe):Oe}var ge;(function(Oe){function Me(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?ye(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Oe.from=Me})(ge||(e.ThemableDecorationAttachmentRenderOptions=ge={}));var Y;(function(Oe){function Me(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?ye(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?ge.from(Se.before):void 0,after:Se.after?ge.from(Se.after):void 0}}Oe.from=Me})(Y||(e.ThemableDecorationRenderOptions=Y={}));var U;(function(Oe){function Me(Se){if(typeof Se>"u")return Se;switch(Se){case v.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Oe.from=Me})(U||(e.DecorationRangeBehavior=U={}));var oe;(function(Oe){function Me(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?U.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?Y.from(Se.light):void 0,dark:Se.dark?Y.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?ye(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?ge.from(Se.before):void 0,after:Se.after?ge.from(Se.after):void 0}}Oe.from=Me})(oe||(e.DecorationRenderOptions=oe={}));var ve;(function(Oe){function Me(ie){return{text:ie.newText,eol:ie.newEol&&je.from(ie.newEol),range:N.from(ie.range)}}Oe.from=Me;function Se(ie){const Ae=new v.$ZN(N.to(ie.range),ie.text);return Ae.newEol=typeof ie.eol>"u"?void 0:je.to(ie.eol),Ae}Oe.to=Se})(ve||(e.TextEdit=ve={}));var te;(function(Oe){function Me(ie,Ae){const Ge={edits:[]};if(ie instanceof v.$3N){const _e=new O.$Cc;for(const Xe of ie._allEntries())Xe._type===v.FileEditType.File&&m.URI.isUri(Xe.to)&&Xe.from===void 0&&_e.add(Xe.to);for(const Xe of ie._allEntries())if(Xe._type===v.FileEditType.File){let ft;Xe.options?.contents&&(ArrayBuffer.isView(Xe.options.contents)?ft={type:"base64",value:(0,h.$9e)(h.$Oe.wrap(Xe.options.contents))}:ft={type:"dataTransferItem",id:Xe.options.contents._itemId}),Ge.edits.push({oldResource:Xe.from,newResource:Xe.to,options:{...Xe.options,contents:ft},metadata:Xe.metadata})}else Xe._type===v.FileEditType.Text?Ge.edits.push({resource:Xe.uri,textEdit:ve.from(Xe.edit),versionId:_e.has(Xe.uri)?void 0:Ae?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===v.FileEditType.Snippet?Ge.edits.push({resource:Xe.uri,textEdit:{range:N.from(Xe.range),text:Xe.edit.value,insertAsSnippet:!0},versionId:_e.has(Xe.uri)?void 0:Ae?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===v.FileEditType.Cell?Ge.edits.push({metadata:Xe.metadata,resource:Xe.uri,cellEdit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Xe.uri)}):Xe._type===v.FileEditType.CellReplace&&Ge.edits.push({metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Xe.uri),cellEdit:{editType:D.CellEditType.Replace,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Ot.from)}})}return Ge}Oe.from=Me;function Se(ie){const Ae=new v.$3N,Ge=new O.$Bc;for(const _e of ie.edits)if(_e.textEdit){const Xe=_e,ft=m.URI.revive(Xe.resource),Rt=N.to(Xe.textEdit.range),Zt=Xe.textEdit.text,si=Xe.textEdit.insertAsSnippet;let Bt;si?Bt=v.$2N.replace(Rt,new v.$4N(Zt)):Bt=v.$ZN.replace(Rt,Zt);const _t=Ge.get(ft);_t?_t.push(Bt):Ge.set(ft,[Bt])}else Ae.renameFile(m.URI.revive(_e.oldResource),m.URI.revive(_e.newResource),_e.options);for(const[_e,Xe]of Ge)Ae.set(_e,Xe);return Ae}Oe.to=Se})(te||(e.WorkspaceEdit=te={}));var ae;(function(Oe){const Me=Object.create(null);Me[v.SymbolKind.File]=s.SymbolKind.File,Me[v.SymbolKind.Module]=s.SymbolKind.Module,Me[v.SymbolKind.Namespace]=s.SymbolKind.Namespace,Me[v.SymbolKind.Package]=s.SymbolKind.Package,Me[v.SymbolKind.Class]=s.SymbolKind.Class,Me[v.SymbolKind.Method]=s.SymbolKind.Method,Me[v.SymbolKind.Property]=s.SymbolKind.Property,Me[v.SymbolKind.Field]=s.SymbolKind.Field,Me[v.SymbolKind.Constructor]=s.SymbolKind.Constructor,Me[v.SymbolKind.Enum]=s.SymbolKind.Enum,Me[v.SymbolKind.Interface]=s.SymbolKind.Interface,Me[v.SymbolKind.Function]=s.SymbolKind.Function,Me[v.SymbolKind.Variable]=s.SymbolKind.Variable,Me[v.SymbolKind.Constant]=s.SymbolKind.Constant,Me[v.SymbolKind.String]=s.SymbolKind.String,Me[v.SymbolKind.Number]=s.SymbolKind.Number,Me[v.SymbolKind.Boolean]=s.SymbolKind.Boolean,Me[v.SymbolKind.Array]=s.SymbolKind.Array,Me[v.SymbolKind.Object]=s.SymbolKind.Object,Me[v.SymbolKind.Key]=s.SymbolKind.Key,Me[v.SymbolKind.Null]=s.SymbolKind.Null,Me[v.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Me[v.SymbolKind.Struct]=s.SymbolKind.Struct,Me[v.SymbolKind.Event]=s.SymbolKind.Event,Me[v.SymbolKind.Operator]=s.SymbolKind.Operator,Me[v.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function Se(Ae){return typeof Me[Ae]=="number"?Me[Ae]:s.SymbolKind.Property}Oe.from=Se;function ie(Ae){for(const Ge in Me)if(Me[Ge]===Ae)return Number(Ge);return v.SymbolKind.Property}Oe.to=ie})(ae||(e.SymbolKind=ae={}));var se;(function(Oe){function Me(ie){switch(ie){case v.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}Oe.from=Me;function Se(ie){switch(ie){case s.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Oe.to=Se})(se||(e.SymbolTag=se={}));var Z;(function(Oe){function Me(ie){return{name:ie.name,kind:ae.from(ie.kind),tags:ie.tags&&ie.tags.map(se.from),containerName:ie.containerName,location:ze.from(ie.location)}}Oe.from=Me;function Se(ie){const Ae=new v.$_N(ie.name,ae.to(ie.kind),ie.containerName,ze.to(ie.location));return Ae.tags=ie.tags&&ie.tags.map(se.to),Ae}Oe.to=Se})(Z||(e.WorkspaceSymbol=Z={}));var re;(function(Oe){function Me(ie){const Ae={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),kind:ae.from(ie.kind),tags:ie.tags?.map(se.from)??[]};return ie.children&&(Ae.children=ie.children.map(Me)),Ae}Oe.from=Me;function Se(ie){const Ae=new v.$aO(ie.name,ie.detail,ae.to(ie.kind),N.to(ie.range),N.to(ie.selectionRange));return(0,r.$Lb)(ie.tags)&&(Ae.tags=ie.tags.map(se.to)),ie.children&&(Ae.children=ie.children.map(Se)),Ae}Oe.to=Se})(re||(e.DocumentSymbol=re={}));var pe;(function(Oe){function Me(ie){const Ae=new v.$eO(ae.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Ae._sessionId=ie._sessionId,Ae._itemId=ie._itemId,Ae}Oe.to=Me;function Se(ie,Ae,Ge){if(Ae=Ae??ie._sessionId,Ge=Ge??ie._itemId,Ae===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ge,name:ie.name,detail:ie.detail,kind:ae.from(ie.kind),uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(se.from)}}Oe.from=Se})(pe||(e.CallHierarchyItem=pe={}));var we;(function(Oe){function Me(Se){return new v.$fO(pe.to(Se.from),Se.fromRanges.map(ie=>N.to(ie)))}Oe.to=Me})(we||(e.CallHierarchyIncomingCall=we={}));var Fe;(function(Oe){function Me(Se){return new v.$gO(pe.to(Se.to),Se.fromRanges.map(ie=>N.to(ie)))}Oe.to=Me})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var ze;(function(Oe){function Me(ie){return{range:ie.range&&N.from(ie.range),uri:ie.uri}}Oe.from=Me;function Se(ie){return new v.$5N(m.URI.revive(ie.uri),N.to(ie.range))}Oe.to=Se})(ze||(e.location=ze={}));var Re;(function(Oe){function Me(ie){const Ae=ie,Ge=ie;return{originSelectionRange:Ae.originSelectionRange?N.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Ge.uri,range:N.from(Ae.targetRange?Ae.targetRange:Ge.range),targetSelectionRange:Ae.targetSelectionRange?N.from(Ae.targetSelectionRange):void 0}}Oe.from=Me;function Se(ie){return{targetUri:m.URI.revive(ie.uri),targetRange:N.to(ie.range),targetSelectionRange:ie.targetSelectionRange?N.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?N.to(ie.originSelectionRange):void 0}}Oe.to=Se})(Re||(e.DefinitionLink=Re={}));var De;(function(Oe){function Me(ie){return{range:N.from(ie.range),contents:ce.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Oe.from=Me;function Se(ie){const Ae=ie.contents.map(ce.to),Ge=N.to(ie.range),_e=ie.canIncreaseVerbosity,Xe=ie.canDecreaseVerbosity;return new v.$9N(Ae,Ge,_e,Xe)}Oe.to=Se})(De||(e.Hover=De={}));var Ce;(function(Oe){function Me(ie){return{range:N.from(ie.range),expression:ie.expression}}Oe.from=Me;function Se(ie){return new v.$4O(N.to(ie.range),ie.expression)}Oe.to=Se})(Ce||(e.EvaluatableExpression=Ce={}));var V;(function(Oe){function Me(ie){if(ie instanceof v.$5O)return{type:"text",range:N.from(ie.range),text:ie.text};if(ie instanceof v.$6O)return{type:"variable",range:N.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof v.$7O)return{type:"expression",range:N.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=Me;function Se(ie){switch(ie.type){case"text":return{range:N.to(ie.range),text:ie.text};case"variable":return{range:N.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:N.to(ie.range),expression:ie.expression}}}Oe.to=Se})(V||(e.InlineValue=V={}));var G;(function(Oe){function Me(ie){return{frameId:ie.frameId,stoppedLocation:N.from(ie.stoppedLocation)}}Oe.from=Me;function Se(ie){return new v.$8O(ie.frameId,N.to(ie.stoppedLocation))}Oe.to=Se})(G||(e.InlineValueContext=G={}));var J;(function(Oe){function Me(ie){return{range:N.from(ie.range),kind:ie.kind}}Oe.from=Me;function Se(ie){return new v.$0N(N.to(ie.range),ie.kind)}Oe.to=Se})(J||(e.DocumentHighlight=J={}));var x;(function(Oe){function Me(ie){return{uri:ie.uri,highlights:ie.highlights.map(J.from)}}Oe.from=Me;function Se(ie){return new v.$$N(m.URI.revive(ie.uri),ie.highlights.map(J.to))}Oe.to=Se})(x||(e.MultiDocumentHighlight=x={}));var de;(function(Oe){function Me(Se){switch(Se){case s.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Oe.to=Me})(de||(e.CompletionTriggerKind=de={}));var Ee;(function(Oe){function Me(Se){return{triggerKind:de.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Oe.to=Me})(Ee||(e.CompletionContext=Ee={}));var Le;(function(Oe){function Me(ie){switch(ie){case v.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}Oe.from=Me;function Se(ie){switch(ie){case s.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Oe.to=Se})(Le||(e.CompletionItemTag=Le={}));var He;(function(Oe){const Me=new Map([[v.CompletionItemKind.Method,s.CompletionItemKind.Method],[v.CompletionItemKind.Function,s.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,s.CompletionItemKind.Field],[v.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[v.CompletionItemKind.Class,s.CompletionItemKind.Class],[v.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[v.CompletionItemKind.Module,s.CompletionItemKind.Module],[v.CompletionItemKind.Property,s.CompletionItemKind.Property],[v.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[v.CompletionItemKind.Value,s.CompletionItemKind.Value],[v.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,s.CompletionItemKind.Text],[v.CompletionItemKind.Color,s.CompletionItemKind.Color],[v.CompletionItemKind.File,s.CompletionItemKind.File],[v.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[v.CompletionItemKind.Event,s.CompletionItemKind.Event],[v.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[v.CompletionItemKind.User,s.CompletionItemKind.User]]);function Se(Ge){return Me.get(Ge)??s.CompletionItemKind.Property}Oe.from=Se;const ie=new Map([[s.CompletionItemKind.Method,v.CompletionItemKind.Method],[s.CompletionItemKind.Function,v.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,v.CompletionItemKind.Field],[s.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[s.CompletionItemKind.Class,v.CompletionItemKind.Class],[s.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[s.CompletionItemKind.Module,v.CompletionItemKind.Module],[s.CompletionItemKind.Property,v.CompletionItemKind.Property],[s.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[s.CompletionItemKind.Value,v.CompletionItemKind.Value],[s.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,v.CompletionItemKind.Text],[s.CompletionItemKind.Color,v.CompletionItemKind.Color],[s.CompletionItemKind.File,v.CompletionItemKind.File],[s.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[s.CompletionItemKind.Event,v.CompletionItemKind.Event],[s.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,v.CompletionItemKind.User],[s.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Ae(Ge){return ie.get(Ge)??v.CompletionItemKind.Property}Oe.to=Ae})(He||(e.CompletionItemKind=He={}));var Ke;(function(Oe){function Me(Se,ie){const Ae=new v.$oO(Se.label);return Ae.insertText=Se.insertText,Ae.kind=He.to(Se.kind),Ae.tags=Se.tags?.map(Le.to),Ae.detail=Se.detail,Ae.documentation=T.$7k(Se.documentation)?ce.to(Se.documentation):Se.documentation,Ae.sortText=Se.sortText,Ae.filterText=Se.filterText,Ae.preselect=Se.preselect,Ae.commitCharacters=Se.commitCharacters,f.$Pt.isIRange(Se.range)?Ae.range=N.to(Se.range):typeof Se.range=="object"&&(Ae.range={inserting:N.to(Se.range.insert),replacing:N.to(Se.range.replace)}),Ae.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof Se.insertTextRules<"u"&&Se.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Ae.insertText=new v.$4N(Se.insertText):(Ae.insertText=Se.insertText,Ae.textEdit=Ae.range instanceof v.$SN?new v.$ZN(Ae.range,Ae.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ae.additionalTextEdits=Se.additionalTextEdits.map(Ge=>ve.to(Ge))),Ae.command=ie&&Se.command?ie.fromInternal(Se.command):void 0,Ae}Oe.to=Me})(Ke||(e.CompletionItem=Ke={}));var et;(function(Oe){function Me(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:ce.fromStrict(ie.documentation)}}Oe.from=Me;function Se(ie){return{label:ie.label,documentation:T.$7k(ie.documentation)?ce.to(ie.documentation):ie.documentation}}Oe.to=Se})(et||(e.ParameterInformation=et={}));var nt;(function(Oe){function Me(ie){return{label:ie.label,documentation:ce.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(et.from):[],activeParameter:ie.activeParameter}}Oe.from=Me;function Se(ie){return{label:ie.label,documentation:T.$7k(ie.documentation)?ce.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(et.to):[],activeParameter:ie.activeParameter}}Oe.to=Se})(nt||(e.SignatureInformation=nt={}));var st;(function(Oe){function Me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(nt.from):[]}}Oe.from=Me;function Se(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(nt.to):[]}}Oe.to=Se})(st||(e.SignatureHelp=st={}));var rt;(function(Oe){function Me(Se,ie){const Ae=new v.$nO(z.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(at.to.bind(void 0,Se)),ie.kind&&gt.to(ie.kind));return Ae.textEdits=ie.textEdits&&ie.textEdits.map(ve.to),Ae.tooltip=T.$7k(ie.tooltip)?ce.to(ie.tooltip):ie.tooltip,Ae.paddingLeft=ie.paddingLeft,Ae.paddingRight=ie.paddingRight,Ae}Oe.to=Me})(rt||(e.InlayHint=rt={}));var at;(function(Oe){function Me(Se,ie){const Ae=new v.$mO(ie.label);return Ae.tooltip=T.$7k(ie.tooltip)?ce.to(ie.tooltip):ie.tooltip,s.Command.is(ie.command)&&(Ae.command=Se.fromInternal(ie.command)),ie.location&&(Ae.location=ze.to(ie.location)),Ae}Oe.to=Me})(at||(e.InlayHintLabelPart=at={}));var gt;(function(Oe){function Me(ie){return ie}Oe.from=Me;function Se(ie){return ie}Oe.to=Se})(gt||(e.InlayHintKind=gt={}));var dt;(function(Oe){function Me(ie){return{range:N.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Oe.from=Me;function Se(ie){let Ae;if(ie.url)try{Ae=typeof ie.url=="string"?m.URI.parse(ie.url,!0):m.URI.revive(ie.url)}catch{}const Ge=new v.$tO(N.to(ie.range),Ae);return Ge.tooltip=ie.tooltip,Ge}Oe.to=Se})(dt||(e.DocumentLink=dt={}));var ct;(function(Oe){function Me(ie){const Ae=new v.$wO(ie.label);return ie.textEdit&&(Ae.textEdit=ve.to(ie.textEdit)),ie.additionalTextEdits&&(Ae.additionalTextEdits=ie.additionalTextEdits.map(Ge=>ve.to(Ge))),Ae}Oe.to=Me;function Se(ie){return{label:ie.label,textEdit:ie.textEdit?ve.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Ae=>ve.from(Ae)):void 0}}Oe.from=Se})(ct||(e.ColorPresentation=ct={}));var Pe;(function(Oe){function Me(ie){return new v.$uO(ie[0],ie[1],ie[2],ie[3])}Oe.to=Me;function Se(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Oe.from=Se})(Pe||(e.Color=Pe={}));var Be;(function(Oe){function Me(ie){return{range:N.from(ie.range)}}Oe.from=Me;function Se(ie){return new v.$dO(N.to(ie.range))}Oe.to=Se})(Be||(e.SelectionRange=Be={}));var Qe;(function(Oe){function Me(Se){switch(Se){case l.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Oe.to=Me})(Qe||(e.TextDocumentSaveReason=Qe={}));var Ne;(function(Oe){function Me(ie){switch(ie){case v.TextEditorLineNumbersStyle.Off:return $.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return $.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return $.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return $.RenderLineNumbersType.On}}Oe.from=Me;function Se(ie){switch(ie){case $.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case $.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case $.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case $.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Oe.to=Se})(Ne||(e.TextEditorLineNumbersStyle=Ne={}));var je;(function(Oe){function Me(ie){if(ie===v.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===v.EndOfLine.LF)return t.EndOfLineSequence.LF}Oe.from=Me;function Se(ie){if(ie===t.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return v.EndOfLine.LF}Oe.to=Se})(je||(e.EndOfLine=je={}));var ue;(function(Oe){function Me(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case v.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case v.ProgressLocation.Window:return n.ProgressLocation.Window;case v.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Oe.from=Me})(ue||(e.ProgressLocation=ue={}));var he;(function(Oe){function Me(ie){const Ae={start:ie.start+1,end:ie.end+1};return ie.kind&&(Ae.kind=le.from(ie.kind)),Ae}Oe.from=Me;function Se(ie){const Ae={start:ie.start-1,end:ie.end-1};return ie.kind&&(Ae.kind=le.to(ie.kind)),Ae}Oe.to=Se})(he||(e.FoldingRange=he={}));var le;(function(Oe){function Me(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return s.$Qu.Comment;case v.FoldingRangeKind.Imports:return s.$Qu.Imports;case v.FoldingRangeKind.Region:return s.$Qu.Region}}Oe.from=Me;function Se(ie){if(ie)switch(ie.value){case s.$Qu.Comment.value:return v.FoldingRangeKind.Comment;case s.$Qu.Imports.value:return v.FoldingRangeKind.Imports;case s.$Qu.Region.value:return v.FoldingRangeKind.Region}}Oe.to=Se})(le||(e.FoldingRangeKind=le={}));var Ze;(function(Oe){function Me(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?N.from(Se.selection):void 0,override:typeof Se.override=="boolean"?l.$7F.id:void 0}}Oe.from=Me})(Ze||(e.TextEditorOpenOptions=Ze={}));var tt;(function(Oe){function Me(Ge){return Ge instanceof v.$RO?Ge.toJSON():typeof Ge=="string"?Ge:Se(Ge)||ie(Ge)?new v.$RO(Ge.baseUri??Ge.base,Ge.pattern).toJSON():Ge}Oe.from=Me;function Se(Ge){const _e=Ge;return _e?m.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ie(Ge){const _e=Ge;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ae(Ge){return typeof Ge=="string"?Ge:new v.$RO(m.URI.revive(Ge.baseUri),Ge.pattern)}Oe.to=Ae})(tt||(e.GlobPattern=tt={}));var ut;(function(Oe){function Me(Se){if(Se){if(Array.isArray(Se))return Se.map(Me);if(typeof Se=="string")return Se;{const ie=Se;return{language:ie.language,scheme:ie.scheme,pattern:tt.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Oe.from=Me})(ut||(e.LanguageSelector=ut={}));var mt;(function(Oe){function Me(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Ae=>Array.isArray(Ae)&&Ae.every(Ge=>Ge&&typeof Ge=="object"&&"uri"in Ge&&m.URI.isUri(Ge.uri)&&"version"in Ge&&typeof Ge.version=="number"&&"ranges"in Ge&&Array.isArray(Ge.ranges)&&Ge.ranges.every(_e=>_e instanceof v.$SN)))}Oe.is=Me;function Se(ie){return{documents:ie.documents.map(Ae=>Ae.map(Ge=>({uri:m.URI.from(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>N.from(_e))})))}}Oe.from=Se})(mt||(e.MappedEditsContext=mt={}));var Dt;(function(Oe){function Me(ie){return{start:ie.start,end:ie.end}}Oe.from=Me;function Se(ie){return new v.$iP(ie.start,ie.end)}Oe.to=Se})(Dt||(e.NotebookRange=Dt={}));var Mt;(function(Oe){function Me(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Oe.to=Me;function Se(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Oe.from=Se})(Mt||(e.NotebookCellExecutionSummary=Mt={}));var Ht;(function(Oe){function Me(Se){if(Se===D.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(Se===D.NotebookCellExecutionState.Pending)return;if(Se===D.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Oe.to=Me})(Ht||(e.NotebookCellExecutionState=Ht={}));var ei;(function(Oe){function Me(ie){switch(ie){case v.NotebookCellKind.Markup:return D.CellKind.Markup;case v.NotebookCellKind.Code:default:return D.CellKind.Code}}Oe.from=Me;function Se(ie){switch(ie){case D.CellKind.Markup:return v.NotebookCellKind.Markup;case D.CellKind.Code:default:return v.NotebookCellKind.Code}}Oe.to=Se})(ei||(e.NotebookCellKind=ei={}));var oi;(function(Oe){function Me(ie){const Ae={metadata:ie.metadata??Object.create(null),cells:[]};for(const Ge of ie.cells)v.$jP.validate(Ge),Ae.cells.push(Ot.from(Ge));return Ae}Oe.from=Me;function Se(ie){const Ae=new v.$kP(ie.cells.map(Ot.to));return(0,a.$sg)(ie.metadata)||(Ae.metadata=ie.metadata),Ae}Oe.to=Se})(oi||(e.NotebookData=oi={}));var Ot;(function(Oe){function Me(ie){return{cellKind:ei.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Mt.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Ct.from):[]}}Oe.from=Me;function Se(ie){return new v.$jP(ei.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Ct.to):void 0,ie.metadata,ie.internalMetadata?Mt.to(ie.internalMetadata):void 0)}Oe.to=Se})(Ot||(e.NotebookCellData=Ot={}));var it;(function(Oe){function Me(ie){return{mime:ie.mime,valueBytes:h.$Oe.wrap(ie.data)}}Oe.from=Me;function Se(ie){return new v.$lP(ie.valueBytes.buffer,ie.mime)}Oe.to=Se})(it||(e.NotebookCellOutputItem=it={}));var Ct;(function(Oe){function Me(ie){return{outputId:ie.id,items:ie.items.map(it.from),metadata:ie.metadata}}Oe.from=Me;function Se(ie){const Ae=ie.items.map(it.to);return new v.$mP(Ae,ie.outputId,ie.metadata)}Oe.to=Se})(Ct||(e.NotebookCellOutput=Ct={}));var hi;(function(Oe){function Me(Ae){return ie(Ae)?{include:tt.from(Ae.include)??void 0,exclude:tt.from(Ae.exclude)??void 0}:tt.from(Ae)??void 0}Oe.from=Me;function Se(Ae){return ie(Ae)?{include:tt.to(Ae.include),exclude:tt.to(Ae.exclude)}:tt.to(Ae)}Oe.to=Se;function ie(Ae){const Ge=Ae;return Ge?!(0,a.$og)(Ge.include)&&!(0,a.$og)(Ge.exclude):!1}})(hi||(e.NotebookExclusiveDocumentPattern=hi={}));var bt;(function(Oe){function Me(Se,ie,Ae){const Ge=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===v.NotebookCellStatusBarAlignment.Left?D.CellStatusbarAlignment.Left:D.CellStatusbarAlignment.Right,command:ie.toInternal(Ge,Ae),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Oe.from=Me})(bt||(e.NotebookStatusBarItem=bt={}));var St;(function(Oe){function Me(Se,ie,Ae){const Ge=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ie.toInternal(Ge,Ae),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Oe.from=Me})(St||(e.NotebookKernelSourceAction=St={}));var ti;(function(Oe){function Me(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Oe.from=Me})(ti||(e.NotebookDocumentContentOptions=ti={}));var ii;(function(Oe){function Me(ie){return{uri:ie.uri,provides:ie.provides}}Oe.from=Me;function Se(ie){return new v.$oP(m.URI.revive(ie.uri),ie.provides)}Oe.to=Se})(ii||(e.NotebookRendererScript=ii={}));var qt;(function(Oe){function Me(ie){return{message:ce.fromStrict(ie.message)||"",type:P.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:N.from(ie.location.range),uri:ie.location.uri},stackTrace:ie.stackTrace?.map(Ae=>({label:Ae.label,position:Ae.position&&z.from(Ae.position),uri:Ae.uri&&m.URI.revive(Ae.uri).toJSON()}))}}Oe.from=Me;function Se(ie){const Ae=new v.$uP(typeof ie.message=="string"?ie.message:ce.to(ie.message));return Ae.actualOutput=ie.actual,Ae.expectedOutput=ie.expected,Ae.contextValue=ie.contextValue,Ae.location=ie.location?ze.to(ie.location):void 0,Ae}Oe.to=Se})(qt||(e.TestMessage=qt={}));var pt;(function(Oe){Oe.namespace=P.$dJ,Oe.denamespace=P.$eJ})(pt||(e.TestTag=pt={}));var zt;(function(Oe){function Me(ie){const Ae=(0,d.$kQ)(ie).controllerId;return{extId:k.$$I.fromExtHostTestItem(ie,Ae).toString(),label:ie.label,uri:m.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Ge=>pt.namespace(Ae,Ge.id)),range:f.$Pt.lift(N.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&ce.fromStrict(ie.error)||null}}Oe.from=Me;function Se(ie){return{parent:void 0,error:void 0,id:k.$$I.fromString(ie.extId).localId,label:ie.label,uri:m.URI.revive(ie.uri),tags:(ie.tags||[]).map(Ae=>{const{tagId:Ge}=pt.denamespace(Ae);return new v.$vP(Ge)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Oe.toPlain=Se})(zt||(e.TestItem=zt={})),function(Oe){function Me(ie){return{id:ie.id}}Oe.from=Me;function Se(ie){return new v.$vP(ie.id)}Oe.to=Se}(pt||(e.TestTag=pt={}));var ni;(function(Oe){const Me=(ie,Ae)=>{const Ge=ie.value;if(!Ge)return;const _e={...zt.toPlain(Ge.item),parent:Ae,taskStates:Ge.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(ft=>ft.type===P.TestMessageType.Error).map(qt.to)})),children:[]};if(ie.children)for(const Xe of ie.children.values()){const ft=Me(Xe,_e);ft&&_e.children.push(ft)}return _e};function Se(ie){const Ae=new u.$0I;for(const Xe of ie.items)Ae.insert(k.$$I.fromString(Xe.item.extId).path,Xe);const Ge=[Ae.nodes],_e=[];for(;Ge.length;)for(const Xe of Ge.pop())Xe.value?_e.push(Xe):Xe.children&&Ge.push(Xe.children.values());return{completedAt:ie.completedAt,results:_e.map(Xe=>Me(Xe)).filter(a.$ng)}}Oe.to=Se})(ni||(e.TestResults=ni={}));var ai;(function(Oe){function Me(Ge){return{covered:Ge.covered,total:Ge.total}}function Se(Ge){return"line"in Ge?z.from(Ge):N.from(Ge)}function ie(Ge){if(typeof Ge.executed=="number"&&Ge.executed<0)throw new Error(`Invalid coverage count ${Ge.executed}`);return"branches"in Ge?{count:Ge.executed,location:Se(Ge.location),type:P.DetailType.Statement,branches:Ge.branches.length?Ge.branches.map(_e=>({count:_e.executed,location:_e.location&&Se(_e.location),label:_e.label})):void 0}:{type:P.DetailType.Declaration,name:Ge.name,count:Ge.executed,location:Se(Ge.location)}}Oe.fromDetails=ie;function Ae(Ge,_e,Xe){return v.$yP(Xe.statementCoverage),v.$yP(Xe.branchCoverage),v.$yP(Xe.declarationCoverage),{id:_e,uri:Xe.uri,statement:Me(Xe.statementCoverage),branch:Xe.branchCoverage&&Me(Xe.branchCoverage),declaration:Xe.declarationCoverage&&Me(Xe.declarationCoverage),testIds:Xe instanceof v.$zP&&Xe.fromTests.length?Xe.fromTests.map(ft=>k.$$I.fromExtHostTestItem(ft,Ge).toString()):void 0}}Oe.fromFile=Ae})(ai||(e.TestCoverage=ai={}));var xe;(function(Oe){function Me(Se){switch(Se){case s.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Oe.to=Me})(xe||(e.CodeActionTriggerKind=xe={}));var ci;(function(Oe){function Me(ie){const Ae=new v.$DP(ae.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Ae._sessionId=ie._sessionId,Ae._itemId=ie._itemId,Ae}Oe.to=Me;function Se(ie,Ae,Ge){if(Ae=Ae??ie._sessionId,Ge=Ge??ie._itemId,Ae===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ge,kind:ae.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(se.from)}}Oe.from=Se})(ci||(e.TypeHierarchyItem=ci={}));var di;(function(Oe){function Me(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Oe.from=Me})(di||(e.ViewBadge=di={}));var fi;(function(Oe){function Me(Ge,_e,Xe){const ft=_e.fileData;return ft?new v.$JO(new v.$KO(ft.name,m.URI.revive(ft.uri),ft.id,(0,R.$db)(()=>Xe(ft.id)))):Ge===I.$_s.uriList&&_e.uriListData?new v.$IO(Ae(_e.uriListData)):new v.$IO(_e.asString)}Oe.to=Me;async function Se(Ge,_e){const Xe=await _e.asString();if(Ge===I.$_s.uriList)return{asString:Xe,fileData:void 0,uriListData:ie(Xe)};const ft=_e.asFile();return{asString:Xe,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Oe.from=Se;function ie(Ge){return A.$uu.split(Ge).map(_e=>{if(_e.startsWith("#"))return _e;try{return m.URI.parse(_e)}catch{}return _e})}function Ae(Ge){return A.$uu.create(Ge.map(_e=>typeof _e=="string"?_e:m.URI.revive(_e)))}})(fi||(e.DataTransferItem=fi={}));var vt;(function(Oe){function Me(ie,Ae){const Ge=ie.items.map(([_e,Xe])=>[_e,fi.to(_e,Xe,Ae)]);return new v.$LO(Ge)}Oe.toDataTransfer=Me;async function Se(ie){const Ae={items:[]},Ge=[];for(const[_e,Xe]of ie)Ge.push((async()=>{Ae.items.push([_e,await fi.from(_e,Xe)])})());return await Promise.all(Ge),Ae}Oe.from=Se})(vt||(e.DataTransfer=vt={}));var jt;(function(Oe){function Me(ie,Ae){return{kind:"reply",agentId:ie.participant??Ae?.agentId??"",subCommand:ie.command??Ae?.command,message:ie.prompt,title:ie.label}}Oe.from=Me;function Se(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Oe.to=Se})(jt||(e.ChatFollowup=jt={}));var Nt;(function(Oe){function Me(ie){switch(ie){case E.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Oe.to=Me;function Se(ie){switch(ie){case v.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}Oe.from=Se})(Nt||(e.LanguageModelChatMessageRole=Nt={}));var Gt;(function(Oe){function Me(ie){let Ae="",Ge;ie.content.type==="text"?Ae=ie.content.value:Ge=new v.$8P(ie.content.name,ie.content.value,ie.content.isError);const _e=Nt.to(ie.role),Xe=new v.$9P(_e,Ae,ie.name);return Ge!==void 0&&(Xe.content2=Ge),Xe}Oe.to=Me;function Se(ie){const Ae=Nt.from(ie.role),Ge=ie.name;let _e;return ie.content2 instanceof v.$8P?_e={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:_e={type:"text",value:ie.content},{role:Ae,name:Ge,content:_e}}Oe.from=Se})(Gt||(e.LanguageModelChatMessage=Gt={}));var ri;(function(Oe){function Me(ie){return{kind:"markdownContent",content:ce.from(ie.value)}}Oe.from=Me;function Se(ie){return new v.$QP(ce.to(ie.content))}Oe.to=Se})(ri||(e.ChatResponseMarkdownPart=ri={}));var Xt;(function(Oe){function Me(ie){return{kind:"markdownVuln",content:ce.from(ie.value),vulnerabilities:ie.vulnerabilities}}Oe.from=Me;function Se(ie){return new v.$RP(ce.to(ie.content),ie.vulnerabilities)}Oe.to=Se})(Xt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Xt={}));var li;(function(Oe){function Me(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Oe.from=Me;function Se(ie){return new v.$SP(ie.agentId,ie.command)}Oe.to=Se})(li||(e.ChatResponseDetectedParticipantPart=li={}));var Wt;(function(Oe){function Me(Se){return{kind:"confirmation",title:Se.title,message:Se.message,data:Se.data,buttons:Se.buttons}}Oe.from=Me})(Wt||(e.ChatResponseConfirmationPart=Wt={}));var Kt;(function(Oe){function Me(ie){const{value:Ae,baseUri:Ge}=ie;function _e(Xe,ft){return Xe.map(Rt=>{const Zt=m.URI.joinPath(ft,Rt.name);return{label:Rt.name,uri:Zt,children:Rt.children&&_e(Rt.children,Zt)}})}return{kind:"treeData",treeData:{label:(0,C.$eh)(Ge),uri:Ge,children:_e(Ae,Ge)}}}Oe.from=Me;function Se(ie){const Ae=(0,c.$di)(ie.treeData);function Ge(ft){return ft.map(Rt=>({name:Rt.label,children:Rt.children&&Ge(Rt.children)}))}const _e=Ae.uri,Xe=Ae.children?Ge(Ae.children):[];return new v.$UP(Xe,_e)}Oe.to=Se})(Kt||(e.ChatResponseFilesPart=Kt={}));var Jt;(function(Oe){function Me(ie){const Ae=Ge=>m.URI.isUri(Ge);return{kind:"inlineReference",name:ie.title,inlineReference:Ae(ie.value)?ie.value:L.from(ie.value)}}Oe.from=Me;function Se(ie){const Ae=(0,c.$di)(ie);return new v.$VP(m.URI.isUri(Ae.inlineReference)?Ae.inlineReference:L.to(Ae.inlineReference),ie.name)}Oe.to=Se})(Jt||(e.ChatResponseAnchorPart=Jt={}));var Ft;(function(Oe){function Me(ie){return{kind:"progressMessage",content:ce.from(ie.value)}}Oe.from=Me;function Se(ie){return new v.$WP(ie.content.value)}Oe.to=Se})(Ft||(e.ChatResponseProgressPart=Ft={}));var wt;(function(Oe){function Me(ie){return{kind:"warning",content:ce.from(ie.value)}}Oe.from=Me;function Se(ie){return new v.$YP(ie.content.value)}Oe.to=Se})(wt||(e.ChatResponseWarningPart=wt={}));var It;(function(Oe){function Me(Se){return{kind:"progressTask",content:ce.from(Se.value)}}Oe.from=Me})(It||(e.ChatTask=It={}));var Qt;(function(Oe){function Me(Se){return{kind:"progressTaskResult",content:typeof Se=="string"?ce.from(Se):void 0}}Oe.from=Me})(Qt||(e.ChatTaskResult=Qt={}));var Pt;(function(Oe){function Me(ie,Ae,Ge){return{kind:"command",command:Ae.toInternal(ie.value,Ge)??{command:ie.value.command,title:ie.value.title}}}Oe.from=Me;function Se(ie,Ae){return new v.$ZP(Ae.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Oe.to=Se})(Pt||(e.ChatResponseCommandButtonPart=Pt={}));var mi;(function(Oe){function Me(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Ae=>ve.from(Ae))}}Oe.from=Me;function Se(ie){return new v.$3P(m.URI.revive(ie.uri),ie.edits.map(Ae=>ve.to(Ae)))}Oe.to=Se})(mi||(e.ChatResponseTextEditPart=mi={}));var xt;(function(Oe){function Me(ie){const Ae=w.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:m.URI.isUri(ie.iconPath)?{light:m.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&m.URI.isUri(ie.iconPath.light)&&m.URI.isUri(ie.iconPath.dark)?{light:m.URI.revive(ie.iconPath.light),dark:m.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:m.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:L.from(ie.value.value)},iconPath:Ae,options:ie.options}:{kind:"reference",reference:m.URI.isUri(ie.value)?ie.value:L.from(ie.value),iconPath:Ae,options:ie.options}}Oe.from=Me;function Se(ie){const Ae=(0,c.$di)(ie),Ge=_e=>m.URI.isUri(_e)?_e:L.to(_e);return new v.$1P("variableName"in Ae.reference?{variableName:Ae.reference.variableName,value:Ae.reference.value&&Ge(Ae.reference.value)}:Ge(Ae.reference))}Oe.to=Se})(xt||(e.ChatResponseReferencePart=xt={}));var ki;(function(Oe){function Me(Se){return{kind:"codeCitation",value:Se.value,license:Se.license,snippet:Se.snippet}}Oe.from=Me})(ki||(e.ChatResponseCodeCitationPart=ki={}));var bi;(function(Oe){function Me(Ae,Ge,_e){return Ae instanceof v.$QP?ri.from(Ae):Ae instanceof v.$VP?Jt.from(Ae):Ae instanceof v.$1P?xt.from(Ae):Ae instanceof v.$WP?Ft.from(Ae):Ae instanceof v.$UP?Kt.from(Ae):Ae instanceof v.$ZP?Pt.from(Ae,Ge,_e):Ae instanceof v.$3P?mi.from(Ae):Ae instanceof v.$RP?Xt.from(Ae):Ae instanceof v.$SP?li.from(Ae):Ae instanceof v.$YP?wt.from(Ae):Ae instanceof v.$TP?Wt.from(Ae):Ae instanceof v.$2P?ki.from(Ae):{kind:"markdownContent",content:ce.from("")}}Oe.from=Me;function Se(Ae,Ge){switch(Ae.kind){case"reference":return xt.to(Ae);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Ae,Ge)}}Oe.to=Se;function ie(Ae,Ge){switch(Ae.kind){case"markdownContent":return ri.to(Ae);case"inlineReference":return Jt.to(Ae);case"progressMessage":return;case"treeData":return Kt.to(Ae);case"command":return Pt.to(Ae,Ge)}}Oe.toContent=ie})(bi||(e.ChatResponsePart=bi={}));var Ri;(function(Oe){function Me(Se,ie){const Ae=Se.variables.variables.filter(_e=>_e.isTool).map(_e=>_e.id),Ge=Se.variables.variables.filter(_e=>!_e.isTool);return{prompt:Se.message,command:Se.command,attempt:Se.attempt??0,enableCommandDetection:Se.enableCommandDetection??!0,references:Ge.map(Li.to),location:Tt.to(Se.location),acceptedConfirmationData:Se.acceptedConfirmationData,rejectedConfirmationData:Se.rejectedConfirmationData,location2:ie,requestedTools:Ae}}Oe.to=Me})(Ri||(e.ChatAgentRequest=Ri={}));var Tt;(function(Oe){function Me(ie){switch(ie){case g.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case g.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case g.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case g.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Oe.to=Me;function Se(ie){switch(ie){case v.ChatLocation.Notebook:return g.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return g.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return g.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return g.ChatAgentLocation.Editor}}Oe.from=Se})(Tt||(e.ChatLocation=Tt={}));var Li;(function(Oe){function Me(Se){const ie=Se.value;if(!ie)throw new Error("Invalid value reference");return{id:Se.id,name:Se.name,range:Se.range&&[Se.range.start,Se.range.endExclusive],value:(0,m.$wc)(ie)?m.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,m.$wc)(ie.uri)?L.to((0,c.$di)(ie)):ie,modelDescription:Se.modelDescription}}Oe.to=Me})(Li||(e.ChatAgentValueReference=Li={}));var ui;(function(Oe){function Me(Se,ie,Ae){return{id:Se.id,label:Se.label,fullName:Se.fullName,icon:Se.icon?.id,value:Se.values[0].value,insertText:Se.insertText,detail:Se.detail,documentation:Se.documentation,command:ie.toInternal(Se.command,Ae)}}Oe.from=Me})(ui||(e.ChatAgentCompletionItem=ui={}));var At;(function(Oe){function Me(Se){return{errorDetails:Se.errorDetails,metadata:Se.metadata,nextQuestion:Se.nextQuestion}}Oe.to=Me})(At||(e.ChatAgentResult=At={}));var Oi;(function(Oe){function Me(Se,ie,Ae){if(ie.action.kind==="vote")return;const Ge=At.to(Se);if(ie.action.kind==="command"){const _e=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ae.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:Ge}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:jt.to(ie.action.followup)},result:Ge}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:Ge}:{action:ie.action,result:Ge}}Oe.to=Me})(Oi||(e.ChatAgentUserActionEvent=Oi={}));var Ii;(function(Oe){function Me(Se,ie,Ae){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand,shouldExecute:Se.shouldExecute}:"uri"in Se?{uri:Se.uri}:ie.toInternal(Se,Ae)}Oe.from=Me})(Ii||(e.TerminalQuickFix=Ii={}));var Si;(function(Oe){function Me(Se){return{kind:Ni.to(Se.kind)}}Oe.to=Me})(Si||(e.PartialAcceptInfo=Si={}));var Ni;(function(Oe){function Me(Se){switch(Se){case s.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Oe.to=Me})(Ni||(e.PartialAcceptTriggerKind=Ni={}));var wi;(function(Oe){function Me(Se,ie){return{id:ie,label:Se.label,description:Se.description,canEdit:Se.canEdit,collapsibleState:Se.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:Se.contextValue}}Oe.from=Me})(wi||(e.DebugTreeItem=wi={}));var Vt;(function(Oe){function Me(Se){return{name:Se.name,description:Se.description,parametersSchema:Se.parametersSchema}}Oe.to=Me})(Vt||(e.LanguageModelToolDescription=Vt={}))}),define(ke[294],Ie([1,0,6,19,15,53]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0;let T=class{constructor(b,c){this.a=b.getProxy(r.$ON.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>c.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,c,I){const y=new R.$Zw(A.WorkspaceEdit.from(b,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,I?.isRefactoring??!1)}};e.$Qpc=T,e.$Qpc=T=Je([Ve(0,h.$oQ)],T)}),define(ke[295],Ie([1,0,18,7,52,4,39,3,44,42,17,2,23,6,15,9,154,257,25]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=void 0,w=We(w),a=We(a);class i{constructor(n,d,l,g,E){this.j=n,this.k=d,this.l=l,this.m=g,this.n=E,this.b=c.$ge.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let d=function(g){if(n.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,g),E}};const n=this;this.b.reset();const l=(g,E)=>{if(typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),E){const S=this.l.$handleProgressChunk(this.k.requestId,g),D={report:k=>{S?.then(P=>{P&&(a.$iO.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseWarningPart.from(k),P):this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseReferencePart.from(k),P))})}};Promise.all([S,E?.(D)]).then(([k,P])=>{k!==void 0&&P!==void 0&&this.l.$handleProgressChunk(this.k.requestId,w.ChatTaskResult.from(P),k)})}else this.l.$handleProgressChunk(this.k.requestId,g)};this.g={markdown(g){d(this.markdown);const E=new a.$QP(g),S=w.ChatResponseMarkdownPart.from(E);return l(S),this},markdownWithVulnerabilities(g,E){d(this.markdown),E&&(0,f.$jH)(n.j,"chatParticipantAdditions");const S=new a.$RP(g,E),D=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(S);return l(D),this},filetree(g,E){d(this.filetree);const S=new a.$UP(g,E),D=w.ChatResponseFilesPart.from(S);return l(D),this},anchor(g,E){d(this.anchor);const S=new a.$VP(g,E),D=w.ChatResponseAnchorPart.from(S);return l(D),this},button(g){d(this.anchor);const E=new a.$ZP(g),S=w.ChatResponseCommandButtonPart.from(E,n.m,n.n);return l(S),this},progress(g,E){d(this.progress);const S=new a.$XP(g,E),D=E?w.ChatTask.from(S):w.ChatResponseProgressPart.from(S);return l(D,E),this},warning(g){d(this.progress),(0,f.$jH)(n.j,"chatParticipantAdditions");const E=new a.$YP(g),S=w.ChatResponseWarningPart.from(E);return l(S),this},reference(g,E){return this.reference2(g,E)},reference2(g,E,S){if(d(this.reference),"variableName"in g&&(0,f.$jH)(n.j,"chatParticipantAdditions"),"variableName"in g&&!g.value){const D=n.k.variables.variables.find(k=>k.name===g.variableName);if(D){let k;if(D.references?.length)k=D.references.map(P=>({kind:"reference",reference:{variableName:g.variableName,value:P.reference}}));else{const P=new a.$1P(g,E,S);k=[w.ChatResponseReferencePart.from(P)]}return k.forEach(P=>l(P)),this}}else{const D=new a.$1P(g,E,S),k=w.ChatResponseReferencePart.from(D);l(k)}return this},codeCitation(g,E,S){d(this.codeCitation),(0,f.$jH)(n.j,"chatParticipantAdditions");const D=new a.$2P(g,E,S),k=w.ChatResponseCodeCitationPart.from(D);l(k)},textEdit(g,E){d(this.textEdit),(0,f.$jH)(n.j,"chatParticipantAdditions");const S=new a.$3P(g,E),D=w.ChatResponseTextEditPart.from(S);return l(D),this},detectedParticipant(g,E){d(this.detectedParticipant),(0,f.$jH)(n.j,"chatParticipantAdditions");const S=new a.$SP(g,E),D=w.ChatResponseDetectedParticipantPart.from(S);return l(D),this},confirmation(g,E,S,D){d(this.confirmation),(0,f.$jH)(n.j,"chatParticipantAdditions");const k=new a.$TP(g,E,S,D),P=w.ChatResponseConfirmationPart.from(k);return l(P),this},push(g){if(d(this.push),(g instanceof a.$3P||g instanceof a.$RP||g instanceof a.$SP||g instanceof a.$YP||g instanceof a.$TP||g instanceof a.$2P)&&(0,f.$jH)(n.j,"chatParticipantAdditions"),g instanceof a.$1P)this.reference2(g.value,g.iconPath,g.options);else{const E=w.ChatResponsePart.from(g,n.m,n.n);l(E)}return this}}}return this.g}}class s extends O.$Vc{static{this.b=0}constructor(n,d,l,g){super(),this.n=d,this.s=l,this.t=g,this.c=new Map,this.j=this.B(new O.$5c),this.m=this.B(new O.$5c),this.g=n.getProxy(C.$ON.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,d,l){const g=s.b++,E=new t(n,d,this.g,g,l);return this.c.set(g,E),this.g.$registerAgent(g,n.identifier,d,{},void 0),E.apiAgent}createDynamicChatAgent(n,d,l,g){const E=s.b++,S=new t(n,d,this.g,E,g);return this.c.set(E,S),this.g.$registerAgent(E,n.identifier,d,{isSticky:!0},l),S.apiAgent}async $invokeAgent(n,d,l,g){const E=this.c.get(n);if(!E)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);const S=(0,b.$di)(d);let D=this.j.get(S.sessionId);D||(D=new O.$Uc,this.j.set(S.sessionId,D));const k=new i(E.extension,S,this.g,this.s.converter,D);try{const P=await this.u(S.agentId,l);let p;if(S.locationData?.type===m.ChatAgentLocation.Editor){const F=this.t.getDocument(S.locationData.document);p=new a.$6P(F,w.Selection.to(S.locationData.selection),w.Range.to(S.locationData.wholeRange))}else if(S.locationData?.type===m.ChatAgentLocation.Notebook){const F=this.t.getDocument(S.locationData.sessionInputUri);p=new a.$7P(F)}else S.locationData?.type,m.ChatAgentLocation.Terminal;const v=E.invoke(w.ChatAgentRequest.to(S,p),{history:P},k.apiObject,g);return await(0,h.$uh)(Promise.resolve(v).then(F=>{if(F?.metadata)try{JSON.stringify(F.metadata)}catch(L){const M=`result.metadata MUST be JSON.stringify-able. Got error: ${L.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${M}`,E.extension),{errorDetails:{message:M},timings:k.timings,nextQuestion:F.nextQuestion}}let N;return F?.errorDetails&&(N={...F.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,f.$jH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:k.timings,metadata:F?.metadata,nextQuestion:F?.nextQuestion}}),g)}catch(P){return this.n.error(P,E.extension),P instanceof a.$cQ&&P.cause&&(P=P.cause),{errorDetails:{message:(0,A.$rj)(P),responseIsIncomplete:!0}}}finally{k.close()}}async u(n,d){const l=[];for(const g of d.history){const E=w.ChatAgentResult.to(g.result),S=n===g.request.agentId?E:{...E,metadata:void 0},D=g.request.variables.variables.filter(P=>!P.isTool).map(w.ChatAgentValueReference.to);l.push(new a.$4P(g.request.message,g.request.command,D,g.request.agentId));const k=(0,r.$Hb)(g.response.map(P=>w.ChatResponsePart.toContent(P,this.s.converter)));l.push(new a.$5P(k,S,g.request.agentId,g.request.command))}return l}$releaseSession(n){this.j.deleteAndDispose(n)}async $provideFollowups(n,d,l,g,E){const S=this.c.get(d);if(!S)return Promise.resolve([]);const D=(0,b.$di)(n),k=await this.u(S.id,g),P=w.ChatAgentResult.to(l);return(await S.provideFollowups(P,{history:k},E)).filter(p=>{const v=!p.participant||T.Iterable.some(this.c.values(),F=>F.id===p.participant&&u.$sn.equals(F.extension.identifier,S.extension.identifier));return v||this.n.warn(`[@${S.id}] ChatFollowup refers to an unknown participant: ${p.participant}`),v}).map(p=>w.ChatFollowup.from(p,D))}$acceptFeedback(n,d,l,g){const E=this.c.get(n);if(!E)return;const S=w.ChatAgentResult.to(d);let D;switch(l){case $.ChatAgentVoteDirection.Down:D=a.ChatResultFeedbackKind.Unhelpful;break;case $.ChatAgentVoteDirection.Up:D=a.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(g?{result:S,kind:D,reportIssue:g}:{result:S,kind:D}))}$acceptAction(n,d,l){const g=this.c.get(n);if(!g||l.action.kind==="vote")return;const E=w.ChatAgentUserActionEvent.to(d,l,this.s.converter);E&&g.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(n,d,l){const g=this.c.get(n);if(!g)return[];let E=this.m.get(n);return E?E.clear():(E=new O.$Uc,this.m.set(n,E)),(await g.invokeCompletionProvider(d,l)).map(D=>w.ChatAgentCompletionItem.from(D,this.s.converter,E))}async $provideWelcomeMessage(n,d,l){const g=this.c.get(n);if(g)return await g.provideWelcomeMessage(w.ChatLocation.to(d),l)}async $provideSampleQuestions(n,d,l){const g=this.c.get(n);if(g)return(await g.provideSampleQuestions(w.ChatLocation.to(d),l)).map(E=>w.ChatFollowup.from(E,void 0))}}e.$Rpc=s;class t{constructor(n,d,l,g,E){this.extension=n,this.id=d,this.w=l,this.x=g,this.y=E,this.m=new R.$me,this.n=new R.$me}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,d){return this.q?await this.q.provider.provideCompletionItems(n,d)??[]:[]}async provideFollowups(n,d,l){if(!this.b)return[];const g=await this.b.provideFollowups(n,d,l);return g?g.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(n,d){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(n,d);return l?l.map(g=>typeof g=="string"?g:w.MarkdownString.from(g)):[]}async provideSampleQuestions(n,d){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(n,d);return l||[]}get apiAgent(){let n=!1,d=!1;const l=()=>{n||d||(d=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof y.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof a.$PO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:w.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),d=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g.c},set iconPath(E){g.c=E,l()},get requestHandler(){return g.y},set requestHandler(E){(0,I.$pg)(typeof E=="function","Invalid request handler"),g.y=E},get followupProvider(){return g.b},set followupProvider(E){g.b=E,l()},get isDefault(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.d},set isDefault(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.d=E,l()},get helpTextPrefix(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.g},set helpTextPrefix(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.g=E,l()},get helpTextVariablesPrefix(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.j},set helpTextVariablesPrefix(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.j=E,l()},get helpTextPostfix(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.k},set helpTextPostfix(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.k=E,l()},get isSecondary(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.l},set isSecondary(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.l=E,l()},get supportIssueReporting(){return(0,f.$jH)(g.extension,"chatParticipantPrivate"),g.o},set supportIssueReporting(E){(0,f.$jH)(g.extension,"chatParticipantPrivate"),g.o=E,l()},get onDidReceiveFeedback(){return g.m.event},set participantVariableProvider(E){if((0,f.$jH)(g.extension,"chatParticipantAdditions"),g.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");g.w.$registerAgentCompletionsProvider(g.x,g.id,E.triggerCharacters)}else g.w.$unregisterAgentCompletionsProvider(g.x,g.id)},get participantVariableProvider(){return(0,f.$jH)(g.extension,"chatParticipantAdditions"),g.q},set welcomeMessageProvider(E){(0,f.$jH)(g.extension,"defaultChatParticipant"),g.s=E,l()},get welcomeMessageProvider(){return(0,f.$jH)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,f.$iH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){g.t=E,l()},get requester(){return g.t},set supportsSlowReferences(E){(0,f.$jH)(g.extension,"chatParticipantPrivate"),g.u=E,l()},get supportsSlowReferences(){return(0,f.$jH)(g.extension,"chatParticipantPrivate"),g.u},dispose(){n=!0,g.b=void 0,g.m.dispose(),g.w.$unregisterAgent(g.x)}}}invoke(n,d,l,g){return this.y(n,d,l,g)}}}),define(ke[296],Ie([1,0,13,3,51,6,15,9,25]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0,T=We(T),O=We(O);class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(R.$ON.MainThreadChatVariables)}async $resolveVariable(u,C,w,a){const m=this.b.get(u);if(m)try{if(m.resolver.resolve2){(0,b.$jH)(m.extension,"chatParticipantAdditions");const $=new I(C,this.c),f=await m.resolver.resolve2(m.data.name,{prompt:w},$.apiObject,a);if(f&&f[0])return f[0].value}else{const $=await m.resolver.resolve(m.data.name,{prompt:w},a);if($&&$[0])return $[0].value}}catch($){(0,r.$1)($)}}registerVariableResolver(u,C,w,a,m,$,f,i,s){const t=c.a++,o=s?A.ThemeIcon.fromId(s):void 0;return this.b.set(t,{extension:u,data:{id:C,name:w,description:a,modelDescription:m,icon:o},resolver:f}),this.c.$registerVariable(t,{id:C,name:w,description:a,modelDescription:m,isSlow:$,fullName:i,icon:o}),(0,h.$Tc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Spc=c;class I{constructor(u,C){this.c=u,this.d=C,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let C=function(a){if(u.a){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,a),m}};const u=this,w=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){C(this.progress);const m=new O.$WP(a),$=T.ChatResponseProgressPart.from(m);return w($),this},reference(a){C(this.reference);const m=new O.$1P(a),$=T.ChatResponseReferencePart.from(m);return w($),this},push(a){return C(this.push),a instanceof O.$1P?w(T.ChatResponseReferencePart.from(a)):a instanceof O.$WP&&w(T.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(ke[297],Ie([1,0,7,59,4,3,40,2,87,23,15,9,6,25]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=w,b=We(b),I=We(I),y=We(y);function w(a,m,$){const f=a.getProxy(u.$ON.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$un,m.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===T.MarshalledId.CommentController){const k=this.b.get(D.handle);return k?k.value:D}else if(D&&D.$mid===T.MarshalledId.CommentThread){const k=D,P=this.b.get(k.commentControlHandle);if(!P)return k;const p=P.getCommentThread(k.commentThreadHandle);return p?p.value:k}else if(D&&(D.$mid===T.MarshalledId.CommentThreadReply||D.$mid===T.MarshalledId.CommentThreadInstance)){const k=this.b.get(D.thread.commentControlHandle);if(!k)return D;const P=k.getCommentThread(D.thread.commentThreadHandle);return P?D.$mid===T.MarshalledId.CommentThreadInstance?P.value:{thread:P.value,text:D.text}:D}else if(D&&D.$mid===T.MarshalledId.CommentNode){const k=this.b.get(D.thread.commentControlHandle);if(!k)return D;const P=k.getCommentThread(D.thread.commentThreadHandle);if(!P)return D;const p=D.commentUniqueId,v=P.getCommentByUniqueId(p);return v||D}else if(D&&D.$mid===T.MarshalledId.CommentThreadNode){const k=this.b.get(D.thread.commentControlHandle);if(!k)return D;const P=k.getCommentThread(D.thread.commentThreadHandle);if(!P)return D;const p=D.text,v=D.commentUniqueId,F=P.getCommentByUniqueId(v);return F?(typeof F.body=="string"?F.body=p:F.body=new y.$iO(p),F):D}return D}})}createCommentController(D,k,P){const p=i.a++,v=new t(D,p,k,P);this.b.set(v.handle,v);const F=this.c.get(D.identifier)||[];return F.push(v),this.c.set(D.identifier,F),v.value}async $createCommentThreadTemplate(D,k,P,p){const v=this.b.get(D);v&&v.$createCommentThreadTemplate(k,P,p)}async $setActiveComment(D,k){const P=this.b.get(D);P&&P.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(D,k,P){const p=this.b.get(D);p&&p.$updateCommentThreadTemplate(k,P)}$deleteCommentThread(D,k){this.b.get(D)?.$deleteCommentThread(k)}async $provideCommentingRanges(D,k,P){const p=this.b.get(D);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const v=await $.ensureDocumentData(O.URI.revive(k));return(0,r.$yh)(async()=>{const F=await p.commentingRangeProvider.provideCommentingRanges(v.document,P);let N;return Array.isArray(F)?N={ranges:F,fileComments:!1}:F?N={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:N=F??void 0,N}).then(F=>{let N;return F&&(N={ranges:F.ranges.map(L=>I.Range.from(L)),fileComments:F.fileComments}),N})}$toggleReaction(D,k,P,p,v){const F=this.b.get(D);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,r.$yh)(()=>{const N=F.getCommentThread(k);if(N){const L=N.getCommentByUniqueId(p.uniqueIdInThread);if(F!==void 0&&L&&F.reactionHandler)return F.reactionHandler(L,d(v))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(D){this.n=D}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(D){(D===void 0!=(this.p===void 0)||!D||!this.p||!D.isEqual(this.p))&&(this.p=D,this.b.range=D,this.c.fire())}get range(){return this.p}set canReply(D){this.d!==D&&(this.d=D,this.b.canReply=D,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(D){this.e=D,this.b.label=D,this.c.fire()}get contextValue(){return this.f}set contextValue(D){this.f=D,this.b.contextValue=D,this.c.fire()}get comments(){return this.q}set comments(D){this.q=D,this.b.comments=D,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(D){this.g=D,this.b.collapsibleState=D,this.c.fire()}get state(){return this.h}set state(D){this.h=D,typeof D=="object"?((0,C.$jH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=D.resolved,this.b.applicability=D.applicability):this.b.state=D,this.c.fire()}get isDisposed(){return this.j}constructor(D,k,P,p,v,F,N,L,M){this.m=k,this.n=P,this.o=p,this.p=v,this.q=F,this.extensionDescription=N,this.r=L,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$me,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Wc,this.l.value=new R.$Uc,this.n===void 0&&(this.n=`${D}.${this.handle}`),f.$createCommentThread(k,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(j=>o(this,j,this.k,this.extensionDescription)),N.identifier,this.r,M),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{f.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(j){z.range=j},get comments(){return z.comments},set comments(j){z.comments=j},get collapsibleState(){return z.collapsibleState},set collapsibleState(j){z.collapsibleState=j},get canReply(){return z.canReply},set canReply(j){z.canReply=j},get contextValue(){return z.contextValue},set contextValue(j){z.contextValue=j},get label(){return z.label},set label(j){z.label=j},get state(){return z.state},set state(j){z.state=j},reveal:(j,q)=>z.reveal(j,q),hide:()=>z.hide(),dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Uc);const D=P=>Object.prototype.hasOwnProperty.call(this.b,P),k={};D("range")&&(k.range=I.Range.from(this.p)),D("label")&&(k.label=this.label),D("contextValue")&&(k.contextValue=this.contextValue??null),D("comments")&&(k.comments=this.q.map(P=>o(this,P,this.k,this.extensionDescription))),D("collapsibleState")&&(k.collapseState=l(this.g)),D("canReply")&&(k.canReply=this.canReply),D("state")&&(k.state=g(this.h)),D("applicability")&&(k.applicability=E(this.h)),D("isTemplate")&&(k.isTemplate=this.r),this.b={},f.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(D){for(const k of this.k){const P=k[0],p=k[1];if(D===p)return P}}async reveal(D,k){(0,C.$jH)(this.extensionDescription,"commentReveal");let P;D&&D.body!==void 0?P=D:k=k??D;let p=P?this.k.get(P):void 0;p??=this.k.get(this.q[0]);let v=!0,F=!1;return k?.focus===y.CommentThreadFocus.Reply?(F=!0,v=!1):k?.focus===y.CommentThreadFocus.Comment&&(v=!1),f.$revealCommentThread(this.m,this.handle,p,{preserveFocus:v,focusReply:F})}async hide(){return f.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(D=>D.dispose())}}Je([(0,h.$_h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(D){this.b=D,D?.resourceHints&&(0,C.$jH)(this.h,"commentingRangeHint"),f.$updateCommentingRanges(this.handle,D?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(D){this.c=D,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!D})}get options(){return this.d}set options(D){this.d=D,f.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,C.$jH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,C.$jH)(this.h,"activeComment"),this.f?.value}constructor(D,k,P,p){this.h=D,this.i=k,this.j=P,this.k=p,this.a=new Map,f.$registerCommentController(this.handle,P,p,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(F){v.options=F},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(F){v.commentingRangeProvider=F},get reactionHandler(){return v.reactionHandler},set reactionHandler(F){v.reactionHandler=F},get activeCommentThread(){return v.activeCommentThread},createCommentThread(F,N,L){return v.createCommentThread(F,N,L).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(D,k,P){k===void 0&&(0,C.$jH)(this.h,"fileComments");const p=new s(this.id,this.handle,void 0,D,k,P,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(D){if(!D){this.e=void 0,this.f=void 0;return}const k=this.a.get(D.commentThreadHandle);k&&(this.e=D.uniqueIdInThread?k.getCommentByUniqueId(D.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(D,k,P){const p=new s(this.id,this.handle,void 0,O.URI.revive(D),I.Range.to(k),[],this.h,!0,P);return p.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(D,k){const P=this.a.get(D);P&&(P.range=I.Range.to(k))}$deleteCommentThread(D){this.a.get(D)?.dispose(),this.a.delete(D)}getCommentThread(D){return this.a.get(D)}dispose(){this.a.forEach(D=>{D.dispose()}),this.g.forEach(D=>D.dispose())}}function o(S,D,k,P){let p=k.get(D);return p||(p=++S.commentHandle,k.set(D,p)),D.state!==void 0&&(0,C.$jH)(P,"commentsDraftState"),D.reactions?.some(v=>v.reactors!==void 0)&&(0,C.$jH)(P,"commentReactor"),{mode:D.mode,contextValue:D.contextValue,uniqueIdInThread:p,body:typeof D.body=="string"?D.body:I.MarkdownString.from(D.body),userName:D.author.name,userIconPath:D.author.iconPath,label:D.label,commentReactions:D.reactions?D.reactions.map(v=>n(v)):void 0,state:D.state,timestamp:D.timestamp?.toJSON()}}function n(S){return{label:S.label,iconPath:S.iconPath?I.$nQ(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(D=>D.name):S.reactors}}function d(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?O.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(D=>({name:D}))}}function l(S){if(S!==void 0)switch(S){case y.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function g(S){let D;if(typeof S=="object"?D=S.resolved:D=S,D!==void 0)switch(D){case y.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function E(S){let D;if(typeof S=="object"&&(D=S.applicability),D!==void 0)switch(D){case y.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new i}}),define(ke[298],Ie([1,0,20,60,3,14,22,2,15,96,118,6,9]),function($e,e,r,h,A,R,T,O,b,c,I,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=void 0,b=We(b),y=We(y),u=We(u);class C{constructor(n,d){this.document=n,this.b=d,this.a=1,this.c=new I.$Cpc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,d){await this.f(n).undo(),d||this.disposeBackup()}async redo(n,d){await this.f(n).redo(),d||this.disposeBackup()}disposeEdits(n){for(const d of n)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=t(this.document.uri)+this.a++;return(0,T.$hh)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const d=this.c.get(n,0);if(!d)throw new Error("No edit found");return d}}class w{constructor(){this.a=new Map}get(n,d){return this.a.get(this.b(n,d))}add(n,d,l){const g=this.b(n,d.uri);if(this.a.has(g))throw new Error(`Document already exists for viewType:${n} resource:${d.uri}`);const E=new C(d,l);return this.a.set(g,E),E}delete(n,d){const l=this.b(n,d.uri);this.a.delete(l)}b(n,d){return`${n}@@@${d}`}}var a;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(n,d,l){return this.b(n,{type:a.Text,extension:d,provider:l})}addCustomProvider(n,d,l){return this.b(n,{type:a.Custom,extension:d,provider:l})}get(n){return this.a.get(n)}b(n,d){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,d),new u.$QN(()=>this.a.delete(n))}}class ${constructor(n,d,l,g,E){this.d=d,this.f=l,this.g=g,this.h=E,this.b=new m,this.c=new w,this.a=n.getProxy(y.$ON.MainThreadCustomEditors)}registerCustomEditorProvider(n,d,l,g){const E=new A.$Uc;return i(l)?(E.add(this.b.addTextProvider(d,n,l)),this.a.$registerTextEditorProvider((0,c.$_pc)(n),d,g.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$0pc)(n))):(E.add(this.b.addCustomProvider(d,n,l)),f(l)&&E.add(l.onDidChangeCustomDocument(S=>{const D=this.i(d,S.document.uri);if(s(S)){const k=D.addEdit(S);this.a.$onDidEdit(S.document.uri,d,k,S.label)}else this.a.$onContentChange(S.document.uri,d)})),this.a.$registerCustomEditorProvider((0,c.$_pc)(n),d,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,c.$0pc)(n))),u.$QN.from(E,new u.$QN(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(n,d,l,g,E){const S=this.b.get(d);if(!S)throw new Error(`No provider found for '${d}'`);if(S.type!==a.Custom)throw new Error(`Invalid provide type for '${d}'`);const D=O.URI.revive(n),k=await S.provider.openCustomDocument(D,{backupId:l,untitledDocumentData:g?.buffer},E);let P;return f(S.provider)&&this.f&&(P=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(d,k,P),{editable:f(S.provider)}}async $disposeCustomDocument(n,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==a.Custom)throw new Error(`Invalid provider type for '${d}'`);const g=O.URI.revive(n),{document:E}=this.i(d,g);this.c.delete(d,E),E.dispose()}async $resolveCustomEditor(n,d,l,g,E,S){const D=this.b.get(l);if(!D)throw new Error(`No provider found for '${l}'`);const k=b.ViewColumn.to(E),P=this.g.createNewWebview(d,g.contentOptions,D.extension),p=this.h.createNewWebviewPanel(d,l,g.title,k,g.options,P,g.active),v=O.URI.revive(n);switch(D.type){case a.Custom:{const{document:F}=this.i(l,v);return D.provider.resolveCustomEditor(F,p,S)}case a.Text:{const F=this.d.getDocument(v);return D.provider.resolveCustomTextEditor(F,p,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,d,l){this.i(d,n).disposeEdits(l)}async $onMoveCustomEditor(n,d,l){const g=this.b.get(l);if(!g)throw new Error(`No provider found for '${l}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const E=this.h.getWebviewPanel(n);if(!E)throw new Error("No webview found");const S=O.URI.revive(d),D=this.d.getDocument(S);await g.provider.moveCustomTextEditor(D,E,r.CancellationToken.None)}async $undo(n,d,l,g){return this.i(d,n).undo(l,g)}async $redo(n,d,l,g){return this.i(d,n).redo(l,g)}async $revert(n,d,l){const g=this.i(d,n);await this.j(d).revertCustomDocument(g.document,l),g.disposeBackup()}async $onSave(n,d,l){const g=this.i(d,n);await this.j(d).saveCustomDocument(g.document,l),g.disposeBackup()}async $onSaveAs(n,d,l,g){const E=this.i(d,n);return this.j(d).saveCustomDocumentAs(E.document,O.URI.revive(l),g)}async $backup(n,d,l){const g=this.i(d,n),S=await this.j(d).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},l);return g.updateBackup(S),S.id}i(n,d){const l=this.c.get(n,O.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(n){const l=this.b.get(n)?.provider;if(!l||!f(l))throw new Error("Custom document is not editable");return l}}e.$cqc=$;function f(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function s(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const n=o.scheme===R.Schemas.file||o.scheme===R.Schemas.untitled?o.fsPath:o.toString();return(0,h.$uj)(n)+""}}),define(ke[299],Ie([1,0,8,146,2,6,9,15,4,11,28,62]),function($e,e,r,h,A,R,T,O,b,c,I,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=e.$Jpc=void 0,O=We(O);class C{#e;#t;#i;constructor(m,$,f,i,s,t,o,n){this.d=m,this.e=$,this.f=f,this.g=i,this.h=s,this.c=!1,this.f=Math.max(i,f),this.#i=new I.$Bc(d=>t.getComparisonKey(d)),this.#e=o,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,$){if(!m){this.clear();return}this.j();let f=[];if(A.URI.isUri(m)){if(!$){this.delete(m);return}this.#i.set(m,$.slice()),f=[m]}else if(Array.isArray(m)){f=[];let t;m=[...m].sort(C.k);for(const o of m){const[n,d]=o;if((!t||n.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=n,f.push(n),this.#i.set(n,[])),d)this.#i.get(n)?.push(...d);else{const l=this.#i.get(n);l&&(l.length=0)}}}if(this.#t.fire(f),!this.#e)return;const i=[];let s=0;for(const t of f){let o=[];const n=this.#i.get(t);if(n)if(n.length>this.g){o=[];const d=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const g of n)if(g.severity===d[l]&&o.push({...O.Diagnostic.from(g),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(2683,null,n.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=n.map(d=>({...O.Diagnostic.from(d),modelVersionId:this.h(t)}));if(i.push([t,o]),s+=o.length,s>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,$){this.j();for(const[f,i]of this)m.call($,f,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const $=this.#i.get(m);return Array.isArray($)?Object.freeze($.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,$){return m[0].toString()<$[0].toString()?-1:m[0].toString()>$[0].toString()?1:0}}e.$Jpc=C;let w=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(m){const $=new I.$Bc;for(const f of m)$.set(f,f);return{uris:Object.freeze(Array.from($.values()))}}constructor(m,$,f,i){this.j=$,this.k=f,this.l=i,this.g=new Map,this.h=new b.$qe({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this.h.event,u._mapper),this.f=m.getProxy(R.$ON.MainThreadDiagnostics)}createDiagnosticCollection(m,$){const{g:f,f:i,h:s,j:t,k:o,l:n}=this,d=new class{$changeMany(E,S){i.$changeMany(E,S),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,E,S.length===0?"CLEARING":S)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,E)}dispose(){i.dispose()}};let l;if(!$)$="_generated_diagnostic_collection_name_#"+u.c++,l=$;else if(!f.has($))l=$;else{this.j.warn(`DiagnosticCollection with name '${$}' does already exist.`);do l=$+u.c++;while(f.has(l))}return new class extends C{constructor(){super($,l,u.e,u.d,E=>n.getDocument(E)?.version,o.extUri,d,s),f.set(l,this)}dispose(){super.dispose(),f.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const $=new Map,f=[];for(const i of this.g.values())i.forEach((s,t)=>{let o=$.get(s.toString());typeof o>"u"&&(o=f.length,$.set(s.toString(),o),f.push([s,[]])),f[o][1]=f[o][1].concat(...t)});return f}}m(m){let $=[];for(const f of this.g.values())f.has(m)&&($=$.concat(f.get(m)));return $}$acceptMarkersChange(m){if(!this.n){const $="_generated_mirror",f=new C($,$,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set($,f),this.n=f}for(const[$,f]of m)this.n.set(A.URI.revive($),f.map(O.Diagnostic.to))}};e.$Kpc=w,e.$Kpc=w=u=Je([Ve(1,c.$bk),Ve(2,y.$Ipc)],w)}),define(ke[300],Ie([1,0,2,13,9,15,80,53]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=void 0;class b{constructor(I,y,u,C={timeout:1500,errors:3}){this.c=I,this.d=y,this.f=u,this.g=C,this.a=new T.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(y,u,C)=>{const a={dispose:this.a.push([y,u,I])};return Array.isArray(C)&&C.push(a),a}}async $participateInSave(I,y){const u=r.URI.revive(I);let C=!1;const w=setTimeout(()=>C=!0,this.g.timeout),a=[];try{for(const m of[...this.a]){if(C)break;const $=this.d.getDocument(u),f=await this.h(m,{document:$,reason:R.TextDocumentSaveReason.to(y)});a.push(f)}}finally{clearTimeout(w)}return a}h([I,y,u],C){const w=this.b.get(I);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(u,I,y,C).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const m=this.b.get(I);this.b.set(I,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,y,u,C){const w=[],a=Date.now(),{document:m,reason:$}=C,{version:f}=m,i=Object.freeze({document:m,reason:$,waitUntil(s){if(Object.isFrozen(w))throw(0,h.$8)("waitUntil can not be called async");w.push(Promise.resolve(s))}});try{y.apply(u,[i])}catch(s){return Promise.reject(s)}return Object.freeze(w),new Promise((s,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(w).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(o),s(n)}).catch(n=>{clearTimeout(o),t(n)})}).then(s=>{const t={edits:[]};for(const o of s)if(Array.isArray(o)&&o.every(n=>n instanceof A.$ZN))for(const{newText:n,newEol:d,range:l}of o)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:n,eol:d&&R.EndOfLine.from(d)}});if(t.edits.length!==0)return f===m.version?this.f.$tryApplyWorkspaceEdit(new O.$Zw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Xqc=b}),define(ke[301],Ie([1,0,4,3,2,6,165,15,17,24,9]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=void 0,O=We(O);class y{constructor(C,w){this.a=new r.$me,this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Uc,this.h=new Map,this.f=C.getProxy(R.$ON.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const w=this.g.getDocument(C);if(w)return w}getDocument(C){const w=this.getDocumentData(C);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return w.document}ensureDocumentData(C){const w=this.g.getDocument(C);if(w)return Promise.resolve(w);let a=this.h.get(C.toString());return a||(a=this.f.$tryOpenDocument(C).then(m=>{this.h.delete(C.toString());const $=A.URI.revive(m);return(0,b.$qg)(this.g.getDocument($))},m=>(this.h.delete(C.toString()),Promise.reject(m))),this.h.set(C.toString(),a)),a}createDocumentData(C){return this.f.$tryCreateDocument(C).then(w=>A.URI.revive(w))}$acceptModelLanguageChanged(C,w){const a=A.URI.revive(C),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(w),this.a.fire(m.document)}$acceptModelSaved(C){const w=A.URI.revive(C),a=this.g.getDocument(w);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(C,w){const a=A.URI.revive(C),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(w),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,w,a){const m=A.URI.revive(C),$=this.g.getDocument(m);if(!$)throw new Error("unknown document");$._acceptIsDirty(a),$.onEvents(w);let f;w.isUndoing?f=I.TextDocumentChangeReason.Undo:w.isRedoing&&(f=I.TextDocumentChangeReason.Redo),this.c.fire((0,c.$go)({document:$.document,contentChanges:w.changes.map(i=>({range:O.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:f}))}setWordDefinitionFor(C,w){(0,T.$qQ)(C,w)}}e.$Lpc=y}),define(ke[77],Ie([1,0,78,4,17,2,5,6,19,15,9]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqc=e.$dqc=void 0,c=We(c),e.$dqc=(0,T.$Gi)("IExtHostEditorTabs");class y{constructor(m,$,f){this.e=f,this.d=$,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,$={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze($)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case O.TabInputKind.TextInput:return new I.$EP(R.URI.revive(this.b.input.uri));case O.TabInputKind.TextDiffInput:return new I.$FP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case O.TabInputKind.TextMergeInput:return new I.$GP(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case O.TabInputKind.CustomEditorInput:return new I.$HP(R.URI.revive(this.b.input.uri),this.b.input.viewType);case O.TabInputKind.WebviewEditorInput:return new I.$IP(this.b.input.viewType);case O.TabInputKind.NotebookInput:return new I.$JP(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case O.TabInputKind.NotebookDiffInput:return new I.$KP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case O.TabInputKind.TerminalEditorInput:return new I.$LP;case O.TabInputKind.InteractiveEditorInput:return new I.$MP(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case O.TabInputKind.ChatEditorInput:return new I.$NP;case O.TabInputKind.MultiDiffEditorInput:return new I.$OP(this.b.input.diffEditors.map(m=>new I.$FP(R.URI.revive(m.original),R.URI.revive(m.modified))));default:return}}}class u{constructor(m,$){this.c=[],this.d="",this.b=m,this.e=$;for(const f of m.tabs)f.isActive&&(this.d=f.id),this.c.push(new y(f,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,$={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return c.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(f=>f.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(f=>f.apiObject))}};this.a=Object.freeze($)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===O.TabModelOperationKind.TAB_OPEN){const f=new y(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,f),m.tabDto.isActive&&(this.d=f.tabId),f}else if(m.kind===O.TabModelOperationKind.TAB_CLOSE){const f=this.c.splice(m.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return f.tabId===this.d&&(this.d=""),f}else if(m.kind===O.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this.c.splice(m.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,f),f}const $=this.c.find(f=>f.tabId===m.tabDto.id);if(!$)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),$.acceptDtoUpdate(m.tabDto),$}activeTabId(){return this.d}}let C=class{constructor(m){this.b=new h.$me,this.c=new h.$me,this.e=[],this.a=m.getProxy(O.$ON.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,$={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(f=>f.apiObject))},get activeTabGroup(){const f=m.d;return(0,A.$qg)(m.e.find(s=>s.groupId===f)?.apiObject)},close:async(f,i)=>{const s=Array.isArray(f)?f:[f];return s.length?w(s[0])?this.j(s,i):this.i(s,i):!0}};this.f=Object.freeze($)}return this.f}$acceptEditorTabModel(m){const $=new Set(this.e.map(d=>d.groupId)),f=new Set(m.map(d=>d.groupId)),i=(0,r.$d)($,f),s=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),t=[],o=[];this.e=m.map(d=>{const l=new u(d,()=>this.d);return i.added.includes(l.groupId)?t.push(l.apiObject):o.push(l.apiObject),l});const n=(0,A.$qg)(m.find(d=>d.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:t,closed:s,changed:o}))}$acceptTabGroupUpdate(m){const $=this.e.find(f=>f.groupId===m.groupId);if(!$)throw new Error("Update Group IPC call received before group creation.");$.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[$.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const $=this.e.find(i=>i.groupId===m.groupId);if(!$)throw new Error("Update Tabs IPC call received before group creation.");const f=$.acceptTabOperation(m);switch(m.kind){case O.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case O.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case O.TabModelOperationKind.TAB_MOVE:case O.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}g(m){for(const $ of this.e)for(const f of $.tabs)if(f.apiObject===m)return f}h(m){return this.e.find($=>$.apiObject===m)}async i(m,$){const f=[];for(const i of m){const s=this.g(i);if(!s)throw new Error("Tab close: Invalid tab not found!");f.push(s.tabId)}return this.a.$closeTab(f,$)}async j(m,$){const f=[];for(const i of m){const s=this.h(i);if(!s)throw new Error("Group close: Invalid group not found!");f.push(s.groupId)}return this.a.$closeGroup(f,$)}};e.$eqc=C,e.$eqc=C=Je([Ve(0,b.$oQ)],C);function w(a){return a.tabs!==void 0}}),define(ke[302],Ie([1,0,2,6,27,3,9,15,203,12,26,21,25,85]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=void 0,A=We(A),O=We(O);class w{constructor(){this.a=[]}add($){this.b=void 0,this.a.push($)}delete($){const f=this.a.indexOf($);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const $=this.a.sort(),f=[];let i,s,t=b.State.LastKnownState,o=b.State.LastKnownState;for(const n of $){let d=i?(0,c.$If)(i,n):0;for(d===0?s=b.State.Start:s=o;d<n.length;d++)d+1===n.length?(t=o,o=b.State.BeforeColon):o+=1,f.push([s,n.toUpperCase().charCodeAt(d),o]),f.push([s,n.toLowerCase().charCodeAt(d),o]),s=o;i=n,o=t}f.push([b.State.BeforeColon,I.CharCode.Colon,b.State.AfterColon]),f.push([b.State.AfterColon,I.CharCode.Slash,b.State.End]),this.b=new b.$J4(f)}}provideDocumentLinks($){this.c();const f=[],i=b.$K4.computeLinks({getLineContent(s){return $.lineAt(s-1).text},getLineCount(){return $.lineCount}},this.b);for(const s of i){const t=O.DocumentLink.to(s);t.target&&f.push(t)}return f}}class a{constructor($,f){this.i=f,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=$.getProxy(h.$ON.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider($,f,i,s={}){if(a.j(i),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider($,"*",this.b));const t=this.h++;this.b.add(f),this.d.add(f),this.c.set(t,i);let o=A.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(o+=A.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(o+=A.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=A.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$jH)($,"fsChunks"),o+=A.FileSystemProviderCapabilities.FileOpenReadWriteClose);let n;s.isReadonly&&(0,C.$7k)(s.isReadonly)&&s.isReadonly.value!==""&&(n={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(t,f,o,n).catch(l=>{console.error(`FAILED to register filesystem provider of ${$.identifier.value}-extension for the scheme ${f}`),console.error(l)});const d=i.onDidChangeFile(l=>{const g=[];for(const E of l){const{uri:S,type:D}=E;if(S.scheme!==f)continue;let k;switch(D){case T.FileChangeType.Changed:k=A.FileChangeType.UPDATED;break;case T.FileChangeType.Created:k=A.FileChangeType.ADDED;break;case T.FileChangeType.Deleted:k=A.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:S,type:k})}this.a.$onFileSystemChange(t,g)});return(0,R.$Tc)(()=>{d.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(t),this.a.$unregisterProvider(t)})}static j($){if(!$)throw new Error("MISSING provider");if(typeof $.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof $.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof $.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof $.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof $.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof $.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof $.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof $.rename!="function")throw new Error("Provider does NOT implement rename")}static k($){const{type:f,ctime:i,mtime:s,size:t,permissions:o}=$;return{type:f,ctime:i,mtime:s,size:t,permissions:o}}$stat($,f){return Promise.resolve(this.l($).stat(r.URI.revive(f))).then(i=>a.k(i))}$readdir($,f){return Promise.resolve(this.l($).readDirectory(r.URI.revive(f)))}$readFile($,f){return Promise.resolve(this.l($).readFile(r.URI.revive(f))).then(i=>y.$Oe.wrap(i))}$writeFile($,f,i,s){return Promise.resolve(this.l($).writeFile(r.URI.revive(f),i.buffer,s))}$delete($,f,i){return Promise.resolve(this.l($).delete(r.URI.revive(f),i))}$rename($,f,i,s){return Promise.resolve(this.l($).rename(r.URI.revive(f),r.URI.revive(i),s))}$copy($,f,i,s){const t=this.l($);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(r.URI.revive(f),r.URI.revive(i),s))}$mkdir($,f){return Promise.resolve(this.l($).createDirectory(r.URI.revive(f)))}$watch($,f,i,s){const t=this.l($).watch(r.URI.revive(i),s);this.f.set(f,t)}$unwatch($,f){const i=this.f.get(f);i&&(i.dispose(),this.f.delete(f))}$open($,f,i){const s=this.l($);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(r.URI.revive(f),i))}$close($,f){const i=this.l($);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(f))}$read($,f,i,s){const t=this.l($);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.$Oe.alloc(s);return Promise.resolve(t.read(f,i,o.buffer,0,s)).then(n=>o.slice(0,n))}$write($,f,i,s){const t=this.l($);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(f,i,s.buffer,0,s.byteLength))}l($){const f=this.c.get($);if(!f){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return f}}e.$1qc=a}),define(ke[303],Ie([1,0,4,38,2,6,15,9,27,50]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=void 0,T=We(T);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,a,m,$,f,i){this.a=Math.random(),this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const s=(0,h.$Bk)(f),t=typeof f=="string",o=i?.correlate,n=$(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(o&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const l of d.created){const g=A.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.b.fire(g)}if(!i?.ignoreChangeEvents)for(const l of d.changed){const g=A.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.c.fire(g)}if(!i?.ignoreDeleteEvents)for(const l of d.deleted){const g=A.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=O.$QN.from(this.i(w,m,f,i,i?.correlate),this.b,this.c,this.d,n)}i(w,a,m,$,f){const i=O.$QN.from();if(typeof m=="string"||$?.ignoreChangeEvents&&$?.ignoreCreateEvents&&$?.ignoreDeleteEvents)return i;const s=w.getProxy(R.$ON.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(h.$xk)||m.pattern.includes(h.$yk))&&(t=!0);let o;return f&&($?.ignoreChangeEvents||$?.ignoreCreateEvents||$?.ignoreDeleteEvents)&&(o=b.FileChangeFilter.UPDATED|b.FileChangeFilter.ADDED|b.FileChangeFilter.DELETED,$?.ignoreChangeEvents&&(o&=~b.FileChangeFilter.UPDATED),$?.ignoreCreateEvents&&(o&=~b.FileChangeFilter.ADDED),$?.ignoreDeleteEvents&&(o&=~b.FileChangeFilter.DELETED)),s.$watch(a.identifier.value,this.a,m.baseUri,{recursive:t,excludes:$?.excludes??[],filter:o},!!f),O.$QN.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(w){this.a=w,this.session=this.a.session,this.b=new c.$U(()=>this.a.created.map(A.URI.revive)),this.c=new c.$U(()=>this.a.changed.map(A.URI.revive)),this.d=new c.$U(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(w,a,m){this.j=w,this.k=a,this.l=m,this.a=new r.$me,this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.g=new r.$oe,this.h=new r.$oe,this.i=new r.$oe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,a,m,$){return new I(this.j,w,a,this.a.event,T.GlobPattern.from(m),$)}$onFileEvent(w){this.a.fire(new y(w))}$onDidRunFileOperation(w,a){switch(w){case b.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))}));break;case b.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map(m=>A.URI.revive(m.target))}));break;case b.FileOperation.CREATE:case b.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map(m=>A.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,a){return(m,$,f)=>{const i=function(t){m.call($,t)};return i.extension=w,a.event(i,void 0,f)}}async $onWillRunFileOperation(w,a,m,$){switch(w){case b.FileOperation.MOVE:return await this.n(this.g,{files:a.map(f=>({oldUri:A.URI.revive(f.source),newUri:A.URI.revive(f.target)}))},m,$);case b.FileOperation.DELETE:return await this.n(this.i,{files:a.map(f=>A.URI.revive(f.target))},m,$);case b.FileOperation.CREATE:case b.FileOperation.COPY:return await this.n(this.h,{files:a.map(f=>A.URI.revive(f.target))},m,$)}}async n(w,a,m,$){const f=new Set,i=[];if(await w.fireAsync(a,$,async(t,o)=>{const n=Date.now(),d=await Promise.resolve(t);d instanceof O.$3N&&(i.push([o.extension,d]),f.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-n>m&&this.k.warn("SLOW file-participant",o.extension.identifier)}),$.isCancellationRequested||i.length===0)return;const s={edits:[]};for(const[,t]of i){const{edits:o}=T.WorkspaceEdit.from(t,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(o)}return{edit:s,extensionNames:Array.from(f)}}}e.$2qc=u}),define(ke[304],Ie([1,0,18,7,20,13,133,3,24,42,12,17,2,30,196,87,143,8,23,15,9,25,118,6]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=void 0,a=We(a),i=We(i),n=We(n);class d{constructor(V,G){this.d=V,this.e=G}async provideDocumentSymbols(V,G){const J=this.d.getDocument(V),x=await this.e.provideDocumentSymbols(J,G);if(!(0,r.$Kb)(x))return x[0]instanceof s.$aO?x.map(i.DocumentSymbol.from):d.f(x)}static f(V){V=V.slice(0).sort((x,de)=>{let Ee=x.location.range.start.compareTo(de.location.range.start);return Ee===0&&(Ee=de.location.range.end.compareTo(x.location.range.end)),Ee});const G=[],J=[];for(const x of V){const de={name:x.name||"!!MISSING: name!!",kind:i.SymbolKind.from(x.kind),tags:x.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:i.Range.from(x.location.range),selectionRange:i.Range.from(x.location.range),children:[]};for(;;){if(J.length===0){J.push(de),G.push(de);break}const Ee=J[J.length-1];if(C.$Pt.containsRange(Ee.range,de.range)&&!C.$Pt.equalsRange(Ee.range,de.range)){Ee.children?.push(de),J.push(de);break}J.pop()}}return G}}class l{constructor(V,G,J,x,de,Ee){this.f=V,this.g=G,this.h=J,this.j=x,this.k=de,this.l=Ee,this.d=new o.$Cpc("CodeLens"),this.e=new Map}async provideCodeLenses(V,G){const J=this.f.getDocument(V),x=await this.h.provideCodeLenses(J,G);if(!x||G.isCancellationRequested)return;const de=this.d.add(x),Ee=new O.$Uc;this.e.set(de,Ee);const Le={cacheId:de,lenses:[]};for(let He=0;He<x.length;He++)Le.lenses.push({cacheId:[de,He],range:i.Range.from(x[He].range),command:this.g.toInternal(x[He].command,Ee)});return Le}async resolveCodeLens(V,G){const J=V.cacheId&&this.d.get(...V.cacheId);if(!J)return;let x;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?x=J:x=await this.h.resolveCodeLens(J,G),x||(x=J),G.isCancellationRequested)return;const de=V.cacheId&&this.e.get(V.cacheId[0]);if(de){if(!x.command){const Ee=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,Ee),this.l.error(Ee);return}return V.command=this.g.toInternal(x.command,de),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function g(Ce){return Array.isArray(Ce)?Ce.map(i.DefinitionLink.from):Ce?[i.DefinitionLink.from(Ce)]:[]}class E{constructor(V,G){this.d=V,this.e=G}async provideDefinition(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideDefinition(x,de,J);return g(Ee)}}class S{constructor(V,G){this.d=V,this.e=G}async provideDeclaration(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideDeclaration(x,de,J);return g(Ee)}}class D{constructor(V,G){this.d=V,this.e=G}async provideImplementation(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideImplementation(x,de,J);return g(Ee)}}class k{constructor(V,G){this.d=V,this.e=G}async provideTypeDefinition(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideTypeDefinition(x,de,J);return g(Ee)}}class P{static{this.f=10}constructor(V,G){this.g=V,this.h=G,this.d=0,this.e=new Map}async provideHover(V,G,J,x){const de=this.g.getDocument(V),Ee=i.Position.to(G);let Le;if(J&&J.verbosityRequest){const nt=J.verbosityRequest.previousHover.id,st=this.e.get(nt);if(!st)throw new Error(`Hover with id ${nt} not found`);const rt={verbosityDelta:J.verbosityRequest.verbosityDelta,previousHover:st};Le=await this.h.provideHover(de,Ee,x,rt)}else Le=await this.h.provideHover(de,Ee,x);if(!Le||(0,r.$Kb)(Le.contents))return;Le.range||(Le.range=de.getWordRangeAtPosition(Ee)),Le.range||(Le.range=new s.$SN(Ee,Ee));const He=i.Hover.from(Le),Ke=this.d;if(this.e.size===P.f){const nt=Math.min(...this.e.keys());this.e.delete(nt)}return this.e.set(Ke,Le),this.d+=1,{...He,id:Ke}}releaseHover(V){this.e.delete(V)}}class p{constructor(V,G){this.d=V,this.e=G}async provideEvaluatableExpression(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideEvaluatableExpression(x,de,J);if(Ee)return i.EvaluatableExpression.from(Ee)}}class v{constructor(V,G){this.d=V,this.e=G}async provideInlineValues(V,G,J,x){const de=this.d.getDocument(V),Ee=await this.e.provideInlineValues(de,i.Range.to(G),i.InlineValueContext.to(J),x);if(Array.isArray(Ee))return Ee.map(Le=>i.InlineValue.from(Le))}}class F{constructor(V,G){this.d=V,this.e=G}async provideDocumentHighlights(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideDocumentHighlights(x,de,J);if(Array.isArray(Ee))return Ee.map(i.DocumentHighlight.from)}}class N{constructor(V,G){this.d=V,this.e=G}async provideMultiDocumentHighlights(V,G,J,x){const de=this.d.getDocument(V),Ee=J.map(Ke=>this.d.getDocument(Ke)),Le=i.Position.to(G),He=await this.e.provideMultiDocumentHighlights(de,Le,Ee,x);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class L{constructor(V,G){this.d=V,this.e=G}async provideLinkedEditingRanges(V,G,J){const x=this.d.getDocument(V),de=i.Position.to(G),Ee=await this.e.provideLinkedEditingRanges(x,de,J);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,r.$Hb)(Ee.ranges.map(i.Range.from)),wordPattern:Ee.wordPattern}}}class M{constructor(V,G){this.d=V,this.e=G}async provideReferences(V,G,J,x){const de=this.d.getDocument(V),Ee=i.Position.to(G),Le=await this.e.provideReferences(de,Ee,J,x);if(Array.isArray(Le))return Le.map(i.location.from)}}class z{static{this.d=1e3}constructor(V,G,J,x,de,Ee,Le){this.g=V,this.h=G,this.j=J,this.k=x,this.l=de,this.m=Ee,this.n=Le,this.e=new o.$Cpc("CodeAction"),this.f=new Map}async provideCodeActions(V,G,J,x){const de=this.g.getDocument(V),Ee=w.$Rt.isISelection(G)?i.Selection.to(G):i.Range.to(G),Le=[];for(const rt of this.j.getDiagnostics(V))if(Ee.intersection(rt.range)&&Le.push(rt)>z.d)break;const He={diagnostics:Le,only:J.only?new s.$cO(J.only):void 0,triggerKind:i.CodeActionTriggerKind.to(J.trigger)},Ke=await this.k.provideCodeActions(de,Ee,He,x);if(!(0,r.$Lb)(Ke)||x.isCancellationRequested)return;const et=this.e.add(Ke),nt=new O.$Uc;this.f.set(et,nt);const st=[];for(let rt=0;rt<Ke.length;rt++){const at=Ke[rt];if(at)if(z.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,nt)});else{He.only&&(at.kind?He.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const gt=at.ranges??[];st.push({cacheId:[et,rt],title:at.title,command:at.command&&this.h.toInternal(at.command,nt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$iH)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$iH)(this.m,"codeActionRanges")?(0,r.$Hb)(gt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:et,actions:st}}async resolveCodeAction(V,G){const[J,x]=V,de=this.e.get(J,x);if(!de||z.o(de))return{};if(!this.k.resolveCodeAction)return{};const Ee=await this.k.resolveCodeAction(de,G)??de;let Le;Ee.edit&&(Le=i.WorkspaceEdit.from(Ee.edit,void 0));let He;if(Ee.command){const Ke=this.f.get(J);Ke&&(He=this.h.toInternal(Ee.command,Ke))}return{edit:Le,command:He}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class j{constructor(V,G,J,x,de){this.e=V,this.f=G,this.g=J,this.h=x,this.j=de,this.d=new o.$Cpc("DocumentPasteEdit")}async prepareDocumentPaste(V,G,J,x){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(V),Ee=G.map(Ke=>i.Range.to(Ke)),Le=i.DataTransfer.toDataTransfer(J,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(de,Ee,Le,x),x.isCancellationRequested)return;const He=Array.from(Le).filter(([,Ke])=>!(Ke instanceof s.$IO));return i.DataTransfer.from(He)}async providePasteEdits(V,G,J,x,de,Ee){if(!this.g.provideDocumentPasteEdits)return[];const Le=this.f.getDocument(G),He=J.map(st=>i.Range.to(st)),Ke=i.DataTransfer.toDataTransfer(x,async st=>(await this.e.$resolvePasteFileData(this.h,V,st)).buffer),et=await this.g.provideDocumentPasteEdits(Le,He,Ke,{only:de.only?new s.$NO(de.only):void 0,triggerKind:de.triggerKind},Ee);if(!et||Ee.isCancellationRequested)return[];const nt=this.d.add(et);return et.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,$.localize)(2686,null,this.j.displayName||this.j.name),kind:st.kind,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,G){const[J,x]=V,de=this.d.get(J,x);if(!de||!this.g.resolveDocumentPasteEdit)return{};const Ee=await this.g.resolveDocumentPasteEdit(de,G)??de;return{additionalEdit:Ee.additionalEdit?i.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class q{constructor(V,G){this.d=V,this.e=G}async provideDocumentFormattingEdits(V,G,J){const x=this.d.getDocument(V),de=await this.e.provideDocumentFormattingEdits(x,G,J);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class B{constructor(V,G){this.d=V,this.e=G}async provideDocumentRangeFormattingEdits(V,G,J,x){const de=this.d.getDocument(V),Ee=i.Range.to(G),Le=await this.e.provideDocumentRangeFormattingEdits(de,Ee,J,x);if(Array.isArray(Le))return Le.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,G,J,x){(0,y.$pg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(V),Ee=G.map(i.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(de,Ee,J,x);if(Array.isArray(Le))return Le.map(i.TextEdit.from)}}class ee{constructor(V,G){this.d=V,this.e=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,G,J,x,de){const Ee=this.d.getDocument(V),Le=i.Position.to(G),He=await this.e.provideOnTypeFormattingEdits(Ee,Le,J,x,de);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class H{constructor(V,G){this.e=V,this.f=G,this.d=new o.$Cpc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,G){const J=await this.e.provideWorkspaceSymbols(V,G);if(!(0,r.$Lb)(J))return{symbols:[]};const x=this.d.add(J),de={cacheId:x,symbols:[]};for(let Ee=0;Ee<J.length;Ee++){const Le=J[Ee];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}de.symbols.push({...i.WorkspaceSymbol.from(Le),cacheId:[x,Ee]})}return de}async resolveWorkspaceSymbol(V,G){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const J=this.d.get(...V.cacheId);if(J){const x=await this.e.resolveWorkspaceSymbol(J,G);return x&&(0,b.$io)(V,i.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class W{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,G,J){this.d=V,this.e=G,this.f=J}async provideRenameEdits(V,G,J,x){const de=this.d.getDocument(V),Ee=i.Position.to(G);try{const Le=await this.e.provideRenameEdits(de,Ee,J,x);return Le?i.WorkspaceEdit.from(Le):void 0}catch(Le){const He=W.g(Le);return He?{rejectReason:He,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(V,G,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(V),de=i.Position.to(G);try{const Ee=await this.e.prepareRename(x,de,J);let Le,He;if(s.$SN.isRange(Ee)?(Le=Ee,He=x.getText(Ee)):(0,y.$hg)(Ee)&&(Le=Ee.range,He=Ee.placeholder),!Le||!He)return;if(Le.start.line>de.line||Le.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Le),text:He}}catch(Ee){const Le=W.g(Ee);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(Ee)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class X{static{this.d={[a.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(V,G,J){this.e=V,this.f=G,this.g=J}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(V,G,J,x){const de=this.e.getDocument(V),Ee=i.Range.to(G);try{const Le=X.d[J],He=await this.f.provideNewSymbolNames(de,Ee,Le,x);return He?He.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Le){this.g.error(X.h(Le)??JSON.stringify(Le,null,"	"));return}}static h(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class _{constructor(V,G){this.resultId=V,this.tokens=G}}class ce{constructor(V,G){this.f=V,this.g=G,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,G,J){const x=this.f.getDocument(V),de=G!==0?this.d.get(G):null;let Ee=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,de.resultId,J):await this.g.provideDocumentSemanticTokens(x,J);return de&&this.d.delete(G),Ee?(Ee=ce.h(Ee),this.o(ce.n(de,Ee),Ee)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return ce.j(V)?ce.k(V)?V:new s.$bP(new Uint32Array(V.data),V.resultId):ce.l(V)?ce.m(V)?V:new s.$dP(V.edits.map(G=>new s.$cP(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const G of V.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static n(V,G){if(!ce.j(G)||!V||!V.tokens)return G;const J=V.tokens,x=J.length,de=G.data,Ee=de.length;let Le=0;const He=Math.min(x,Ee);for(;Le<He&&J[Le]===de[Le];)Le++;if(Le===x&&Le===Ee)return new s.$dP([],G.resultId);let Ke=0;const et=He-Le;for(;Ke<et&&J[x-Ke-1]===de[Ee-Ke-1];)Ke++;return new s.$dP([{start:Le,deleteCount:x-Le-Ke,data:de.subarray(Le,Ee-Ke)}],G.resultId)}o(V,G){if(ce.j(V)){const J=this.e++;return this.d.set(J,new _(V.resultId,V.data)),(0,m.$2db)({id:J,type:"full",data:V.data})}if(ce.l(V)){const J=this.e++;return ce.j(G)?this.d.set(J,new _(G.resultId,G.data)):this.d.set(J,new _(V.resultId)),(0,m.$2db)({id:J,type:"delta",deltas:(V.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ne{constructor(V,G){this.d=V,this.e=G}async provideDocumentRangeSemanticTokens(V,G,J){const x=this.d.getDocument(V),de=await this.e.provideDocumentRangeSemanticTokens(x,i.Range.to(G),J);return de?this.f(de):null}f(V){return(0,m.$2db)({id:0,type:"full",data:V.data})}}class ye{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,G,J,x,de){this.f=V,this.g=G,this.h=J,this.j=x,this.k=de,this.d=new o.$Cpc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,G,J,x){const de=this.f.getDocument(V),Ee=i.Position.to(G),Le=de.getWordRangeAtPosition(Ee)||new s.$SN(Ee,Ee),He=Le.with({end:Ee}),Ke=new c.$ge,et=await this.h.provideCompletionItems(de,Ee,x,i.CompletionContext.to(J));if(!et||x.isCancellationRequested)return;const nt=Array.isArray(et)?new s.$pO(et):et,st=ye.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),rt=new O.$Uc;this.e.set(st,rt);const at=[],gt={x:st,[n.ISuggestResultDtoField.completions]:at,[n.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Le),insert:i.Range.from(He)},[n.ISuggestResultDtoField.isIncomplete]:nt.isIncomplete||void 0,[n.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let dt=0;dt<nt.items.length;dt++){const ct=nt.items[dt],Pe=this.l(ct,[st,dt],He,Le);at.push(Pe)}return gt}async resolveCompletionItem(V,G){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...V);if(!J)return;const x=this.l(J,V),de=await this.h.resolveCompletionItem(J,G);if(!de)return;const Ee=this.l(de,V);return(x[n.ISuggestDataDtoField.insertText]!==Ee[n.ISuggestDataDtoField.insertText]||x[n.ISuggestDataDtoField.insertTextRules]!==Ee[n.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[n.ISuggestDataDtoField.commandIdent]!==Ee[n.ISuggestDataDtoField.commandIdent]||x[n.ISuggestDataDtoField.commandId]!==Ee[n.ISuggestDataDtoField.commandId]||!(0,b.$jo)(x[n.ISuggestDataDtoField.commandArguments],Ee[n.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[n.ISuggestDataDtoField.documentation]:Ee[n.ISuggestDataDtoField.documentation],[n.ISuggestDataDtoField.detail]:Ee[n.ISuggestDataDtoField.detail],[n.ISuggestDataDtoField.additionalTextEdits]:Ee[n.ISuggestDataDtoField.additionalTextEdits],[n.ISuggestDataDtoField.insertText]:Ee[n.ISuggestDataDtoField.insertText],[n.ISuggestDataDtoField.insertTextRules]:Ee[n.ISuggestDataDtoField.insertTextRules],[n.ISuggestDataDtoField.commandIdent]:Ee[n.ISuggestDataDtoField.commandIdent],[n.ISuggestDataDtoField.commandId]:Ee[n.ISuggestDataDtoField.commandId],[n.ISuggestDataDtoField.commandArguments]:Ee[n.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,G,J,x){const de=this.e.get(G[0]);if(!de)throw Error("DisposableStore is missing...");const Ee=this.g.toInternal(V.command,de),Le={x:G,[n.ISuggestDataDtoField.label]:V.label,[n.ISuggestDataDtoField.kind]:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,[n.ISuggestDataDtoField.kindModifier]:V.tags&&V.tags.map(i.CompletionItemTag.from),[n.ISuggestDataDtoField.detail]:V.detail,[n.ISuggestDataDtoField.documentation]:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),[n.ISuggestDataDtoField.sortText]:V.sortText!==V.label?V.sortText:void 0,[n.ISuggestDataDtoField.filterText]:V.filterText!==V.label?V.filterText:void 0,[n.ISuggestDataDtoField.preselect]:V.preselect||void 0,[n.ISuggestDataDtoField.insertTextRules]:V.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[n.ISuggestDataDtoField.commitCharacters]:V.commitCharacters?.join(""),[n.ISuggestDataDtoField.additionalTextEdits]:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),[n.ISuggestDataDtoField.commandIdent]:Ee?.$ident,[n.ISuggestDataDtoField.commandId]:Ee?.id,[n.ISuggestDataDtoField.commandArguments]:Ee?.$ident?void 0:Ee?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le[n.ISuggestDataDtoField.insertText]=V.textEdit.newText):typeof V.insertText=="string"?Le[n.ISuggestDataDtoField.insertText]=V.insertText:V.insertText instanceof s.$4N&&(Le[n.ISuggestDataDtoField.insertText]=V.insertText.value,Le[n.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let He;return V.textEdit?He=V.textEdit.range:V.range&&(He=V.range),s.$SN.isRange(He)?Le[n.ISuggestDataDtoField.range]=i.Range.from(He):He&&(!J?.isEqual(He.inserting)||!x?.isEqual(He.replacing))&&(Le[n.ISuggestDataDtoField.range]={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Le}}class ge{async provideInlineCompletions(V,G,J,x){}async provideInlineEdits(V,G,J,x){}disposeCompletions(V){}handleDidShowCompletionItem(V,G,J){}handlePartialAccept(V,G,J,x){}}class Y extends ge{constructor(V,G,J,x){super(),this.f=V,this.g=G,this.h=J,this.j=x,this.d=new oe,this.e=(0,t.$iH)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$iH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,G,J,x){const de=this.g.getDocument(V),Ee=i.Position.to(G),Le=await this.h.provideInlineCompletionItems(de,Ee,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},x);if(!Le||x.isCancellationRequested)return;const He=Array.isArray(Le)?Le:Le.items,Ke=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],et=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,at)=>{let gt;rt.command&&(nt||(nt=new O.$Uc),gt=this.j.toInternal(rt.command,nt));const dt=rt.insertText;return{insertText:typeof dt=="string"?dt:{snippet:dt.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:gt,idx:at,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ke.map(rt=>(nt||(nt=new O.$Uc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:et}}async provideInlineEdits(V,G,J,x){if(!this.h.provideInlineEdits)return;(0,t.$jH)(this.f,"inlineCompletionsAdditions");const de=this.g.getDocument(V),Ee=i.Range.to(G),Le=await this.h.provideInlineEdits(de,Ee,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind],userPrompt:J.userPrompt},x);if(!Le||x.isCancellationRequested)return;const He=Array.isArray(Le)?Le:Le.items,Ke=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],et=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,at)=>{let gt;rt.command&&(nt||(nt=new O.$Uc),gt=this.j.toInternal(rt.command,nt));const dt=rt.insertText;return{insertText:typeof dt=="string"?dt:{snippet:dt.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:gt,idx:at,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ke.map(rt=>(nt||(nt=new O.$Uc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,G,J){const x=this.d.get(V)?.items[G];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,J)}handlePartialAccept(V,G,J,x){const de=this.d.get(V)?.items[G];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,J),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(x)))}}class U{async provideInlineEdits(V,G,J){const x=this.f.getDocument(V),de=await this.g.provideInlineEdit(x,{triggerKind:this.e[G.triggerKind]},J);if(!de||J.isCancellationRequested)return;let Ee;const Le=this.d.createReferenceId({dispose(){Ee?.dispose()},item:de});let He;de.accepted&&(Ee||(Ee=new O.$Uc),He=this.h.toInternal(de.accepted,Ee));let Ke;return de.rejected&&(Ee||(Ee=new O.$Uc),Ke=this.h.toInternal(de.rejected,Ee)),{pid:Le,text:de.text,range:i.Range.from(de.range),accepted:He,rejected:Ke}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,G,J,x){this.f=G,this.g=J,this.h=x,this.d=new oe,this.e={[a.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class oe{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const G=this.e++;return this.d.set(G,V),G}disposeReferenceId(V){const G=this.d.get(V);return this.d.delete(V),G}get(V){return this.d.get(V)}}class ve{constructor(V,G){this.e=V,this.f=G,this.d=new o.$Cpc("SignatureHelp")}async provideSignatureHelp(V,G,J,x){const de=this.e.getDocument(V),Ee=i.Position.to(G),Le=this.g(J),He=await this.f.provideSignatureHelp(de,Ee,x,Le);if(He){const Ke=this.d.add([He]);return{...i.SignatureHelp.from(He),id:Ke}}}g(V){let G;if(V.activeSignatureHelp){const J=i.SignatureHelp.to(V.activeSignatureHelp),x=this.d.get(V.activeSignatureHelp.id,0);x?(G=x,G.activeSignature=J.activeSignature,G.activeParameter=J.activeParameter):G=J}return{...V,activeSignatureHelp:G}}releaseSignatureHelp(V){this.d.delete(V)}}class te{constructor(V,G,J,x,de){this.f=V,this.g=G,this.h=J,this.j=x,this.k=de,this.d=new o.$Cpc("InlayHints"),this.e=new Map}async provideInlayHints(V,G,J){const x=this.f.getDocument(V),de=i.Range.to(G),Ee=await this.h.provideInlayHints(x,de,J);if(!Array.isArray(Ee)||Ee.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`);return}if(J.isCancellationRequested)return;const Le=this.d.add(Ee);this.e.set(Le,new O.$Uc);const He={hints:[],cacheId:Le};for(let Ke=0;Ke<Ee.length;Ke++)this.l(Ee[Ke],de)&&He.hints.push(this.m(Ee[Ke],[Le,Ke]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`),He}async resolveInlayHint(V,G){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...V);if(!J)return;const x=await this.h.resolveInlayHint(J,G);if(x&&this.l(x))return this.m(x,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,G){return V.label.length===0||Array.isArray(V.label)&&V.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(G&&!G.contains(V.position))}m(V,G){const J=this.e.get(G[0]);if(!J)throw Error("DisposableStore is missing...");const x={label:"",cacheId:G,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")x.label=V.label;else{const de=[];x.label=de;for(const Ee of V.label){if(!Ee.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Le={label:Ee.value,tooltip:i.MarkdownString.fromStrict(Ee.tooltip)};s.$5N.isLocation(Ee.location)&&(Le.location=i.location.from(Ee.location)),Ee.command&&(Le.command=this.g.toInternal(Ee.command,J)),de.push(Le)}}return x}}class ae{constructor(V,G){this.e=V,this.f=G,this.d=new o.$Cpc("DocumentLink")}async provideLinks(V,G){const J=this.e.getDocument(V),x=await this.f.provideDocumentLinks(J,G);if(!(!Array.isArray(x)||x.length===0)&&!G.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(ae.g).map(i.DocumentLink.from)};{const de=this.d.add(x),Ee={links:[],cacheId:de};for(let Le=0;Le<x.length;Le++){if(!ae.g(x[Le]))continue;const He=i.DocumentLink.from(x[Le]);He.cacheId=[de,Le],Ee.links.push(He)}return Ee}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,G){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...V);if(!J)return;const x=await this.f.resolveDocumentLink(J,G);if(!(!x||!ae.g(x)))return i.DocumentLink.from(x)}releaseLinks(V){this.d.delete(V)}}class se{constructor(V,G){this.d=V,this.e=G}async provideColors(V,G){const J=this.d.getDocument(V),x=await this.e.provideDocumentColors(J,G);return Array.isArray(x)?x.map(Ee=>({color:i.Color.from(Ee.color),range:i.Range.from(Ee.range)})):[]}async provideColorPresentations(V,G,J){const x=this.d.getDocument(V),de=i.Range.to(G.range),Ee=i.Color.to(G.color),Le=await this.e.provideColorPresentations(Ee,{document:x,range:de},J);if(Array.isArray(Le))return Le.map(i.ColorPresentation.from)}}class Z{constructor(V,G){this.d=V,this.e=G}async provideFoldingRanges(V,G,J){const x=this.d.getDocument(V),de=await this.e.provideFoldingRanges(x,G,J);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class re{constructor(V,G,J){this.d=V,this.e=G,this.f=J}async provideSelectionRanges(V,G,J){const x=this.d.getDocument(V),de=G.map(i.Position.to),Ee=await this.e.provideSelectionRanges(x,de,J);if(!(0,r.$Lb)(Ee))return[];if(Ee.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let He=0;He<de.length;He++){const Ke=[];Le.push(Ke);let et=de[He],nt=Ee[He];for(;;){if(!nt.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(nt)),!nt.parent)break;et=nt.range,nt=nt.parent}}return Le}}class pe{constructor(V,G){this.f=V,this.g=G,this.d=new T.$tQ(""),this.e=new Map}async prepareSession(V,G,J){const x=this.f.getDocument(V),de=i.Position.to(G),Ee=await this.g.prepareCallHierarchy(x,de,J);if(!Ee)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(Ee)?Ee.map(He=>this.h(Le,He)):[this.h(Le,Ee)]}async provideCallsTo(V,G,J){const x=this.j(V,G);if(!x)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(x,J);if(de)return de.map(Ee=>({from:this.h(V,Ee.from),fromRanges:Ee.fromRanges.map(Le=>i.Range.from(Le))}))}async provideCallsFrom(V,G,J){const x=this.j(V,G);if(!x)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(x,J);if(de)return de.map(Ee=>({to:this.h(V,Ee.to),fromRanges:Ee.fromRanges.map(Le=>i.Range.from(Le))}))}releaseSession(V){this.e.delete(V)}h(V,G){const J=this.e.get(V),x=i.CallHierarchyItem.from(G,V,J.size.toString(36));return J.set(x._itemId,G),x}j(V,G){return this.e.get(V)?.get(G)}}class we{constructor(V,G){this.f=V,this.g=G,this.d=new T.$tQ(""),this.e=new Map}async prepareSession(V,G,J){const x=this.f.getDocument(V),de=i.Position.to(G),Ee=await this.g.prepareTypeHierarchy(x,de,J);if(!Ee)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(Ee)?Ee.map(He=>this.h(Le,He)):[this.h(Le,Ee)]}async provideSupertypes(V,G,J){const x=this.j(V,G);if(!x)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(x,J);if(de)return de.map(Ee=>this.h(V,Ee))}async provideSubtypes(V,G,J){const x=this.j(V,G);if(!x)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(x,J);if(de)return de.map(Ee=>this.h(V,Ee))}releaseSession(V){this.e.delete(V)}h(V,G){const J=this.e.get(V),x=i.TypeHierarchyItem.from(G,V,J.size.toString(36));return J.set(x._itemId,G),x}j(V,G){return this.e.get(V)?.get(G)}}class Fe{constructor(V,G,J,x,de){this.e=V,this.f=G,this.g=J,this.h=x,this.j=de,this.d=new o.$Cpc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,G,J,x,de){const Ee=this.f.getDocument(G),Le=i.Position.to(J),He=i.DataTransfer.toDataTransfer(x,async st=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,st)).buffer),Ke=await this.g.provideDocumentDropEdits(Ee,Le,He,de);if(!Ke)return;const et=(0,r.$2b)(Ke),nt=this.d.add(et);return et.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,$.localize)(2687,null,this.j.displayName||this.j.name),kind:st.kind?.value,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,G){const[J,x]=V,de=this.d.get(J,x);if(!de||!this.g.resolveDocumentDropEdit)return{};const Ee=await this.g.resolveDocumentDropEdit(de,G)??de;return{additionalEdit:Ee.additionalEdit?i.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class ze{constructor(V,G){this.d=V,this.e=G}async provideMappedEdits(V,G,J,x){const de=u.URI.revive(V),Ee=this.d.getDocument(de),Le=J.documents.map(et=>et.map(nt=>({uri:u.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(st=>i.Range.to(st))}))),He={documents:Le,selections:Le[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(Ee,G,He,x);return Ke?i.WorkspaceEdit.from(Ke):null}}class Re{constructor(V,G){this.adapter=V,this.extension=G}}class De{static{this.d=0}constructor(V,G,J,x,de,Ee,Le,He){this.g=G,this.h=J,this.j=x,this.k=de,this.l=Ee,this.m=Le,this.n=He,this.f=new Map,this.e=V.getProxy(n.$ON.MainThreadLanguageFeatures)}o(V,G){return i.DocumentSelector.from(V,this.g,G)}p(V){return new s.$QN(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return De.d++}async s(V,G,J,x,de,Ee=!1){const Le=this.f.get(V);if(!Le||!(Le.adapter instanceof G))return x;const He=Date.now();Ee||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ke=J(Le.adapter,Le.extension);return Promise.resolve(Ke).catch(et=>{(0,R.$4)(et)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(Le.extension.identifier,et))}).finally(()=>{Ee||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),A.CancellationToken.isCancellationToken(de)?(0,h.$vh)(Ke,de):Ke}t(V,G){const J=this.q();return this.f.set(J,new Re(V,G)),J}static u(V){return V.displayName||V.name}static w(V){return V.identifier.value}registerDocumentSymbolProvider(V,G,J,x){const de=this.t(new d(this.h,J),V),Ee=x&&x.label||De.u(V);return this.e.$registerDocumentSymbolProvider(de,this.o(G,V),Ee),this.p(de)}$provideDocumentSymbols(V,G,J){return this.s(V,d,x=>x.provideDocumentSymbols(u.URI.revive(G),J),void 0,J)}registerCodeLensProvider(V,G,J){const x=this.q(),de=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new Re(new l(this.h,this.j.converter,J,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(x,this.o(G,V),de);let Ee=this.p(x);if(de!==void 0){const Le=J.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(de));Ee=s.$QN.from(Ee,Le)}return Ee}$provideCodeLenses(V,G,J){return this.s(V,l,x=>x.provideCodeLenses(u.URI.revive(G),J),void 0,J)}$resolveCodeLens(V,G,J){return this.s(V,l,x=>x.resolveCodeLens(G,J),void 0,void 0)}$releaseCodeLenses(V,G){this.s(V,l,J=>Promise.resolve(J.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(V,G,J){const x=this.t(new E(this.h,J),V);return this.e.$registerDefinitionSupport(x,this.o(G,V)),this.p(x)}$provideDefinition(V,G,J,x){return this.s(V,E,de=>de.provideDefinition(u.URI.revive(G),J,x),[],x)}registerDeclarationProvider(V,G,J){const x=this.t(new S(this.h,J),V);return this.e.$registerDeclarationSupport(x,this.o(G,V)),this.p(x)}$provideDeclaration(V,G,J,x){return this.s(V,S,de=>de.provideDeclaration(u.URI.revive(G),J,x),[],x)}registerImplementationProvider(V,G,J){const x=this.t(new D(this.h,J),V);return this.e.$registerImplementationSupport(x,this.o(G,V)),this.p(x)}$provideImplementation(V,G,J,x){return this.s(V,D,de=>de.provideImplementation(u.URI.revive(G),J,x),[],x)}registerTypeDefinitionProvider(V,G,J){const x=this.t(new k(this.h,J),V);return this.e.$registerTypeDefinitionSupport(x,this.o(G,V)),this.p(x)}$provideTypeDefinition(V,G,J,x){return this.s(V,k,de=>de.provideTypeDefinition(u.URI.revive(G),J,x),[],x)}registerHoverProvider(V,G,J,x){const de=this.t(new P(this.h,J),V);return this.e.$registerHoverProvider(de,this.o(G,V)),this.p(de)}$provideHover(V,G,J,x,de){return this.s(V,P,Ee=>Ee.provideHover(u.URI.revive(G),J,x,de),void 0,de)}$releaseHover(V,G){this.s(V,P,J=>Promise.resolve(J.releaseHover(G)),void 0,void 0)}registerEvaluatableExpressionProvider(V,G,J,x){const de=this.t(new p(this.h,J),V);return this.e.$registerEvaluatableExpressionProvider(de,this.o(G,V)),this.p(de)}$provideEvaluatableExpression(V,G,J,x){return this.s(V,p,de=>de.provideEvaluatableExpression(u.URI.revive(G),J,x),void 0,x)}registerInlineValuesProvider(V,G,J,x){const de=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,Ee=this.t(new v(this.h,J),V);this.e.$registerInlineValuesProvider(Ee,this.o(G,V),de);let Le=this.p(Ee);if(de!==void 0){const He=J.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(de));Le=s.$QN.from(Le,He)}return Le}$provideInlineValues(V,G,J,x,de){return this.s(V,v,Ee=>Ee.provideInlineValues(u.URI.revive(G),J,x,de),void 0,de)}registerDocumentHighlightProvider(V,G,J){const x=this.t(new F(this.h,J),V);return this.e.$registerDocumentHighlightProvider(x,this.o(G,V)),this.p(x)}registerMultiDocumentHighlightProvider(V,G,J){const x=this.t(new N(this.h,J),V);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(G,V)),this.p(x)}$provideDocumentHighlights(V,G,J,x){return this.s(V,F,de=>de.provideDocumentHighlights(u.URI.revive(G),J,x),void 0,x)}$provideMultiDocumentHighlights(V,G,J,x,de){return this.s(V,N,Ee=>Ee.provideMultiDocumentHighlights(u.URI.revive(G),J,x.map(Le=>u.URI.revive(Le)),de),void 0,de)}registerLinkedEditingRangeProvider(V,G,J){const x=this.t(new L(this.h,J),V);return this.e.$registerLinkedEditingRangeProvider(x,this.o(G,V)),this.p(x)}$provideLinkedEditingRanges(V,G,J,x){return this.s(V,L,async de=>{const Ee=await de.provideLinkedEditingRanges(u.URI.revive(G),J,x);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?De.y(Ee.wordPattern):void 0}},void 0,x)}registerReferenceProvider(V,G,J){const x=this.t(new M(this.h,J),V);return this.e.$registerReferenceSupport(x,this.o(G,V)),this.p(x)}$provideReferences(V,G,J,x,de){return this.s(V,M,Ee=>Ee.provideReferences(u.URI.revive(G),J,x,de),void 0,de)}registerCodeActionProvider(V,G,J,x){const de=new O.$Uc,Ee=this.t(new z(this.h,this.j.converter,this.k,J,this.l,V,this.m),V);return this.e.$registerCodeActionSupport(Ee,this.o(G,V),{providedKinds:x?.providedCodeActionKinds?.map(Le=>Le.value),documentation:x?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,de)}))},De.u(V),De.w(V),!!J.resolveCodeAction),de.add(this.p(Ee)),de}$provideCodeActions(V,G,J,x,de){return this.s(V,z,Ee=>Ee.provideCodeActions(u.URI.revive(G),J,x,de),void 0,de)}$resolveCodeAction(V,G,J){return this.s(V,z,x=>x.resolveCodeAction(G,J),{},void 0)}$releaseCodeActions(V,G){this.s(V,z,J=>Promise.resolve(J.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(V,G,J){const x=this.t(new q(this.h,J),V);return this.e.$registerDocumentFormattingSupport(x,this.o(G,V),V.identifier,V.displayName||V.name),this.p(x)}$provideDocumentFormattingEdits(V,G,J,x){return this.s(V,q,de=>de.provideDocumentFormattingEdits(u.URI.revive(G),J,x),void 0,x)}registerDocumentRangeFormattingEditProvider(V,G,J){const x=typeof J.provideDocumentRangesFormattingEdits=="function",de=this.t(new B(this.h,J),V);return this.e.$registerRangeFormattingSupport(de,this.o(G,V),V.identifier,V.displayName||V.name,x),this.p(de)}$provideDocumentRangeFormattingEdits(V,G,J,x,de){return this.s(V,B,Ee=>Ee.provideDocumentRangeFormattingEdits(u.URI.revive(G),J,x,de),void 0,de)}$provideDocumentRangesFormattingEdits(V,G,J,x,de){return this.s(V,B,Ee=>Ee.provideDocumentRangesFormattingEdits(u.URI.revive(G),J,x,de),void 0,de)}registerOnTypeFormattingEditProvider(V,G,J,x){const de=this.t(new ee(this.h,J),V);return this.e.$registerOnTypeFormattingSupport(de,this.o(G,V),x,V.identifier),this.p(de)}$provideOnTypeFormattingEdits(V,G,J,x,de,Ee){return this.s(V,ee,Le=>Le.provideOnTypeFormattingEdits(u.URI.revive(G),J,x,de,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(V,G){const J=this.t(new H(G,this.l),V);return this.e.$registerNavigateTypeSupport(J,typeof G.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(V,G,J){return this.s(V,H,x=>x.provideWorkspaceSymbols(G,J),{symbols:[]},J)}$resolveWorkspaceSymbol(V,G,J){return this.s(V,H,x=>x.resolveWorkspaceSymbol(G,J),void 0,void 0)}$releaseWorkspaceSymbols(V,G){this.s(V,H,J=>J.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(V,G,J){const x=this.t(new W(this.h,J,this.l),V);return this.e.$registerRenameSupport(x,this.o(G,V),W.supportsResolving(J)),this.p(x)}$provideRenameEdits(V,G,J,x,de){return this.s(V,W,Ee=>Ee.provideRenameEdits(u.URI.revive(G),J,x,de),void 0,de)}$resolveRenameLocation(V,G,J,x){return this.s(V,W,de=>de.resolveRenameLocation(u.URI.revive(G),J,x),void 0,x)}registerNewSymbolNamesProvider(V,G,J){const x=this.t(new X(this.h,J,this.l),V);return this.e.$registerNewSymbolNamesProvider(x,this.o(G,V)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(V){return this.s(V,X,G=>G.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(V,G,J,x,de){return this.s(V,X,Ee=>Ee.provideNewSymbolNames(u.URI.revive(G),J,x,de),void 0,de)}registerDocumentSemanticTokensProvider(V,G,J,x){const de=this.t(new ce(this.h,J),V),Ee=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(G,V),x,Ee);let Le=this.p(de);if(Ee){const He=J.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(Ee));Le=s.$QN.from(Le,He)}return Le}$provideDocumentSemanticTokens(V,G,J,x){return this.s(V,ce,de=>de.provideDocumentSemanticTokens(u.URI.revive(G),J,x),null,x)}$releaseDocumentSemanticTokens(V,G){this.s(V,ce,J=>J.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,G,J,x){const de=this.t(new ne(this.h,J),V);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(G,V),x),this.p(de)}$provideDocumentRangeSemanticTokens(V,G,J,x){return this.s(V,ne,de=>de.provideDocumentRangeSemanticTokens(u.URI.revive(G),J,x),null,x)}registerCompletionItemProvider(V,G,J,x){const de=this.t(new ye(this.h,this.j.converter,J,this.m,V),V);return this.e.$registerCompletionsProvider(de,this.o(G,V),x,ye.supportsResolving(J),V.identifier),this.p(de)}$provideCompletionItems(V,G,J,x,de){return this.s(V,ye,Ee=>Ee.provideCompletionItems(u.URI.revive(G),J,x,de),void 0,de)}$resolveCompletionItem(V,G,J){return this.s(V,ye,x=>x.resolveCompletionItem(G,J),void 0,J)}$releaseCompletionItems(V,G){this.s(V,ye,J=>J.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(V,G,J,x){const de=new Y(V,this.h,J,this.j.converter),Ee=this.t(de,V);return this.e.$registerInlineCompletionsSupport(Ee,this.o(G,V),de.supportsHandleEvents,f.$sn.toKey(V.identifier.value),x?.yieldTo?.map(Le=>f.$sn.toKey(Le))||[]),this.p(Ee)}$provideInlineCompletions(V,G,J,x,de){return this.s(V,ge,Ee=>Ee.provideInlineCompletions(u.URI.revive(G),J,x,de),void 0,de)}$provideInlineEdits(V,G,J,x,de){return this.s(V,ge,Ee=>Ee.provideInlineEdits(u.URI.revive(G),J,x,de),void 0,de)}$handleInlineCompletionDidShow(V,G,J,x){this.s(V,ge,async de=>{de.handleDidShowCompletionItem(G,J,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,G,J,x,de){this.s(V,ge,async Ee=>{Ee.handlePartialAccept(G,J,x,de)},void 0,void 0)}$freeInlineCompletionsList(V,G){this.s(V,ge,async J=>{J.disposeCompletions(G)},void 0,void 0)}registerInlineEditProvider(V,G,J){const x=new U(V,this.h,J,this.j.converter),de=this.t(x,V);return this.e.$registerInlineEditProvider(de,this.o(G,V),V.identifier),this.p(de)}$provideInlineEdit(V,G,J,x){return this.s(V,U,de=>de.provideInlineEdits(u.URI.revive(G),J,x),void 0,x)}$freeInlineEdit(V,G){this.s(V,U,async J=>{J.disposeEdit(G)},void 0,void 0)}registerSignatureHelpProvider(V,G,J,x){const de=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,Ee=this.t(new ve(this.h,J),V);return this.e.$registerSignatureHelpProvider(Ee,this.o(G,V),de),this.p(Ee)}$provideSignatureHelp(V,G,J,x,de){return this.s(V,ve,Ee=>Ee.provideSignatureHelp(u.URI.revive(G),J,x,de),void 0,de)}$releaseSignatureHelp(V,G){this.s(V,ve,J=>J.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(V,G,J){const x=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new te(this.h,this.j.converter,J,this.l,V),V);this.e.$registerInlayHintsProvider(de,this.o(G,V),typeof J.resolveInlayHint=="function",x,De.u(V));let Ee=this.p(de);if(x!==void 0){const Le=J.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(x));Ee=s.$QN.from(Ee,Le)}return Ee}$provideInlayHints(V,G,J,x){return this.s(V,te,de=>de.provideInlayHints(u.URI.revive(G),J,x),void 0,x)}$resolveInlayHint(V,G,J){return this.s(V,te,x=>x.resolveInlayHint(G,J),void 0,J)}$releaseInlayHints(V,G){this.s(V,te,J=>J.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(V,G,J){const x=this.t(new ae(this.h,J),V);return this.e.$registerDocumentLinkProvider(x,this.o(G,V),typeof J.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(V,G,J){return this.s(V,ae,x=>x.provideLinks(u.URI.revive(G),J),void 0,J,G.scheme==="output")}$resolveDocumentLink(V,G,J){return this.s(V,ae,x=>x.resolveLink(G,J),void 0,void 0,!0)}$releaseDocumentLinks(V,G){this.s(V,ae,J=>J.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(V,G,J){const x=this.t(new se(this.h,J),V);return this.e.$registerDocumentColorProvider(x,this.o(G,V)),this.p(x)}$provideDocumentColors(V,G,J){return this.s(V,se,x=>x.provideColors(u.URI.revive(G),J),[],J)}$provideColorPresentations(V,G,J,x){return this.s(V,se,de=>de.provideColorPresentations(u.URI.revive(G),J,x),void 0,x)}registerFoldingRangeProvider(V,G,J){const x=this.q(),de=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new Re(new Z(this.h,J),V)),this.e.$registerFoldingRangeProvider(x,this.o(G,V),V.identifier,de);let Ee=this.p(x);if(de!==void 0){const Le=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));Ee=s.$QN.from(Ee,Le)}return Ee}$provideFoldingRanges(V,G,J,x){return this.s(V,Z,de=>de.provideFoldingRanges(u.URI.revive(G),J,x),void 0,x)}registerSelectionRangeProvider(V,G,J){const x=this.t(new re(this.h,J,this.l),V);return this.e.$registerSelectionRangeProvider(x,this.o(G,V)),this.p(x)}$provideSelectionRanges(V,G,J,x){return this.s(V,re,de=>de.provideSelectionRanges(u.URI.revive(G),J,x),[],x)}registerCallHierarchyProvider(V,G,J){const x=this.t(new pe(this.h,J),V);return this.e.$registerCallHierarchyProvider(x,this.o(G,V)),this.p(x)}$prepareCallHierarchy(V,G,J,x){return this.s(V,pe,de=>Promise.resolve(de.prepareSession(u.URI.revive(G),J,x)),void 0,x)}$provideCallHierarchyIncomingCalls(V,G,J,x){return this.s(V,pe,de=>de.provideCallsTo(G,J,x),void 0,x)}$provideCallHierarchyOutgoingCalls(V,G,J,x){return this.s(V,pe,de=>de.provideCallsFrom(G,J,x),void 0,x)}$releaseCallHierarchy(V,G){this.s(V,pe,J=>Promise.resolve(J.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(V,G,J){const x=this.t(new we(this.h,J),V);return this.e.$registerTypeHierarchyProvider(x,this.o(G,V)),this.p(x)}$prepareTypeHierarchy(V,G,J,x){return this.s(V,we,de=>Promise.resolve(de.prepareSession(u.URI.revive(G),J,x)),void 0,x)}$provideTypeHierarchySupertypes(V,G,J,x){return this.s(V,we,de=>de.provideSupertypes(G,J,x),void 0,x)}$provideTypeHierarchySubtypes(V,G,J,x){return this.s(V,we,de=>de.provideSubtypes(G,J,x),void 0,x)}$releaseTypeHierarchy(V,G){this.s(V,we,J=>Promise.resolve(J.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(V,G,J,x){const de=this.q();return this.f.set(de,new Re(new Fe(this.e,this.h,J,de,V),V)),this.e.$registerDocumentOnDropEditProvider(de,this.o(G,V),(0,t.$iH)(V,"documentPaste")&&x?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(V,G,J,x,de,Ee){return this.s(V,Fe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(G,u.URI.revive(J),x,de,Ee)),void 0,void 0)}$resolveDropEdit(V,G,J){return this.s(V,Fe,x=>x.resolveDropEdit(G,J),{},void 0)}$releaseDocumentOnDropEdits(V,G){this.s(V,Fe,J=>Promise.resolve(J.releaseDropEdits(G)),void 0,void 0)}registerMappedEditsProvider(V,G,J){const x=this.t(new ze(this.h,J),V);return this.e.$registerMappedEditsProvider(x,this.o(G,V),V.displayName??V.name),this.p(x)}$provideMappedEdits(V,G,J,x,de){return this.s(V,ze,Ee=>Promise.resolve(Ee.provideMappedEdits(G,J,x,de)),null,de)}registerDocumentPasteEditProvider(V,G,J,x){const de=this.q();return this.f.set(de,new Re(new j(this.e,this.h,J,de,V),V)),this.e.$registerPasteEditProvider(de,this.o(G,V),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(Ee=>Ee.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(V,G,J,x,de){return this.s(V,j,Ee=>Ee.prepareDocumentPaste(u.URI.revive(G),J,x,de),void 0,de)}$providePasteEdits(V,G,J,x,de,Ee,Le){return this.s(V,j,He=>He.providePasteEdits(G,u.URI.revive(J),x,de,Ee,Le),void 0,Le)}$resolvePasteEdit(V,G,J){return this.s(V,j,x=>x.resolvePasteEdit(G,J),{},void 0)}$releasePasteEdits(V,G){this.s(V,j,J=>Promise.resolve(J.releasePasteEdits(G)),void 0,void 0)}static y(V){return{pattern:V.source,flags:V.flags}}static z(V){return{decreaseIndentPattern:De.y(V.decreaseIndentPattern),increaseIndentPattern:De.y(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?De.y(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?De.y(V.unIndentedLinePattern):void 0}}static B(V){return{beforeText:De.y(V.beforeText),afterText:V.afterText?De.y(V.afterText):void 0,previousLineText:V.previousLineText?De.y(V.previousLineText):void 0,action:V.action}}static C(V){return V.map(De.B)}static D(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(G=>s.SyntaxTokenType.toString(G)):void 0}}static E(V){return V.map(De.D)}setLanguageConfiguration(V,G,J){const{wordPattern:x}=J;if(x&&(0,I.$sf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(G,x):this.h.setWordDefinitionFor(G,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const de=this.q(),Ee={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?De.y(J.wordPattern):void 0,indentationRules:J.indentationRules?De.z(J.indentationRules):void 0,onEnterRules:J.onEnterRules?De.C(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?De.E(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,G,Ee),this.p(de)}$setWordDefinitions(V){for(const G of V)this.h.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.$Mpc=De}),define(ke[305],Ie([1,0,3,44,6,15]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$erc=void 0,R=We(R);class T{constructor(b){this.a=new Map,this.c=new Map,this.b=b.getProxy(A.$ON.MainThreadLanguageModelTools),this.b.$getTools().then(c=>{for(const I of c)this.c.set(I.name,(0,h.$di)(I))})}async invokeTool(b,c,I){return await this.b.$invokeTool(b,c,I)}async $acceptToolDelta(b){b.added&&this.c.set(b.added.name,b.added),b.removed&&this.c.delete(b.removed)}get tools(){return Array.from(this.c.values()).map(b=>R.LanguageModelToolDescription.to(b))}async $invokeTool(b,c,I){const y=this.a.get(b);if(!y)throw new Error(`Unknown tool ${b}`);return await y.tool.invoke(c,I)}registerTool(b,c,I){return this.a.set(c,{extension:b,tool:I}),this.b.$registerTool(c),(0,r.$Tc)(()=>{this.a.delete(c),this.b.$unregisterTool(c)})}}e.$erc=T}),define(ke[128],Ie([1,0,7,20,52,13,4,39,3,8,23,5,11,89,6,127,19,15,9,157,25]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=e.$tqc=void 0,$=We($),f=We(f),e.$tqc=(0,y.$Gi)("IExtHostLanguageModels");class o{constructor(g,E){this.option=g,this.stream=new r.$0h,this.stream=E??new r.$0h}}class n{constructor(){this.a=new Map,this.b=new r.$0h,this.c=!1;const g=this;this.apiObject={get stream(){return g.b.asyncIterable},get text(){return r.$7h.map(g.b.asyncIterable,E=>{if(E instanceof f.$$P)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,g]of this.a)yield g.stream;else yield this.b}handleFragment(g){if(this.c)return;let E=this.a.get(g.index);E||(this.a.size===0?E=new o(g.index,this.b):E=new o(g.index),this.a.set(g.index,E));let S;g.part.type==="text"?S=new f.$$P(g.part.value):S=new f.$0P(g.part.name,g.part.parameters),E.stream.emitOne(S)}reject(g){this.c=!0;for(const E of this.d())E.reject(g)}resolve(){this.c=!0;for(const g of this.d())g.resolve()}}let d=class{static{t=this}static{this.a=1}constructor(g,E,S){this.j=E,this.k=S,this.c=new T.$me,this.d=new T.$me,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$un,this.i=new Map,this.s=new Set,this.b=g.getProxy(w.$ON.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(g,E,S,D){const k=t.a++;this.f.set(k,{extension:g.identifier,provider:S,languageModelId:E});let P;D.auth&&(P={providerLabel:g.displayName||g.name,accountLabel:typeof D.auth=="object"?D.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${I.$sn.toKey(g.identifier)}/${k}/${E}`,{extension:g.identifier,id:E,vendor:D.vendor??I.$sn.toKey(g.identifier),name:D.name??"",family:D.family??"",version:D.version,maxInputTokens:D.maxInputTokens,maxOutputTokens:D.maxOutputTokens,auth:P,targetExtensions:D.extensions});const p=S.onDidReceiveLanguageModelResponse2?.(({extensionId:v,participant:F,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new I.$sn(v),F,N)});return(0,b.$Tc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),p?.dispose()})}async $startChatRequest(g,E,S,D,k,P){const p=this.f.get(g);if(!p)throw new Error("Provider not found");const v=new C.$Bw(async N=>{if(P.isCancellationRequested){this.j.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(N.part instanceof f.$0P?L={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof f.$$P&&(L={type:"text",value:N.part.value}),!L){this.j.warn(`[CHAT](${p.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:L})});let F;if(p.provider.provideLanguageModelResponse2)F=Promise.resolve(p.provider.provideLanguageModelResponse2(D.map($.LanguageModelChatMessage.to),k,I.$sn.toKey(S),v,P));else{const N=new C.$Bw(async L=>{v.report({index:L.index,part:new f.$$P(L.part)})});F=Promise.resolve(p.provider.provideLanguageModelResponse(D.map($.LanguageModelChatMessage.to),k?.modelOptions??{},I.$sn.toKey(S),N,P))}F.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,R.$2)(N))})}$provideTokenLength(g,E,S){const D=this.f.get(g);return D?Promise.resolve(D.provider.provideTokenCount(E,S)):Promise.resolve(0)}$acceptChatModelMetadata(g){if(g.added)for(const{identifier:E,metadata:S}of g.added)this.g.set(E,{metadata:S,apiObjects:new I.$un});if(g.removed)for(const E of g.removed){this.g.delete(E);for(const[S,D]of this.i)D.languageModelId===E&&(D.res.reject(new R.$5),this.i.delete(S))}g.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(g,E){const S=await this.b.$selectChatModels({...E,extension:g.identifier}),D=[],k=this;for(const P of S){const p=this.g.get(P);if(!p)continue;this.o(g.identifier,p.metadata)&&await this.q(p.metadata);let v=p.apiObjects.get(g.identifier);v||(v={id:P,vendor:p.metadata.vendor,family:p.metadata.family,version:p.metadata.version,name:p.metadata.name,maxInputTokens:p.metadata.maxInputTokens,countTokens(F,N){if(!k.g.has(P))throw f.$cQ.NotFound(P);return k.r(P,F,N??h.CancellationToken.None)},sendRequest(F,N,L){if(!k.g.has(P))throw f.$cQ.NotFound(P);return k.l(g,P,F,N??{},L??h.CancellationToken.None)}},Object.freeze(v),p.apiObjects.set(g.identifier,v)),D.push(v)}return D}async l(g,E,S,D,k){const P=this.m(g,S),p=g.identifier,v=this.g.get(E)?.metadata;if(!v||!this.g.has(E))throw f.$cQ.NotFound(`Language model '${E}' is unknown.`);if(this.o(p,v)&&(!await this.n(g,{identifier:v.extension,displayName:v.auth.providerLabel},D.justification,!1)||!this.h.get(p)?.has(v.extension)))throw f.$cQ.NoPermissions(`Language model '${E}' cannot be used by '${p.value}'.`);try{const F=Math.random()*1e6|0,N=new n;this.i.set(F,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(p,E,F,P,D,k)}catch(L){throw this.i.delete(F),L}return N.apiObject}catch(F){throw F.name===f.$cQ.name?F:new f.$cQ(`Language model '${E}' errored: ${(0,A.$rj)(F)}`,"Unknown",F)}}m(g,E){const S=[];for(const D of E)D.role===f.LanguageModelChatMessageRole.System&&(0,s.$jH)(g,"languageModelSystem"),D.content2 instanceof f.$8P&&(0,s.$jH)(g,"lmTools"),S.push($.LanguageModelChatMessage.from(D));return S}async $acceptResponsePart(g,E){const S=this.i.get(g);S&&S.res.handleFragment(E)}async $acceptResponseDone(g,E){const S=this.i.get(g);S&&(this.i.delete(g),E?S.res.reject((0,R.$3)(E)):S.res.resolve())}async n(g,E,S,D){const k=i.$QM+E.identifier.value;if(await this.k.getSession(g,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:g.identifier,to:E.identifier,enabled:!0}]),!0;if(D)return!1;try{const p=S?(0,c.localize)(2688,null,E.displayName,S):void 0;return await this.k.getSession(g,k,[],{forceNewSession:{detail:p}}),this.$updateModelAccesslist([{from:g.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(g,E){return!!E.auth&&!I.$sn.equals(E.extension,g)}async q(g){if(g.auth)for(const E of this.s)try{await this.n(E,{identifier:g.extension,displayName:""},void 0,!0)}catch(S){this.j.error("Fake Auth request failed"),this.j.error(S)}}async r(g,E,S){if(!this.g.get(g))throw f.$cQ.NotFound(`Language model '${g}' is unknown.`);const k=O.Iterable.find(this.f.values(),P=>P.languageModelId===g);return k?k.provider.provideTokenCount(E,S):this.b.$countTokens(g,typeof E=="string"?E:$.LanguageModelChatMessage.from(E),S)}$updateModelAccesslist(g){const E=new Array;for(const{from:S,to:D,enabled:k}of g){const P=this.h.get(S)??new I.$tn;if(P.has(D)!==k){k?P.add(D):P.delete(D),this.h.set(S,P);const v={from:S,to:D};E.push(v),this.c.fire(v)}}}createLanguageModelAccessInformation(g){this.s.add(g);const E=this,S=T.Event.signal(T.Event.filter(this.c.event,k=>I.$sn.equals(k.from,g.identifier))),D=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(S,D)},canSendRequest(k){let P;e:for(const[v,F]of E.g)for(const N of F.apiObjects.values())if(N===k){P=F.metadata;break e}if(!P)return;if(!E.o(g.identifier,P))return!0;const p=E.h.get(g.identifier);if(p)return p.has(P.extension)}}}};e.$uqc=d,e.$uqc=d=t=Je([Ve(0,m.$oQ),Ve(1,u.$bk),Ve(2,a.$Opc)],d)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[306],Ie([1,0,6,15,9,43,7,3,25]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=void 0,h=We(h),R=Ut(R);class c{constructor(y,u,C,w){this.c=u,this.d=C,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(r.$ON.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const C=this.c.getDocumentData(y);if(!C)throw new Error(`document '${y.toString()}' NOT found`);return C.document}async tokenAtPosition(y,u){const C=y.version,w=h.Position.from(u),a=await this.a.$tokensAtPosition(y.uri,w),m={type:A.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new A.$SN(u.line,u.character,u.line,u.character)};if(!a)return m;const $={range:h.Range.to(a.range),type:h.TokenType.to(a.type)};return!$.range.contains(u)||C!==y.version?m:$}createLanguageStatusItem(y,u,C){const w=this.f++,a=this.a,m=this.g,$=`${y.identifier.value}/${u}`;if(m.has($))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);m.add($);const f={selector:C,id:u,name:y.displayName??y.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new O.$Uc,t=()=>{if(i?.dispose(),!m.has($)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,T.$Ih)(()=>{s.clear(),this.a.$setLanguageStatus(w,{id:$,name:f.name??y.displayName??y.name,source:y.displayName??y.name,selector:h.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===A.LanguageStatusSeverity.Error?R.default.Error:f.severity===A.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:f.command&&this.d.toInternal(f.command,s),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},o={dispose(){s.dispose(),i?.dispose(),a.$removeLanguageStatus(w),m.delete($)},get id(){return f.id},get name(){return f.name},set name(n){f.name=n,t()},get selector(){return f.selector},set selector(n){f.selector=n,t()},get text(){return f.text},set text(n){f.text=n,t()},set text2(n){(0,b.$jH)(y,"languageStatusText"),f.text=n,t()},get text2(){return(0,b.$jH)(y,"languageStatusText"),f.text},get detail(){return f.detail},set detail(n){f.detail=n,t()},get severity(){return f.severity},set severity(n){f.severity=n,t()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(n){f.accessibilityInformation=n,t()},get command(){return f.command},set command(n){f.command=n,t()},get busy(){return f.busy},set busy(n){f.busy=n,t()}};return t(),o}}e.$frc=c}),define(ke[307],Ie([1,0,14,2,15,9,126]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=e.$3qc=void 0,A=We(A),T=We(T);class O{constructor(y,u,C,w){this.start=y,this.deletedCount=u,this.deletedItems=C,this.items=w}asApiEvent(){return{range:new R.$iP(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,C){this.notebook=y,this.h=u,this.j=C,this.handle=C.handle,this.uri=h.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(A.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(w){y.g=w},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(C)}return this.f}setOutputs(y){this.a=y.map(A.NotebookCellOutput.to)}setOutputItems(y,u,C){const w=C.map(A.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===y);if(a&&(u||(a.items.length=0),a.items.push(...w),a.items.length>1&&a.items.every(m=>T.$QL(m.mime)))){const m=new Map,$=[];a.items.forEach(f=>{let i;m.has(f.mime)?i=m.get(f.mime):(i=[],m.set(f.mime,i),$.push(f.mime)),i.push(f.data)}),a.items.length=0,$.forEach(f=>{const i=T.$RL(m.get(f));a.items.push({mime:f,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$3qc=b;class c{static{this.a=0}constructor(y,u,C,w,a){this.k=y,this.l=u,this.m=C,this.uri=w,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===r.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(C){return C=y.n(C),y.b[C].apiCell},getCells(C){return(C?y.p(C):y.b).map(a=>a.apiCell)},save(){return y.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,C){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:C});const w={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},a=[];for(const $ of y.rawEvents)$.kind===T.NotebookCellsChangeType.ModelChange?this.r($.changes,!1,w.contentChanges):$.kind===T.NotebookCellsChangeType.Move?this.s($.index,$.length,$.newIdx,w.contentChanges):$.kind===T.NotebookCellsChangeType.Output?(this.t($.index,$.outputs),a.push({cell:this.b[$.index].apiCell,outputs:this.b[$.index].apiCell.outputs})):$.kind===T.NotebookCellsChangeType.OutputItem?(this.u($.index,$.outputId,$.append,$.outputItems),a.push({cell:this.b[$.index].apiCell,outputs:this.b[$.index].apiCell.outputs})):$.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this.v($.index,$.language),a.push({cell:this.b[$.index].apiCell,document:this.b[$.index].apiCell.document})):$.kind===T.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[$.index].apiCell,document:this.b[$.index].apiCell.document}):$.kind===T.NotebookCellsChangeType.ChangeCellMime?this.w($.index,$.mime):$.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this.x($.index,$.metadata),a.push({cell:this.b[$.index].apiCell,metadata:this.b[$.index].apiCell.metadata})):$.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y($.index,$.internalMetadata),a.push({cell:this.b[$.index].apiCell,executionSummary:this.b[$.index].apiCell.executionSummary}));const m=new Map;for(let $=0;$<a.length;$++){const f=a[$],i=m.get(f.cell);if(i===void 0){const s=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});m.set(f.cell,s-1)}else w.cellChanges[i]={...w.cellChanges[i],...f}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,C=y.end|0;return u<0&&(u=0),C>this.b.length&&(C=this.b.length),y.with({start:u,end:C})}p(y){y=this.o(y);const u=[];for(let C=y.start;C<y.end;C++)u.push(this.b[C]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,C){if(this.j)return;const w=[],a=[],m=[];if(y.reverse().forEach($=>{const i=$[2].map(o=>{const n=new b(this,this.l,o);return u||a.push(b.asModelAddData(o)),n}),s=new O($[0],$[1],[],i),t=this.b.splice($[0],$[1],...i);for(const o of t)m.push(o.uri),s.deletedItems.push(o.apiCell);w.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),C)for(const $ of w)C.push($.asApiEvent())}s(y,u,C,w){const a=this.b.splice(y,u);this.b.splice(C,0,...a);const m=[new O(y,u,a.map($=>$.apiCell),[]),new O(C,0,[],a)];for(const $ of m)w.push($.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,C,w){this.b[y].setOutputItems(u,C,w)}v(y,u){const C=this.b[y];C.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(C.uri,u)}w(y,u){const C=this.b[y];C.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$4qc=c}),define(ke[308],Ie([1,0,4,2,15,9,53]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=void 0;class O{constructor(c,I,y,u={timeout:1500,errors:3}){this.b=c,this.c=I,this.d=y,this.f=u,this.a=new r.$oe}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(I,y,u)=>{const C=function(a){I.call(y,a)};return C.extension=c,this.a.event(C,void 0,u)}}async $participateInSave(c,I,y){const u=h.URI.revive(c),C=this.c.getNotebookDocument(u);if(!C)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:C.apiNotebook,reason:A.TextDocumentSaveReason.to(I)},y,async(m,$)=>{const f=Date.now(),i=await await Promise.resolve(m);Date.now()-f>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",$.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof R.$3N?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",$.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(w.length===0)return!0;const a={edits:[]};for(const m of w){const{edits:$}=A.WorkspaceEdit.from(m);a.edits=a.edits.concat($)}return this.d.$tryApplyWorkspaceEdit(new T.$Zw(a))}}e.$hrc=O}),define(ke[166],Ie([1,0,13,15,9]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0,h=We(h),A=We(A);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(O,b,c,I,y,u){this.id=O,this.f=b,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=I,this.c=u}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(b){this.selections=[b]},get selections(){return O.a},set selections(b){if(!Array.isArray(b)||!b.every(A.$iP.isNotebookRange))throw(0,r.$7)("selections");O.a=b,O.g(b)},get visibleRanges(){return O.b},revealRange(b,c){O.f.$tryRevealRange(O.id,h.NotebookRange.from(b),c??A.NotebookEditorRevealType.Default)},get viewColumn(){return O.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(h.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.$5qc=R}),define(ke[309],Ie([1,0,4,11,15]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0,A=We(A);let R=class{constructor(O,b){this.c=O,this.d=b,this.a=new r.$me,this.b=new r.$me,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,b);const c=this.d.getEditorById(O);b.visibleRanges&&c._acceptVisibleRanges(b.visibleRanges.ranges.map(A.NotebookRange.to)),b.selections&&c._acceptSelections(b.selections.selections.map(A.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const b in O)this.d.getEditorById(b)._acceptViewColumn(A.ViewColumn.to(O[b]))}};e.$jrc=R,e.$jrc=R=Je([Ve(0,h.$bk)],R)}),define(ke[310],Ie([1,0,4,6,166]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=void 0;class R{constructor(O,b){this.c=b,this.a=new Map,this.b=O.getProxy(h.$ON.MainThreadNotebookRenderers)}$postRendererMessage(O,b,c){const I=this.c.getEditorById(O);this.a.get(b)?.fire({editor:I.apiEditor,message:c})}createRendererMessaging(O,b){if(!O.contributes?.notebookRenderer?.some(I=>I.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(I,y,u)=>this.d(b).event(I,y,u),postMessage:(I,y)=>{A.$5qc.apiEditorsToExtHost.has(I)&&([I,y]=[y,I]);const u=y&&A.$5qc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,b,I)}}}d(O){let b=this.a.get(O);return b||(b=new r.$me({onDidRemoveLastListener:()=>{b?.dispose(),this.a.delete(O)}}),this.a.set(O,b),b)}}e.$mrc=R}),define(ke[311],Ie([1,0,15,89,20,59,13]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qrc=void 0;class O{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,C){const w=this.b++,{title:a,location:m,cancellable:$}=u,f={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(w,{location:r.ProgressLocation.from(m),title:a,source:f,cancellable:$},y.isUnderDevelopment?void 0:y.identifier.value).catch(T.$1),this.d(w,C,!!$)}d(y,u,C){let w;C&&(w=new A.$xe,this.c.set(y,w));const a=$=>{this.a.$progressEnd($),this.c.delete($),w?.dispose()};let m;try{m=u(new c(this.a,y),C&&w?w.token:A.CancellationToken.None)}catch($){throw a(y),$}return m.then($=>a(y),$=>a(y)),m}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$qrc=O;function b(I,y){return I.message=y.message,typeof y.increment=="number"&&(typeof I.increment=="number"?I.increment+=y.increment:I.increment=y.increment),I}class c extends h.$Bw{constructor(y,u){super(C=>this.throttledReport(C)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,R.$ai)(100,(I,y)=>b(I,y),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(ke[312],Ie([1,0,2,6,7,15]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=void 0;class T{static{this.a=0}constructor(b,c){this.d=c,this.c=new Map,this.b=b.getProxy(h.$ON.MainThreadQuickDiff)}$provideOriginalResource(b,c,I){const y=r.URI.revive(c),u=this.c.get(b);return u?(0,A.$yh)(()=>u.provideOriginalResource(y,I)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider(b,c,I,y){const u=T.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,R.DocumentSelector.from(b,this.d),I,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$rrc=T});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[313],Ie([1,0,20,4,3,6,2,9,13,18,43,51,25,15]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=w,I=Ut(I);function w(a,m,$){const f=a.getProxy(R.$ON.MainThreadQuickOpen);class i{constructor(S,D){this.e=new Map,this.f=0,this.a=S,this.b=D}showQuickPick(S,D,k,P=r.CancellationToken.None){this.c=void 0;const p=Promise.resolve(D),v=++this.f,F=f.$show(v,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},P),N={},L=F.then(()=>N);return Promise.race([L,p]).then(M=>{if(M===N)return;const z=(0,u.$iH)(S,"quickPickItemTooltip");return p.then(j=>{const q=[];for(let B=0;B<j.length;B++){const ee=j[B];if(typeof ee=="string")q.push({label:ee,handle:B});else if(ee.kind===O.QuickPickItemKind.Separator)q.push({type:"separator",label:ee.label});else{ee.tooltip&&!z&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const H=ee.iconPath?d(ee.iconPath):void 0;q.push({label:ee.label,iconPath:H?.iconPath,iconClass:H?.iconClass,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:z?C.MarkdownString.fromStrict(ee.tooltip):void 0,handle:B})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=B=>{k.onDidSelectItem(j[B])}),f.$setItems(v,q),F.then(B=>{if(typeof B=="number")return j[B];if(Array.isArray(B))return B.map(ee=>j[ee])})})}).then(void 0,M=>{if(!(0,b.$4)(M))return f.$setError(v,M),Promise.reject(M)})}$onItemSelected(S){this.c?.(S)}showInput(S,D=r.CancellationToken.None){return this.d=S?.validateInput,f.$input(S,typeof this.d=="function",D).then(void 0,k=>{if(!(0,b.$4)(k))return Promise.reject(k)})}async $validateInput(S){if(!this.d)return;const D=await this.d(S);if(!D||typeof D=="string")return D;let k;switch(D.severity){case O.InputBoxValidationSeverity.Info:k=I.default.Info;break;case O.InputBoxValidationSeverity.Warning:k=I.default.Warning;break;case O.InputBoxValidationSeverity.Error:k=I.default.Error;break;default:k=D.message?I.default.Error:I.default.Ignore;break}return{content:D.message,severity:k}}async showWorkspaceFolderPick(S,D=r.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!k)return;const P=await this.a.getWorkspaceFolders2();if(P)return P.find(p=>p.uri.toString()===k.uri.toString())}createQuickPick(S){const D=new l(S,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(S){const D=new g(S,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(S,D){this.e.get(S)?._fireDidChangeValue(D)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,D){const k=this.e.get(S);k instanceof l&&k._fireDidChangeActive(D)}$onDidChangeSelection(S,D){const k=this.e.get(S);k instanceof l&&k._fireDidChangeSelection(D)}$onDidTriggerButton(S,D){this.e.get(S)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(S,D,k){const P=this.e.get(S);P instanceof l&&P._fireDidTriggerItemButton(D,k)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class s{static{this.a=1}constructor(S,D){this.x=S,this.y=D,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$me,this.q=new h.$me,this.r=new h.$me,this.s=new h.$me,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){const D=(0,u.$iH)(this.x,"quickInputButtonLocation");!D&&S.some(k=>k.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=S.slice(),this.o.clear(),S.forEach((k,P)=>{const p=k===O.$fP.Back?-1:P;this.o.set(p,k)}),this.z({buttons:S.map((k,P)=>({...d(k.iconPath),tooltip:k.tooltip,handle:k===O.$fP.Back?-1:P,location:D?k.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const D=this.o.get(S);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),f.$dispose(this._id))}z(S){if(!this.v){for(const D of Object.keys(S)){const k=S[D];this.u[D]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){f.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof O.$PO)return{id:E.id};const S=n(E),D=o(E);return{dark:typeof S=="string"?T.URI.file(S):S,light:typeof D=="string"?T.URI.file(D):D}}function o(E){return typeof E=="object"&&"light"in E?E.light:E}function n(E){return typeof E=="object"&&"dark"in E?E.dark:E}function d(E){const S=t(E);let D,k;return"id"in S?k=y.ThemeIcon.asClassName(S):D=S,{iconPath:D,iconClass:k}}class l extends s{constructor(S,D){super(S,D),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$me,this.L=[],this.M=new h.$me,this.N=new h.$me,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((P,p)=>{this.C.set(p,P),this.D.set(P,p)});const D=(0,u.$iH)(this.x,"quickPickItemTooltip"),k=[];for(let P=0;P<S.length;P++){const p=S[P];if(p.kind===O.QuickPickItemKind.Separator)k.push({type:"separator",label:p.label});else{p.tooltip&&!D&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const v=p.iconPath?d(p.iconPath):void 0;k.push({handle:P,label:p.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:D?C.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((F,N)=>({...d(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(S){const D=(0,c.$Hb)(S.map(k=>this.C.get(k)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(S){const D=(0,c.$Hb)(S.map(k=>this.C.get(k)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(S,D){const k=this.C.get(S);if(!k||!k.buttons||!k.buttons.length)return;const P=k.buttons[D];P&&this.N.fire({button:P,item:k})}}class g extends s{constructor(S,D){super(S,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:I.default.Error}):this.z({validationMessage:S.message,severity:S.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(m,$)}}),define(ke[314],Ie([1,0,2,4,59,3,7,6,18,135,11,23,40,51,15,25,14,10]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=e.$trc=void 0;function i(N){return N instanceof r.URI}function s(N,L){return N.scheme===m.Schemas.file&&L.scheme===m.Schemas.file&&$.$l?N.toString()===L.toString():N.toString().toLowerCase()===L.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||C.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function o(N){if(N){if(r.URI.isUri(N))return N;if(C.ThemeIcon.isThemeIcon(N))return N;{const L=N;return{light:L.light,dark:L.dark}}}else return}function n(N){const L=o(N.icon),M=N.labels?.map(z=>({title:z.title,icon:o(z.icon)}));return{...N,icon:L,labels:M}}function d(N,L){if(!N.iconPath&&!L.iconPath)return 0;if(N.iconPath){if(!L.iconPath)return 1}else return-1;const M=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,z=typeof L.iconPath=="string"?L.iconPath:r.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,c.$Lr)(M,z)}function l(N,L){let M=0;if(N.strikeThrough!==L.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==L.faded)return N.faded?1:-1;if(N.tooltip!==L.tooltip)return(N.tooltip||"").localeCompare(L.tooltip||"");if(M=d(N,L),M!==0)return M;if(N.light&&L.light)M=d(N.light,L.light);else{if(N.light)return 1;if(L.light)return-1}if(M!==0)return M;if(N.dark&&L.dark)M=d(N.dark,L.dark);else{if(N.dark)return 1;if(L.dark)return-1}return M}function g(N,L){if(N.command!==L.command)return N.command<L.command?-1:1;if(N.title!==L.title)return N.title<L.title?-1:1;if(N.tooltip!==L.tooltip){if(N.tooltip!==void 0&&L.tooltip!==void 0)return N.tooltip<L.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(N.arguments===L.arguments)return 0;if(N.arguments)if(L.arguments){if(N.arguments.length!==L.arguments.length)return N.arguments.length-L.arguments.length}else return 1;else return-1;for(let M=0;M<N.arguments.length;M++){const z=N.arguments[M],j=L.arguments[M];if(z!==j&&!(i(z)&&i(j)&&s(z,j)))return z<j?-1:1}return 0}function E(N,L){let M=(0,c.$Lr)(N.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(M!==0)return M;if(N.command&&L.command)M=g(N.command,L.command);else{if(N.command)return 1;if(L.command)return-1}if(M!==0)return M;if(N.decorations&&L.decorations)M=l(N.decorations,L.decorations);else{if(N.decorations)return 1;if(L.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)M=(0,c.$Lr)(N.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)M=(0,c.$Lr)(N.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return M}function S(N,L){for(let M=0;M<N.length;M++)if(N[M]!==L[M])return!1;return!0}function D(N,L){return N.command===L.command&&N.title===L.title&&N.tooltip===L.tooltip&&(N.arguments&&L.arguments?S(N.arguments,L.arguments):N.arguments===L.arguments)}function k(N,L){return(0,b.$ub)(N,L,D)}class P{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,a.$jH)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,a.$jH)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,a.$jH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,M,z,j,q){this.k=L,this.m=j,this.n=q,this.d="",this.e=new h.$me,this.f="",this.h=!0,this.j=!0,this.#t=M,this.#e=z}showValidationMessage(L,M){(0,a.$jH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,M)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$trc=P;class p{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,M,z,j,q,B,ee){this.s=L,this.t=M,this.u=z,this.v=j,this.w=q,this.multiDiffEditorEnableViewChanges=B,this.x=ee,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$me,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new h.$me,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=p.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,M){const z=this.h.get(L);return z?(0,T.$yh)(()=>this.t.executeCommand(z.command,...z.arguments||[],M)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(E),z=(0,b.$Db)(this.p,L,E).map(B=>{const ee=B.toInsert.map(H=>{const W=this.e++;this.g.set(W,H);const X=H.resourceUri;let _;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"||H.command.command==="vscode.changes"){const re=new R.$Uc;_=this.t.converter.toInternal(H.command,re),this.j.set(W,re)}else this.h.set(W,H.command);const ce=(0,a.$iH)(this.x,"scmMultiDiffEditor"),ne=ce?H.multiDiffEditorOriginalUri:void 0,ye=ce?H.multiFileDiffEditorModifiedUri:void 0,ge=t(H.decorations),Y=H.decorations&&t(H.decorations.light)||ge,U=H.decorations&&t(H.decorations.dark)||ge,oe=[Y,U],ve=H.decorations&&H.decorations.tooltip||"",te=H.decorations&&!!H.decorations.strikeThrough,ae=H.decorations&&!!H.decorations.faded,se=H.contextValue||"";return{rawResource:[W,X,oe,ve,te,ae,se,_,ne,ye],handle:W}});return{start:B.start,deleteCount:B.deleteCount,toInsert:ee}}),j=z.map(({start:B,deleteCount:ee,toInsert:H})=>[B,ee,H.map(W=>W.rawResource)]),q=z.reverse();for(const{start:B,deleteCount:ee,toInsert:H}of q){const W=H.map(_=>_.handle),X=this.o.splice(B,ee,...W);for(const _ of X)this.g.delete(_),this.h.delete(_),this.j.get(_)?.dispose(),this.j.delete(_)}return this.p=L,j}dispose(){this.m=!0,this.n.fire()}}class v{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let M;(0,a.$iH)(this.y,"quickDiffProvider")&&(M=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:M})}get historyProvider(){return(0,a.$jH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,a.$jH)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new R.$Uc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new R.$Uc,this.p=L;const M=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:M})}get actionButton(){return(0,a.$jH)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,a.$jH)(this.y,"scmActionButton"),this.q.value=new R.$Uc,this.s=L;const M=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(z=>z.map(j=>this.z.converter.toInternal(j,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:M??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.u&&L&&k(this.u,L))return;this.t.value=new R.$Uc,this.u=L;const M=(L||[]).map(z=>this.z.converter.toInternal(z,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:M})}get selected(){return this.v}constructor(L,M,z,j,q,B,ee){this.y=L,this.z=j,this.A=q,this.B=B,this.C=ee,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Wc,this.n=void 0,this.o=new R.$Wc,this.p=void 0,this.q=new R.$Wc,this.t=new R.$Wc,this.u=void 0,this.v=!1,this.w=new h.$me,this.onDidChangeSelection=this.w.event,this.x=v.d++,this.D=new Map,this.E=new Set,this.#e=z;const H=r.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${q}/scm${this.x}/input`,query:ee?`rootUri=${encodeURIComponent(ee.toString())}`:void 0});this.f=new P(L,M,this.#e,this.x,H),this.#e.$registerSourceControl(this.x,q,B,ee,H)}createResourceGroup(L,M,z){const j=(0,a.$iH)(this.y,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,q=new p(this.#e,this.z,this.x,L,M,j,this.y),B=h.Event.once(q.onDidDispose)(()=>this.D.delete(q));return this.D.set(q,B),this.eventuallyAddResourceGroups(),q}eventuallyAddResourceGroups(){const L=[],M=[];for(const[z,j]of this.D){j.dispose();const q=z.onDidUpdateResourceStates(()=>{this.E.add(z),this.eventuallyUpdateResourceStates()});h.Event.once(z.onDidDispose)(()=>{this.E.delete(z),q.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.x,z.handle)}),L.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const B=z._takeResourceStateSnapshot();B.length>0&&M.push([z.handle,B]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.x,L,M),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(M=>{const z=M._takeResourceStateSnapshot();z.length!==0&&L.push([M.handle,z])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Je([(0,A.$_h)(100)],v.prototype,"eventuallyAddResourceGroups",null),Je([(0,A.$_h)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{f=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,M,z,j){this.m=M,this.n=z,this.o=j,this.g=new Map,this.h=new y.$un,this.j=new h.$me,this.e=L.getProxy(O.$ON.MainThreadSCM),this.f=L.getProxy(O.$ON.MainThreadTelemetry),M.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===u.MarshalledId.ScmResource){const B=this.g.get(q.sourceControlHandle);if(!B)return q;const ee=B.getResourceGroup(q.groupHandle);return ee?ee.getResourceState(q.handle):q}else if(q&&q.$mid===u.MarshalledId.ScmResourceGroup){const B=this.g.get(q.sourceControlHandle);return B?B.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===u.MarshalledId.ScmProvider){const B=this.g.get(q.handle);return B||q}return q}})}createSourceControl(L,M,z,j){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,M,z,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const q=f.d++,B=new v(L,this.n,this.e,this.m,M,z,j);this.g.set(q,B);const ee=this.h.get(L.identifier)||[];return ee.push(B),this.h.set(L.identifier,ee),B}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const M=this.h.get(L.identifier),z=M&&M[M.length-1];return z&&z.inputBox}$provideOriginalResource(L,M,z){const j=r.URI.revive(M);this.o.trace("ExtHostSCM#$provideOriginalResource",L,j.toString());const q=this.g.get(L);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.$yh)(()=>q.quickDiffProvider.provideOriginalResource(j,z)).then(B=>B||null)}$onInputBoxValueChange(L,M){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const z=this.g.get(L);return z&&z.inputBox.$onInputBoxValueChange(M),Promise.resolve(void 0)}$executeResourceCommand(L,M,z,j){this.o.trace("ExtHostSCM#$executeResourceCommand",L,M,z);const q=this.g.get(L);if(!q)return Promise.resolve(void 0);const B=q.getResourceGroup(M);return B?B.$executeResourceCommand(z,j):Promise.resolve(void 0)}$validateInput(L,M,z){this.o.trace("ExtHostSCM#$validateInput",L);const j=this.g.get(L);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,T.$yh)(()=>j.inputBox.validateInput(M,z)).then(q=>{if(!q)return Promise.resolve(void 0);const B=w.MarkdownString.fromStrict(q.message);return B?Promise.resolve([B,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,M,z,j){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(M,z,j)??void 0}async $resolveHistoryItemGroupCommonAncestor2(L,M,z){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(M,z)??void 0}async $provideHistoryItems(L,M,z,j){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(M,z,j))?.map(ee=>n(ee))??void 0}async $provideHistoryItems2(L,M,z){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(M,z))?.map(B=>n(B))??void 0}async $provideHistoryItemSummary(L,M,z,j){const q=this.g.get(L)?.historyProvider;if(typeof q?.provideHistoryItemSummary!="function")return;const B=await q.provideHistoryItemSummary(M,z,j);return B?n(B):void 0}async $provideHistoryItemChanges(L,M,z,j){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(M,z,j)??void 0}};e.$urc=F,e.$urc=F=f=Je([Ve(3,I.$bk)],F)}),define(ke[315],Ie([1,0,6,15,2]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=void 0;class R{static{this.a=0}constructor(O,b){this.d=b,this.c=new Map,this.b=O.getProxy(r.$ON.MainThreadShare)}async $provideShare(O,b,c){return await this.c.get(O)?.provideShare({selection:h.Range.to(b.selection),resourceUri:A.URI.revive(b.resourceUri)},c)??void 0}registerShareProvider(O,b){const c=R.a++;return this.c.set(c,b),this.b.$registerShareProvider(c,h.DocumentSelector.from(O,this.d),b.id,b.label,b.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$vrc=R}),define(ke[316],Ie([1,0,9,6,8,3,15,17]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yrc=e.$xrc=void 0;class b{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$QO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$QO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,C,w,a,m,$=r.StatusBarAlignment.Left,f){if(this.i=!1,this.k="",this.q=new R.$Uc,this.#e=u,this.#t=C,m&&a){this.c=(0,r.$sO)(a.identifier,m);const i=w.get(this.c);i&&($=i.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,f=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(b.a++);this.e=a,this.f=m,this.g=$,this.h=this.u(f)}u(u){if((0,O.$jg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!b.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new R.$Uc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let C;this.m?C=this.m:C=(0,A.localize)(2694,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=b.b.get(this.o.id));const a=T.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,C,this.k,a,this.r?.internal,w,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$xrc=b;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(2695,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const C={message:u};return this.b.unshift(C),this.c(),new r.$QN(()=>{const w=this.b.indexOf(C);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,C){this.e=new Map,this.a=u.getProxy(h.$ON.MainThreadStatusBar),this.b=C,this.c=new c(this)}$acceptStaticEntries(u){for(const C of u)this.e.set(C.entryId,C)}createStatusBarEntry(u,C,w,a){return new b(this.a,this.b,this.e,u,C,w,a)}setStatusBarMessage(u,C){const w=this.c.setMessage(u);let a;return typeof C=="number"?a=setTimeout(()=>w.dispose(),C):typeof C<"u"&&C.then(()=>w.dispose(),()=>w.dispose()),new r.$QN(()=>{w.dispose(),clearTimeout(a)})}}e.$yrc=I}),define(ke[167],Ie([1,0,30,156,73,120,74,15,2]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=e.$CQ=e.$BQ=e.$AQ=void 0,r=We(r),O=We(O);const c=(i,s,t,o)=>{let n=s;return{enumerable:!0,configurable:!1,get(){return n},set(d){if(!t(n,d)){const l=n;n=d,i.listener?.(o(d,l))}}}},I=(i,s)=>i===s,y={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,s)=>!(i.length!==s.length||i.some(t=>!s.find(o=>t.id===o.id)))},u=i=>s=>({op:R.TestItemEventOp.SetProp,update:i(s)}),C=(i,s)=>({range:(()=>{let t;const o=u(n=>({range:r.$Pt.lift(O.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return t},set(n){i.listener?.({op:R.TestItemEventOp.DocumentSynced}),y.range(t,n)||(t=n,i.listener?.(o(n)))}}})(),label:c(i,s,y.label,u(t=>({label:t}))),description:c(i,void 0,y.description,u(t=>({description:t}))),sortText:c(i,void 0,y.sortText,u(t=>({sortText:t}))),canResolveChildren:c(i,!1,y.canResolveChildren,t=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:c(i,!1,y.busy,u(t=>({busy:t}))),error:c(i,void 0,y.error,u(t=>({error:O.MarkdownString.fromStrict(t)||null}))),tags:c(i,[],y.tags,(t,o)=>({op:R.TestItemEventOp.SetTags,new:t.map(O.TestTag.from),old:o.map(O.TestTag.from)}))}),w=i=>{const s=A.$$I.fromString(i.extId),t=new m(s.controllerId,s.localId,i.label,b.URI.revive(i.uri)||void 0);return t.range=O.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>O.TestTag.to({id:(0,T.$eJ)(o).tagId})),t},a=i=>{let s;for(const t of i.tests){const o=w(t.item);(0,h.$kQ)(o).parent=s,s=o}return s};e.$AQ=a;class m{constructor(s,t,o,n){if(t.includes(A.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const d=(0,h.$jQ)(this,s);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof $?void 0:d.parent}},children:{value:(0,R.$iQ)(d,h.$kQ,m),enumerable:!0,writable:!1},...C(d,o)})}}e.$BQ=m;class $ extends m{constructor(s,t){super(s,s,t,void 0),this._isRoot=!0}}e.$CQ=$;class f extends R.$eQ{constructor(s,t,o){super({controllerId:s,getDocumentVersion:n=>n&&o.getDocument(n)?.version,getApiFor:h.$kQ,getChildren:n=>n.children,root:new $(s,t),toITestItem:O.TestItem.from})}}e.$DQ=f}),define(ke[34],Ie([1,0,17,9,15,24,6,18,11,44,30,57,2,3,5,19,167,21,53,52,42,91,94,32]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=e.$NQ=e.$MQ=e.$LQ=e.$KQ=e.$JQ=void 0,h=We(h),A=We(A);let d=class{#e;#t;#i;constructor(k,P,p){this.b=new Map,this.c=new Map,this.#e=k.getProxy(T.$ON.MainThreadCommands),this.d=P,this.#i=p,this.#t=k.getProxy(T.$ON.MainThreadTelemetry),this.converter=new l(this,v=>{const F=this.c.get(v);return F?.result===E.Void?F:void 0},P),this.f=[{processArgument(v){return(0,c.$di)(v)}},{processArgument(v){return(0,R.$ho)(v,function(F){if(I.$Pt.isIRange(F))return A.Range.to(F);if(y.$Ot.isIPosition(F))return A.Position.to(F);if(I.$Pt.isIRange(F.range)&&u.URI.isUri(F.uri))return A.location.to(F);if(F instanceof $.$Oe)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const P=this.registerCommand(!1,k.id,async(...p)=>{const v=k.args.map((N,L)=>{if(!N.validate(p[L]))throw new Error(`Invalid argument '${N.name}' when running '${k.id}', received: ${typeof p[L]=="object"?JSON.stringify(p[L],null,"	"):p[L]} `);return N.convert(p[L])}),F=await this.executeCommand(k.internalId,...v);return k.result.convert(F,p,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new h.$QN(()=>{P.dispose(),this.c.delete(k.id)})}registerCommand(k,P,p,v,F,N){if(this.d.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this.b.has(P))throw new Error(`command '${P}' already exists`);return this.b.set(P,{callback:p,thisArg:v,metadata:F,extension:N}),k&&this.#e.$registerCommand(P),new h.$QN(()=>{this.b.delete(P)&&k&&this.#e.$unregisterCommand(P)})}executeCommand(k,...P){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,P,!0)}async g(k,P,p){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,P,!1);{let v=!1;const F=(0,R.$ho)(P,function(N){if(N instanceof h.$RN)return A.Position.from(N);if(N instanceof h.$SN)return A.Range.from(N);if(N instanceof h.$5N)return A.location.from(N);if(h.$iP.isNotebookRange(N))return A.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,$.$Oe.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,$.$Oe.wrap(N);if(N instanceof $.$Oe)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(k,v?new f.$Zw(F):F,p);return(0,c.$di)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(k,P,!1);throw N}}}async h(k,P,p){const v=this.b.get(k);if(!v)throw new Error("Unknown command");const{callback:F,thisArg:N,metadata:L}=v;if(L?.args)for(let z=0;z<L.args.length;z++)try{(0,r.$wg)(P[z],L.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${L.args[z].name}' - ${L.args[z].description}`)}const M=s.$ge.create();try{return await F.apply(N,P)}catch(z){if(k===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...P);j&&(k=j.command)}if(this.d.error(z,k,v.extension?.identifier),!p)throw z;if(v.extension?.identifier){const j=this.#i.onExtensionError(v.extension.identifier,z);this.d.trace("forwarded error to extension?",j,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$rj)(z)),this.id=k,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,k,M.elapsed())}}j(k,P,p){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$yp(P),duration:p})}$executeContributedCommand(k,...P){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const p=this.b.get(k);return p?(P=P.map(v=>this.f.reduce((F,N)=>N.processArgument(F,p.extension?.identifier),v)),this.h(k,P,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(P=>(k&&(P=P.filter(p=>p[0]!=="_")),P))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[P,p]of this.b){const{metadata:v}=p;v&&(k[P]=v)}return Promise.resolve(k)}};e.$JQ=d,e.$JQ=d=Je([Ve(0,a.$oQ),Ve(1,b.$bk),Ve(2,o.$IQ)],d),e.$KQ=(0,w.$Gi)("IExtHostCommands");class l{constructor(k,P,p){this.d=k,this.f=P,this.g=p,this.delegatingCommandId=`__vsc${(0,n.$3g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,P){if(!k)return;const p={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return p;const v=this.f(k.command);if(v)p.id=v.internalId,p.arguments=v.args.map((F,N)=>F.convert(k.arguments&&k.arguments[N]));else if((0,O.$Lb)(k.arguments)){const F=`${k.command} /${++this.c}`;this.b.set(F,k),P.add((0,C.$Tc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),p.$ident=F,p.id=this.delegatingCommandId,p.arguments=[F],this.g.trace("CommandsConverter#CREATE",k.command,F)}return p}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const P=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],P?P.command:"MISSING"),P?this.d.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$LQ=l;class g{static{this.Uri=new g("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new g("position","A position in a text document",k=>h.$RN.isPosition(k),A.Position.from)}static{this.Range=new g("range","A range in a text document",k=>h.$SN.isRange(k),A.Range.from)}static{this.Selection=new g("selection","A selection in a text document",k=>h.$TN.isSelection(k),A.Selection.from)}static{this.Number=new g("number","",k=>typeof k=="number",k=>k)}static{this.String=new g("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=g.Arr(g.String)}static Arr(k){return new g(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,P=>Array.isArray(P)&&P.every(p=>k.validate(p)),P=>P.map(p=>k.convert(p)))}static{this.CallHierarchyItem=new g("item","A call hierarchy item",k=>k instanceof h.$eO,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new g("item","A type hierarchy item",k=>k instanceof h.$DP,A.TypeHierarchyItem.from)}static{this.TestItem=new g("testItem","A VS Code TestItem",k=>k instanceof m.$BQ,A.TestItem.from)}constructor(k,P,p,v){this.name=k,this.description=P,this.validate=p,this.convert=v}optional(){return new g(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,P){return new g(k??this.name,P??this.description,this.validate,this.convert)}}e.$MQ=g;class E{static{this.Void=new E("no result",k=>k)}constructor(k,P){this.description=k,this.convert=P}}e.$NQ=E;class S{constructor(k,P,p,v,F){this.id=k,this.internalId=P,this.description=p,this.args=v,this.result=F}}e.$OQ=S}),define(ke[317],Ie([1,0,18,14,2,87,143,35,34,15,9]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=void 0,R=We(R),c=We(c),I=We(I);const y=[new b.$OQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of DocumentHighlight-instances.",C(c.DocumentHighlight.to))),new b.$OQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$MQ.Uri],new b.$NQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,r.$Kb)(a))return;class $ extends I.$_N{static to(i){const s=new $(i.name,c.SymbolKind.to(i.kind),i.containerName||"",new I.$5N(m[0],c.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=c.Range.to(i.selectionRange),s.children=i.children?i.children.map($.to):[],s}}return a.map($.to)})),new b.$OQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$MQ.Uri,new b.$MQ("options","Formatting options",a=>!0,a=>a)],new b.$NQ("A promise that resolves to an array of TextEdits.",C(c.TextEdit.to))),new b.$OQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$MQ.Uri,b.$MQ.Range,new b.$MQ("options","Formatting options",a=>!0,a=>a)],new b.$NQ("A promise that resolves to an array of TextEdits.",C(c.TextEdit.to))),new b.$OQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$MQ.Uri,b.$MQ.Position,new b.$MQ("ch","Trigger character",a=>typeof a=="string",a=>a),new b.$MQ("options","Formatting options",a=>!0,a=>a)],new b.$NQ("A promise that resolves to an array of TextEdits.",C(c.TextEdit.to))),new b.$OQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$OQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location-instances.",C(c.location.to))),new b.$OQ("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Location-instances.",C(c.location.to))),new b.$OQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Hover-instances.",C(c.Hover.to))),new b.$OQ("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of Hover-instances.",C(c.Hover.to))),new b.$OQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$MQ.Uri,new b.$MQ("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>I.$RN.isPosition(m)),a=>a.map(c.Position.from))],new b.$NQ("A promise that resolves to an array of ranges.",a=>a.map(m=>{let $;for(const f of m.reverse())$=new I.$dO(c.Range.to(f),$);return $}))),new b.$OQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$MQ.String.with("query","Search string")],new b.$NQ("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(c.WorkspaceSymbol.to))),new b.$OQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(c.CallHierarchyItem.to))),new b.$OQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$MQ.CallHierarchyItem],new b.$NQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(c.CallHierarchyIncomingCall.to))),new b.$OQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$MQ.CallHierarchyItem],new b.$NQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(c.CallHierarchyOutgoingCall.to))),new b.$OQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:c.Range.to(a.range),placeholder:a.text}})),new b.$OQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$MQ.Uri,b.$MQ.Position,b.$MQ.String.with("newName","The new symbol name")],new b.$NQ("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return c.WorkspaceEdit.to(a)}})),new b.$OQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$MQ.Uri,b.$MQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$NQ("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(c.DocumentLink.to))),new b.$OQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$MQ.Uri],new b.$NQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$_O(a.tokenTypes,a.tokenModifiers)})),new b.$OQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$MQ.Uri],new b.$NQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,T.$3db)(a);if(m.type==="full")return new I.$bP(m.data,void 0)})),new b.$OQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$MQ.Uri,b.$MQ.Range.optional()],new b.$NQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$_O(a.tokenTypes,a.tokenModifiers)})),new b.$OQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$MQ.Uri,b.$MQ.Range],new b.$NQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,T.$3db)(a);if(m.type==="full")return new I.$bP(m.data,void 0)})),new b.$OQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$MQ.Uri,b.$MQ.Position,b.$MQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$MQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$NQ("A promise that resolves to a CompletionList-instance.",(a,m,$)=>{if(!a)return new I.$pO([]);const f=a.suggestions.map(i=>c.CompletionItem.to(i,$));return new I.$pO(f,a.incomplete)})),new b.$OQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$MQ.Uri,b.$MQ.Position,b.$MQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$NQ("A promise that resolves to SignatureHelp.",a=>{if(a)return c.SignatureHelp.to(a)})),new b.$OQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$MQ.Uri,b.$MQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$NQ("A promise that resolves to an array of CodeLens-instances.",(a,m,$)=>C(f=>new I.$hO(c.Range.to(f.range),f.command&&$.fromInternal(f.command)))(a))),new b.$OQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$MQ.Uri,new b.$MQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>I.$SN.isRange(a),a=>I.$TN.isSelection(a)?c.Selection.from(a):c.Range.from(a)),b.$MQ.String.with("kind","Code action kind to return code actions for").optional(),b.$MQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$NQ("A promise that resolves to an array of Command-instances.",(a,m,$)=>C(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return $.fromInternal(f.command)}else{const i=new I.$bO(f.title,f.kind?new I.$cO(f.kind):void 0);return f.edit&&(i.edit=c.WorkspaceEdit.to(f.edit)),f.command&&(i.command=$.fromInternal(f.command)),i.isPreferred=f.isPreferred,i}})(a))),new b.$OQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$MQ.Uri],new b.$NQ("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new I.$vO(c.Range.to(m.range),c.Color.to(m.color))):[])),new b.$OQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$MQ("color","The color to show and insert",a=>a instanceof I.$uO,c.Color.from),new b.$MQ("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:c.Range.from(a.range)}))],new b.$NQ("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(c.ColorPresentation.to):[])),new b.$OQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$MQ.Uri,b.$MQ.Range],new b.$NQ("A promise that resolves to an array of Inlay objects",(a,m,$)=>a.map(c.InlayHint.to.bind(void 0,$)))),new b.$OQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$MQ.Uri],new b.$NQ("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(c.FoldingRange.to)})),new b.$OQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$NQ("A promise that resolves to an array of NotebookContentProvider static info objects.",C(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>c.NotebookExclusiveDocumentPattern.to(m))})))),new b.$OQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$MQ.Uri,b.$MQ.Range,new b.$MQ("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof I.$SN,a=>c.InlineValueContext.from(a))],new b.$NQ("A promise that resolves to an array of InlineValue objects",a=>a.map(c.InlineValue.to))),new b.$OQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$MQ("uriOrString","Uri-instance or string (only http/https)",a=>A.URI.isUri(a)||typeof a=="string"&&(0,h.$Qg)(a,h.Schemas.http,h.Schemas.https),a=>a),new b.$MQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional(),b.$MQ.String.with("label","").optional()],b.$NQ.Void),new b.$OQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$MQ.Uri.with("resource","Resource to open"),b.$MQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$MQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional()],b.$NQ.Void),new b.$OQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$MQ.Uri.with("left","Left-hand side resource of the diff editor"),b.$MQ.Uri.with("right","Right-hand side resource of the diff editor"),b.$MQ.String.with("title","Human readable title for the diff editor").optional(),new b.$MQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)]).optional()],b.$NQ.Void),new b.$OQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[b.$MQ.String.with("title","Human readable title for the changes editor"),new b.$MQ("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[$,f,i]=m;if(!A.URI.isUri($)||!A.URI.isUri(f)&&f!==void 0&&f!==null||!A.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],b.$NQ.Void),new b.$OQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$MQ.Uri,b.$MQ.Position],new b.$NQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$OQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$MQ.TypeHierarchyItem],new b.$NQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$OQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$MQ.TypeHierarchyItem],new b.$NQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$OQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$MQ.TestItem],b.$NQ.Void),new b.$OQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$MQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$NQ.Void),new b.$OQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$MQ.String.with("name","The context key name"),new b.$MQ("value","The context key value",()=>!0,a=>a)],b.$NQ.Void),new b.$OQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$MQ.Uri,b.$MQ.StringArray,new b.$MQ("MappedEditsContext","Mapped Edits Context",a=>c.MappedEditsContext.is(a),a=>c.MappedEditsContext.from(a))],new b.$NQ("A promise that resolves to a workspace edit or null",a=>a?c.WorkspaceEdit.to(a):null)),new b.$OQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$MQ("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?c.Range.from(a.initialRange):void 0,initialSelection:I.$TN.isSelection(a.initialSelection)?c.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?c.Position.from(a.position):void 0}})],b.$NQ.Void)];class u{static register(m){y.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",O.$Fj)}}e.$Npc=u;function C(a){return m=>{if(Array.isArray(m))return m.map(a)}}function w(a){if(!Array.isArray(a))return;const m=[];for(const $ of a)R.$Mu($)?m.push(c.DefinitionLink.to($)):m.push(c.location.to($));return m}}),define(ke[318],Ie([1,0,2,34]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=void 0;class A{constructor(T,O,b,c,I){this.a=O,this.b=b,this.c=c;const y=new h.$OQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$MQ("showOptions","Show Options",u=>!0,u=>u),new h.$MQ("resource","Interactive resource Uri",u=>!0,u=>u),new h.$MQ("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$MQ("title","Interactive editor title",u=>!0,u=>u)],new h.$NQ("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const C=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:C.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(T,O,b,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:b,uri:T,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(T,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.$crc=A}),define(ke[319],Ie([1,0,18,7,20,4,3,28,2,23,11,6,34,15,9,121,261,25,53,262]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0,e.$lrc=g,C=We(C);let s=class{constructor(S,D,k,P,p){this.m=D,this.n=k,this.o=P,this.q=p,this.b=new O.$Bc,this.c=new O.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$me,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=S.getProxy(y.$ON.MainThreadNotebookKernels);const v=new u.$OQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$MQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const L=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:L}}else if(N&&"notebookEditor"in N){const L=this.n.getIdByEditor(N.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return N})],u.$NQ.Void),F=new u.$OQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$MQ.Uri],new u.$NQ("A promise that resolves to an array of variables",(N,L)=>N.map(M=>({variable:{name:M.name,value:M.value,expression:M.expression,type:M.type,language:M.language},hasNamedChildren:M.hasNamedChildren,indexedChildrenCount:M.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(F)}createNotebookController(S,D,k,P,p,v){for(const ne of this.j.values())if(ne.controller.id===D&&c.$sn.equals(S.identifier,ne.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const F=this.k++,N=this;this.q.trace(`NotebookController[${F}], CREATED by ${S.identifier.value}, ${D}`);const L=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${S.identifier}'`);let M=!1;const z=new R.$me,j=new R.$me,q={id:g(S.identifier,D),notebookType:k,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:P||S.identifier.value,preloads:v?v.map(C.NotebookRendererScript.from):[]};let B=p??L,ee,H;this.a.$addKernel(F,q).catch(ne=>{console.log(ne),M=!0});let W=0;const X=()=>{if(M)return;const ne=++W;Promise.resolve().then(()=>{ne===W&&this.a.$updateKernel(F,q)})},_=new O.$Bc,ce={get id(){return D},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return q.label},set label(ne){q.label=ne??S.displayName??S.name,X()},get detail(){return q.detail??""},set detail(ne){q.detail=ne,X()},get description(){return q.description??""},set description(ne){q.description=ne,X()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(ne){q.supportedLanguages=ne,X()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){q.supportsExecutionOrder=ne,X()},get rendererScripts(){return q.preloads?q.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(ne){B=ne??L},get interruptHandler(){return ee},set interruptHandler(ne){ee=ne,q.supportsInterrupt=!!ne,X()},set variableProvider(ne){(0,$.$jH)(S,"notebookVariableProvider"),H=ne,q.hasVariableProvider=!!ne,ne?.onDidChangeVariables(ye=>N.a.$variablesUpdated(ye.uri)),X()},get variableProvider(){return H},createNotebookCellExecution(ne){if(M)throw new Error("notebook controller is DISPOSED");if(!_.has(ne.notebook.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return N._createNotebookCellExecution(ne,g(S.identifier,this.id))},createNotebookExecution(ne){if((0,$.$jH)(S,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!_.has(ne.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return N._createNotebookExecution(ne,g(S.identifier,this.id))},dispose:()=>{M||(this.q.trace(`NotebookController[${F}], DISPOSED`),M=!0,this.j.delete(F),z.dispose(),j.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(ne,ye){ye===w.NotebookControllerAffinity2.Hidden&&(0,$.$jH)(S,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(F,ne.uri,ye)},onDidReceiveMessage:j.event,postMessage(ne,ye){return(0,$.$jH)(S,"notebookMessaging"),N.a.$postMessage(F,ye&&N.n.getIdByEditor(ye),ne)},asWebviewUri(ne){return(0,$.$jH)(S,"notebookMessaging"),(0,a.$NDb)(ne,N.m.remote)}};return this.j.set(F,{extensionId:S.identifier,controller:ce,onDidReceiveMessage:j,onDidChangeSelection:z,associatedNotebooks:_}),ce}getIdByController(S){for(const[D,k]of this.j)if(k.controller===S)return g(k.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,D){const k=this.g++,P=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(k,D);const p={dispose:()=>{this.f.delete(k),P.a.$removeKernelDetectionTask(k)}};return this.f.set(k,p),p}registerKernelSourceActionProvider(S,D,k){const P=this.i++,p=typeof k.onDidChangeNotebookKernelSourceActions=="function"?P:void 0,v=this;this.h.set(P,k),this.q.trace(`NotebookKernelSourceActionProvider[${P}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(P,P,D);let F;return p!==void 0&&(F=k.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(P),v.a.$removeKernelSourceActionProvider(P,P),F?.dispose()}}}async $provideKernelSourceActions(S,D){const k=this.h.get(S);if(k){const P=new T.$Uc;return(await k.provideNotebookKernelSourceActions(D)??[]).map(v=>C.NotebookKernelSourceAction.from(v,this.o.converter,P))}return[]}$acceptNotebookAssociation(S,D,k){const P=this.j.get(S);if(P){const p=this.n.getNotebookDocument(b.URI.revive(D));k?P.associatedNotebooks.set(p.uri,!0):P.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,p.uri.toString(),k),P.onDidChangeSelection.fire({selected:k,notebook:p.apiNotebook})}}async $executeCells(S,D,k){const P=this.j.get(S);if(!P)return;const p=this.n.getNotebookDocument(b.URI.revive(D)),v=[];for(const F of k){const N=p.getCell(F);N&&v.push(N.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,p.uri.toString(),v.length),await P.controller.executeHandler.call(P.controller,v,p.apiNotebook,P.controller)}catch(F){this.q.error(`NotebookController[${S}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(S,D,k){const P=this.j.get(S);if(!P)return;const p=this.n.getNotebookDocument(b.URI.revive(D));if(P.controller.interruptHandler)await P.controller.interruptHandler.call(P.controller,p.apiNotebook);else for(const v of k){const F=p.getCell(v);F&&this.b.get(F.uri)?.cancel()}if(P.controller.interruptHandler){const v=this.c.get(p.uri);this.c.delete(p.uri),k.length&&Array.isArray(v)&&v.length&&v.forEach(F=>F.dispose())}}async $provideVariables(S,D,k,P,p,v,F){const N=this.j.get(S);if(!N)return;const L=this.n.getNotebookDocument(b.URI.revive(k)),M=N.controller.variableProvider;if(!M)return;let z;if(P!==void 0){if(z=this.s[P],!z)return}else this.s={};const j=p==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,q=M.provideVariables(L.apiNotebook,z,j,v,F);let B=0;for await(const ee of q){if(F.isCancellationRequested)return;const H={id:this.r++,name:ee.variable.name,value:ee.variable.value,type:ee.variable.type,interfaces:ee.variable.interfaces,language:ee.variable.language,expression:ee.variable.expression,hasNamedChildren:ee.hasNamedChildren,indexedChildrenCount:ee.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[H.id]=ee.variable,this.a.$receiveVariable(D,H),B++>=i.$4K)return}}$acceptKernelMessageFromRenderer(S,D,k){const P=this.j.get(S);if(!P)return;const p=this.n.getEditorById(D);P.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:k}))}$cellExecutionChanged(S,D,k){const p=this.n.getNotebookDocument(b.URI.revive(S)).getCell(D);if(p){const v=k?C.NotebookCellExecutionState.to(k):w.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:p.apiCell,state:v})}}_createNotebookCellExecution(S,D){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const P=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!P)throw new Error("invalid cell");if(this.b.has(P.uri))throw new Error(`duplicate execution for ${P.uri}`);const p=new o(D,P,this.a);this.b.set(P.uri,p);const v=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),v.dispose(),this.b.delete(P.uri))});return p.asApiObject()}_createNotebookExecution(S,D){const k=this.n.getNotebookDocument(S.uri),P=S.getCells().find(F=>{const N=k.getCellFromApiCell(F);return N&&this.b.has(N.uri)});if(P)throw new Error(`duplicate cell execution for ${P.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const p=new d(D,k,this.a),v=p.onDidChangeState(()=>{p.state===n.Resolved&&(p.dispose(),v.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[p,v]),p.asApiObject()}};e.$krc=s,e.$krc=s=Je([Ve(4,I.$bk)],s);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class o extends T.$Vc{static{this.a=0}get state(){return this.f}constructor(S,D,k){super(),this.m=D,this.n=k,this.b=o.a++,this.c=new R.$me,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new A.$xe),this.h=new l(10,P=>this.s(P)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const D=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new f.$Zw(D))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let D=this.m;if(S&&(D=this.m.notebook.getCellFromApiCell(S)),!D)throw new Error("INVALID cell");return D.handle}y(S){return S.map(D=>{const k=w.$mP.ensureUniqueMimeTypes(D.items,!0);return k===D.items?C.NotebookCellOutput.from(D):C.NotebookCellOutput.from({items:k,id:D.id,metadata:D.metadata})})}async z(S,D,k){const P=this.w(D),p=this.y((0,r.$2b)(S));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:P,append:k,outputs:p})}async C(S,D,k){return S=w.$mP.ensureUniqueMimeTypes((0,r.$2b)(S),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:S.map(C.NotebookCellOutputItem.from),outputId:D.id,append:k})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(k){S.j=k,S.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(k){if(S.f===t.Resolved||S.f===t.Started)throw new Error("Cannot call start again");S.f=t.Started,S.c.fire(),S.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,P,p){if(S.f===t.Resolved)throw new Error("Cannot call resolve twice");S.f=t.Resolved,S.c.fire(),S.h.flush();const v=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;S.n.$completeExecution(S.b,new f.$Zw({runEndTime:P,lastRunSuccess:k,error:v}))},clearOutput(k){return S.t(),S.z([],k,!1)},appendOutput(k,P){return S.t(),S.z(k,P,!0)},replaceOutput(k,P){return S.t(),S.z(k,P,!1)},appendOutputItems(k,P){return S.t(),S.C(k,P,!0)},replaceOutputItems(k,P){return S.t(),S.C(k,P,!1)}})}}var n;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(n||(n={}));class d extends T.$Vc{static{this.a=0}get state(){return this.f}constructor(S,D,k){super(),this.h=D,this.j=k,this.b=d.a++,this.c=new R.$me,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new A.$xe),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(S,D){this.f=S,this.g=D,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new h.$4h,this.b=Date.now(),(0,h.$Hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>S.complete())}}function g(E,S){return`${E.value}/${S}`}}),define(ke[48],Ie([1,0,4,6,5,2,19,3,9,8,13,241,20,32,242,243,51,7,15,34,40]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=e.$rqc=e.$qqc=e.$pqc=void 0,e.$pqc=(0,A.$Gi)("IExtHostTerminalService");class t extends O.$Vc{constructor(p,v,F,N){super(),this.u=p,this._id=v,this.w=F,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$me),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(M=>this.g=M);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(M,z=!0){L.C(),L.u.$sendText(L._id,M,z)},show(M){L.C(),L.u.$show(L._id,M)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??v?.cwd??void 0,env:p.env??void 0,icon:S(p.iconPath)??void 0,color:m.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(p.location,v?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,v,F,N,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:m.ThemeColor.isThemeColor(L)?L.id:void 0,location:v?.location||this.z(p,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,v){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in p?{viewColumn:f.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,v){this.j=Object.freeze({code:p,reason:v})}setDimensions(p,v){return p===this.f&&v===this.h||p===0||v===0?!1:(this.f=p,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(v=>{v!==p&&(this.b=Promise.resolve(p))})}}e.$qqc=t;class o{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new r.$me,this.onProcessData=this.a.event,this.b=new r.$me,this.d=new r.$me,this.onDidChangeProperty=this.d.event,this.f=new r.$me,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,v){this.g.setDimensions?.({columns:p,rows:v})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:w.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:w.ProcessPropertyType.Title,value:v})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let n=1,d=class extends O.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,v,F){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new O.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$me,this.onDidCloseTerminal=this.H.event,this.I=new r.$me,this.onDidOpenTerminal=this.I.event,this.J=new r.$me,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$me,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$me,this.onDidChangeTerminalState=this.M.event,this.N=new r.$me,this.onDidChangeShell=this.N.event,this.O=new r.$me({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$me({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(h.$ON.MainThreadTerminalService),this.y=new a.$3xb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:N=>{const L=M=>{const z=M;return this.getTerminalById(z.instanceId)?.value};switch(N?.$mid){case s.MarshalledId.TerminalContext:return L(N);default:{if(Array.isArray(N))for(let M=0;M<N.length&&N[M].$mid===s.MarshalledId.TerminalContext;M++)N[M]=L(N[M]);return N}}}}),this.B({dispose:()=>{for(const[N,L]of this.g)L.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,v){const F=new t(this.a,(0,C.$3g)(),p,p.name),N=new o(p.pty);return F.createExtensionTerminal(p.location,v,this.R(p,v).resolvedExtHostIdentifier,S(p.iconPath),D(p.color)).then(L=>{const M=this.S(L,N);this.h[L]=M}),this.f.push(F),F.value}R(p,v){if(v=v||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const F=p.location.parentTerminal;if(F){const N=this.f.find(L=>L.value===F);N&&(v.resolvedExtHostIdentifier=N._id)}}else p.location&&typeof p.location!="object"?v.location=p.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(p,v){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const N=new o(v),L=this.S(p,N);this.h[p]=L}async $acceptActiveTerminalChanged(p){const v=this.b;if(p===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(p);F&&(this.b=F,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,v){const F=this.getTerminalById(p);F&&this.O.fire({terminal:F.value,data:v})}async $acceptTerminalDimensions(p,v,F){const N=this.getTerminalById(p);N&&N.setDimensions(v,F)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(p,v){const F=this.getTerminalById(p);F&&this.P.fire({terminal:F.value,...v})}async $acceptTerminalMaximumDimensions(p,v,F){this.g.get(p)?.resize(v,F)}async $acceptTerminalTitleChange(p,v){const F=this.getTerminalById(p);F&&(F.name=v)}async $acceptTerminalClosed(p,v,F){const N=this.X(this.f,p);if(N!==null){const L=this.f.splice(N,1)[0];L.setExitStatus(v,F),this.H.fire(L.value)}}$acceptTerminalOpened(p,v,F,N){if(v){const z=this.X(this.f,v);if(z!==null){this.f[z]._id=p,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const L={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:R.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},M=new t(this.a,p,L,F);this.f.push(M),this.I.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(p,v){this.getTerminalById(p)?._setProcessId(v)}async $startExtensionTerminal(p,v){const F=this.getTerminalById(p);if(!F)return{message:(0,c.localize)(2697,null,p)};F.isOpen||await new Promise(L=>{const M=this.onDidOpenTerminal(async z=>{z===F.value&&(M.dispose(),L())})});const N=this.g.get(p);N?N.startSendingEvents(v):this.j[p]={initialDimensions:v}}S(p,v){const F=new O.$Uc;F.add(v.onProcessReady(L=>this.a.$sendProcessReady(p,L.pid,L.cwd,L.windowsPty))),F.add(v.onDidChangeProperty(L=>this.a.$sendProcessProperty(p,L))),this.y.startBuffering(p,v.onProcessData),F.add(v.onProcessExit(L=>this.U(p,L))),this.g.set(p,v);const N=this.j[p];return N&&v instanceof o&&(v.startSendingEvents(N.initialDimensions),delete this.j[p]),F}$acceptProcessAckDataEvent(p,v){this.g.get(p)?.acknowledgeDataEvent(v)}$acceptProcessInput(p,v){this.g.get(p)?.input(v)}$acceptTerminalInteraction(p){const v=this.getTerminalById(p);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(p,v){this.getTerminalById(p)?.setSelection(v)}$acceptProcessResize(p,v,F){try{this.g.get(p)?.resize(v,F)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(p,v){this.g.get(p)?.shutdown(v)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(p,{type:w.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(v=>this.a.$sendProcessProperty(p,{type:w.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new b.$QN(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,v,F){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,F),this.a.$registerProfileProvider(v,p.identifier.value),new b.$QN(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(p,v,F){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,F),this.a.$registerQuickFixProvider(p,v),new b.$QN(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,v){const F=new u.$xe().token;if(F.isCancellationRequested)return;const N=this.D.get(p);if(!N)return;const L=await N.provideTerminalQuickFixes(v,F);if(L===null||Array.isArray(L)&&L.length===0)return;const M=new O.$Uc;if(this.w.value=M,!Array.isArray(L))return L?f.TerminalQuickFix.from(L,this.Q.converter,M):void 0;const z=[];for(const j of L){const q=f.TerminalQuickFix.from(j,this.Q.converter,M);q&&z.push(q)}return z}async $createContributedProfileTerminal(p,v){const F=new u.$xe().token;let N=await this.C.get(p)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,v);return}this.createTerminalFromOptions(N.options,v)}}async $provideLinks(p,v){const F=this.getTerminalById(p);if(!F)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const L=new u.$xe;this.G.set(p,L);const M=[],z={terminal:F.value,line:v},j=[];for(const ee of this.z)j.push($.Promises.withAsyncBody(async H=>{L.token.onCancellationRequested(()=>H({provider:ee,links:[]}));const W=await ee.provideTerminalLinks(z,L.token)||[];L.token.isCancellationRequested||H({provider:ee,links:W})}));const q=await Promise.all(j);if(L.token.isCancellationRequested)return[];const B=new Map;for(const ee of q)ee&&ee.links.length>0&&M.push(...ee.links.map(H=>{const W={id:n++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return B.set(W.id,{provider:ee.provider,link:H}),W}));return this.F.set(p,B),M}$activateLink(p,v){const F=this.F.get(p)?.get(v);F&&F.provider.handleTerminalLink(F.link)}U(p,v){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const F=this.h[p];F&&(F.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,v)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const v=this.f.findIndex(F=>F.value===p);return v>=0?v:null}W(p,v){const F=this.X(p,v);return F!==null?p[F]:null}X(p,v){const F=p.findIndex(N=>N._id===v);return F>=0?F:null}getEnvironmentVariableCollection(p){let v=this.n.get(p.identifier.value);return v||(v=this.B(new l),this.Z(p.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(p,v){const F=(0,y.$Gs)(v.map),N=(0,y.$Hs)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(p,v.persistent,F.length===0?void 0:F,N)}$initEnvironmentVariableCollections(p){p.forEach(v=>{const F=v[0],N=this.B(new l(v[1]));this.Z(F,N)})}$acceptDefaultProfile(p,v){const F=this.s;this.s=p,this.u=v,F?.path!==p.path&&this.N.fire(p.path)}Z(p,v){this.n.set(p,v),this.B(v.onDidChangeCollection(()=>{this.Y(p,v)}))}};e.$rqc=d,e.$rqc=d=Je([Ve(1,i.$KQ),Ve(2,T.$oQ)],d);class l extends O.$Vc{get persistent(){return this.b}set persistent(p){this.b=p,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(p){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$me,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const v=this.j(p);let F=this.a.get(v);return F||(F=new g(this,p),this.a.set(v,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:N})}append(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:N})}prepend(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:N})}g(p,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(p,v.scope),N=this.map.get(F),L=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==v.value||N.type!==v.type||N.options?.applyAtProcessCreation!==L.applyAtProcessCreation||N.options?.applyAtShellIntegration!==L.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const M=this.h(p,v.scope),z={variable:p,...v,options:L};this.map.set(M,z),this.f.fire()}}get(p,v){const F=this.h(p,v),N=this.map.get(F);return N?k(N):void 0}h(p,v){const F=this.j(v);return F.length?`${p}:::${F}`:p}j(p){return this.m(p?.workspaceFolder)??""}m(p){return p?p.uri.toString():void 0}getVariableMap(p){const v=new Map;for(const[F,N]of this.map)this.j(N.scope)===this.j(p)&&v.set(N.variable,k(N));return v}delete(p,v){const F=this.h(p,v);this.map.delete(F),this.f.fire()}clear(p){if(p?.workspaceFolder){for(const[v,F]of this.map)F.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(v);this.n(p)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(p,v){const F=this.j(v),N=this.descriptionMap.get(F);if(!N||N.description!==p){let L;typeof p=="string"?L=p:L=p?.value.split(`

`)[0];const M={description:L,scope:v};this.descriptionMap.set(F,M),this.f.fire()}}getDescription(p){const v=this.j(p);return this.descriptionMap.get(v)?.description}n(p){const v=this.j(p);this.descriptionMap.delete(v)}}class g{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,v){this.b=p,this.d=v,this.a=new r.$me}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,v,F){this.b.replace(p,v,F,this.d)}append(p,v,F){this.b.append(p,v,F,this.d)}prepend(p,v,F){this.b.prepend(p,v,F,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,v){this.b.getVariableMap(this.d).forEach((F,N)=>p.call(v,N,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends d{constructor(p,v){super(!1,p,v)}createTerminal(p,v,F){throw new I.$_}createTerminalFromOptions(p,v){throw new I.$_}};e.$sqc=E,e.$sqc=E=Je([Ve(0,i.$KQ),Ve(1,T.$oQ)],E);function S(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function D(P){return m.ThemeColor.isThemeColor(P)?P:void 0}function k(P){const p={...P};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[168],Ie([1,0,9,3,5,6,19,48,4,2,7]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=e.$Crc=void 0,e.$Crc=(0,A.$Gi)("IExtHostTerminalShellIntegration");let y=class extends h.$Vc{constructor(m,$){super(),this.h=$,this.b=new Map,this.c=new b.$me,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new b.$me,this.onDidStartTerminalShellExecution=this.f.event,this.g=new b.$me,this.onDidEndTerminalShellExecution=this.g.event,this.a=m.getProxy(R.$ON.MainThreadTerminalShellIntegration),this.B((0,h.$Tc)(()=>{for(const[f,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(m){const $=this.h.getTerminalById(m);if(!$)return;const f=$.value;let i=this.b.get(m);i||(i=new u($.value,this.f),this.b.set(m,i),i.store.add($.onWillDispose(()=>this.b.get(m)?.dispose())),i.store.add(i.onDidRequestShellExecution(s=>this.a.$executeCommand(m,s))),i.store.add(i.onDidRequestEndExecution(s=>this.g.fire(s))),i.store.add(i.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),$.shellIntegration=i.value),this.c.fire({terminal:f,shellIntegration:i.value})}$shellExecutionStart(m,$,f,i,s){this.b.has(m)||this.$shellIntegrationChange(m);const t={value:$,confidence:f,isTrusted:i};this.b.get(m)?.startShellExecution(t,c.URI.revive(s))}$shellExecutionEnd(m,$,f,i,s){const t={value:$,confidence:f,isTrusted:i};this.b.get(m)?.endShellExecution(t,s)}$shellExecutionData(m,$){this.b.get(m)?.emitData($)}$cwdChange(m,$){this.b.get(m)?.setCwd(c.URI.revive($))}$closeTerminal(m){this.b.get(m)?.dispose(),this.b.delete(m)}};e.$Drc=y,e.$Drc=y=Je([Ve(0,T.$oQ),Ve(1,O.$pqc)],y);class u extends h.$Vc{get currentExecution(){return this.a}constructor(m,$){super(),this.j=m,this.m=$,this.b=!1,this.store=this.B(new h.$Uc),this.f=this.B(new b.$me),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new b.$me),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new b.$me),this.onDidRequestEndExecution=this.h.event;const f=this;this.value={get cwd(){return f.c},executeCommand(i,s){let t=i;s&&(t+=` "${s.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),f.g.fire(t);const o={value:t,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},n=f.startShellExecution(o,f.c,!0).value;return f.b=!0,n}}}startShellExecution(m,$,f){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new C(m,$??this.c);f?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,$){this.a&&(this.a.endExecution(m),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:$}),this.a=void 0)}setCwd(m){let $=!1;c.URI.isUri(this.c)?$=!c.URI.isUri(m)||this.c.toString()!==m.toString():this.c!==m&&($=!0),$&&(this.c=m,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class C{constructor(m,$){this.c=m,this.cwd=$,this.b=!1;const f=this;this.value={get commandLine(){return f.c},get cwd(){return f.cwd},read(){return f.d()}}}d(){if(!this.a){if(this.b)return I.$7h.EMPTY;this.a=new w}return this.a.createIterable()}emitData(m){this.a?.emitData(m)}endExecution(m){m&&(this.c=m),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends h.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Fh);const m=this.a;return new I.$7h(async f=>{this.b.push(f),await m.wait()})}emitData(m){for(const $ of this.b)$.emitOne(m)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[169],Ie([1,0,65,13,133,15,9]),function($e,e,r,h,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=e.$vQ=void 0,R=We(R);class O{static{this.c=new A.$tQ("TextEditorDecorationType")}constructor(u,C,w){const a=O.c.nextId();u.$registerTextEditorDecorationType(C.identifier,a,R.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:a,dispose(){u.$removeTextEditorDecorationType(a)}})}}e.$vQ=O;class b{constructor(u,C){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,C){this.k();let w=null;if(u instanceof T.$RN)w=new T.$SN(u,u);else if(u instanceof T.$SN)w=u;else throw new Error("Unrecognized location");this.l(w,C,!1)}insert(u,C){this.k(),this.l(new T.$SN(u,u),C,!0)}delete(u){this.k();let C=null;if(u instanceof T.$SN)C=u;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(u,C,w){const a=this.c.validateRange(u);this.g.push({range:a,text:C,forceMoveMarkers:w})}setEndOfLine(u){if(this.k(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,h.$7)("endOfLine");this.h=u}}class c{constructor(u,C,w,a){this.c=u,this.d=C,this._accept(w),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize($){m.n($)},get indentSize(){return m.g},set indentSize($){m.p($)},get insertSpaces(){return m.j},set insertSpaces($){m.s($)},get cursorStyle(){return m.k},set cursorStyle($){m.t($)},get lineNumbers(){return m.l},set lineNumbers($){m.u($)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const C=Math.floor(u);return C>0?C:null}if(typeof u=="string"){const C=parseInt(u,10);return isNaN(C)?null:C>0?C:null}return null}n(u){const C=this.m(u);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const C=Math.floor(u);return C>0?C:null}if(typeof u=="string"){const C=parseInt(u,10);return isNaN(C)?null:C>0?C:null}return null}p(u){const C=this.o(u);if(C!==null){if(typeof C=="number"){if(this.h===C)return;this.g=C,this.h=C}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const C=this.q(u);if(typeof C=="boolean"){if(this.j===C)return;this.j=C}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const C={};let w=!1;if(typeof u.tabSize<"u"){const a=this.m(u.tabSize);a==="auto"?(w=!0,C.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,w=!0,C.tabSize=a)}if(typeof u.indentSize<"u"){const a=this.o(u.indentSize);a==="tabSize"?(w=!0,C.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,w=!0,C.indentSize=a)}if(typeof u.insertSpaces<"u"){const a=this.q(u.insertSpaces);a==="auto"?(w=!0,C.insertSpaces=a):this.j!==a&&(this.j=a,w=!0,C.insertSpaces=a)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,w=!0,C.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,w=!0,C.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,C))}v(u,C){C.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(w)})}}e.$wQ=c;class I{constructor(u,C,w,a,m,$,f,i){this.id=u,this.j=C,this.k=w,this.g=!1,this.h=new Set,this.c=m,this.d=new c(this.j,this.id,$,w),this.e=f,this.f=i;const s=this;this.value=Object.freeze({get document(){return a.value},set document(t){throw new h.$9("document")},get selection(){return s.c&&s.c[0]},set selection(t){if(!(t instanceof T.$TN))throw(0,h.$7)("selection");s.c=[t],s.l()},get selections(){return s.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof T.$TN)))throw(0,h.$7)("selections");s.c=t,s.l()},get visibleRanges(){return s.e},set visibleRanges(t){throw new h.$9("visibleRanges")},get options(){return s.d.value},set options(t){s.g||s.d.assign(t)},get viewColumn(){return s.f},set viewColumn(t){throw new h.$9("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new b(a.value,o);return t(n),s.m(n)},insertSnippet(t,o,n={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!o||Array.isArray(o)&&o.length===0)d=s.c.map(l=>R.Range.from(l));else if(o instanceof T.$RN){const{lineNumber:l,column:g}=R.Position.from(o);d=[{startLineNumber:l,startColumn:g,endLineNumber:l,endColumn:g}]}else if(o instanceof T.$SN)d=[R.Range.from(o)];else{d=[];for(const l of o)if(l instanceof T.$SN)d.push(R.Range.from(l));else{const{lineNumber:g,column:E}=R.Position.from(l);d.push({startLineNumber:g,startColumn:E,endLineNumber:g,endColumn:E})}}return C.$tryInsertSnippet(u,a.value.version,t.value,d,n)},setDecorations(t,o){const n=o.length===0;n&&!s.h.has(t.key)||(n?s.h.delete(t.key):s.h.add(t.key),s.n(()=>{if(R.$lQ(o))return C.$trySetDecorations(u,t.key,R.$mQ(o));{const d=new Array(4*o.length);for(let l=0,g=o.length;l<g;l++){const E=o[l];d[4*l]=E.start.line+1,d[4*l+1]=E.start.character+1,d[4*l+2]=E.end.line+1,d[4*l+3]=E.end.character+1}return C.$trySetDecorationsFast(u,t.key,d)}}))},revealRange(t,o){s.n(()=>C.$tryRevealRange(u,R.Range.from(t),o||T.TextEditorRevealType.Default))},show(t){C.$tryShowEditor(u,R.ViewColumn.from(t))},hide(){C.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const C=u.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const w=C.edits.map(m=>m.range);w.sort((m,$)=>m.end.line===$.end.line?m.end.character===$.end.character?m.start.line===$.start.line?m.start.character-$.start.character:m.start.line-$.start.line:m.end.character-$.end.character:m.end.line-$.end.line);for(let m=0,$=w.length-1;m<$;m++){const f=w[m].end;if(w[m+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=C.edits.map(m=>({range:R.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,a,{setEndOfLine:typeof C.setEndOfLine=="number"?R.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.$xQ=I}),define(ke[63],Ie([1,0,65,4,3,2,5,6,165,19,169,15,11,28,14,39,50]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.$yQ=void 0,r=We(r),y=We(y);class ${constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let f=class{constructor(s,t){this.h=s,this.i=t,this.a=null,this.b=new Map,this.c=new C.$Bc,this.d=new h.$me,this.e=new h.$me,this.f=new h.$me,this.g=new h.$me,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const t=[],o=[],n=[];if(s.removedDocuments)for(const d of s.removedDocuments){const l=R.URI.revive(d),g=this.c.get(l);g?.unref()&&(this.c.delete(l),t.push(g.value))}if(s.addedDocuments)for(const d of s.addedDocuments){const l=R.URI.revive(d.uri);let g=this.c.get(l);if(g&&l.scheme!==w.Schemas.vscodeNotebookCell&&l.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);g||(g=new $(new b.$rQ(this.h.getProxy(O.$ON.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,g),o.push(g.value)),g.ref()}if(s.removedEditors)for(const d of s.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&n.push(l)}if(s.addedEditors)for(const d of s.addedEditors){const l=R.URI.revive(d.documentUri);r.ok(this.c.has(l),`document '${l}' does not exist`),r.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const g=this.c.get(l).value,E=new I.$xQ(d.id,this.h.getProxy(O.$ON.MainThreadTextEditors),this.i,new m.$U(()=>g.document),d.selections.map(y.Selection.to),d.options,d.visibleRanges.map(S=>y.Range.to(S)),typeof d.editorPosition=="number"?y.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,E)}s.newActiveEditor!==void 0&&(r.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,A.$Qc)(t),(0,A.$Qc)(n),s.removedDocuments&&this.e.fire(t),s.addedDocuments&&this.d.fire(o),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return a.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const t=this.b.get(this.a);return s?t:t?.value}allEditors(){return[...this.b.values()]}};e.$yQ=f,e.$yQ=f=Je([Ve(0,c.$oQ),Ve(1,u.$bk)],f),e.$zQ=(0,T.$Gi)("IExtHostDocumentsAndEditors")}),define(ke[98],Ie([1,0,7,21,20,4,79,60,3,40,17,2,32,5,11,6,34,63,19,167,15,9,264,73,120,74,25]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n,d,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=e.$Mqc=e.$Lqc=e.$Kqc=e.$Jqc=void 0,s=We(s);let E=0;const S=new WeakMap;e.$Jqc=(0,C.$Gi)("IExtHostTesting");let D=class extends b.$Vc{constructor(W,X,_,ce){super(),this.C=X,this.D=_,this.F=ce,this.f=this.B(new R.$me),this.g=new Map,this.w=this.B(new R.$me),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=W.getProxy(a.$ON.MainThreadTesting),this.m=new z(this.h),this.j=new v(this.h,X),_.registerArgumentProcessor({processArgument:ne=>{switch(ne?.$mid){case c.MarshalledId.TestItemContext:{const ye=ne,ge=ye.tests[ye.tests.length-1].item.extId;return this.g.get(n.$$I.root(ge))?.collection.tree.get(ge)?.actual??(0,i.$AQ)(ne)}case c.MarshalledId.TestMessageMenuArgs:{const{test:ye,message:ge}=ne,Y=ye.item.extId;return{test:this.g.get(n.$$I.root(Y))?.collection.tree.get(Y)?.actual??(0,i.$AQ)({$mid:c.MarshalledId.TestItemContext,tests:[ye]}),message:s.TestMessage.to(ge)}}default:return ne}}}),_.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ne=await _.executeCommand(o.TestCommandId.GetExplorerSelection),ye=ge=>{const Y=this.g.get(n.$$I.root(ge));if(Y)return n.$$I.isRoot(ge)?Y.controller:Y.collection.tree.get(ge)?.actual};return{include:ne?.include.map(ye).filter(I.$ng)||[],exclude:ne?.exclude.map(ye).filter(I.$ng)||[]}})}createTestController(W,X,_,ce){if(this.g.has(X))throw new Error(`Attempt to insert a duplicate controller with ID "${X}"`);const ne=new b.$Uc,ye=ne.add(new i.$DQ(X,_,this.F));ye.root.label=_;const ge=new Map,Y=new Set,U=this.h,oe=()=>{let ae=0;ce&&(ae|=l.TestControllerCapability.Refresh);const se=te.relatedCodeProvider;return se&&(se?.provideRelatedTests&&(ae|=l.TestControllerCapability.TestRelatedToCode),se?.provideRelatedCode&&(ae|=l.TestControllerCapability.CodeRelatedToTest)),ae},ve={items:ye.root.children,get label(){return _},set label(ae){_=ae,ye.root.label=ae,U.$updateController(X,{label:_})},get refreshHandler(){return ce},set refreshHandler(ae){ce=ae,U.$updateController(X,{capabilities:oe()})},get id(){return X},get relatedCodeProvider(){return te.relatedCodeProvider},set relatedCodeProvider(ae){(0,g.$jH)(W,"testRelatedCode"),te.relatedCodeProvider=ae,U.$updateController(X,{capabilities:oe()})},createRunProfile:(ae,se,Z,re,pe,we)=>{let Fe=(0,O.$uj)(ae);for(;ge.has(Fe);)Fe++;return new q(this.h,ge,Y,this.w.event,X,Fe,ae,se,Z,re,pe,we)},createTestItem(ae,se,Z){return new i.$BQ(X,ae,se,Z)},createTestRun:(ae,se,Z=!0)=>this.j.createTestRun(W,X,ye,ae,se,Z),invalidateTestResults:ae=>{if(ae===void 0)this.h.$markTestRetired(void 0);else{const se=ae instanceof Array?ae:[ae];this.h.$markTestRetired(se.map(Z=>n.$$I.fromExtHostTestItem(Z,X).toString()))}},set resolveHandler(ae){ye.resolveHandler=ae},get resolveHandler(){return ye.resolveHandler},dispose:()=>{ne.dispose()}},te={controller:ve,collection:ye,profiles:ge,extension:W,activeProfiles:Y};return U.$registerTestController(X,_,oe()),ne.add((0,b.$Tc)(()=>U.$unregisterTestController(X))),this.g.set(X,te),ne.add((0,b.$Tc)(()=>this.g.delete(X))),ne.add(ye.onDidGenerateDiff(ae=>U.$publishDiff(X,ae.map(l.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(W,X=A.CancellationToken.None){const _=F(W);if(!_)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ce=this.g.get(_.controllerId);if(!ce)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:W.preserveFocus??!0,group:B[_.kind],targets:[{testIds:W.include?.map(ne=>n.$$I.fromExtHostTestItem(ne,ce.collection.root.id).toString())??[ce.collection.root.id],profileId:_.profileId,controllerId:_.controllerId}],exclude:W.exclude?.map(ne=>ne.id)},X)}registerTestFollowupProvider(W){return this.y.add(W),{dispose:()=>{this.y.delete(W)}}}async $getTestsRelatedToCode(W,X,_){const ce=this.F.getDocument(y.URI.revive(W));if(!ce)return[];const ne=s.Position.to(X),ye=[];return await Promise.all([...this.g.values()].map(async ge=>{let Y;try{Y=await ge.relatedCodeProvider?.provideRelatedTests?.(ce.document,ne,_)}catch(U){_.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${ge.controller.label}`,U)}if(Y){for(const U of Y)ye.push(n.$$I.fromExtHostTestItem(U,ge.controller.id).toString());ge.collection.flushDiff()}})),ye}async $getCodeRelatedToTest(W,X){const _=this.g.get(n.$$I.root(W));if(!_)return[];const ce=_.collection.tree.get(W);return ce?(await _.relatedCodeProvider?.provideRelatedCode?.(ce.actual,X))?.map(s.location.from)??[]:[]}$syncTests(){for(const{collection:W}of this.g.values())W.flushDiff();return Promise.resolve()}async $getCoverageDetails(W,X,_){return(await this.j.getCoverageDetails(W,X,_))?.map(s.TestCoverage.fromDetails)}async $disposeRun(W){this.j.disposeTestRun(W)}$configureRunProfile(W,X){this.g.get(W)?.profiles.get(X)?.configureHandler?.()}$setDefaultRunProfiles(W){const X=new Map;for(const[_,ce]of Object.entries(W)){const ne=this.g.get(_);if(!ne)continue;const ye=new Map,ge=ce.filter(U=>!ne.activeProfiles.has(U)),Y=[...ne.activeProfiles].filter(U=>!ce.includes(U));for(const U of ge)ye.set(U,!0),ne.activeProfiles.add(U);for(const U of Y)ye.set(U,!1),ne.activeProfiles.delete(U);ye.size&&X.set(_,ye)}this.w.fire(X)}async $refreshTests(W,X){await this.g.get(W)?.controller.refreshHandler?.(X)}$publishTestResults(W){this.results=Object.freeze(W.map(X=>{const _=s.TestResults.to(X);return S.set(_,X.id),_}).concat(this.results).sort((X,_)=>_.completedAt-X.completedAt).slice(0,32)),this.f.fire()}async $expandTest(W,X){const _=this.g.get(n.$$I.fromString(W).controllerId)?.collection;_&&(await _.expand(W,X<0?1/0:X),_.flushDiff())}$acceptDiff(W){this.m.applyDiff(W.map(X=>l.TestsDiffOp.deserialize({asCanonicalUri:_=>_},X)))}async $runControllerTests(W,X){return Promise.all(W.map(_=>this.G(_,!1,X)))}async $startContinuousRun(W,X){const _=new A.$xe(X),ce=await Promise.all(W.map(ne=>this.G(ne,!0,_.token)));return!X.isCancellationRequested&&!ce.some(ne=>ne.error)&&await new Promise(ne=>X.onCancellationRequested(ne)),_.dispose(!0),ce}async $provideTestFollowups(W,X){const _=this.results.find(ye=>S.get(ye)===W.resultId),ce=_&&ee(n.$$I.fromString(W.extId),_?.results);if(!ce)return[];let ne=[];return await Promise.all([...this.y].map(async ye=>{try{const ge=await ye.provideFollowup(_,ce,W.taskIndex,W.messageIndex,X);ge&&(ne=ne.concat(ge))}catch(ge){this.C.error("Error thrown while providing followup for test message",ge)}})),X.isCancellationRequested?[]:ne.map(ye=>{const ge=E++;return this.z.set(ge,ye),{title:ye.title,id:ge}})}$disposeTestFollowups(W){for(const X of W)this.z.delete(X)}$executeTestFollowup(W){const X=this.z.get(W);return X?this.D.executeCommand(X.command,...X.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(W,X){W===void 0?this.j.cancelAllRuns():this.j.cancelRunById(W,X)}getMetadataForRun(W){for(const X of this.j.trackers){const _=X.getTaskIdForRun(W);if(_)return{taskId:_,runId:X.id}}}async G(W,X,_){const ce=this.g.get(W.controllerId);if(!ce)return{};const{collection:ne,profiles:ye,extension:ge}=ce,Y=ye.get(W.profileId);if(!Y)return{};const U=W.testIds.map(ae=>ne.tree.get(ae)).filter(I.$ng),oe=W.excludeExtIds.map(ae=>ce.collection.tree.get(ae)).filter(I.$ng).filter(ae=>U.some(se=>se.fullId.compare(ae.fullId)===n.TestPosition.IsChild));if(!U.length)return{};const ve=new t.$tP(U.some(ae=>ae.actual instanceof i.$CQ)?void 0:U.map(ae=>ae.actual),oe.map(ae=>ae.actual),Y,X),te=(0,l.$bJ)(W)&&this.j.prepareForMainThreadTestRun(ge,ve,N.fromInternal(W,ce.collection),Y,_);try{return await Y.runHandler(ve,_),{}}catch(ae){return{error:String(ae)}}finally{te&&te.hasRunningTasks&&!_.isCancellationRequested&&await R.Event.toPromise(te.onEnd)}}};e.$Kqc=D,e.$Kqc=D=Je([Ve(0,f.$oQ),Ve(1,w.$bk),Ve(2,m.$KQ),Ve(3,$.$zQ)],D);const k=1e4;var P;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(P||(P={}));class p extends b.$Vc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(W,X,_,ce,ne,ye){super(),this.C=W,this.D=X,this.F=_,this.G=ce,this.H=ne,this.f=P.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new R.$me),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new A.$xe(ye));const ge=this.B(new r.$Sh(()=>this.I(),k));this.B(this.m.token.onCancellationRequested(()=>ge.schedule()));const Y=new R.$me;this.y=Y.event,this.B((0,b.$Tc)(()=>{Y.fire(),Y.dispose()}))}getTaskIdForRun(W){for(const[X,{run:_}]of this.h)if(_===W)return X}cancel(W){W?this.h.get(W)?.cts.cancel():this.f===P.Running?(this.m.cancel(),this.f=P.Cancelling):this.f===P.Cancelling&&this.I()}async getCoverageDetails(W,X,_){const[,ce]=n.$$I.fromString(W).path,ne=this.z.get(W);if(!ne)return[];const{report:ye,extIds:ge}=ne,Y=this.h.get(ce);if(!Y)throw new Error("unreachable: run task was not found");let U;if(X&&ye instanceof t.$zP){const ve=ge.indexOf(X);if(ve===-1)return[];U=ye.fromTests[ve]}return await(U?this.G?.loadDetailedCoverageForTest?.(Y.run,ye,U,_):this.G?.loadDetailedCoverage?.(Y.run,ye,_))??[]}createRun(W){const X=this.C.id,_=this.C.controllerId,ce=(0,u.$3g)(),ne=oe=>(ve,...te)=>{if(ge){this.F.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.L(ve),oe(ve,...te)},ye=(oe,ve)=>{const te=ve instanceof Array?ve.map(s.TestMessage.from):[s.TestMessage.from(ve)];if(oe.uri&&oe.range){const ae={range:s.Range.from(oe.range),uri:oe.uri};for(const se of te)se.location=se.location||ae}this.D.$appendTestMessagesInRun(X,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),te)};let ge=!1;const Y=this.B(new A.$xe(this.m.token)),U={isPersisted:this.C.isPersisted,token:Y.token,name:W,onDidDispose:this.y,addCoverage:oe=>{if(ge)return;const ve=oe instanceof t.$zP?oe.fromTests:[];if(ve.length){(0,g.$jH)(this.H,"attributableCoverage");for(const se of ve)this.L(se)}const te=oe.uri.toString(),ae=new n.$$I([X,ce,te]).toString();this.z.set(ae,{report:oe,extIds:ve.map(se=>n.$$I.fromExtHostTestItem(se,_).toString())}),this.D.$appendCoverage(X,ce,s.TestCoverage.fromFile(_,ae,oe))},enqueued:ne(oe=>{this.D.$updateTestStateInRun(X,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),l.TestResultState.Queued)}),skipped:ne(oe=>{this.D.$updateTestStateInRun(X,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),l.TestResultState.Skipped)}),started:ne(oe=>{this.D.$updateTestStateInRun(X,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),l.TestResultState.Running)}),errored:ne((oe,ve,te)=>{ye(oe,ve),this.D.$updateTestStateInRun(X,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),l.TestResultState.Errored,te)}),failed:ne((oe,ve,te)=>{ye(oe,ve),this.D.$updateTestStateInRun(X,ce,n.$$I.fromExtHostTestItem(oe,_).toString(),l.TestResultState.Failed,te)}),passed:ne((oe,ve)=>{this.D.$updateTestStateInRun(X,ce,n.$$I.fromExtHostTestItem(oe,this.C.controllerId).toString(),l.TestResultState.Passed,ve)}),appendOutput:(oe,ve,te)=>{ge||(te&&this.L(te),this.D.$appendOutputToRun(X,ce,h.$Oe.fromString(oe),ve&&s.location.from(ve),te&&n.$$I.fromExtHostTestItem(te,_).toString()))},end:()=>{ge||(ge=!0,this.D.$finishedTestRunTask(X,ce),--this.g||this.J())}};return this.g++,this.h.set(ce,{run:U,cts:Y}),this.D.$startedTestRunTask(X,{id:ce,ctrlId:this.C.controllerId,name:W||this.H.displayName||this.H.identifier.value,running:!0}),U}I(){for(const{run:W}of this.h.values())W.end()}J(){this.f!==P.Ended&&(this.f=P.Ended,this.w.fire())}L(W){if(!(W instanceof i.$BQ))throw new d.$gQ(W.id);if(this.j.has(n.$$I.fromExtHostTestItem(W,this.C.controllerId).toString()))return;const X=[],_=this.C.colllection.root;for(;;){const ce=s.TestItem.from(W);if(X.unshift(ce),this.j.has(ce.extId)||(this.j.add(ce.extId),W===_))break;W=W.parent||_}this.D.$addTestsToRun(this.C.controllerId,this.C.id,X)}dispose(){this.J(),super.dispose()}}class v{get trackers(){return this.f.values()}constructor(W,X){this.h=W,this.j=X,this.f=new Map,this.g=new Map}getCoverageDetails(W,X,_){const ce=n.$$I.root(W);return this.g.get(ce)?.getCoverageDetails(W,X,_)||[]}disposeTestRun(W){this.g.get(W)?.dispose(),this.g.delete(W);for(const[X,{id:_}]of this.f)_===W&&this.f.delete(X)}prepareForMainThreadTestRun(W,X,_,ce,ne){return this.k(X,_,ce,W,ne)}cancelRunById(W,X){this.g.get(W)?.cancel(X)}cancelAllRuns(){for(const W of this.f.values())W.cancel()}createTestRun(W,X,_,ce,ne,ye){const ge=this.f.get(ce);if(ge)return ge.createRun(ne);const Y=N.fromPublic(X,_,ce,ye),U=F(ce);this.h.$startedExtensionTestRun({controllerId:X,continuous:!!ce.continuous,profile:U&&{group:B[U.kind],id:U.profileId},exclude:ce.exclude?.map(ve=>n.$$I.fromExtHostTestItem(ve,_.root.id).toString())??[],id:Y.id,include:ce.include?.map(ve=>n.$$I.fromExtHostTestItem(ve,_.root.id).toString())??[_.root.id],preserveFocus:ce.preserveFocus??!0,persist:ye});const oe=this.k(ce,Y,ce.profile,W);return R.Event.once(oe.onEnd)(()=>{this.h.$finishedExtensionTestRun(Y.id)}),oe.createRun(ne)}k(W,X,_,ce,ne){const ye=new p(X,this.h,this.j,_,ce,ne);return this.f.set(W,ye),this.g.set(ye.id,ye),ye}}e.$Lqc=v;const F=H=>{if(H.profile){if(!(H.profile instanceof q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class N{static fromPublic(W,X,_,ce){return new N(W,(0,u.$3g)(),ce,X)}static fromInternal(W,X){return new N(W.controllerId,W.runId,!0,X)}constructor(W,X,_,ce){this.controllerId=W,this.id=X,this.isPersisted=_,this.colllection=ce}}e.$Mqc=N;class L{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(W){this.k=W,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(W){this.f.add(W)}update(W){Object.assign(W.revived,s.TestItem.toPlain(W.item)),this.f.has(W)||this.g.add(W)}remove(W){if(this.f.has(W)){this.f.delete(W);return}this.g.delete(W);const X=n.$$I.parentId(W.item.extId);if(X&&this.j.has(X.toString())){this.j.add(W.item.extId);return}this.h.add(W)}getChangeEvent(){const{f:W,g:X,h:_}=this;return{get added(){return[...W].map(ce=>ce.revived)},get updated(){return[...X].map(ce=>ce.revived)},get removed(){return[..._].map(ce=>ce.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class M extends l.$hJ{constructor(){super(...arguments),this.z=new R.$me,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(W){return this.g.get(W)}getMirroredTestDataByReference(W){return this.g.get(W.id)}y(W,X){return{...W,revived:s.TestItem.toPlain(W.item),depth:X?X.depth+1:0,children:new Set}}x(){return new L(this.z)}}class z{constructor(W){this.g=W}checkout(){this.f||(this.f=this.h());const W=this.f;return W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,get tests(){return[...W.tests.rootTests].map(X=>X.revived)},dispose:(0,T.$db)(()=>{--W.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(W){return this.f?.tests.getMirroredTestDataByReference(W)}applyDiff(W){this.f?.tests.apply(W)}h(){const W=new M({asCanonicalUri:X=>X});return this.g.$subscribeToDiffs(),{observers:0,tests:W}}}const j=(H,W,X,_)=>{X?Object.assign(X,_):W.$updateTestRunConfig(H.controllerId,H.profileId,_)};class q{#e;#t;#i;#n;#s;get label(){return this.g}set label(W){W!==this.g&&(this.g=W,j(this,this.#e,this.#n,{label:W}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(W){W!==this.h&&(this.h=W,j(this,this.#e,this.#n,{supportsContinuousRun:W}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(W){W!==this.isDefault&&(W?this.#t.add(this.profileId):this.#t.delete(this.profileId),j(this,this.#e,this.#n,{isDefault:W}))}get tag(){return this._tag}set tag(W){W?.id!==this._tag?.id&&(this._tag=W,j(this,this.#e,this.#n,{tag:W?s.TestTag.namespace(this.controllerId,W.id):null}))}get configureHandler(){return this.f}set configureHandler(W){W!==this.f&&(this.f=W,j(this,this.#e,this.#n,{hasConfigurationHandler:!!W}))}get onDidChangeDefault(){return R.Event.chain(this.#i,W=>W.map(X=>X.get(this.controllerId)?.get(this.profileId)).filter(I.$ng))}constructor(W,X,_,ce,ne,ye,ge,Y,U,oe=!1,ve=void 0,te=!1){this.controllerId=ne,this.profileId=ye,this.g=ge,this.kind=Y,this.runHandler=U,this._tag=ve,this.h=te,this.#e=W,this.#s=X,this.#t=_,this.#i=ce,X.set(ye,this);const ae=B[Y];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);oe&&_.add(ye),this.#n={profileId:ye,controllerId:ne,tag:ve?s.TestTag.namespace(this.controllerId,ve.id):null,label:ge,group:ae,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:te},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Nqc=q;const B={[t.TestRunProfileKind.Coverage]:l.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:l.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:l.TestRunProfileBitset.Run};function ee(H,W){for(let X=0;X<H.path.length;X++){const _=W.find(ce=>ce.id===H.path[X]);if(!_)return;if(X===H.path.length-1)return _;W=_.children}}}),define(ke[320],Ie([1,0,18,4,3,6,169,15,9]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=void 0,r=We(r),O=We(O);class c extends A.$Vc{constructor(y,u){super(),this.m=u,this.a=new h.$me,this.b=new h.$me,this.c=new h.$me,this.f=new h.$me,this.g=new h.$me,this.h=new h.$me,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(R.$ON.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(C=>this.h.fire(C))),this.B(this.m.onDidChangeActiveTextEditor(C=>this.g.fire(C)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const u=this.m.allEditors();return y?u:u.map(C=>C.value)}async showTextDocument(y,u,C){let w;typeof u=="number"?w={position:O.ViewColumn.from(u),preserveFocus:C}:typeof u=="object"?w={position:O.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?O.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:w={preserveFocus:!1};const a=await this.j.$tryShowTextDocument(y.uri,w),m=a&&this.m.getEditor(a);if(m)return m.value;throw a?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,u){return new T.$vQ(this.j,y,u).value}$acceptEditorPropertiesChanged(y,u){const C=this.m.getEditor(y);if(!C)throw new Error("unknown text editor");if(u.options&&C._acceptOptions(u.options),u.selections){const w=u.selections.selections.map(O.Selection.to);C._acceptSelections(w)}if(u.visibleRanges){const w=r.$Hb(u.visibleRanges.map(O.Range.to));C._acceptVisibleRanges(w)}if(u.options&&this.b.fire({textEditor:C.value,options:{...u.options,lineNumbers:O.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const w=b.TextEditorSelectionChangeKind.fromValue(u.selections.source),a=u.selections.selections.map(O.Selection.to);this.a.fire({textEditor:C.value,selections:a,kind:w})}if(u.visibleRanges){const w=r.$Hb(u.visibleRanges.map(O.Range.to));this.c.fire({textEditor:C.value,visibleRanges:w})}}$acceptEditorPositionData(y){for(const u in y){const C=this.m.getEditor(u);if(!C)throw new Error("Unknown text editor");const w=O.ViewColumn.to(y[u]);C.value.viewColumn!==w&&(C._acceptViewColumn(w),this.f.fire({textEditor:C.value,viewColumn:w}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$Upc=c}),define(ke[321],Ie([1,0,2,5,6,3,9,15,23,40,17]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Grc=e.$Frc=void 0,e.$Frc=(0,h.$Gi)("IExtHostTimeline");class y{constructor(w,a){this.b=new Map,this.c=new Map,this.a=w.getProxy(A.$ON.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(m,$)=>{if(m&&m.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(m.source)&&b.$sn.equals($,this.b.get(m.source)?.extension)){const f=m.uri===void 0?void 0:r.URI.revive(m.uri);return this.c.get(m.source)?.get(u(f))?.get(m.handle)}else return;return m}})}async $getTimeline(w,a,m,$){return this.b.get(w)?.provider.provideTimeline(r.URI.revive(a),m,$)}registerTimelineProvider(w,a,m,$){const f=new R.$Uc,i=this.d(a.id,$,f).bind(this);let s;a.onDidChange&&(s=a.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:a.id}),this));const t=this.c;return this.f({...a,scheme:w,onDidChange:void 0,async provideTimeline(o,n,d){n?.resetCache&&(f.clear(),t.get(a.id)?.clear());const l=await a.provideTimeline(o,n,d);if(l==null)return;const g=i(o,n);return{...l,source:a.id,items:l.items.map(g)}},dispose(){for(const o of t.values())o.get(a.id)?.clear();s?.dispose(),f.dispose()}},m)}d(w,a,m){return($,f)=>{let i;if(f?.cacheResults){let s=this.c.get(w);s===void 0&&(s=new Map,this.c.set(w,s));const t=u($);i=s.get(t),i===void 0&&(i=new Map,s.set(t,i))}return s=>{const{iconPath:t,...o}=s,n=`${w}|${s.id??s.timestamp}`;i?.set(n,s);let d,l,g;s.iconPath&&(t instanceof T.$PO?g={id:t.id,color:t.color}:r.URI.isUri(t)?(d=t,l=t):{light:d,dark:l}=t);let E;return T.$iO.isMarkdownString(o.tooltip)?E=O.MarkdownString.from(o.tooltip):(0,I.$fg)(o.tooltip)?E=o.tooltip:T.$iO.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=O.MarkdownString.from(o.detail)):(0,I.$fg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=o.detail),{...o,id:o.id??void 0,handle:n,source:w,command:s.command?a.toInternal(s.command,m):void 0,icon:d,iconDark:l,themeIcon:g,tooltip:E,accessibilityInformation:s.accessibilityInformation}}}}f(w,a){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:a}),(0,R.$Tc)(()=>{for(const $ of this.c.values())$.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$Grc=y;function u(C){return C?.toString()}}),define(ke[322],Ie([1,0,8,22,2,4,3,255,7,9,17,18,15,85,20,209,25]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hrc=void 0,c=We(c);function $(s,t){if((0,I.$fg)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let o;return Array.isArray(s.highlights)&&(o=s.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),o=o.length?o:void 0),{label:s.label,highlights:o}}}class f extends T.$Vc{constructor(t,o,n){super(),this.f=t,this.g=o,this.h=n,this.a=new Map,this.b=new a.$S_;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(g=>d(g)?this.r(g):g):l})}registerTreeDataProvider(t,o,n){const d=this.createTreeView(t,{treeDataProvider:o},n);return{dispose:()=>d.dispose()}}createTreeView(t,o,n){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=o.dragAndDropController?.dropMimeTypes??[],l=o.dragAndDropController?.dragMimeTypes??[],g=!!o.dragAndDropController?.handleDrag,E=!!o.dragAndDropController?.handleDrop,S=this.m(t,o,n),D={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:g,hasHandleDrop:E,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(t,D),P={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,m.$jH)(n,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,m.$jH)(n,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(p){(0,C.$7k)(p)&&(0,m.$jH)(n,"treeViewMarkdownMessage"),S.message=p},get title(){return S.title},set title(p){S.title=p},get description(){return S.description},set description(p){S.description=p},get badge(){return S.badge},set badge(p){p!==void 0&&c.ViewBadge.isViewBadge(p)?S.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(S.badge=void 0)},reveal:(p,v)=>S.reveal(p,v),dispose:async()=>{await k,this.a.delete(t),S.dispose()}};return this.B(P),P}$getChildren(t,o){const n=this.a.get(t);return n?n.getChildren(o):Promise.reject(new O.$EG(t))}async $handleDrop(t,o,n,d,l,g,E,S){const D=this.a.get(t);if(!D)return Promise.reject(new O.$EG(t));const k=u.DataTransfer.toDataTransfer(n,async P=>(await this.f.$resolveDropFileData(t,o,P)).buffer);return E===t&&S&&await this.j(k,D,S,l,g),D.onDrop(k,d,l)}async j(t,o,n,d,l){const g=this.b.removeDragOperationTransfer(l);if(g)(await g)?.forEach((E,S)=>{E&&t.set(S,E)});else if(l&&o.handleDrag){const E=o.handleDrag(n,t,d);this.b.addDragOperationTransfer(l,E),await E}return t}async $handleDrag(t,o,n,d){const l=this.a.get(t);if(!l)return Promise.reject(new O.$EG(t));const g=await this.j(new c.$LO,l,o,d,n);if(!(!g||d.isCancellationRequested))return u.DataTransfer.from(g)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new O.$EG(t);return o.hasResolve}$resolve(t,o,n){const d=this.a.get(t);if(!d)throw new O.$EG(t);return d.resolveTreeItem(o,n)}$setExpanded(t,o,n){const d=this.a.get(t);if(!d)throw new O.$EG(t);d.setExpanded(o,n)}$setSelectionAndFocus(t,o,n){const d=this.a.get(t);if(!d)throw new O.$EG(t);d.setSelectionAndFocus(o,n)}$setVisible(t,o){const n=this.a.get(t);if(!n){if(!o)return;throw new O.$EG(t)}n.setVisible(o)}$changeCheckboxState(t,o){const n=this.a.get(t);if(!n)throw new O.$EG(t);n.setCheckboxState(o)}m(t,o,n){const d=this.B(new i(t,o,this.f,this.g.converter,this.h,n));return this.a.set(t,d),d}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$Hrc=f;class i extends T.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$og)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,n,d,l,g){if(super(),this.I=t,this.J=n,this.L=d,this.M=l,this.N=g,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$me),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$me),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$me),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$me),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$me),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$me),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$me),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$xe,g.contributes&&g.contributes.views)for(const k in g.contributes.views)for(const P of g.contributes.views[k])P.id===t&&(this.P=P.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let E,S;const D=R.Event.debounce(this.F.event,(k,P)=>(k||(k={message:!1,elements:[]}),P.element!==!1&&(E||(E=new Promise(p=>S=p),this.G=this.G.then(()=>E)),Array.isArray(P.element)?k.elements.push(...P.element):k.elements.push(P.element)),P.message&&(k.message=!0),k),200,!0);this.B(D(({message:k,elements:P})=>{P.length&&(this.H=this.H.then(()=>{const p=S;return E=null,this.$(P).then(()=>p())})),k&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let n=this.X(t);return n||(n=await this.Y(o)),n?n.map(d=>d.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const n=(0,I.$og)(o.select)?!0:o.select,d=(0,I.$og)(o.focus)?!1:o.focus,l=(0,I.$og)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(g=>this.W(t,g[g.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:g.map(S=>S.item)},{select:n,focus:d,expand:l})),g=>this.M.error(g)):this.J.$reveal(this.I,void 0,{select:n,focus:d,expand:l})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const n=this.getExtensionElement(t);n&&(o?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(t,o){const n=!(0,y.$ub)(this.s,t);this.s=t;const d=this.t!==o;this.t=o,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async n=>{const d=this.getExtensionElement(n.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);o.forEach(n=>{n.treeItem.checkboxState=n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(n=>[n.extensionItem,n.newState])})}async handleDrag(t,o,n){const d=[];for(const l of t){const g=this.getExtensionElement(l);g&&d.push(g)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,o,n),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,n){const d=o?this.getExtensionElement(o):void 0;if(!(!d&&o||!this.g?.handleDrop))return(0,b.$yh)(()=>this.g?.handleDrop?this.g.handleDrop(d,t,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const n=this.j.get(t);if(n){const d=this.m.get(n);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,n,o)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(n=>this.W(o,n[n.length-1]).then(d=>(n.push(d),n))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,b.$yh)(()=>this.f.getParent(t))}W(t,o){const n=this.m.get(t);return n?Promise.resolve(n):(0,b.$yh)(()=>this.f.getTreeItem(t)).then(d=>this.kb(t,d,o,!0)).then(d=>this.getChildren(o?o.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const g=this.m.get(l);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const n=this.getExtensionElement(t);o=n?this.m.get(n):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new w.$xe(this.Z.token);try{const n=t?this.m.get(t):void 0,d=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const l=(0,y.$Hb)(d||[]),g=await Promise.all((0,y.$Hb)(l).map(S=>this.f.getTreeItem(S)));if(o.token.isCancellationRequested)return;const E=g.map((S,D)=>S?this.db(l[D],S,n):null);return(0,y.$Hb)(E)}finally{o.dispose()}}$(t){if(t.some(n=>!n))return this.Z.dispose(!0),this.Z=new w.$xe,this.tb(),this.J.$refresh(this.I);{const n=this.ab(t);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(t){const o=new Set,n=t.map(l=>this.m.get(l));for(const l of n)if(l&&!o.has(l.item.handle)){let g=l;for(;g&&g.parent&&n.findIndex(E=>g&&g.parent&&E&&E.item.handle===g.parent.item.handle)===-1;){const E=this.j.get(g.parent.item.handle);g=E?this.m.get(E):void 0}g&&!g.parent&&o.add(l.item.handle)}const d=[];return o.forEach(l=>{const g=this.j.get(l);if(g){const E=this.m.get(g);E&&(!E.parent||!o.has(E.parent.item.handle))&&d.push(l)}}),d}bb(t){const o={};return Promise.all(t.map(n=>this.cb(n).then(d=>{d&&(o[n]=d.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const n=this.m.get(o);if(n)return this.rb(o),(0,b.$yh)(()=>this.f.getTreeItem(o)).then(d=>{if(d){const l=this.ib(o,d,n.parent);return this.pb(o,l,n,n.parent),n.dispose(),l}return null})}return Promise.resolve(null)}db(t,o,n){const d=this.ib(t,o,n);if(o.id&&this.j.has(d.item.handle))throw new Error((0,r.localize)(2698,null,o.id));return this.ob(t,d),this.qb(d,n),d}eb(t){return c.$iO.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,n,d;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,n=t.checkboxState.tooltip,d=t.checkboxState.accessibilityInformation),{isChecked:o===c.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:d}}hb(t){if(!c.$GO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,n){this.hb(o);const d=this.B(new T.$Uc),l=this.kb(t,o,n),g=this.lb(o);return{item:{handle:l,parentHandle:n?n.item.handle:void 0,label:$(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(d,o.command),contextValue:o.contextValue,icon:g,iconDark:this.mb(o)||g,themeIcon:this.jb(o),collapsibleState:(0,I.$og)(o.collapsibleState)?c.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:n,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(t){return t.iconPath instanceof c.$PO?t.iconPath:void 0}kb(t,{id:o,label:n,resourceUri:d},l,g){if(o)return`${i.b}/${o}`;const E=$(n,this.N),S=l?l.item.handle:i.a;let D=E?E.label:d?(0,h.$eh)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const k=this.m.has(t)?this.m.get(t).item.handle:void 0,P=this.X(l)||[];let p,v=0;do{if(p=`${S}/${v}:${D}`,g||!this.j.has(p)||k===p)break;v++}while(v<=P.length);return p}lb(t){if(t.iconPath&&!(t.iconPath instanceof c.$PO))return typeof t.iconPath=="string"||A.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof c.$PO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return A.URI.isUri(t)?t:A.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,n,d){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(t,o);const l=this.X(d)||[],g=l.filter(E=>E.item.handle===n.item.handle)[0];g&&l.splice(l.indexOf(g),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const n of o.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const n of o.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[323],Ie([1,0,4,3,2,32,15,96,6,9]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=void 0,T=We(T),b=We(b),c=We(c);class I extends h.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(w,a,m,$){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$me),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$me),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=a,this.#n=m,this.#i=$.viewType,this.#s=$.panelOptions,this.#o=$.viewColumn,this.#r=$.title,this.#l=$.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,A.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(w){this.#u||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#l=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:T.ViewColumn.from(w),preserveFocus:!!a})}c(){if(this.#u)throw new Error("Webview is disposed")}}class y extends h.$Vc{static c(){return(0,R.$3g)()}constructor(w,a,m){super(),this.j=a,this.m=m,this.g=new Map,this.h=new Map,this.f=w.getProxy(b.$ON.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,a,m,$,f={}){const i=typeof $=="object"?$.viewColumn:$,s={viewColumn:T.ViewColumn.from(i),preserveFocus:typeof $=="object"&&!!$.preserveFocus},t=(0,O.$0pc)(w),o=y.c();this.f.$createWebviewPanel((0,O.$_pc)(w),o,a,{title:m,panelOptions:u(f),webviewOptions:(0,O.$aqc)(w,this.m,f),serializeBuffersForPostMessage:t},s);const n=this.j.createNewWebview(o,f,w);return this.createNewWebviewPanel(o,a,m,i,f,n,!0)}$onDidChangeWebviewPanelViewStates(w){const a=Object.keys(w);a.sort((m,$)=>{const f=w[m],i=w[$];return f.active?1:i.active?-1:+f.visible-+i.visible});for(const m of a){const $=this.getWebviewPanel(m);if(!$)continue;const f=w[m];$._updateViewState({active:f.active,visible:f.visible,viewColumn:T.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,a,m){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:m,extension:w}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,O.$0pc)(w)}),new c.$QN(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(w,a,m,$){const f=this.h.get(a);if(!f)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:s}=f,t=this.j.createNewWebview(w,m.webviewOptions,s),o=this.createNewWebviewPanel(w,a,m.title,$,m.panelOptions,t,m.active);await i.deserializeWebviewPanel(o,m.state)}createNewWebviewPanel(w,a,m,$,f,i,s){const t=new I(w,this.f,i,{viewType:a,title:m,viewColumn:$,panelOptions:f,active:s});return this.g.set(w,t),t}getWebviewPanel(w){return this.g.get(w)}}e.$bqc=y;function u(C){return{enableFindWidget:C.enableFindWidget,retainContextWhenHidden:C.retainContextWhenHidden}}}),define(ke[324],Ie([1,0,4,3,96,15,6,9]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Krc=void 0,T=We(T),O=We(O);class b extends h.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,u,C,w,a,m){super(),this.#s=!1,this.#l=this.B(new r.$me),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$me),this.onDidDispose=this.#u.event,this.#i=C,this.#a=w,this.#e=y,this.#t=u,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(y,u){this.d=u,this.b=new Map,this.c=new Map,this.a=y.getProxy(T.$ON.MainThreadWebviewViews)}registerWebviewViewProvider(y,u,C,w){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:C,extension:y}),this.a.$registerWebviewViewProvider((0,A.$_pc)(y),u,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$0pc)(y)}),new O.$QN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(y,u,C,w,a){const m=this.b.get(u);if(!m)throw new Error(`No view provider found for '${u}'`);const{provider:$,extension:f}=m,i=this.d.createNewWebview(y,{},f),s=new b(y,this.a,u,C,i,!0);this.c.set(y,s),await $.resolveWebviewView(s,{state:w},a)}async $onDidChangeWebviewViewVisibility(y,u){this.e(y)._setVisible(u)}async $disposeWebviewView(y){const u=this.e(y);this.c.delete(y),u.dispose(),this.d.deleteWebview(y)}e(y){const u=this.c.get(y);if(!u)throw new Error("No webview found");return u}}e.$Krc=c}),define(ke[325],Ie([1,0,75,14,11,227,27,10]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$psc=void 0;let b=class{constructor(y,u){y.addFileSystemProvider(h.Schemas.file,new c(u),{isCaseSensitive:O.$l})}};e.$psc=b,e.$psc=b=Je([Ve(0,r.$6pc),Ve(1,A.$bk)],b);class c{constructor(y){this.b=y,this.a=new R.$ur(this.b)}async stat(y){const u=await this.a.stat(y);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===T.FilePermission.Readonly?1:void 0}}readDirectory(y){return this.a.readdir(y)}createDirectory(y){return this.a.mkdir(y)}readFile(y){return this.a.readFile(y)}writeFile(y,u,C){return this.a.writeFile(y,u,{...C,unlock:!1,atomic:!1})}delete(y,u){return this.a.delete(y,{...u,useTrash:!1,atomic:!1})}rename(y,u,C){return this.a.rename(y,u,C)}copy(y,u,C){return this.a.copy(y,u,C)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(y,u){throw new Error("Method not implemented.")}}}),define(ke[326],Ie([1,0,16,66,32,34,3,6,2,19]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nsc=void 0;let I=class extends T.$Vc{constructor(u,C){super();const w=u.getProxy(O.$ON.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=b.URI.file((0,r.$kc)((0,h.tmpdir)(),(0,A.$3g)()));return await w.$download(a,m),m})}};e.$nsc=I,e.$nsc=I=Je([Ve(0,c.$oQ),Ve(1,R.$KQ)],I)}),define(ke[327],Ie([1,0,45,16,2,97,3,14,7,33]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zsc=void 0,r=We(r),h=We(h);class I extends R.$8pc{constructor(){super(...arguments),this.i=null}async g(o){const n=await super.g(o);if(n.scheme!==O.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const d=n.fsPath;let l=0;do{let g;l===0?g=d:g=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await y(g);const E=h.$kc(g,"vscode.lock"),S=await a(this.d,E,!1);if(S)return this.i=S,process.on("exit",()=>{S.dispose()}),A.URI.file(g);l++}while(l<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$zsc=I;async function y(t){try{await r.promises.stat(t);return}catch{}try{await r.promises.mkdir(t,{recursive:!0})}catch{}}const u=1e3,C=10*60*1e3;class w extends T.$Vc{constructor(o,n){super(),this.b=o,this.c=n,this.a=this.B(new b.$Rh),this.a.cancelAndSet(async()=>{const d=await m(o,n);(!d||d.pid!==process.pid)&&(o.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await r.promises.utimes(n,new Date,new Date)}catch(l){o.error(l),o.info(`Lock '${n}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(o){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+o};await c.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function a(t,o,n){try{const l={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(o,JSON.stringify(l),{flag:"wx"})}catch(l){t.error(l)}const d=await m(t,o);return!d||d.pid!==process.pid?n?(t.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),i(t,o)):(t.info(`Lock '${o}': Lock acquired.`),new w(t,o))}async function m(t,o){let n;try{n=await r.promises.readFile(o)}catch(d){return t.error(d),null}try{return JSON.parse(String(n))}catch(d){return t.error(d),null}}async function $(t,o){let n;try{n=await r.promises.stat(o)}catch(d){return t.error(d),0}return n.mtime.getTime()}function f(t){try{return process.kill(t,0),!0}catch{return!1}}async function i(t,o){const n=await m(t,o);if(!n)return t.info(`Lock '${o}': Could not read pid of lock holder.`),s(t,o);if(n.willReleaseAt){let S=n.willReleaseAt-Date.now();if(S<5e3){for(S>0?t.info(`Lock '${o}': The lockfile is scheduled to be released in ${S} ms.`):t.info(`Lock '${o}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,b.$Hh)(Math.min(100,S)),await $(t,o)===0)return s(t,o);S=n.willReleaseAt-Date.now()}return s(t,o)}}if(!f(n.pid))return t.info(`Lock '${o}': The pid ${n.pid} appears to be gone.`),s(t,o);const d=await $(t,o),l=Date.now()-d;if(l<=C)return t.info(`Lock '${o}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;t.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,b.$Hh)(2e3);const g=await $(t,o),E=Date.now()-g;return E<=C?(t.info(`Lock '${o}': The lock does not look stale, elapsed: ${E} ms, giving up.`),null):(t.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),s(t,o))}async function s(t,o){t.info(`Lock '${o}': Deleting a stale lock.`);try{await r.promises.unlink(o)}catch{}return a(t,o,!0)}}),define(ke[328],Ie([1,0,32,19,48,34]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=void 0;let T=class extends A.$rqc{constructor(b,c){super(!0,b,c)}createTerminal(b,c,I){return this.createTerminalFromOptions({name:b,shellPath:c,shellArgs:I})}createTerminalFromOptions(b,c){const I=new A.$qqc(this.a,(0,r.$3g)(),b,b.name);return this.f.push(I),I.create(b,this.R(b,c)),I.value}};e.$Urc=T,e.$Urc=T=Je([Ve(0,R.$KQ),Ve(1,h.$oQ)],T)}),define(ke[329],Ie([1,0,4,36,35,5]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.OutputChannelUpdateMode=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=void 0,e.$WM="text/x-code-output",e.$XM="output",e.$YM="Log",e.$ZM="text/x-code-log-output",e.$1M="log",e.$2M="workbench.panel.output",e.$3M=new A.$Xj("inOutput",!1),e.$4M=new A.$Xj("activeLogOutput",!1),e.$5M=new A.$Xj("activeLogOutput.levelSettable",!1),e.$6M=new A.$Xj("activeLogOutput.level",""),e.$7M=new A.$Xj("activeLogOutput.levelIsDefault",!1),e.$8M=new A.$Xj("outputView.scrollLock",!1),e.$9M=(0,R.$Gi)("outputService");var T;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.$0M={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new r.$me,this.onDidRegisterChannel=this.b.event,this.c=new r.$me,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(I=>c.push(I)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}h.$so.add(e.$0M.OutputChannels,new O),e.$$M=new A.$Xj("activeOutputChannel","")}),define(ke[170],Ie([1,0,6,5,19,23,11,329,75,29,62,212,21,17,27,4,3]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orc=e.$nrc=void 0;class $ extends T.$hk{get disposed(){return this.n}constructor(t,o,n,d,l){super(),this.id=t,this.name=o,this.r=n,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,O.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=u.$Oe.fromString(o).byteLength,(0,T.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class f extends ${appendLine(t){this.append(t)}}let i=class{constructor(t,o,n,d,l,g){this.i=o,this.j=n,this.k=d,this.l=l,this.m=g,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(r.$ON.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,y.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,n]of this.g)n.visible=o===this.h}createOutputChannel(t,o,n){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const d=typeof o=="object"&&o.log,l=(0,C.$fg)(o)?o:void 0;if((0,C.$fg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const E=this.i.environment.extensionLogLevel?.find(([D])=>R.$sn.equals(n.identifier,D))?.[1];E&&(g=(0,T.$sk)(E));const S=d?this.o(t,g,n):this.n(t,l,n);return S.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(t,g??this.m.getLevel(),S):this.q(t,S)}async n(t,o,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,l,o,n.identifier.value);return new $(E,t,g,this.a,n)}async o(t,o,n){const d=await this.p(n),l=t.replace(/[\\/:\*\?"<>\|]/g,""),g=this.k.extUri.joinPath(d,`${l}.log`),E=`${n.identifier.value}.${l}`,S=this.l.createLogger(g,{id:E,name:t,logLevel:o,extensionId:n.identifier.value});return new f(E,t,S,this.a,n)}p(t){let o=this.d.get(t.identifier.value);if(!o){const n=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(n)}catch(d){if((0,w.$rl)(d)!==w.FileSystemProviderErrorCode.FileExists)throw d}return n})())}return o}q(t,o){let n=!1;const d=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return t},append(l){d(),o.then(g=>g.append(l))},appendLine(l){d(),o.then(g=>g.appendLine(l))},clear(){d(),o.then(l=>l.clear())},replace(l){d(),o.then(g=>g.replace(l))},show(l,g){d(),o.then(E=>E.show(l,g))},hide(){d(),o.then(l=>l.hide())},dispose(){n=!0,o.then(l=>l.dispose())}}}r(t,o,n){const d=new m.$Uc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},g=d.add(new a.$me);function E(S){o=S,g.fire(S)}return n.then(S=>{d.add(S),S.logLevel!==o&&E(S.logLevel),d.add(S.onDidChangeLogLevel(D=>E(D)))}),{...this.q(t,n),get logLevel(){return o},onDidChangeLogLevel:g.event,trace(S,...D){l(),n.then(k=>k.trace(S,...D))},debug(S,...D){l(),n.then(k=>k.debug(S,...D))},info(S,...D){l(),n.then(k=>k.info(S,...D))},warn(S,...D){l(),n.then(k=>k.warn(S,...D))},error(S,...D){l(),n.then(k=>k.error(S,...D))},dispose(){d.dispose()}}}};e.$nrc=i,e.$nrc=i=Je([Ve(0,A.$oQ),Ve(1,c.$EQ),Ve(2,b.$6pc),Ve(3,I.$Ipc),Ve(4,T.$ck),Ve(5,T.$bk)],i),e.$orc=(0,h.$Gi)("IExtHostOutputService")}),define(ke[171],Ie([1,0,5,7]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=void 0,e.$Xm=(0,r.$Gi)("remoteAgentService"),e.$Ym=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let R=1/0;for(let O=0;O<this.maxSampleCount;O++){const b=await A.getRoundTripTime();if(b===void 0)return;R=Math.min(R,b/2),await(0,h.$Hh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(R):T=this.initial.reduce((O,b)=>O+b,0)/this.initial.length,this.lastMeasurement={initial:T,current:R,average:this.average.reduce((O,b)=>O+b,0)/this.average.length,high:typeof T>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>T*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[330],Ie([1,0,8,70,36,47,46,3,4,171,10,24,7,151]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=void 0,e.$hL=Object.freeze({id:"application",order:100,title:(0,r.localize)(3958,null),type:"object"}),e.$iL=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(3959,null),type:"object"}),e.$jL=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(3960,null),type:"object",order:7}),e.$kL=Object.freeze({id:"problems",title:(0,r.localize)(3961,null),type:"object",order:101}),e.$lL=Object.freeze({id:"window",order:8,title:(0,r.localize)(3962,null),type:"object"}),e.$mL={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new b.$me,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const a=new w;A.$so.add(e.$mL.ConfigurationMigration,a);let m=class extends O.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(s,t){super(),this.a=s,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const n of o.added)await this.f(n,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(s){await this.f(void 0,s);for(const t of this.b.getWorkspace().folders)await this.f(t,s)}async f(s,t){await Promise.all([t.map(o=>this.g(o,s?.uri))])}async g(s,t){const o=this.a.inspect(s.key,{resource:t}),n=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE],["workspaceFolder",T.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE]];for(const[d,l]of n){const g=o[d];if(!g)continue;const E=[];if(g.value!==void 0){const S=await this.h(s,d,g.value,t,void 0);for(const D of S??[])E.push([D,[]])}for(const{identifiers:S,value:D}of g.overrides??[])if(D!==void 0){const k=await this.h(s,d,D,t,S);for(const P of k??[])E.push([P,S])}E.length&&await Promise.allSettled(E.map(async([[S,D],k])=>this.a.updateValue(S,D.value,{resource:t,overrideIdentifiers:k},l)))}}async h(s,t,o,n,d){const l=E=>{const D=this.a.inspect(E,{resource:n})[t];if(D)return d?D.overrides?.find(({identifiers:k})=>(0,y.$jo)(k,d))?.value:D.value},g=await s.migrateFn(o,l);return Array.isArray(g)?g:[[s.key,g]]}};e.$nL=m,e.$nL=m=Je([Ve(0,T.$aj),Ve(1,R.$Pi)],m);let $=class extends O.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(s){super(),this.b=s,this.a=new u.$4h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;A.$so.as(h.$xo.Configuration).registerConfiguration({...e.$jL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(3963,null)},default:[],markdownDescription:(0,r.localize)(3964,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(3965,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$oL=$,e.$oL=$=Je([Ve(0,c.$Xm)],$),e.$pL="window.newWindowProfile";let f=class extends O.$Vc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(s,t){super(),this.c=s,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==T.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$pL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const s=A.$so.as(h.$xo.Configuration),t={...e.$lL,properties:{[e.$pL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,r.localize)(3966,null)],description:(0,r.localize)(3967,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?s.updateConfigurations({add:[t],remove:[this.a]}):s.registerConfiguration(t),this.a=t}h(){const s=this.f.getValue(e.$pL);this.b=s?this.c.profiles.find(t=>t.name===s):void 0}j(){const s=this.f.getValue(e.$pL);if(!s)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;s!==t?.name&&this.f.updateValue(e.$pL,t?.name)}};e.$qL=f,e.$qL=f=Je([Ve(0,C.$Nl),Ve(1,T.$aj)],f)}),define(ke[331],Ie([1,0,38,14,16,22,8,330,70,5,36]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$sL=e.$rL=void 0,e.$tL=a,e.$uL=m,r=We(r),e.$rL=(0,c.$Gi)("editorResolverService"),e.$sL="workbench.editorAssociations";const y=I.$so.as(b.$xo.Configuration),u={...O.$iL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(12094,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var C;(function($){$.builtin="builtin",$.option="option",$.exclusive="exclusive",$.default="default"})(C||(e.RegisteredEditorPriority=C={}));var w;(function($){$[$.ABORT=1]="ABORT",$[$.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function a($){switch($){case C.exclusive:return 5;case C.default:return 4;case C.builtin:return 3;case C.option:default:return 1}}function m($,f){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(f.scheme))return!1;const t=typeof $=="string"&&$.indexOf(A.$hc.sep)>=0?`${f.scheme}:${f.path}`:(0,R.$eh)(f);return r.$Ak(typeof $=="string"?$.toLowerCase():$,t.toLowerCase())}}),define(ke[332],Ie([1,0,31,14,16,10,22,2,5,247,47,159,171]),function($e,e,r,h,A,R,T,O,b,c,I,y,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=void 0,e.$qN=(0,b.$Gi)("pathService");let w=C=class{constructor(m,$,f,i){this.d=m,this.e=$,this.f=f,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??m})()}hasValidBasename(m,$,f){return typeof $=="string"||typeof $>"u"?this.a.then(i=>this.h(m,i,$)):this.h(m,$,f)}h(m,$,f){return m.scheme===h.Schemas.file||m.scheme===h.Schemas.vscodeRemote?(0,r.$Dg)(f??(0,T.$eh)(m),$===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return C.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,$){if(m.remoteAuthority)return h.Schemas.vscodeRemote;const f=(0,c.$nN)($.getWorkspace());if(f)return f;const i=$.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=$.getWorkspace().configuration;return s?s.scheme:h.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===R.OperatingSystem.Windows?A.$gc:A.$hc)}async fileURI(m){let $="";if(await this.a===R.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?($=m.substring(2),m="/"):($=m.substring(2,i),m=m.substring(i)||"/")}return O.URI.from({scheme:h.Schemas.file,authority:$,path:m,query:"",fragment:""})}};e.$rN=w,e.$rN=w=C=Je([Ve(1,u.$Xm),Ve(2,y.$_M),Ve(3,I.$Pi)],w)}),define(ke[333],Ie([1,0,8,59,4,60,3,2,46,216,11,71,152,92,47,159,25,20,17,24,35]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.OnPortForward=e.$eN=e.$dN=e.TunnelSource=e.TunnelCloseReason=e.$bN=e.$aN=void 0,e.$cN=l,e.$fN=S,e.$gN=D,e.$hN=k,e.$iN=p,r=We(r);const t=10*1e3,o="remote.tunnels.toRestore",n="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$aN="onTunnel",e.$bN=new s.$Xj("forwardedPortsViewEnabled",!1,r.localize(12477,null));function l(N){const L=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(L)return{host:L[1]?.substring(0,L[1].length-1)||"localhost",port:Number(L[2])}}var g;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(g||(e.TunnelCloseReason=g={}));var E;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(E||(e.TunnelSource=E={})),e.$dN={source:E.User,description:r.localize(12478,null)},e.$eN={source:E.Auto,description:r.localize(12479,null)};function S(N,L,M){const z=N.get(k(L,M));if(z)return z;if((0,C.$Mw)(L))for(const j of C.$Lw){const q=k(j,M);if(N.has(q))return N.get(q)}else if((0,C.$Ow)(L))for(const j of C.$Nw){const q=k(j,M);if(N.has(q))return N.get(q)}}function D(N,L,M){const z=S(N,L,M);if(z)return z;const j=(0,C.$Ow)(L)?"localhost":(0,C.$Mw)(L)?"0.0.0.0":void 0;if(j)return S(N,j,M)}function k(N,L){return N+":"+L}var P;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(P||(e.OnPortForward=P={}));function p(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class v extends T.$Vc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(L){super(),this.r=L,this.j=[],this.n=new A.$me,this.onDidChangeAttributes=this.n.event,this.B(L.onDidChangeConfiguration(M=>{(M.affectsConfiguration(v.c)||M.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(L,M,z){let j=this.w(L,M,z,this.j,0);const q={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const B=this.j[j];B.key===L?(q.onAutoForward=B.onAutoForward??q.onAutoForward,q.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:q.elevateIfNeeded,q.label=B.label??q.label,q.requireLocalPort=B.requireLocalPort,q.protocol=B.protocol):(q.onAutoForward=q.onAutoForward??B.onAutoForward,q.elevateIfNeeded=q.elevateIfNeeded!==void 0?q.elevateIfNeeded:B.elevateIfNeeded,q.label=q.label??B.label,q.requireLocalPort=q.requireLocalPort!==void 0?q.requireLocalPort:void 0,q.protocol=q.protocol??B.protocol),j=this.w(L,M,z,this.j,j+1)}return q.onAutoForward!==void 0||q.elevateIfNeeded!==void 0||q.label!==void 0||q.requireLocalPort!==void 0||q.protocol!==void 0?q:this.C()}t(L){return L.start!==void 0&&L.end!==void 0}u(L){return L.host!==void 0&&L.port!==void 0&&(0,f.$fg)(L.host)&&(0,f.$jg)(L.port)}w(L,M,z,j,q){if(q>=j.length)return-1;const B=!(0,C.$Mw)(M)&&!(0,C.$Ow)(M),H=j.slice(q).findIndex(W=>(0,f.$jg)(W.key)?B?!1:W.key===L:this.t(W.key)?B?!1:L>=W.key.start&&L<=W.key.end:this.u(W.key)?L===W.key.port&&M===W.key.host:z?W.key.test(z):!1);return H>=0?H+q:-1}y(){const L=this.r.getValue(v.c);if(!L||!(0,f.$hg)(L))return[];const M=[];for(const j in L){if(j===void 0)continue;const q=L[j];let B;if(Number(j))B=Number(j);else if((0,f.$fg)(j))if(v.g.test(j)){const ee=j.match(v.g);B={start:Number(ee[1]),end:Number(ee[2])}}else if(v.h.test(j)){const ee=j.match(v.h);B={host:ee[1],port:Number(ee[2])}}else{let ee;try{ee=RegExp(j)}catch{}ee&&(B=ee)}B&&M.push({key:B,elevateIfNeeded:q.elevateIfNeeded,onAutoForward:q.onAutoForward,label:q.label,requireLocalPort:q.requireLocalPort,protocol:q.protocol})}const z=this.r.getValue(v.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(M)}z(L){function M(z,j){return(0,f.$jg)(z.key)?z.key:j.t(z.key)?z.key.start:j.u(z.key)?z.key.port:Number.MAX_VALUE}return L.sort((z,j)=>M(z,this)-M(j,this))}C(){return this.m}static providedActionToAction(L){switch(L){case C.ProvidedOnAutoForward.Notify:return P.Notify;case C.ProvidedOnAutoForward.OpenBrowser:return P.OpenBrowser;case C.ProvidedOnAutoForward.OpenBrowserOnce:return P.OpenBrowserOnce;case C.ProvidedOnAutoForward.OpenPreview:return P.OpenPreview;case C.ProvidedOnAutoForward.Silent:return P.Silent;case C.ProvidedOnAutoForward.Ignore:return P.Ignore;default:return}}async addAttributes(L,M,z){const q=this.r.inspect(v.c).userRemoteValue;let B;!q||!(0,f.$hg)(q)?B={}:B=(0,i.$fo)(q),B[`${L}`]||(B[`${L}`]={});for(const ee in M)B[`${L}`][ee]=M[ee];return this.r.updateValue(v.c,B,z)}}e.$jN=v;let F=class extends T.$Vc{constructor(L,M,z,j,q,B,ee,H,W,X){super(),this.H=L,this.I=M,this.J=z,this.L=j,this.M=q,this.N=B,this.O=ee,this.P=H,this.Q=W,this.R=X,this.c=new Map,this.g=new A.$me,this.onForwardPort=this.g.event,this.h=new A.$me,this.onClosePort=this.h.event,this.j=new A.$me,this.onPortName=this.j.event,this.n=new A.$me,this.onCandidatesChanged=this.n.event,this.t=new A.$me,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$me,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(z),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async _=>{const ce=await this.getAttributes(_.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of _)if(ne.localAddress){const ye=k(ne.tunnelRemoteHost,ne.tunnelRemotePort),ge=D(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(ye,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:ce?.get(ne.tunnelRemotePort)?.protocol??C.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ce?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,name:ce?.get(ne.tunnelRemotePort)?.label,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:ne.privacy,source:e.$dN}),this.f.set(ye,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async _=>{const ce=k(_.tunnelRemoteHost,_.tunnelRemotePort);if(!D(this.forwarded,_.tunnelRemoteHost,_.tunnelRemotePort)&&!D(this.detected,_.tunnelRemoteHost,_.tunnelRemotePort)&&!D(this.c,_.tunnelRemoteHost,_.tunnelRemotePort)&&_.localAddress){const ne=D(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort),ye=(await this.getAttributes([{port:_.tunnelRemotePort,host:_.tunnelRemoteHost}]))?.get(_.tunnelRemotePort);this.forwarded.set(ce,{remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localAddress:_.localAddress,protocol:ye?.protocol??C.TunnelProtocol.Http,localUri:await this.X(_.localAddress,ye),localPort:_.tunnelLocalPort,name:ye?.label,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:_.privacy,source:e.$dN})}await this.cb(),this.f.set(ce,_),this.g.fire(this.forwarded.get(ce))})),this.B(this.H.onTunnelClosed(_=>this.W(_,g.Other))),this.U()}S(){return this.Q.extensions.find(L=>L.activationEvents?.includes(e.$aN))?(this.R.createKey(e.$bN.key,!0),!0):!1}U(){if(this.S())return;const L=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&L.dispose()}))}async W(L,M){const z=k(L.host,L.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.cb(),this.h.fire(L))}X(L,M){if(L.startsWith("http"))return O.URI.parse(L);const z=M?.protocol??"http";return O.URI.parse(`${z}://${L}`)}async Y(L){const M=this.N.getWorkspace(),z=M.configuration?(0,R.$uj)(M.configuration.path):M.folders.length>0?(0,R.$uj)(M.folders[0].uri.path):void 0;if(z===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${L}.${this.L.remoteAuthority}.${z}`}async Z(){return this.Y(o)}async $(){return this.Y(n)}async ab(){const L=this.I.get(o,u.StorageScope.WORKSPACE);if(L)return this.I.remove(o,u.StorageScope.WORKSPACE),await this.cb(),L;const M=await this.Z();if(M)return this.I.get(M,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const L=await this.s;if(L&&L!==this.y){const M=JSON.parse(L)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(z=>z.remotePort).join(", ")}`);for(const z of M){const j=D(this.detected,z.remoteHost,z.remotePort);z.source.source!==E.Extension&&!j||z.source.source===E.Extension&&j?await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,elevateIfNeeded:!0,source:z.source}):z.source.source===E.Extension&&!j&&this.D.set(k(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const L=await this.Z();this.w=this.B(new T.$Uc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async M=>{M.key===L&&(this.s=Promise.resolve(this.I.get(L,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const L=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(M=>M.startsWith(n));for(const M of L){const z=this.I.getNumber(M,u.StorageScope.PROFILE);if(z&&z<Date.now()){this.s=Promise.resolve(void 0);const j=M.replace(n,o);this.I.remove(M,u.StorageScope.PROFILE),this.I.remove(j,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const L=Array.from(this.forwarded.values()),M=L.map(B=>({remoteHost:B.remoteHost,remotePort:B.remotePort,localPort:B.localPort,name:B.name,localAddress:B.localAddress,localUri:B.localUri,protocol:B.protocol,source:B.source}));let z;L.length>0&&(z=JSON.stringify(M));const j=await this.Z(),q=await this.$();!z&&j&&q?(this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(q,u.StorageScope.PROFILE)):z!==this.y&&j&&q&&(this.I.store(j,z,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(q,Date.now()+d,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=z}}async eb(L,M,z){if(!L.tunnelLocalPort||!z?.requireLocalPort||L.tunnelLocalPort===M)return;const j=new Date;if(this.db.getTime()+t>j.getTime())return;this.db=j;const q=r.localize(12480,null,M,L.tunnelRemotePort,L.tunnelLocalPort);return this.P.info(q)}async forward(L,M){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(L,M)}async fb(L,M){await this.Q.activateByEvent(e.$aN);const z=D(this.forwarded,L.remote.host,L.remote.port);M=M??(M!==null?(await this.getAttributes([L.remote]))?.get(L.remote.port):void 0);const j=L.local!==void 0?L.local:L.remote.port;let q;if(z)return this.hb(z,L,M);{const B=this.L.remoteAuthority,ee=B?{getAddress:async()=>(await this.M.resolveAuthority(B)).authority}:void 0,H=k(L.remote.host,L.remote.port);this.c.set(H,!0),L=this.gb(H,L);const W=await this.H.openTunnel(ee,L.remote.host,L.remote.port,void 0,j,L.elevateIfNeeded?L.elevateIfNeeded:M?.elevateIfNeeded,L.privacy,M?.protocol);if(typeof W=="string")q=W;else if(W&&W.localAddress){const X=D(this.m??new Map,L.remote.host,L.remote.port),_=W.protocol?W.protocol===C.TunnelProtocol.Https?C.TunnelProtocol.Https:C.TunnelProtocol.Http:M?.protocol??C.TunnelProtocol.Http,ce={remoteHost:W.tunnelRemoteHost,remotePort:W.tunnelRemotePort,localPort:W.tunnelLocalPort,name:M?.label??L.name,closeable:!0,localAddress:W.localAddress,protocol:_,localUri:await this.X(W.localAddress,M),runningProcess:X?.detail,hasRunningProcess:!!X,pid:X?.pid,source:L.source??e.$dN,privacy:W.privacy};return this.forwarded.set(H,ce),this.f.set(H,W),this.c.delete(H),await this.cb(),await this.eb(W,j,M),this.g.fire(ce),W}this.c.delete(H)}return q}gb(L,M){const z=this.D.has(L)?this.D:this.F.has(L)?this.F:void 0;if(z){const j=z.get(L);z.delete(L),j&&(M.name=j.name??M.name,M.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??M.local,M.privacy=M.privacy)}return M}async hb(L,M,z){const j=z?.label??M.name;let q;(function(ee){ee[ee.None=0]="None",ee[ee.Fire=1]="Fire",ee[ee.Reopen=2]="Reopen"})(q||(q={}));let B=q.None;switch(j!==L.name&&(L.name=j,B=q.Fire),(z?.protocol||L.protocol!==C.TunnelProtocol.Http)&&z?.protocol!==L.protocol&&(M.source=L.source,B=q.Reopen),M.privacy&&L.privacy!==M.privacy&&(B=q.Reopen),B){case q.Fire:{this.g.fire();break}case q.Reopen:await this.close(L.remoteHost,L.remotePort,g.User),await this.fb(M,z)}return D(this.f,M.remote.host,M.remote.port)}async name(L,M,z){const j=D(this.forwarded,L,M),q=k(L,M);if(j){j.name=z,await this.cb(),this.j.fire({host:L,port:M});return}else this.detected.has(q)&&(this.detected.get(q).name=z,this.j.fire({host:L,port:M}))}async close(L,M,z){const j=k(L,M),q=this.forwarded.get(j);return z===g.AutoForwardEnd&&q&&q.source.source===E.Auto&&this.F.set(j,{local:q.localPort,name:q.name,privacy:q.privacy}),await this.H.closeTunnel(L,M),this.W({host:L,port:M},z)}address(L,M){const z=k(L,M);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(L){if(L)for(const M of L){const z=D(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),j=typeof M.localAddress=="string"?M.localAddress:k(M.localAddress.host,M.localAddress.port);this.detected.set(k(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:j,protocol:C.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:C.TunnelPrivacyId.ConstantPrivate,source:{source:E.Extension,description:r.localize(12481,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,j,C.TunnelPrivacyId.ConstantPrivate,C.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(L){this.r=L}async setCandidates(L){let M=L;this.r&&(M=await this.r(L));const z=this.ib(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(j=>j.port).join(", ")}`),this.n.fire(z)}ib(L){const M=this.m??new Map,z=new Map;return this.m=z,L.forEach(j=>{const q=k(j.host,j.port);z.set(q,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),M.has(q)&&M.delete(q);const B=D(this.forwarded,j.host,j.port);B&&(B.runningProcess=j.detail,B.hasRunningProcess=!0,B.pid=j.pid)}),M.forEach((j,q)=>{const B=l(q);if(!B)return;const ee=D(this.forwarded,B.host,B.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0);const H=D(this.detected,B.host,B.port);H&&(H.runningProcess=void 0,H.hasRunningProcess=!1,H.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const L=Array.from(this.forwarded.values()),M=await this.getAttributes(L.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(M)for(const z of L){const j=M.get(z.remotePort);(j?.protocol||z.protocol!==C.TunnelProtocol.Http)&&j?.protocol!==z.protocol&&await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},j),j&&j.label&&j.label!==z.name&&await this.name(z.remoteHost,z.remotePort,j.label)}}async getAttributes(L,M=!0){const z=new Map,j=new Map;L.forEach(W=>{const X=D(this.m??new Map,C.$Lw[0],W.port)??W;if(X){z.set(W.port,X);const _=p(X)?X.pid:void 0;j.has(_)||j.set(_,[]),j.get(_)?.push(W.port)}});const q=new Map;if(L.forEach(W=>{const X=this.configPortsAttributes.getAttributes(W.port,W.host,z.get(W.port)?.detail);X&&q.set(W.port,X)}),this.G.length===0||!M)return q.size>0?q:void 0;const B=await Promise.all(this.G.flatMap(W=>Array.from(j.entries()).map(X=>{const _=X[1],ce=z.get(_[0]);return W.providePortAttributes(_,ce?.pid,ce?.detail,$.CancellationToken.None)}))),ee=new Map;if(B.forEach(W=>W.forEach(X=>{X&&ee.set(X.port,X)})),!q&&!ee)return;const H=new Map;return L.forEach(W=>{const X=q.get(W.port),_=ee.get(W.port);H.set(W.port,{elevateIfNeeded:X?.elevateIfNeeded,label:X?.label,onAutoForward:X?.onAutoForward??v.providedActionToAction(_?.autoForwardAction),requireLocalPort:X?.requireLocalPort,protocol:X?.protocol})}),H}addAttributesProvider(L){this.G.push(L)}};e.$kN=F,Je([(0,h.$_h)(1e3)],F.prototype,"cb",null),e.$kN=F=Je([Ve(0,C.$Gw),Ve(1,u.$jq),Ve(2,b.$aj),Ve(3,a.$_M),Ve(4,y.$Sl),Ve(5,w.$Pi),Ve(6,I.$bk),Ve(7,c.$_w),Ve(8,m.$fH),Ve(9,s.$Yj)],F)}),define(ke[99],Ie([1,0,18]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageTypeNew=e.ExcludeSettingOptions=e.$4L=e.$3L=e.TextSearchCompleteMessageType=e.$2L=e.$1L=void 0,e.$5L=y;class h{constructor(C,w){this.line=C,this.character=w}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,w){return new h(0,0)}with(C){return new h(0,0)}}e.$1L=h;class A{constructor(C,w,a,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(C,w),this.end=new h(a,m)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new A(0,0,0,0)}with(C){return new A(0,0,0,0)}}e.$2L=A;var R;(function(u){u[u.Information=1]="Information",u[u.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}));class T{constructor(C,w,a){this.uri=C,this.ranges=w,this.previewText=a}}e.$3L=T;class O{constructor(C,w,a){this.uri=C,this.text=w,this.lineNumber=a}}e.$4L=O;var b;(function(u){u[u.None=1]="None",u[u.FilesExclude=2]="FilesExclude",u[u.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(b||(e.ExcludeSettingOptions=b={}));var c;(function(u){u[u.Information=1]="Information",u[u.Warning=2]="Warning"})(c||(e.TextSearchCompleteMessageTypeNew=c={}));function I(u){return"uri"in u&&"ranges"in u&&"preview"in u}function y(u){if(I(u)){const C=(0,r.$2b)(u.ranges).map(w=>({sourceRange:w,previewRange:w}));return new T(u.uri,C,u.preview.text)}else return new O(u.uri,u.text,u.lineNumber)}}),define(ke[37],Ie([1,0,18,38,24,31,12,5,16,13,99,7]),function($e,e,r,h,A,R,T,O,b,c,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$qM=e.$jM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$gM=e.$fM=e.$eM=e.$dM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.TextSearchCompleteMessageType=void 0,e.$aM=$,e.$bM=f,e.$cM=i,e.$hM=S,e.$iM=D,e.$kM=p,e.$lM=v,e.$mM=F,e.$nM=N,e.$oM=L,e.$pM=M,e.$rM=j,e.$tM=ee,e.$uM=H,h=We(h),A=We(A),R=We(R),b=We(b),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$6L="workbench.view.search",e.$7L="workbench.panel.search",e.$8L="workbench.view.search",e.$9L="search-result",e.$0L="search.exclude",e.$$L=2e4;const u="\u27EA ",C=" characters skipped \u27EB",w=(u.length+C.length+5)*2;e.$_L=(0,O.$Gi)("searchService");var a;(function(X){X[X.file=0]="file",X[X.text=1]="text",X[X.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.aiText=3]="aiText"})(m||(e.QueryType=m={}));function $(X){return!!X.preview}function f(X){return!!X.resource}function i(X){return!!X.message}var s;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class t{constructor(_){this.resource=_,this.results=[]}}e.$dM=t;class o{constructor(_,ce,ne,ye){this.ranges=ce,this.webviewIndex=ye;const ge=Array.isArray(ce)?ce:[ce];if(ne&&ne.matchLines===1&&n(ge)){_=(0,T.$$f)(_,ne.matchLines);let Y="",U=0,oe=0;const ve=Math.floor(ne.charsPerLine/5),te=[];for(const ae of ge){const se=Math.max(ae.startColumn-ve,0),Z=ae.startColumn+ne.charsPerLine;if(se>oe+ve+w){const re=u+(se-oe)+C;Y+=re+_.slice(se,Z),U+=se-(oe+re.length)}else Y+=_.slice(oe,Z);te.push(new l(0,ae.startColumn-U,ae.endColumn-U)),oe=Z}this.preview={text:Y,matches:Array.isArray(this.ranges)?te:te[0]}}else{const Y=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:_,matches:(0,r.$1b)(ce,U=>new d(U.startLineNumber-Y,U.startColumn,U.endLineNumber-Y,U.endColumn))}}}}e.$eM=o;function n(X){const _=X[0].startLineNumber;for(const ce of X)if(ce.startLineNumber!==_||ce.endLineNumber!==_)return!1;return!0}class d{constructor(_,ce,ne,ye){this.startLineNumber=_,this.startColumn=ce,this.endLineNumber=ne,this.endColumn=ye}}e.$fM=d;class l extends d{constructor(_,ce,ne){super(_,ce,_,ne)}}e.$gM=l;var g;(function(X){X.List="list",X.Tree="tree"})(g||(e.ViewMode=g={}));var E;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function S(X,_=!0){const ce=X&&X.files&&X.files.exclude,ne=_&&X&&X.search&&X.search.exclude;if(!ce&&!ne)return;if(!ce||!ne)return ce||ne||void 0;let ye=Object.create(null);return ye=A.$io(ye,A.$fo(ce)),ye=A.$io(ye,A.$fo(ne),!0),ye}function D(X,_){return X.excludePattern&&h.$Ak(X.excludePattern,_)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&h.$Ak(X.includePattern,_)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(ce=>{const ne=ce.folder.fsPath;if(R.$Fg(_,ne)){const ye=b.$mc(ne,_);return!ce.includePattern||!!h.$Ak(ce.includePattern,ye)}else return!1}):!1:!0}var k;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class P extends Error{constructor(_,ce){super(_),this.code=ce}}e.$jM=P;function p(X){const _=X.message;if((0,c.$4)(X))return new P(_,k.canceled);try{const ce=JSON.parse(_);return new P(ce.message,ce.code)}catch{return new P(_,k.other)}}function v(X){const _={message:X.message,code:X.code};return new Error(JSON.stringify(_))}function F(X){return X.type==="error"?!0:X.type==="success"}function N(X){return X.type==="success"}function L(X){return!!X.path}function M(X,_,ce=!0){const ne=X.searchPath?X.searchPath:X.relativePath;return ce?(0,T.$8f)(ne,_):h.$Ak(_,ne)}class z{constructor(_){this.path=_,this.results=[]}addMatch(_){this.results.push(_)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$qM=z;function j(X,_){const ce={...X||{},..._||{}};return Object.keys(ce).filter(ne=>{const ye=ce[ne];return typeof ye=="boolean"&&ye})}class q{constructor(_,ce){this.c=null,this.a={..._.excludePattern||{},...ce.excludePattern||{}},this.b=h.$Bk(this.a);let ne=_.includePattern;ce.includePattern&&(ne?ne={...ne,...ce.includePattern}:ne=ce.includePattern),ne&&(this.c=h.$Bk(ne))}matchesExcludesSync(_,ce,ne){return!!(this.b&&this.b(_,ce,ne))}includedInQuerySync(_,ce,ne){return!(this.b&&this.b(_,ce,ne)||this.c&&!this.c(_,ce,ne))}includedInQuery(_,ce,ne){const ye=this.b(_,ce,ne),ge=()=>this.c?!!this.c(_,ce,ne):!0;return(0,y.$sh)(ye)?ye.then(Y=>Y?!1:ge()):ge()}hasSiblingExcludeClauses(){return B(this.a)}}e.$sM=q;function B(X){for(const _ in X)if(typeof X[_]!="boolean")return!0;return!1}function ee(X){if(!X)return;let _;return ce=>(_||(_=(X()||Promise.resolve([])).then(ne=>ne?W(ne):{})),_.then(ne=>!!ne[ce]))}function H(X){if(!X)return;let _;return ce=>{if(!_){const ne=X();_=ne?W(ne):{}}return!!_[ce]}}function W(X){const _={};for(const ce of X)_[ce]=!0;return _}}),define(ke[49],Ie([1,0,18,7,20,4,3,84,14,134,22,12,2,8,27,5,11,230,47,62,29,19,15,9,72,37,6,44]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n,d,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=e.$Zpc=void 0;function S(L,M,z){return new I.$9g(j=>p(j,z)).isEqual(L,M)}function D(L,M,z){return S(L.uri,M.uri,z)?0:(0,y.$zf)(L.uri.toString(),M.uri.toString())}function k(L,M,z){return L.index!==M.index?L.index<M.index?-1:1:S(L.uri,M.uri,z)?(0,y.$zf)(L.name,M.name):(0,y.$zf)(L.uri.toString(),M.uri.toString())}function P(L,M,z,j){const q=L.slice(0).sort((ee,H)=>z(ee,H,j)),B=M.slice(0).sort((ee,H)=>z(ee,H,j));return(0,r.$Eb)(q,B,(ee,H)=>z(ee,H,j))}function p(L,M){const z=M.getCapabilities(L.scheme);return!(z&&z&w.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends f.$Zi{static toExtHostWorkspace(M,z,j,q){if(!M)return{workspace:null,added:[],removed:[]};const{id:B,name:ee,folders:H,configuration:W,transient:X,isUntitled:_}=M,ce=[],ne=z;z?H.forEach((U,oe)=>{const ve=u.URI.revive(U.uri),te=v.o(j||z,ve,q);te?(te.name=U.name,te.index=U.index,ce.push(te)):ce.push({uri:ve,name:U.name,index:oe})}):ce.push(...H.map(({uri:U,name:oe,index:ve})=>({uri:u.URI.revive(U),name:oe,index:ve}))),ce.sort((U,oe)=>U.index<oe.index?-1:1);const ye=new v(B,ee,ce,!!X,W?u.URI.revive(W):null,!!_,U=>p(U,q)),{added:ge,removed:Y}=P(ne?ne.workspaceFolders:[],ye.workspaceFolders,D,q);return{workspace:ye,added:ge,removed:Y}}static o(M,z,j){for(let q=0;q<M.folders.length;q++){const B=M.workspaceFolders[q];if(S(B.uri,z,j))return B}}constructor(M,z,j,q,B,ee,H){super(M,j.map(W=>new f.$1i(W)),q,B,H),this.t=z,this.u=ee,this.q=[],this.s=O.$Mi.forUris(H,()=>!0),j.forEach(W=>{this.q.push(W),this.s.set(W.uri,W)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,z){return z&&this.s.get(M)&&(M=(0,I.$gh)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let F=class{constructor(M,z,j,q,B){this.c=new R.$me,this.onDidChangeWorkspace=this.c.event,this.g=new R.$me,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$oe,this.C=new Map,this.h=q,this.s=j,this.t=B,this.j=new c.$Om,this.k=new h.$Fh,this.o=M.getProxy(g.$ON.MainThreadWorkspace),this.q=M.getProxy(g.$ON.MainThreadMessageService);const ee=z.workspace;this.l=ee?new v(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,H=>p(H,j)):void 0}$initializeWorkspace(M,z){this.v=z,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:b.Schemas.untitled,path:(0,I.$eh)((0,I.$gh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,z,j,...q){const B=[];if(Array.isArray(q)&&q.forEach(_=>{u.URI.isUri(_.uri)&&!B.some(ce=>S(ce.uri,_.uri,this.s))&&B.push({uri:_.uri,name:_.name||(0,I.$dh)(_.uri)})}),this.n||[z,j].some(_=>typeof _!="number"||_<0)||j===0&&B.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(z+j>ee.length)return!1;const H=ee.slice(0);H.splice(z,j,...B.map(_=>({uri:_.uri,name:_.name||(0,I.$dh)(_.uri),index:void 0})));for(let _=0;_<H.length;_++){const ce=H[_];if(H.some((ne,ye)=>ye!==_&&S(ce.uri,ne.uri,this.s)))return!1}H.forEach((_,ce)=>_.index=ce);const{added:W,removed:X}=P(ee,H,k,this.s);if(W.length===0&&X.length===0)return!1;if(this.o){const _=M.displayName||M.name;this.o.$updateWorkspaceFolders(_,z,j,B).then(void 0,ce=>{this.n=void 0;const ne={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage($.Severity.Error,(0,C.localize)(2701,null,_,ce.toString()),ne,[])})}return this.y(H),!0}getWorkspaceFolder(M,z){if(this.x)return this.x.getWorkspaceFolder(M,z)}async getWorkspaceFolder2(M,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,z)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,z){let j,q="";if(typeof M=="string"?(j=u.URI.file(M),q=M):typeof M<"u"&&(j=M,q=M.fsPath),!j)return q;const B=this.getWorkspaceFolder(j,!0);if(!B)return q;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ee=(0,I.$jh)(B.uri,j);return z&&B.name&&(ee=`${B.name}/${ee}`),ee}y(M){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:z,added:j,removed:q}=v.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:q}))}findFiles(M,z,j,q,B=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let ee="",H=!0;return z===null?H=!1:z!==void 0&&(typeof z=="string"?ee=z:ee=z.pattern),this.z(M,void 0,{exclude:ee,maxResults:j,useDefaultExcludes:H,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(M,z={},j,q=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${j.value}, entryPoint: findFiles2`),this.z(void 0,M,z,q)}async z(M,z,j,q=A.CancellationToken.None){if(q&&q.isCancellationRequested)return Promise.resolve([]);const B=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,ee={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof j.useDefaultSearchExcludes=="boolean"?!j.useDefaultSearchExcludes:!1,maxResults:j.maxResults,excludePattern:B,shouldGlobSearch:typeof j.fuzzy=="boolean"?!j.fuzzy:!0,_reason:"startFileSearch"};let H;if(M){const{includePattern:W,folder:X}=N(o.GlobPattern.from(M));H=X,ee.includePattern=W}else{const{includePattern:W,folder:X}=N(o.GlobPattern.from(z));H=X,ee.filePattern=W}return this.o.$startFileSearch(H??null,ee,q).then(W=>Array.isArray(W)?W.map(X=>u.URI.revive(X)):[])}async findTextInFiles(M,z,j,q,B=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),H=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:W,folder:X}=N(o.GlobPattern.from(z.include)),_=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ce={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof z.useSearchExclude=="boolean"?!z.useSearchExclude:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:H,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:W,excludePattern:_},ne=!1;if(this.u[ee]=ye=>{if(ne)return;const ge=u.URI.revive(ye.resource);ye.results.forEach(Y=>{const U=(0,E.$di)(Y);(0,l.$aM)(U)?j({uri:ge,preview:{text:U.preview.text,matches:(0,r.$1b)(U.preview.matches,oe=>new n.$SN(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))},ranges:(0,r.$1b)(U.ranges,oe=>new n.$SN(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))}):j({uri:ge,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(M,X??null,ce,ee,B);return delete this.u[ee],ye||{}}catch(ye){throw delete this.u[ee],ye}}$handleTextSearchResult(M,z){this.u[z]?.(M)}async save(M){const z=await this.o.$save(M,{saveAs:!1});return u.URI.revive(z)}async saveAs(M){const z=await this.o.$save(M,{saveAs:!0});return u.URI.revive(z)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}lookupAuthorization(M){return this.o.$lookupAuthorization(M)}lookupKerberosAuthorization(M){return this.o.$lookupKerberosAuthorization(M)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,z){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,z);const j=this.t.transformOutgoingScheme(M),q=this.A++;return this.o.$registerEditSessionIdentityProvider(q,j),(0,T.$Tc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(q)})}async $getEditSessionIdentifier(M,z){this.h.info("Getting edit session identifier for workspaceFolder",M);const j=await this.resolveWorkspaceFolder(u.URI.revive(M));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const q=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!q),!q)return;const B=await q.provideEditSessionIdentity(j,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(M,z,j,q){this.h.info("Getting edit session identifier for workspaceFolder",M);const B=await this.resolveWorkspaceFolder(u.URI.revive(M));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const ee=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!ee),!ee)return;const H=await ee.provideEditSessionIdentityMatch?.(z,j,q);if(this.h.info("Provider returned edit session identifier match result: ",H),!!H)return H}getOnWillCreateEditSessionIdentityEvent(M){return(z,j,q)=>{const B=function(H){z.call(j,H)};return B.extension=M,this.B.event(B,void 0,q)}}async $onWillCreateEditSessionIdentity(M,z,j){const q=await this.resolveWorkspaceFolder(u.URI.revive(M));if(q===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:q},z,async(B,ee)=>{const H=Date.now();await Promise.resolve(B),Date.now()-H>j&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(M,z){if(this.C.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.C.set(M,z);const j=this.t.transformOutgoingScheme(M),q=this.A++;return this.o.$registerCanonicalUriProvider(q,j),(0,T.$Tc)(()=>{this.C.delete(M),this.o.$unregisterCanonicalUriProvider(q)})}async provideCanonicalUri(M,z,j){const q=this.C.get(M.scheme);if(!q)return;const B=await q.provideCanonicalUri?.(u.URI.revive(M),z,j);if(B)return B}async $provideCanonicalUri(M,z,j){return this.provideCanonicalUri(u.URI.revive(M),{targetScheme:z},j)}};e.$Zpc=F,e.$Zpc=F=Je([Ve(0,t.$oQ),Ve(1,s.$EQ),Ve(2,i.$Ipc),Ve(3,m.$bk),Ve(4,d.$Xpc)],F),e.$1pc=(0,a.$Gi)("IExtHostWorkspace");function N(L){let M,z;return L&&(typeof L=="string"?M=L:(M=L.pattern,z=u.URI.revive(L.baseUri))),{includePattern:M,folder:z}}}),define(ke[41],Ie([1,0,24,4,49,6,9,46,232,70,17,7,5,19,11,2]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=e.$3pc=e.$2pc=void 0;function m(d,l){if(l){const g=l.split(".");let E=d;for(let S=0;E&&S<g.length;S++)E=E[g[S]];return E}}function $(d){return d instanceof a.URI}function f(d){return d&&d.uri instanceof a.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function s(d){return d&&d.uri instanceof a.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function t(d){if($(d))return{resource:d};if(f(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(s(d))return{resource:d.uri};if(d===null)return{resource:null}}let o=class{constructor(l,g,E){this.a=l.getProxy(R.$ON.MainThreadConfiguration),this.c=g,this.b=E,this.d=new y.$Fh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new n(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,g){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(l,g))}};e.$2pc=o,e.$2pc=o=Je([Ve(0,C.$oQ),Ve(1,A.$1pc),Ve(2,w.$bk)],o);class n{constructor(l,g,E,S){this.a=new h.$me,this.b=l,this.f=S,this.c=g,this.e=b.$So.parse(E,S),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,g){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$So.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(g,E))}getConfiguration(l,g,E){const S=t(g)||{},D=this.g(l?m(this.e.getValue(void 0,S,this.c.workspace),l):this.e.getValue(void 0,S,this.c.workspace));l&&this.h(l,S,E?.identifier);function k(p){if(p==null)return null;if(typeof p=="boolean")return p?O.ConfigurationTarget.USER:O.ConfigurationTarget.WORKSPACE;switch(p){case T.ConfigurationTarget.Global:return O.ConfigurationTarget.USER;case T.ConfigurationTarget.Workspace:return O.ConfigurationTarget.WORKSPACE;case T.ConfigurationTarget.WorkspaceFolder:return O.ConfigurationTarget.WORKSPACE_FOLDER}}const P={has(p){return typeof m(D,p)<"u"},get:(p,v)=>{this.h(l?`${l}.${p}`:p,S,E?.identifier);let F=m(D,p);if(typeof F>"u")F=v;else{let N;const L=(M,z)=>{if((0,I.$hg)(M)){let j;const q=()=>{N=N||(0,r.$fo)(D),j=j||m(N,z)};return new Proxy(M,{get:(B,ee)=>{if(typeof ee=="string"&&ee.toLowerCase()==="tojson")return q(),()=>j;if(N)return j=j||m(N,z),j[ee];const H=B[ee];return typeof ee=="string"?L(H,`${z}.${ee}`):H},set:(B,ee,H)=>(q(),j&&(j[ee]=H),!0),deleteProperty:(B,ee)=>(q(),j&&delete j[ee],!0),defineProperty:(B,ee,H)=>(q(),j&&Object.defineProperty(j,ee,H),!0)})}return Array.isArray(M)?(0,r.$fo)(M):M};F=L(F,p)}return F},update:(p,v,F,N)=>{p=l?`${l}.${p}`:p;const L=k(F);return v!==void 0?this.b.$updateConfigurationOption(L,p,v,S,N):this.b.$removeConfigurationOption(L,p,S,N)},inspect:p=>{p=l?`${l}.${p}`:p;const v=this.e.inspect(p,S,this.c.workspace);if(v)return{key:p,defaultValue:(0,r.$fo)(v.policy?.value??v.default?.value),globalValue:(0,r.$fo)(v.user?.value??v.application?.value),workspaceValue:(0,r.$fo)(v.workspace?.value),workspaceFolderValue:(0,r.$fo)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$fo)(v.default?.override),globalLanguageValue:(0,r.$fo)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$fo)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$fo)(v.workspaceFolder?.override),languageIds:(0,r.$fo)(v.overrideIdentifiers)}}};return typeof D=="object"&&(0,r.$io)(P,D,!1),Object.freeze(P)}g(l){const g=E=>(0,I.$hg)(E)?new Proxy(E,{get:(S,D)=>g(S[D]),set:(S,D,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(S,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(S,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return g(l)}h(l,g,E){const S=c.$Ho.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),D=E?`[${E.value}] `:"";if(c.ConfigurationScope.RESOURCE===S){typeof g?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===S){g?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,g){const E=new b.$Uo(l,g,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,D)=>E.affectsConfiguration(S,t(D))})}k(l){return l.reduce((g,E)=>(g.set(E[0],E[1]),g),new Map)}}e.$3pc=n,e.$4pc=(0,u.$Gi)("IExtHostConfiguration")}),define(ke[100],Ie([1,0,2,7,4,6,9,49,63,41,20,48,19,29,5,14,10,11,95,273,13]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Brc=e.$Arc=e.$zrc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,T=We(T),m=We(m);var t;(function(N){function L(z){if(z!=null)return z}N.from=L;function M(z){if(z!=null)return z}N.to=M})(t||(t={}));var o;(function(N){function L(z){if(z!=null)return z}N.from=L;function M(z){if(z!=null)return z}N.to=M})(o||(o={}));var n;(function(N){function L(z){if(z!=null)return z}N.from=L;function M(z){if(z!=null)return z}N.to=M})(n||(n={}));var d;(function(N){function L(j){if(j){const q=j;return q&&!!q.process}else return!1}N.is=L;function M(j){if(j==null)return;const q={process:j.process,args:j.args};return j.options&&(q.options=n.from(j.options)),q}N.from=M;function z(j){if(j!=null)return new T.$CO(j.process,j.args,j.options)}N.to=z})(d||(d={}));var l;(function(N){function L(z){if(z!=null)return z}N.from=L;function M(z){if(z!=null)return z}N.to=M})(l||(l={}));var g;(function(N){function L(j){if(j){const q=j;return q&&(!!q.commandLine||!!q.command)}else return!1}N.is=L;function M(j){if(j==null)return;const q={};return j.commandLine!==void 0?q.commandLine=j.commandLine:(q.command=j.command,q.args=j.args),j.options&&(q.options=l.from(j.options)),q}N.from=M;function z(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new T.$DO(j.commandLine,j.options):new T.$DO(j.command,j.args?j.args:[],j.options)}N.to=z})(g||(g={}));var E;(function(N){function L(j){if(j){const q=j;return q&&q.customExecution==="customExecution"}else return!1}N.is=L;function M(j){return{customExecution:"customExecution"}}N.from=M;function z(j,q){return q.get(j)}N.to=z})(E||(e.CustomExecutionDTO=E={}));var S;(function(N){function L(M,z){let j;return M.scope!==void 0&&typeof M.scope!="number"?j=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===T.TaskScope.Workspace&&z&&z.workspaceFile?j=z.workspaceFile:j=i.$ZI),{id:M._id,workspaceFolder:j}}N.from=L})(S||(e.TaskHandleDTO=S={}));var D;(function(N){function L(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}N.from=L})(D||(D={}));var k;(function(N){function L(j,q){if(j==null)return[];const B=[];for(const ee of j){const H=M(ee,q);H&&B.push(H)}return B}N.fromMany=L;function M(j,q){if(j==null)return;let B;j.execution instanceof T.$CO?B=d.from(j.execution):j.execution instanceof T.$DO?B=g.from(j.execution):j.execution&&j.execution instanceof T.$EO&&(B=E.from(j.execution));const ee=t.from(j.definition);let H;return j.scope?typeof j.scope=="number"?H=j.scope:H=j.scope.uri:H=T.TaskScope.Workspace,!ee||!H?void 0:{_id:j._id,definition:ee,name:j.name,source:{extensionId:q.identifier.value,label:j.source,scope:H},execution:B,isBackground:j.isBackground,group:D.from(j.group),presentationOptions:o.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}N.from=M;async function z(j,q,B){if(j==null)return;let ee;d.is(j.execution)?ee=d.to(j.execution):g.is(j.execution)?ee=g.to(j.execution):E.is(j.execution)&&(ee=E.to(j._id,B));const H=t.to(j.definition);let W;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?W=j.source.scope:W=await q.resolveWorkspaceFolder(r.URI.revive(j.source.scope)):W=T.TaskScope.Workspace),!H||!W)return;const X=new T.$FO(H,W,j.name,j.source.label,ee,j.problemMatchers);return j.isBackground!==void 0&&(X.isBackground=j.isBackground),j.group!==void 0&&(X.group=T.$BO.from(j.group._id),X.group&&j.group.isDefault&&(X.group=new T.$BO(X.group.id,X.group.label),j.group.isDefault===!0&&(X.group.isDefault=j.group.isDefault))),j.presentationOptions&&(X.presentationOptions=o.to(j.presentationOptions)),j._id&&(X._id=j._id),j.detail&&(X.detail=j.detail),X}N.to=z})(k||(e.TaskDTO=k={}));var P;(function(N){function L(z){return z}N.from=L;function M(z){if(z)return Object.assign(Object.create(null),z)}N.to=M})(P||(P={}));class p{#e;constructor(L,M,z){this._id=M,this.a=z,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let v=class{constructor(L,M,z,j,q,B,ee,H){this.q=new A.$me,this.r=new A.$me,this.s=new A.$me,this.u=new A.$me,this.a=L.getProxy(R.$ON.MainThreadTask),this.b=z,this.c=j,this.d=q,this.e=B,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ee,this.g=H,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,M,z){if(!z)return new T.$QN(()=>{});const j=this.x();return this.j.set(j,{type:M,provider:z,extension:L}),this.a.$registerTaskProvider(j,M),new T.$QN(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(L,M){this.a.$registerTaskSystem(L,M)}fetchTasks(L){return this.a.$fetchTasks(P.from(L)).then(async M=>{const z=[];for(const j of M){const q=await k.to(j,this.b,this.m);q&&z.push(q)}return z})}get taskExecutions(){const L=[];return this.k.forEach(M=>L.push(M)),L}terminateTask(L){if(!(L instanceof p))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,M,z){const j=this.m.get(L.id);j&&(this.o.set(L.id,j),this.e.attachPtyToTerminal(M,await j.callback(z))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const M=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:M})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const M=await this.z(L.id);this.s.fire({execution:M,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const M=await this.z(L.id);this.u.fire({execution:M,exitCode:L.exitCode})}$provideTasks(L,M){const z=this.j.get(L);if(!z)return Promise.reject(new Error("no handler found"));const j=[],q=(0,h.$yh)(()=>z.provider.provideTasks(I.CancellationToken.None)).then(B=>this.v(M,j,z,B));return new Promise(B=>{q.then(ee=>{Promise.all(j).then(()=>{B(ee)})})})}async $resolveTask(L,M){const z=this.j.get(L);if(!z)return Promise.reject(new Error("no handler found"));if(M.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${z.type}].`);const j=await k.to(M,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const q=await z.provider.resolveTask(j,I.CancellationToken.None);if(!q)return;this.A(q,z);const B=k.from(q,z.extension);if(!B)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(B.execution)&&await this.y(B,q,!0),await this.w(B)}x(){return this.h++}async y(L,M,z){const j=await this.a.$createTaskId(L);!z&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,M.execution)),this.m.set(j,M.execution)}async z(L,M){if(typeof L=="string"){const q=this.l.get(L);if(!q)throw new s.$bb("Unexpected: The specified task is missing an execution");return q}const z=this.l.get(L.id);if(z)return z;let j;return M?j=Promise.resolve(new p(this,L.id,M)):j=k.to(L.task,this.b,this.m).then(q=>{if(!q)throw new s.$bb("Unexpected: Task does not exist.");return new p(this,L.id,q)}),this.l.set(L.id,j),j.then(q=>(this.k.set(L.id,q),q))}A(L,M){L._deprecated&&this.g.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const z=this.n.values();let j=z.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=z.next()}};e.$zrc=v,e.$zrc=v=Je([Ve(0,u.$oQ),Ve(1,C.$EQ),Ve(2,O.$1pc),Ve(3,b.$zQ),Ve(4,c.$4pc),Ve(5,y.$pqc),Ve(6,$.$bk),Ve(7,f.$Epc)],v);let F=class extends v{constructor(L,M,z,j,q,B,ee,H){super(L,M,z,j,q,B,ee,H),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$i(m.Platform.Web)})}async executeTask(L,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const z=k.from(M,L);if(z===void 0)throw new Error("Task is not valid");if(E.is(z.execution))await this.y(z,M,!1);else throw new s.$_;const j=await this.z(await this.a.$getTaskExecution(z),M);return this.a.$executeTask(z).catch(q=>{throw new Error(q)}),j}v(L,M,z,j){const q=[];if(j)for(const B of j){if(this.A(B,z),!B.definition||!L[B.definition.type]){const H=B.source?B.source:"No task source";this.f.warn(`The task [${H}, ${B.name}] uses an undefined task type. The task will be ignored in the future.`)}const ee=k.from(B,z.extension);ee&&E.is(ee.execution)?(q.push(ee),M.push(this.y(ee,B,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:z.extension}}async w(L){if(E.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,M,z){}};e.$Arc=F,e.$Arc=F=Je([Ve(0,u.$oQ),Ve(1,C.$EQ),Ve(2,O.$1pc),Ve(3,b.$zQ),Ve(4,c.$4pc),Ve(5,y.$pqc),Ve(6,$.$bk),Ve(7,f.$Epc)],F),e.$Brc=(0,w.$Gi)("IExtHostTask")}),define(ke[334],Ie([1,0,37,30]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=void 0,e.$AM=A,e.$CM=R;function A(T){return"cellResults"in T}e.$BM="rawCell#";function R(T,O){let b=-1;const c=[];let I=[];return T.forEach(u=>{u.range.startLineNumber!==b&&I.length>0&&(c.push([...I]),I=[]),I.push(u),b=u.range.endLineNumber}),I.length>0&&c.push([...I]),c.map(u=>{const C=[],w=u[0].range.startLineNumber,a=u[u.length-1].range.endLineNumber;for(let m=w;m<=a;m++)C.push(O.getLineContent(m));return new r.$eM(C.join(`
`)+`
`,u.map(m=>new h.$Pt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ke[335],Ie([1,0,8,21,4,3,28,40,12,17,2,27,118,6,34,15,9,53,307,166,24,14,37,263,334,331]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$brc=void 0,y=We(y),a=We(a),m=We(m);class g{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,D,k,P,p,v,F){this.q=k,this.r=P,this.s=p,this.t=v,this.u=F,this.f=new Map,this.g=new T.$Bc,this.h=new Map,this.j=new A.$me,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$me,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$me,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$me,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$Cpc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=S.getProxy(C.$ON.MainThreadNotebook),this.c=S.getProxy(C.$ON.MainThreadNotebookDocuments),this.d=S.getProxy(C.$ON.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===O.MarshalledId.NotebookCellActionContext){const L=N.notebookEditor?.notebookUri,M=N.cell.handle,j=this.g.get(L)?.getCell(M);if(j)return j.apiCell}if(N&&N.$mid===O.MarshalledId.NotebookActionContext){const L=N.uri,M=this.g.get(L);if(M)return M.apiNotebook}return N}}),g.C(D)}getEditorById(S){const D=this.h.get(S);if(!D)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(S){for(const[D,k]of this.h)if(k.apiEditor===S)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,D){const k=this.g.get(S);if(!k&&!D)throw new Error(`NO notebook document for '${S}'`);return k}static w(S,D){if(!D)return;const k=D.filenamePattern.map(P=>a.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(D.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:D.displayName,filenamePattern:k,priority:D.exclusive?l.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(S,D,k){const P=g.a++,p=typeof k.onDidChangeCellStatusBarItems=="function"?g.a++:void 0;this.f.set(P,k),this.b.$registerNotebookCellStatusBarItemProvider(P,p,D);let v;return p!==void 0&&(v=k.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(p))),new m.$QN(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,p),v?.dispose()})}async createNotebookDocument(S){const D=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&a.NotebookData.from(S.content)});return I.URI.revive(D)}async openNotebookDocument(S){const D=this.g.get(S);if(D)return D.apiNotebook;const k=await this.c.$tryOpenNotebook(S),P=this.g.get(I.URI.revive(k));return(0,c.$qg)(P?.apiNotebook)}async showNotebookDocument(S,D){I.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let k;typeof D=="object"?k={position:a.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(a.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:k={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,k),p=P&&this.h.get(P)?.apiEditor;if(p)return p;throw P?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,D,k,P){const p=this.f.get(S),v=I.URI.revive(D),F=this.g.get(v);if(!F||!p)return;const N=F.getCellFromIndex(k);if(!N)return;const L=await p.provideCellStatusBarItems(N.apiCell,P);if(!L)return;const M=new R.$Uc,z=this.p.add([M]),q=(Array.isArray(L)?L:[L]).map(B=>a.NotebookStatusBarItem.from(B,this.i,M));return{cacheId:z,items:q}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,D,k,P,p){if((0,b.$df)(D))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:D,serializer:k,options:P}),this.b.$registerNotebookSerializer(v,{id:S.identifier,location:S.extensionLocation},D,a.NotebookDocumentContentOptions.from(P),g.w(S,p)),(0,R.$Tc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(S,D,k){const P=this.y.get(S);if(!P)throw new Error("NO serializer found");const p=await P.serializer.deserializeNotebook(D.buffer,k);return new $.$Zw(a.NotebookData.from(p))}async $notebookToData(S,D,k){const P=this.y.get(S);if(!P)throw new Error("NO serializer found");const p=await P.serializer.serializeNotebook(a.NotebookData.to(D.value),k);return h.$Oe.wrap(p)}async $saveNotebook(S,D,k,P,p){const v=I.URI.revive(D),F=this.y.get(S);if(this.D(`enter saveNotebook(versionId: ${k}, ${v.toString()})`),!F)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new y.$wl((0,r.localize)(2692,null,this.A(v)),y.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,s.$no)(N.apiNotebook.metadata,B=>!(F.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of N.apiNotebook.getCells()){const ee=new m.$jP(B.kind,B.document.getText(),B.document.languageId,B.mime,F.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);ee.metadata=(0,s.$no)(B.metadata,H=>!(F.options?.transientCellMetadata??{})[H]),L.cells.push(ee)}if(await this.z(v,P),p.isCancellationRequested)throw new Error("canceled");const M=await F.serializer.serializeNotebook(L,p);if(p.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${v.toString()}`),await this.s.value.writeFile(v,M),this.D(`Finished write versionId: ${k} ${v.toString()}`);const z=this.s.getFileSystemProviderExtUri(v.scheme),j=await this.s.value.stat(v),q={name:z.basename(v),isFile:(j.type&y.FileType.File)!==0,isDirectory:(j.type&y.FileType.Directory)!==0,isSymbolicLink:(j.type&y.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((j.permissions??0)&y.FilePermission.Locked),etag:y.$Hl({mtime:j.mtime,size:j.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${v.toString()})`),q}async $searchInNotebooks(S,D,k,P,p){const v=this.y.get(S)?.serializer;if(!v)return{limitHit:!1,results:[]};const F=new T.$Cc;await(async(j,q,B)=>{await Promise.all(j.map(async ee=>await Promise.all(ee.filenamePatterns.map(H=>{const W={_reason:B._reason,folderQueries:B.folderQueries,includePattern:B.includePattern,excludePattern:B.excludePattern,maxResults:B.maxResults,type:o.QueryType.File,filePattern:H};return this.t.doInternalFileSearchWithCustomCallback(W,q,X=>{X.forEach(_=>{F.has(_)||P.some(ne=>ee.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(ye=>(0,l.$uL)(ye,_)))||F.add(_)})}).catch(X=>{if(X.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw X})}))))})(k,p,D);const L=new T.$Bc;let M=!1;const z=Array.from(F).map(async j=>{const q=[];try{if(p.isCancellationRequested)return;if(D.maxResults&&[...L.values()].reduce((W,X)=>W+X.cellResults.length,0)>D.maxResults){M=!0;return}const B=[],ee=this.g.get(j);if(ee)ee.apiNotebook.getCells().forEach(X=>B.push({input:X.document.getText(),outputs:X.outputs.flatMap(_=>_.items.map(ce=>ce.data.toString()))}));else{const W=await this.s.value.readFile(j),X=h.$Oe.fromString(W.toString()),_=await v.deserializeNotebook(X.buffer,p);if(p.isCancellationRequested)return;a.NotebookData.from(_).cells.forEach(ne=>B.push({input:ne.source,outputs:ne.outputs.flatMap(ye=>ye.items.map(ge=>ge.valueBytes.toString()))}))}if(p.isCancellationRequested)return;B.forEach((W,X)=>{const _=D.contentPattern.pattern,ce=new n.$u1b(W.input,void 0,W.outputs),ne=ce.findInInputs(_),ye=ce.findInOutputs(_),ge=ye.flatMap(Y=>(0,d.$CM)(Y.matches,Y.textBuffer)).map((Y,U)=>(Y.webviewIndex=U,Y));if(ne.length>0||ye.length>0){const Y={index:X,contentResults:(0,d.$CM)(ne,ce.inputTextBuffer),webviewResults:ge};q.push(Y)}});const H={resource:j,cellResults:q};L.set(j,H);return}catch{return}});return await Promise.all(z),{limitHit:M,results:[...L.values()]}}async z(S,D){const k=await this.s.value.stat(S);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==y.$Gl&&typeof k.mtime=="number"&&typeof k.size=="number"&&D.mtime<k.mtime&&D.etag!==y.$Hl({mtime:D.mtime,size:k.size}))throw new y.$wl((0,r.localize)(2693,null),y.FileOperationResult.FILE_MODIFIED_SINCE,D)}A(S){return S.scheme===t.Schemas.file?S.fsPath:S.toString()}B(S,D,k){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const P=new i.$5qc(D,this.d,S,k.visibleRanges.map(a.NotebookRange.to),k.selections.map(a.NotebookRange.to),typeof k.viewColumn=="number"?a.ViewColumn.to(k.viewColumn):void 0);this.h.set(D,P)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const k of S.value.removedDocuments){const P=I.URI.revive(k),p=this.g.get(P);p&&(p.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(p.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===P.toString()&&this.h.delete(v.id)}if(S.value.addedDocuments){const k=[];for(const P of S.value.addedDocuments){const p=I.URI.revive(P.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const v=new f.$4qc(this.c,this.q,this.r,p,P);k.push(...P.cells.map(F=>f.$3qc.asModelAddData(F))),this.g.get(p)?.dispose(),this.g.set(p,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(v.apiNotebook)}}if(S.value.addedEditors)for(const k of S.value.addedEditors){if(this.h.has(k.id))return;const P=I.URI.revive(k.documentUri),p=this.g.get(P);p&&this.B(p,k.id,k)}const D=[];if(S.value.removedEditors)for(const k of S.value.removedEditors){const P=this.h.get(k);P&&(this.h.delete(k),this.k?.id===P.id&&(this.k=void 0),D.push(P))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const k=new Set;this.l.forEach(P=>k.add(P.id));for(const P of this.h.values()){const p=k.has(P.id);P._acceptVisibility(p)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(S){const D=w.$MQ.String.with("notebookType","A notebook type"),k=new w.$OQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new w.$MQ("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>h.$Oe.wrap(p))],new w.$NQ("Notebook Data",p=>a.NotebookData.to(p.value))),P=new w.$OQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new w.$MQ("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new $.$Zw(a.NotebookData.from(p)))],new w.$NQ("Bytes",p=>p.buffer));S.registerApiCommand(k),S.registerApiCommand(P)}D(S){this.u.trace(`[Extension Host Notebook] ${S}`)}}e.$brc=g}),define(ke[336],Ie([1,0,16,20,52,38,22,42,37]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0,r=We(r),R=We(R),T=We(T);class c{constructor(u,C,w){this.k=u,this.l=C,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&R.$Bk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&R.$Bk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const C=this.k.folderQueries||[];return new Promise((w,a)=>{const m=$=>{this.f++,u($)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach($=>{const f=$.toString(),i=r.$oc(f);this.j&&this.j(f,i)||this.v(m,{base:$,basename:i})}),Promise.all(C.map($=>this.p($,m))).then($=>{w({limitHit:this.e,stats:$[0]||void 0})},$=>{a(new Error((0,A.$rj)($)))})})}async p(u,C){const w=new h.$xe,a=this.q(u),m=this.r(),$=new b.$sM(this.k,u),f=!$.hasSiblingExcludeClauses();let i;try{this.h.add(w),i=O.$ge.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,w.token),t=i.elapsed(),o=O.$ge.create();return this.g&&!this.e||(s&&s.forEach(n=>{const d=r.$hc.relative(u.folder.path,n.path);if(f){const l=r.$oc(n.path);this.v(C,{base:u.folder,relativePath:d,basename:l});return}this.s(m,u.folder,d,C)}),this.g&&!this.e)?null:(this.u(m,$,C),{providerTime:t,postProcessTime:o.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(u){const C=(0,b.$rM)(this.k.includePattern,u.includePattern),w=(0,b.$rM)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:w,includes:C,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},C,w,a){if(w===this.a){const $=r.$oc(this.a);this.v(a,{base:C,relativePath:this.a,basename:$})}function m($){const f=r.$oc($),i=r.$nc($);let s=u[i];s||(s=u[i]=[],m(i)),s.push({base:C,relativePath:$,basename:f})}m(w)}u({rootEntries:u,pathToEntries:C},w,a){const m=this,$=this.a;function f(i){const s=(0,b.$uM)(()=>i.map(t=>t.basename));for(let t=0,o=i.length;t<o;t++){const n=i[t],{relativePath:d,basename:l}=n;if(w.matchesExcludesSync(d,l,$!==l?s:void 0))continue;const g=C[d];if(g)f(g);else{if(d===$)continue;m.v(a,n)}if(m.e)break}}f(u)}v(u,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(C))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,C,w,a){const m=this.c(u.cacheKey),$=new c(u,C,m&&m.token);let f=0;const i=s=>{f+=s.length,w(s.map(t=>this.d(t)))};return this.e($,I.a,i,a).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$xe),this.b.get(u)}d(u){return u.relativePath?{resource:T.$hh(u.base,u.relativePath)}:{resource:u.base}}e(u,C,w,a){const m=a.onCancellationRequested(()=>{u.cancel()}),$=i=>{i&&(f.push(i),C>0&&f.length>=C&&(w(f),f=[]))};let f=[];return u.search($).then(i=>(f.length&&w(f),m.dispose(),i),i=>(f.length&&w(f),m.dispose(),Promise.reject(i)))}}e.$6qc=I}),define(ke[337],Ie([1,0,18,78,38,107,28,14,16,22,12,17,2,111,8,46,11,47,158,332,37]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0,e.$tN=D,r=We(r),h=We(h),A=We(A),b=We(b),I=We(I),w=We(w);let t=class{constructor(P,p,v,F,N){this.a=P,this.b=p,this.c=v,this.d=F,this.e=N}text(P,p,v={}){P=this.f(P,v);const F=this.a.getValue(),N=p&&p.some(M=>!this.a.getValue({resource:M}).search.useRipgrep);return{...this.h(p?.map($.$2i),v),type:s.QueryType.Text,contentPattern:P,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(P,p){const v=this.a.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const F={...P,wordSeparators:v.editor.wordSeparators};return this.j(P,p)&&(F.isCaseSensitive=!0),this.k(P)&&(F.isMultiline=!0),p.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=p.notebookSearchConfig.includeMarkupInput),p.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=p.notebookSearchConfig.includeMarkupPreview),p.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=p.notebookSearchConfig.includeCodeInput),p.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=p.notebookSearchConfig.includeOutput),F}file(P,p={}){return{...this.h(P,p),type:s.QueryType.File,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey,shouldGlobMatchFilePattern:p.shouldGlobSearch}}g(P,p){return P?(P=Array.isArray(P)?P.map(g):g(P),p?this.parseSearchPaths(P):{pattern:n(...Array.isArray(P)?P:[P])}):{}}h(P=[],p={}){const v=this.g(p.includePattern,p.expandPatterns),F=this.g(p.excludePattern,p.expandPatterns),N=P.length>1,L=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(j=>this.q(j,p,F)):P.map(j=>this.r(j,p,F,N))).filter(j=>!!j),M={_reason:p._reason,folderQueries:L,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:F.pattern,includePattern:v.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const j=r.$Hb(this.c.groups.flatMap(ee=>ee.editors.map(H=>H.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const q=j.filter(ee=>(0,s.$iM)(M,ee.fsPath)),B=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...M,...B}}const z=p.extraFileResources&&p.extraFileResources.filter(j=>(0,s.$iM)(M,j.fsPath));return M.extraFileResources=z&&z.length?z:void 0,M}i(P){const p=[],v=new T.$Bc,F={};let N=!1;return P.forEach(L=>{if(L.scheme===O.Schemas.walkThrough)return;if((0,c.$lh)(L)){const z=this.b.getWorkspaceFolder(L)?.uri??L.with({path:b.$nc(L.fsPath)});let j=v.get(z);j||(N=!0,j={folder:z,includePattern:{}},p.push(j),v.set(z,j));const q=b.$mc(z.fsPath,L.fsPath);(0,y.$qg)(j.includePattern)[q.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,F[L.fsPath]=!0)}),{folderQueries:p,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(P,p){if(p.isSmartCase){if(P.isRegExp){if(I.$9f(P.pattern,!0))return!0}else if(I.$9f(P.pattern))return!0}return!!P.isCaseSensitive}k(P){return P.isMultiline||P.isRegExp&&(0,C.$nD)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const p=B=>b.$jc(B)||/^\.\.?([\/\\]|$)/.test(B),F=(Array.isArray(P)?P:d(P)).map(B=>{const ee=this.e.resolvedUserHome;return ee?(0,R.$5w)(B,ee.scheme===O.Schemas.file?ee.fsPath:ee.path):B}),N=h.$c(F,B=>p(B)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(B=>I.$of(B,"/")).map(B=>I.$of(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),l(B))),M={},z=this.m(N.searchPaths||[]);z&&z.length&&(M.searchPaths=z);const j=L.flat(),q=n(...j);return q&&(M.pattern=q),M}l(P,p){return p.disregardExcludeSettings?void 0:(0,s.$hM)(P,!p.disregardSearchExcludeSettings)}m(P){if(!P||!P.length)return[];const p=P.flatMap(F=>{let{pathPortion:N,globPortion:L}=o(F);return L&&(L=E(L)),this.n(N).flatMap(z=>this.o(z,L))}),v=new Map;return p.forEach(F=>{const N=F.searchPath.toString(),L=v.get(N);L?F.pattern&&(L.pattern=L.pattern||{},L.pattern[F.pattern]=!0):v.set(N,{searchPath:F.searchPath,pattern:F.pattern?n(F.pattern):void 0})}),Array.from(v.values())}n(P){if(b.$jc(P)){const p=this.b.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==O.Schemas.file?[{searchPath:p[0].uri.with({path:P})}]:[{searchPath:u.URI.file(b.$ic(P))}]}if(this.b.getWorkbenchState()===$.WorkbenchState.FOLDER){const p=this.b.getWorkspace().folders[0].uri;if(P=g(P),P.startsWith("../")||P===".."){const F=b.$hc.resolve(p.path,P);return[{searchPath:p.with({path:F})}]}const v=E(P);return[{searchPath:p,pattern:v}]}else{if(P==="./"||P===".\\")return[];{const p=P.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(N=>{const L=p.match(new RegExp(`^${I.$if(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(y.$ng);if(F.length)return F.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&E(L)}});{const N=P.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:P,M=w.localize(12487,null,L);throw new Error(M)}}}}o(P,p){const v=P.pattern&&p?`${P.pattern}/${p}`:P.pattern||p,F=[{searchPath:P.searchPath,pattern:v}];return v&&!v.endsWith("**")&&F.push({searchPath:P.searchPath,pattern:v+"/**"}),F}q(P,p,v){const F=this.r((0,$.$2i)(P.searchPath),p,v,!1);return F?{...F,includePattern:P.pattern}:null}r(P,p,v,F){let N;const L=u.URI.isUri(P)?P:P.uri;if(v.searchPaths){const B=v.searchPaths.filter(ee=>(0,c.$ah)(ee.searchPath,L))[0];if(B&&!B.pattern)return null;B&&(N=B.pattern)}const M=this.a.getValue({resource:L}),j={...this.l(M,p)||{},...N||{}},q=u.URI.isUri(P)?(0,c.$eh)(P):P.name;return{folder:L,folderName:F?q:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!M.search.followSymlinks}}};e.$sN=t,e.$sN=t=Je([Ve(0,a.$aj),Ve(1,$.$Pi),Ve(2,f.$vE),Ve(3,m.$bk),Ve(4,i.$qN)],t);function o(k){const P=k.match(/[\*\{\}\(\)\[\]\?]/);if(P){const p=P.index,v=k.substr(0,p).match(/[/|\\][^/\\]*$/);if(v){let F=k.substr(0,v.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:k.substr((v.index||0)+1)}}}return{pathPortion:k}}function n(...k){return k.length?k.reduce((P,p)=>(P[p]=!0,P),Object.create(null)):void 0}function d(k){return A.$zk(k,",").map(P=>P.trim()).filter(P=>!!P.length)}function l(k){return[`**/${k}/**`,`**/${k}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function g(k){return k.replace(/\\/g,"/")}function E(k){return g(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(k){return k.replace(/([?*[\]])/g,"[$1]")}function D(k,P){k=r.$Mb(k,F=>F.toString());const p=[],v=P.getWorkspace();return k&&k.forEach(F=>{let N;if(P.getWorkbenchState()===$.WorkbenchState.FOLDER)N=(0,c.$jh)(v.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const L=P.getWorkspaceFolder(F);if(L){const M=L.name;if(v.folders.filter(j=>j.name===M).length===1){const j=(0,c.$jh)(L.uri,F);j===""?N=`./${L.name}`:N=`./${L.name}/${j}`}else N=F.fsPath}}N&&p.push(S(N))}),p}}),define(ke[338],Ie([1,0,22,2,20,13,5,337,37,47,7]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iyb=u,e.$Jyb=a,r=We(r),R=We(R);const y=7e3;function u(m,$){const f=$.activationEvents;if(!f)return Promise.resolve(void 0);const i=[],s=[];for(const g of f)if(/^workspaceContains:/.test(g)){const E=g.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||m.forceUsingSearch?s.push(E):i.push(E)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.$zh)(),n=g=>o({activationEvent:g}),d=Promise.all(i.map(g=>C(m,g,n))).then(()=>{}),l=w(m,$.identifier,s,n);return Promise.all([d,l]).then(()=>{o(void 0)}),t}async function C(m,$,f){for(const i of m.folders)if(await m.exists(r.$hh(h.URI.revive(i),$))){f(`workspaceContains:${$}`);return}}async function w(m,$,f,i){if(f.length===0)return Promise.resolve(void 0);const s=new A.$xe,t=m.checkExists(m.folders,f,s.token),o=setTimeout(async()=>{s.cancel(),m.logService.info(`Not activating extension '${$.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},y);let n=!1;try{n=await t}catch(d){R.$4(d)||R.$Z(d)}s.dispose(),clearTimeout(o),n&&i(`workspaceContains:${f.join(",")}`)}function a(m,$,f,i){const s=m.get(T.$Fi),t=m.get(b.$_L),n=s.createInstance(O.$sN).file($.map(d=>(0,c.$2i)(h.URI.revive(d))),{_reason:"checkExists",includePattern:f,exists:!0});return t.fileSearch(n,i).then(d=>!!d.limitHit,d=>R.$4(d)?!1:Promise.reject(d))}}),define(ke[54],Ie([1,0,8,16,61,22,7,3,84,2,11,6,41,270,125,49,25,160,13,23,21,249,9,71,5,29,97,19,114,76,48,128,4,338,124,251,14,122,42,10,123]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n,d,l,g,E,S,D,k,P,p,v,F,N,L,M,z,j,q){"use strict";var B;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=e.$Fqc=e.$Eqc=e.$Dqc=e.$Cqc=void 0,r=We(r),h=We(h),A=We(A),f=We(f),e.$Cqc=(0,d.$Gi)("IHostUtils");let ee=B=class extends O.$Vc{constructor(Y,U,oe,ve,te,ae,se,Z,re,pe,we,Fe,ze){super(),this.Y=Fe,this.Z=ze,this.a=this.B(new p.$me),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=U,this.g=oe,this.f=se,this.j=ve,this.m=te,this.s=ae,this.t=re,this.u=pe,this.w=we,this.y=this.g.getProxy(y.$ON.MainThreadWorkspace),this.z=this.g.getProxy(y.$ON.MainThreadTelemetry),this.C=this.g.getProxy(y.$ON.MainThreadExtensionService),this.D=new T.$Fh,this.F=new T.$Fh,this.G=new T.$Fh,this.H=new T.$Fh,this.I=new ye(this.f.extensions.activationEvents),this.L=new $.$Xdc(this.I,this.f.extensions.allExtensions);const Re=new i.$tn(this.f.extensions.myExtensions);this.J=new $.$Xdc(this.I,ce(this.L,Re)),j.$u&&(this.s.info(`Creating extension host with the following global extensions: ${X(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${X(this.J)}`)),this.M=new w.$lqc(this.g,this.s),this.N=new F.$vqc(this.g),this.O=Z,this.h=this.q.add(Y.createChild(new S.$Ei([w.$mqc,this.M],[F.$wqc,this.N]))),this.P=this.B(new C.$kqc(this.J,this.L,{onExtensionActivationError:(De,Ce,V)=>{this.C.$onExtensionActivationError(De,f.$2(Ce),V)},actualActivateExtension:async(De,Ce)=>{if($.$Xdc.isHostExtension(De,this.J,this.L))return await this.C.$activateExtension(De,Ce),new C.$jqc;const V=this.J.getExtensionDescription(De);return this.fb(V,Ce)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){f.$Z(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.eb(te))}catch{}await Promise.all(Y)}terminate(Y,U=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),f.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const oe=this.$();Promise.race([(0,T.$Hh)(5e3),oe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const U=await this.C.$getExtension(Y);return U&&{...U,identifier:new i.$sn(U.identifier.value),extensionLocation:c.URI.revive(U.extensionLocation)}}ab(Y,U){return this.P.activateByEvent(Y,U)}bb(Y,U){return this.P.activateById(Y,U)}activateByIdWithErrors(Y,U){return this.bb(Y,U).then(()=>{const oe=this.P.getActivatedExtension(Y);if(oe.activationFailed)return Promise.reject(oe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===L.Schemas.file&&this.c.fsRealpath){const U=Y.fsPath;this.R.has(U)||this.R.set(U,this.c.fsRealpath(U));const oe=await this.R.get(U);return c.URI.file(oe)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new ne(Y))),this.Q}async db(Y){const U=b.$Mi.forUris(oe=>R.$$g.ignorePathCasing(oe));return await Promise.all(Y.map(async oe=>{if(this.wb(oe)){const ve=await this.cb(oe.extensionLocation);U.set(ve,oe)}})),U}eb(Y){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return U;const oe=this.P.getActivatedExtension(Y);if(!oe)return U;try{typeof oe.module.deactivate=="function"&&(U=Promise.resolve(oe.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(ve)}try{oe.disposable.dispose()}catch(ve){this.s.error(`An error occurred when disposing the subscriptions for extension '${Y.value}':`),this.s.error(ve)}return U}async fb(Y,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,U).then(oe=>{const ve=oe.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,U),this.gb(Y,U,"success",ve),oe},oe=>{throw this.gb(Y,U,"failure"),oe})}gb(Y,U,oe,ve){const te=W(Y,U);this.z.$publicLog2("extensionActivationTimes",{...te,...ve||{},outcome:oe})}hb(Y,U){const oe=W(Y,U);this.z.$publicLog2("activatePlugin",oe);const ve=this.wb(Y);if(!ve)return Promise.resolve(new C.$iqc(C.$fqc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${Y.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const te=new O.$Uc,ae=new C.$gqc(U.startup);return Promise.all([this.xb(Y,(0,R.$hh)(Y.extensionLocation,ve),ae),this.ib(Y,te)]).then(se=>(A.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),B.jb(this.s,Y.identifier,se[0],se[1],te,ae))).then(se=>(A.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),se))}ib(Y,U){const oe=this.Z.createLanguageModelAccessInformation(Y),ve=U.add(new t.$oqc(Y,this.M)),te=U.add(new t.$nqc(Y.identifier.value,!1,this.M)),ae=U.add(new N.$xqc(Y,this.N)),se=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,Z=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ve.whenReady,te.whenReady,this.O.whenReady]).then(()=>{const re=this;let pe,we;const Fe=(0,m.$iH)(Y,"ipc")?this.f.messagePorts?.get(i.$sn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:te,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return oe},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(ze){return h.$kc(Y.extensionLocation.fsPath,ze)},get storagePath(){return re.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return re.O.globalValue(Y).fsPath},get logPath(){return h.$kc(re.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return c.URI.joinPath(re.f.logsLocation,Y.identifier.value)},get storageUri(){return re.O.workspaceValue(Y)},get globalStorageUri(){return re.O.globalValue(Y)},get extensionMode(){return se},get extension(){return pe===void 0&&(pe=new _(re,Y.identifier,Y,Z,!1)),pe},get extensionRuntime(){return(0,m.$jH)(Y,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!we){if(!Fe)return;const ze=p.Event.buffer(p.Event.fromDOMEventEmitter(Fe,"message",Re=>Re.data));Fe.start(),we={onDidReceiveMessage:ze,postMessage:Fe.postMessage.bind(Fe)}}return we}})})}static jb(Y,U,oe,ve,te,ae){return oe=oe||{activate:void 0,deactivate:void 0},this.kb(Y,U,oe,ve,ae).then(se=>new C.$hqc(!1,null,ae.build(),oe,se,(0,O.$Tc)(()=>{te.dispose(),(0,O.$Qc)(ve.subscriptions)})))}static kb(Y,U,oe,ve,te){if(typeof oe.activate=="function")try{te.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${U.value}`);const ae=typeof global=="object"?global:self,se=oe.activate.apply(ae,[ve]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(se).then(Z=>(te.activateResolveStop(),Z))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(oe)}lb(Y,U){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:U}).then(void 0,oe=>{this.s.error(oe)})}mb(Y,U=0){const ve=Date.now();(0,j.$C)(()=>{for(let te=U;te<Y.length;te+=1){const ae=Y[te];for(const se of ae.activationEvents??[])if(se==="onStartupFinished")if(Date.now()-ve>50){this.mb(Y,te);break}else this.lb(ae,se)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(Y=>{const U=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),oe=this.J.getAllExtensionDescriptions();if(U)this.mb(oe);else for(const ve of oe)if(ve.activationEvents)for(const te of ve.activationEvents)te==="onStartupFinished"&&this.lb(ve,te)})}ob(){const Y=this.ab("*",!0).then(void 0,ae=>{this.s.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.pb(ae.added)));const U=this.j.workspace?this.j.workspace.folders:[],oe=this.pb(U),ve=this.rb(),te=Promise.all([ve,Y,oe]).then(()=>{});return Promise.race([te,(0,T.$Hh)(1e4)]).then(()=>{this.nb()}),te}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.qb(Y,U))).then(()=>{})}async qb(Y,U){if(this.isActivated(U.identifier))return;const oe=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:Y.map(ae=>ae.uri),forceUsingSearch:oe||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,se,Z)=>this.y.$checkExists(ae,se,Z)},te=await(0,v.$Iyb)(ve,U);if(te)return this.bb(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:te.activationEvent}).then(void 0,ae=>this.s.error(ae))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:U}=this.f.environment;if(!Y||!U)throw new Error(r.localize(2684,null));const oe=await this.xb(null,U,new C.$gqc(!1));if(!oe||typeof oe.run!="function")throw new Error(r.localize(2685,null,U.toString()));return new Promise((ve,te)=>{const ae=(re,pe)=>{re?(j.$u&&this.s.error("Test runner called back with error",re),te(re)):(j.$u&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof pe=="number"&&pe>0?1:0))},se=(0,R.$8g)(U),Z=oe.run(se,ae);Z&&Z.then&&Z.then(()=>{j.$u&&this.s.info("Test runner finished successfully."),ve(0)}).catch(re=>{j.$u&&this.s.error("Test runner finished with error",re),te(re instanceof Error&&re.stack?re.stack:String(re))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,T.$Hh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,U){return this.S[Y]=U,(0,O.$Tc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:U}=await this.ub(Y);return U?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const U=Y.indexOf("+");if(U===-1)throw new o.$YN("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const oe=Y.substr(0,U);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${oe}`,!1),{authorityPrefix:oe,resolver:this.S[oe]}}async $resolveAuthority(Y,U){const oe=z.$ge.create(!1),ve=()=>`[resolveAuthority(${(0,n.$Wl)(Y)},${U})][${oe.elapsed()}ms] `,te=G=>this.s.info(`${ve()}${G}`),ae=G=>this.s.warn(`${ve()}${G}`),se=(G,J=void 0)=>this.s.error(`${ve()}${G}`,J),Z=G=>{if(G instanceof o.$YN)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},re=async G=>{te(`activating resolver for ${G}...`);const{resolver:J,authorityPrefix:x}=await this.ub(G);if(!J)throw se(`no resolver for ${x}`),new o.$YN(`No remote extension installed to resolve ${x}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:G}},pe=Y.split(/@|%40/g).reverse();te(`activating remote resolvers ${pe.join(" -> ")}`);let we;try{we=await Promise.all(pe.map(re)).catch(async G=>{if(!(G instanceof o.$YN)||G._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return ae(`resolving nested authorities failed: ${G.message}`),[await re(Y)]})}catch(G){return Z(G)}const Fe=new T.$Rh;Fe.cancelAndSet(()=>te("waiting..."),1e3);let ze,Re;for(const[G,{authorityPrefix:J,resolver:x,remoteAuthority:de}]of we.entries())try{if(G===we.length-1)te("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${J}`),ze=await x.resolve(de,{resolveAttempt:U,execServer:Re}),A.mark(`code/extHost/didResolveAuthorityOK/${J}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,o.$XN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(te(`invoking resolveExecServer() for ${de}`),A.mark(`code/extHost/willResolveExecServer/${J}`),Re=await x.resolveExecServer?.(de,{resolveAttempt:U,execServer:Re}),!Re)throw new o.$YN(`Exec server was not available for ${de}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(Ee){return A.mark(`code/extHost/didResolveAuthorityError/${J}`),se("returned an error",Ee),Fe.dispose(),Z(Ee)}Fe.dispose();const De={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Ce={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${o.$XN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let V;if(o.$XN.isManagedResolvedAuthority(ze)){const G=U;this.Y.setFactory(G,ze.makeConnection),V={authority:Y,connectTo:new n.$Tl(G),connectionToken:ze.connectionToken}}else V={authority:Y,connectTo:new n.$Ul(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:V,options:Ce,tunnelInformation:De}}}async $getCanonicalURI(Y,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Wl)(Y)})`);const{resolver:oe}=await this.ub(Y);if(!oe)return null;const ve=c.URI.revive(U);if(typeof oe.getCanonicalURI>"u")return ve;const te=await(0,T.$yh)(()=>oe.getCanonicalURI(ve));return te||ve}async $startExtensionHost(Y){Y.toAdd.forEach(ae=>ae.extensionLocation=c.URI.revive(ae.extensionLocation));const{globalRegistry:U,myExtensions:oe}=H(this.I,this.L,this.J,Y),ve=await this.db(oe);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(U.getAllExtensionDescriptions()),this.J.set(oe),j.$u&&(this.s.info(`$startExtensionHost: global extensions: ${X(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${X(this.J)}`)),this.tb()}$activateByEvent(Y,U){return U===m.ActivationKind.Immediate?this.D.wait().then(oe=>this.ab(Y,!1)):this.G.wait().then(oe=>this.ab(Y,!1))}async $activate(Y,U){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,U),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(ae=>ae.extensionLocation=c.URI.revive(ae.extensionLocation));const{globalRegistry:U,myExtensions:oe}=H(this.I,this.L,this.J,Y),ve=await this.db(oe);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(U.getAllExtensionDescriptions()),this.J.set(oe),j.$u&&(this.s.info(`$deltaExtensions: global extensions: ${X(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${X(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const U=s.$Oe.alloc(Y),oe=Math.random()%256;for(let ve=0;ve<Y;ve++)U.writeUInt8(oe,ve);return U}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$Dqc=ee,e.$Dqc=ee=B=Je([Ve(0,d.$Fi),Ve(1,e.$Cqc),Ve(2,E.$oQ),Ve(3,a.$1pc),Ve(4,u.$4pc),Ve(5,I.$bk),Ve(6,l.$EQ),Ve(7,g.$7pc),Ve(8,D.$pGb),Ve(9,k.$pqc),Ve(10,M.$zqc),Ve(11,q.$Aqc),Ve(12,P.$tqc)],ee);function H(ge,Y,U,oe){ge.addActivationEvents(oe.addActivationEvents);const ve=new $.$Xdc(ge,Y.getAllExtensionDescriptions());ve.deltaExtensions(oe.toAdd,oe.toRemove);const te=new i.$tn(U.getAllExtensionDescriptions().map(se=>se.identifier));for(const se of oe.myToRemove)te.delete(se);for(const se of oe.myToAdd)te.add(se);const ae=ce(ve,te);return{globalRegistry:ve,myExtensions:ae}}function W(ge,Y){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function X(ge){return ge.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$Eqc=(0,d.$Gi)("IExtHostExtensionService");class _{#e;#t;#i;constructor(Y,U,oe,ve,te){this.#e=Y,this.#t=U,this.#i=oe.identifier,this.id=oe.identifier.value,this.extensionUri=oe.extensionLocation,this.extensionPath=h.$ic((0,R.$8g)(oe.extensionLocation)),this.packageJSON=oe,this.extensionKind=ve,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Fqc=_;function ce(ge,Y){return ge.getAllExtensionDescriptions().filter(U=>Y.has(U.identifier))}class ne{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$Gqc=ne;class ye{constructor(Y){this.a=new i.$un,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const U of Object.keys(Y))this.a.set(U,Y[U])}}}),define(ke[339],Ie([1,0,61,2,6,41,25,23,19,29,5,54,11,12]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrc=void 0,r=We(r);let a=class{constructor(s,t,o,n,d,l,g){this.c=s,this.d=t,this.e=o,this.f=n,this.g=d,this.h=l,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new $(this.c,t,this.d,s,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(f,t,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const t of s.nodeModuleName)this.a.set(t,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(t=>s.alternativeModuleName(t))}};e.$Rrc=a,e.$Rrc=a=Je([Ve(2,I.$Fi),Ve(3,R.$4pc),Ve(4,y.$Eqc),Ve(5,c.$EQ),Ve(6,u.$bk)],a);let m=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&w.a.size){const t=(0,C.$if)(this.c(s.environment.appRoot.fsPath)),o="[a-z0-9_.-]",n=`@${o}+\\/${o}+|${o}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${d}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const t=this.b.exec(this.c(s));if(!t)return;const[,o,n,d]=t,l=w.a.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),o+l+d}c(s){return s.replace(/\\/g,"/")}};m=w=Je([Ve(0,c.$EQ)],m);class ${constructor(s,t,o,n,d){this.c=s,this.d=t,this.e=o,this.f=n,this.g=d,this.nodeModuleName="vscode",this.a=new O.$un}load(s,t){const o=this.d.findSubstr(t);if(o){let n=this.a.get(o.identifier);return n||(n=this.c(o,this.e,this.f),this.a.set(o.identifier,n)),n}if(!this.b){let n="";this.d.forEach((d,l)=>n+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${n}`),this.b=this.c(T.$dH,this.e,this.f)}return this.b}}let f=class{constructor(s,t,o){this.e=s,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(A.$ON.MainThreadTelemetry);const n=o.getProxy(A.$ON.MainThreadWindow);this.c=(d,l)=>{const g=h.URI.parse(d);return l?this.g(d,l):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,d,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?n.$openUri(g,d,{}):this.g(d,l)}}load(s,t,o){const n=this.e.findSubstr(t);return n&&(this.a=n.identifier.value,this.h()),this.b=o(s),this.c}g(s,t){return this.i(),this.b(s,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};f=Je([Ve(2,b.$oQ)],f)}),define(ke[64],Ie([1,0,50,3,16,55,5,63,77,54,9,49,267,41]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=e.$Hqc=void 0,A=We(A),R=We(R),e.$Hqc=(0,T.$Gi)("IExtHostVariableResolverProvider");class w extends u.$sR{constructor($,f,i,s,t,o,n){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const g=s.tabGroups.all.find(E=>E.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof I.$FP||g.input instanceof I.$KP)return g.input.modified;if(g.input instanceof I.$EP||g.input instanceof I.$JP||g.input instanceof I.$HP)return g.input.uri}}}super({getFolderUri:l=>{const g=o.folders.filter(E=>E.name===l);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(l,g)=>t.getConfiguration(void 0,l).get(g),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return A.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const l=d();if(l){const g=f.getWorkspaceFolder(l);if(g)return A.$ic(g.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>$.getExtension(l)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(R.env))}}let a=class extends h.$Vc{constructor($,f,i,s,t){super(),this.b=$,this.c=f,this.g=i,this.h=s,this.j=t,this.a=new r.$U(async()=>{const o=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,o,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Iqc=a,e.$Iqc=a=Je([Ve(0,c.$Eqc),Ve(1,y.$1pc),Ve(2,O.$zQ),Ve(3,C.$4pc),Ve(4,b.$dqc)],a)}),define(ke[101],Ie([1,0,7,4,2,3,23,5,6,77,54,19,9,49,155,119,258,41,64,51,34,15,18,98]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=e.$Rqc=e.$Qqc=e.$Pqc=e.$Oqc=void 0,t=We(t),e.$Oqc=(0,O.$Gi)("IExtHostDebugService");let d=class extends R.$Vc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(P,p,v,F,N,L,M,z){super(),this.Y=p,this.Z=v,this.$=F,this.ab=N,this.bb=L,this.cb=M,this.db=z,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$me),this.z=this.B(new h.$me),this.C=this.B(new h.$me),this.F=this.B(new h.$me),this.u=P.getProxy(b.$ON.MainThreadDebugService),this.I=this.B(new h.$me),this.L=this.B(new h.$me),this.G=new g(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(j=>{this.B(j.onDidChange(q=>{this.fb(j)})),this.fb(j)})}async $getVisualizerTreeItem(P,p){const v=this.gb(p);if(!v)return;const F=await this.Q.get(P)?.getTreeItem?.(v);return F?this.eb(P,F):void 0}registerDebugVisualizationTree(P,p,v){const F=T.$sn.toKey(P.identifier),N=this.ub(F,p);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.Q.set(N,v),this.u.$registerDebugVisualizerTree(N,!!v.editItem),(0,R.$Tc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(p)})}async $getVisualizerTreeItemChildren(P,p){const v=this.S.get(p)?.item;return v?(await this.Q.get(P)?.getChildren?.(v))?.map(N=>this.eb(P,N))||[]:[]}async $editVisualizerTreeItem(P,p){const v=this.S.get(P);if(!v)return;const F=await this.Q.get(v.provider)?.editItem?.(v.item,p);return this.eb(v.provider,F||v.item)}$disposeVisualizedTree(P){const p=this.S.get(P);if(!p)return;const v=[p.children];for(const F of v)if(F)for(const N of F)v.push(this.S.get(N)?.children),this.S.delete(N)}eb(P,p){let v=this.R.get(p);return v||(v=this.O++,this.R.set(p,v),this.S.set(v,{provider:P,item:p})),t.DebugTreeItem.from(p,v)}asDebugSourceUri(P,p){const v=P;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let F=`debug:${encodeURIComponent(v.path||"")}`,N="?";return p&&(F+=`${N}session=${encodeURIComponent(p.id)}`,N="&"),F+=`${N}ref=${v.sourceReference}`,A.URI.parse(F)}else{if(v.path)return A.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(P){const p=[];for(const v of P.getAllExtensionDescriptions())if(v.contributes){const F=v.contributes.debuggers;if(F&&F.length>0)for(const N of F)(0,m.$dI)(N)&&p.push(N.type)}this.u.$registerDebugTypes(p)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const P=[];return this.H.forEach(p=>P.push(p)),P}async $resolveDebugVisualizer(P,p){const v=this.W.get(P);if(!v)throw new Error(`No debug visualizer found with id '${P}'`);let{v:F,provider:N,extensionId:L}=v;if(F.visualization||(F=await N.resolveDebugVisualization?.(F,p)||F,v.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(L,F.visualization)}async $executeDebugVisualizerCommand(P){const p=this.W.get(P);if(!p)throw new Error(`No debug visualizer found with id '${P}'`);const v=p.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(P){const p=this.w.get(P.sessionId);return p&&{session:p.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId}}async $provideDebugVisualizers(P,p,v,F){const N=this.gb(v),L=this.ub(P,p),M=this.P.get(L);if(!N||!M)return[];const z=await M.provideDebugVisualization(N,F);return z?z.map(j=>{const q=++this.X;this.W.set(q,{v:j,provider:M,extensionId:P});const B=j.iconPath?this.wb(j.iconPath):void 0;return{id:q,name:j.name,iconClass:B?.iconClass,iconPath:B?.iconPath,visualization:this.vb(P,j.visualization)}}):[]}$disposeDebugVisualizers(P){for(const p of P)this.W.delete(p)}registerDebugVisualizationProvider(P,p,v){if(!P.contributes?.debugVisualizers?.some(L=>L.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const F=T.$sn.toKey(P.identifier),N=this.ub(F,p);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.P.set(N,v),this.u.$registerDebugVisualizer(F,p),(0,R.$Tc)(()=>{this.u.$unregisterDebugVisualizer(F,p),this.P.delete(p)})}addBreakpoints(P){const p=P.filter(N=>{const L=N.id;return this.H.has(L)?!1:(this.H.set(L,N),!0)});this.rb(p,[],[]);const v=[],F=new Map;for(const N of p)if(N instanceof u.$UO){let L=F.get(N.location.uri.toString());L||(L={type:"sourceMulti",uri:N.location.uri,lines:[]},F.set(N.location.uri.toString(),L),v.push(L)),L.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof u.$VO&&v.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(P){const p=P.filter(L=>this.H.delete(L.id));this.rb([],p,[]);const v=p.filter(L=>L instanceof u.$UO).map(L=>L.id),F=p.filter(L=>L instanceof u.$VO).map(L=>L.id),N=p.filter(L=>L instanceof u.$WO).map(L=>L.id);return this.u.$unregisterBreakpoints(v,F,N)}startDebugging(P,p,v){const F=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(P?P.uri:void 0,p,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(P){return this.u.$stopDebugging(P?P.id:void 0)}registerDebugConfigurationProvider(P,p,v){if(!p)return new u.$QN(()=>{});const F=this.f++;return this.g.push({type:P,handle:F,provider:p}),this.u.$registerDebugConfigurationProvider(P,v,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,F),new u.$QN(()=>{this.g=this.g.filter(N=>N.provider!==p),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(P,p,v){if(!v)return new u.$QN(()=>{});if(!this.nb(P,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.kb(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:p,handle:F,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(p,F),new u.$QN(()=>{this.j=this.j.filter(N=>N.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(P,p){if(!p)return new u.$QN(()=>{});const v=this.m++;return this.n.push({type:P,handle:v,factory:p}),new u.$QN(()=>{this.n=this.n.filter(F=>F.factory!==p)})}async $runInTerminal(P,p){return Promise.resolve(void 0)}async $substituteVariables(P,p){let v;const F=await this.tb(P);return F&&(v={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,p)}hb(P,p){if(P.type==="implementation")return new S(P.implementation)}ib(){}async $startDASession(P,p){const v=this,F=await this.sb(p);return this.pb(this.kb(F.type),F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const L=this.jb(N),M=this.hb(L,F);if(!M)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const z=M;return this.M.set(P,z),this.ob(F).then(j=>(j&&this.N.set(P,j),z.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const B=q,ee={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const H=await this.U.sign(B.arguments.value);ee.body={signature:H},z.sendResponse(ee)}else throw new Error("no signer")}catch(H){ee.success=!1,ee.message=H.message,z.sendResponse(ee)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(q),q=(0,m.$iI)(q,!0),v.u.$acceptDAMessage(P,q)}),z.onError(q=>{j&&j.onError&&j.onError(q),this.u.$acceptDAError(P,q.name,q.message,q.stack)}),z.onExit(q=>{j&&j.onExit&&j.onExit(q??void 0,void 0),this.u.$acceptDAExit(P,q??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),z.startSession()))})}$sendDAMessage(P,p){p=(0,m.$hI)(p,!1);const v=this.N.get(P);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(p),this.M.get(P)?.sendMessage(p)}$stopDASession(P){const p=this.N.get(P);this.N.delete(P),p&&p.onWillStopSession&&p.onWillStopSession();const v=this.M.get(P);return this.M.delete(P),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(P){const p=[],v=[],F=[];if(P.added)for(const N of P.added){const L=N.id;if(L&&!this.H.has(L)){let M;if(N.type==="function")M=new u.$VO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")M=new u.$WO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const z=A.URI.revive(N.uri);M=new u.$UO(new u.$5N(z,new u.$RN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,u.$SO)(M,L),this.H.set(L,M),p.push(M)}}if(P.removed)for(const N of P.removed){const L=this.H.get(N);L&&(this.H.delete(N),v.push(L))}if(P.changed){for(const N of P.changed)if(N.id){const L=this.H.get(N.id);if(L){if(L instanceof u.$VO&&N.type==="function"){const M=L;M.enabled=N.enabled,M.condition=N.condition,M.hitCondition=N.hitCondition,M.logMessage=N.logMessage,M.functionName=N.functionName}else if(L instanceof u.$UO&&N.type==="source"){const M=L;M.enabled=N.enabled,M.condition=N.condition,M.hitCondition=N.hitCondition,M.logMessage=N.logMessage,M.location=new u.$5N(A.URI.revive(N.uri),new u.$RN(N.line,N.character))}F.push(L)}}}this.rb(p,v,F)}async $acceptStackFrameFocus(P){let p;if(P){const v=await this.sb(P.sessionId);P.kind==="thread"?p=new u.$3O(v.api,P.threadId):p=new u.$2O(v.api,P.threadId,P.frameId)}this.J=p,this.L.fire(this.J)}$provideDebugConfigurations(P,p,v){return(0,r.$yh)(async()=>{const F=this.mb(P);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(p);return F.provideDebugConfigurations(N,v)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(P,p,v,F){return(0,r.$yh)(async()=>{const N=this.mb(P);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb(p);return N.resolveDebugConfiguration(L,v,F)})}$resolveDebugConfigurationWithSubstitutedVariables(P,p,v,F){return(0,r.$yh)(async()=>{const N=this.mb(P);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb(p);return N.resolveDebugConfigurationWithSubstitutedVariables(L,v,F)})}async $provideDebugAdapter(P,p){const v=this.lb(P);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(p);return this.pb(v,F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(P){const p=await this.sb(P);this.y.fire(p.api)}async $acceptDebugSessionTerminated(P){const p=await this.sb(P);p&&(this.z.fire(p.api),this.w.delete(p.id))}async $acceptDebugSessionActiveChanged(P){this.D=P?await this.sb(P):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(P,p){(await this.sb(P))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(P,p){const F={session:(await this.sb(P)).api,event:p.event,body:p.body};this.F.fire(F)}jb(P){if(P instanceof u.$XO)return{type:"executable",command:P.command,args:P.args,options:P.options};if(P instanceof u.$YO)return{type:"server",port:P.port,host:P.host};if(P instanceof u.$ZO)return{type:"pipeServer",path:P.path};if(P instanceof u.$1O)return{type:"implementation",implementation:P.implementation};throw new Error("convertToDto unexpected type")}kb(P){const p=this.j.filter(v=>v.type===P);if(p.length>0)return p[0].factory}lb(P){const p=this.j.filter(v=>v.handle===P);if(p.length>0)return p[0].factory}mb(P){const p=this.g.filter(v=>v.handle===P);if(p.length>0)return p[0].provider}nb(P,p){if(P.contributes){const v=P.contributes.debuggers;if(v&&v.length>0){for(const F of v)if(F.label&&F.type&&F.type===p)return!0}}return!1}ob(P){const v=P.configuration.type,F=this.n.filter(N=>N.type===v||N.type==="*").map(N=>(0,r.$yh)(()=>N.factory.createDebugAdapterTracker(P.api)).then(L=>L,L=>null));return Promise.race([Promise.all(F).then(N=>{const L=(0,o.$Hb)(N);if(L.length>0)return new E(L)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(P,p){const v=p.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new u.$YO(v));if(P){const N=await this.Z.getExtensionRegistry();return(0,r.$yh)(()=>P.createDebugAdapterDescriptor(p.api,this.qb(p,N))).then(L=>{if(L)return L})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(p,F))}qb(P,p){}rb(P,p,v){(P.length>0||p.length>0||v.length>0)&&this.I.fire(Object.freeze({added:P,removed:p,changed:v}))}async sb(P){if(P)if(typeof P=="string"){const p=this.w.get(P);if(p)return p}else{let p=this.w.get(P.id);if(!p){const v=await this.tb(P.folderUri),F=P.parent?this.w.get(P.parent):void 0;p=new l(this.u,P.id,P.type,P.name,v,P.configuration,F?.api),this.w.set(p.id,p),this.u.$sessionCached(p.id)}return p}throw new Error("cannot find session")}tb(P){if(P){const p=A.URI.revive(P);return this.Y.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}ub(P,p){return`${P}\0${p}`}vb(P,p){if(p){if("title"in p&&"command"in p)return{type:a.DebugVisualizationType.Command};if("treeId"in p)return{type:a.DebugVisualizationType.Tree,id:`${P}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(P){const p=this.xb(P);let v,F;return"id"in p?F=i.ThemeIcon.asClassName(p):v=p,{iconPath:v,iconClass:F}}xb(P){if(P instanceof u.$PO)return{id:P.id};const p=typeof P=="object"&&"dark"in P?P.dark:P,v=typeof P=="object"&&"light"in P?P.light:P;return{dark:typeof p=="string"?A.URI.file(p):p,light:typeof v=="string"?A.URI.file(v):v}}};e.$Pqc=d,e.$Pqc=d=Je([Ve(0,y.$oQ),Ve(1,C.$1pc),Ve(2,I.$Eqc),Ve(3,$.$4pc),Ve(4,c.$dqc),Ve(5,f.$Hqc),Ve(6,s.$KQ),Ve(7,n.$Jqc)],d);class l{constructor(P,p,v,F,N,L,M){this.f=P,this.g=p,this.h=v,this.j=F,this.k=N,this.l=L,this.m=M}get api(){const P=this;return this.d??=Object.freeze({id:P.g,type:P.h,get name(){return P.j},set name(p){P.j=p,P.f.$setDebugSessionName(P.g,p)},parentSession:P.m,workspaceFolder:P.k,configuration:P.l,customRequest(p,v){return P.f.$customDebugAdapterRequest(P.g,p,v)},getDebugProtocolBreakpoint(p){return P.f.$getDebugProtocolBreakpoint(P.g,p.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(P){this.j=P}get configuration(){return this.l}}e.$Qqc=l;class g{constructor(P){this.value=Object.freeze({append(p){P.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$Rqc=g;class E{constructor(P){this.d=P}onWillStartSession(){this.d.forEach(P=>P.onWillStartSession?P.onWillStartSession():void 0)}onWillReceiveMessage(P){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(P):void 0)}onDidSendMessage(P){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(P):void 0)}onWillStopSession(){this.d.forEach(P=>P.onWillStopSession?P.onWillStopSession():void 0)}onError(P){this.d.forEach(p=>p.onError?p.onError(P):void 0)}onExit(P,p){this.d.forEach(v=>v.onExit?v.onExit(P,p):void 0)}}class S extends w.$cub{constructor(P){super(),this.h=P,P.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(P){this.h.handleMessage(P)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let D=class extends d{constructor(P,p,v,F,N,L,M,z){super(P,p,v,F,N,L,M,z)}};e.$Sqc=D,e.$Sqc=D=Je([Ve(0,y.$oQ),Ve(1,C.$1pc),Ve(2,I.$Eqc),Ve(3,$.$4pc),Ve(4,c.$dqc),Ve(5,f.$Hqc),Ve(6,s.$KQ),Ve(7,n.$Jqc)],D)}),define(ke[340],Ie([1,0,13,61,2,6,288,11,88,114,29,225,19,72,54,94]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Trc=e.$Src=void 0,r=We(r),h=We(h);class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(O.$bk),o=i.get(u.$oQ).getProxy(R.$ON.MainThreadErrors);r.setUnexpectedErrorHandler(n=>{s.error(n);const d=r.$2(n);o.$onUnexpectedError(d)})}static async installFullHandler(i){const s=i.get(O.$bk),t=i.get(u.$oQ),o=i.get(w.$Eqc),n=i.get(a.$IQ),d=t.getProxy(R.$ON.MainThreadExtensionService),l=t.getProxy(R.$ON.MainThreadErrors),g=await o.getExtensionPathIndex(),E=new WeakMap;function S(P,p){if(E.has(P))return E.get(P).stack;let v="",F,N;for(const M of p)v+=`
	at ${M.toString()}`,N=M.getFileName(),!F&&N&&(F=g.findSubstr(A.URI.file(N)));const L=`${P.name||"Error"}: ${P.message||""}${v}`;return E.set(P,{extensionIdentifier:F?.identifier,stack:L}),L}const D=Symbol("prepareStackTrace wrapped");let k=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(P){if(P===S||!P||P[D]){k=P||S;return}k=function(p,v){return S(p,v),P.call(Error,p,v)},Object.assign(k,{[D]:!0})}}),r.setUnexpectedErrorHandler(P=>{s.error(P);const p=r.$2(P),v=E.get(P);if(!v?.extensionIdentifier){l.$onUnexpectedError(p);return}d.$onExtensionRuntimeError(v.extensionIdentifier,p);const F=n.onExtensionError(v.extensionIdentifier,P);s.trace("forwarded error to extension?",F,v)})}}e.$Src=m;class ${constructor(i,s,t,o,n){this.a=t,this.b=new T.$6dc(i,null,o),s=$.e(s,this.b);const d=new c.$Ei(...(0,b.$Ts)());d.set(I.$EQ,{_serviceBrand:void 0,...s,messagePorts:n}),d.set(u.$oQ,new u.$pQ(this.b)),d.set(C.$Xpc,new C.$Ypc(o)),d.set(w.$Cqc,t);const l=new y.$xr(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(g=>g.get(O.$bk)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction(g=>g.get(w.$Eqc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const s=this.b.getProxy(R.$ON.MainThreadExtensionService);return A.URI.revive(await s.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,s){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=A.URI.revive(s.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=A.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>A.URI.revive(s.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=A.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=A.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=A.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=A.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=A.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=A.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.$Trc=$}),define(ke[341],Ie([1,0,7,10,8,218,149,101,77,54,19,48,9,64,49,259,260,41,34,98]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4rc=void 0,h=We(h),A=We(A);let s=class extends O.$Pqc{constructor(l,g,E,S,D,k,P,p,v){super(l,g,E,S,k,P,p,v),this.Ab=D,this.yb=new n}hb(l,g){switch(l.type){case"server":return new a.$Yrc(l);case"pipeServer":return new a.$Zrc(l);case"executable":return new a.$1rc(l,g.type)}return super.hb(l,g)}qb(l,g){const E=a.$1rc.platformAdapterExecutable(g.getAllExtensionDescriptions(),l.type);if(E)return new u.$XO(E.command,E.args,E.options)}ib(){return new T.$6hc}async $runInTerminal(l,g){if(l.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(z=>{this.yb.onTerminalClosed(z)})));const E=await this.$.getConfigProvider(),S=this.Ab.getDefaultShell(!0),D=this.Ab.getDefaultShellArgs(!0),k=l.title||A.localize(2714,null),P=JSON.stringify({shell:S,shellArgs:D});let p=await this.yb.checkout(P,k),v,F=!1;if(p)v=l.cwd;else{const z={shellPath:S,shellArgs:D,cwd:l.cwd,name:k,iconPath:new u.$PO("debug")};F=!0,p=this.Ab.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(p,P)}p.show(!0);const N=await p.processId;F?await new Promise(z=>setTimeout(z,1e3)):(p.state.isInteractedWith&&(p.sendText(""),await(0,r.$Hh)(200)),E.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?p.sendText("cls"):S.indexOf("bash")>=0?p.sendText("clear"):h.$j?p.sendText("cls"):p.sendText("clear")));const L=(0,m.$3rc)(S,l.args,!!l.argsCanBeInterpretedByShell,v,l.env);p.sendText(L);const M=this.onDidTerminateDebugSession(z=>{z.id===g&&(this.yb.free(p),M.dispose())});return N}else if(l.kind==="external")return o(l,await this.$.getConfigProvider());return super.$runInTerminal(l,g)}};e.$4rc=s,e.$4rc=s=Je([Ve(0,I.$oQ),Ve(1,w.$1pc),Ve(2,c.$Eqc),Ve(3,$.$4pc),Ve(4,y.$pqc),Ve(5,b.$dqc),Ve(6,C.$Hqc),Ve(7,f.$KQ),Ve(8,i.$Jqc)],s);let t;function o(d,l){if(!t)if(h.$j)t=new R.$Ngc;else if(h.$k)t=new R.$Ogc;else if(h.$l)t=new R.$Pgc;else throw new Error("external terminals not supported on this platform");const g=l.getConfiguration("terminal");return t.runInTerminal(d.title,d.cwd,d.args,d.env||{},g.external||{})}class n{constructor(){this.b=new Map}static{this.a=1e3}async checkout(l,g,E=!1){const D=[...this.b.entries()].map(([k,P])=>(0,r.$th)(async p=>{if(k.name!==g||P.lastUsedAt!==-1&&await(0,m.$2rc)(await k.processId))return null;const v=Date.now();return P.lastUsedAt+n.a>v||p.isCancellationRequested?null:P.config!==l?(E&&k.dispose(),null):(P.lastUsedAt=v,k)}));return await(0,r.$Lh)(D,k=>!!k)}insert(l,g){this.b.set(l,{lastUsedAt:Date.now(),config:g})}free(l){const g=this.b.get(l);g&&(g.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}}),define(ke[342],Ie([1,0,16,2,109,49,63,41,47,48,19,29,100,14,11,95,22,66,64]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrc=void 0,r=We(r),m=We(m);let i=class extends u.$zrc{constructor(t,o,n,d,l,g,E,S,D){super(t,o,n,d,l,g,E,S),this.C=n,this.D=D,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,o){const n=o;if(!o.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const d=u.TaskHandleDTO.from(n,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const g=await this.z(l,o);return this.a.$executeTask(d).catch(()=>{}),g}else{const d=u.TaskDTO.from(o,t);if(d===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(d.execution)&&await this.y(d,o,!1);const l=await this.z(await this.a.$getTaskExecution(d),o);return this.a.$executeTask(d).catch(()=>{}),l}}v(t,o,n,d){const l=[];if(d)for(const g of d){this.A(g,n),(!g.definition||!t[g.definition.type])&&this.f.warn(`The task [${g.source}, ${g.name}] uses an undefined task type. The task will be ignored in the future.`);const E=u.TaskDTO.from(g,n.extension);E&&(l.push(E),u.CustomExecutionDTO.is(E.execution)&&o.push(this.y(E,g,!0)))}return{tasks:l,extension:n.extension}}async w(t){return t}async G(t){let o=t&&t.length>0?t[0]:void 0;if(!o){const n=h.URI.file((0,$.homedir)());o=new b.$1i({uri:n,name:m.$eh(n),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,o){const n=h.URI.revive(t),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(n),g=await this.b.getWorkspaceFolders2()??[],E=await this.D.getResolver(),S=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(g);for(const D of o.variables)d.variables[D]=await E.resolveAsync(S,D);if(o.process!==void 0){let D;if(o.process.path!==void 0){D=o.process.path.split(r.$uc);for(let k=0;k<D.length;k++)D[k]=await E.resolveAsync(S,D[k])}d.process=await A.win32.findExecutable(await E.resolveAsync(S,o.process.name),o.process.cwd!==void 0?await E.resolveAsync(S,o.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(t,o,n){return A.win32.findExecutable(t,o,n)}};e.$Vrc=i,e.$Vrc=i=Je([Ve(0,I.$oQ),Ve(1,y.$EQ),Ve(2,R.$1pc),Ve(3,T.$zQ),Ve(4,O.$4pc),Ve(5,c.$pqc),Ve(6,w.$bk),Ve(7,a.$Epc),Ve(8,f.$Hqc)],i)}),define(ke[343],Ie([1,0,66,64]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bsc=void 0;class A extends h.$Iqc{m(){return(0,r.homedir)()}}e.$Bsc=A}),define(ke[172],Ie([1,0,18,7,20,52,14,16,22,2,37]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=e.$8qc=e.$7qc=void 0,e.$9qc=a,O=We(O),b=We(b);class y{constructor(f,i,s){this.d=f,this.e=i,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(f,i){const s=this.g.folderQueries||[],t=new A.$xe(i);return new Promise((o,n)=>{this.a=new C(f);let d=!1;const l=(g,E)=>{if(!d&&!this.b){const S=this.h(g);a(g)&&typeof this.g.maxResults=="number"&&this.c+S>this.g.maxResults&&(this.b=!0,d=!0,t.cancel(),g=this.j(g,this.g.maxResults-this.c));const D=this.h(g);this.c+=D,(D>0||!a(g))&&this.a.add(g,E)}};Promise.all(s.map((g,E)=>this.k(g,S=>l(S,E),t.token))).then(g=>{t.dispose(),this.a.flush();const E=g.some(S=>!!S&&!!S.limitHit);o({limitHit:this.b||E,messages:g.flatMap(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[]),stats:{type:this.f}})},g=>{t.dispose();const E=(0,R.$rj)(g);n(new Error(E))})})}h(f){return a(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}j(f,i){const s=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:s.slice(0,i),preview:{matches:t.slice(0,i),text:f.preview.text},uri:f.uri}}async k(f,i,s){const t=new I.$sM(this.g,f),o=[],n={report:g=>{if(!this.l(g))return;const E=f.folder.scheme===T.Schemas.file?(0,I.$tM)(()=>this.e.readdir(b.$gh(g.uri))):void 0,S=b.$jh(f.folder,g.uri);if(S){const D=t.includedInQuery(S,O.$oc(S),E);(0,h.$sh)(D)?o.push(D.then(k=>{k&&i(g)})):D&&i(g)}}},d=this.n(f);let l;return this.d.query.type===I.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,n,s):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),d,n,s),o.length&&await Promise.all(o),l}l(f){if(a(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(f){const i=(0,I.$rM)(this.g.includePattern,f.includePattern),s=(0,I.$rM)(this.g.excludePattern,f.excludePattern),t={folder:c.URI.from(f.folder),excludes:s,includes:i,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.e.toCanonicalName(f.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$$L,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$7qc=y;function u($){return{isCaseSensitive:$.isCaseSensitive||!1,isRegExp:$.isRegExp||!1,isWordMatch:$.isWordMatch||!1,isMultiline:$.isMultiline||!1,pattern:$.pattern}}class C{constructor(f){this.e=f,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(f,i){this.d&&(this.b!==i||!b.$ah(this.c,f.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:f.uri,results:[]}),this.d.results.push(w(f))}f(){const f=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,f)}flush(){this.f(),this.a.flush()}g(f){this.e(f)}}e.$8qc=C;function w($){return a($)?{preview:{matches:(0,r.$1b)($.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:$.preview.text},ranges:(0,r.$1b)($.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:$.text,lineNumber:$.lineNumber}}function a($){return!!$.preview}class m{static{this.a=4e3}static{this.b=50}constructor(f,i){this.g=f,this.h=i,this.c=0,this.d=[],this.e=0}addItem(f,i){f&&this.j(f,i)}addItems(f,i){f&&this.k(f,i)}j(f,i){this.d.push(f),this.e+=i,this.l()}k(f,i){this.d=this.d.concat(f),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$0qc=m}),define(ke[102],Ie([1,0,3,6,5,336,19,72,11,2,172]),function($e,e,r,h,A,R,T,O,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=e.$$qc=void 0,e.$arc=u,e.$$qc=(0,A.$Gi)("IExtHostSearch");let y=class{constructor(a,m,$){this.n=a,this.o=m,this.q=$,this.c=this.n.getProxy(h.$ON.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$6qc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const $=this.d++;return this.e.set($,m),this.c.$registerTextSearchProvider($,this.s(a)),(0,r.$Tc)(()=>{this.g.delete(a),this.e.delete($),this.c.$unregisterProvider($)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const $=this.d++;return this.h.set($,m),this.c.$registerAITextSearchProvider($,this.s(a)),(0,r.$Tc)(()=>{this.i.delete(a),this.h.delete($),this.c.$unregisterProvider($)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const $=this.d++;return this.j.set($,m),this.c.$registerFileSearchProvider($,this.s(a)),(0,r.$Tc)(()=>{this.k.delete(a),this.j.delete($),this.c.$unregisterProvider($)})}$provideFileSearchResults(a,m,$,f){const i=u($),s=this.j.get(a);if(s)return this.l.fileSearch(i,s,t=>{this.c.$handleFileMatch(a,m,t.map(o=>o.resource))},f);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,$){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,$,f){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${a}`);const s=u($);return this.t(s,i).search(o=>this.c.$handleTextMatch(a,m,o),f)}$provideAITextSearchResults(a,m,$,f){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${a}`);const s=u($);return this.v(s,i).search(o=>this.c.$handleTextMatch(a,m,o),f)}$enableExtensionHostSearch(){}t(a,m){return new I.$7qc({query:a,provider:m},{readdir:$=>Promise.resolve([]),toCanonicalName:$=>$},"textSearchProvider")}v(a,m){return new I.$7qc({query:a,provider:m},{readdir:$=>Promise.resolve([]),toCanonicalName:$=>$},"aiTextSearchProvider")}};e.$_qc=y,e.$_qc=y=Je([Ve(0,T.$oQ),Ve(1,O.$Xpc),Ve(2,b.$bk)],y);function u(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(C),extraFileResources:w.extraFileResources&&w.extraFileResources.map(a=>c.URI.revive(a))}}function C(w){return{...w,folder:c.URI.revive(w.folder)}}});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[344],Ie([1,0,7,20,13,4,3,14,43,2,113,201,202,58,23,27,11,90,91,246,6,290,317,95,127,294,295,296,275,265,34,297,41,298,101,164,299,277,291,300,301,63,77,278,292,54,302,75,303,62,29,318,279,304,305,128,306,122,123,280,335,308,250,309,319,310,170,281,311,312,313,19,314,102,124,315,282,316,125,97,100,94,48,168,98,320,293,321,322,76,15,9,283,72,284,96,323,324,163,49,119,93,25,99]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n,d,l,g,E,S,D,k,P,p,v,F,N,L,M,z,j,q,B,ee,H,W,X,_,ce,ne,ye,ge,Y,U,oe,ve,te,ae,se,Z,re,pe,we,Fe,ze,Re,De,Ce,V,G,J,x,de,Ee,Le,He,Ke,et,nt,st,rt,at,gt,dt,ct,Pe,Be,Qe,Ne,je,ue,he,le,Ze,tt,ut,mt,Dt,Mt,Ht,ei,oi,Ot,it,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrc=hi,A=We(A),b=Ut(b),u=We(u),a=We(a),he=We(he),le=We(le);function hi(bt){const St=bt.get(ge.$EQ),ti=bt.get(ye.$Ipc),ii=bt.get(ce.$6pc),qt=bt.get(X.$Eqc),pt=bt.get(ei.$1pc),zt=bt.get(gt.$IQ),ni=bt.get(p.$4pc),ai=bt.get(tt.$Xpc),xe=bt.get(de.$oQ),ci=bt.get(st.$mqc),di=bt.get(rt.$7pc),fi=bt.get(m.$ck),vt=bt.get(m.$bk),jt=bt.get(ue.$pGb),Nt=bt.get(n.$Epc),Gt=bt.get(Ht.$Mrc),ri=bt.get(He.$wqc),Xt=bt.get(ee.$dqc),li=bt.get(Z.$Aqc),Wt=bt.get(d.$Opc),Kt=bt.get(te.$tqc);xe.set(s.$PN.ExtHostFileSystemInfo,ti),xe.set(s.$PN.ExtHostLogLevelServiceShape,fi),xe.set(s.$PN.ExtHostWorkspace,pt),xe.set(s.$PN.ExtHostConfiguration,ni),xe.set(s.$PN.ExtHostExtensionService,qt),xe.set(s.$PN.ExtHostStorage,ci),xe.set(s.$PN.ExtHostTunnelService,jt),xe.set(s.$PN.ExtHostWindow,Gt),xe.set(s.$PN.ExtHostSecretState,ri),xe.set(s.$PN.ExtHostTelemetry,zt),xe.set(s.$PN.ExtHostEditorTabs,Xt),xe.set(s.$PN.ExtHostManagedSockets,li),xe.set(s.$PN.ExtHostAuthentication,Wt),xe.set(s.$PN.ExtHostChatProvider,Kt);const Jt=xe.set(s.$PN.ExtHostDecorations,bt.get(N.$Uqc)),Ft=xe.set(s.$PN.ExtHostDocumentsAndEditors,bt.get(B.$zQ)),wt=xe.set(s.$PN.ExtHostCommands,bt.get(k.$KQ)),It=xe.set(s.$PN.ExtHostTerminalService,bt.get(dt.$pqc)),Qt=xe.set(s.$PN.ExtHostTerminalShellIntegration,bt.get(ct.$Crc)),Pt=xe.set(s.$PN.ExtHostDebugService,bt.get(F.$Oqc)),mi=xe.set(s.$PN.ExtHostSearch,bt.get(Le.$$qc)),xt=xe.set(s.$PN.ExtHostTask,bt.get(at.$Brc)),ki=xe.set(s.$PN.ExtHostOutputService,bt.get(Ce.$orc)),bi=xe.set(s.$PN.ExtHostLocalization,bt.get(se.$zqc)),Ri=xe.set(s.$PN.ExtHostUrls,new ut.$Jrc(xe)),Tt=xe.set(s.$PN.ExtHostDocuments,new q.$Lpc(xe,Ft)),Li=xe.set(s.$PN.ExtHostDocumentContentProviders,new z.$Wqc(xe,Ft,vt)),ui=xe.set(s.$PN.ExtHostDocumentSaveParticipant,new j.$Xqc(vt,Tt,xe.getProxy(s.$ON.MainThreadBulkEdits))),At=xe.set(s.$PN.ExtHostNotebook,new pe.$brc(xe,wt,Ft,Tt,ii,mi,vt)),Oi=xe.set(s.$PN.ExtHostNotebookDocuments,new Fe.$irc(At)),Ii=xe.set(s.$PN.ExtHostNotebookEditors,new ze.$jrc(vt,At)),Si=xe.set(s.$PN.ExtHostNotebookKernels,new Re.$krc(xe,St,At,wt,vt)),Ni=xe.set(s.$PN.ExtHostNotebookRenderers,new De.$mrc(xe,At)),wi=xe.set(s.$PN.ExtHostNotebookDocumentSaveParticipant,new we.$hrc(vt,At,xe.getProxy(s.$ON.MainThreadBulkEdits))),Vt=xe.set(s.$PN.ExtHostEditors,new Be.$Upc(xe,Ft)),Oe=xe.set(s.$PN.ExtHostTreeViews,new je.$Hrc(xe.getProxy(s.$ON.MainThreadTreeViews),wt,vt)),Me=xe.set(s.$PN.ExtHostEditorInsets,new D.$Vpc(xe.getProxy(s.$ON.MainThreadEditorInsets),Vt,St.remote)),Se=xe.set(s.$PN.ExtHostDiagnostics,new L.$Kpc(xe,vt,ti,Ft)),ie=xe.set(s.$PN.ExtHostLanguages,new ae.$frc(xe,Tt,wt.converter,ai)),Ae=xe.set(s.$PN.ExtHostLanguageFeatures,new oe.$Mpc(xe,ai,Tt,wt,Se,vt,Nt,zt)),Ge=xe.set(s.$PN.ExtHostFileSystem,new _.$1qc(xe,Ae)),_e=xe.set(s.$PN.ExtHostFileSystemEventService,new ne.$2qc(xe,vt,Ft)),Xe=xe.set(s.$PN.ExtHostQuickOpen,(0,x.$src)(xe,pt,wt)),ft=xe.set(s.$PN.ExtHostSCM,new Ee.$urc(xe,wt,Tt,vt)),Rt=xe.set(s.$PN.ExtHostQuickDiff,new J.$rrc(xe,ai)),Zt=xe.set(s.$PN.ExtHostShare,new Ke.$vrc(xe,ai)),si=xe.set(s.$PN.ExtHostComments,(0,P.$Wpc)(xe,wt,Tt)),Bt=xe.set(s.$PN.ExtHostProgress,new G.$qrc(xe.getProxy(s.$ON.MainThreadProgress))),_t=xe.set(s.$PN.ExtHostLabelService,new U.$drc(xe)),Wi=xe.set(s.$PN.ExtHostTheming,new Qe.$Erc(xe)),rn=xe.set(s.$PN.ExtHostTimeline,new Ne.$Grc(xe,wt)),Vi=xe.set(s.$PN.ExtHostWebviews,new mt.$$pc(xe,St.remote,pt,vt,Nt)),Mi=xe.set(s.$PN.ExtHostWebviewPanels,new Dt.$bqc(xe,Vi,pt)),Hi=xe.set(s.$PN.ExtHostCustomEditors,new v.$cqc(xe,Tt,di,Vi,Mi)),Gi=xe.set(s.$PN.ExtHostWebviewViews,new Mt.$Krc(xe,Vi)),Pi=xe.set(s.$PN.ExtHostTesting,bt.get(Pe.$Jqc)),sn=xe.set(s.$PN.ExtHostUriOpeners,new Ze.$Irc(xe)),on=xe.set(s.$PN.ExtHostProfileContentHandlers,new V.$prc(xe));xe.set(s.$PN.ExtHostInteractive,new Y.$crc(xe,At,Ft,wt,vt));const ji=xe.set(s.$PN.ExtHostChatAgents2,new g.$Rpc(xe,vt,wt,Tt)),an=xe.set(s.$PN.ExtHostChatVariables,new E.$Spc(xe)),Bi=xe.set(s.$PN.ExtHostLanguageModelTools,new ve.$erc(xe)),Qi=xe.set(s.$PN.ExtHostAiRelatedInformation,new t.$Dpc(xe)),yn=xe.set(s.$PN.ExtHostAiEmbeddingVector,new W.$Zqc(xe)),cn=xe.set(s.$PN.ExtHostStatusBar,new nt.$yrc(xe,wt.converter)),Ki=xe.set(s.$PN.ExtHostSpeech,new et.$wrc(xe)),Ci=xe.set(s.$PN.ExtHostEmbeddings,new H.$Yqc(xe)),Sn=Object.values(s.$PN);xe.assertRegistered(Sn);const Dn=new l.$Qpc(xe,Ft),ln=new S.$Tpc(xe),Xi=new re.$grc(xe,vt),Ji=new M.$Vqc(xe);return o.$Npc.register(wt),function(qe,vi,Zi){function lt(fe){return(be,Ue,ht)=>{const Et=fe(Lt=>{try{be.call(Ue,Lt)}catch(gi){A.$1(new Error(`[ExtensionListenerError] Extension '${qe.identifier.value}' FAILED to handle event: ${gi.toString()}`,{cause:gi})),zt.onExtensionError(qe.identifier,gi)}});return ht?.push(Et),Et}}const kt=function(){let fe=!qe.isUnderDevelopment;function be(){fe||(vt.info(`Extension '${qe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Ue(ht){if(Array.isArray(ht))ht.forEach(Ue);else if(typeof ht=="string")be();else{const Et=ht;typeof Et.scheme>"u"&&be(),typeof Et.exclusive=="boolean"&&(0,it.$jH)(qe,"documentFiltersExclusive")}return ht}}(),Yi={getSession(fe,be,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,it.$jH)(qe,"authLearnMore"),Ue?.account&&(0,it.$jH)(qe,"authGetSessions"),Wt.getSession(qe,fe,be,Ue)},getAccounts(fe){return(0,it.$jH)(qe,"authGetSessions"),Wt.getAccounts(fe)},async hasSession(fe,be){return(0,it.$jH)(qe,"authSession"),!!await Wt.getSession(qe,fe,be,{silent:!0})},get onDidChangeSessions(){return lt(Wt.onDidChangeSessions)},registerAuthenticationProvider(fe,be,Ue,ht){return Wt.registerAuthenticationProvider(fe,be,Ue,ht)}},un={registerCommand(fe,be,Ue){return wt.registerCommand(!0,fe,be,Ue,void 0,qe)},registerTextEditorCommand(fe,be,Ue){return wt.registerCommand(!0,fe,(...ht)=>{const Et=Vt.getActiveTextEditor();if(!Et){vt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return Et.edit(Lt=>{be.apply(Ue,[Et,Lt,...ht])}).then(Lt=>{Lt||vt.warn("Edits from command "+fe+" were not applied.")},Lt=>{vt.warn("An error occurred while running command "+fe,Lt)})},void 0,void 0,qe)},registerDiffInformationCommand:(fe,be,Ue)=>((0,it.$jH)(qe,"diffCommand"),wt.registerCommand(!0,fe,async(...ht)=>{const Et=Ft.activeEditor(!0);if(!Et){vt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Lt=await Vt.getDiffInformation(Et.id);be.apply(Ue,[Lt,...ht])},void 0,void 0,qe)),executeCommand(fe,...be){return wt.executeCommand(fe,...be)},getCommands(fe=!1){return wt.getCommands(fe)}},Ei={get machineId(){return St.telemetryInfo.machineId},get sessionId(){return St.telemetryInfo.sessionId},get language(){return St.environment.appLanguage},get appName(){return St.environment.appName},get appRoot(){return St.environment.appRoot?.fsPath??""},get appHost(){return St.environment.appHost},get uriScheme(){return St.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return lt(It.onDidChangeShell)},get isTelemetryEnabled(){return zt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(zt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,it.$jH)(qe,"telemetry"),zt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,it.$jH)(qe,"telemetry"),lt(zt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,gt.$HQ)(St.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,be){return gt.$GQ.validateSender(fe),zt.instantiateLogger(qe,fe,be)},openExternal(fe,be){return Gt.openUri(fe,{allowTunneling:!!St.remote.authority,allowContributedOpeners:be?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===St.environment.appUriScheme)return Ri.createAppUri(fe);try{return await Gt.asExternalUri(fe,{allowTunneling:!!St.remote.authority})}catch(be){if((0,O.$Pg)(fe,O.Schemas.http)||(0,O.$Pg)(fe,O.Schemas.https))return fe;throw be}},get remoteName(){return(0,$.$jn)(St.remote.authority)},get remoteAuthority(){return(0,it.$jH)(qe,"resolvers"),St.remote.authority},get uiKind(){return St.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return lt(vt.onDidChangeLogLevel)},get appQuality(){return(0,it.$jH)(qe,"resolvers"),St.quality},get appCommit(){return(0,it.$jH)(qe,"resolvers"),St.commit}};St.environment.extensionTestsLocationURI||Object.freeze(Ei);const zi={createTestController(fe,be,Ue){return Pi.createTestController(qe,fe,be,Ue)},createTestObserver(){return(0,it.$jH)(qe,"testObserver"),Pi.createTestObserver()},runTests(fe){return(0,it.$jH)(qe,"testObserver"),Pi.runTests(fe)},registerTestFollowupProvider(fe){return(0,it.$jH)(qe,"testObserver"),Pi.registerTestFollowupProvider(fe)},get onDidChangeTestResults(){return(0,it.$jH)(qe,"testObserver"),lt(Pi.onResultsChanged)},get testResults(){return(0,it.$jH)(qe,"testObserver"),Pi.results}},Ui=St.remote.isRemote?le.ExtensionKind.Workspace:le.ExtensionKind.UI,$i={getExtension(fe,be){(0,it.$iH)(qe,"extensionsAny")||(be=!1);const Ue=vi.mine.getExtensionDescription(fe);if(Ue)return new X.$Fqc(qt,qe.identifier,Ue,Ui,!1);if(be){const ht=vi.all.getExtensionDescription(fe);if(ht)return new X.$Fqc(qt,qe.identifier,ht,Ui,!0)}},get all(){const fe=[];for(const be of vi.mine.getAllExtensionDescriptions())fe.push(new X.$Fqc(qt,qe.identifier,be,Ui,!1));return fe},get allAcrossExtensionHosts(){(0,it.$jH)(qe,"extensionsAny");const fe=new w.$tn(vi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),be=[];for(const Ue of vi.all.getAllExtensionDescriptions()){const ht=!fe.has(Ue.identifier);be.push(new X.$Fqc(qt,qe.identifier,Ue,Ui,ht))}return be},get onDidChange(){return(0,it.$iH)(qe,"extensionsAny")?lt(R.Event.any(vi.mine.onDidChange,vi.all.onDidChange)):lt(vi.mine.onDidChange)}},qi={createDiagnosticCollection(fe){return Se.createDiagnosticCollection(qe.identifier,fe)},get onDidChangeDiagnostics(){return lt(Se.onDidChangeDiagnostics)},getDiagnostics:fe=>Se.getDiagnostics(fe),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(fe,be){return ie.changeLanguage(fe.uri,be)},match(fe,be){const Ue=he.LanguageSelector.from(fe);let ht;return(0,y.$yu)(Ue)&&(ht=At.notebookDocuments.find(Et=>Et.apiNotebook.getCells().find(Lt=>Lt.document===be))?.apiNotebook),(0,y.$xu)(Ue,be.uri,be.languageId,!0,ht?.uri,ht?.notebookType)},registerCodeActionsProvider(fe,be,Ue){return Ae.registerCodeActionProvider(qe,kt(fe),be,Ue)},registerDocumentPasteEditProvider(fe,be,Ue){return(0,it.$jH)(qe,"documentPaste"),Ae.registerDocumentPasteEditProvider(qe,kt(fe),be,Ue)},registerCodeLensProvider(fe,be){return Ae.registerCodeLensProvider(qe,kt(fe),be)},registerDefinitionProvider(fe,be){return Ae.registerDefinitionProvider(qe,kt(fe),be)},registerDeclarationProvider(fe,be){return Ae.registerDeclarationProvider(qe,kt(fe),be)},registerImplementationProvider(fe,be){return Ae.registerImplementationProvider(qe,kt(fe),be)},registerTypeDefinitionProvider(fe,be){return Ae.registerTypeDefinitionProvider(qe,kt(fe),be)},registerHoverProvider(fe,be){return Ae.registerHoverProvider(qe,kt(fe),be,qe.identifier)},registerEvaluatableExpressionProvider(fe,be){return Ae.registerEvaluatableExpressionProvider(qe,kt(fe),be,qe.identifier)},registerInlineValuesProvider(fe,be){return Ae.registerInlineValuesProvider(qe,kt(fe),be,qe.identifier)},registerDocumentHighlightProvider(fe,be){return Ae.registerDocumentHighlightProvider(qe,kt(fe),be)},registerMultiDocumentHighlightProvider(fe,be){return Ae.registerMultiDocumentHighlightProvider(qe,kt(fe),be)},registerLinkedEditingRangeProvider(fe,be){return Ae.registerLinkedEditingRangeProvider(qe,kt(fe),be)},registerReferenceProvider(fe,be){return Ae.registerReferenceProvider(qe,kt(fe),be)},registerRenameProvider(fe,be){return Ae.registerRenameProvider(qe,kt(fe),be)},registerNewSymbolNamesProvider(fe,be){return(0,it.$jH)(qe,"newSymbolNamesProvider"),Ae.registerNewSymbolNamesProvider(qe,kt(fe),be)},registerDocumentSymbolProvider(fe,be,Ue){return Ae.registerDocumentSymbolProvider(qe,kt(fe),be,Ue)},registerWorkspaceSymbolProvider(fe){return Ae.registerWorkspaceSymbolProvider(qe,fe)},registerDocumentFormattingEditProvider(fe,be){return Ae.registerDocumentFormattingEditProvider(qe,kt(fe),be)},registerDocumentRangeFormattingEditProvider(fe,be){return Ae.registerDocumentRangeFormattingEditProvider(qe,kt(fe),be)},registerOnTypeFormattingEditProvider(fe,be,Ue,...ht){return Ae.registerOnTypeFormattingEditProvider(qe,kt(fe),be,[Ue].concat(ht))},registerDocumentSemanticTokensProvider(fe,be,Ue){return Ae.registerDocumentSemanticTokensProvider(qe,kt(fe),be,Ue)},registerDocumentRangeSemanticTokensProvider(fe,be,Ue){return Ae.registerDocumentRangeSemanticTokensProvider(qe,kt(fe),be,Ue)},registerSignatureHelpProvider(fe,be,Ue,...ht){return typeof Ue=="object"?Ae.registerSignatureHelpProvider(qe,kt(fe),be,Ue):Ae.registerSignatureHelpProvider(qe,kt(fe),be,typeof Ue>"u"?[]:[Ue,...ht])},registerCompletionItemProvider(fe,be,...Ue){return Ae.registerCompletionItemProvider(qe,kt(fe),be,Ue)},registerInlineCompletionItemProvider(fe,be,Ue){return be.handleDidShowCompletionItem&&(0,it.$jH)(qe,"inlineCompletionsAdditions"),be.handleDidPartiallyAcceptCompletionItem&&(0,it.$jH)(qe,"inlineCompletionsAdditions"),Ue&&(0,it.$jH)(qe,"inlineCompletionsAdditions"),Ae.registerInlineCompletionsProvider(qe,kt(fe),be,Ue)},registerInlineEditProvider(fe,be){return(0,it.$jH)(qe,"inlineEdit"),Ae.registerInlineEditProvider(qe,kt(fe),be)},registerDocumentLinkProvider(fe,be){return Ae.registerDocumentLinkProvider(qe,kt(fe),be)},registerColorProvider(fe,be){return Ae.registerColorProvider(qe,kt(fe),be)},registerFoldingRangeProvider(fe,be){return Ae.registerFoldingRangeProvider(qe,kt(fe),be)},registerSelectionRangeProvider(fe,be){return Ae.registerSelectionRangeProvider(qe,fe,be)},registerCallHierarchyProvider(fe,be){return Ae.registerCallHierarchyProvider(qe,fe,be)},registerTypeHierarchyProvider(fe,be){return Ae.registerTypeHierarchyProvider(qe,fe,be)},setLanguageConfiguration:(fe,be)=>Ae.setLanguageConfiguration(qe,fe,be),getTokenInformationAtPosition(fe,be){return(0,it.$jH)(qe,"tokenInformation"),ie.tokenAtPosition(fe,be)},registerInlayHintsProvider(fe,be){return Ae.registerInlayHintsProvider(qe,fe,be)},createLanguageStatusItem(fe,be){return ie.createLanguageStatusItem(qe,fe,be)},registerDocumentDropEditProvider(fe,be,Ue){return Ae.registerDocumentOnDropEditProvider(qe,fe,be,(0,it.$iH)(qe,"documentPaste")?Ue:void 0)}},hn={get activeTextEditor(){return Vt.getActiveTextEditor()},get visibleTextEditors(){return Vt.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(fe,be,Ue){c.URI.isUri(fe)&&fe.scheme===O.Schemas.vscodeRemote&&!fe.authority&&Nt.report("workspace.showTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority.");const ht=await(c.URI.isUri(fe)?Promise.resolve(xi.openTextDocument(fe)):Promise.resolve(fe));return Vt.showTextDocument(ht,be,Ue)},createTextEditorDecorationType(fe){return Vt.createTextEditorDecorationType(qe,fe)},onDidChangeActiveTextEditor(fe,be,Ue){return lt(Vt.onDidChangeActiveTextEditor)(fe,be,Ue)},onDidChangeVisibleTextEditors(fe,be,Ue){return lt(Vt.onDidChangeVisibleTextEditors)(fe,be,Ue)},onDidChangeTextEditorSelection(fe,be,Ue){return lt(Vt.onDidChangeTextEditorSelection)(fe,be,Ue)},onDidChangeTextEditorOptions(fe,be,Ue){return lt(Vt.onDidChangeTextEditorOptions)(fe,be,Ue)},onDidChangeTextEditorVisibleRanges(fe,be,Ue){return lt(Vt.onDidChangeTextEditorVisibleRanges)(fe,be,Ue)},onDidChangeTextEditorViewColumn(fe,be,Ue){return lt(Vt.onDidChangeTextEditorViewColumn)(fe,be,Ue)},onDidCloseTerminal(fe,be,Ue){return lt(It.onDidCloseTerminal)(fe,be,Ue)},onDidOpenTerminal(fe,be,Ue){return lt(It.onDidOpenTerminal)(fe,be,Ue)},onDidChangeActiveTerminal(fe,be,Ue){return lt(It.onDidChangeActiveTerminal)(fe,be,Ue)},onDidChangeTerminalDimensions(fe,be,Ue){return(0,it.$jH)(qe,"terminalDimensions"),lt(It.onDidChangeTerminalDimensions)(fe,be,Ue)},onDidChangeTerminalState(fe,be,Ue){return lt(It.onDidChangeTerminalState)(fe,be,Ue)},onDidWriteTerminalData(fe,be,Ue){return(0,it.$jH)(qe,"terminalDataWriteEvent"),lt(It.onDidWriteTerminalData)(fe,be,Ue)},onDidExecuteTerminalCommand(fe,be,Ue){return(0,it.$jH)(qe,"terminalExecuteCommandEvent"),lt(It.onDidExecuteTerminalCommand)(fe,be,Ue)},onDidChangeTerminalShellIntegration(fe,be,Ue){return(0,it.$jH)(qe,"terminalShellIntegration"),lt(Qt.onDidChangeTerminalShellIntegration)(fe,be,Ue)},onDidStartTerminalShellExecution(fe,be,Ue){return(0,it.$jH)(qe,"terminalShellIntegration"),lt(Qt.onDidStartTerminalShellExecution)(fe,be,Ue)},onDidEndTerminalShellExecution(fe,be,Ue){return(0,it.$jH)(qe,"terminalShellIntegration"),lt(Qt.onDidEndTerminalShellExecution)(fe,be,Ue)},get state(){return Gt.getState()},onDidChangeWindowState(fe,be,Ue){return lt(Gt.onDidChangeWindowState)(fe,be,Ue)},showInformationMessage(fe,...be){return Xi.showMessage(qe,b.default.Info,fe,be[0],be.slice(1))},showWarningMessage(fe,...be){return Xi.showMessage(qe,b.default.Warning,fe,be[0],be.slice(1))},showErrorMessage(fe,...be){return Xi.showMessage(qe,b.default.Error,fe,be[0],be.slice(1))},showQuickPick(fe,be,Ue){return Xe.showQuickPick(qe,fe,be,Ue)},showWorkspaceFolderPick(fe){return Xe.showWorkspaceFolderPick(fe)},showInputBox(fe,be){return Xe.showInput(fe,be)},showOpenDialog(fe){return Ji.showOpenDialog(qe,fe)},showSaveDialog(fe){return Ji.showSaveDialog(fe)},createStatusBarItem(fe,be,Ue){let ht,Et,Lt;return typeof fe=="string"?(ht=fe,Et=be,Lt=Ue):(Et=fe,Lt=be),cn.createStatusBarEntry(qe,ht,Et,Lt)},setStatusBarMessage(fe,be){return cn.setStatusBarMessage(fe,be)},withScmProgress(fe){return Nt.report("window.withScmProgress",qe,"Use 'withProgress' instead."),Bt.withProgress(qe,{location:le.ProgressLocation.SourceControl},(be,Ue)=>fe({report(ht){}}))},withProgress(fe,be){return Bt.withProgress(qe,fe,be)},createOutputChannel(fe,be){return ki.createOutputChannel(fe,be,qe)},createWebviewPanel(fe,be,Ue,ht){return Mi.createWebviewPanel(qe,fe,be,Ue,ht)},createWebviewTextEditorInset(fe,be,Ue,ht){return(0,it.$jH)(qe,"editorInsets"),Me.createWebviewEditorInset(fe,be,Ue,ht,qe)},createTerminal(fe,be,Ue){return typeof fe=="object"?"pty"in fe?It.createExtensionTerminal(fe):It.createTerminalFromOptions(fe):It.createTerminal(fe,be,Ue)},registerTerminalLinkProvider(fe){return It.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,be){return It.registerProfileProvider(qe,fe,be)},registerTerminalQuickFixProvider(fe,be){return(0,it.$jH)(qe,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(fe,qe.identifier.value,be)},registerTreeDataProvider(fe,be){return Oe.registerTreeDataProvider(fe,be,qe)},createTreeView(fe,be){return Oe.createTreeView(fe,be,qe)},registerWebviewPanelSerializer:(fe,be)=>Mi.registerWebviewPanelSerializer(qe,fe,be),registerCustomEditorProvider:(fe,be,Ue={})=>Hi.registerCustomEditorProvider(qe,fe,be,Ue),registerFileDecorationProvider(fe){return Jt.registerFileDecorationProvider(fe,qe)},registerUriHandler(fe){return Ri.registerUriHandler(qe,fe)},createQuickPick(){return Xe.createQuickPick(qe)},createInputBox(){return Xe.createInputBox(qe)},get activeColorTheme(){return Wi.activeColorTheme},onDidChangeActiveColorTheme(fe,be,Ue){return lt(Wi.onDidChangeActiveColorTheme)(fe,be,Ue)},registerWebviewViewProvider(fe,be,Ue){return Gi.registerWebviewViewProvider(qe,fe,be,Ue?.webviewOptions)},get activeNotebookEditor(){return At.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,be,Ue){return lt(At.onDidChangeActiveNotebookEditor)(fe,be,Ue)},get visibleNotebookEditors(){return At.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(At.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,be,Ue){return lt(Ii.onDidChangeNotebookEditorSelection)(fe,be,Ue)},onDidChangeNotebookEditorVisibleRanges(fe,be,Ue){return lt(Ii.onDidChangeNotebookEditorVisibleRanges)(fe,be,Ue)},showNotebookDocument(fe,be){return At.showNotebookDocument(fe,be)},registerExternalUriOpener(fe,be,Ue){return(0,it.$jH)(qe,"externalUriOpener"),sn.registerExternalUriOpener(qe.identifier,fe,be,Ue)},registerProfileContentHandler(fe,be){return(0,it.$jH)(qe,"profileContentHandlers"),on.registerProfileContentHandler(qe,fe,be)},registerQuickDiffProvider(fe,be,Ue,ht){return(0,it.$jH)(qe,"quickDiffProvider"),Rt.registerQuickDiffProvider(kt(fe),be,Ue,ht)},get tabGroups(){return Xt.tabGroups},registerShareProvider(fe,be){return(0,it.$jH)(qe,"shareProvider"),Zt.registerShareProvider(kt(fe),be)}},xi={get rootPath(){return Nt.report("workspace.rootPath",qe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(fe){throw new A.$9("rootPath")},getWorkspaceFolder(fe){return pt.getWorkspaceFolder(fe)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(fe){throw new A.$9("name")},get workspaceFile(){return pt.workspaceFile},set workspaceFile(fe){throw new A.$9("workspaceFile")},updateWorkspaceFolders:(fe,be,...Ue)=>pt.updateWorkspaceFolders(qe,fe,be||0,...Ue),onDidChangeWorkspaceFolders:function(fe,be,Ue){return lt(pt.onDidChangeWorkspace)(fe,be,Ue)},asRelativePath:(fe,be)=>pt.getRelativePath(fe,be),findFiles:(fe,be,Ue,ht)=>pt.findFiles(fe,be,Ue,qe.identifier,ht),findFiles2:(fe,be,Ue)=>((0,it.$jH)(qe,"findFiles2"),pt.findFiles2(fe,be,qe.identifier,Ue)),findFiles2New:(fe,be,Ue)=>{(0,it.$jH)(qe,"findFiles2New");const ht={exclude:be?.exclude&&be.exclude.length>0?be.exclude[0]:void 0,useDefaultExcludes:!be?.useExcludeSettings||be?.useExcludeSettings===Ct.ExcludeSettingOptions.FilesExclude||be?.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,useDefaultSearchExcludes:!be?.useExcludeSettings||be?.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:be?.maxResults,useIgnoreFiles:be?.useIgnoreFiles?.local,useGlobalIgnoreFiles:be?.useIgnoreFiles?.global,useParentIgnoreFiles:be?.useIgnoreFiles?.parent,followSymlinks:be?.followSymlinks};return pt.findFiles2(fe&&fe.length>0?fe[0]:void 0,ht,qe.identifier,Ue)},findTextInFiles:(fe,be,Ue,ht)=>{(0,it.$jH)(qe,"findTextInFiles");let Et,Lt;return typeof be=="object"?(Et=be,Lt=Ue):(Et={},Lt=be,ht=Ue),pt.findTextInFiles(fe,Et||{},Lt,qe.identifier,ht)},findTextInFilesNew:(fe,be,Ue)=>{(0,it.$jH)(qe,"findTextInFilesNew"),(0,it.$jH)(qe,"textSearchProviderNew");let ht={};be&&(ht={include:be.include&&be.include.length>0?be.include[0]:void 0,exclude:be.exclude&&be.exclude.length>0?be.exclude[0]:void 0,useDefaultExcludes:be.useExcludeSettings===void 0||be.useExcludeSettings===Ct.ExcludeSettingOptions.FilesExclude||be.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,useSearchExclude:be.useExcludeSettings===void 0||be.useExcludeSettings===Ct.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:be.maxResults,useIgnoreFiles:be.useIgnoreFiles?.local,useGlobalIgnoreFiles:be.useIgnoreFiles?.global,useParentIgnoreFiles:be.useIgnoreFiles?.parent,followSymlinks:be.followSymlinks,encoding:be.encoding,previewOptions:be.previewOptions?{matchLines:be.previewOptions?.numMatchLines??100,charsPerLine:be.previewOptions?.charsPerLine??1e4}:void 0,beforeContext:be.surroundingContext,afterContext:be.surroundingContext});const Et=Promise.resolve(void 0);return{results:new r.$7h(async gi=>{const Fi=async en=>(gi.emitOne((0,Ct.$5L)(en)),en);await Et.then(en=>pt.findTextInFiles(fe,ht,Fi,qe.identifier,Ue))}),complete:Et.then(gi=>({limitHit:gi?.limitHit??!1}))}},save:fe=>pt.save(fe),saveAs:fe=>pt.saveAs(fe),saveAll:fe=>pt.saveAll(fe),applyEdit(fe,be){return Dn.applyWorkspaceEdit(fe,qe,be)},createFileSystemWatcher:(fe,be,Ue,ht)=>{let Et;return typeof be=="boolean"?Et={ignoreCreateEvents:!!be,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ht,correlate:!1}:be&&((0,it.$jH)(qe,"createFileSystemWatcher"),Et={...be,correlate:!0}),_e.createFileSystemWatcher(pt,qe,fe,Et)},get textDocuments(){return Tt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new A.$9("textDocuments")},openTextDocument(fe){let be;const Ue=fe;if(typeof fe=="string")be=Promise.resolve(c.URI.file(fe));else if(c.URI.isUri(fe))be=Promise.resolve(fe);else if(!Ue||typeof Ue=="object")be=Tt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return be.then(ht=>(ht.scheme===O.Schemas.vscodeRemote&&!ht.authority&&Nt.report("workspace.openTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority."),Tt.ensureDocumentData(ht).then(Et=>Et.document)))},onDidOpenTextDocument:(fe,be,Ue)=>lt(Tt.onDidAddDocument)(fe,be,Ue),onDidCloseTextDocument:(fe,be,Ue)=>lt(Tt.onDidRemoveDocument)(fe,be,Ue),onDidChangeTextDocument:(fe,be,Ue)=>lt(Tt.onDidChangeDocument)(fe,be,Ue),onDidSaveTextDocument:(fe,be,Ue)=>lt(Tt.onDidSaveDocument)(fe,be,Ue),onWillSaveTextDocument:(fe,be,Ue)=>lt(ui.getOnWillSaveTextDocumentEvent(qe))(fe,be,Ue),get notebookDocuments(){return At.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,be){let Ue;if(c.URI.isUri(fe))Ue=fe,await At.openNotebookDocument(fe);else if(typeof fe=="string")Ue=c.URI.revive(await At.createNotebookDocument({viewType:fe,content:be}));else throw new Error("Invalid arguments");return At.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(fe,be,Ue){return lt(Oi.onDidSaveNotebookDocument)(fe,be,Ue)},onDidChangeNotebookDocument(fe,be,Ue){return lt(Oi.onDidChangeNotebookDocument)(fe,be,Ue)},onWillSaveNotebookDocument(fe,be,Ue){return lt(wi.getOnWillSaveNotebookDocumentEvent(qe))(fe,be,Ue)},get onDidOpenNotebookDocument(){return lt(At.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(At.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,be,Ue,ht){return At.registerNotebookSerializer(qe,fe,be,Ue,(0,it.$iH)(qe,"notebookLiveShare")?ht:void 0)},onDidChangeConfiguration:(fe,be,Ue)=>lt(Zi.onDidChangeConfiguration)(fe,be,Ue),getConfiguration(fe,be){return be=arguments.length===1?void 0:be,Zi.getConfiguration(fe,be,qe)},registerTextDocumentContentProvider(fe,be){return Li.registerTextDocumentContentProvider(fe,be)},registerTaskProvider:(fe,be)=>(Nt.report("window.registerTaskProvider",qe,"Use the corresponding function on the 'tasks' namespace instead"),xt.registerTaskProvider(qe,fe,be)),registerFileSystemProvider(fe,be,Ue){return(0,T.$Sc)(Ge.registerFileSystemProvider(qe,fe,be,Ue),ii.addFileSystemProvider(fe,be,Ue))},get fs(){return ii.value},registerFileSearchProvider:(fe,be)=>((0,it.$jH)(qe,"fileSearchProvider"),mi.registerFileSearchProvider(fe,be)),registerTextSearchProvider:(fe,be)=>((0,it.$jH)(qe,"textSearchProvider"),mi.registerTextSearchProvider(fe,be)),registerAITextSearchProvider:(fe,be)=>((0,it.$jH)(qe,"aiTextSearchProvider"),(0,it.$jH)(qe,"textSearchProvider"),mi.registerAITextSearchProvider(fe,be)),registerFileSearchProviderNew:(fe,be)=>((0,it.$jH)(qe,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(fe,be)=>((0,it.$jH)(qe,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(fe,be)=>((0,it.$jH)(qe,"aiTextSearchProviderNew"),(0,it.$jH)(qe,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(fe,be)=>((0,it.$jH)(qe,"resolvers"),qt.registerRemoteAuthorityResolver(fe,be)),registerResourceLabelFormatter:fe=>((0,it.$jH)(qe,"resolvers"),_t.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,it.$jH)(qe,"resolvers"),qt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,be,Ue)=>lt(_e.onDidCreateFile)(fe,be,Ue),onDidDeleteFiles:(fe,be,Ue)=>lt(_e.onDidDeleteFile)(fe,be,Ue),onDidRenameFiles:(fe,be,Ue)=>lt(_e.onDidRenameFile)(fe,be,Ue),onWillCreateFiles:(fe,be,Ue)=>lt(_e.getOnWillCreateFileEvent(qe))(fe,be,Ue),onWillDeleteFiles:(fe,be,Ue)=>lt(_e.getOnWillDeleteFileEvent(qe))(fe,be,Ue),onWillRenameFiles:(fe,be,Ue)=>lt(_e.getOnWillRenameFileEvent(qe))(fe,be,Ue),openTunnel:fe=>((0,it.$jH)(qe,"tunnels"),jt.openTunnel(qe,fe).then(be=>{if(!be)throw new Error("cannot open tunnel");return be})),get tunnels(){return(0,it.$jH)(qe,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(fe,be,Ue)=>((0,it.$jH)(qe,"tunnels"),lt(jt.onDidChangeTunnels)(fe,be,Ue)),registerPortAttributesProvider:(fe,be)=>((0,it.$jH)(qe,"portsAttributes"),jt.registerPortsAttributesProvider(fe,be)),registerTunnelProvider:(fe,be)=>((0,it.$jH)(qe,"tunnelFactory"),jt.registerTunnelProvider(fe,be)),registerTimelineProvider:(fe,be)=>((0,it.$jH)(qe,"timeline"),rn.registerTimelineProvider(fe,be,qe.identifier,wt.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:fe=>((0,it.$jH)(qe,"workspaceTrust"),pt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,be,Ue)=>lt(pt.onDidGrantWorkspaceTrust)(fe,be,Ue),registerEditSessionIdentityProvider:(fe,be)=>((0,it.$jH)(qe,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(fe,be)),onWillCreateEditSessionIdentity:(fe,be,Ue)=>((0,it.$jH)(qe,"editSessionIdentityProvider"),lt(pt.getOnWillCreateEditSessionIdentityEvent(qe))(fe,be,Ue)),registerCanonicalUriProvider:(fe,be)=>((0,it.$jH)(qe,"canonicalUriProvider"),pt.registerCanonicalUriProvider(fe,be)),getCanonicalUri:(fe,be,Ue)=>((0,it.$jH)(qe,"canonicalUriProvider"),pt.provideCanonicalUri(fe,be,Ue))},dn={get inputBox(){return Nt.report("scm.inputBox",qe,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox(qe)},createSourceControl(fe,be,Ue){return ft.createSourceControl(qe,fe,be,Ue)}},fn={createCommentController(fe,be){return si.createCommentController(qe,fe,be)}},kn={get activeDebugSession(){return Pt.activeDebugSession},get activeDebugConsole(){return Pt.activeDebugConsole},get breakpoints(){return Pt.breakpoints},get activeStackItem(){return Pt.activeStackItem},registerDebugVisualizationProvider(fe,be){return(0,it.$jH)(qe,"debugVisualization"),Pt.registerDebugVisualizationProvider(qe,fe,be)},registerDebugVisualizationTreeProvider(fe,be){return(0,it.$jH)(qe,"debugVisualization"),Pt.registerDebugVisualizationTree(qe,fe,be)},onDidStartDebugSession(fe,be,Ue){return lt(Pt.onDidStartDebugSession)(fe,be,Ue)},onDidTerminateDebugSession(fe,be,Ue){return lt(Pt.onDidTerminateDebugSession)(fe,be,Ue)},onDidChangeActiveDebugSession(fe,be,Ue){return lt(Pt.onDidChangeActiveDebugSession)(fe,be,Ue)},onDidReceiveDebugSessionCustomEvent(fe,be,Ue){return lt(Pt.onDidReceiveDebugSessionCustomEvent)(fe,be,Ue)},onDidChangeBreakpoints(fe,be,Ue){return lt(Pt.onDidChangeBreakpoints)(fe,be,Ue)},onDidChangeActiveStackItem(fe,be,Ue){return lt(Pt.onDidChangeActiveStackItem)(fe,be,Ue)},registerDebugConfigurationProvider(fe,be,Ue){return Pt.registerDebugConfigurationProvider(fe,be,Ue||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,be){return Pt.registerDebugAdapterDescriptorFactory(qe,fe,be)},registerDebugAdapterTrackerFactory(fe,be){return Pt.registerDebugAdapterTrackerFactory(fe,be)},startDebugging(fe,be,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Pt.startDebugging(fe,be,{parentSession:Ue}):Pt.startDebugging(fe,be,Ue||{})},stopDebugging(fe){return Pt.stopDebugging(fe)},addBreakpoints(fe){return Pt.addBreakpoints(fe)},removeBreakpoints(fe){return Pt.removeBreakpoints(fe)},asDebugSourceUri(fe,be){return Pt.asDebugSourceUri(fe,be)}},gn={registerTaskProvider:(fe,be)=>xt.registerTaskProvider(qe,fe,be),fetchTasks:fe=>xt.fetchTasks(fe),executeTask:fe=>xt.executeTask(qe,fe),get taskExecutions(){return xt.taskExecutions},onDidStartTask:(fe,be,Ue)=>lt(xt.onDidStartTask)(fe,be,Ue),onDidEndTask:(fe,be,Ue)=>lt(xt.onDidEndTask)(fe,be,Ue),onDidStartTaskProcess:(fe,be,Ue)=>lt(xt.onDidStartTaskProcess)(fe,be,Ue),onDidEndTaskProcess:(fe,be,Ue)=>lt(xt.onDidEndTaskProcess)(fe,be,Ue)},mn={createNotebookController(fe,be,Ue,ht,Et){return Si.createNotebookController(qe,fe,be,Ue,ht,(0,it.$iH)(qe,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(fe,be)=>At.registerNotebookCellStatusBarItemProvider(qe,fe,be),createRendererMessaging(fe){return Ni.createRendererMessaging(qe,fe)},createNotebookControllerDetectionTask(fe){return(0,it.$jH)(qe,"notebookKernelSource"),Si.createNotebookControllerDetectionTask(qe,fe)},registerKernelSourceActionProvider(fe,be){return(0,it.$jH)(qe,"notebookKernelSource"),Si.registerKernelSourceActionProvider(qe,fe,be)},onDidChangeNotebookCellExecutionState(fe,be,Ue){return(0,it.$jH)(qe,"notebookCellExecutionState"),lt(Si.onDidChangeNotebookCellExecutionState)(fe,be,Ue)}},In={t(...fe){if(typeof fe[0]=="string"){const be=fe.shift(),Ue=!fe||typeof fe[0]!="object"?fe:fe[0];return bi.getMessage(qe.identifier.value,{message:be,args:Ue})}return bi.getMessage(qe.identifier.value,fe[0])},get bundle(){return bi.getBundle(qe.identifier.value)},get uri(){return bi.getBundleUri(qe.identifier.value)}},Pn={_version:1,transferActiveChat(fe){return(0,it.$jH)(qe,"interactive"),ji.transferActiveChat(fe)}},$n={getRelatedInformation(fe,be){return(0,it.$jH)(qe,"aiRelatedInformation"),Qi.getRelatedInformation(qe,fe,be)},registerRelatedInformationProvider(fe,be){return(0,it.$jH)(qe,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(qe,fe,be)},registerEmbeddingVectorProvider(fe,be){return(0,it.$jH)(qe,"aiRelatedInformation"),yn.registerEmbeddingVectorProvider(qe,fe,be)}},_i={_version:1,registerChatResponseProvider(fe,be,Ue){return(0,it.$jH)(qe,"chatProvider"),Kt.registerLanguageModel(qe,fe,be,Ue)},registerChatVariableResolver(fe,be,Ue,ht,Et,Lt,gi,Fi){return(0,it.$jH)(qe,"chatVariableResolver"),an.registerVariableResolver(qe,fe,be,Ue,ht,Et,Lt,gi,Fi?.id)},registerMappedEditsProvider(fe,be){return(0,it.$jH)(qe,"mappedEditsProvider"),Ae.registerMappedEditsProvider(qe,fe,be)},createChatParticipant(fe,be){return ji.createChatAgent(qe,fe,be)},createDynamicChatParticipant(fe,be,Ue){return(0,it.$jH)(qe,"chatParticipantPrivate"),ji.createDynamicChatAgent(qe,fe,be,Ue)}},pn={selectChatModels:fe=>Kt.selectLanguageModels(qe,fe??{}),onDidChangeChatModels:(fe,be,Ue)=>Kt.onDidChangeProviders(fe,be,Ue),registerChatModelProvider:(fe,be,Ue)=>((0,it.$jH)(qe,"chatProvider"),Kt.registerLanguageModel(qe,fe,be,Ue)),get embeddingModels(){return(0,it.$jH)(qe,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(fe,be,Ue)=>((0,it.$jH)(qe,"embeddings"),Ci.onDidChange(fe,be,Ue)),registerEmbeddingsProvider(fe,be){return(0,it.$jH)(qe,"embeddings"),Ci.registerEmbeddingsProvider(qe,fe,be)},async computeEmbeddings(fe,be,Ue){return(0,it.$jH)(qe,"embeddings"),Ci.computeEmbeddings(fe,be,Ue)},registerTool(fe,be){return(0,it.$jH)(qe,"lmTools"),Bi.registerTool(qe,fe,be)},invokeTool(fe,be,Ue){return(0,it.$jH)(qe,"lmTools"),Bi.invokeTool(fe,be,Ue)},get tools(){return(0,it.$jH)(qe,"lmTools"),Bi.tools}},bn={registerSpeechProvider(fe,be){return(0,it.$jH)(qe,"speech"),Ki.registerProvider(qe.identifier,fe,be)}};return{version:St.version,ai:$n,authentication:Yi,commands:un,comments:fn,chat:_i,debug:kn,env:Ei,extensions:$i,interactive:Pn,l10n:In,languages:qi,lm:pn,notebooks:mn,scm:dn,speech:bn,tasks:gn,tests:zi,window:hn,workspace:xi,Breakpoint:le.$TO,TerminalOutputAnchor:le.TerminalOutputAnchor,ChatResultFeedbackKind:le.ChatResultFeedbackKind,ChatVariableLevel:le.ChatVariableLevel,ChatCompletionItem:le.$PP,CallHierarchyIncomingCall:le.$fO,CallHierarchyItem:le.$eO,CallHierarchyOutgoingCall:le.$gO,CancellationError:A.$5,CancellationTokenSource:h.$xe,CandidatePortSource:s.CandidatePortSource,CodeAction:le.$bO,CodeActionKind:le.$cO,CodeActionTriggerKind:le.CodeActionTriggerKind,CodeLens:le.$hO,Color:le.$uO,ColorInformation:le.$vO,ColorPresentation:le.$wO,ColorThemeKind:le.ColorThemeKind,CommentMode:le.CommentMode,CommentState:le.CommentState,CommentThreadCollapsibleState:le.CommentThreadCollapsibleState,CommentThreadState:le.CommentThreadState,CommentThreadApplicability:le.CommentThreadApplicability,CommentThreadFocus:le.CommentThreadFocus,CompletionItem:le.$oO,CompletionItemKind:le.CompletionItemKind,CompletionItemTag:le.CompletionItemTag,CompletionList:le.$pO,CompletionTriggerKind:le.CompletionTriggerKind,ConfigurationTarget:le.ConfigurationTarget,CustomExecution:le.$EO,DebugAdapterExecutable:le.$XO,DebugAdapterInlineImplementation:le.$1O,DebugAdapterNamedPipeServer:le.$ZO,DebugAdapterServer:le.$YO,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:le.DebugConsoleMode,DebugVisualization:le.$eP,DecorationRangeBehavior:le.DecorationRangeBehavior,Diagnostic:le.$7N,DiagnosticRelatedInformation:le.$6N,DiagnosticSeverity:le.DiagnosticSeverity,DiagnosticTag:le.DiagnosticTag,Disposable:le.$QN,DocumentHighlight:le.$0N,DocumentHighlightKind:le.DocumentHighlightKind,MultiDocumentHighlight:le.$$N,DocumentLink:le.$tO,DocumentSymbol:le.$aO,EndOfLine:le.EndOfLine,EnvironmentVariableMutatorType:le.EnvironmentVariableMutatorType,EvaluatableExpression:le.$4O,InlineValueText:le.$5O,InlineValueVariableLookup:le.$6O,InlineValueEvaluatableExpression:le.$7O,InlineCompletionTriggerKind:le.InlineCompletionTriggerKind,EventEmitter:R.$me,ExtensionKind:le.ExtensionKind,ExtensionMode:le.ExtensionMode,ExternalUriOpenerPriority:le.ExternalUriOpenerPriority,FileChangeType:le.FileChangeType,FileDecoration:le.$gP,FileDecoration2:le.$gP,FileSystemError:le.$0O,FileType:a.FileType,FilePermission:a.FilePermission,FoldingRange:le.$$O,FoldingRangeKind:le.FoldingRangeKind,FunctionBreakpoint:le.$VO,InlineCompletionItem:le.$qO,InlineCompletionList:le.$rO,Hover:le.$8N,VerboseHover:le.$9N,HoverVerbosityAction:le.HoverVerbosityAction,IndentAction:u.IndentAction,Location:le.$5N,MarkdownString:le.$iO,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:le.$jO,PortAutoForwardAction:le.PortAutoForwardAction,Position:le.$RN,ProcessExecution:le.$CO,ProgressLocation:le.ProgressLocation,QuickInputButtonLocation:le.QuickInputButtonLocation,QuickInputButtons:le.$fP,Range:le.$SN,RelativePattern:le.$RO,Selection:le.$TN,SelectionRange:le.$dO,SemanticTokens:le.$bP,SemanticTokensBuilder:le.$aP,SemanticTokensEdit:le.$cP,SemanticTokensEdits:le.$dP,SemanticTokensLegend:le.$_O,ShellExecution:le.$DO,ShellQuoting:le.ShellQuoting,SignatureHelp:le.$lO,SignatureHelpTriggerKind:le.SignatureHelpTriggerKind,SignatureInformation:le.$kO,SnippetString:le.$4N,SourceBreakpoint:le.$UO,StandardTokenType:le.StandardTokenType,StatusBarAlignment:le.StatusBarAlignment,SymbolInformation:le.$_N,SymbolKind:le.SymbolKind,SymbolTag:le.SymbolTag,Task:le.$FO,TaskGroup:le.$BO,TaskPanelKind:le.TaskPanelKind,TaskRevealKind:le.TaskRevealKind,TaskScope:le.TaskScope,TerminalLink:le.$xO,TerminalQuickFixTerminalCommand:le.$zO,TerminalQuickFixOpener:le.$yO,TerminalLocation:le.TerminalLocation,TerminalProfile:le.$AO,TerminalExitReason:le.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:le.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:le.TextDocumentSaveReason,TextEdit:le.$ZN,SnippetTextEdit:le.$2N,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:le.TextEditorLineNumbersStyle,TextEditorRevealType:le.TextEditorRevealType,TextEditorSelectionChangeKind:le.TextEditorSelectionChangeKind,SyntaxTokenType:le.SyntaxTokenType,TextDocumentChangeReason:le.TextDocumentChangeReason,ThemeColor:le.$QO,ThemeIcon:le.$PO,TreeItem:le.$GO,TreeItemCheckboxState:le.TreeItemCheckboxState,TreeItemCollapsibleState:le.TreeItemCollapsibleState,TypeHierarchyItem:le.$DP,UIKind:Ot.UIKind,Uri:c.URI,ViewColumn:le.ViewColumn,WorkspaceEdit:le.$3N,DocumentPasteTriggerKind:le.DocumentPasteTriggerKind,DocumentDropEdit:le.$MO,DocumentDropOrPasteEditKind:le.$NO,DocumentPasteEdit:le.$OO,InlayHint:le.$nO,InlayHintLabelPart:le.$mO,InlayHintKind:le.InlayHintKind,RemoteAuthorityResolverError:le.$YN,ResolvedAuthority:le.$WN,ManagedResolvedAuthority:le.$XN,SourceControlInputBoxValidationType:le.SourceControlInputBoxValidationType,ExtensionRuntime:le.ExtensionRuntime,TimelineItem:le.$qP,NotebookRange:le.$iP,NotebookCellKind:le.NotebookCellKind,NotebookCellExecutionState:le.NotebookCellExecutionState,NotebookCellData:le.$jP,NotebookData:le.$kP,NotebookRendererScript:le.$oP,NotebookCellStatusBarAlignment:le.NotebookCellStatusBarAlignment,NotebookEditorRevealType:le.NotebookEditorRevealType,NotebookCellOutput:le.$mP,NotebookCellOutputItem:le.$lP,NotebookCellStatusBarItem:le.$nP,NotebookControllerAffinity:le.NotebookControllerAffinity,NotebookControllerAffinity2:le.NotebookControllerAffinity2,NotebookEdit:le.$1N,NotebookKernelSourceAction:le.$pP,NotebookVariablesRequestKind:le.NotebookVariablesRequestKind,PortAttributes:le.$sP,LinkedEditingRanges:le.$rP,TestResultState:le.TestResultState,TestRunRequest:le.$tP,TestMessage:le.$uP,TestMessage2:le.$uP,TestMessageStackFrame:le.$wP,TestTag:le.$vP,TestRunProfileKind:le.TestRunProfileKind,TextSearchCompleteMessageType:Ct.TextSearchCompleteMessageType,DataTransfer:le.$LO,DataTransferItem:le.$HO,TestCoverageCount:le.$xP,FileCoverage:le.$zP,FileCoverage2:le.$zP,StatementCoverage:le.$AP,BranchCoverage:le.$BP,DeclarationCoverage:le.$CP,WorkspaceTrustState:le.WorkspaceTrustState,LanguageStatusSeverity:le.LanguageStatusSeverity,QuickPickItemKind:le.QuickPickItemKind,InputBoxValidationSeverity:le.InputBoxValidationSeverity,TabInputText:le.$EP,TabInputTextDiff:le.$FP,TabInputTextMerge:le.$GP,TabInputCustom:le.$HP,TabInputNotebook:le.$JP,TabInputNotebookDiff:le.$KP,TabInputWebview:le.$IP,TabInputTerminal:le.$LP,TabInputInteractiveWindow:le.$MP,TabInputChat:le.$NP,TabInputTextMultiDiff:le.$OP,TelemetryTrustedValue:f.$yp,LogLevel:m.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:le.InteractiveSessionVoteDirection,ChatCopyKind:le.ChatCopyKind,InteractiveEditorResponseFeedbackKind:le.InteractiveEditorResponseFeedbackKind,DebugStackFrame:le.$2O,DebugThread:le.$3O,RelatedInformationType:le.RelatedInformationType,SpeechToTextStatus:le.SpeechToTextStatus,TextToSpeechStatus:le.TextToSpeechStatus,PartialAcceptTriggerKind:le.PartialAcceptTriggerKind,KeywordRecognitionStatus:le.KeywordRecognitionStatus,ChatResponseMarkdownPart:le.$QP,ChatResponseFileTreePart:le.$UP,ChatResponseAnchorPart:le.$VP,ChatResponseProgressPart:le.$WP,ChatResponseProgressPart2:le.$XP,ChatResponseReferencePart:le.$1P,ChatResponseReferencePart2:le.$1P,ChatResponseCodeCitationPart:le.$2P,ChatResponseWarningPart:le.$YP,ChatResponseTextEditPart:le.$3P,ChatResponseMarkdownWithVulnerabilitiesPart:le.$RP,ChatResponseCommandButtonPart:le.$ZP,ChatResponseDetectedParticipantPart:le.$SP,ChatResponseConfirmationPart:le.$TP,ChatResponseReferencePartStatusKind:le.ChatResponseReferencePartStatusKind,ChatRequestTurn:le.$4P,ChatResponseTurn:le.$5P,ChatLocation:le.ChatLocation,ChatRequestEditorData:le.$6P,ChatRequestNotebookData:le.$7P,LanguageModelChatMessageRole:le.LanguageModelChatMessageRole,LanguageModelChatMessage:le.$9P,LanguageModelChatMessageFunctionResultPart:le.$8P,LanguageModelChatResponseTextPart:le.$$P,LanguageModelChatResponseFunctionUsePart:le.$0P,LanguageModelError:le.$cQ,NewSymbolName:le.$9O,NewSymbolNameTag:le.NewSymbolNameTag,NewSymbolNameTriggerKind:le.NewSymbolNameTriggerKind,InlineEdit:le.$dQ,InlineEditTriggerKind:le.InlineEditTriggerKind,ExcludeSettingOptions:Ct.ExcludeSettingOptions,TextSearchContextNew:Ct.$4L,TextSearchMatchNew:Ct.$3L,TextSearchCompleteMessageTypeNew:Ct.TextSearchCompleteMessageTypeNew}}}}),define(ke[345],Ie([1,0,88,170,49,164,41,34,63,48,100,101,102,125,76,95,163,75,62,124,94,77,162,11,64,122,123,127,128,168,98]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n,d,l,g,E,S,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Ss)(l.$zqc,l.$yqc,r.InstantiationType.Delayed),(0,r.$Ss)(n.$ck,o.$Orc,r.InstantiationType.Delayed),(0,r.$Ss)(a.$Epc,a.$Fpc,r.InstantiationType.Delayed),(0,r.$Ss)(O.$KQ,O.$JQ,r.InstantiationType.Eager),(0,r.$Ss)(E.$Opc,E.$Ppc,r.InstantiationType.Eager),(0,r.$Ss)(S.$tqc,S.$uqc,r.InstantiationType.Eager),(0,r.$Ss)(T.$4pc,T.$2pc,r.InstantiationType.Eager),(0,r.$Ss)($.$6pc,$.$5pc,r.InstantiationType.Eager),(0,r.$Ss)(k.$Jqc,k.$Kqc,r.InstantiationType.Eager),(0,r.$Ss)(y.$Oqc,y.$Sqc,r.InstantiationType.Eager),(0,r.$Ss)(R.$Uqc,R.$Tqc,r.InstantiationType.Eager),(0,r.$Ss)(b.$zQ,b.$yQ,r.InstantiationType.Eager),(0,r.$Ss)(g.$Aqc,g.$Bqc,r.InstantiationType.Eager),(0,r.$Ss)(f.$Ipc,f.$Hpc,r.InstantiationType.Eager),(0,r.$Ss)(h.$orc,h.$nrc,r.InstantiationType.Delayed),(0,r.$Ss)(u.$$qc,u.$_qc,r.InstantiationType.Eager),(0,r.$Ss)(C.$mqc,C.$lqc,r.InstantiationType.Eager),(0,r.$Ss)(I.$Brc,I.$Arc,r.InstantiationType.Eager),(0,r.$Ss)(c.$pqc,c.$sqc,r.InstantiationType.Eager),(0,r.$Ss)(D.$Crc,D.$Drc,r.InstantiationType.Eager),(0,r.$Ss)(w.$pGb,w.$qGb,r.InstantiationType.Eager),(0,r.$Ss)(m.$Mrc,m.$Lrc,r.InstantiationType.Eager),(0,r.$Ss)(A.$1pc,A.$Zpc,r.InstantiationType.Eager),(0,r.$Ss)(i.$wqc,i.$vqc,r.InstantiationType.Eager),(0,r.$Ss)(s.$IQ,s.$FQ,r.InstantiationType.Eager),(0,r.$Ss)(t.$dqc,t.$eqc,r.InstantiationType.Eager),(0,r.$Ss)(d.$Hqc,d.$Iqc,r.InstantiationType.Eager)}),define(ke[129],Ie([1,0,18,11,37,99]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7rc=void 0,e.$5rc=T,e.$6rc=O,R=We(R);function T(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}function O(y,u,C,w){const a=(0,r.$1b)(C,b),m=new A.$eM(u,a,w),$=m.preview.matches;return{ranges:(0,r.$1b)(a,c),uri:y,preview:{text:m.preview.text,matches:(0,r.$1b)($,c)}}}function b(y){return new A.$fM(y.start.line,y.start.character,y.end.line,y.end.character)}function c(y){return new R.$2L(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let I=class{constructor(u,C){this.a=u,this.b=C}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$7rc=I,e.$7rc=I=Je([Ve(1,h.$bk)],I)}),define(ke[346],Ie([1,0,56,16,81,31,10,12,129,347]),function($e,e,r,h,A,R,T,O,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8rc=y,e.$9rc=m,e.$0rc=f,r=We(r),h=We(h),R=We(R),O=We(O);const I=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(i,s,t,o,n){const d=u(i,s,t,o,n),l=s.folder.fsPath;return{cmd:r.spawn(I,d.args,{cwd:l}),rgDiskPath:I,siblingClauses:d.siblingClauses,rgArgs:d,cwd:l}}function u(i,s,t,o,n){const d=["--files","--hidden","--case-sensitive","--no-require-git"];w([s],t,!1).forEach(g=>{const E=(0,b.$5rc)(g);if(d.push("-g",E),T.$k){const S=(0,A.$pm)(E);S!==E&&d.push("-g",S)}});const l=C([s],o,void 0,!1);return l.globArgs.forEach(g=>{const E=`!${(0,b.$5rc)(g)}`;if(d.push("-g",E),T.$k){const S=(0,A.$pm)(E);S!==E&&d.push("-g",S)}}),s.disregardIgnoreFiles!==!1?d.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),s.ignoreSymlinks||d.push("--follow"),i.exists&&d.push("--quiet"),n&&d.push("--threads",`${n}`),d.push("--no-config"),s.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:l.siblingClauses}}function C(i,s,t,o=!0){const n=[];let d={};return i.forEach(l=>{const g=Object.assign({},l.excludePattern||{},s||{}),E=a(g,o?l.folder.fsPath:void 0,t);n.push(...E.globArgs),E.siblingClauses&&(d=Object.assign(d,E.siblingClauses))}),{globArgs:n,siblingClauses:d}}function w(i,s,t=!0){const o=[];return i.forEach(n=>{const d=Object.assign({},s||{},n.includePattern||{}),l=a(d,t?n.folder.fsPath:void 0);o.push(...l.globArgs)}),o}function a(i,s,t){const o=[],n={};return Object.keys(i).forEach(d=>{if(t&&t.has(d)||!d)return;const l=i[d];d=$(s?m(s,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),o.push(f(d))):l&&l.when&&(n[d]=l)}),{globArgs:o,siblingClauses:n}}function m(i,s){return h.$jc(s)?s:h.$kc(i,s)}function $(i){return i=O.$of(i,"\\"),O.$of(i,"/")}function f(i){return R.$Bg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[348],Ie([1,0,56,45,16,349,18,52,38,81,31,10,42,12,17,33,37,346,137]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_rc=e.$$rc=void 0,r=We(r),h=We(h),A=We(A),T=We(T),b=We(b),c=We(c),y=We(y),C=We(C),w=We(w);const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class s{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&b.$Bk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,f.$Sr)(this.b).normalizedLowercase),this.u=l.excludePattern&&b.$Bk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(g=>{const E=Object.assign({},g.excludePattern||{},this.a.excludePattern||{}),S=g.folder.fsPath;l.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==S).forEach(D=>{(0,I.$Fg)(D,S)&&(E[A.$mc(S,D)]=!0)}),this.t.set(S,new o(E,S))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,g,E,S,D,k){if(this.m=u.$ge.create(!1),this.l)return k(null,this.j);g.forEach(P=>{const p=A.$oc(P.fsPath);this.u&&this.u(P.fsPath,p)||this.J(S,{relativePath:P.fsPath,searchPath:void 0})}),this.r=u.$ge.create(!1),this.w(l,(P,p)=>{this.x(this.y,this,P,E,S,D,v=>{if(v){const F=(0,O.$rj)(v);console.error(F),this.q.push(F),p(v,void 0)}else p(null,void 0)})},(P,p)=>{this.m.stop();const v=P?T.$Hb(P)[0]:null;k(v,this.j)})}w(l,g,E){const S=new Array(l.length),D=new Array(l.length);let k=!1,P=0;if(l.length===0)return E(null,[]);l.forEach((p,v)=>{g(p,(F,N)=>{if(F?(k=!0,S[v]=null,D[v]=F):(S[v]=N,D[v]=null),++P===l.length)return E(k?D:null,S)})})}x(l,g,...E){try{l.apply(g,E)}catch(S){E[E.length-1](S)}}y(l,g,E,S,D){const k=l.folder.fsPath,P=y.$k,p=()=>M&&M.kill();i.add(p);let v=B=>{i.delete(p),v=()=>{},D(B)},F="";const N=this.D(),L=(0,$.$8rc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression,g),M=L.cmd,z=!Object.keys(L.siblingClauses).length,j=L.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let q=`${L.rgDiskPath} ${j}
 - cwd: ${L.cwd}`;L.rgArgs.siblingClauses&&(q+=`
 - Sibling clauses: ${JSON.stringify(L.rgArgs.siblingClauses)}`),S({message:q}),this.s=0,this.z(M,"utf8",S,(B,ee,H)=>{if(B){v(B);return}if(this.j){v();return}const X=(F+(P?c.$om(ee||""):ee)).split(`
`);if(H){const _=X.length;X[_-1]=X[_-1].trim(),X[_-1]||X.pop()}else F=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=X.length,z){for(const _ of X)if(this.J(E,{base:k,relativePath:_,searchPath:this.N(l,_)}),this.j){p();break}(H||this.j)&&v();return}this.G(l,N,k,X,E),H&&(this.H(N,k,E),v())})}spawnFindCmd(l){const g=this.t.get(l.folder.fsPath),E=g.getBasenameTerms(),S=g.getPathTerms(),D=["-L","."];if(E.length||S.length){D.push("-not","(","(");for(const k of E)D.push("-name",k),D.push("-o");for(const k of S)D.push("-path",k),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),r.spawn("find",D,{cwd:l.folder.fsPath})}readStdout(l,g,E){let S="";this.z(l,g,()=>{},(D,k,P)=>{if(D){E(D);return}S+=k,P&&E(null,S)})}z(l,g,E,S){let D=(p,v,F)=>{(p||F)&&(D=()=>{},this.r?.stop()),S(p,v,F)},k=!1;l.stdout?(this.A(l.stdout,g,D),l.stdout.once("data",()=>k=!0)):E({message:"stdout is null"});let P;l.stderr?P=this.B(l.stderr):E({message:"stderr is null"}),l.on("error",p=>{D(p)}),l.on("close",p=>{let v;!k&&(v=this.C(P,g))&&n(v)?D(new Error(`command failed with error code ${p}: ${this.C(P,g)}`)):(this.g&&p===0&&(this.j=!0),D(null,"",!0))})}A(l,g,E){const S=new R.StringDecoder(g);return l.on("data",D=>{E(null,S.write(D))}),S}B(l){const g=[];return l.on("data",E=>{g.push(E)}),g}C(l,g){const E=new R.StringDecoder(g);return l.map(S=>E.write(S)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:g},E,S,D){S.indexOf(this.b)!==-1&&this.J(D,{base:E,relativePath:this.b,searchPath:this.N(l,this.b)});const k=P=>{const p=A.$oc(P),v=A.$nc(P);let F=g[v];F||(F=g[v]=[],k(v)),F.push({base:E,relativePath:P,basename:p,searchPath:this.N(l,P)})};S.forEach(k)}H({rootEntries:l,pathToEntries:g},E,S){const D=this,k=this.t.get(E),P=this.b;function p(v){D.o++;const F=(0,m.$uM)(()=>v.map(N=>N.basename));for(let N=0,L=v.length;N<L;N++){const M=v[N],{relativePath:z,basename:j}=M;if(k.test(z,j,P!==j?F:void 0))continue;const q=g[z];if(q)p(q);else{if(D.p++,z===P)continue;D.J(S,M)}if(D.j)break}}p(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,g,E,S,D){const k=l.folder,P=(0,m.$uM)(()=>E);this.w(E,(p,v)=>{if(this.l||this.j)return v(null);const F=g?[g,p].join(A.sep):p;if(this.t.get(l.folder.fsPath).test(F,p,this.a.filePattern!==p?P:void 0))return v(null);const N=[k.fsPath,F].join(A.sep);h.lstat(N,(L,M)=>{if(L||this.l||this.j)return v(null);this.L(N,M,(z,j)=>z||this.l||this.j?v(null):j.isDirectory()?(this.o++,this.M(N,M,(q,B)=>q||this.l||this.j||(B=B||"",this.v[B])?v(null):(this.v[B]=!0,a.Promises.readdir(N).then(ee=>{if(this.l||this.j)return v(null);this.I(l,F,ee,S,H=>v(H||null))},ee=>{v(null)})))):(this.p++,F===this.b||this.h&&w.$jg(j.size)&&j.size>this.h||this.J(S,{base:k.fsPath,relativePath:F,searchPath:this.N(l,F)}),v(null,void 0)))})},p=>{const v=p&&T.$Hb(p);return D(v&&v.length>0?v[0]:void 0)})}J(l,g){this.K(g)&&(!this.d||this.d(g.relativePath,A.$oc(g.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(g))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$pM)(l,this.c);if(this.b)return(0,m.$pM)(l,this.b,!1)}return!0}L(l,g,E){return g.isSymbolicLink()?h.stat(l,E):E(null,g)}M(l,g,E){return g.isSymbolicLink()?h.realpath(l,(S,D)=>S?E(S):E(null,D)):E(null,l)}N(l,g){return l.folderName?A.$kc(l.folderName,g):g}}e.$$rc=s;class t{constructor(l,g){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.d=g,this.c=new s(l)}search(l,g,E){this.c.walk(this.a,this.b,this.d,l,g,(S,D)=>{E(S,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$_rc=t;class o{constructor(l,g){this.expression=l,this.c=g,this.d(l)}d(l){let g,E;Object.keys(l).filter(S=>l[S]).forEach(S=>{A.$jc(S)?(g=g||b.$wk(),g[S]=l[S]):(E=E||b.$wk(),E[S]=l[S])}),this.a=g&&b.$Bk(g,{trimForExclusions:!0}),this.b=E&&b.$Bk(E,{trimForExclusions:!0})}test(l,g,E){return this.b&&this.b(l,g,E)||this.a&&this.a(A.$kc(this.c,l),g,E)}getBasenameTerms(){const l=[];return this.a&&l.push(...b.$Dk(this.a)),this.b&&l.push(...b.$Dk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...b.$Ek(this.a)),this.b&&l.push(...b.$Ek(this.b)),l}}function n(d){const l=d.trim().split(`
`),g=l[0].trim();if(g.startsWith("Error parsing regex"))return g;if(g.startsWith("regex parse error"))return C.$0f(l[l.length-1].trim());if(g.startsWith("error parsing glob")||g.startsWith("unsupported encoding"))return g.charAt(0).toUpperCase()+g.substr(1);if(g==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(g.startsWith("Literal "))return g}}),define(ke[350],Ie([1,0,105,21,189,20,18,131]),function($e,e,r,h,A,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XE=e.$WE=e.$OE=e.DecodeStreamErrorKind=e.$NE=e.$ME=e.$LE=e.$JE=e.$IE=e.$HE=e.$GE=void 0,e.$KE=b,e.$PE=m,e.$QE=$,e.$RE=f,e.$SE=i,e.$TE=s,e.$UE=S,e.$VE=D,e.$GE="utf8",e.$HE="utf8bom",e.$IE="utf16be",e.$JE="utf16le";function b(k){return[e.$GE,e.$HE,e.$IE,e.$JE].some(P=>P===k)}e.$LE=[254,255],e.$ME=[255,254],e.$NE=[239,187,191];const c=512,I=512,y=512*8,u=512*128;var C;(function(k){k[k.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class w extends Error{constructor(P,p){super(P),this.decodeStreamErrorKind=p}}e.$OE=w;class a{static async create(P){let p;if(P!==e.$GE)p=(await(0,A.$EE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(i(P));else{const v=new TextDecoder;p={write(F){return v.decode(F,{stream:!0})},end(){return v.decode()}}}return new a(p)}constructor(P){this.a=P}write(P){return this.a.write(P)}end(){return this.a.end()}}function m(k,P){const p=P.minBytesRequiredForDetection??P.guessEncoding?y:I;return new Promise((v,F)=>{const N=(0,r.$Ce)(B=>B.join("")),L=[];let M=0,z;const j=new R.$xe,q=async()=>{try{const B=await D({buffer:h.$Oe.concat(L),bytesRead:M},P.guessEncoding,P.candidateGuessEncodings);if(B.seemsBinary&&P.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",C.STREAM_IS_BINARY);B.encoding=await P.overwriteEncoding(B.encoding),z=await a.create(B.encoding);const ee=z.write(h.$Oe.concat(L).buffer);N.write(ee),L.length=0,M=0,v({stream:N,detected:B})}catch(B){j.cancel(),N.destroy(),F(B)}};(0,r.$Ge)(k,{onData:async B=>{z?N.write(z.write(B.buffer)):(L.push(B),M+=B.byteLength,M>=p&&(k.pause(),await q(),setTimeout(()=>k.resume())))},onError:B=>N.error(B),onEnd:async()=>{z||await q(),N.end(z?.end())}},j.token)})}async function $(k,P,p){const F=(await(0,A.$EE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(i(P),p);let N=!1,L=!1;return{read(){if(L)return null;const M=k.read();if(typeof M!="string"){if(L=!0,!N&&p?.addBOM)switch(P){case e.$GE:case e.$HE:return h.$Oe.wrap(Uint8Array.from(e.$NE));case e.$IE:return h.$Oe.wrap(Uint8Array.from(e.$LE));case e.$JE:return h.$Oe.wrap(Uint8Array.from(e.$ME))}const z=F.end();return z&&z.length>0?(N=!0,h.$Oe.wrap(z)):null}return N=!0,h.$Oe.wrap(F.write(M))}}}async function f(k){return(await(0,A.$EE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(i(k))}function i(k){return k===e.$HE||k===null?e.$GE:k}function s(k,P){if(!k||P<e.$LE.length)return null;const p=k.readUInt8(0),v=k.readUInt8(1);if(p===e.$LE[0]&&v===e.$LE[1])return e.$IE;if(p===e.$ME[0]&&v===e.$ME[1])return e.$JE;if(P<e.$NE.length)return null;const F=k.readUInt8(2);return p===e.$NE[0]&&v===e.$NE[1]&&F===e.$NE[2]?e.$HE:null}const t=["ascii","utf-16","utf-32"];async function o(k,P){const p=await(0,A.$EE)("jschardet",O.$R?"dist/jschardet.js":"dist/jschardet.min.js"),v=k.slice(0,u),F=E(v.buffer);P&&(P=(0,T.$Hb)(P.map(M=>g(M))),P.length===0&&(P=void 0));const N=p.detect(F,P?{detectEncodings:P}:void 0);if(!N||!N.encoding)return null;const L=N.encoding.toLowerCase();return 0<=t.indexOf(L)?null:l(N.encoding)}const n={ibm866:"cp866",big5:"cp950"};function d(k){return k.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function l(k){const P=d(k);return n[P]||P}function g(k){const P=d(k);return e.$XE[P].guessableName}function E(k){let P="";for(let p=0;p<k.length;p++)P+=String.fromCharCode(k[p]);return P}function S(k){switch(k){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const P=k.match(/windows(\d+)/);return P?"windows-"+P[1]:k}}}function D({buffer:k,bytesRead:P},p,v){let F=s(k,P),N=!1;if(F!==e.$IE&&F!==e.$JE&&k){let L=!0,M=!0,z=!1;for(let j=0;j<P&&j<c;j++){const q=j%2===1,B=k.readUInt8(j)===0;if(B&&(z=!0),L&&(q&&!B||!q&&B)&&(L=!1),M&&(q&&B||!q&&!B)&&(M=!1),B&&!L&&!M)break}z&&(L?F=e.$JE:M?F=e.$IE:N=!0)}return p&&!N&&!F&&k?o(k.slice(0,P),v).then(L=>({seemsBinary:!1,encoding:L})):{seemsBinary:N,encoding:F}}e.$WE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$XE=(()=>{const k={};for(const P in e.$WE)e.$WE[P].guessableName&&(k[P]=e.$WE[P]);return k})()}),define(ke[173],Ie([1,0,350,33,172]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hsc=void 0,h=We(h);class R extends A.$7qc{constructor(O,b,c=h,I="searchProcess"){super({query:O,provider:b},{readdir:y=>c.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,r.$UE)(y)},I)}}e.$hsc=R}),define(ke[174],Ie([1,0,56,365,349,18,78,38,12,2,37,99,366,347,129]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bsc=e.$asc=void 0,e.$csc=o,e.$dsc=d,e.$esc=g,e.$fsc=E,e.$gsc=D,r=We(r);const a=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(P,p){this.a=P,this.b=p}provideTextSearchResults(P,p,v,F){return this.a.appendLine(`provideTextSearchResults ${P.pattern}, ${JSON.stringify({...p,folder:p.folder.toString()})}`),new Promise((N,L)=>{F.onCancellationRequested(()=>X());const M={...p,numThreads:this.b},z=o(P,M),j=p.folder.fsPath,q=z.map(ge=>ge.match(/^-/)?ge:`'${ge}'`).join(" ");this.a.appendLine(`${a} ${q}
 - cwd: ${j}`);let B=r.spawn(a,z,{cwd:j});B.on("error",ge=>{console.error(ge),this.a.appendLine("Error: "+(ge&&ge.message)),L((0,I.$lM)(new I.$jM(ge&&ge.message,I.SearchErrorCode.rgProcessError)))});let ee=!1;const H=new i(p.maxResults,p.folder,p.previewOptions);H.on("result",ge=>{ee=!0,ce="",v.report(ge)});let W=!1;const X=()=>{W=!0,B?.kill(),H?.cancel()};let _=!1;H.on("hitLimit",()=>{_=!0,X()});let ce="";B.stdout.on("data",ge=>{H.handleData(ge),ee||(ce+=ge)});let ne=!1;B.stdout.once("data",()=>ne=!0);let ye="";B.stderr.on("data",ge=>{const Y=ge.toString();this.a.appendLine(Y),ye.length+Y.length<1e6&&(ye+=Y)}),B.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(ee?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),W)N({limitHit:_});else{H.flush(),B=null;let ge;ye&&!ne&&(ge=$(ye))?L((0,I.$lM)(new I.$jM(ge.message,ge.code))):N({limitHit:_})}})})}}e.$asc=m;function $(k){const P=k.split(`
`),p=P[0].trim();if(P.some(F=>F.startsWith("regex parse error")))return new I.$jM(f(P),I.SearchErrorCode.regexParseError);const v=p.match(/grep config error: unknown encoding: (.*)/);if(v)return new I.$jM(`Unknown encoding: ${v[1]}`,I.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new I.$jM(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new I.$jM(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new I.$jM(p,I.SearchErrorCode.regexParseError)}function f(k){const P=["Regex parse error"],p=k.filter(v=>v.startsWith("PCRE2:"));if(p.length>=1){const v=p[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const F=v.split(":")[1];P.push(":"+F)}}return P.join("")}class i extends h.EventEmitter{constructor(P,p,v){super(),this.g=P,this.h=p,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new A.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(P,p){return super.on(P,p),this}handleData(P){if(this.b)return;const p=typeof P=="string"?P:this.d.write(P);this.k(p)}k(P){let p=P.indexOf(`
`);const v=this.a+P;if(p>=0)p+=this.a.length;else{this.a=v;return}let F=0;for(;p>=0;)this.m(v.substring(F,p).trim()),F=p+1,p=v.indexOf(`
`,F);this.a=v.substring(F)}m(P){if(this.b||!P)return;let p;try{p=JSON.parse(P)}catch{throw new Error(`malformed line from rg: ${P}`)}if(p.type==="match"){const v=s(p.data.path),F=c.URI.joinPath(this.h,v),N=this.n(p.data,F);this.p(N),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const v=s(p.data.path),F=c.URI.joinPath(this.h,v);this.o(p.data,F).forEach(L=>this.p(L))}}n(P,p){const v=P.line_number-1,F=s(P.lines),N=Buffer.from(F);let L=0,M=0,z=v;P.submatches.length===0&&P.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const j=(0,R.$Hb)(P.submatches.map((q,B)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=s(q.match),H=N.slice(L,q.start).toString(),W=t(H),X=W.numLines>0?W.lastLineLength:W.lastLineLength+M,_=t(ee),ce=W.numLines+z,ne=_.numLines+ce,ye=_.numLines>0?_.lastLineLength:_.lastLineLength+X;return L=q.end,M=ye,z=ne,new y.$2L(ce,X,ne,ye)}));return(0,w.$6rc)(p,F,j,this.j)}o(P,p){const v=s(P.lines),F=P.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((N,L)=>({text:N,uri:p,lineNumber:F+L}))}p(P){this.emit("result",P)}}e.$bsc=i;function s(k){return k.bytes?Buffer.from(k.bytes,"base64").toString():k.text}function t(k){const P=/\n/g;let p=0,v=-1,F;for(;F=P.exec(k);)p++,v=F.index;const N=v>=0?k.length-v-1:k.length;return{numLines:p,lastLineLength:N}}function o(k,P){const p=["--hidden","--no-require-git"];p.push(k.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:F}=(0,T.$c)(P.includes,L=>L.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const L=new Set;F.forEach(M=>{L.add(M)}),p.push("-g","!*"),L.forEach(M=>{n(M).map(w.$5rc).forEach(z=>{p.push("-g",z)})})}v&&v.length&&v.forEach(L=>{p.push("-g",L)}),P.excludes.map(w.$5rc).forEach(L=>p.push("-g",`!${L}`)),P.maxFileSize&&p.push("--max-filesize",P.maxFileSize+""),P.useIgnoreFiles?P.useParentIgnoreFiles||p.push("--no-ignore-parent"):p.push("--no-ignore"),P.followSymlinks&&p.push("--follow"),P.encoding&&P.encoding!=="utf8"&&p.push("--encoding",P.encoding),P.numThreads&&p.push("--threads",`${P.numThreads}`),k.pattern==="--"&&(k.isRegExp=!0,k.pattern="\\-\\-"),k.isMultiline&&!k.isRegExp&&(k.pattern=(0,b.$if)(k.pattern),k.isRegExp=!0),P.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),k.isRegExp&&(k.pattern=d(k.pattern),p.push("--engine","auto"));let N;if(k.isWordMatch){const M=(0,b.$rf)(k.pattern,!!k.isRegExp,{wholeWord:k.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",M)}else if(k.isRegExp){let L=g(k.pattern);L=E(L),p.push("--regexp",L)}else N=k.pattern,p.push("--fixed-strings");return p.push("--no-config"),P.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),k.isMultiline&&p.push("--multiline"),P.beforeContext&&p.push("--before-context",P.beforeContext+""),P.afterContext&&p.push("--after-context",P.afterContext+""),p.push("--"),N&&p.push(N),p.push("."),p}function n(k){return D(k).flatMap(p=>{const v=(0,O.$zk)(p,"/");return v.map((F,N)=>v.slice(0,N+1).join("/"))})}function d(k){const P=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;k.match(P);)k=k.replace(P,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;k.match(p);)k=k.replace(p,"$1\\x{$2}");return k}const l=k=>k.type==="Assertion"&&k.kind==="lookbehind";function g(k){let P;try{P=new u.RegExpParser().parsePattern(k)}catch{return k}let p="",v=0;const F=(M,z,j)=>{p+=k.slice(v,M)+j,v=z},N=[];return new u.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const z=N[0];if(!z)F(M.start,M.end,"\\r?\\n");else if(!N.some(l))if(z.type==="CharacterClass")if(z.negate){const j=k.slice(z.start+2,M.start)+k.slice(M.end,z.end-1);z.parent?.type==="Quantifier"?F(z.start,z.end,j?`[^${j}]`:"."):F(z.start,z.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=k.slice(z.start+1,M.start)+k.slice(M.end,z.end-1);F(z.start,z.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else z.type==="Quantifier"&&F(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){N.unshift(M)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(M){N.unshift(M)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(M){N.unshift(M)},onCharacterClassLeave(){N.shift()},onAssertionEnter(M){l(M)&&N.push(M)},onAssertionLeave(M){N[0]===M&&N.shift()}}).visit(P),p+=k.slice(v),p}function E(k){return k.replace(/\n/g,"\\r?\\n")}function S(k){let P=!1,p=!1,v="",F="";for(let N=0;N<k.length;N++){const L=k[N];switch(L){case"\\":p?(P?F+="\\"+L:v+="\\"+L,p=!1):p=!0;break;case"{":if(p)P?F+=L:v+=L,p=!1;else{if(P)return{strInBraces:v+"{"+F+"{"+k.substring(N+1)};P=!0}break;case"}":if(p)P?F+=L:v+=L,p=!1;else{if(P)return{fixedStart:v,strInBraces:F,fixedEnd:k.substring(N+1)};v+=L}break;default:P?F+=(p?"\\":"")+L:v+=(p?"\\":"")+L,p=!1;break}}return{strInBraces:v+(P?"{"+F:"")}}function D(k){const{fixedStart:P,strInBraces:p,fixedEnd:v}=S(k);if(P===void 0||v===void 0)return[p];let F=(0,O.$zk)(p,",");F.length||(F=[""]);const N=D(v);return F.flatMap(L=>{const M=P+L;return N.map(z=>M+z)})}}),define(ke[351],Ie([1,0,20,174,89,14]),function($e,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ksc=void 0;class T{constructor(c,I){this.b=c,this.c=I,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(c,I,y,u){const C=await this.c(),w=new h.$asc(this.b,C),a={...I,numThreads:C};if(I.folder.scheme===R.Schemas.vscodeUserData){const m={...a,folder:I.folder.with({scheme:R.Schemas.file})},$=new A.$Bw(f=>y.report({...f,uri:f.uri.with({scheme:I.folder.scheme})}));return this.d(u,f=>w.provideTextSearchResults(c,m,$,f))}else return this.d(u,m=>w.provideTextSearchResults(c,a,y,m))}async d(c,I){const y=O(c);this.a.add(y);const u=await I(y.token);return this.a.delete(y),u}e(){this.a.forEach(c=>c.cancel())}}e.$ksc=T;function O(b){const c=new r.$xe;return b.onCancellationRequested(()=>c.cancel()),c}}),define(ke[352],Ie([1,0,33,174,173]),function($e,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$isc=void 0,r=We(r);class R{constructor(b,c){this.a=b,this.b=c}search(b,c,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const y={appendLine(C){I({message:C})}},u=new A.$hsc(this.a,new h.$asc(y,this.b),r);return new Promise((C,w)=>u.search(a=>{c(a.map(T))},b).then(a=>C({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),w))}}e.$isc=R;function T(O){return{path:O.resource&&O.resource.fsPath,results:O.results,numMatches:(O.results||[]).reduce((b,c)=>{if(c.ranges){const I=c;return b+(Array.isArray(I.ranges)?I.ranges.length:1)}else return b+1},0)}}}),define(ke[353],Ie([1,0,18,7,13,4,137,16,42,2,27,37,348,352]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jsc=void 0,r=We(r);class w{static{this.a=512}constructor(s="searchProcess",t){this.d=s,this.f=t,this.b=Object.create(null)}fileSearch(s){let t;const o=$(s),n=new R.$me({onDidAddFirstListener:()=>{t=(0,h.$th)(async d=>{const l=await this.f?.();return this.doFileSearchWithEngine(u.$_rc,o,g=>n.fire(g),d,w.a,l)}),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}textSearch(s){let t;const o=$(s),n=new R.$me({onDidAddFirstListener:()=>{t=(0,h.$th)(d=>this.g(o,l=>n.fire(l),d)),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}async g(s,t,o){s.maxFileSize=this.h().maxFileSize;const n=await this.f?.();return new C.$isc(s,n).search(o,t,t)}h(){return{maxFileSize:16*I.$Jl.GB}}doFileSearch(s,t,o,n){return this.doFileSearchWithEngine(u.$_rc,s,o,n,w.a,t)}doFileSearchWithEngine(s,t,o,n,d=w.a,l){let g=0;const E=D=>{Array.isArray(D)?(g+=D.length,o(D.map(k=>this.j(k)))):D.relativePath?(g++,o(this.j(D))):o(D)};if(t.sortByScore){let D=this.n(t,E,n);if(!D){const k=t.maxResults?Object.assign({},t,{maxResults:null}):t,P=new s(k,l);D=this.k(P,t,o,E,n)}return new Promise((k,P)=>{D.then(([p,v])=>{const F=v.map(N=>this.j(N));this.q(F,o,d),k(p)},P)})}const S=new s(t,l);return this.s(S,E,d,n).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:this.d,fromCache:!1,resultCount:g,sortingTime:void 0},messages:[]}))}j(s){return{path:s.base?(0,O.$kc)(s.base,s.relativePath):s.relativePath}}k(s,t,o,n,d){const l=new R.$me;let g=(0,h.$th)(S=>{let D=[];const k=P=>{Array.isArray(P)?D=P:(n(P),l.fire(P))};return this.s(s,k,-1,S).then(P=>[P,D])}),E;if(t.cacheKey){E=this.l(t.cacheKey);const S={promise:g,event:l.event,resolved:!1};E.resultsToSearchCache[t.filePattern||""]=S,g.then(()=>{S.resolved=!0},D=>{delete E.resultsToSearchCache[t.filePattern||""]}),g=this.t(g)}return g.then(([S,D])=>{const k=E?E.scorerCache:Object.create(null),P=(typeof t.maxResults!="number"||t.maxResults>0)&&b.$ge.create(!1);return this.o(t,D,k,d).then(p=>{const v=P?P.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:p.length},messages:S.messages,limitHit:S.limitHit||typeof t.maxResults=="number"&&D.length>t.maxResults},p]})})}l(s){const t=this.b[s];return t||(this.b[s]=new a)}n(s,t,o){const n=s.cacheKey&&this.b[s.cacheKey];if(!n)return;const d=this.r(n,s.filePattern||"",t,o);if(d)return d.then(([l,g,E])=>{const S=b.$ge.create(!1);return this.o(s,g,n.scorerCache,o).then(D=>{const k=S.elapsed(),P={fromCache:!0,detailStats:E,type:this.d,resultCount:g.length,sortingTime:k};return[{type:"success",limitHit:l.limitHit||typeof s.maxResults=="number"&&g.length>s.maxResults,stats:P,messages:[]},D]})})}o(s,t,o,n){const d=(0,T.$Sr)(s.filePattern||""),l=(E,S)=>(0,T.$Rr)(E,S,d,!0,m,o),g=typeof s.maxResults=="number"?s.maxResults:y.$$L;return r.$Gb(t,l,g,1e4,n)}q(s,t,o){if(o&&o>0)for(let n=0;n<s.length;n+=o)t(s.slice(n,n+o));else t(s)}r(s,t,o,n){const d=b.$ge.create(!1),l=t.indexOf(O.sep)>=0;let g;for(const k in s.resultsToSearchCache)if(t.startsWith(k)){if(l&&k.indexOf(O.sep)<0&&k!=="")continue;const P=s.resultsToSearchCache[k];g={promise:this.t(P.promise),event:P.event,resolved:P.resolved};break}if(!g)return null;const E=d.elapsed(),S=b.$ge.create(!1),D=g.event(o);return n&&n.onCancellationRequested(()=>{D.dispose()}),g.promise.then(([k,P])=>{if(n&&n.isCancellationRequested)throw(0,A.$6)();const p=[],v=(0,T.$Sr)(t).normalizedLowercase;for(const F of P)(0,y.$pM)(F,v)&&p.push(F);return[k,p,{cacheWasResolved:g.resolved,cacheLookupTime:E,cacheFilterTime:S.elapsed(),cacheEntryCount:P.length}]})}s(s,t,o,n){return new Promise((d,l)=>{let g=[];n?.onCancellationRequested(()=>s.cancel()),s.search(E=>{E&&(o?(g.push(E),o>0&&g.length>=o&&(t(g),g=[])):t(E))},E=>{t(E)},(E,S)=>{g.length&&t(g),E?(t({message:"Search finished. Error: "+E.message}),l(E)):(t({message:"Search finished. Stats: "+JSON.stringify(S.stats)}),d(S))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}t(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,o){return s.then(t,o)}catch(t){return this.then(void 0,t)}finally(t){return s.finally(t)}}}}e.$jsc=w;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,O.$oc)(i.relativePath)}getItemDescription(i){return(0,O.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function $(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(f),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>c.URI.revive(s))}}function f(i){return{...i,folder:c.URI.revive(i.folder)}}}),define(ke[354],Ie([1,0,3,14,2,33,11,41,29,19,102,72,37,353,351,129,173]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsc=void 0,R=We(R);let $=class extends I.$_qc{constructor(i,s,t,o,n){super(i,t,n),this.D=o,this.w=R,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Uc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const d=new a.$7rc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new w.$ksc(d,this.getNumThreadsCached))),s.remote.isRemote&&s.remote.authority&&this.F(),o.getConfigProvider().then(l=>{this.C||this.B.add(l.onDidChangeConfiguration(this.E))})}E(i){i.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const i=new a.$7rc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new w.$ksc(i,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new C.$jsc("fileSearchProvider",this.getNumThreadsCached)))}G(i,s){const t=this.d++;return this.y=s,this.x=t,this.c.$registerFileSearchProvider(t,this.s(i)),(0,r.$Tc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(i,s,t,o){const n=(0,I.$arc)(t);if(i===this.x){const d=Date.now();return this.H(i,s,n,o).then(l=>{const g=Date.now()-d;return this.q.debug(`Ext host file search time: ${g}ms`),l})}return super.$provideFileSearchResults(i,s,t,o)}async doInternalFileSearchWithCustomCallback(i,s,t){const o=d=>{if((0,u.$oM)(d)&&(d=[d]),Array.isArray(d)){t(d.map(l=>A.URI.file(l.path)));return}d.message&&this.q.debug("ExtHostSearch",d.message)};if(!this.y)throw new Error("No internal file search handler");const n=await this.getNumThreadsCached();return this.y.doFileSearch(i,n,o,s)}async H(i,s,t,o){return this.doInternalFileSearchWithCustomCallback(t,o,n=>{this.c.$handleFileMatch(i,s,n)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,s){return new m.$hsc(i,s,void 0,"textSearchProvider")}};e.$lsc=$,e.$lsc=$=Je([Ve(0,c.$oQ),Ve(1,b.$EQ),Ve(2,y.$Xpc),Ve(3,O.$4pc),Ve(4,T.$bk)],$)}),define(ke[130],Ie([1,0,367,67,66,368,21,13,4,3,16,10,32,86,68]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$xi=e.$wi=e.$vi=void 0,e.$yi=l,e.$zi=g,e.$Bi=D,e.$Ci=k;const a=3e4;class m{traceSocketEvent(p,v){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,v)}constructor(p,v=""){this.f=!0,this.debugLabel=v,this.socket=p,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent(w.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,O.$Z)(N)}},this.socket.on("error",this.a);let F;this.b=N=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Close,{hadError:N}),this.f=!1,F&&clearTimeout(F)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,F=setTimeout(()=>p.destroy(),a)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const v=F=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Read,F),p(T.$Oe.wrap(F))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(p){const v=F=>{p({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:F,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(p){const v=()=>{p()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(w.SocketDiagnosticsEventType.Write,p),this.socket.write(p.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,O.$Z)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,O.$Z)(v)}}end(){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((p,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),p();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),p()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.$vi=m;var $;(function(P){P[P.MinHeaderByteSize=2]="MinHeaderByteSize",P[P.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var f;(function(P){P[P.PeekHeader=1]="PeekHeader",P[P.ReadHeader=2]="ReadHeader",P[P.ReadBody=3]="ReadBody",P[P.Fin=4]="Fin"})(f||(f={}));class i extends c.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,v){this.socket.traceSocketEvent(p,v)}constructor(p,v,F,N){super(),this.f=this.B(new b.$me),this.g=this.B(new b.$me),this.h=!1,this.j={state:f.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:F?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new s(this,v,F,N,this.f,(L,M)=>this.m(L,M))),this.B(this.a.onError(L=>{console.error(L),(0,O.$Z)(L),this.g.fire({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:L})})),this.b=new w.$qi,this.B(this.socket.onData(L=>this.n(L))),this.B(this.socket.onClose(async L=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(L)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let v=0;for(;v<p.byteLength;)this.a.writeMessage(p.slice(v,Math.min(v+$.MaxWebSocketMessageLength,p.byteLength)),{compressed:!0,opcode:2}),v+=$.MaxWebSocketMessageLength}m(p,{compressed:v,opcode:F}){if(this.h)return;this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,p);let N=$.MinHeaderByteSize;p.byteLength<126?N+=0:p.byteLength<2**16?N+=2:N+=8;const L=T.$Oe.alloc(N),M=v?64:0,z=F&15;if(L.writeUInt8(128|M|z,0),p.byteLength<126)L.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){L.writeUInt8(126,1);let j=1;L.writeUInt8(p.byteLength>>>8&255,++j),L.writeUInt8(p.byteLength>>>0&255,++j)}else{L.writeUInt8(127,1);let j=1;L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(p.byteLength>>>24&255,++j),L.writeUInt8(p.byteLength>>>16&255,++j),L.writeUInt8(p.byteLength>>>8&255,++j),L.writeUInt8(p.byteLength>>>0&255,++j)}this.socket.write(T.$Oe.concat([L,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===f.PeekHeader){const v=this.b.peek(this.j.readLen),F=v.readUInt8(0),N=(F&128)>>>7,L=(F&64)>>>6,M=F&15,z=v.readUInt8(1),j=(z&128)>>>7,q=z&127;this.j.state=f.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(j?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!L),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===f.ReadHeader){const v=this.b.read(this.j.readLen),F=v.readUInt8(1),N=(F&128)>>>7;let L=F&127,M=1;L===126?L=v.readUInt8(++M)*2**8+v.readUInt8(++M):L===127&&(L=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let z=0;N&&(z=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=f.ReadBody,this.j.readLen=L,this.j.mask=z,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===f.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),n(v,this.j.mask),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=f.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$wi=i;class s extends c.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Oe.alloc(0)}constructor(p,v,F,N,L,M){super(),this.n=p,this.r=L,this.s=M,this.a=this.B(new b.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new t(this.n,N,F,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(p,v){this.g.push({data:p,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:v}=this.g.shift();if(this.f&&v.compressed){const F=await this.w(this.f,p);this.s(F,v)}else this.s(p,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,v){return new Promise((F,N)=>{p.write(v),p.flush(L=>F(L))})}acceptFrame(p,v,F){this.h.push({data:p,isCompressed:v,isLastFrameOfMessage:F}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const v=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,v,F){return new Promise((N,L)=>{p.write(v),F&&p.write(T.$Oe.fromByteArray([0,0,255,255])),p.flush(M=>N(M))})}}class t extends c.$Vc{get recordedInflateBytes(){return this.j?T.$Oe.concat(this.f):T.$Oe.alloc(0)}constructor(p,v,F,N){super(),this.h=p,this.j=v,this.a=this.B(new b.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",L=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateError,{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateData,L),this.g.push(T.$Oe.wrap(L))}),F&&(this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialWrite,F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateWrite,p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Oe.concat(this.g);this.g.length=0,p(v)})}}class o extends c.$Vc{constructor(p,v){super(),this.g=p,this.a=this.B(new b.$me),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateData,F),this.f.push(T.$Oe.wrap(F))})}write(p){this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateWrite,p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Oe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),p(v)})}}function n(P,p){if(p===0)return;const v=P.byteLength>>>2;for(let j=0;j<v;j++){const q=P.readUInt32BE(j*4);P.writeUInt32BE(q^p,j*4)}const F=v*4,N=P.byteLength-F,L=p>>>24&255,M=p>>>16&255,z=p>>>8&255;N>=1&&P.writeUInt8(P.readUInt8(F)^L,F),N>=2&&P.writeUInt8(P.readUInt8(F+1)^M,F+1),N>=3&&P.writeUInt8(P.readUInt8(F+2)^z,F+2)}e.$xi=process.env.XDG_RUNTIME_DIR;const d={[y.Platform.Linux]:107,[y.Platform.Mac]:103};function l(){const P=(0,u.$3g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${P}-sock`;const p=process.platform!=="darwin"&&e.$xi?e.$xi:(0,A.tmpdir)(),v=(0,I.$kc)(p,`vscode-ipc-${P}.sock`);return E(v),v}function g(P,p,v){const N=(0,r.createHash)("sha256").update(P).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${v}-${p}-sock`;const L=v.substr(0,4),M=p.substr(0,6);let z;return process.platform!=="darwin"&&e.$xi&&!process.env.VSCODE_PORTABLE?z=(0,I.$kc)(e.$xi,`vscode-${N}-${L}-${M}.sock`):z=(0,I.$kc)(P,`${L}-${M}.sock`),E(z),z}function E(P){const p=d[y.$v];typeof p=="number"&&P.length>=p&&console.warn(`WARNING: IPC handle "${P}" is longer than ${p} chars, try a shorter --user-data-dir`)}class S extends C.$ki{static b(p){const v=b.Event.fromNodeEventEmitter(p,"connection");return b.Event.map(v,F=>({protocol:new w.$ri(new m(F,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(F,"close"))}))}constructor(p){super(S.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ai=S;function D(P){return new Promise((p,v)=>{const F=(0,h.createServer)();F.on("error",v),F.listen(P,()=>{F.removeListener("error",v),p(new S(F))})})}function k(P,p){return new Promise((v,F)=>{const N=(0,h.createConnection)(P,()=>{N.removeListener("error",F),v(w.$si.fromSocket(new m(N,`ipc-client${p}`),p))});N.once("error",F)})}}),define(ke[355],Ie([1,0,67,66,191,130,7,3,10,46,11,115,234,236,117,92,21]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=e.$3hc=e.$2hc=e.$1hc=void 0,r=We(r),h=We(h);async function $(o,n,d,l,g){let E;for(let S=3;S&&(E?.dispose(),E=await new f(o,n,d,l,g).waitForReady(),!(g&&A.$6g[g]||!A.$6g[E.tunnelLocalPort]));S--);return E}class f extends O.$Vc{constructor(n,d,l,g,E){super(),this.m=d,this.n=E,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=r.createServer(),this.c=new T.$Fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=g,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,d=(0,a.$Ow)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,A.$7g)(n,2,1e3,d),g=null;return this.b.listen(l,this.m),await this.c.wait(),g=this.b.address(),g||(l=0,this.b.listen(l,this.m),await this.c.wait(),g=this.b.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async r(n){n.pause();const d=(0,a.$Mw)(this.tunnelRemoteHost)||(0,a.$Ow)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,u.$4l)(this.a,d,this.tunnelRemotePort),g=l.getSocket(),E=l.readEntireBuffer();l.dispose(),E.byteLength>0&&n.write(E.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),g.end()}),n.on("close",()=>g.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),g instanceof R.$vi?g.socket.destroy():g.end()}),g instanceof R.$vi?this.t(n,g):this.s(n,g),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),g.end()})}s(n,d){d.onClose(()=>n.destroy()),d.onEnd(()=>n.end()),d.onData(l=>n.write(l.buffer)),n.on("data",l=>d.write(m.$Oe.wrap(l))),n.resume()}t(n,d){const l=d.socket;l.on("end",()=>n.end()),l.on("close",()=>n.end()),l.on("error",()=>{n.destroy()}),l.pipe(n),n.pipe(l)}}e.$1hc=f;let i=class extends a.$Rw{constructor(n,d,l,g,E){super(d,E),this.H=n,this.I=l,this.J=g}isPortPrivileged(n){return(0,a.$Pw)(n,this.t,b.OS,h.release())}F(n,d,l,g,E,S,D,k){const P=this.D(d,l);if(P)return++P.refcount,P.value;if((0,a.$Iw)(n))return this.G(n,d,l,E,S,D,k);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${E}.`);const p={commit:this.J.commit,quality:this.J.quality,addressProvider:n,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=$(p,g,d,l,E);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(d,l,v),v}}};e.$2hc=i,e.$2hc=i=Je([Ve(0,C.$Xl),Ve(1,I.$bk),Ve(2,w.$1l),Ve(3,y.$uk),Ve(4,c.$aj)],i);let s=class extends i{constructor(n,d,l,g,E){super(n,d,l,g,E)}};e.$3hc=s,e.$3hc=s=Je([Ve(0,C.$Xl),Ve(1,I.$bk),Ve(2,w.$1l),Ve(3,y.$uk),Ve(4,c.$aj)],s);let t=class extends O.$Vc{constructor(n,d,l,g,E){super(),this.b=n,this.c=d,this.f=l,this.g=g,this.h=E,this.a=new Map}async openTunnel(n,d,l,g,E,S,D,k,P){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${g} on local port ${S}.`),!this.a.has(n)){const p=new s(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(n,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(d,l,g,E,S,D,k,P)}};e.$4hc=t,e.$4hc=t=Je([Ve(0,C.$Xl),Ve(1,I.$bk),Ve(2,y.$uk),Ve(3,w.$1l),Ve(4,c.$aj)],t)}),define(ke[356],Ie([1,0,130,253,45,34,2,11,47]),function($e,e,r,h,A,R,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QQ=e.$PQ=void 0,h=We(h),A=We(A);class c{constructor(u,C,w){this.b=u,this.c=C,this.f=w,this.a=h.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(C.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,C){const w=(m,$)=>{C.writeHead(m,{"content-type":"application/json"}),C.end(JSON.stringify($||null),f=>f&&this.c.error(f))},a=[];u.setEncoding("utf8"),u.on("data",m=>a.push(m)),u.on("end",async()=>{try{const m=JSON.parse(a.join(""));let $;switch(m.type){case"open":$=await this.i(m);break;case"openExternal":$=await this.j(m);break;case"status":$=await this.l(m);break;case"extensionManagement":$=await this.k(m);break;default:w(404,`Unknown message type: ${m.type}`);break}w(200,$)}catch(m){const $=m instanceof Error?m.message:JSON.stringify(m);w(500,$),this.c.error("Error while processing pipe request",m)}})}async i(u){const{fileURIs:C,folderURIs:w,forceNewWindow:a,diffMode:m,mergeMode:$,addMode:f,forceReuseWindow:i,gotoLineMode:s,waitMarkerFilePath:t,remoteAuthority:o}=u,n=[];if(Array.isArray(w))for(const E of w)try{n.push({folderUri:T.URI.parse(E)})}catch{}if(Array.isArray(C))for(const E of C)try{(0,b.$_i)(E)?n.push({workspaceUri:T.URI.parse(E)}):n.push({fileUri:T.URI.parse(E)})}catch{}const d=t?T.URI.file(t):void 0,g={forceNewWindow:a,diffMode:m,mergeMode:$,addMode:f,gotoLineMode:s,forceReuseWindow:i,preferNewWindow:!i&&!d&&!f,waitMarkerFileURI:d,remoteAuthority:o};this.b.executeCommand("_remoteCLI.windowOpen",n,g)}async j(u){for(const C of u.uris){const w=T.URI.parse(C),a=w.scheme==="file"?w:C;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(u){const C=a=>a?.map(m=>/\.vsix$/i.test(m)?T.URI.parse(m):m),w={list:u.list,install:C(u.install),uninstall:C(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&A.existsSync(this.f)&&A.unlinkSync(this.f)}}e.$PQ=c;let I=class extends c{constructor(u,C){super(u,C,(0,r.$yi)())}};e.$QQ=I,e.$QQ=I=Je([Ve(0,R.$KQ),Ve(1,O.$bk)],I)}),define(ke[357],Ie([1,0,61,344,339,252,54,326,2,14,9,356,108,286,325]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qsc=void 0,r=We(r);class a extends A.$Rrc{j(){const f=this,i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(d,l,g){return d=o(d),f.a.has(d)?f.a.get(d).load(d,b.URI.file((0,u.$pr)(l.filename)),E=>s.apply(this,[E,l,g])):s.apply(this,arguments)};const t=i._resolveLookupPaths;i._resolveLookupPaths=(n,d)=>t.call(this,o(n),d);const o=n=>{for(const d of f.b){const l=d(n);if(l){n=l;break}}return n}}}class m extends T.$Dqc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(C.$osc);const f=this.h.invokeFunction(h.$Nrc);if(this.h.createInstance(O.$nsc),this.f.remote.isRemote&&this.f.remote.authority){const t=this.h.createInstance(y.$QQ);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this.h.createInstance(w.$psc),await this.h.createInstance(a,f,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,R.$msc)(this.j,s,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(f){return f.main}async xb(f,i,s){if(i.scheme!==c.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let t=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const o=f?.identifier.value;f&&await this.w.initializeLocalizedMessages(f);try{o&&r.mark(`code/extHost/willLoadExtensionCode/${o}`),t=$e.__$__nodeRequire(i.fsPath)}finally{o&&r.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}return t}async $setRemoteEnvironment(f){if(this.f.remote.isRemote)for(const i in f){const s=f[i];s===null?delete process.env[i]:process.env[i]=s}}}e.$qsc=m}),define(ke[358],Ie([1,0,45,56,21,4,3,134,10,22,2,33,68,11,233,71,117,92,355,29,19,76,333]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ysc=void 0,e.$rsc=n,e.$ssc=d,e.$tsc=l,e.$usc=g,e.$vsc=S,e.$wsc=D,e.$xsc=k,r=We(r),c=We(c),y=We(y);function n(v){const F=v.trim().split(`
`),N=[];return F.forEach(M=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(M);z&&z.length>=3&&N.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),N.reduce((M,z)=>(M[z.socket]=z,M),{})}function d(...v){const F=[].concat(...v.map(g));return[...new Map(F.filter(N=>N.st==="0A").map(N=>{const L=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:l(L[0]),port:parseInt(L[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function l(v){let F="";if(v.length===8)for(let N=v.length-2;N>=0;N-=2)F+=parseInt(v.substr(N,2),16),N!==0&&(F+=".");else for(let N=0;N<v.length;N+=8){const L=v.substring(N,N+8);let M="";for(let z=8;z>=2;z-=2)M+=L.substring(z-2,z),(z===6||z===2)&&(M=parseInt(M,16).toString(16),F+=`${M}`,M="",N+z!==v.length-6&&(F+=":"))}return F}function g(v){const F=v.trim().split(`
`),N=F.shift().trim().split(/\s+/).filter(M=>M!=="rx_queue"&&M!=="tm->when");return F.map(M=>M.trim().split(/\s+/).reduce((z,j,q)=>(z[N[q]||q]=j,z),{}))}function E(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/server-main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function S(v){const F=v.trim().split(`
`),N=[];return F.forEach(L=>{const M=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(L);M&&M.length>=4&&N.push({pid:parseInt(M[1],10),ppid:parseInt(M[2]),cmd:M[3]})}),N}async function D(v,F,N){const L=N.reduce((z,j)=>(z[j.pid]=j,z),{}),M=[];return v.forEach(({socket:z,ip:j,port:q})=>{const B=F[z]?F[z].pid:void 0,ee=B?L[B]?.cmd:void 0;B&&ee&&!E(ee)&&M.push({host:j,port:q,detail:ee,pid:B})}),M}function k(v,F,N){const L=new Map,M=S(F);for(const z of v){const j=N.get(z.port);if(j){L.set(z.port,j);continue}const q=M.find(B=>B.cmd.includes(`${z.port}`));if(q){let B=q,ee;do ee=M.find(H=>H.ppid===B.pid),ee&&(B=ee);while(ee);L.set(z.port,{host:z.ip,port:z.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else L.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return L}let P=class extends t.$qGb{constructor(F,N,L,M){super(F,N,L),this.D=N,this.F=M,this.y=void 0,this.z=new Map,this.C=!1,b.$l&&N.remote.isRemote&&N.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(F){if(F&&this.C)return;this.C=F;let N;this.y&&(N=this.y,await this.a.$onFoundNewCandidates(this.y));const L=new O.$Pm;let M=0;for(;this.C;){const z=new Date().getTime(),j=(await this.I()).filter(ee=>(0,$.$Mw)(ee.host)||(0,$.$Ow)(ee.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(ee=>ee.port).join(", ")}`);const q=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${q} ms.`),M++>3&&L.update(q),(!N||JSON.stringify(N)!==JSON.stringify(j))&&(N=j,await this.a.$onFoundNewCandidates(N));const B=this.G(L.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${B} ms.`),await new Promise(ee=>setTimeout(()=>ee(),B))}}G(F){return Math.max(F*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(F=>F.port).join(", ")}`)}async I(){let F="",N="";try{F=await r.promises.readFile("/proc/net/tcp","utf8"),N=await r.promises.readFile("/proc/net/tcp6","utf8")}catch{}const L=d(F,N),M=await new Promise(X=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(_,ce,ne)=>{X(ce)})}),z=n(M),j=await y.Promises.readdir("/proc"),q=[];for(const X of j)try{const _=Number(X),ce=c.$hh(I.URI.file("/proc"),X);if((await r.promises.stat(ce.fsPath)).isDirectory()&&!isNaN(_)){const ye=await r.promises.readlink(c.$hh(ce,"cwd").fsPath),ge=await r.promises.readFile(c.$hh(ce,"cmdline").fsPath,"utf8");q.push({pid:_,cwd:ye,cmd:ge})}}catch{}const B=[],ee=L.filter(X=>{const _=z[X.socket];return _||B.push(X),_}),H=D(ee,z,q);let W;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const X=await new Promise(_=>{(0,h.exec)("ps -F -A -l | grep root",(ce,ne,ye)=>{_(ne)})});this.z=k(B,X,this.z),W=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${W.map(_=>_.port).join(", ")}`)}return H.then(X=>W?X.concat(W):X)}w(F){return async N=>{const L=new f.$1hc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,j,q,B){const ee=await F.makeConnection();return p.connect(ee,j,q,B)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new a.$Tl(0),connectionToken:F.connectionToken})}},signService:this.F},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await L.waitForReady();const M=new R.$me;return{localAddress:(0,o.$cN)(L.localAddress)??L.localAddress,remoteAddress:{port:L.tunnelRemotePort,host:L.tunnelRemoteHost},onDidDispose:M.event,dispose:()=>{L.dispose(),M.fire(),M.dispose()}}}}};e.$ysc=P,e.$ysc=P=Je([Ve(0,s.$oQ),Ve(1,i.$EQ),Ve(2,C.$bk),Ve(3,m.$1l)],P);class p extends w.$Kxb{static connect(F,N,L,M){const z=new T.$Uc,j={onClose:z.add(new R.$me),onData:z.add(new R.$me),onEnd:z.add(new R.$me)};z.add(F.onDidReceiveMessage(B=>j.onData.fire(A.$Oe.wrap(B)))),z.add(F.onDidEnd(()=>j.onEnd.fire())),z.add(F.onDidClose(B=>j.onClose.fire({type:u.SocketCloseEventType.NodeSocketCloseEvent,error:B,hadError:!!B})));const q=new p(F,M,j);return q.B(z),(0,w.$Jxb)(q,N,L,M,j)}constructor(F,N,L){super(N,L),this.n=F}write(F){this.n.send(F.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[359],Ie([1,0,88,328,342,341,354,357,358,101,54,102,100,48,76,97,327,287,11,343,64,248,112,117,149]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$,f,i,s,t,o,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Ss)(I.$Eqc,O.$qsc,r.InstantiationType.Eager),(0,r.$Ss)(f.$ck,$.$Asc,r.InstantiationType.Delayed),(0,r.$Ss)(f.$bk,new o.$Di(t.$Qrc,[!1],!0)),(0,r.$Ss)(n.$1l,d.$6hc,r.InstantiationType.Delayed),(0,r.$Ss)(a.$7pc,m.$zsc,r.InstantiationType.Eager),(0,r.$Ss)(c.$Oqc,R.$4rc,r.InstantiationType.Eager),(0,r.$Ss)(y.$$qc,T.$lsc,r.InstantiationType.Eager),(0,r.$Ss)(u.$Brc,A.$Vrc,r.InstantiationType.Eager),(0,r.$Ss)(C.$pqc,h.$Urc,r.InstantiationType.Eager),(0,r.$Ss)(w.$pGb,b.$ysc,r.InstantiationType.Eager),(0,r.$Ss)(s.$Hqc,i.$Bsc,r.InstantiationType.Eager)});var Ut=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(ke[369],Ie([1,0,370,67,7,21,13,61,108,33,68,130,113,231,340,254,269,93,345,359]),function($e,e,r,h,A,R,T,O,b,c,I,y,u,C,w,a,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Ut(r),h=We(h),O=We(O),C=Ut(C),function(){for(let S=0;S<process.execArgv.length;S++)process.execArgv[S]==="--inspect-port=0"&&(process.execArgv.splice(S,1),S--)}();const f=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const E=globalThis._VSCODE_NODE_MODULES.module,S=E._load;E._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return S.apply(this,arguments)}})();const i=process.exit.bind(process),s=process.on.bind(process);function t(E){process.exit=function(S){if(E)i(S);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const S=new Error("An extension called process.crash() and this was prevented.");console.warn(S.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(S,D){S==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),s(S,D)}}let o=function(E){i()};function n(){const E=(0,m.$hn)(process.env);if(E.type===m.ExtHostConnectionType.MessagePort)return new Promise((S,D)=>{const k=P=>{const p=P[0],v=new I.$ti;p.on("message",F=>v.fire(R.$Oe.wrap(F.data))),p.on("close",()=>{o("renderer closed the MessagePort")}),p.start(),S({onMessage:v.event,send:F=>p.postMessage(F.buffer)})};process.parentPort.on("message",P=>k(P.ports))});if(E.type===m.ExtHostConnectionType.Socket)return new Promise((S,D)=>{let k=null;const P=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=I.ProtocolConstants.ReconnectionGraceTime,v=I.ProtocolConstants.ReconnectionShortGraceTime,F=new A.$Th(()=>o("renderer disconnected for too long (1)"),p),N=new A.$Th(()=>o("renderer disconnected for too long (2)"),v);process.on("message",(M,z)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const j=R.$Oe.wrap(Buffer.from(M.initialDataChunk,"base64"));let q;if(M.skipWebSocketFrames)q=new y.$vi(z,"extHost-socket");else{const B=R.$Oe.wrap(Buffer.from(M.inflateBytes,"base64"));q=new y.$wi(new y.$vi(z,"extHost-socket"),M.permessageDeflate,B,!1)}k?(F.cancel(),N.cancel(),k.beginAcceptReconnection(q,j),k.endAcceptReconnection(),k.sendResume()):(clearTimeout(P),k=new I.$ui({socket:q,initialChunk:j}),k.sendResume(),k.onDidDispose(()=>o("renderer disconnected")),S(k),k.onSocketClose(()=>{F.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;F.isScheduled()&&N.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(L)});{const S=E.pipeName;return new Promise((D,k)=>{const P=h.createConnection(S,()=>{P.removeListener("error",k);const p=new I.$ui({socket:new y.$vi(P,"extHost-renderer")});p.sendResume(),D(p)});P.once("error",k),P.on("close",()=>{o("renderer closed the socket")})})}}async function d(){const E=await n();return new class{constructor(){this.a=new I.$ti,this.onMessage=this.a.event,this.b=!1,this.d=E.onMessage(S=>{(0,$.$Dn)(S,$.MessageType.Terminate)?(this.b=!0,this.d.dispose(),o("received terminate message from renderer")):this.a.fire(S)})}send(S){this.b||E.send(S)}async drain(){if(E.drain)return E.drain()}}}function l(E){return new Promise(S=>{const D=E.onMessage(k=>{D.dispose();const P=JSON.parse(k.toString()),p=P.commit,v=C.default.commit;if(p&&v&&p!==v&&i($.ExtensionHostExitCode.VersionMismatch),P.parentPid){let F=0;setInterval(function(){try{process.kill(P.parentPid,0),F=0}catch(L){L&&L.code==="EPERM"?(F++,F>=3&&o(`parent process ${P.parentPid} does not exist anymore (3 x EPERM): ${L.message} (code: ${L.code}) (errno: ${L.errno})`)):o(`parent process ${P.parentPid} does not exist anymore: ${L.message} (code: ${L.code}) (errno: ${L.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(P.parentPid)}catch(L){(0,T.$Z)(L)}}E.send((0,$.$Cn)($.MessageType.Initialized)),S({protocol:E,initData:P})});E.send((0,$.$Cn)($.MessageType.Ready))})}async function g(){const E=[];process.on("unhandledRejection",(F,N)=>{E.push(N),setTimeout(()=>{const L=E.indexOf(N);L>=0&&N.catch(M=>{E.splice(L,1),(0,T.$4)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),F&&(0,T.$Z)(F))})},1e3)}),process.on("rejectionHandled",F=>{const N=E.indexOf(F);N>=0&&E.splice(N,1)}),process.on("uncaughtException",function(F){(0,T.$Y)(F)||(0,T.$Z)(F)}),O.mark("code/extHost/willConnectToRenderer");const S=await d();O.mark("code/extHost/didConnectToRenderer");const D=await l(S);O.mark("code/extHost/didWaitForInitData");const{initData:k}=D;t(!!k.environment.extensionTestsLocationURI),k.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,k.environment.skipWorkspaceStorageLock=(0,u.boolean)(f.skipWorkspaceStorageLock,!1);const P=new class{constructor(){this.pid=process.pid}exit(N){i(N)}fsExists(N){return c.Promises.exists(N)}fsRealpath(N){return(0,b.$or)(N)}};let p=null;k.remote.authority&&f.transformURIs&&(p=(0,a.$Ws)(k.remote.authority));const v=new w.$Trc(D.protocol,k,P,p);o=F=>v.terminate(F)}g().catch(E=>console.log(E))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/3b27f1f74bc09fe2e2068997fcd42768be44a4e3/core/vs/workbench/api/node/extensionHostProcess.js.map
